
#ifndef __elfapi_hh__
#define __elfapi_hh__

#define AX_USE_PROTOS 1

#include <elfapi.h>		// Basic interface definitions.

typedef struct AxMethodInfo_t AxMethodInfo_t;

//
// Base class for exporting C++ objects to Applixware
//
class CAxInterface {
public:
	CAxInterface();
	virtual ~CAxInterface();
	virtual CAxInterface *AxCreateSimilar(void) const = 0; // create similar
	virtual AxMethodInfo_t *AxQueryInterface(void) const = 0;	// interface table
	AxMethodInfo_t *axMethodInfo;
};

typedef elfData (CAxInterface::*AX_MEMBER_FUNC)(elfData);

//
// Class method table.
//
struct AxMethodInfo_t {
	char *methodName;
	AX_MEMBER_FUNC memberFunc;
	char *helpStr;
};

//
// Table of class info.
//
typedef struct AxClassInfo_t {
	char *className;
	CAxInterface *modelObj;
} AxClassInfo_t;

extern "C" AxClassInfo_t *AxGetClassInfo (void);

#endif // !__elfapi_hh__
