#
#	This file contains the date and time formats used to parse and format
#	Applixware dates and times.  There are 20 date formats and 6 time formats.
#
#	These formats can be changed under the following conditions:
#		- You can REPLACE any format with one of your own, based on the
#		  abbreviations given below.  If you change the inbox date display
#         format, your inbox messages might not line up in the display.
#       - DO NOT ADD EXTRA FORMATS.  They will not be interpreted correctly.
#       - To change this file, leave the original file alone.  Make a copy
#         in the axlocal area, which is site-specific, and make changes
#         to the copy.
#		- A line with only a pound sign at the beginning must separate the date
#		  paragraph from the time paragraph and end the time paragraph.
#		- A line may not be blank.
#		- If you have made changes to this file, then exchange spreadsheets or
#		  Words documents with another user at a different site, you might
#         want to send a copy of this file along with the document to support
#         your date formats.  The recipient should place this file in
#         axlocal, the site-specific area.
#		- The abbreviations for this file are language-independent and are:
#				- Mmmm		Full month name
#				- Mm		Abbreviated month name
#				- mm		Month as a number, zero-padded to 2 digits
#				- m			Month as a 1 or 2 digit number
#				- dd		Day as a number, zero-padded to 2 digits
#				- ddd		Day as a number, zero-padded to 3 digits
#												(number in a year)
#				- d			Day as a 1 or 2 digit number
#				- th		Use ordinal abbreviation
#				- Wwww		Full weekday name
#				- Ww		Abbreviated weekday name
#				- yy		Year as a two-digit number
#				- yyyy		Year as a four-digit number
#				- hh		12-Hour
#				- HH		24-Hour
#				- mi		Minutes
#				- ss		Seconds
#				- pm		Use am/pm abbreviation and a 12-hour clock
#				- EE		Year of emperor's reign (Oriental interface only)
#
Mmmm d, yyyy		# December 7, 1992  or  December 17, 1992
Mm d, yyyy			# Dec 7, 1992  or  Dec 17, 1992
d Mm yy				# 7 Dec 92  or  17 Dec 92
mm/dd/yy			# 12/07/92
dd.mm.yy			# 02.12.92
yyyy-mm-dd			# 1992-12-02
yy-mm-dd			# 92-12-02
yyyy mm dd			# 1992 12 02
yy mm dd			# 92 12 02
yyyymmdd			# 19921202
yymmdd				# 921202
dd/mm/yy			# 02/12/92
dd.mm.yyyy			# 02.12.92
Mm dd, yyyy			# Dec 02, 1992   This is the inbox date display format.
Mmmm yyyy			# December 1992
Mm yyyy				# Dec 1992
Mm yy				# Dec 92
mm/dd				# 12/02
yy mm				# 92 12
yyyy mm				# 1992 12
#
hh:mi pm			# 09:34 PM		12-hour format
hh:mipm				# 09:34pm		12-hour format
HH:mi				# 21:34			24-hour format
HH.mi				# 21.34			24-hour format
HHmi				# 2134			24-hour format
HH:mi:ss			# 21:34:05		24-hour format
#
