/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: am_aos.h
   Applix ASC version: 8
   Date: Sun Jan 24 21:13:12 1999
*/

#ifndef aosHinclude  /* (This insures that this file is only presented to
			 the compiler once regardless of the number of 
			 times it is #include'd. ) */
#define aosHinclude 1

#if AXMS
#include <io.h>
#include <direct.h>
#include <stdlib.h>
#endif
#include <stdio.h>

#if SYS&B4_2
#include <sys/file.h>
#else
#include <fcntl.h>
#endif

#ifndef O_NDELAY
#include <fcntl.h>
#endif

/* The following definitions do not exist on SYS 5 or VMS */

#ifndef F_OK
#define	F_OK		0	/* does file exist */
#define	X_OK		1	/* is it executable by caller */
#define	W_OK		2	/* writable by caller */
#define	R_OK		4	/* readable by caller */
#endif

extern int errno;

typedef short typeErr;	/* Values must be represented in 16 bits!! */
				/* Must be a short (not int) because it
				   is passed in DIA messages */

#define AOK		0		/* the best error code of all !! */
#define IN
#define OUT
#define INOUT
#define TRUE		1
#define FALSE		0

#define MIN(a,b) 	(((a)<(b))?(a):(b))
#define MAX(a,b) 	(((a)>(b))?(a):(b))
#define MAXLONGINT 	0x7fffffff
#define MINLONGINT	0x80000000

#define MAXINT		0x7fffffff
#define MININT		0x80000000

#define MAXSHORTINT	0x7fff
#define MINSHORTINT	0x8000
 
#define STRLONG		100	/* max size of long strings:   AP(long)   */
#define STRPATH		1024	/* max size of operating system pathnames */

#define V7		1	/* Version 7 */
#define SYS3		2	/* System III */
#define SYS5		4	/* System V */
#define B4_2		8	/* Berkely 4.2BSD */
#define AEGISO		16	/* apollo aegis only */
#define AEGIS (B4_2|AEGISO)	/* apollo aegis with 4.2BSD C-lib */
#define VMSSYS		32	/* DEC/VMS */

#ifndef AX_NT
#define AX_X11 1
#define AX_NT 0
#define AX_UNIX 1
#endif

#define Astat		stat

#ifndef EXIT_SUCCESS
#define EXIT_CODE_TRANS
#define EXIT_SUCCESS  ( 0 EXIT_CODE_TRANS)
#define EXIT_FAILURE  ( 1 EXIT_CODE_TRANS)
#define EXIT1 	      ( 1 EXIT_CODE_TRANS)
#define EXIT2 	      ( 2 EXIT_CODE_TRANS)
#define EXIT3 	      ( 3 EXIT_CODE_TRANS)
#endif

#endif

