# Copyright (C) 1983-1999 Applix, Inc.
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307, USA.
# 
# Applix Inc. is the original author of this material.  Please send
# generally useful enhancements to Applix in the form of all modified 
# source files including an explanation of the changes.  For more
# information see our website at www.applixware.org.
# 
# Do not remove or modify the license information above or the following
# Applix source control information from this file.
# 
# Applix filename: amake.mak
# Applix ASC version: 6
# Date: Sun Jan 24 21:13:17 1999
# 
#
aos_unix=
aos_ccflags=
aos_ldflags=
aos_fnlflags=
aos_compiler=cc
aos_final=cc
aos_tools=tools
aos_includes=

cc_flags=-c $(aos_ccflags) -I$(aos_includes)

compile=$(aos_compiler) $(cc_flags)
final=$(aos_final) $(aos_fnlflags) -o

cpp_objects=cpp1.o cpp2.o cpp3.o cpp4.o cpp5.o cpp6.o

cpr_objects=cpr_lintlibs.o cpr_semantic.o cpr_strkey.o cpr_strstr.o cpr_symbol.o cpr_y.tab.o cproto.o

objects=am_main.o am_utils.o \
	am_deps.o am_cdump.o am_rules.o am_bld.o \
	am_where.o am_getcw.o \
	am_hash.o am_mem.o junkscan.o

sys5_objects=am_main.o am_utils.o \
	am_deps.o am_cdump.o am_rules.o am_bld.o \
	am_where.o am_getcw.o \
	am_hash.o am_mem.o scansys5.o

adeps=$(aos_includes)/am_aos.h
deps=$(source)/am_bld.h $(adeps)
cdeps=$(adeps) $(source)/cppdef.h

all : $(aos_tools)/amake $(aos_tools)/acpp $(aos_tools)/acproto
sys5 : $(aos_tools)/amake.sys5 $(aos_tools)/acpp $(aos_tools)/acproto

$(aos_tools)/acproto : $(cpr_objects)
	$(final) $(aos_tools)/acproto $(cpr_objects)

$(aos_tools)/acpp : $(cpp_objects)
	$(final) $(aos_tools)/acpp $(cpp_objects)

$(aos_tools)/amake : $(objects)
	$(final) $(aos_tools)/amake $(objects)

$(aos_tools)/amake.sys5 : $(sys5_objects)
	$(final) $(aos_tools)/amake $(sys5_objects)

am_main.o : $(source)/am_main.c $(deps)
	$(compile) $(source)/am_main.c

am_cdump.o : $(source)/am_cdump.c $(deps)
	$(compile) $(source)/am_cdump.c

am_rules.o : $(source)/am_rules.c $(deps)
	$(compile) $(source)/am_rules.c

am_bld.o : $(source)/am_bld.c $(deps)
	$(compile) $(source)/am_bld.c

am_hash.o : $(source)/am_hash.c $(deps)
	$(compile) $(source)/am_hash.c

am_mem.o : $(source)/am_mem.c $(deps)
	$(compile) $(source)/am_mem.c

am_utils.o : $(source)/am_utils.c $(deps)
	$(compile) $(source)/am_utils.c

am_where.o : $(source)/am_where.c $(deps)
	$(compile) $(source)/am_where.c

am_getcw.o : $(source)/am_getcw.c $(deps)
	$(compile) $(source)/am_getcw.c

am_deps.o : $(source)/am_deps.c $(deps)
	$(compile) $(source)/am_deps.c

junkscan.o : $(source)/junkscan.c $(deps)
	$(compile) $(source)/junkscan.c

scansys5.o : $(source)/scansys5.c $(deps)
	$(compile) $(source)/scansys5.c

cpp1.o : $(source)/cpp1.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp1.c

cpp2.o : $(source)/cpp2.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp2.c

cpp3.o : $(source)/cpp3.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp3.c

cpp4.o : $(source)/cpp4.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp4.c

cpp5.o : $(source)/cpp5.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp5.c

cpp6.o : $(source)/cpp6.c $(cdeps)
	$(compile) -DFOR_AMAKE $(source)/cpp6.c


# C function prototyper - cproto

cprdeps=$(source)/cpr_semantic.h $(source)/cpr_symbol.h $(source)/cpr_system.h $(source)/cpr_yyerror.h $(source)/cproto.h

cpr_lintlibs.o : $(source)/cpr_lintlibs.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cpr_lintlibs.c

cpr_semantic.o : $(source)/cpr_semantic.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cpr_semantic.c

cpr_strkey.o : $(source)/cpr_strkey.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cpr_strkey.c

cpr_strstr.o : $(source)/cpr_strstr.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cpr_strstr.c

cpr_symbol.o : $(source)/cpr_symbol.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cpr_symbol.c

cpr_y.tab.o : $(source)/cpr_y.tab.c $(cprdeps) $(source)/cpr_lex.h
	$(compile) -DFOR_AMAKE $(source)/cpr_y.tab.c

cproto.o : $(source)/cproto.c $(cprdeps)
	$(compile) -DFOR_AMAKE $(source)/cproto.c

