# Copyright (C) 1983-1999 Applix, Inc.
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307, USA.
# 
# Applix Inc. is the original author of this material.  Please send
# generally useful enhancements to Applix in the form of all modified 
# source files including an explanation of the changes.  For more
# information see our website at www.applixware.org.
# 
# Do not remove or modify the license information above or the following
# Applix source control information from this file.
# 
# Applix filename: ntmake.mak
# Applix ASC version: 19
# Date: Thu May 27 21:12:41 1999
# 

# makefile for NT version of amake
#
# define NT_X86   when building on Intel NT
# define NT_MIPS  when building on ACE/ARC MIPS NT
# define NT_ALPHA when building on DEC Alpha NT

!include <ntwin32.mak>

# -Zg for proto


!IF "$(CPU)" == "i386"
flags=$(cflags) $(cdebug) -O -I. -nologo -DAXMS=1 -DAX_NT -D_MSDOS=1 -DMSDOS=1 -DSYS=MSDOS -DNT_X86 -DLOGGING \
    -DFOR_AMAKE -DSYNC_NT=1\
    -DX11 -DNO_APX_INTERNATIONAL=1
!ENDIF

!IF "$(CPU)" == "ALPHA"
flags=$(cflags) $(cdebug) -O -I. -nologo -DAXMS=1 -DAX_NT -D_MSDOS=1 -DMSDOS=1 -DSYS=MSDOS -DNT_ALPHA -DLOGGING \
    -DFOR_AMAKE -DSYNC_NT=1\
    -DX11 -DNO_APX_INTERNATIONAL=1
!ENDIF

!IF "$(CPU)" == "MIPS"
flags=$(cflags) $(cdebug) -O -I. -nologo -DAXMS=1 -DAX_NT -D_MSDOS=1 -DMSDOS=1 -DSYS=MSDOS -DNT_MIPS -DLOGGING \
    -DFOR_AMAKE -DSYNC_NT=1\
    -DX11 -DNO_APX_INTERNATIONAL=1
!ENDIF

!IF "$(CPU)" == "PPC"
flags=$(cflags) $(cdebug) -O -I. -nologo -DAXMS=1 -DAX_NT -D_MSDOS=1 -DMSDOS=1 -DSYS=MSDOS -DNT_PPC -DLOGGING \
    -DFOR_AMAKE -DSYNC_NT=1\
    -DX11 -DNO_APX_INTERNATIONAL=1
!ENDIF


cpp_objects=cpp1.obj cpp2.obj cpp3.obj cpp4.obj cpp5.obj cpp6.obj

cpr_objects=cpr_lintlibs.obj cpr_semantic.obj cpr_strkey.obj cpr_strstr.obj \
            cpr_symbol.obj cpr_y.tab.obj cproto.obj

objects=am_main.obj am_utils.obj \
    am_deps.obj am_cdump.obj am_rules.obj am_bld.obj \
    am_hash.obj am_mem.obj \
    am_del.obj acopy1.obj \
    am_getcw.obj junkscan.obj am_where.obj

incobj=fixinc.obj 

includes=am_aos.h

finder_objects=finder.obj
 
all : amake.exe acpp.exe acproto.exe

acproto.exe : $(cpr_objects)
    $(link) $(linkdebug) $(conflags) -out:acproto.exe $(cpr_objects) $(conlibs)
        copy acproto.exe ..\..\acproto.exe

acpp.exe : $(cpp_objects)
    $(link) $(linkdebug) $(conflags) -out:acpp.exe $(cpp_objects) $(conlibs)
        copy acpp.exe ..\..\acpp.exe

amake.exe : $(objects)
    $(link) $(linkdebug) $(conflags) -out:amake.exe $(objects) $(conlibs)
        copy amake.exe ..\..\amake.exe

fixinc.exe : $(objects)
    $(link) $(conflags) -out:fixinc.exe $(incobj) $(conlibs)

fixinc.obj : fixinc.c 
    $(cc) $(flags) $(cvars) fixinc.c

am_main.obj : am_main.c am_bld.h
    $(cc) $(flags) $(cvars) am_main.c

am_cdump.obj : am_cdump.c 
    $(cc) $(flags) $(cvars) am_cdump.c

am_rules.obj : am_rules.c am_bld.h
    $(cc) $(flags) $(cvars) am_rules.c

am_bld.obj : am_bld.c 
    $(cc) $(flags) $(cvars) am_bld.c

am_hash.obj : am_hash.c 
    $(cc) $(flags) $(cvars) am_hash.c

am_mem.obj : am_mem.c 
    $(cc) $(flags) $(cvars) am_mem.c

am_utils.obj : am_utils.c 
    $(cc) $(flags) $(cvars) am_utils.c

am_deps.obj : am_deps.c 
    $(cc) $(flags) $(cvars) am_deps.c

am_maketape.obj : am_maketape.c 
    $(cc) $(flags) $(cvars) am_maketape.c

agetNfname.obj : agetNfname.c 
    $(cc) $(flags) $(cvars) agetNfname.c
 
am_del.obj : am_del.c  $(includes)
    $(cc) $(flags) $(cvars) am_del.c

acopy1.obj : acopy1.c $(includes)
    $(cc) $(flags) $(cvars) acopy1.c

afindfiles.obj : afindfiles.c 
    $(cc) $(flags) $(cvars) afindfiles.c

am_getcw.obj : am_getcw.c  $(includes)
    $(cc) $(flags) $(cvars) am_getcw.c

junkscan.obj : junkscan.c  $(includes)
    $(cc) $(flags) $(cvars) junkscan.c

cpp1.obj : cpp1.c 
    $(cc) $(flags) $(cvars) cpp1.c

cpp2.obj : cpp2.c 
    $(cc) $(flags) $(cvars) cpp2.c

cpp3.obj : cpp3.c 
    $(cc) $(flags) $(cvars) cpp3.c

cpp4.obj : cpp4.c 
    $(cc) $(flags) $(cvars) cpp4.c

cpp5.obj : cpp5.c 
    $(cc) $(flags) $(cvars) cpp5.c

cpp6.obj : cpp6.c 
    $(cc) $(flags) $(cvars) cpp6.c

finder.obj : finder.c 
    $(cc) $(flags) $(cvars) finder.c

am_where.obj : am_where.c 
    $(cc) $(flags) $(cvars) am_where.c


# C function prototyper - cproto

cprdeps=cpr_lex.h cpr_semantic.h cpr_symbol.h cpr_system.h cpr_yyerror.h cproto.h

cpr_lintlibs.obj : cpr_lintlibs.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_lintlibs.c

cpr_semantic.obj : cpr_semantic.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_semantic.c

cpr_strkey.obj : cpr_strkey.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_strkey.c

cpr_strstr.obj : cpr_strstr.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_strstr.c

cpr_symbol.obj : cpr_symbol.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_symbol.c

cpr_y.tab.obj : cpr_y.tab.c $(cprdeps)
        $(cc) $(flags) $(cvars) cpr_y.tab.c

cproto.obj : cproto.c $(cprdeps)
        $(cc) $(flags) $(cvars) cproto.c

