/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axlist.hh
   Applix ASC version: 1
   Date: Mon Nov 16 14:27:53 1998
*/
#include <stdio.h>
#include <stdlib.h>

#ifndef _LIST_
#define _LIST_

#ifndef OK
#define OK 1
#endif

#ifndef ERROR
#define ERROR 0
#endif

typedef struct node {
    struct node *next;
    struct node *prev;
    void *elem;
} node;

#if 0
/* This list class uses (void *) for adding elements and returning elements.
   They user of the list has to cast anything returned as void * to the
   appropriate type. The cmpFunc is a pointer to a user function that will be
   called to find an element. Again both elements are void* and have to be cast
   appropriately. The first element is the info passed to the "find" call and
   the 2nd arg is the element against which the comparision is being done.
   A call to "unlink" will simply remove the element from the list. It DOES NOT
   free the memory associated with the element. This is the user's 
   responsibility.
   There are 3 ways to go through all the elements in the list. 
	1. Use the init_iter() and next() calls.
	2. do {elem = element(ix); ix++ } while (elem);
	3. for (ix=0;ix<listvar.number_of_elements();ix++) {
		elem = listvar.element(ix);
	
*/
#endif
class list {
    public:
        list(int (*cmpFunc)(void*, void*) = 0);
        ~list();
		long number_of_elements(void);
        long add(void *info);
		void *element(long n);
        long unlink(void *info, long n=-1);
        void* find(void *info);
        void print_list(void);
		int  comp_function( int (*cmpFunc)(void*, void*) );
		void  init_iter(void *elem = 0);
		void* next(void);
		int delete_all(void);		
 
        void del(int ix){ this->unlink(NULL,ix); }
        void* get(int ix) { return(this->element(ix));}
        int numberOfElements(void) { return(this->number_of_elements());} 

    private:
		int  _cmp(void *info, node *node);
		node *new_node(void *elem);
		void _unlink(node *tmp);

        node *head, *tail;
        int (*cmp)(void*, void*);
		node *iter;
		long n_elem;
};

typedef list axlist;
#endif
