/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elf_lib.c
   Applix ASC version: 43
   Date: Mon Jun 21 21:11:12 1999
*/
#include <aos.h>
#include <elfapi.h>
#include <elf.h>
#include <revstamp.h>

/* For version-stamping of library */
static char *my_program_version = ASC_WHAT_STR;
static char *my_build_machine = ASC_WHAT_MACHINE2;

#define ELELF_MODULE   "el_syms" /* .dat file name excluding lang. number */

extern package_info ELF_BIN_mainlib;
extern package_info ELF_BIN_super;
extern package_info ELF_BIN_bldrins;
extern package_info ELF_BIN_dialog;
extern package_info ELF_BIN_elcursor;
extern package_info ELF_BIN_sysdlg;
extern package_info ELF_BIN_dlged;
extern package_info ELF_BIN_debitmap;
extern package_info ELF_BIN_dedlgatt;
extern package_info ELF_BIN_deeditbx;
extern package_info ELF_BIN_deenter;
extern package_info ELF_BIN_delabel;
extern package_info ELF_BIN_delist;
extern package_info ELF_BIN_deoption;
extern package_info ELF_BIN_depanel;
extern package_info ELF_BIN_deradio;
extern package_info ELF_BIN_descale;
extern package_info ELF_BIN_deselect;
extern package_info ELF_BIN_detoggle;
extern package_info ELF_BIN_deverb;
extern package_info ELF_BIN_deaccel;
extern package_info ELF_BIN_decanvas;
extern package_info ELF_BIN_detable;
extern package_info ELF_BIN_decolor;
extern package_info ELF_BIN_menus;
extern package_info ELF_BIN_fstable;
extern package_info ELF_BIN_pr_dlg;
extern package_info ELF_BIN_axjv;
extern package_info ELF_BIN_url;
extern package_info ELF_BIN_sampler;
extern package_info ELF_BIN_upgrade;
extern package_info ELF_BIN_book;
extern package_info ELF_BIN_help;
extern package_info ELF_BIN_helplib;
extern package_info ELF_BIN_ehelp;
extern package_info ELF_BIN_ehelplib;
extern package_info ELF_BIN_tutorlib;
extern package_info ELF_BIN_tutor;
extern package_info ELF_BIN_doclinks;
extern package_info ELF_BIN_elrec;
extern package_info ELF_BIN_exit_all;
extern package_info ELF_BIN_compatible;
extern package_info ELF_BIN_printutl;
extern package_info ELF_BIN_printass;
extern package_info ELF_BIN_eltree;
extern package_info ELF_BIN_newopen;
extern package_info ELF_BIN_taborder;
extern package_info ELF_BIN_filtwiz;

extern package_info ELF_BIN_bldrdlg;
extern package_info ELF_BIN_buildlib;
extern package_info ELF_BIN_odata;
extern package_info ELF_BIN_olapserv;
#if !BUILD_KANJI
extern package_info ELF_BIN_o_tm1;
#endif
extern package_info ELF_BIN_sqlcnx;
extern package_info ELF_BIN_sqlcmd;
extern package_info ELF_BIN_oapp;
extern package_info ELF_BIN_odlg;
extern package_info ELF_BIN_oui;
extern package_info ELF_BIN_obox;
extern package_info ELF_BIN_open;
extern package_info ELF_BIN_owidget;
extern package_info ELF_BIN_oradio;
extern package_info ELF_BIN_otoggle;
extern package_info ELF_BIN_omenubar;
extern package_info ELF_BIN_ooptionm;
extern package_info ELF_BIN_oenter;
extern package_info ELF_BIN_olabel;
extern package_info ELF_BIN_oicon;
extern package_info ELF_BIN_olistbox;
extern package_info ELF_BIN_ocanvas;
extern package_info ELF_BIN_obrowse;
extern package_info ELF_BIN_dbglist;
extern package_info ELF_BIN_opanel;
extern package_info ELF_BIN_otabctl;
extern package_info ELF_BIN_oeditbox;
extern package_info ELF_BIN_ospliter;
extern package_info ELF_BIN_oscaler;
extern package_info ELF_BIN_otable;
extern package_info ELF_BIN_ocrosstb;
extern package_info ELF_BIN_orowcol;
extern package_info ELF_BIN_obutton;
extern package_info ELF_BIN_ortgate;
extern package_info ELF_BIN_ortrec;
extern package_info ELF_BIN_orttmpl;
extern package_info ELF_BIN_ohistdat;
extern package_info ELF_BIN_oerror;
extern package_info ELF_BIN_oprinter;
extern package_info ELF_BIN_oreport;
extern package_info ELF_BIN_odpen;
extern package_info ELF_BIN_omail;
extern package_info ELF_BIN_ocmndlg;
extern package_info ELF_BIN_o_ssapp;
extern package_info ELF_BIN_elodbc;
extern package_info ELF_BIN_odbc;
extern package_info ELF_BIN_ocombo;
extern package_info ELF_BIN_ocorba;
extern package_info ELF_BIN_o_wpapp;
extern package_info ELF_BIN_o_geapp;
extern package_info ELF_BIN_o_chart;

static package_info* elf_stdlib[] =
{
 &ELF_BIN_mainlib,
 &ELF_BIN_super,
 &ELF_BIN_bldrins,
 &ELF_BIN_dialog,
 &ELF_BIN_elcursor,
 &ELF_BIN_sysdlg,
 &ELF_BIN_dlged,
 &ELF_BIN_debitmap,
 &ELF_BIN_dedlgatt,
 &ELF_BIN_deeditbx,
 &ELF_BIN_deenter,
 &ELF_BIN_delabel,
 &ELF_BIN_delist,
 &ELF_BIN_deoption,
 &ELF_BIN_depanel,
 &ELF_BIN_deradio,
 &ELF_BIN_descale,
 &ELF_BIN_deselect,
 &ELF_BIN_detoggle,
 &ELF_BIN_deverb,
 &ELF_BIN_deaccel,
 &ELF_BIN_decanvas,
 &ELF_BIN_detable,
 &ELF_BIN_decolor,
 &ELF_BIN_menus,
 &ELF_BIN_axjv,
 &ELF_BIN_url,
 &ELF_BIN_newopen,
 &ELF_BIN_taborder,
 &ELF_BIN_filtwiz,
};

static package_info* elf_objects[]=
{
 &ELF_BIN_bldrdlg,
 &ELF_BIN_buildlib,
 &ELF_BIN_odata,
 &ELF_BIN_olapserv,
#if !BUILD_KANJI
 &ELF_BIN_o_tm1,
#endif
 &ELF_BIN_sqlcnx,
 &ELF_BIN_sqlcmd,
 &ELF_BIN_oapp,
 &ELF_BIN_odlg,
 &ELF_BIN_oui,
 &ELF_BIN_obox,
 &ELF_BIN_open,
 &ELF_BIN_owidget,
 &ELF_BIN_oradio,
 &ELF_BIN_otoggle,
 &ELF_BIN_omenubar,
 &ELF_BIN_ooptionm,
 &ELF_BIN_oenter,
 &ELF_BIN_olabel,
 &ELF_BIN_oicon,
 &ELF_BIN_olistbox,
 &ELF_BIN_ocanvas,
 &ELF_BIN_obrowse,
 &ELF_BIN_dbglist,
 &ELF_BIN_opanel,
 &ELF_BIN_otabctl,
 &ELF_BIN_oeditbox,
 &ELF_BIN_ospliter,
 &ELF_BIN_oscaler,
 &ELF_BIN_otable,
 &ELF_BIN_ocrosstb,
 &ELF_BIN_orowcol,
 &ELF_BIN_obutton,
 &ELF_BIN_ortgate,
 &ELF_BIN_ortrec,
 &ELF_BIN_orttmpl,
 &ELF_BIN_ohistdat,
 &ELF_BIN_oerror,
 &ELF_BIN_oprinter,
 &ELF_BIN_oreport,
 &ELF_BIN_odpen,
 &ELF_BIN_omail,
 &ELF_BIN_ocmndlg,
 &ELF_BIN_o_ssapp,
 &ELF_BIN_elodbc,
 &ELF_BIN_odbc,
 &ELF_BIN_ocombo,
 &ELF_BIN_eltree,
 &ELF_BIN_ocorba,
 &ELF_BIN_o_wpapp,
 &ELF_BIN_o_geapp,
 &ELF_BIN_o_chart,
};


static package_info* elf_app_packages[] =
{ /* These should be moved to the application libraries */
 &ELF_BIN_fstable,
 &ELF_BIN_pr_dlg,
 &ELF_BIN_sampler,
 &ELF_BIN_upgrade,
 &ELF_BIN_book,
 &ELF_BIN_help,
 &ELF_BIN_helplib,
 &ELF_BIN_ehelp,
 &ELF_BIN_ehelplib,
 &ELF_BIN_tutor,
 &ELF_BIN_tutorlib,
 &ELF_BIN_doclinks,
 &ELF_BIN_elrec,
 &ELF_BIN_exit_all,
 &ELF_BIN_compatible,
 &ELF_BIN_printutl,
 &ELF_BIN_printass,
};


static int ELElfModuleStartInd=0; 

/*************************************************************************
function: ElfInstallLibModules() - Install all ELF Library Modules 
*       
*/

ElfInstallLibModules()
{
	ElfInstallModule(sizeof(elf_stdlib)/sizeof(package_info*),elf_stdlib);
	ElfInstallModule(sizeof(elf_objects)/sizeof(package_info*),elf_objects);
	ElfInstallModule(sizeof(elf_app_packages)/sizeof(package_info*),elf_app_packages);
}

/*****************************************************************************
* function: ELElfMacroId() -  given a macro (in libaxel.so) offset returns
* its absolute macro index
*       
*/
int 
ELElfMacroId(macro_offset)
int macro_offset;
{
	if(!ELElfModuleStartInd)
      ELElfModuleStartInd = ElfGetModuleStartInd(ELELF_MODULE); 
	return(ELElfModuleStartInd+macro_offset);
}


