/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: opensrc.ctl
   Applix ASC version: 19
   Date: Wed Jun 16 21:13:46 1999
*/
/* This is the master control file for opensrc builds. */

.tell Source Tree AOS/src

#if SUN4S
#include <solaris_sparc.defs>
#elif SUNIS
#include <solaris_x86.defs>
#elif LINUX
#if __alpha__
#include <linux_alpha_glibc2.defs>
#elif __powerpc__
#include <linux_ppc_glibc2.defs>
#else
#include <linux_x86_glibc2.defs>
#endif
#elif LINUX_LIBC5
#include <linux_x86_libc5.defs>
#elif NT_X86
#include <nt_x86.defs>
#else
No_machine_specified,_enter_one_here_(opensrc.ctl).
#endif

.tell Building into AOS_AXDATA
.tell Objects Tree AOS_OBJECTS

/* Root of objects place.  By default all object go here/component */
.objdir AOS_OBJECTS

/* List all of the valid object directories */
.outdir AOS_AXDATA
.outdir AOS_OBJECTS
.outdir AOS_AXOBJ/trans
.outdir AOS_TOOLS
.outdir AOS_SCRIPTS
.outdir THIM_OBJ
.outdir AOS_EXEC
.outdir AOS_AXDATA/axshlib
.outdir AOS_JAVA
.outdir AOS_AXOBJ/proto

/* Where to load prototypes - same for debug/optimized builds */
.defdir cproto_dir AOS_AXOBJ/proto

/*
Define all sorts of directories for the benefit of the .locate directives
in the .amk files.  Many of the following directories are not currently used 
by the open source ELF, but may be part of the open source release in
future versions.
*/
.defdir opensrc_result AOS/opensrc
.defdir above_sources AOS
.defdir top_level AOS_EXEC
.defdir shlibloc AOS_AXDATA/axshlib
.defdir projects AOS_AXDATA/projects
.defdir exec AOS_AXDATA
.defdir axlangdir AOS_AXDATA/eng
.defdir linux_office AOS_EXEC/applix_office
.defdir linux_office_eng AOS_EXEC/applix_office/eng
.defdir linux_office_frn AOS_EXEC/applix_office/frn
.defdir linux_office_grm AOS_EXEC/applix_office/grm
.chmod_dir Demos 755
.defdir openmail_nt AOS_EXEC/openmail
.defdir integration AOS_INTEGRATION
.defdir filters AOS_FILTERS
.defdir local AOS_EXEC/axlocal
.defdir local_eng AOS_EXEC/axlocal/eng
.defdir freebees AOS_AXDATA/filters
.defdir toolkit_rt AOS_OBJECTS/toolkits/realtime
.defdir toolkit_dbase AOS_OBJECTS/toolkits/database
.defdir toolkit_help AOS_OBJECTS/toolkits/help
.defdir dialogs AOS_AXDATA/eng/dialogs
.defdir images AOS_AXDATA/eng/images
.defdir helpdb AOS_AXDATA/eng/help.db
.defdir tutorials AOS_AXDATA/eng/tutor
.defdir modeldocs AOS_AXDATA/eng/models
.defdir demodocs AOS_AXDATA/eng/demodocs
.defdir demo_wp AOS_AXDATA/eng/Samples
.defdir demo_ss AOS_AXDATA/eng/Samples
.defdir demo_gr AOS_AXDATA/eng/Samples
.defdir demo_me AOS_AXDATA/eng/Samples
.defdir help AOS_AXDATA/eng/help
.defdir books AOS_AXDATA/eng/books
.defdir html_help_eng AOS_AXDATA/eng/help
.defdir builder_samples AOS_AXDATA/eng/Demos/MainDemo/bld_demo
.defdir builder_samples_calc AOS_AXDATA/eng/Demos/MainDemo/bld_demo/calc
.defdir builder_samples_clock AOS_AXDATA/eng/Demos/MainDemo/bld_demo/clock
.defdir builder_samples_livewire AOS_AXDATA/eng/Demos/MainDemo/bld_demo/livewire
.defdir builder_samples_intro AOS_AXDATA/eng/Demos/MainDemo/bld_demo/intro
.defdir builder_samples_canvas AOS_AXDATA/eng/Demos/MainDemo/bld_demo/canvas
.defdir builder_samples_chart AOS_AXDATA/eng/Demos/MainDemo/bld_demo/chart
.defdir builder_samples_mail AOS_AXDATA/eng/Demos/MainDemo/bld_demo/mail
.defdir builder_samples_print AOS_AXDATA/eng/Demos/MainDemo/bld_demo/print
.defdir builder_samples_rt AOS_AXDATA/eng/Demos/MainDemo/bld_demo/rt
.defdir builder_samples_table AOS_AXDATA/eng/Demos/MainDemo/bld_demo/table
.defdir frn_builder_samples AOS_AXDATA/frn/Demos/MainDemo/bld_demo
.defdir frn_builder_samples_calc AOS_AXDATA/frn/Demos/MainDemo/bld_demo/calc
.defdir frn_builder_samples_clock AOS_AXDATA/frn/Demos/MainDemo/bld_demo/clock
.defdir frn_builder_samples_livewire AOS_AXDATA/frn/Demos/MainDemo/bld_demo/livewire
.defdir frn_builder_samples_intro AOS_AXDATA/frn/Demos/MainDemo/bld_demo/intro
.defdir frn_builder_samples_canvas AOS_AXDATA/frn/Demos/MainDemo/bld_demo/canvas
.defdir frn_builder_samples_chart AOS_AXDATA/frn/Demos/MainDemo/bld_demo/chart
.defdir frn_builder_samples_mail AOS_AXDATA/frn/Demos/MainDemo/bld_demo/mail
.defdir frn_builder_samples_print AOS_AXDATA/frn/Demos/MainDemo/bld_demo/print
.defdir frn_builder_samples_rt AOS_AXDATA/frn/Demos/MainDemo/bld_demo/rt
.defdir frn_builder_samples_table AOS_AXDATA/frn/Demos/MainDemo/bld_demo/table
.defdir grm_builder_samples AOS_AXDATA/grm/Demos/MainDemo/bld_demo
.defdir grm_builder_samples_calc AOS_AXDATA/grm/Demos/MainDemo/bld_demo/calc
.defdir grm_builder_samples_clock AOS_AXDATA/grm/Demos/MainDemo/bld_demo/clock
.defdir grm_builder_samples_livewire AOS_AXDATA/grm/Demos/MainDemo/bld_demo/livewire
.defdir grm_builder_samples_intro AOS_AXDATA/grm/Demos/MainDemo/bld_demo/intro
.defdir grm_builder_samples_canvas AOS_AXDATA/grm/Demos/MainDemo/bld_demo/canvas
.defdir grm_builder_samples_chart AOS_AXDATA/grm/Demos/MainDemo/bld_demo/chart
.defdir grm_builder_samples_mail AOS_AXDATA/grm/Demos/MainDemo/bld_demo/mail
.defdir grm_builder_samples_print AOS_AXDATA/grm/Demos/MainDemo/bld_demo/print
.defdir grm_builder_samples_rt AOS_AXDATA/grm/Demos/MainDemo/bld_demo/rt
.defdir grm_builder_samples_table AOS_AXDATA/grm/Demos/MainDemo/bld_demo/table
.defdir devsetup AOS_EXEC/axfonts/all_bdf
.defdir devpcf AOS_EXEC/axfonts/all_pcf
.defdir lang AOS_EXEC/axlang
.defdir colordir AOS_EXEC/template/color
.defdir monodir AOS_EXEC/template/mono
.defdir 35mmdir AOS_EXEC/template/35mm
.defdir backlitdir AOS_EXEC/template/backlit
.defdir outlinedir AOS_EXEC/template/outline/eng
.defdir french_outlinedir AOS_EXEC/template/outline/frn
.defdir german_outlinedir AOS_EXEC/template/outline/grm
.defdir japanese_outlinedir AOS_EXEC/template/outline/jpn
.defdir chartdir AOS_EXEC/template/chart
.defdir schemedir AOS_EXEC/template/scheme
.defdir elf AOS_AXDATA/elf
.defdir elflib AOS_AXDATA/elflib/eng
.defdir elflib_frn AOS_AXDATA/elflib/frn
.defdir elflib_grm AOS_AXDATA/elflib/grm
.defdir elflib_jpn AOS_AXDATA/elflib/jpn
.defdir obj AOS_OBJECTS
.defdir elfobj AOS_OBJECTS/elflib
.defdir data AOS_OBJECTS/data
.defdir odbc_drv AOS_AXDATA/axshlib/drivers
.defdir odbc_lib AOS_OBJECTS/odbc/odbclib
.defdir clipart AOS_EXEC/axart
.defdir alphabet AOS_EXEC/axart/alphabet
.defdir anml_out AOS_EXEC/axart/anml_out
.defdir arrows2 AOS_EXEC/axart/arrows
.defdir art_ent AOS_EXEC/axart/art_ent
.defdir back_grou AOS_EXEC/axart/backgrnd
.defdir banners AOS_EXEC/axart/banners
.defdir beauty AOS_EXEC/axart/beauty
.defdir beverage AOS_EXEC/axart/beverage
.defdir borders2 AOS_EXEC/axart/borders
.defdir buld_str AOS_EXEC/axart/bldg_str
.defdir business AOS_EXEC/axart/business
.defdir cartoons AOS_EXEC/axart/cartoons
.defdir child_ed AOS_EXEC/axart/child_ed
.defdir clothes AOS_EXEC/axart/clothes
.defdir comm AOS_EXEC/axart/comm
.defdir computer AOS_EXEC/axart/computer
.defdir dingbats AOS_EXEC/axart/dingbats
.defdir fitness AOS_EXEC/axart/fitness
.defdir foods AOS_EXEC/axart/foods
.defdir framers AOS_EXEC/axart/framers
.defdir games AOS_EXEC/axart/games
.defdir headers AOS_EXEC/axart/headers
.defdir holiday AOS_EXEC/axart/holiday
.defdir househld AOS_EXEC/axart/househld
.defdir icons AOS_EXEC/axart/icons
.defdir industry AOS_EXEC/axart/industry
.defdir internat AOS_EXEC/axart/internat
.defdir people AOS_EXEC/axart/people
.defdir recreat AOS_EXEC/axart/recreat
.defdir roadsign AOS_EXEC/axart/roadsign
.defdir shapes AOS_EXEC/axart/shapes
.defdir sports AOS_EXEC/axart/sports
.defdir stars AOS_EXEC/axart/stars
.defdir symbols AOS_EXEC/axart/symbols
.defdir ctools AOS_EXEC/axart/tools
.defdir transpor AOS_EXEC/axart/transpor
.defdir travel AOS_EXEC/axart/travel
.defdir types_ph AOS_EXEC/axart/types_ph
.defdir zodiac AOS_EXEC/axart/zodiac
.defdir trans_base AOS_AXOBJ/trans
.defdir trans_tkit AOS_AXOBJ/trans/toolkit
.defdir trans_tools AOS_AXOBJ/trans/toolkit/tools
.defdir trans_gloss AOS_AXOBJ/trans/toolkit/gloss
.defdir base_dir AOS_AXOBJ/trans/base
.defdir base_dialogs AOS_AXOBJ/trans/base/dialogs
.defdir base_custom AOS_AXOBJ/trans/base/custom
.defdir base_custom_dialogs AOS_AXOBJ/trans/base/custom/dialogs
.defdir base_images AOS_AXOBJ/trans/base/images
.defdir webuser_exec AOS_AXDATA/webuser
.defdir french_base AOS_AXOBJ/trans/french
.defdir french_base_dialogs AOS_AXOBJ/trans/french/dialogs
.defdir french_base_exceptions AOS_AXOBJ/trans/french/exceptions
.defdir french_dir AOS_AXDATA/frn
.defdir french_dialogs AOS_AXDATA/frn/dialogs
.defdir french_images AOS_AXDATA/frn/images
.defdir french_models AOS_AXDATA/frn/models
.defdir french_help AOS_AXDATA/frn/help
.defdir french_tutorials AOS_AXDATA/frn/tutor
.defdir french_books AOS_AXDATA/frn/books
.defdir french_demos_top AOS_AXDATA/frn/Demos
.defdir french_demos_main AOS_AXDATA/frn/Demos/MainDemo
.defdir french_demos_custom AOS_AXDATA/frn/Demos/MainDemo/custom_apps
.defdir french_demos_gfx AOS_AXDATA/frn/Demos/MainDemo/gfx_demo
.defdir french_demos_presents AOS_AXDATA/frn/Demos/MainDemo/presents_demo
.defdir french_demos_rt AOS_AXDATA/frn/Demos/MainDemo/rt_demo
.defdir french_demos_ss AOS_AXDATA/frn/Demos/MainDemo/ss_demo
.defdir french_demos_wp AOS_AXDATA/frn/Demos/MainDemo/wp_demo
.defdir french_demos_bld AOS_AXDATA/frn/Demos/MainDemo/bld_demo
.defdir french_install AOS_EXEC/install_frn
.defdir german_install AOS_EXEC/install_grm
.defdir german_base AOS_AXOBJ/trans/german
.defdir german_base_dialogs AOS_AXOBJ/trans/german/dialogs
.defdir german_base_exceptions AOS_AXOBJ/trans/german/exceptions
.defdir german_dir AOS_AXDATA/grm
.defdir german_dialogs AOS_AXDATA/grm/dialogs
.defdir german_images AOS_AXDATA/grm/images
.defdir german_models AOS_AXDATA/grm/models
.defdir german_help AOS_AXDATA/grm/help
.defdir german_tutorials AOS_AXDATA/grm/tutor
.defdir german_books AOS_AXDATA/grm/books
.defdir german_demos_top AOS_AXDATA/grm/Demos
.defdir german_demos_main AOS_AXDATA/grm/Demos/MainDemo
.defdir german_demos_custom AOS_AXDATA/grm/Demos/MainDemo/custom_apps
.defdir german_demos_gfx AOS_AXDATA/grm/Demos/MainDemo/gfx_demo
.defdir german_demos_presents AOS_AXDATA/grm/Demos/MainDemo/presents_demo
.defdir german_demos_rt AOS_AXDATA/grm/Demos/MainDemo/rt_demo
.defdir german_demos_ss AOS_AXDATA/grm/Demos/MainDemo/ss_demo
.defdir german_demos_wp AOS_AXDATA/grm/Demos/MainDemo/wp_demo
.defdir german_demos_bld AOS_AXDATA/grm/Demos/MainDemo/bld_demo
.defdir rts AOS_OBJECTS/rts
.defdir ginclude AOS_OBJECTS/ginclude
.defdir setools AOS_AXDATA
.defdir tools AOS_OBJECTS/bldtools
.defdir bldtools AOS_OBJECTS/bldtools
.defdir scripts AOS_SCRIPTS
.defdir lintlibs AOS_AXOBJ/lint
.defdir InitELF AOS_AXDATA/InitELF
.defdir elfsaobjects AOS_OBJECTS/elf_sa
.defdir licensetools AOS_OBJECTS/axnlm
.defdir elfsamples AOS_EXEC/axlocal/elf
.defdir elflangsamples AOS_AXDATA/eng/Demos
.defdir demos_top AOS_AXDATA/eng/Demos
.defdir demos_main AOS_AXDATA/eng/Demos/MainDemo
.defdir demos_custom AOS_AXDATA/eng/Demos/MainDemo/custom_apps
.defdir demos_gfx AOS_AXDATA/eng/Demos/MainDemo/gfx_demo
.defdir demos_presents AOS_AXDATA/eng/Demos/MainDemo/presents_demo
.defdir demos_rt AOS_AXDATA/eng/Demos/MainDemo/rt_demo
.defdir demos_ss AOS_AXDATA/eng/Demos/MainDemo/ss_demo
.defdir demos_wp AOS_AXDATA/eng/Demos/MainDemo/wp_demo
.defdir demos_bld AOS_AXDATA/eng/Demos/MainDemo/bld_demo
.defdir axcalcsvr AOS_EXEC/axlocal/ss
.defdir triarch_dir AOS_AXDATA/idn
.defdir oracle_dir AOS_OBJECTS/oracle
.defdir oracle_proc AOS_OBJECTS/oracle/proc
.defdir oracle_proc_lib AOS_OBJECTS/oracle/proc/lib
.defdir oracle_proc_mesg AOS_OBJECTS/oracle/proc/mesg
.defdir oracle_rdbms AOS_OBJECTS/oracle/rdbms
.defdir oracle_rdbms_lib AOS_OBJECTS/oracle/rdbms/lib
.defdir fontmetrics AOS_AXDATA/fontmetrics
.defdir galliumbase AOS_AXDATA/fontmetrics/gallium
.defdir galliumfs AOS_AXDATA/fontmetrics/gallium/fs
.defdir outlinefont AOS_AXDATA/fontmetrics/gallium/fs/aplxfont
.defdir aaresources AOS_AXDATA/aarsrc/eng
.defdir aa_img_resources AOS_AXDATA/aarsrc/eng/aximg
.defdir olefilters AOS_AXDATA/filters/olefilter
.defdir java_main AOS_JAVA
.defdir java_aahttp AOS_JAVA_AAHTTP
.defdir java_netscape AOS_JAVA/netscape
.defdir java_apache AOS_JAVA/apache
.defdir java_cgi-bin AOS_JAVA/cgi-bin
.defdir java_aahttp_root AOS_JAVA_AAHTTP_ROOT
.defdir java_aahttp_config AOS_JAVA_AAHTTP/config
.defdir java_aahttp_load AOS_JAVA_AAHTTP/load
.defdir java_classes AOS_JAVA_AAHTTP_ROOT/classes
.defdir java_office AOS_JAVA_AAHTTP_ROOT/classes/office
.defdir java_ent    AOS_JAVA_AAHTTP_ROOT/classes/ent
.defdir java_elf AOS_JAVA_AAHTTP_ROOT/classes/elf

.defdir java_help AOS_JAVA_AAHTTP_ROOT/help

.defdir java_templates_images AOS_JAVA_AAHTTP_ROOT/templates/images
.defdir java_templates_eng AOS_JAVA_AAHTTP_ROOT/templates/eng
.defdir java_templates_grm AOS_JAVA_AAHTTP_ROOT/templates/grm
.defdir java_templates_frn AOS_JAVA_AAHTTP_ROOT/templates/frn
.defdir java_templates_jpn AOS_JAVA_AAHTTP_ROOT/templates/jpn

.defdir java_demo_jpn AOS_JAVA_COMMON/demos/jpn

lib_ext=a
shlib_ext=so

/*
Specify which files should not particpate at all in the prototyping.
This is needed to avoid handing the prototyper stub and true C++ files.
*/
.cproto_exclude no_proto.dat

.locate AOS/src
synclist.dat		/* versions of all files from Applix Source Control */

.locate AOS
amake acpp acproto	/* build tools go above the sources */

.locate AOS_EXEC
elf delf			/* the final launching executable */

.shared_lib_dir AOS_AXDATA/axshlib	/* add this to LD_LIBRARY_PATH */

.locdir AOS/src		/* main source tree */

#if NT_X86
.buildfile nt_opensrc.amk
#else
.buildfile opensrc.amk
#endif

.locate /var/axlinks
jdk115 jre115

