/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elfrtmainimports.c
   Applix ASC version: 0
   Date: Thu Jun 24 21:58:39 1999
*/
#include <axshlib.h>

/** Funcs Imported from axel
   ***********************************************************/

static ShlibFuncInfo* ELExpFuncPtrTbl=NULL;

int  (*ELEXPORT_ELElfMacroId)(int macro_offset);

int  ELElfMacroId(int macro_offset)
{
	if(ELExpFuncPtrTbl==NULL && !SHLoadAndSnap_EL(0))
		return((int )0);
	return(ELEXPORT_ELElfMacroId(macro_offset));
}

int  (*ELEXPORT_ElfInstallLibModules)(void);

int  ElfInstallLibModules(void)
{
	if(ELExpFuncPtrTbl==NULL && !SHLoadAndSnap_EL(1))
		return((int )0);
	return(ELEXPORT_ElfInstallLibModules());
}

int isShlibLoaded_EL()
{
	return(ELExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_EL(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "ELElfMacroId", NULL },
		{ "ElfInstallLibModules", NULL },
		{ NULL,NULL }
	};

	if((ELExpFuncPtrTbl=AxLoadShlib(LIBID_EL,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,ELExpFuncPtrTbl);

	ELEXPORT_ELElfMacroId = 
		(int  (*)(int macro_offset)) impFuncTbl[0].fptr;
	ELEXPORT_ElfInstallLibModules = 
		(int  (*)(void)) impFuncTbl[1].fptr;

	AxElfInstallForShlib(LIBID_EL);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_EL()
{
	if(ELExpFuncPtrTbl != NULL)
		return;

	ELEXPORT_ELElfMacroId = ELElfMacroId;
	ELEXPORT_ElfInstallLibModules = ElfInstallLibModules;
}

/** Funcs Imported from axdb
   ***********************************************************/

static ShlibFuncInfo* DBExpFuncPtrTbl=NULL;

int  (*DBEXPORT_DBElfInstall)(void);

int  DBElfInstall(void)
{
	if(DBExpFuncPtrTbl==NULL && !SHLoadAndSnap_DB(0))
		return((int )0);
	return(DBEXPORT_DBElfInstall());
}

int isShlibLoaded_DB()
{
	return(DBExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_DB(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "DBElfInstall", NULL },
		{ NULL,NULL }
	};

	if((DBExpFuncPtrTbl=AxLoadShlib(LIBID_DB,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,DBExpFuncPtrTbl);

	DBEXPORT_DBElfInstall = 
		(int  (*)(void)) impFuncTbl[0].fptr;

	AxElfInstallForShlib(LIBID_DB);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_DB()
{
	if(DBExpFuncPtrTbl != NULL)
		return;

	DBEXPORT_DBElfInstall = DBElfInstall;
}

/** Funcs Imported from axge
   ***********************************************************/

static ShlibFuncInfo* GEExpFuncPtrTbl=NULL;

void  (*GEEXPORT_AxFreeGFXbyPID)(int pid);

void  AxFreeGFXbyPID(int pid)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(0))
		return;
	GEEXPORT_AxFreeGFXbyPID(pid);
}

void * (*GEEXPORT_AxGFXFromData)(data_ptr aP);

void * AxGFXFromData(data_ptr aP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(1))
		return((void *)0);
	return(GEEXPORT_AxGFXFromData(aP));
}

graphics_main_type * (*GEEXPORT_AxGetGFXfromPID)(int pid);

graphics_main_type * AxGetGFXfromPID(int pid)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(2))
		return((graphics_main_type *)0);
	return(GEEXPORT_AxGetGFXfromPID(pid));
}

graphics_main_type * (*GEEXPORT_AxGetGFXfromUID)(int uid);

graphics_main_type * AxGetGFXfromUID(int uid)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(3))
		return((graphics_main_type *)0);
	return(GEEXPORT_AxGetGFXfromUID(uid));
}

data_ptr  (*GEEXPORT_AxMakeGFXData)(graphics_main_type *gfx);

data_ptr  AxMakeGFXData(graphics_main_type *gfx)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(4))
		return((data_ptr )0);
	return(GEEXPORT_AxMakeGFXData(gfx));
}

short  (*GEEXPORT_ElfbAssignGraphic)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbAssignGraphic(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(5))
		return((short )0);
	return(GEEXPORT_ElfbAssignGraphic(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbCreateGraphic)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbCreateGraphic(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(6))
		return((short )0);
	return(GEEXPORT_ElfbCreateGraphic(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbDestroyGraphic)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbDestroyGraphic(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(7))
		return((short )0);
	return(GEEXPORT_ElfbDestroyGraphic(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbGetGraphic)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbGetGraphic(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(8))
		return((short )0);
	return(GEEXPORT_ElfbGetGraphic(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbGraphicFuncs)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbGraphicFuncs(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(9))
		return((short )0);
	return(GEEXPORT_ElfbGraphicFuncs(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbLoadGraphic)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbLoadGraphic(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(10))
		return((short )0);
	return(GEEXPORT_ElfbLoadGraphic(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbReadGraphicBuffer)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbReadGraphicBuffer(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(11))
		return((short )0);
	return(GEEXPORT_ElfbReadGraphicBuffer(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbReadGraphicFile)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbReadGraphicFile(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(12))
		return((short )0);
	return(GEEXPORT_ElfbReadGraphicFile(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbReadRasterInfo)(data_ptr aP, data_ptr bufP, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbReadRasterInfo(data_ptr aP, data_ptr bufP, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(13))
		return((short )0);
	return(GEEXPORT_ElfbReadRasterInfo(aP,bufP,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbWriteGraphicBuffer)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbWriteGraphicBuffer(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(14))
		return((short )0);
	return(GEEXPORT_ElfbWriteGraphicBuffer(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*GEEXPORT_ElfbWriteGraphicFile)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbWriteGraphicFile(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(15))
		return((short )0);
	return(GEEXPORT_ElfbWriteGraphicFile(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

int  (*GEEXPORT_GECmdStatus)(char *name, int timestamp, int toggle_state_too, int code);

int  GECmdStatus(char *name, int timestamp, int toggle_state_too, int code)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(16))
		return((int )0);
	return(GEEXPORT_GECmdStatus(name,timestamp,toggle_state_too,code));
}

int  (*GEEXPORT_GEElfInstall)(void);

int  GEElfInstall(void)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(17))
		return((int )0);
	return(GEEXPORT_GEElfInstall());
}

int  (*GEEXPORT_GEElfMacroId)(int macro_offset);

int  GEElfMacroId(int macro_offset)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(18))
		return((int )0);
	return(GEEXPORT_GEElfMacroId(macro_offset));
}

int  (*GEEXPORT_GEMenuBarInfoModified)(int pid);

int  GEMenuBarInfoModified(int pid)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(19))
		return((int )0);
	return(GEEXPORT_GEMenuBarInfoModified(pid));
}

int  (*GEEXPORT_GETiffToGE)(void);

int  GETiffToGE(void)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(20))
		return((int )0);
	return(GEEXPORT_GETiffToGE());
}

int  (*GEEXPORT_GEUpdateMenuBarInfo)(int menubar_id);

int  GEUpdateMenuBarInfo(int menubar_id)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(21))
		return((int )0);
	return(GEEXPORT_GEUpdateMenuBarInfo(menubar_id));
}

int  (*GEEXPORT_GEthimble)(int argc, char *argv[]);

int  GEthimble(int argc, char *argv[])
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(22))
		return((int )0);
	return(GEEXPORT_GEthimble(argc,argv));
}

int  (*GEEXPORT_GetWashoutColor)(color_type *old_color, color_type *new_color);

int  GetWashoutColor(color_type *old_color, color_type *new_color)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(23))
		return((int )0);
	return(GEEXPORT_GetWashoutColor(old_color,new_color));
}

doc_links_info_t * (*GEEXPORT_GrGetDocLinksInfo)(graphics_main_type *ge);

doc_links_info_t * GrGetDocLinksInfo(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(24))
		return((doc_links_info_t *)0);
	return(GEEXPORT_GrGetDocLinksInfo(ge));
}

int  (*GEEXPORT_GrLocalizeDocLinks)(graphics_main_type *ge);

int  GrLocalizeDocLinks(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(25))
		return((int )0);
	return(GEEXPORT_GrLocalizeDocLinks(ge));
}

int  (*GEEXPORT_GrSetDocLinksInfo)(graphics_main_type *ge, doc_links_info_t *info);

int  GrSetDocLinksInfo(graphics_main_type *ge, doc_links_info_t *info)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(26))
		return((int )0);
	return(GEEXPORT_GrSetDocLinksInfo(ge,info));
}

int  (*GEEXPORT_GrSetRmInfo)(long w, int pid, int x, int y);

int  GrSetRmInfo(long w, int pid, int x, int y)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(27))
		return((int )0);
	return(GEEXPORT_GrSetRmInfo(w,pid,x,y));
}

int  (*GEEXPORT_PXthimble)(void);

int  PXthimble(void)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(28))
		return((int )0);
	return(GEEXPORT_PXthimble());
}

void  (*GEEXPORT_addStrToTextBox)(graphics_main_type *ge, thing *t, thing *s_t, int ix);

void  addStrToTextBox(graphics_main_type *ge, thing *t, thing *s_t, int ix)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(29))
		return;
	GEEXPORT_addStrToTextBox(ge,t,s_t,ix);
}

int  (*GEEXPORT_axtNeedBullet)(axtext *txt, axtIndent *in, int ix);

int  axtNeedBullet(axtext *txt, axtIndent *in, int ix)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(30))
		return((int )0);
	return(GEEXPORT_axtNeedBullet(txt,in,ix));
}

int  (*GEEXPORT_calcExtents)(graphics_main_type *ge, thing *t);

int  calcExtents(graphics_main_type *ge, thing *t)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(31))
		return((int )0);
	return(GEEXPORT_calcExtents(ge,t));
}

void  (*GEEXPORT_clearGE)(graphics_main_type *ge);

void  clearGE(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(32))
		return;
	GEEXPORT_clearGE(ge);
}

int  (*GEEXPORT_colormapInit)(graphics_main_type *ge);

int  colormapInit(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(33))
		return((int )0);
	return(GEEXPORT_colormapInit(ge));
}

void  (*GEEXPORT_convertPath)(graphics_main_type *ge, poly_type *inpath, poly_type *outpath);

void  convertPath(graphics_main_type *ge, poly_type *inpath, poly_type *outpath)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(34))
		return;
	GEEXPORT_convertPath(ge,inpath,outpath);
}

char * (*GEEXPORT_createToolString)(int tool_ix);

char * createToolString(int tool_ix)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(35))
		return((char *)0);
	return(GEEXPORT_createToolString(tool_ix));
}

thing * (*GEEXPORT_cvtInsertNewLines)(graphics_main_type *ge, thing *t);

thing * cvtInsertNewLines(graphics_main_type *ge, thing *t)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(36))
		return((thing *)0);
	return(GEEXPORT_cvtInsertNewLines(ge,t));
}

void  (*GEEXPORT_disposePaths)(graphics_main_type *ge, int n_paths, poly_type *paths);

void  disposePaths(graphics_main_type *ge, int n_paths, poly_type *paths)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(37))
		return;
	GEEXPORT_disposePaths(ge,n_paths,paths);
}

void  (*GEEXPORT_disposeThing)(graphics_main_type *ge, thing *t, int dispose_children);

void  disposeThing(graphics_main_type *ge, thing *t, int dispose_children)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(38))
		return;
	GEEXPORT_disposeThing(ge,t,dispose_children);
}

void  (*GEEXPORT_ellToPath)(graphics_main_type *ge, TmPoint32 outline_pts[5], int first, int final, int close_flag, poly_type *path);

void  ellToPath(graphics_main_type *ge, TmPoint32 outline_pts[5], int first, int final, int close_flag, poly_type *path)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(39))
		return;
	GEEXPORT_ellToPath(ge,outline_pts,first,final,close_flag,path);
}

int  (*GEEXPORT_extractSizeAndAngle)(graphics_main_type *ge, TmPoint32 *p1, TmPoint32 *p2, TmPoint32 *p3, TmPoint32 *p4, int *width, int *height, double *sinAng, double *cosAng, double *xShear);

int  extractSizeAndAngle(graphics_main_type *ge, TmPoint32 *p1, TmPoint32 *p2, TmPoint32 *p3, TmPoint32 *p4, int *width, int *height, double *sinAng, double *cosAng, double *xShear)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(40))
		return((int )0);
	return(GEEXPORT_extractSizeAndAngle(ge,p1,p2,p3,p4,width,height,sinAng,cosAng,xShear));
}

int  (*GEEXPORT_foundCmap)(graphics_main_type *ge, cmap_type *cmap1, cmap_type *cmap2);

int  foundCmap(graphics_main_type *ge, cmap_type *cmap1, cmap_type *cmap2)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(41))
		return((int )0);
	return(GEEXPORT_foundCmap(ge,cmap1,cmap2));
}

int  (*GEEXPORT_freeCmap)(graphics_main_type *ge, cmap_type *cmap);

int  freeCmap(graphics_main_type *ge, cmap_type *cmap)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(42))
		return((int )0);
	return(GEEXPORT_freeCmap(ge,cmap));
}

void  (*GEEXPORT_gClearPage)(graphics_main_type *ge, ge_page_type *page, int del_chart);

void  gClearPage(graphics_main_type *ge, ge_page_type *page, int del_chart)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(43))
		return;
	GEEXPORT_gClearPage(ge,page,del_chart);
}

int  (*GEEXPORT_gInstantiateTxt)(graphics_main_type *ge, thing *text_t, axtext *txt, int zoom, int use_ffg, int convert);

int  gInstantiateTxt(graphics_main_type *ge, thing *text_t, axtext *txt, int zoom, int use_ffg, int convert)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(44))
		return((int )0);
	return(GEEXPORT_gInstantiateTxt(ge,text_t,txt,zoom,use_ffg,convert));
}

void  (*GEEXPORT_gJavaCursor)(graphics_main_type *ge, int n_points, TmPoint32 *point, TmRect32 *clip);

void  gJavaCursor(graphics_main_type *ge, int n_points, TmPoint32 *point, TmRect32 *clip)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(45))
		return;
	GEEXPORT_gJavaCursor(ge,n_points,point,clip);
}

void  (*GEEXPORT_gJavaFillrect)(graphics_main_type *ge, TmRect32 *rect, int pat_id, int mode, int fg, int bg, int x0, int y0, TmRect32 *clip);

void  gJavaFillrect(graphics_main_type *ge, TmRect32 *rect, int pat_id, int mode, int fg, int bg, int x0, int y0, TmRect32 *clip)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(46))
		return;
	GEEXPORT_gJavaFillrect(ge,rect,pat_id,mode,fg,bg,x0,y0,clip);
}

void  (*GEEXPORT_gJavaMaskBits)(graphics_main_type *ge, int x, int y, int wid, int hyt, unsigned char *bits, attr_type *poly_attr);

void  gJavaMaskBits(graphics_main_type *ge, int x, int y, int wid, int hyt, unsigned char *bits, attr_type *poly_attr)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(47))
		return;
	GEEXPORT_gJavaMaskBits(ge,x,y,wid,hyt,bits,poly_attr);
}

int  (*GEEXPORT_gResetPage)(graphics_main_type *ge);

int  gResetPage(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(48))
		return((int )0);
	return(GEEXPORT_gResetPage(ge));
}

int  (*GEEXPORT_geFilterDocToCurRev)(graphics_main_type *ge, char *pathname, char *ofile);

int  geFilterDocToCurRev(graphics_main_type *ge, char *pathname, char *ofile)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(49))
		return((int )0);
	return(GEEXPORT_geFilterDocToCurRev(ge,pathname,ofile));
}

void  (*GEEXPORT_geVerifyPNameCollision)(graphics_main_type *ge, udo_type *udo_pack);

void  geVerifyPNameCollision(graphics_main_type *ge, udo_type *udo_pack)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(50))
		return;
	GEEXPORT_geVerifyPNameCollision(ge,udo_pack);
}

int  (*GEEXPORT_gematherr)(void *ge, char *thingy);

int  gematherr(void *ge, char *thingy)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(51))
		return((int )0);
	return(GEEXPORT_gematherr(ge,thingy));
}

void  (*GEEXPORT_getEllPath)(graphics_main_type *ge, thing *t, poly_type *path);

void  getEllPath(graphics_main_type *ge, thing *t, poly_type *path)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(52))
		return;
	GEEXPORT_getEllPath(ge,t,path);
}

int  (*GEEXPORT_getTextInfo)(graphics_main_type *ge, thing *t, coord *lowerRightCorner, coord *baseline);

int  getTextInfo(graphics_main_type *ge, thing *t, coord *lowerRightCorner, coord *baseline)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(53))
		return((int )0);
	return(GEEXPORT_getTextInfo(ge,t,lowerRightCorner,baseline));
}

int  (*GEEXPORT_get_page_info_from_ge)(int pid);

int  get_page_info_from_ge(int pid)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(54))
		return((int )0);
	return(GEEXPORT_get_page_info_from_ge(pid));
}

void  (*GEEXPORT_gfree)(graphics_main_type *ge, void *buf);

void  gfree(graphics_main_type *ge, void *buf)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(55))
		return;
	GEEXPORT_gfree(ge,buf);
}

char * (*GEEXPORT_gloc)(graphics_main_type *ge, int bytesize);

char * gloc(graphics_main_type *ge, int bytesize)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(56))
		return((char *)0);
	return(GEEXPORT_gloc(ge,bytesize));
}

int  (*GEEXPORT_grApplyTemplateToChild)(graphics_main_type *ge, thing *temp_t);

int  grApplyTemplateToChild(graphics_main_type *ge, thing *temp_t)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(57))
		return((int )0);
	return(GEEXPORT_grApplyTemplateToChild(ge,temp_t));
}

data_ptr  (*GEEXPORT_grCreateInsetImageGraphic)(long w, data_ptr objP, data_ptr infP, data_ptr pimP);

data_ptr  grCreateInsetImageGraphic(long w, data_ptr objP, data_ptr infP, data_ptr pimP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(58))
		return((data_ptr )0);
	return(GEEXPORT_grCreateInsetImageGraphic(w,objP,infP,pimP));
}

void  (*GEEXPORT_grInitBasePrint)(graphics_main_type *ge, ge_print_info_type *print, int use_metric, int old, int check_profile);

void  grInitBasePrint(graphics_main_type *ge, ge_print_info_type *print, int use_metric, int old, int check_profile)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(59))
		return;
	GEEXPORT_grInitBasePrint(ge,print,use_metric,old,check_profile);
}

void  (*GEEXPORT_grInitPresentationPrint)(graphics_main_type *ge, int use_metric, int old, int check_profile);

void  grInitPresentationPrint(graphics_main_type *ge, int use_metric, int old, int check_profile)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(60))
		return;
	GEEXPORT_grInitPresentationPrint(ge,use_metric,old,check_profile);
}

int  (*GEEXPORT_grMeasureInsetObject)(data_ptr objP, data_ptr *unitP, data_ptr *sizeP);

int  grMeasureInsetObject(data_ptr objP, data_ptr *unitP, data_ptr *sizeP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(61))
		return((int )0);
	return(GEEXPORT_grMeasureInsetObject(objP,unitP,sizeP));
}

int  (*GEEXPORT_grMeasureInsetObjectArea)(data_ptr objP, data_ptr *unitP, data_ptr *areaP);

int  grMeasureInsetObjectArea(data_ptr objP, data_ptr *unitP, data_ptr *areaP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(62))
		return((int )0);
	return(GEEXPORT_grMeasureInsetObjectArea(objP,unitP,areaP));
}

int  (*GEEXPORT_grMouseDotsToUnits)(int pid, int src_x, int src_y, double *dst_x, double *dst_y);

int  grMouseDotsToUnits(int pid, int src_x, int src_y, double *dst_x, double *dst_y)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(63))
		return((int )0);
	return(GEEXPORT_grMouseDotsToUnits(pid,src_x,src_y,dst_x,dst_y));
}

data_ptr  (*GEEXPORT_grPackageInsetObject)(data_ptr uidP, data_ptr srcP, data_ptr unitsP);

data_ptr  grPackageInsetObject(data_ptr uidP, data_ptr srcP, data_ptr unitsP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(64))
		return((data_ptr )0);
	return(GEEXPORT_grPackageInsetObject(uidP,srcP,unitsP));
}

data_ptr  (*GEEXPORT_grPackageMouseData)(int b1, int b2, int b3);

data_ptr  grPackageMouseData(int b1, int b2, int b3)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(65))
		return((data_ptr )0);
	return(GEEXPORT_grPackageMouseData(b1,b2,b3));
}

int  (*GEEXPORT_grRenderAssociatedGraphic)(long w, data_ptr objP, data_ptr infP, data_ptr imP);

int  grRenderAssociatedGraphic(long w, data_ptr objP, data_ptr infP, data_ptr imP)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(66))
		return((int )0);
	return(GEEXPORT_grRenderAssociatedGraphic(w,objP,infP,imP));
}

int  (*GEEXPORT_grUnitsToDots)(graphics_main_type *ge, double val);

int  grUnitsToDots(graphics_main_type *ge, double val)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(67))
		return((int )0);
	return(GEEXPORT_grUnitsToDots(ge,val));
}

int  (*GEEXPORT_initDefaultMapWithDefaults)(graphics_main_type *ge);

int  initDefaultMapWithDefaults(graphics_main_type *ge)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(68))
		return((int )0);
	return(GEEXPORT_initDefaultMapWithDefaults(ge));
}

int  (*GEEXPORT_isRectForm)(graphics_main_type *ge, TmPoint32 *points);

int  isRectForm(graphics_main_type *ge, TmPoint32 *points)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(69))
		return((int )0);
	return(GEEXPORT_isRectForm(ge,points));
}

int  (*GEEXPORT_loadCmapEntry)(graphics_main_type *ge, int c_ix, char *name, int see_thru, int ink_type, int c, int m, int y, int k);

int  loadCmapEntry(graphics_main_type *ge, int c_ix, char *name, int see_thru, int ink_type, int c, int m, int y, int k)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(70))
		return((int )0);
	return(GEEXPORT_loadCmapEntry(ge,c_ix,name,see_thru,ink_type,c,m,y,k));
}

void  (*GEEXPORT_makeData)(graphics_main_type *ge, thing *t, int type);

void  makeData(graphics_main_type *ge, thing *t, int type)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(71))
		return;
	GEEXPORT_makeData(ge,t,type);
}

thing * (*GEEXPORT_makePrim)(graphics_main_type *ge, int type);

thing * makePrim(graphics_main_type *ge, int type)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(72))
		return((thing *)0);
	return(GEEXPORT_makePrim(ge,type));
}

thing * (*GEEXPORT_makeThing)(graphics_main_type *ge, int otype, thing_attributes *attr);

thing * makeThing(graphics_main_type *ge, int otype, thing_attributes *attr)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(73))
		return((thing *)0);
	return(GEEXPORT_makeThing(ge,otype,attr));
}

int  (*GEEXPORT_name_from_scheme)(graphics_main_type *ge, int scheme_ix, char *name);

int  name_from_scheme(graphics_main_type *ge, int scheme_ix, char *name)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(74))
		return((int )0);
	return(GEEXPORT_name_from_scheme(ge,scheme_ix,name));
}

char * (*GEEXPORT_regloc)(graphics_main_type *ge, void *buf, int bytesize);

char * regloc(graphics_main_type *ge, void *buf, int bytesize)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(75))
		return((char *)0);
	return(GEEXPORT_regloc(ge,buf,bytesize));
}

int  (*GEEXPORT_removeFromGroup)(graphics_main_type *ge, thing *grp_t, int ix);

int  removeFromGroup(graphics_main_type *ge, thing *grp_t, int ix)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(76))
		return((int )0);
	return(GEEXPORT_removeFromGroup(ge,grp_t,ix));
}

int  (*GEEXPORT_tAddToGroup)(graphics_main_type *ge, thing *grp_t, thing *t, int ix);

int  tAddToGroup(graphics_main_type *ge, thing *grp_t, thing *t, int ix)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(77))
		return((int )0);
	return(GEEXPORT_tAddToGroup(ge,grp_t,t,ix));
}

int  (*GEEXPORT_tAddToPaintList)(graphics_main_type *ge, thing *t, int ix, int no_recalc);

int  tAddToPaintList(graphics_main_type *ge, thing *t, int ix, int no_recalc)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(78))
		return((int )0);
	return(GEEXPORT_tAddToPaintList(ge,t,ix,no_recalc));
}

int  (*GEEXPORT_textMsg)(graphics_main_type *ge, char *msg);

int  textMsg(graphics_main_type *ge, char *msg)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(79))
		return((int )0);
	return(GEEXPORT_textMsg(ge,msg));
}

void  (*GEEXPORT_unionExtents)(graphics_main_type *ge, thing *t, vector *extent, vector *ink, int first);

void  unionExtents(graphics_main_type *ge, thing *t, vector *extent, vector *ink, int first)
{
	if(GEExpFuncPtrTbl==NULL && !SHLoadAndSnap_GE(80))
		return;
	GEEXPORT_unionExtents(ge,t,extent,ink,first);
}

int isShlibLoaded_GE()
{
	return(GEExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_GE(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "AxFreeGFXbyPID", NULL },
		{ "AxGFXFromData", NULL },
		{ "AxGetGFXfromPID", NULL },
		{ "AxGetGFXfromUID", NULL },
		{ "AxMakeGFXData", NULL },
		{ "ElfbAssignGraphic", NULL },
		{ "ElfbCreateGraphic", NULL },
		{ "ElfbDestroyGraphic", NULL },
		{ "ElfbGetGraphic", NULL },
		{ "ElfbGraphicFuncs", NULL },
		{ "ElfbLoadGraphic", NULL },
		{ "ElfbReadGraphicBuffer", NULL },
		{ "ElfbReadGraphicFile", NULL },
		{ "ElfbReadRasterInfo", NULL },
		{ "ElfbWriteGraphicBuffer", NULL },
		{ "ElfbWriteGraphicFile", NULL },
		{ "GECmdStatus", NULL },
		{ "GEElfInstall", NULL },
		{ "GEElfMacroId", NULL },
		{ "GEMenuBarInfoModified", NULL },
		{ "GETiffToGE", NULL },
		{ "GEUpdateMenuBarInfo", NULL },
		{ "GEthimble", NULL },
		{ "GetWashoutColor", NULL },
		{ "GrGetDocLinksInfo", NULL },
		{ "GrLocalizeDocLinks", NULL },
		{ "GrSetDocLinksInfo", NULL },
		{ "GrSetRmInfo", NULL },
		{ "PXthimble", NULL },
		{ "addStrToTextBox", NULL },
		{ "axtNeedBullet", NULL },
		{ "calcExtents", NULL },
		{ "clearGE", NULL },
		{ "colormapInit", NULL },
		{ "convertPath", NULL },
		{ "createToolString", NULL },
		{ "cvtInsertNewLines", NULL },
		{ "disposePaths", NULL },
		{ "disposeThing", NULL },
		{ "ellToPath", NULL },
		{ "extractSizeAndAngle", NULL },
		{ "foundCmap", NULL },
		{ "freeCmap", NULL },
		{ "gClearPage", NULL },
		{ "gInstantiateTxt", NULL },
		{ "gJavaCursor", NULL },
		{ "gJavaFillrect", NULL },
		{ "gJavaMaskBits", NULL },
		{ "gResetPage", NULL },
		{ "geFilterDocToCurRev", NULL },
		{ "geVerifyPNameCollision", NULL },
		{ "gematherr", NULL },
		{ "getEllPath", NULL },
		{ "getTextInfo", NULL },
		{ "get_page_info_from_ge", NULL },
		{ "gfree", NULL },
		{ "gloc", NULL },
		{ "grApplyTemplateToChild", NULL },
		{ "grCreateInsetImageGraphic", NULL },
		{ "grInitBasePrint", NULL },
		{ "grInitPresentationPrint", NULL },
		{ "grMeasureInsetObject", NULL },
		{ "grMeasureInsetObjectArea", NULL },
		{ "grMouseDotsToUnits", NULL },
		{ "grPackageInsetObject", NULL },
		{ "grPackageMouseData", NULL },
		{ "grRenderAssociatedGraphic", NULL },
		{ "grUnitsToDots", NULL },
		{ "initDefaultMapWithDefaults", NULL },
		{ "isRectForm", NULL },
		{ "loadCmapEntry", NULL },
		{ "makeData", NULL },
		{ "makePrim", NULL },
		{ "makeThing", NULL },
		{ "name_from_scheme", NULL },
		{ "regloc", NULL },
		{ "removeFromGroup", NULL },
		{ "tAddToGroup", NULL },
		{ "tAddToPaintList", NULL },
		{ "textMsg", NULL },
		{ "unionExtents", NULL },
		{ NULL,NULL }
	};

	if((GEExpFuncPtrTbl=AxLoadShlib(LIBID_GE,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,GEExpFuncPtrTbl);

	GEEXPORT_AxFreeGFXbyPID = 
		(void  (*)(int pid)) impFuncTbl[0].fptr;
	GEEXPORT_AxGFXFromData = 
		(void * (*)(data_ptr aP)) impFuncTbl[1].fptr;
	GEEXPORT_AxGetGFXfromPID = 
		(graphics_main_type * (*)(int pid)) impFuncTbl[2].fptr;
	GEEXPORT_AxGetGFXfromUID = 
		(graphics_main_type * (*)(int uid)) impFuncTbl[3].fptr;
	GEEXPORT_AxMakeGFXData = 
		(data_ptr  (*)(graphics_main_type *gfx)) impFuncTbl[4].fptr;
	GEEXPORT_ElfbAssignGraphic = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[5].fptr;
	GEEXPORT_ElfbCreateGraphic = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[6].fptr;
	GEEXPORT_ElfbDestroyGraphic = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[7].fptr;
	GEEXPORT_ElfbGetGraphic = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[8].fptr;
	GEEXPORT_ElfbGraphicFuncs = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[9].fptr;
	GEEXPORT_ElfbLoadGraphic = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[10].fptr;
	GEEXPORT_ElfbReadGraphicBuffer = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[11].fptr;
	GEEXPORT_ElfbReadGraphicFile = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[12].fptr;
	GEEXPORT_ElfbReadRasterInfo = 
		(short  (*)(data_ptr aP, data_ptr bufP, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[13].fptr;
	GEEXPORT_ElfbWriteGraphicBuffer = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[14].fptr;
	GEEXPORT_ElfbWriteGraphicFile = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[15].fptr;
	GEEXPORT_GECmdStatus = 
		(int  (*)(char *name, int timestamp, int toggle_state_too, int code)) impFuncTbl[16].fptr;
	GEEXPORT_GEElfInstall = 
		(int  (*)(void)) impFuncTbl[17].fptr;
	GEEXPORT_GEElfMacroId = 
		(int  (*)(int macro_offset)) impFuncTbl[18].fptr;
	GEEXPORT_GEMenuBarInfoModified = 
		(int  (*)(int pid)) impFuncTbl[19].fptr;
	GEEXPORT_GETiffToGE = 
		(int  (*)(void)) impFuncTbl[20].fptr;
	GEEXPORT_GEUpdateMenuBarInfo = 
		(int  (*)(int menubar_id)) impFuncTbl[21].fptr;
	GEEXPORT_GEthimble = 
		(int  (*)(int argc, char *argv[])) impFuncTbl[22].fptr;
	GEEXPORT_GetWashoutColor = 
		(int  (*)(color_type *old_color, color_type *new_color)) impFuncTbl[23].fptr;
	GEEXPORT_GrGetDocLinksInfo = 
		(doc_links_info_t * (*)(graphics_main_type *ge)) impFuncTbl[24].fptr;
	GEEXPORT_GrLocalizeDocLinks = 
		(int  (*)(graphics_main_type *ge)) impFuncTbl[25].fptr;
	GEEXPORT_GrSetDocLinksInfo = 
		(int  (*)(graphics_main_type *ge, doc_links_info_t *info)) impFuncTbl[26].fptr;
	GEEXPORT_GrSetRmInfo = 
		(int  (*)(long w, int pid, int x, int y)) impFuncTbl[27].fptr;
	GEEXPORT_PXthimble = 
		(int  (*)(void)) impFuncTbl[28].fptr;
	GEEXPORT_addStrToTextBox = 
		(void  (*)(graphics_main_type *ge, thing *t, thing *s_t, int ix)) impFuncTbl[29].fptr;
	GEEXPORT_axtNeedBullet = 
		(int  (*)(axtext *txt, axtIndent *in, int ix)) impFuncTbl[30].fptr;
	GEEXPORT_calcExtents = 
		(int  (*)(graphics_main_type *ge, thing *t)) impFuncTbl[31].fptr;
	GEEXPORT_clearGE = 
		(void  (*)(graphics_main_type *ge)) impFuncTbl[32].fptr;
	GEEXPORT_colormapInit = 
		(int  (*)(graphics_main_type *ge)) impFuncTbl[33].fptr;
	GEEXPORT_convertPath = 
		(void  (*)(graphics_main_type *ge, poly_type *inpath, poly_type *outpath)) impFuncTbl[34].fptr;
	GEEXPORT_createToolString = 
		(char * (*)(int tool_ix)) impFuncTbl[35].fptr;
	GEEXPORT_cvtInsertNewLines = 
		(thing * (*)(graphics_main_type *ge, thing *t)) impFuncTbl[36].fptr;
	GEEXPORT_disposePaths = 
		(void  (*)(graphics_main_type *ge, int n_paths, poly_type *paths)) impFuncTbl[37].fptr;
	GEEXPORT_disposeThing = 
		(void  (*)(graphics_main_type *ge, thing *t, int dispose_children)) impFuncTbl[38].fptr;
	GEEXPORT_ellToPath = 
		(void  (*)(graphics_main_type *ge, TmPoint32 outline_pts[5], int first, int final, int close_flag, poly_type *path)) impFuncTbl[39].fptr;
	GEEXPORT_extractSizeAndAngle = 
		(int  (*)(graphics_main_type *ge, TmPoint32 *p1, TmPoint32 *p2, TmPoint32 *p3, TmPoint32 *p4, int *width, int *height, double *sinAng, double *cosAng, double *xShear)) impFuncTbl[40].fptr;
	GEEXPORT_foundCmap = 
		(int  (*)(graphics_main_type *ge, cmap_type *cmap1, cmap_type *cmap2)) impFuncTbl[41].fptr;
	GEEXPORT_freeCmap = 
		(int  (*)(graphics_main_type *ge, cmap_type *cmap)) impFuncTbl[42].fptr;
	GEEXPORT_gClearPage = 
		(void  (*)(graphics_main_type *ge, ge_page_type *page, int del_chart)) impFuncTbl[43].fptr;
	GEEXPORT_gInstantiateTxt = 
		(int  (*)(graphics_main_type *ge, thing *text_t, axtext *txt, int zoom, int use_ffg, int convert)) impFuncTbl[44].fptr;
	GEEXPORT_gJavaCursor = 
		(void  (*)(graphics_main_type *ge, int n_points, TmPoint32 *point, TmRect32 *clip)) impFuncTbl[45].fptr;
	GEEXPORT_gJavaFillrect = 
		(void  (*)(graphics_main_type *ge, TmRect32 *rect, int pat_id, int mode, int fg, int bg, int x0, int y0, TmRect32 *clip)) impFuncTbl[46].fptr;
	GEEXPORT_gJavaMaskBits = 
		(void  (*)(graphics_main_type *ge, int x, int y, int wid, int hyt, unsigned char *bits, attr_type *poly_attr)) impFuncTbl[47].fptr;
	GEEXPORT_gResetPage = 
		(int  (*)(graphics_main_type *ge)) impFuncTbl[48].fptr;
	GEEXPORT_geFilterDocToCurRev = 
		(int  (*)(graphics_main_type *ge, char *pathname, char *ofile)) impFuncTbl[49].fptr;
	GEEXPORT_geVerifyPNameCollision = 
		(void  (*)(graphics_main_type *ge, udo_type *udo_pack)) impFuncTbl[50].fptr;
	GEEXPORT_gematherr = 
		(int  (*)(void *ge, char *thingy)) impFuncTbl[51].fptr;
	GEEXPORT_getEllPath = 
		(void  (*)(graphics_main_type *ge, thing *t, poly_type *path)) impFuncTbl[52].fptr;
	GEEXPORT_getTextInfo = 
		(int  (*)(graphics_main_type *ge, thing *t, coord *lowerRightCorner, coord *baseline)) impFuncTbl[53].fptr;
	GEEXPORT_get_page_info_from_ge = 
		(int  (*)(int pid)) impFuncTbl[54].fptr;
	GEEXPORT_gfree = 
		(void  (*)(graphics_main_type *ge, void *buf)) impFuncTbl[55].fptr;
	GEEXPORT_gloc = 
		(char * (*)(graphics_main_type *ge, int bytesize)) impFuncTbl[56].fptr;
	GEEXPORT_grApplyTemplateToChild = 
		(int  (*)(graphics_main_type *ge, thing *temp_t)) impFuncTbl[57].fptr;
	GEEXPORT_grCreateInsetImageGraphic = 
		(data_ptr  (*)(long w, data_ptr objP, data_ptr infP, data_ptr pimP)) impFuncTbl[58].fptr;
	GEEXPORT_grInitBasePrint = 
		(void  (*)(graphics_main_type *ge, ge_print_info_type *print, int use_metric, int old, int check_profile)) impFuncTbl[59].fptr;
	GEEXPORT_grInitPresentationPrint = 
		(void  (*)(graphics_main_type *ge, int use_metric, int old, int check_profile)) impFuncTbl[60].fptr;
	GEEXPORT_grMeasureInsetObject = 
		(int  (*)(data_ptr objP, data_ptr *unitP, data_ptr *sizeP)) impFuncTbl[61].fptr;
	GEEXPORT_grMeasureInsetObjectArea = 
		(int  (*)(data_ptr objP, data_ptr *unitP, data_ptr *areaP)) impFuncTbl[62].fptr;
	GEEXPORT_grMouseDotsToUnits = 
		(int  (*)(int pid, int src_x, int src_y, double *dst_x, double *dst_y)) impFuncTbl[63].fptr;
	GEEXPORT_grPackageInsetObject = 
		(data_ptr  (*)(data_ptr uidP, data_ptr srcP, data_ptr unitsP)) impFuncTbl[64].fptr;
	GEEXPORT_grPackageMouseData = 
		(data_ptr  (*)(int b1, int b2, int b3)) impFuncTbl[65].fptr;
	GEEXPORT_grRenderAssociatedGraphic = 
		(int  (*)(long w, data_ptr objP, data_ptr infP, data_ptr imP)) impFuncTbl[66].fptr;
	GEEXPORT_grUnitsToDots = 
		(int  (*)(graphics_main_type *ge, double val)) impFuncTbl[67].fptr;
	GEEXPORT_initDefaultMapWithDefaults = 
		(int  (*)(graphics_main_type *ge)) impFuncTbl[68].fptr;
	GEEXPORT_isRectForm = 
		(int  (*)(graphics_main_type *ge, TmPoint32 *points)) impFuncTbl[69].fptr;
	GEEXPORT_loadCmapEntry = 
		(int  (*)(graphics_main_type *ge, int c_ix, char *name, int see_thru, int ink_type, int c, int m, int y, int k)) impFuncTbl[70].fptr;
	GEEXPORT_makeData = 
		(void  (*)(graphics_main_type *ge, thing *t, int type)) impFuncTbl[71].fptr;
	GEEXPORT_makePrim = 
		(thing * (*)(graphics_main_type *ge, int type)) impFuncTbl[72].fptr;
	GEEXPORT_makeThing = 
		(thing * (*)(graphics_main_type *ge, int otype, thing_attributes *attr)) impFuncTbl[73].fptr;
	GEEXPORT_name_from_scheme = 
		(int  (*)(graphics_main_type *ge, int scheme_ix, char *name)) impFuncTbl[74].fptr;
	GEEXPORT_regloc = 
		(char * (*)(graphics_main_type *ge, void *buf, int bytesize)) impFuncTbl[75].fptr;
	GEEXPORT_removeFromGroup = 
		(int  (*)(graphics_main_type *ge, thing *grp_t, int ix)) impFuncTbl[76].fptr;
	GEEXPORT_tAddToGroup = 
		(int  (*)(graphics_main_type *ge, thing *grp_t, thing *t, int ix)) impFuncTbl[77].fptr;
	GEEXPORT_tAddToPaintList = 
		(int  (*)(graphics_main_type *ge, thing *t, int ix, int no_recalc)) impFuncTbl[78].fptr;
	GEEXPORT_textMsg = 
		(int  (*)(graphics_main_type *ge, char *msg)) impFuncTbl[79].fptr;
	GEEXPORT_unionExtents = 
		(void  (*)(graphics_main_type *ge, thing *t, vector *extent, vector *ink, int first)) impFuncTbl[80].fptr;

	AxElfInstallForShlib(LIBID_GE);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_GE()
{
	if(GEExpFuncPtrTbl != NULL)
		return;

	GEEXPORT_AxFreeGFXbyPID = AxFreeGFXbyPID;
	GEEXPORT_AxGFXFromData = AxGFXFromData;
	GEEXPORT_AxGetGFXfromPID = AxGetGFXfromPID;
	GEEXPORT_AxGetGFXfromUID = AxGetGFXfromUID;
	GEEXPORT_AxMakeGFXData = AxMakeGFXData;
	GEEXPORT_ElfbAssignGraphic = ElfbAssignGraphic;
	GEEXPORT_ElfbCreateGraphic = ElfbCreateGraphic;
	GEEXPORT_ElfbDestroyGraphic = ElfbDestroyGraphic;
	GEEXPORT_ElfbGetGraphic = ElfbGetGraphic;
	GEEXPORT_ElfbGraphicFuncs = ElfbGraphicFuncs;
	GEEXPORT_ElfbLoadGraphic = ElfbLoadGraphic;
	GEEXPORT_ElfbReadGraphicBuffer = ElfbReadGraphicBuffer;
	GEEXPORT_ElfbReadGraphicFile = ElfbReadGraphicFile;
	GEEXPORT_ElfbReadRasterInfo = ElfbReadRasterInfo;
	GEEXPORT_ElfbWriteGraphicBuffer = ElfbWriteGraphicBuffer;
	GEEXPORT_ElfbWriteGraphicFile = ElfbWriteGraphicFile;
	GEEXPORT_GECmdStatus = GECmdStatus;
	GEEXPORT_GEElfInstall = GEElfInstall;
	GEEXPORT_GEElfMacroId = GEElfMacroId;
	GEEXPORT_GEMenuBarInfoModified = GEMenuBarInfoModified;
	GEEXPORT_GETiffToGE = GETiffToGE;
	GEEXPORT_GEUpdateMenuBarInfo = GEUpdateMenuBarInfo;
	GEEXPORT_GEthimble = GEthimble;
	GEEXPORT_GetWashoutColor = GetWashoutColor;
	GEEXPORT_GrGetDocLinksInfo = GrGetDocLinksInfo;
	GEEXPORT_GrLocalizeDocLinks = GrLocalizeDocLinks;
	GEEXPORT_GrSetDocLinksInfo = GrSetDocLinksInfo;
	GEEXPORT_GrSetRmInfo = GrSetRmInfo;
	GEEXPORT_PXthimble = PXthimble;
	GEEXPORT_addStrToTextBox = addStrToTextBox;
	GEEXPORT_axtNeedBullet = axtNeedBullet;
	GEEXPORT_calcExtents = calcExtents;
	GEEXPORT_clearGE = clearGE;
	GEEXPORT_colormapInit = colormapInit;
	GEEXPORT_convertPath = convertPath;
	GEEXPORT_createToolString = createToolString;
	GEEXPORT_cvtInsertNewLines = cvtInsertNewLines;
	GEEXPORT_disposePaths = disposePaths;
	GEEXPORT_disposeThing = disposeThing;
	GEEXPORT_ellToPath = ellToPath;
	GEEXPORT_extractSizeAndAngle = extractSizeAndAngle;
	GEEXPORT_foundCmap = foundCmap;
	GEEXPORT_freeCmap = freeCmap;
	GEEXPORT_gClearPage = gClearPage;
	GEEXPORT_gInstantiateTxt = gInstantiateTxt;
	GEEXPORT_gJavaCursor = gJavaCursor;
	GEEXPORT_gJavaFillrect = gJavaFillrect;
	GEEXPORT_gJavaMaskBits = gJavaMaskBits;
	GEEXPORT_gResetPage = gResetPage;
	GEEXPORT_geFilterDocToCurRev = geFilterDocToCurRev;
	GEEXPORT_geVerifyPNameCollision = geVerifyPNameCollision;
	GEEXPORT_gematherr = gematherr;
	GEEXPORT_getEllPath = getEllPath;
	GEEXPORT_getTextInfo = getTextInfo;
	GEEXPORT_get_page_info_from_ge = get_page_info_from_ge;
	GEEXPORT_gfree = gfree;
	GEEXPORT_gloc = gloc;
	GEEXPORT_grApplyTemplateToChild = grApplyTemplateToChild;
	GEEXPORT_grCreateInsetImageGraphic = grCreateInsetImageGraphic;
	GEEXPORT_grInitBasePrint = grInitBasePrint;
	GEEXPORT_grInitPresentationPrint = grInitPresentationPrint;
	GEEXPORT_grMeasureInsetObject = grMeasureInsetObject;
	GEEXPORT_grMeasureInsetObjectArea = grMeasureInsetObjectArea;
	GEEXPORT_grMouseDotsToUnits = grMouseDotsToUnits;
	GEEXPORT_grPackageInsetObject = grPackageInsetObject;
	GEEXPORT_grPackageMouseData = grPackageMouseData;
	GEEXPORT_grRenderAssociatedGraphic = grRenderAssociatedGraphic;
	GEEXPORT_grUnitsToDots = grUnitsToDots;
	GEEXPORT_initDefaultMapWithDefaults = initDefaultMapWithDefaults;
	GEEXPORT_isRectForm = isRectForm;
	GEEXPORT_loadCmapEntry = loadCmapEntry;
	GEEXPORT_makeData = makeData;
	GEEXPORT_makePrim = makePrim;
	GEEXPORT_makeThing = makeThing;
	GEEXPORT_name_from_scheme = name_from_scheme;
	GEEXPORT_regloc = regloc;
	GEEXPORT_removeFromGroup = removeFromGroup;
	GEEXPORT_tAddToGroup = tAddToGroup;
	GEEXPORT_tAddToPaintList = tAddToPaintList;
	GEEXPORT_textMsg = textMsg;
	GEEXPORT_unionExtents = unionExtents;
}

/** Funcs Imported from axss
   ***********************************************************/

static ShlibFuncInfo* SSExpFuncPtrTbl=NULL;

AXWidget  (*SSEXPORT_AxCreatePlates)(AXWidget parentWidget, char *name, int wid);

AXWidget  AxCreatePlates(AXWidget parentWidget, char *name, int wid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(0))
		return((AXWidget )0);
	return(SSEXPORT_AxCreatePlates(parentWidget,name,wid));
}

void  (*SSEXPORT_AxFreeSSXbyPID)(int pid);

void  AxFreeSSXbyPID(int pid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(1))
		return;
	SSEXPORT_AxFreeSSXbyPID(pid);
}

void * (*SSEXPORT_AxGetSSTaskInfo)(int pid);

void * AxGetSSTaskInfo(int pid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(2))
		return((void *)0);
	return(SSEXPORT_AxGetSSTaskInfo(pid));
}

double  (*SSEXPORT_DAY)(double datenum);

double  DAY(double datenum)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(3))
		return((double )0);
	return(SSEXPORT_DAY(datenum));
}

int  (*SSEXPORT_ElfSSCalcGetCellRange)(void *tssP, int *col1, int *row1, int *sheet1, int *col2, int *row2, int *sheet2);

int  ElfSSCalcGetCellRange(void *tssP, int *col1, int *row1, int *sheet1, int *col2, int *row2, int *sheet2)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(4))
		return((int )0);
	return(SSEXPORT_ElfSSCalcGetCellRange(tssP,col1,row1,sheet1,col2,row2,sheet2));
}

data_ptr  (*SSEXPORT_ElfbSSCall)(data_ptr argArray);

data_ptr  ElfbSSCall(data_ptr argArray)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(5))
		return((data_ptr )0);
	return(SSEXPORT_ElfbSSCall(argArray));
}

GPHOBJ * (*SSEXPORT_GetObjFromUID)(ss_value *ssP, int uid, int appid);

GPHOBJ * GetObjFromUID(ss_value *ssP, int uid, int appid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(6))
		return((GPHOBJ *)0);
	return(SSEXPORT_GetObjFromUID(ssP,uid,appid));
}

char * (*SSEXPORT_GetSSPathname)(void);

char * GetSSPathname(void)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(7))
		return((char *)0);
	return(SSEXPORT_GetSSPathname());
}

double  (*SSEXPORT_MONTH)(double datenum);

double  MONTH(double datenum)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(8))
		return((double )0);
	return(SSEXPORT_MONTH(datenum));
}

int  (*SSEXPORT_SSChangeLinks)(ss_value *ssP, doc_links_info_t *docLinksP);

int  SSChangeLinks(ss_value *ssP, doc_links_info_t *docLinksP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(9))
		return((int )0);
	return(SSEXPORT_SSChangeLinks(ssP,docLinksP));
}

int  (*SSEXPORT_SSCmdStatus)(char *name, int timeUID, int toggle_state_too, int cmd, int wID);

int  SSCmdStatus(char *name, int timeUID, int toggle_state_too, int cmd, int wID)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(10))
		return((int )0);
	return(SSEXPORT_SSCmdStatus(name,timeUID,toggle_state_too,cmd,wID));
}

int  (*SSEXPORT_SSCreateSSX)(int pid, int forSSTask);

int  SSCreateSSX(int pid, int forSSTask)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(11))
		return((int )0);
	return(SSEXPORT_SSCreateSSX(pid,forSSTask));
}

data_ptr  (*SSEXPORT_SSElfExtDocInfo)(ss_value *ssP, data_ptr aP);

data_ptr  SSElfExtDocInfo(ss_value *ssP, data_ptr aP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(12))
		return((data_ptr )0);
	return(SSEXPORT_SSElfExtDocInfo(ssP,aP));
}

int  (*SSEXPORT_SSElfInstall)(void);

int  SSElfInstall(void)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(13))
		return((int )0);
	return(SSEXPORT_SSElfInstall());
}

int  (*SSEXPORT_SSFreeSSXbyUID)(int uid);

int  SSFreeSSXbyUID(int uid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(14))
		return((int )0);
	return(SSEXPORT_SSFreeSSXbyUID(uid));
}

char * (*SSEXPORT_SSGetEditTypeFaceStr)(void);

char * SSGetEditTypeFaceStr(void)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(15))
		return((char *)0);
	return(SSEXPORT_SSGetEditTypeFaceStr());
}

int  (*SSEXPORT_SSGetLinks)(ss_value *ssP, char *pathname, doc_links_info_t *docLinksP);

int  SSGetLinks(ss_value *ssP, char *pathname, doc_links_info_t *docLinksP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(16))
		return((int )0);
	return(SSEXPORT_SSGetLinks(ssP,pathname,docLinksP));
}

int  (*SSEXPORT_SSGetSSXFromUid)(int ssx_uid, ss_value **ssx);

int  SSGetSSXFromUid(int ssx_uid, ss_value **ssx)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(17))
		return((int )0);
	return(SSEXPORT_SSGetSSXFromUid(ssx_uid,ssx));
}

int  (*SSEXPORT_SSJVGetCurwinId)(int pid);

int  SSJVGetCurwinId(int pid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(18))
		return((int )0);
	return(SSEXPORT_SSJVGetCurwinId(pid));
}

int  (*SSEXPORT_SSLocalizeLinks)(ss_value *ssP, char *parentDoc);

int  SSLocalizeLinks(ss_value *ssP, char *parentDoc)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(19))
		return((int )0);
	return(SSEXPORT_SSLocalizeLinks(ssP,parentDoc));
}

int  (*SSEXPORT_SSNoteUserFunc)(char *category, char *alias, char *engname, char *argInfo, int callMode);

int  SSNoteUserFunc(char *category, char *alias, char *engname, char *argInfo, int callMode)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(20))
		return((int )0);
	return(SSEXPORT_SSNoteUserFunc(category,alias,engname,argInfo,callMode));
}

int  (*SSEXPORT_SSPlatesHeight)(void);

int  SSPlatesHeight(void)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(21))
		return((int )0);
	return(SSEXPORT_SSPlatesHeight());
}

int  (*SSEXPORT_SSRemoveUserFunc)(char *fname);

int  SSRemoveUserFunc(char *fname)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(22))
		return((int )0);
	return(SSEXPORT_SSRemoveUserFunc(fname));
}

void  (*SSEXPORT_SSSetRmInfo)(AXWidget_popup widget, int pid);

void  SSSetRmInfo(AXWidget_popup widget, int pid)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(23))
		return;
	SSEXPORT_SSSetRmInfo(widget,pid);
}

int  (*SSEXPORT_SSUpdateMenuBarInfo)(int menubar_id);

int  SSUpdateMenuBarInfo(int menubar_id)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(24))
		return((int )0);
	return(SSEXPORT_SSUpdateMenuBarInfo(menubar_id));
}

int  (*SSEXPORT_SSXReadFile)(int uid, char *path, char *rootPath);

int  SSXReadFile(int uid, char *path, char *rootPath)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(25))
		return((int )0);
	return(SSEXPORT_SSXReadFile(uid,path,rootPath));
}

int  (*SSEXPORT_SSXWriteFile)(int uid, char *path);

int  SSXWriteFile(int uid, char *path)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(26))
		return((int )0);
	return(SSEXPORT_SSXWriteFile(uid,path));
}

void  (*SSEXPORT_SSZoomCallback)(AXWidget widget, int pid, XmAnyCallbackStruct *data);

void  SSZoomCallback(AXWidget widget, int pid, XmAnyCallbackStruct *data)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(27))
		return;
	SSEXPORT_SSZoomCallback(widget,pid,data);
}

int  (*SSEXPORT_SSthimble)(int argc, char *argv[]);

int  SSthimble(int argc, char *argv[])
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(28))
		return((int )0);
	return(SSEXPORT_SSthimble(argc,argv));
}

int  (*SSEXPORT_SStmatherr)(void *mathP);

int  SStmatherr(void *mathP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(29))
		return((int )0);
	return(SSEXPORT_SStmatherr(mathP));
}

double  (*SSEXPORT_YEAR)(double datenum);

double  YEAR(double datenum)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(30))
		return((double )0);
	return(SSEXPORT_YEAR(datenum));
}

int  (*SSEXPORT_addEntryToFuncTable)(AxCallInfo_t *funcTable, int funcIdx, char *catgP, elfData (*funcP)(), char *fnameP, char *engnameP, char *argP, int disp_flag);

int  addEntryToFuncTable(AxCallInfo_t *funcTable, int funcIdx, char *catgP, elfData (*funcP)(), char *fnameP, char *engnameP, char *argP, int disp_flag)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(31))
		return((int )0);
	return(SSEXPORT_addEntryToFuncTable(funcTable,funcIdx,catgP,funcP,fnameP,engnameP,argP,disp_flag));
}

double  (*SSEXPORT_days_between)(double start, double end, int basis);

double  days_between(double start, double end, int basis)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(32))
		return((double )0);
	return(SSEXPORT_days_between(start,end,basis));
}

double  (*SSEXPORT_idate)(int year, int month, int day, boolean last);

double  idate(int year, int month, int day, boolean last)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(33))
		return((double )0);
	return(SSEXPORT_idate(year,month,day,last));
}

double  (*SSEXPORT_ssDATEVALUE)(char *s);

double  ssDATEVALUE(char *s)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(34))
		return((double )0);
	return(SSEXPORT_ssDATEVALUE(s));
}

double  (*SSEXPORT_ssDAYS360)(double sdate, double edate, double method);

double  ssDAYS360(double sdate, double edate, double method)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(35))
		return((double )0);
	return(SSEXPORT_ssDAYS360(sdate,edate,method));
}

int  (*SSEXPORT_ssDrawButtonAsBitmap)(void *tssP, char *name, int x, int y, int width, int height, SSRECT *clipP);

int  ssDrawButtonAsBitmap(void *tssP, char *name, int x, int y, int width, int height, SSRECT *clipP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(36))
		return((int )0);
	return(SSEXPORT_ssDrawButtonAsBitmap(tssP,name,x,y,width,height,clipP));
}

int  (*SSEXPORT_ssDrawButtonImgText)(void *tssP, Window xwin, unsigned char *wstr, int printfactor, int xPos, int yPos, char *fontFamily, int ptsize, int weight, int slant, unsigned long fcolor, unsigned long bcolor, int ruling, int word_underline_only, r32 *cliprect);

int  ssDrawButtonImgText(void *tssP, Window xwin, unsigned char *wstr, int printfactor, int xPos, int yPos, char *fontFamily, int ptsize, int weight, int slant, unsigned long fcolor, unsigned long bcolor, int ruling, int word_underline_only, r32 *cliprect)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(37))
		return((int )0);
	return(SSEXPORT_ssDrawButtonImgText(tssP,xwin,wstr,printfactor,xPos,yPos,fontFamily,ptsize,weight,slant,fcolor,bcolor,ruling,word_underline_only,cliprect));
}

double  (*SSEXPORT_ssEDATE)(double d, double months);

double  ssEDATE(double d, double months)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(38))
		return((double )0);
	return(SSEXPORT_ssEDATE(d,months));
}

double  (*SSEXPORT_ssEOMONTH)(double d, double months);

double  ssEOMONTH(double d, double months)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(39))
		return((double )0);
	return(SSEXPORT_ssEOMONTH(d,months));
}

int  (*SSEXPORT_ssGetNonFontAttrValues)(ss_value *tssP, char *str, XFontStruct **font, char *fontFamily, int *weight, int *slant, int *ruling, int *ascent, int ptsize, int *img_width, int *img_height, int editbutt);

int  ssGetNonFontAttrValues(ss_value *tssP, char *str, XFontStruct **font, char *fontFamily, int *weight, int *slant, int *ruling, int *ascent, int ptsize, int *img_width, int *img_height, int editbutt)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(40))
		return((int )0);
	return(SSEXPORT_ssGetNonFontAttrValues(tssP,str,font,fontFamily,weight,slant,ruling,ascent,ptsize,img_width,img_height,editbutt));
}

data_ptr  (*SSEXPORT_ssJavaGetChart)(ss_value *ssP, char *chartname);

data_ptr  ssJavaGetChart(ss_value *ssP, char *chartname)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(41))
		return((data_ptr )0);
	return(SSEXPORT_ssJavaGetChart(ssP,chartname));
}

int  (*SSEXPORT_ssMeasureInsetObject)(data_ptr objP, data_ptr *unitP, data_ptr *areaP);

int  ssMeasureInsetObject(data_ptr objP, data_ptr *unitP, data_ptr *areaP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(42))
		return((int )0);
	return(SSEXPORT_ssMeasureInsetObject(objP,unitP,areaP));
}

double  (*SSEXPORT_ssNETWORKDAYS)(double start, double end, double *holiday);

double  ssNETWORKDAYS(double start, double end, double *holiday)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(43))
		return((double )0);
	return(SSEXPORT_ssNETWORKDAYS(start,end,holiday));
}

data_ptr  (*SSEXPORT_ssPackageInsetObject)(data_ptr uidP, data_ptr srcP, data_ptr unitsP);

data_ptr  ssPackageInsetObject(data_ptr uidP, data_ptr srcP, data_ptr unitsP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(44))
		return((data_ptr )0);
	return(SSEXPORT_ssPackageInsetObject(uidP,srcP,unitsP));
}

int  (*SSEXPORT_ssRenderAssociatedGraphic)(AXWidget wP, data_ptr objP, data_ptr insetP, data_ptr imP);

int  ssRenderAssociatedGraphic(AXWidget wP, data_ptr objP, data_ptr insetP, data_ptr imP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(45))
		return((int )0);
	return(SSEXPORT_ssRenderAssociatedGraphic(wP,objP,insetP,imP));
}

double  (*SSEXPORT_ssTIMEVALUE)(char *s);

double  ssTIMEVALUE(char *s)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(46))
		return((double )0);
	return(SSEXPORT_ssTIMEVALUE(s));
}

double  (*SSEXPORT_ssWEEKDAY)(double d, double type);

double  ssWEEKDAY(double d, double type)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(47))
		return((double )0);
	return(SSEXPORT_ssWEEKDAY(d,type));
}

double  (*SSEXPORT_ssWORKDAY)(double start, double days, double *holiday);

double  ssWORKDAY(double start, double days, double *holiday)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(48))
		return((double )0);
	return(SSEXPORT_ssWORKDAY(start,days,holiday));
}

data_ptr  (*SSEXPORT_ssXUtil)(data_ptr argsP);

data_ptr  ssXUtil(data_ptr argsP)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(49))
		return((data_ptr )0);
	return(SSEXPORT_ssXUtil(argsP));
}

double  (*SSEXPORT_ssYEARFRAC)(double start, double end, double basis);

double  ssYEARFRAC(double start, double end, double basis)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(50))
		return((double )0);
	return(SSEXPORT_ssYEARFRAC(start,end,basis));
}

void  (*SSEXPORT_undate)(double datenum, DATE_TRIP *s);

void  undate(double datenum, DATE_TRIP *s)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(51))
		return;
	SSEXPORT_undate(datenum,s);
}

int  (*SSEXPORT_x_basis)(double basis);

int  x_basis(double basis)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(52))
		return((int )0);
	return(SSEXPORT_x_basis(basis));
}

boolean  (*SSEXPORT_x_date)(double *d);

boolean  x_date(double *d)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(53))
		return((boolean )0);
	return(SSEXPORT_x_date(d));
}

int  (*SSEXPORT_x_pint)(double d);

int  x_pint(double d)
{
	if(SSExpFuncPtrTbl==NULL && !SHLoadAndSnap_SS(54))
		return((int )0);
	return(SSEXPORT_x_pint(d));
}

int isShlibLoaded_SS()
{
	return(SSExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_SS(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "AxCreatePlates", NULL },
		{ "AxFreeSSXbyPID", NULL },
		{ "AxGetSSTaskInfo", NULL },
		{ "DAY", NULL },
		{ "ElfSSCalcGetCellRange", NULL },
		{ "ElfbSSCall", NULL },
		{ "GetObjFromUID", NULL },
		{ "GetSSPathname", NULL },
		{ "MONTH", NULL },
		{ "SSChangeLinks", NULL },
		{ "SSCmdStatus", NULL },
		{ "SSCreateSSX", NULL },
		{ "SSElfExtDocInfo", NULL },
		{ "SSElfInstall", NULL },
		{ "SSFreeSSXbyUID", NULL },
		{ "SSGetEditTypeFaceStr", NULL },
		{ "SSGetLinks", NULL },
		{ "SSGetSSXFromUid", NULL },
		{ "SSJVGetCurwinId", NULL },
		{ "SSLocalizeLinks", NULL },
		{ "SSNoteUserFunc", NULL },
		{ "SSPlatesHeight", NULL },
		{ "SSRemoveUserFunc", NULL },
		{ "SSSetRmInfo", NULL },
		{ "SSUpdateMenuBarInfo", NULL },
		{ "SSXReadFile", NULL },
		{ "SSXWriteFile", NULL },
		{ "SSZoomCallback", NULL },
		{ "SSthimble", NULL },
		{ "SStmatherr", NULL },
		{ "YEAR", NULL },
		{ "addEntryToFuncTable", NULL },
		{ "days_between", NULL },
		{ "idate", NULL },
		{ "ssDATEVALUE", NULL },
		{ "ssDAYS360", NULL },
		{ "ssDrawButtonAsBitmap", NULL },
		{ "ssDrawButtonImgText", NULL },
		{ "ssEDATE", NULL },
		{ "ssEOMONTH", NULL },
		{ "ssGetNonFontAttrValues", NULL },
		{ "ssJavaGetChart", NULL },
		{ "ssMeasureInsetObject", NULL },
		{ "ssNETWORKDAYS", NULL },
		{ "ssPackageInsetObject", NULL },
		{ "ssRenderAssociatedGraphic", NULL },
		{ "ssTIMEVALUE", NULL },
		{ "ssWEEKDAY", NULL },
		{ "ssWORKDAY", NULL },
		{ "ssXUtil", NULL },
		{ "ssYEARFRAC", NULL },
		{ "undate", NULL },
		{ "x_basis", NULL },
		{ "x_date", NULL },
		{ "x_pint", NULL },
		{ NULL,NULL }
	};

	if((SSExpFuncPtrTbl=AxLoadShlib(LIBID_SS,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,SSExpFuncPtrTbl);

	SSEXPORT_AxCreatePlates = 
		(AXWidget  (*)(AXWidget parentWidget, char *name, int wid)) impFuncTbl[0].fptr;
	SSEXPORT_AxFreeSSXbyPID = 
		(void  (*)(int pid)) impFuncTbl[1].fptr;
	SSEXPORT_AxGetSSTaskInfo = 
		(void * (*)(int pid)) impFuncTbl[2].fptr;
	SSEXPORT_DAY = 
		(double  (*)(double datenum)) impFuncTbl[3].fptr;
	SSEXPORT_ElfSSCalcGetCellRange = 
		(int  (*)(void *tssP, int *col1, int *row1, int *sheet1, int *col2, int *row2, int *sheet2)) impFuncTbl[4].fptr;
	SSEXPORT_ElfbSSCall = 
		(data_ptr  (*)(data_ptr argArray)) impFuncTbl[5].fptr;
	SSEXPORT_GetObjFromUID = 
		(GPHOBJ * (*)(ss_value *ssP, int uid, int appid)) impFuncTbl[6].fptr;
	SSEXPORT_GetSSPathname = 
		(char * (*)(void)) impFuncTbl[7].fptr;
	SSEXPORT_MONTH = 
		(double  (*)(double datenum)) impFuncTbl[8].fptr;
	SSEXPORT_SSChangeLinks = 
		(int  (*)(ss_value *ssP, doc_links_info_t *docLinksP)) impFuncTbl[9].fptr;
	SSEXPORT_SSCmdStatus = 
		(int  (*)(char *name, int timeUID, int toggle_state_too, int cmd, int wID)) impFuncTbl[10].fptr;
	SSEXPORT_SSCreateSSX = 
		(int  (*)(int pid, int forSSTask)) impFuncTbl[11].fptr;
	SSEXPORT_SSElfExtDocInfo = 
		(data_ptr  (*)(ss_value *ssP, data_ptr aP)) impFuncTbl[12].fptr;
	SSEXPORT_SSElfInstall = 
		(int  (*)(void)) impFuncTbl[13].fptr;
	SSEXPORT_SSFreeSSXbyUID = 
		(int  (*)(int uid)) impFuncTbl[14].fptr;
	SSEXPORT_SSGetEditTypeFaceStr = 
		(char * (*)(void)) impFuncTbl[15].fptr;
	SSEXPORT_SSGetLinks = 
		(int  (*)(ss_value *ssP, char *pathname, doc_links_info_t *docLinksP)) impFuncTbl[16].fptr;
	SSEXPORT_SSGetSSXFromUid = 
		(int  (*)(int ssx_uid, ss_value **ssx)) impFuncTbl[17].fptr;
	SSEXPORT_SSJVGetCurwinId = 
		(int  (*)(int pid)) impFuncTbl[18].fptr;
	SSEXPORT_SSLocalizeLinks = 
		(int  (*)(ss_value *ssP, char *parentDoc)) impFuncTbl[19].fptr;
	SSEXPORT_SSNoteUserFunc = 
		(int  (*)(char *category, char *alias, char *engname, char *argInfo, int callMode)) impFuncTbl[20].fptr;
	SSEXPORT_SSPlatesHeight = 
		(int  (*)(void)) impFuncTbl[21].fptr;
	SSEXPORT_SSRemoveUserFunc = 
		(int  (*)(char *fname)) impFuncTbl[22].fptr;
	SSEXPORT_SSSetRmInfo = 
		(void  (*)(AXWidget_popup widget, int pid)) impFuncTbl[23].fptr;
	SSEXPORT_SSUpdateMenuBarInfo = 
		(int  (*)(int menubar_id)) impFuncTbl[24].fptr;
	SSEXPORT_SSXReadFile = 
		(int  (*)(int uid, char *path, char *rootPath)) impFuncTbl[25].fptr;
	SSEXPORT_SSXWriteFile = 
		(int  (*)(int uid, char *path)) impFuncTbl[26].fptr;
	SSEXPORT_SSZoomCallback = 
		(void  (*)(AXWidget widget, int pid, XmAnyCallbackStruct *data)) impFuncTbl[27].fptr;
	SSEXPORT_SSthimble = 
		(int  (*)(int argc, char *argv[])) impFuncTbl[28].fptr;
	SSEXPORT_SStmatherr = 
		(int  (*)(void *mathP)) impFuncTbl[29].fptr;
	SSEXPORT_YEAR = 
		(double  (*)(double datenum)) impFuncTbl[30].fptr;
	SSEXPORT_addEntryToFuncTable = 
		(int  (*)(AxCallInfo_t *funcTable, int funcIdx, char *catgP, elfData (*funcP)(), char *fnameP, char *engnameP, char *argP, int disp_flag)) impFuncTbl[31].fptr;
	SSEXPORT_days_between = 
		(double  (*)(double start, double end, int basis)) impFuncTbl[32].fptr;
	SSEXPORT_idate = 
		(double  (*)(int year, int month, int day, boolean last)) impFuncTbl[33].fptr;
	SSEXPORT_ssDATEVALUE = 
		(double  (*)(char *s)) impFuncTbl[34].fptr;
	SSEXPORT_ssDAYS360 = 
		(double  (*)(double sdate, double edate, double method)) impFuncTbl[35].fptr;
	SSEXPORT_ssDrawButtonAsBitmap = 
		(int  (*)(void *tssP, char *name, int x, int y, int width, int height, SSRECT *clipP)) impFuncTbl[36].fptr;
	SSEXPORT_ssDrawButtonImgText = 
		(int  (*)(void *tssP, Window xwin, unsigned char *wstr, int printfactor, int xPos, int yPos, char *fontFamily, int ptsize, int weight, int slant, unsigned long fcolor, unsigned long bcolor, int ruling, int word_underline_only, r32 *cliprect)) impFuncTbl[37].fptr;
	SSEXPORT_ssEDATE = 
		(double  (*)(double d, double months)) impFuncTbl[38].fptr;
	SSEXPORT_ssEOMONTH = 
		(double  (*)(double d, double months)) impFuncTbl[39].fptr;
	SSEXPORT_ssGetNonFontAttrValues = 
		(int  (*)(ss_value *tssP, char *str, XFontStruct **font, char *fontFamily, int *weight, int *slant, int *ruling, int *ascent, int ptsize, int *img_width, int *img_height, int editbutt)) impFuncTbl[40].fptr;
	SSEXPORT_ssJavaGetChart = 
		(data_ptr  (*)(ss_value *ssP, char *chartname)) impFuncTbl[41].fptr;
	SSEXPORT_ssMeasureInsetObject = 
		(int  (*)(data_ptr objP, data_ptr *unitP, data_ptr *areaP)) impFuncTbl[42].fptr;
	SSEXPORT_ssNETWORKDAYS = 
		(double  (*)(double start, double end, double *holiday)) impFuncTbl[43].fptr;
	SSEXPORT_ssPackageInsetObject = 
		(data_ptr  (*)(data_ptr uidP, data_ptr srcP, data_ptr unitsP)) impFuncTbl[44].fptr;
	SSEXPORT_ssRenderAssociatedGraphic = 
		(int  (*)(AXWidget wP, data_ptr objP, data_ptr insetP, data_ptr imP)) impFuncTbl[45].fptr;
	SSEXPORT_ssTIMEVALUE = 
		(double  (*)(char *s)) impFuncTbl[46].fptr;
	SSEXPORT_ssWEEKDAY = 
		(double  (*)(double d, double type)) impFuncTbl[47].fptr;
	SSEXPORT_ssWORKDAY = 
		(double  (*)(double start, double days, double *holiday)) impFuncTbl[48].fptr;
	SSEXPORT_ssXUtil = 
		(data_ptr  (*)(data_ptr argsP)) impFuncTbl[49].fptr;
	SSEXPORT_ssYEARFRAC = 
		(double  (*)(double start, double end, double basis)) impFuncTbl[50].fptr;
	SSEXPORT_undate = 
		(void  (*)(double datenum, DATE_TRIP *s)) impFuncTbl[51].fptr;
	SSEXPORT_x_basis = 
		(int  (*)(double basis)) impFuncTbl[52].fptr;
	SSEXPORT_x_date = 
		(boolean  (*)(double *d)) impFuncTbl[53].fptr;
	SSEXPORT_x_pint = 
		(int  (*)(double d)) impFuncTbl[54].fptr;

	AxElfInstallForShlib(LIBID_SS);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_SS()
{
	if(SSExpFuncPtrTbl != NULL)
		return;

	SSEXPORT_AxCreatePlates = AxCreatePlates;
	SSEXPORT_AxFreeSSXbyPID = AxFreeSSXbyPID;
	SSEXPORT_AxGetSSTaskInfo = AxGetSSTaskInfo;
	SSEXPORT_DAY = DAY;
	SSEXPORT_ElfSSCalcGetCellRange = ElfSSCalcGetCellRange;
	SSEXPORT_ElfbSSCall = ElfbSSCall;
	SSEXPORT_GetObjFromUID = GetObjFromUID;
	SSEXPORT_GetSSPathname = GetSSPathname;
	SSEXPORT_MONTH = MONTH;
	SSEXPORT_SSChangeLinks = SSChangeLinks;
	SSEXPORT_SSCmdStatus = SSCmdStatus;
	SSEXPORT_SSCreateSSX = SSCreateSSX;
	SSEXPORT_SSElfExtDocInfo = SSElfExtDocInfo;
	SSEXPORT_SSElfInstall = SSElfInstall;
	SSEXPORT_SSFreeSSXbyUID = SSFreeSSXbyUID;
	SSEXPORT_SSGetEditTypeFaceStr = SSGetEditTypeFaceStr;
	SSEXPORT_SSGetLinks = SSGetLinks;
	SSEXPORT_SSGetSSXFromUid = SSGetSSXFromUid;
	SSEXPORT_SSJVGetCurwinId = SSJVGetCurwinId;
	SSEXPORT_SSLocalizeLinks = SSLocalizeLinks;
	SSEXPORT_SSNoteUserFunc = SSNoteUserFunc;
	SSEXPORT_SSPlatesHeight = SSPlatesHeight;
	SSEXPORT_SSRemoveUserFunc = SSRemoveUserFunc;
	SSEXPORT_SSSetRmInfo = SSSetRmInfo;
	SSEXPORT_SSUpdateMenuBarInfo = SSUpdateMenuBarInfo;
	SSEXPORT_SSXReadFile = SSXReadFile;
	SSEXPORT_SSXWriteFile = SSXWriteFile;
	SSEXPORT_SSZoomCallback = SSZoomCallback;
	SSEXPORT_SSthimble = SSthimble;
	SSEXPORT_SStmatherr = SStmatherr;
	SSEXPORT_YEAR = YEAR;
	SSEXPORT_addEntryToFuncTable = addEntryToFuncTable;
	SSEXPORT_days_between = days_between;
	SSEXPORT_idate = idate;
	SSEXPORT_ssDATEVALUE = ssDATEVALUE;
	SSEXPORT_ssDAYS360 = ssDAYS360;
	SSEXPORT_ssDrawButtonAsBitmap = ssDrawButtonAsBitmap;
	SSEXPORT_ssDrawButtonImgText = ssDrawButtonImgText;
	SSEXPORT_ssEDATE = ssEDATE;
	SSEXPORT_ssEOMONTH = ssEOMONTH;
	SSEXPORT_ssGetNonFontAttrValues = ssGetNonFontAttrValues;
	SSEXPORT_ssJavaGetChart = ssJavaGetChart;
	SSEXPORT_ssMeasureInsetObject = ssMeasureInsetObject;
	SSEXPORT_ssNETWORKDAYS = ssNETWORKDAYS;
	SSEXPORT_ssPackageInsetObject = ssPackageInsetObject;
	SSEXPORT_ssRenderAssociatedGraphic = ssRenderAssociatedGraphic;
	SSEXPORT_ssTIMEVALUE = ssTIMEVALUE;
	SSEXPORT_ssWEEKDAY = ssWEEKDAY;
	SSEXPORT_ssWORKDAY = ssWORKDAY;
	SSEXPORT_ssXUtil = ssXUtil;
	SSEXPORT_ssYEARFRAC = ssYEARFRAC;
	SSEXPORT_undate = undate;
	SSEXPORT_x_basis = x_basis;
	SSEXPORT_x_date = x_date;
	SSEXPORT_x_pint = x_pint;
}

/** Funcs Imported from axwp
   ***********************************************************/

static ShlibFuncInfo* WPExpFuncPtrTbl=NULL;

int  (*WPEXPORT_AllowJavaWp)(void);

int  AllowJavaWp(void)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(0))
		return((int )0);
	return(WPEXPORT_AllowJavaWp());
}

AXWidget  (*WPEXPORT_AxCreateRuler)(AXWidget parentWidget, char *name, void (*callback_func)(), caddr_t pid);

AXWidget  AxCreateRuler(AXWidget parentWidget, char *name, void (*callback_func)(), caddr_t pid)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(1))
		return((AXWidget )0);
	return(WPEXPORT_AxCreateRuler(parentWidget,name,callback_func,pid));
}

void  (*WPEXPORT_AxFreeWPXbyPID)(int pid);

void  AxFreeWPXbyPID(int pid)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(2))
		return;
	WPEXPORT_AxFreeWPXbyPID(pid);
}

data_ptr  (*WPEXPORT_AxfMeasureWpInsetObjectCoords)(data_ptr aP);

data_ptr  AxfMeasureWpInsetObjectCoords(data_ptr aP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(3))
		return((data_ptr )0);
	return(WPEXPORT_AxfMeasureWpInsetObjectCoords(aP));
}

int  (*WPEXPORT_DCCmdStatus)(char *name, int timeUID, int toggle_state_too, int cmd);

int  DCCmdStatus(char *name, int timeUID, int toggle_state_too, int cmd)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(4))
		return((int )0);
	return(WPEXPORT_DCCmdStatus(name,timeUID,toggle_state_too,cmd));
}

void  (*WPEXPORT_DCZoomCallback)(AXWidget widget, int pid, XmAnyCallbackStruct *data);

void  DCZoomCallback(AXWidget widget, int pid, XmAnyCallbackStruct *data)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(5))
		return;
	WPEXPORT_DCZoomCallback(widget,pid,data);
}

void  (*WPEXPORT_EDtester)(void);

void  EDtester(void)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(6))
		return;
	WPEXPORT_EDtester();
}

int  (*WPEXPORT_EQCmdStatus)(char *name, int timeUID, int toggle_state_too, int cmd);

int  EQCmdStatus(char *name, int timeUID, int toggle_state_too, int cmd)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(7))
		return((int )0);
	return(WPEXPORT_EQCmdStatus(name,timeUID,toggle_state_too,cmd));
}

void  (*WPEXPORT_EQthimble)(int argc, char *argv[]);

void  EQthimble(int argc, char *argv[])
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(8))
		return;
	WPEXPORT_EQthimble(argc,argv);
}

short  (*WPEXPORT_ElfbAssignWpInstance)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbAssignWpInstance(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(9))
		return((short )0);
	return(WPEXPORT_ElfbAssignWpInstance(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbCreateWpInstance)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbCreateWpInstance(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(10))
		return((short )0);
	return(WPEXPORT_ElfbCreateWpInstance(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbDestroyWpInstance)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbDestroyWpInstance(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(11))
		return((short )0);
	return(WPEXPORT_ElfbDestroyWpInstance(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbGetWpInstance)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbGetWpInstance(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(12))
		return((short )0);
	return(WPEXPORT_ElfbGetWpInstance(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbLoadWpInstance)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbLoadWpInstance(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(13))
		return((short )0);
	return(WPEXPORT_ElfbLoadWpInstance(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbReadWpInstanceBuffer)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbReadWpInstanceBuffer(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(14))
		return((short )0);
	return(WPEXPORT_ElfbReadWpInstanceBuffer(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbReadWpInstanceFile)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbReadWpInstanceFile(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(15))
		return((short )0);
	return(WPEXPORT_ElfbReadWpInstanceFile(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

void  (*WPEXPORT_ElfbWpCall)(data_ptr wpTask, data_ptr cmdCode, data_ptr aP1, data_ptr aP2, data_ptr aP3, data_ptr aP4, data_ptr aP5);

void  ElfbWpCall(data_ptr wpTask, data_ptr cmdCode, data_ptr aP1, data_ptr aP2, data_ptr aP3, data_ptr aP4, data_ptr aP5)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(16))
		return;
	WPEXPORT_ElfbWpCall(wpTask,cmdCode,aP1,aP2,aP3,aP4,aP5);
}

void  (*WPEXPORT_ElfbWpxCall)(data_ptr cmdP, data_ptr wpxP, data_ptr argsP);

void  ElfbWpxCall(data_ptr cmdP, data_ptr wpxP, data_ptr argsP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(17))
		return;
	WPEXPORT_ElfbWpxCall(cmdP,wpxP,argsP);
}

short  (*WPEXPORT_ElfbWriteWpInstanceBuffer)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbWriteWpInstanceBuffer(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(18))
		return((short )0);
	return(WPEXPORT_ElfbWriteWpInstanceBuffer(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

short  (*WPEXPORT_ElfbWriteWpInstanceFile)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P);

short  ElfbWriteWpInstanceFile(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(19))
		return((short )0);
	return(WPEXPORT_ElfbWriteWpInstanceFile(aP,jnk1P,jnk2P,jnk3P,jnk4P,jnk5P,jnk6P));
}

int  (*WPEXPORT_HTMLCmdStatus)(char *name, int timeUID, int toggle_state_too, int cmd);

int  HTMLCmdStatus(char *name, int timeUID, int toggle_state_too, int cmd)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(20))
		return((int )0);
	return(WPEXPORT_HTMLCmdStatus(name,timeUID,toggle_state_too,cmd));
}

void  (*WPEXPORT_HTMLthimble)(int argc, char *argv[]);

void  HTMLthimble(int argc, char *argv[])
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(21))
		return;
	WPEXPORT_HTMLthimble(argc,argv);
}

int  (*WPEXPORT_MECmdStatus)(char *name, int timeUID, int toggle_state_too, int cmd);

int  MECmdStatus(char *name, int timeUID, int toggle_state_too, int cmd)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(22))
		return((int )0);
	return(WPEXPORT_MECmdStatus(name,timeUID,toggle_state_too,cmd));
}

void  (*WPEXPORT_MEthimble)(int argc, char *argv[]);

void  MEthimble(int argc, char *argv[])
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(23))
		return;
	WPEXPORT_MEthimble(argc,argv);
}

void  (*WPEXPORT_RWGlyphCallback)(AXWidget widget, int wid, XmRowColumnCallbackStruct *data);

void  RWGlyphCallback(AXWidget widget, int wid, XmRowColumnCallbackStruct *data)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(24))
		return;
	WPEXPORT_RWGlyphCallback(widget,wid,data);
}

void  (*WPEXPORT_WPAsserter)(char *file, int line);

void  WPAsserter(char *file, int line)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(25))
		return;
	WPEXPORT_WPAsserter(file,line);
}

int  (*WPEXPORT_WPElfInstall)(void);

int  WPElfInstall(void)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(26))
		return((int )0);
	return(WPEXPORT_WPElfInstall());
}

int  (*WPEXPORT_WPUpdateMenuBarInfo)(int menubar_id);

int  WPUpdateMenuBarInfo(int menubar_id)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(27))
		return((int )0);
	return(WPEXPORT_WPUpdateMenuBarInfo(menubar_id));
}

void  (*WPEXPORT_WPthimble)(int argc, char *argv[]);

void  WPthimble(int argc, char *argv[])
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(28))
		return;
	WPEXPORT_WPthimble(argc,argv);
}

void  (*WPEXPORT_WpDestroyRulerWidget)(AXWidget_ruler w);

void  WpDestroyRulerWidget(AXWidget_ruler w)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(29))
		return;
	WPEXPORT_WpDestroyRulerWidget(w);
}

int  (*WPEXPORT_WpRulerHeight)(int appId);

int  WpRulerHeight(int appId)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(30))
		return((int )0);
	return(WPEXPORT_WpRulerHeight(appId));
}

void  (*WPEXPORT_WpSetRmInfo)(AXWidget widget, int pid);

void  WpSetRmInfo(AXWidget widget, int pid)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(31))
		return;
	WPEXPORT_WpSetRmInfo(widget,pid);
}

short  (*WPEXPORT_WpxChangeDocLinksInfo)(data_ptr uidP, doc_links_info_t *docLinksP, char *savefile);

short  WpxChangeDocLinksInfo(data_ptr uidP, doc_links_info_t *docLinksP, char *savefile)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(32))
		return((short )0);
	return(WPEXPORT_WpxChangeDocLinksInfo(uidP,docLinksP,savefile));
}

short  (*WPEXPORT_WpxGetDocLinksInfo)(data_ptr uidP, doc_links_info_t *docLinksP);

short  WpxGetDocLinksInfo(data_ptr uidP, doc_links_info_t *docLinksP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(33))
		return((short )0);
	return(WPEXPORT_WpxGetDocLinksInfo(uidP,docLinksP));
}

short  (*WPEXPORT_WpxLocalizeDocLinks)(data_ptr uidP, char *name, doc_links_info_t *docLinksP, char *savefile, char *parentdoc);

short  WpxLocalizeDocLinks(data_ptr uidP, char *name, doc_links_info_t *docLinksP, char *savefile, char *parentdoc)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(34))
		return((short )0);
	return(WPEXPORT_WpxLocalizeDocLinks(uidP,name,docLinksP,savefile,parentdoc));
}

data_ptr  (*WPEXPORT_htmlPackageInsetObject)(data_ptr uidP, data_ptr srcP, data_ptr unitsP);

data_ptr  htmlPackageInsetObject(data_ptr uidP, data_ptr srcP, data_ptr unitsP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(35))
		return((data_ptr )0);
	return(WPEXPORT_htmlPackageInsetObject(uidP,srcP,unitsP));
}

short  (*WPEXPORT_wpMeasureInsetObject)(data_ptr objP, data_ptr *unitsP, data_ptr *sizeP);

short  wpMeasureInsetObject(data_ptr objP, data_ptr *unitsP, data_ptr *sizeP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(36))
		return((short )0);
	return(WPEXPORT_wpMeasureInsetObject(objP,unitsP,sizeP));
}

short  (*WPEXPORT_wpMeasureInsetObjectCoords)(data_ptr objP, data_ptr *unitsP, data_ptr *areaP);

short  wpMeasureInsetObjectCoords(data_ptr objP, data_ptr *unitsP, data_ptr *areaP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(37))
		return((short )0);
	return(WPEXPORT_wpMeasureInsetObjectCoords(objP,unitsP,areaP));
}

data_ptr  (*WPEXPORT_wpPackageInsetObject)(data_ptr uidP, data_ptr srcP, data_ptr unitsP);

data_ptr  wpPackageInsetObject(data_ptr uidP, data_ptr srcP, data_ptr unitsP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(38))
		return((data_ptr )0);
	return(WPEXPORT_wpPackageInsetObject(uidP,srcP,unitsP));
}

short  (*WPEXPORT_wpRenderAssociatedGraphic)(AXWidget w, data_ptr objP, data_ptr insetP, data_ptr imP);

short  wpRenderAssociatedGraphic(AXWidget w, data_ptr objP, data_ptr insetP, data_ptr imP)
{
	if(WPExpFuncPtrTbl==NULL && !SHLoadAndSnap_WP(39))
		return((short )0);
	return(WPEXPORT_wpRenderAssociatedGraphic(w,objP,insetP,imP));
}

int isShlibLoaded_WP()
{
	return(WPExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_WP(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "AllowJavaWp", NULL },
		{ "AxCreateRuler", NULL },
		{ "AxFreeWPXbyPID", NULL },
		{ "AxfMeasureWpInsetObjectCoords", NULL },
		{ "DCCmdStatus", NULL },
		{ "DCZoomCallback", NULL },
		{ "EDtester", NULL },
		{ "EQCmdStatus", NULL },
		{ "EQthimble", NULL },
		{ "ElfbAssignWpInstance", NULL },
		{ "ElfbCreateWpInstance", NULL },
		{ "ElfbDestroyWpInstance", NULL },
		{ "ElfbGetWpInstance", NULL },
		{ "ElfbLoadWpInstance", NULL },
		{ "ElfbReadWpInstanceBuffer", NULL },
		{ "ElfbReadWpInstanceFile", NULL },
		{ "ElfbWpCall", NULL },
		{ "ElfbWpxCall", NULL },
		{ "ElfbWriteWpInstanceBuffer", NULL },
		{ "ElfbWriteWpInstanceFile", NULL },
		{ "HTMLCmdStatus", NULL },
		{ "HTMLthimble", NULL },
		{ "MECmdStatus", NULL },
		{ "MEthimble", NULL },
		{ "RWGlyphCallback", NULL },
		{ "WPAsserter", NULL },
		{ "WPElfInstall", NULL },
		{ "WPUpdateMenuBarInfo", NULL },
		{ "WPthimble", NULL },
		{ "WpDestroyRulerWidget", NULL },
		{ "WpRulerHeight", NULL },
		{ "WpSetRmInfo", NULL },
		{ "WpxChangeDocLinksInfo", NULL },
		{ "WpxGetDocLinksInfo", NULL },
		{ "WpxLocalizeDocLinks", NULL },
		{ "htmlPackageInsetObject", NULL },
		{ "wpMeasureInsetObject", NULL },
		{ "wpMeasureInsetObjectCoords", NULL },
		{ "wpPackageInsetObject", NULL },
		{ "wpRenderAssociatedGraphic", NULL },
		{ NULL,NULL }
	};

	if((WPExpFuncPtrTbl=AxLoadShlib(LIBID_WP,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,WPExpFuncPtrTbl);

	WPEXPORT_AllowJavaWp = 
		(int  (*)(void)) impFuncTbl[0].fptr;
	WPEXPORT_AxCreateRuler = 
		(AXWidget  (*)(AXWidget parentWidget, char *name, void (*callback_func)(), caddr_t pid)) impFuncTbl[1].fptr;
	WPEXPORT_AxFreeWPXbyPID = 
		(void  (*)(int pid)) impFuncTbl[2].fptr;
	WPEXPORT_AxfMeasureWpInsetObjectCoords = 
		(data_ptr  (*)(data_ptr aP)) impFuncTbl[3].fptr;
	WPEXPORT_DCCmdStatus = 
		(int  (*)(char *name, int timeUID, int toggle_state_too, int cmd)) impFuncTbl[4].fptr;
	WPEXPORT_DCZoomCallback = 
		(void  (*)(AXWidget widget, int pid, XmAnyCallbackStruct *data)) impFuncTbl[5].fptr;
	WPEXPORT_EDtester = 
		(void  (*)(void)) impFuncTbl[6].fptr;
	WPEXPORT_EQCmdStatus = 
		(int  (*)(char *name, int timeUID, int toggle_state_too, int cmd)) impFuncTbl[7].fptr;
	WPEXPORT_EQthimble = 
		(void  (*)(int argc, char *argv[])) impFuncTbl[8].fptr;
	WPEXPORT_ElfbAssignWpInstance = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[9].fptr;
	WPEXPORT_ElfbCreateWpInstance = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[10].fptr;
	WPEXPORT_ElfbDestroyWpInstance = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[11].fptr;
	WPEXPORT_ElfbGetWpInstance = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[12].fptr;
	WPEXPORT_ElfbLoadWpInstance = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[13].fptr;
	WPEXPORT_ElfbReadWpInstanceBuffer = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[14].fptr;
	WPEXPORT_ElfbReadWpInstanceFile = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[15].fptr;
	WPEXPORT_ElfbWpCall = 
		(void  (*)(data_ptr wpTask, data_ptr cmdCode, data_ptr aP1, data_ptr aP2, data_ptr aP3, data_ptr aP4, data_ptr aP5)) impFuncTbl[16].fptr;
	WPEXPORT_ElfbWpxCall = 
		(void  (*)(data_ptr cmdP, data_ptr wpxP, data_ptr argsP)) impFuncTbl[17].fptr;
	WPEXPORT_ElfbWriteWpInstanceBuffer = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[18].fptr;
	WPEXPORT_ElfbWriteWpInstanceFile = 
		(short  (*)(data_ptr aP, data_ptr jnk1P, data_ptr jnk2P, data_ptr jnk3P, data_ptr jnk4P, data_ptr jnk5P, data_ptr jnk6P)) impFuncTbl[19].fptr;
	WPEXPORT_HTMLCmdStatus = 
		(int  (*)(char *name, int timeUID, int toggle_state_too, int cmd)) impFuncTbl[20].fptr;
	WPEXPORT_HTMLthimble = 
		(void  (*)(int argc, char *argv[])) impFuncTbl[21].fptr;
	WPEXPORT_MECmdStatus = 
		(int  (*)(char *name, int timeUID, int toggle_state_too, int cmd)) impFuncTbl[22].fptr;
	WPEXPORT_MEthimble = 
		(void  (*)(int argc, char *argv[])) impFuncTbl[23].fptr;
	WPEXPORT_RWGlyphCallback = 
		(void  (*)(AXWidget widget, int wid, XmRowColumnCallbackStruct *data)) impFuncTbl[24].fptr;
	WPEXPORT_WPAsserter = 
		(void  (*)(char *file, int line)) impFuncTbl[25].fptr;
	WPEXPORT_WPElfInstall = 
		(int  (*)(void)) impFuncTbl[26].fptr;
	WPEXPORT_WPUpdateMenuBarInfo = 
		(int  (*)(int menubar_id)) impFuncTbl[27].fptr;
	WPEXPORT_WPthimble = 
		(void  (*)(int argc, char *argv[])) impFuncTbl[28].fptr;
	WPEXPORT_WpDestroyRulerWidget = 
		(void  (*)(AXWidget_ruler w)) impFuncTbl[29].fptr;
	WPEXPORT_WpRulerHeight = 
		(int  (*)(int appId)) impFuncTbl[30].fptr;
	WPEXPORT_WpSetRmInfo = 
		(void  (*)(AXWidget widget, int pid)) impFuncTbl[31].fptr;
	WPEXPORT_WpxChangeDocLinksInfo = 
		(short  (*)(data_ptr uidP, doc_links_info_t *docLinksP, char *savefile)) impFuncTbl[32].fptr;
	WPEXPORT_WpxGetDocLinksInfo = 
		(short  (*)(data_ptr uidP, doc_links_info_t *docLinksP)) impFuncTbl[33].fptr;
	WPEXPORT_WpxLocalizeDocLinks = 
		(short  (*)(data_ptr uidP, char *name, doc_links_info_t *docLinksP, char *savefile, char *parentdoc)) impFuncTbl[34].fptr;
	WPEXPORT_htmlPackageInsetObject = 
		(data_ptr  (*)(data_ptr uidP, data_ptr srcP, data_ptr unitsP)) impFuncTbl[35].fptr;
	WPEXPORT_wpMeasureInsetObject = 
		(short  (*)(data_ptr objP, data_ptr *unitsP, data_ptr *sizeP)) impFuncTbl[36].fptr;
	WPEXPORT_wpMeasureInsetObjectCoords = 
		(short  (*)(data_ptr objP, data_ptr *unitsP, data_ptr *areaP)) impFuncTbl[37].fptr;
	WPEXPORT_wpPackageInsetObject = 
		(data_ptr  (*)(data_ptr uidP, data_ptr srcP, data_ptr unitsP)) impFuncTbl[38].fptr;
	WPEXPORT_wpRenderAssociatedGraphic = 
		(short  (*)(AXWidget w, data_ptr objP, data_ptr insetP, data_ptr imP)) impFuncTbl[39].fptr;

	AxElfInstallForShlib(LIBID_WP);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_WP()
{
	if(WPExpFuncPtrTbl != NULL)
		return;

	WPEXPORT_AllowJavaWp = AllowJavaWp;
	WPEXPORT_AxCreateRuler = AxCreateRuler;
	WPEXPORT_AxFreeWPXbyPID = AxFreeWPXbyPID;
	WPEXPORT_AxfMeasureWpInsetObjectCoords = AxfMeasureWpInsetObjectCoords;
	WPEXPORT_DCCmdStatus = DCCmdStatus;
	WPEXPORT_DCZoomCallback = DCZoomCallback;
	WPEXPORT_EDtester = EDtester;
	WPEXPORT_EQCmdStatus = EQCmdStatus;
	WPEXPORT_EQthimble = EQthimble;
	WPEXPORT_ElfbAssignWpInstance = ElfbAssignWpInstance;
	WPEXPORT_ElfbCreateWpInstance = ElfbCreateWpInstance;
	WPEXPORT_ElfbDestroyWpInstance = ElfbDestroyWpInstance;
	WPEXPORT_ElfbGetWpInstance = ElfbGetWpInstance;
	WPEXPORT_ElfbLoadWpInstance = ElfbLoadWpInstance;
	WPEXPORT_ElfbReadWpInstanceBuffer = ElfbReadWpInstanceBuffer;
	WPEXPORT_ElfbReadWpInstanceFile = ElfbReadWpInstanceFile;
	WPEXPORT_ElfbWpCall = ElfbWpCall;
	WPEXPORT_ElfbWpxCall = ElfbWpxCall;
	WPEXPORT_ElfbWriteWpInstanceBuffer = ElfbWriteWpInstanceBuffer;
	WPEXPORT_ElfbWriteWpInstanceFile = ElfbWriteWpInstanceFile;
	WPEXPORT_HTMLCmdStatus = HTMLCmdStatus;
	WPEXPORT_HTMLthimble = HTMLthimble;
	WPEXPORT_MECmdStatus = MECmdStatus;
	WPEXPORT_MEthimble = MEthimble;
	WPEXPORT_RWGlyphCallback = RWGlyphCallback;
	WPEXPORT_WPAsserter = WPAsserter;
	WPEXPORT_WPElfInstall = WPElfInstall;
	WPEXPORT_WPUpdateMenuBarInfo = WPUpdateMenuBarInfo;
	WPEXPORT_WPthimble = WPthimble;
	WPEXPORT_WpDestroyRulerWidget = WpDestroyRulerWidget;
	WPEXPORT_WpRulerHeight = WpRulerHeight;
	WPEXPORT_WpSetRmInfo = WpSetRmInfo;
	WPEXPORT_WpxChangeDocLinksInfo = WpxChangeDocLinksInfo;
	WPEXPORT_WpxGetDocLinksInfo = WpxGetDocLinksInfo;
	WPEXPORT_WpxLocalizeDocLinks = WpxLocalizeDocLinks;
	WPEXPORT_htmlPackageInsetObject = htmlPackageInsetObject;
	WPEXPORT_wpMeasureInsetObject = wpMeasureInsetObject;
	WPEXPORT_wpMeasureInsetObjectCoords = wpMeasureInsetObjectCoords;
	WPEXPORT_wpPackageInsetObject = wpPackageInsetObject;
	WPEXPORT_wpRenderAssociatedGraphic = wpRenderAssociatedGraphic;
}

/** Funcs Imported from axmail
   ***********************************************************/

static ShlibFuncInfo* MAILExpFuncPtrTbl=NULL;

int  (*MAILEXPORT_ElfbAddressParse)(char *str);

int  ElfbAddressParse(char *str)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(0))
		return((int )0);
	return(MAILEXPORT_ElfbAddressParse(str));
}

void  (*MAILEXPORT_ElfbDeleteMessages)(data_ptr dp1, data_ptr dp2);

void  ElfbDeleteMessages(data_ptr dp1, data_ptr dp2)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(1))
		return;
	MAILEXPORT_ElfbDeleteMessages(dp1,dp2);
}

int  (*MAILEXPORT_ElfbEncryptString)(char *passwd, char salt[3]);

int  ElfbEncryptString(char *passwd, char salt[3])
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(2))
		return((int )0);
	return(MAILEXPORT_ElfbEncryptString(passwd,salt));
}

int  (*MAILEXPORT_ElfbFormatMailItem)(data_ptr message, int val, int quick);

int  ElfbFormatMailItem(data_ptr message, int val, int quick)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(3))
		return((int )0);
	return(MAILEXPORT_ElfbFormatMailItem(message,val,quick));
}

int  (*MAILEXPORT_ElfbHasUnreadMail)(char *folder);

int  ElfbHasUnreadMail(char *folder)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(4))
		return((int )0);
	return(MAILEXPORT_ElfbHasUnreadMail(folder));
}

int  (*MAILEXPORT_ElfbMailBltins)(data_ptr command, data_ptr dp1, data_ptr dp2, data_ptr dp3, data_ptr dp4);

int  ElfbMailBltins(data_ptr command, data_ptr dp1, data_ptr dp2, data_ptr dp3, data_ptr dp4)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(5))
		return((int )0);
	return(MAILEXPORT_ElfbMailBltins(command,dp1,dp2,dp3,dp4));
}

int  (*MAILEXPORT_ElfbMkRandKey)(void);

int  ElfbMkRandKey(void)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(6))
		return((int )0);
	return(MAILEXPORT_ElfbMkRandKey());
}

int  (*MAILEXPORT_ElfbNewMailCount)(char *folder);

int  ElfbNewMailCount(char *folder)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(7))
		return((int )0);
	return(MAILEXPORT_ElfbNewMailCount(folder));
}

int  (*MAILEXPORT_ElfbReplaceSpace)(char *line);

int  ElfbReplaceSpace(char *line)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(8))
		return((int )0);
	return(MAILEXPORT_ElfbReplaceSpace(line));
}

int  (*MAILEXPORT_MailElfInstall)(void);

int  MailElfInstall(void)
{
	if(MAILExpFuncPtrTbl==NULL && !SHLoadAndSnap_MAIL(9))
		return((int )0);
	return(MAILEXPORT_MailElfInstall());
}

int isShlibLoaded_MAIL()
{
	return(MAILExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_MAIL(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "ElfbAddressParse", NULL },
		{ "ElfbDeleteMessages", NULL },
		{ "ElfbEncryptString", NULL },
		{ "ElfbFormatMailItem", NULL },
		{ "ElfbHasUnreadMail", NULL },
		{ "ElfbMailBltins", NULL },
		{ "ElfbMkRandKey", NULL },
		{ "ElfbNewMailCount", NULL },
		{ "ElfbReplaceSpace", NULL },
		{ "MailElfInstall", NULL },
		{ NULL,NULL }
	};

	if((MAILExpFuncPtrTbl=AxLoadShlib(LIBID_MAIL,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,MAILExpFuncPtrTbl);

	MAILEXPORT_ElfbAddressParse = 
		(int  (*)(char *str)) impFuncTbl[0].fptr;
	MAILEXPORT_ElfbDeleteMessages = 
		(void  (*)(data_ptr dp1, data_ptr dp2)) impFuncTbl[1].fptr;
	MAILEXPORT_ElfbEncryptString = 
		(int  (*)(char *passwd, char salt[3])) impFuncTbl[2].fptr;
	MAILEXPORT_ElfbFormatMailItem = 
		(int  (*)(data_ptr message, int val, int quick)) impFuncTbl[3].fptr;
	MAILEXPORT_ElfbHasUnreadMail = 
		(int  (*)(char *folder)) impFuncTbl[4].fptr;
	MAILEXPORT_ElfbMailBltins = 
		(int  (*)(data_ptr command, data_ptr dp1, data_ptr dp2, data_ptr dp3, data_ptr dp4)) impFuncTbl[5].fptr;
	MAILEXPORT_ElfbMkRandKey = 
		(int  (*)(void)) impFuncTbl[6].fptr;
	MAILEXPORT_ElfbNewMailCount = 
		(int  (*)(char *folder)) impFuncTbl[7].fptr;
	MAILEXPORT_ElfbReplaceSpace = 
		(int  (*)(char *line)) impFuncTbl[8].fptr;
	MAILEXPORT_MailElfInstall = 
		(int  (*)(void)) impFuncTbl[9].fptr;

	AxElfInstallForShlib(LIBID_MAIL);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_MAIL()
{
	if(MAILExpFuncPtrTbl != NULL)
		return;

	MAILEXPORT_ElfbAddressParse = ElfbAddressParse;
	MAILEXPORT_ElfbDeleteMessages = ElfbDeleteMessages;
	MAILEXPORT_ElfbEncryptString = ElfbEncryptString;
	MAILEXPORT_ElfbFormatMailItem = ElfbFormatMailItem;
	MAILEXPORT_ElfbHasUnreadMail = ElfbHasUnreadMail;
	MAILEXPORT_ElfbMailBltins = ElfbMailBltins;
	MAILEXPORT_ElfbMkRandKey = ElfbMkRandKey;
	MAILEXPORT_ElfbNewMailCount = ElfbNewMailCount;
	MAILEXPORT_ElfbReplaceSpace = ElfbReplaceSpace;
	MAILEXPORT_MailElfInstall = MailElfInstall;
}

/** Funcs Imported from axom
   ***********************************************************/

static ShlibFuncInfo* OMExpFuncPtrTbl=NULL;

int  (*OMEXPORT_OMailElfInstall)(void);

int  OMailElfInstall(void)
{
	if(OMExpFuncPtrTbl==NULL && !SHLoadAndSnap_OM(0))
		return((int )0);
	return(OMEXPORT_OMailElfInstall());
}

int isShlibLoaded_OM()
{
	return(OMExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_OM(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "OMailElfInstall", NULL },
		{ NULL,NULL }
	};

	if((OMExpFuncPtrTbl=AxLoadShlib(LIBID_OM,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,OMExpFuncPtrTbl);

	OMEXPORT_OMailElfInstall = 
		(int  (*)(void)) impFuncTbl[0].fptr;

	AxElfInstallForShlib(LIBID_OM);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_OM()
{
	if(OMExpFuncPtrTbl != NULL)
		return;

	OMEXPORT_OMailElfInstall = OMailElfInstall;
}

/** Funcs Imported from axrt
   ***********************************************************/

static ShlibFuncInfo* RTExpFuncPtrTbl=NULL;

int  (*RTEXPORT_RTElfInstall)(void);

int  RTElfInstall(void)
{
	if(RTExpFuncPtrTbl==NULL && !SHLoadAndSnap_RT(0))
		return((int )0);
	return(RTEXPORT_RTElfInstall());
}

int isShlibLoaded_RT()
{
	return(RTExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_RT(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "RTElfInstall", NULL },
		{ NULL,NULL }
	};

	if((RTExpFuncPtrTbl=AxLoadShlib(LIBID_RT,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,RTExpFuncPtrTbl);

	RTEXPORT_RTElfInstall = 
		(int  (*)(void)) impFuncTbl[0].fptr;

	AxElfInstallForShlib(LIBID_RT);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_RT()
{
	if(RTExpFuncPtrTbl != NULL)
		return;

	RTEXPORT_RTElfInstall = RTElfInstall;
}

/** Funcs Imported from axlm
   ***********************************************************/

static ShlibFuncInfo* LMExpFuncPtrTbl=NULL;

int  (*LMEXPORT_LMElfInstall)(void);

int  LMElfInstall(void)
{
	if(LMExpFuncPtrTbl==NULL && !SHLoadAndSnap_LM(0))
		return((int )0);
	return(LMEXPORT_LMElfInstall());
}

int isShlibLoaded_LM()
{
	return(LMExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_LM(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "LMElfInstall", NULL },
		{ NULL,NULL }
	};

	if((LMExpFuncPtrTbl=AxLoadShlib(LIBID_LM,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,LMExpFuncPtrTbl);

	LMEXPORT_LMElfInstall = 
		(int  (*)(void)) impFuncTbl[0].fptr;

	AxElfInstallForShlib(LIBID_LM);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_LM()
{
	if(LMExpFuncPtrTbl != NULL)
		return;

	LMEXPORT_LMElfInstall = LMElfInstall;
}

/** Funcs Imported from axcorba
   ***********************************************************/

static ShlibFuncInfo* CORBAExpFuncPtrTbl=NULL;

elfData  (*CORBAEXPORT_bldrDeferredInvocationResult)(corbabase *control, elfData reqId, int *status, elfData addInfo);

elfData  bldrDeferredInvocationResult(corbabase *control, elfData reqId, int *status, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(0))
		return((elfData )0);
	return(CORBAEXPORT_bldrDeferredInvocationResult(control,reqId,status,addInfo));
}

elfData  (*CORBAEXPORT_bldrDummyCallToLoadLibrary)(void);

elfData  bldrDummyCallToLoadLibrary(void)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(1))
		return((elfData )0);
	return(CORBAEXPORT_bldrDummyCallToLoadLibrary());
}

elfData  (*CORBAEXPORT_bldrExtAdditionalInfo)(elfData arg1, elfData addInfo);

elfData  bldrExtAdditionalInfo(elfData arg1, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(2))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtAdditionalInfo(arg1,addInfo));
}

void  (*CORBAEXPORT_bldrExtAppTerminated)(bldrextobjectbase *extObj);

void  bldrExtAppTerminated(bldrextobjectbase *extObj)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(3))
		return;
	CORBAEXPORT_bldrExtAppTerminated(extObj);
}

void * (*CORBAEXPORT_bldrExtCreateClassObj)(elfData className, elfData classInfo, elfData addInfo, int *status);

void * bldrExtCreateClassObj(elfData className, elfData classInfo, elfData addInfo, int *status)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(4))
		return((void *)0);
	return(CORBAEXPORT_bldrExtCreateClassObj(className,classInfo,addInfo,status));
}

void * (*CORBAEXPORT_bldrExtCreateObject)(elfData objectName, bldrextobjectbase *elfClassObj, int *status, elfData addInfo);

void * bldrExtCreateObject(elfData objectName, bldrextobjectbase *elfClassObj, int *status, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(5))
		return((void *)0);
	return(CORBAEXPORT_bldrExtCreateObject(objectName,elfClassObj,status,addInfo));
}

void  (*CORBAEXPORT_bldrExtDeleteObject)(bldrextobjectbase *obj);

void  bldrExtDeleteObject(bldrextobjectbase *obj)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(6))
		return;
	CORBAEXPORT_bldrExtDeleteObject(obj);
}

elfData  (*CORBAEXPORT_bldrExtHelpOnAllMethods)(elfData arg1);

elfData  bldrExtHelpOnAllMethods(elfData arg1)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(7))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtHelpOnAllMethods(arg1));
}

elfData  (*CORBAEXPORT_bldrExtHelpOnMethod)(bldrextobjectbase *extObj, elfData elfMethodName, elfData addInfo);

elfData  bldrExtHelpOnMethod(bldrextobjectbase *extObj, elfData elfMethodName, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(8))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtHelpOnMethod(extObj,elfMethodName,addInfo));
}

elfData  (*CORBAEXPORT_bldrExtListOfObjects)(elfData hostName, elfData objName, elfData addInfo);

elfData  bldrExtListOfObjects(elfData hostName, elfData objName, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(9))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtListOfObjects(hostName,objName,addInfo));
}

int  (*CORBAEXPORT_bldrExtMethodExists)(bldrextobjectbase *extObj, char *methodName);

int  bldrExtMethodExists(bldrextobjectbase *extObj, char *methodName)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(10))
		return((int )0);
	return(CORBAEXPORT_bldrExtMethodExists(extObj,methodName));
}

elfData  (*CORBAEXPORT_bldrExtObjMethodList)(bldrextobjectbase *extObj, elfData addInfo);

elfData  bldrExtObjMethodList(bldrextobjectbase *extObj, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(11))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtObjMethodList(extObj,addInfo));
}

void * (*CORBAEXPORT_bldrExtRegisterCallBack)(int dex, int uid, bldrextobjectbase *obj);

void * bldrExtRegisterCallBack(int dex, int uid, bldrextobjectbase *obj)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(12))
		return((void *)0);
	return(CORBAEXPORT_bldrExtRegisterCallBack(dex,uid,obj));
}

void  (*CORBAEXPORT_bldrExtSetInvocationMode)(corbabase *control, int mode, elfData addInfo);

void  bldrExtSetInvocationMode(corbabase *control, int mode, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(13))
		return;
	CORBAEXPORT_bldrExtSetInvocationMode(control,mode,addInfo);
}

elfData  (*CORBAEXPORT_bldrExtStructsAsFormats)(bldrextobjectbase *extObj, elfData arg1, elfData addInfo);

elfData  bldrExtStructsAsFormats(bldrextobjectbase *extObj, elfData arg1, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(14))
		return((elfData )0);
	return(CORBAEXPORT_bldrExtStructsAsFormats(extObj,arg1,addInfo));
}

elfData  (*CORBAEXPORT_bldrGetInterfaceName)(elfData arg1, elfData arg2, int *status);

elfData  bldrGetInterfaceName(elfData arg1, elfData arg2, int *status)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(15))
		return((elfData )0);
	return(CORBAEXPORT_bldrGetInterfaceName(arg1,arg2,status));
}

elfData  (*CORBAEXPORT_bldrInvokeMethodOnExtObj)(bldrextobjectbase *extObj, char *methodName, elfData args, int *status);

elfData  bldrInvokeMethodOnExtObj(bldrextobjectbase *extObj, char *methodName, elfData args, int *status)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(16))
		return((elfData )0);
	return(CORBAEXPORT_bldrInvokeMethodOnExtObj(extObj,methodName,args,status));
}

void  (*CORBAEXPORT_bldrSetExtInheritance)(bldrextobjectbase *obj, bldrextobjectbase *inheritFrom, elfData addInfo);

void  bldrSetExtInheritance(bldrextobjectbase *obj, bldrextobjectbase *inheritFrom, elfData addInfo)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(17))
		return;
	CORBAEXPORT_bldrSetExtInheritance(obj,inheritFrom,addInfo);
}

elfData  (*CORBAEXPORT_bldrUseAxORB)(void);

elfData  bldrUseAxORB(void)
{
	if(CORBAExpFuncPtrTbl==NULL && !SHLoadAndSnap_CORBA(18))
		return((elfData )0);
	return(CORBAEXPORT_bldrUseAxORB());
}

int isShlibLoaded_CORBA()
{
	return(CORBAExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_CORBA(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "bldrDeferredInvocationResult", NULL },
		{ "bldrDummyCallToLoadLibrary", NULL },
		{ "bldrExtAdditionalInfo", NULL },
		{ "bldrExtAppTerminated", NULL },
		{ "bldrExtCreateClassObj", NULL },
		{ "bldrExtCreateObject", NULL },
		{ "bldrExtDeleteObject", NULL },
		{ "bldrExtHelpOnAllMethods", NULL },
		{ "bldrExtHelpOnMethod", NULL },
		{ "bldrExtListOfObjects", NULL },
		{ "bldrExtMethodExists", NULL },
		{ "bldrExtObjMethodList", NULL },
		{ "bldrExtRegisterCallBack", NULL },
		{ "bldrExtSetInvocationMode", NULL },
		{ "bldrExtStructsAsFormats", NULL },
		{ "bldrGetInterfaceName", NULL },
		{ "bldrInvokeMethodOnExtObj", NULL },
		{ "bldrSetExtInheritance", NULL },
		{ "bldrUseAxORB", NULL },
		{ NULL,NULL }
	};

	if((CORBAExpFuncPtrTbl=AxLoadShlib(LIBID_CORBA,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,CORBAExpFuncPtrTbl);

	CORBAEXPORT_bldrDeferredInvocationResult = 
		(elfData  (*)(corbabase *control, elfData reqId, int *status, elfData addInfo)) impFuncTbl[0].fptr;
	CORBAEXPORT_bldrDummyCallToLoadLibrary = 
		(elfData  (*)(void)) impFuncTbl[1].fptr;
	CORBAEXPORT_bldrExtAdditionalInfo = 
		(elfData  (*)(elfData arg1, elfData addInfo)) impFuncTbl[2].fptr;
	CORBAEXPORT_bldrExtAppTerminated = 
		(void  (*)(bldrextobjectbase *extObj)) impFuncTbl[3].fptr;
	CORBAEXPORT_bldrExtCreateClassObj = 
		(void * (*)(elfData className, elfData classInfo, elfData addInfo, int *status)) impFuncTbl[4].fptr;
	CORBAEXPORT_bldrExtCreateObject = 
		(void * (*)(elfData objectName, bldrextobjectbase *elfClassObj, int *status, elfData addInfo)) impFuncTbl[5].fptr;
	CORBAEXPORT_bldrExtDeleteObject = 
		(void  (*)(bldrextobjectbase *obj)) impFuncTbl[6].fptr;
	CORBAEXPORT_bldrExtHelpOnAllMethods = 
		(elfData  (*)(elfData arg1)) impFuncTbl[7].fptr;
	CORBAEXPORT_bldrExtHelpOnMethod = 
		(elfData  (*)(bldrextobjectbase *extObj, elfData elfMethodName, elfData addInfo)) impFuncTbl[8].fptr;
	CORBAEXPORT_bldrExtListOfObjects = 
		(elfData  (*)(elfData hostName, elfData objName, elfData addInfo)) impFuncTbl[9].fptr;
	CORBAEXPORT_bldrExtMethodExists = 
		(int  (*)(bldrextobjectbase *extObj, char *methodName)) impFuncTbl[10].fptr;
	CORBAEXPORT_bldrExtObjMethodList = 
		(elfData  (*)(bldrextobjectbase *extObj, elfData addInfo)) impFuncTbl[11].fptr;
	CORBAEXPORT_bldrExtRegisterCallBack = 
		(void * (*)(int dex, int uid, bldrextobjectbase *obj)) impFuncTbl[12].fptr;
	CORBAEXPORT_bldrExtSetInvocationMode = 
		(void  (*)(corbabase *control, int mode, elfData addInfo)) impFuncTbl[13].fptr;
	CORBAEXPORT_bldrExtStructsAsFormats = 
		(elfData  (*)(bldrextobjectbase *extObj, elfData arg1, elfData addInfo)) impFuncTbl[14].fptr;
	CORBAEXPORT_bldrGetInterfaceName = 
		(elfData  (*)(elfData arg1, elfData arg2, int *status)) impFuncTbl[15].fptr;
	CORBAEXPORT_bldrInvokeMethodOnExtObj = 
		(elfData  (*)(bldrextobjectbase *extObj, char *methodName, elfData args, int *status)) impFuncTbl[16].fptr;
	CORBAEXPORT_bldrSetExtInheritance = 
		(void  (*)(bldrextobjectbase *obj, bldrextobjectbase *inheritFrom, elfData addInfo)) impFuncTbl[17].fptr;
	CORBAEXPORT_bldrUseAxORB = 
		(elfData  (*)(void)) impFuncTbl[18].fptr;

	AxElfInstallForShlib(LIBID_CORBA);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_CORBA()
{
	if(CORBAExpFuncPtrTbl != NULL)
		return;

	CORBAEXPORT_bldrDeferredInvocationResult = bldrDeferredInvocationResult;
	CORBAEXPORT_bldrDummyCallToLoadLibrary = bldrDummyCallToLoadLibrary;
	CORBAEXPORT_bldrExtAdditionalInfo = bldrExtAdditionalInfo;
	CORBAEXPORT_bldrExtAppTerminated = bldrExtAppTerminated;
	CORBAEXPORT_bldrExtCreateClassObj = bldrExtCreateClassObj;
	CORBAEXPORT_bldrExtCreateObject = bldrExtCreateObject;
	CORBAEXPORT_bldrExtDeleteObject = bldrExtDeleteObject;
	CORBAEXPORT_bldrExtHelpOnAllMethods = bldrExtHelpOnAllMethods;
	CORBAEXPORT_bldrExtHelpOnMethod = bldrExtHelpOnMethod;
	CORBAEXPORT_bldrExtListOfObjects = bldrExtListOfObjects;
	CORBAEXPORT_bldrExtMethodExists = bldrExtMethodExists;
	CORBAEXPORT_bldrExtObjMethodList = bldrExtObjMethodList;
	CORBAEXPORT_bldrExtRegisterCallBack = bldrExtRegisterCallBack;
	CORBAEXPORT_bldrExtSetInvocationMode = bldrExtSetInvocationMode;
	CORBAEXPORT_bldrExtStructsAsFormats = bldrExtStructsAsFormats;
	CORBAEXPORT_bldrGetInterfaceName = bldrGetInterfaceName;
	CORBAEXPORT_bldrInvokeMethodOnExtObj = bldrInvokeMethodOnExtObj;
	CORBAEXPORT_bldrSetExtInheritance = bldrSetExtInheritance;
	CORBAEXPORT_bldrUseAxORB = bldrUseAxORB;
}

/** Funcs Imported from prox
   ***********************************************************/

static ShlibFuncInfo* PROXExpFuncPtrTbl=NULL;

int  (*PROXEXPORT_Prox_Quflags)(void);

int  Prox_Quflags(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(0))
		return((int )0);
	return(PROXEXPORT_Prox_Quflags());
}

UCHAR * (*PROXEXPORT_Prox_Quinfo)(void);

UCHAR * Prox_Quinfo(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(1))
		return((UCHAR *)0);
	return(PROXEXPORT_Prox_Quinfo());
}

int  (*PROXEXPORT_Prox_Qulen)(void);

int  Prox_Qulen(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(2))
		return((int )0);
	return(PROXEXPORT_Prox_Qulen());
}

UCHAR * (*PROXEXPORT_Prox_Qulookup)(void);

UCHAR * Prox_Qulookup(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(3))
		return((UCHAR *)0);
	return(PROXEXPORT_Prox_Qulookup());
}

int  (*PROXEXPORT_Prox_Quwflags)(void);

int  Prox_Quwflags(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(4))
		return((int )0);
	return(PROXEXPORT_Prox_Quwflags());
}

int  (*PROXEXPORT_Prox_Quwlist)(void);

int  Prox_Quwlist(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(5))
		return((int )0);
	return(PROXEXPORT_Prox_Quwlist());
}

UCHAR * (*PROXEXPORT_Prox_Quword)(void);

UCHAR * Prox_Quword(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(6))
		return((UCHAR *)0);
	return(PROXEXPORT_Prox_Quword());
}

int  (*PROXEXPORT_clamadd)(UCHAR *word, int flags, CLAM *cp);

int  clamadd(UCHAR *word, int flags, CLAM *cp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(7))
		return((int )0);
	return(PROXEXPORT_clamadd(word,flags,cp));
}

int  (*PROXEXPORT_clamclose)(CLAM *cp);

int  clamclose(CLAM *cp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(8))
		return((int )0);
	return(PROXEXPORT_clamclose(cp));
}

int  (*PROXEXPORT_clamlanguage)(char *fname);

int  clamlanguage(char *fname)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(9))
		return((int )0);
	return(PROXEXPORT_clamlanguage(fname));
}

int  (*PROXEXPORT_clamnext)(UCHAR *buffer0, int *flagsptr, int init, CLAM *cp);

int  clamnext(UCHAR *buffer0, int *flagsptr, int init, CLAM *cp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(10))
		return((int )0);
	return(PROXEXPORT_clamnext(buffer0,flagsptr,init,cp));
}

CLAM * (*PROXEXPORT_clamopen)(int idcode, int flags, char *fname);

CLAM * clamopen(int idcode, int flags, char *fname)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(11))
		return((CLAM *)0);
	return(PROXEXPORT_clamopen(idcode,flags,fname));
}

int  (*PROXEXPORT_clampair)(UCHAR *misp, UCHAR *corr, CLAM *cp);

int  clampair(UCHAR *misp, UCHAR *corr, CLAM *cp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(12))
		return((int )0);
	return(PROXEXPORT_clampair(misp,corr,cp));
}

VOID  (*PROXEXPORT_clxclose)(CORELEX *clxp);

VOID  clxclose(CORELEX *clxp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(13))
		return;
	PROXEXPORT_clxclose(clxp);
}

VOID  (*PROXEXPORT_clxfree)(CORELEX *clex);

VOID  clxfree(CORELEX *clex)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(14))
		return;
	PROXEXPORT_clxfree(clex);
}

CORELEX * (*PROXEXPORT_clxopen)(int idcode, int flags, CORELEX *clxp);

CORELEX * clxopen(int idcode, int flags, CORELEX *clxp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(15))
		return((CORELEX *)0);
	return(PROXEXPORT_clxopen(idcode,flags,clxp));
}

CORELEX * (*PROXEXPORT_clxread)(char *name, int env, unsigned offset, COREHEAD *hp);

CORELEX * clxread(char *name, int env, unsigned offset, COREHEAD *hp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(16))
		return((CORELEX *)0);
	return(PROXEXPORT_clxread(name,env,offset,hp));
}

UCHAR ** (*PROXEXPORT_correct)(UCHAR *query);

UCHAR ** correct(UCHAR *query)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(17))
		return((UCHAR **)0);
	return(PROXEXPORT_correct(query));
}

VOID  (*PROXEXPORT_cshclose)(CACHE *cshptr);

VOID  cshclose(CACHE *cshptr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(18))
		return;
	PROXEXPORT_cshclose(cshptr);
}

CACHE * (*PROXEXPORT_cshopen)(int idcode, int flags, unsigned size, int mode);

CACHE * cshopen(int idcode, int flags, unsigned size, int mode)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(19))
		return((CACHE *)0);
	return(PROXEXPORT_cshopen(idcode,flags,size,mode));
}

int  (*PROXEXPORT_doflags)(UCHAR *word0, UCHAR *outword, int maxlen);

int  doflags(UCHAR *word0, UCHAR *outword, int maxlen)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(20))
		return((int )0);
	return(PROXEXPORT_doflags(word0,outword,maxlen));
}

VOID  (*PROXEXPORT_envclose)(int env);

VOID  envclose(int env)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(21))
		return;
	PROXEXPORT_envclose(env);
}

int  (*PROXEXPORT_envread)(char *name, int env, unsigned offset);

int  envread(char *name, int env, unsigned offset)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(22))
		return((int )0);
	return(PROXEXPORT_envread(name,env,offset));
}

int  (*PROXEXPORT_getsclang)(void);

int  getsclang(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(23))
		return((int )0);
	return(PROXEXPORT_getsclang());
}

int  (*PROXEXPORT_hycalc)(UCHAR *word, UCHAR *hystr);

int  hycalc(UCHAR *word, UCHAR *hystr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(24))
		return((int )0);
	return(PROXEXPORT_hycalc(word,hystr));
}

VOID  (*PROXEXPORT_hyclose)(void);

VOID  hyclose(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(25))
		return;
	PROXEXPORT_hyclose();
}

int  (*PROXEXPORT_hyread)(char *name, unsigned offset, int mode);

int  hyread(char *name, unsigned offset, int mode)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(26))
		return((int )0);
	return(PROXEXPORT_hyread(name,offset,mode));
}

int  (*PROXEXPORT_isword)(UCHAR *word);

int  isword(UCHAR *word)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(27))
		return((int )0);
	return(PROXEXPORT_isword(word));
}

LEX * (*PROXEXPORT_lexalloc)(char *fname, unsigned offset);

LEX * lexalloc(char *fname, unsigned offset)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(28))
		return((LEX *)0);
	return(PROXEXPORT_lexalloc(fname,offset));
}

VOID  (*PROXEXPORT_lexclose)(LEX *lexptr);

VOID  lexclose(LEX *lexptr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(29))
		return;
	PROXEXPORT_lexclose(lexptr);
}

VOID  (*PROXEXPORT_lexfree)(LEX *lp);

VOID  lexfree(LEX *lp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(30))
		return;
	PROXEXPORT_lexfree(lp);
}

LEX * (*PROXEXPORT_lexopen)(int idcode, int flags, char *fname, unsigned offset);

LEX * lexopen(int idcode, int flags, char *fname, unsigned offset)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(31))
		return((LEX *)0);
	return(PROXEXPORT_lexopen(idcode,flags,fname,offset));
}

int  (*PROXEXPORT_memfree)(void);

int  memfree(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(32))
		return((int )0);
	return(PROXEXPORT_memfree());
}

int  (*PROXEXPORT_phonclose)(int env);

int  phonclose(int env)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(33))
		return((int )0);
	return(PROXEXPORT_phonclose(env));
}

int  (*PROXEXPORT_phonread)(char *name, int env, unsigned offset);

int  phonread(char *name, int env, unsigned offset)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(34))
		return((int )0);
	return(PROXEXPORT_phonread(name,env,offset));
}

char * (*PROXEXPORT_prx_langprf)(int langcode);

char * prx_langprf(int langcode)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(35))
		return((char *)0);
	return(PROXEXPORT_prx_langprf(langcode));
}

int  (*PROXEXPORT_pub_MAXEXP)(void);

int  pub_MAXEXP(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(36))
		return((int )0);
	return(PROXEXPORT_pub_MAXEXP());
}

int  (*PROXEXPORT_pub_cl_rdonly)(void *clamptr);

int  pub_cl_rdonly(void *clamptr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(37))
		return((int )0);
	return(PROXEXPORT_pub_cl_rdonly(clamptr));
}

TOKEN * (*PROXEXPORT_pub_token)(void);

TOKEN * pub_token(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(38))
		return((TOKEN *)0);
	return(PROXEXPORT_pub_token());
}

int  (*PROXEXPORT_pub_tokepos)(TOKEN *tp);

int  pub_tokepos(TOKEN *tp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(39))
		return((int )0);
	return(PROXEXPORT_pub_tokepos(tp));
}

int  (*PROXEXPORT_pub_tokspos)(TOKEN *tp);

int  pub_tokspos(TOKEN *tp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(40))
		return((int )0);
	return(PROXEXPORT_pub_tokspos(tp));
}

VOID  (*PROXEXPORT_setcpdcorr)(int langcode, int bool);

VOID  setcpdcorr(int langcode, int bool)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(41))
		return;
	PROXEXPORT_setcpdcorr(langcode,bool);
}

int  (*PROXEXPORT_setlanguage)(int langcode);

int  setlanguage(int langcode)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(42))
		return((int )0);
	return(PROXEXPORT_setlanguage(langcode));
}

int  (*PROXEXPORT_setths)(int langcode);

int  setths(int langcode)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(43))
		return((int )0);
	return(PROXEXPORT_setths(langcode));
}

VOID  (*PROXEXPORT_thesclose)(void);

VOID  thesclose(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(44))
		return;
	PROXEXPORT_thesclose();
}

VOID  (*PROXEXPORT_thescntrl)(long control);

VOID  thescntrl(long control)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(45))
		return;
	PROXEXPORT_thescntrl(control);
}

char * (*PROXEXPORT_thesinfo)(int meanno, UCHAR ***lists);

char * thesinfo(int meanno, UCHAR ***lists)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(46))
		return((char *)0);
	return(PROXEXPORT_thesinfo(meanno,lists));
}

int  (*PROXEXPORT_thesopen)(LEX *lexptr);

int  thesopen(LEX *lexptr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(47))
		return((int )0);
	return(PROXEXPORT_thesopen(lexptr));
}

int  (*PROXEXPORT_thesword)(UCHAR *query, int start, int meanreq, UCHAR **defs);

int  thesword(UCHAR *query, int start, int meanreq, UCHAR **defs)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(48))
		return((int )0);
	return(PROXEXPORT_thesword(query,start,meanreq,defs));
}

USHORT  (*PROXEXPORT_thstatus)(void);

USHORT  thstatus(void)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(49))
		return((USHORT )0);
	return(PROXEXPORT_thstatus());
}

int  (*PROXEXPORT_tokdesc)(TOKEN *tp);

int  tokdesc(TOKEN *tp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(50))
		return((int )0);
	return(PROXEXPORT_tokdesc(tp));
}

int  (*PROXEXPORT_tokinit)(TOKEN *tokptr, int state);

int  tokinit(TOKEN *tokptr, int state)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(51))
		return((int )0);
	return(PROXEXPORT_tokinit(tokptr,state));
}

int  (*PROXEXPORT_tokmake)(int cc, int len, TOKEN *tp);

int  tokmake(int cc, int len, TOKEN *tp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(52))
		return((int )0);
	return(PROXEXPORT_tokmake(cc,len,tp));
}

VOID  (*PROXEXPORT_tokskip)(TOKEN *tp);

VOID  tokskip(TOKEN *tp)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(53))
		return;
	PROXEXPORT_tokskip(tp);
}

VOID  (*PROXEXPORT_undoflags)(UCHAR *word, int flags, UCHAR *outword);

VOID  undoflags(UCHAR *word, int flags, UCHAR *outword)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(54))
		return;
	PROXEXPORT_undoflags(word,flags,outword);
}

int  (*PROXEXPORT_vhyrank)(UCHAR *str, UCHAR *hystr);

int  vhyrank(UCHAR *str, UCHAR *hystr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(55))
		return((int )0);
	return(PROXEXPORT_vhyrank(str,hystr));
}

int  (*PROXEXPORT_vhyword)(UCHAR *word, UCHAR *hystr);

int  vhyword(UCHAR *word, UCHAR *hystr)
{
	if(PROXExpFuncPtrTbl==NULL && !SHLoadAndSnap_PROX(56))
		return((int )0);
	return(PROXEXPORT_vhyword(word,hystr));
}

int isShlibLoaded_PROX()
{
	return(PROXExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_PROX(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "Prox_Quflags", NULL },
		{ "Prox_Quinfo", NULL },
		{ "Prox_Qulen", NULL },
		{ "Prox_Qulookup", NULL },
		{ "Prox_Quwflags", NULL },
		{ "Prox_Quwlist", NULL },
		{ "Prox_Quword", NULL },
		{ "clamadd", NULL },
		{ "clamclose", NULL },
		{ "clamlanguage", NULL },
		{ "clamnext", NULL },
		{ "clamopen", NULL },
		{ "clampair", NULL },
		{ "clxclose", NULL },
		{ "clxfree", NULL },
		{ "clxopen", NULL },
		{ "clxread", NULL },
		{ "correct", NULL },
		{ "cshclose", NULL },
		{ "cshopen", NULL },
		{ "doflags", NULL },
		{ "envclose", NULL },
		{ "envread", NULL },
		{ "getsclang", NULL },
		{ "hycalc", NULL },
		{ "hyclose", NULL },
		{ "hyread", NULL },
		{ "isword", NULL },
		{ "lexalloc", NULL },
		{ "lexclose", NULL },
		{ "lexfree", NULL },
		{ "lexopen", NULL },
		{ "memfree", NULL },
		{ "phonclose", NULL },
		{ "phonread", NULL },
		{ "prx_langprf", NULL },
		{ "pub_MAXEXP", NULL },
		{ "pub_cl_rdonly", NULL },
		{ "pub_token", NULL },
		{ "pub_tokepos", NULL },
		{ "pub_tokspos", NULL },
		{ "setcpdcorr", NULL },
		{ "setlanguage", NULL },
		{ "setths", NULL },
		{ "thesclose", NULL },
		{ "thescntrl", NULL },
		{ "thesinfo", NULL },
		{ "thesopen", NULL },
		{ "thesword", NULL },
		{ "thstatus", NULL },
		{ "tokdesc", NULL },
		{ "tokinit", NULL },
		{ "tokmake", NULL },
		{ "tokskip", NULL },
		{ "undoflags", NULL },
		{ "vhyrank", NULL },
		{ "vhyword", NULL },
		{ NULL,NULL }
	};

	if((PROXExpFuncPtrTbl=AxLoadShlib(LIBID_PROX,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,PROXExpFuncPtrTbl);

	PROXEXPORT_Prox_Quflags = 
		(int  (*)(void)) impFuncTbl[0].fptr;
	PROXEXPORT_Prox_Quinfo = 
		(UCHAR * (*)(void)) impFuncTbl[1].fptr;
	PROXEXPORT_Prox_Qulen = 
		(int  (*)(void)) impFuncTbl[2].fptr;
	PROXEXPORT_Prox_Qulookup = 
		(UCHAR * (*)(void)) impFuncTbl[3].fptr;
	PROXEXPORT_Prox_Quwflags = 
		(int  (*)(void)) impFuncTbl[4].fptr;
	PROXEXPORT_Prox_Quwlist = 
		(int  (*)(void)) impFuncTbl[5].fptr;
	PROXEXPORT_Prox_Quword = 
		(UCHAR * (*)(void)) impFuncTbl[6].fptr;
	PROXEXPORT_clamadd = 
		(int  (*)(UCHAR *word, int flags, CLAM *cp)) impFuncTbl[7].fptr;
	PROXEXPORT_clamclose = 
		(int  (*)(CLAM *cp)) impFuncTbl[8].fptr;
	PROXEXPORT_clamlanguage = 
		(int  (*)(char *fname)) impFuncTbl[9].fptr;
	PROXEXPORT_clamnext = 
		(int  (*)(UCHAR *buffer0, int *flagsptr, int init, CLAM *cp)) impFuncTbl[10].fptr;
	PROXEXPORT_clamopen = 
		(CLAM * (*)(int idcode, int flags, char *fname)) impFuncTbl[11].fptr;
	PROXEXPORT_clampair = 
		(int  (*)(UCHAR *misp, UCHAR *corr, CLAM *cp)) impFuncTbl[12].fptr;
	PROXEXPORT_clxclose = 
		(VOID  (*)(CORELEX *clxp)) impFuncTbl[13].fptr;
	PROXEXPORT_clxfree = 
		(VOID  (*)(CORELEX *clex)) impFuncTbl[14].fptr;
	PROXEXPORT_clxopen = 
		(CORELEX * (*)(int idcode, int flags, CORELEX *clxp)) impFuncTbl[15].fptr;
	PROXEXPORT_clxread = 
		(CORELEX * (*)(char *name, int env, unsigned offset, COREHEAD *hp)) impFuncTbl[16].fptr;
	PROXEXPORT_correct = 
		(UCHAR ** (*)(UCHAR *query)) impFuncTbl[17].fptr;
	PROXEXPORT_cshclose = 
		(VOID  (*)(CACHE *cshptr)) impFuncTbl[18].fptr;
	PROXEXPORT_cshopen = 
		(CACHE * (*)(int idcode, int flags, unsigned size, int mode)) impFuncTbl[19].fptr;
	PROXEXPORT_doflags = 
		(int  (*)(UCHAR *word0, UCHAR *outword, int maxlen)) impFuncTbl[20].fptr;
	PROXEXPORT_envclose = 
		(VOID  (*)(int env)) impFuncTbl[21].fptr;
	PROXEXPORT_envread = 
		(int  (*)(char *name, int env, unsigned offset)) impFuncTbl[22].fptr;
	PROXEXPORT_getsclang = 
		(int  (*)(void)) impFuncTbl[23].fptr;
	PROXEXPORT_hycalc = 
		(int  (*)(UCHAR *word, UCHAR *hystr)) impFuncTbl[24].fptr;
	PROXEXPORT_hyclose = 
		(VOID  (*)(void)) impFuncTbl[25].fptr;
	PROXEXPORT_hyread = 
		(int  (*)(char *name, unsigned offset, int mode)) impFuncTbl[26].fptr;
	PROXEXPORT_isword = 
		(int  (*)(UCHAR *word)) impFuncTbl[27].fptr;
	PROXEXPORT_lexalloc = 
		(LEX * (*)(char *fname, unsigned offset)) impFuncTbl[28].fptr;
	PROXEXPORT_lexclose = 
		(VOID  (*)(LEX *lexptr)) impFuncTbl[29].fptr;
	PROXEXPORT_lexfree = 
		(VOID  (*)(LEX *lp)) impFuncTbl[30].fptr;
	PROXEXPORT_lexopen = 
		(LEX * (*)(int idcode, int flags, char *fname, unsigned offset)) impFuncTbl[31].fptr;
	PROXEXPORT_memfree = 
		(int  (*)(void)) impFuncTbl[32].fptr;
	PROXEXPORT_phonclose = 
		(int  (*)(int env)) impFuncTbl[33].fptr;
	PROXEXPORT_phonread = 
		(int  (*)(char *name, int env, unsigned offset)) impFuncTbl[34].fptr;
	PROXEXPORT_prx_langprf = 
		(char * (*)(int langcode)) impFuncTbl[35].fptr;
	PROXEXPORT_pub_MAXEXP = 
		(int  (*)(void)) impFuncTbl[36].fptr;
	PROXEXPORT_pub_cl_rdonly = 
		(int  (*)(void *clamptr)) impFuncTbl[37].fptr;
	PROXEXPORT_pub_token = 
		(TOKEN * (*)(void)) impFuncTbl[38].fptr;
	PROXEXPORT_pub_tokepos = 
		(int  (*)(TOKEN *tp)) impFuncTbl[39].fptr;
	PROXEXPORT_pub_tokspos = 
		(int  (*)(TOKEN *tp)) impFuncTbl[40].fptr;
	PROXEXPORT_setcpdcorr = 
		(VOID  (*)(int langcode, int bool)) impFuncTbl[41].fptr;
	PROXEXPORT_setlanguage = 
		(int  (*)(int langcode)) impFuncTbl[42].fptr;
	PROXEXPORT_setths = 
		(int  (*)(int langcode)) impFuncTbl[43].fptr;
	PROXEXPORT_thesclose = 
		(VOID  (*)(void)) impFuncTbl[44].fptr;
	PROXEXPORT_thescntrl = 
		(VOID  (*)(long control)) impFuncTbl[45].fptr;
	PROXEXPORT_thesinfo = 
		(char * (*)(int meanno, UCHAR ***lists)) impFuncTbl[46].fptr;
	PROXEXPORT_thesopen = 
		(int  (*)(LEX *lexptr)) impFuncTbl[47].fptr;
	PROXEXPORT_thesword = 
		(int  (*)(UCHAR *query, int start, int meanreq, UCHAR **defs)) impFuncTbl[48].fptr;
	PROXEXPORT_thstatus = 
		(USHORT  (*)(void)) impFuncTbl[49].fptr;
	PROXEXPORT_tokdesc = 
		(int  (*)(TOKEN *tp)) impFuncTbl[50].fptr;
	PROXEXPORT_tokinit = 
		(int  (*)(TOKEN *tokptr, int state)) impFuncTbl[51].fptr;
	PROXEXPORT_tokmake = 
		(int  (*)(int cc, int len, TOKEN *tp)) impFuncTbl[52].fptr;
	PROXEXPORT_tokskip = 
		(VOID  (*)(TOKEN *tp)) impFuncTbl[53].fptr;
	PROXEXPORT_undoflags = 
		(VOID  (*)(UCHAR *word, int flags, UCHAR *outword)) impFuncTbl[54].fptr;
	PROXEXPORT_vhyrank = 
		(int  (*)(UCHAR *str, UCHAR *hystr)) impFuncTbl[55].fptr;
	PROXEXPORT_vhyword = 
		(int  (*)(UCHAR *word, UCHAR *hystr)) impFuncTbl[56].fptr;

	AxElfInstallForShlib(LIBID_PROX);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_PROX()
{
	if(PROXExpFuncPtrTbl != NULL)
		return;

	PROXEXPORT_Prox_Quflags = Prox_Quflags;
	PROXEXPORT_Prox_Quinfo = Prox_Quinfo;
	PROXEXPORT_Prox_Qulen = Prox_Qulen;
	PROXEXPORT_Prox_Qulookup = Prox_Qulookup;
	PROXEXPORT_Prox_Quwflags = Prox_Quwflags;
	PROXEXPORT_Prox_Quwlist = Prox_Quwlist;
	PROXEXPORT_Prox_Quword = Prox_Quword;
	PROXEXPORT_clamadd = clamadd;
	PROXEXPORT_clamclose = clamclose;
	PROXEXPORT_clamlanguage = clamlanguage;
	PROXEXPORT_clamnext = clamnext;
	PROXEXPORT_clamopen = clamopen;
	PROXEXPORT_clampair = clampair;
	PROXEXPORT_clxclose = clxclose;
	PROXEXPORT_clxfree = clxfree;
	PROXEXPORT_clxopen = clxopen;
	PROXEXPORT_clxread = clxread;
	PROXEXPORT_correct = correct;
	PROXEXPORT_cshclose = cshclose;
	PROXEXPORT_cshopen = cshopen;
	PROXEXPORT_doflags = doflags;
	PROXEXPORT_envclose = envclose;
	PROXEXPORT_envread = envread;
	PROXEXPORT_getsclang = getsclang;
	PROXEXPORT_hycalc = hycalc;
	PROXEXPORT_hyclose = hyclose;
	PROXEXPORT_hyread = hyread;
	PROXEXPORT_isword = isword;
	PROXEXPORT_lexalloc = lexalloc;
	PROXEXPORT_lexclose = lexclose;
	PROXEXPORT_lexfree = lexfree;
	PROXEXPORT_lexopen = lexopen;
	PROXEXPORT_memfree = memfree;
	PROXEXPORT_phonclose = phonclose;
	PROXEXPORT_phonread = phonread;
	PROXEXPORT_prx_langprf = prx_langprf;
	PROXEXPORT_pub_MAXEXP = pub_MAXEXP;
	PROXEXPORT_pub_cl_rdonly = pub_cl_rdonly;
	PROXEXPORT_pub_token = pub_token;
	PROXEXPORT_pub_tokepos = pub_tokepos;
	PROXEXPORT_pub_tokspos = pub_tokspos;
	PROXEXPORT_setcpdcorr = setcpdcorr;
	PROXEXPORT_setlanguage = setlanguage;
	PROXEXPORT_setths = setths;
	PROXEXPORT_thesclose = thesclose;
	PROXEXPORT_thescntrl = thescntrl;
	PROXEXPORT_thesinfo = thesinfo;
	PROXEXPORT_thesopen = thesopen;
	PROXEXPORT_thesword = thesword;
	PROXEXPORT_thstatus = thstatus;
	PROXEXPORT_tokdesc = tokdesc;
	PROXEXPORT_tokinit = tokinit;
	PROXEXPORT_tokmake = tokmake;
	PROXEXPORT_tokskip = tokskip;
	PROXEXPORT_undoflags = undoflags;
	PROXEXPORT_vhyrank = vhyrank;
	PROXEXPORT_vhyword = vhyword;
}

/** Funcs Imported from axtm1
   ***********************************************************/

static ShlibFuncInfo* TM1ExpFuncPtrTbl=NULL;

elfData  (*TM1EXPORT_RtTm1Funcs)(elfData funcData);

elfData  RtTm1Funcs(elfData funcData)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(0))
		return((elfData )0);
	return(TM1EXPORT_RtTm1Funcs(funcData));
}

int  (*TM1EXPORT_TM1ElfInstall)(void);

int  TM1ElfInstall(void)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(1))
		return((int )0);
	return(TM1EXPORT_TM1ElfInstall());
}

int  (*TM1EXPORT_vio_access)(char *name, int mode);

int  vio_access(char *name, int mode)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(2))
		return((int )0);
	return(TM1EXPORT_vio_access(name,mode));
}

int  (*TM1EXPORT_vio_do_rename)(char *oldname, char *newname);

int  vio_do_rename(char *oldname, char *newname)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(3))
		return((int )0);
	return(TM1EXPORT_vio_do_rename(oldname,newname));
}

int  (*TM1EXPORT_vio_fclose)(int fd);

int  vio_fclose(int fd)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(4))
		return((int )0);
	return(TM1EXPORT_vio_fclose(fd));
}

int  (*TM1EXPORT_vio_fopen)(char *file, char *modestr);

int  vio_fopen(char *file, char *modestr)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(5))
		return((int )0);
	return(TM1EXPORT_vio_fopen(file,modestr));
}

char * (*TM1EXPORT_vio_gets)(char *buf, int bufsiz, int fd);

char * vio_gets(char *buf, int bufsiz, int fd)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(6))
		return((char *)0);
	return(TM1EXPORT_vio_gets(buf,bufsiz,fd));
}

char ** (*TM1EXPORT_vio_listfiles)(char *dirname);

char ** vio_listfiles(char *dirname)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(7))
		return((char **)0);
	return(TM1EXPORT_vio_listfiles(dirname));
}

void  (*TM1EXPORT_vio_listfilesfreer)(char **files);

void  vio_listfilesfreer(char **files)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(8))
		return;
	TM1EXPORT_vio_listfilesfreer(files);
}

int  (*TM1EXPORT_vio_puts)(char *buf, int fd);

int  vio_puts(char *buf, int fd)
{
	if(TM1ExpFuncPtrTbl==NULL && !SHLoadAndSnap_TM1(9))
		return((int )0);
	return(TM1EXPORT_vio_puts(buf,fd));
}

int isShlibLoaded_TM1()
{
	return(TM1ExpFuncPtrTbl!=NULL);
}

int SHLoadAndSnap_TM1(int call_idx)
{
	static ShlibFuncInfo impFuncTbl[] = {
		{ "RtTm1Funcs", NULL },
		{ "TM1ElfInstall", NULL },
		{ "vio_access", NULL },
		{ "vio_do_rename", NULL },
		{ "vio_fclose", NULL },
		{ "vio_fopen", NULL },
		{ "vio_gets", NULL },
		{ "vio_listfiles", NULL },
		{ "vio_listfilesfreer", NULL },
		{ "vio_puts", NULL },
		{ NULL,NULL }
	};

	if((TM1ExpFuncPtrTbl=AxLoadShlib(LIBID_TM1,impFuncTbl[call_idx].fname)) == NULL)
		return(FALSE);

	AxBindShlibImportFuncs(impFuncTbl,TM1ExpFuncPtrTbl);

	TM1EXPORT_RtTm1Funcs = 
		(elfData  (*)(elfData funcData)) impFuncTbl[0].fptr;
	TM1EXPORT_TM1ElfInstall = 
		(int  (*)(void)) impFuncTbl[1].fptr;
	TM1EXPORT_vio_access = 
		(int  (*)(char *name, int mode)) impFuncTbl[2].fptr;
	TM1EXPORT_vio_do_rename = 
		(int  (*)(char *oldname, char *newname)) impFuncTbl[3].fptr;
	TM1EXPORT_vio_fclose = 
		(int  (*)(int fd)) impFuncTbl[4].fptr;
	TM1EXPORT_vio_fopen = 
		(int  (*)(char *file, char *modestr)) impFuncTbl[5].fptr;
	TM1EXPORT_vio_gets = 
		(char * (*)(char *buf, int bufsiz, int fd)) impFuncTbl[6].fptr;
	TM1EXPORT_vio_listfiles = 
		(char ** (*)(char *dirname)) impFuncTbl[7].fptr;
	TM1EXPORT_vio_listfilesfreer = 
		(void  (*)(char **files)) impFuncTbl[8].fptr;
	TM1EXPORT_vio_puts = 
		(int  (*)(char *buf, int fd)) impFuncTbl[9].fptr;

	AxElfInstallForShlib(LIBID_TM1);
	return(TRUE);
}

static void InitShlibImportFuncPtrs_TM1()
{
	if(TM1ExpFuncPtrTbl != NULL)
		return;

	TM1EXPORT_RtTm1Funcs = RtTm1Funcs;
	TM1EXPORT_TM1ElfInstall = TM1ElfInstall;
	TM1EXPORT_vio_access = vio_access;
	TM1EXPORT_vio_do_rename = vio_do_rename;
	TM1EXPORT_vio_fclose = vio_fclose;
	TM1EXPORT_vio_fopen = vio_fopen;
	TM1EXPORT_vio_gets = vio_gets;
	TM1EXPORT_vio_listfiles = vio_listfiles;
	TM1EXPORT_vio_listfilesfreer = vio_listfilesfreer;
	TM1EXPORT_vio_puts = vio_puts;
}

void InitShlibImportFuncPtrs()
{
	InitShlibImportFuncPtrs_EL();
	InitShlibImportFuncPtrs_DB();
	InitShlibImportFuncPtrs_GE();
	InitShlibImportFuncPtrs_SS();
	InitShlibImportFuncPtrs_WP();
	InitShlibImportFuncPtrs_MAIL();
	InitShlibImportFuncPtrs_OM();
	InitShlibImportFuncPtrs_RT();
	InitShlibImportFuncPtrs_LM();
	InitShlibImportFuncPtrs_CORBA();
	InitShlibImportFuncPtrs_PROX();
	InitShlibImportFuncPtrs_TM1();
}

