/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: odbcclass.h
   Applix ASC version: 3
   Date: Mon Nov 16 14:25:15 1998
*/
/* STRIP LINES THROUGH HERE */




'Connection Specification
format cnx$ 'sqlX
	vendor,
	gateway,
	host,
	gatewayPid,
	server,
	database,
	username,
	password,
	format sql_channel@ channel,
	isTransactionless,
	isInformixNonAnsi,
    transactionState, /* EDIT#OFF, EDIT#TRANSACTION, EDIT#TRANSACTIONLESS */
	format sql_cursor_properties@ cursor_props

'SQL Query Specification
format qry$
	stmtId, /* prepared statement id */
	sql, /* sql text */
	format sql_description@ desc,	/* results description */
	editable /* true is data set results are editable */


'Cursor Control
format crs$ 'sqlC
	cursId, /* open cursor id */
	forEditing, /* open for editing */
	lockWhenChanged, /* "lock" row in dbms when row is changed */
	currentRow, /* row index, or null */
	activeTableX, /* index of table being processed */
	fetchSize, /* count of rows to fetch at a time */
	allRowsFetched, /* indicates all rows fetched */
    currentRowWhereClause,
	format arrayof crs_row$ rows

format crs_row$
    format arrayof crs_col$ cols,
	updateStatus,
define ROW_UNCHANGED 0
define ROW_INSERTED 1
define ROW_CHANGED 2
define ROW_DELETED 3
define ROW_UNDEFINED 4 '!!!!!! WHAT IS THIS FOR?
	editApplied, /* true if edit has been applied */
	locked		/* true if row is "locked" */
 
format crs_col$
    value,
    newValue,
    changed 'TRUE or FALSE
 
' Currently specific to ODBC
format crs_concurrency$
	read_only,		' no updates possible
	lock,			' supports lowest level of locking
	rowver,			' optimistic row locking using row versions
	values			' optimistic row locking using row values

format crs_lock_types$
	no_change,		' used in SQLSetPos to specify lock type
	xlock,
	unlock

