/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ax400.h
   Applix ASC version: 42
   Date: Tue Feb  2 15:21:12 1999
*/
/* STRIP LINES THROUGH HERE */

' OpenMail generic file stuff

define X400_stub    "ax400"
define X400_sock    300178

define OM#CLIENT_1		0
define OM#CLIENT_2		1

define OM_MSG_BODY#NAME			"Message_Body"
define OM_OMSG_BODY#NAME		"Original_Message"

define OM_OBJECT_NAME			".axobjfile"

define MSG_WIDTH_DEFAULT		1000

define OM_TO_APP		0
define APP_TO_OM		1

'
' OM error numbers
'

define ERR_TOO_MANY_LISTS	556
define ERR_BAD_ITEM_REF		557
define ERR_NO_FILE			565
define ERR_ACCESS_CAPS		574
define ERR_NOT_DESIG		575
define ERR_INCOMPATIBLE		601
define ERR_UI_DISABLED		602
define ERR_NAME_BAD_CHAR	650
define ERR_NAME_NOT_KNOWN	653
define ERR_BAD_PASSWORD		655
define ERR_PASSWORD_REQD	656
define ERR_SIGNED_ON		658
define ERR_BAD_OLD_PASSWD	1751
define ERR_NO_OLD_PASSWD	1752
define ERR_BAD_OBJ_INDEX	1801
define ERR_NO_OBJ_FILE		1802
define ERR_BAD_OBJ_FILE		1803
define ERR_OBJ_FILE			1804
define ERR_DESIG_NO_PWD		1905
define ERR_MSG_MAILED		2155
define ERR_CANT_DELETE_WB	2702
define ERR_BAD_FILE_NO		4201
define ERR_NO_SUCH_FILE		4202
define ERR_DIR_ERROR		4500
define ERR_DIR_NO_PERM		4501
define ERR_NO_DIR			4505
define ERR_DIR_BAD_PASSWD   4506
define ERR_DIR_PASSWD_REQD  4507
define ERR_DIRENT_LIMIT		4521
define ERR_DIRENT_TIMEOUT	4522
define ERR_DIR_SERIAL_REQD  4537
define ERR_RESTRICTED		5000
define ERR_FATAL			5003

define EXPORT_DELENV       0x0004
define EXPORT_ATTRIBS      0x0040


'
' filter types, attribute id's, AutoAction types
'

'
' Transaction File Record Types
'

define 		TFR_FILTER_NUM				46020
define 		TFR_FILTER_DATE				46030
define 		TFR_FILTER_NAME				46040
define 		TFR_FILTER_STRING			46050

'
' Filter Types
'

define		AA_FILTER_NUM				0
define		AA_FILTER_DATE				1
define		AA_FILTER_NAME				2
define		AA_FILTER_STRING			3

'
' AutoAction Options
'

define		AA_TYPE_SIMPLE_FORWARD 		0
define		AA_TYPE_REDIRECT			1
define		AA_TYPE_SIMPLE_REPLY		2
define		AA_TYPE_FILE				3
define		AA_TYPE_NOTIFY				4
define		AA_TYPE_PRINT				5
define		AA_TYPE_DELETE				6

'
' Filter Attribute ID's
'

define		ATT_ID_MSGTYPE				 1
define		ATT_ID_SUBJECT				 2
define		ATT_ID_SENDER 				 3
define		ATT_ID_PRIORITY				 4
define		ATT_ID_IMPORTANCE			 5
define		ATT_ID_SENSITIVITY			 6
define		ATT_ID_CREATEDATE			 7
define		ATT_ID_EXPIRYDATE			 8
define		ATT_ID_DELIVERYDATE			 9
define		ATT_ID_PRESENTDATE			10
define		ATT_ID_ENTRYSTATUS			11
define		ATT_ID_REQACKS				12


'
' Filter Test Types
'

define	TFV_ATT_PRESENT			0		' attribute present
define	TFV_ATT_EQUAL			1		' attribute equal to
define	TFV_ATT_LESS_THAN		2		' attribute less than
define	TFV_ATT_LT_EQUAL		3		' attribute less than or equal
define	TFV_ATT_GREAT_THAN		4		' attribute greater than
define	TFV_ATT_GT_EQUAL		5		' attribute greater than or equal

'
' Filter Group Operations
'

define TFV_AND_GROUP			0		' AND filter groups
define TFV_OR_GROUP				1		' OR filter groups

'
' Requested ACK levels
'

define	ACK_NONE			0
define	ACK_NONDEL			3
define	ACK_DELIVER			4
define	ACK_AUTOFWD			5
define	ACK_DELETE			6
define		ACK_DEL_USER		0		' sub acks
define		ACK_DEL_EXPIRED		1
define		ACK_DEL_OBSOLETE	2
define		ACK_DEL_RETRIEVE	3
define		ACK_DEL_SUBSTERM	4
define	ACK_RECEIPT			7
define	ACK_READ			7
define	ACK_AUTOREPLY		8
define	ACK_REPLY			9

'
' query flag word values
'

define QRY#P_NORMAL			0x01
define QRY#NON_URGENT		0x02
define QRY#URGENT			0x04

define QRY#S_NORMAL			0x01
define QRY#PERSONAL			0x02
define QRY#PRIVATE			0x04
define QRY#CONFIDENTIAL		0x08

define QRY#I_NORMAL			0x01
define QRY#LOW				0x02
define QRY#HIGH				0x04


define QRY#TO_RECIP			0x01
define QRY#CC_RECIP			0x02
define QRY#BC_RECIP			0x04


'
' query integer values
'

define QRY#SUBJECT			0
define QRY#SENDER			1
define QRY#MESSAGE			2
define QRY#DATE_SENT		3
define QRY#DATE_RCVD		4

define QRY#ALL_DATES_		0
define QRY#YESTERDAY_		1
define QRY#TODAY_			2
define QRY#DATE_RANGE_		3


'
' integer values used in user-callable macros
'

define OM_PRIORITY#NORMAL			0
define OM_PRIORITY#NON_URGENT		1
define OM_PRIORITY#URGENT			2

define OM_IMPORTANCE#NORMAL			0
define OM_IMPORTANCE#LOW			1
define OM_IMPORTANCE#HIGH			2

define OM_SENSITIVITY#NORMAL		0
define OM_SENSITIVITY#PERSONAL		1
define OM_SENSITIVITY#PRIVATE		2
define OM_SENSITIVITY#CONFIDENTIAL	3

define OM_SERVICE#LEVEL_A0			0		' OpenMail A.00.01 (pre-Atlantic)
define OM_SERVICE#LEVEL_A1			1		' OpenMail A.01.00 (Atlantic)
define OM_SERVICE#LEVEL_B1			2		' OpenMail B.01.00 (Biscay)
define OM_SERVICE#LEVEL_B2			3		' OpenMail B.02.00 (Baltic)
define OM_SERVICE#LEVEL_B3			4		' OpenMail B.03.00 (Baffin)
define OM_SERVICE#LEVEL_C1			5		' OpenMail B.04.00 (Coral)

' 
' flag mask values for msg_flags element in om_msg_attrs_
' structure
'

' message attributes

define OM_MSG#NO_ALTRECIP			0x00000040
define OM_MSG#ROC					0x00000080
define OM_MSG#NO_AUTOFWD			0x00000100
define OM_MSG#NO_AUTOREP			0x00000200
define OM_MSG#DISCLOSE				0x00000400
define OM_MSG#NO_DL_EXP				0x00000800
define OM_MSG#NO_CONV_LOSS			0x00010000
define OM_MSG#UNREAD				0x00020000
define OM_MSG#NO_REASSIGN			0x00080000
define OM_MSG#REPLYTO				0x00400000
define OM_MSG#NOCONVERT				0x00800000
define OM_MSG#ERRMGR				0x04000000


' directory access capabilities

define OM_CAP#CONFIG				0x00000001
define OM_CAP#UPDATE				0x00000002
define OM_CAP#READ					0x00000004
define OM_CAP#SELF					0x00000008

' designate attributes and capabilities

define OM_DESIG#PSUEDO				0x00000001

define OM_DESIG#ITEM_READ			0x00000001
define OM_DESIG#ITEM_ATTACH			0x00000002
define OM_DESIG#ITEM_MODIFY			0x00000004
define OM_DESIG#ITEM_DELETE			0x00000008

define OM_DESIG#BB_READ				0x00000001
define OM_DESIG#BB_ATTACH			0x00000002
define OM_DESIG#BB_MODIFY			0x00000004
define OM_DESIG#BB_DELETE			0x00000008
define OM_DESIG#BB_ADMIN			0x00000010

define OM_DESIG#CFG_READ			0x00000100
define OM_DESIG#CFG_MODIFY			0x00000200

define OM_DESIG#MAIL				0x00001000

define OM_DESIG#DIR_READ			0x00010000
define OM_DESIG#DIR_UPDATE			0x00020000

define OM_DESIG#PERSONAL			0x00100000
define OM_DESIG#PRIVATE				0x00200000
define OM_DESIG#CONFIDENTIAL		0x00400000

define OM_DESIG#ALL					0x00ffffff


' access caps

define OM_ACCESS#ITEM_READ			0x00000001
define OM_ACCESS#ITEM_ATTACH		0x00000002
define OM_ACCESS#ITEM_MODIFY		0x00000004
define OM_ACCESS#ITEM_DELETE		0x00000008
define OM_ACCESS#ALL				0x0000000f
define OM_ACCESS#ALL_OTHER			0x0073131f


' info returned from sign on command

define		UAL_SIGNON_EX_SESS		0x00000001
define		UAL_SIGNON_EX_FULL		0x00000002
define		UAL_SIGNON_IS_DESIG		0x00000004
define		UAL_SIGNON_DES_LIC		0x00000008
define		UAL_SIGNON_BB_LIC		0x00000010
define		UAL_SIGNON_ADMIN		0x00000020
define		UAL_SIGNON_BB_ADMIN		0x00000040
define		UAL_SIGNON_HAS_PRIN		0x00000080


' flags used by specific AutoAction types

define		AA_NUM_UNSIGNED				0x00000001
define		AA_RELATIVE_DATE			0x00000002
define		AA_AAP_NDN					0x00000004
define		AA_AAP_ROC					0x00000008
define		AA_CONTENT_PRESENT			0x00000010
define		AA_ENABLE_FWD_REPORTS		0x00000020
define		AA_RETAIN_ORIGINATOR		0x00000040
define		AA_CHANGE_SUBJECT			0x00000080
define		AA_USE_REPLY_TO_LIST		0x00000100


' flags used for custom print headers

define		OM#PRT_SUBJECT				0x00000001
define		OM#PRT_SENDER				0x00000002
define		OM#PRT_CDATE				0x00000004
define		OM#PRT_ADATE				0x00000008
define		OM#PRT_PRIORITY				0x00000010
define		OM#PRT_SENSITIVITY			0x00000020
define		OM#PRT_IMPORTANCE			0x00000040
define		OM#PRT_ACKINFO				0x00000080
define		OM#PRT_MSGID				0x00000100
define		OM#PRT_MSGPROPS				0x00000200


' type of thing being created by create_folder

define OM#FOLDER_TYPE		0
define OM#BB_TYPE			1


'
' move these to adlgpoke.h as soon as possible...
'
define GS       29
define RS       30
define US       31

define OM_DIR_PERSONAL		1
define OM_DIR_SHARED		2

'
' session types
'

define DESIG_TYPE_NONE			-1
define DESIG_TYPE_REAL			0
define DESIG_TYPE_PSEUDO		1

'
' new message flags (see below for associated profile values)
'

define UAL_NEWMSG_URGENT		0x00000001
define UAL_NEWMSG_IMPORTANT		0x00000002
define UAL_NEWMSG_PRIVATE		0x00000004

'
' profile values for new message flags
'

define OM#NEWFLT_NONE				0
define OM#NEWFLT_URGENT				1
define OM#NEWFLT_IMPORTANT			2
define OM#NEWFLT_PRIVATE			3

'
' folder sort orders
'

define OM_SORT_NONE					 0
define OM_SORT_ALPHASUBJ			 1
define OM_SORT_ALPHASEND			 2
define OM_SORT_ALPHARCP				 3
define OM_SORT_PRIORITY				 4
define OM_SORT_SENSITIVITY			 5
define OM_SORT_IMPORTANCE			 6
define OM_SORT_DATE_ASCEND			 7
define OM_SORT_DATE_DESCEND			 8
define OM_SORT_UNREAD				 9
define OM_SORT_SENDER				10
define OM_SORT_STATUS				11
define OM_SORT_KEYWORD				12
define OM_SORT_DATE					13
define OM_SORT_COMBINED				14
define OM_SORT_CUSTOM				15
define OM_SORT_DEFAULT				16


'
'	OpenMail format definitions
'

	format om_folder_info_
		name,
		size,
		access

	format om_directory_info_
		attr,
		value

	format om_config_info_
		wbclear,
		tabsize,
		readdl,
		printdl,
		msgattr,
		autoexp,
		autoobs,
		mailsave,
		printcmd,
		charset

	format om_ack_info_
		recip_name,
		recip_type,			' to, cc or bc
		req_ack,			' ack type requested
		rec_ack,			' ack type received
		rec_ack_date		' date last ack received

	format om_msg_attrs_
		priority,			' urgent, non-urgent or normal
		sensitivity,		' normal, personal, private or confidential
		importance,			' normal, low or high
		ack_req,			' none, deliver, read or reply (requested)
		ack_sent,			' ack already sent for this message
		recip_type,			' from, to, cc or bc
		expire_date,		' expiration date for this message
		reply_date,			' date reply is requested by
		defer_date,			' date delivery is deferred to
		msg_id,				' message id
		sender,				' full address of message sender
		subject,			' message subject
		abs_ref,			' absolute message reference
		cdate,				' message creation date (long)
		create_date,		' message creation date (string)
		rdate,				' message receipt date (long)
		receipt_date,		' message receipt date (string)
		msg_flags,			' various message attribute flags
		sender_name			' message sender name only for display

	format om_msg_contents_
		size,				' item size (in bytes)
		type,				' item type (OpenMail filetype)
		title,				' item subject (displayed name)
		abs_ref,			' absolute item handle
		level				' depth of item relative to message

	format omsvr_event_
		cmdCode,
		data

	format dlist_members_
		orig_recips,
		cc_recips,
		bc_recips,
		sender

	format om_aa_info_
		aa_num,
		is_disabled,
		filters,
		actions

'
' Forward and Reply AutoAction format
'

	format sfaa_info_
		disabled,
		content_type,
		comment,
		subject,
		has_content,
		fwd_reports,
		retain_orig,
		use_subject,
		delete,
		format arrayof om_filter_spec_ filters

	format sraa_info_
		disabled,
		content_type,
		unused1,
		subject,
		has_content,
		unused2,
		unused3,
		use_subject,
		reply_to_list,
		format arrayof om_filter_spec_ filters


'
' Filter and AutoAction spec
'

	format om_filter_spec_
		type,							' filter type
		reverse,						' BOOL: NOT this filter
		att_id,							' message attribute to test
		test_type,						' test operation
		num_data,						' numeric data
		str_data,						' string data
		special							' flags word

	format om_auto_action_spec_
		type,							' AutoAction type
		folder,							' used for FILE
		printer,						' registered printer name
		printopts,						' command line opts
		filename,						' used for FORWARD and REPLY
		filetype,						' see above...
		comment,						' returned with FORWARD NDN
		subject,						' used with FORWARD and REPLY
		to_list,						' used with FORWARD
		cc_list,						' used with FORWARD
		bc_list,						' used with FORWARD
		special							' flag word


'
' OpenMail recipient preference information
'
 
	format om_recip_prefs_
		username,						' full O/R address
		wp_pref,						' wp doc format pref
		gr_pref,						' gr doc format pref
		ss_pref,						' ss doc format pref
		dd_pref,						' dd doc format pref
		wp_pref_func,					' wp conversion func
		gr_pref_func,					' gr conversion func
		ss_pref_func,					' ss conversion func
		dd_pref_func,					' dd conversion func
		mac_user,						' true or false (for mac hdr)
		unused1,
		unused2,
		unused3,
		unused4

'
' OpenMail message format
'

	format om_message_
		to_recips,
		cc_recips,
		bc_recips,
		to_acks,
		cc_acks,
		bc_acks,
		files,
		ftypes,
		wp_pref,
		gr_pref,
		ss_pref,
		dd_pref

'
' OpenMail attached document format
'

	format om_doc_info_
		doc_format,
		localize



'
'	OpenMail directory data format
'
	format om_dir_data_
		tag,
		value

'
'	OpenMail cached directory info format
'
	format om_dir_entry_
		name,
		type,
		flags,
		access_caps,
		passwd						' added to cache after first use

'
' OpenMail designate access capabilities
'	Note: this same structure is used for both setting and retrieving
'	designate/principal caps - in each case, not all fields are valid.
'
	format om_desig_caps_
		name,				' OpenMail username of designate
		is_pseudo,			' boolean - is pseudo-designate?
		start_date,			' date designate becomes active
		end_date,			' date designate access expires
		intray_caps,		' flags describing intray caps
		outtray_caps,		' flags describing outtray caps
		pending_caps,		' flags describing pending caps
		filing_caps,		' flags describing filing cab caps
		dlist_caps,			' flags describing dist list caps
		bb_caps,			' flags describing bulletin board caps
		config_caps,		' flags describing config caps
		mail_caps,			' flags describing mail caps
		dir_caps,			' flags describing directory caps
		sens_caps,			' flags describing access to sensitive mail
		password			' password for pseudo designates

'
' X.400 name/address attributes
'

	format om_name_
		given_name,			' up to 16 characters
		initials,			' up to 5 characters, terminated by "."
		surname,			' up to 40 characters
		generation,			' up to 3 characters
		ou1,				' up to 32 characters
		ou2,				' up to 32 characters
		ou3,				' up to 32 characters
		ou4,				' up to 32 characters
		organization,		' up to 64 characters
		country,			' up to 3 characters
		admd,				' up to 16 characters
		prmd,				' up to 16 characters
		x121,				' up to 15 characters
		uaid,				' up to 32 characters
		ttid,				' up to 24 characters
		ddat1,				' up to 8 characters
		ddav1,				' up to 128 characters
		ddat2,				' up to 8 characters
		ddav2,				' up to 128 characters
		ddat3,				' up to 8 characters
		ddav3,				' up to 128 characters
		ddat4,				' up to 8 characters
		ddav4				' up to 128 characters
