/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: chart_.h
   Applix ASC version: 48
   Date: Tue Feb  2 15:21:32 1999
*/
/* STRIP LINES THROUGH HERE */
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' chart formating data
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format chart_datum@
	' label string
	label_x_offset,
	label_y_offset,
	label_string,

	' the data and the way to display it
	display_type, ' "plot", "substitute", "span", "gap", or "null"
	x, y, z

format chart_number_format@
	style,
	aux_style_info,
	units,
	radix_places,
	prefix, suffix,
	am_str,
	pm_str,
	true_str,
	false_str,
	thousands_seperator,
	decimal_seperator,
	display_format_errors,
	trim_string

format chart_trend@
	type,
	t_order,
	r_squared,
	correlations

format chart_group@
	type, stack_id, custom_part_name,
	x_axis,
	y_axis,
	z_axis,
	label_x_offset,
	label_y_offset,
	label_type,
	format chart_number_format@ label_format,
	format arrayof chart_datum@ data,
	legend_string,
	label_alignment,
	data_range,
	hidden,
	format chart_trend@ trend,
     num_buffers,
	enable_watch

format chart_type_info@
	bar_margin,
	bar_overlap,
	starting_pos

format chart_axis@
	type, ' category, value, log10
	auto_max, max_value,
	auto_min, min_value,
	auto_bas, bas_value,
	position, floating_value,
	minor_tik_type,
	minor_tik_size,
	auto_n_minor_tiks, n_minor_tiks,
	major_tik_type,
	major_tik_size,
	auto_n_major_tiks, n_major_tiks,
	bar_margin,
	bar_overlap,
	use_tik_attributes,
	behind_data,
	hidden,
	inverted

format chart_axis_labels@
	type, ' category, value, log10
	tight_label, label, label_x_margin, label_y_margin, label_alignment,
	format chart_number_format@ tik_format,
	tight_tiks,
	tik_range,
	tik_labels,
	tik_margin,
	tik_alignment,
	tik_filter,
	tik_flags,
	custom_tiks

' old data structure now split into two: axis, axis_labels
format chart_axis_info@
	value_type, log10,
	auto_max, max_value,
	auto_min, min_value,
	auto_bas, bas_value,
	position, value,
	minor_tik_type,
	minor_tik_size,
	auto_n_minor_tiks, n_minor_tiks,
	major_tik_type,
	major_tik_size,
	auto_n_major_tiks, n_major_tiks,
	format chart_number_format@ tik_format,
	label_x_margin, label_y_margin,
	tik_range, tik_filter, tik_labels, tik_flags,
	label,
	bar_margin,
	bar_overlap,
	label_alignment,
	tik_alignment,
	tik_margin,
	tight_label,
	tight_tiks,
	use_tik_attributes,
	behind_data,
	hidden,
	inverted

format chart_decorations@
	close_top,
	close_bottom,
	close_left,
	close_right,
	major_h_grids,
	minor_h_grids,
	major_v_grids,
	minor_v_grids,
	close_foreground,
	close_background,
	major_z_grids,
	minor_z_grids

format chart_legend@
	disabled,
	uses_x_space,
	uses_y_space,
	text_before_sample,
	arrange_by_row, max_per_row_or_column,
	title,
	horizontal_alignment, horizontal_offset,
	vertical_alignment, vertical_offset,
	top_margin, bottom_margin, row_margin,
	left_margin, right_margin, column_margin,
	proportional_margins,
	title_alignment,
    label_range

format chart_titles@
	title, title_alignment,
	expand_margin_for_title,
	title_x_offset,
	title_y_offset,
	subtitle, subtitle_alignment,
	expand_margin_for_subtitle,
	subtitle_x_offset,
	subtitle_y_offset,
	footer, footer_alignment,
	expand_margin_for_footer,
	footer_x_offset,
	footer_y_offset

format chart_3D_effect@
	enabled,
	yaw,
	pitch,
	projection,
	depth,
	right_angles

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' range parsing formats
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
format range_datum@
	cell_string,
	data_value

format chart_range@
	series_string,
	format arrayof range_datum@ values

format chart_range_list@
	row_string,
	col_string,
	data_string,
	format arrayof chart_range@ row_range,
	format arrayof chart_range@ col_range,
	format arrayof chart_range@ data_range

format chart_data@
	ranges,
	legend_cells,
	axis_tick_range

format chart_range_info@
	ranges,
	legend_cells,
	legend_range,
	axis_tick_range
