/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cpptalk.C
   Applix ASC version: 4
   Date: Tue Feb  2 15:22:06 1999
*/
#ifdef __cplusplus

#include <elapi.hh>

extern "C" {
	CAxInterface *AxCreateCppObject (CAxInterface *);
	void AxDestroyCppObject (CAxInterface *);
	elfData AxCallCppMemberFunc (CAxInterface *, CAxInterface **, int , elfData);
	char **AxQueryCppInterface (CAxInterface **);
	char **AxQueryCppInterfaceHelpStrs (CAxInterface **);
};

CAxInterface::CAxInterface ()
{
	axMethodInfo = NULL;
}

CAxInterface::~CAxInterface ()
{
	axMethodInfo = NULL;
}

CAxInterface *
AxCreateCppObject (CAxInterface *modelP)
{
	return(modelP->AxCreateSimilar());
}

void
AxDestroyCppObject (CAxInterface *objP)
{
	delete objP;
}

char **
AxQueryCppInterfaceHelpStrs (CAxInterface **modelPP)
{
	CAxInterface *modelP = *modelPP;
	modelP->axMethodInfo = modelP->AxQueryInterface();
	AxMethodInfo_t *methods = modelP->axMethodInfo;
	int count = 0;
	for (; methods[count].methodName; ++count)
		;
	char **help_strs = (char **)TrueCalloc(count+1, sizeof(char *));
	for (int ix = 0; ix < count+1; ++ix) {
		help_strs[ix] 	= methods[ix].helpStr;
	}
	*modelPP = modelP;
	return(help_strs);		// to be free'd by caller
}

char **
AxQueryCppInterface (CAxInterface **modelPP)
{
	CAxInterface *modelP = *modelPP;
	modelP->axMethodInfo = modelP->AxQueryInterface();
	AxMethodInfo_t *methods = modelP->axMethodInfo;
	int count = 0;
	for (; methods[count].methodName; ++count)
		;
	char **method_names = (char **)TrueCalloc(count+1, sizeof(char *));
	for (int ix = 0; ix < count+1; ++ix) {
		method_names[ix] = methods[ix].methodName;
	}
	*modelPP = modelP;
	return(method_names);		// to be free'd by caller
}

elfData
AxCallCppMemberFunc (CAxInterface *modelP, CAxInterface **objPP,
					 int mx, elfData args)
{
	CAxInterface *objP = *objPP;
	AX_MEMBER_FUNC memberFunc = modelP->axMethodInfo[mx].memberFunc;
	elfData retP = (objP->*memberFunc)(args);
	*objPP = objP;
	return(retP);
}

#else  /* __cplusplus */

void AxCreateCppObject() { }
void AxDestroyCppObject() { }
void AxCallCppMemberFunc() { }
void AxQueryCppInterface() { }
void AxQueryCppInterfaceHelpStrs() { }

#endif /* __cplusplus */
