/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: db_util.h
   Applix ASC version: 10
   Date: Tue Feb  2 15:22:22 1999
*/
#define MAKE_DB_UID                  1   /* widget id, unique within dbox */
#define MAKE_DBOX_UID                2   /* dbox id, unique within axmain */
#define DB_CTRL_GET_PIXEL_SIZE       3
#define CLASSNAME_FROM_GTYPE         4
#define LAYOUT_STR_WIDTH             5   /* measure string in "layout" font */
#define CUTCOPYPASTE                 6   /* dbox text-widget cut/copy/paste */

/* opcodes for tabcontrol-widget funcs
 */
#define APPLY_TABCTRL_LINKS          7
#define ADD_TABCTRL_LINK             8
#define CHECK_TABCTRL_CONTAINMENT    9
#define BREAK_TABCTRL_LINKS          10
#define RECHECK_TABCTRL_CONTAINEES   11
#define GET_ACTIVE_TABCTRL_LAYER     12
#define SET_ACTIVE_TABCTRL_LAYER     13
#define SET_TABLAYERS                14
#define READ_TABCTL_INSET            15
#define DISTINCT_LAYERNAMES          16

/* opcodes for keyboard-focus-change widget link funcs
 */
#define MAKE_KEY_FOCUS_LINK          20
#define BREAK_KEY_FOCUS_LINK         21
#define APPLY_KEYFOCUS_LINKS         22
#define SET_KEYFOCUS                 23  /* directly set keyboard focus to w */
#define GET_KEYFOCUS                 24  /* return which widg currently has */

/* Radio widgets and Tabcontrol widgets have "sub-accelerators"
 */
#define READ_SUB_ACCELERATORS        25
#define WRITE_SUB_ACCELERATORS       26

/* opcodes for align-links functions in db_util$
 */
#define COUNT_ALIGN_LINKS             52
#define INSERT_NEW_SIZES              53
#define DELETE_SIZES                  54
#define APPLY_LINKS                   55
#define BREAK_LINKS                   56
#define APPLY_SIZECHANGES             57
#define READ_SIZES                    58
#define READ_ELF_SIZES                59
#define READ_ACTUAL_SIZES             60
#define INSERT_DLG_SIZE               61
#define APPLY_DLG_SIZECHANGE          62

/* sub-opcodes used with CUTCOPYPASTE op
 */
#define CUTCOPYPASTE_CUT 1
#define CUTCOPYPASTE_COPY 2
#define CUTCOPYPASTE_PASTE 3
#define CUTCOPYPASTE_GET_TEXT 4

/* uid's are used as names for linking gadget_size's.
 * the naming scope is within a single dialog box.
 * elf layer can assign from 1 to MAX_GADGET_ID.
 * container edges get their own range not usable by
 * the elf layer.
 */
#define MAX_GADGET_UID 1000000
#define MAX_EDGE_UID 5000000
#define DBOX_GSIZE_ID (MAX_EDGE_UID + 1)

/* this (fake) elf gadget type will be out-of-band of the real
 * ones, to help distinguish the gadget_size instance as the dbox's
 */
#define DBOX_GTYPE       -1     /* please note indexing danger */

/* these are the link types to be used for
 * storing alignment information
 */
#define ALIGN_LINK_TYPE      1
#define BUMPER_ALIGN         2
#define EDGE_ALIGN           3
#define ROWCOL_ALIGN         4
#define SAME_WIDTH_ALIGN     5
#define SAME_HEIGHT_ALIGN    6
#define SIMPLE_CONTAIN       7

/* indices for use with gadget_size.edgeIds
 */
#define CONTAINER_LEFT_EDGE   0
#define CONTAINER_TOP_EDGE    1
#define CONTAINER_RIGHT_EDGE  2
#define CONTAINER_BOTTOM_EDGE 3

/* these defines match enums in widgfmt.h..
 */
#define WF_EDGE_TO_EDGE    1
#define WF_ROW_COL         2
#define WF_BUMPER          3
#define WF_SAME_WIDTH      4
#define WF_SAME_HEIGHT     5
#define WF_FIXED_WIDTH     6
#define WF_FIXED_HEIGHT    7

#define WF_OUTER_RIGHT      1
#define WF_OUTER_LEFT       2
#define WF_OUTER_TOP        3
#define WF_OUTER_BOTTOM     4
#define WF_INNER_RIGHT      5
#define WF_INNER_LEFT       6
#define WF_INNER_TOP        7
#define WF_INNER_BOTTOM     8
#define WF_CENTER           9


