/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elatm.c
   Applix ASC version: 5
   Date: Tue Apr 20 21:12:50 1999
*/
#define USE_IMP_PROMPT 1

#include <elf_env.h>
#include <signal.h>
#include <akeys.h>
#include <paripc.h>
#include <scac.h>
#include <dia.h>
#include <getstr4.h>
#include <thimble.h>
#include <getstr5.h>


#if DEBUG
extern FILE *ElfLogFp;
#define LOGGER(body) ElfLogger body
#else
#define LOGGER(body)
#endif

extern short THIMpid;
extern int ElfLogging;         /* TRUE enables logging */
extern bint ElfInLearnMode;

#include <elatm.p>


/*************************************************************************
function: ElfWindowReady - Return whether window can accept input
*/
int
ElfWindowReady()
{
	return(TRUE);
}

/*************************************************************************
function: IsElfInLearnMode - Return whether in learn mode
*/
bint
IsElfInLearnMode ()
{
	return(ElfInLearnMode != 0);
}

#if DEBUG
/*************************************************************************
function: ElfLogger - Logging routine for elf
*/
LINTCOMMENT(VARARG1)
int
ElfLogger (pstr,a,b,c,d,e,f,g,h,i,j,k)
char *pstr;
int a,b,c,d,e,f,g,h,i,j,k;
{
    int newline;
    char str[100];

    if ( ElfLogging ) {
        if ( !ElfLogFp )
            ElfLogFp = fopen("zzelf.log","w");
        strcpy(str,pstr);
        if ( str[strlen(str)-1] == '\\' ) {
            newline = FALSE;
            str[strlen(str)-1] = 0;
        }
        else
            newline = TRUE;
		if ( str[0] == '!' )
			strcpy(str,str+1);
		else
        	fprintf(ElfLogFp,"ELF(%d): ",THIMpid);
        fprintf(ElfLogFp,str,a,b,c,d,e,f,g,h,i,j,k);
        if ( newline )
            fprintf(ElfLogFp,"\n");
        fflush(ElfLogFp);
    }
	return(0);
}
#else
int ElfLogger(){return(0);}   /* ?? why needed? */
#endif

int TmMkCurWin(){return(0);}  /* blech!! */
