/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elbfs.c
   Applix ASC version: 82
   Date: Fri May 28 21:11:58 1999
*/
#include <stdlib.h>
#include <elbltn.h>
#include <doctypes.h>
#include <afile.h>

#if PMAX            /* Dec audio support */
extern int      ShellPid;
extern char     tempName[];
static SoundId  sdSound;
static aSoundHandleAttributes sdAttrs;
static LoudId   ldCloud;
static VDeviceId vdRecorder;
#endif
typeErr         FSWriteFileObjAsFile();
extern char *DirSlash;
FILE *THIMfopen();
extern data_ptr AxFilePermissions();
extern char *AxReadFileIntoBuf();
extern data_ptr ElfReadDataAndInfoFromBuffer(), AxAddDataToArray();
extern char *GetProfileByStr();
extern char *UPbyName();

ElfbPutToKS(){} /* OBSOLETE */
ElfbGetInKS(){} /* OBSOLETE */

/**************************************************************************/


#if !AX_STUB            /* !!cvt from 3.0 */
#include <fsjunk.h>     /* !!cvt was fskitchen.h */
#endif              /* !!cvt */
extern char    *FSGetInternalRefname();

ElfbFetchRefs(){}

#define AUDIO_NAME "/dev/audio"
/*************************************************************************
function: ElfbAudio - Manage sound device
*/
ElfbAudio(codeP, arg1P, arg2P, arg3P, arg4P, arg5P, arg6P)
    data_ptr        codeP;  /* 0 - write, 1-open, 2-read, 3-close,
                 * 4-addfile, 5-getdata */
    data_ptr        arg1P, arg2P, arg3P, arg4P, arg5P, arg6P;
{
#if !FOR_TESTER
    static int      fd = -1, timesCalled = 0;
    int             code, size, call_type, remaining_size;
    FILE           *fp, *OpenFileObjFmode();
    data_ptr        aP;
    double          volume;
    typeErr         FSReadFileIntoFileObj();
    char           *FSfgets();
    int i;
    data_binary    *bin_dataP;
    unsigned char  *read_destP = (unsigned char *) 0;
	data_ptr AxfGetFilesize();
	data_ptr sizeD;

#if 0 /* ********* from audio_filehdr.h    1.10    92/11/10 SMI */
typedef unsigned    u_32;
typedef struct {
    u_32        magic;      /* magic number */
    u_32        hdr_size;   /* size of this header */
    u_32        data_size;  /* length of data (optional) */
    u_32        encoding;   /* data encoding format */
    u_32        sample_rate;    /* samples per second */
    u_32        channels;   /* number of interleaved channels */
} Audio_filehdr;
#define AUDIO_FILE_MAGIC        ((u_32)0x2e736e64) 
#define AUDIO_FILE_ENCODING_MULAW_8 (1) /* 8-bit ISDN u-law */
#endif /* ********* end of code from audio_filehdr.h    1.10    92/11/10 SMI */
    char            *filename;
    /* here are the bytes for the header for a sun sound file */
    static unsigned char ahdr_bytes[]={0056,0163,0156,0144, /* magic */
                                    0,0,0,0040, /* header size */
                                    0,0,0,0, /* data length */
                                    0,0,0,1, /* encoding */
                                    0,0,037,0100, /* sample rate */
                                    0,0,0,1,    /* channels */
                                    };


    call_type = IntFromDataPtr(codeP);
    ElfRetData = NULL;
    switch (call_type) {

    case ELFINS_WRITE_AUDIO_FILE_: /* given data, write audio file */

        if (!arg1P || !arg2P)
            ElfStrAbort(ERR_ARGSTOOFEW, NULL, NULL);
        /* file is header, followed by binary data */
        filename = AxStrPtrFromDataPtr(arg1P);
        size = ElfbBinarySize(arg2P);   /* may throw error */

        /* insert header as defined by SUN, with presumed values */
        aP = AxMakeBinaryData(sizeof(ahdr_bytes) + size);
        memcpy(((data_binary *)aP)->bytes,
                    ahdr_bytes,
                    sizeof(ahdr_bytes));
        memcpy(((data_binary *)aP)->bytes + sizeof(ahdr_bytes),
                    ((data_binary *)arg2P)->bytes,
                    size);
        ElfbWriteBinaryFile(filename,aP);
        AxFreeData(aP);
        break;

#if PMAX
    case ELFINS_PLAY_AUDIO_:    /* make noise */
        GetSupportsAudio();
        if (SupportsAudio) {
            size = ElfbBinarySize(arg1P);   /* may throw error */
            if (size != 0) {
                if (PlayDecAudio(((data_binary *) arg1P)->bytes, size))
                    ElfStrAbort(0, XLT("Audio Server Error"), "");
            }
        }
        break;

    case ELFINS_OPEN_AUDIO_:
        GetSupportsAudio();
        if (SupportsAudio) {
            char            tempStrs[STRPATH + 1], *namep;

            sprintf(tempName, "%s/x%%%%%%%%%%%%%%%%%%%%", ThimTempDir);
            if ((namep = (char *) Amktemp(tempName)) == NULL)
                ElfStrAbort(ErrnoErr(), NULL, tempName);
            strcpy(tempName, namep);
            sprintf(tempStrs, "%s/record %s", ThimFiltersDir, namep);
            THIMexecRet(tempStrs);
        }
        break;

#undef sleep
#undef kill
#undef fopen
#undef fclose

    case ELFINS_READ_AUDIO_:
        if ((timesCalled++) % 2)
            /* sleeping 1 sec every other time = 1/2 sec */
            /* sleep, simulating Sun feel.  */
            sleep(1);
        break;
    case ELFINS_CLOS_AUDIO_:
        if (SupportsAudio && ShellPid) {

            /* Tell the process to terminate */
            if (kill(ShellPid, SIGINT))
                SVERIFY(0, ErrnoErr(), tempName);

            /* verify the process has completely stopped */
            errno = 0;
            while (errno != ESRCH)
                kill(ShellPid, SIGINT);
            ShellPid = 0;

            /* read the data from the file produced */
            /* by the record process */
            fp = fopen(tempName, "r");
            SVERIFY(fp, ErrnoErr(), tempName);
			sizeD = AxfGetFilesize(tempName);
            if ((size = AxIntFromDataPtr(sizeD)) == -1)
                SVERIFY(0, ErrnoErr(), tempName);
            ElfRetData = aP = (data_ptr) (MkBinary(size));
            code = fread(((data_binary *) aP)->bytes, 1, size, fp);
            fclose(fp);
            unlink(tempName);
            if (code != size) {
                ElfFree(aP);
                ElfStrAbort(ErrnoErr(), NULL, tempName);
            }
        }
        break;

#define sleep ThimNoSleep
#define kill  THIMkill
#define fopen THIMfopen
#define fclose THIMfclose

#else               /* not PMAX */
    case ELFINS_PLAY_AUDIO_:    /* make noise */
        size = ElfbBinarySize(arg1P);   /* may throw error */
        fp = fopen(AUDIO_NAME, "w");
        SVERIFY(fp, ErrnoErr(), AUDIO_NAME);
        if (size != 0) {
            fwrite(((data_binary *) arg1P)->bytes, size, 1, fp);
            if (ferror(fp)) {
                fclose(fp);
                break;
            }
        }
        fclose(fp);
        break;

    case ELFINS_OPEN_AUDIO_:    /* open device */
        fd = open(AUDIO_NAME, 0, 0);
        SVERIFY(fd != -1, ErrnoErr(), AUDIO_NAME);
        break;

    case ELFINS_READ_AUDIO_:    /* read device */
        SVERIFY(fd != -1, ERR_ILLVAL, AUDIO_NAME);
        size = remaining_size = IntFromDataPtr(arg1P);
		ElfRetData = MkBinary(size);
        bin_dataP = BX(ElfRetData);
#if SUN4S
        /* The audio driver undero Solaris seems to NOT work in a blocking */
        /*  mode, so we must be careful to keep reading till we get all the */
        /*  bytes we expect                                                */
        i = 0;
        read_destP = (unsigned char *)(bin_dataP->bytes);
        while ( remaining_size > 0 )
           { 
           code = read(fd, read_destP, remaining_size );
           remaining_size = remaining_size - code;
           read_destP = read_destP + code;
           }
        code = size;
#else
        code = read(fd, bin_dataP->bytes, size);
#endif
        if (code != size) {
            close(fd);
			if (read_destP) {
				ElfFree(read_destP);
			}
            ElfStrAbort(ErrnoErr(), NULL, AUDIO_NAME);
        }
        break;

    case ELFINS_CLOS_AUDIO_:    /* close device */
        close(fd);
        fd = -1;
        break;
#endif              /* not PMAX */
    }
#endif  /* !FOR_TESTER */
}

#if (PMAX)
/* Beginning of DEC specific stuff for Audio */

/* Creates a player, a speaker and connects the player to the speaker by a
 * wire. Returns the player id. */
#ifdef AX_USE_PROTOS
VDeviceId
CreateReq(
      AudioServer * pAserver,
      LoudId ldCloud,
      int DevType)
#else
VDeviceId
CreateReq(pAserver, ldCloud, DevType)
    AudioServer    *pAserver;
    LoudId          ldCloud;
    int             DevType;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("CreateReq");
}

/* Fill up the loop buffer to the size specified in lLimit. */
#ifdef AX_USE_PROTOS
void
FillLoopBuffer(
           AudioServer * pAserver,
           SoundId sdSound,
           aSoundType sdSoundType,
           char *indata_p,
           int size,
           long lBytesRead,
           long lLimit /* always 28000 */ )
#else
void
FillLoopBuffer(pAserver, sdSound, sdSoundType,
           indata_p, size, lBytesRead, lLimit)
    AudioServer    *pAserver;
    SoundId         sdSound;
    aSoundType      sdSoundType;
    char           *indata_p;
    int             size;
    long            lBytesRead;
    long            lLimit; /* always 28000 */
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("FillLoopBuffer");
}

/* Handles CommandStart and SoundPosition event. */
#ifdef AX_USE_PROTOS
void
HandleEvent(
        AudioServer * pAserver,
        aEvent * pEvent)
#else
void
HandleEvent(pAserver, pEvent)
    AudioServer    *pAserver;
    aEvent         *pEvent;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("HandleEvent");
}

/* At each SoundPosition event coming back, the client will read 4000 bytes and
 * send them to the server. */
#ifdef AX_USE_PROTOS
void
SendAtPosEvent(
           AudioServer * pAserver,
           aSoundType sdSoundType,
           SoundId sdSound,
           char *indata_p,
           int size)
#else
void
SendAtPosEvent(pAserver, sdSoundType, sdSound, indata_p, size)
    register AudioServer *pAserver;
    aSoundType      sdSoundType;
    SoundId         sdSound;
    char           *indata_p;
    int             size;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("SendAtPosEvent");
}

/* No more input. Plays the remaining samples in the loop buffer. */
#ifdef AX_USE_PROTOS
void
PlayRemaining(AudioServer * pAserver)
#else
void
PlayRemaining(pAserver)
    AudioServer    *pAserver;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("PlayRemaining");
}

/* Plays the client sound file. The client sound file has no audio header in
 * it. */
#ifdef AX_USE_PROTOS
void
PlayClientSound(
        AudioServer * pAserver,
        LoudId ldCloud,
        VDeviceId vdid,
        SoundId sdSound,
        char *indata_p,
        int size,
        aSoundType sdSoundType)
#else
void
PlayClientSound(pAserver, ldCloud, vdid, sdSound, indata_p, size, sdSoundType)
    AudioServer    *pAserver;
    LoudId          ldCloud;
    VDeviceId       vdid;
    SoundId         sdSound;
    char           *indata_p;
    int             size;
    aSoundType      sdSoundType;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("PlayClientSound");
}

#ifdef AX_USE_PROTOS
PlayDecAudio(
         char *indata_p,
         int size)
#else
PlayDecAudio(indata_p, size)
    char           *indata_p;
    int             size;
#endif
{
	ElfStrAbort( ERR_ILLVAL, NXLT("Need DEC audio library"), NXLT("PlayDecAudio");
}


/* End of DEC specific stuff for Audio */
#endif              /* not PMAX */

#define BLK 60          /* copied from elb.c */
#define BL3 20          /* copied from elb.c */
#define BLT 81          /* copied from elb.c */

/*************************************************************************
function: ElfEncodeTo6Bits - Encode passed array to a new array
*/
ElfEncodeTo6Bits(fd, passed_size, passed_p)
int             fd; /* file to write to */
int             passed_size;    /* number of bytes */
char           *passed_p;
{
    char            line[82];
    int             num_blocks;
    char           *p;
    int             ix;

    /* round size up to nearest BLK byte value */

    num_blocks = (passed_size + (BLK - 1)) / BLK;

    /* for sanity, copy padded to new array */

    p = malloc(num_blocks * BLK);
    memcpy(p, passed_p, num_blocks * BLK);

    /* convert and write */

    sprintf(line, "%7d\n", passed_size);
    DocSegWrite(fd, line, 8, -1);
    for (ix = 0; ix < num_blocks; ix++) {
        bin_to_hex6(line, p + ix * BLK);
        DocSegWrite(fd, line, BLT, -1);
    }
    free(p);
}

/*************************************************************************
function: ElfDecodeFrom6Bits - Decode a hex6 file
*/
char           *
ElfDecodeFrom6Bits(fd, size)
int             fd;
int            *size;
{
    char            line[82];
    int             num_blocks;
    char           *p;
    int             ix;

    /* fetch size */

    DocSegRead(fd, line, 8, -1);
    line[8] = 0;
    *size = atoi(line);

    /* round size up to nearest BLK byte value */

    num_blocks = (*size + (BLK - 1)) / BLK;
    p = malloc(num_blocks * BLK);

    for (ix = 0; ix < num_blocks; ix++) {
        DocSegRead(fd, line, BLT, -1);
        hex6_to_bin(p + ix * BLK, line);
    }
    return (p);
}

ElfbPrintFileByName(){}

/*************************************************************************
function: ElfbInstall - Compile Elf source into elf object code
*/
ElfbInstall(name)
    register char  *name;
{
    extern data_ptr ElfCompileArray();
    data_ptr lines, stuff;

/* REV2 file handler: gets R2 source object as a tempfile */

{
    char tmpName[STRPATH+1], *namep;
    int is_rev2 = FALSE;
    static char *rev2str = "227879175587464137";
    static char *rev3str = NXLT("*START");
    static char *rev4str = NXLT("*BEGIN");
    static char *rev3compiled = ".elo";
    char buf[2002];
    DocInfoType doc;
    FILE *fp;
    int code;
	int currentWindow;
    char objname[STRPATH+1];
    int len;

    fp = fopen(name,"r");
    if ( !fp )
        ElfStrAbort(ErrnoErr(), NULL, name);
    if ( !fgets(buf, 2000, fp) ) {
        fclose(fp);
        ElfbReadFile(name);
        goto doit;
    }
    fclose(fp);
    len = strlen(name);

    /* Rev 3 source files get compiled and installed by a special ELF function.
        It will throw an error if the file does not exist, or the compile 
        fails. */
    if ( (0 == strncmp(buf,rev3str,strlen(rev3str))) ||
    			(0 == strncmp(buf,rev4str,strlen(rev4str))) ) {
		currentWindow = ElfbCurWindow();
        code = ElfbPendForNewTask(NXLT("ME_COMPILE_FILE_ARRAY$"),name);
		make_curwin( currentWindow);
        switch (code) {
            case 0:                     /* No errors, so nothing to do */
                break;
            case -1:                    /* out of slots, or some such */
                ElfStrAbort( ERR_ILLVAL, XLT("Could not start process"), NULL);
            default:                    /* bad compile, etc. */
                ElfStrAbort( code, NULL, name);
        }
        return;     /* all done - file now installed if no error occurred */
    }

    /* For Rev 3 compiled files, grab the object and install */
    if (!strcmp( &name[len-4], rev3compiled)) {
        ElfbReadDataFile(name);
        ElfLoadPackage(ElfRetData,FALSE);
        /* !!0 Do I have to free anything here? */
        return;
    }

    /* For Rev 2 files, extract pure ASCII part */
    if ( 0 == strncmp(buf,rev2str,strlen(rev2str)) ) {
        sprintf(tmpName, "%s/x%%%%%%%%%%%%%%%%%%%%", ThimTempDir);
        if ((namep = (char *) Amktemp(tmpName)) == NULL)
            ElfStrAbort(ErrnoErr(), NULL, tmpName);
        strcpy(tmpName, namep);
        code = FSOpenDocument(name, FSO_READ + FSO_FILEOK, &doc);
        if (code != AOK)
            ElfStrAbort(code, NULL, name);
        sprintf(objname, "%s/1.elf", doc.pathname);
        FSWriteFileObjAsFile(tmpName,0666,&doc,objname);
        FSClsDoc(&doc, -1);
        ElfbReadFile(tmpName);
        unlink(tmpName);
    }

    else {                  /* Must be a pure ASCII file (Rev 2 or 3) */
        ElfbReadFile(name);
    }
}

/* The REAL stuff */

doit:
    lines = ElfRetData;
    ElfRetData = NULL;
    stuff = ElfCompileArray(name,lines);
    if ( !ElfbIsArray(stuff) || !ElfbIsArray(ReadArray(stuff,0)) )
        ElfStrAbort(ERR_NOCOMPILE,NULL,name);
    ElfLoadPackage(stuff,FALSE);
    ELF_DATA_FREE(stuff);
}

ElfbDecomposeFile(){}

/*************************************************************************
function: AxfOpenDoc - Open a document
?? Leaves newley_created doc if task could not be started
*/
data_ptr
AxfOpenDoc( data_ptr argsP)
{
    char            opts[2*STRPATH + 64];
    char            filename[STRPATH+1];
    char            template[STRPATH+1];
    char            cmd[4*STRPATH + 128];
	char			*codePage = NULL;
    char           *ThimSfxFromType();
    int             retcode;
    FILE            *fp;
    char            buf[301];
    char 			menubar_id_opt[ELFIDSTR + 1];
    char 			bitmap_opt[ELFIDSTR + 1];
    char            root_opt[STRPATH + 16];
    int 			uid = 0;
	int				appid;
	int				doctype;

	char			*name, *root_path;
	int				menubar_id, readOnly, quiet;
	int				readOnlySet, rootPathSet;


    XmPutBusyCursor(NULL);

	/* extract input args */
	name = AxStrPtrFromArray(argsP, 0);
	menubar_id = AxIntFromArray(argsP, 1);
	quiet = AxIntFromArray(argsP, 2);

	readOnlySet = FALSE;
	if(AxArrayElement(argsP, 3)	)	{
		readOnlySet = TRUE;
		readOnly = AxIntFromArray(argsP, 3);
	}else	{
		readOnly = FALSE;
	}

	rootPathSet = FALSE;
	root_path = NULL;
	if(AxArrayElement(argsP, 4))		{
		root_path = AxStrPtrFromArray(argsP, 4);
		if(*root_path != '\0')
			rootPathSet = TRUE;
	}

	appid = IC_UNKNOWN;
	if(AxArrayElement(argsP, 5)	)	{
		appid = AxIntFromArray(argsP, 5);
	}

	if (!AxAccessAllowed(name))
		ElfStrAbort(ERR_ILLVAL, XLT("Access Denied"), name);

	switch( appid) {
		case IC_SS:
    		doctype = MSpreadsheet;
			break;

		case IC_GE:
    		doctype = MDrawing;
			break;

		case IC_DC:
			doctype = MText;
			break;

		case IC_EQN:
			doctype = MEquation;
			break;

		case IC_CE:
			doctype = MUserCommand;
			break;

		case IC_SQL:
			doctype = MQuery;
			break;

		case IC_ABD:
			doctype = MApplixBuilderDistribution;
			break;

		case IC_AB:
			doctype = MApplixBuilder;
			break;

		case IC_ABO:
			doctype = MApplixBuilderTurbo;
			break;

		case IC_PIXED:
			doctype = MBitmap;
			break;

		case IC_DIALOG:
			doctype = MDialog;
			break;

		default:
			doctype = DocTypeFromName(name);
	}


	/* build up the command line for the app */

   	if (quiet != 0)
       	sprintf(opts, "\"-v%s\" -B", name);   /* name may contain blanks so quote */
   	else
       	sprintf(opts, "\"-v%s\"", name);

   	if (menubar_id > 0)
	{
      	sprintf(menubar_id_opt, " -W%d", menubar_id);
       	strcat(opts, menubar_id_opt);
   	}

    XmPutBusyCursor(NULL);

    switch (doctype) {
    case MSpreadsheet:
        if (readOnlySet)	{
			if(readOnly)
            	strcat(opts, NXLT(" -r"));
			else
            	strcat(opts, NXLT(" -z"));	/* explicit open for read write */
		}
		if (rootPathSet)	{
			sprintf(root_opt, NXLT(" -D%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APSS, opts);
        break;
    case MDrawing:
		if (readOnlySet)	{
			if(readOnly)
            	strcat(opts, NXLT(" -q"));
			else
            	strcat(opts, NXLT(" -z"));  /* explicit open for read write */
		}
		if (rootPathSet)	{
			sprintf(root_opt, NXLT(" -N%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APGE, opts);
        break;
    case MText:
        if (readOnly)
            strcat(opts, NXLT(" -r"));		/* Force read-only */
        else if (!readOnlySet)
            strcat(opts, NXLT(" -rx"));		/* Try read-write, accept r-o */
		/* else we try read-write and error if can't get it */

		if(rootPathSet)		{
			sprintf(root_opt, NXLT(" -D%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APDC, opts);
        break;
    case MEquation:
        if (readOnly)
            strcat(opts, NXLT(" -r"));		/* Force read-only */
        else if (!readOnlySet)
            strcat(opts, NXLT(" -rx"));		/* Try read-write, accept r-o */
		/* else we try read-write and error if can't get it */

		if(rootPathSet)		{
			sprintf(root_opt, NXLT(" -D%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APEQN, opts);
        break;
    case MUserCommand:
        if (readOnly)
            strcat(opts, NXLT(" -r"));		/* Force read-only */
        else if (!readOnlySet)
            strcat(opts, NXLT(" -rx"));		/* Try read-write, accept r-o */
		/* else we try read-write and error if can't get it */

		if(rootPathSet)		{
			sprintf(root_opt, NXLT(" -D%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APUCM, opts);
        break;
    case MQuery:
        uid = ElfbNewTask(NXLT("DATA_"), name); /* !!0 more arg control */
        break;
	case MApplixBuilderDistribution:
		uid = ElfbNewTask(NXLT("BUILDER_INSTALL_DISTRIBUTION_DLG@"), name);
		break;
	case MApplixBuilder:
		uid = ElfbNewTask(NXLT("BUILDER_APPLICATION_DLG@"), name);
		break;
	case MApplixBuilderTurbo:
		uid = ElfbNewTask(NXLT("BUILDER_APPLICATION@"), name);
		break;
	case MBitmap:
		/* run bitmap application */
		sprintf(bitmap_opt, NXLT(" -R "));
       	strcat(opts, bitmap_opt);
        if (readOnlySet)	{
			if(readOnly)
            	strcat(opts, NXLT(" -q"));
			else
            	strcat(opts, NXLT(" -w"));	/* explicit read write */
		}
		if(rootPathSet)		{
			sprintf(root_opt, NXLT(" -A%s"),root_path);
       		strcat(opts, root_opt);
		}
		uid = ElfbProc(APGE, opts);
		break;
	case MDialog:
		uid = ElfbNewTask(NXLT("DE_EDIT_DIALOG@"), name);
		break;
    default:
        /* May be a legitimate WP file without an extension
            (e.g. converted via Dir Displayer) */
        fp = fopen(name, "r");
        if (fp) {
            fgets(buf,300,fp);
            fclose( fp);
            if ( (0 == strncmp(NXLT("*START WORDS"),buf,12)) ||
            			(0 == strncmp(NXLT("*BEGIN WORDS"),buf,12)) ) {
                goto open_wp;
            }
        }

        /* Convert the ASCII file to a WP file */
        if ( !AxTempFile(NXLT("a%%%%%%%.aw"), filename) ) {
            ElfStrAbort(ErrnoErr(), NULL, name);
        }

		/* look for template ascii.aw */
		sprintf(template, "%s%smodels%sascii.aw", AxLangDir, DirSlash, DirSlash) ;
		if (access(template, R_OK) == 0)
	        sprintf( cmd, 
				NXLT("\"%s%sfilters%sasc2wp\" -t \"%s\" -i \"%s\" \"%s\""),
                            ThimApplixDir, DirSlash, DirSlash,
							template, name, filename);
		else
	        sprintf( cmd, 
				NXLT("\"%s%sfilters%sasc2wp\" -i \"%s\" \"%s\""),
                            ThimApplixDir, DirSlash, DirSlash,
							name, filename);

		/* Add most recent code page file used, if it exists */
		codePage = UPbyName(NXLT("axImportFilterUsingCodePage"));
		if (codePage && *codePage) {
			if (access(codePage, R_OK) == 0) {
	        	sprintf( cmd, NXLT("%s -c \"%s\""), cmd, codePage);
			}
		}

        retcode = AxRunProgram(cmd, NULL, NULL, NULL, FALSE);
        if (retcode) {
            ElfStrAbort(retcode, NULL, name);
        }

        /* Open that WP file */
        if (quiet != 0)
            sprintf(opts, "-pA \"-v%s\" -B", filename);
        else
            sprintf(opts, "-pA \"-v%s\"", filename);

open_wp:
		if(rootPathSet)		{
			sprintf(root_opt, NXLT(" -D%s"),root_path);
       		strcat(opts, root_opt);
		}
        uid = ElfbProc(APDC, opts);
    }
    XmPutBusyCursor(NULL);
    ElfbSetTaskMaster(uid);
	return(AxMakeIntData(uid));
}

/*************************************************************************
function: ElfbPrintDoc - Start a DC to print a doc
*/
extern char    *SEhackname, *SEhackfilename;    /* ?? */

ElfbPrintDoc()
{
    ElfAbort(ERR_ILLVAL);   /* ?? bad class num */
}

/*************************************************************************
function: ElfbAddAudio - Update DC inset audio file
*/
ElfbAddAudio()
{
}

/*************************************************************************
function: ElfbGetAudio - Return audio portion of a document
*/
ElfbGetAudio()
{
}

/*************************************************************************
function: DocIconIdFromName - Return doc's window icon number
*/
#ifdef AX_USE_PROTOS
DocIconIdFromName(char *name /* e.g. foo.ad */ )
#else
DocIconIdFromName(name)
    char           *name;   /* e.g. foo.ad */
#endif
{
    switch (DocTypeFromName(name)) {
    case MSpreadsheet:
        return (IC_SS);
    case MQuery:
        return (IC_SQL);
    case MDrawing:
        return (IC_GE);
    case MText:
        return (IC_DC);
    case MUserCommand:
        return (IC_CE);
    case MDialog:
        return (IC_DIALOG);
	case MApplixBuilder:
		return(IC_AB);
	case MApplixBuilderTurbo:
		return(IC_ABO);
	case MBitmap:
		return(IC_PIXED);
	case MApplixSlideShow:
		return(IC_AGO);
    default:
        return (0);
    }
}

/*************************************************************************
function: ElfbOpenMail - Open a document
*/
#ifdef AX_USE_PROTOS
ElfbOpenMail(char *name)
#else
ElfbOpenMail(name)
    char           *name;
#endif
{
#if !FOR_TESTER
    int             parent_wid = 0;
    char            opts[STRPATH + 10];
    char            nopts[STRPATH + 10];
    char           *ThimSfxFromType();
    int             uid = 0;

    XmPutBusyCursor(NULL);
    sprintf(opts, "-pA -v%s", name);
    opts[2] += parent_wid;
    XmPutBusyCursor(NULL);
    switch (DocTypeFromName(name)) {
    case MSpreadsheet:
        strcat(opts, " -m");
        uid = ElfbProc(APSS, opts);
        break;
    case MDrawing:
        sprintf(nopts, "-D %s", opts);
        uid = ElfbProc(APGE, nopts);
        break;
    case MText:
        {
            strcat(opts, " -M");
            uid = ElfbProc(APDC, opts);
            break;
        }
    default:
        strcat(opts, " -M");
        uid = ElfbProc(APUCM, opts);
    }
    XmPutBusyCursor(NULL);
    ElfbSetTaskMaster(uid);
#endif
}

 
 
ElfbPrtrFile(){taskAbort("ElfbPrtrFile called");}
ElfbPrintFile(){taskAbort("ElfbPrintFile called");}
