/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elbltn.h
   Applix ASC version: 16
   Date: Fri May  7 21:11:08 1999
*/
#define is_Latin_1(c) ( ((unsigned char)(c)<0xFF) || (((unsigned char)(c)) >= 160) )

#if SUN3 || SYSV4
#include <unistd.h>
#endif              

#include <sys/types.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <errno.h>
#include <sys/stat.h>

#if RIOS || AUX || AX_STUB || ALPHA || AXMS || HP800V3
#include <time.h>
#else
long time();
#endif

#if PMAX            /* Dec audio support */
#include <Alib.h>
#undef NeedFunctionPrototypes
#endif

#if AX_STUB
#include <fcntl.h>
#endif

#ifndef bool
#define bool int
#endif

#include <elf_env.h>

/* #include <elf_bltins.h> *//* ??cvt Not used in 3.0 */
#include <paripc.h>
#include <elipc.h>      
#include <elf_strs.h>

#if !AX_STUB            
#include <apwd.h>
#endif

#include <paratm.h>     
#include <tmi.h>
#include <parint.h>
#include <scac.h>
#include <fsrts.h>
#include <adocio.h>     
#include <aiconids.h>       
#include <bounds.h>
#include <aspeller.h>       

#if AX_NT
#undef Status      /* for now! */
#endif  /* DAMNT */

#include <thimble.h>
#include <datetime.h>
#include <elhelper.h>
#if !USL54
#include <afile.h>      
#endif
#include <getstr0.h>        
#include <getstr5.h>        
#include <getstr6.h>        
#include <getstr10.h>       
#include <adlgpoke.h>       
#include <impexp.h>     /* Format codes for DC export routines */
#include <dia.h>        /* IPC stuff */
#include <elf_ins.h>
#include <ax.h>         
#if 0
#include <Xm/Xm.h>
#endif  /* DAMNT */

#include <amenudef.h>
#include <elfnodes.h>
#include <pageform.h>
#include <elrecarg.h>
#include <paratm.h>
#include <parint.h>
#include <memblk.h>
#include <eldebug.h>
#include <elcomp.h>


#define NULLP (char*)NULL
#define MAX_FRDLEN 240      /* smaller than a power of 2 */

#if DEBUG
#define LOGGER(body)     {if ( ElfbLogging ) ElfbLogger body;}
#else
#define LOGGER(body)
#endif
#define MAX_FILES 10        /* opened by helper logic */

/* Maximum allowable directory name is around 150 */
#define MAX_DIR_LEN (STRPATH - 90)

extern char **AxListFilesInDir();   
extern void AxListFilesFreer(); 
typeErr ElfCompile(), FSOpenDocument(), ElfLoadImage();
int ATMelfReadSourceLine(), ATMelfPostError(), TSTelfPostError();
char *FSMakeFStrForSharedFile();
char *AxGetStr();
extern ElfbSendMes();
extern ElfbGetMes(), ThimLogout();
extern ElfbCallByName(), ElfbNewTask();
extern ElfbDumpData(), ElfbDoLogging(), ElfbNoLogging();
extern typeErr FSSaveFileToDisk();
extern typeErr ParseDate();
extern ElfPlayTypeAhead();

extern DLL_IMPORT int ElfAllowAbort;
extern DLL_IMPORT int Logging;   /* for compiler */
extern DLL_IMPORT int ElfbLogging;   /* enables bltins logging */
extern DLL_IMPORT int ElfLogging;      /* interpreter logging */
extern DLL_IMPORT char ElfActTitle[];
extern DLL_IMPORT data_ptr NullDataPtr;
extern DLL_IMPORT short Xmpc, Ympc;    /* mill char height/width */
extern DLL_IMPORT data_ptr ElfRetData; /* Alis func generic return value */
extern DLL_IMPORT char *ElfStrPtrRet;
extern DLL_IMPORT short THIMpid;
extern DLL_IMPORT char *ThimCustomDir, *ThimApplixDir, *ThimLangDir, *ThimFiltersDir;
extern DLL_IMPORT short CellWidDC, CellHtDC, CellUnder;
extern DLL_IMPORT int AxOpenLook;
extern DLL_IMPORT int SupportsAudio;
extern DLL_IMPORT DocInfoType THIMCurrDoc;
extern DLL_IMPORT bint ElfInLearnMode; /* TRUE while in learn mode */
extern DLL_IMPORT char AxCurrentDir[];
extern DLL_IMPORT short cur_win;

typeErr ErrnoErr(), IsValidPathFilename();
typeErr docSetupInfo();
char *FSGenName();
char *AxCreateTempfile();   /* Needed in ElfbExportDCA() */
typeErr FSCopyFileObject(), FSOpenDocument();
menu_item_def *ElfLookupSlider();

#if !(RIOS || PMAX) && !AX_STUB
char *TrueRealloc();
#endif


