/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elcodes.h
   Applix ASC version: 21
   Date: Tue Feb  2 15:21:21 1999
*/
#define MAX_REGS 1000	/* now that EA's are no longer encoded */

#define OP_SRC0         0 /* src map */
#define OP_SRC1         1 /* src map */
#define OP_SRC2         2 /* src map */
#define OP_SRC3         3 /* src map */
#define OP_SRC4         4 /* src map */
#define OP_SRC5         5 /* src map */
#define OP_SRC6         6 /* src map */
#define OP_SRC7         7 /* src map up to 2047 lines */
#define OP_PUSH         8  /* push ptr to eff addr */
#define OP_PUSH_ARG     9
#define OP_POPTO        10  /* pop data to EA */
#define OP_POPTO_ARG    11
#define OP_PUSHARR      12  /* push array reference */
#define OP_PUSHARR_ARG  13
#define OP_POPDATA      14  /* create array of poped datums */
#define OP_POPDATA_ARG  15
#define OP_POPTOARR     16  /* pop data to array element */
#define OP_POPTOARR_ARG 17
#define OP_POPADD       18 /* Add tos to var store var */
#define OP_POPADD_ARG   19 /* Add tos to var store var */
#define OP_POPSUB       20 /* Subtract tos from var store var*/
#define OP_POPSUB_ARG   21 /* Subtract tos from var store var*/
#define OP_PUSH1ARR     22  /* push array reference */
#define OP_PUSH1ARR_ARG 23
#define OP_POPTO1AR     24  /* pop data to array element */
#define OP_POPTO1AR_ARG 25
#define OP_POPDARR      26  /* create sub-array of poped datums to array */
#define OP_POPDARR_ARG  27
#define OP_SETOBJ		28 /* Call object's change method */
#define OP_SETOBJ_ARG	29
#define OP_INC          30 /* Add one to var store var (locvars only) */
#define OP_DEC          31 /* Subtract one from var store var (locs only)*/
#define OP_CASE         32 /* comp tos against selecter, jne */
#define OP_JZ_SHRT      33 /* jump if tos equals zero */
#define OP_JMP_SHRT     34 /* unconditional jump */
#define OP_ADD          35 /* number integer add the two tos values */
#define OP_SUB          36 /* number integer subtract the two tos values */
#define OP_MULT         37 /* number integer multiply the two tos values */
#define OP_DIV          38 /* number floating divide the two tos values */
#define OP_EXP          39 /* number take to a power */
#define OP_LESS         40 /* number < the two tos values */
#define OP_GRTR         41 /* number > the two tos values */
#define OP_LEQ          42 /* number <= the two tos values */
#define OP_GEQ          43 /* number >= the two tos values */
#define OP_IDIV         44 /* integer divide the two tos values */
#define OP_EQV          45 /* bitwise equivalance */
#define OP_IMP          46 /* bitwise implication */
#define OP_REM          47 /* integer remainder the two tos values */
#define OP_AND          48 /* bitwise and the two tos values */
#define OP_OR           49 /* bitwise or the two tos values */
#define OP_XOR          50 /* bitwise exclusive or the two tos values */
#define OP_IADD         51 /* integer integer add the two tos values */
#define OP_ISUB         52 /* integer integer subtract the two tos values */
#define OP_IMULT        53 /* integer integer multiply the two tos values */
#define OP_ILESS        54 /* integer < the two tos values */
#define OP_IGRTR        55 /* integer > the two tos values */
#define OP_ILEQ         56 /* integer <= the two tos values */
#define OP_IGEQ         57 /* integer >= the two tos values */
#define OP_SADD         58 /* string concatination */
#define OP_SLESS        59 /* string < the two tos values */
#define OP_SGRTR        60 /* string > the two tos values */
#define OP_SLEQ         61 /* string <= the two tos values */
#define OP_SGEQ         62 /* string >= the two tos values */
#define OP_EQUALS       63 /* number/string == the two tos values */
#define OP_NEQ          64 /* number/string != the two tos values */
#define OP_UMINUS       65 /* number unary minus */
#define OP_NOT          66 /* bitwise unary negative */
#define OP_PUSH_GLO     67 /* push ptr to eff addr */
#define OP_PUSH_EXT     68
#define OP_POPTO_GLO    69 /* pop data to EA */
#define OP_POPTO_EXT    70
#define OP_PUSHARR_GLO  71 /* push array reference */
#define OP_PUSHARR_EXT  72
#define OP_POPDATA_GLO  73 /* create array of poped datums */
#define OP_POPDATA_EXT  74
#define OP_POPTOARR_GLO 75 /* pop data to array element */
#define OP_POPTOARR_EXT 76
#define OP_POPADD_GLO   77 /* Add tos to var store var */
#define OP_POPADD_EXT   78
#define OP_POPSUB_GLO   79 /* Subtract tos from var store var*/
#define OP_POPSUB_EXT   80
#define OP_PUSH1ARR_GLO 81 /* push array reference */
#define OP_PUSH1ARR_EXT 82
#define OP_POPTO1AR_GLO 83  /* pop data to array element */
#define OP_POPTO1AR_EXT 84
#define OP_POPDARR_GLO  85  /* create sub-array of poped datums to array */
#define OP_POPDARR_EXT  86
#define OP_SETOBJ_GLO	87
#define OP_SETOBJ_EXT	88
#define OP_CALL         89 /* call a routine with args, tell count */
#define OP_CALL_EXT     90
#define OP_RCALL        91 /* same as OP_CALL, but expect return value */
#define OP_RCALL_EXT    92
#define OP_CALL0        93 /* call routine with no args */
#define OP_CALL0_EXT    94
#define OP_RCALL0       95 /* call value returning routine no args */
#define OP_RCALL0_EXT   96
#define OP_ONERROR      97 /* catch error */
#define OP_PUSH_LIT     98 /* push ptr to a literal */
#define OP_JZ           99 /* jump if tos equals zero */
#define OP_JMP          100 /* unconditional jump */
#define OP_FORLOOP      101 /* assign var, step & stop */
#define OP_FORTEST      102 /* jmp out if tos grtr than for loop stop */
#define OP_RETVAL       103 /* return from routine with tos */
#define OP_RETURN       104 /* return from routine, no return value */
#define OP_NOP          105 /* no operation */
#define OP_COMPCALL     106 /* computed call */
#define OP_COMPGOTO     107 /* computed goto */
#define OP_ERRERR       108 /* on error return error error_number */
#define OP_ERROR        109 /* OBSOLETE */
#define OP_RETERR       110 /* OBSOLETE */
#define OP_POPSTEP      111 /* note for loop stepper */
#define OP_POPSTOP      112 /* note for loop stopper */
#define OP_ADDSTEP      113 /* add for loop's step val to var */
#define OP_SRCMAP       114 /* src map 8K - 32K lines */
#define OP_SELECTER     115 /* defines a 'loc var' for a select stmt */
#define OP_ENTER        116 /* Subroutine's 1st inst, creates args table */
#define OP_PUSH_ENT     117 /* Push function entry thru dyn link name */
#define OP_PUSH_EXTENT  118 /* OBSOLETE */
#define OP_ENTRYCALL	119 /* Call func thru tos */
#define OP_RENTRYCALL   120 /* Call func thru tos & return value */
#define OP_0ENTRYCALL   121 /* Call (no args) func thru tos */
#define OP_0RENTRYCALL  122 /* Call (no args) func thru tos & rtn value */
#define OP_IEQUALS      123 /* integer/string == the two tos values */
#define OP_INEQ         124 /* integer/string != the two tos values */
#define OP_IFORTEST     125 /* jmp out if tos int grtr than for loop stop */
#define OP_IUMINUS      126 /* integer unary minus */
#define OP_PUSH_NUM		127 /* push a small literal number -1 to 100 */
#define OP_BCALL0		128 /* builtin function, no args, no retval */
#define OP_BCALL		129 /* builtin function, X args, no retval */
#define OP_KCALL0		130 /* keystroke function, no args, no retval */
#define OP_KCALL		131 /* keystroke function, X args, no retval */
#define OP_RBCALL0		132 /* builtin function, no args, no retval */
#define OP_RBCALL		133 /* builtin function, X args, no retval */
#define OP_RKCALL0		134 /* keystroke function, no args, no retval */
#define OP_RKCALL		135 /* keystroke function, X args, no retval */
#define OP_PUSH_NULL	136 /* push the null datum */
#define OP_TRCALL		137 /* translate arg strs */
#define OP_XTRCALL		138 /* translate arg strs */
#define OP_SQL			139 /* SQL related opcode */
#define OP_PATCH_RET	140 /* Used by debugger, return from patch code */
#define OP_PUSH_OBJ     141 /* push ptr to eff addr */
#define OP_PUSH_SYS     142
#define OP_POPTO_OBJ    143 /* pop data to EA */
#define OP_POPTO_SYS    144
#define OP_PUSHARR_OBJ  145 /* push array reference */
#define OP_PUSHARR_SYS  146
#define OP_POPDATA_OBJ  147 /* create array of poped datums */
#define OP_POPDATA_SYS  148
#define OP_POPTOARR_OBJ 149 /* pop data to array element */
#define OP_POPTOARR_SYS 150
#define OP_POPADD_OBJ   151 /* Add tos to var store var */
#define OP_POPADD_SYS   152
#define OP_POPSUB_OBJ   153 /* Subtract tos from var store var*/
#define OP_POPSUB_SYS   154
#define OP_PUSH1ARR_OBJ 155 /* push array reference */
#define OP_PUSH1ARR_SYS 156
#define OP_POPTO1AR_OBJ 157  /* pop data to array element */
#define OP_POPTO1AR_SYS 158
#define OP_POPDARR_OBJ  159  /* create sub-array of poped datums to array */
#define OP_POPDARR_SYS  160
#define OP_SETOBJ_OBJ	161
#define OP_SETOBJ_SYS	162
#define OP_SWITCH		163  /* switch statement for integers */
#define OP_SSWITCH		164  /* switch statement for strings */
#define OP_TOSSTOS		165  /* ignore tos, used in multi-method object calls */
#define OP_TIMECHECK	166  /* (turbo) checks to see whether timeslice is up */
#define OP_SRCTIMECHECK	167  /* (debug) OP_SRCMAP && OP_TIMECHECK */

#define OP_LOC_OFFSET	0	/* e.g OP_PUSH */
#define OP_ARG_OFFSET	1	/* add to local var EA for Argument EA reference */
#define OP_GLO_OFFSET	(OP_PUSH_GLO - OP_PUSH)	/* for Global var reference */
#define OP_EXT_OFFSET	(OP_GLO_OFFSET+1)		/* for External var reference */
#define OP_OBJ_OFFSET	(OP_PUSH_OBJ - OP_PUSH)	/* for Object var reference */
#define OP_SYS_OFFSET	(OP_OBJ_OFFSET+1)		/* for System var reference */

