/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elfrhead.h
   Applix ASC version: 4
   Date: Tue Feb  2 15:21:27 1999
*/

format field_read_format_
    text,               ' Text at termination time
    xpos,               ' Horizontal char pos
    ypos,               ' Vertical char pos
    cursorpos,          ' Text-Zero-based initial/final cursor pos
    cursortype,         ' FALSE for insertion, else overtype
	terminated,			' Always TRUE
    changed,            ' FALSE if no text edits were performed
    event_type,         ' Type of termination event
    key,                ' Function key if FR#LOGICAL_KEY_ or FR#MESSAGE_
    width,              ' Display width in characters
    length,             ' Max number of characters allowed (>= width)
    xpick,              ' X char pos of pick event
    ypick,              ' Y char pos of pick event
	open_pick,			' Pick was of type 'open'
	help_pick,			' Pick was of type 'help'
	event_text			' data associated with event_type FR#MESSAGE_
'
' Termination conditions:
'
define FR#LOGICAL_KEY_      10  ' Terminating function key struck
define FR#BUFFER_OVF_       7   ' Buffer (FRDEX#LENGTH_) overflowed
define FR#MOUSE_PICK_       11  ' Mouse pick
define FR#MESSAGE_			24	' Message from another task
'
' Indexes for post_field_read() array.  See format above.  These index
' values are included here for compatability.
'
define FRDEX#TEXT_          0   ' Text at termination time
define FRDEX#XPOS_          1   ' Horizontal char pos
define FRDEX#YPOS_          2   ' Vertical char pos
define FRDEX#CURSORPOS_     3   ' Text-Zero-based initial/final cursor pos
define FRDEX#CURSORTYPE_    4   ' FALSE for insertion, else overtype
define FRDEX#CHANGED_       6   ' FALSE if no text edits were performed
define FRDEX#EVENT_TYPE_    7   ' Type of termination event
define FRDEX#KEY_           8   ' Function key if FR#LOGICAL_KEY_
define FRDEX#WIDTH_         9   ' Display width in characters
define FRDEX#LENGTH_        10  ' Max number of characters allowed (>= width)
define FRDEX#XPICK_         11  ' X char pos of pick event
define FRDEX#YPICK_         12  ' Y char pos of pick event
'
' Format used for the wait_event_() function
'
format event_format_
	event_type,
	text
'
' Special 'function keys' that result from window border actions
'
define KEY#FRAME_WINDOW_ 42		' window was resized
define KEY#THUMB_ 54			' thumbing bar was moved
'
' Standard function key definitions
'
define KEY#SAVE_                          4000	/* ??x TEMP */
define KEY#PRINT_                         4001	/* ??x TEMP */
define KEY#PRINT_CLOSE_                   4002	/* ??x TEMP */
define KEY#ABANDON_                       4003	/* ??x TEMP */
define KEY#QUIT_                          4004	/* ??x TEMP */
define KEY#REVERT_                        4005	/* ??x TEMP */
define KEY#DO_REVERT_                     4006	/* ??x TEMP */
define KEY#DELDOC_                        4007	/* ??x TEMP */
define KEY#DO_DELDOC_                     4008	/* ??x TEMP */
define KEY#MARK_ALL_                      4009	/* ??x TEMP */
define KEY#MARK_CLEAR_                    4010	/* ??x TEMP */
define KEY#MARK_REVERSE_                  4011	/* ??x TEMP */
define KEY#MARK_LAST_                     4012	/* ??x TEMP */
define KEY#ADD_ENTRY_                     4013	/* ??x TEMP */
define KEY#HIDE_                          4014	/* ??x TEMP */
define KEY#REVEAL_                        4015	/* ??x TEMP */
define KEY#REPLACE_                       4016	/* ??x TEMP */
define KEY#JOIN_                          4017	/* ??x TEMP */
define KEY#SPLIT_                         4018	/* ??x TEMP */


