/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elrecarg.h
   Applix ASC version: 2
   Date: Tue Feb  2 15:21:06 1999
*/
#ifndef ELRECARG_INCLUDED
#define ELRECARG_INCLUDED 1

/*
Elf argument recording structure

This 'C-ifies' Elf data for the ElfRecord function.

All data passed to ElfRecord is malloc'd and ElfRecord frees the
data when the recording is completed.

*/

typedef struct elf_c_data {
	int type;		/* data type recorded 0 - for null datum */
	union {
		char *str;	/* for string type */
		double num;	/* for number type */
		int val;	/* for small numbers */
		struct {
			int size;	/* number of elements in array */
			struct elf_c_data *data;	/* ptr to array of data */
		} arr;
	} info;
} elf_c_data;


#endif    /*   ELRECARG_INCLUDED  */
