/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: eltest.c
   Applix ASC version: 266.17
   Date: Thu May 13 21:13:50 1999
*/
#include <errno.h>
#if X386_NEW || AXMS || AVIION
#include <stdlib.h>
#endif


#define _NO_PROTO

#include <elf_env.h>
#include <fsrts.h>
#include <getstr4.h>
#include <getstr10.h>
#include <getstr20.h>
#include <getstr27.h>
#include <paripc.h>
#include <scac.h>
#include <thimble.h>
#define FOR_MAIN 1
#include <ax.h>

/* undo the redefines that thim_gen.h does */
#undef malloc
#undef calloc
#undef realloc
#undef free 

int Logging;
DocInfoType FSCurrDoc, XferDoc;
extern package_info *Packages;  /* head of packages list */
char ElfEventBuffer[100];
int ElfBufLen;
int ElfMsgPause;
int ElfAllowAbort;
short cur_win;
extern char ElfTextInBuffer[256];
extern int ElfLogging;
int ElfGotEscape;
char window[3000];
short MapMode;
short MenulessMode;
int ElfbLogging;
char *getenv();

#if AXMS
char *DirSlash = "\\";
#else
char *DirSlash = "/";
#endif

extern int ElfSysMode;     /* TRUE if ELF compiled in system mode */
extern short GvarFreeList[MAX_GVARS];	/* Free list for gvars (maps to TaskFrame's) */
extern int GvarFreeHead;		/* first avail gvar */
char *StackBase;
ax_jmp_buf KernelJump;
short THIMpid;
context_block TaskInfo[MAX_PIDS];	/* Array of task descriptions */
DocInfoType THIMCurrDoc;
char *ThimApplixDir, *ThimCustomDir;
char ThimTempDir[10];
void THIMexit(){}
void AxFreeData(p)data_ptr p;{}AxExitWithData(){}
extern short ElfHasStatusMessageDisplayed; /* TRUE if there is a status message */
extern long ElfQNumbers[MAX_QPUSH+2];	/* for the OP_PUSH_NUM small numbers */
char *ErrnoTextFromUnix();
extern int ElfcLanguage;
extern FILE *Xrf;	/* cross reference file */
extern int ElfcPortableBytes;	/* By default, machine independent! */
FILE *AsmFP;
char *AxStrflName;

#if !ELFRTXMODE
/*************************************************************************
function: main - Temp main routine
*/
main(argc,argv)
int argc;
char *argv[];
{
    int code;
    char *srcname;
    char objname[256];
    char modname[STRPATH+1];
    extern char *ElfSearchList[];
    int ix;
    char *p;
    extern int ElfStrsForInterpreter;
    int ATMelfReadSourceLine(),ATMelfPostError(),TSTelfPostError();
	data_ptr srcP, codeP;
	data_ptr searchList;
	static char axstrfl[STRPATH];
	char applixDir[STRPATH+1];
	data_ptr ElfDoCompileArray();
	int do_portable = FALSE;
    char *runit = NULL;
 	char tmp[STRPATH+1];
	char tmp2[STRPATH+1];

	for ( ix = 1; ix < argc; ix++ ) {
		if ( streq("-s",argv[ix]) ) {
			strcpy(axstrfl,argv[++ix]);
			AxStrflName = axstrfl;
			AxSysDosUnixPath(AxStrflName);
		}
	}
	ElfcLanguage = 0;	/* GOTHIC by default */
    ElfStrsForInterpreter = TRUE; /* needed by InitStrs */

	for ( ix = 1; ix < argc; ix++ ) {
		if ( streq("-errs",argv[ix]) ) {
			AxStrflName = argv[ix+2];
			AxSysDosUnixPath(AxStrflName);
	        GenErrcodes(argv[++ix]);
	        exit(EXIT_SUCCESS);
		}
		else if ( streq(argv[ix],"-sserrs" )) {
			AxStrflName = argv[ix+2];
			AxSysDosUnixPath(AxStrflName);
			GenSSErrcodes(argv[++ix]);
	        exit(EXIT_SUCCESS);
		}
	}

    ElfAllowAbort = TRUE;
	srcname = argv[1];
    strcpy(modname,srcname);
    strcpy(objname,srcname);
	searchList = MkArray(0);
    for ( ix = 2; ix < argc; ix++ ) {
        if ( streq("-x",argv[ix]) ) {
            Logging = ElfLogging = ElfbLogging = FALSE;
        }
        else if ( streq("-o",argv[ix]) )
            strcpy(objname,argv[++ix]);
        else if ( streq("-s",argv[ix]) ) {
			strcpy(axstrfl,argv[++ix]);
			AxStrflName = axstrfl;
			AxSysDosUnixPath(AxStrflName);
		}
		else if ( streq("-portable",argv[ix]) ) {
			do_portable = TRUE;
		}
		else if ( streq("-run",argv[ix]) ) {
			runit = argv[++ix];
			do_portable = TRUE;
		}
        else if ( (*argv[ix] == '-') && (*(argv[ix]+1) == 'I') ) {
			searchList = ElfAddStrToArray(searchList,
				ElfbArraySize(searchList),argv[ix]+2);
        }
    }
	if ( !do_portable )
		ElfcPortableBytes = FALSE;	/* By default, machine independent! */

	ElfbSetSysVar("elf_search_list@",searchList);

    /* we create the name to the executables by clipping stuff off the */
    /*  end of the path to the stringfile.  At this point the path to th  */
    /*  stringfile looks something like ".../axexec/eng/axstrfl"    */
    strcpy(applixDir,AxStrflName);
    p = strrchr(applixDir,*DirSlash);
    *p = 0;
    p = strrchr(applixDir,*DirSlash);/* axstrfl is 1 dir lower than axdata */
	*p = 0;
	ThimApplixDir = applixDir;



    ElfInitStrs();


    if ( getenv( "DO_XREF" ) != (char *)NULL )
       {
       /* I have taken this out for the generic case.    Cross-reference **/
       /*  files, cause some problems on crowded machines, or   **/
       /*  machines where 2 different builds are bing done - jon May-12-1994 */
	   AxParsePath(srcname,tmp,tmp2);
	   sprintf(tmp,"/tmp/%s",tmp2);
	   AxReplaceFileExtension(tmp,"xr");
	   AxSysDosUnixPath(tmp);
	   Xrf = fopen(tmp,"w");
       if ( Xrf == (FILE *)NULL )
          {
          printf("Unable to open input file <%s>,  errno=%d\n", tmp, errno );
          exit( EXIT_FAILURE );
          }
       }
    else
       Xrf = (FILE *)NULL;



	AxReplaceFileExtension(objname,"elo");

	if ( !do_portable ) {	/* make sure we can write outfile */
		char tmp[STRPATH+1];
		char tmp2[STRPATH+1];

		strcpy(tmp,objname);
		AxReplaceFileExtension(tmp,"c");
		AxSysDosUnixPath(tmp);
		AsmFP = fopen(tmp,"w");
	    if ( AsmFP == (FILE *)NULL )
	       {
	       printf("Unable to open output file <%s>,  errno=%d\n", tmp, errno );
	       exit( EXIT_FAILURE );
	       }
	}

	ElfbReadFile(srcname);
	srcP = ElfRetData;
    ElfSysMode = TRUE;
    ElfCompAddrs(TSTelfPostError);/*before each compile*/
    codeP = ElfDoCompileArray(modname,srcP);
	if ( !ElfbIsArray(codeP) || !ElfbIsArray(ReadArray(codeP,0)) )
        exit(EXIT_FAILURE);
	ElfbWriteDataFile(MkStrData(-1,objname),codeP,NULL);
	if ( Xrf )
		fclose(Xrf);

	if ( runit ) {
		data_ptr retData;
		ElfInitLibs();
		ElfbInstallBinary(codeP, FALSE);
		ElfCallFromC(runit,&retData,NULL);
	}

    exit(EXIT_SUCCESS);
}

#else
int ElfSysMode; /* TRUE if ELF compiled in system mode */
int ElfcAllowOracle = FALSE;	/* If true, accpet SQL keywords */
int ElfcObjectMode = FALSE; /* If true, compiling methods */
int ElfcLanguage = 0;	/* Gothic default */
int ElfcAllowSQL = FALSE;	/* If true, accpet SQL keywords */

/*************************************************************************
function: ElfRtxInit - Init embedded elf runtimes
*/
void ElfRtxInit ()
{
    int code;
    extern char *ElfSearchList[];
    char *p;
    extern int ElfStrsForInterpreter;
	data_ptr searchList;
	static char axstrfl[STRPATH];
	static char applixDir[STRPATH+1];
	char *runit;

	strcpy(axstrfl,"/ax/axexec/daxdata/eng/axstrfl");

	ElfcLanguage = 0;	/* GOTHIC by default */
    ElfStrsForInterpreter = TRUE; /* needed by InitStrs */

    ElfAllowAbort = TRUE;
	searchList = MkArray(0);
	ElfbSetSysVar("elf_search_list@",searchList);
	AxStrflName = axstrfl;
	AxSysDosUnixPath(AxStrflName);

    /* we create the name to the executables by clipping stuff off the */
    /*  end of the path to the stringfile.  At this point the path to th  */
    /*  stringfile looks something like ".../axexec/eng/axstrfl"    */
    strcpy(applixDir,AxStrflName);
    p = strrchr(applixDir,*DirSlash);
    *p = 0;
    p = strrchr(applixDir,*DirSlash);/* axstrfl is 1 dir lower than axdata */
	*p = 0;
	ThimApplixDir = applixDir;

    ElfInitStrs();
    ElfSysMode = TRUE;
	ElfInitLibs();
}

/*************************************************************************
function: ElfRtxLoadPackage - Install an Elf exectable
*/
void ElfRtxLoadPackage (objname)
char *objname;
{
	ElfbReadDataFile(objname);
	ElfbInstallBinary(ElfRetData, FALSE);
}

#endif

#if NO_VARARGS
/*************************************************************************
function: ElfLogger - Logging when not in atm
*/
LINTCOMMENT(VARARGS1)
ElfLogger (str,a,b,c,d,e,f,g,h,i,j,k)
char *str;
int a,b,c,d,e,f,g,h,i,j,k;
{
    static FILE *logfp = NULL;

    if ( !logfp )
        logfp = fopen("zzin.log","w");

    fprintf(logfp,str,a,b,c,d,e,f,g,h,i,j,k);
    fprintf(logfp,"\n");
    fflush(logfp);
}
#else
int vElfLogger(fmt, args)
  char *fmt;
  va_list args;
{
  static FILE *logfp = NULL;

  if (!logfp)
    logfp = fopen("zzin.log","w");

  if (*fmt)
    vfprintf(logfp, fmt, args);
  else fprintf(logfp, "ElfLogger: internal error!\n");
  fflush(logfp);
}

int ElfLogger(fmt, va_alist)
  char *fmt;
  va_dcl
{
  va_list args;

  va_start(args);
  vElfLogger(fmt, args);
  va_end(args);
}
#endif

char *ATMmalloc(n)
int n;
{
    return((char*)malloc(n));
}

ATMfree(p)
char *p;
{
    free(p);
}

LINTCOMMENT(VARARGS1)
errInd(wid,str)
int wid;
char *str;
{
	if (wid == -1 )
	    printf("%s\n",str);
}
newsl(){}

ElfPostFrd(mode,str)
int mode;
char *str;
{
}

#if NO_VARARGS
LINTCOMMENT(VARARGS2)
TSTelfPostError(line,a,b,c,d,e,f,g,h,i,j,k,l)
int line;
char *a;
int b,c,d,e,f,g,h,i,j,k,l;
{
    printf("***line %d: ",line);
    printf(a,b,c,d,e,f,g,h,i,j,k,l);
    printf("\n");
    fflush(stdout);
}
#else
int TSTelfPostError(line, fmt, args)
  int line;
  char *fmt;
  va_list args;
{
  fprintf(stdout,"***line %d: ",line);
  if (*fmt)
    vfprintf(stdout, fmt, args);
  else fprintf(stdout, "TSTelfPostError: internal error!");
  fprintf(stdout,"\n");
  fflush(stdout);
}
#endif

int ClipDocSuffix(){}

int ACproc(aid,cmd,pid)
int aid;
char *cmd;
int *pid;
{
    *pid = 99;
}

get_fds(x,y)
int x, *y;
{
*y = 99;
}

typeErr TmCreate(wid)
short *wid;
{
*wid = 66;
return(AOK);
}
short Ympc = 250;
short Xmpc = 100;
BindWindowForElf() {return(TRUE);}

typeErr TmWriteTx(wid,x,y,abs,bc,str)
short wid,x,y,abs,bc;
char *str;
{
    printf("TmWriteTx: %s\n",str);
}
typeErr TmTerm(){}
data_ptr AxfLogout(argDatum)
data_ptr argDatum; { return(NULL); }

char Sline[100];

ElfbPrintf(str)
char *str;
{
	write(1,str,strlen(str));
}


int QuietRunning;
int QuietErrsRunning;
int AxViewOnly;	/* TRUE only if axViewOnly set in profile... */
int AxViewRest;	/* Set/Clear able by ELF macro */
short BarVChanged, BarHChanged; 
char AxCurrentDir[100];
char *ThimCmdArgsFile;
char *Wp; ElfbWidgetProfile(){}
char *MainLibBuf;
int AxMetric, AxInTask;
short THIMpid;
int TmDefDev;
int MinWWid, MinWHt;
short ElfPromptMode;

data_ptr AxfAppIsData(){}
data_ptr AxfAppIsSS(){}
data_ptr AxMakeIntData(){}
data_ptr AxfInfoFromFileHeader(){}
data_ptr AxfFileHeaderFromInfo() {}
ElfbWpCall(){}
ElfbSSCall(){}
ElfbTableData(){}
ElfbTableNewData(){}
ElfbSetTableSelections(){}
ElfbClearTableData() {}
ElfbGetTableSelections() {}
ElfbGetTableData(){}
ElfbAllowTableEditing() {}
ElfbDataRequestModel() {}
ElfDoStopCleanup(){}
PromptElfMode(){}
CLthimble(){}
THIMnew(){}
ElfGetLogonDoc(){}
VfyContext(){}
ElfbResources(){}
DCthimble(){}
GEthimble(){}
HLthimble(){}
ElfbShowDialog(){}
ElfbPromoteDlg(){}
ElfbPromotedDlgID(){}
ElfbTiffIsGray(){}
data_ptr AxfUtil(){}
data_ptr AxfAxNet(){}
ElfbRebuildDialog(){}
UPgetinfo(){}
UPIsLocked(){}
data_ptr AxfArray1Column(){}
data_ptr AxfArrayColumns(){}
data_ptr AxfBecomeParasite(){}
data_ptr AxfListParasites(){}
data_ptr AxfArrayTranspose(){}
ElfbMiniDemo(){}
IPCignore(){} AxPokeDialogs(){} AxRePaintAll(){}
ElfbGetActiveWidgetFromElf(){} 
ElfbSetActiveWidget(){}
ACprocForElf(){}
data_ptr AxfRunProgramPid(){}
data_ptr AxfRunStdinProgram(){}
data_ptr AxfRunProgram(){}
data_ptr AxfRunStdinBatchProgram(){}
data_ptr AxfRunBatchProgram(){}
ElfbDestroyWidget(){} KillTask(){}
ElfbPrivateMenuBar(){}ElfbProfiler(){}
ElfbDelEditBoxData(){}
ElfbGetEditBoxData(){}
ElfbInsEditBoxData(){}
ElfbGetEditBoxSelectedRegion() {}
ElfbMapiFuncs(){}
ElfbMarkEditBoxRegion() {}
ElfbEditBoxEdited(){} AxXmEditBoxResetEdited(){}
ElfbCutEditBoxSeln(){}
ElfbFuncsInObject(){}
data_ptr AxfRtReader(){}
ElfbCopyEditBoxSeln(){}
ElfbPasteEditBoxSeln(){}
TmToggleToolBar(){}
ElfbToggleToolBar(){}
ElfbToolBarStatus(){}
ElfbEntryValChanged(){}
data_ptr AxfVfyMenu(){}
ElfbFileSelectionCreate(){}
ElfbObjCrtLocalData(){}
data_ptr AxfREV32(){}
ElfFindObjQueryMethod(){}
ElfbGetMaxFileLength(){}
ElfbObjInfo(){}
elf_object *ElfObjPtr(){}
data_ptr elfCallRemoteObjMethod(){}
ElfObjData(){}
ElfGetObjData(){}
ElfObjDecRef(){}
ElfbObjCrtChangeMethod(){}
ElfbCreateObject(){}
ElfbObjCrtQueryMethod(){}
ElfbObjectExists(){}
ElfbObjLoadImage(){}
ElfbDataType(){}
ElfFindObjChangeMethod(){}
ElfVfyObjLocalData(){}
ElfFindObjLocalData(){}
typeErr FSClsDoc(){} typeErr FSChkPtDoc(){} TestForFileObject(){}
FSGenName(){} DeleteFileObject(){}
ElfbSendMesToApp(){}
ElfbSendAndAckElfData(){}
ElfbRespondElf(){}
typeErr FSOpenDocument(){}AxErrorMessage(){}
ElfCallByName(){}
ATMelfPostError(){}
ElfbMenuCallback(){}
ElfbRespondElfErr(){}
extern int AxElfrtMode;
extern int AxMailrtMode;
char *ElfrtGetStrfl(){return(0);}
data_ptr AxfIsElfrt(){}
data_ptr AxfIsMailrt(){}
ElfbDraw(){}
ElfbTextSpellerHyphenationOK(){}
data_ptr AxfNewGE(){}
data_ptr AxfNewGP(){}
data_ptr AxfReadElfFile(){}
data_ptr AxfMoveFile(){}
data_ptr AxfStrlen(){}
data_ptr AxfMk1TempName(){}
ElfbDelete(){}
data_ptr AxfViewRest(){}
data_ptr AxfIsUUEncoded(){}
data_ptr AxfXlateGothic(){}
data_ptr AxfShXterm(){}
CallUserElfb(){}ElfFindUserFunc(){return(0);}ElfBindUserFunc(){}
data_ptr AxfTaskMaster(){}
data_ptr AxfInLearn(){}
data_ptr AxfGetDtmod(){}
data_ptr AxfUpCase(){}
data_ptr AxfGetKeyCode(){}
data_ptr AxfFormat(){}
ElfbCompose_String(){}
ElfbExit(){}
ElfbEditIcon(){}
data_ptr AxfRecursiveDelete(){}
ElfbTextSpellingAlternatives(){}
data_ptr AxfSort(){}
ElfbImageFromGE(){}
data_ptr AxfError(){}
data_ptr AxfViewOnly(){}
ElfbImportAscii(){}
data_ptr AxfStrToValue(){}
data_ptr AxfStrToNum(){}
data_ptr AxfNumToStr(){}
data_ptr AxfWriteBigFile(){}
data_ptr AxfGenSafeName(){}
data_ptr AxfFullPathname(){}
data_ptr AxfGetFilesize(){}
data_ptr AxfCurrentTime(){}
ElfbCurFR(){}
ElfbGetArgsGroup(){}
data_ptr AxfIsMetric(){}
ElfbTextSpellerThesaurusOK(){}
ElfbTextDictAddWord(){}
data_ptr AxfIsFunc(){}
data_ptr AxfFindElfFile(){}
data_ptr AxfTaskId(){}
ElfbIsLikeAscii(){}
AxfIsLikeLatin1(){}
ElfbOpenMail(){}
ElfbPrtrFile(){}
ElfbTextThesaurusClose(){}
ElfbTextDictCreate(){}
data_ptr AxfSuppressErrsDisplay(){}
data_ptr AxfNewSS(){}
data_ptr AxfShcmd(){}
data_ptr AxfSeedRand(){}
data_ptr AxfDeleteDir(){}
data_ptr AxfMkdir(){}
data_ptr AxfArgsToArray(){}
ElfbTextGetLanguageName(){}
data_ptr AxfAed(){}
data_ptr AxfRand(){}
ElfbXwinOfWin(){}
ElfbNewDeamonWithArgs(){}
ElfbCurWindow(){}
ElfbGetInKS(){}
ElfbDecomposeFile(){}
data_ptr AxfArrayToBinary(){}
ElfbExportDCA(){}
ElfbTextSpelledCorrectly(){}
data_ptr AxfGetenv(){}
data_ptr AxfErrorBox(){}
data_ptr AxfMDDFuncs(){}
data_ptr AxfBuilderFindInstanceGivenFilenameAndParentTaskid(){}
data_ptr AxfBuilderGetContainerApptype(){}
data_ptr AxfBuilderGetContainerInfo(){}
data_ptr AxfBuilderRegisterAppobjWithInset(){}
data_ptr AxfBuilderDestroyInset(){}
data_ptr AxfBuilderGetInsetAppobj(){}
data_ptr AxfBuilderGetGraphicsInset(){}
data_ptr AxfBuilderGetGraphicsInsetUID(){}
data_ptr AxfBuilderSetRootPathname(){}
data_ptr AxfBuilderSetSourceInfo(){}
data_ptr AxfBuilderGetSourceInfo(){}
data_ptr AxfBuilderSetInsetDocInfo(){}
data_ptr AxfBuilderGetInsetDocInfo(){}
data_ptr AxfGetBlobData(){}
data_ptr AxfFileOpenedNotify(){}
data_ptr AxfFileClosedNotify(){}
data_ptr AxfChangeDateFormat(){}
ElfbWinTitle(){}
data_ptr AxfCloseFile(){}
data_ptr AxfI2CM(){}
data_ptr AxfTrunc(){}
ElfbWindowInfo(){}
data_ptr AxfFRwait(){}
ElfbTextSpellerClose(){}
ElfbTextDictRemoveWord(){}
data_ptr AxfStrIndex(){}
data_ptr AxfSplitPath(){}
ElfbPutToKS(){}
ElfbTextSpellingInfo(){}
data_ptr AxfTabsToSpaces(){}
data_ptr AxfSubstr(){}
ElfbMkWinActive(){}
ElfbPromoteWindow(){}
data_ptr AxfReadBigFile(){}
data_ptr AxfInt(){} data_ptr AxfPreloadJavaImgsFromStrs(){}
data_ptr AxfJavaTaskNotify(){}
data_ptr AxfPostJavaImagePacket(){}
data_ptr AxfJavaTaskSyncMesNotify(){}
data_ptr AxfPostJavaImage(){}
data_ptr AxfJavaMenubarNotify(){}
data_ptr AxfJavaNotify(){}
data_ptr AxfErrStr(){}
ElfbSelByXId(){}
data_ptr AxfParseDate(){}
data_ptr AxfJulianDate(){}
data_ptr AxfListTasks(){}
data_ptr AxfOpenFile(){}
ElfbMkStrForLexor(){}
ElfbSys5(){}
ElfbTextDictGetWords(){}
data_ptr AxfReadLine(){}
data_ptr AxfMkTempName(){}
ElfbWindowList(){}
ElfbUsrFuncKey(){}
data_ptr AxfFileExists(){}
ElfbDirExists(){}
data_ptr AxfFileSavedNotify(){}
ElfbUpdateBitmap(){}
data_ptr AxfDnCase(){}
data_ptr AxfVfyFileExists(){}
data_ptr AxfUnixFileSystem(){}
data_ptr AxfChmodAbsolute(){}
ElfbAudio(){}
data_ptr AxfReadBinaryFile(){}
data_ptr AxfTruncArray(){}
data_ptr AxfPProc(){}
ElfbHelpAvailable(){}
ElfbFileWritable(){}
data_ptr AxfFileReadable(){}
data_ptr AxfProcessId(){}
data_ptr AxfUserId(){}
data_ptr AxfParentTask(){}
data_ptr AxfUserName(){}
data_ptr AxfSortIndexed(){}
data_ptr AxfSetSubstr(){}
data_ptr AxfFSQuery(){}
data_ptr AxfErrLine(){}
data_ptr AxfErrElfObj(){}
data_ptr AxfErrFunc(){}
ElfbColorState(){}
data_ptr AxfCatchErrors(){}
data_ptr AxfWriteLine(){}
ElfbTextThesaurusInfo(){}
ElfbTextDictCanAdd(){}
data_ptr AxfSysMode(){}
data_ptr AxfMakeFileWriteable(){}
ElfbInstall(){}
ElfbGetLiveData(){}
data_ptr AxfCreateTempfile(){}
data_ptr AxfNewAE(){}
data_ptr Axfsqrt(){}
data_ptr AxfGetPageInfo(){}
ElfbSetTaskMaster(){}
ElfbGetFontFamilies(){}
ElfbLocalizeSS(){}
data_ptr AxfBinaryByte(){}
ElfbTextSpellingErrors(){}
ElfbTextSpellerCurrLanguage(){}
ElfbTextGetLanguageCode(){}
data_ptr AxfFileExecutable(){}
data_ptr AxfErrNum(){}
data_ptr AxfCurrDir(){}
data_ptr AxfNoMapWindowsFlag(){}
ElfbExportAscii(){}
data_ptr AxfSuppressDisplay(){}
data_ptr AxfFuncList(){}
ElfbGEQuietCreate(){}
ElfbGetKeyName(){}
ElfbWriteBinaryFile(){}
data_ptr AxfTokenize(){}
data_ptr AxfDispTutor(){}
data_ptr AxfNewDC(){}
data_ptr AxfNewHLP(){}
data_ptr AxfNewHTML(){}
data_ptr AxfBinarySubArray(){} data_ptr AxfBinaryAppend(){}
data_ptr AxfWriteBinaryToFile(){} data_ptr AxfReadBinaryFromFile(){}
data_ptr AxfShWin(){}
ElfbReadAppFile(){}
ElfbWriteAppFile(){}
data_ptr AxfCompileArray(){}
ElfbGEQuietOpen(){}
data_ptr AxfI2IN(){}
data_ptr AxfAbs(){}
data_ptr AxfCos(){}
data_ptr AxfSin(){}
data_ptr AxfWindowPos(){}
ElfbTextThesaurus(){}
ElfbTextHyphenate(){}
data_ptr AxfErrObject(){}
data_ptr AxfDelay(){}
data_ptr AxfDefErrStr(){}
data_ptr AxfAbsPath(){}
data_ptr AxfXLT_Complex(){}
ElfbFuncKey(){}
ElfbTHIMpid(){}
data_ptr AxfNlog(){}
ElfbTextSpellerLanguageOK(){}
data_ptr AxfFormatDate(){}
ElfbCopyFile(){}
ElfbKillTask(){}
data_ptr AxfErrFile(){}
data_ptr AxfValidCmdName(){}
data_ptr AxfFormatArray(){}
data_ptr AxfBinaryToArray(){}
data_ptr AxfWriteFile(){}
ElfbImportSS(){}
ElfbTextDictClose(){}
data_ptr Axflog10(){}
data_ptr AxfTrim(){}
data_ptr AxfNormlKeySeq(){}
data_ptr AxfDatePieces(){}
data_ptr AxfSetCurrDir(){}
ElfbProc(){}
data_ptr AxfGetHelp(){}
FSGetDir(){}OpenFileObject(){}FSfgets(){}SleepForUser(){}
AxListFilesInDir(){}AxListFilesFreer(){}
CloseFileObject(){}
ElfbLoadBitmap(){}
DocSegWrite(){}XmNewStarMenu(){}
DocSegRead(){}
DocSegSeek(){}
ElfbNewUser(){}
ElfbDemoMode(){}
ElfbMachine(){}
ElfbSupportsAudio(){}
ElfbCheckAudioSupport(){}
FSgetc(){}
FSfputc(){}
ElfbTblFuncs() {}
ElfbEnterFuncs() {}
ElfbTrayFuncs() {}
ElfbTreeFuncs() {}
data_ptr AxfFreeNamedBitmap(){}
OpenFileObjFmode(){}
ElfbRPCAccept(){}
ElfbDEeditWidget(){}
ElfbDEeditSession(){}
ElfbDEreadData(){}
ElfbPutImageIconCreate(){}
ElfbRPCRespond(){}
ElfbRPCErrRespond(){}
ElfbDefaultButtons(){}
data_ptr AxfMakeEntryLink(){}
data_ptr AxfIsAXMS(){}
data_ptr AxfIsOrientBuild() {}
data_ptr AxfUseWideMenuBarEdit() {}
data_ptr AxfNameFromEntry(){}
AxReallocToAnotherTask(){}
ElfbCreateDialog(){}
ElfbDialogDestroy(){}
ElfbPushButtonCreate(){}
ElfbEntryFieldCreate(){}
ElfbTextLabelCreate(){}
ElfbCreateDlgMenuBar(){} 
ElfbRectCreate(){}
ElfbEntryValue(){}
ElfbMenuStatus(){}
ElfbToggleButtonCreate(){}
ElfbRadioBoxCreate(){}
ElfbCreateChoiceMenu(){}
ElfbGetPrinterTypes(){}
EDthimble(){}ThimPidFromUID(){}
typeErr FSCrtDoc(){}
typeErr FSGtDcInfo(){}
extern int ElfAllowNewTask;
FindThimbleFile(){}
data_ptr AxfSelections(){}
WriteSelectsFile(){}
ElfbReadPrinters(){}
ElfbReadSetups(){}
data_ptr AxfSetServices(){}
ElfRecycle(){} dsp_mous(){}
ElfRecord(){}
ElfbGetSelections(){} 
unsigned char *uncompress(){}
DlgLiftCursor(){}
ElfbSetSelection(){}
ElfbGetSelection(){}
IsAppidElf(){} ACpproc(){}
ElfbListSels(){}
ElfbXferSafe() {}
DlgPaintIcon(){} PickIsOpen(){}
DlgDrawLine() {} getWp(){} new_wind(){} doResize(){}
CreateDialogBox(){}
ElfHelperEvent(){}
ElfbWaitEvent(){}
ElfbSendElfData(){}
ElfbWaitForMessage(){}
ElfbArrPendForNewTask(){}
ElfbRecognizeFile(){}
ElfbArrNewTask(){}
ElfbPendForNewTaskWithArgs(){}
ElfbNewTaskWithArgs(){}
ElfbUnpendedNewTaskWithArgs(){}
DlgWriteTx(){} boundCalc(){} iconEvent(){} setclip(){} dispBar(){}
ElfbMapCursor(){}
ElfbSetHelpMode(){}
XmPutBusyCursor(){} ThimToggleRuler(){} 
data_ptr AxfGetLangDir(){}
ElfbFetchRefs(){}
ElfbSetRefs(){}
/* ElfbPurgeMailWastebasket(){} */
/* ElfbRecognizeFile(){} */
RingTheBell(){}
ElfbReadCustomCursors(){}
ElfbNewMailCount(){}
ElfbHasUnreadMail(){}
ElfbFormatMailItem(){}
AxIconifyWindow(){}
WidgetColorsFromProfile(){}UPnumVal(){}
ElfbMkRandKey(){}
ElfbEncryptString(){}
ElfbCreateChangeWidget(){}
ElfbPick(){}
ElfbStroke(){} TaskRecycle(){}
ElfWindowReady(){}
ElfbGEFromHPGL(){}
SuperMessage(){}
ElfbGEFromTIFF(){}
ElfbPokeDialogs(){}
ElfbLoadTiffToXferBin(){}
ElfbStartLearn(){}
ElfbEndLearn(){}
FSMakeFStrForSharedFile(){}
ElfbCreatePF(){}
ElfbCreate10LinePF(){}
ElfbGetPF(){}
ElfbGetNewPF(){} docSetupInfo(){} FormatDt(){} UnixTimeToAlisTime(){}
context_block *ActiveTasks[MAX_PIDS+1]; /* array of tasks .in_use */
CloseDialogBox(){} AxIsUserHelp(){}
data_ptr AxfSetHelp(){}
data_ptr AxfHelpFile(){}
ElfbSetXKey(){}
ElfbGetXKeys(){}
ElfbDBList(){}
int DialogBoxActive;
ThimDirType(){} PidOfDlgBox(){}
ElfbListBoxCreate(){}
winExists(){}
ElfbSendMes(){}
ElfbServer(){}
ElfbClient(){}
ElfbSockRead(){}
ElfbSockWrite(){}
ElfbSockRPCRead(){}
ElfbSockRPCWrite(){}
ElfbSockClose(){}
ElfbChanClose(){}
AxLockResource(){}
AxUnlockResource(){}
ElfbSockReadBinary(){}
ElfbSockWriteBinary(){}
AxfSockWriteAscii(){}
int ElfbIsFileOpen(){}
int ElfbIsFileLocked(){}
data_ptr AxfNoteFileInUse(){}
data_ptr AxfDoneWithFile(){}
int ElfbGetDpyWid(){}
int ElfbGetDpyHt(){}
int ElfbGetDlgFontHeight(){}
void taskAbort(){abort();}
ElfbAxNet(){}
ACprocIt(){}
char *SetupsInfoP;
ACqproc(){}
data_ptr AxfGetDataDir(){}
data_ptr AxfGetFilterDir(){}
data_ptr AxfGetEnterpriseDir(){}
data_ptr AxfGetEnterpriseAppsDir(){}
data_ptr AxfGetEnterpriseAppFilename(){}
data_ptr AxfIsLinuxOffice(){}
ElfbTest(){}
ElfbCrtDoc(){}
ElfbDocInfoFromID(){}
ElfbLoadKey(){}
ThimLogout(){}
ElfbSetupsInfo(){}
AxfOpenDoc(){}
ElfbDocInfo(){}
ElfbGetXLFD(){}
ProfileSave(){}
ElfbValidSetupForPrinter(){}
ElfbValidPrinter(){}
ElfbPrintersInfo(){}
ElfbAddProfile(){}
ThimIOSync(){}
data_ptr AxfProfile(){}
data_ptr AxfProfileByCode(){}
AddProfileByCode(){}
ElfbPrintDoc(){}
ElfbPrintFile(){}
ElfbPrintFileByName(){}
ElfbFixupQuirks(){}
ElfbDelDoc(){}
ElfbCrtWindow(){}
saAll(){}
ElfbUpdateDialog(){}
ElfbUpdateDialogSize(){}
data_ptr AxfGetTempDir(){}
data_ptr AxfGetCustomDir(){}
data_ptr AxfGetClipArtDir(){}
data_ptr AxfGetPresBklitDir(){}
data_ptr AxfGetPresMonoDir(){}
data_ptr AxfGetPres35mmDir(){}
data_ptr AxfGetPresColorDir(){}
data_ptr AxfGetPresTemplateDir(){}
data_ptr AxfSetPresTemplateDir(){}
data_ptr AxfGetPresOutlineDir(){}
data_ptr AxfGetPresSchemeDir(){}
data_ptr AxfGetPresChartDir(){}
ElfbGetBars(){}
ElfbSetBars(){}
data_ptr AxfValDocName(){}
ElfbAddPrinter(){}
PrintersSave(){}
ElfbAddSetup(){}
SetupsSave(){}
ElfbFindIndex(){}
data_ptr AxfMaxStrlen(){}
ElfbFetchAndRun(){}
ElfbCheckXForData(){}
data_ptr AxfGetUserDir(){}
data_ptr AxfNormalizeIn(){}
data_ptr AxfNormalizeOut(){}
data_ptr AxfNewFilePermissions(){}
data_ptr AxfGetAxHomeDir(){} InstallIconToSession(){} setupIcons(){}
FSSetCurrDocFromFstr(){} DocHardWrite(){}
DlgCreateBox(){}
DlgInvertRect(){}
DlgInnerCorner(){}
PaintIconicPart(){}
layline(){}
conv_i_p(){}
XmPutHourglass(){}
data_ptr AxfGetBluTime(){}
data_ptr AxfEncryptTime(){}
ElfbDEloadNewGadget(){}
ElfbCopyFileToClipboard(){}
ElfbCopyClipboardToFile(){}
data_ptr AxfDocHasLinks(){}
data_ptr AxfGetDocLinksInfo(){}
data_ptr AxfChangeDocLinksInfo(){}
data_ptr AxfLocalizeDocLinks(){}
ElfbLocalizeDoc(){}
data_ptr AxfGetAxLangDir(){}
data_ptr AxfGetAxLocalLangDir(){}
data_ptr AxfGetAxLangDemosDir(){}
ElfbListImages() {}
data_ptr AxfGetHostname() {}
ElfbTextDictLanguage() {}
data_ptr AxfGetDisplayVar() {}
ElfbAddressParse() {}
ElfbGadgetSizesFuncs() {}
data_ptr AxfAxStringFileName() {}
data_ptr ElfbTextSize() {}
data_ptr ElfbListScreenfonts() {}
ElfbDEscaleDialog() {}
ElfbReplaceSpace() {}
ElfbDeleteMessages() {}
ElfbGraphicFuncs() {}
ElfbMailBltins() {}
ElfbDestroyGraphic(){}
ElfbAssignGraphic(){}
ElfbCreateGraphic(){}
ElfbCreateBuilder(){}
ElfbReadGraphicBuffer(){}
ElfbReadGraphicFile(){}
ElfbReadRasterInfo(){}
data_ptr AxfSSUtil() {}
data_ptr AxfSSRegisterFunction(){}
AxSetElfAbortHandler() {}
ElfbPaintInsetObject(){}
ElfbCreateInsetImage(){}
ElfbDestroyInsetImage(){}
AxfMeasureInsetObject(){}
AxfMeasureInsetObjectArea(){}
AxfEncSetPasswd(){}
AxfEncDisable(){}
AxfNoteTaskInterested(){}
AxfCheckSpellingLibrary(){}
data_ptr AxfFormatDate_Str(){}
data_ptr AxfLockFile() {}
data_ptr AxfUnlockFile() {}
char *FSFilterDocToCurRev() {}
AxTempFile() {}
AxDeleteTempfile() {}
ElfbLoadGraphic(){}
data_ptr AxfFilterWpToAsciiLayout() {}
ElfbWriteGraphicBuffer(){}
ElfbWriteGraphicFile(){}
ElfbGetGraphic(){}
data_ptr AxfIsTask(){}
data_ptr AxfStringToBinary(){}
data_ptr AxfBinaryToString(){}
data_ptr AxfFontUtils(){}
ElfbCreateWpInstance(){}
ElfbDestroyWpInstance(){}
ElfbAssignWpInstance(){}
ElfbLoadWpInstance(){}
ElfbGetWpInstance(){}
ElfbReadWpInstanceBuffer(){}
ElfbReadWpInstanceFile(){}
ElfbWriteWpInstanceBuffer(){}
ElfbWriteWpInstanceFile(){}
ElfbWpxCall(){}
ElfbCreateInsetObject(){}
ElfbAddIconInsetObject(){}
data_ptr AxfMeasureWpInsetObjectCoords(){}

char *ThimFindUserName(){return(0);}
typeErr VfyHaveSetupsFile(){}

short CellWidDC, CellHtDC, CellUnder;


#undef getenv
char *THIMgetenv(p)
char *p;
{
	char *getenv();
	return(getenv(p));
}

char *qstr(n)
typeErr n;
{
    static char temp[200];
    StrGet(n,temp);
    return(temp);
}

/*************************************************************************
function: GenErrcodes - Generate error codes file
*/
GenErrcodes (name)
char *name;
{
    FILE *fp;
    int ix = ERR_BADONCALL;

#if SYS&VMSSYS
#define ES ix++;fprintf(fp,NXLT("define ERR#%s %d  ' %s\n"),
#else
#define ES ix++;fprintf(fp,NXLT("define ERR#%-20s %d  ' %s\n"),
#endif

    if(	(fp = fopen(name,"w")) == NULL)
		{/* file open failed */
		printf("ERROR: Unable to open the file %s.\n", name);
		printf("ERROR: Elf Errcodes file not created.\n"); 
		exit(1);
		} 
    ES NXLT("BAD_ONCALL_"),ERR_BADONCALL,qstr(ERR_BADONCALL));
    ES NXLT("BAD_ONGOTO_"),ERR_BADONGOTO,qstr(ERR_BADONGOTO));
    ES NXLT("ZERO_DIVIDE_"),ERR_ZERODIVIDE,qstr(ERR_ZERODIVIDE));
    ES NXLT("NEXT_WITHOUT_FOR_"),ERR_NEXTNOFOR,qstr(ERR_NEXTNOFOR));
    ES NXLT("NOT_LABEL_"),ERR_NOTLABEL,qstr(ERR_NOTLABEL));
    ES NXLT("NUM_TOO_BIG_"),ERR_CVTOVF,qstr(ERR_CVTOVF));
    ES NXLT("STACK_OVF_"),ERR_STACKOVF,qstr(ERR_STACKOVF));
    ES NXLT("NOT_A_VARIABLE_"),ERR_NOTVAR,qstr(ERR_NOTVAR));
    ES NXLT("NOT_A_FUNCTION_"),ERR_NOTFUNC,qstr(ERR_NOTFUNC));
    ES NXLT("FUNC_NO_EXISTS_"),ERR_FUNCNOEXISTS,qstr(ERR_FUNCNOEXISTS));
    ES NXLT("TOO_MANY_ARGS_"),ERR_ARGSTOOMANY,qstr(ERR_ARGSTOOMANY));
    ES NXLT("TOO_FEW_ARGS_"),ERR_ARGSTOOFEW,qstr(ERR_ARGSTOOFEW));
    ES NXLT("CANNOT_OPEN_"),ERR_NOOPEN,qstr(ERR_NOOPEN));
    ES NXLT("CANNOT_READ_"),ERR_NOREAD,qstr(ERR_NOREAD));
    ES NXLT("NOT_CMD_FILE_"),ERR_NOTELFFILE,qstr(ERR_NOTELFFILE));
    ES NXLT("CODE_FAILURE_"),ERR_WENTWEST,qstr(ERR_WENTWEST));
    ES NXLT("NOT_A_NUMBER_"),ERR_NOTNUMBER,qstr(ERR_NOTNUMBER));
    ES NXLT("NOT_A_STRING_"),ERR_NOTSTRING,qstr(ERR_NOTSTRING));
    ES NXLT("BAD_ARRAY_INDEX_"),ERR_BADARRDEX,qstr(ERR_BADARRDEX));
    ES NXLT("NOT_AN_ARRAY_"),ERR_NOTARRAY,qstr(ERR_NOTARRAY));
    ES NXLT("VAR_NO_EXISTS_"),ERR_VARNOEXISTS,qstr(ERR_VARNOEXISTS));
    ES NXLT("STR_TOO_LONG_"),ERR_STRTOOLONG,qstr(ERR_STRTOOLONG));
    ES NXLT("CANNOT_COMPILE_"),ERR_NOCOMPILE,qstr(ERR_NOCOMPILE));
    ES NXLT("BAD_CHANNEL_"),ERR_BADCHANNEL,qstr(ERR_BADCHANNEL));
    ES NXLT("IPC_TOO_BIG_"),ERR_IPCTOOBIG,qstr(ERR_IPCTOOBIG));
    ES NXLT("IPC_BAD_CTL_"),ERR_IPCBADCTL,qstr(ERR_IPCBADCTL));
    ES NXLT("IPC_NODATA_"),ERR_IPCNODATA,qstr(ERR_IPCNODATA));
    ES NXLT("IPC_NOT_HELPER_"),ERR_NOTHELPER,qstr(ERR_NOTHELPER));
    ES NXLT("IPC_BAD_CMD_"),ERR_NOTCMD,qstr(ERR_NOTCMD));
    ES NXLT("TOO_MANY_WINDOWS_"),ERR_TOOMANYWIDS,qstr(ERR_TOOMANYWIDS));
    ES NXLT("IN_CMD_MODE_"),ERR_INCMDMODE,qstr(ERR_INCMDMODE));
    ES NXLT("BAD_WINDOW_"),ERR_BADWINDOW,qstr(ERR_BADWINDOW));
    ES NXLT("ELF_RELOAD_"),ERR_ELFRELOAD,qstr(ERR_ELFRELOAD));
    ES NXLT("FILE_OPEN_"),ERR_FILEOPEN,qstr(ERR_FILEOPEN));
    ES NXLT("BAD_FILE_MODE_"),ERR_BADFILMODE,qstr(ERR_BADFILMODE));
    ES NXLT("FILE_NOT_OPEN_"),ERR_FILENOPEN,qstr(ERR_FILENOPEN));
    ES NXLT("TOO_MANY_FILES_"),ERR_FILTOOMANY,qstr(ERR_FILTOOMANY));
    ES NXLT("CANNOT_WRITE_"),ERR_NOWRITE,qstr(ERR_NOWRITE));
    ES NXLT("ILLVAL_"),ERR_ILLVAL,qstr(ERR_ILLVAL));
    ES NXLT("ESCAPE_"),ERR_ESCAPE,qstr(ERR_ESCAPE));
    ES NXLT("NO_WINDOW_"),ERR_NOWINDOW,qstr(ERR_NOWINDOW));
    ES NXLT("NO_FIELD_READ_"),ERR_NOFIELDREAD,qstr(ERR_NOFIELDREAD));
    ES NXLT("WRONG_MENU_"),ERR_WRONGMENU,qstr(ERR_WRONGMENU));
    ES NXLT("BAD_DOC_NAME_"),ERR_DOCBADNAME,qstr(ERR_DOCBADNAME));
    ES NXLT("RECURSIVE_"),ERR_RECURS,qstr(ERR_RECURS));
    ES NXLT("NOT_A_COMMAND_"),ERR_NOTCOMMAND,qstr(ERR_NOTCOMMAND));
    ES NXLT("NOT_CMD_DOC_"),ERR_NOTCMDDOC,qstr(ERR_NOTCMDDOC));
    ES NXLT("APPLIX_NAME_"),ERR_MYNAME,qstr(ERR_MYNAME));
    ES NXLT("RESERVED_"),ERR_RSVDWORD,qstr(ERR_RSVDWORD));
    ES NXLT("KEYWORD_"),ERR_KEYWORD,qstr(ERR_KEYWORD));
    ES NXLT("BAD_NAME_"),ERR_BADNAME,qstr(ERR_BADNAME));
    ES NXLT("ARRAY_TOO_BIG_"),ERR_ARRTOOBIG,qstr(ERR_ARRTOOBIG));
    ES NXLT("ARITHMETIC_"),ERR_ARITHMETIC,qstr(ERR_ARITHMETIC));
    ES NXLT("WIN_TOOBIG_"),ERR_WINTOOBIG,qstr(ERR_WINTOOBIG));
    ES NXLT("NOMEMORY_"),ERR_NOMEMORY,qstr(ERR_NOMEMORY));
    ES NXLT("NOSWAPSPACE_"),ERR_NOSWAPSPACE,qstr(ERR_NOSWAPSPACE));
    ES NXLT("NORECURSION_"),ERR_NORECURSE,qstr(ERR_NORECURSE));
    ES NXLT("BADSTEP_"),ERR_BADSTEP,qstr(ERR_BADSTEP));
	ES NXLT("ERR_NOHELPATALL_"),ERR_NOHELPATALL,qstr(ERR_NOHELPATALL));
	ES NXLT("ERR_NOHELP_"),ERR_NOHELP,qstr(ERR_NOHELP));
	ES NXLT("ERR_PRINTERNAME_"),ERR_PRINTERNAME,qstr(ERR_PRINTERNAME));
	ES NXLT("ERR_BADREV_"),ERR_BADREV,qstr(ERR_BADREV));
	ES NXLT("ERR_NOIMAGE_"),ERR_NOIMAGE,qstr(ERR_NOIMAGE));
	ES NXLT("ERR_BADMACHINE_"),ERR_BADMACHINE,qstr(ERR_BADMACHINE));
	ES NXLT("ERR_BADPFNAME_"),ERR_BADPFNAME,qstr(ERR_BADPFNAME));
	ES NXLT("ERR_BADCOPIES_"),ERR_BADCOPIES,qstr(ERR_BADCOPIES));
	ES NXLT("ERR_PRTBADPAGES_"),ERR_PRTBADPAGES,qstr(ERR_PRTBADPAGES));
	ES NXLT("ERR_BADACCEL_"),ERR_BADACCEL,qstr(ERR_BADACCEL));
	ES NXLT("ERR_DUPACCEL_"),ERR_DUPACCEL,qstr(ERR_DUPACCEL));
	ES NXLT("ERR_BIGSRCH_"),ERR_BIGSRCH,qstr(ERR_BIGSRCH));
	ES NXLT("ERR_PRINTJOB_"),ERR_PRINTJOB,qstr(ERR_PRINTJOB));
	ES NXLT("ERR_DUPMNEMONIC_"),ERR_DUPMNEMONIC,qstr(ERR_DUPMNEMONIC));
	ES NXLT("ERR_NORECORD_"),ERR_NORECORD,qstr(ERR_NORECORD));
	ES NXLT("ERR_CANTINDENT_"),ERR_CANTINDENT,qstr(ERR_CANTINDENT));
	ES NXLT("ERR_BADHEIGHT_"),ERR_BADHEIGHT,qstr(ERR_BADHEIGHT));
	ES NXLT("ERR_BADWIDTH_"),ERR_BADWIDTH,qstr(ERR_BADWIDTH));
	ES NXLT("ERR_UNEXPECTED_"),ERR_UNEXPECTED,qstr(ERR_UNEXPECTED));
	ES NXLT("ERR_NOTOBJECT_"),ERR_NOTOBJECT,qstr(ERR_NOTOBJECT));
	ES NXLT("ERR_METHNOTINOBJECT_"),ERR_METHNOTINOBJECT,qstr(ERR_METHNOTINOBJECT));
	ES NXLT("ERR_OBJNOTINOBJECT_"),ERR_OBJNOTINOBJECT,qstr(ERR_OBJNOTINOBJECT));
	ES NXLT("ERR_OBJECTGONE_"),ERR_OBJECTGONE,qstr(ERR_OBJECTGONE));
	ES NXLT("ERR_SQLTOOMANYSTMTS_"),ERR_SQLTOOMANYSTMTS,qstr(ERR_SQLTOOMANYSTMTS));
	ES NXLT("ERR_SQLUPDATE_"),ERR_SQLUPDATE,qstr(ERR_SQLUPDATE));
	ES NXLT("ERR_SQLMEMORY_"),ERR_SQLMEMORY,qstr(ERR_SQLMEMORY));
	ES NXLT("ERR_SQLSTMTID_"),ERR_SQLSTMTID,qstr(ERR_SQLSTMTID));
	ES NXLT("ERR_SQLCURSID_"),ERR_SQLCURSID,qstr(ERR_SQLCURSID));
	ES NXLT("ERR_SQLSERVER_"),ERR_SQLSERVER,qstr(ERR_SQLSERVER));
	ES NXLT("ERR_SQLTIMEOUT_"),ERR_SQLTIMEOUT,qstr(ERR_SQLTIMEOUT));
	ES NXLT("ERR_SQLDATATYPE_"),ERR_SQLDATATYPE,qstr(ERR_SQLDATATYPE));
	ES NXLT("ERR_SQLFETCH_"),ERR_SQLFETCH,qstr(ERR_SQLFETCH));
	ES NXLT("ERR_SQLGATEWAY_"),ERR_SQLGATEWAY,qstr(ERR_SQLGATEWAY));
	ES NXLT("ERR_SQLERRNO_"),ERR_SQLERRNO,qstr(ERR_SQLERRNO));
	ES NXLT("ERR_SQLARGS_"),ERR_SQLARGS,qstr(ERR_SQLARGS));
	ES NXLT("ERR_SQLINTERRUPT_"),ERR_SQLINTERRUPT,qstr(ERR_SQLINTERRUPT));
	ES NXLT("ERR_SQLDEADLOCK_"),ERR_SQLDEADLOCK,qstr(ERR_SQLDEADLOCK));
	ES NXLT("ERR_SQLODBC_"),ERR_SQLODBC,qstr(ERR_SQLODBC));
	ES NXLT("ERR_OTHER"),ERR_OTHER,qstr(ERR_OTHER));
	if ( ix != ERR_UNUSED ) { printf("Need to edit eltest.c\n");abort();}
	ES NXLT("ERR_FEEPERM_"),FEEPERM,qstr(FEEPERM));
	ES NXLT("ERR_FEENOENT_"),FEENOENT,qstr(FEENOENT));
	ES NXLT("ERR_FEESRCH_"),FEESRCH,qstr(FEESRCH));
	ES NXLT("ERR_FEEINTR_"),FEEINTR,qstr(FEEINTR));
	ES NXLT("ERR_FEEIO_"),FEEIO,qstr(FEEIO));
	ES NXLT("ERR_FEENXIO_"),FEENXIO,qstr(FEENXIO));
	ES NXLT("ERR_FEE2BIG_"),FEE2BIG,qstr(FEE2BIG));
	ES NXLT("ERR_FEENOEXEC_"),FEENOEXEC,qstr(FEENOEXEC));
	ES NXLT("ERR_FEEBADF_"),FEEBADF,qstr(FEEBADF));
	ES NXLT("ERR_FEECHILD_"),FEECHILD,qstr(FEECHILD));
	ES NXLT("ERR_FEEAGAIN_"),FEEAGAIN,qstr(FEEAGAIN));
	ES NXLT("ERR_FEENOMEM_"),FEENOMEM,qstr(FEENOMEM));
	ES NXLT("ERR_FEEACCES_"),FEEACCES,qstr(FEEACCES));
	ES NXLT("ERR_FEEFAULT_"),FEEFAULT,qstr(FEEFAULT));
	ES NXLT("ERR_FEENOTBLK_"),FEENOTBLK,qstr(FEENOTBLK));
	ES NXLT("ERR_FEEBUSY_"),FEEBUSY,qstr(FEEBUSY));
	ES NXLT("ERR_FEEEXIST_"),FEEEXIST,qstr(FEEEXIST));
	ES NXLT("ERR_FEEXDEV_"),FEEXDEV,qstr(FEEXDEV));
	ES NXLT("ERR_FEENODEV_"),FEENODEV,qstr(FEENODEV));
	ES NXLT("ERR_FEENOTDIR_"),FEENOTDIR,qstr(FEENOTDIR));
	ES NXLT("ERR_FEEISDIR_"),FEEISDIR,qstr(FEEISDIR));
	ES NXLT("ERR_FEEINVAL_"),FEEINVAL,qstr(FEEINVAL));
	ES NXLT("ERR_FEENFILE_"),FEENFILE,qstr(FEENFILE));
	ES NXLT("ERR_FEEMFILE_"),FEEMFILE,qstr(FEEMFILE));
	ES NXLT("ERR_FEENOTTY_"),FEENOTTY,qstr(FEENOTTY));
	ES NXLT("ERR_FEETXTBSY_"),FEETXTBSY,qstr(FEETXTBSY));
	ES NXLT("ERR_FEEFBIG_"),FEEFBIG,qstr(FEEFBIG));
	ES NXLT("ERR_FEENOSPC_"),FEENOSPC,qstr(FEENOSPC));
	ES NXLT("ERR_FEESPIPE_"),FEESPIPE,qstr(FEESPIPE));
	ES NXLT("ERR_FEEROFS_"),FEEROFS,qstr(FEEROFS));
	ES NXLT("ERR_FEEMLINK_"),FEEMLINK,qstr(FEEMLINK));
	ES NXLT("ERR_FEEPIPE_"),FEEPIPE,qstr(FEEPIPE));
	ES NXLT("ERR_FEEDOM_"),FEEDOM,qstr(FEEDOM));
	ES NXLT("ERR_FEERANGE_"),FEERANGE,qstr(FEERANGE));
	ES NXLT("ERR_FEEWOULDBLOCK_"),FEEWOULDBLOCK,qstr(FEEWOULDBLOCK));
	ES NXLT("ERR_FEEINPROGRESS_"),FEEINPROGRESS,qstr(FEEINPROGRESS));
	ES NXLT("ERR_FEEALREADY_"),FEEALREADY,qstr(FEEALREADY));
	ES NXLT("ERR_FEENOTSOCK_"),FEENOTSOCK,qstr(FEENOTSOCK));
	ES NXLT("ERR_FEEDESTADDRREQ_"),FEEDESTADDRREQ,qstr(FEEDESTADDRREQ));
	ES NXLT("ERR_FEEMSGSIZE_"),FEEMSGSIZE,qstr(FEEMSGSIZE));
	ES NXLT("ERR_FEEPROTOTYPE_"),FEEPROTOTYPE,qstr(FEEPROTOTYPE));
	ES NXLT("ERR_FEENOPROTOOPT_"),FEENOPROTOOPT,qstr(FEENOPROTOOPT));
	ES NXLT("ERR_FEEPROTONOSUPPORT_"),FEEPROTONOSUPPORT,qstr(FEEPROTONOSUPPORT));
	ES NXLT("ERR_FEESOCKTNOSUPPORT_"),FEESOCKTNOSUPPORT,qstr(FEESOCKTNOSUPPORT));
	ES NXLT("ERR_FEEOPNOTSUPP_"),FEEOPNOTSUPP,qstr(FEEOPNOTSUPP));
	ES NXLT("ERR_FEEPFNOSUPPORT_"),FEEPFNOSUPPORT,qstr(FEEPFNOSUPPORT));
	ES NXLT("ERR_FEEAFNOSUPPORT_"),FEEAFNOSUPPORT,qstr(FEEAFNOSUPPORT));
	ES NXLT("ERR_FEEADDRINUSE_"),FEEADDRINUSE,qstr(FEEADDRINUSE));
	ES NXLT("ERR_FEEADDRNOTAVAIL_"),FEEADDRNOTAVAIL,qstr(FEEADDRNOTAVAIL));
	ES NXLT("ERR_FEENETDOWN_"),FEENETDOWN,qstr(FEENETDOWN));
	ES NXLT("ERR_FEENETUNREACH_"),FEENETUNREACH,qstr(FEENETUNREACH));
	ES NXLT("ERR_FEENETRESET_"),FEENETRESET,qstr(FEENETRESET));
	ES NXLT("ERR_FEECONNABORTED_"),FEECONNABORTED,qstr(FEECONNABORTED));
	ES NXLT("ERR_FEECONNRESET_"),FEECONNRESET,qstr(FEECONNRESET));
	ES NXLT("ERR_FEENOBUFS_"),FEENOBUFS,qstr(FEENOBUFS));
	ES NXLT("ERR_FEEISCONN_"),FEEISCONN,qstr(FEEISCONN));
	ES NXLT("ERR_FEENOTCONN_"),FEENOTCONN,qstr(FEENOTCONN));
	ES NXLT("ERR_FEESHUTDOWN_"),FEESHUTDOWN,qstr(FEESHUTDOWN));
	ES NXLT("ERR_FEETOOMANYREFS_"),FEETOOMANYREFS,qstr(FEETOOMANYREFS));
	ES NXLT("ERR_FEETIMEDOUT_"),FEETIMEDOUT,qstr(FEETIMEDOUT));
	ES NXLT("ERR_FEECONNREFUSED_"),FEECONNREFUSED,qstr(FEECONNREFUSED));
	ES NXLT("ERR_FEELOOP_"),FEELOOP,qstr(FEELOOP));
	ES NXLT("ERR_FEENAMETOOLONG_"),FEENAMETOOLONG,qstr(FEENAMETOOLONG));
	ES NXLT("ERR_FEEHOSTDOWN_"),FEEHOSTDOWN,qstr(FEEHOSTDOWN));
	ES NXLT("ERR_FEEHOSTUNREACH_"),FEEHOSTUNREACH,qstr(FEEHOSTUNREACH));
	ES NXLT("ERR_FEENOTEMPTY_"),FEENOTEMPTY,qstr(FEENOTEMPTY));
	ES NXLT("ERR_FEEPROCLIM_"),FEEPROCLIM,qstr(FEEPROCLIM));
	ES NXLT("ERR_FEEUSERS_"),FEEUSERS,qstr(FEEUSERS));
	ES NXLT("ERR_FEEDQUOT_"),FEEDQUOT,qstr(FEEDQUOT));
	ES NXLT("ERR_FEESTALE_"),FEESTALE,qstr(FEESTALE));
	ES NXLT("ERR_FEEREMOTE_"),FEEREMOTE,qstr(FEEREMOTE));
	ES NXLT("ERR_FEENOSTR_"),FEENOSTR,qstr(FEENOSTR));
	ES NXLT("ERR_FEETIME_"),FEETIME,qstr(FEETIME));
	ES NXLT("ERR_FEENOSR_"),FEENOSR,qstr(FEENOSR));
	ES NXLT("ERR_FEENOMSG_"),FEENOMSG,qstr(FEENOMSG));
	ES NXLT("ERR_FEEBADMSG_"),FEEBADMSG,qstr(FEEBADMSG));
	ES NXLT("ERR_FEEIDRM_"),FEEIDRM,qstr(FEEIDRM));
	ES NXLT("ERR_FEEDEADLK_"),FEEDEADLK,qstr(FEEDEADLK));
	ES NXLT("ERR_FEENOLCK_"),FEENOLCK,qstr(FEENOLCK));
	ES NXLT("ERR_FEnotDoc_"),FEnotDoc,qstr(FEnotDoc));
	ES NXLT("ERR_FEnoDir_"),FEnoDir,qstr(FEnoDir));
	ES NXLT("ERR_FEnotRightSfx_"),FEnotRightSfx,qstr(FEnotRightSfx));
	ES NXLT("ERR_FEBadType_"),FEBadType,qstr(FEBadType));
	ES NXLT("ERR_FEalreadyOpen_"),FEalreadyOpen,qstr(FEalreadyOpen));
	ES NXLT("ERR_FEnoDelOpen_"),FEnoDelOpen,qstr(FEnoDelOpen));
	ES NXLT("ERR_FEBadDoc_"),FEBadDoc,qstr(FEBadDoc));
	ES NXLT("ERR_FEtooLong_"),FEtooLong,qstr(FEtooLong));
	ES NXLT("ERR_FEnameSpaces_"),FEnameSpaces,qstr(FEnameSpaces));
	ES NXLT("ERR_FEBadName_"),FEBadName,qstr(FEBadName));
	ES NXLT("ERR_FEbadMachine_"),FEbadMachine,qstr(FEbadMachine));
	ES NXLT("ERR_FEbadEntryName_"),FEbadEntryName,qstr(FEbadEntryName));
    if(0 != fclose(fp))
		{/* file close failed */
		printf("ERROR: Unable to close the file %s.\n", name);
		printf("ERROR: Elf Errcodes file not created.\n"); 
		exit(1);
		}
}

/************************************************************************
function GenSSErrcodes() generated the errcode file for SS
*/
GenSSErrcodes (name)
char *name;
{
    FILE *fp;

#if SYS&VMSSYS
#define SSES fprintf(fp,NXLT("define SSERR#%s %d  ' %s\n"),
#else
#define SSES fprintf(fp,NXLT("define SSERR#%-20s %d  ' %s\n"),
#endif

    if( (fp = fopen(name,"w")) == NULL)
		{/* file open failed */
		printf("ERROR: Unable to open the file %s.",name);
		printf("ERROR: SS Elf Errcodes file not created.\n");
		exit(1);
		}
	SSES NXLT("PRSNONAME_"),PRSNONAME,qstr(PRSNONAME));
	SSES NXLT("INVSELECTION_"),INVSELECTION,qstr(INVSELECTION));
	SSES NXLT("NORNGMARKED_"),NORNGMARKED,qstr(NORNGMARKED));
	SSES NXLT("NOINSPT_"),NOINSPT,qstr(NOINSPT));
	SSES NXLT("PSTONEPLACE_"),PSTONEPLACE,qstr(PSTONEPLACE));
	SSES NXLT("GRPHEXISTS_"),GRPHEXISTS,qstr(GRPHEXISTS));
	SSES NXLT("GRPHACTIVE_"),GRPHACTIVE,qstr(GRPHACTIVE));
	SSES NXLT("GRPHLOST_"),GRPHLOST,qstr(GRPHLOST));
	SSES NXLT("VLDWIDTHS_"),VLDWIDTHS,qstr(VLDWIDTHS));
	SSES NXLT("GOTONOMORE_"),GOTONOMORE,qstr(GOTONOMORE));
	SSES NXLT("LBLNOTFOUND_"),LBLNOTFOUND,qstr(LBLNOTFOUND));
	SSES NXLT("NOPREVGOTO_"),NOPREVGOTO,qstr(NOPREVGOTO));
	SSES NXLT("NOTVIEW_"),NOTVIEW,qstr(NOTVIEW));
	SSES NXLT("NAMEINVALID_"),NAMEINVALID,qstr(NAMEINVALID));
	SSES NXLT("NAMEEXISTS_"),NAMEEXISTS,qstr(NAMEEXISTS));
	SSES NXLT("NAMENFINDEX_"),NAMENFINDEX,qstr(NAMENFINDEX));
	SSES NXLT("GOALPREC_"),GOALPREC,qstr(GOALPREC));
	SSES NXLT("MVNOTED_"),MVNOTED,qstr(MVNOTED));
	SSES NXLT("RNGTOOBIG_"),RNGTOOBIG,qstr(RNGTOOBIG));
	SSES NXLT("NOTAVIEW_"),NOTAVIEW,qstr(NOTAVIEW));
	SSES NXLT("CHNGNAME_"),CHNGNAME,qstr(CHNGNAME));
	SSES NXLT("PRSNEEDOP_"),PRSNEEDOP,qstr(PRSNEEDOP));
	SSES NXLT("PRSOCPAREN_"),PRSOCPAREN,qstr(PRSOCPAREN));
	SSES NXLT("PRSUNXCOMMA_"),PRSUNXCOMMA,qstr(PRSUNXCOMMA));
	SSES NXLT("PRSUNXOPERATOR_"),PRSUNXOPERATOR,qstr(PRSUNXOPERATOR));
	SSES NXLT("PRSFNOP_"),PRSFNOP,qstr(PRSFNOP));
	SSES NXLT("PRSMISMPARENS_"),PRSMISMPARENS,qstr(PRSMISMPARENS));
	SSES NXLT("PRSNMBRCELL_"),PRSNMBRCELL,qstr(PRSNMBRCELL));
	SSES NXLT("PRSDECIMALS_"),PRSDECIMALS,qstr(PRSDECIMALS));
	SSES NXLT("PRSNBBAD_"),PRSNBBAD,qstr(PRSNBBAD));
	SSES NXLT("PRSUNKFUNC_"),PRSUNKFUNC,qstr(PRSUNKFUNC));
	SSES NXLT("PRSNMLONG_"),PRSNMLONG,qstr(PRSNMLONG));
	SSES NXLT("PRSROWNUM_"),PRSROWNUM,qstr(PRSROWNUM));
	SSES NXLT("PRSNOROW_"),PRSNOROW,qstr(PRSNOROW));
	SSES NXLT("PRSBDCELL_"),PRSBDCELL,qstr(PRSBDCELL));
	SSES NXLT("PRSTOOLONG_"),PRSTOOLONG,qstr(PRSTOOLONG));
	SSES NXLT("PRSBAPREDICT_"),PRSBAPREDICT,qstr(PRSBAPREDICT));
	SSES NXLT("GOALICFGVW_"),GOALICFGVW,qstr(GOALICFGVW));
	SSES NXLT("NOTINEDITMODE_"),NOTINEDITMODE,qstr(NOTINEDITMODE));
	SSES NXLT("EDITOOLONG_"),EDITOOLONG,qstr(EDITOOLONG));
	SSES NXLT("CELLPROTECTED_"),CELLPROTECTED,qstr(CELLPROTECTED));
	SSES NXLT("PASTEMPTY_"),PASTEMPTY,qstr(PASTEMPTY));
	SSES NXLT("TCOLSTOOMANY_"),TCOLSTOOMANY,qstr(TCOLSTOOMANY));
	SSES NXLT("TROWSTOOMANY_"),TROWSTOOMANY,qstr(TROWSTOOMANY));
	SSES NXLT("LDINGISR_"),LDINGISR,qstr(LDINGISR));
	SSES NXLT("ISRNONAME_"),ISRNONAME,qstr(ISRNONAME));
	SSES NXLT("XFERNEXISTS_"),XFERNEXISTS,qstr(XFERNEXISTS));
	SSES NXLT("DOCEXISTS_"),DOCEXISTS,qstr(DOCEXISTS));
	SSES NXLT("CANTCREATE_"),CANTCREATE,qstr(CANTCREATE));
	SSES NXLT("DOCNOTFOUND_"),DOCNOTFOUND,qstr(DOCNOTFOUND));
	SSES NXLT("DOCBDTYPE_"),DOCBDTYPE,qstr(DOCBDTYPE));
	SSES NXLT("HDALLCOLS_"),HDALLCOLS,qstr(HDALLCOLS));
	SSES NXLT("HDALLROWS_"),HDALLROWS,qstr(HDALLROWS));
	SSES NXLT("PRSNUMTOOSML_"),PRSNUMTOOSML,qstr(PRSNUMTOOSML));
	SSES NXLT("VCPROBLEM_"),VCPROBLEM,qstr(VCPROBLEM));
	SSES NXLT("VCCANTOPEN_"),VCCANTOPEN,qstr(VCCANTOPEN));
	SSES NXLT("PRSBAISERROR_"),PRSBAISERROR,qstr(PRSBAISERROR));
	SSES NXLT("PRSBANA_"),PRSBANA,qstr(PRSBANA));
	SSES NXLT("PROTOVER_"),PROTOVER,qstr(PROTOVER));
	SSES NXLT("MAILEDOLD_"),MAILEDOLD,qstr(MAILEDOLD));
	SSES NXLT("PRINTDOLD_"),PRINTDOLD,qstr(PRINTDOLD));
	SSES NXLT("READABD_"),READABD,qstr(READABD));
	SSES NXLT("TOOMRTITLED_"),TOOMRTITLED,qstr(TOOMRTITLED));
	SSES NXLT("TOOMCTITLED_"),TOOMCTITLED,qstr(TOOMCTITLED));
	SSES NXLT("HDNPROTOVER_"),HDNPROTOVER,qstr(HDNPROTOVER));
	SSES NXLT("HDNOVER_"),HDNOVER,qstr(HDNOVER));
	SSES NXLT("NOSTATHELP_"),NOSTATHELP,qstr(NOSTATHELP));
	SSES NXLT("NOMRKGOTO_"),NOMRKGOTO,qstr(NOMRKGOTO));
	SSES NXLT("ONLY4GRAPHS_"),ONLY4GRAPHS,qstr(ONLY4GRAPHS));
	SSES NXLT("PARTIALGRAPH_"),PARTIALGRAPH,qstr(PARTIALGRAPH));
	SSES NXLT("CANNOTINIT_"),CANNOTINIT,qstr(CANNOTINIT));
	SSES NXLT("DOCROACHED_"),DOCROACHED,qstr(DOCROACHED));
	SSES NXLT("ISLOCKED_"),ISLOCKED,qstr(ISLOCKED));
	SSES NXLT("NOALLCURVIEW_"),NOALLCURVIEW,qstr(NOALLCURVIEW));
	SSES NXLT("NOPROCBG_"),NOPROCBG,qstr(NOPROCBG));
	SSES NXLT("ILLDOCNAME_"),ILLDOCNAME,qstr(ILLDOCNAME));
	SSES NXLT("ILLVIEWNAME_"),ILLVIEWNAME,qstr(ILLVIEWNAME));
	SSES NXLT("PRSNUMTOOBIG_"),PRSNUMTOOBIG,qstr(PRSNUMTOOBIG));
	SSES NXLT("READONLYFONT_"),READONLYFONT,qstr(READONLYFONT));
	SSES NXLT("NOACCESSDOC_"),NOACCESSDOC,qstr(NOACCESSDOC));
	SSES NXLT("SSWRITTEN_"),SSWRITTEN,qstr(SSWRITTEN));
	SSES NXLT("READWARN_"),READWARN,qstr(READWARN));
	SSES NXLT("FORREAD_"),FORREAD,qstr(FORREAD));
	SSES NXLT("NOMRKEMPTY_"),NOMRKEMPTY,qstr(NOMRKEMPTY));
	SSES NXLT("GNOCRTRDONLY_"),GNOCRTRDONLY,qstr(GNOCRTRDONLY));
	SSES NXLT("COPYNOTED_"),COPYNOTED,qstr(COPYNOTED));
	SSES NXLT("NOCUTRANGE_"),NOCUTRANGE,qstr(NOCUTRANGE));
	SSES NXLT("INSCOUNT1001_"),INSCOUNT1001,qstr(INSCOUNT1001));
	SSES NXLT("DOCREADONLY_"),DOCREADONLY,qstr(DOCREADONLY));
	SSES NXLT("NOUNDO_"),NOUNDO,qstr(NOUNDO));
	SSES NXLT("GOALINEMPTY_"),GOALINEMPTY,qstr(GOALINEMPTY));
	SSES NXLT("GOALOTEMPTY_"),GOALOTEMPTY,qstr(GOALOTEMPTY));
	SSES NXLT("GOALINNOGOOD_"),GOALINNOGOOD,qstr(GOALINNOGOOD));
	SSES NXLT("GOALOTNOGOOD_"),GOALOTNOGOOD,qstr(GOALOTNOGOOD));
	SSES NXLT("GOAL_UNRELATED_"),GOAL_UNRELATED,qstr(GOAL_UNRELATED));
	SSES NXLT("GOAL_IMPOSSIBLE_"),GOAL_IMPOSSIBLE,qstr(GOAL_IMPOSSIBLE));
	SSES NXLT("GOAL_UNAPPROACHABLE_"),GOAL_UNAPPROACHABLE,qstr(GOAL_UNAPPROACHABLE));
	SSES NXLT("BAD1GOAL_"),BAD1GOAL,qstr(BAD1GOAL));
	SSES NXLT("BAD2GOAL_"),BAD2GOAL,qstr(BAD2GOAL));
	SSES NXLT("BAD3GOAL_"),BAD3GOAL,qstr(BAD3GOAL));
	SSES NXLT("HLPCONST_"),HLPCONST,qstr(HLPCONST));
	SSES NXLT("BADSSIMPORT_"),BADSSIMPORT,qstr(BADSSIMPORT));
	SSES NXLT("NOCVTRDONLY_"),NOCVTRDONLY,qstr(NOCVTRDONLY));
	SSES NXLT("INSPURGED_"),INSPURGED,qstr(INSPURGED));
	SSES NXLT("INSNAV_"),INSNAV,qstr(INSNAV));
	SSES NXLT("INSNOVIEW_"),INSNOVIEW,qstr(INSNOVIEW));
	SSES NXLT("FILETOOBIG_"),FILETOOBIG,qstr(FILETOOBIG));
	SSES NXLT("IDXWHRISR_"),IDXWHRISR,qstr(IDXWHRISR));
	SSES NXLT("HLPOBS_"),HLPOBS,qstr(HLPOBS));
	SSES NXLT("CLCERRTOKEN_"),CLCERRTOKEN,qstr(CLCERRTOKEN));
	SSES NXLT("WCELLOFFGRID_"),WCELLOFFGRID,qstr(WCELLOFFGRID));
	SSES NXLT("BACKISRPROC_"),BACKISRPROC,qstr(BACKISRPROC));
	SSES NXLT("DEFAULTMSG_"),DEFAULTMSG,qstr(DEFAULTMSG));
	SSES NXLT("SSIMPFILEERR_"),SSIMPFILEERR,qstr(SSIMPFILEERR));
	SSES NXLT("SSIMPNOFILE_"),SSIMPNOFILE,qstr(SSIMPNOFILE));
	SSES NXLT("SSIMPFAIL_"),SSIMPFAIL,qstr(SSIMPFAIL));
	SSES NXLT("SSIMPBADTYPE_"),SSIMPBADTYPE,qstr(SSIMPBADTYPE));
	SSES NXLT("SSBADCVT_"),SSBADCVT,qstr(SSBADCVT));
	SSES NXLT("SSCONVERT_"),SSCONVERT,qstr(SSCONVERT));
	SSES NXLT("SSNOTSUPPORTED_"),SSNOTSUPPORTED,qstr(SSNOTSUPPORTED));
	SSES NXLT("BEYONDBOUNDS_"),BEYONDBOUNDS,qstr(BEYONDBOUNDS));
	SSES NXLT("UNABLEACCESS_"),UNABLEACCESS,qstr(UNABLEACCESS));
	SSES NXLT("SSTOOMANY_"),SSTOOMANY,qstr(SSTOOMANY));
	SSES NXLT("GRPHARCVD_"),GRPHARCVD,qstr(GRPHARCVD));
	SSES NXLT("ISRARCVD_"),ISRARCVD,qstr(ISRARCVD));
	SSES NXLT("CONV110SS_"),CONV110SS,qstr(CONV110SS));
	SSES NXLT("BADREVMOD_"),BADREVMOD,qstr(BADREVMOD));
	SSES NXLT("NOCONVERT_"),NOCONVERT,qstr(NOCONVERT));
	SSES NXLT("ISRIMPORT_"),ISRIMPORT,qstr(ISRIMPORT));
	SSES NXLT("PARTIALMKS_"),PARTIALMKS,qstr(PARTIALMKS));
	SSES NXLT("CRTFRMTAB_"),CRTFRMTAB,qstr(CRTFRMTAB));
	SSES NXLT("NO_EMPTY_PROT_"),NO_EMPTY_PROT,qstr(NO_EMPTY_PROT));
	SSES NXLT("NO_DELETE_PROT_"),NO_DELETE_PROT,qstr(NO_DELETE_PROT));
	SSES NXLT("FILL_BOGUS_"),FILL_BOGUS,qstr(FILL_BOGUS));
	SSES NXLT("FILL_PARTIAL_"),FILL_PARTIAL,qstr(FILL_PARTIAL));
	SSES NXLT("ULCLEAR_"),ULCLEAR,qstr(ULCLEAR));
	SSES NXLT("ULNMCREATE_"),ULNMCREATE,qstr(ULNMCREATE));
	SSES NXLT("ULNMDELETE_"),ULNMDELETE,qstr(ULNMDELETE));
	SSES NXLT("ULNMCHANGE_"),ULNMCHANGE,qstr(ULNMCHANGE));
	SSES NXLT("ULXREFCRE_"),ULXREFCRE,qstr(ULXREFCRE));
	SSES NXLT("ULXREFDEL_"),ULXREFDEL,qstr(ULXREFDEL));
	SSES NXLT("ULXREFCHG_"),ULXREFCHG,qstr(ULXREFCHG));
	SSES NXLT("SSTOOSMALL_"),SSTOOSMALL,qstr(SSTOOSMALL));
	SSES NXLT("SSIMPBADNAME_"),SSIMPBADNAME,qstr(SSIMPBADNAME));
	SSES NXLT("SSIMPBADNDATA_"),SSIMPBADNDATA,qstr(SSIMPBADNDATA));
	SSES NXLT("PRS_NUMOUTOFRANGE_"),PRS_NUMOUTOFRANGE,qstr(PRS_NUMOUTOFRANGE));
	SSES NXLT("ERNOTRANSFER_"),ERNOTRANSFER,qstr(ERNOTRANSFER));
	SSES NXLT("RESULT_OUTOFRANGE_"),RESULT_OUTOFRANGE,qstr(RESULT_OUTOFRANGE));
	SSES NXLT("FILLVAL_OUTOFRANGE_"),FILLVAL_OUTOFRANGE,qstr(FILLVAL_OUTOFRANGE));
	SSES NXLT("FILLSTART_OUTOFRANGE_"),FILLSTART_OUTOFRANGE,qstr(FILLSTART_OUTOFRANGE));
	SSES NXLT("FILLSTOP_OUTOFRANGE_"),FILLSTOP_OUTOFRANGE,qstr(FILLSTOP_OUTOFRANGE));
	SSES NXLT("FILLINC_OUTOFRANGE_"),FILLINC_OUTOFRANGE,qstr(FILLINC_OUTOFRANGE));
	SSES NXLT("VLDITRCOUNT_"),VLDITRCOUNT,qstr(VLDITRCOUNT));
	SSES NXLT("DELTITLEROWS_"),DELTITLEROWS,qstr(DELTITLEROWS));
	SSES NXLT("DELTITLECOLS_"),DELTITLECOLS,qstr(DELTITLECOLS));
	SSES NXLT("NO_OVER_PROT_"),NO_OVER_PROT,qstr(NO_OVER_PROT));
	SSES NXLT("NO_PAGEBREAKS_"),NO_PAGEBREAKS,qstr(NO_PAGEBREAKS));
	SSES NXLT("MISSING_LINKEDFILE_"),MISSING_LINKEDFILE,qstr(MISSING_LINKEDFILE));
	SSES NXLT("ISRNOTALLOWED1_"),ISRNOTALLOWED1,qstr(ISRNOTALLOWED1));
	SSES NXLT("ISRNOTALLOWED2_"),ISRNOTALLOWED2,qstr(ISRNOTALLOWED2));
	SSES NXLT("PRSBALFIT1_"),PRSBALFIT1,qstr(PRSBALFIT1));
	SSES NXLT("PRSBALFIT2_"),PRSBALFIT2,qstr(PRSBALFIT2));
	SSES NXLT("PRSSTRFOL_"),PRSSTRFOL,qstr(PRSSTRFOL));
	SSES NXLT("PRSUNXSTR_"),PRSUNXSTR,qstr(PRSUNXSTR));
	SSES NXLT("PRSMISQUOTE_"),PRSMISQUOTE,qstr(PRSMISQUOTE));
	SSES NXLT("INSNODATA_"),INSNODATA,qstr(INSNODATA));
	SSES NXLT("VIEWNOTOK_"),VIEWNOTOK,qstr(VIEWNOTOK));
	SSES NXLT("SELFREFERROR_"),SELFREFERROR,qstr(SELFREFERROR));
	if(0 != fclose(fp))
		{/* file close failed */
		printf("ERROR: Unable to close the file %s.",name);
		printf("ERROR: SS Errcodes file not created.\n");
		exit(1);
		}
}



char *TrueMalloc(n)
int n;
{
    return((char*)malloc(n));
}
char *TrueRealloc(p,n)
char *p;
int n;
{
    return((char*)realloc(p,n));
}
TrueFree(p)
char *p;
{
    free(p);
}

ElfbStatusMessage(){}
DocTypeFromName(){}

/*************************************************************************
function: ErrnoTextFromUnix - Read Unix errno text
*/
char *ErrnoTextFromUnix (err)
int err;
{
    static char *buf;
#if !LINUX
    extern char *sys_errlist[];
#endif
    extern int sys_nerr;

    if ( err < sys_nerr )
        return((char*)sys_errlist[err]);	/* cast away the 'const' */
	buf = (char *)malloc(300);
	sprintf(buf,"err %d",err);
	return(buf);
}

int ThimLogEvents;
XWINSlog(){}
acceptKeyIn(){}
THIMexitWithStr(){exit(0);}

char *XLT( str )
char *str;
{
    return( str );
}


char *XLT2( tag,str)
char *tag;
char *str;
{
     return( str );
}


char *PermAlloc(size)
int size;
{
	return((char*)malloc(size));
}

ParseNum(code,str,junk,retval)
int code, junk;
char *str;
double *retval;
{
	double atof();
	*retval = atof(str);
	return(TRUE);
}

tempAbort(str)
char *str;
{
	printf("%s\n",str);
	exit(1);
}

#if NO_VARARGS
void AxLogger(s,a,b,c,d,e,f,g,h,i,j,k)
char *s;
char *a,b,c,d,e,f,g,h,i,j,k;
{
	printf(s,a,b,c,d,e,f,g,h,i,j,k);
}
#else
int vAxLogger(fmt, args)
  char *fmt;
  va_list args;
{
  if (*fmt)
    vfprintf(stdout, fmt, args);
  else fprintf(stdout, "AxLogger: internal error!\n");
  fflush(stdout);
}

int AxLogger(fmt, va_alist)
  char *fmt;
  va_dcl
{
  va_list args;

  va_start(args);
  vAxLogger(fmt, args);
  va_end(args);
}
#endif

char *AxTaskPoolAllocate(t,s)
int t,s;
{
	return((char*)malloc(s));
}
char *AxTaskPoolRealloc(t,p,new,old)
int t,new,old;
char *p;
{
	return((char*)realloc(p,new));
}
AxTaskPoolFree(t,p,s)
char *p;
int t,s;
{
	free(p);
}

char *TaskAlloc(t,s)
int t;
unsigned int s;
{
	return((char*)malloc(s));
}
char *TaskCalloc(t,s,n)
int t;
unsigned int s,n;
{
	return((char*)calloc(s,n));
}
char *TaskRealloc(t,p,s)
int t;
void *p;
unsigned int s;
{
	if ( !p )
		return((char*)malloc(s));
	return((char*)realloc(p,s));
}

void
TaskFree(t,p)
int t;
void *p;
{
	free(p);
}

IsValidPathFilename( src )
{
return(0);
}

AbsolutifyPathname(dst,src,x)
char *dst, *src;
int x;
{
	strcpy(dst,src);
}

/*************************************************************************
function: ParsePath - Convert a pathname to Dir & entry names
Works fastest if dir & path are same variable
*/
void ParsePath (path,dir,ent)
char *path;
char *dir;	/* result directory */
char *ent;	/* result entry file name */
{
	AxParsePath(path,dir,ent);
}

char *TaskCopy(t,p)
int t;
char *p;
{
	data_ptr aP = (data_ptr)p;
	char *p2;
	int size;

	if ( aP->type == TYPE_ARRAY ) {
	    size = sizeof(data_array) + (sizeof(data_ptr) * ((AX(aP)->size) - 1));
	    p2 = (char*)TaskAlloc(t,size);
            if (!p2)
                tempAbort("TaskCopy");
            memcpy(p2,p,size);
	    return(p2);
	}
	else
		tempAbort("TaskCopy");
}

/*************************************************************************
function: Astrtod - Applix strtod allows commas as well as dots
*/
double Astrtod (str,pp)
char *str;
char **pp;
{
	extern char *strchr();
	char *p;
	char buf[STRLONG];
	double v;

	if ( !strchr(str,',') )		/* quick & easy test & convert */
		return(strtod(str,pp));
	else {							/* oh, well, slow */
		if ( strlen(str) >= STRLONG ) {
			*pp = str;
			return(0.0);
		}
		strcpy(buf,str);
		for ( p = buf; *p; p++ ) {
			if ( *p == ',' )
				*p = '.';
		}
		v = strtod(buf,pp);
		*pp = str + (*pp - buf);
		return(v);
	}
}

ConvertUSDotsToEuropeComma(){}
ElfbMapDefaultCursor(){}
AxfSSFuncs(){} 
AxfNoOp(){}

AxfByteLen(){}
AxfStrClip(){}
Axfeuc2sjis(){}
Axfsjis2euc(){}
Axfeuc2jis(){}
Axfjis2euc(){}
Axfsjis2jis(){}
Axfjis2sjis(){}
Axfmime2jis(){}
Axfjis2mime(){}
Axfascissjis(){}
Axfispureascii(){}
Axfiseuc(){}
Axfissjis(){}
Axfisjis(){}
data_ptr AxfReadGlomBitmap(){}
int AXTrace;
void AXTracer()	{}
AxfStartApp(){}
AxfGetServByName(){}
AxfGetCurrentLanguage(){}

AxfACLEnabled(){}
AxfSetACLEntry(){}
AxfClearACLEntry(){}
AxfGetACL(){}
AxfListGroupsAndUsers(){}
AxElfLoadShlibForId() { }

AxfFindLargeWindowId(){}
AxfFindSmallWindowId(){}

RtTm1Funcs() {}
AxRtTm1Funcs() {}
AxfMClientBltins() {}

AxfCallLibFunc() {}
