/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: elwin.c
   Applix ASC version: 156
   Date: Mon May 10 21:13:15 1999
*/
#include <dwt2xm.h>
#include <basicwin.h>
#include <ax_xm.h>
#include <aos.h>
#include <xmlib.h>
#include <adlgpoke.h>
#include <evreason.h>
#include <elf.h>
#include <elf_env.h>
#include <elxwins.h>
#include <xmpixel.h>


#define KEY_SHIFT_SHIFT     FSHIFT;
#define KEY_SHIFT_CONTROL   FCONTROL;
#define KEY_SHIFT_ALT       FALT;
#define STRALLOC(s) strcpy(TrueMalloc(strlen(s)+1),s)


eventHandlerList ehList;
extern short THIMpid;
extern XFontStruct *AxDlgMainFont;
extern int Scrollbar_Thickness;
extern int Option_Pad;


extern BOOL CallBackToMenu(AXWidget_main, WPARAM);
extern void ElfXCmenuBarSelected(AXWidget, int, menu_item_def*);
#include <elwin.p>





/*************************************************************************
function: ElfbCreateDlgMenuBar - Add menu bar to dialog

data_ptr oldP;           current widget id or 0 
data_ptr parentP;        not used 
data_ptr strP;           not used 
data_ptr idP;            menu bar id 
data_ptr elf_obj;
*/
void
ElfbCreateDlgMenuBar(data_ptr oldP, data_ptr parentP, data_ptr strP,
                                    data_ptr idP, data_ptr elf_obj)
{
    int id;
    menu_item_def *menu_item;
    AXWidget old;
    AXWidget_menu menu_bar;
    AXWidget_handle w_handle;
    AXWidget_main parent;


    old = WidgetPointerFromHandleData(oldP);
    parent = (AXWidget_main)WidgetPointerFromHandleData(parentP);

    if ( AxIsArray(idP) )
        {
        /* !!0 set the free-able flag */
        menu_item = ElfCrtMenuBarDesc(idP);
        }
    else
    	{
        id = IntFromDataPtr(idP);
        menu_item = ElfLookupSlider(id);
        if ( !menu_item )
            return;
    	}
    menu_bar = AxCrtMenuStructFromId(menu_item);
    WXCreateMenuBar(parent, menu_bar);

    if ( menu_bar )
        {
        menu_bar->popups = menu_item;
        menu_bar->callback = ElfXCmenuBarSelected;
        menu_bar->callbacktag = (caddr_t)THIMpid;
        if ( elf_obj != (data_ptr)NULL )
            menu_bar->elfObject = AxTaskCopyElfData(0, elf_obj);
        }

    if ( old )
		{
        ClipFromWindowList(old);
    	MS_DestroyMenu(((AXWidget_menu)old)->menu_handle);
		FreeMenuBarItems((AXWidget_menu)old);
		}
    AddToWindowList((AXWidget)menu_bar);
    parent->menuBar = menu_bar;
    if ( parent->winid )
        /* have seen one case during initial start-up where "parent->winid" */
        /* is null - jon                                                    */
        MS_SetMenu(parent->winid, menu_bar->menu_handle);

    /* do toolbar */
    ZXmCreateToolBar(parent, menu_item, 0, elf_obj, CallBackToMenu,
                                                (caddr_t)THIMpid);
    if ( parent->toolBar )
        {
        if ( !parent->toolBar->uid )
            parent->toolBar->uid = GetAvailableUID((AXWidget)parent->toolBar);
        parent->toolBar->initial_paint = TRUE;
        }

    w_handle = HANDLE_FROM_WIDGET(menu_bar);
    ElfRetData = AxMakeBinaryData(sizeof(w_handle), (char*)&w_handle);
    return;
}

/* checks whether button name is an image by looking for an
    integer in the string.  hack for now!! */
BOOL
buttonIsImage(char *name)
{
    while (*name)
        {
        if (isdigit(*name))
            return TRUE;
        *name++;
        }
    return FALSE;
}

void
ElfbRadioBoxCreate(data_ptr old_dataP, data_ptr parent_dataP, data_ptr info){}

void
ElfbCreateChoiceMenu(data_ptr oldP, data_ptr parentP, data_ptr info){}

/*********************************************************
function: ElfbDelEditBoxData - Clear contents of edit box
*/
void
ElfbDelEditBoxData(data_ptr wid_dataP)
{
    AXWidget_editbox wid;

    wid = (AXWidget_editbox) WidgetPointerFromHandleData(wid_dataP);

    /* clear widget data. */
    /* taken from X only code in xmeditbx.c, AxXmDelEditBoxData() */
    destroyEditBox(wid);
    createEditBox(wid);

    /* clear editbox by setting no text. */
    MS_SendMessage(wid->winid, WM_SETTEXT, (WPARAM)0, 0L);
}



/******************************************************************/
/******* move the following to appropriate common file(s)!! *********/
/* from xmlib.c */
String
AxXmGetEditBoxData(AXWidget_editbox w)
{
    if ( (w == (AXWidget)NULL) || (w->type != W_EDITBOX) )
        return((String)NULL);

    return (String)getEditBoxData(w);
}
/******************************************************************/

/********************************************************
function: ElfbMSListScreenfonts - return list of available screen fonts
*/
void
ElfbMSListScreenfonts(void)
{
    ElfRetData = (data_ptr) NULL;
}

/******************************************************************/
