/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: evreason.h
   Applix ASC version: 23
   Date: Tue Feb  2 15:21:36 1999
*/
#define EV_CHANGED_ 0		/* widget has new value (or verb button pushed) */
#define EV_FOCUS_IN_ 1		/* entryfield/editbox got focus */
#define EV_FOCUS_OUT_ 2		/* entryfield/editbox lost focus */
#define EV_TYPING_ 3		/* entryfield per-char callback */
#define EV_DBLCLICK_ 4	/* listboxs, temp till dbl click generically handled */
#define EV_MULTI_SELECT_ 5	/* listboxes only */
#define EV_MOTION_ 6		/* currently only scales widgets */
#define EV_STROKE_SELECT_ 7 /* listboxes only */

#define EV_EXPOSE_ 8					/* Canvas */
#define EV_NEW_SCROLL_POS_NOTIFY_ 9		/* Canvas */
#define EV_BUTTON_PRESS_ 10				/* Canvas */
#define EV_BUTTON_RELEASE_ 11			/* Canvas */

#define EV_ARMED_ 	12		/* Mouse down (or drag enter) on pushbutton */
#define EV_DISARMED_	13	/* Mouse up (or drag exit) on pushbutton */

#define EV_DLG_RESIZED_ 20	/* dialog box has been resized */
#define EV_DLG_DESTROY_ 21	/* Delete request from window manager */

#define EV_LIST_DROP_ 30                /* List */
#define EV_STRS_INCREMENT_ACK_ 31       /* list widget has received increment of strs */

#define EV_BUT3_MENU_SELECT_ 40		/* button3 menu selection */

#define EV_TBL_SELECTION_CHANGE_ 50     /* Table */
#define EV_TBL_DBLCLICK_         51     /* Table */
#define EV_TBL_FOCUS_CHANGE_         52     /* Table */
#define EV_TBL_XXX_UNUSED_        53     /* Table USEME */
#define EV_TBL_EDIT_BEGIN_       54     /* Table */
#define EV_TBL_KEYPRESS_         55     /* Table */
#define EV_TBL_COLUMN_RESIZE_    56     /* Table */
#define EV_TBL_REQUEST_DATA_     57     /* Table */
#define EV_TBL_COPY_TO_CLIPBOARD_ 58    /* Table */
#define EV_TBL_PASTE_FROM_CLIPBOARD_ 59 /* Table */
#define EV_TBL_BUTTONPRESS_          60 /* Table */
#define EV_TBL_ROWCOLCREATE_         61 /* Table */

#define EV_TRAY_SELECTION_CHANGE_  70   /* Tray */
#define EV_TRAY_DBLCLICK_          71   /* Tray */
#define EV_TRAY_BUTTONPRESS_       72   /* Tray */

#define EV_SELECTION_DATA_         73   /* Jcli: clipboard selection events */
#define EV_SET_SELECTION_OWNER_    74
#define EV_SELECTION_CLEAR_        75
#define EV_SELECTION_REQUEST_      76

#define EV_CALTASK_INFO_REQUEST_   77   /* calendar events */
#define EV_NEW_CALTASK_            78
#define EV_DELETE_CALTASK_         79
#define EV_UPDATE_CALTASK_         80

#define EV_TEXT_CHANGED_           81   /* Jcli: text inserted,deleted */
#define EV_TEXT_SELECTION_CHANGED_ 82   /* Jcli: change in text cursor/sel */

#define EV_TBL_CELL_FOCUS_IN_      83 /* Table */
#define EV_TBL_CELL_FOCUS_OUT_     84 /* Table */

/* Elf Key Ids for use with the table widget.
   These Key Ids are sent as a part of the `EV_TBL_KEYPRESS' event.
   ELFK_PRINTABLE means one of the printable keys was pressed, look at
   `wbuf' element of the TblKeyPress structure for chars that were
   typed in.
   See Also:
   "xmtable.h" for definition of the TblKeyPress structure.
   "xmtable.c::TblSendKeyPressEvent()" for the keypress event sender.
   "elxwins.c::ElfXCtable()" for keypress event  packaging. */
#define ELFK_PRINTABLE  0   /* one of the printable character set */
#define ELFK_RETURN     1   /* newline */
#define ELFK_DOWN       2   /* down arrow */
#define ELFK_UP         3   /* up arrow */
#define ELFK_BACKTAB    4   /* shift-tab */
#define ELFK_TAB        5   /* tab */
#define ELFK_LEFT       6   /* left arrow */
#define ELFK_RIGHT      7   /* right arrow */
#define ELFK_LINEFEED   8   /* linefeed */
#define ELFK_DELETE     9   /* delete/backspace */
#define ELFK_ESCAPE     10  /* escape */
