/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: evtray.h
   Applix ASC version: 3
   Date: Tue Feb  2 15:21:23 1999
*/
#ifndef _evtray_h_
#define _evtray_h_

/* Keep this struct defn in sync with the ELF format defn in
   `elf_tree.elf'. */
typedef struct {
	char *title;
	char *pixmap;
	int  value;
	long handle;
} elf_tree_node_fmt_t;
	
typedef struct {
	int type; /* one of the types defined in ``evreason.h''. */
} TrayAnyEvent;

typedef struct {
	int  type;    /* `EV_TRAY_DBLCLICK_' */
	elf_tree_node_fmt_t node_info;
} TrayDoubleClickEvent;

typedef struct {
	int  type;    /* `EV_TRAY_BUTTONPRESS_' */
	elf_tree_node_fmt_t node_info;
} TrayButtonPressEvent;

typedef struct {
	int  type; /* `EV_TRAY_SELECTION_CHANGE_' */
	long *node_info_array; /* IntsArray of (elf_tree_node_fmt_t *) */
} TraySelectionChangeEvent;

typedef union {
	TrayAnyEvent any;
	TrayDoubleClickEvent double_click;
	TrayButtonPressEvent button_press;
	TraySelectionChangeEvent selection_change;
} TrayEventData;

#endif /* not _evtray_h_ */


/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
