/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: mail.h
   Applix ASC version: 54
   Date: Tue Feb  2 15:20:53 1999
*/
/* STRIP LINES THROUGH HERE */

/*
* the format for shared folder, infomation of shared folder
*/

	format sync_table_
		folder_name,
		mod_time,
	    format inb_item folder_contents,
		flag,
		access_mode,
		remote_host,
		sortedby

	
/*
 * The format for an individual mail message in the Inbox
*/

	format inb_item
        from,					' sender (for reply)
        reply,					' Reply by string
        date,					' date (text)
        subject,
        status,					' status flags
        file,					' path to attachments
        forward,				' forward history
        comment,
		ldate,					' send date as a long
		altreply,				' alternate recipient for reply
		lfrom,					' long name of sender
		mid,					' unique message id
		response,				' date response sent to certmail sender
		color,					' inbox message display color
		reserved1,
		reserved2,
		reserved3

/*
 * The format for a folder
*/
	format folder_info_
		folder_name,
		folder_type,					' "private" or "shared"
		format access_data access_info,
		owner,							' the true folder owner
		supress,						' supress notifier for this folder
		sortedby,
		unused1,
		unused2

/*
 * The format for subscribers to a shared folder
*/
	format access_data
		readers,						' list of folder readers
		writers,						' list of folder writers
		deleters						' list of folder deleters


/*
 * The format for a mail rule
*/
	format rule_info_
		title,
		macro_t,
		active,
		unused1,
		unused2,
		unused3

/*
 * format for specifying attached files at send time
 */

	format mail_attfiles_
		filename,
		filetype,
		encapsulate,
		docopt,
		cvt_name,
		cvt_macro,
		shadow,
		filesize

/*
 * structure of foreign file info
 */
	format ff_info_
		doctype,
		small_bitmap,
		large_bitmap,
		launch_cmd,
		launch_mode,
		filter_macro,
		exec_macro


/*
 * doc recipient preferences format
 */

	' note: user's may provide an alternate function that maintains
	' this data outside of Aster*x, but it must be returned in this
	' format...

	format mail_recip_prefs_
		username,						' recipient name
		wp_pref,						' wp doc format pref
		gr_pref,						' gr doc format pref
		ss_pref,						' ss doc format pref
		wp_pref_func,					' wp conversion func
		gr_pref_func,					' gr conversion func
		ss_pref_func,					' ss conversion func
		mac_user,						' true or false (for mac hdr)
		fax_phone,						' phone number as dialed
		fax_longname,					' full name for header page
		fax_send_time,					' deferred send time or 0
		mime,							' true or false (wants mime)
		dd_pref,						' dd doc format pref
		dd_pref_func,					' dd conversion func
		unused1,
		unused2,
		unused3,
		unused4

/*
 * FAX format data - a subset of mail_recip_prefs_ passed to
 * customer supplied FAX macros
 */

	format fax_info_
		recipient,					' recipient name
		phone,						' fax phone number
		longname,					' full name for header page
		sendtime					' deferred send time or 0 (now)


/*
 * the format for a selection in an editbox
 */

	format selection_info_
		start_line,
		start_col,
		end_line,
		end_col


	
	format sm_message_
		to_recips,
		cc_recips,
		bc_recips,
		format arrayof mail_attfiles_ files,
		wp_pref,
		gr_pref,
		ss_pref,
		dd_pref

	format mail_recip_info_
		name,
		class,
		wp_pref,
		gr_pref,
		ss_pref,
		dd_pref


/*
 * attribute definitions for mail macros
 */

define MAIL#SUBJECT_			0
define MAIL#SENDER_				1
define MAIL#DATE_				2
define MAIL#COMMENT_			3
define MAIL#BODY_				4

define MAIL#ALL_DATES_			0
define MAIL#YESTERDAY_			1
define MAIL#TODAY_				2
define MAIL#DATE_RANGE_			3

define TRUE_TERM             	2
define FALSE_TERM            	3
define OVERRIDE_SAFETYNET   	10		' allows for disposal of message
define SUPRESS_NOTIFIER			100		' no notifier for this message


define LAUNCH_TYPE_SHCMD       0		' launch foreign file w/shell cmd
define LAUNCH_TYPE_AXMACRO     1		' launch foreign file as * macro

define FOLDER#TYPE_PRIVATE		0		' not a shared folder
define FOLDER#TYPE_SHARED		1		' a shared folder

define MSG_MODE_SEND			0
define MSG_MODE_FORWARD			1
define MSG_MODE_REPLY			2
define MSG_MODE_DOCSEND			3
define MSG_MODE_RELEASE     	4

define MAIL_ADD#PREPEND			0		' prepend buffer to message body
define MAIL_ADD#INSERT			1		' insert buffer at cursor location
define MAIL_ADD#APPEN			2		' append buffer at end of message body

#define DOC_OPT#LOCALIZE		0
#define DOC_OPT#INCL_FILES		1
#define DOC_OPT#THIS_FILE		2


/*
 * MAPI function definitions	(must match mapiapp.c)
 */

define MAPI#LOGON				0
define MAPI#LOGOFF				1
define MAPI#SENDMSG				2
define MAPI#MSGLIST				3
define MAPI#ADDRESS				4
define MAPI#CHKNAME				5
define MAPI#DETAILS				6


define RECIP_TYPE_ORIG			0
define RECIP_TYPE_TO			1
define RECIP_TYPE_CC			2
define RECIP_TYPE_BC			3

#define CLIENT#UNIX				0
#define CLIENT#OPENMAIL			1
#define CLIENT#POP				2
#define CLIENT#MAPI				3
#define CLIENT#IMAP				4
#define CLIENT#SMTP				5

#define MODE#ONLINE				-1	
#define MODE#CONNECTED			0
#define MODE#OFFLINE				1
#define MODE#OFFLINE_CONFIRM	2
#define MODE#OFFLINE_ERROR		3

#define AXPOP#STATE#AUTH				0
#define AXPOP#STATE#TRANS				1
#define AXPOP#STATE#UPDT				2
/*
 * MAPI format definitions
 */

	format mapi_msg_
		sender,
		recips,
		rdate,
		subject,
		body


	format mapi_recip_
		name,
		type,
		EIDsize,
		EID

/*
 * format for mailed document conversion options
 */
	format mail_format_array_
		name,			' name of conversion format (text)
		filtmac,		' name of conversion function
		extension,		' extension for converted document
		doctype			' Applixware magic number for output file

/*
 * Shared folder data...
 */

define BB#SVR 4137

define BB#SERVER_NAME NXLT("bb server")

' request types...
define BB#REGISTER			0
define BB#SYNC				1
define BB#GET_INFO			2
define BB#TERM				3
define BB#FOLDER_LIST		4
define BB#MESSAGE_LIST		5
define BB#MESSAGE_INFO		6
define BB#FOLDER_INFO		7
define BB#MESSAGE_UPDATE	8
define BB#MESSAGE_ADD		9
define BB#MESSAGE_DELETE	10
define BB#FOLDER_ACCESS		11
define BB#ENV_INFO   		12 
define BB#GET_FILE			13
define BB#DELETE_FILE		14
define BB#GET_VERSION		15
define BB#MSG_LASTMOD		16

' ack types...
define BB#SYNC_ACK		21
define BB#INFO_ACK		22
define BB#TERM_ACK		23
define BB#UPDATE_ACK	24
define BB#UPDATE_ERROR	25
define BB#UNKNOWN_CMD	26
define BB#SYNC_ERROR	27


/*
 * Format for a shared folder request for data
 */
	format bb_request_
		caller,
		type,
		message,
		unused1,
		unused2,
		unused3


/*
 * 
 */
	format pending_message_
		to_recips,
		cc_recips,
		bc_recips,
		subject,
		msgbody,
		attfiles,
		reply_state,
		reply_text,
		urgent_state,
		certified_state,
		encrypt_state,
		outbox_state,
		addrecip_state,
		is_signed,
		format arrayof inb_item messages,		'the messsage to forw/reply
		mode												'MSG_MODE_REPLY...

