/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: mapinit.c
   Applix ASC version: 1
   Date: Tue Feb  2 15:22:17 1999
*/
#include <windows.h>
#include "mapi.h"
#include "mminit.h"

extern HANDLE hLibrary;

/************************************************************************/
/*                                                                      */
/*   This file contains the source code for functions that load and     */
/*   unload the MAPI DLLs, as well as determine the runtime entry       */
/*   points.  Currently, they are only called implicitly from           */
/*   ElfbMapiLogon() and ElfbMapiLogoff() in mapiapp.c                  */
/*                                                                      */
/*   This is an NT only source file!!!                                  */
/*                                                                      */
/************************************************************************/

int FAR PASCAL InitMAPI()
{
	if ((hLibrary = LoadLibrary(MAPIDLL)) < (HANDLE)32)
		return(ERR_LOAD_LIB);


	if ((lpfnMAPILogon = (PFNMAPILOGON)GetProcAddress(hLibrary,
	  SZ_MAPILOGON)) == NULL)
    	return(ERR_LOAD_FUNC);

	if ((lpfnMAPILogoff= (PFNMAPILOGOFF)GetProcAddress(hLibrary,
	  SZ_MAPILOGOFF)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPISendMail= (PFNMAPISENDMAIL)GetProcAddress(hLibrary,
	  SZ_MAPISENDMAIL)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPISendDocuments= (PFNMAPISENDDOCUMENTS)GetProcAddress(hLibrary,
	  SZ_MAPISENDDOC)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIFindNext= (PFNMAPIFINDNEXT)GetProcAddress(hLibrary,
	  SZ_MAPIFINDNEXT)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIReadMail= (PFNMAPIREADMAIL)GetProcAddress(hLibrary,
	  SZ_MAPIREADMAIL)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPISaveMail= (PFNMAPISAVEMAIL)GetProcAddress(hLibrary,
	  SZ_MAPISAVEMAIL)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIDeleteMail= (PFNMAPIDELETEMAIL)GetProcAddress(hLibrary,
	  SZ_MAPIDELMAIL)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIFreeBuffer= (PFNMAPIFREEBUFFER)GetProcAddress(hLibrary,
	  SZ_MAPIFREEBUFFER)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIAddress= (PFNMAPIADDRESS)GetProcAddress(hLibrary,
	  SZ_MAPIADDRESS)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIDetails= (PFNMAPIDETAILS)GetProcAddress(hLibrary,
	  SZ_MAPIDETAILS)) == NULL)
		return(ERR_LOAD_FUNC);

	if ((lpfnMAPIResolveName= (PFNMAPIRESOLVENAME)GetProcAddress(hLibrary,
	  SZ_MAPIRESOLVENAME)) == NULL)
		return(ERR_LOAD_FUNC);

	return(0);
}


int FAR PASCAL DeInitMAPI()
{

	lpfnMAPILogon = NULL;
	lpfnMAPILogoff= NULL;
	lpfnMAPISendMail= NULL;
	lpfnMAPISendDocuments= NULL;
	lpfnMAPIFindNext= NULL;
	lpfnMAPIReadMail= NULL;
	lpfnMAPISaveMail= NULL;
	lpfnMAPIDeleteMail= NULL;
	lpfnMAPIFreeBuffer = NULL;
	lpfnMAPIAddress= NULL;
	lpfnMAPIDetails = NULL;
	lpfnMAPIResolveName = NULL;

	FreeLibrary(hLibrary);

	return(0);
}
