/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: objinfo.h
   Applix ASC version: 40
   Date: Tue Feb  2 15:21:28 1999
*/
#define OBJINFO_ROOT_OBJECT_NAME		NXLT("RootObject")


/* command codes for format object_server_request$  */

#define OBJSVR_REMOVE_SERVER_			100
#define OBJSVR_CREATE_OBJECT_			101
#define OBJSVR_FIND_OBJECT_				102
#define OBJSVR_SET_METHOD_				103
#define OBJSVR_GET_METHOD_				104
#define OBJSVR_DESTROY_OBJECT_			105
#define OBJSVR_PING_SERVICE_			106


/* command codes for obj_info@ */

#define OBJINFO_GETAPP_					1	/* Given appname, get app object */
#define OBJINFO_APPLIST_				2	/* Get list of apps */
#define OBJINFO_GETNAME_				3	/* Return name */
#define OBJINFO_GET_INHERIT_			4	/* Return obj this inherits from*/
#define OBJINFO_CREATE_APP_				5	/* Create top level app object */
#define OBJINFO_GET_DATA_NAMES_			6	/* Fetch local var names */
#define OBJINFO_SET_APPNAME_			7	/* Set object's owner app */
#define OBJINFO_GET_APPNAME_			8	/* Get object's owner app */
#define OBJINFO_GET_PARENT_				9	/* return parent object */
#define OBJINFO_SET_PARENT_				10	/* set parent */
#define OBJINFO_ADD_CHILD_				11	/* add a child */
#define OBJINFO_GET_CHILD_				12	/* get child object */
#define OBJINFO_DEL_CHILD_				13	/* delete child object */
#define OBJINFO_GET_CHILDREN_			14	/* get all children */
#define OBJINFO_GET_DATUM_				15	/* Fetch local var value */
#define OBJINFO_DESTROY_				16	/* destroy object */
#define OBJINFO_GET_ALL_CHILDREN_		17	/* get all children recursively */
#define OBJINFO_READ_VARS_				18	/* Read file to create objvars */
#define OBJINFO_WRITE_VARS_				19	/* Write object's vars to file */
#define OBJINFO_SET_DATUM_				20	/* Set local var value... creates if needed */
#define OBJINFO_GET_PACKAGE_			21	/* get package name str for object */
#define OBJINFO_OBJ_FROM_PACK_NAME_		22	/* get object from package name */
#define OBJINFO_GET_DEXUID_FROM_NAME_	23  /* get dex-uid from name */
#define OBJINFO_GET_OBJ_FROM_DEXUID_	24  /* get object from dex-uid pair */
#define OBJINFO_GET_DEXUID_FROM_REF_	25  /* get dex-uid from object ref */
#define	OBJINFO_CREATE_REF_FROM_DEXUID_	26  /* create ref from dex-uid pair */
#define OBJINFO_DESTROY_REMOTE_OBJECTS_	27  /* destroy objects created on channel */
#define OBJINFO_KILL_APP_				28  /* free all app objects */
#define OBJINFO_SET_BUILDER_APP_		29  /* applix builder(arcade) object */
#define OBJINFO_GET_BUILDER_APP_		30  /* applix builder(arcade) object */
#define OBJINFO_SNAP_OBJECTS_			31  /* now is a good time to snap all unsnapped refs */
#define OBJINFO_SET_APP_TASK_UID_		32  /* set application objects task_uid */
#define OBJINFO_GET_APP_TASK_UID_		33  /* get application objects task_uid */
#define OBJINFO_SET_INHERIT_			34  /* set/change object inheritance */
#define OBJINFO_DEL_CHILDREN_			35  /* delete all of its children */
#define OBJINFO_ADD_CLASS_				36  /* add class library to top level obj */
#define OBJINFO_DEL_CLASS_				37  /* delete class library to top level obj */
#define OBJINFO_GET_CLASS_				38	/* return class library object */
#define OBJINFO_GET_CLASSES_			39	/* return list of all class library objects */
#define OBJINFO_DEL_CLASSES_			40	/* delete all class library objects */
#define OBJINFO_MOVE_KID_				41	/* move kid in the list */
#define OBJINFO_EXCHANGE_KIDS_			42	/* exchange dex of two objs in their parent's children list */
#define OBJINFO_RENAME_					43	/* rename the object */
#define OBJINFO_REPLACE_CHILD_			44  /* remove old child, add new child in his place */
#define OBJINFO_SET_STATIC_VARNAMES_	45	/* list of objvar names saved */
#define OBJINFO_GET_STATIC_VARNAMES_	46	/* return lsit of objvar names */
#define OBJINFO_SET_PUBLIC_VARNAMES_	47	/* list of public objvar names */
#define OBJINFO_GET_PUBLIC_VARNAMES_	48	/* return lsit of public objvar names */
#define OBJINFO_GET_NEXT_SIBLING_		49	/* return next sibling */
#define OBJINFO_LIBRARY_OBJECT_			50	/* return library object */
#define OBJINFO_GET_FUNCS_LIST_			51  /* return list of func names */
#define OBJINFO_SET_LOCAL_DATUMS_		52  /* set local objvars info */
#define OBJINFO_MAKE_UID_FILENAME_		53  /* make unique filename */
#define OBJINFO_INIT_OBJVARS_			54  /* make unique filename */
#define OBJINFO_CREATE_CPP_OBJECT_		55  /* Create C++ object */
#define OBJINFO_LOCAL_STATIC_DATUMS_	56  /* get local objvars info */
#define OBJINFO_IS_SAME_DATA_			57  /* compare two datums */
#define OBJINFO_INSERT_CHILD_			58	/* insert child before passed obj */
#define OBJINFO_CREATE_OBJ_FROM_STRUCT_ 59  /* macro object_create_from_struct$ */
#define OBJINFO_GET_CHILDREN_REVORDER_	60	/* return children list in reverse */
#define OBJINFO_FIND_OBJECTS_			61  /* search with given class_uid */
#define OBJINFO_PROCESS_CORBA_OBJECT_   62  /* Catch all for CORBA Objects */
#define OBJINFO_REPOSITORY_REQUEST_     63  /* Catch all for Repository */
#define OBJINFO_OBJECT_TYPE_			64	/* get object type - C++, CORBA */
#define OBJINFO_JAVADLG_SET_MAP_		65  /* set javaDlg mapped info */
#define OBJINFO_JAVADLG_GET_MAP_		66  /* get obj from dlg/widget ids */

