/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: sqlops.h
   Applix ASC version: 10
   Date: Tue Feb  2 15:21:23 1999
*/
#define SQLOP_START 1		/* SQL stream begins */
#define SQLOP_EXEC 2		/* Execute SQL stream, clear stream */
#define SQLOP_PUSH 3		/* Execute and push result of SQL stream */
#define SQLOP_SELECT 4		/* beginning of a select expression */
#define SQLOP_TOKEN 5		/* pop last str as a SQL token */
#define SQLOP_DATUM 6		/* pop & quote str, just pop number */
#define SQLOP_REPL_TOKEN 7	/* OBSOLETE */
#define SQLOP_REPL_DATUM 8	/* OBSOLETE */
#define SQLOP_DCLCURSOR 9	/* create a cursor on a stmt */
#define SQLOP_OPENCURSOR 10	/* run the cursor */
#define SQLOP_FETCHCURSOR 11	/* get a record */
#define SQLOP_ARRAYFETCHCURSOR 12	/* get array of records */
#define SQLOP_CLOSECURSOR 13	/* release the cursor */
#define SQLOP_BIND_TOKEN 14	/* binding placeholder */
#define SQLOP_BIND_DATUM 15	/* binding placeholder */
#define SQLOP_EXECUTE 16	/* run prepared statement */
#define SQLOP_UNPREPARE 17	/* unprepare statement */

#define SQLOP_EA_REPL_TOKEN 18	/* push local var info as a replaced var */
#define SQLOP_EA_REPL_TOKEN_ARG 19
#define SQLOP_EA_REPL_TOKEN_GLO (SQLOP_EA_REPL_TOKEN+OP_GLO_OFFSET)
#define SQLOP_EA_REPL_TOKEN_EXT (SQLOP_EA_REPL_TOKEN+OP_EXT_OFFSET)
#define SQLOP_EA_REPL_TOKEN_OBJ (SQLOP_EA_REPL_TOKEN+OP_OBJ_OFFSET)

#define SQLOP_EA_REPL_DATUM 20	/* push local var info as a replaced var */
#define SQLOP_EA_REPL_DATUM_ARG 21	/* push local var info as a replaced var */
#define SQLOP_EA_REPL_DATUM_GLO (SQLOP_EA_REPL_DATUM+OP_GLO_OFFSET)
#define SQLOP_EA_REPL_DATUM_EXT (SQLOP_EA_REPL_DATUM+OP_EXT_OFFSET)
#define SQLOP_EA_REPL_DATUM_OBJ (SQLOP_EA_REPL_DATUM+OP_OBJ_OFFSET)

