/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cvtglob.c
   Applix ASC version: 238
   Date: Tue Mar 23 21:11:58 1999
*/
#include <stdio.h>
#include <math.h>
#include <aos.h>
#include <getstr23.h>
#include <getstr10.h>
#include <atm.h>
#include <atmattr.h>
#include <atmwin.h>  
#include <axtext.h> 
#include <atxint.h>
#include <atmtxtin.h>
#include <atmgraph.h>
#include <axtext.h>
#include <parint.h>
#include <ge.h>
#include <cvttoks.h>
#include <cvt.h>
#include <afileimg.h>
#include <undo.h>
#include <akeys.h>
#include <rule.h>
#include <items.h>
#include <fontmap.h>
#include <fb.h>

#define CVTGLOB 1
#define LOGGING 0

#if FOR_FILTER
#   undef exit
#   include <stiorts.h>
#else
#   include <fsrts.h>
#endif

#if !M_88K
#if !NO_VARARGS
#include <varargs.h>
#endif
#endif

#define MAX_MRKR_X  10
#define MAX_MRKR_Y  10

extern FILE *OpenFileObjFmode();

ge_template_type * cvtPageToTemplate();
ge_template_type * cvtCreateBlankTemplate();

/* this is a list of convenient font names for lookup */
/* by foreign converters.  Use interface through CvtText() */
#if BUILD_KANJI
#define NUM_EXT_FONTS 23
#define NUM_INT_FONTS 13
#else
#define NUM_EXT_FONTS 15
#define NUM_INT_FONTS 11
#endif

char *CvtFonts[] = {
    NXLT("cour"),
    NXLT("tim"),
    NXLT("avan"),
    NXLT("gard"),
    NXLT("chanc"),
    NXLT("pala"),
    NXLT("narr"), /* put narrow before helv for searching */
    NXLT("helv"),
    NXLT("sym"),
    NXLT("book"),
    NXLT("sch"),
    NXLT("ding"),
    NXLT("sans"),  /* sans-serif before serif ditto */
    NXLT("serif"),
#if BUILD_KANJI
    NXLT("rom"),
    NXLT("mincho"),
    NXLT("\314\300"),
    NXLT("\245\337\245\363"),
    NXLT("\334\264"),
    NXLT("\244\270\244\345\244\363"),
    NXLT("gothic"),
    NXLT("\245\264"),
    NXLT("\216\272\216\336")
#else
    NXLT("rom")
#endif
};

#if BUILD_KANJI
char CvtFontMap[] = {2, 0, 7, 7, 9, 6, 8, 1, 3, 4, 5, 10, 1, 0, 2, 11, 11, 12,
12, 12};
#else
char CvtFontMap[] = {2, 0, 7, 7, 9, 6, 8, 1, 3, 4, 5, 10, 1, 0, 2};
#endif

/* ProtoTypes */
#if 1
#include <cvtglob.p>
#endif
int bgetcNoSize();
extern thing *makeThing();
thing *best_choice();
int ge_layout_size();
extern thing *makePrim();

/*********************************************************************\
* The tok array is used by the converter to parse it's files.        *
* To add a new token:                                                *
*   1) put the literal string in the tok[] array in alphabetic order *
*   2) add a token handler function in the TokFuncs[] array (cvti.c) *
*   3) put it in the T-prefixed enum (in cvt.h) in alphabetic order  *
*   4) change TLAST_TOK (in cvt.h) if necessary                      *
\*********************************************************************/

char *pnm[] = {
    NXLT("EMPTY"),
    NXLT("TEXTBOX"),
    NXLT("IMAGE"),
    NXLT("TEXT"),
    NXLT("POLYLINE"),
    NXLT("STROKE"),
    NXLT("GROUP"),
    NXLT("LINE"),
    NXLT("RECTANGLE"),
    NXLT("ELLIPSE"),
    NXLT("REGULAR_POLY"),
    NXLT("INSET"),
    NXLT("TEMPLATE"),
    NXLT("REGION")
};
char *pnm2[] = {
    NXLT(".VOID"),
    NXLT(".TXT"),
    NXLT(".IMG"),
    NXLT(".STR"),
    NXLT(".POL"),
    NXLT(".STK"),
    NXLT(".GRP"),
    NXLT(".LINE"),
    NXLT(".RECT"),
    NXLT(".ELL"),
    NXLT(".RPOL"),
    NXLT(".INS"),
    NXLT(".TMP"),
    NXLT(".RGN")
};
char *fnt2[FNTS2] = {
    NXLT("REGULAR"), NXLT("PLAIN"), NXLT("MONOSPACE"), NXLT("OTHER")
};
int fnt2val[FNTS2] = {
    /* Prop. Serif: Times */
    /* Prop. SanSerif: Helvetica: */
    /* Mono SanSerif: Courier */
    0, 1, 2, 3
};
char *fnt1[FNTS1] = {
    NXLT("SERIF1"), NXLT("SANS1"), NXLT("MONO1"), NXLT("SYMBOL1"),
    NXLT("SERIF2"), NXLT("SANS2"), NXLT("SYMBOL2"), NXLT(""),
    NXLT("FACE8"), NXLT("FACE9"), NXLT("FACE10"), NXLT("FACE11"), NXLT("FACE12")
};
char *fnt[FNTS] = {
    NXLT("Times"), NXLT("Helvetica"), NXLT("Courier"), NXLT("Symbol"),
    NXLT("Bookman"), NXLT(""), NXLT("Zapf Dingbats"), NXLT(""), NXLT("Avant Garde"),
    NXLT("Helvetica Narrow"), NXLT("New Century Schoolbook"),
    NXLT("Palatino"), NXLT("Zapf Chancery")
};
char *siz1[SIZS1] = {
    NXLT("SMALL"), NXLT("MEDIUM"), NXLT("LARGE"), NXLT("EXTRA_LARGE")
};
int siz2val2[SIZS1] = {
    80000, 120000, 180000, 360000
};
char *siz[SIZS] = {
    NXLT("PT10"), NXLT("PT12"), NXLT("PT14"), NXLT("PT18"),
    NXLT("PT6"), NXLT("PT8"), NXLT("PT24"), NXLT("PT36")
};
int siz2val1[SIZS] = {
    100000, 120000, 140000, 180000, 60000, 80000, 240000, 360000
};
char *und[UNDS] = {
    NXLT("OFF"), NXLT("ON"), NXLT("DOUBLE"), NXLT("THRU")
};
char *jst[JSTS] = {
    NXLT("LEFT"), NXLT("CENTER"), NXLT("RIGHT"), NXLT("JUSTIFIED")
};
char *vjst[JSTS] = {
    NXLT("TOP"), NXLT("BASELINE"), NXLT("BOTTOM"), NXLT("JUSTIFIED")
};
char *lst[LSTS] = {
    NXLT("SOLID"), NXLT("DASHED"), NXLT("DOTTED"), NXLT("DASH_DOT")
};
char *lth[LTHS] = {
    NXLT("VERY_THIN"), NXLT("THIN"), NXLT("MEDIUM"), NXLT("THICK"),
    NXLT("VERY_THICK"), NXLT("(UNDEFINED)"), NXLT("(UNDEFINED)"), NXLT("NONE")
};
int lth2val[LTHS] = {
    1,14,27,40,54,1,1,0
};
char *mkr[MKRS] = {
    NXLT("SQUARE"), NXLT("PLUS"), NXLT("STAR"), NXLT("CIRCLE"), NXLT("CROSS")
};
 
char *aro[AROWS] = {
    NXLT("LAST_END"), NXLT("FIRST_END"), NXLT("RESERVED"), NXLT("BOTH_ENDS")
};
char *art[AROTS] = {
    NXLT("ARROW1"), NXLT("ARROW2"), NXLT("ARROW3"), NXLT("ARROW4")
};

char *cmp[CMPS] = {
    NXLT("RAW"), NXLT("RUN"), NXLT("LZW")
};
char *ity[ITYS] = {
    NXLT("LINEART"), NXLT("HALFTONE")
};
char *enc[ENCS] = {
    NXLT("HEX"), NXLT("BIT6")
};

char *tst[TSTS] = {
    NXLT("OFF"), NXLT("ON")
};

char *sts[TSTS] = {
    NXLT("FALSE"), NXLT("TRUE")
};

int clr2val[CLRS] = {
    2,  /* WHITE -> white */
    1,  /* Black -> black */
    1,  /* Black -> black */
    1,  /* Black -> black */
    7,  /* red ->   red*/
    32, /* cyan ->  cyan */
    12, /* green -> green */
    46, /* purple -> purple */
    17, /* blue ->  blue */
    22, /* yellow -> yellow */
    6,  /* Dark Grey -> Grey 50*/
    41, /* Olive -> Olive */
    3,  /* Light Grey -> Grey 95 */
    11, /* Dark Red -> Red 50*/
    43, /* Orange -> Orange*/
    21  /* Dark Blue -> Blue 50*/
};

char *chrtypes[NCHART_TYPES] = {
    NXLT("PERCENT"), NXLT("CAT-VAL"), NXLT("VAL-VAL"), NXLT("HIST"), NXLT("SPIDER"), NXLT("STRATA")
};

char *glab_types[] = {
    NXLT("NONE"), NXLT("VALUE"), NXLT("PERCENT"), NXLT("STRING")
};

int TokPointers[26];

#if SGI
extern char *read_only_tok[];
#endif

/**************************************************************************
**
 *
 * module:  InitTokens - remove the ! character from the
 *                       ends before we start searching.
 */
InitTokens(ge)
graphics_main_type *ge;
{
    int ii=0, len;
    char *tokP, curr;
#if SGI
	int num_toks;
	char **roTokP;
	int tx;
#endif

#if SGI
	roTokP = read_only_tok;
	num_toks = 0;
	while (*roTokP) {
		num_toks++;
		roTokP++;
	}
	tok = (char **) gloc(ge, (sizeof(char *) * (num_toks + 1)));
	roTokP = read_only_tok;
	tx = 0;
	while (*roTokP) {
		tok[tx] = (char *) gloc(ge, strlen(*roTokP) + 1);
		strcpy(tok[tx], *roTokP);
		roTokP++;
		tx++;
	}
	tok[tx] = '\0';
#endif

    /* remove the ! char from the tokens */
    tokP = tok[0];
    while (tokP)
    {
        len = strlen(tokP) - 1;
        if (len && (tokP[len] == '!'))
            tokP[len] = '\0';
        ii++;
        tokP = tok[ii];
    }

    /* and initialize the TokPointers array with the pointer to
     * the string which is first (alphabetically) for each letter.
     */
    memset(TokPointers,0xFF,26*sizeof(int)); /* -1 */
    curr = ii = 0;
    tokP = tok[0];
    while (tokP)
    {
        if (*tokP != curr)
        {
            curr = (*tokP);
            TokPointers[curr - 'A'] = ii;
        }
        ii++;
        tokP = tok[ii];
    }

}

/****************************************************************************
 *
 * module:  c v t I n i t A t t r s - Sane Defaults prior to session read
 */
cvtInitAttrs(ge, atts)
graphics_main_type *ge;
thing_attributes *atts;
{
    /* clear all fields, setting most flags to true */
    memset(atts,0,sizeof(thing_attributes));
    memset((char *)&atts->use, 0xff, sizeof(attr_flags));
    atts->use.style = FALSE;
    atts->use.callback = FALSE;
    atts->use.tag = FALSE;

    /* fill attributes */
    atts->fill_pat = 0;
    atts->fpat_type = 0;
    atts->fill_fg = 1;
    atts->fill_bg = 0;

    /* line attributes */
    atts->line_pat = 1000;
    atts->lpat_type = GRAY_FILL_TYPE;
    atts->line_fg = 1;
    atts->line_bg = 2;
    atts->mode    = TMS_O_D;
    atts->line_style = 0;
    atts->line_thickness = 1;
    atts->left_arrow = 0;
    atts->right_arrow = 0;
    atts->join_symbols = 0;

    /* drop shadow attributes */
    atts->shadow = 0;
    atts->shadow_color = 6;
    atts->shadow_x = 15;
    atts->shadow_y = 15;

    /* text attributes */
    atts->face = 0;
    atts->size = 180000;
    atts->ruling = 0;
    atts->strike = 0;
    atts->weight = 0;
    atts->slant = 0;
    atts->x_scale = 10000;
    atts->shear = 0;
    atts->angle = 0;
    atts->x_off = 0;
    atts->y_sub_sup = 0;

	atts->l_indent1 = 0;
	atts->l_indent2 = 0;
	atts->r_indent = 0;
	atts->bullet = 0;
	atts->bullet_color = 1;
	atts->bullet_scale = 1000;
	atts->bullet_font  = 0;
	atts->bullet_glyph = 111;
	atts->space_above = 0;
	atts->space_below = 0;
	atts->space_inside = 250;

    atts->h_just = LEFT_JUST;
    atts->v_just = 0;
    atts->field_x_scale = 10000;
    atts->field_y_scale = 10000;
    atts->field_shear = 0;
    atts->field_angle = 0;
    atts->field_space = 250;
    atts->l_margin = 125;
    atts->r_margin = 125;
    atts->t_margin = 250;
    atts->b_margin = 62;

    /* style id */
    atts->style = 0;

    /* callback id */
    atts->callback = 0;

    /* user definable tag field */
    atts->tag = 0;
}

/***************************************************************************
 *
 * module:  m l I n i t - set default state
 */
mlInit(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    int ii;
    char *p;

    /*
     * This function is intended to set a NEW cvt to
     * defaults!  If any fields are allocated, they
     * are gone forever, and so is their memory.
     */
    memset(cvt,0,sizeof(cvt_global_type));

    /* note that we're running as part of the GE */
    cvt->appID  = G_APP;

    /* set any non-zero default flags */
    cvt->writing = TRUE;
    cvt->widechars = TRUE;
 
    /* cvti, cvto  vars */
    cvt->endAngle = 3600;
    cvt->height = INITIAL;
    cvt->width = INITIAL;
    cvt->depth = 1; /* default to accept pre-color files */
    cvt->type = INITIAL;
    cvt->compression = COMP_LZW;
    cvt->encoding = BIT6;
    cvt->depth = 1;
    cvt->xres = INITIAL;
    cvt->yres = INITIAL;
    cvt->quantize = TRUE;

    /* point it at the first line in the file */
    cvt->lineno = 1;

    /* set the initial default attributes */
    cvtInitAttrs(ge, &cvt->curr_atts);

    /* file related stuff */
    cvt->fileName = cvt->file1;
    cvt->unixName = cvt->file2;

    /* create the buffer. If a larger buffer becomes */
    /* necessary, use CvtBiggerBuffer() */
    CvtBiggerBuffer(ge, cvt,1);
}

/****************************************************************************
 *
 * module:  CvtBiggerBuffer
 */
CvtBiggerBuffer(ge, cvt,n_blocks)
graphics_main_type *ge;
cvt_global_type *cvt;
int n_blocks;
{
    char *p;

    cvt->n_bufblks += n_blocks;
    cvt->buf_size = cvt->n_bufblks*CVTBUFLEN;
    cvt->buf = (char *)regloc(ge, cvt->buf,cvt->buf_size*sizeof(char));

    /* clear the new area */
    p = cvt->buf + ((cvt->n_bufblks-n_blocks)*CVTBUFLEN);
    memset(p,0,CVTBUFLEN);
}

/****************************************************************************
 *
 * module:  mlCleanupCvt
 */
mlCleanupCvt(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    /* if anything is allocated as part of cvt, it should be freed here. */
    if ( cvt->buf )
        gfree(ge, cvt->buf);
	cvt->buf = (char *)0;
	cvt->n_bufblks = 0;
	cvt->buf_size = 0;
}

/****************************************************************************
 *
 * module:  CvtMbToWStr
 */
int
CvtMbToWStr(ge, in_str, out_str )
graphics_main_type *ge;
unsigned char *in_str;
unsigned char *out_str;
{
    tx_char tmp=0;
    unsigned char *ip, *op, *tp=(unsigned char*)&tmp;
    int len = 0;

#if BUILD_WIDE
    len = MbToWStr(in_str, out_str );
#else
    /* a hacky piece of code to prepare any */
    /* strings currently stored as char[]   */
    /* for output as tx_char. This goes away */
    /* as soon as all internal strings are wide. */
    /* out_str better be twice as wide as in_str */
    /* Returns the number of characters, ie */
    /* strlen(in_str) */
    ip = in_str;
    op = out_str;
    while (*ip)
    {
        tmp = *ip;
        *op++ = tp[0];
        *op++ = tp[1];
        *ip++;
        len++;
    }

    /* delimit with a 'short' 0 */
    tmp = 0;
    *op++ = tp[0];
    *op++ = tp[1];
#endif
    return(len);
}

/****************************************************************************
 *
 * module:  CvtWStrToMb
 */
CvtWStrToMb(ge, in_str, out_str)
graphics_main_type *ge;
tx_char *in_str;
mbchar  *out_str;
{
    /* the complement of CvtMbToWStr() above */

    tx_char *ip;
    mbchar *op;

#if BUILD_WIDE
    WToMbStr(in_str, out_str );
#else
    ip = in_str;
    op = out_str;
    while (*ip)
        *op++ = (mbchar)(*ip++);

    *op = 0;
#endif
}

/****************************************************************************
 *
 * module:  MultiToWideStr
 */
int
MultiToWideStr(ge, in_str, out_str)
graphics_main_type *ge;
mbchar  *in_str;
tx_char *out_str;
{
#if !BUILD_WIDE
    return(CvtMbToWStr(ge, in_str, out_str));
#else
    return(MbToWStr(in_str, out_str));
#endif
}

/****************************************************************************
 *
 * module:  WideToMultiStr
 */
WideToMultiStr(ge, in_str, out_str)
graphics_main_type *ge;
tx_char *in_str;
mbchar  *out_str;
{
#if !BUILD_WIDE
    CvtWStrToMb(ge, in_str, out_str);
#else
    WToMbStr(in_str, out_str);
#endif
}

/****************************************************************************
 *
 * module:  SetToTransparent - make the thing's color transparent
 */
SetToTransparent(ge,cvt,t,thingAttr)
graphics_main_type *ge;
cvt_global_type *cvt;
thing *t;
int thingAttr;
{
    int ii;

    /* first, find the color we will use. */
    for (ii=0; ii<ge->cmap[0].n_colors; ii++)
    {
        if (ge->cmap[0].color[ii].see_thru)
            break;
    }
    if (ii == ge->cmap[0].n_colors) /* no transparent color */
    {
        ii = ge->cmap[0].n_colors;
        mlLoadCmapEntry(ge, 0, XLT("Transparent"), 0, 0, 0, 0, 0, 1);
    }

    switch(thingAttr)
    {
        case TLINE_BACKGROUND_COLOR:
        case TLINE_BACK_COLOR:
            t->attr.line_bg = ii;
        break;
        case TLINE_FOREGROUND_COLOR:
        case TLINE_FORE_COLOR:
            t->attr.line_fg = ii;
        break;
        case TFOREGROUND_COLOR:
        case TFORE_COLOR:
            t->attr.fill_fg = ii;
        break;
        case TBACKGROUND_COLOR:
        case TBACK_COLOR:
            t->attr.fill_bg = ii;
        break;
    }
}

/****************************************************************************
 *
 * module:  CvtGetPercentFill
 */
CvtGetPercentFill(ge, patn)
graphics_main_type *ge;
int patn;
{
    if (patn == 5)
        return(1000);
    else if (patn == 14)
        return(875);
    else if (patn == 4)
        return(750);
    else if (patn == 22)
        return(625);
    else if (patn == 3)
        return(500);
    else if (patn == 11)
        return(375);
    else if (patn == 2)
        return(250);
    else if (patn == 13)
        return(125);
    else if (patn == 1)
        return(0);
    return(patn);
}

/****************************************************************************
 *
 * module:  CvtGetPatnFromPercent
 */
CvtGetPatnFromPercent(ge, percent)
graphics_main_type *ge;
int percent;
{
    if (percent == 1000)
        return(5);
    else if (percent == 875)
        return(14);
    else if (percent == 750)
        return(4);
    else if (percent == 625)
        return(22);
    else if (percent == 500)
        return(3);
    else if (percent == 375)
        return(11);
    else if (percent == 250)
        return(2);
    else if (percent == 125)
        return(13);
    return(1);
}

/****************************************************************************
 *
 * module:  C v t A d d F o n t
 */
CvtAddFont(ge,cvt,face)
graphics_main_type *ge;
cvt_global_type *cvt;
char *face;
{
    int ii;


#if !FOR_FILTER
     /* deal with differences between NT and UNIX fnt names */
    face = (char *)MapFontFamily( face, FOREIGN_TO_NATIVE );
#endif

    /* look for the face in the existing list */
    for ( ii=0; ii<ge->n_faces; ii++ )
        if ( strcmp(ge->face[ii], face) == 0 )
            break;

    /* if not found, create a new entry */
    if ( ii >= ge->n_faces )
    {
        /* add the face to the used face list */
        ge->n_faces++;
        ge->face = (char **) regloc(ge, ge->face, ge->n_faces * sizeof(char *));
        ge->face[ii] = (char *) gloc(ge, (strlen(face)+1));
        strcpy(ge->face[ii], face);
    }

    return(ii);
}

/****************************************************************************
 *
 * module:  c v t G e t F P - a fairly clean fopen
 */
FILE *cvtGetFP(ge, fname, mode)
graphics_main_type *ge;
char *fname, *mode;
{
#if AXMS
    char dosMode[4];
#endif

    if (!(strcmp(fname,NXLT("stdin"))))
        return (stdin);
    if (!(strcmp(fname,NXLT("stdout"))))
        return (stdout);
#if AXMS
    dosMode[0] = mode[0];
    dosMode[1] = 'b';
    if ( mode[1] == '+' )
    {
        dosMode[2] = '+';
        dosMode[3] = 0;
    }
    else
    {
        dosMode[2] = 0;
    }
    return ( fopen(fname, dosMode) );
#else
    return ( fopen(fname, mode) );
#endif
}


/****************************************************************************
 *
 * module:  c v t C l o s e F i l e
 */
cvtCloseFile(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    fclose(cvt->fp);
}

/****************************************************************************
 *
 * module:  c a l c B o u n d s - compute bounding box of an object
 */
CalcBounds(ge, t)
graphics_main_type *ge;
thing *t;
{
    int ii;
    TmPoint32 max,min;

    switch(t->type)
    {
        case POLY:
        case STROK:
        case LINE:
            min.x = max.x = t->paths->points[0].x;
            min.y = max.y = t->paths->points[0].y;
            for (ii=1; ii<t->paths->nPoints; ii++)
            {
                if (t->paths->points[ii].x < min.x)
                    min.x = t->paths->points[ii].x;
                if (t->paths->points[ii].x > max.x)
                    max.x = t->paths->points[ii].x;
                if (t->paths->points[ii].y < min.y)
                    min.y = t->paths->points[ii].y;
                if (t->paths->points[ii].y > max.y)
                    max.y = t->paths->points[ii].y;
            }
            t->extent.x1 = min.x; t->extent.y1 = min.y;
            t->extent.x2 = max.x; t->extent.y2 = max.y;
        break;
    }
}

/****************************************************************************
 *
 * module: c v t A d d T o P a i n t L i s t
 */
cvtAddToPaintList(ge, t, ix)
graphics_main_type *ge;
thing *t;
int ix;
{
    int i, tSize;

    if (ix > ge->t->data.group->num+1)
        return;

    if ( ix < 0 ) /* append to end of list */
    {
        ge->t->data.group->num++;
        tSize = ge->t->data.group->num * sizeof(thing *);
        if (ge->t->data.group->list == NULL)
            ge->t->data.group->list = (thing**)gloc(ge, sizeof(thing *));
        else
            ge->t->data.group->list = (thing**)regloc(ge, ge->t->data.group->list,tSize);
        ge->t->data.group->list[ge->t->data.group->num-1] = t;
    }
    else
    {   
        tSize = (ge->t->data.group->num+1) * sizeof(thing *);
        ge->t->data.group->list = (thing**)regloc(ge, ge->t->data.group->list,tSize);
        for ( i=ge->t->data.group->num; i>ix; i-- )
            ge->t->data.group->list[i] = ge->t->data.group->list[i-1];
        ge->t->data.group->list[ix] = t;
        ge->t->data.group->num++;
    }
}

/****************************************************************************
 *
 * module: 
 */
cvt_remove_from_plist(ge, ix)
graphics_main_type *ge;
int ix;
{
	removeFromGroup(ge, ge->t, ix);
}

/****************************************************************************
 *
 * module:  CvtPartGenesis2
 */
thing *CvtPartGenesis2(ge, cvt, type, attr)
graphics_main_type *ge;
cvt_global_type *cvt;
int type;
thing_attributes *attr;
{
    thing *t;

    t = (thing *)makeThing(ge, type, attr);
    if ( t )
        t->id = cvt->count++;
    return (t);
}

/****************************************************************************
 *
 * module:  CvtPrim
 */
thing *CvtPrim(ge,cvt,objType,addtolist)
graphics_main_type *ge;
cvt_global_type *cvt;
int objType,addtolist;
{
    thing *t;

    t = CvtPartGenesis2(ge, cvt, objType, &cvt->curr_atts);
    if (addtolist)
    {
        cvtAddToPaintList(ge, t, -1);
        cvt->lastobj = t;
    }
    return(t);
}

/***************************************************************************
function: CvtGetIndexToAxFonts - given a font name this function returns
installed font number to use with CvtText.
*/
int
CvtGetIndexToAxFonts (ge,cvt,fontName)
graphics_main_type *ge;
cvt_global_type *cvt;
char *fontName;     /* name of the font */
{
    if ( fontName )
        cvt->curr_atts.face = CvtAddFont(ge, cvt, fontName);
    else
        cvt->curr_atts.face = CvtAddFont(ge, cvt, NXLT("Times"));
	return(cvt->curr_atts.face);
}

/****************************************************************************
 *
 * module:  CvtAddText - add substrings to a textbox
 */
CvtAddText(ge,cvt,t,fontName,pointSize,bold,italic,length,string)
graphics_main_type *ge;
cvt_global_type *cvt;
thing *t;
char *fontName;
int pointSize;
int bold,italic; /* 0 == off, 1 == on */
int length;
char *string;
{
    thing *txt_t;
    int nstrs, sz;

    nstrs = t->data.txtbox->n_strings++;
    sz = t->data.txtbox->n_strings*sizeof(thing*);
    t->data.txtbox->strings = (thing **)regloc(ge, t->data.txtbox->strings,sz);
    txt_t = (thing *)makeThing(ge, TEXT, &t->attr);
    t->data.txtbox->strings[nstrs] = txt_t;

    txt_t->data.str->n_chars = length;
    txt_t->data.str->chars = (tx_char*)gloc(ge, (length+1)*sizeof(tx_char));
    memset(txt_t->data.str->chars, 0x0, (length+1) * sizeof(tx_char));

    MultiToWideStr(ge, string,txt_t->data.str->chars);

    CvtGetIndexToAxFonts (ge,cvt,fontName);
    cvt->curr_atts.size = GetAxFontSize(ge, pointSize) * cvt->curr_atts.field_y_scale;
    cvt->curr_atts.weight = bold;
    cvt->curr_atts.slant = italic;

    memcpy(&txt_t->attr, &cvt->curr_atts, sizeof(thing_attributes));
    txt_t->attr.fpat_type = GRAY_FILL_TYPE;
    txt_t->attr.fill_pat = 1000;
    calcExtents(ge, txt_t);
}


/****************************************************************************
 *
 * module:  GetAxFontSize - FontSize rounder
 */
GetAxFontSize(ge, size)
graphics_main_type *ge;
int size;
{
    if (size <= 7)
        return (6);
    else if (size <= 9)
        return (8);
    else if (size <= 11)
        return (10);
    else if (size <= 13)
        return (12);
    else if (size <= 16)
        return (14);
    else if (size <= 21)
        return (18);
    else if (size <= 30)
        return (24);
    else
        return (36);


}

/* some tx_char functions */

/****************************************************************************
 *
 * module:	t x _ s t r n e q
 */
tx_strneq(ge, str1, str2, len)
graphics_main_type *ge;
tx_char *str1, *str2;
int len;
{
	int i;
	for ( i=0; i<len; i++ )
		if ( str1[i] != str2[i] )
			return ( FALSE );
	return ( TRUE );
}

tx_char *tx_ch(str, name)
tx_char *str;
char *name;
{
    register int i, len;
    len = strlen(name);
    for ( i=0; i<len; i++ )
        str[i] = (tx_char)name[i];
    str[i] = (tx_char)0;
    return(str);
}

/********** tx_strlen ****************/
int tx_strlen( p )
tx_char *p;
{
    int count = 0;
    while ( *p++ != (tx_char)0 )
       count++;
    return( count );
}

/********** tx_strcmp ****************/
int32 tx_strcmp( str1, str2 )
tx_char *str1, *str2;
{
    if (str1 == str2)
        return(0);

    while (TRUE) 
    {
        if ( (*str1 != *str2) || (*str1 == 0) || (*str2 == 0) )
           return( ((unsigned int)*str1) - ((unsigned int)*str2) );
        str1++;
        str2++;
    }
}

/********** tx_strncmp ****************/
int32 tx_strncmp( str1, str2, n )
tx_char *str1, *str2;
int n;
{
    if (str1 == str2)
        return(0);

    while (n > 0)
    {
        if ( *str1 != *str2 )
            return( ((unsigned int)*str1) - ((unsigned int)*str2) );
        str1++;
        str2++;
        n--;
    }

    /* strings are the same */
    return(0);
}

/********** tx_strncpy ****************/
tx_char * tx_strncpy(destination, source, count)
tx_char *destination, *source;
int count;
{
    register tx_char *dest;
    dest = destination;
    while (count--)
       *dest++ = *source++;
    *dest = (tx_char)0;
    return( destination );
}

/********** tx_strcpy ****************/
tx_char * tx_strcpy(destination, source)
tx_char *destination, *source;
{
    register tx_char *dest;
    dest = destination;
    while ( *source != (tx_char)0 )
       *dest++ = *source++;
    *dest = (tx_char)0;
    return( destination );
}

/********** tx_strcat ****************/
tx_char *tx_strcat(base, add)
tx_char *base, *add;
{
    tx_char *p;

    p = base + tx_strlen( base );
    tx_strcpy( p, add );
    return( base );
}

/********** tx_strncat ****************/
tx_char *tx_strncat(base, add, count)
tx_char *base, *add;
{
    tx_char *p;

    p = base + tx_strlen( base );
    tx_strncpy( p, add, count );
    return( base );
}

/****************************************************************************
 *
 * module:  e l l F l i p
 */
ellFlip(ge, t1, t2, rad)
graphics_main_type *ge;
int *t1, *t2, rad;
{
    int l1, l2;

    /* intelligently flip an ELLIPSE */

    l1 = rad - *t1;
    l2 = rad - *t2;
    while (l1 < 0)
        l1 += MAXANG;
    while (l2 < 0)
        l2 += MAXANG;
    if (l1 <= l2)
        l1 += MAXANG;
    *t1 = l2;
    *t2 = l1;
}

/****************************************************************************
 *
 * module:  p r i m F i x
 */
primFix(ge, t, otype)
graphics_main_type *ge;
register thing *t;
int otype;
{
    short m;
    bool arrowflip, sx, sy;

    /* make sure object's dimensions and other characteristics
     * are normalized properly after an edit operation, the way
     * we like 'em to be (optimized for speedy searchs. etc)
     */
    arrowflip = FALSE;

    /* x2 < x1 or y2 < y1? */
    sx = LT(t->extent.x2, t->extent.x1);
    sy = LT(t->extent.y2, t->extent.y1);

    if (otype == LINE)
    {
        /* deal with arrowheads */
        arrowflip = sx || sy;
    }

    if (sx)
        SWAP(t->extent.x1, t->extent.x2);
    if (sy)
        SWAP(t->extent.y1, t->extent.y2);

    /* do the flippy thing for arcs */
    if (otype == ELL && !FULL_ELL(t))
    {
        if (sx)
            ellFlip(ge, &t->data.ell->start_angle, &t->data.ell->end_angle, MAXANG);
        if (sy)
            ellFlip(ge, &t->data.ell->start_angle, &t->data.ell->end_angle, MAXANG >> 1);
        arrowflip = sx != sy;
    }
}


/****************************************************************************
 *
 * module: s e e W i n d o w - geometry controls for charting interface
 */
LINTCOMMENT(VARARGS2)

/* BE SURE TO CHANGE THE CALLER TO PASS GE !!! */

seeWindow(ge, arg, rdwr, new_val)
graphics_main_type *ge;
int arg, rdwr, new_val;
{

#if 0 /* #1 */
    static vector lastWin;
    int return_val;

    return_val = 0;
    switch (arg)
    {
        case WBOT:
            if ( rdwr == READ )
            {
                lastWin.y2 = ge->state.vp.y2 - ge->state.vp.y1;
                return_val = ge->state.win_orig.y1 + YLENTOWIN(lastWin.y2);
            }
            else
                lastWin.y2 = YLENTOVP(new_val);
        break;

        case WRIGHT:
            if ( rdwr == READ )
            {
                lastWin.x2 = ge->state.vp.x2 - ge->state.vp.x1;
                return_val = ge->state.win_orig.x1 + XLENTOWIN(lastWin.x2);
            }
            else
                lastWin.x2 = XLENTOVP(new_val);
        break;

    }
    return ( return_val );
#endif /* #1 */
}

/****************************************************************************
 *
 * module:  N o D u p L o a d C m a p E n t r y
 */
NoDupLoadCmapEntry(ge,cvt,mapNum,c,m,y,k,trans,name)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned int mapNum,c,m,y,k, trans;
char *name;
{
    int ii;
    cmap_type *cmap;
	char lname[16];

    /* only load the color if not already loaded */
    cmap = &ge->cmap[mapNum];
    for (ii=0; ii<cmap->n_colors; ii++)
    {
        if ((cmap->color[ii].c == c) &&
            (cmap->color[ii].m == m) &&
            (cmap->color[ii].y == y) &&
            (cmap->color[ii].k == k) &&
            (cmap->color[ii].see_thru == trans))
                return (ii);
    }

	if ( name == (char *)0 )
	{
		sprintf(lname ,NXLT("Color %d"), cmap->n_colors);
		mlLoadCmapEntry(ge, mapNum, lname, FALSE, c, m, y, k, trans);
	}
	else
		mlLoadCmapEntry(ge, mapNum, name, FALSE, c, m, y, k, trans);
    return (ii);
}


/****************************************************************************
 *
 * module:  m l L o a d C o l o r m a p E n t r y - for mlInColormap
 */
int
mlLoadCmapEntry(ge, ix, name, ink_type, c, m, y, k, see_thru)
graphics_main_type *ge;
int ix;
char *name; /* this is not 16 bit clean */
int ink_type;
int c, m, y, k;
int see_thru;
{
    return(loadCmapEntry(ge, ix, name, see_thru, ink_type, c, m, y, k));
}


/****************************************************************************
 *
 * module:  m l A x C o l o r m a p - default ax colormap
 */
mlAxColormap(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    if (ge->n_cmaps == 0 )
    {
        ge->cmap = (cmap_type*)gloc(ge,sizeof(cmap_type));
        memset(ge->cmap, 0x0, sizeof(cmap_type));
        ge->n_cmaps = 1;
		initDefaultMapWithDefaults(ge);
    }
}

/****************************************************************************
 *
 * module:  CmapperfromRGB - Load a colormap from rgb arrays
 */
CmapperfromRGB(ge,cvt,r,g,b,num_colors,makeNewCmap,colorZeroTrans)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned char *r,*g,*b;
int num_colors, colorZeroTrans;
{
    int ii;
    int mapno;
    char clr[20], *clrP;

    /* the caller has the option of having the  */
    /* map created prior to the call or now. */
    if (makeNewCmap)
    {
        mapno = ge->n_cmaps;
        MakeNewCmap(ge,cvt);
    }
    else
        mapno = ge->n_cmaps - 1;

    strcpy(clr,XLT("Color0"));
    LoadRGBCmapEntry(ge,cvt,mapno,0,r[0],g[0],b[0],colorZeroTrans,clr);
    clrP=clr+strlen(clr)-1;
    for (ii=1; ii<num_colors; ii++)
    {
        sprintf(clrP,"%d",ii);
        LoadRGBCmapEntry(ge,cvt,mapno,0,r[ii],g[ii],b[ii],0,clr);
    }
    return(mapno);
}


/****************************************************************************
 *
 * module:  NewCmapperfromRGB - Load a colormap from rgb arrays, with 
 *                              transparency flag.
 */
NewCmapperfromRGB(ge,cvt,r,g,b,num_colors,makeNewCmap,Trans)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned char *r,*g,*b;
int num_colors;
unsigned char *Trans;
{
    int ii;
    int mapno;
    char clr[20], *clrP;

    /* the caller has the option of having the  */
    /* map created prior to the call or now. */
    if (makeNewCmap)
    {
        mapno = ge->n_cmaps;
        MakeNewCmap(ge,cvt);
    }
    else
        mapno = ge->n_cmaps - 1;

    strcpy(clr,XLT("Color0"));
    LoadRGBCmapEntry(ge, cvt, mapno, 0, r[0], g[0], b[0], Trans[0], clr);
    clrP=clr+strlen(clr)-1;
    for (ii=1; ii<num_colors; ii++)
    {
        sprintf(clrP,"%d",ii);
        LoadRGBCmapEntry(ge, cvt, mapno, 0, r[ii], g[ii], b[ii],Trans[ii],clr);
    }
    return(mapno);
}

/****************************************************************************
 *
 * module:  N o D u p L o a d R G B C m a p E n t r y
 */
NoDupLoadRGBCmapEntryWithName(ge,cvt,mapNum,shiftval,r,g,b,t, name)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned int mapNum,shiftval, r,g,b, t;
char *name;
{
    int val,c,m,y,k;

    rgb2cmyk(r,g,b,&c,&m,&y,&k,shiftval);
    val = NoDupLoadCmapEntry(ge,cvt,mapNum,c,m,y,k,t,name);
    return(val);
}


/****************************************************************************
 *
 * module:  N o D u p L o a d R G B C m a p E n t r y
 */
NoDupLoadRGBCmapEntry(ge,cvt,mapNum,shiftval,red,green,blue,trans)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned int mapNum,shiftval, red,green,blue, trans;
{
    int val,c,m,y,k;

    rgb2cmyk(red,green,blue,&c,&m,&y,&k,shiftval);
    val = NoDupLoadCmapEntry(ge,cvt,mapNum,c,m,y,k,trans,NULL);
    return(val);
}


/****************************************************************************
 *
 * module:  L o a d R G B C m a p E n t r y
 */
LoadRGBCmapEntry(ge,cvt,mapNum,shiftval,red,green,blue,trans,name)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned int mapNum,shiftval, red,green,blue, trans;
char *name;
{
    int c,m,y,k, ix;

    rgb2cmyk(red,green,blue,&c,&m,&y,&k,shiftval);
    ix = mlLoadCmapEntry(ge, mapNum, name, FALSE, c, m, y, k, trans);
	return(ix);
}


/****************************************************************************
 *
 * module:  E x t r a c t R G B C m a p E n t r y
 */
ExtractRGBCmapEntry(ge,cvt,mapNum,colornum,red,green,blue)
graphics_main_type *ge;
cvt_global_type *cvt;
unsigned int mapNum,colornum,*red, *green, *blue;
{
    cmyk2rgb(ge->cmap[mapNum].color[colornum].c,
             ge->cmap[mapNum].color[colornum].m,
             ge->cmap[mapNum].color[colornum].y,
             ge->cmap[mapNum].color[colornum].k,
             red,green,blue);
}

/****************************************************************************
 *
 * module:  M a k e N e w C m a p
 */
MakeNewCmap(ge,cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    int size;

    /* allocate space for the new colormap */
    size = (ge->n_cmaps+1)*sizeof(cmap_type);
    ge->cmap = (cmap_type *)regloc(ge, ge->cmap, size);
    memset((char *)&ge->cmap[ge->n_cmaps], 0, sizeof(cmap_type));
    ge->n_cmaps++;
}
 
/****************************************************************************
 *
 * module:  m l L o a d A x I m D e f C m a p
 *          Load Asterx Image Default Colormap
 */
mlLoadAxImDefCmap(ge, cvt, nm)
graphics_main_type *ge;
cvt_global_type *cvt;
int nm; /* map number */
{
    /* create the default Asterx colormap for images */
    mlLoadCmapEntry(ge, nm, XLT("Transparent"), 0, 0, 0, 0, 0, 1);
    mlLoadCmapEntry(ge, nm, XLT("Black"), 0, 0, 0, 0, 255, 0);
    mlLoadCmapEntry(ge, nm, XLT("White"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color003"), 0, 128, 128, 128, 127, 0);
    mlLoadCmapEntry(ge, nm, XLT("color004"), 0, 190, 190, 66, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color005"), 0, 227, 227, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color006"), 0, 239, 239, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color007"), 0, 247, 247, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color008"), 0, 255, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color009"), 0, 190, 66, 190, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color010"), 0, 190, 66, 66, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color011"), 0, 227, 103, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color012"), 0, 239, 115, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color013"), 0, 247, 123, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color014"), 0, 255, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color015"), 0, 227, 29, 227, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color016"), 0, 227, 29, 103, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color017"), 0, 227, 29, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color018"), 0, 239, 41, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color019"), 0, 247, 49, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color020"), 0, 255, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color021"), 0, 239, 16, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color022"), 0, 239, 16, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color023"), 0, 239, 16, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color024"), 0, 239, 16, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color025"), 0, 247, 24, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color026"), 0, 255, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color027"), 0, 247, 8, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color028"), 0, 247, 8, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color029"), 0, 247, 8, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color030"), 0, 247, 8, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color031"), 0, 247, 8, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color032"), 0, 255, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color033"), 0, 255, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color034"), 0, 255, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color035"), 0, 255, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color036"), 0, 255, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color037"), 0, 255, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color038"), 0, 255, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color039"), 0, 66, 190, 190, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color040"), 0, 66, 190, 66, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color041"), 0, 103, 227, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color042"), 0, 115, 239, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color043"), 0, 123, 247, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color044"), 0, 131, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color045"), 0, 66, 66, 190, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color046"), 0, 66, 66, 66, 65, 0);
    mlLoadCmapEntry(ge, nm, XLT("color047"), 0, 103, 103, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color048"), 0, 115, 115, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color049"), 0, 123, 123, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color050"), 0, 131, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color051"), 0, 103, 29, 227, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color052"), 0, 103, 29, 103, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color053"), 0, 103, 29, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color054"), 0, 115, 41, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color055"), 0, 123, 49, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color056"), 0, 131, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color057"), 0, 115, 16, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color058"), 0, 115, 16, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color059"), 0, 115, 16, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color060"), 0, 115, 16, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color061"), 0, 123, 24, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color062"), 0, 131, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color063"), 0, 123, 8, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color064"), 0, 123, 8, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color065"), 0, 123, 8, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color066"), 0, 123, 8, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color067"), 0, 123, 8, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color068"), 0, 131, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color069"), 0, 131, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color070"), 0, 131, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color071"), 0, 131, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color072"), 0, 131, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color073"), 0, 131, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color074"), 0, 131, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color075"), 0, 29, 227, 227, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color076"), 0, 29, 227, 103, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color077"), 0, 29, 227, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color078"), 0, 41, 239, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color079"), 0, 49, 247, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color080"), 0, 57, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color081"), 0, 29, 103, 227, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color082"), 0, 29, 103, 103, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color083"), 0, 29, 103, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color084"), 0, 41, 115, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color085"), 0, 49, 123, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color086"), 0, 57, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color087"), 0, 29, 29, 227, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color088"), 0, 29, 29, 103, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color089"), 0, 29, 29, 29, 28, 0);
    mlLoadCmapEntry(ge, nm, XLT("color090"), 0, 41, 41, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color091"), 0, 49, 49, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color092"), 0, 57, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color093"), 0, 41, 16, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color094"), 0, 41, 16, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color095"), 0, 41, 16, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color096"), 0, 41, 16, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color097"), 0, 49, 24, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color098"), 0, 57, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color099"), 0, 49, 8, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color100"), 0, 49, 8, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color101"), 0, 49, 8, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color102"), 0, 49, 8, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color103"), 0, 49, 8, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color104"), 0, 57, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color105"), 0, 57, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color106"), 0, 57, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color107"), 0, 57, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color108"), 0, 57, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color109"), 0, 57, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color110"), 0, 57, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color111"), 0, 16, 239, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color112"), 0, 16, 239, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color113"), 0, 16, 239, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color114"), 0, 16, 239, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color115"), 0, 24, 247, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color116"), 0, 32, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color117"), 0, 16, 115, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color118"), 0, 16, 115, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color119"), 0, 16, 115, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color120"), 0, 16, 115, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color121"), 0, 24, 123, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color122"), 0, 32, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color123"), 0, 16, 41, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color124"), 0, 16, 41, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color125"), 0, 16, 41, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color126"), 0, 16, 41, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color127"), 0, 24, 49, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color128"), 0, 32, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color129"), 0, 16, 16, 239, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color130"), 0, 16, 16, 115, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color131"), 0, 16, 16, 41, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color132"), 0, 16, 16, 16, 16, 0);
    mlLoadCmapEntry(ge, nm, XLT("color133"), 0, 24, 24, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color134"), 0, 32, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color135"), 0, 24, 8, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color136"), 0, 24, 8, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color137"), 0, 24, 8, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color138"), 0, 24, 8, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color139"), 0, 24, 8, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color140"), 0, 32, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color141"), 0, 32, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color142"), 0, 32, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color143"), 0, 32, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color144"), 0, 32, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color145"), 0, 32, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color146"), 0, 32, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color147"), 0, 8, 247, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color148"), 0, 8, 247, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color149"), 0, 8, 247, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color150"), 0, 8, 247, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color151"), 0, 8, 247, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color152"), 0, 16, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color153"), 0, 8, 123, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color154"), 0, 8, 123, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color155"), 0, 8, 123, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color156"), 0, 8, 123, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color157"), 0, 8, 123, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color158"), 0, 16, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color159"), 0, 8, 49, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color160"), 0, 8, 49, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color161"), 0, 8, 49, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color162"), 0, 8, 49, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color163"), 0, 8, 49, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color164"), 0, 16, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color165"), 0, 8, 24, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color166"), 0, 8, 24, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color167"), 0, 8, 24, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color168"), 0, 8, 24, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color169"), 0, 8, 24, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color170"), 0, 16, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color171"), 0, 8, 8, 247, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color172"), 0, 8, 8, 123, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color173"), 0, 8, 8, 49, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color174"), 0, 8, 8, 24, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color175"), 0, 8, 8, 8, 8, 0);
    mlLoadCmapEntry(ge, nm, XLT("color176"), 0, 16, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color177"), 0, 16, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color178"), 0, 16, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color179"), 0, 16, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color180"), 0, 16, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color181"), 0, 16, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color182"), 0, 16, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color183"), 0, 0, 255, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color184"), 0, 0, 255, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color185"), 0, 0, 255, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color186"), 0, 0, 255, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color187"), 0, 0, 255, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color188"), 0, 0, 255, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color189"), 0, 0, 131, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color190"), 0, 0, 131, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color191"), 0, 0, 131, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color192"), 0, 0, 131, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color193"), 0, 0, 131, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color194"), 0, 0, 131, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color195"), 0, 0, 57, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color196"), 0, 0, 57, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color197"), 0, 0, 57, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color198"), 0, 0, 57, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color199"), 0, 0, 57, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color200"), 0, 0, 57, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color201"), 0, 0, 32, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color202"), 0, 0, 32, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color203"), 0, 0, 32, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color204"), 0, 0, 32, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color205"), 0, 0, 32, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color206"), 0, 0, 32, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color207"), 0, 0, 16, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color208"), 0, 0, 16, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color209"), 0, 0, 16, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color210"), 0, 0, 16, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color211"), 0, 0, 16, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color212"), 0, 0, 16, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color213"), 0, 0, 0, 255, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color214"), 0, 0, 0, 131, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color215"), 0, 0, 0, 57, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color216"), 0, 0, 0, 32, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color217"), 0, 0, 0, 16, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color218"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color219"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color220"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color221"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color222"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color223"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color224"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color225"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color226"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color227"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color228"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color229"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color230"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color231"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color232"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color233"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color234"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color235"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color236"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color237"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color238"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color239"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color240"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color241"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color242"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color243"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color244"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color245"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color246"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color247"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color248"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color249"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color250"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color251"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color252"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color253"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color254"), 0, 0, 0, 0, 0, 0);
    mlLoadCmapEntry(ge, nm, XLT("color255"), 0, 0, 0, 0, 0, 0);
}

/****************************************************************************
 *
 * module:  m l I n I m g M a s k
 */
mlCreateImgMask(ge, t, cvt, maskData)
graphics_main_type *ge;
thing *t;
cvt_global_type *cvt;
unsigned char maskData;
{
    int sz;

	t->data.img->info.mask_byte_wid = ((t->data.img->info.wid + 15)/8) & (~1);
	sz = t->data.img->info.hyt*t->data.img->info.mask_byte_wid;
	t->data.img->info.mask = (unsigned char *)gloc(ge, sz);
	if ( t->data.img->info.mask )
	    memset(t->data.img->info.mask, maskData, sz);
}

/****************************************************************************
 *
 * module:  c h e c k O l i n
 */
checkOlin(ge, cvt, t, obj)
graphics_main_type *ge;
cvt_global_type *cvt;
thing *t;
cvt_part_creation_type *obj;
{
    double dwid, dhyt;
    TmPoint32 *pts;
    int wid, hyt;

    /* convert from pixels to mils */
    if ( obj->sawCorner == FALSE && obj->sawXYres == TRUE )
    {
        /* pix to mils */
        dwid = cvt->width  * MILS_P_INCH;
        dhyt = cvt->height * MILS_P_INCH;
        wid = ceil((double)(dwid / (double)cvt->xres));
        hyt = ceil((double)(dhyt / (double)cvt->xres));

        /* convert from a size to a position */
        t->extent.x2 = t->extent.x1 + wid - 1;
        t->extent.y2 = t->extent.y1 + hyt - 1;
    }

    /* compute missing outline, if necessary */
    if ( t->data.img->trans.nPoints == 0 )
    {
        t->data.img->trans.nPoints = 5;
        pts = (TmPoint32*)gloc(ge, 5*sizeof(TmPoint32));
        memset(pts, 0x0, 5*sizeof(TmPoint32));

        pts[0].x = pts[3].x = pts[4].x = t->extent.x1;
        pts[1].x = pts[2].x = t->extent.x2;
        pts[0].y = pts[1].y = pts[4].y = t->extent.y1;
        pts[2].y = pts[3].y = t->extent.y2;
        t->data.img->trans.nPoints = 5;
        t->data.img->trans.points = pts;
    }
}

/****************************************************************************
 *
 * module:  mlFreeCharts
 */
mlFreeCharts(ge)
graphics_main_type *ge;
{
    ge->n_charts = 0;
}

/****************************************************************************
 *
 * module:  mlFreeFaces
 */
mlFreeFaces(ge)
graphics_main_type *ge;
{
    int ii;

    for (ii=0; ii<ge->n_faces; ii++)
        gfree(ge, ge->face[ii]);

    if (ge->face != NULL)
    {
        gfree(ge, ge->face);
        ge->face = NULL;
    }
    ge->n_faces = 0;
}

/****************************************************************************
 *
 * module:  mlFreeFills
 */
mlFreeFills(ge)
graphics_main_type *ge;
{
    int ii;

    for (ii=0; ii<ge->n_fills; ii++)
    {
        gfree(ge, ge->fill[ii].name);
        gfree(ge, ge->fill[ii].data);
    }

    if (ge->fill != NULL)
    {
        gfree(ge, ge->fill);
        ge->fill = NULL;
    }
    ge->n_fills = 0;
}

/****************************************************************************
 *
 * module:  mlFreeStyles
 */
mlFreeStyles(ge)
graphics_main_type *ge;
{
    int ii;

    if (ge->style != NULL)
    {
        gfree(ge, ge->style);
        ge->style = NULL;
    }
    ge->n_styles = 0;
}

/****************************************************************************
 *
 * module:  mlFreeCallbacks
 */
mlFreeCallbacks(ge)
graphics_main_type *ge;
{
    int ii, jj;

    for (ii=0; ii<ge->n_callbacks; ii++)
    {
        gfree(ge, ge->callback[ii].name);
        if ( ge->callback[ii].args )
        {
            for (jj=0; jj<ge->callback[ii].n_args; jj++)
                gfree(ge, ge->callback[ii].args[jj]);
            gfree(ge, ge->callback[ii].args);
        }
    }

    if (ge->callback != NULL)
    {
        gfree(ge, ge->callback);
        ge->callback = NULL;
    }
    ge->n_callbacks = 0;
}

/****************************************************************************
 *
 * module:  mlFreeTags
 */
mlFreeTags(ge)
graphics_main_type *ge;
{
    int ii, jj;

    for (ii=0; ii<ge->n_tags; ii++)
    {
        if ( ge->tag[ii].str )
        {
            for (jj=0; jj<ge->tag[ii].n_strs; jj++)
                gfree(ge, ge->tag[ii].str[jj]);
            gfree(ge, ge->tag[ii].str);
        }
    }

    if (ge->tag != NULL)
    {
        gfree(ge, ge->tag);
        ge->tag = NULL;
    }
    ge->n_tags = 0;
}

/****************************************************************************
 *
 * module:  mlFreeUdo
 */
mlFreeUdo(ge)
graphics_main_type *ge;
{
    int ii;

    for (ii=0; ii<ge->n_udos; ii++)
    {
        disposeThing(ge, ge->udo[ii].t, TRUE);
        gfree(ge, ge->udo[ii].name);
    }

    if (ge->udo != NULL)
    {
        gfree(ge, ge->udo);
        ge->udo = NULL;
    }
    ge->n_udos = 0;
}

/****************************************************************************
 *
 * module:  m l F r e e C M a p - Blow them all away
 */
mlFreeCMap(ge)
graphics_main_type *ge;
{
    int ii,jj;

    for (ii=0; ii<ge->n_cmaps; ii++)
    {
        for (jj=0; jj<ge->cmap[ii].n_colors; jj++)
            gfree(ge, ge->cmap[ii].color[jj].name);
        gfree(ge, ge->cmap[ii].color);
    }

    if (ge->cmap != NULL)
    {
        gfree(ge, ge->cmap);
        ge->cmap = NULL;
    }
    ge->n_cmaps = 0;
}

/****************************************************************************
 *
 * module:  m l F r e e P a g e s - free all the pages
 */
mlFreePages(ge)
graphics_main_type *ge;
{
    int i,j;
    thing *t;

    /* clear all per page info */
    if ( ge->n_pages > 0 )
    {
        for ( i=0; i<ge->n_pages; i++ )
			gClearPage(ge, &ge->page[i], FALSE);

        /* reset the page list */
        if ( ge->page )
        {
            gfree(ge, ge->page);
            ge->page = (ge_page_type *)0;
        }
        ge->n_pages = 0;
    }
    ge->t = (thing *)0;
    ge->page_ix = 0;
}

/****************************************************************************
 *
 * module:  ResetCvtState -
 */
ResetCvtState(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
	cvt->done              = FALSE;
	cvt->vers_found        = FALSE;
	cvt->cmaps_found       = FALSE;
	cvt->faces_found       = FALSE;
	cvt->cbacks_found      = FALSE;
	cvt->fills_found       = FALSE;
	cvt->styles_found      = FALSE;
	cvt->sess_found        = FALSE;
	cvt->udos_found        = FALSE;
	cvt->tags_found        = FALSE;
	cvt->pict_found        = FALSE;
	cvt->audio_found       = FALSE;
	cvt->hdrftr_found      = FALSE;
	cvt->slide_found       = FALSE;
	cvt->layers_found      = FALSE;
	cvt->tmp_found         = FALSE;
	cvt->templ_print       = FALSE;
	cvt->inserted_page     = FALSE;
	cvt->slide_build_found = FALSE;

	mlCleanupCvt(ge, cvt);
	CvtBiggerBuffer(ge, cvt, 1);

    /* note that we're running as part of the GE */
    cvt->x_off = 0;
    cvt->y_off = 0;
    cvt->field_wid = 0;
    cvt->x_corner_radius = 0;
    cvt->y_corner_radius = 0;
    cvt->scale_corners = 0;
    cvt->x_corner_numerator = 0;
    cvt->y_corner_numerator = 0;
    cvt->sshape_type = 0;
    cvt->lshape_type = 0;
    cvt->cmapID = 0;
    cvt->nsides = 0;
	cvt->startAngle = 0;
    cvt->endAngle = 3600;
    cvt->lineno = 1;
    cvt->count = 0;

    /* set the initial default attributes */
    cvtInitAttrs(ge, &cvt->curr_atts);
}

/****************************************************************************
 *
 * module:  ResetGEstate - Set the GE graphics_main_type to start state
 */
ResetGEstate(ge)
graphics_main_type *ge;
{
    /* Delete all existing data */
	clearGE(ge);
#if 0
    mlFreeCharts(ge);
    mlFreeFaces(ge);
    mlFreeFills(ge);
    mlFreeStyles(ge);
    mlFreeCallbacks(ge);
    mlFreeTags(ge);
    mlFreeUdo(ge);
    mlFreeCMap(ge);
    mlFreePages(ge);
#endif

    /* get to a sane state */
    ge->state.def_tabsize = 1000;
    ge->state.dpi = 1000;
    ge->state.unit_precision = 3;
    ge->state.unit_size = 1000;
    ge->state.gridSize = 250;
    ge->state.line_1 = 28;
    ge->state.line_2 = 42;
    ge->state.line_3 = 56;
    ge->state.line_4 = 70;
    ge->state.default_slide_effect = 0;
    ge->state.default_slide_throttle = 1;
    ge->state.default_slide_delay  = 5;

	/* build info */
    ge->state.default_build.build_delay = -1; /* on click */
    ge->state.default_build.build_throttle = 1;
    ge->state.default_build.baudio.volume = 50;

    ge->state.unit_name = strcpy((char*)gloc(ge, 4),NXLT("in."));
    ge->state.layer = 0;
    ge->print.page_x = 59750;
    ge->print.page_y = 58000;
    ge->print.page_wid = 8500;
    ge->print.page_hyt = 11000;
    ge->print.margin.x1 = ge->print.margin.x2 = 500;
    ge->print.margin.y1 = ge->print.margin.y2 = 500;
    ge->x_zero_pt = ge->print.page_x + ge->print.margin.x1;
    ge->y_zero_pt = ge->print.page_y + ge->print.margin.y1;
	ge->state.win_orig.x1 = ge->x_zero_pt;
	ge->state.win_orig.y1 = ge->y_zero_pt;
    ge->print.wid = 8500;
    ge->print.hyt = 11000;
    ge->print.h_scale = 100;
    ge->print.v_scale = 100;
    ge->print.landscape = FALSE;
	ge->xform.zoom_to_fit = FALSE;
	ge->xform.x_res = 1000;
	ge->xform.y_res = 1000;
    cvtInitAttrs(ge, &ge->def_attr);
	ge->state.show_option.full_screen = TRUE;
	ge->state.show_option.all_pages = TRUE;
	ge->state.show_option.page1 = 0;
	ge->state.show_option.pageN = 0;
	ge->state.show_option.at_end = 0;
}

int
ge_layout_size(ge, size)
graphics_main_type *ge;
int size;
{
    if ( size > 250 )
        size -= 125;
    else if ( size > 125 )
        size = 125;
    return(size);
}

thing *
best_choice(ge, t, t0, t1, t2, t3, t4, init)
graphics_main_type *ge;
thing *t, *t0, *t1, *t2, *t3, *t4;
int init;
{
	/* must be a title */
	if ( t0 && t0->flags.used == FALSE )
	{
		if ( t0->data.temp->type == t->data.temp->type &&
			( t->data.temp->size == TMP_TITLE_1 ||
			 t->data.temp->size == TMP_TITLE_2 ))
			return(t0);
	}

	/* can be a subtitle */
	if ( t1 && t1->flags.used == FALSE )
	{
		if ( t1->data.temp->type == t->data.temp->type )
		{
			if ( t1->data.temp->type == TEMPLATE_TITLE &&
			     t1->data.temp->size == TMP_SUBTITLE )
			{
				 if ( t->data.temp->size == TMP_SUBTITLE )
					return(t1);
			}

			else if ( t1->data.temp->size == t->data.temp->size )
				return(t1);

			else if ( !best_choice(ge, t, NULL, NULL, t2, t3, t4, FALSE) )
			{
				if ( init )
					return(t1);
			}
		}
	}

	/* could be anything */
	if ( t2 && t2->flags.used == FALSE )
	{
		if ( t2->data.temp->type == t->data.temp->type )
		{
			if ( t2->data.temp->size == t->data.temp->size )
				return(t2);

			else if ( !best_choice(ge, t, NULL, NULL, NULL, t3, t4, FALSE) )
			{
				if ( init )
					return(t2);
			}
		}
	}

	/* could be anything */
	if ( t3 && t3->flags.used == FALSE )
	{
		if ( t3->data.temp->type == t->data.temp->type )
		{
			if ( t3->data.temp->size == t->data.temp->size )
				return(t3);

			else if ( !best_choice(ge, t, NULL, NULL, NULL, NULL, t4, FALSE) )
			{
				if ( init )
					return(t3);
			}
		}
	}

	/* could be anything */
	if ( t4 && t4->flags.used == FALSE )
	{
		if ( t4->data.temp->type == t->data.temp->type )
		{
			if ( t4->data.temp->size == t->data.temp->size )
				return(t4);
		}
		return((thing *)0);
	}

	/* didn't find a match */
	return((thing *)0);
}


thing *
tCreateTemplate(ge, ix, type_ix)
graphics_main_type *ge;
int ix;
int type_ix;
{
	int hyt, wid, i;
	vector area;
	thing *t;

	if ( !ge->template )
		return((thing *)0);
	switch ( type_ix )
	{
		case TEMPLATE_OTHER:
		case TEMPLATE_TITLE:
		case TEMPLATE_BLIST:
		case TEMPLATE_GRAFX:
		case TEMPLATE_CHART:
		case TEMPLATE_SLIDE:
		case TEMPLATE_NOTES:
		case TEMPLATE_HOUTS:
		case TEMPLATE_S1:
		case TEMPLATE_S2:
		case TEMPLATE_N1:
		case TEMPLATE_N2:
		case TEMPLATE_TABLE:
		case TEMPLATE_NUM_LIST:
				t = (thing *)makePrim(ge, TEMPLATE);
		break;
		default:
				t = (thing *)0;
		break;
	}
	if ( t == (thing *)0 )
		return(t);

	t->layer = 0;
	switch ( ix )
	{
		case TMP_TITLE_1:
			t->data.temp->area = ge->template->slide_heading;
			t->data.temp->size = TMP_TITLE_1;
		break;
		case TMP_TITLE_2:
			t->data.temp->area = ge->template->slide_heading;
			t->data.temp->size = TMP_TITLE_2;
		break;
		case TMP_SUBTITLE:
			t->data.temp->area = ge->template->slide_content;
			t->data.temp->size = TMP_SUBTITLE;
		break;
		default:
		case TMP_FULLSIZE:
			t->data.temp->area = ge->template->slide_content;
			t->data.temp->size = TMP_FULLSIZE;
		break;
		case TMP_COLUMN_1:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			area.x2 = area.x1 + ge_layout_size(ge, wid);
			t->data.temp->area = area;
			t->data.temp->size = TMP_COLUMN_1;
		break;
		case TMP_COLUMN_2:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			area.x1 = area.x2 - ge_layout_size(ge, wid);
			t->data.temp->area = area;
			t->data.temp->size = TMP_COLUMN_2;
		break;
		case TMP_ROW_1:
			area = ge->template->slide_content;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.y2 = area.y1 + ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_ROW_1;
		break;
		case TMP_ROW_2:
			area = ge->template->slide_content;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.y1 = area.y2 - ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_ROW_2;
		break;
		case TMP_SMALL_1:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.x2 = area.x1 + ge_layout_size(ge, wid);
			area.y2 = area.y1 + ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_SMALL_1;
		break;
		case TMP_SMALL_2:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.x1 = area.x2 - ge_layout_size(ge, wid);
			area.y2 = area.y1 + ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_SMALL_2;
		break;
		case TMP_SMALL_3:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.x2 = area.x1 + ge_layout_size(ge, wid);
			area.y1 = area.y2 - ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_SMALL_3;
		break;
		case TMP_SMALL_4:
			area = ge->template->slide_content;
			wid = (area.x2 - area.x1 + 1) / 2.0;
			hyt = (area.y2 - area.y1 + 1) / 2.0;
			area.x1 = area.x2 - ge_layout_size(ge, wid);
			area.y1 = area.y2 - ge_layout_size(ge, hyt);
			t->data.temp->area = area;
			t->data.temp->size = TMP_SMALL_4;
		break;
		case TMP_N1:
			t->data.temp->area = ge->template->notes_preview;
			t->data.temp->size = TMP_N1;
		break;
		case TMP_N2:
			t->data.temp->area = ge->template->notes_content;
			t->data.temp->size = TMP_N2;
		break;
		case TMP_FULLPAGE:
			t->data.temp->area.x1 = ge->print.page_x + ge->print.margin.x1;
			t->data.temp->area.y1 = ge->print.page_y + ge->print.margin.y1;
			t->data.temp->area.x2 = ge->print.page_x + ge->print.page_wid - 
									ge->print.margin.x2;
			t->data.temp->area.y2 = ge->print.page_y + ge->print.page_hyt -
									ge->print.margin.y2;
			t->data.temp->size = TMP_FULLPAGE;
		break;
	}
	t->data.temp->type = type_ix;
	calcExtents(ge, t);
	primFix(ge, t, TEMPLATE);

	/* add the object to the paint list */
	tAddToPaintList(ge, t, -1, FALSE);
	/* note there is no object under construction */
	ge->prim_t = (thing *)NULL;
	return(t);
}

/****************************************************************************
 *
 * module: g r R e m o v e T e m p l a t e s
 */
grRemoveTemplates(ge, template_tlist, n_templates, temp_info)
graphics_main_type *ge;
thing ***template_tlist;
int *n_templates;
int temp_info;
{
	thing **tlist, *t;
	int i, j, n, size;

	/* init */
	tlist = ge->t->data.group->list;
	n = ge->t->data.group->num;
	*template_tlist = (thing **)0;
	*n_templates = 0;

	/* check the top level objects ONLY! */
	if ( ge->t->type == GROUP ) for ( i=0; i<n; i++ )
	{
		t = tlist[i];
		if ( !t || t->type != TEMPLATE )
			continue;

		/* get the old template */
		(*n_templates)++;
		size = (*n_templates) * sizeof(thing *);
		*template_tlist = (thing **)regloc(ge, *template_tlist, size);
		if ( temp_info )
		{
			t->flags.recolored = FALSE;
			t->flags.templated = FALSE;
		}
		(*template_tlist)[(*n_templates)-1] = t;
		t->data.temp->inactive = TRUE;

		/* remove it from the paintlist */
		for ( j=i; j<n; j++ )
			tlist[j] = tlist[j+1];
		i--;
		n--;
	}

	if ( n != ge->t->data.group->num )
	{
		size = n * sizeof(thing *);
		tlist = (thing **)regloc(ge, tlist, size);
		ge->t->data.group->list = tlist;
		ge->t->data.group->num = n;
		calcExtents(ge, ge->t);
		if ( ge->file.doc_changed == FALSE )
			ge->file.doc_changed = TRUE;
	}

}

grCreateTemplateMasters(ge, page_ix, do_slides, do_notes)
graphics_main_type *ge;
int page_ix;
int do_slides;
int do_notes;
{
	thing *t, *t0, *t1, *t2, *t3, *t4, *old_t, **template_tlist, *best_t;
	int i, l_ix, n_templates;
	ge_page_type *page;

	/* get ready */
	old_t = ge->t;

	/* remove and inactivate old template objects from current page */
	if ( do_slides )
	{
		page = &ge->page[page_ix];
		ge->t = &ge->page[page_ix].t;
		grRemoveTemplates(ge, &template_tlist, &n_templates, FALSE);


		/* create object template(s) */
		l_ix = ge->page[page_ix].layout_ix;
		switch ( l_ix )
		{
			case TITLE_PAGE: /* 0 - title page */
				t0 = tCreateTemplate(ge, TMP_TITLE_2,  TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_SUBTITLE, page->object1);
				t2 = (thing *)0;
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
			case BASIC_PAGE: /* 1 - basic  page - 1 obj */
				t0 = tCreateTemplate(ge, TMP_TITLE_1,  TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_FULLSIZE, page->object1);
				t2 = (thing *)0;
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
			case TWO_COLUMN_PAGE: /* 2 - 2 column page - obj1, obj2 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1,  TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_COLUMN_1, page->object1);
				t2 = tCreateTemplate(ge, TMP_COLUMN_2, page->object2);
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
			case TWO_ROW_PAGE: /* 3 - 2 row page - obj1, obj2 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1, TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_ROW_1,   page->object1);
				t2 = tCreateTemplate(ge, TMP_ROW_2,   page->object2);
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
			case SPLT_COL_AND_COL_PG: /* 4 - obj1, obj2, obj3 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1,  TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_SMALL_1,  page->object1);
				t2 = tCreateTemplate(ge, TMP_COLUMN_2, page->object2);
				t3 = tCreateTemplate(ge, TMP_SMALL_3,  page->object3);
				t4 = (thing *)0;
			break;
			case COL_AND_SPLT_COL_PG: /* 5 - obj1, obj2, obj3 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1,  TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_COLUMN_1, page->object1);
				t2 = tCreateTemplate(ge, TMP_SMALL_2,  page->object2);
				t3 = tCreateTemplate(ge, TMP_SMALL_4,  page->object3);
				t4 = (thing *)0;
			break;
			case SPLT_ROW_OVR_ROW_PG: /* 6 - obj1, obj2, obj3  */
				t0 = tCreateTemplate(ge, TMP_TITLE_1, TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_SMALL_1, page->object1);
				t2 = tCreateTemplate(ge, TMP_SMALL_2, page->object2);
				t3 = tCreateTemplate(ge, TMP_ROW_2,   page->object3);
				t4 = (thing *)0;
			break;
			case ROW_OVR_SPLT_ROW_PG: /* 7 - obj1, obj2, obj3 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1, TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_ROW_1,   page->object1);
				t2 = tCreateTemplate(ge, TMP_SMALL_3, page->object2);
				t3 = tCreateTemplate(ge, TMP_SMALL_4, page->object3);
				t4 = (thing *)0;
			break;
			case FOUR_OBJECTS_PAGE: /* 8 - 4 objects- obj1, obj2, obj3, obj4 */
				t0 = tCreateTemplate(ge, TMP_TITLE_1, TEMPLATE_TITLE);
				t1 = tCreateTemplate(ge, TMP_SMALL_1, page->object1);
				t2 = tCreateTemplate(ge, TMP_SMALL_2, page->object2);
				t3 = tCreateTemplate(ge, TMP_SMALL_3, page->object3);
				t4 = tCreateTemplate(ge, TMP_SMALL_4, page->object4);
			break;
			case BLANK_PAGE: /* 9 - blank page - no title, no objs */
				t0 = (thing *)0;
				t1 = (thing *)0;
				t2 = (thing *)0;
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
			case BIG_OBJECT_PAGE: /* 10 - big object page - no title, 1 objs */
				t0 = tCreateTemplate(ge, TMP_FULLPAGE,TEMPLATE_OTHER);
				t1 = (thing *)0;
				t2 = (thing *)0;
				t3 = (thing *)0;
				t4 = (thing *)0;
			break;
		}

		/* get the children from the old templates */
		if ( n_templates > 0 )
		{
			for ( i=0; i<n_templates; i++ )
			{
				t = template_tlist[i];
				if ( !t )
					continue;
				if ( t->data.temp->child_t == (thing *)0 )
					continue;

				best_t = best_choice(ge, t, t0, t1, t2, t3, t4, TRUE);
				if ( best_t )
				{
					best_t->data.temp->child_t = t->data.temp->child_t;
					best_t->data.temp->ix = t->data.temp->ix;
					best_t->data.temp->enable_build =t->data.temp->enable_build;
					best_t->data.temp->build = t->data.temp->build;
					t->data.temp->build = (ge_build_info_type *)0;
					t->data.temp->child_t = (thing *)0;
					best_t->flags.used = TRUE;
#if !FOR_FILTER
					if ( ge->template->rem_suppress == FALSE )
						grApplyTemplateToChild(ge, best_t);
#endif
					calcExtents(ge, best_t);
	
					disposeThing(ge, t, TRUE);
					template_tlist[i] = (thing *)0;
				}
			}

			/* reload inactive templates with children (delete the others) */
			for ( i=0; i<n_templates; i++ )
			{
				t = template_tlist[i];
				if ( t )
				{
					if ( !t->data.temp->child_t )
						disposeThing(ge, t, TRUE);
					else
						tAddToPaintList(ge, t, -1, FALSE);
				}
			}
		}
		/* reset the used flag */
		if ( t0 && t0->flags.used )
			t0->flags.used = FALSE;
		if ( t1 && t1->flags.used )
			t1->flags.used = FALSE;
		if ( t2 && t2->flags.used )
			t2->flags.used = FALSE;
		if ( t3 && t3->flags.used )
			t3->flags.used = FALSE;
		if ( t4 && t4->flags.used )
			t4->flags.used = FALSE;

		if ( template_tlist )
			gfree(ge, template_tlist);
	}
 
	/* remove and inactivate old template objects from current notes */
	if ( do_notes && ge->page[page_ix].notes_t )
	{
		ge->t = ge->page[page_ix].notes_t;
		grRemoveTemplates(ge, &template_tlist, &n_templates, FALSE);

		/* create the new templates */
		t0 = tCreateTemplate(ge, TMP_N1, TEMPLATE_SLIDE);
		t1 = tCreateTemplate(ge, TMP_N2, TEMPLATE_NOTES);

		/* get the children from the old templates */
		if ( n_templates > 0 )
		{
			if ( t0 ) for ( i=0; i<n_templates; i++ )
			{
				t = template_tlist[i];
				if ( !t || t->data.temp->type != t0->data.temp->type )
					continue;

				t0->data.temp->child_t = t->data.temp->child_t;
				t->data.temp->child_t = (thing *)0;
#if !FOR_FILTER
				if ( ge->template->rem_suppress == FALSE )
					grApplyTemplateToChild(ge, t0);
#endif
				calcExtents(ge, t0);

				disposeThing(ge, t, TRUE);
				template_tlist[i] = (thing *)0;
				break;
			}
			if ( t1 ) for ( i=0; i<n_templates; i++ )
			{
				t = template_tlist[i];
				if ( !t || t->data.temp->type != t1->data.temp->type )
					continue;

				t1->data.temp->child_t = t->data.temp->child_t;
				t->data.temp->child_t = (thing *)0;
#if !FOR_FILTER
				if ( ge->template->rem_suppress == FALSE )
					grApplyTemplateToChild(ge, t1);
#endif
				calcExtents(ge, t1);

				disposeThing(ge, t, TRUE);
				template_tlist[i] = (thing *)0;
				break;
			}

			/* reload inactive templates with children (delete the others) */
			for ( i=0; i<n_templates; i++ )
			{
				t = template_tlist[i];
				if ( t )
				{
					if ( !t->data.temp->child_t )
						disposeThing(ge, t, TRUE);
					else
						tAddToPaintList(ge, t, -1, FALSE);
				}
			}
		}
		if ( template_tlist )
			gfree(ge, template_tlist);
	}

	/* done */
	ge->t = old_t;
}

/****************************************************************************
 *
 * module: 
 */
cvtInitTemplatePageInfo(ge, page, i, use_back)
graphics_main_type *ge;
ge_page_type *page;
int i;
int use_back;
{
	int old_ix;

	/* copy any template info */
	if ( ge->template )
	{
		/* add templates to the new page */
		old_ix = ge->page_ix;
		ge->page_ix = i;
		ge->t = &ge->page[ge->page_ix].t;
		grCreateTemplateMasters(ge, ge->page_ix, TRUE, TRUE);
		if ( use_back )
		{
			ge->page[i].old_t = makeThing(ge, GROUP, &ge->def_attr);
			ge->page[i].old_t->data.group->num = ge->page[i].t.data.group->num;
			ge->page[i].old_t->data.group->list= ge->page[i].t.data.group->list;
			ge->page[i].t.data.group->num = 0;
			ge->page[i].t.data.group->list = (thing **)0;
		}

		/* restore the old page */
		ge->page_ix = old_ix;
		ge->t = &ge->page[ge->page_ix].t;
	}
}

/****************************************************************************
 *
 * module:  c v t I n i t P a g e - must match gInitPage in gpage.c
 */
cvtInitPage(ge, cvt, page, attr, do_template)
graphics_main_type *ge;
cvt_global_type *cvt;
ge_page_type *page;
thing_attributes *attr;
int do_template;
{
	int sz;

    /* clear */
	memset((char *)page, 0, sizeof(ge_page_type));

    /* paint list */
    page->t.type = GROUP;
    sz = sizeof(gr_group_type);
    page->t.data.group = (gr_group_type *)gloc(ge, sz);
    page->t.data.group->num = 0;
    page->t.data.group->list = (thing **)0;
    memcpy(&page->t.attr, attr, sizeof(thing_attributes));
    page->t.attr.join_symbols = 0;
    page->t.attr.left_arrow = 0;
    page->t.attr.right_arrow = 0;
    page->t.attr.shadow = 0;

    /* slide info */
    if ( do_template &&  ge->template )
	{
		/* notes list */
		page->notes_t = (thing *)makeThing(ge, GROUP, &ge->def_attr);
		page->notes_t->data.group->list = (thing **)0;
		memcpy(&page->notes_t->attr, &ge->def_attr, sizeof(thing_attributes));
		page->notes_t->attr.join_symbols = 0;
		page->notes_t->attr.left_arrow = 0;
		page->notes_t->attr.right_arrow = 0;
		page->notes_t->attr.shadow = 0;

        page->hide_objs = ge->template->s_master_page.hide_objs;
        page->hide_pg_backgd = ge->template->s_master_page.hide_pg_backgd;
        page->hide_slide = ge->template->s_master_page.hide_slide;
 
        page->c_scheme = ge->template->s_master_page.c_scheme;
	}
    page->slide_effect = 0;
    page->slide_throttle = 1;
    page->slide_delay = 0;

	/* build info */
	memcpy(&page->build, &ge->state.default_build, sizeof(ge_build_info_type));

	/* audio info */
	page->audio.volume = 50;
}

/****************************************************************************
 *
 * module:  c v t A p p e n d  P a g e - must match gAppendPage in gpage.c
 */
cvtAppendPage(ge, cvt, attr)
graphics_main_type *ge;
cvt_global_type *cvt;
thing_attributes *attr;
{
    int sz;
	ge_page_type *page;

    ge->n_pages++;
    ge->page_ix = ge->n_pages-1;
    sz = ge->n_pages * sizeof(ge_page_type);
    ge->page = (ge_page_type *)regloc(ge, ge->page, sz);

	page = &ge->page[ge->page_ix];
	cvtInitPage(ge, cvt, page, attr, ge->template ? TRUE:FALSE);
    ge->t = &ge->page[ge->page_ix].t;
}

/****************************************************************************
 *
 * module:  c g e t c - safe getc - WARNING!!
 *                      Currenty only called from cvti.c so if you use
 *                      this anywhere else, you had better set a jumpoint!
 */
int cgetc(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    int c;

    c = FSgetc(cvt->fp);
    if ( c == EOF )
        longjmp(cvt->jmpPoint, SGE_NOFILE);
    return c;
}

/****************************************************************************
 *
 * module:  c u n g e t c
 */
int cungetc(ge, cvt, ch)
graphics_main_type *ge;
cvt_global_type *cvt;
int ch;
{

    FSungetc(ch, cvt->fp);
}

/****************************************************************************
 *
 * module:  bgetcNoSize
 */
int bgetcNoSize(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    if (*cvt->inBufPtr == 0)
        longjmp(cvt->jmpPoint, SGE_NOFILE);
    return((int)(*cvt->inBufPtr++));
}


/****************************************************************************
 *
 * module:  bgetc
 */
int bgetc(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    if (cvt->inputBufferSize == 0)
    {
        /* We'll have to test for NULL. Use different */
        /* function for overhead reduction. */
        cvt->getcFunc = bgetcNoSize;
        return((int)bgetcNoSize(ge, cvt));
    }

    if ((unsigned int)(cvt->inBufPtr - cvt->inputBuff) >= cvt->inputBufferSize)
        longjmp(cvt->jmpPoint, SGE_NOFILE);
    return((int)(*cvt->inBufPtr++));
}

/****************************************************************************
 *
 * module:  bungetc
 */
int bungetc(ge, cvt, ch)
graphics_main_type *ge;
cvt_global_type *cvt;
int ch;
{
    /*
     * WARNING!! This ungetc function does not actually
     * write a character to the buffer.  It is only useful
     * if the character to unget is the last one read (which
     * it is in every occurence in cvti.c)
     */

     cvt->inBufPtr--;
}


/****************************************************************************
 *
 * module:  bfgets
 */
char *bfgets(ge, cvt,inBuff,inSize)
graphics_main_type *ge;
cvt_global_type *cvt;
char *inBuff;
int inSize;
{
    char *p;

    /* the test (*(p-1) != 0) really only works if the
       caller has explicitly put a 0 terminator at the
       end of the buffer. (a very good idea!!)
     */
    p = inBuff;
    do {
        *p++ = (*cvt->inBufPtr++);
    } while ((*(p-1) != '\n') && (*(p-1) != 0));

    if (*(p-1) != 0)
        *p = 0;
    else
        cvt->inBufPtr--; /* force NULL on all subsequent reads */

    if (inBuff[0])
        return(inBuff);
    else
        return (NULL);
}

/****************************************************************************
 *
 * module:  cfgets
 */
char *cfgets(ge, cvt,inBuff,inSize)
graphics_main_type *ge;
cvt_global_type *cvt;
char *inBuff;
int inSize;
{
    return((char*)FSfgets(inBuff,inSize,cvt->fp));
}

/****************************************************************************
 *
 * module:  m a i l I n B i t 6
 */
mailInBit6(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    char result;
    int c;

    do  {
        c = (*cvt->getcFunc)(ge, cvt);
    } while (isspace(c));
    if (c == '.') {
        cvt->bits_used = 0; 
        return (-1);
    }

    c = (c - '0') & 0x3F;
    switch (cvt->bits_used)
    {
    case 0:
        cvt->in_char = c << 2;
        do  {
            c = (*cvt->getcFunc)(ge, cvt);
        } while (isspace(c));
        c = (c - '0') & 0x3F;
        cvt->in_char |= c >> 4;
        result = cvt->in_char;
        cvt->in_char = c << 4;
        cvt->bits_used = 4;
        break;

    case 2:
        cvt->in_char |= c;
        result = cvt->in_char;
        cvt->in_char = c << 8;
        cvt->bits_used = 0;
        break;

    case 4:
        cvt->in_char |= c >> 2;
        result = cvt->in_char;
        cvt->in_char = c << 6;
        cvt->bits_used = 2;
        break;
    }

    return (result & 0xFF);
}

/****************************************************************************
 *
 * module:  m a i l I n H e x
 */
mailInHex(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    int c;
    char result;
    
    if (cvt->binary)
    {
        c = (*cvt->getcFunc)(ge, cvt);
        return (c & 0xFF);
    }
    else
    {
        do {
            c = (*cvt->getcFunc)(ge, cvt);
        } while (isspace(c));

        if (c == '.')
            return (-1);

        /* High nibble */
        c -= '0';
        if (9 < c)
            c -= 7;
        result = c << 4;

        /* Low nibble */
        do  {
            c = (*cvt->getcFunc)(ge, cvt);
        } while (isspace(c));

        c -= '0';
        if (9 < c)
            c -= 7;
        result |= c;

        return (result & 0xFF);
    }
}


/****************************************************************************
 *
 * module:  c p r i n t f - HACK!!! - this should be an actual varargs func
 */
#if NO_VARARGS
cprintf(ge, cvt, s, p1, p2, p3, p4, p5, p6, p7)
graphics_main_type *ge;
cvt_global_type *cvt;
char *s;
int p1, p2, p3, p4, p5, p6, p7;
#else
cprintf(ge, cvt, s, va_alist)
graphics_main_type *ge;
cvt_global_type *cvt;
char *s;
va_dcl
#endif
{
    int len;

#if !NO_VARARGS
    va_list args;

    va_start(args);
    vsprintf(cvt->buf, s, args);
    va_end(args);
#else
    sprintf(cvt->buf, s, p1, p2, p3, p4, p5, p6, p7);
#endif
    len = strlen(cvt->buf);
    cvt->n_bytes += len;
    if (cvt->buffit)
        CvtBuffputs(ge, cvt,len);
    else
        FSfputs(cvt->buf,cvt->fp);
    return (len);
}

/***************************************************************************
 *
 * module:  c p u t c
 */
cputc(ge, cvt, ch)
graphics_main_type *ge;
cvt_global_type *cvt;
int ch;
{
    if (cvt->buffit)
    {
        cvt->buf[0] = ch;
        CvtBuffputs(ge, cvt,1);
    }
    else
        FSfputc(ch,cvt->fp);
}

/***************************************************************************
 *
 * module:  CvtBuffputs
 */
CvtBuffputs(ge, cvt,len)
graphics_main_type *ge;
cvt_global_type *cvt;
int len;
{
    int newsize, curUsed;

    if ((cvt->outBufPtr + len) > cvt->outBufEndPtr)
    {
        /* get another block. */
        curUsed = cvt->outBufPtr - cvt->outBuff; 
        newsize = cvt->outBufEndPtr - cvt->outBuff + CVTBLKSIZE;
        /* check if newsize is big enough to hold all the info */
        while ( newsize < (curUsed+len) )
        	newsize += CVTBLKSIZE;
        cvt->outBuff = (char*)regloc(ge, cvt->outBuff,newsize);
        cvt->outBufEndPtr = cvt->outBuff + newsize;
        cvt->outBufPtr = cvt->outBuff + curUsed;
    }

    memcpy(cvt->outBufPtr,cvt->buf,len);
    cvt->outBufPtr += len;
}

/****************************************************************************
 *
 * module:  m a i l O u t B i t 6
 */
int mailOutBit6(ge, datum, llen, cvt)
graphics_main_type *ge;
int datum, llen;
cvt_global_type *cvt;
{
    int outc;

    outc = 0;

    /* Finish the scanline */
    if (datum < 0)
    {
        if ( cvt->bits_used )
        {
            cputc(ge, cvt,'0' + cvt->out_char);
            outc++;
            cvt->out_char = cvt->bits_used = 0;
        }
        if (!llen && !outc)
            cputc(ge, cvt,' ');
        cputc(ge, cvt,'.');
        outc++;
        return outc;
    }

    /* Complete last character */
    cvt->bits_used += 2;
    cvt->out_char |= (datum >> cvt->bits_used) & 0x3F;
    cputc(ge, cvt,'0' + cvt->out_char);
    outc++;
    cvt->out_char = 0;

    /* Form next character */
    cvt->out_char = (datum << 6 - cvt->bits_used) & 0x3F;
    if (cvt->bits_used == 6)
    {
        cputc(ge, cvt,'0' + cvt->out_char);
        outc++;
        cvt->out_char = cvt->bits_used = 0;
    }

    return outc;
}

/****************************************************************************
 *
 * module:  m a i l O u t H e x
 */
int mailOutHex(ge, datum, llen, cvt)
graphics_main_type *ge;
int datum, llen;
cvt_global_type *cvt;
{
    /* What is the proper return from cputc ?? */
    if (cvt->binary)
    {
        cputc(ge, cvt,datum&0xFF);
        return (1);
    }
    else
    {
        /* Finish the scanline */
        if (datum < 0)
        {
            cputc(ge, cvt,'.');
            return 1;
        }

        /* High nibble */
        cvt->out_char = (datum >> 4) & 0xF;
        if (9 < cvt->out_char)
            cvt->out_char += 7;
        cputc(ge, cvt,'0' + cvt->out_char);

        /* Low nibble */
        cvt->out_char = datum & 0xF;
        if (9 < cvt->out_char)
            cvt->out_char += 7;
        cputc(ge, cvt,'0' + cvt->out_char);

        return (2);
    }
}

#if LOGGING
mlDumpTxtObjs(ge, t)
graphics_main_type *ge;
thing *t;
{
    int ii;

    for (ii=0; ii<t->data.group->num; ii++)
        mlDumpTxt(ge, t->data.group->list[ii]);
}

mlDumpTxt(ge, t)
graphics_main_type *ge;
thing *t;
{
    int ii,jj;

    if ((t->type != TEXTBOX) && (t->type != TEXT))
        return;

    fprintf(stderr,"%s\n",(t->type == TEXT)?NXLT("TEXT"):NXLT("TEXTBOX"));
    fprintf(stderr,NXLT("t->x1 %d\n"),t->x1);
    fprintf(stderr,NXLT("t->y1 %d\n"),t->y1);
    fprintf(stderr,NXLT("t->x2 %d\n"),t->x2);
    fprintf(stderr,NXLT("t->y2 %d\n"),t->y2);

    mlDumpAttrs(ge, t);

    fprintf(stderr,NXLT("t->data.txtbox->n_paths %d\n"),t->data.txtbox->n_paths);
    for (ii=0; ii<t->data.txtbox->n_paths; ii++)
    {
        fprintf(stderr,NXLT("t->data.txtbox->paths[ii].nPoints %d\n"),t->data.txtbox->paths[ii].nPoints);
        for (jj=0; jj<t->data.txtbox->paths[ii].nPoints; jj++)
            fprintf(stderr,NXLT("x: %d    y: %d\n"),
                t->data.txtbox->paths[ii].points[jj].x, t->data.txtbox->paths[ii].points[jj].y);

        fprintf(stderr,NXLT("t->data.txtbox->paths[ii].nCtrls %d\n"),t->data.txtbox->paths[ii].nCtrls);
        for (jj=0; jj<t->data.txtbox->paths[ii].nCtrls; jj++)
            fprintf(stderr,NXLT("x: %d    y: %d\n"),
                t->data.txtbox->paths[ii].controls[jj].x, t->data.txtbox->paths[ii].controls[jj].y);
    }
    fprintf(stderr,NXLT("t->data.txtbox->trans.nPoints %d\n"),t->data.txtbox->trans.nPoints);
    if (t->data.txtbox->trans.points) for (jj=0; jj<t->data.txtbox->trans.nPoints; jj++)
        fprintf(stderr,NXLT("x: %d    y: %d\n"),
            t->data.txtbox->trans.points[jj].x, t->data.txtbox->trans.points[jj].y);

    fprintf(stderr,NXLT("t->data.txtbox->trans.nCtrls %d\n"),t->data.txtbox->trans.nCtrls);
    if (t->data.txtbox->trans.controls) for (jj=0; jj<t->data.txtbox->trans.nCtrls; jj++)
        fprintf(stderr,NXLT("x: %d    y: %d\n"),
            t->data.txtbox->trans.controls[jj].x, t->data.txtbox->trans.controls[jj].y);

    fprintf(stderr,NXLT("t->data.txtbox->n_strings %d\n"),t->data.txtbox->n_strings);
    for (ii=0; ii<t->data.txtbox->n_strings; ii++)
        mlDumpTxt(ge, t->data.txtbox->strings[ii]);

    fprintf(stderr,NXLT("t->data.txtbox->x_off %d\n"),t->data.txtbox->x_off);
    fprintf(stderr,NXLT("t->data.txtbox->y_off %d\n"),t->data.txtbox->y_off);
    fprintf(stderr,NXLT("t->chart %d\n"),t->chart);
    fprintf(stderr,NXLT("t->type %d\n"),t->type);
    fprintf(stderr,NXLT("t->undo %d\n"),t->undo);
    fprintf(stderr,NXLT("t->id %d\n"),t->id);

}

mlDumpAttrs(ge, t)
graphics_main_type *ge;
thing *t;
{
    mlDumpUse(ge, t);

    fprintf(stderr,NXLT("t->attr.fill_pat %d\n"),t->attr.fill_pat);
    fprintf(stderr,NXLT("t->attr.fpat_type %d\n"),t->attr.fpat_type);
    fprintf(stderr,NXLT("t->attr.fill_fg %d\n"),t->attr.fill_fg);
    fprintf(stderr,NXLT("t->attr.fill_bg %d\n"),t->attr.fill_bg);
    fprintf(stderr,NXLT("t->attr.line_pat %d\n"),t->attr.line_pat);
    fprintf(stderr,NXLT("t->attr.lpat_type %d\n"),t->attr.lpat_type);
    fprintf(stderr,NXLT("t->attr.line_fg %d\n"),t->attr.line_fg);
    fprintf(stderr,NXLT("t->attr.line_bg %d\n"),t->attr.line_bg);
    fprintf(stderr,NXLT("t->attr.mode %d\n"),t->attr.mode);
    fprintf(stderr,NXLT("t->attr.line_style %d\n"),t->attr.line_style);
    fprintf(stderr,NXLT("t->attr.line_thickness %d\n"),t->attr.line_thickness);
    fprintf(stderr,NXLT("t->attr.left_arrow %d\n"),t->attr.left_arrow);
    fprintf(stderr,NXLT("t->attr.right_arrow %d\n"),t->attr.right_arrow);
    fprintf(stderr,NXLT("t->attr.join_symbols %d\n"),t->attr.join_symbols);
    fprintf(stderr,NXLT("t->attr.shadow %d\n"),t->attr.shadow);
    fprintf(stderr,NXLT("t->attr.shadow_color %d\n"),t->attr.shadow_color);
    fprintf(stderr,NXLT("t->attr.shadow_x %d\n"),t->attr.shadow_x);
    fprintf(stderr,NXLT("t->attr.shadow_y %d\n"),t->attr.shadow_y);
    fprintf(stderr,NXLT("t->attr.face %d\n"),t->attr.face);
    fprintf(stderr,NXLT("t->attr.size %d\n"),t->attr.size);
    fprintf(stderr,NXLT("t->attr.ruling %d\n"),t->attr.ruling);
    fprintf(stderr,NXLT("t->attr.strike %d\n"),t->attr.strike);
    fprintf(stderr,NXLT("t->attr.weight %d\n"),t->attr.weight);
    fprintf(stderr,NXLT("t->attr.slant %d\n"),t->attr.slant);
    fprintf(stderr,NXLT("t->attr.x_scale %d\n"),t->attr.x_scale);
    fprintf(stderr,NXLT("t->attr.shear %d\n"),t->attr.shear);
    fprintf(stderr,NXLT("t->attr.angle %d\n"),t->attr.angle);
    fprintf(stderr,NXLT("t->attr.x_off %d\n"),t->attr.x_off);
    fprintf(stderr,NXLT("t->attr.y_sub_sup %d\n"),t->attr.y_sub_sup);
    fprintf(stderr,NXLT("t->attr.h_just %d\n"),t->attr.h_just);
    fprintf(stderr,NXLT("t->attr.v_just %d\n"),t->attr.v_just);
    fprintf(stderr,NXLT("t->attr.space_above %d\n"),t->attr.space_above);
    fprintf(stderr,NXLT("t->attr.space_below %d\n"),t->attr.space_below);
    fprintf(stderr,NXLT("t->attr.space_inside %d\n"),t->attr.space_inside);
    fprintf(stderr,NXLT("t->attr.field_x_scale %d\n"),t->attr.field_x_scale);
    fprintf(stderr,NXLT("t->attr.field_y_scale %d\n"),t->attr.field_y_scale);
    fprintf(stderr,NXLT("t->attr.field_shear %d\n"),t->attr.field_shear);
    fprintf(stderr,NXLT("t->attr.field_angle %d\n"),t->attr.field_angle);
    fprintf(stderr,NXLT("t->attr.field_space %d\n"),t->attr.field_space);
    fprintf(stderr,NXLT("t->attr.l_margin %d\n"),t->attr.l_margin);
    fprintf(stderr,NXLT("t->attr.r_margin %d\n"),t->attr.r_margin);
    fprintf(stderr,NXLT("t->attr.t_margin %d\n"),t->attr.t_margin);
    fprintf(stderr,NXLT("t->attr.b_margin %d\n"),t->attr.b_margin);
    fprintf(stderr,NXLT("t->attr.style %d\n"),t->attr.style);
    fprintf(stderr,NXLT("t->attr.callback %d\n"),t->attr.callback);
    fprintf(stderr,NXLT("t->attr.tag %d\n"),t->attr.tag);
}

mlDumpUse(ge, t)
graphics_main_type *ge;
thing *t;
{
    fprintf(stderr,NXLT("t->attr.use.fill_pat %d\n"), t->attr.use.fill_pat);
    fprintf(stderr,NXLT("t->attr.use.fpat_type %d\n"), t->attr.use.fpat_type);
    fprintf(stderr,NXLT("t->attr.use.fill_fg %d\n"), t->attr.use.fill_fg);
    fprintf(stderr,NXLT("t->attr.use.fill_bg %d\n"), t->attr.use.fill_bg);
    fprintf(stderr,NXLT("t->attr.use.line_pat %d\n"), t->attr.use.line_pat);
    fprintf(stderr,NXLT("t->attr.use.lpat_type %d\n"), t->attr.use.lpat_type);
    fprintf(stderr,NXLT("t->attr.use.line_fg %d\n"), t->attr.use.line_fg);
    fprintf(stderr,NXLT("t->attr.use.line_bg %d\n"), t->attr.use.line_bg);
    fprintf(stderr,NXLT("t->attr.use.mode %d\n"), t->attr.use.mode);
    fprintf(stderr,NXLT("t->attr.use.line_style %d\n"), t->attr.use.line_style);
    fprintf(stderr,NXLT("t->attr.use.line_thickness %d\n"), t->attr.use.line_thickness);
    fprintf(stderr,NXLT("t->attr.use.left_arrow %d\n"), t->attr.use.left_arrow);
    fprintf(stderr,NXLT("t->attr.use.right_arrow %d\n"), t->attr.use.right_arrow);
    fprintf(stderr,NXLT("t->attr.use.join_symbols %d\n"), t->attr.use.join_symbols);
    fprintf(stderr,NXLT("t->attr.use.shadow %d\n"), t->attr.use.shadow);
    fprintf(stderr,NXLT("t->attr.use.shadow_color %d\n"), t->attr.use.shadow_color);
    fprintf(stderr,NXLT("t->attr.use.shadow_x %d\n"), t->attr.use.shadow_x);
    fprintf(stderr,NXLT("t->attr.use.shadow_y %d\n"), t->attr.use.shadow_y);
    fprintf(stderr,NXLT("t->attr.use.face %d\n"), t->attr.use.face);
    fprintf(stderr,NXLT("t->attr.use.size %d\n"), t->attr.use.size);
    fprintf(stderr,NXLT("t->attr.use.ruling %d\n"), t->attr.use.ruling);
    fprintf(stderr,NXLT("t->attr.use.strike %d\n"), t->attr.use.strike);
    fprintf(stderr,NXLT("t->attr.use.weight %d\n"), t->attr.use.weight);
    fprintf(stderr,NXLT("t->attr.use.slant %d\n"), t->attr.use.slant);
    fprintf(stderr,NXLT("t->attr.use.x_scale %d\n"), t->attr.use.x_scale);
    fprintf(stderr,NXLT("t->attr.use.shear %d\n"), t->attr.use.shear);
    fprintf(stderr,NXLT("t->attr.use.angle %d\n"), t->attr.use.angle);
    fprintf(stderr,NXLT("t->attr.use.x_off %d\n"), t->attr.use.x_off);
    fprintf(stderr,NXLT("t->attr.use.y_sub_sup %d\n"), t->attr.use.y_sub_sup);
    fprintf(stderr,NXLT("t->attr.use.h_just %d\n"), t->attr.use.h_just);
    fprintf(stderr,NXLT("t->attr.use.v_just %d\n"), t->attr.use.v_just);
    fprintf(stderr,NXLT("t->attr.use.field_x_scale %d\n"), t->attr.use.field_x_scale);
    fprintf(stderr,NXLT("t->attr.use.field_y_scale %d\n"), t->attr.use.field_y_scale);
    fprintf(stderr,NXLT("t->attr.use.field_shear %d\n"), t->attr.use.field_shear);
    fprintf(stderr,NXLT("t->attr.use.field_angle %d\n"), t->attr.use.field_angle);
    fprintf(stderr,NXLT("t->attr.use.field_space %d\n"), t->attr.use.field_space);
    fprintf(stderr,NXLT("t->attr.use.l_margin %d\n"), t->attr.use.l_margin);
    fprintf(stderr,NXLT("t->attr.use.r_margin %d\n"), t->attr.use.r_margin);
    fprintf(stderr,NXLT("t->attr.use.t_margin %d\n"), t->attr.use.t_margin);
    fprintf(stderr,NXLT("t->attr.use.b_margin %d\n"), t->attr.use.b_margin);
    fprintf(stderr,NXLT("t->attr.use.style %d\n"), t->attr.use.style);
    fprintf(stderr,NXLT("t->attr.use.callback %d\n"), t->attr.use.callback);
    fprintf(stderr,NXLT("t->attr.use.tag %d\n"), t->attr.use.tag);
}
#else
mlDumpTxtObjs(ge, t)
graphics_main_type *ge;
thing *t;
{
    return;
}
#endif

/****************************************************************************
 *
 * module:
 */
cvtInitOutputStream(ge, cvt, outBuffer)
graphics_main_type *ge;
cvt_global_type *cvt;
char **outBuffer;
{
	if ( outBuffer )
	{
		cvt->buffit = TRUE;
		cvt->outBuff = cvt->outBufPtr = (char *)gloc(ge, CVTBLKSIZE);
		cvt->outBufEndPtr = cvt->outBufPtr + CVTBLKSIZE;
	}
	else
	{
		cvt->fp = (FILE *)cvtGetFP(ge, cvt->fileName, "w+");
		if ( cvt->fp == (FILE *)0 )
			return(!AOK);
	}
	return(AOK);
}

/****************************************************************************
 *
 * module:  A t t r C m p
 */
AttrCmp(ge, tstAttr1, tstAttr2)
graphics_main_type *ge;
thing_attributes *tstAttr1, *tstAttr2;
{
    /* return whether 2 attr structs are DIFFERENT */
 
    if (tstAttr1->fill_pat     != tstAttr2->fill_pat)
        return(TRUE);
    if (tstAttr1->fpat_type     != tstAttr2->fpat_type)
        return(TRUE);
    if (tstAttr1->fill_fg     != tstAttr2->fill_fg)
        return(TRUE);
    if (tstAttr1->fill_bg     != tstAttr2->fill_bg)
        return(TRUE);
 
    if (tstAttr1->line_pat     != tstAttr2->line_pat)
        return(TRUE);
    if (tstAttr1->lpat_type     != tstAttr2->lpat_type)
        return(TRUE);
    if (tstAttr1->line_fg     != tstAttr2->line_fg)
        return(TRUE);
    if (tstAttr1->line_bg     != tstAttr2->line_bg)
        return(TRUE);
    if (tstAttr1->line_style     != tstAttr2->line_style)
        return(TRUE);
    if (tstAttr1->line_thickness     != tstAttr2->line_thickness)
        return(TRUE);
    if (tstAttr1->left_arrow     != tstAttr2->left_arrow)
        return(TRUE);
    if (tstAttr1->right_arrow     != tstAttr2->right_arrow)
        return(TRUE);
    if (tstAttr1->join_symbols     != tstAttr2->join_symbols)
        return(TRUE);
 
    if (tstAttr1->shadow     != tstAttr2->shadow)
        return(TRUE);
    if (tstAttr1->shadow_color     != tstAttr2->shadow_color)
        return(TRUE);
    if (tstAttr1->shadow_x     != tstAttr2->shadow_x)
        return(TRUE);
    if (tstAttr1->shadow_y     != tstAttr2->shadow_y)
        return(TRUE);
 
    if (tstAttr1->face     != tstAttr2->face)
        return(TRUE);
    if (tstAttr1->size     != tstAttr2->size)
        return(TRUE);
    if (tstAttr1->ruling     != tstAttr2->ruling)
        return(TRUE);
    if (tstAttr1->strike     != tstAttr2->strike)
        return(TRUE);
    if (tstAttr1->weight     != tstAttr2->weight)
        return(TRUE);
    if (tstAttr1->slant     != tstAttr2->slant)
        return(TRUE);
    if (tstAttr1->x_scale   != tstAttr2->x_scale)
        return(TRUE);
    if (tstAttr1->shear     != tstAttr2->shear)
        return(TRUE);
    if (tstAttr1->angle     != tstAttr2->angle)
        return(TRUE);
    if (tstAttr1->x_off     != tstAttr2->x_off)
        return(TRUE);
    if (tstAttr1->y_sub_sup     != tstAttr2->y_sub_sup)
        return(TRUE);

    if (tstAttr1->l_indent1     != tstAttr2->l_indent1)
        return(TRUE);
    if (tstAttr1->l_indent2     != tstAttr2->l_indent2)
        return(TRUE);
    if (tstAttr1->r_indent     != tstAttr2->r_indent)
        return(TRUE);
    if (tstAttr1->bullet     != tstAttr2->bullet)
        return(TRUE);
    if (tstAttr1->bullet_scale     != tstAttr2->bullet_scale)
        return(TRUE);
    if (tstAttr1->bullet_color     != tstAttr2->bullet_color)
        return(TRUE);
    if (tstAttr1->bullet_font     != tstAttr2->bullet_font)
        return(TRUE);
    if (tstAttr1->bullet_glyph     != tstAttr2->bullet_glyph)
        return(TRUE);
    if (tstAttr1->space_above     != tstAttr2->space_above)
        return(TRUE);
    if (tstAttr1->space_below     != tstAttr2->space_below)
        return(TRUE);
    if (tstAttr1->space_inside     != tstAttr2->space_inside)
        return(TRUE);
 
    if (tstAttr1->h_just    != tstAttr2->h_just)
        return(TRUE);
    if (tstAttr1->v_just    != tstAttr2->v_just)
        return(TRUE);
    if (tstAttr1->field_space    != tstAttr2->field_space)
        return(TRUE);
    if (tstAttr1->field_x_scale     != tstAttr2->field_x_scale)
        return(TRUE);
    if (tstAttr1->field_y_scale     != tstAttr2->field_y_scale)
        return(TRUE);
    if (tstAttr1->field_shear   != tstAttr2->field_shear)
        return(TRUE);
    if (tstAttr1->field_angle   != tstAttr2->field_angle)
        return(TRUE);
    if (tstAttr1->l_margin  != tstAttr2->l_margin)
        return(TRUE);
    if (tstAttr1->r_margin  != tstAttr2->r_margin)
        return(TRUE);
    if (tstAttr1->t_margin  != tstAttr2->t_margin)
        return(TRUE);
    if (tstAttr1->b_margin  != tstAttr2->b_margin)
        return(TRUE);
 
    if (tstAttr1->style     != tstAttr2->style)
        return(TRUE);
 
    if (tstAttr1->callback  != tstAttr2->callback)
        return(TRUE);
 
    if (tstAttr1->tag   != tstAttr2->tag)
        return(TRUE);

    return (FALSE);
}


/****************************************************************************
 *
 * module: g r C r e a t e T e m p l a t e
 */
int
cvtCreateTemplate(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    ge_print_info_type *print, *print2;
    ge_color_scheme_type *c_scheme;
    ge_template_type *template;
    vector ext1, ext2;
    thing *t, *grp_t;
    vector old, new;
    int i, n, sz;
 
 
    /* make sure there are page info defaults */
    grInitPresentationPrint(ge, FALSE, FALSE, TRUE);
 
    /* create a template for the dst_ge */
     print = &ge->print;
    ext1.x1 = print->page_x + print->margin.x1 + 250;
    ext1.y1 = print->page_y + print->margin.y1 + 250;
    ext1.x2 = print->page_x + print->page_wid - 1 - print->margin.x2 - 250;
    ext1.y2 = print->page_y + print->page_hyt - 1 - print->margin.y2 - 250;
    ext2.x1 = print->page_x + print->margin.x1 + 250;
    ext2.y1 = print->page_y + print->margin.y1 + 250;
    ext2.x2 = print->page_x + print->page_wid - 1 - print->margin.x2 - 250;
    ext2.y2 = print->page_y + print->page_hyt - 1 - print->margin.y2 - 250;
 
    /* create an empty template */
    sz = sizeof(ge_template_type);
    template = (ge_template_type *)gloc(ge, sz);
    memset((char *)template, 0, sz);
 
    /* create the slide master page */
    cvtInitPage(ge, cvt, &template->s_master_page, &ge->def_attr, FALSE);
    template->s_master_page.use_backgd = TRUE;
    template->s_master_page.use_color = TRUE;
    template->s_master_page.c_scheme.title_fg = ge->def_attr.fill_fg;
    template->s_master_page.c_scheme.title_bg = ge->def_attr.fill_bg;
    template->s_master_page.c_scheme.text_fg = ge->def_attr.fill_fg;
    template->s_master_page.c_scheme.text_bg = ge->def_attr.fill_bg;
    template->s_master_page.c_scheme.fill_fg = ge->def_attr.fill_fg;
    template->s_master_page.c_scheme.fill_bg = ge->def_attr.fill_bg;
    template->s_master_page.c_scheme.line_fg = ge->def_attr.line_fg;
    template->s_master_page.c_scheme.line_bg = ge->def_attr.line_bg;
    template->s_master_page.c_scheme.page_fg = ge->def_attr.fill_fg;
    template->s_master_page.c_scheme.page_bg = ge->def_attr.fill_bg;
    template->s_master_page.c_scheme.page_pat  = 0;
    template->s_master_page.c_scheme.page_type = 0;
    template->s_master_page.c_scheme.n_other_colors = 0;
    template->s_master_page.c_scheme.other_color = (int *)0;
    for ( i=0; i<15; i++ )
        template->s_master_page.c_scheme.accent_color[i] = ge->def_attr.fill_fg;
    template->s_master_page.c_scheme.shadow_color = ge->def_attr.shadow_color;
 
    /* create the outline master page */
    cvtInitPage(ge, cvt, &template->o_master_page, &ge->def_attr, FALSE);
    template->o_master_page.use_backgd = FALSE;
    template->o_master_page.c_scheme = template->s_master_page.c_scheme;
 
    /* create the handout master page */
    cvtInitPage(ge, cvt, &template->h_master_page, &ge->def_attr, FALSE);
    template->h_master_page.use_backgd = FALSE;
    template->h_master_page.c_scheme = template->s_master_page.c_scheme;
 
    /* create the notes master page */
    cvtInitPage(ge, cvt, &template->n_master_page, &ge->def_attr, FALSE);
    template->n_master_page.use_backgd = FALSE;
    template->n_master_page.c_scheme = template->s_master_page.c_scheme;
 
    /* init slide header */
    template->slide_heading.x1 = ext1.x1;
    template->slide_heading.x2 = ext1.x2;
    template->slide_heading.y1 = ext1.y1;
    template->slide_heading.y2 = ext1.y1 + (ext1.y2 - ext1.y1 + 1)/5.0;
    if ( template->slide_heading.x2 < template->slide_heading.x1 )
        template->slide_heading.x2 = template->slide_heading.x1;
    if ( template->slide_heading.y2 < template->slide_heading.y1 )
        template->slide_heading.y2 = template->slide_heading.y1;
    sz = sizeof(thing_attributes);
    memcpy((char *)&template->t0_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->t1_attr, (char *)&ge->def_attr, sz);
 
    /* init slide content */
    template->slide_content.x1 = ext1.x1;
    template->slide_content.x2 = ext1.x2;
    template->slide_content.y1 = template->slide_heading.y2 + 250;
    template->slide_content.y2 = ext1.y2;
    if ( template->slide_content.x2 < template->slide_content.x1 )
        template->slide_content.x2 = template->slide_content.x1;
    if ( template->slide_content.y2 < template->slide_content.y1 )
        template->slide_content.y2 = template->slide_content.y1;
    memcpy((char *)&template->b0_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->b1_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->b2_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->b3_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->b4_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->b5_attr, (char *)&ge->def_attr, sz);
 
    /* init notes preview */
    template->notes_preview.x1 = ext2.x1;
    template->notes_preview.x2 = ext2.x2;
    template->notes_preview.y1 = ext2.y1;
    template->notes_preview.y2 = ext2.y1 + (ext2.y2 - ext2.y1 + 1)/2.0 - 125;
    if ( template->notes_preview.x2 < template->notes_preview.x1 )
        template->notes_preview.x2 = template->notes_preview.x1;
    if ( template->notes_preview.y2 < template->notes_preview.y1 )
        template->notes_preview.y2 = template->notes_preview.y1;
 
    /* init notes content */
    template->notes_content.x1 = ext2.x1;
    template->notes_content.x2 = ext2.x2;
    template->notes_content.y1 = template->notes_preview.y2 + 250;
    template->notes_content.y2 = ext2.y2;
    if ( template->notes_content.x2 < template->notes_content.x1 )
        template->notes_content.x2 = template->notes_content.x1;
    if ( template->notes_content.y2 < template->notes_content.y1 )
        template->notes_content.y2 = template->notes_content.y1;
    memcpy((char *)&template->n0_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->n1_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->n2_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->n3_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->n4_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&template->n5_attr, (char *)&ge->def_attr, sz);
    template->page_mode = SLIDE_ED;
 
    ge->template = template;
 
    /* apply the template to all pages */
    /* set the default attribute */
    ge->def_attr.shadow_color = template->s_master_page.c_scheme.shadow_color;
    ge->def_attr.fill_fg = template->s_master_page.c_scheme.fill_fg;
    ge->def_attr.fill_bg = template->s_master_page.c_scheme.fill_bg;
    ge->def_attr.line_fg = template->s_master_page.c_scheme.line_fg;
    ge->def_attr.line_bg = template->s_master_page.c_scheme.line_bg;
    sz = sizeof(thing_attributes);
    memcpy((char *)&ge->drp_attr, (char *)&ge->def_attr, sz);
    memcpy((char *)&ge->cur_attr, (char *)&ge->def_attr, sz);
 
    /* set the default fill pattern */
    ge->def_attr.fpat_type = 5;
    ge->def_attr.fill_pat = 1000;
 
    /* done */
    return(AOK);
}
