/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cvtlzw.c
   Applix ASC version: 19
   Date: Mon Nov 16 13:56:02 1998
*/
#if AXMS
#pragma optimize("g", off)
#endif

#define NXLT(str) str	/*	Keep xlt scans sane by NXLT'g where necess */

/* Compress - data compression program */

/*
 * Set USERMEM to the maximum amount of physical user memory available
 * in bytes.  USERMEM is used to determine the maximum BITS that can be used
 * for compression.
 */

#ifndef USERMEM
#	define USERMEM 	450000	/* default user memory */
#endif

#ifdef USERMEM
# if USERMEM >= (433484)
#  define PBITS	16
# else
#  if USERMEM >= (229600)
#   define PBITS	15
#  else
#   if USERMEM >= (127536)
#    define PBITS	14
#   else
#    if USERMEM >= (73464)
#     define PBITS	13
#    else
#     define PBITS	12
#    endif
#   endif
#  endif
# endif
# undef USERMEM
#endif /* USERMEM */

#ifdef PBITS		/* Preferred BITS for this memory size */
# ifndef BITS
#  define BITS PBITS
# endif /* BITS */
#endif /* PBITS */

#if BITS == 16
# define HSIZE	69001		/* 95% occupancy */
#endif
#if BITS == 15
# define HSIZE	35023		/* 94% occupancy */
#endif
#if BITS == 14
# define HSIZE	18013		/* 91% occupancy */
#endif
#if BITS == 13
# define HSIZE	9001		/* 91% occupancy */
#endif
#if BITS <= 12
# define HSIZE	5003		/* 80% occupancy */
#endif

#if !X386_NEW
#ifdef M_XENIX			/* Stupid compiler can't handle arrays with */
# if BITS == 16			/* more than 65535 bytes - so we fake it */
#  define XENIX_16
# else
#  if BITS > 13			/* Code only handles BITS = 12, 13, or 16 */
#   define BITS	13
#  endif
# endif
#endif
#endif

/*
 * a code_int must be able to hold 2**BITS values of type int, and also -1
 */
#if BITS > 15
typedef long int	code_int;
#else
typedef int		code_int;
#endif

typedef long int	  count_int;
typedef	unsigned char	char_type;
char_type magic_header[] = { NXLT("\037\235") };	/* 1F 9D */

/* Defines for third byte of header */
#define BIT_MASK	0x1f
#define BLOCK_MASK	0x80
/* Masks 0x40 and 0x20 are free.  I think 0x20 should mean that there is
   a fourth header byte (for expansion).
*/
#define INIT_BITS 9			/* initial number of bits/code */

#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <setjmp.h>
#include <aos.h>
#include <atmattr.h>
#include <atmgraph.h>
#include <attr.h>
#include <atm.h>
#include <atmwin.h>
#include <axtext.h>
#include <atxint.h>
#include <img.h>
#include <ge.h>
#include <afileimg.h>
#include <cvt.h>

int n_bits;				/* number of bits/code */
int maxbits = BITS;			/* user settable max # bits/code */
code_int maxcode;			/* maximum code, given n_bits */
code_int maxmaxcode = 1 << BITS;	/* should NEVER generate this code */
#define MAXCODE(n_bits)	((1 << (n_bits)) - 1)

#ifdef XENIX_16
	count_int htab0[8192];
	count_int htab1[8192];
	count_int htab2[8192];
	count_int htab3[8192];
	count_int htab4[8192];
	count_int htab5[8192];
	count_int htab6[8192];
	count_int htab7[8192];
	count_int htab8[HSIZE-65536];
	count_int * htab[9] = {
		htab0, htab1, htab2, htab3, htab4, htab5, htab6, htab7, htab8 };

#	define htabof(i)	(htab[(i) >> 13][(i) & 0x1fff])
	unsigned short code0tab[16384];
	unsigned short code1tab[16384];
	unsigned short code2tab[16384];
	unsigned short code3tab[16384];
	unsigned short code4tab[16384];
	unsigned short * codetab[5] = {
		code0tab, code1tab, code2tab, code3tab, code4tab };

#	define codetabof(i)	(codetab[(i) >> 14][(i) & 0x3fff])

#else
	count_int *htab;
	unsigned short *codetab;
#	define htabof(i)	htab[i]
#	define codetabof(i)	codetab[i]
#endif	/* !XENIX_16 */

code_int hsize = HSIZE;			/* for dynamic table sizing */
code_int free_ent = 0;			/* first unused entry */

/*
 * To save much memory, we overlay the table used by imgcompress() with those
 * used by imgdecompress().  The tab_prefix table is the same size and type
 * as the codetab.  The tab_suffix table needs 2**BITS characters.  We
 * get this from the beginning of htab.  The output stack uses the rest
 * of htab, and contains characters.  There is plenty of room for any
 * possible stack (stack used to be 8000 characters).
 */

#define tab_prefixof(i)	codetabof(i)
#ifdef XENIX_16
#	define tab_suffixof(i)	((char_type *)htab[(i)>>15])[(i) & 0x7fff]
#	define de_stack		((char_type *)(htab2))
#else	/* Normal machine */
#	define tab_suffixof(i)	((char_type *)(htab))[i]
#	define de_stack		((char_type *)&tab_suffixof(1<<BITS))
#endif	/* XENIX_16 */

/*
 * block compression parameters -- after all codes are used up,
 * and compression rate changes, start over.
 */
int block_compress = BLOCK_MASK;
int clear_flg = 0;
long int ratio = 0;
#define CHECK_GAP 10000	/* ratio check interval */
count_int checkpoint = CHECK_GAP;

/*
 * the next two codes should not be changed lightly, as they must not
 * lie within the contiguous general code space.
 */ 
#define FIRST	257	/* first free entry */
#define	CLEAR	256	/* table clear output code */

int DoingDecompression, (*iofunc)();

#include <cvtlzw.p>

/*****************************************************************
 *
 * compress.c - File compression ala IEEE Computer, June 1984.
 *
 * Authors:	Spencer W. Thomas	(decvax!harpo!utah-cs!utah-gr!thomas)
 *		Jim McKie		(decvax!mcvax!jim)
 *		Steve Davies		(decvax!vax135!petsd!peora!srd)
 *		Ken Turkowski		(decvax!decwrl!turtlevax!ken)
 *		James A. Woods		(decvax!ihnp4!ames!jaw)
 *		Joe Orost		(decvax!vax135!petsd!joe)
 *
 * Algorithm from "A Technique for High Performance Data Compression",
 * Terry A. Welch, IEEE Computer Vol 17, No 6 (June 1984), pp 8-19.
 *
 * Algorithm:
 * 	Modified Lempel-Ziv method (LZW).  Basically finds common
 * substrings and replaces them with a variable size code.  This is
 * deterministic, and can be done on the fly.  Thus, the decompression
 * procedure needs no input table, but tracks the way the table was built.
 */

ReadWriteLZW(ge, cvt, llen, imgHyt, imgWid, buffP, func, doingDecompression)
graphics_main_type *ge;
cvt_global_type *cvt;
int llen; /* current line position */
unsigned int imgHyt, imgWid;
unsigned char *buffP;
int (*func)();
int doingDecompression;
{
	register count_int fsize;
	int rslt;

	if (!(htab = (count_int*)gloc(ge, HSIZE*sizeof(count_int))))
		return(1);
	if (!(codetab = (unsigned short*)gloc(ge, HSIZE*sizeof(unsigned short))))
		return(1);

	cvt->lineno = llen;
	cvt->imgP = buffP;
	DoingDecompression = doingDecompression;
	iofunc = func;
	FS_fread(ge, cvt,NULL, 0, 0); /* init */
		
    if(maxbits < INIT_BITS)
		maxbits = INIT_BITS;
    if (maxbits > BITS)
		maxbits = BITS;
    maxmaxcode = 1 << maxbits;

	fsize = (count_int)(imgHyt*imgWid);

	if (doingDecompression) /* DECOMPRESSION */
	{
		/* Check the magic number */
		if (((char_type)FS_getc(ge, cvt) != (magic_header[0] & 0xFF)) ||
			((char_type)FS_getc(ge, cvt) != (magic_header[1] & 0xFF)))
				return(1);

		maxbits = FS_getc(ge, cvt);	/* set -b from file */
		block_compress = maxbits & BLOCK_MASK;
		maxbits &= BIT_MASK;
		maxmaxcode = 1 << maxbits;
		if (maxbits > BITS)
			return(1);
		rslt = imgdecompress(ge, cvt);
	}

	else /* COMPRESSION */
	{
		/*
		 * tune hash table size for small files -- ad hoc,
		 * but the sizes match earlier #defines, which
		 * serve as upper bounds on the number of output codes. 
		 */
		hsize = HSIZE;
		if ( fsize < (1 << 12) )
			hsize = MIN ( 5003, HSIZE );
		else if ( fsize < (1 << 13) )
			hsize = MIN ( 9001, HSIZE );
		else if ( fsize < (1 << 14) )
			hsize = MIN ( 18013, HSIZE );
		else if ( fsize < (1 << 15) )
			hsize = MIN ( 35023, HSIZE );
		else if ( fsize < 47000 )
			hsize = MIN ( 50021, HSIZE );
		rslt = imgcompress(ge, cvt, fsize);
	}

	gfree(ge, htab);
	gfree(ge, codetab);
	return(rslt);
}

static int offset;
long int in_count = 1;	/* length of input */
long int bytes_out;		/* length of compressed output */
long int out_count = 0;	/* # of codes output (for debugging) */

/*
 * Algorithm:  use open addressing double hashing (no chaining) on the 
 * prefix code / next character combination.  We do a variant of Knuth's
 * algorithm D (vol. 3, sec. 6.4) along with G. Knott's relatively-prime
 * secondary probe.  Here, the modular division first probe is gives way
 * to a faster exclusive-or manipulation.  Also do block compression with
 * an adaptive reset, whereby the code table is cleared when the compression
 * ratio decreases, but after the table fills.  The variable-length output
 * codes are re-sized at this point, and a special CLEAR code is generated
 * for the decompressor.  Late addition:  construct the table according to
 * file size for noticeable speed improvement on small files.
 */
imgcompress(ge, cvt, fsize)
graphics_main_type *ge;
cvt_global_type *cvt;
register count_int fsize;
{
	register long fcode;
	register code_int i = 0;
	register int c;
	register code_int ent;
#ifdef XENIX_16
	register code_int disp;
#else	/* Normal machine */
	register int disp;
#endif
	register code_int hsize_reg;
	register int hshift;

	FS_putc(ge, cvt,magic_header[0]);
	FS_putc(ge, cvt,magic_header[1]);
	FS_putc(ge, cvt,(char)(maxbits | block_compress));

	offset = 0;
	bytes_out = 3;		/* includes 3-byte header mojo */
	out_count = 0;
	clear_flg = 0;
	ratio = 0;
	in_count = 1;
	checkpoint = CHECK_GAP;
	maxcode = MAXCODE(n_bits = INIT_BITS);
	free_ent = ((block_compress) ? FIRST : 256 );

	ent = FS_getc(ge, cvt);
	fsize -= 1;

	hshift = 0;
	for ( fcode = (long) hsize;  fcode < 65536L; fcode *= 2L )
		hshift++;
	hshift = 8 - hshift;		/* set hash code range bound */

	hsize_reg = hsize;
	cl_hash(ge, (count_int) hsize_reg);	/* clear hash table */

	while(fsize--)
	{
		c = FS_getc(ge, cvt);
		in_count++;
		fcode = (long) (((long) c << maxbits) + ent);
		i = ((c << hshift) ^ ent);	/* xor hashing */

		if ( htabof (i) == fcode )
		{
			ent = codetabof (i);
			continue;
		}
		else if ((long)htabof (i) < 0)	/* empty slot */
			goto nomatch;

		disp = hsize_reg - i;	/* secondary hash (after G. Knott) */
		if (i == 0)
			disp = 1;
probe:
		if ( (i -= disp) < 0 )
			i += hsize_reg;

		if (htabof (i) == fcode)
		{
			ent = codetabof (i);
			continue;
		}

		if ((long)htabof (i) > 0) 
			goto probe;
nomatch:
		cvtlzw_output (ge, cvt,(code_int)ent);
		out_count++;
		ent = c;
		if (free_ent < maxmaxcode)
		{
			codetabof (i) = free_ent++;	/* code -> hashtable */
			htabof (i) = fcode;
		}
		else if (((count_int)in_count >= checkpoint) && block_compress)
			cl_block (ge, cvt);
	}

	/* Put out the final code. */
	cvtlzw_output(ge, cvt,(code_int)ent);
	out_count++;
	cvtlzw_output(ge, cvt,(code_int)-1);

	/* put out the end of data marker */
	(*iofunc)(ge, -1, 10, cvt);

	if ( bytes_out > in_count )	/* return(2) if no savings */
		return(2);

	return(AOK);
}

/*****************************************************************
 * TAG( cvtlzw_output )
 *
 * Output the given code.
 * Inputs:
 * 	code:	A n_bits-bit integer.  If == -1, then EOF.  This assumes
 *		that n_bits =< (long)wordsize - 1.
 * Outputs:
 * 	Outputs code to the file.
 * Assumptions:
 *	Chars are 8 bits long.
 * Algorithm:
 * 	Maintain a BITS character long buffer (so that 8 codes will
 * fit in it exactly).  Use the VAX insv instruction to insert each
 * code in turn.  When the buffer fills up empty it and start over.
 */

static char buf[BITS];

#ifndef vax
char_type lmask[9] = {0xff, 0xfe, 0xfc, 0xf8, 0xf0, 0xe0, 0xc0, 0x80, 0x00};
char_type rmask[9] = {0x00, 0x01, 0x03, 0x07, 0x0f, 0x1f, 0x3f, 0x7f, 0xff};
#endif /* vax */

static cvtlzw_output(ge, cvt,code)
graphics_main_type *ge;
cvt_global_type *cvt;
code_int  code;
{

    /*
     * On the VAX, it is important to have the register declarations
     * in exactly the order given, or the asm will break.
     */
    register int r_off = offset, bits= n_bits;
    register char * bp = buf;

    if ( code >= 0 )
	{
#ifdef vax
		/* VAX DEPENDENT!! Implementation on other machines is below.
		 *
		 * Translation: Insert BITS bits from the argument starting at
		 * offset bits from the beginning of buf.
		 */
		0;	/* Work around for pcc -O bug with asm and if stmt */
		asm( NXLT("insv	4(ap),r11,r10,(r9)") );
#else /* not a vax */

		/* byte/bit numbering on the VAX is simulated by the following code */

		/* Get to the first byte.  */
		bp += (r_off >> 3);
		r_off &= 7;

		/*
		 * Since code is always >= 8 bits, only need to mask the first
		 * hunk on the left.
		 */
		*bp = (*bp & rmask[r_off]) | (code << r_off) & lmask[r_off];
		bp++;
		bits -= (8 - r_off);
		code >>= 8 - r_off;

		/* Get any 8 bit parts in the middle (<=1 for up to 16 bits). */
		if ( bits >= 8 )
		{
			*bp++ = code;
			code >>= 8;
			bits -= 8;
		}

		/* Last bits. */
		if(bits)
			*bp = code;
#endif /* vax */

		offset += n_bits;
		if (offset == (n_bits << 3))
		{
			bp = buf;
			bits = n_bits;
			bytes_out += bits;

			do
				FS_putc(ge, cvt,*bp++);
			while (--bits);

			offset = 0;
		}

		/*
		 * If the next entry is going to be too big for the code size,
		 * then increase it, if possible.
		 */
		if ( free_ent > maxcode || (clear_flg > 0))
		{
			/*
			 * Write the whole buffer, because the input side won't
			 * discover the size increase until after it has read it.
			 */
			if ( offset > 0 )
			{
				if( FS_fwrite(ge, cvt,buf, 1, n_bits) != n_bits)
					return(1);
				bytes_out += n_bits;
			}
			offset = 0;

			if ( clear_flg )
			{
				maxcode = MAXCODE (n_bits = INIT_BITS);
				clear_flg = 0;
			}
			else
			{
				n_bits++;
				if ( n_bits == maxbits )
					maxcode = maxmaxcode;
				else
					maxcode = MAXCODE(n_bits);
			}
		}
    }
	else
	{
		/* At EOF, write the rest of the buffer.  */
		if ( offset > 0 )
			FS_fwrite(ge, cvt,buf, 1, (offset + 7) / 8 );
		bytes_out += (offset + 7) / 8;
		offset = 0;
	}
	return(AOK);
}

/*
 * Decompress.  This routine adapts to the codes in the
 * file building the "string" table on-the-fly; requiring no table to
 * be stored in the compressed file.  The tables used herein are shared
 * with those of the compress() routine.  See the definitions above.
 */

imgdecompress(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    register char_type *stackp, chh;
    register int finchar;
    register code_int code, oldcode, incode;

    /* As above, initialize the first 256 entries in the table.  */
    maxcode = MAXCODE(n_bits = INIT_BITS);
    for (code = 255; code >= 0; code--)
	{
		tab_prefixof(code) = 0;
		tab_suffixof(code) = (char_type)code;
    }
    free_ent = ((block_compress) ? FIRST : 256 );

    finchar = oldcode = getcode(ge, cvt);
    if(oldcode == -1)	/* EOF already? Get out of here */
		return !AOK;
    FS_putc(ge, cvt, (char)finchar);	/* first code must be 8 bits = char */
    stackp = de_stack;

    while ((code = getcode(ge, cvt)) > -1)
	{
		if ((code == CLEAR) && block_compress)
		{
			for (code = 255; code >= 0; code--)
				tab_prefixof(code) = 0;
			clear_flg = 1;
			free_ent = FIRST - 1;
			if ((code = getcode (ge, cvt)) == -1)	/* O, untimely death! */
				break;
		}
		incode = code;

		/* Special case for KwKwK string.  */
		if (code >= free_ent)
		{
			*stackp++ = finchar;
			code = oldcode;
		}

		/* Generate output characters in reverse order */
		while (code >= 256)
		{
			*stackp++ = tab_suffixof(code);
			code = tab_prefixof(code);
		}
		*stackp++ = finchar = tab_suffixof(code);

		/* And put them out in forward order */
		do
		{
			FS_putc (ge, cvt, *--stackp);
		} while (stackp > de_stack);

		/* Generate the new entry.  */
		if ( (code=free_ent) < maxmaxcode )
		{
			tab_prefixof(code) = (unsigned short)oldcode;
			tab_suffixof(code) = finchar;
			free_ent = code+1;
		} 

		/* Remember previous code.  */
		oldcode = incode;
    }

	return AOK;
}

/*****************************************************************
 * TAG( getcode )
 *
 * Read one code from the standard input.  If EOF, return -1.
 * Inputs:
 * 	stdin
 * Outputs:
 * 	code or -1 is returned.
 */

code_int getcode(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    /*
     * On the VAX, it is important to have the register declarations
     * in exactly the order given, or the asm will break.
     */
    register code_int code;
    static int offset = 0, size = 0;
    static char_type buf[BITS];
    register int r_off, bits;
    register char_type *bp = buf;

    if (clear_flg > 0 || offset >= size || free_ent > maxcode)
	{
		/*
		 * If the next entry will be too big for the current code
		 * size, then we must increase the size.  This implies reading
		 * a new buffer full, too.
		 */

		if ( free_ent > maxcode )
		{
			n_bits++;
			if ( n_bits == maxbits )
				maxcode = maxmaxcode;	/* won't get any bigger now */
			else
				maxcode = MAXCODE(n_bits);
		}

		if (clear_flg > 0)
		{
			maxcode = MAXCODE (n_bits = INIT_BITS);
			clear_flg = 0;
		}

		size = FS_fread(ge, cvt,buf, 1, n_bits );
		if ( size <= 0 )
			return(-1);	/* end of file */
		offset = 0;

		/* Round size down to integral number of codes */
		size = (size << 3) - (n_bits - 1);
    }

    r_off = offset;
    bits = n_bits;

#ifdef vax
    asm( NXLT("extzv   r10,r9,(r8),r11") );
#else /* not a vax */

	/* Get to the first byte.  */
	bp += (r_off >> 3);
	r_off &= 7;

	/* Get first part (low order bits) */
	code = (*bp++ >> r_off);
	bits -= (8 - r_off);
	r_off = 8 - r_off;		/* now, offset into code word */

	/* Get any 8 bit parts in the middle (<=1 for up to 16 bits). */
	if ( bits >= 8 )
	{
	    code |= *bp++ << r_off;
	    r_off += 8;
	    bits -= 8;
	}

	/* high order bits. */
	code |= (*bp & rmask[bits]) << r_off;
#endif /* vax */
    offset += n_bits;

    return code;
}


/* table clear for block compress */
cl_block (ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
    register long int rat;

    checkpoint = in_count + CHECK_GAP;

    if (in_count > 0x007fffff) /* shift will overflow */
	{
		rat = bytes_out >> 8;
		/* Don't divide by zero */
		rat = (rat == 0) ? 0x7fffffff : (in_count / rat);
    }
	else
	{
		rat = (in_count << 8) / bytes_out;	/* 8 fractional bits */
    }

    if ( rat > ratio )
	{
		ratio = rat;
    }
	else
	{
		ratio = 0;
		cl_hash (ge, (count_int) hsize);
		free_ent = FIRST;
		clear_flg = 1;
		cvtlzw_output (ge, cvt,(code_int)CLEAR );
    }
}

/* reset code table */
cl_hash(ge, hsize)
graphics_main_type *ge;
register count_int hsize;
{
#ifndef XENIX_16	/* Normal machine */
	register count_int *htab_p = htab+hsize;
#else
	register j;
	register long k = hsize;
	register count_int *htab_p;
#endif
	register long i;
	register long m1 = -1;

#ifdef XENIX_16
    for(j=0; j<=8 && k>=0; j++,k-=8192)
	{
		i = 8192;
		if (k < 8192)
			i = k;
		htab_p = &(htab[j][i]);
		i -= 16;

		if(i > 0)
		{
#else
			i = hsize - 16;
#endif
			do 		/* might use Sys V memset(3) here */
			{
				*(htab_p-16) = m1;
				*(htab_p-15) = m1;
				*(htab_p-14) = m1;
				*(htab_p-13) = m1;
				*(htab_p-12) = m1;
				*(htab_p-11) = m1;
				*(htab_p-10) = m1;
				*(htab_p-9) = m1;
				*(htab_p-8) = m1;
				*(htab_p-7) = m1;
				*(htab_p-6) = m1;
				*(htab_p-5) = m1;
				*(htab_p-4) = m1;
				*(htab_p-3) = m1;
				*(htab_p-2) = m1;
				*(htab_p-1) = m1;
				htab_p -= 16;
			} while ((i -= 16) >= 0);
#ifdef XENIX_16
		}
    }
#endif
    	for ( i += 16; i > 0; i-- )
			*--htab_p = m1;
}

FS_putc(ge, cvt,ch)
graphics_main_type *ge;
cvt_global_type *cvt;
char ch;
{

	if (DoingDecompression) {
		*(cvt->imgP)++ = ch;
	}
	else {
		cvt->lineno += (*iofunc)(ge, ch & 0xFF, cvt->lineno, cvt);
		if (MAX_LINE < cvt->lineno) {
			cputc(ge, cvt,'\n');
			cputc(ge, cvt,' ');
			cvt->lineno = 0;
		}
	}
}


FS_getc(ge, cvt)
graphics_main_type *ge;
cvt_global_type *cvt;
{
	unsigned int xxx;

	if (DoingDecompression)
		return((*iofunc)(ge, cvt));
	else
	{
		xxx = *(cvt->imgP)++;
		return((int)xxx);
	}
}

FS_fread(ge, cvt,bufpointer, size, nitems)
graphics_main_type *ge;
cvt_global_type *cvt;
char *bufpointer;
unsigned int size, nitems;
{
	unsigned int ii, tmp;
	unsigned long total;
	char *ptr=bufpointer;
	static int got_eof = 0;

	if (bufpointer == NULL)
		return(got_eof = 0);

	if (got_eof)
		return(EOF);

	total = size*nitems;
	for (ii=0; ii<total; ii++)
	{
		if ((tmp = FS_getc(ge, cvt)) == EOF)
		{
			got_eof = 1;
			if (ii==0)
				return(EOF);
			else
				return(ii);
		}
		*ptr++ = tmp & 0xFF;
	}

	return(nitems);
}

FS_fwrite(ge, cvt,bufpointer, size, nitems)
graphics_main_type *ge;
cvt_global_type *cvt;
char *bufpointer;
unsigned int size, nitems;
{
	unsigned int ii;
	unsigned long total;
	char *ptr=bufpointer;

	total = size*nitems;

	for (ii=0; ii<total; ii++)
		FS_putc(ge, cvt,*ptr++);

	return(nitems);
}

