/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: items.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:56:04 1998
*/
#define GE_MENUS 14

#define	CLRK_INDEX	0
#define MARK_INDEX	1
#define HIDE_INDEX	2
#define XFER_INDEX	3
#define ATTR_INDEX	4
#define AIDS_INDEX	5
#define EDIT_INDEX	6
#define ALGN_INDEX	7
#define TATR_INDEX	8
#define COLR_INDEX	9
#define SCAN_INDEX	10
#define FAX_INDEX	11
#define EPS_INDEX	12
#define XWD_INDEX	13
#define BASOC_INDEX	(GE_MENUS + 1)
#define BFRMT_INDEX	(GE_MENUS + 2)
#define BLAYT_INDEX	(GE_MENUS + 3)
#define BEDIT_INDEX	(GE_MENUS + 4)

/* Allowing 32 subitems in 16 options in 32 menus */
#define M_INDEX_MASK	0x001F
#define M_MENU_SHIFT	0x0200
#define M_CASE_MASK	0x3E00
#define M_BG_PASS	0x4000

#define CLRK_MENU	(M_MENU_SHIFT * 1)
#define MARK_MENU	(M_MENU_SHIFT * 2)
#define HIDE_MENU	(M_MENU_SHIFT * 3)
#define XFER_MENU	(M_MENU_SHIFT * 4)
#define ATTR_MENU	(M_MENU_SHIFT * 5)
#define AIDS_MENU	(M_MENU_SHIFT * 6)
#define EDIT_MENU	(M_MENU_SHIFT * 7)
#define ALGN_MENU	(M_MENU_SHIFT * 8)
#define TATR_MENU	(M_MENU_SHIFT * 9)
#define COLR_MENU	(M_MENU_SHIFT * 10)
#define SCAN_MENU	(M_MENU_SHIFT * 11)
#define FAX_MENU	(M_MENU_SHIFT * 12)
#define EPS_MENU	(M_MENU_SHIFT * 13)
#define XWD_MENU	(M_MENU_SHIFT * 14)

#define BCLRK_MENU	(M_MENU_SHIFT * 15)
#define BASOC_MENU	(M_MENU_SHIFT * 16)
#define BFRMT_MENU	(M_MENU_SHIFT * 17)
#define BLAYT_MENU	(M_MENU_SHIFT * 18)
#define BEDIT_MENU	(M_MENU_SHIFT * 19)
#define BMUNG_MENU	(M_MENU_SHIFT * 20)

#define MTSCAN_MENU	(M_MENU_SHIFT * 21)

/* Clerk Menu items */
#define M_CLRK	CLRK_MENU
#define M_TOSS	(CLRK_MENU + 1)
#define M_DELT	(CLRK_MENU + 32 + 1)

/* Mark Menu items */
#define M_MARK	MARK_MENU

/* Hide Menu items */
#define M_HIDE	HIDE_MENU

/* Transfer Menu items */
#define M_XFER	XFER_MENU
#define M_PEDIT	(XFER_MENU + 1)
#define M_PFIX	(XFER_MENU + 2)
#define M_LXFER	(XFER_MENU + 32 + 1)
#define M_OVERW	(XFER_MENU + 64 + 1)

/* Fill/Line Attribute Menu items */
#define M_PATTR	ATTR_MENU

/* Aids Menu items */
#define M_AIDS	AIDS_MENU
#define M_AIDS2	(AIDS_MENU + 1)
#define M_SAIDS	(AIDS_MENU + 2)
#define M_TARGN	(AIDS_MENU + 32 + 2)
#define M_MOVX	(AIDS_MENU + 64 + 2)
#define M_MOVY	(AIDS_MENU + 64 + 3)
#define M_SCLX	(AIDS_MENU + 96 + 2)
#define M_SCLY	(AIDS_MENU + 96 + 3)
#define M_ROTX	(AIDS_MENU + 128 + 2)

/* Edit Menu items */
#define M_EDIT	EDIT_MENU

/* Constrain Menu items */
#define M_ALGN	ALGN_MENU

/* Text Attribute Menu items */
#define M_TATTR	TATR_MENU

/* Color Attribute Menu items */
#define M_COLR	COLR_MENU

/* Scan Menu items */
#define M_SCAN	SCAN_MENU

/* CCITT/Fax Menu */
#define M_FAX		FAX_MENU
#define M_FAXWID	(FAX_MENU + 1)
#define M_FAXHYT	(FAX_MENU + 2)

/* Encapsulated Postscript Menu */
#define M_EPS		EPS_MENU

/* XWD Menu */
#define M_XWD		XWD_MENU

/* BG Clerk Menu items */
#define M_BCLRK	BCLRK_MENU
#define M_BTOSS	(BCLRK_MENU + 1)
#define M_BDELT	(BCLRK_MENU + 2)

/* BG Associate Menu items */
#define M_ASEX	BASOC_MENU
#define M_BMTIT	(M_BG_PASS + BASOC_MENU + 0)
#define M_BSTIT (M_BG_PASS + BASOC_MENU + 1)
#define M_BDAXT	(M_BG_PASS + BASOC_MENU + 2)
#define M_BVAXT	(M_BG_PASS + BASOC_MENU + 3)
#define M_BGLAB	(M_BG_PASS + BASOC_MENU + 4)
#define M_BDAXL	(M_BG_PASS + BASOC_MENU + 5)
#define M_BDG01 (M_BG_PASS + BASOC_MENU + 6)
#define M_BDG02 (M_BG_PASS + BASOC_MENU + 7)
#define M_BDG03 (M_BG_PASS + BASOC_MENU + 8)
#define M_BDG04 (M_BG_PASS + BASOC_MENU + 9)
#define M_BDG05 (M_BG_PASS + BASOC_MENU + 10)
#define M_BDG06 (M_BG_PASS + BASOC_MENU + 11)
#define M_BDG07 (M_BG_PASS + BASOC_MENU + 12)
#define M_BDG08 (M_BG_PASS + BASOC_MENU + 13)
#define M_BDG09 (M_BG_PASS + BASOC_MENU + 14)
#define M_BDG10 (M_BG_PASS + BASOC_MENU + 15)
#define M_BDG11 (M_BG_PASS + BASOC_MENU + 16)
#define M_BDG12 (M_BG_PASS + BASOC_MENU + 17)

/* BG Format Menu items */
#define M_BFRMT	BFRMT_MENU
#define M_BFGRP	(BFRMT_MENU + 1)
#define M_BFXGR	(BFRMT_MENU + 2)

/* BG Layout Menu items */
#define M_BLAYT	BLAYT_MENU
#define M_BHSIZ	(BLAYT_MENU + 1)
#define M_BVSIZ	(BLAYT_MENU + 2)
#define M_BVALU	(BLAYT_MENU + 32 + 1)

/* BG Mung Menu items */
#define M_BMUNG	BMUNG_MENU


/* Microtek Scanner Menu items */
#define M_MTSCAN	MTSCAN_MENU
#define M_MTDOCLEN	(MTSCAN_MENU + 1)
#define M_MTTOP		(MTSCAN_MENU + 2)
#define M_MTBOTTOM	(MTSCAN_MENU + 3)
#define M_MTLEFT	(MTSCAN_MENU + 4)
#define M_MTRIGHT	(MTSCAN_MENU + 5)
#define M_MTBRIGHTNESS	(MTSCAN_MENU + 6)
#define M_MTCONTRAST	(MTSCAN_MENU + 7)
#define M_MTGRAIN	(MTSCAN_MENU + 8)
#define M_MTMODE	(MTSCAN_MENU + 9)
#define M_MTRESOLUTION	(MTSCAN_MENU + 10)
#define M_MTBAUDRATE	(MTSCAN_MENU + 11)
#define M_MTDEVICE	(MTSCAN_MENU + 12)


/* menu listcheck ids */

#define aidsR	"A"
#define aidsRO	"B"
#define aidsG	"C"
#define aidsGO	"D"
#define aidsB	"E"
#define aidsBO	"F"
#define aidsA	"G"
#define aidsAO	"H"
#define aidsP	"I"
#define aidsPO	"J"
#define aidsC	"K"
#define aidsCO	"L"
#define aidsT	"M"
#define aidsTO	"N"
#define aidsH	"O"
#define aidsV	"P"
#define aidsS	"Q"
#define aidsE	"R"
#define aidsGS	"S"
#define aidsME	"T"
#define aidsSE	"U"
#define aidsRE	"V"
#define aidsL	"W"
#define aidsNUL	"Z"
#define aids16	"A"
#define aids10	"B"
#define aids8	"C"
#define aids4	"D"
#define aids2	"E"
#define aidsCM	"F"
#define algnL	"A"
#define algnC	"B"
#define algnR	"C"
#define algnT	"D"
#define algnM	"E"
#define algnB	"F"
#define algnW	"G"
#define algnH	"H"
#define algnWH	"I"
#define algnHW	"J"
#define algnSM	"M"
#define algnLG	"N"
#define algnCX	"O"
#define algnCY	"P"
#define algnSX	"Q"
#define algnSY	"R"
#define algnAX	"S"
#define algnAY 	"T"
#define attrS	"A"
#define attrDS	"B"
#define attrDT	"C"
#define attrDD	"D"
#define attr0	"F"
#define attr1	"G"
#define attr2	"H"
#define attr3	"I"
#define attr4	"J"
#define attr5	"K"
#define attrN	"N"
#define attrA	"O"
#define attrB	"P"
#define attrC	"Q"
#define attrD	"R"
#define attrE	"S"
#define attrF	"T"
#define attrG	"U"
#define attrH	"V"
#define attrI	"W"
#define attrJ	"X"
#define attrK	"Y"
#define attrL	"Z"
#define attrA1	"a"
#define attrA2	"b"
#define attrA3	"c"
#define attrA4	"d"
#define attrNA	"e"
#define attrBE	"f"
#define attrFE	"g"
#define attrLE	"h"
#define bclrkC	"A"
#define bclrkH	"B"
#define bclrkM	"C"
#define bclrkP	"D"
#define bclrkPC	"E"
#define bclrkS	"F"
#define bclrkAB	"G"
#define bclrkDE	"H"
#define bclrkY	"A"
#define bclrkN	"B"
#define	bfrmtP	"A"
#define	bfrmtCB	"B"
#define	bfrmtHB	"C"
#define	bfrmtSB	"D"
#define	bfrmtL	"E"
#define	bfrmtM	"F"
#define	bfrmtLM	"G"
#define	bfrmtS	"H"
#define	bfrmtL2	"I"
#define	bfrmtM2	"J"
#define	bfrmtLM2	"K"
#define	bfrmtA2	"L"
#define	bfrmtH	"M"
#define	bfrmt1	"A"
#define	bfrmt2	"B"
#define	bfrmt3	"C"
#define	bfrmt4	"D"
#define	bfrmt5	"E"
#define	bfrmt6	"F"
#define	bfrmt7	"G"
#define	bfrmt8	"H"
#define	bfrmt9	"I"
#define	bfrmt10	"J"
#define	bfrmt11	"K"
#define	bfrmt12	"L"
#define	bfrmtA	"M"
#define	blaytG	"A"
#define	blaytGO	"B"
#define	blaytH	"C"
#define	blaytV	"D"
#define	blaytS	"E"
#define	blaytW	"F"
#define	blaytBV	"G"
#define	blaytHV	"H"
#define	blaytLV	"I"
#define	blaytL	"J"
#define	blaytSL	"K"
#define	blaytLL	"L"
#define blayt2D	"M"
#define blayt3D	"N"
#define bmungD	"A"
#define clrkC	"A"
#define clrkH	"B"
#define clrkM	"C"
#define clrkP	"D"
#define clrkPC	"E"
#define clrkS	"F"
#define clrkAB	"G"
#define clrkDE	"H"
#define clrkRE	"I"
#define clrkY	"A"
#define clrkN	"B"
#define colrBW	"A"
#define colrBBK	"B"
#define colrBDG	"C"
#define colrBLG	"D"
#define colrBR	"E"
#define colrBDR	"F"
#define colrBOR	"G"
#define colrBY	"H"
#define colrBO	"I"
#define colrBG	"J"
#define colrBLB	"K"
#define colrBBL	"L"
#define colrBDB	"M"
#define colrBP	"N"
#define colrFW	"a"
#define colrFBK	"b"
#define colrFDG	"c"
#define colrFLG	"d"
#define colrFR	"e"
#define colrFDR	"f"
#define colrFOR	"g"
#define colrFY	"h"
#define colrFO	"i"
#define colrFG	"j"
#define colrFLB	"k"
#define colrFBL	"l"
#define colrFDB	"m"
#define colrFP	"n"
#define colrR	"2"
#define colrRO	"1"
#define colrO	"3"
#define colrT	"4"
#define editC	"A"
#define editD	"B"
#define editR	"C"
#define editG	"D"
#define editUG	"E"
#define editB	"F"
#define editF	"G"
#define editA	"H"
#define editS	"I"
#define editU	"J"
#define editX	"K"
#define editY	"L"
#define editP	"M"
#define editM	"N"
#define hideH	"A"
#define hideHU	"B"
#define hideR	"C"
#define hideM	"D"
#define markA	"A"
#define markC	"B"
#define markL	"C"
#define markR	"D"
#define markT	"E"
#define scanmtL	"A"
#define scanmtF	"B"
#define scanmtB	"C"
#define scanmtC	"D"
#define scanmtG	"E"
#define scanmtM	"F"
#define scanmtR	"G"
#define scanmtD	"H"
#define scanmtNUL	"I"
#define scanmtAA	"A"
#define scanmtBB	"B"
#define scanmtCC	"C"
#define scanmtDD	"D"
#define scanmtEE	"E"
#define scanmtFF	"F"
#define scanmtGG	"G"
#define scanmtHH	"H"
#define scanmtII	"I"
#define scanmtJJ	"J"
#define scanmtKK	"K"
#define scanmtLL	"L"
#define scanmtMM	"M"
#define scanmtNN	"N"
#define scanmtOO	"O"
#define scanmtPP	"P"
#define tatrBO	"A"
#define tatrB	"B"
#define tatrIO	"C"
#define tatrI	"D"
#define tatrLO	"E"
#define tatrU	"F"
#define tatrD	"G"
#define tatrT	"H"
#define tatrLJ	"I"
#define tatrCJ	"J"
#define tatrRJ	"K"
#define tatrS	"L"
#define tatrSS	"M"
#define tatrM	"N"
#define tatrSY	"O"
#define tatrSY2	"R"
#define tatr10  "S"
#define tatr12  "T"
#define tatr14  "U"
#define tatr18  "V"
#define tatr6   "W"
#define tatr8   "X"
#define tatr24  "Y"
#define tatr36  "Z"
#define tatrLG	"a"
#define tatrO	"b"
#define tatrPE	"c"
#define tatrOA	"d"
#define tatrOB	"e"
#define xferC	"A"
#define xferM	"B"
#define xferP	"C"
#define xferL	"a"
#define xferCP	"b"
#define xferDP	"D"
#define xferMP	"c"
#define xferSP	"E"
#define xferD	"F"
#define xferY	"A"
#define xferN	"B"
#define xferNUL	"C"
