/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: maketoks.c
   Applix ASC version: 6
   Date: Mon Nov 16 13:56:03 1998
*/
#include <apheader.h>
#include <stdio.h>

#if SGI
extern char *read_only_tok[];
#define tok read_only_tok
#else
extern char *tok[];
#endif

main(argc,argv)
int argc;
char *argv[];
{
	char *tokP;
	int ii, len;
	FILE *fp;

	if (argv[1][strlen(argv[1])-1] == 'h' ||
        argv[1][strlen(argv[1])-1] == 'H')
	{
		fp = fopen(argv[1],"w+");
		if ( !fp ) {
			printf("Could not open %s\n",argv[1]);
			exit(1);
		}

		/* Create the enum list */
		ii=0;
		tokP = tok[0];
		fprintf(fp,"enum {\n");
		while (tok[ii+1])
		{
			len = strlen(tokP) - 1;
			if (len && (tokP[len] == '!'))
				tokP[len] = '\0';
			fprintf(fp,"\tT%s,\n",tokP);
			ii++;
			tokP = tok[ii];
		}
		if (len && (tokP[len] == '!'))
			tokP[len] = '\0';
		fprintf(fp,"\tT%s\n};\n",tokP);

		/* define TLAST_TOK as appropriate */
		fprintf(fp,"\n#define TLAST_TOK T%s\n\n",tokP);

		if ( 0 != fclose(fp) ) {
			printf("Could not close %s\n",argv[1]);
			exit(1);
		}

	}
	else /* the .c file */
	{
		fp = fopen(argv[1],"w+");
		if ( !fp ) {
			printf("Could not open %s\n",argv[1]);
			exit(1);
		}

		ii=0;
		tokP = tok[0];
		fprintf(fp,"extern int ReadNULL();\n");
		while (tokP)
		{
			len = strlen(tokP) - 1;
			if (len && (tokP[len] != '!'))
				fprintf(fp,"extern int Read%s();\n",tokP);
			ii++;
			tokP = tok[ii];
		}

		ii=0;
		fprintf(fp,"\n\nint (*TokFuncs[])() = {\n");
		tokP = tok[0];
		while (tok[ii+1])
		{
			len = strlen(tokP) - 1;
			if (len && (tokP[len] == '!'))
				fprintf(fp,"\tReadNULL,\n");
			else
				fprintf(fp,"\tRead%s,\n",tokP);
			ii++;
			tokP = tok[ii];
		}

		if (len && (tokP[len] == '!'))
			fprintf(fp,"\tReadNULL\n};\n");
		else
			fprintf(fp,"\tRead%s\n};\n",tokP);

		if ( 0 != fclose(fp) ) {
			printf("Could not close %s\n",argv[1]);
			exit(1);
		}
	}
	exit(0);
}

