/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: mac.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:58:49 1998
*/
#ifndef MAC_H
#define MAC_H 1

typedef struct mac_disk_header {
	long	magic;
	long	version;
	char	filesys[16];
	short	numentries;
} MACDISKHEADER;

#define sizeof_MACDISKHEADER 26
#define MAC_FILESYS		"Macintosh       "

typedef struct mac_entry_rec {
	long	id;
	long	offset;
	long	length;
} MACENTRYREC;

#define sizeof_MACENTRYREC 12


typedef struct {
    char zerobyte;
    char length;
    char name[63];
    char type[4];
    char creator[4];
    char filler[10];
    unsigned char datafork_size[4];
    unsigned char rsrcfork_size[4];
    unsigned char creation_date[4];
    unsigned char modif_date[4];
    char filler2[29];
} MACBINARY;

/* a MACBINARY header is 128 bytes by definition */
#define MACBINARY_SIZE 128

typedef struct {
	unsigned char version[4];
	char patterns[304];
	char filler[204];
} MACPAINT_HDR;

/* MACPAINT and PICT headers are 512 bytes by definition */
#define MACPAINT_SIZE 512
#define PICT_SIZE 512

#define FILE_TYPE_UP "PNTG"
#define FILE_TYPE_LW "pntg"
#define CREATOR_UP "MPNT"
#define CREATOR_LW "mpnt"
#define MACPAINT_WIDTH 576
#define MACPAINT_HEIGHT 720
#define MACPAINT_BYTES 72	/* 576 bits == 72 bytes per scanline */
#define MACBINARY_SIZE 128
#endif
