/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: DrgDrpLib.h
   Applix ASC version: 2
   Date: Mon Nov 16 13:53:42 1998
*/
#ifndef INCLUDED_DRGDRPLIB_H
#define INCLUDED_DRGDRPLIB_H

/*
static char sccs_id_DrgDrpLib_h [] = "@(#) DrgDrpLib.h 7.3";
*/


#include <stdlib.h>
#include <X11/Xlib.h>


typedef enum { DrgDrpDeviceStyle, DrgDrpLogicalStyle } DrgDrpStyleType;

typedef struct
{
    DrgDrpStyleType type;
    unsigned long   device_state;
    Atom            drop_type;
    unsigned long   internal;
}
DrgDrpStyle;

typedef struct
{
    Atom          format;
    int           wordsize;
    void *        data;
    unsigned long length;
}
DrgDrpInfo;

typedef struct DrgDrpContext
{
    /* This structure is opaque; it should not be accessed. */

    /* Client callback routine */

    void (*callback)();
    void *closure;

    /* Pointer to the event list. */

    struct DrgDrp_Event *events;
}
DrgDrpContext;



extern int  DrpDrpGetTarget ();
extern int  SendData ();
extern int  RegisterWindow ();
extern int  UnregisterWindow ();
extern void SetupFilter ();
extern int  FilterEvent ();
extern int  RegisterWidget ();
extern int  UnregisterWidget ();


#endif /* INCLUDED_DRGDRPLIB_H */
