/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axdnd.h
   Applix ASC version: 9
   Date: Mon Nov 16 13:53:40 1998
*/
#ifndef _axdnd_h
#define _axdnd_h

/* PORT HERE!
   The following pre-processor variables define desktop support:
   `SUPPORT_IXI', `SUPPORT_OLWM', `SUPPORT_HP_VUE', `SUPPORT_MOTIF'. */
#if HP800
#define SUPPORT_IXI    1
#define SUPPORT_HP_VUE 0
#endif

#if SUN4 || LINUX
#define SUPPORT_OLWM 1
#define SUPPORT_IXI  1
#endif

/* Types of desktop managers understood. */
#define AXDTM_FLAG_UNKNOWN   (1 << 0) /* -- must be 0 -- */
#define AXDTM_FLAG_IXI       (1 << 1) /* IXI-Desktop Version 3 */
#define AXDTM_FLAG_HP_VUE    (1 << 2) /* HP-VUE Version 2.01 */
#define AXDTM_FLAG_OLWM      (1 << 3) /* Open Windows Version 3 */
#define AXDTM_FLAG_MOTIF     (1 << 4)

#define HAVE_IXI(f)    (((f) & AXDTM_FLAG_IXI) ? 1 : 0)
#define HAVE_HP_VUE(f) (((f) & AXDTM_FLAG_HP_VUE) ? 1 : 0)
#define HAVE_OLWM(f)   (((f) & AXDTM_FLAG_OLWM) ? 1 : 0)
#define HAVE_MOTIF(f)  (((f) & AXDTM_FLAG_MOTIF) ? 1 : 0)

/* Desktop manager names in string form.  These are here in case we
   provide a startup switch that tells ``asterx'' which desktop
   manager it is being run under.
   Eg: asterx -dm xdt */
#define AXDTM_STR_IXI      NXLT("xdt")
#define AXDTM_STR_HP_VUE   NXLT("hpvue")
#define AXDTM_STR_OLWM     NXLT("ol")
#define AXDTM_STR_MOTIF    NXLT("mwm")

/* Drag file types */
#define DRAG_FILETYPE_REG      0  /* regular file */
#define DRAG_FILETYPE_DIR      1  /* directory */
#define DRAG_FILETYPE_CHR      2  /* character dev */
#define DRAG_FILETYPE_BLK      3  /* block dev */ 
#define DRAG_FILETYPE_LNK      4  /* link */
#define DRAG_FILETYPE_SOCK     5  /* socket */
#define DRAG_FILETYPE_FIFO     6  /* fifo */
#define DRAG_FILETYPE_UNKNOWN  7  /* unknown */

/* Site requests Enter & Leave events. */
#define AXOL_SITE_FLAG_CROSSING     (1 << 0)

/* Site requests Motion events. */
#define AXOL_SITE_FLAG_MOTION       (1 << 1)

/* This site is the default site for this window. */
#define AXOL_SITE_FLAG_DEFAULT      (1 << 2)

/* This site exists as a proxy for another site. */
#define AXOL_SITE_FLAG_FORWARD      (1 << 3)

/* This site is currently not interested in receiving trigger
   messages. */
#define AXOL_SITE_FLAG_INSENSITIVE  (1 << 4)

/* Definitions for the flags field in ``Trigger Message''s */
/* If set, this flag indicates that the source intends the transfer to
   be a move operation instead of a copy. */
#define AXOL_TRG_DELETE       (1 << 0)

/* If set, the source is awaiting an acknowledgement from the
   destination to indicate receipt of the trigger message. */
#define AXOL_TRG_ACKNOWLEDGE  (1 << 1)

/* If set, the selection named in the trigger message was transient,
   i.e. created by the source for use only during this selection
   transfer. */
#define AXOL_TRG_TRANSIENT    (1 << 2)

/* If set, this flag indicates the trigger message was sent to a site
   that had the `AXOL_SITE_FLAG_FORWARD' bit set in it's site flag
   field */
#define AXOL_TRG_FORWARD      (1 << 3)

extern int AxDndNoMessaging;

extern void AxDndInitialize(/* Display *dpy */);
extern void AxDndRegisterWindow(/* Display *dpy, Window win,
								   Window target */);
extern void AxDndUnregisterWindow(/* Display *dpy, Window win */);
extern int  AxDndHandleEvent(/* XEvent *ev */);

#endif /* !_axdnd_h */


/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
