/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axt.c
   Applix ASC version: 7
   Date: Mon Nov 16 13:53:42 1998
*/
#if SUPPORT_HP_VUE /* { */

#define _axt_h_  /* Since we want to use real toolkit functions here. */

#include <aos.h>
#include <axdnd.h>

#define _NO_PROTO
#include <X11/Intrinsic.h>
#include <stdio.h>
#include <aos.h>

extern Display *Dpy;
extern char *AxDisplayName; /* Name of display from applix command
							   line or getenv */
static int AxRealToolkitInitDone = FALSE;

void
AxRealXtToolkitInitialize()
{
	Widget dummy;
	char *argv[20];
	int  argc = 0;
	
	if (AxRealToolkitInitDone)
		return;

	if (!getenv("DISPLAY")) {
		char env_var[100];
		sprintf(env_var, "DISPLAY=%s", AxDisplayName);
		(void) putenv(env_var);
	}

	dummy = XtInitialize(0, NXLT("Dummy"), NULL, 0, 0, 0);

	Dpy = XtDisplay(dummy);
	AxRealToolkitInitDone = TRUE;
	while (argc--)
		if (argv[argc])
			free(argv[argc]);
	return;
}

int
AxRealXtPending()
{
	if (XtPending())
		return(TRUE);
	else
		return(FALSE);
}
#else /* }{ */
/* Null function to suppress compiler errors/warnings about
   "empty module". */
int
axt_c_nullfunc()
{
	return;
}
#endif /* } */
