/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: colors.h
   Applix ASC version: 7
   Date: Mon Nov 16 13:53:45 1998
*/
#ifndef _COLORS_H
#define _COLORS_H

typedef struct col_table {
    int  rfg,rbg,rpat;
	int  gfg,gbg,gpat;
	int  bfg,bbg,bpat;
	int  fgcolor,bgcolor,colpat;
} col_table;

static int dithers[][16] = {
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1},
	{1,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1},
	{1,1,1,1,1,1,0,1,1,1,1,1,0,1,0,1},
	{1,1,1,1,0,1,0,1,1,1,1,1,0,1,0,1},
	{1,1,1,1,0,1,0,1,1,0,1,1,0,1,0,1},
	{1,1,1,0,0,1,0,1,1,0,1,1,0,1,0,1},
	{1,1,1,0,0,1,0,1,1,0,1,0,0,1,0,1},
	{1,0,1,0,0,1,0,1,1,0,1,0,0,1,0,1},
	{1,0,1,0,0,1,0,1,1,0,1,0,0,0,0,1},
	{1,0,1,0,0,1,0,0,1,0,1,0,0,0,0,1},
	{1,0,1,0,0,1,0,0,1,0,1,0,0,0,0,0},
	{1,0,1,0,0,0,0,0,1,0,1,0,0,0,0,0},
	{1,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0},
	{1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0},
	{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
};
/************************************************************************/
static unsigned long low_bits_table[] = {
   0x00000000, 0x00000001, 0x00000003, 0x00000007,
   0x0000000f, 0x0000001f, 0x0000003f, 0x0000007f,
   0x000000ff, 0x000001ff, 0x000003ff, 0x000007ff,
   0x00000fff, 0x00001fff, 0x00003fff, 0x00007fff,
   0x0000ffff, 0x0001ffff, 0x0003ffff, 0x0007ffff,
   0x000fffff, 0x001fffff, 0x003fffff, 0x007fffff,
   0x00ffffff, 0x01ffffff, 0x03ffffff, 0x07ffffff,
   0x0fffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff,
   0xffffffff
};
#define ZINDEX(x, y, xim) ((y) * xim->bytes_per_line) + \
						  (((x) * xim->bits_per_pixel) >> 3)
#define ZNORMALIZE(bp, xim) \
				normalizebits((unsigned char *)(bp), xim)
/************************************************************************/
#define MONO(rd,gn,bl) (((rd)*30 + (gn)*59 + (bl)*11) / 100) 
#define COL_IX(imP, x, y) (imP->data[y*imP->data_byte_wid + x])
#define DITHER(ix,col ) ((dithers[col->rpat][ix] ? col->rfg : col->rbg) \
						 +(dithers[col->gpat][ix] ? col->gfg : col->gbg) \
						 +(dithers[col->bpat][ix] ? col->bfg : col->bbg))
#define AXGETPIXEL08(xim, x, y) (((unsigned char *)xim->data) \
								  [y * xim->bytes_per_line + x])

#define AXGETPIXEL01LSB(xim,x,y) \
		 (xim->data[y * xim->bytes_per_line + ((x+xim->xoffset) >> 3)] \
		 & (1 << ((x+ xim->xoffset & 7)))) ? 1 : 0
#define AXGETPIXEL01MSB(xim,x,y) \
		 (xim->data[y * xim->bytes_per_line + ((x+xim->xoffset) >> 3)] \
		 & ( 0x80 >> ((x+ xim->xoffset & 7)))) ? 1 : 0
/************************************************************************/
#define RSTDCOMP(stdmap, r, max) ((unsigned long)(0.5 +\
							   ((double)r/(double)max*stdmap->red_max))*\
							   stdmap->red_mult)
#define GSTDCOMP(stdmap, g, max) ((unsigned long)(0.5 +\
							   ((double)g/(double)max*stdmap->green_max))*\
							   stdmap->green_mult)
#define BSTDCOMP(stdmap, b, max) ((unsigned long)(0.5 +\
							   ((double)b/(double)max*stdmap->blue_max))*\
							   stdmap->blue_mult)

#endif   /* _COLORS_H */
