/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ddlsend.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:53:41 1998
*/
#include <stdio.h>
#include <DrgDrpLibP.h>


int DrgDrpSendData (dpy, win, time, x, y, styles, n_styles, data, n_formats)
Display *dpy;
Window win;
Time time;
unsigned int x, y;
DrgDrpStyle *styles;
unsigned int n_styles;
DrgDrpInfo *data;
unsigned int n_formats;
{
    XClientMessageEvent e;
    unsigned int n_to_go = n_styles > n_formats ? n_styles : n_formats;
    unsigned int i;

    if (n_styles == 0 || n_formats == 0)
        return False;

    /* Check and munge all the style values. */

    for (i = 0; i < n_styles; i++)
    {
        switch (styles [i].type)
        {
        case DrgDrpDeviceStyle:
            if (styles [i].device_state & ~F_DEVICE)
                return False;
            styles [i].internal = styles [i].device_state | F_S_DEVICE;
            break;

        case DrgDrpLogicalStyle:
            styles [i].internal = styles [i].drop_type | F_S_LOGICAL;
            break;

        default:
            return False;
        }
    }

    /* Set up the unchanging fields. */

    e.type = ClientMessage;
    e.window = win;
    e.message_type = DrgDrp_Atom (dpy);
    e.format = 32;
    e.data.l [0] = time;
    e.data.l [1] = (x << 16) + y;

    for (i = 0; i < n_to_go; i++)
    {
#if 0
        DrgDrpInfo info = data [n_to_go - n_formats + i];
#else
		/* sgd - no aggregate init */
		DrgDrpInfo info;
		info = data [n_to_go - n_formats + i];
#endif
        /* Set up the flag word. */

        e.data.l [2] = styles [i % n_styles].internal |
                       (i != n_to_go - 1 ? F_MORE : 0);

        /* Set up the data fields. */

        if (i < n_to_go - n_formats)
            e.data.l [3] = e.data.l [4] = 0;
        else
        {
            e.data.l [3] = info.format;
            e.data.l [4] = DrgDrp_UniqueAtom (dpy, (unsigned long) time,
                                                   (unsigned long) i);
            XChangeProperty (dpy, win, e.data.l [4], info.format,
                             info.wordsize, PropModeReplace, info.data,
                             info.length);
        }

        /* Now send the event. */

        XSendEvent (dpy, win, False, 0L, (XEvent *) &e);
    }

    return True;
}
