/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: kanjicnv.c
   Applix ASC version: 77
   Date: Mon Nov 16 13:53:40 1998
*/
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include <basicwin.h>
#include <ax_xm.h>

#include <aos.h>
#include <xmlib.h>
#include <elxwins.h>
#include <wchars.h>
#include <xim.h>
#include <xmtable.h>

#ifndef MBstrlen
#define MBstrlen strlen
#endif

#include <ximcomm.h>
#include <paratm.h>
#include <parint.h>
#include <scac.h>
#include <aiconids.h>


int typing_possible_into_widget( );

Window ignore_window;
int ignore_bytes;
extern PIXEL_VALUE ForePixel;   /* foreground for control panels */
extern PIXEL_VALUE BackPixel;   /* backround for control panels */


#if BUILD_ORIENT  /*  {  */


/********************************************************************/
/* Make sure that every character in the string is either wide or   */
/* narrow.  We scan the string once and if there are any wide chars */
/* we convert, as best we can, everything to wide.                  */
/*  Returns:  TRUE if string is wide chars,  FALSE if narrow        */
/*                                                                  */
/* Method: The wide fonts have an 'ascii' section which contsins the*/
/*    ascii alpha and numeric chars, in the same sequence.  We      */
/*    try to shift the chars to keep them around if they are alpha/num */
/*    otherwise the chars get deleted                               */
/********************************************************************/

#if BUILD_KANJI
#define START_WIDE_ALPHA (unsigned)0x2330
#define WIDE_BLANK_CHAR (unsigned)0x2121
#endif

#if BUILD_CHINA
#define START_WIDE_ALPHA (unsigned)0x2330
#define WIDE_BLANK_CHAR (unsigned)0x2121
#endif


#if HYUNDAI
#if OPENWIN
#define START_WIDE_ALPHA (unsigned)0x2330
#define WIDE_BLANK_CHAR (unsigned)0x2121
#else
#define START_WIDE_ALPHA (unsigned)0xA3D0
#define WIDE_BLANK_CHAR (unsigned)0xA1A1
#endif
#endif


int MakeConstantCharSet( wstr )
wchar *wstr;
{
    int str_len, num_wide;
    int force_wide;
    wchar *p, *dest;;

    str_len = num_wide = 0;
    p = wstr;
    while ( *p != (wchar)0 )
        {
        str_len++;
        if ( IS_ORIENT_CHAR( *p ) )
            num_wide++;
        p++;
        }

        
    force_wide = FALSE;
    if ( num_wide > 0 )
        /* if there are any wide, make everything wide */
        force_wide = TRUE;
    else
        /* no wide chars, all dont */
        return( FALSE );

    /* convert the chars of the 'different' type */
    dest = p = wstr;
    while ( *p != (wchar)0 )
        {
        if ( (force_wide && IS_ORIENT_CHAR( *p )) ||
             (!force_wide && !IS_ORIENT_CHAR( *p )) )
            {
            /* char is of correct type */
            *dest = *p;
            dest++;
            }
        else
            {
            /* If the character is [a-z][A-Z][0-9] subsititue from the */
            /* other font set                  */
            if ( force_wide )
               {
               /* char is narrow, and should be wide */
               if ( ((*p >= 'a') && (*p <= 'z')) ||
                    ((*p >= 'A') && (*p <= 'Z')) || 
                    ((*p >= '0') && (*p <= '9')) )
                  {
                  *dest++ = START_WIDE_ALPHA + (*p - '0');
                  }
               else
                  {
                  if ( *p != '\t' )
                      /* bash character to a wide blank */
                      *dest++ = WIDE_BLANK_CHAR;
                  else
                      /* leave tabs alone since we never actually print them */
                      *dest++ = *p;
                  }
               }
            else
               {
               /* char is wide, and should be narrow */
               /* there are 75 chars between '0' and 'z'    */
               if ( (*p >= START_WIDE_ALPHA) && (*p < (START_WIDE_ALPHA+75)) )
                  {
                  *dest++ = *p - START_WIDE_ALPHA;
                  }
               else
                  *dest++ = ' ';
               }
            }
        p++;
        }
    *dest = 0;

    return( force_wide );
}
#endif     /*  } BUILD_ORIENT  */


#if !BUILD_ORIENT || AXMS   /*  {  */
   /* some stubs */
void PaintOrientalStatus(w, exP, regen, layered)
AXWidget w;          /* the status area itself */
XExposeEvent *exP;
int regen;
int layered;
{
 return;
}



#else     /** }   {  BUILD_ORIENT */

AXWidget spot_widget = (AXWidget)NULL ;
AXWidget TotalWidgetsList;

AXWidget CrtWidget();
Widget XmCreateDlgShell();
Widget XmCreateText();
XIC AXCreateIC();
mbchar *GetModeString();
AXWidget WidgetOfFocusWindow();
XIMProc PreeditDrawDialogCallback();
XIMProc OffspotStatusCallback();
XIMProc PreeditDoneDialogCallback();
int AppStartConversionMode();
int AppDoneConversionMode();
XIMProc AppDrawCallback();

int PreeditStartDialogCallback();
AXWidget ElfbGetActiveWidget();
AXWidget FindActiveAsianWidget();
AXWidget XmCreateBulletinBoardDialog();
AXWidget WidgetOfWindow();
int InitOffSpotIC();

int KanjiHeight, KanjiWidth;
static int EGC_activity;
int eucflg = 0;
extern int CallbackGlobalRetValue;

extern Display *Dpy;
extern short DpyWid, DpyHt, DpyDepth;
extern XFontStruct *orient_dlg_font;
extern GC ForeGC, BackGC, ShadowGC, SunGC;
extern win_list_t *TotalWindowsList;
extern Display *Dpy;
extern Cursor kanji_base_cursor;
extern Cursor kanji_field_cursor;
extern Cursor ThimPointerCursor;
extern Cursor ThimTextCursor;
extern int AxOpenLook;
extern XFontStruct *Txfont;
extern XIM input_method;






AXWidget_main TheMainWidget( w )
AXWidget w;
{
	static AXWidget last_widget = NULL;
	static AXWidget_main last_main_w = NULL;
	int i;

	if (w == last_widget)
		return(last_main_w);

	last_widget = w;
	last_main_w = (AXWidget_main) w;
    while (last_main_w != NULL) {
		if (last_main_w->type == W_MAIN)
			break;
		else if (last_main_w->parent == NULL)
			/* For test */
#if 0
			break;
#else
			i = i + 1;
#endif
		else
			last_main_w = last_main_w->parent;
	}
	return(last_main_w);
}


/** set the flag indicating that this widget may be put into kana-kanji */
/** input mode                                                          */
SetWidgetWideCapable( w )
AXWidget w;
{
	AXWidget_main main_w = TheMainWidget(w);

	main_w->allow_wide_input = TRUE;
    return;
}


AXWidget_main FindMainWidgetFromWindow( win )
Window win;
{
    AXWidget w;
    static Window last_win;
    static AXWidget_main last_widget;

    if ( win == last_win )
       /* a simple optimization */
       return( last_widget );

    last_widget = NULL;
    last_win = win;
    for ( w=TotalWidgetsList; w != (AXWidget)NULL; w = w->next )
       {
       if (w->window == win)
           {
           last_widget = (AXWidget_main)w;
           break;
           }
       }

    /* Ashisuto added the more conditions for ver4.3 struct change of
     * W_ENTER and newer W_COMBO_BOX, the real input window becomes 
     * edit_win.win, and that are not registed in WindowList, when do
     * event filtering, it results that the main widget of the win cannot
     * be found. Because our program AXFilterEvent() is heavily depending
     * on the main_w, so add the return of main widget even for inside 
     * window so as to smoothing our treatment.
     **** Remark:
     **** If there is a macro somehow like
     ****        Window parent = XParentWindow(Window w);
     **** our modification will be more simple.
     * 1996.11.18
     */
    if ( last_widget == NULL )
    {
        for ( w=TotalWidgetsList; w != (AXWidget)NULL; w = w->next )
        {
            if ( (w->type == W_ENTER &&
                  ((AXWidget_entry)w)->edit_win.win == win) ||
                 (w->type == W_COMBO_BOX &&
                  ((AXWidget_combo_box)w)->edit_win.win == win) )
            {
                last_widget = (AXWidget_main)w;
                break;
            }
        }
    }

	last_widget = TheMainWidget(last_widget);
	return(last_widget);

}


static UpdateKanjiStatusMessage(status_w)
AXWidget_kanji status_w;      /* kanji status area widget */
{
	GC gc;
	int yoffset;
    AXWidget_main main_w;

    if ( (status_w == NULL) || (input_method == (XIM)NULL) )
       return;

    main_w = TheMainWidget((AXWidget)status_w);
    if ( main_w == NULL )
       return;

	XClearArea (Dpy, status_w->window, 0, 0, 
                          status_w->width, status_w->height, FALSE);

    if ( AxIsGraphicsTask(main_w->taskOwner))
       {
       /* since we use an off-the-spot input mode in the GE, and we use */
       /* the status widget as the off-the-spot location, don't draw */
       /* the seperator line                                         */
       XDrawLine( Dpy, status_w->window, ForeGC, 0, 0, status_w->width, 0 );
       }

    if ( (status_w->kanjiStatusStr == (mbchar *)NULL) || 
         (MBstrlen(status_w->kanjiStatusStr) == 0) )
       return;

    /* +3==>get top of letters below border*/
    yoffset = orient_dlg_font->ascent+4; 

	axDrawString(Dpy, status_w->window, ForeGC, (XFontStruct *) 0,
				 5, yoffset, status_w->kanjiStatusStr,
				 MBstrlen(status_w->kanjiStatusStr) );
}




/*************************************************************************/
/* function: PaintOrientalStatus - Handle exposure to the status area used */
/*           during oriental input conversion by the X Input Method */
/*************************************************************************/
void PaintOrientalStatus (status_w, exP, regen, layered)
AXWidget_kanji status_w;          /* the status area itself */
XExposeEvent *exP;
int regen;
int layered;
{
    register AXWidget_main main_w;
    app_call_data *callback_data;
    static use_off_spot_style = -1;

    if ( use_off_spot_style == -1 )
       {
       /* initialize */
#if BUILD_KANJI
       /* OffTheSpot is more effecient, let it be the default. The only
        * platform support OnTheSpot is Solaris2.x for Japanese. Ashisuto
        * changed, 1995.11.30
        */
       char *inputStyleStr;
       use_off_spot_style = TRUE;  /* Set the default */
       inputStyleStr = getenv("AX_ONSPOT");
       if (inputStyleStr) {
           if (*inputStyleStr == '1')
               use_off_spot_style = FALSE;
       } else {
           inputStyleStr = (char *)GetProfileByStr(NXLT("axOnTheSpot"));
           if (inputStyleStr && *inputStyleStr && atoi(inputStyleStr))
               use_off_spot_style = FALSE;
       }
#else
       if ( getenv(NXLT("AX_OFFSPOT")) != (char *)NULL ) 
           use_off_spot_style = TRUE;
       else
           use_off_spot_style = FALSE;
#endif

#if BUILD_KANJI && !SUN4S && !SUNIS
       /* force over-the-spot to emulate off-the-spot.               */
       /* See InitOffSpot() for the rest of this hack                */
       use_off_spot_style = TRUE;
#endif

#if HYUNDAI
#if HP800 || RIOS
       /* since HP does not support anything but over-the-spot, we use */
       /* over-the-spot to emulate off-the-spot.  See InitOffSpot() for the */
       /* rest of this hack                                          */
       use_off_spot_style = TRUE;
#endif
#endif
       }

	main_w = TheMainWidget((AXWidget)status_w);
    if ( main_w == NULL )
       return;

    if ( (status_w == NULL) || (input_method == (XIM)NULL) )
       return;

	if ( !status_w->window || !main_w->allow_wide_input )
		return;

	if ((status_w->flags & WFLG_IN_EDIT) && layered) {
		if(dePaintWidget(status_w))
			return;
	}

    if ( main_w->callback_data  == (mbchar *)NULL )
       {
       /* need to initialize the input context for this window */
       /* figure out what type of window this is, and set up the correct */
       /* input context                                              */
       if ( main_w->style == IC_MAIN )
          {
          /* no entry areas on main menu */
          main_w->allow_wide_input = FALSE;
          return;
          }
       else if ( (main_w->style == IC_DC) || (main_w->style == IC_CE) ||
           (main_w->style == IC_EQN) || (main_w->style == IC_HTML) )
          {
          /* a Words window  or a macro editor window, or equations editor */
          if ( use_off_spot_style )
              InitOffSpotIC( main_w );
          else
              InitOnSpotInput( main_w );
          /* WpXimModeConversionOn( NULL ); */

          return;               /* will get future "paint" callback */
          }
       else if ( main_w->style == IC_SS )
          {
          /* a spreadsheet window */
          if ( use_off_spot_style )
              InitOffSpotIC( main_w );
          else
              InitOnSpotInput( main_w );
          return;               /* will get future "paint" callback */
          }
       else if ( AxIsGraphicsTask(main_w->taskOwner))
          {
          /* a graphics window, which is currently off-the-spot mode */
          InitOffSpotIC( main_w );
          return;
          }
       else if ( main_w->dialog != NULL )
          {
          /* it seems to be a dialog box */
          /* we only do this if there is an entry area of some sort for the */
          /* user to type into                      */
          if ( typing_possible_into_widget( main_w ) ||
               typing_possible_into_widget( main_w->widgets ) ||
               typing_possible_into_widget( main_w->dialog ) )
             main_w->allow_wide_input = TRUE;
          else
             {
             /* no entry areas, we're out of here, never to come back */
             main_w->allow_wide_input = FALSE;
             return;
             }
          if ( use_off_spot_style )
              InitOffSpotIC( main_w );
          else
              InitDialogIC( main_w );
          }
       else
          {
          /* we don't know what this is so don't start any input context */
          main_w->allow_wide_input = FALSE;
          return;
          }
       }

   if ( !main_w->inWideInput )
       {
       /* initialization not yet complete, recursive call during */
       /*   creation of the IC                     */
       return;
       }
   
   /* repaint embeded text */
   UpdateKanjiStatusMessage(status_w);
   
}


/*************************************************************************/
/* UpdatePermKanjiMessage - Update kanji status line assciated with a window */
/*************************************************************************/

UpdatePermKanjiMessage (main_w,text)
AXWidget_main main_w;		/* main widget */
char *text;
{
    AXWidget_kanji status_w;
	char str[MAX_NAME+1];

    if ( main_w == NULL )
       return;

	if ( main_w->kanji_status )
		status_w = main_w->kanji_status;
	else
		return;

	strncpy(str,text,MAX_NAME);
	str[MAX_NAME] = 0;

    if ( status_w->kanjiStatusStr != (mbchar *)NULL )
	    free(status_w->kanjiStatusStr);
	status_w->kanjiStatusStr = (mbchar *)strcpy(malloc(strlen(str)+1),str);
	UpdateKanjiStatusMessage(status_w);
}




XIMProc StatusCallback( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XIMStatusDrawCallbackStruct *call_data;
{
    AXWidget_main main_w;
    AXWidget active_w;
    mbchar temp_buff[200];
    wchar_t wide_buff[200];
    int in_len;

    main_w = client_data->xim_widget;
    if ( main_w == NULL )
        return;

   if ( (!main_w->inWideInput) || 
        (call_data->data.text == (struct _XIMText *)NULL) ||
        (call_data->data.text->string.multi_byte == (char *)NULL) )
       {
       /* initialization not yet complete, or a null string */
       return;
       }
    
    /** Note: the input string is NOT guaranteed to be null terminated, so **/
    /*        we must make sure it is.                                     **/
    in_len = call_data->data.text->length;
    if ( call_data->data.text->encoding_is_wchar )
        {
        /* we use the system "wcstombs" rather than our own wide->mixed byte */
        /* since we do not know whether "wide" to the system is 2 bytes or 4 */
        memcpy( (char *)wide_buff, 
                             (char *)call_data->data.text->string.wide_char,
                             (in_len * sizeof(wchar_t)) );
        wide_buff[in_len] = 0;
        wcstombs( (char *)temp_buff, wide_buff, sizeof(temp_buff) );
        UpdatePermKanjiMessage( main_w, temp_buff );
        }
    else
        {
        memcpy( temp_buff, call_data->data.text->string.multi_byte, in_len );
        temp_buff[in_len] = 0;
        UpdatePermKanjiMessage(main_w, call_data->data.text->string.multi_byte);
        }

    return;
}


NoOpFunc()
{
    return;
}


int InitOffSpotIC( main_w )
AXWidget_main main_w;
{
    app_call_data *new_callback_data;
    XIMCallback Sstart_c, Sdone_c, Sdraw_c;
    XIC ic;
    XRectangle p_rect, s_rect;
    XPoint spot;
    AXWidget_kanji status_w;
    XVaNestedList preedit_attr, status_attr;
    int i;
    char *ret;
    XIMStyles *styles;

#if BUILD_KANJI && (SUN4S || SUNIS || RIOS || LINUX)
/* Correspond to Wnn JSERVER which use ASCII also as its conversion status font,
 * and without the default fontset within the XIC.
 * Ashisuto added, 1996.11.12
 * Modify for IBM-AIX 4.2 Wnn6 xwnmo FEP.  Ashisuto, 1997.07.18
 */
#define DEFAULT_FONT_NAME NXLT("-misc-fixed-medium-r-normal--14-*")
	static XFontSet fs = (XFontSet)0;
	char **missing_list;
	int missing_count;
	char *def_string;

	if (fs == (XFontSet)0) {
		/* create a font set for use by the input mechanism */
		fs = XCreateFontSet(Dpy, DEFAULT_FONT_NAME, &missing_list,
				&missing_count, &def_string);
		if (fs == 0) {
			RingTheBell();
			main_w->ic = (XIC)NULL;
			return(FALSE);
		}
	}
#endif	/* BUILD_KANJI */

#if HP800
/*** Wildcarded font for increased portability ***/
/*#define DEFAULT_FONT_NAME NXLT("*-18-*")*/
    static XFontSet fs = (XFontSet)0;
    char **missing_list;
    int missing_count;
    char *def_string;

#endif
    
 
    if ( main_w == NULL )
       return( FALSE );
 
#if HP800
    /* open a connection to the input method per window */
    input_method = XOpenIM( Dpy, NULL, NULL, NULL);
    if ( input_method == (XIM)NULL )
       {
       RingTheBell();
       main_w->ic = (XIC)NULL;
       main_w->im = (XIM)NULL;
       return( FALSE );
       }
    main_w->im = input_method;
#endif

    /* the callback data is not used, but as a flag and for constency */
    /*  on the 'free' end of things we put it in */
    new_callback_data=(app_call_data *)malloc(sizeof(app_call_data));
    memset( new_callback_data, 0, sizeof(app_call_data) );

    main_w->callback_data = (mbchar *)new_callback_data;
    new_callback_data->task_pid = THIMpid;
    new_callback_data->xim_widget = main_w;

    status_w = main_w->kanji_status;

#if HP800   /*   {  */
    /* on hp, they only currently support an over-the-spot mode.  We emulate */
    /* off-the-spot by using over-the-spot over the status window.  There is */
    /* also no status information displayed as part of HP's over-the-spot */
    /* We express all positions relative to the root window */
    if ( fs == (XFontSet)0 )
       {
       /* create a font set for use by the input mechanism */
       fs = XCreateFontSet( Dpy, NXLT("*-18-*"), &missing_list,
                &missing_count, &def_string);
       if ( fs == 0 )
          {
          RingTheBell();
          main_w->ic = (XIC)NULL;
          return( FALSE );
          }
       }

    spot.x = status_w->xpos;
    spot.y = status_w->ypos + status_w->height - 3;

    preedit_attr = XVaCreateNestedList( NULL, XNSpotLocation, &spot, 
                         XNFontSet, fs,
                         XNForeground, ForePixel,
                         XNBackground, BackPixel,
                         NULL );


#if 0
    ret = XGetIMValues( input_method, XNQueryInputStyle, &styles, 0 );

    if ( ret != (char *)NULL )
        {
        printf("XGetIMValues fails\n");
        }

    for ( i=0; i<styles->count_styles; i++ )
        {
        printf(" - ");
        if ( styles->supported_styles[i] & XIMPreeditArea )
            printf("XIMPreeditArea ");
        if ( styles->supported_styles[i] & XIMPreeditCallbacks )
            printf("XIMPreeditCallbacks ");
        if ( styles->supported_styles[i] & XIMPreeditPosition )
            printf("XIMPreeditPosition ");
        if ( styles->supported_styles[i] & XIMPreeditNothing )
            printf("XIMPreeditNothing ");
        if ( styles->supported_styles[i] & XIMPreeditNone )
            printf("XXIMPreeditNone ");
        if ( styles->supported_styles[i] & XIMStatusArea )
            printf("XIMStatusArea ");
        if ( styles->supported_styles[i] & XIMStatusCallbacks )
            printf("XIMStatusCallbacks ");
        if ( styles->supported_styles[i] & XIMStatusNothing )
            printf("XIMStatusNothing ");
        if ( styles->supported_styles[i] & XIMStatusNone )
            printf("XIMStatusNone");
        printf("\n");
        }
#endif

    ic = XCreateIC( input_method,
                    XNInputStyle, (XIMPreeditPosition | XIMStatusNothing),
                    XNClientWindow, main_w->window,
                    XNFocusWindow, main_w->window,
                    XNPreeditAttributes, preedit_attr,
                    NULL );

    {
    Window client_window;
    Window focus_window;
    XFontSet fs;
    XGetICValues( ic, XNClientWindow, &client_window,
                      XNFocusWindow, &focus_window,
                      XNFontSet, &fs, NULL );
    if ( (client_window != main_w->window) ||
         (focus_window != main_w->window) ||
         ( fs == (XFontSet)NULL) )
       i = i + 2;

    }

    XFree( preedit_attr );
#if 0
    XGetICValues(ic, XNFilterEvents, &fevent, NULL);
    mask = ExposureMask | KeyPressMask | FocusChangeMask;
    XSelectInput(display, main_w->window, mask | fevent);
#endif

#else       /*  }  HP800 {  */

    p_rect.x = 120;
    p_rect.y = 0;
    p_rect.width = status_w->width - 120;
    p_rect.height = status_w->height;

#if SUN4S && !HYUNDAI
    if ( getenv(NXLT("AX_OLD_SOLARIS")) != (char *)NULL )
        {
        /** HACK,  the off-spot preedit area ends up root-window relative */
        /** prior to solaris 2.3 so we must adjust the position           */
        p_rect.x = 120 + status_w->xpos;
        p_rect.y  = status_w->ypos;
        }
#endif

#if BUILD_KANJI && (SUN4S || SUNIS || RIOS || LINUX)
    preedit_attr = XVaCreateNestedList(NULL,
									XNArea, &p_rect, XNFontSet, fs, NULL);
#else
    preedit_attr = XVaCreateNestedList( NULL, XNArea, &p_rect, NULL );
#endif

    s_rect.x = 0;
    s_rect.y = 0;
    s_rect.width = 120;
    s_rect.height = status_w->height;
#if BUILD_KANJI && (SUN4S || SUNIS || RIOS || LINUX)
    status_attr = XVaCreateNestedList(NULL,
									XNArea, &s_rect, XNFontSet, fs, NULL);
#else
    status_attr = XVaCreateNestedList( NULL, XNArea, &s_rect, NULL );
#endif
 
    ic = XCreateIC( input_method,
                    XNInputStyle, (XIMPreeditArea | XIMStatusArea),
                    XNClientWindow, status_w->window,
                    XNFocusWindow, status_w->window,
                    XNPreeditAttributes, preedit_attr,
                    XNStatusAttributes, status_attr,
                    NULL );

    XFree( status_attr );
    XFree( preedit_attr );
#endif        /* } HP800  */


    if ( ic == (XIC)NULL )
       {
       RingTheBell();
       main_w->ic = (XIC)NULL;
       return( FALSE );
       }

    main_w->ic = ic;
    main_w->useOnSpot = FALSE;
#if SUN4 && !USE_XIM && BUILD_KANJI
    main_w->inWideInput = FALSE;
#else
    main_w->inWideInput = TRUE;
#endif

    return( TRUE );
}


InitDialogIC( main_w )
AXWidget_main main_w;
{
    XIC new_ic;
    app_call_data *new_callback_data;
    
    if ( main_w == NULL )
       return( FALSE );

    if ( main_w->callback_data  != (mbchar *)NULL )
        /* already initialized */
        return( TRUE );

    new_callback_data=(app_call_data *)malloc(sizeof(app_call_data));
    memset( new_callback_data, 0, sizeof(app_call_data) );

    main_w->callback_data = (mbchar *)new_callback_data;
    new_callback_data->task_pid = THIMpid;
    new_callback_data->xim_widget = main_w;

    new_ic = AXCreateIC(main_w->window, new_callback_data,
               (XIMProc)PreeditStartDialogCallback,
               (XIMProc)PreeditDoneDialogCallback,
               (XIMProc)PreeditDrawDialogCallback,
               (XIMProc)NoOpFunc,
               (XIMProc)NoOpFunc,
               (XIMProc)NoOpFunc,
               (XIMProc)StatusCallback);

    if ( new_ic == (XIC)NULL )
       {
       /* can not create at this time */
       RingTheBell();
       return( FALSE );
       }

    main_w->ic = new_ic;
    main_w->useOnSpot = TRUE;
#if SUN4 && !USE_XIM && BUILD_KANJI
    main_w->inWideInput = FALSE;
#else
    main_w->inWideInput = TRUE;
#endif
    return;
}




/* set up start of conversion in a dialog box.  This means, start of */
/* conversion in either an entry area or an edit box                  */
/* By definition this is supposed to return the max length string which */
/*    can be handled of -1 to handle any length                       */

PreeditStartDialogCallback( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    AXWidget active_w;
    any_obj_t *op;
    tline_t *lp;
    table_info *tp;
	AXWidget_main main_w;
    AXWidget_dialog dialog_w;

	main_w = client_data->xim_widget;
	if ( main_w == NULL )
		return;

	dialog_w = main_w->dialog;
	if ( (dialog_w == NULL) || (dialog_w->type != W_DIALOG) )
		return( -1 );

    active_w = FindActiveAsianWidget( dialog_w );
    if ( active_w == NULL )
       /* still no luck */
       return( -1 );


    main_w->conv_phrase_start = -1;
    main_w->conv_phrase_end = -1;
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );

    if ( active_w->type == W_ENTER )
       {
       main_w->conversion_start = MAX( 0, ((AXWidget_entry)active_w)->curPos ); /* curr cursor position */
       main_w->conversion_end = main_w->conversion_start;
       }
    else if ( active_w->type == W_EDITBOX )
        {
        memcpy( &((AXWidget_editbox)active_w)->editbox->conv_info, &((AXWidget_editbox)active_w)->editbox->tcursor,
                              sizeof( ((AXWidget_editbox)active_w)->editbox->conv_info ) );
        main_w->conversion_start = MAX( 0, ((AXWidget_editbox)active_w)->editbox->tcursor.ac_index );
        main_w->conversion_end =  MAX( 0, ((AXWidget_editbox)active_w)->editbox->tcursor.ac_index );
        }
    else if ( active_w->type == W_TABLE )
        {
        tp = (table_info *)((AXWidget_table)active_w)->info.table;
        main_w->conversion_start = MAX( 0, tp->cursor.char_pos );
        main_w->conversion_end = main_w->conversion_start;
        }

    return( XLS_BUF_LEN );
}

XIMProc PreeditDoneDialogCallback( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    AXWidget active_w;
    int buff_len;
	AXWidget_main main_w;
    AXWidget_dialog dialog_w;


    /* find the active widget in this dialog.  We first check for a table */
    /*   widget, since at this point editing is implied by the window id  */
	main_w = client_data->xim_widget;
	if ( main_w == NULL )
		return;

	dialog_w = main_w->dialog;
	if ( (dialog_w == NULL) || (dialog_w->type != W_DIALOG) )
		return;

    active_w = FindActiveAsianWidget( dialog_w );
    if ( active_w == NULL )
       /* still no luck */
       return;

#if HYUNDAI && (SUN4 || SUN4S)    /*   {  */
    buff_len = Wstrlen( client_data->preedit_buf );
    if ( buff_len > 0 )
        {
        /* there is some string in the preedit buffer.  This means that */
        /* the input was just terminated.  To make the X11R5 server match */
        /* the processing style of the Solaris and IBM RS6000 server, we */
        /* create a PreeditDraw callback call, which specifies a change */
        /* length of the entire area.  This allows the application to clear */
        /* the preedit text, before it receives the final input characters */
        /* as a result of the KeyPress event/XMbLookupString() call which */
        /* will be the next event received.                               */
        XIMPreeditDrawCallbackStruct call_data;
        memset( &call_data, 0, sizeof(call_data) );
        call_data.chg_length = buff_len;
        PreeditDrawDialogCallback( ic, client_data, &call_data );
        }
#endif     /*  }  */


 
    main_w->conversion_start = -1; 
    main_w->conversion_end = -1;
    main_w->conv_phrase_start = -1;
    main_w->conv_phrase_end = -1;
    main_w->conv_change_start = -1;
    main_w->conv_change_end = -1;
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );

    if ( active_w->type == W_ENTER )
        EntReplaceText( (AXWidget_entry)active_w, NULL, 0 );
    else if ( active_w->type == W_EDITBOX )
        ReplaceEntryText( active_w, "", 0 );   /* get display updated */

    CallbackGlobalRetValue = TRUE;    /* we handled the keystroke locally */
    return;
}


XIMProc PreeditDrawDialogCallback( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XIMPreeditDrawCallbackStruct *call_data;
{
    int under_start, under_end;
    int high_start, high_end;
    XIMFeedback *feedP;
    int i;
    int area_len;
    AXWidget active_w;
    AXWidget_main main_w;
    AXWidget_dialog dialog_w;
    int new_len, old_len;

    main_w = client_data->xim_widget;
    if ( main_w == NULL )
        return;

    dialog_w = main_w->dialog;
    if ( (dialog_w == NULL) || (dialog_w->type != W_DIALOG) )
       return;

    /* find the active widget in this dialog.  We first check for a table */
    /*   widget, since at this point editing is implied by the window id  */
    active_w = FindActiveAsianWidget( dialog_w );
    if ( active_w == NULL )
       /* still no luck */
       return;
 
    /* The XIM input mechanism will hand us individual characters, */
    /* so we must keep around the entire pre-edit string here */
    old_len = Wstrlen( client_data->preedit_buf );
    new_len = 0;
    if ( call_data->text != (XIMText *)NULL )
       new_len = call_data->text->length;

    if ( (old_len == 0) && (new_len > 0) )
       {
       /* we went from no previous text --> some text, we regard this as the  */
       /*  "start" of a conversion session, so set the insertion point  */
       PreeditStartDialogCallback( ic, client_data, call_data );
       }

#if 0
    else if ( (old_len > 1) && (call_data->chg_length == old_len) &&
              (new_len == 0) )
        {
        /* HACK WARNING:  (to overcome a shortcoming in on-the-spot entry    */
        /*                 as implemented by the X Input Method)             */
        /* we went from something to nothing.  We imply that the user        */
        /*  'fixed' the active conversion zone.  Normally, this would        */
        /* result in a normal PreeditDraw which would cause the conversion   */
        /* string to be deleted, and then the same string is returned as     */
        /* the "real" string to AXLookupString() which causes the same string */
        /* to be re-inserted.  This results in a double reformat, and an odd */
        /* screen flash.  As a hack, since we know that the next thing       */
        /* coming to AXLooupString is this string, remember it here so we    */
        /* can ignore them there.                                            */
        main_w = w->parent;
        while ((main_w->parent != (AXWidget)NULL) && (main_w->type != W_MAIN))
          { main_w = main_w->parent; }

        ignore_window = main_w->window;
        ignore_bytes = old_len;
        PreeditDoneDialogCallback( ic, client_data, call_data );
        return;
        } 
#endif
    else if ( (old_len == 0) && (new_len == 0) )
        {
        /* reset only */
        return;
        }

    MakeNewXimBuffer( client_data->preedit_buf,
                      client_data->feedback,
                      call_data );

    new_len = Wstrlen( client_data->preedit_buf );

    if ( old_len > 0 )
        {
        /* we had some old string, so change it to the new string */
        main_w->conv_change_start = main_w->conversion_start;
        main_w->conv_change_end = main_w->conv_change_start + old_len;
        }
    else
        {
        /* no previous string, therefore no area to be changed       */
        main_w->conv_change_start = main_w->conv_change_end = -1;
        }

    /* set the highlight and underline positions */
    SetHighUnderline( client_data->feedback, new_len, 
                          &high_start, &high_end,
                          &under_start, &under_end );
    if ( high_start >= 0 )
        {
        main_w->conv_phrase_start = main_w->conversion_start + high_start;
        main_w->conv_phrase_end = main_w->conversion_start + high_end;
        }
    else
        main_w->conv_phrase_start = main_w->conv_phrase_end = -1;

    if ( under_start >= 0 )
        main_w->conversion_end = main_w->conversion_start + new_len - 1;
    else
        /* make end befroe start so no underline takes place */
        main_w->conversion_end = main_w->conversion_start - 1;

    /* put in the new text */
    if ( active_w->type == W_ENTER )
        {
        EntReplaceText( active_w, client_data->preedit_buf, new_len  );
        }
    else if ( active_w->type == W_EDITBOX )
        {
        ReplaceEntryText(  active_w, client_data->preedit_buf, new_len  );
        }
    else if ( active_w->type == W_TABLE )
        {
        TblReplaceText( active_w, client_data->preedit_buf, new_len  );
        }

    if ( new_len == 0 )
        {
        /* we cleared the conversion area, reset things */
        PreeditDoneDialogCallback( ic, client_data, call_data );
        }

    if ( active_w->callback && 
            ((active_w->type == W_EDITBOX) || (active_w->type == W_ENTER)) )
		(*active_w->callback)( active_w, active_w->callbacktag );

    return;
}






MakeNewXimBuffer( preedit_buf, feedback, call_data )
wchar *preedit_buf;
XIMFeedback *feedback;
XIMPreeditDrawCallbackStruct *call_data;
{
    wchar *srcP, *destP;
    XIMFeedback *dstfP, *srcfP;
    int area_len;
    int i;
    wchar wbuff[1000];
    mbchar *mbP, mbbuff[1000];
    int in_len;

    if ( call_data->chg_length > 0 )
        {
        /* we are to delete some characters */
        destP = preedit_buf + call_data->chg_first;
        dstfP = feedback + call_data->chg_first;

        srcP = destP + call_data->chg_length;
        srcfP = dstfP + call_data->chg_length;
        while( *srcP != 0 )
           { 
           *destP++ = *srcP++;
           *dstfP++ = *srcfP++;
           }
        *destP = 0;
        }

    wbuff[0] = (wchar)0;
    if ( call_data->text != (XIMText *)NULL )
        {
        if ( call_data->text->string.wide_char != NULL )
            {
            /* we have some text to add to the string */

            /* normalize to our notion of wide characters */
            mbP = (mbchar *)call_data->text->string.multi_byte;
            if ( call_data->text->encoding_is_wchar )
               {
               /* convert wide to mixed byte using the system function */
               /*  since we do not know whether "wide" from */
               /*  the system is 2 or 4 bytes                           */
               wcstombs( (char *)mbbuff, call_data->text->string.wide_char,
                                  call_data->text->length );
               mbP = mbbuff;
               }
            
            /* convert mixed-byte to our notion of 'wide' */
            MbToWStr( mbP, wbuff );
            in_len = Wstrlen( wbuff );

#if BUILD_KANJI && SUN4S
            /** HACK: The ATOK conversion server                           */
            /** puts a trailing underscore at the end of the               */
            /** conversion zone, which is then not reported to the         */
            /** AXLookupString.  This 'extra' character also greatly       */
            /** complicates things in the positioning of the input cursor */
            /** when an input conversion zone is 'fixed' since the character */
            /** was there, and then dissappears.   To simplify all of this,  */
            /** we hereby strip this character                               */
            if ( (call_data->chg_length > 0) || (in_len > 1) )
                {
                /* hack applies if we are changing some text, (pressing    */
                /* 'delete' causes a single underscore to be reported)     */
                /* or if there are at least 2 characters, since */
                /* unless there are 2 chars, there can not be an 'extra' one */
                if ( wbuff[in_len-1] == 0x5f )
                   {
                   /* there is a trailing underscore */
                   wbuff[in_len-1] = 0;      /* remove it */
                   in_len = in_len - 1;
                   }
                }
#endif

            /*-----------------------------------------*/
            /* make room for the new text and feedback */
            /*-----------------------------------------*/
            area_len = Wstrlen(preedit_buf);
            destP = preedit_buf + area_len + in_len;
            dstfP = feedback + area_len + in_len;
            srcP =  preedit_buf + area_len;
            srcfP = feedback + area_len;
            for ( i=0; i < in_len; i++ )
               { 
               *destP-- = *srcP--; 
               *dstfP-- = *srcfP--;
               }

            /* now put the new text and feedback array in place */
            destP = preedit_buf + call_data->chg_first;
            dstfP = feedback + call_data->chg_first;
            srcfP = call_data->text->feedback;
       
            srcP = wbuff;

            /* put the characters in our preedit buffer */
            for ( i=0; i < in_len; i++ )
               { 
#if BUILD_KANJI
               if ( *srcP < 127 )
                  {
                  /* the only time we see a character in the normal */
                  /* ascii range is when it is a narrow kana character */
                  /* so make it so in our internal encoding */
                  *srcP = *srcP | 0x8E00;
                  }
#endif
               *destP++ = *srcP++;
               *dstfP++ = *srcfP++;
               }
            
            }
        else
            {
            /* no text string, see if there is feedback info */
            if ( call_data->text->feedback != (XIMFeedback *)NULL )
               {
               /* we have some feedback info */
               dstfP = feedback + call_data->chg_first;
               srcfP = call_data->text->feedback;
               for ( i=0; i<(int)call_data->text->length; i++ )
                  {
                  *dstfP++ = *srcfP++;
                  }
               }
            }
        }
}


SetHighUnderline( feedP, area_len, 
                  high_start, high_end, under_start, under_end )
XIMFeedback *feedP;
int area_len;
int *high_start, *high_end, *under_start, *under_end;
{

    int i;
    *under_start = *under_end = -1;
    *high_start = *high_end = -1;

    for ( i=0; i<area_len; i++ )
        {
#if HYUNDAI && (SUN4 || SUN4S)
        /* The X11R5 input server returns the wrong bit set for highlight */
        /* so we hard-code the value here until this is corrected         */
        if ( (*feedP & 0x20) || (*feedP & XIMReverse) )
#else
        if ( (*feedP & XIMHighlight) || (*feedP & XIMReverse) )
#endif
           {
           if ( *high_start < 0 )
               {
               *high_start = i;
               *high_end = i;
               }
           else
               /* highlight continues */
               *high_end = i;
           }
        else if ( (*high_start >= 0) && (*high_end < 0) )
           {
           /* was on, now its off */
           *high_end = i;
           }

        if ( *feedP & XIMUnderline )
           {
           if ( *under_start < 0 )
               {
               *under_start = i;
               *under_end = i;
               }
           else
               /* underline continues */
               *under_end = i;
           }
        else if ( (*under_start >= 0) && (*under_end < 0) )
           {
           /* was on, now its off */
           *under_end = i;
           }
        feedP++;
        }
}





InitOnSpotInput( main_w )
AXWidget_main main_w;
{
    XIC new_ic;
    app_call_data *callback_data;
    
    if ( main_w == NULL )
       return( FALSE );

    if ( main_w->ic != (XIC)NULL )
        /* already initialized */
        return( TRUE );

    callback_data=(app_call_data *)malloc(sizeof(app_call_data));
    memset( (char *)callback_data, 0, sizeof(app_call_data));
    callback_data->task_pid = main_w->taskOwner;
    callback_data->xim_widget = main_w;

#if USE_XIM
     new_ic = AXCreateIC(main_w->window, (XPointer)callback_data,
                 (XIMProc)AppStartConversionMode,
                 (XIMProc)AppDoneConversionMode,
                 (XIMProc)AppDrawCallback,
                 (XIMProc)NoOpFunc,
                 (XIMProc)NoOpFunc,
                 (XIMProc)NoOpFunc,
                 (XIMProc)StatusCallback);
    if ( new_ic == (XIC)NULL )
       {
       /* can not create at this time */
       RingTheBell();
       free( (char *)callback_data );
       return( FALSE );
       }
 
    main_w->ic = new_ic;
    main_w->useOnSpot = TRUE;
#if SUN4 && !USE_XIM && BUILD_KANJI
    main_w->inWideInput = FALSE;
#else
    main_w->inWideInput = TRUE;
#endif
    main_w->callback_data = (mbchar *)callback_data;
#endif   /*  USE_XIM */


    return( TRUE );
}


/* user toggled conversion mode on */
AppStartConversionMode( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    conversion_data cnv_data;
  
#if HYUNDAI && (SUN4 || SUN4S)    /*  {  */
    int buff_len;

    buff_len = Wstrlen( client_data->preedit_buf );
    if ( buff_len > 0 )
        {
        /* there is some string in the preedit buffer.  This means that */
        /* the input was just terminated.  To make the X11R5 server match */
        /* the porcessing style of the Solaris and IBM RS6000 server, we */
        /* create a PreeditDraw callback call, which specifies a change */
        /* length of the entire area.  This allows the application to clear */+         /* the preedit text, before it receives the final input characters */
        /* as a result of the KeyPress event/XMbLookupString() call which */
        /* will be the next event received.                               */
        XIMPreeditDrawCallbackStruct call_data;
        memset( &call_data, 0, sizeof(call_data) );
        call_data.chg_length = buff_len;
        AppDrawCallback( ic, client_data, &call_data );
        }
#endif      /*  }  */
 

 
    cnv_data.command = XIM_START_CONV_MODE;
    cnv_data.ic = ic;
 
    /* clear our conversion buffer */
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );
    memset( &cnv_data, 0, sizeof(cnv_data) );
 
#if BUILD_KANJI || BUILD_CHINA
    /* default is to underline active input zone */
    cnv_data.under_start = 1;
#endif

    /* tell the application */
    AxSendMes( client_data->task_pid, &cnv_data, sizeof(cnv_data), 
                                                          APXIM_SERVER );
    return( XLS_BUF_LEN );
}

 
/* user toggled conversion mode off */
AppDoneConversionMode( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    conversion_data cnv_data;
 
#if HYUNDAI && (SUN4||SUN4S) /*  {  */
    int buff_len;

    buff_len = Wstrlen( client_data->preedit_buf );
    if ( buff_len > 0 )
        {
        /* there is some string in the preedit buffer. This means that      */
        /* the input was just terminated. To make the X11R5 server match    */
        /* the porcessing style of the Solaris and IBM RS6000 server, we    */
        /* create a PreeditDraw callback call, which specifies a change     */
        /* length of the entire area.  This allows the application to clear */
        /* the preedit text, before it receives the final input characters  */
        /* as a result of the KeyPress event/XMbLookupString() call which   */
        /* will be the next event received.                                 */
        XIMPreeditDrawCallbackStruct call_data;
        memset( &call_data, 0, sizeof(call_data) );
        call_data.chg_length = buff_len;
        AppDrawCallback( ic, client_data, &call_data );
        }
#endif      /*  }  */

    cnv_data.command = XIM_DONE_CONV_MODE;
    cnv_data.ic = ic;

 
    /* clear our conversion buffer */
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );
 
    /* tell the application */
    AxSendMes( client_data->task_pid, &cnv_data, sizeof(cnv_data), 
                                                          APXIM_SERVER );
    return( XLS_BUF_LEN );
}

 
 

 

/* This is called when the user actually starts entering a string in */
/*   conversion mode    */
AppStartCallback(  ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    conversion_data cnv_data;

    /* clear our conversion buffer */
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );
    memset( &cnv_data, 0, sizeof(cnv_data) );

    cnv_data.command = XIM_START_CONV;
    cnv_data.ic = ic;

#if BUILD_KOREAN
    /* we never use the underline attribute tin korean input */
    cnv_data.under_start = -1;
#endif


    /* tell the application */
    AxSendMes( client_data->task_pid, &cnv_data, sizeof(cnv_data), 
                                                          APXIM_SERVER );
    return;
}






#if 0    /*  {  */
/** called when a user 'fixes' an active conversion zone to make it real */
XIMProc AppDoneCallback(  ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XPointer call_data;
{
    conversion_data cnv_data;

    cnv_data.command = XIM_DONE_CONV;
    cnv_data.ic = ic;

    /* clear our conversion buffer */
    memset( client_data->preedit_buf, 0, sizeof(client_data->preedit_buf) );


    CallbackGlobalRetValue = TRUE;    /* we handled the key here */
    AxSendMes( client_data->task_pid, &cnv_data, sizeof(cnv_data), 
                                                                APXIM_SERVER );
    return;
}
#endif    /*  }  */




XIMProc AppDrawCallback( ic, client_data, call_data )
XIC ic;
app_call_data *client_data;
XIMPreeditDrawCallbackStruct *call_data;
{
    int under_start, under_end;
    int high_start, high_end;
    int i;
    int area_len;
    conversion_data *convP;
    int data_size;
    int new_len, old_len;


    /* The XIM input mechanism will hand us individual characters, */
    /* so we must keep around the entire pre-edit string here */
    old_len = Wstrlen( client_data->preedit_buf );
    new_len = 0;
    if ( call_data->text != (XIMText *)NULL )
       new_len = call_data->text->length;
 
    if ( (old_len == 0) && (new_len > 0) )
       {
       /* we went from no previous text --> some text, we regard this as the  */
       /*  "start" of a conversion session, so set the insertion point  */
       AppStartCallback( ic, client_data, call_data );
       }
    else if ( (old_len == 0) && (new_len == 0) )
        {
        /* reset only */
        return;
        }
 
    MakeNewXimBuffer( client_data->preedit_buf,
                      client_data->feedback,
                      call_data );
 
    new_len = Wstrlen( client_data->preedit_buf );
    
    /* set the highlight and underline positions */
    SetHighUnderline( client_data->feedback, new_len,
                          &high_start, &high_end,
                          &under_start, &under_end );


    /* put in the new text */
    data_size = sizeof(conversion_data) + ((new_len+1) * sizeof(wchar));
    convP = (conversion_data *)malloc( data_size );
    memset( (char *)convP, 0, data_size );
    convP->command = XIM_DRAW_CONV;
    convP->ic = ic;

    if ( old_len > 0 )
        {
        /* we delete the entire old string and replace it */
        convP->start_change = 0;
        convP->change_len =  old_len;
        }
    else
        {
        convP->start_change = convP->change_len = -1;
        }

    if ( high_start >= 0 )
        {
        convP->highlight_start = high_start;
        convP->highlight_end = high_end;
        }
    else
        convP->highlight_start = convP->highlight_end = -1;

    convP->under_start = under_start;
    convP->under_end = under_end;

    Wstrncpy( convP->wstr, client_data->preedit_buf, new_len );
    client_data->preedit_buf[new_len] = (wchar)0;

    AxSendMes( client_data->task_pid, convP, data_size, APXIM_SERVER );
    
    CallbackGlobalRetValue = TRUE;    /* we handled the key here */
    free( convP );
    return;
}



int typing_possible_into_widget( w )
AXWidget w;
{
    int first = TRUE;

    if ( w == (AXWidget)NULL )
       return( 0 );

    while ( w != (AXWidget)NULL )
       {
       if ( (w->type == W_ENTER) || (w->type == W_WORK) ||
            (w->type == W_EDITBOX) || (w->type == W_TABLE) ||
            (w->type == W_ROWCOL) || (w->type == W_COMBO_BOX) )
           {
           if ( (w->type == W_EDITBOX && !((AXWidget_editbox)w)->no_picks) || !w->disabled )
               return( 1 );    /* this is a field into which user can type */
           }
       if ( first )
           {
           w = w->widgets;
           first = FALSE;
           }
       else
           w = w->nextChild;
       }
    return( 0 );
}




         



/** find the widget into which the Asian input should be placed */

AXWidget FindActiveAsianWidget( w_dialog )
AXWidget_dialog w_dialog;
{
    register AXWidget wP;

    if (w_dialog == NULL) 
        return (NULL);

    /* check for an active text edit or entry box or table */
    for (wP = w_dialog->widgets; wP != NULL; wP = wP->nextChild)
        {
#if 0
        if ( (wP->type == W_ENTER) && !(wP->disabled) &&
            ((((AXWidget_entry)wP)->curPos != -1) || (wP->pending_delete)))
            return( wP );
#else
        if ( (wP->type == W_ENTER) && !(wP->disabled) && (wP->hasFocus) )
            return( wP );
#endif
        else if ((wP->type == W_EDITBOX) && (wP->hasFocus))
            return( wP );
        else if ( (wP->type == W_TABLE) && (wP->hasFocus) )
            return( wP );
        }

    return (NULL);
}







#endif              /**         } BUILD_ORIENT **/



