/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: menuglob.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:41 1998
*/
#include <stdio.h>
#include <ctype.h>
#include <aos.h>
#include <getstr13.h>
#include <amenudef.h>

selects_desc *ElfWinSelections;	/* Root of list for all windows */

/*************************************************************************
function: MenuGlob - Glom all menu info into a single storage block
Needed by Elf bltin, here to get TRUE rather than task malloc!
*/
menu_item_def *MenuGlob (menuP,count,size)
register menu_item_def *menuP;	/* orginally malloced menu info */
register int count;				/* how many 1st level elements here */
register int size;				/* original malloc size of menuP */
{
	register int strsize = 0,	/* of strings database */
				ix;
	register menu_item_def *mP;
	register char *strP;

/* compute how much storage is needed for strings */

	for ( ix = 0, mP = menuP+1; ix < count; ix++,mP++ ) {
		strsize += strlen(mP->word) + 1;	/* include trailing null */
		if ( mP->type == ITEM_FUNC ) {
			strsize += strlen(mP->word2) + 1;	/* include trailing null */
			strsize += strlen(mP->bitmap) + 1;	/* include trailing null */
			strsize += strlen(mP->toolword) + 1;/* include trailing null */
		}
        if ( mP->menu_key_str != (unsigned char *)NULL )
            strsize += MBstrlen(mP->menu_key_str) + 1;
	}

/* realloc to get strs in memory at the menu place, copy strs in */

	menuP = (menu_item_def *)realloc(menuP,size+strsize);
	strP = (char*)menuP + size;
	for ( ix = 0, mP = menuP+1; ix < count; ix++,mP++ ) {
		strcpy(strP,mP->word);
		mP->word = strP;
		strP += strlen(strP) + 1;	/* include trailing null */
		if ( mP->type == ITEM_FUNC ) {
			strcpy(strP,mP->word2);
			mP->word2 = strP;
			strP += strlen(mP->word2) + 1;	/* include trailing null */
			strcpy(strP,mP->bitmap);
			mP->bitmap = strP;
			strP += strlen(mP->bitmap) + 1;	/* include trailing null */
			strcpy(strP,mP->toolword);
			mP->toolword = strP;
			strP += strlen(mP->toolword) + 1;	/* include trailing null */
		}
        if ( mP->menu_key_str != (unsigned char *)NULL )
           {
           MBstrcpy(strP,mP->menu_key_str);
           mP->menu_key_str = strP;
           strP += MBstrlen(mP->menu_key_str) + 1;
           }
	}
	return(menuP);
}

