/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: mincom.h
   Applix ASC version: 2
   Date: Mon Nov 16 13:53:34 1998
*/
#define SIGAIO	SIGUSR1

#define FOREIGN		0		/* non-VENIX compilation? */
#define MINECHO		1		/* echo from MIN rather than ATM? */

/* note MINDR build always defines IBM, even if FOREIGN */ 

/* shared memory addresses */


/* shared memory structure */

#if X386 && IBM_EGA && COLOR
#define KERNEL_MOUSE
#endif

#ifdef KERNEL_MOUSE

#define RB_SIZE		16		/* ring buffer size (must be 2**n) */
#define RB_MOD		15		/* mask for mod RB_SIZE */

typedef struct {
	int sigpid;		/* ATM's PID to signal */
	int atmlock;	/* ATM is diddling w/ cursor */
	int mctype;		/* cursor type to display */
	AxRectangle lockrect;	/* forbidden rectangle */
	int xpix;		/* current mouse position */
	int ypix;
	int nextin;		/* ring buffer maintenance */
	int nextout;
	struct {
		int swstat;		/* switch status bits */
		int ev_xpix;	/* switch transition location */
		int ev_ypix;
	} ev[RB_SIZE];		/* several of these */
#if X386 && IBM_EGA && COLOR
	int minlock, alisMouse;
	int xmouse, ymouse;
#else
	int i_am_even;		/* TRUE only in the even scan lines buffer */
	int extra[9];		/* extra storage, if needed (WYSE) */
#endif
} ShStruct;

#else	/* #ifdef KERNEL_MOUSE $else */

#define RB_SIZE		8		/* ring buffer size (must be 2**n) */
#define RB_MOD		7		/* mask for mod RB_SIZE */

typedef struct {
	int sigpid;		/* PID to signal: set by ATM, cleared by MINDR */
	int atmlock;	/* ATM is requesting exclusive use of cursor */
	int minlock;	/* MIN is requesting exclusive use of cursor */
	int mctype;		/* mouse cursor type */
	AxRectangle lockrect;	/* forbidden rectangle */

	/* current mouse position */

	int xmil;
	int ymil;
	int xpix;
	int ypix;

	/* button event queue (ring buffer) */

	int nextin;			/* ring buffer input pointer (subscript) */
	int nextout;		/* ring buffer output pointer (subscript) */
	struct {
		int swstat;		/* switch status bits */

		/* mouse position at time of event */

		int ev_xmil;
		int ev_ymil;
		int ev_xpix;
		int ev_ypix;
	}  ev[RB_SIZE];
} ShStruct;

#endif	/* #else #if KERNEL_MOUSE */


#ifdef KERNEL_QIN

/* Kernel QIN stuff */

/* shared memory addresses */
/* 200 must be > sizeof (ShStruct) ; (usually) follows MIN comm. area */


#define QRB_SIZE	128		/* ring buffer size (must be 2**n) */
#define QRB_MOD		127		/* mask for mod QRB_SIZE */

typedef struct {
	int sigpid;
	int nextin;
	int nextout;
	char ev[QRB_SIZE];
} ShqStruct;

#endif
