/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: paratmin.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:53:35 1998
*/
#if !THIMBLE
/* TmGetEvent returning Elf message */

#define MAX_ELF_DATA (1020 - sizeof(struct RGetEventData))

    struct RElfEventData {          /* Elf info appended to GetEvent data */
        struct RGetEventData event;
        char data[MAX_ELF_DATA];
    };
#endif

/*
 * NOTICE: must change the 1020 if SEN_BUF_SIZE (or IPCBUFSIZE) changes!!!
*/

/*
 * old version (without direct i/o client addition)
 */
    struct oRGetEventData
    {
        char filler1[IPC_HEAD_LEN];

        short status;
        short pack_len;
        short window_id;
        short td_type;
        short td_len;
        union TmTermData td;
        struct TmGEflags flags;
        short cursor_pos;
        short cur_pos;
        short cut_point;
        short scroll_state;
        short event_type;
        short str_len;
        short attrSlen; /* lenght of attr_string in no of chars */
    };

/* TmReset */

    struct SResetData
    {
        char filler1[IPC_HEAD_LEN];

        short event_indicator;
        short pack_len;
        char filler[4];

        short window_id;
        DeviceIds device_ids;
    };

/* TmInitPick */

    struct SInitPickData
    {
        char filler1[IPC_HEAD_LEN];

        short event_indicator;
        short pack_len;
        char filler[4];

        short window_id;
        struct TmPickTrigger p_trig;
        short time_out;
    };

/* TmIStroke */

    struct SIStrokeData
    {
        char filler1[IPC_HEAD_LEN];

        short event_indicator;
        short pack_len;
        char filler[4];

        short window_id;
        struct TmStkTrigger s_trig;
        short time_out;
    };

/* TmHomeLine */

    struct ShlData
    {
        char filler[IPC_HEAD_LEN];
        short event_indicator;

        short window_id;
        struct TmHLpacket hlPack;
    };

/* TmStRegen */

    struct SStRegenData
    {
        char filler[IPC_HEAD_LEN];

        short event_indicator;  /* must be in this position */
        short window_id;
    };

/* TmAckKey */

	struct SakyData
	{
        char filler[IPC_HEAD_LEN];
        short event_indicator;

		short window_id;
		short logkey;
	};

/* TmSync */

    struct  SyncData
    {
        char    filler[IPC_HEAD_LEN];
        short   event_indicator;        /* currently unused */
        short   window_id;              /* currently unused */
    };

/* TmXfer */

    struct  SxferControlData
    {
        char filler1[IPC_HEAD_LEN];

        short       event_indicator;
        short       pack_len;
        char        filler[4];

        short       xfer_type;
        short       xfer_flags;
        short       mous_x;
        short       mous_y;
    };
