/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: parattr.h
   Applix ASC version: 3
   Date: Sat Jan 23 21:14:20 1999
*/

/* TmInq */

	struct SInqData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		short window_id;
		char filler[2];
	};

	struct RInqData
	{
		char filler1[IPC_HEAD_LEN];

		short x_position;
		short y_position;
		short x_size;
		short y_size;
		int h_sc_pos;
		int v_sc_pos;
		short curtype;
		short x_cur_pos;
		short y_cur_pos;
	};

/* TmDchar */

	struct SDcharData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		short pSetup;	/* print set-up device */
		char filler[2];
	};

	struct RDcharData
	{
		char filler1[IPC_HEAD_LEN];

		short h_desktop;
		short w_desktop;
		short d_height;
		short d_width;
		struct TmFeatures features;
		short status;
	};

/* TmDcursor */

	struct SDcursorData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		short text_overtype;
		short mouse_type;
		short mouse_state;
		short x_cur_pos;
		short y_cur_pos;
	};

	struct RDcursorData
	{
		char filler1[IPC_HEAD_LEN];

		short status;
	};

/* TmInqAttr */

/* TmSetWinAttr */

	struct SSetWinData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		short x_cur_pos;
		short y_cur_pos;
		TmLineDescriptor lin_des;
		TmTextDescriptor write_tx_des;
		TmTextDescriptor read_tx_des;
		short trans_mode;
		TmRect cliprect;
		short txAlign;
		short fg_color;
		short bg_color;
	};

/* TmSetImageTextMode */

	struct SSetImgTxtMode
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		short on;
		int zoomFactor;
		int targetSetup;
		TmPoint32 imageBox[4];
	};

/* TmSetDevAttr */

/* TmSetSpWid */

	struct SSetSpWidData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		short spWid;
	};

/* TmAlterTxExtent */

	struct SAlterTxExtentData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short window_id;
		short spCount;
		short totalChange;
	};

/* TmInqTxExtent */

	struct SInqTxExtData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short pack_len;
		char filler[4];

		short byte_count;
		short pSetup;
		short limit;
		short sp_width;
		short extent3;
		short attrSlen;
		TmTextDescriptor defAttr;
				/* char string[]; */
				/* attr_string */
	};

	struct RInqTxExtData
	{
		char filler1[IPC_HEAD_LEN];

		short space_count;
		short cut_pt1;
		short cut_pt2;
		short extent1;
		short extent2;
		short extent3;
		short str_status;
		short maxHeight;
		short maxAboveLine;
		short minHeight;
		short minAboveLine;
		short status;
	};

/* TmSetTabStops */

	struct StabsData
	{
		char filler1[IPC_HEAD_LEN];

		short event_indicator;
		short winID;
		short numTabs;
		short showGlyph;
		short decimalChar;
	};
