/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: setpxval.c
   Applix ASC version: 5
   Date: Mon Nov 16 13:53:42 1998
*/
#ifndef MIN
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#endif
/****************************************************************************
 *
 * module:	B i t S p i n
 */
unsigned char 
BitSpin(x)
unsigned char x;
{
    unsigned char y = 0;

    y |= (x & 1) << 7;
    y |= (x & 2) << 5;
    y |= (x & 4) << 3;
    y |= (x & 8) << 1;
    y |= (unsigned char)(x & 16) >> 1;
    y |= (unsigned char)(x & 32) >> 3;
    y |= (unsigned char)(x & 64) >> 5;
    y |= (unsigned char)(x & 128) >> 7;
    return(y);
}
/****************************************************************************
 */
AxSet125PixVal(destPix, invert, red, green, blue, max_div_by_16, initialize)
char *destPix;
int invert, red, green, blue, max_div_by_16, initialize;
{
	static int one_sixteenth, invertImage;
	int tempColor;

	if(initialize)
	{
		one_sixteenth = max_div_by_16;
		invertImage = invert;
	}
	else
	{
		if(invertImage)
		{
			/* red */
			tempColor = 2 * red / one_sixteenth;
			if(tempColor < 4)
				*destPix = 100;
			else if(tempColor < 12)
				*destPix = 75;
			else if(tempColor < 19)
				*destPix = 50;
			else if(tempColor < 26)
				*destPix = 25;
			else
				*destPix = 0;
			/* green */
			tempColor = 2 * green / one_sixteenth;
			if(tempColor < 4)
				*destPix += 20;
			else if(tempColor < 12)
				*destPix += 15;
			else if(tempColor < 19)
				*destPix += 10;
			else if(tempColor < 26)
				*destPix += 5;
			else
				*destPix += 0;
			/* blue */
			tempColor = 2 * blue / one_sixteenth;
			if(tempColor < 4)
				*destPix += 4;
			else if(tempColor < 12)
				*destPix += 3;
			else if(tempColor < 19)
				*destPix += 2;
			else if(tempColor < 26)
				*destPix += 1;
			else
				*destPix += 0;
		}
		else
		{
			/* red */
			tempColor = 2 * red / one_sixteenth;
			if(tempColor < 5) /* 4 */
				*destPix = 0;
			else if(tempColor < 12)
				*destPix = 25;
			else if(tempColor < 19)
				*destPix = 50;
			else if(tempColor < 26)
				*destPix = 75;
			else
				*destPix = 100;
			/* green */
			tempColor = 2 * green / one_sixteenth;
			if(tempColor < 5)
				*destPix += 0;
			else if(tempColor < 12)
				*destPix += 5;
			else if(tempColor < 19)
				*destPix += 10;
			else if(tempColor < 26)
				*destPix += 15;
			else
				*destPix += 20;
			/* blue */
			tempColor = 2 * blue / one_sixteenth;
			if(tempColor < 5)
				*destPix += 0;
			else if(tempColor < 12)
				*destPix += 1;
			else if(tempColor < 19)
				*destPix += 2;
			else if(tempColor < 26)
				*destPix += 3;
			else
				*destPix += 4;
		}
	}
}

/****************************************************************************
 *
 * module: rgb2cmyk
 */
rgb2cmyk(r,g,b,c,m,y,k,shiftVal)
int r,g,b,*c,*m,*y,*k,shiftVal;
{
	if (shiftVal == 8)
	{ r=r>>8; g=g>>8; b=b>>8; }

	*c = (~r) & 0xFF;
	*m = (~g) & 0xFF;
	*y = (~b) & 0xFF;
	*k =  MIN (MIN (*c, *m), *y);

#if LATER1
	*k =  (*k > 128) ? (*k - 128) : 0;
#endif

	*c = (*c)-(*k); *m = (*m)-(*k); *y = (*y)-(*k);

#if LATER2
	*y = *y - (48 * (*m) / 100);
	*m = *m - (31 * (*c) / 100);
	*k = (*k) * 125 / 100;
#endif
}

/****************************************************************************
 *
 * module: cmyk2rgb
 */
cmyk2rgb(c,m,y,k,r,g,b)
int c,m,y,k,*r,*g,*b;
{
	*r  = 255 - MIN (255, c+k);
	*g  = 255 - MIN (255, m+k);
	*b  = 255 - MIN (255, y+k);
}
