/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmout.c
   Applix ASC version: 56
   Date: Tue Apr  6 21:51:29 1999
*/
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#if RIOS /* _BSD : math.h won't include stdlib.h (redefs malloc and free) */
#define _BSD
#endif
#include <math.h>
#include <aos.h>
#include <tmi.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parout.h>
#include <parint.h>
#include <bounds.h>
#include <scac.h>
#include <getstr13.h>
#include <laytext.h>
#include <devsetup.h>
#include <axtext.h>
#include <basicwin.h>

struct wind_struct *SetWp();
void atmBblt();

extern short ColorDisplay;
extern Display *Dpy;
Drawable HostWin;
extern int FGpixel, BGpixel;
int halftoneMode;

#if (AVT_G && MULT_FONT)
extern short gfi;
#endif

/* AX_BOOLEAN has been #defined to int in aos.h */
#ifdef AX_BOOLEAN
#undef AX_BOOLEAN
#endif

typedef int AX_BOOLEAN;

extern short Xmpc, Ympc;    /* mils per cell */
extern int FontVOffset;
extern struct fieldInfo *FieldInfo;
extern short AppPlayback;
extern GC Gc1;
A_Bitmap *A_Display;

#if COLOR
extern short BGcolor, FGcolor;

/****************************************************************/

/* copied from color.c */
#define DEFAULT_BG  0
#define DEFAULT_FG  1
#define FILL_COLOR 0
#define LINE_COLOR 1

void setColors()
{
    BGcolor = Wp->bgcolor;
    if (BGcolor == TMA_DEF)
        BGcolor = DEFAULT_BG;

    FGcolor = Wp->fgcolor;
    if (FGcolor == TMA_DEF)
        FGcolor = DEFAULT_FG;

    WMsetColors(FGcolor, BGcolor);
}
 
void setTColors(fattr, rflag, hilite)
TmTextDescriptor fattr;
int rflag, hilite;
{
    TmTextDescriptor tx_des;

    BGcolor = Wp->bgcolor;
    if (BGcolor == TMA_DEF)
        BGcolor = DEFAULT_BG;

    FGcolor = (fattr >> TMFPCOLOR) & TMFMCOLOR;
    if (FGcolor == TMA_DEF)
    {
        tx_des = rflag ? Wp->read_tx_des : Wp->write_tx_des;
        FGcolor = (tx_des >> TMFPCOLOR) & TMFMCOLOR;
        if (FGcolor == TMA_DEF)
            FGcolor = Wp->fgcolor;
        if (FGcolor == TMA_DEF)
            FGcolor = DEFAULT_FG;
    }

    /* select complementary colors (for hilighted color field reads) */
    if (hilite)
    {
        BGcolor ^= 1;
        FGcolor ^= 1;
    }

    WMsetColors(FGcolor, BGcolor);
}

void systemColors() /* black on white */
{
    BGcolor = DEFAULT_BG;
    FGcolor = DEFAULT_FG;
    WMsetColors(FGcolor, BGcolor);
}

void cmykSystemColors() /* black on white */
{
    if ( ColorDisplay )
    {
#if 0   /* babu */
        AxGetColormapIndex(2, 0,0,0,255, 255, &fg);
        FGcolor = fg + 16;

        AxGetColormapIndex(2, 0,0,0,0,   255, &bg);
        BGcolor = bg + 16;
#endif
        BGcolor = DEFAULT_BG;
        FGcolor = DEFAULT_FG;
    }
    else
    {
        BGcolor = DEFAULT_BG;
        FGcolor = DEFAULT_FG;
    }
    WMsetColors(FGcolor, BGcolor);
}

#endif  /* #if COLOR */


/****************************************************************/
/*
 * TmPolymarker function
 *
 *          - not implemented -
 */
void atm_pmark(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;
{
    union
    {
        struct
        {
            struct SPMarkData pmark_data;
            TmPoint points[TM_POINT_MAX];
        } pack;
        char rec_buf[REC_BUF_SIZE];
    } rec_pack;

    ATMmesMov(mes, rec_pack.rec_buf, mesLen, REC_BUF_SIZE, flag);

#if CHECK
    PCkPMark(rec_pack.rec_buf);
#endif
}

/*****************************************************************
 *
 * TmPolyline function for display
 */
void 
ax_tm_pline(w, nPolys, attr, polygon, clip, clip_info)
long w; 
int nPolys;
attr_type *attr;
poly_type *polygon;
TmRect32 *clip;
clip_path *clip_info;
{
    int *nPoints, *nClosedPts, i, junk=0;
    TmPoint32 **points;

    /* allocate space for the list of polygons */
    points  = (TmPoint32 **)malloc(nPolys * sizeof(TmPoint32 **));
    nPoints = (int *)malloc(nPolys * sizeof(int *));
    nClosedPts = (int *)malloc(nPolys * sizeof(int *));

    /* decompose the polys, also converting them from mills to screen pels */
    convertPols(nPolys, polygon, nPoints, points, TRUE);

    /* transform the line width from mills to screen pels */
    if ( attr->l_wid > 1 )
    {
        milPix32(&attr->l_wid, &junk);
        if ( attr->l_wid < 1 )
            attr->l_wid = 1;
    }
    else if ( attr->l_wid < 0 )
        attr->l_wid = 0;

    /* is the line drawn first? */
    if ( attr->line_first && attr->l_wid > 2 )
    {
        /* for each poly... */
        for ( i=0; i<nPolys; i++ )
            AxDrawPoly(w, nPoints[i], points[i], attr, clip, clip_info);
    }
 
    /* ...fill the shape... */
    AxFillPoly(w, nPolys, nPoints, points, attr, clip, clip_info);

    /* is the line drawn after? */
    if ( attr->line_first == FALSE || attr->l_wid < 3 )
    {
        /* for each poly... */
        for ( i=0; i<nPolys; i++ )
            AxDrawPoly(w, nPoints[i], points[i], attr, clip, clip_info);
    }

    /* free any allocated space */
    for(i=0; i<nPolys; i++)
        free(points[i]);
    free(points);
    free(nPoints);
    free(nClosedPts);
}

/*****************************************************************
 *
 * old TmPolyline function for display
 */
void atm_pline(mes, mesLen, flag) /* old TmPolyline function */
char *mes;
short mesLen;
short flag;
{
}

/*****************************************************************
 *
 * TmArc function for display
 */
int 
ax_tm_arc(wID, bound_box, start_angle, arc_angle, attr, clip)
int wID;
TmRect32 *bound_box;
int start_angle;
int arc_angle;
attr_type *attr;
TmRect32 *clip;
{
    typeErr status;
    poly_type polygon;
    TmPoint32 points[65];

    SetWp(&window[wID]);

    /* reduce the arc to a polyline */
    polygon.nPoints = ellipse(bound_box, start_angle, arc_angle, points);

    /* if fill not requested, clip out center point (no wedge) */
    if ( arc_angle < 3600 && !attr->fill_flag )
    {
        polygon.points = &points[1];
        polygon.nPoints -= 2;
    }
    else
        polygon.points = points;

    /* disable bezier controls */
    polygon.nCtrls   = 0;
    polygon.controls = (TmPoint32 *)NULL;

    /* draw the polyline */
    ax_tm_pline(wID, 1, attr, &polygon, clip);

    /* restore the default colors */
    systemColors();
    return ( AOK );
}
/*****************************************************************
 *
 * old TmArc function for display
 */
void atm_Arc(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;
{
}
/****************************************************************/


/*****************************************************************
 *
 * TmFillRect function
 */
void ax_tm_fillrect(w, in_mils, x, y, wid, hyt, mode,
					pat, cmap, c1, c2, x0, y0, clip)
long w;
int  in_mils, x, y, wid, hyt, mode, pat;
cmap_type *cmap;
int c1, c2, x0, y0;
TmRect32 *clip;
{
    /* use the clip set by the caller */

    /* convert the rectangle and the fill origin */ 
    if ( in_mils )
    {
        wid += x;
        hyt += y;
        conv_i_p32(&x, &wid, &x, &wid, MILLS_TO_PIXEL);
        conv_i_p32(&y, &hyt, &y, &hyt, MILLS_TO_PIXEL);
        wid -= x;
        hyt -= y;
        conv_i_p32(&x0,&y0, &x0,&y0, MILLS_TO_PIXEL);
    }
 
    /* fill the rectangle */
    AxFillrect(w, x,y,wid,hyt, mode, pat, cmap,c1,c2, x0,y0, clip);
}

/****************************************************************/
/*
 * TmBblt function
 */
void atm_bblt(mes, mesLen, flag)
char *mes;
short mesLen;
short flag;
{
    union
    {
        struct SBbltData bblt_data;
        char rec_buf[sizeof(struct SBbltData)];
    } rec_pack;

    struct TmBbltStruct *bbPack;
    AX_BOOLEAN noSource;           /* bitblt mode does not use a source */
    short *shp;                 /* for logging */

    ATMmesMov(mes, rec_pack.rec_buf, mesLen, sizeof(struct SBbltData), flag);

    bbPack = &rec_pack.bblt_data.bblt_pack;
    shp = (short *)bbPack;
    if (AppPlayback) bbPack->window_id = Wp->window_id;

    /* perform function only if own window and not discarding output */

    if ( getOwnWin(bbPack->window_id) && !Wp->regenWait &&
                                    !(Wp->gRegenWait && Wp->g_mod_flag) )
    {

    if (Wp->recording) mesRec(rec_pack.rec_buf, mesLen, flag);
    if ( Wp->wind_attr.modifiers.gr_window || Wp->g_mod_flag )
    {
        /*
         * not supported in remote graphics until mixed cell and pixel
         * coordinate situation has been cleaned up
         *
         * request application regen; clear, send as field read input
         */
        regenEvent(TRUE, FALSE);
        return;
    }
    /*
     * if bitblt transfer function is one in which the result
     * is independent of the source, source need never be accessed
     */
    noSource = (AX_BOOLEAN) ( (bbPack->rule >> 2) == (bbPack->rule & 3) );
    if (noSource)
    {
        /* set source = dest for clipping calculations */

        bbPack->x_source = bbPack->x_destination;
        bbPack->y_source = bbPack->y_destination;
        if(bbPack->halftone)
            halftoneMode = bbPack->halftone;
        else
            halftoneMode = 0;
    }

    setColors();

    if (Wp->layer->obs == NULL)         /* fully visible window */
    {
        atmBblt(bbPack, FALSE);         /* not in pixels */
    }
    else if (noSource)
    {
        AxRectangle rClip, rDest;
        /*
         * character mode output not deferred in this path
         * because window not active
         */

        /* compute destination rectangle */

        ccRect(Wp, FALSE,               /* not in pixels */
            bbPack->x_destination,
            bbPack->y_destination,
            bbPack->x_dest_len,
            bbPack->y_dest_len,
            &rDest);

        /* compute clipping rectangle */

        ccRect(Wp, FALSE,               /* not in pixels */
                bbPack->x_clip,
                bbPack->y_clip,
                bbPack->x_clip_len,
                bbPack->y_clip_len,
                &rClip);

        /* compute clipped destination rectangle */

        if (!sectRect(&rClip, &rDest, &rDest)) return;

        lrectf(Wp->layer, &rDest, bbPack->rule);
    }  /* bitblt with no source */
    else        /* cannot do bitblt - request regen instead */
    {
        /* request application regen; clear, send as field read input */
        regenEvent(TRUE, FALSE);
    }
    systemColors();
    }  /* own window and not discarding output */
}
/*
 * atmBblt -- internally callable TmBblt function
 */
void atmBblt(bbPack, inPixels)
    struct TmBbltStruct *bbPack;
    int inPixels;
{
    AxRectangle rSource, bbSource;
    AxRectangle rDest;
    AxRectangle rClip;
    AxRectangle rClipped;
    AxRectangle *winClip;

    /* compute sources rectangle */

    ccRect(Wp, inPixels,
            bbPack->x_source,
            bbPack->y_source,
            bbPack->x_dest_len,
            bbPack->y_dest_len,
            &rSource);

    /* compute destination rectangle */

    ccRect(Wp, inPixels,
        bbPack->x_destination,
        bbPack->y_destination,
        bbPack->x_dest_len,
        bbPack->y_dest_len,
        &rDest);

    /* compute clipping rectangle */

    ccRect(Wp, inPixels,
            bbPack->x_clip,
            bbPack->y_clip,
            bbPack->x_clip_len,
            bbPack->y_clip_len,
            &rClip);

    /* clip destination rectangle to atmBblt clipping rectangle */

    if (!sectRect(&rClip, &rDest, &rClipped)) return;

    /* further clip destination to window clipping rectangle */

    if (!sectRect(&Wp->layer->curClip, &rClipped, &rClipped)) return;

    /* compute the actual source rectangle from the clipped destination */

    rSource.origin.x += (rClipped.origin.x - rDest.origin.x);
    rSource.origin.y += (rClipped.origin.y - rDest.origin.y);
    rSource.corner.x += (rClipped.corner.x - rDest.corner.x);
    rSource.corner.y += (rClipped.corner.y - rDest.corner.y);

    /*
     * clip source to window (producing bbSource),
     * reflect result in destination (rClipped)
     */
    if (Wp->layer == NULL)
        winClip = &Wp->inner;
    else
        winClip = &Wp->layer->curClip;

    if (!sectRect(winClip, &rSource, &bbSource)) return;
    rClipped.origin.x += bbSource.origin.x - rSource.origin.x;
    rClipped.origin.y += bbSource.origin.y - rSource.origin.y;
    rClipped.corner.x += bbSource.corner.x - rSource.corner.x;
    rClipped.corner.y += bbSource.corner.y - rSource.corner.y;

    /* do bitblitting */

    ATMbitblt(A_Display, &bbSource, A_Display, &rClipped.origin,
                bbPack->rule, bbPack->halftone,
                Wp->layer->mixed || Wp->wind_attr.modifiers.gr_window);
}  /* atmBblt() */
/****************************************************************/

/****************************************************************/
/*
 * TmBeep
 */

void atm_beep(mes, mesLen, flag)
    char *mes;
    short mesLen;
    short flag;
{
    union
    {
        struct SbeepData d;
        char buf[sizeof(struct SbeepData)];
    } mm;

    /* get message so logging is done */

    ATMmesMov(mes, mm.buf, mesLen, sizeof(mm.d), flag);

}

/*
 *
 */
void getWinColorsFromLayer(lp, fgp, bgp)
Layer *lp;      /* in  */
int *fgp, *bgp; /* out */
{
 *fgp = window[lp->window_id].fgcolor;
 *bgp = window[lp->window_id].bgcolor;
}

int 
AxCheckImageTx(wID, xp, yp, lenp, text)
short wID; /* in */
int *xp, *yp, *lenp;    /* out; optionally modified */
char **text;            /* out; optionally modified */
{
    return 0; /* OBSOLETE */
}

/*
 * Defined as "bad" if any point coincides
 * with any other. Note "not bad" doesn't
 * necessarily mean good..  Really aimed at
 * the zero-area imageBox.
 */
#define SAMEPT(p1, p2) (p1->x == p2->x && p1->y == p2->y)
int
badImageBox(pts)
TmPoint32 *pts; /* there's four in array */
{
    TmPoint32 *p1, *p2;
    int i1, i2, numleft;

    p1 = &pts[0];
    p2 = &pts[1];
    numleft = 3;
    for(i1=0; i1<3; i1++) {
        for(i2=0; i2<numleft; i2++) {
            if (SAMEPT(p1, p2))
                return(TRUE);
            p2++;
        }
        numleft--;
        p1++;
        p2 = p1+1;
    }
    return(FALSE);
}

void findMinMax(pt, numPoints, minx, miny, maxx, maxy)
TmPoint32 *pt; /* we hope there's at least numPoints many */
int numPoints;
int *minx, *miny, *maxx, *maxy;
{
    int i;

    *minx = *maxx = pt[0].x;
    *miny = *maxy = pt[0].y;
    for (i=1; i<numPoints; i++) {
        if (pt[i].x > *maxx)
            *maxx = pt[i].x;
        else if (pt[i].x <= *minx)
            *minx = pt[i].x;
        if (pt[i].y > *maxy)
            *maxy = pt[i].y;
        else if (pt[i].y <= *miny)
            *miny = pt[i].y;
    }
}

/* de-rotate */
void scaleInvR(srcx, srcy, dstxp, dstyp, cosAng, sinAng)
int srcx, srcy, *dstxp, *dstyp;
double cosAng, sinAng;
{
    *dstxp = (int)(srcx * cosAng + srcy * sinAng);
    *dstyp = (int)(srcy * cosAng - srcx * sinAng);
}


/* ------------ */
XRectangle *
getxrect(ox, oy, xsiz, ysiz)
int ox, oy, xsiz, ysiz;
{
	int orgx, orgy, corsizx, corsizy;
	XRectangle *rp;

	orgx = ox;
	orgy = oy;
	corsizx = xsiz;
	corsizy = ysiz;
	corsizx += orgx;
	corsizy += orgy;

	conv_i_p32(&orgx, &orgy, &orgx, &orgy, MILLS_TO_PIXEL);
	conv_i_p32(&corsizx, &corsizy, &corsizx, &corsizy,MILLS_TO_PIXEL);

	rp = (XRectangle *)malloc(sizeof(XRectangle));
	rp->x = orgx;
	rp->y = orgy;

	rp->width = corsizx;
	rp->height = corsizy;

	return(rp);
}
