/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmsysev.c
   Applix ASC version: 18
   Date: Mon Nov 16 13:53:46 1998
*/
#define TM_NO_PTR_INPUTS_MASK KeyPressMask | KeyReleaseMask | \
        ResizeRedirectMask | FocusChangeMask | SubstructureNotifyMask | \
        StructureNotifyMask | ButtonPressMask | ButtonReleaseMask | \
        ButtonMotionMask | ExposureMask | LeaveWindowMask | EnterWindowMask

/* input mask for work area window - includes pointer motion mask */
#define TM_PTR_INPUTS_MASK (TM_NO_PTR_INPUTS_MASK | PointerMotionMask)
#define APPLIX_WIDGETS 1
#define NEED_X_INFO 1

#if 0
#include <X11/Shell.h>
#include <X11/keysym.h>
#include <X11/Xproto.h>

#include <string.h>
#include <dwt2xm.h>
#include <aos.h>
#include <ax_xm.h>
#else
#include <basicwin.h>
#include <aos.h>
#endif

#include <xmlib.h>
#include <axtime.h>
#include <setjmp.h>

#include <paripc.h>
#include <scac.h>
#include <tmi.h>
#include <paratm.h>
#include <parint.h>
#include <paratmgr.h>
#include <paramin.h>
#include <elhelper.h>
#include <aiconids.h>
#if X386_NEW
#define MAXPATHLEN 1024 /* JJM */
#endif
#include <laytext.h>
#include <axtext.h>
#include <infobox.h>

extern short ElfHasStatusMessageDisplayed; /* TRUE if there is a status message */
extern int PrintXWarnings; /* set in xmlibcom.c */
extern Window AxXtWindow();
extern int ThimbleSaysToReturnNow; /* hack for breaking out of XtAppNextEvent */
extern long AxPulldownActive;   /* non-zero while a menubar pulldown is active */
extern AXWidget WidgetOfFocusWindow();
extern AXWidget InfoBoxWidget;
AXWidget WidgetOfWindow();
extern Display *Dpy;

#if QATOOL
/* lance */
extern void QaCaptureEvent();
extern int QaCaptureMode();
#endif

extern Window RootWin;

extern Atom AxPROTOCOL_ATOM;
extern Atom AxDELETE_WIN_ATOM;
extern Atom AxWIN_TAKE_FOCUS;
extern Atom AxXA_EDITBOX_PROP;

extern unsigned long TimeOfButtonPress; /* event time of button down */
extern unsigned long TimeOfButtonRelease;   /* event time of button up */
extern int AxNoteAllMousePoints;
struct wind_struct *SetWpFromX11Window();

Atom AxTEK_LOW_MEM;
Atom AxTEK_MEM_DAT;

static int low_mem_condition;

int
AxGetLowMemWarning(low_mem)
int *low_mem;
{
#if AX_X11
    unsigned long n_items_return, bytes_after_return;
    int stat, actual_format_return;
    unsigned char *prop_return;
    Atom actual_type_return;

    if ( AxTEK_LOW_MEM == None )
    {
        *low_mem = FALSE;
        return(FALSE);
    }

    stat = XGetWindowProperty(Dpy, RootWin, AxTEK_LOW_MEM,
                              0L, 1L, False, XA_INTEGER,
                              &actual_type_return, &actual_format_return,
                              &n_items_return, &bytes_after_return,
                              &prop_return);
    if ( stat == Success && actual_type_return == XA_INTEGER && prop_return )
    {
        stat = TRUE;
        *low_mem = (*prop_return) ? TRUE : FALSE;
        XFree(prop_return);
    }
    else
    {
        stat = FALSE;
        *low_mem = FALSE;
    }
#else
    int stat = FALSE;
    *low_mem = FALSE;
#endif
    return(stat);
}

int
AxGetServerMemInfo(total_mem, free_mem, largest_mem)
int *total_mem;
int *free_mem;
int *largest_mem;
{
#if AX_X11
    unsigned long n_items_return, bytes_after_return;
    int stat, actual_format_return;
    unsigned char *prop_return;
    Atom actual_type_return;

    stat = XGetWindowProperty(Dpy, RootWin, AxTEK_MEM_DAT,
                              0L, 256L, False, XA_STRING,
                              &actual_type_return, &actual_format_return,
                              &n_items_return, &bytes_after_return,
                              &prop_return);
    if ( stat == Success && actual_type_return == XA_STRING && prop_return )
    {
        if ( sscanf((char *)prop_return,"total 0x%lx, free 0x%lx, largest 0x%lx",
                    total_mem, free_mem, largest_mem) == 3 )
            stat = TRUE;
        else
        {
            *total_mem = 0;
            *free_mem = 0;
            *largest_mem = 0;
            stat = FALSE;
        }
        XFree(prop_return);
    }
    else
    {
        *total_mem = 0;
        *free_mem = 0;
        *largest_mem = 0;
        stat = FALSE;
    }
#else
    int stat = FALSE;
    *total_mem = 0;
    *free_mem = 0;
    *largest_mem = 0;
#endif
    return(stat);
}

int
AxCreateMemInfoAtoms()
{
#if AX_X11
	int low_mem;
	XSelectInput(Dpy, RootWin, PropertyChangeMask);
    AxTEK_LOW_MEM = XInternAtom(Dpy, "_TEK_LOW_MEM",  True);
    AxTEK_MEM_DAT = XInternAtom(Dpy, "_TEK_MEM_INFO", False);
	AxGetLowMemWarning(&low_mem);
    return(TRUE);
#else
    return(FALSE);
#endif
}


extern data_ptr ElfRetData;

int
AxPostTekMemExit()
{
	int pid;

	if ( ElfRetData )
		ElfRetData = (data_ptr)0;
	pid = ElfbNewTask (NXLT("ax_low_memory_dlg@"), "");
	if ( ElfRetData )
		ElfRetData = (data_ptr)0;
	return(pid);
}

int
handle_low_mem_property(event)
XEvent *event;
{
#if AX_X11
	int low_mem;
	if ( event->type != PropertyNotify )
		return(FALSE);
	if ( event->xproperty.window != RootWin )
		return(FALSE);
	if ( event->xproperty.atom != AxTEK_LOW_MEM )
		return(FALSE);

	/* free resources and log activity */
	if ( PrintXWarnings )
		printf("AXWarning: Change in X server memory state -");
	if ( AxGetLowMemWarning(&low_mem) && low_mem )
	{
		deleteAllPixmapsFromCache();
		if ( PrintXWarnings )
			printf(" Memory Low: freeing resource caches.\n");

		/* post an exit dialog box, give the user a chance to escape */
		if ( low_mem_condition == FALSE )
		{
			low_mem_condition = TRUE;
			AxPostTekMemExit();
		}
	}
	else
	{
		low_mem_condition = FALSE;
		if ( PrintXWarnings )
			printf(" Memory Recovered.\n");
	}
	return(TRUE);
#else
	return(FALSE);
#endif
}

/*************************************************************************
function: is_selection_event - utility function for DoSysEvent
*/
is_selection_event(eventWin, eventType)
int eventWin, eventType;
{
    extern Window AxDummyWin;

    if ( eventWin == AxDummyWin &&
         (eventType == SelectionRequest ||
          eventType == SelectionNotify ||
          eventType == PropertyNotify ||
          eventType == SelectionClear) )
        return ( TRUE );
    else
        return ( FALSE );
}
/*************************************************************************
function: DoSysEvent - Process incoming event
*/
DoSysEvent(eventP)
XEvent *eventP;
{

#if !ELFRT_ONLY /* { */
    struct wind_struct *windowP;
    Window re_route;

#if QATOOL
    /* lance */
    if ( QaCaptureMode() ) {
        QaCaptureEvent(eventP);
    }
#endif

    /* assume part of selection transfer */
    if ( eventP->type == PropertyNotify )
    {
            AxSelectionEvent(eventP);
            return;
    }

    windowP = SetWpFromX11Window(eventP->xany.window);
    if ( windowP != (struct wind_struct *)NULL )
    {
        if ( TmPulldownKeyEvent(eventP) )
            return;
    }
    else if ( is_selection_event(eventP->xany.window, eventP->type) )
    {
        AxSelectionEvent( eventP );
        return;
    }
    else /* must be for bounding area */
    {
        re_route = ZXtDispatchEvent(eventP);

        /* for keystrokes in DC ruler... */
        if ( re_route )
        {
            windowP = SetWpFromX11Window( re_route );
            if ( windowP == (struct wind_struct *)NULL )
                return;
        }
        else
            return;
    }

    /* keep Info box on top!  Ignore activity in other windows */
	if ( AxInfoMessages && !IsWinInfoBox(eventP->xany.window) ) {
        if ( eventP->type == FocusIn ) {
            KeepMessageBoxOnTop(eventP);
			return;
		}
        else if ( (eventP->type == KeyPress) ||
                (eventP->type == KeyRelease) ||
                (eventP->type == ButtonPress) ||
				(eventP->type == ButtonRelease) ) {
            ZXtDispatchEvent(eventP);
            return;
        }
    }

    /* only exposures and key activity are important to a pulldown */
    if ( AxPulldownActive )
    {
        if ( eventP->type != Expose &&
             eventP->type != KeyPress &&
             eventP->type != KeyRelease )
            return;
    }

    /* some events handled generically / pre-processed for all apps */
    switch ( eventP->type )
    {
        case ClientMessage:
#if !AXMS    /*  {  */
            if ( eventP->xclient.message_type == AxPROTOCOL_ATOM ) {
                if ( eventP->xclient.data.l[0] == AxDELETE_WIN_ATOM )
                    AxExitThisAppWindow();
                else if ( eventP->xclient.data.l[0] == AxWIN_TAKE_FOCUS ) {
					if ( AxInfoMessages && !IsWinInfoBox(eventP->xany.window) )
                        KeepMessageBoxOnTop(eventP);
                    else
                        AXSetInputFocus(eventP->xany.window, TRUE,
										(Time)(eventP->xclient.data.l[1]));
                }
            }
#endif    /* }  !AXMS  */

            ZXtDispatchEvent(eventP);
            ThimbleSaysToReturnNow = FALSE;
        return;     /* event handled completely */

        case FocusIn:
            /* enable pointer motion events */
            if ( (eventP->xfocus.window == windowP->xwin)||
                 (eventP->xfocus.window == AxXtWindow(windowP->topwidget)) )
                XSelectInput(Dpy, windowP->xwin, TM_PTR_INPUTS_MASK);
        break;

        case FocusOut:
            /* disable pointer motion events - useful if in click-to-focus
             * mode and move pointer over window when it doesn't have focus */
            if ( (eventP->xfocus.window == windowP->xwin) ||
                    (eventP->xfocus.window == AxXtWindow(windowP->topwidget)) )
            {
                XSelectInput(Dpy, windowP->xwin, TM_NO_PTR_INPUTS_MASK);
            }
        break;

        case MotionNotify:
            /* pre-process event (discard intermediate points) */
            if ( !AxNoteAllMousePoints )
                AxGetLastMotionEventInQueue(eventP);
        break;

        case ButtonPress:
            /* set focus (some window managers don't do this
             * automatically in click-to-focus mode) */

            if ( windowP->ap_id != APSS )   
                AXSetInputFocus(eventP->xany.window,
                                TRUE, eventP->xbutton.time);

            else
            {
                /* always set the input focus to the spreadsheet main */
                /* window, since the editwindow and row/col windows don't */
                /* have the keypress enabled */
                AXSetInputFocus(windowP->xwin, TRUE,
                                eventP->xbutton.time);
            }
        break;
    }

    /* Set Asterix concept of current_window based SOLELY on explicit
        user actions like KeyPress and ButtonPress.  This is needed
        so that macros are well behaved is the user happens to move the
        point while a macro is running. */
    if ( (eventP->type == ButtonPress) || (eventP->type == KeyPress) )
        SetCurwinFromWp( windowP );

    /* respond to window-based event, apps that handle X directly */
    if ( (windowP->ap_id == APDC) ||
         (windowP->ap_id == APUCM) ||
         (windowP->ap_id == APEQN) ||
         (windowP->ap_id == APHTML) ||
         (windowP->ap_id == APSS) )
    {
        if ( eventP->type != KeyRelease )
        {
            if ( !xmEventNeededForRightButtonPopup(eventP) ) {
                if ( eventP->type != NoExpose || windowP->ap_id == APSS )
                    AxSendMes(windowP->p_id,eventP,sizeof(*eventP),APXSERVER);
            }

            ZXtDispatchEvent(eventP);
        }
        ThimbleSaysToReturnNow = FALSE;
        return;
    }

    /* respond to window-based event, apps that preprocess system events */
    AxSetThisPidAsActiveTask(windowP->p_id);
    switch(eventP->type)
    {
        case GraphicsExpose:
        case Expose:
            HandleExposureEvent(eventP);
            ThimbleSaysToReturnNow = TRUE;
        break;

        case FocusIn:
#if BUILD_ORIENT
            SetXIMFocus( (widget_t *)NULL, eventP->xany.window );
#endif
        break;

        case FocusOut:
#if BUILD_ORIENT
            UnSetXIMFocus( (widget_t *)NULL, eventP->xany.window );
#endif
        break;

        case LeaveNotify:
        break;

        case EnterNotify:
        break;

        case KeyRelease:
            TimeOfButtonPress = eventP->xkey.time;
        break;

        case KeyPress:
            TimeOfButtonPress = eventP->xkey.time;
            HandleKeyEvent(eventP);
        break;

        case ButtonPress:
            TimeOfButtonPress = eventP->xbutton.time;
            AxSetKeyModifiers(eventP->xbutton.state);
            Handle_ButtonPressEvent(eventP, windowP);
            if ( windowP && windowP->ap_id == APGE )
                AxNoteAllMousePoints = TRUE;
            else
                AxNoteAllMousePoints = FALSE;
        break;

        case ButtonRelease:
            TimeOfButtonRelease = eventP->xbutton.time;
            Handle_ButtonReleaseEvent(eventP,windowP);
            AxNoteAllMousePoints = FALSE;
        break;

        case MotionNotify:
            AxSetKeyModifiers(eventP->xmotion.state);
            Handle_MotionEvent(eventP, windowP);
        break;

        case SelectionRequest:
        case SelectionNotify:
        case SelectionClear:
            AxSelectionEvent(eventP);
        break;
    }
#endif /* !ELFRT_ONLY } */

    /* handle cases like button up in work area during a pulldown menu */
    ZXtDispatchEvent(eventP);

    /* clean up and return */
    ThimbleSaysToReturnNow = FALSE;
}

