/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tmxarcls.c
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:35 1998
*/
#include <fcntl.h>
#include <aos.h>
#include <paripc.h>
#include <paratm.h>
#include <paratmgr.h>
#include <parcint.h>
#include <parreg.h>

/*************************************************************************
function: TmARclose - Close all regions
*/
typeErr TmARclose(window_id)
short window_id;

{
    union
    {
        struct SARcloseData arclose_data;
        char sen_buf[sizeof(struct SARcloseData)];
    } sen_pack;

    union
    {
        struct RARcloseData arclose_data;
        char rec_buf[sizeof(struct RARcloseData)];
    } rec_pack;

    short i;

    if(!TmOpFlag) return(TMR_OWN);
    if (!TmValWin(window_id, FALSE)) return TMR_NOWIN;
    sen_pack.arclose_data.event_indicator = QATM_ARCLOSE;
    sen_pack.arclose_data.window_id = window_id;
    sen_pack.arclose_data.pack_len = sizeof(struct SARcloseData);

    TmSenMes(sen_pack.sen_buf, sen_pack.arclose_data.pack_len, TMNOHURRY, NULLP, 0);

    return(TMR_OK);
    /* no need to get the return status */
}
