/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: widefont.c
   Applix ASC version: 9
   Date: Mon Apr  5 21:13:10 1999
*/
#include <stdlib.h>
#include <basicwin.h>
#include <aos.h>
#include <xim.h>
#include <xmlib.h>
#include <wchars.h>
#include <ximcomm.h>
#include <widefont.h>
#include <wide_extern.h>

#ifdef __cplusplus
extern "C" {
    XFontStruct *AXLoadQueryFont();
    }
#endif

#include <widefont.p>

extern Display *Dpy;


#if BUILD_KANJI   /*  {   */

/** in order to provide some intelligent defaults here is a small */
/* routine which will atempt to find a narrow kana font based on the */
/* height of another font.  There is a lot of hard coded font name stuff here */
/* but I can think of nothing else till we get to X11R5 font-sets - jon */
#if SUN4 && !SUN4S    /*  {  */
font_name_struct narrow_mincho_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-sun-minchou-medium-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-sun-minchou-medium-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-minchou-medium-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-sun-minchou-medium-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-minchou-medium-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-sun-gothic-medium-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-sun-gothic-medium-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-gothic-medium-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-sun-gothic-medium-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-gothic-medium-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_bold_names[] = {
  {10,"-applix-minchou-bold-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-sun-gothic-bold-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-sun-gothic-bold-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-gothic-bold-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-sun-gothic-bold-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-gothic-bold-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };


font_name_struct wide_serif_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-sun-minchou-medium-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-sun-minchou-medium-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-minchou-medium-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-sun-minchou-medium-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-minchou-medium-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-sun-gothic-medium-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-sun-gothic-medium-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-gothic-medium-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-sun-gothic-medium-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-gothic-medium-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_bold_names[] = {
  {10,"-applix-minchou-bold-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-sun-gothic-bold-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-sun-gothic-bold-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-gothic-bold-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-sun-gothic-bold-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-gothic-bold-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

#endif     /*  }  SUN4 && !SUN4S */



#if SUN4S || SUNIS   /*  {  */
font_name_struct narrow_mincho_names[] = {
   {10,"-morisawa-ryumin light kl-light-r-normal--10-100-72-72-m-50-jisx0201.1976-0"},
   {12,"-morisawa-ryumin light kl-light-r-normal--12-120-72-72-m-60-jisx0201.1976-0"},
   {14,"-morisawa-ryumin light kl-light-r-normal--14-140-72-72-m-70-jisx0201.1976-0"},
   {18,"-morisawa-ryumin light kl-light-r-normal--18-180-72-72-m-90-jisx0201.1976-0"},
   {24,"-morisawa-ryumin light kl-light-r-normal--24-240-72-72-m-120-jisx0201.1976-0"},
   {36,"-morisawa-ryumin light kl-light-r-normal--36-360-72-72-m-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_names[] = {
   {10,"-morisawa-gothic medium bbb-medium-r-normal-sans-10-100-72-72-m-50-jisx0201.1976-0"},
   {12,"-morisawa-gothic medium bbb-medium-r-normal-sans-12-120-72-72-m-60-jisx0201.1976-0"},
   {14,"-morisawa-gothic medium bbb-medium-r-normal-sans-14-140-72-72-m-70-jisx0201.1976-0"},
   {18,"-morisawa-gothic medium bbb-medium-r-normal-sans-18-180-72-72-m-90-jisx0201.1976-0"},
   {24,"-morisawa-gothic medium bbb-medium-r-normal-sans-24-240-72-72-m-120-jisx0201.1976-0"},
   {36,"-morisawa-gothic medium bbb-medium-r-normal-sans-36-360-72-72-m-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_bold_names[] = {
   {10,"-morisawa-gothic medium bbb-bold-r-normal-sans-10-100-72-72-m-50-jisx0201.1976-0"},
   {12,"-morisawa-gothic medium bbb-bold-r-normal-sans-12-120-72-72-m-60-jisx0201.1976-0"},
   {14,"-morisawa-gothic medium bbb-bold-r-normal-sans-14-140-72-72-m-70-jisx0201.1976-0"},
   {18,"-morisawa-gothic medium bbb-bold-r-normal-sans-18-180-72-72-m-90-jisx0201.1976-0"},
   {24,"-morisawa-gothic medium bbb-bold-r-normal-sans-24-240-72-72-m-120-jisx0201.1976-0"},
   {36,"-morisawa-gothic medium bbb-bold-r-normal-sans-36-360-72-72-m-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };


font_name_struct wide_serif_names[] = {
   {10,"-morisawa-ryumin light kl-light-r-normal--10-100-72-72-m-100-jisx0208.1983-0"},
   {12,"-morisawa-ryumin light kl-light-r-normal--12-120-72-72-m-120-jisx0208.1983-0"},
   {14,"-morisawa-ryumin light kl-light-r-normal--14-140-72-72-m-140-jisx0208.1983-0"},
   {18,"-morisawa-ryumin light kl-light-r-normal--18-180-72-72-m-180-jisx0208.1983-0"},
   {24,"-morisawa-ryumin light kl-light-r-normal--24-240-72-72-m-240-jisx0208.1983-0"},
   {36,"-morisawa-ryumin light kl-light-r-normal--36-360-72-72-m-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_names[] = {
   {10,"-morisawa-gothic medium bbb-medium-r-normal-sans-10-100-72-72-m-100-jisx0208.1983-0"},
   {12,"-morisawa-gothic medium bbb-medium-r-normal-sans-12-120-72-72-m-120-jisx0208.1983-0"},
   {14,"-morisawa-gothic medium bbb-medium-r-normal-sans-14-140-72-72-m-140-jisx0208.1983-0"},
   {18,"-morisawa-gothic medium bbb-medium-r-normal-sans-18-180-72-72-m-180-jisx0208.1983-0"},
   {24,"-morisawa-gothic medium bbb-medium-r-normal-sans-24-240-72-72-m-240-jisx0208.1983-0"},
   {36,"-morisawa-gothic medium bbb-medium-r-normal-sans-36-360-72-72-m-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_bold_names[] = {
   {10,"-morisawa-gothic medium bbb-bold-r-normal-sans-10-100-72-72-m-100-jisx0208.1983-0"},
   {12,"-morisawa-gothic medium bbb-bold-r-normal-sans-12-120-72-72-m-120-jisx0208.1983-0"},
   {14,"-morisawa-gothic medium bbb-bold-r-normal-sans-14-140-72-72-m-140-jisx0208.1983-0"},
   {18,"-morisawa-gothic medium bbb-bold-r-normal-sans-18-180-72-72-m-180-jisx0208.1983-0"},
   {24,"-morisawa-gothic medium bbb-bold-r-normal-sans-24-240-72-72-m-240-jisx0208.1983-0"},
   {36,"-morisawa-gothic medium bbb-bold-r-normal-sans-36-360-72-72-m-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

#endif     /*  }  SUN4S || SUNIS */

#if RIOS || HP800 || NEC || LINUX         /*  {  */
font_name_struct narrow_mincho_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-applix-minchou-medium-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-applix-minchou-medium-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-minchou-medium-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-applix-minchou-medium-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-minchou-medium-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-applix-gothic-medium-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-applix-gothic-medium-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-gothic-medium-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-applix-gothic-medium-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-gothic-medium-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct narrow_gothic_bold_names[] = {
  {10,"-applix-minchou-bold-r-normal--12-100-75-75-c-50-jisx0201.1976-0"},
  {12,"-applix-gothic-bold-r-normal--14-120-75-75-c-60-jisx0201.1976-0"},
  {14,"-applix-gothic-bold-r-normal--16-140-75-75-c-70-jisx0201.1976-0"},
  {18,"-applix-gothic-bold-r-normal--20-180-75-75-c-90-jisx0201.1976-0"},
  {24,"-applix-gothic-bold-r-normal--26-240-75-75-c-120-jisx0201.1976-0"},
  {36,"-applix-gothic-bold-r-normal--38-360-75-75-c-180-jisx0201.1976-0"},
  {10000, ""}  /* the stoper */ };


font_name_struct wide_serif_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-applix-gothic-medium-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-applix-gothic-medium-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-gothic-medium-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-applix-gothic-medium-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-gothic-medium-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_names[] = {
  {10,"-applix-minchou-medium-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-applix-gothic-medium-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-applix-gothic-medium-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-gothic-medium-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-applix-gothic-medium-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-gothic-medium-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_bold_names[] = {
  {10,"-applix-minchou-bold-r-normal--12-100-75-75-c-100-jisx0208.1983-0"},
  {12,"-applix-gothic-bold-r-normal--14-120-75-75-c-120-jisx0208.1983-0"},
  {14,"-applix-gothic-bold-r-normal--16-140-75-75-c-140-jisx0208.1983-0"},
  {18,"-applix-gothic-bold-r-normal--20-180-75-75-c-180-jisx0208.1983-0"},
  {24,"-applix-gothic-bold-r-normal--26-240-75-75-c-240-jisx0208.1983-0"},
  {36,"-applix-gothic-bold-r-normal--38-360-75-75-c-360-jisx0208.1983-0"},
  {10000, ""}  /* the stoper */ };


#endif   /*  }  RIOS || HP800 || NEC || LINUX   */
#endif    /*   BUILD_KANJI  }  */




/* we use times roman as the default */
font_name_struct narrow_names[] = {
  {12,"-applix-axtmr-medium-r-normal--13-120-75-75-p-63-iso8859-1"},
  {14,"-applix-axtmr-medium-r-normal--15-140-75-75-p-74-iso8859-1"},
  {18,"-applix-axtmr-medium-r-normal--18-180-75-75-p-95-iso8859-1"},
  {24, "-applix-axtmr-medium-r-normal--24-240-75-75-p-125-iso8859-1"},
  {10000, ""}  /* the stoper */ };





#if BUILD_CHINA   /*  }  */
font_name_struct wide_serif_names[] = {
  {12,"-sun-song-medium-r-normal--14-120-75-75-c-120-gb2312.1980-0"},
  {14,"-sun-song-medium-r-normal--16-140-75-75-c-140-gb2312.1980-0"},
  {16,"-sun-song-medium-r-normal--18-160-75-75-c-160-gb2312.1980-0"},
  {20,"-sun-song-medium-r-normal--22-200-75-75-c-200-gb2312.1980-0"},
  {24,"-sun-song-medium-r-normal--26-240-75-75-c-240-gb2312.1980-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_names[] = {
  {12,"-sun-song-medium-r-normal--14-120-75-75-c-120-gb2312.1980-0"},
  {14,"-sun-song-medium-r-normal--16-140-75-75-c-140-gb2312.1980-0"},
  {16,"-sun-song-medium-r-normal--18-160-75-75-c-160-gb2312.1980-0"},
  {20,"-sun-song-medium-r-normal--22-200-75-75-c-200-gb2312.1980-0"},
  {24,"-sun-song-medium-r-normal--26-240-75-75-c-240-gb2312.1980-0"},
  {10000, ""}  /* the stoper */ };

#endif   /* }   BUILD_CHINA */

#if BUILD_KOREAN   /*  {  */
font_name_struct wide_serif_names[] = {
  {14,"-sun-myeongjo-medium-r-normal--16-140-75-75-c-140-ksc5601.1987-0"},
  {20,"-sun-myeongjo-medium-r-normal--22-200-75-75-c-200-ksc5601.1987-0"},
  {24,"-sun-myeongjo-medium-r-normal--26-240-75-75-c-240-ksc5601.1987-0"},
  {10000, ""}  /* the stoper */ };

font_name_struct wide_sansserif_names[] = {
{12,"-sun-gothic-medium-r-normal--14-120-75-75-c-120-ksc5601.1987-0"},
{14,"-sun-gothic-medium-r-normal--16-140-75-75-c-140-ksc5601.1987-0"},
{16,"-sun-gothic-medium-r-normal--18-160-75-75-c-160-ksc5601.1987-0"},
{20,"-sun-gothic-medium-r-normal--22-200-75-75-c-100-ksc5636-0"},
{24,"-sun-gothic-medium-r-normal--26-240-75-75-c-120-ksc5636-0"},
{10000, ""}  /* the stoper */ };

#endif     /*  }  */





/*  I don't think this is used in non-Orient wide builds... DHM 1/99 */
#if BUILD_ORIENT        /*   {  */

XFontStruct *AXLoadQueryFont();
mbchar *sansserif_orient_face();
mbchar *serif_orient_face();



void GetNarrowFontFromSize( FontSet font_set )
{
    font_name_struct *fp;
    XFontStruct *fontP;
    int scalable;
 
#if BUILD_KANJI
    XFontStruct *fontRef;
    char    *family;
    int     point, weight, slant, wide;

    /* We found an inevitable difficulty in our FontSet concept because we
     * alias the NarrowKana and cell-type "Brief" fonts: that is if wide_font
     * and narrow_kana_font were composed into an fontset, then the "Brief"
     * font will be in X-identical with NarrowKana, but its code is ascii.
     * Then in awDrawString16(), the FontSetFontId() requesting a narrow font
     * while narrow font is still null, this time the default English font
     * will be added to the fontset to give the narrow font id, the result is
     * mis-matching of font assign("Brief") and font display("Times" or
     * "Helvetica"). We still dont know what is the complete solution, by now
     * we do here the temporory method to avoid the above mis-matching.
     * Ashisuto, 96.03.26 */
    if (font_set->narrow_kana) {
        font_set->narrow_font = font_set->narrow_kana;
        font_set->narrow_font_id = font_set->narrow_kana_id;
        return;
    }
 
    fontRef = font_set->wide_font ? font_set->wide_font : font_set->narrow_kana;
    if (font_set->sans)
        family = axDefaultSansSerifFont;
    else
        family = axDefaultSerifFont;
    if (!getXFontAttr(fontRef, NULL, &point, &weight, &slant, NULL)) {
        point = font_set->pointsize ? font_set->pointsize/10 : font_set->height;
        weight = FALSE;
        slant = FALSE;
    }
 
    if (!getXFontStruct(family, point, weight, slant, &scalable, &fontP ) )
#else
    if ( !getXFontStruct( axDefaultSerifFont, font_set->height, 0, 0, 
                                                      &scalable, &fontP ) )
#endif
       {
       /* could not load from cache, use a hard coded name */
       fp = narrow_names;
       while ( (fp+1)->font_height <= font_set->height )
          { fp++; }
 
       fontP = AXLoadQueryFont( Dpy, fp->font_name );
       }

    if (font_set->height < fontP->ascent + fontP->descent)
        /* correct possible incorrect font metrics seen on SUN */
        font_set->height = fontP->ascent + fontP->descent;

    font_set->narrow_font_id = fontP->fid;
    font_set->narrow_font = fontP;
    return;
}



void GetWideFontFromSize( FontSet font_set )
{
    font_name_struct *fp;
    XFontStruct *fontP;
    int scalable, height;
#if BUILD_KANJI   /*  {  */
    XFontStruct *fontRef;
    mbchar    *family;
    int     point, weight, slant, wide;
    fontRef = font_set->narrow_kana ? font_set->narrow_kana :
            font_set->narrow_font;
    if (getXFontAttr(fontRef, (char **)(&family), &point, &weight, 
                                                            &slant, NULL)) {
        if (IsNarrowKanaFontFace(family))
            family += strlen(NXLT("Narrow"));
        else
            if (font_set->sans)
                family = sansserif_orient_face();
            else
                family = serif_orient_face();
    } else {    /* fontRef is not in font cache. */
        if (font_set->sans)
            family = sansserif_orient_face();
        else
            family = serif_orient_face();
        point = font_set->pointsize ? font_set->pointsize/10 : font_set->height;
        weight = FALSE;
    }
    if (!getXFontStruct((char *)family, point, weight, FALSE, &scalable, &fontP))
#else     /*  }  {  */
    /* since this is a wide font we have not seen before, we need */
    /* to load a corresponding narrow kana font so that future    */
    /* references can always see the font set                     */
 
    height = font_set->height;
    if ( !getXFontStruct( (char *)get_default_orient_face(), height,
                         0, 0, &scalable, &fontP ) )
#endif    /* }  BUILD_KANJI */
       {
       /* could not load from cache, use a hard coded name */
       if (font_set->sans)
          fp = wide_sansserif_names;
       else
          fp = wide_serif_names;
  
       while ( (fp+1)->font_height <= font_set->height )
          { fp++; }
 
       fontP = AXLoadQueryFont( Dpy, fp->font_name );
       }
    if ( fontP == (XFontStruct *)NULL )
       {
       /* could not load anything */
       font_set->wide_font_id = (Font)NULL;
       font_set->wide_font = (XFontStruct *)NULL;
       }
    else
       {
       /* found a wide font */
       font_set->wide_font_id = fontP->fid;
       font_set->wide_font = fontP;
       }
 
    if (font_set->height < fontP->ascent + fontP->descent)
        /* correct possible incorrect font metrics seen on SUN */
        font_set->height = fontP->ascent + fontP->descent;

    return;
}

#if BUILD_KANJI || HYUNDAI     /*  {  */

/** get the narrow kana font which is the matching pair to a particular **/
/** kanji font                                                          **/
/** In the Hyundai Korean environment, we are using the "narrow-kana"   **/
/**    functionalty to treat wide-blanks as narrow blanks since that is **/
/**    the traditional Korean spacing. Thererore, this function get a   **/
/**    western font in the same pointsize as the Korean font            **/
void GetNarrowKanaFont( mbchar *name, Font *font )
{
    int width;
    int dash_count;
    mbchar buff[200];
    mbchar *p;

#if BUILD_KANJI              /*  {  */
    *font = NULL;
    MBstrcpy( buff, name );
    p = buff + MBstrlen(buff );

  /** The Japanese narrow kana font name differs from the wide font name
  * in the fact that it has half the width, and the encoding field 
  * reads "1976" instead of "1983".  For example:
  *   wide: -sun-minchou-medium-r-normal--14-120-75-75-c-120-jisx0208.1983-0
  * narrow: -sun-minchou-medium-r-normal--14-120-75-75-c-60-jisx0201.1976-0 
  *
  * or, under solaris 2.3
  * -morisawa-ryumin light kl-light-r-normal-sans-0-120-0-0-m-0-jisx0208.1983-1
  * -morisawa-ryumin light kl-light-r-normal-sans-0-120-0-0-m-0-jisx0201.1976-0
  */

    dash_count = 0;
    while ( p != buff )
       {
       p--;
       if ( *p == '-' )
            dash_count++;
       if ( dash_count == 3 )
           {
           /* found the width field */
           p++;                  /* start of width digits */
           width = atoi( (char *)p );
           width = width/2;
           sprintf( (char *)p, "%d", width );
#if SUN4 || RIOS
           MBstrcat( p, "-jisx0201.1976-0" );
#endif
           *font = XLoadFont( Dpy, (char *)buff );
           return;
           }
       }

    /* fell through, not much we can do */
    return;
#endif    /*  }  end of BUILD_KANJI   */

#if HYUNDAI      /*  {  */
    /* generate the correct size of "Times" from the input point size     */
    width = decipointSize( name );

    sprintf( (char *)buff, 
           "-applix-axtmr-medium-r-normal--*-%d-75-75-p-*-iso8859-1", width );

    *font = XLoadFont( Dpy, buff );
    return;
#endif             /* } HYUNDAI */

}


void GetNarrowKanaFontFromSize( FontSet font_set )
{
    font_name_struct *fp;
    XFontStruct *fontP;
    int scalable;

#if BUILD_KANJI   /*  {  */
    XFontStruct *fontRef;
    char    *family;
    int     point, weight, slant, wide;
    char   narrow_name[100];
    fontRef = font_set->wide_font ? font_set->wide_font : font_set->narrow_font;
    if (getXFontAttr(fontRef, &family, &point, &weight, &slant, NULL)) {
        if (fontRef->max_byte1 > 0)
            sprintf(narrow_name, "%s%s", NXLT("Narrow"), family);
        else
            if (font_set->sans)
                MBstrcpy(narrow_name, sansserif_narrow_kana_face());
            else
                MBstrcpy(narrow_name, serif_narrow_kana_face());
    } else {    /* fontRef is not in font cache. */
        if (font_set->sans)
            MBstrcpy(narrow_name, sansserif_narrow_kana_face());
        else
            MBstrcpy(narrow_name, serif_narrow_kana_face());
        point = font_set->pointsize ? font_set->pointsize/10 : font_set->height;
        weight = FALSE;
    }
    if (!getXFontStruct((char *)narrow_name, point, weight, FALSE, &scalable, &fontP)) 
       {
       /* could not load from cache, use a hard coded name */
       if (font_set->sans)
           fp = narrow_gothic_names;
       else
           fp = narrow_mincho_names;
   
       while ( (fp+1)->font_height <= font_set->height )
          { fp++; }

       fontP = AXLoadQueryFont( Dpy, fp->font_name );
       }
#endif    /*  }  */

#if HYUNDAI    /*  {  */
    /* For the Hyundai Korean environment we are interested in getting a */
    /*   western font (times) for the wide-blank character which is treaded */
    /*   as a narrow blank for spacing purposes.                            */
    if ( !getXFontStruct( (char *)axDefaultSerifFont, font_set->height, 0, 0, 
                                                        &scalable , &fontP ) )
       {
       /* could not load from cache, use a hard coded name */
       fp = narrow_names;
       while ( (fp+1)->font_height <= font_set->height )
          { fp++; }

       fontP = XLoadQueryFont( Dpy, fp->font_name );
       }
#endif     /*  }  */

    if (font_set->height < fontP->ascent + fontP->descent)
        /* correct possible incorrect font metrics seen on SUN */
        font_set->height = fontP->ascent + fontP->descent;

    font_set->narrow_kana_id = fontP->fid;
    font_set->narrow_kana = fontP;
    return;
}

#endif      /*  } end of BUILD_KANJI || HYUNDAI */


#endif   /*  } BUILD_ORIENT */
