/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: wingen.c
   Applix ASC version: 2
   Date: Mon Nov 16 13:53:42 1998
*/
#include <aos.h>

/*
 * Convert pair of bytes from Applix-format image to X10-format image word
 * ...or vice versa.
 *
 * Operating in reverse, the argument is an X10-format image word viewed
 * as a pair of bytes.   (On a VAXorder machine the bytes are formed into
 * a byte-swapped 16-bit word prior to bit-reversing.)
 */
unsigned short
bitreverse(pob, flag)
	unsigned char pob[];        /* pair of bytes in Applix format */
	short flag;
{
	int inv, outv, i;

	switch (flag)
	{
	 default:
	 case 0: /* just reverse the bit order, leave bytes in place */
		/* swap the bytes */
		inv = (pob[0] << 8) + pob[1]; 

		/*reverse the bits */
		outv = 0;
		for (i = 0; i < 16; i++) 
		{
			if (i > 0) 
			{
				inv >>= 1;
				outv <<= 1;
			}
			if (inv & 1)
				outv |= 1;
		}
		break;

	 case 1: /* just flip the bytes */
		outv = (pob[0] << 8) + pob[1]; 
		break;

	 case 2: /* flip the bytes and reverse the bit order */
		/* don't swap the bytes */
		inv = (pob[1] << 8) + pob[0]; 

		/*reverse the bits */
		outv = 0;
		for (i = 0; i < 16; i++) 
		{
			if (i > 0) 
			{
				inv >>= 1;
				outv <<= 1;
			}
			if (inv & 1)
				outv |= 1;
		}
		break;
		
	}
	return (unsigned short) outv;
}

