/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winmenu.c
   Applix ASC version: 43
   Date: Wed Mar 17 21:12:50 1999
*/
#define NEED_X_INFO 1 
#define ATMPROTO_H_INCL    /* hack to shut off atmproto.h */
#include <basicwin.h>
#include <windowsx.h>
#include <stdlib.h>
#include <string.h>
#include <ax_xm.h>
#include <aos.h>
#include <xmlib.h>
#include <paripc.h> 
#include <scac.h>
#include <tmi.h>
#include <paratm.h>
#include <parint.h>

#define STRALLOC(s) strcpy(malloc(strlen(s)+1),s)

extern int MenuUID;
extern int THIMhelpMode;
extern int AxNewMailMenuIcon;
extern AXWidget WindowList;
extern PIXEL_VALUE ForePixel, ButtonFacePixel;
extern int RunningWin95Look;
extern int AxWinDefaultMenuHeight;


#include <winmenu.p>




/*** beware!  recursive function! ***/
AXWidget_menu
AxCrtMenuStructFromId(menu_item_def *mP)
/* menu_item_def *mP;    the elf menu bar data */
{
    axw_menu list[MAX_MENU_ITEMS + 1], *retp;
    int ix = 0;


    memset(list, 0, sizeof(list));
    for ( ++mP; mP && (ix < MAX_MENU_ITEMS); mP++, ix++ )
        {
        if ( (mP->type == ITEM_MARK) && mP->ender )
            break;

        if ( mP->noshow )
            list[ix].noshow = TRUE;
        else
            list[ix].noshow = FALSE;

        list[ix].menu_type = mP->type;
        if ( mP->menu_key_str != NULL )
            list[ix].menu_key  = *(mP->menu_key_str);
        if ( mP->type == ITEM_MENU )
            {
            if ( SubMenuHidden((AXWidget)list, mP, FALSE) )
                list[ix].noshow = TRUE; 

            list[ix].name = STRALLOC(mP->word);
            list[ix].value = (int)
                            AxCrtMenuStructFromId((menu_item_def*)mP->word2);
            }
        else if (mP->type == ITEM_LINE)
            {
            }
        else if (mP->type == ITEM_FUNC)
            {
            list[ix].name = STRALLOC(mP->word);
            list[ix].value = (int)(STRALLOC(mP->word2));
            list[ix].accel_str = (char*)AccelStr(mP);
            }
        else
            ix--;   /* just ignore nonsense */
        }

    list[ix].menu_type = ITEM_MARK;
    ix++;           /* for empty last */
    retp = (axw_menu *) TrueMalloc(ix * sizeof(axw_menu));
    memcpy(retp, list, ix * sizeof(axw_menu));
    retp->type = W_MENUBAR;
    return (retp);
}



/****************************************************************
* gets the visible item count of a particular submenu, not the
* complete menubar.
*/
static int
axGetVisibleMenuItems(AXWidget_menu menu_info, AXWidget wP)
{
    int ix, code, count;
    AXWidget_menu mp;

    count = 0;
    for ( ix = 0; menu_info[ix].menu_type != ITEM_MARK; ix++ )
        {
        mp = &menu_info[ix];
        if ( mp->menu_type == ITEM_FUNC )
            {
            menu_item_def tmp;
            /* get status code. */
            tmp.word2 = (char*)mp->value;
            code = FlagsFromApp((AXWidget_main)wP, &tmp, TRUE);
            if ( code != MENUSTAT_NO_SHOW && code != MENUSTAT_KEYONLY &&
                                                            !mp->noshow )
                count++;
            }
        else if ( mp->menu_type == ITEM_MENU )
            {
            if ( !mp->noshow )
                count++;
            }
        }
    return count;
}



/*************************************************************************
function: WXCreateMenuBar - Create menu bar to dialog
             *** beware!  recursive function! ***
*/

void WXCreateMenuBar(AXWidget_main parent, AXWidget_menu mP)
{
    int ix;
    HMENU menu;
    AXWidget_menu subptr;
#if 0
    AXWidget_menu mP = NULL, subptr;
#endif
    int insert_count = 0;  /* number of items actually inserted in the menu */
    int actual_item_count = 0;
    int num_visible_items;
    static int uid;
    static int menu_level = 0;


    if ( !mP )
        return;
    WIDGET_PARANOID(parent, W_MAIN);
    WIDGET_PARANOID(mP, W_MENUBAR);
    if ( menu_level == 0 )
        uid = FIRST_MENU_ID;

#if 0
    /* count number of terms & malloc struct */
    for ( ix = 0; info[ix].menu_type != ITEM_MARK; ix++ );
    ix++;           /* room for MARK item */
    mP = (axw_menu *) malloc(ix * sizeof(axw_menu));
#endif

    subptr = (AXWidget_menu)NULL;

    num_visible_items = axGetVisibleMenuItems(mP, (AXWidget)parent);

    /* create Windows menus & fill in struct */
    menu = MS_CreateMenu();
    for ( ix = 0; mP[ix].menu_type != ITEM_MARK; ix++ )
        {
        if ( mP[ix].menu_type == ITEM_FUNC )
            {
            mP[ix].uid = uid;
            if ( !mP[ix].noshow )
                {
                /* only add items that will be displayed */
                AddItemToMenuBar(menu, uid++, mP[ix].name,
                                            mP[ix].menu_key,
                                            mP[ix].accel_str, MF_ENABLED);
                insert_count++;
                if ( mP[ix].name[0] != '@' ) /* for dynamic menu items */
                    actual_item_count++;
                }
            else
                uid++;
            }
        else if ( mP[ix].menu_type == ITEM_MENU )
            {
            menu_level++;
            subptr = (AXWidget_menu)mP[ix].value;
            WXCreateMenuBar(parent, subptr );
            menu_level--;
            /* fix last arg to Append Menu for Mnemonic */
            if ( !mP[ix].noshow )
                {    /* only add items that will be displayed */
                insert_count++;
                actual_item_count++;
                if ( MBstreq(mP[ix].name, "*") )
					{
                    /* the asterix is actually a bitmap */
                    DrawMenuBitmap(menu, subptr, FALSE);
					/* if the bitmap is bigger than the default Windows menubar
					 * we'll have to adjust window size later.
					 */
					if ( subptr->height > 0 )
						mP->height = subptr->height;
					}
                else
                    {
                    AddItemToMenuBar(menu, (UINT) subptr->menu_handle,
                                    mP[ix].name, mP[ix].menu_key, 
                                    mP[ix].accel_str, MF_ENABLED | MF_POPUP);
                    }
                }

            mP[ix].submenu = subptr->menu_handle;
            }
        else if ( (mP[ix].menu_type == ITEM_LINE) && !mP[ix].noshow &&
                                (menu_level > 0) && (insert_count > 0) )
            {
            /* add a separator if we are dealing with a submenu *
             * (i.e. not the top-level menubar), and the noshow *
             * flag is false.                                   */
            /* if we've already inserted the last visible menu item
             * no need to add extraneous separators.
             */
            if ( actual_item_count <= num_visible_items )
                {
                AddItemToMenuBar(menu, uid++, NULL, (char)0, NULL, MF_SEPARATOR);
                insert_count++;
                }
            }
        }

    mP->type = W_MENUBAR;
    mP->parent = parent;
    mP->menu_handle = menu;
	if ( num_visible_items == 0 )
		mP->display = FALSE;
	else
		mP->display = TRUE;
    return;
}


static void
AddItemToMenuBar(HMENU menu, UINT uid, char *name, char menu_key,
                                char *accel_str, UINT menu_style)
{
	char *new_name;
	new_name = PutMnemonicAndAccelInString(name, menu_key, accel_str);
    MS_AppendMenu(menu, menu_style, uid, new_name);
	free(new_name);
}

static void
InsertItemInMenuBar(HMENU menu_handle, UINT prev_pos, UINT uid, char *item,
                                            char menu_key, char *accel_str)
{
    BOOL ret;
	char *new_name;
    
	new_name = PutMnemonicAndAccelInString(item, menu_key, accel_str);
    ret = MS_InsertMenu(menu_handle, prev_pos, MF_BYPOSITION | MF_STRING, uid,
            				(LPCTSTR)new_name);
	free(new_name);
    if ( !ret )
        taskAbort(NXLT("InsertItemInMenuBar: could not insert menu item!"));
}



/****************************************************************************
function: PutMnemonicAndAccelInString - insert '&' before menu_key in
                                    name string, and append accelerator key
***/
static char *
PutMnemonicAndAccelInString(char *name, char menu_key, char *accel_str)
{
    char current_letter;
	char *newstring;
    int i, j, found;

    j = 0;
    found = 0;
    if ( !name )
        return( (char *)NULL );

	if ( accel_str )
		newstring = (char*)malloc(strlen(name) + strlen(accel_str) + 3);
	else
		newstring = (char*)malloc(strlen(name) + 2);
    for ( i=0; *name != '\0'; i++ )
        {
        /* get current letter and make it uppercase just for searching    *
         * purposes. this is because we are assuming that all menu keys   *
         * (mnemonics) are uppercase, and thus we want to ensure a match. */
        current_letter = toupper(*name);
        if ( menu_key > 96 )    /* just in case it isn't uppercase! */
            menu_key = toupper(menu_key);

        /* insert a '&' if we find the mnemonic letter, or an actual *
         * ampersand. (Windows wants a '&&' to denote just one '&'). */
        if ( ((current_letter == menu_key) && (found != 1)) || *name == '&' )
            {
            /* if we are processing the ampersand, *
             * we haven't found the mnemonic yet.  */
            if ( *name != '&' )
                found = 1;
            newstring[j++] = '&';
            newstring[j++] = *name++;
            }
        else
            newstring[j++] = *name++;
        }

    newstring[j] = '\0';

    if ( accel_str )
        {
        strcat(newstring, "\t");        /* append tab */
        strcat(newstring, accel_str);   /* append accel key name */
        newstring[j + strlen(accel_str) + 1] = '\0';    /* null terminate */
        }

    return (newstring);
}


static BOOL
SubMenuNoShow(HMENU sub_hmenu)
{
    int item_count;

    item_count = MS_GetMenuItemCount(sub_hmenu);
    if ( item_count )
        return FALSE;
    else
        return TRUE;
}


/*************************************************************************
function: AxSetMenuFlags - Runtime set the grayed/toggle state of the menu items
*/
void
AxSetMenuFlags(AXWidget_menu w_menu, HMENU hmenu)
{
    MenuUID++;

    if ( w_menu->elfObject )
        axSetMenuStatusFlags(w_menu, (AXWidget)w_menu, hmenu);
    else
        axSetMenuStatusFlags(w_menu, (AXWidget)w_menu->parent, hmenu);

    MS_DrawMenuBar(w_menu->parent->winid);  /* Windows will update menubar */
}


/* Calls app's CmdStatus routine to get dim values */
/*** beware!  recursive function! ***/
static void
axSetMenuStatusFlags(AXWidget_menu info, AXWidget wP, HMENU hmenu)
{
    int insert_count = 0;  /* number of items actually inserted in the menu */
    int ix, code, item_len;
    AXWidget_menu mp;
    menu_item_def tmp;
    mbchar *new_menu_str;
	char *tmp_str;
    char tmp_buf[81];
    BOOL ret;
    static int menu_level = 0;


    WIDGET_PARANOID(info, W_MENUBAR);

    memset(&tmp, 0, sizeof(menu_item_def));
    for ( ix = 0; info[ix].menu_type != ITEM_MARK; ix++ )
        {
        if ( info[ix].menu_type == ITEM_LINE )
            insert_count++;  /* we need to count separators as menu items. */
        else if ( info[ix].menu_type == ITEM_FUNC )
            {
            mp = &info[ix];

            if ( mp->name[0] == '@' ) /* for dynamic menu items */
                {
                new_menu_str = ElfFetchMenuWord(wP,mp->name+1,(char*)mp->value);
                MS_ModifyMenu(hmenu,mp->uid, MF_STRING, mp->uid,new_menu_str);
                free(new_menu_str);    /* allocated in ElfFetchMenuWord */
                }

            /* get status code. */
            tmp.word2 = (char*)mp->value;
            code = FlagsFromApp((AXWidget_main)wP, &tmp, TRUE);

            /* check for already existing menu item (that is, a menu item *
             * that has been inserted into the menu). if it doesn't exist *
             * we have to insert it. only insert item if flag is set and  *
             * status code doesn't indicate deletion.                     */
            if ( !mp->noshow && code != MENUSTAT_NO_SHOW &&
                                code != MENUSTAT_KEYONLY )
                {
                item_len = MS_GetMenuString(hmenu, mp->uid, tmp_buf,
                                                80, MF_BYCOMMAND);
                if ( item_len <= 0 )
                    {
                    /* no item string so we need to insert it. */
                    /* the menu handle passed in is for the root menu,  *
                     * so here we must use the sub-menu handle in order *
                     * to properly insert the menu item.                */
                    InsertItemInMenuBar(info[0].menu_handle, insert_count,
                                        mp->uid, mp->name,
                                        mp->menu_key, mp->accel_str);
                    }
                }

            /* perform status operation on menu item. */
            switch (code)
                {
            case 0:
                /* enable it. */
                MS_EnableMenuItem(hmenu, mp->uid, MF_ENABLED);
                MS_CheckMenuItem(hmenu, mp->uid, MF_UNCHECKED);
                insert_count++;
                break;
            case MENUSTAT_INACTIVE:  
                /* gray out item */
                MS_EnableMenuItem(hmenu, mp->uid, MF_GRAYED);
                insert_count++;
                break;
            case MENUSTAT_TOGGLE_ON:
                MS_EnableMenuItem(hmenu, mp->uid, MF_ENABLED);
                MS_CheckMenuItem(hmenu, mp->uid, MF_CHECKED);
                insert_count++;
                break;
            case MENUSTAT_TOGGLE_OFF:
                MS_EnableMenuItem(hmenu, mp->uid, MF_ENABLED);
                MS_CheckMenuItem(hmenu, mp->uid, MF_UNCHECKED);
                insert_count++;
                break;
            case MENUSTAT_RADIO_OFF:
                /* toggle it off. */
                MS_EnableMenuItem(hmenu, mp->uid, MF_ENABLED);
                MS_CheckMenuItem(hmenu, mp->uid, MF_UNCHECKED);
                insert_count++;
                break;
            case MENUSTAT_RADIO_ON:
                /* toggle it on. */
                MS_EnableMenuItem(hmenu, mp->uid, MF_ENABLED);
                MS_CheckMenuItem(hmenu, mp->uid, MF_CHECKED);
                insert_count++;
                break;
            case MENUSTAT_NO_SHOW:
                /* supress display altogether */
                /* at this point, the menu item may or may not already be *
                 * in the menubar. If it's not there, MS_RemoveMenu will  *
                 * return an error, but let's ignore it (we'll assume that*
                 * the menu handle and uid are valid).                    */
                ret = MS_RemoveMenu(hmenu, mp->uid, MF_BYCOMMAND);
                break;
            case MENUSTAT_KEYONLY:
                /* supress display altogether */
                /* at this point, the menu item may or may not already be *
                 * in the menubar. If it's not there, MS_RemoveMenu will  *
                 * return an error, but let's ignore it (we'll assume that*
                 * the menu handle and uid are valid).                    */
                ret = MS_RemoveMenu(hmenu, mp->uid, MF_BYCOMMAND);
                break;
            default:
                taskAbort(NXLT("axSetMenuStatusFlags:invalid menu item code"));
                }
            }
        else if ( info[ix].menu_type == ITEM_MENU )
            {
            UINT item_state;
            mp = &info[ix];
            menu_level++;
            axSetMenuStatusFlags((AXWidget_menu)mp->value, wP, hmenu);
            menu_level--;
            if ( !mp->noshow && SubMenuNoShow(mp->submenu) )
                {
                /* noshow flag not set, but it has no-show children,
                 * so remove parent too.
                 */
                /* first make sure it hasn't already been removed! */
                item_len = MS_GetMenuString(info[0].menu_handle, insert_count,
                                                tmp_buf, 80, MF_BYPOSITION);
				if ( item_len > 0 )
					{
					tmp_str = PutMnemonicAndAccelInString(mp->name,
														mp->menu_key, 
														mp->accel_str);
                	if ( strcmp(tmp_buf, tmp_str) == 0 )
						{
                    	MS_RemoveMenu(info[0].menu_handle, insert_count,
														MF_BYPOSITION);
						}
					free(tmp_str);
					}
                }
            else if ( SubMenuGrayed(info[ix].submenu) )
                {
                /* this means all items of a submenu are grayed out,  *
                 * so gray out the submenu itself (unless the submenu *
                 * is a top level popup).                             */
                if ( !mp->noshow && menu_level > 0 )
                    {
                    /* only gray out cascading sub menus. */
                    MS_EnableMenuItem(info[0].menu_handle, insert_count,
                                            MF_BYPOSITION | MF_GRAYED);
                    }
                insert_count++;
                }
            else
                {
                item_state = MS_GetMenuState(info[0].menu_handle,insert_count,
                                                                MF_BYPOSITION);
                if ( item_state & MF_GRAYED )
                    {
                    /* enable item in case it was previously grayed. */
                    MS_EnableMenuItem(info[0].menu_handle, insert_count,
                                            MF_BYPOSITION | MF_ENABLED);
                    }
                insert_count++;
                }
            }
        }
}


/*************************************************************************
function: CallBackToMenu - Respond to a menu bar selection
*/
BOOL
CallBackToMenu(AXWidget_main mw, WPARAM wParam)
/* UINT wParam;    contains menu id */
{
    AXWidget_menu mP;


    WIDGET_PARANOID(mw, W_MAIN);
    mP = FindIdInMenuBar(mw->menuBar, wParam);
    if ( !mP )
        return (FALSE);

    if ( THIMhelpMode )
        {
        ElfPostHelp((mbchar*)mP->value);
        ElfbSetHelpMode(FALSE);
        }
    else
        {
        if ( mw->dialog )
            {
            CallWidget(mw->dialog->taskOwner, (AXWidget)mw->menuBar,
                        EV_CHANGED_, AxMakeStrData(-1, (char*)mP->value));
            }
        else if ( mw->workWindow )
            {
            AxSendMes(mw->workWindow->taskOwner, (mbchar*)mP->value,
                        strlen((char*)mP->value) + 1, APMENUBAR);
            }
        }
    return (TRUE);
}

/*************************************************************************
function: FindIdInMenuBar - Recurse thru menu struct looking for Windows UID
Returns NULL if not found.  axw_menu addr if found.
*/
static AXWidget_menu
FindIdInMenuBar(AXWidget_menu info, int uid)
{
    int ix;
    AXWidget_menu mP;
    UINT menu_id;


    WIDGET_PARANOID(info, W_MENUBAR);
    if ( !info )
        return NULL;

    menu_id = LOWORD(uid);
    for ( ix = 0; info[ix].menu_type != ITEM_MARK; ix++ )
        {
        if ( info[ix].menu_type == ITEM_FUNC )
            {
            if ( info[ix].uid == menu_id )
                return (&info[ix]);
            }
        else if ( info[ix].menu_type == ITEM_MENU )
            {
            mP = FindIdInMenuBar((AXWidget_menu)info[ix].value, menu_id);
            if ( mP )
                return (mP);
            }
        }
    return NULL;
}


void
FreeMenuBarItems(AXWidget_menu info)
{
    int ix;

    WIDGET_PARANOID(info, W_MENUBAR);

    for ( ix = 0; info[ix].menu_type != ITEM_MARK; ix++ )
        {
        if ( info[ix].menu_type == ITEM_FUNC )
            {
            free(info[ix].name);
            if ( info[ix].accel_str )
                free(info[ix].accel_str);
            free((void*)info[ix].value);
            }
        else if ( info[ix].menu_type == ITEM_MENU )
            {
            FreeMenuBarItems((AXWidget_menu)info[ix].value);
            free(info[ix].name);
            free( (char *)info[ix].value );
            }
        }
}


/* create a tiny bitmap to use to avoid a bug in the menu bar under NT4.0 */
/* Win95, where our "asterx" icon in the left of the menu bar will not    */
/* display (you get the flying windows icon scaled to the size of our icon) */
/* THings do work OK if our "asterx" icon is the second thing on the line, */
/* so as a real hack, we put an almost invisible bitmap up as the first    */
/* thing.  Note: more hack, if this tiny bitmap has a zero dimension the   */
/* system will put up a "cancel" box, as found in the upper right corner   */
/* of the title bar!  Microsoft must be using a zero birmap as a hacky flag */
HBITMAP get_tiny_bitmap(void)
{
    HDC hdc;
    HBITMAP hBitmap;
    HBITMAP hOldBitmap;

    hdc = MS_CreateCompatibleDC(NULL);
    hBitmap = MS_CreateCompatibleBitmap(hdc, 1, 1 );
    hOldBitmap = MS_SelectObject(hdc, hBitmap);
    MS_PatBlt(hdc, 0, 0, 1, 1, WHITENESS );
    MS_SelectObject(hdc,hOldBitmap);
    MS_DeleteDC(hdc);
    return( hBitmap );
}


static void
DrawMenuBitmap(HMENU hmenu, AXWidget_menu subptr, int modify_menu)
{
    int menu_item;
    HBITMAP hbm, inv_hbm;
    unsigned int flags;
	BITMAP bm;
    static HBITMAP mail_ihbm, ax_ihbm;
	static int bitmap_hyt;

    WIDGET_PARANOID(subptr, W_MENUBAR);
    /* get the menu "star" bitmap */
    if ( AxNewMailMenuIcon )
        {
        if ( mail_ihbm == (HBITMAP)NULL )
            {
            /* first time */
            hbm = (HBITMAP)LookupPixmap(NXLT("menu_mail"));
            mail_ihbm = AxWinGetInverseBitmap(hbm);
			MS_GetObject(mail_ihbm, sizeof(BITMAP), &bm);	
			bitmap_hyt = bm.bmHeight;
            }
        inv_hbm = mail_ihbm;
        }
    else
        {
        if ( ax_ihbm == (HBITMAP)NULL )
            {
            /* first time */
            hbm = (HBITMAP)LookupPixmap(NXLT("menu_ax"));
            ax_ihbm = AxWinGetInverseBitmap(hbm);
			MS_GetObject(ax_ihbm, sizeof(BITMAP), &bm);	
			bitmap_hyt = bm.bmHeight;
            }
        inv_hbm = ax_ihbm;
        }

	if ( bitmap_hyt > AxWinDefaultMenuHeight )
		subptr->height = bitmap_hyt + 1;

    /* add bitmap to menu */
    if ( RunningWin95Look && !modify_menu)
       {
       /* HACK WARNING - see description above "get_tiny_bitmap"  */
       hbm = get_tiny_bitmap();
       flags = MF_BITMAP | MF_DISABLED | MF_GRAYED;
       MS_AppendMenu(hmenu,  flags, (UINT)0, (LPCTSTR)hbm);
       }

    flags = MF_ENABLED | MF_POPUP | MF_BITMAP;
    if ( !modify_menu )
        {
        /* adding a new bitmap... */
        MS_AppendMenu(hmenu,flags,(UINT)subptr->menu_handle,(LPCTSTR)inv_hbm);
        }
    else
        {
        /* updating an already existing bitmap... */
        flags |= MF_BYPOSITION;
		if ( RunningWin95Look )
            menu_item = 1;
        else
            menu_item = 0;
        MS_ModifyMenu(hmenu,menu_item,flags,(UINT)subptr->menu_handle,(LPCTSTR)inv_hbm);
        }
    /* we do not delete the inverse bitmap handle, because the Windows
     * menubar needs it. Windows deletes it when the menubar is destroyed.
     */
}

void
axmsToggleStarMenus(void)
{
    AXWidget w;
    for ( w = WindowList; w; w = w->nextWin )
        {
        if ( w->type == W_MENUBAR )
            {
            DrawMenuBitmap(((AXWidget_menu)w)->menu_handle,
                            (AXWidget_menu)w->value, TRUE);
            MS_DrawMenuBar(w->parent->winid);
            }
        }
}


int
GetUIDfromMenu(AXWidget_menu mP, char *title, char *macro_name)
{
    int ix;


    WIDGET_PARANOID(mP, W_MENUBAR);
    for ( mP; mP->menu_type != ITEM_MARK;  mP++ )
        {
        if ( mP->menu_type == ITEM_MENU )
            {
            ix = GetUIDfromMenu((AXWidget_menu)mP->value, title, macro_name);
            if ( ix >= 0 )
                return (ix);
            else
                continue;
            }
        else if ( mP->menu_type == ITEM_FUNC )
            {
            if ( ((strcmp((char*)mP->value, macro_name)) == 0) &&
                        ((strcmp((char*)mP->name, title)) == 0) )
                return (mP->uid);
            else
                continue;
            }
    }
    return (-1);
}



/*************************************************************************
function: CreateOrChangeMenuBar - Create or Re-create menu bar
*/
AXWidget_menu
CreateOrChangeMenuBar(AXWidget_main w_main)
{
    register struct wind_struct *wp;
    AXWidget_menu menu_bar;
    menu_item_def *mp;
    HMENU old_menu_handle, new_menu_handle;
    int winID;

    if ( !w_main )
        return (AXWidget_menu)NULL;
    WIDGET_PARANOID(w_main, W_MAIN);
    winID = WindowIdFromShellWidget((long)w_main);
    wp = &window[winID];

    /* create the menu bar */
	new_menu_handle = NULL;
	old_menu_handle = NULL;
    if ( mp = (menu_item_def*) ElfFindSlider(wp) )
        {
        menu_bar = AxCrtMenuStructFromId(mp);
        WXCreateMenuBar(w_main, menu_bar);
        menu_bar->popups = mp;
        /* get the old menu handle if there is one so we can destroy it. */
        if ( w_main->menuBar )
            {
            new_menu_handle = menu_bar->menu_handle;
			ClipFromWindowList(w_main->menuBar);
   	    	MS_DestroyMenu(w_main->menuBar->menu_handle);
			FreeMenuBarItems(w_main->menuBar);
            }
        w_main->menuBar = menu_bar;
        wp->menu_bar = (AXWidget_menu) menu_bar;
        }
    else
        {
        menu_bar = NULL;
        return menu_bar;
        }

    AddToWindowList((AXWidget)menu_bar);

	if ( w_main->display )
		{
    	/* do toolbar */
    	ZXmCreateToolBar(w_main, mp, 0, NULL, CallBackToMenu,
    	                            (caddr_t)wp->window_id);
    	if ( !w_main->toolBar->uid )
        	w_main->toolBar->uid = GetAvailableUID((AXWidget)w_main->toolBar);
    	w_main->toolBar->initial_paint = TRUE;

    	if ( w_main->winid )
    	    {
			if ( new_menu_handle )
    	    	MS_SetMenu(w_main->winid, new_menu_handle);
    	    MS_DrawMenuBar(w_main->winid);
    	    XmRestructureWindow(w_main);
    	    }
		}

    return menu_bar;
}


/*************************************************************
 this function checks the state of each submenu item and
 returns TRUE if all are grayed, FALSE otherwise.
 *****************************/
static BOOL
SubMenuGrayed(HMENU sub_hmenu)
{
    int ix, item_count;
    UINT item_state;
    BOOL retval;


    item_count = MS_GetMenuItemCount(sub_hmenu);
    if ( item_count )
        retval = TRUE;
    /* loop thru submenu items. */
    for ( ix=0; ix < item_count; ix++ )
        {
        item_state = MS_GetMenuState(sub_hmenu, ix, MF_BYPOSITION);
        if ( item_state & MF_SEPARATOR )
            continue;    /* ignore separators. */
        if ( !(item_state & MF_GRAYED) )
            {
            /* we've reached a non-grayed item, return false. */
            retval = FALSE;
            break;
            }
        }
    return retval;
}



#if 0
static void
strip_ampersand(char *str)
{
    int curr_char;
    char *p1, *p2;

    p1 = p2 = str;

    //curr_char = 0;
    while ( *p2 != '\0' )
        {
        /* strip ampersand */
        if ( *p2 == '&' )
            p2 = p2 + 1;
        else
            *p1++ = *p2++;

        //curr_char++;
        }

    *p1 = '\0';
    return;
}           

/*************************************************************************
function: FindMenuInMenuBar - Recurse thru menu struct looking for Windows
HMENU.  Returns NULL if not found.  axw_menu addr if found.
*/
static AXWidget_menu FindMenuInMenuBar(info, menu)
AXWidget_menu info;
HMENU menu;
{
    int ix;
    AXWidget_menu mP;

    WIDGET_PARANOID( info, W_MENUBAR );
    if (!info)
        return (NULL);

    for (ix = 0; info[ix].menu_type != ITEM_MARK; ix++)
        {
        if (info[ix].menu_type == ITEM_MENU)
            {
            if (info[ix].submenu == menu)
                return ((AXWidget_menu) info[ix].value);
            else
                {
                mP = FindIdInMenuBar((AXWidget_menu)info[ix].value, menu);
                if (mP)
                    return (mP);
                }
            }
        }
    return (NULL);
}
#endif

