/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: winutl.c
   Applix ASC version: 86.6
   Date: Wed Nov 18 16:28:03 1998
*/
#include <stdlib.h>
#include <math.h>
#include <basicwin.h>
#include <aos.h>
#include <xmlib.h>
#include <paratm.h>
#include <parint.h>
#include <scac.h>
#include <axwinclr.h>




#if FOR_FILTER 
#define TaskAlloc( pid, size ) malloc( size )
#define DEFINE_GDI_ERROR_GLOBALS 1
#define REAL_WHITE_PIXEL (PALETTERGB( 255, 255, 255 ) )
int Running_Windows95;
#else
extern LOGPALETTE *AxWinPalette;
extern HPALETTE   AxWinPaletteHandle;
extern Pixmap ScratchMap;
extern int Running_WindowsNT, Running_Windows95;
extern char *ThimExecDir;
#endif

#define ZERO_NEGATIVE_VALUE(a) ((a < 0) ? (a=0) : (a=a))

extern PIXEL_VALUE BackPixelRGB;
extern PIXEL_VALUE ForeWorkPixelRGB, BackWorkPixelRGB;

extern HDC RootWin;
extern Window HostWin;
extern PIXEL_VALUE ForePixel, BackPixel;
extern AXWidget WindowList;
extern GC Gc1;
extern Display *Dpy;
extern short DpyDepth;
extern short THIMpid;
extern char *ThimApplixDir;

#include <winutl.p>




void
AxBitmapTest(HBITMAP hbm)
{
    int x = 0, y = 275;
    HDC mem_dc;
    HDC display_dc = MS_GetDC(NULL);
    BITMAP bm;
    HBITMAP old_hbm;

    MS_GetObject(hbm, sizeof(BITMAP), &bm);

    mem_dc = MS_CreateCompatibleDC(display_dc);
    old_hbm = MS_SelectObject(mem_dc, hbm);

    MS_BitBlt(display_dc, x,y, bm.bmWidth,bm.bmHeight, mem_dc,0,0, SRCCOPY);
    GdiFlush();

    MS_SelectObject(mem_dc, old_hbm);
    MS_DeleteDC(mem_dc);
    MS_ReleaseDC(NULL, display_dc);    
}




DefaultDepth()
{
    return (8);
}


void DebugMessage(char *str)
{
#if WIN_DEBUG
    MS_MessageBox(NULL, str, NXLT("debug"), MB_OK);
#endif
}


/** draws a transparent fill.  only called from **
 ** XFillRectangle and XFillPolygon and XFillArc. **/
BOOL
DrawTransparentFill(gc, dest_dc, src_dc, pattern_brush, points, num_points,
                                width, height, fill_type, rect_mask, screen_dc)
GC gc;
HDC dest_dc, src_dc;
HBRUSH pattern_brush;
POINT *points;
int num_points, width, height, fill_type;
BOOL rect_mask;
HDC screen_dc;  /*** this must be an unpackaged drawable! ***/
{
    int x, y, mask_x_offset, mask_y_offset;
    BOOL ret;
    HDC mask_dc, drawing_dc;
    HBRUSH src_brush, screen_brush, old_brush, old_mask_brush;
    HBITMAP mask_bm, old_hbm;
    DWORD fg_rop_code, bg_rop_code, obj_type;
    COLORREF old_color, fore_color;
    HPALETTE old_palette, old_mask_palette, old_drawing_palette;
    unsigned long white_pixel, black_pixel;


    x = gc->values.ts_x_origin;
    y = gc->values.ts_y_origin;

    obj_type = MS32_GetObjectType(dest_dc);
    if ( obj_type == OBJ_MEMDC && !num_points )
        {
        /* we are drawing to a memory dc, so use (0,0) */
        x = y = 0;
        }

    black_pixel = 10;    /* first color in our palette. */
    white_pixel = REAL_WHITE_PIXEL;

    /* we need mask offsets because we will be drawing to a  *
     * mask dc (memory) at an arbitrary point. the exception *
     * is when drawing a rectangle, in which case we will    *
     * always be drawing at the origin. for this rectangle   *
     * case, we set the mask offsets to zero. (see below).   */
    mask_x_offset = x;
    mask_y_offset = y;

    /* set up a mask DC. Use RootWin to get a color-compatible DC. */
    mask_dc = MS_CreateCompatibleDC(NULL);
    if ( rect_mask && screen_dc )
        {
        /* mask dc will be used as a source dc, so it needs to be color. */
        mask_bm = MS_CreateCompatibleBitmap(RootWin, width+abs(x), height+abs(y));
        }
    else
        {
        /* mask bitmap will be used as a mask, so it needs to be monochrome. */
        mask_bm = MS_CreateCompatibleBitmap(mask_dc, width+abs(x), height+abs(y));    
        }
    old_hbm = MS_SelectObject(mask_dc, mask_bm);
    old_mask_palette = SelectAndRealizeAxWinPalette(mask_dc);

    /* first, fill the mask DC with zeros */
    MS_PatBlt(mask_dc, 0, 0, width+abs(x), height+abs(y), BLACKNESS);

    /* then draw the shape with the specified pattern (stipple) *
     * brush.  this will give us a mask of that pattern.        */
    old_mask_brush = MS_SelectObject(mask_dc, pattern_brush);
    /* make sure the 1 bits in the pattern get drawn with 1, *
     * and the 0 bits get drawn  with 0                      */
    MS_SetBkColor(mask_dc, GET_COLOR_VALUE(white_pixel));
    MS_SetTextColor(mask_dc, GET_COLOR_VALUE(black_pixel));
    if ( fill_type == FILL_TRANS_RECT )
        {
        /* set mask offsets to zero. see comment above */
        x = points[0].x;
        y = points[0].y;        
        mask_x_offset = 0;
        mask_y_offset = 0;
        ret = MS_PatBlt(mask_dc, 0, 0, width, height, PATCOPY);
        }
    if ( fill_type == FILL_TRANS_POLY )
        {
        ret = MS_Polygon(mask_dc, points, num_points);
        /* zero out any negative positions */
        ZERO_NEGATIVE_VALUE(x);
        ZERO_NEGATIVE_VALUE(y);
        ZERO_NEGATIVE_VALUE(mask_x_offset);
        ZERO_NEGATIVE_VALUE(mask_y_offset);
        }
    if ( fill_type == FILL_TRANS_ARC )
        {
        /* points array contains the necessary radial points */
        ret = MS_Pie(mask_dc, x, y, x+width, y+height,
                    points[1].x, points[1].y,
                    points[2].x, points[2].y);
        }
    if ( !ret )
        taskAbort("DrawTransparentFill: could not draw shape!");


    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    if ( rect_mask && screen_dc )
        {
        drawing_dc = screen_dc;
        old_drawing_palette = SelectAndRealizeAxWinPalette(drawing_dc);

        /* we are drawing a rectangle thru a clip mask.  select the       *
         * desired color (i.e. the GC's foreground) into the display's    *
         * DC.  set the ROP code so that black pixels (0) in the source   *
         * DC are not painted (transparent), and the white pixels (1) are *
         * painted with the brush that is selected into the screen_dc.    *
         * in essence, both the clip_mask bitmap and the mask DC are used *
         * as masks. the clip mask is simply the clipping mask, and the   *
         * mask DC is the "transparency" mask.         -donato            */
        screen_brush = MS_CreateSolidBrush(fore_color);
        old_brush = MS_SelectObject(drawing_dc, screen_brush);
        old_color = MS_SetBkColor(drawing_dc, fore_color);

        fg_rop_code = 0x00E20746;
        bg_rop_code = 0x00AA0029;
#if FOR_FILTER
        ret = MS32_MaskBlt(drawing_dc, x, y, width, height,
                        mask_dc, mask_x_offset, mask_y_offset,
                        gc->values.clip_mask, 0, y - gc->values.clip_y_origin,
                        MAKEROP4(fg_rop_code, bg_rop_code));
#else
        ret = AxWinMaskBlt(drawing_dc, x, y, width, height,
                        mask_dc, mask_x_offset, mask_y_offset,
                        gc->values.clip_mask, 0, y - gc->values.clip_y_origin,
                        fg_rop_code, bg_rop_code);
#endif
        /* cleanup */
        MS_SetBkColor(drawing_dc, old_color);
        MS_SelectObject(drawing_dc, old_brush);
        UnSelectPalette(drawing_dc, old_drawing_palette);
        MS_DeleteObject(screen_brush);
        UnSelectPalette(mask_dc, old_mask_palette);
        MS_SelectObject(mask_dc, old_hbm);
        MS_SelectObject(mask_dc, old_mask_brush);
        MS_DeleteObject(mask_bm);
        MS_DeleteDC(mask_dc);
        }
    else
        {
        /* we need to delete the mask dc because the MaskBlt call below
         * will try to select the mask bitmap into another dc
         * (when running on Windows 95).
         */
        UnSelectPalette(mask_dc, old_mask_palette);
        MS_SelectObject(mask_dc, old_hbm);
        MS_SelectObject(mask_dc, old_mask_brush);
        MS_DeleteDC(mask_dc);

        old_palette = SelectAndRealizeAxWinPalette(src_dc);
        /* fill the source DC with the foreground color. this source *
         * DC will then be Blt'd thru the mask with the appropriate  *
         * rop_code to make it transparent.                          */
        src_brush = MS_CreateSolidBrush(fore_color);
        old_brush = MS_SelectObject(src_dc, src_brush);
        MS_PatBlt(src_dc, 0, 0, width, height, PATCOPY);

        /* SRCAND the destination, SRCCOPY the source */
        fg_rop_code = SRCCOPY;
        bg_rop_code = 0x00AA0029;
        /* BLT the source DC (some specified color) thru the mask  *
         * bitmap (some specified pattern) onto the destination DC *
         * using a "transparency" rop_code. the 1 bits in the mask *
         * are painted with the source color, and the 0 bits are   *
         * left untouched.                                         */
#if FOR_FILTER
        ret = MS32_MaskBlt(dest_dc, x, y, width, height,
                            src_dc, 0, 0,
                            mask_bm, mask_x_offset, mask_y_offset,
                            MAKEROP4(fg_rop_code, bg_rop_code));
#else
        ret = AxWinMaskBlt(dest_dc, x, y, width, height,
                            src_dc, 0, 0,
                            mask_bm, mask_x_offset, mask_y_offset,
                            fg_rop_code, bg_rop_code);
#endif
        /* cleanup */
        MS_SelectObject(src_dc, old_brush);
        MS_DeleteObject(src_brush);
        UnSelectPalette(src_dc, old_palette);
        MS_DeleteObject(mask_bm);
        }

    return ret;
}



/*******************************************************************
* function; GetPolyInfo - returns polygon info:
*                            width, height, minimum x, minimum y
***/
void
GetPolyInfo(POINT *points, int num_points, int *width, int *height,
                                            int *minx, int *miny)
{
    int ix, max_y, max_x, min_y, min_x;


    min_x = max_x = points[0].x;
    min_y = max_y = points[0].y;
    for ( ix=1; ix < num_points; ix++ )
        {
        if ( points[ix].x < min_x )
            min_x = points[ix].x;

        if ( points[ix].y < min_y )
            min_y = points[ix].y;

        if ( points[ix].x > max_x )
            max_x = points[ix].x;

        if ( points[ix].y > max_y )
            max_y = points[ix].y;
        }

    *minx = min_x;
    *miny = min_y;
    *width = max_x - min_x; 
    *height = max_y - min_y;
}


BOOL
PaintPixmap(HBITMAP hbm, HDC hdc, GC gc, int xpos, int ypos, int width,
                        int height, int src_x, int src_y, HBITMAP mask)
/*** the hdc must be unpackaged! ***/
{
    HDC mem_hdc;
    HBITMAP old_hbm;
    COLORREF fore_color, back_color;
    COLORREF old_bk_color, old_text_color;
    DWORD rop_code;
    HPALETTE old_palette;
    BOOL ret;
    POINT points[3];
    BITMAP bm;


    old_palette = SelectAndRealizeAxWinPalette(hdc);
    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    back_color = GET_COLOR_VALUE(gc->values.background);
    switch (gc->values.function)
        {
        case GXcopy:
            old_bk_color = MS_SetBkColor(hdc, fore_color);
            old_text_color = MS_SetTextColor(hdc, back_color);
            rop_code = SRCCOPY;
            break;
        case GXor:
            old_bk_color = MS_SetBkColor(hdc, fore_color);
            old_text_color = MS_SetTextColor(hdc, back_color);
            rop_code = SRCPAINT;
            break;
        case GXand:
            old_bk_color = MS_SetBkColor(hdc, fore_color);
            /* set background to all 1's (white). */
            old_text_color = MS_SetTextColor(hdc, PALETTERGB(255,255,255));
            rop_code = SRCAND;
            break;
        case GXxor:
            old_bk_color = MS_SetBkColor(hdc, back_color);
            old_text_color = MS_SetTextColor(hdc, fore_color);
            rop_code = SRCINVERT;
            break;
        case GXandInverted:
            old_bk_color = MS_SetBkColor(hdc, fore_color);
            /* set background to all 1's (white). */
            //old_text_color = MS_SetTextColor(hdc, GET_COLOR_VALUE(255));
            old_text_color = MS_SetTextColor(hdc, back_color);
            rop_code = 0x00220326;    /* NOT src AND dst */
            break;
        default:
            old_bk_color = MS_SetBkColor(hdc, fore_color);
            old_text_color = MS_SetTextColor(hdc, back_color);
            rop_code = SRCCOPY;
            break;
        }

    mem_hdc = MS_CreateCompatibleDC(NULL);
    old_hbm = MS_SelectObject(mem_hdc, hbm);

    if ( mask )
        {
        /* a mask, draw the bitmap through the mask */
        points[0].x = xpos;            /* upper left corner */
        points[0].y = ypos;
        points[1].x = xpos + width;    /* upper right corner */
        points[1].y = ypos;
        points[2].x = xpos;
        points[2].y = ypos + height;   /* lower left corner */
        /* the points array is a parallelogram into which the source DC *
         * will be copied (the bitmap will stretch as necessary). Since *
         * the dimensions of this parallelogram may differ from those of*
         * the bitmap, we obtain the bitmap dimensions first.           */
        MS_GetObject(hbm, sizeof(BITMAP), (LPSTR) &bm);
#if FOR_FILTER
        ret = MS32_PlgBlt(hdc, points, mem_hdc, src_x, src_y,
                        bm.bmWidth, bm.bmHeight, mask, 0, 0);
#else
        ret = AxWinPlgBlt(hdc, points, mem_hdc, src_x, src_y,
                        bm.bmWidth, bm.bmHeight, mask, 0, 0);
#endif
        }
    else
        {
        MS_GetObject(hbm, sizeof(BITMAP), (LPSTR) &bm);
        if ( (width > bm.bmWidth) && (height > bm.bmHeight) )
            {
            ret = MS_StretchBlt(hdc, xpos, ypos, width, height,
                                mem_hdc, src_x, src_y, bm.bmWidth, bm.bmHeight,
                                rop_code);
            }
        else
            {
            ret = MS_BitBlt(hdc, xpos, ypos, width, height,
                            mem_hdc, src_x, src_y, rop_code);
            }
        }

    /* cleanup */
    MS_SetBkColor(hdc, old_bk_color);
    MS_SetTextColor(hdc, old_text_color);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteDC(mem_hdc);
    UnSelectPalette(hdc, old_palette);
    return ret;
}


int
GetPenStyle(GC gc)
{
    int pen_style;


    switch (gc->values.line_style)
        {
        case LineSolid:
            pen_style = PS_SOLID;
            break;
        case LineOnOffDash:
        case LineDoubleDash:    /* for now, same as LineOnOffDash... */
            if ( gc->values.dash_list_size > 0 )
                pen_style = PS_USERSTYLE | PS_GEOMETRIC;
            else
                {
                if ( Running_Windows95 )
                    pen_style = PS_DOT;
                else
                    pen_style = PS_ALTERNATE;    /* every other pixel on */
                }
            break;        
        default:
            if ( gc->values.dash_list_size > 0 )
                pen_style = PS_USERSTYLE | PS_GEOMETRIC;
            else
                pen_style = PS_SOLID;    /* for now? */
            break;
        }

    switch (gc->values.cap_style)
        {
        case CapButt:
            {
            /* CapButt is the default gc value. if line width is zero *
             * (i.e. single pixel), then we set the Windows pen to    *
             * be "COSMETIC", which is a simple one pixel width line. *
             * otherwise we set the appropriate style.                */
#if 1
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_ENDCAP_FLAT;
            else
                pen_style |= PS_GEOMETRIC | PS_ENDCAP_FLAT;
#else
            if ( gc->values.line_width <= 1 )
                pen_style |= PS_COSMETIC;
            else
                pen_style |= PS_GEOMETRIC | PS_ENDCAP_FLAT;
#endif
            break;
            }
        case CapRound:
            //if ( gc->values.line_width <= 1 )
            //    pen_style |= PS_COSMETIC;
            //else
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_ENDCAP_ROUND;
            else
                pen_style |= PS_GEOMETRIC | PS_ENDCAP_ROUND;
            break;
        case CapProjecting:
            //if ( gc->values.line_width <= 1 )
            //    pen_style |= PS_COSMETIC;
            //else
                /* is this right? */
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_ENDCAP_SQUARE;
            else
                pen_style |= PS_GEOMETRIC | PS_ENDCAP_SQUARE;
            break;
        default:
            pen_style |= PS_COSMETIC;
            break;
        }

    switch (gc->values.join_style)
        {
        case JoinMiter:
            {
            /* JoinMiter is default gc value. if line width is zero   *
             * (i.e. single pixel), then we set the Windows pen to    *
             * be "COSMETIC", which is a simple one pixel width line. *
             * otherwise we set the appropriate style.                */
            //if ( !gc->values.line_width )
            //    pen_style |= PS_COSMETIC;
            //else
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_JOIN_MITER;
            else
                pen_style |= PS_GEOMETRIC | PS_JOIN_MITER;
            //break;
            }
        case JoinRound:
            //if ( !gc->values.line_width )
            //    pen_style |= PS_COSMETIC;
            //else
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_JOIN_ROUND;
            else
                pen_style |= PS_GEOMETRIC | PS_JOIN_ROUND;
            break;
        case JoinBevel:
            //if ( !gc->values.line_width )
            //    pen_style |= PS_COSMETIC;
            //else
            if ( pen_style & PS_ALTERNATE )
                pen_style = pen_style;
            else if ( pen_style & PS_GEOMETRIC )
                pen_style |= PS_JOIN_BEVEL;
            else
                pen_style |= PS_GEOMETRIC | PS_JOIN_BEVEL;
            break;
        default:
            pen_style |= PS_COSMETIC;
            break;
        }

    return pen_style;
}


/******************************************************************
function: DrawXORstring - XORs a string to the screen using Blt 
       functions since windows has no automatic way of doing this.
*/
int
DrawXORstring(HDC hdc, GC gc, char *string, int length, int xpos, int ypos)
/*** the hdc must be unpackaged! ***/
{
    int ret1, ret2;
    int width, height, y_offset;
    HDC     mem_hdc;
    HFONT   hfont, old_font;
    HBITMAP mem_hbm, old_hbm;
    COLORREF fore_color, back_color;
    SIZE char_size;
    DWORD rop_code;
    TEXTMETRIC tm;
    HBRUSH hbrush, old_brush;


    /* set up GC colors. */
    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    back_color = GET_COLOR_VALUE(gc->values.background);
    
    /* need to get string metrics */
    MS_GetTextMetrics(hdc, &tm);
    y_offset = tm.tmAscent;
    MS_GetTextExtentPoint32(hdc, (LPCTSTR)string, length, &char_size);
    width = char_size.cx;
    height = char_size.cy;

    /* create the memory DC for drawing */
    mem_hdc = MS_CreateCompatibleDC(NULL);
    mem_hbm = MS_CreateCompatibleBitmap(mem_hdc, width, height);
    old_hbm = MS_SelectObject(mem_hdc, mem_hbm);

    /* use specified font (from GC) */
    hfont    = gc->values.font;
    old_font = MS_SelectObject(mem_hdc, hfont);

    /* make sure memory DC is filled with 0's (black). */
    MS_PatBlt(mem_hdc, 0, 0, width, height, BLACKNESS);

    /* draw the text (mono) to the memory DC */
    MS_SetBkColor(mem_hdc, RGB(0,0,0));
    MS_SetTextColor(mem_hdc, RGB(255,255,255));
    MS_TextOut(mem_hdc, 0, 0, (LPCTSTR)string, length);

#if 1
    rop_code = SRCINVERT;    /* XOR source and dest */
    MS_SetBkColor(hdc, fore_color);
    MS_SetTextColor(hdc, back_color);
    ret1 = MS_BitBlt(hdc, xpos , ypos - y_offset, width, height,
                                    mem_hdc, 0, 0, rop_code);

    rop_code = PATINVERT;    /* XOR brush and destination */
    hbrush = MS_CreateSolidBrush(back_color);
    old_brush = MS_SelectObject(hdc, hbrush);
    ret2 = MS_PatBlt(hdc, xpos , ypos - y_offset, width, height, rop_code);

    MS_SelectObject(hdc, old_brush);
    MS_DeleteObject(hbrush);
#else
    /* to accomplish the XOR we need to do 2 blts: AND and OR */
    rop_code = SRCAND;
    MS_SetBkColor(hdc, fore_color);
    MS_SetTextColor(hdc, GET_COLOR_VALUE(255));    /* 1's (white). */
    ret1 = MS_BitBlt(hdc, xpos, ypos - y_offset, width, height,
                                    mem_hdc, 0, 0, rop_code);
    rop_code = SRCPAINT;
    MS_SetBkColor(hdc, fore_color);
    MS_SetTextColor(hdc, back_color);
    ret2 = MS_BitBlt(hdc, xpos, ypos - y_offset, width, height,
                                    mem_hdc, 0, 0, rop_code);
#endif

    /* clean up */
    MS_SelectObject(mem_hdc, old_font);
    MS_SelectObject(mem_hdc, old_hbm);
    MS_DeleteObject(mem_hbm);
    MS_DeleteDC(mem_hdc);
    return( ret1 & ret2 );
}


static HBITMAP AxWinDefaultBitmap;

/***
    The following function gets the "default memory bitmap"
    so that we can use it as a "stock" object; that is, we
    don't delete it and we select it into DCs when we need
    to make sure our own bitmaps our de-selected.   -donato
 ***/
void
InitDefaultBitmap(void)
{
    HDC mem_dc;

    mem_dc = MS_CreateCompatibleDC(NULL);
    AxWinDefaultBitmap = MS_GetCurrentObject(mem_dc, OBJ_BITMAP);
    MS_DeleteDC(mem_dc);
}

/** "InsureDrawable" is called to make sure that we have a handle to */
/*  a surface on which one can draw.  There are times in the product where */
/*  the "window" carried around in a widget is only a handle to a bitmap,  */
/*  not a real HDC.  In this case, we create and HDC, select the bitmap into */
/*  it so the rest of the code can draw on the bitmap, and return the handle */
/*  to this newly created HDC.  The flag is because the caller must delete   */
/*  the HDC if one is created, via: "MS_DeleteDC(hDC);"                      */ 
HDC
InsureDrawable(HANDLE in_drw, int *need_to_delete_later)
{
    HDC hDC;
    short obj_type;

    *need_to_delete_later = FALSE;
    if ( !in_drw )
        return NULL;

    if ( !IS_PACKAGED_DRAWABLE(in_drw) )
        {
        /*** ASSUME unpackaged bitmap handle */
        hDC = MS_CreateCompatibleDC(NULL);
        MS_SelectObject(hDC, (HBITMAP)in_drw);
        *need_to_delete_later = TRUE;
        return hDC;
        }

    obj_type = GET_DRAWABLE_TYPE(in_drw);
    if ( obj_type == AX_HWND_TYPE )
        {
        /* we have a window handle. get a DC from it */
        HWND hwnd = (HWND)GET_DRAWABLE_HANDLE(in_drw);
        hDC = MS_GetDC(hwnd);
        *need_to_delete_later = TRUE;
        }
    else if ( (obj_type == AX_DC_TYPE) || (obj_type == AX_MEMDC_TYPE) )
        {
        hDC = (HDC)GET_DRAWABLE_HANDLE(in_drw);
        }
    else
        tempAbort("Unknown object passed to InsureDrawable()");

    return hDC;
}

void
RemoveDrawable(HANDLE in_drw, HDC remove_this_drawable)
{
    short obj_type;

    if ( !IS_PACKAGED_DRAWABLE(in_drw) )
        {
        /*** ASSUME unpackaged bitmap handle */
        /* select a default bitmap into the memory dc so that we
         * select out our bitmap.
         */
#if FOR_FILTER
        /* filters may not have set this, so make sure it is. */
        if ( !AxWinDefaultBitmap )
            InitDefaultBitmap();
#endif
        MS_SelectObject(remove_this_drawable, AxWinDefaultBitmap);
        MS_DeleteDC(remove_this_drawable);
        return;
        }

    obj_type = GET_DRAWABLE_TYPE(in_drw);
    if ( obj_type == AX_HWND_TYPE )
        {
        HWND hwnd = (HWND)GET_DRAWABLE_HANDLE(in_drw);
        MS_ReleaseDC(hwnd, remove_this_drawable);
        }
    else
        tempAbort("RemoveDrawable: invalid drawable!");
#if 0
        {
        /*** ASSUME an HDC that has a bitmap selected into it. ***/
        if ( Old_Bitmap_Handle )
            MS_SelectObject(remove_this_drawable, Old_Bitmap_Handle);
        MS_DeleteDC(remove_this_drawable);
        Old_Bitmap_Handle = NULL;
        }
#endif
}

int
IsMonochromeDrawable(HANDLE drw)
{
    BITMAP bm;
    int retval = FALSE;

    if ( !IS_PACKAGED_DRAWABLE(drw) )
        {
        /*** we can ASSUME an unpackaged bitmap handle. */
        MS_GetObject(drw, sizeof(BITMAP), (LPSTR)&bm);
        if ( bm.bmBitsPixel == 1 )
            retval = TRUE;
        }
    return retval;
}

static void
AddBitmapStructToXImage(XImage *image, unsigned int image_size)
{
    int i;
    unsigned int size;
    LPBITMAPINFOHEADER headerP;
    RGBQUAD *colorP;

    size = sizeof(BITMAPINFO) + (PALETTESIZE*sizeof(RGBQUAD));
    image->bitmap_info = (LPBITMAPINFO)TaskAlloc(THIMpid, size);
    memset(image->bitmap_info, 0, size);

    headerP = &image->bitmap_info->bmiHeader;
    headerP->biSize = sizeof(BITMAPINFOHEADER);
    headerP->biWidth = image->width;
    headerP->biHeight = image->height;
    headerP->biPlanes = 1;
    headerP->biBitCount = image->bits_per_pixel;
    headerP->biCompression = BI_RGB;    /* no compression */
    headerP->biSizeImage = image_size;  /* size in bytes */
    headerP->biClrUsed = 0;       /* full color table is used */
    headerP->biClrImportant = 0;  /* all colors are important */

    if ( DpyDepth > 8 )
       return;

#if !FOR_FILTER     /* I do not think this is called by filters, and */
                   /* "AxWinPalette" s not defined in the filters  */
    colorP = &image->bitmap_info->bmiColors[0];
    for ( i=0; i < PALETTESIZE; i++ )
        {
        colorP->rgbRed = AxWinPalette->palPalEntry[i].peRed;
        colorP->rgbGreen = AxWinPalette->palPalEntry[i].peGreen;
        colorP->rgbBlue =  AxWinPalette->palPalEntry[i].peBlue;
        colorP->rgbReserved = 0;
        colorP++;
        }
#endif
}




HPALETTE
SelectAndRealizeAxWinPalette(HDC hdc)
{
    HPALETTE old_palette = NULL;

#if FOR_FILTER
    return( (HPALETTE)NULL );
#else
    if ( AxWinPaletteHandle )
        {
        old_palette = MS_SelectPalette(hdc, AxWinPaletteHandle, FALSE);
        MS_RealizePalette(hdc);
        }
    return old_palette;
#endif
}

void
UnSelectPalette(HDC hdc, HPALETTE hpalette)
{
    if ( hpalette )
        {
        MS_SelectPalette(hdc, hpalette, FALSE);
        MS_RealizePalette(hdc);
        }
}


#if DEBUG_RESOURCES    /*  {  */
/** the following wrapper routines will allow use to keep track of */
/*  various resources, to help find where we are leaking them            */

#define MAX_DEBUG_HDC 500
#define RES_INC 100
static HDC hdc_list[MAX_DEBUG_HDC];
int SizeResList = 0;
HGDIOBJ *ResListP = (HGDIOBJ *)NULL;
int *ResTypesP = (int *)NULL;

struct {
    int num_hdcs;
    int num_pens;
    int num_fonts;
    int num_bitmaps;
    int num_brushes;
    int num_palettes;
    int num_regions;
    } Resources;



void change_res_count( type, change )
int type, change;
{
    if ( type == PEN_HANDLE )
       Resources.num_pens = Resources.num_pens + change;
    else if ( type == FONT_HANDLE )
       Resources.num_fonts = Resources.num_fonts + change;
    else if ( type == BITMAP_HANDLE )
       Resources.num_bitmaps = Resources.num_bitmaps + change;
    else if ( type == BRUSH_HANDLE )
       Resources.num_brushes = Resources.num_brushes + change;
    else if ( type == PALETTE_HANDLE )
       Resources.num_palettes = Resources.num_palettes + change;
    else if ( type == REGION_HANDLE )
       Resources.num_regions  = Resources.num_regions + change;
    return;
}

HGDIOBJ look_handles[5];

data_ptr report_resource_counts()
{
   char buff[100];
   data_ptr aP, dP;
   int count = 0;
   HGDIOBJ *resP;
   int *restypeP;
   int i, k;

    /* look for the handle on the list, "look_handles" set via debugger */
    resP = ResListP;
    restypeP = ResTypesP;
    for ( i=0; i<SizeResList; i++ )
       {
       for ( k=0; k < 5; k++ )
          {
          if ( (*resP == look_handles[k]) && (*resP != 0) )
             {
             /* found it */
             count++;
             }
          }
       resP++;
       restypeP++;
       }
 
#if !FOR_FILTER
   aP = AxMakeArray(6);

   sprintf( buff, "pens:      %d", Resources.num_pens );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,0,dP );

   sprintf( buff, "fonts:     %d", Resources.num_fonts );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,1,dP );

   sprintf( buff, "bitmaps:   %d", Resources.num_bitmaps );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,2,dP );

   sprintf( buff, "brushes:   %d", Resources.num_brushes );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,3,dP );

   sprintf( buff, "Palettes:  %d", Resources.num_palettes );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,4,dP );

   sprintf( buff, "regions:   %d", Resources.num_regions );
   dP = AxMakeStrData( -1, buff );
   aP = WriteArray(aP,5,dP );
#endif

   return( aP );
}



void remember_Handle( handle, type )
HGDIOBJ handle;
int type;
{
    int i;
    HGDIOBJ *resP;
    int *restypeP;
    if ( ResListP == (HGDIOBJ *)NULL )
       {
       /* initialize */
       SizeResList = RES_INC;
       ResListP = (HGDIOBJ *)calloc( 1, SizeResList * sizeof(HGDIOBJ) );
       ResTypesP = (int *)calloc( 1, SizeResList * sizeof( int ) );
       }

    /* look for a place to put the element on the list */
    resP = ResListP;
    restypeP = ResTypesP;
    for ( i=0; i<SizeResList; i++ )
       {
       if ( *resP == (HGDIOBJ *)NULL )
         {
         /* found a place */
         *resP = handle;
         *restypeP = type;
         change_res_count( type, 1 );
         return;
         }
       resP++;
       restypeP++;
       }

    /* no place on the list, make the  list bigger */
    ResListP = (HGDIOBJ *)realloc( ResListP, 
                                   (SizeResList + RES_INC)*sizeof(HGDIOBJ) );
    ResTypesP = (int *)realloc( ResTypesP,
                                   (SizeResList + RES_INC)*sizeof( int ) );

    resP = ResListP + SizeResList;   /* the first new element */
    restypeP = ResTypesP + SizeResList;

    memset( resP, 0, RES_INC*sizeof(HGDIOBJ) );
    SizeResList = SizeResList + RES_INC;

    *resP= handle;
    *restypeP = type;
    change_res_count( type, 1 );
    return;
}
    

HGDIOBJ debug_handle;
void debug_stop()
{
  int i;

  i = 0;
  i++;
  return;
}


void forget_Handle(  handle )
HGDIOBJ handle;
{
    int i;
    HGDIOBJ *resP;
    int *restypeP;

    if ( handle == debug_handle )
       {
       /* we are trying to free something we are monitoring */
       debug_stop();
       }

    /* look for the handle on the list */
    resP = ResListP;
    restypeP = ResTypesP;
    for ( i=0; i<SizeResList; i++ )
       {
       if ( *resP == handle )
          {
          /* found it */
          *resP = (HGDIOBJ *)NULL;
          change_res_count( *restypeP, -1 );
          return;
          }
       resP++;
       restypeP++;
       }

#if !FOR_FILTER
#if 0
    /* can not do this until we are fully instrumented, since DeleteObject */
    /* is called generically for all objects, whether or not we record them  */
    taskAbort( "forget_Handle - did not find handle on chached list" );
#else
    AxInfoMessage( -1, 0, (char *)NULL, 
               XLT("forget_Handle - did not find handle on chached list") );
#endif
#endif
    return;
}


void remember_HDC( hdc )
HDC hdc;
{
    int i;

    /* look for a place to put the new DC in our cached list */
    for ( i=0; i<MAX_DEBUG_HDC; i++ )
       {
       if ( hdc_list[i] == (HDC)NULL )
          {
          Resources.num_hdcs++;
          hdc_list[i] = hdc;
          return;
          }
       }
    taskAbort("too many HDC's" );
    return;
}

void forget_HDC( hdc )
HDC hdc;
{
    int i;

    /* look for the DC in our cached list */
    for ( i=0; i<MAX_DEBUG_HDC; i++ )
       {
       if ( hdc_list[i] == hdc )
          {
          Resources.num_hdcs--;
          hdc_list[i] = (HDC)NULL;
          return;
          }
       }
#if !FOR_FILTER
#if 0
    taskAbort("my_Del_HDC - could not find HDC in cached list" ); 
#else
    AxInfoMessage( -1, 0, (char *)NULL, 
                          XLT("my_Del_HDC - could not find HDC in cached list") );
#endif
#endif
    return;
}

HDC my_CreateDC( driver, device, output, data)
LPCTSTR driver, device, output;
CONST DEVMODE *data;
{
    HDC ret;
    ret = CreateDC( driver, device, output, data);
    if ( ret == (HDC)NULL )
       taskAbort( "Bad return from CreateDC()" );
    remember_HDC( ret );
    return( ret );
}


HDC my_CreateCompatibleDC( hdc )
HDC hdc;
{

    HDC ret_hdc;
    ret_hdc = CreateCompatibleDC( hdc );
    if ( ret_hdc == (HDC)NULL )
       taskAbort("bad return from CreateCompatibleDC()");

    remember_HDC( ret_hdc );

    return( ret_hdc );
}
    

int my_DeleteDC( hdc )
HDC hdc;
{
    int ret;
    forget_HDC( hdc );

    ret = DeleteDC( hdc );   /* do the Windows thing */
    if ( !ret )
       taskAbort("bad return from DeleteDC()");
    return( ret );
}

HDC my_GetDC( window )
HWND window;
{
    HDC hdc;

    hdc = GetDC( window );
    if ( hdc == (HDC)NULL )
        taskAbort( "bad return from GetDC()" );
    remember_HDC(  hdc );
 
    return( hdc );
}


int my_ReleaseDC( window, hdc )
HWND window;
HDC hdc;
{
    int ret;
    forget_HDC( hdc );
 
    ret = ReleaseDC( window, hdc );   /* do the Windows thing */
    if ( !ret )
       taskAbort("bad return from ReleaseDC()");
    return( ret );
}



HPEN my_CreatePen(style, width, color)
int style, width;
COLORREF color;
{
    HPEN ret_hpen;

    ret_hpen = CreatePen(style, width, color);
    if ( ret_hpen == (HPEN)NULL )
       taskAbort("bad  return from CreatePen");

    remember_Handle( ret_hpen, PEN_HANDLE );

    return( ret_hpen );
}


HPEN my_ExtCreatePen( style, width, brush, size_style, style_bits )
DWORD style, width;
LOGBRUSH *brush;
DWORD size_style;
DWORD *style_bits;
{
    HPEN ret_hpen;
 
    ret_hpen = ExtCreatePen( style, width, brush, size_style, style_bits );
    if ( ret_hpen == (HPEN)NULL )
       taskAbort("bad  return from ExtCreatePen");
 
    remember_Handle( ret_hpen, PEN_HANDLE );
 
    return( ret_hpen );
}


int my_DeleteObject( handle )
HGDIOBJ handle;
{
    int ret;
    forget_Handle( handle );

    ret = DeleteObject( handle );
    if ( !ret )
       taskAbort("bad return from DeleteObject()");
    return( ret );
}


HFONT my_CreateFontIndirect( log_struct )
LOGFONT *log_struct;
{
    HFONT ret_font;

    ret_font = CreateFontIndirect( log_struct );
    if ( ret_font == (LOGFONT *)NULL )
       taskAbort("Bad return from CreateFontIndirect");
    remember_Handle( ret_font, FONT_HANDLE );
    return( ret_font );
}



HBITMAP my_CreateBitmap( width, height, planes, bits, color )
int width, height;
UINT planes, bits;
void *color;
{
    HBITMAP ret;
    ret = CreateBitmap( width, height, planes, bits, color );
    if ( ret == (HBITMAP)NULL )
       taskAbort("bad return from CreateBitmap()");
    remember_Handle( ret, BITMAP_HANDLE );
    return( ret );
}


HBITMAP my_CreateBitmapIndirect( bits )
BITMAP *bits;
{
    HBITMAP ret;
    ret = CreateBitmapIndirect( bits );
    if ( ret == (HBITMAP)NULL )
       taskAbort("bad return from CreateBitmapIndirect()");
    remember_Handle( ret, BITMAP_HANDLE );
    return( ret );
}


HBITMAP my_CreateCompatibleBitmap( hdc, width, height )
HDC hdc;
int width, height;
{
    HBITMAP ret;
    ret = CreateCompatibleBitmap( hdc, width, height );
    if ( ret == (HBITMAP)NULL )
       taskAbort("bad return from CreateCompatibleBitmap()");
    remember_Handle( ret, BITMAP_HANDLE );
    return( ret );
}


HBITMAP my_CreateDIBitmap( hdc, data, flag, init, color, usage )
HDC hdc;
BITMAPINFOHEADER *data;
DWORD flag;
CONST VOID *init;
CONST BITMAPINFO *color;
UINT usage;
{
    HBITMAP ret;
    ret = CreateDIBitmap( hdc, data, flag, init, color, usage );
    if ( ret == (HBITMAP)NULL )
       taskAbort("bad return from CreateDIBitmap()");
    remember_Handle( ret, BITMAP_HANDLE );
    return( ret );
}
 


HBITMAP my_LoadBitmap( inst, name )
HANDLE inst;
char *name;
{
    HBITMAP ret;
    ret = LoadBitmap( inst, name );
    if ( ret != (HBITMAP)NULL )
        remember_Handle( ret, BITMAP_HANDLE );
    return( ret );
}
 



HBRUSH my_CreateSolidBrush(color)
COLORREF color;
{
    HBRUSH ret;
    ret = CreateSolidBrush(color);
    if ( ret == (HBRUSH)NULL )
       taskAbort("bad return from CreateSolidBrush");
    remember_Handle( ret, BRUSH_HANDLE );
    return( ret );
}


HBRUSH my_CreatePatternBrush(bitmap)
HBITMAP bitmap;
{
    HBRUSH ret;
    ret = CreatePatternBrush(bitmap);
    if ( ret == (HBRUSH)NULL )
       taskAbort("bad return from CreatePatternBrush");
    remember_Handle( ret, BRUSH_HANDLE );
    return( ret );
}
 
 
HPALETTE my_CreatePalette(log_pal)
CONST LOGPALETTE *log_pal;
{
    HPALETTE ret;
    ret = CreatePalette(log_pal);
    if ( ret == (HPALETTE)NULL )
       taskAbort("bad return from CreatePalette");
    remember_Handle( ret, PALETTE_HANDLE );
    return( ret );
}


 
HRGN my_CreatePolygonRgn( points, num_points, fill )
CONST POINT *points;
int num_points, fill;
{
    HRGN ret;
    ret = CreatePolygonRgn( points, num_points, fill );
    if ( ret == (HPALETTE)NULL )
       taskAbort("bad return from CreatePolygonRgn");
    remember_Handle( ret, REGION_HANDLE );
    return( ret );
}


HRGN my_CreateRectRgn( left, top, right, bottom )
int left, top, right, bottom;
{
    HRGN ret;
    ret = CreateRectRgn( left, top, right, bottom );
    if ( ret == (HPALETTE)NULL )
       taskAbort("bad return from CreateRectRgn");
    remember_Handle( ret, REGION_HANDLE );
    return( ret );
}

#if 0

HGDIOBJ my_GetStockObject( type )
int type;
{
    HGDIOBJ ret;
    int res_type;

    ret = GetStockObject( type );
    if ( ret == (HGDIOBJ)NULL )
       taskAbort("bad return from GetStockObject");

    if ( (type == BLACK_BRUSH) || (type == DKGRAY_BRUSH) || 
         (type == GRAY_BRUSH) || (type == HOLLOW_BRUSH) ||
         (type == LTGRAY_BRUSH) || (type == NULL_BRUSH) ||
         (type == WHITE_BRUSH) )
       res_type = BRUSH_HANDLE;
    else if ( (type == BLACK_PEN) || (type == NULL_PEN) ||
         (type == WHITE_PEN) )
       res_type = PEN_HANDLE;
    else if ( (type == ANSI_FIXED_FONT) || (type == ANSI_VAR_FONT) ||
         (type == DEVICE_DEFAULT_FONT) || (type == OEM_FIXED_FONT) ||
         (type == SYSTEM_FONT) || (type == SYSTEM_FIXED_FONT) )
       res_type = FONT_HANDLE;
    else if ( type == DEFAULT_PALETTE )
       res_type == PALETTE_HANDLE;
    else
       taskAbort("unknown object types passed to myGetStockObject");

    remember_Handle( ret, res_type );
    return( ret );
}
#endif


#endif    /* DEBUG_RESOURCES  }  */




/*********************************************************************/




BOOL
DrawTransparentPolyline(GC gc, HDC dest_dc, HBITMAP pattern,
                                POINT *points, int npoints)
/*** dest_dc must be unpackaged! ***/
{
    int width, height, minx, miny;
    HDC src_dc, mask_dc;
    HBITMAP src_bm, old_src_hbm, mask_bm, old_mask_hbm;
    HBRUSH src_brush, old_brush, old_mask_brush, pattern_brush;
    COLORREF fore_color;
    DWORD fg_rop_code, bg_rop_code;
    HPALETTE old_palette, old_mask_palette;
    unsigned long white_pixel, black_pixel;
    BOOL retval;


    retval = FALSE;
    if ( npoints <= 1 )
        return retval;

    black_pixel = 10;    /* first color in our palette. */
    white_pixel = REAL_WHITE_PIXEL;
    if ( npoints > 2 )
        GetPolyInfo(points, npoints, &width, &height, &minx, &miny);
    else
        {
        /* single line, compute width and height. */
        width = abs(points[1].x - points[0].x);
        height = abs(points[1].y - points[0].y);
        }

    /* set up a mask DC. */
    mask_dc = MS_CreateCompatibleDC(NULL);
    /* mask bitmap will be used as a mask, so it needs to be monochrome. */
    mask_bm = MS_CreateCompatibleBitmap(mask_dc, width, height);
    old_mask_hbm = MS_SelectObject(mask_dc, mask_bm);
    old_mask_palette = SelectAndRealizeAxWinPalette(mask_dc);

    /* first, fill the mask DC with zeros */
    MS_PatBlt(mask_dc, 0, 0, width, height, BLACKNESS);
    
    /* then draw the shape with the specified pattern (stipple) *
     * brush.  this will give us a mask of that pattern.        */
    pattern_brush = MS_CreatePatternBrush(pattern);
    old_mask_brush = MS_SelectObject(mask_dc, pattern_brush);
    /* make sure the 1 bits in the pattern get drawn as 1, *
     * and the 0 bits get drawn as 0.                      */
    MS_SetBkColor(mask_dc, GET_COLOR_VALUE(white_pixel));
    MS_SetTextColor(mask_dc, GET_COLOR_VALUE(black_pixel));
    MS_Polyline(mask_dc, points, npoints);

    /* get rid of the mask dc because the mask hbm may need to 
     * be selected into another hdc.
     */
    MS_SelectObject(mask_dc, old_mask_hbm);
    MS_SelectObject(mask_dc, old_mask_brush);
    UnSelectPalette(mask_dc, old_mask_palette);
    MS_DeleteObject(pattern_brush);
    MS_DeleteDC(mask_dc);

    fore_color = GET_COLOR_VALUE(gc->values.foreground);
    /* create a color DC for our source dc. */
    src_dc = MS_CreateCompatibleDC((HDC)NULL);
    src_bm = MS_CreateCompatibleBitmap(dest_dc, width, height);
    old_src_hbm = MS_SelectObject(src_dc, src_bm);

    old_palette = SelectAndRealizeAxWinPalette(src_dc);
    /* fill the source DC with the foreground color. this source *
     * DC will then be Blt'd thru the mask with the appropriate  *
     * rop_code to make it transparent.                          */
    src_brush = MS_CreateSolidBrush(fore_color);
    old_brush = MS_SelectObject(src_dc, src_brush);
    MS_PatBlt(src_dc, 0, 0, width, height, PATCOPY);

    /* SRCAND the destination, SRCCOPY the source */
    fg_rop_code = SRCCOPY;
    bg_rop_code = 0x00AA0029;
    /* BLT the source DC (some specified color) thru the mask  *
     * bitmap (some specified pattern) onto the destination DC *
     * using a "transparency" rop_code. the 1 bits in the mask *
     * are painted with the source color, and the 0 bits are   *
     * left untouched.                                         */
#if FOR_FILTER
    retval = MS32_MaskBlt(dest_dc, minx, miny, width, height,
                                src_dc, 0, 0, mask_bm, 0, 0,
                                MAKEROP4(fg_rop_code, bg_rop_code));
#else
    retval = AxWinMaskBlt(dest_dc, minx, miny, width, height,
                                src_dc, 0, 0, mask_bm, 0, 0,
                                fg_rop_code, bg_rop_code);
#endif
    /* final cleanup */
    MS_SelectObject(src_dc, old_src_hbm);
    MS_SelectObject(src_dc, old_brush);
    MS_DeleteObject(src_brush);
    UnSelectPalette(src_dc, old_palette);
    MS_DeleteDC(src_dc);
    MS_DeleteObject(src_bm);
    MS_DeleteObject(mask_bm);
    return retval;
}


/*******************************************************************
* function: AxWinDestroyGCmask  - the clip_mask in a GC may be one
*            of four GDI objects: hdc, memory hdc, bitmap or region.
*            so we need this function to check for type and then call
*            the appropriate destructor function.  
*********************************************************************/
void AxWinDestroyGCmask(mask)
HGDIOBJ mask;
{
    DWORD obj_type;


    /* don't delete object if it's a bitmap because it's most likely *
     * a global resource which will need to be used again.  If it's  *
     * a temporary resource then the caller will free it.            */

    obj_type = MS32_GetObjectType(mask);
    if ( obj_type == OBJ_DC || obj_type == OBJ_MEMDC )
        MS_DeleteDC(mask);
    else if ( obj_type == OBJ_REGION )
        MS_DeleteObject(mask);
    else if ( obj_type != OBJ_BITMAP )
        taskAbort(NXLT("AxWinDestroyGCmask: bad object type!"));
}
/*********************************************************************/



HPEN
AxWinCreateBestPossibleDashedPen(int dash_list_size, DWORD *dashes,
                                                LOGBRUSH *lbrush)
{
    HPEN hpen;
    int pen_style;

    /* we can assume that dash_list_size will be 2 or greater. */
    switch (dashes[0])
        {
        case 1:
            if ( dashes[1] > 1 && dash_list_size > 2 )
                pen_style = PS_DASHDOTDOT;
            else if ( dashes[1] > 1 )
                pen_style = PS_DASHDOT;
            else
                pen_style = PS_DOT;
            break;

        case 2:
            if ( dashes[1] == 1 && dash_list_size > 2 )
                pen_style = PS_DASHDOTDOT;
            else if ( dashes[1] == 1 )
                pen_style = PS_DASHDOT;
            else
                pen_style = PS_DASH;
            break;

        default:
            pen_style = PS_DOT;
        }

    hpen = MS_CreatePen(pen_style, 0, lbrush->lbColor);
    return hpen;
}

HPEN
AxWinCreateDashedPen(DWORD *dashes, int dash_list_size, int pen_style,
                                    int pen_width, LOGBRUSH *lbrush)
{
    HPEN hpen = NULL;

#if !FOR_FILTER    /* { */
    if ( (dash_list_size == 2) && (pen_width == 1) &&
                (dashes[0] == 1) && (dashes[1] == 1) &&
                Running_WindowsNT )
        {
        /* HACK: check for (1,1) in the array. this is the *
         * equivalent of a PS_ALTERNATE pen on Windows.    */
        /* NOTE: PS_ALTERNATE not supported on Win95. */
        hpen = MS32_ExtCreatePen(PS_ALTERNATE, pen_width, lbrush, 0L,
                                                (CONST DWORD *)NULL);
        }
    else
        {
        if ( Running_Windows95 )
            {
            hpen = AxWinCreateBestPossibleDashedPen(dash_list_size,
                                                           dashes,
                                                           lbrush);
            }
        else
            {
            hpen = MS32_ExtCreatePen(pen_style, pen_width, lbrush,
                                           dash_list_size, dashes);
            }
        }
#endif    /* } !FOR_FILTER */
    return hpen;
}





HBITMAP
BitmapFromXImage(XImage *ximg)
{
    int ix, ii;
    int bytewidth, image_size;
    char *destP, *sourceP, *win_data;
    HDC hdc;
    HBITMAP  hbm;
    HPALETTE old_palette;


    if ( ximg->depth == 1 )
        {
        /* monochrome image, use proper Windows function. */
        hbm = MS_CreateBitmap(ximg->width, ximg->height, 1, 1, ximg->data);
        if ( ximg->bitmap_handle != (HBITMAP)NULL )
           MS_DeleteObject( ximg->bitmap_handle );    /* just be leak safe */
        ximg->bitmap_handle = hbm;
        }
    else
        {
        /* color image. check for a bitmap info struct */
        if ( ximg->bitmap_info && ximg->bitmap_info->bmiHeader.biWidth > 0 &&
                                    ximg->bitmap_info->bmiHeader.biHeight > 0 )
            {
            /* we have a "fully-qualified" bitmap info struct, so just create
             * the DIB from it.         -donato
             */
            hdc = MS_GetDC(NULL);
            old_palette = SelectAndRealizeAxWinPalette(hdc);

            hbm = MS_CreateDIBitmap(hdc, &ximg->bitmap_info->bmiHeader,
                                    CBM_INIT, (unsigned char *)ximg->data,
                                    ximg->bitmap_info, DIB_RGB_COLORS);

            UnSelectPalette(hdc, old_palette);
            MS_ReleaseDC(NULL, hdc);
            }
        else
            {
            if ( ximg->bitmap_info && ximg->bitmap_info->bmiHeader.biWidth == 0
                                && ximg->bitmap_info->bmiHeader.biHeight == 0 )
                {
                /* we have an allocated bitmap info struct, but it's empty. *
                 * so free it (was probably allocated in XCreateImage), and *
                 * we'll create a new one in AxWinCreateDIBitmapHandle.     */
                TaskFree(0, (struct mem_header *)(ximg->bitmap_info) );
                }

            if ( ximg->depth == 8 )
                {
                bytewidth = ((ximg->bytes_per_line + 3)/4 ) * 4;
                image_size = bytewidth * ximg->height;
                win_data = (char *)TaskAlloc(0, image_size);

                /* flip and pad to 4-byte boundary. */
                sourceP = ximg->data;
                for ( ix=ximg->height-1; ix >= 0; ix-- )
                    {
                    destP = win_data + (ix * bytewidth);
                    for ( ii=0; ii < ximg->bytes_per_line; ii++ )
                        *destP++ = *sourceP++;
                    }

                hbm = AxWinCreate8BitDIB(ximg, win_data, image_size);
                TaskFree(0, (struct mem_header *)win_data);
                }
            else    /* assume > 8 */
                {
                bytewidth = ximg->width * 4;
                image_size = bytewidth * ximg->height;
                hbm = AxWinCreate16BitDIB(ximg, image_size);
                }
            }
        }

    return(hbm);
}




/*** This function taken from \samples\win32\showdib\dib.c ***/
WORD
GetNumDIBColors(VOID *pv)
{
    INT                 bits;
    LPBITMAPINFOHEADER  lpbi;
    LPBITMAPCOREHEADER  lpbc;

    lpbi = ((LPBITMAPINFOHEADER)pv);
    lpbc = ((LPBITMAPCOREHEADER)pv);

    /*  With the BITMAPINFO format headers, the size of the palette
     *  is in biClrUsed, whereas in the BITMAPCORE - style headers, it
     *  is dependent on the bits per pixel ( = 2 raised to the power of
     *  bits/pixel).
     */
    if ( lpbi->biSize != sizeof(BITMAPCOREHEADER) )
        {
        if ( lpbi->biClrUsed != 0 )
            return (WORD)lpbi->biClrUsed;
        bits = lpbi->biBitCount;
        }
    else
        bits = lpbc->bcBitCount;

    switch (bits)
        {
        case 1:
            return 2;
        case 4:
            return 16;
        case 8:
            return 256;
        default:
            /* A more than 8 bitcount DIB has no color table */
            return 0;
        }
}


/* Convert a DIB to an internal "XImage".  This returns a pointer to an */
/*   XImage structure which the caller must free */
XImage *
BitmapToXImage(HBITMAP hbm)
{
    HDC hdc;
    int i, nColors, aligned_2_width;
    int raw_bytes_per_line, byte_pad;
    int width, height, depth;
    int scan_lines, img_size, bytewidth;
    unsigned char *image_data, *sourceP, *destP;
    XImage *ximage;
    LPLOGPALETTE paletteP;
    RGBQUAD *colorP;
    PBITMAPINFO  bm_infoP;
    ULONG        sizeBMI;
    HPALETTE old_palette;
    int ret;
    BYTE red, green, blue;


    hdc = MS_GetDC(NULL);
    old_palette = SelectAndRealizeAxWinPalette(hdc);

    /* First call GetDIBits with a zero'ed structure (particularly */
    /*   the bm_infoP->bmiHeader.biBitCount field) to get the image size */
    bm_infoP = (BITMAPINFO *)calloc( 1, sizeof(BITMAPINFO) );
    bm_infoP->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

    ret = MS_GetDIBits(hdc, hbm, (UINT)0, (UINT)0, (LPBYTE)NULL,
                   (LPBITMAPINFO)bm_infoP, (DWORD)DIB_RGB_COLORS);
    if ( ret == 0 )
        taskAbort("BitmapToXImage - GetDIBits returns zero");

    /* Now that we know the size, allocate space for the image data */
    scan_lines = bm_infoP->bmiHeader.biHeight;
    img_size   = bm_infoP->bmiHeader.biSizeImage;

    ximage = (XImage *)calloc( 1, sizeof(XImage) );
    image_data = (char*)malloc(img_size);

    /** Allocate space for the color table (if necessary) */
    /** from \mstools\samples\mandel\dibmp.c **/
    /*
     * Note: 24 bits per pixel has no color table.  So, we don't have to
     * allocate memory for retrieving that.  Otherwise, we do.
     */
    nColors = GetNumDIBColors(&bm_infoP->bmiHeader);
    if ( nColors )
        {
        /* has color table */
        sizeBMI = sizeof(BITMAPINFO) + sizeof(RGBQUAD) * nColors;
        /* I need more memory for the color table */
        bm_infoP = (PBITMAPINFO) realloc(bm_infoP, sizeBMI);
        }
    if ( bm_infoP->bmiHeader.biCompression == BI_BITFIELDS )
        {
        /* need more space for color mask values (3 double words). */
        sizeBMI = sizeof(BITMAPINFO) + (sizeof(DWORD) * 3);
        bm_infoP = (PBITMAPINFO) realloc(bm_infoP, sizeBMI);
        }

    /* get the bits and the color table */
    ret = MS_GetDIBits(hdc, hbm, 0, scan_lines,
                        (LPSTR)image_data,
                        bm_infoP, DIB_RGB_COLORS);
    if ( ret != scan_lines )
        taskAbort("BitmapToXImage: GetDIBits failed");

    width = bm_infoP->bmiHeader.biWidth;
    height = bm_infoP->bmiHeader.biHeight;
    depth = bm_infoP->bmiHeader.biBitCount;

    if ( depth == 1 )
        {
        /* monochrome is padded to even bytes */
        ximage->bitmap_pad = 16;
        /* also flip the bits: in their present state (from MS_GetDIBits), *
         * they are upsidedown, which is fine for color images. Monochrome *
         * images, however, will use the MS_CreateBitmap call which expects*
         * the bits to be "normal" (2-byte, right-side up).   -donato      */
        bytewidth = img_size/height;
        aligned_2_width = ((width + 15) & ~0xF)/8;
        ximage->data = (unsigned char *)malloc(aligned_2_width * height);
        for ( i=0; i < height; i++ )
            {
            destP = ximage->data + ((height - i - 1) * aligned_2_width);
            sourceP = (unsigned char *)(image_data + (i * bytewidth));
            memcpy( destP, sourceP, aligned_2_width );
            }
        free(image_data);
        }
    else
        {
        /* color is padded to 4 byte boundries */
        ximage->bitmap_unit = ximage->bitmap_pad = 32;
        /* leave data as we got it. */
        ximage->data = image_data;
        }

    /* if hbm is the global ScratchMap don't set it on the ximage, *
     * otherwise there will be an attempt to delete it.  -donato   */
#if !FOR_FILTER
    if ( hbm != ScratchMap )
#endif
        ximage->bitmap_handle = hbm;
    ximage->width   = width;
    ximage->height  = height;
    ximage->xoffset = 0;
    ximage->format  = XYBitmap;
    ximage->byte_order  = MSBFirst;
    ximage->bitmap_bit_order = MSBFirst;
    ximage->depth = ximage->bits_per_pixel = depth;
    ximage->bitmap_info = bm_infoP;

    raw_bytes_per_line = ((width * depth) + 7)/8;
    byte_pad = ximage->bitmap_pad / 8;
    ximage->bytes_per_line =
                       ((raw_bytes_per_line + byte_pad - 1)/byte_pad)*byte_pad;


    /* Create a palette as necessary. */
    if ( nColors )
        {
        paletteP = (LOGPALETTE*)malloc(sizeof(LOGPALETTE) +
                            (nColors*sizeof(PALETTEENTRY)));
        paletteP->palNumEntries = nColors;
        paletteP->palVersion = PALVERSION;

        colorP = &ximage->bitmap_info->bmiColors[0];
        for ( i=0; i < nColors; i++ )
            {
            paletteP->palPalEntry[i].peRed   = colorP->rgbRed;
            paletteP->palPalEntry[i].peGreen = colorP->rgbGreen;
            paletteP->palPalEntry[i].peBlue  = colorP->rgbBlue;
            paletteP->palPalEntry[i].peFlags = 0;
            colorP++;
            }
        ximage->palette_handle = MS_CreatePalette(paletteP);
        free(paletteP);
        }
    else if ( bm_infoP->bmiHeader.biBitCount == 24 )
        {
        /* A 24 bitcount DIB has no color table entries so, set the number of
         * to the maximum value (256).
         */
        nColors = MAXPALETTE;
        paletteP = (LOGPALETTE*)malloc(sizeof(LOGPALETTE) +
                            (nColors*sizeof(PALETTEENTRY)));
        if ( paletteP )
            {
            paletteP->palNumEntries = nColors;
            paletteP->palVersion    = PALVERSION;

            red = green = blue = 0;
            /* Generate 256 (= 8*8*4) RGB combinations to fill the palette
             * entries.
             */
            for ( i = 0; i < paletteP->palNumEntries; i++ )
                {
                paletteP->palPalEntry[i].peRed   = red;
                paletteP->palPalEntry[i].peGreen = green;
                paletteP->palPalEntry[i].peBlue  = blue;
                paletteP->palPalEntry[i].peFlags = (BYTE)0;

                if ( !(red += 32) )
                    if ( !(green += 32) )
                        blue += 64;
                }
            ximage->palette_handle = MS_CreatePalette(paletteP);
            free(paletteP);
            }
        }

    SetXColorMasks( bm_infoP, ximage );

    UnSelectPalette(hdc, old_palette);
    MS_ReleaseDC(NULL, hdc);
    return(ximage);
}





/* Set the color masks in the X structure based on info from the */
/* bitmap header.  This is only used for 16 and 32 bit (really 24 bit) */
/* color models.  For 8 ad 24 bit models the bytes are read directly */
void
SetXColorMasks( PBITMAPINFO bm_infoP, XImage *ximage )
{
    DWORD *maskP;

    ximage->red_mask = ximage->green_mask = ximage->blue_mask = 0;
    if ( bm_infoP->bmiHeader.biBitCount < 16 )
        return;

    if ( bm_infoP->bmiHeader.biCompression == BI_BITFIELDS )
        {
        /* the masks of where the color bits are placed in each pixel  */
        /* are passed in the bitmap header "colors" area               */
        maskP = (DWORD *)&(bm_infoP->bmiColors);
        ximage->red_mask   = *maskP++;
        ximage->green_mask = *maskP++;
        ximage->blue_mask  = *maskP;
        }

    else if ( bm_infoP->bmiHeader.biBitCount == 16 &&
                bm_infoP->bmiHeader.biCompression == BI_RGB )
        {
        /* The standard 16 bit DIB format uses 5 bits per color value,
         * giving us the following color masks.
         */
        ximage->red_mask   = RED_MASK16;
        ximage->green_mask = GREEN_MASK16;
        ximage->blue_mask  = BLUE_MASK16;
        }
    else if ( bm_infoP->bmiHeader.biBitCount == 24 &&
                bm_infoP->bmiHeader.biCompression == BI_RGB )
        {
        /* The 24 bit format passes the colors as byte triplets, with the */
        /* order being "blue", "green", "red",  NOT RGB  (go figure ...   */
        /* more Microsoft wierdness!)                                     */
        ximage->red_mask   = 0xFF;
        ximage->green_mask = 0xFF00;
        ximage->blue_mask  = 0xFF0000;
        }
    else if ( (bm_infoP->bmiHeader.biBitCount == 32) &&
         (bm_infoP->bmiHeader.biCompression == BI_RGB) )
        {
        ximage->red_mask   = 0x00FF0000;
        ximage->green_mask = 0x0000FF00;
        ximage->blue_mask  = 0x000000FF;
        }
}





static void
AddMonoBitmapStructToXImage(XImage *infoP)
{
    int size;
    LPBITMAPINFOHEADER headerP;
    RGBQUAD *colorP;
    DWORD image_size, fore_rgb, back_rgb;
#if 0 /* FOR_FILTER */
    static HPALETTE mono_palette_handle;
    static HPALETTE inv_palette_handle;
    LPLOGPALETTE  paletteP;
#endif

    
#if FOR_FILTER
    fore_rgb = MS_GetSysColor(COLOR_WINDOWTEXT);
    back_rgb = MS_GetSysColor(COLOR_WINDOW);
#else
    if ( 0 /*use_widget_pixel*/ ) /* was this ever used? */
        {
        /* widget colors. */
        fore_rgb = MS_GetSysColor(COLOR_BTNTEXT);
        back_rgb = BackPixelRGB;
        }
    else
        {
        /* work area colors. */
        fore_rgb = ForeWorkPixelRGB;
        back_rgb = BackWorkPixelRGB;
        }
#endif

    /* setup structure and colors for the DIB image */
    size = sizeof(BITMAPINFO) + (2*sizeof(RGBQUAD));
    infoP->bitmap_info = (LPBITMAPINFO)TaskAlloc(THIMpid, size);
    memset(infoP->bitmap_info, 0, size);

    image_size = infoP->bytes_per_line * infoP->height;
    headerP = &infoP->bitmap_info->bmiHeader;
    headerP->biSize = sizeof(BITMAPINFOHEADER);
    headerP->biWidth = infoP->width;
    headerP->biHeight = infoP->height;
    headerP->biPlanes = 1;
    headerP->biBitCount = 1;
    headerP->biCompression = BI_RGB;
    headerP->biSizeImage = image_size;
    headerP->biClrUsed = 2;           /* full color table is used */
    headerP->biClrImportant = 2;      /* all colors are important */

    /*---------------------------------------------------*/
    /* now create the color palette, for the two colors */
    /* at the same time we fill in the BITMAPINFO strucure */
    /*---------------------------------------------------*/
    /* fill in the table */
    colorP = &infoP->bitmap_info->bmiColors[0];
    colorP->rgbRed = MS_GetRValue(back_rgb);
    colorP->rgbGreen = MS_GetGValue(back_rgb);
    colorP->rgbBlue = MS_GetBValue(back_rgb);
    colorP->rgbReserved = 0;

    colorP++;
    colorP->rgbRed = MS_GetRValue(fore_rgb);
    colorP->rgbGreen = MS_GetGValue(fore_rgb);
    colorP->rgbBlue = MS_GetBValue(fore_rgb);
    colorP->rgbReserved = 0;

#if FOR_FILTER   /*  {  */
#if 0 /* { */
    if ( mono_palette_handle == NULL )
        {
        /* we only need to create the monochrome paletts once */
        paletteP = (LPLOGPALETTE)TrueMalloc( sizeof(LOGPALETTE) +
                                     (2*sizeof(PALETTEENTRY)) );

        paletteP->palNumEntries = 2;
        paletteP->palVersion = PALVERSION;

        /* fill in the table */
        colorP = &infoP->bitmap_info->bmiColors[0];
        paletteP->palPalEntry[0].peRed = colorP->rgbRed;
        paletteP->palPalEntry[0].peGreen = colorP->rgbGreen;
        paletteP->palPalEntry[0].peBlue = colorP->rgbBlue;
        paletteP->palPalEntry[0].peFlags = 0;

        colorP++;
        paletteP->palPalEntry[1].peRed = colorP->rgbRed;
        paletteP->palPalEntry[1].peGreen = colorP->rgbGreen;
        paletteP->palPalEntry[1].peBlue = colorP->rgbBlue;
        paletteP->palPalEntry[1].peFlags = 0;

        mono_palette_handle = MS_CreatePalette(paletteP);
        /* now do the inverse */
        colorP = &infoP->bitmap_info->bmiColors[0];
        paletteP->palPalEntry[1].peRed = colorP->rgbRed;
        paletteP->palPalEntry[1].peGreen = colorP->rgbGreen;
        paletteP->palPalEntry[1].peBlue = colorP->rgbBlue;
        paletteP->palPalEntry[0].peFlags = 0;
  
        colorP++;
        paletteP->palPalEntry[0].peRed = colorP->rgbRed;
        paletteP->palPalEntry[0].peGreen = colorP->rgbGreen;
        paletteP->palPalEntry[0].peBlue = colorP->rgbBlue;
        paletteP->palPalEntry[0].peFlags = 0;

        inv_palette_handle = MS_CreatePalette(paletteP);
        free(paletteP);
        }
    infoP->inv_palette_handle = inv_palette_handle;
#endif  /* } 0 */
#else   /*  }   FOR_FILTER {  */
    infoP->palette_handle = AxWinPaletteHandle;
#endif    /*  }  */

    infoP->bitmap_handle = (HBITMAP)NULL;
}





/*********************************************************************/



HBITMAP
AxWinCreate1BitDIB(XImage *ximage, char *image_data)
{
    HDC hdc;
    HBITMAP bitmap_handle;
    HPALETTE old_palette;


    /* fill out the bitmap info structure, needed by MS_CreateDIBitmap. */
    AddMonoBitmapStructToXImage(ximage);

    hdc = MS_GetDC(NULL);
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    bitmap_handle = MS_CreateDIBitmap(hdc, &ximage->bitmap_info->bmiHeader, 
                                        (DWORD)CBM_INIT,
                                        (unsigned char *)image_data,
                                        ximage->bitmap_info, 
                                        DIB_RGB_COLORS);
    UnSelectPalette(hdc, old_palette);
    MS_ReleaseDC(NULL, hdc);
  
    ximage->bitmap_handle = bitmap_handle;
    return bitmap_handle;
}


/* Create an 8-bit DIB from an XImage. */
HBITMAP
AxWinCreate8BitDIB(XImage *ximage, char *image_data, unsigned int data_size)
{
    HDC hdc;
    HBITMAP bitmap_handle;
    HPALETTE old_palette;


    /* fill out the bitmap info structure, needed by MS_CreateDIBitmap. */
    AddBitmapStructToXImage(ximage, data_size);

    hdc = MS_GetDC(NULL);
    old_palette = SelectAndRealizeAxWinPalette(hdc);
    bitmap_handle = MS_CreateDIBitmap(hdc, &ximage->bitmap_info->bmiHeader, 
                                        (DWORD)CBM_INIT,
                                        (unsigned char *)image_data,
                                        ximage->bitmap_info, 
                                        DIB_RGB_COLORS);
    UnSelectPalette(hdc, old_palette);
    MS_ReleaseDC(NULL, hdc);
  
    ximage->bitmap_handle = bitmap_handle;
    return bitmap_handle;
}

HBITMAP
AxWinCreate16BitDIB(XImage *ximage, unsigned int data_size)
{
    HBITMAP hbm;
    HDC hdc = MS_GetDC(NULL);

    AddBitmapStructToXImage(ximage, data_size);

    hbm = MS_CreateDIBitmap(hdc, &ximage->bitmap_info->bmiHeader,
                                        (DWORD)CBM_INIT,
                                        (unsigned char *)ximage->data,
                                        ximage->bitmap_info,
                                        DIB_RGB_COLORS);
    ximage->bitmap_handle = hbm;
    MS_ReleaseDC(NULL, hdc);
    return hbm;
}


#if FOR_FILTER
#define PRINT_FUNC printf
int in_temp_abort;
#else
#define PRINT_FUNC WinPrintf
extern int in_temp_abort;
#endif

/* Post and error message to the "printf" window to give information, but */
/*    not lock the user up like an "ErrorBox" would do.  This is used     */
/*    by the resource checking functions.  See "winmap.h"                 */
int
PostErrorMessage(char *str)
{
    int err;
    char *err_msg;
    PVOID err_str;
    DWORD buf_len;
    static int in_this_function;

    if ( in_this_function || in_temp_abort )
       /* prevent recursive loops */
       return 0;
    in_this_function = TRUE;

    err = MS_GetLastError();
    buf_len = MS_FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
                               FORMAT_MESSAGE_FROM_SYSTEM,
                               (LPCVOID)NULL, err,
                               0, /* let system decide language! */
                               (LPTSTR)&err_str, 0, NULL);

    if ( buf_len > 0 )
    {
		err_msg = malloc(strlen(str) + buf_len + 1);
    	sprintf(err_msg, "%s, %s", str, err_str);
        /* need to free the string allocated by FormatMessage */
        MS_LocalFree(err_str);
    }
	else
	{
		err_msg = malloc(strlen(str) + 80);
    	sprintf(err_msg, "Error: %s  LastError = %d", str, err);
	}
    
    PRINT_FUNC(XLT("An internal Applixware error has been detected"));
    PRINT_FUNC(XLT("Save any work in progress immediately"));
    PRINT_FUNC(err_msg );
    PRINT_FUNC("---------------------------------------------------");

	free(err_msg);

#if !FOR_FILTER
    WinPrintfToForeground();

    if ( THIMpid == 0 )
    {
       /* this is real serious, and we are probably about to exit */
       /* post a "stop sign" error box */
		WXErrorMessage(
			    XLT("Internal Applixware error, review printf output window"));
    }
    WinPrintfToForeground();
#endif

    return 0;
}


UINT DrawableListSize = 50;
drawable_list_t *DrawableList = NULL;

/* AxPackageHandle takes a handle to a window or device context and saves
 * it into a global array of structures. We return an index to this array
 * with the high bit set so we can distinguish between a  "packaged" handle
 * and a real handle. We've implemented this so that we  know what type of
 * handle we receive in certain X calls and in other drawing functions (there
 * is no win32 API call that distinguishes between window handles (USER space)
 * and device contexts (GDI space)). There is  a third type of handle which
 * WE DO NOT SAVE, and that is the bitmap handle. Therefore, if a drawable is
 * not "packaged" it must be a bitmap handle (or at least should be. Cases
 * which break this rule are bugs).                 -donato
 */

/***********************************************************************/
/* find the next available place in the drawable table,                */
/* put the passed handle into that table, and return the index         */
/* Note: we do not use the zero'th element, so the returned index is   */
/*       never zero.                                                   */
/***********************************************************************/
HANDLE
AxPackageHandle(HANDLE handle, int type)
{
#if FOR_FILTER
    return NULL;
#else
    register UINT ix;
    drawable_list_t *listP;

    if ( !DrawableList )
        {
        /* initialize with a certain size. */
        DrawableList = (drawable_list_t *)TrueCalloc(1, 
                             (DrawableListSize * sizeof(*DrawableList)) );
        }

try_again:
    listP = DrawableList+1;     /* skip offset zero */
    for ( ix=1; ix < DrawableListSize; ix++ )
        {
        if ( listP->type < 1 )
            {
            /* found an available entry */
            listP->type = type;
            listP->handle = handle;
            return (HANDLE)(ix | AX_PACKAGE_BIT);
            }
        listP++;
        }

    /* fell through, no available slots, realloc to make some more room */
    DrawableList = (drawable_list_t *)TrueRealloc((char *)DrawableList,
                            (DrawableListSize + 50)*sizeof(*DrawableList));
    listP = DrawableList + DrawableListSize;  /* where the new stuff begins */
    memset( listP, 0, (50 * sizeof(*DrawableList)) );
    DrawableListSize = DrawableListSize + 50;
    goto try_again;
#endif
}



#if DEBUG_PACKAGED_HANDLES           /*  {  */
  /* functions for what are normally macros */
int IsPackagedHandle( HANDLE ix )
{
    if ( !((UINT)ix & AX_PACKAGE_BIT) )
        return( FALSE );
    if ( !(((UINT)ix & ~AX_PACKAGE_BIT)/sizeof(*DrawableList) < DrawableListSize) )
        return( FALSE );
    if ( ((DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->type) <= 0 )
        return( FALSE );
    return( TRUE );
}

int GetDrawableType( HANDLE ix )
{
    HANDLE ret_h;

    ret_h = (DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->type;
    return( ret_h );
}

HANDLE GetDrawableHandle( HANDLE ix )
{
    HANDLE ret_h;
    ret_h = ((DrawableList+((UINT)ix & ~AX_PACKAGE_BIT))->handle);
    return( ret_h );
}

void RemovePackagedDrawable( HANDLE ix )
{
   drawable_list_t *listP;

   listP = DrawableList+((UINT)ix & ~AX_PACKAGE_BIT);
   memset( (char *)listP, 0, sizeof(*DrawableList) );
   return;
}
#endif   /*  }  */


#if !FOR_FILTER
int
axmsSetSharedLibraryPath(void)
{
	int retval;
	int old_path_len, new_path_len;
	char *old_path, *new_path;

	retval = FALSE;
	if ( old_path = getenv("PATH") )
		{
		old_path_len = strlen(old_path) + 1;
		new_path_len = strlen(ThimApplixDir) + strlen("\\axshlib;") +
	                   strlen(ThimExecDir) + strlen("\\jre115\\bin;") + 1;
		new_path = (char*)malloc(old_path_len + new_path_len);
		if ( new_path )
			{
			sprintf(new_path, "%s\\axshlib;%s\\jre115\\bin;%s",
					ThimApplixDir, ThimExecDir, old_path);
			if ( SetEnvironmentVariable("PATH", new_path) )	/* GDI call */
				retval = TRUE;
			free(new_path);
			}
		}
	return retval;
}
#endif
