/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmlist.c
   Applix ASC version: 87
   Date: Wed May 12 21:10:33 1999
*/
#include <ax_xm.h>
#include <aos.h>
#include <xmlib.h>
#include <elxwins.h>
#include <X11/keysym.h>
#include <wchars.h>
#include <xmpixel.h>
#include <ctype.h>
#include <eldata.h>
#include <elf_env.h>
#include <dwt2xm.h>

extern int AxCharAbove, AxCharHeight;

extern int UseWidgetColors;
extern Display *Dpy;
extern short DpyDepth;
extern Window RootWin;

extern unsigned long AlisPixels[];
extern unsigned long WidgetPixels[];
extern long WinMask;
extern XSetWindowAttributes WinAtt;
extern Pixmap UnknownPixmap;
extern AXWidget ClickWidget;
extern AXWidget_list ListBoxArmed;

extern unsigned long BackWorkPixel;
extern Colormap WorkColormap;
extern unsigned long ForePixel;
extern unsigned long BackPixel;
extern GC ForeGC, BackGC, PixmapperForeGC;
extern GC SunGC, ShadowGC, DisabledGC;
extern GC olClrSunButtonGC, olClrShadowButtonGC, olClrRecessButtonGC;

extern GC MonospaceGC;       /* monspace system font, forground mode */
extern GC MonospaceBackGC;   /* monspace system font, background mode */
extern GC MonospaceBoldGC, MonospaceBoldBackGC;
extern GC MonospaceItalGC, MonospaceItalBackGC;
extern GC MonospaceItalBoldGC, MonospaceItalBoldBackGC;

extern XFontStruct *AxDlgMainFont;  /* Bolded dialog font */
extern XFontStruct *MonospaceFont, *MonospaceBoldFont;
extern XFontStruct *MonospaceItalFont, *MonospaceItalBoldFont;

extern int DoubleMillisec;
extern int AxButtonDown;
extern int WidgetNeedsUpdated;

#define ATTR_BOLD       1
#define ATTR_ITAL       2
#define ATTR_MONO       4

extern Window AxCrtWindow();
extern int TextWidth();
extern void AxXtDestroyWidget();
extern void paintCompositeWidget();
extern void AxDrawBevel();
extern void xmColorFillRectangle();
extern pixcache_t *Pixmapper();
extern long *CreateIntsArray(), *CopyIntsArray();
extern widget_t *AxUnFocusCurrent();
extern AXWidget topWidget();
extern GC axGetGC();

void PaintList(/* widget_t *w, XExposeEvent *exp, int full_regen, int
                  layered */);
int  ListEvent(/* widget_t w, XEvent *eventP */);
void ListAutoScroll(/* widget_t *w */);
void xmDestroyListPixmap();
static void DrawIconedString();
static int AttrFromName();
static int SafeTextWidth(); /* hscroll-fix -- sgd */
static XFontStruct* FontFromAttr();
static GC GCFromAttr(), BackGCFromAttr();
static void ListButtonMotionCB(/* widget_t *w, XEvent *eventP */);
static void ListButtonPressCB(/* widget_t *w, XEvent *eventP */);
static void ListButtonReleaseCB(/* widget_t *w, XEvent *eventP */);
static int  ListKeyPressCB(/* widget_t *w, XEvent *eventP */);
static int  AddSelection(/* widget_t *w, int selno */);
static int  ExtendAddSelection(/* widget_t *w, int selno */);
static int  AddSelectionRange(/* widget_t *w, int from_selno, int
                                     to_selno */);
static int  xmListBoxLineHeight(/* AXWidget w */);
static int  ExtendClearSelection(/* widget_t *w, int selno */);
static void ClearAndInsertSelection(/* widget_t *w, int selno */);
static void ClearAllSelections(/* widget_t *w */);
static void ListSetWorkColors(/* widget_t *w */);
static void ListUnsetWorkColors(/* widget_t *w */);
static int  ToggleSelection(/* widget_t *w, int selno */);
static int  ClearSelection(/* widget_t *w, int selno */);
static void ListUpdateScrollbars(/* widget_t *w */);
static void ListDrawMark(/* widget_t *w, int mark_idx, int put_mark */);
static void ListScrollNewTopRow(/* widget_t *w, int new_scroll_pos */);
static void ListSetClipAllGCs(/* widget_t *w, int clip_x_origin,
                                 int clip_y_origin,
                                 XRectangle *rectangles, int n,
                                 int ordering */);
static void ListUnsetClipAllGCs(/* widget_t *w */);
static int  YPosOfRow(/* widget_t *w, int idx */);
static void ListScrollNewHScrollPos(/* widget_t *w, int new_hscroll_pos */);
static void ListRestoreSavedClips(/* widget_t *w */);
static void ListDrawMarkerBox(/* widget_t *w, int idx */);

static struct {
    /* These static variables are valid *only* during the life of a
       ButtonPress inside the list box.  They are reset upon receiving a
       ButtonRelease.
     */
    int left_button_down;
    int middle_button_down;
    int selected_multiple_items;
    int button_press_item; /* 1 based */
    int left_btn_dbl_clicked;
    int direction_changed;
    int last_button_ypos;
    int btn_motion_direction_down;
    int clips_on;
    int save_clip_x_origin;
    int save_clip_y_origin;
    int save_ordering;
    XRectangle save_crect;

    /* for scrolls only */
    int AllowListToHaveHiddenSelection;
}xmlistStr  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

/***********************************************************************
function: ElfbGetListSelections - Return an elf array-of-numbers
containing selections.
Note:  Caller destroys returned elf datum.
*/
data_ptr
ElfbGetListSelections(w_dataP)
data_ptr w_dataP;
{
    register int num_selections;
    register int ix;
    register data_ptr dp;
    int tempint;
    AXWidget_list w;

    w  = (AXWidget_list)WidgetPointerFromHandleData(w_dataP);
    dp = AxMakeArray(0);
    if (!w)
        return(dp);
    if (w->type != W_LIST)
        return(dp);
    if (!w->selections) {
        w->selections = CreateIntsArray(0); /* sanity */
        return(dp);
    }

    num_selections = IntsArraySize(w->selections);
    if (num_selections <= 0)
        return(dp);
    for (ix = 0; ix < num_selections; ix++) {
        tempint = ReadIntsArray(w->selections, ix);
        dp = ElfAddNumToArray(dp, ix, tempint);
    }
    return(dp);
}

/*************************************************************************
function: ListBarChanged - Callback routine for List Boxes
*/
static void ListBarChanged (widget,w,data)
AXWidget widget;
AXWidget_list w;
XmScrollBarCallbackStruct *data;
{
    int new_scroll_pos; /* top row */
    int new_hscroll_pos; /* xpos */

    if ( w->vScrollBar == (AXWidget_scroll)widget ) {
        /* increase/decrease scroll_pos without checking 
         * for limits - will be adjusted in PaintList */
        switch ( data->reason ) {
        case XmCR_INCREMENT:
            new_scroll_pos = w->scroll_pos + 1;
            break;
        case XmCR_DECREMENT:
            new_scroll_pos = w->scroll_pos - 1;
            break;
        case XmCR_PAGE_INCREMENT:
            new_scroll_pos = w->scroll_pos + w->scroll_max;
            break;
        case XmCR_PAGE_DECREMENT:
            new_scroll_pos = w->scroll_pos - w->scroll_max;
            break;
        case XmCR_VALUE_CHANGED:
            new_scroll_pos = data->value / 10;
            break;
        default:
            return;
        }
        xmlistStr.AllowListToHaveHiddenSelection = TRUE;
        ListScrollNewTopRow(w, new_scroll_pos);
        xmlistStr.AllowListToHaveHiddenSelection = FALSE;
        return;
    }
    else if ( w->hScrollBar == (AXWidget_scroll)widget ) {
        /* increase/decrease hscroll_pos without checking 
         * for limits - will be adjusted in PaintList */
        switch ( data->reason ) {
        case XmCR_INCREMENT:
            new_hscroll_pos = w->hscroll_pos + 15;
            break;
        case XmCR_DECREMENT:
            new_hscroll_pos = w->hscroll_pos - 15;
            break;
        case XmCR_PAGE_INCREMENT:
            new_hscroll_pos = w->hscroll_pos + w->width;
            break;
        case XmCR_PAGE_DECREMENT:
            new_hscroll_pos = w->hscroll_pos - w->width;
            break;
        case XmCR_VALUE_CHANGED:
            new_hscroll_pos = data->value / 10;
            break;
        default:
            return;
        }
        xmlistStr.AllowListToHaveHiddenSelection = TRUE;
        ListScrollNewHScrollPos(w, new_hscroll_pos);
        xmlistStr.AllowListToHaveHiddenSelection = FALSE;
        return;
    } else { /* default */
        /* sanity */
        w->regen_widget = TRUE;
        xmlistStr.AllowListToHaveHiddenSelection = TRUE;
        PaintList(w,NULL,TRUE,TRUE);
        xmlistStr.AllowListToHaveHiddenSelection = FALSE;
    }
    return;
#if 0
    w->regen_widget = TRUE;
    xmlistStr.AllowListToHaveHiddenSelection = TRUE;
    PaintList(w,NULL,TRUE,TRUE);
    xmlistStr.AllowListToHaveHiddenSelection = FALSE;
#endif
}

/*************************************************************************
function: ListEvent - Respond to mouse
Return: 1 if event consumed; 0 otherwise.
*/
int
ListEvent (w,eventP)
register AXWidget_list w;
register XEvent *eventP;
{
    int event_consumed = 0;

    if (!w->callback)
        return(event_consumed);
    if (w->no_picks || w->disabled)
        return(event_consumed);
    if (!eventP)
        return(event_consumed);
    if (!w->multi_pick)
        if (eventP->xany.type == MotionNotify)
            return(event_consumed);

    switch (eventP->xany.type) {
    case MotionNotify:
        event_consumed = 1;
        if (xmlistStr.left_button_down && w->multi_pick) {
            if (eventP->xmotion.x > (w->width - 8))
                return(event_consumed);
            if (eventP->xmotion.x <= 4)
                return(event_consumed);
            
            if (eventP->xmotion.y <= 4) {
                w->armed = XmCR_DECREMENT;
                ListBoxArmed = w;
                ListAutoScroll(w);
                return(event_consumed);
            }
            if (eventP->xmotion.y > (w->height - 8)) {
                w->armed = XmCR_INCREMENT;
                ListBoxArmed = w;
                ListAutoScroll(w);
                return(event_consumed);
            }
            ListBoxArmed = NULL;
            ListButtonMotionCB(w, eventP);
        }
        break;
    case ButtonPress:
        event_consumed = 1;
        xmlistStr.left_button_down   = (eventP->xbutton.button == Button1) ? 1 : 0;
        xmlistStr.middle_button_down = (eventP->xbutton.button == Button2) ? 1 : 0;
        xmlistStr.last_button_ypos = eventP->xbutton.y;
        ListButtonPressCB(w, eventP);
        break;
    case ButtonRelease:
        event_consumed = 1;
        ListButtonReleaseCB(w, eventP);
        /* reset static state variables */
        xmlistStr.left_button_down  = xmlistStr.middle_button_down = xmlistStr.selected_multiple_items = 0;
        xmlistStr.button_press_item = xmlistStr.left_btn_dbl_clicked = 0;
        xmlistStr.last_button_ypos = 0;
        xmlistStr.btn_motion_direction_down = -1; /* default */
        xmlistStr.direction_changed = 0;
        ListBoxArmed = NULL;
        break;
    case KeyPress:
        /* do something */
        if (AxButtonDown)
            return(event_consumed);
        ListSetWorkColors(w);
        event_consumed = ListKeyPressCB(w, eventP);
        ListUnsetWorkColors(w);
        break;
    case KeyRelease:
        if (AxButtonDown)
            return(event_consumed);
        break;
    default:
        break;
    }
    return(event_consumed);
}

/***********************************************************************
function: PaintListBorder - Paint listbox border on parent window.
Note: This function is called from `AXmExposeChildren ()', at which
point the listbox has a window.
*/
void
PaintListBorder(w)
AXWidget_list w;
{
    int width;
    int height;
    int x;
    int y;

    if ((!w) || (w->type != W_LIST))
        return;
    x = w->xpos;
    y = w->ypos;
    width  = w->width;
    height = w->height;

    /* draw border (should be BEFORE GCs changed for work area
       colors) */
    AxDrawBevel(w, WIN_OF(w), x, y, width, height, 2, BEVEL_IN);

    ListSetWorkColors(w);

    /* clear gap between border and window (should be AFTER GCs
       changed for work area colors) */
    xmColorFillRectangle(w, WIN_OF(w), BackGC, x + 2, y + 2,
                         width - 4, height - 4);

    ListUnsetWorkColors(w);
}

/***********************************************************************
function: PaintList - Paint a list box
Note: Make sure this function return() at the bottom! Clips are unset there!
*/
void
PaintList(w, exp, full_regen, layered)
AXWidget_list w;
XExposeEvent *exp;
int full_regen;
int layered;
{
    int force_display_selection = FALSE;
    int width, height, x, y;
    int win_width, win_height, win_xpos, win_ypos;
    int line_height;
    int lines;
    int ix;
    GC  gc, backgc;
    char *p;
    int max_width, xdisp;
    unsigned long mask;
    XSetWindowAttributes atts;
    int old_scroll_pos;
    int old_hscroll_pos;
    int list_items_changed;

    if (!w)
        return;
    
    if ((w->type != W_LIST) || !w->managed || !w->display)
        return;
    
    if (w->parent && (w->parent->type == W_DIALOG) &&
                   !((AXWidget_dialog)w->parent)->exposed)
        return;

    if (layered) {
        if (w->flags & WFLG_IN_EDIT) {
            if (dePaintWidget(w))
                return;
        }
        else {
            if (topWidget(w) == (AXWidget)w) {
                paintCompositeWidget(w, exp, full_regen);
                return;
            }
        }
    }
    
    /* Unless the calling macro wants to force a particular item to be
     * visible, or the list has just been user scrolled, make sure the
     * selection is being displayed (except for multi-pick lists).
     */
    if (w->force_list_item_display)
        w->force_list_item_display = FALSE;
    else if (!xmlistStr.AllowListToHaveHiddenSelection && w->selections &&
             (1 == IntsArraySize(w->selections)) &&
             (-1 != FirstInIntsArray(w->selections)))
        force_display_selection = TRUE;

    if (!w->mapped) {
        w->mapped = TRUE;
        full_regen = TRUE;
    }
    if (w->regen_widget)
        full_regen = TRUE;

    line_height = xmListBoxLineHeight(w);
    lines = w->scroll_max;
    w->height = (lines * line_height) + 7;
    x = w->xpos;
    y = w->ypos;
    win_xpos = x + 3;
    win_ypos = y + 3;
    width  = w->width;
    height = w->height;
    win_width  = width - 6;
    win_height = height - 6;

    /* Repair odd case where the scroll pos makes no sense compared to
       the number of items. */
    /* FIXME, should this not be under a "if (!w->hide_vscroll)"? */
    if ((lines >= w->num_strs) && w->vScrollBar)
        w->scroll_pos = 0;
    if ((w->scroll_pos + lines) > w->num_strs)
        w->scroll_pos = w->num_strs - lines;
    if (w->scroll_pos < 0)
        w->scroll_pos = 0;

    old_scroll_pos = w->scroll_hist->scroll_pos;
    if (w->scroll_hist->num_buttons != w->num_strs)
        list_items_changed = TRUE;
    else
        list_items_changed = FALSE;

    if (w->list_hscroll) {
        max_width = (int) w->maxLen;
        if (max_width > (win_width - 15))
            max_width += 25; /* display extra white space at right */
        /* adjust scroll pos */
        if ((win_width >= max_width) && w->hScrollBar)
            w->hscroll_pos = 0;
        if ((w->hscroll_pos + win_width) > max_width)
            w->hscroll_pos = max_width - win_width;
        if (w->hscroll_pos < 0)
            w->hscroll_pos = 0;
    }

    if (!w->window) {
        mask = WinMask;
        atts = WinAtt;
        if (w->useWorkColors) {
            mask |= CWBackPixel | CWColormap;
            atts.background_pixel = BackWorkPixel;
            atts.colormap = WorkColormap;
        }
        if (w->flags & WFLG_IN_EDIT) { /* dialog editor */
            w->window = AxCreateQueryPixmap(Dpy, w->parent->window,
                                            win_width, win_height,
                                            DpyDepth);
        } else {
            w->window = AxCrtWindow(Dpy, WIN_OF(w), win_xpos,
                                    win_ypos, win_width, win_height,
                                    0, CopyFromParent, InputOutput,
                                    CopyFromParent, mask, &atts);
            XSelectInput(Dpy, w->window,
                         (TM_ALL_INPUTS_MASK) | Button1MotionMask);
            XMapWindow(Dpy, w->window);
            AddToWindowList(w);
            AxDndInitialize(Dpy);
            AxDndRegisterWindow(Dpy, w->window, w->window);
        }
        w->regen_widget = TRUE;
        force_display_selection = TRUE;
        full_regen = TRUE;
    }

    if (full_regen || exp) {
        /* draw border (should be BEFORE GCs changed for work area
           colors) */
        AxDrawBevel(w, WIN_OF(w), x, y, width, height, 2, BEVEL_IN);
    }

    ListSetWorkColors(w);
    
    if (full_regen || exp) {
        /* clear area between border and listbox window. This is done
         * after GC's are changed for color, and before they're changed
         * for clip (always a full clear for this)
         */
        xmColorFillRectangle(w, WIN_OF(w), BackGC, x + 2, y + 2,
                             width - 4, height - 4);
    }

    if (exp && !full_regen) {
        /* we consider this paint to be a 'pure expose' paint;
         * clip to exposure dimensions.  Make sure all clips are reset
         * before this function returns.
         */
        XRectangle crect[1];
        crect[0].x = 0;
        crect[0].y = 0;
        crect[0].width  = exp->width;
        crect[0].height = exp->height;
        ListSetClipAllGCs(w, exp->x, exp->y, crect, 1, YXBanded);
    }

    if (full_regen || exp) {
        /* do window background clearing.  
         */
        int tx, ty, twid, tht;
        
        if (!full_regen) {
            /* take dimensions from the expose data
             */
            tx = exp->x;
            ty = exp->y;
            twid = exp->width;
            tht = exp->height;
        }
        else {
            tx = ty = 0;
            twid = win_width;
            tht = win_height;
        }
        xmColorFillRectangle(w, w->window, BackGC, tx, ty, twid, tht);
    }

    x = 3;
    y = 1;

    /* If desired, make sure selection is visible - try to center it. */
    if (force_display_selection) {
        int old_pos = w->scroll_pos;
        int pos = FirstInIntsArray(w->selections);
        if ((pos >= w->scroll_pos + lines) ||
            (pos < w->scroll_pos)) {
            pos -= lines / 2 ;
            pos = MIN((w->num_strs - lines), pos);
            w->scroll_pos = MAX(0, pos);
        }
        if (old_pos != w->scroll_pos) {
            full_regen = TRUE; /* update all lines */
            w->regen_widget = TRUE; /* clear display */
        }
    }

    if (w->regen_widget) {
        xmColorFillRectangle(w, w->window, BackGC,
                             0, 0, win_width, win_height);
    }

    if (w->monospace_font) {
        gc = MonospaceGC;
        backgc = MonospaceBackGC;
    } else {
        gc = w->disabled ? DisabledGC : ForeGC;
        backgc = BackGC;
    }
    xdisp = -w->hscroll_pos;

    /* Draw in material */
    for (ix = w->scroll_pos; ix < w->num_strs; ix++) {
        p = w->strs[ix];

        if (((int) w->maxWidth != -1) && ((int) w->maxWidth == (ix + 1))) {
            xmColorFillRectangle(w, w->window, BackGC, 0, y, win_width + 1,
                                 line_height);
            DrawIconedString(w, gc, xdisp, y, p, backgc, 0, 0, 0);
            w->maxWidth = -1;
        }

        if (InIntsArray(w->selections, ix))
            ListDrawMark(w, ix, TRUE);
        else if (InIntsArray(w->old_selections, ix))
            ListDrawMark(w, ix, FALSE);
        else if (full_regen) {
            /* clear line */
            if (!w->regen_widget) {
                xmColorFillRectangle(w, w->window, BackGC, 0, y, win_width + 1,
                                     line_height);
            }
            DrawIconedString(w, gc, xdisp, y, p, backgc, 0, 0, 0);
        }
        if (((int) w->curPos != -1) && ((int) w->curPos == (ix + 1))) {
            ListDrawMarkerBox(w, ix);
            w->maxWidth = ix + 1;
        }
        y += line_height;
        if (y >= win_height)
            break;
    }

    w->scroll_hist->scroll_pos  = w->scroll_pos;
    w->scroll_hist->scroll_max  = w->scroll_max;
    w->scroll_hist->num_buttons = w->num_strs;
    if (w->old_selections)
        free(w->old_selections);
    w->old_selections = CopyIntsArray(w->selections);
    ListUnsetWorkColors(w);
    w->regen_widget = FALSE;

    ListUnsetClipAllGCs(w);
    
    if (full_regen)
        ListUpdateScrollbars(w);
    if (w->flags & WFLG_IN_EDIT) {
        XCopyArea(Dpy, w->window, w->parent->window, ForeGC, 0, 0,
                  win_width, win_height, win_xpos, win_ypos);
    }
    return;
}

/***********************************************************************
function: ListDrawMarkerBox - Draw a marker box around IDX.
Assumes hilighting is already there (if selected) and the item is visible.
*/
static void
ListDrawMarkerBox(w, idx)
AXWidget_list w;
register int idx; /* 0 based */
{
    register int ix;
    register int y;
    register int line_height;
    register int win_height;
    int x;
    int xdisp;
    int win_width;
    GC box_gc;
    int box_x;
    int box_y;
    unsigned int box_width;
    unsigned int box_height;

    if (!w)
        return;
    if (w->type != W_LIST)
        return;
    x = 3;
    y = 1;
    xdisp = -w->hscroll_pos;
    win_width = w->width - 6;
    line_height = xmListBoxLineHeight(w);
    win_height = w->height - 6;
    if (!InIntsArray(w->selections, idx))
        box_gc = ForeGC;
    else
        box_gc = BackGC;

    for (ix = w->scroll_pos; ix < w->num_strs; ix++) {
        if (ix != idx)
            goto bottom;
        box_x = xdisp;
        box_y = y + 1;
        box_width = win_width;
        box_height = line_height - 2;
        XDrawRectangle(Dpy, w->window, box_gc, box_x, box_y,
                       box_width, box_height);
        return;
bottom:
        y += line_height;
        if (y >= win_height)
            break;
    }
    return;
}

/***********************************************************************
function: ListDrawMark - Mark/Unmark a list item.
*/
static void
ListDrawMark(w, mark_idx, put_mark)
AXWidget_list w;
register int mark_idx;
int put_mark;
{
    register int ix;
    register int y;
    register int line_height;
    register int win_height;
    register char *p;
    int x;
    int xdisp;
    int win_width;
    GC  mark_gc;
    GC  gc, backgc;
    int xoffset = 0;

    if (!w)
        return;
    if (w->type != W_LIST)
        return;

    /* Draw hilighting */
    x = 3;
    y = 1;
    xdisp = -w->hscroll_pos;
    win_width = w->width - 6;
    line_height = xmListBoxLineHeight(w);
    win_height = w->height - 6;
    if (w->monospace_font) {
        gc = MonospaceGC;
        backgc = MonospaceBackGC;
    } else {
        gc = w->disabled ? DisabledGC : ForeGC;
        backgc = BackGC;
    }

    for (ix = w->scroll_pos; ix < w->num_strs; ix++) {
        if (ix != mark_idx)
            goto bottom;
        p = w->strs[ix];
        if (put_mark == TRUE) {
            /* hilite line */
			PIXEL_VALUE saved_fg;
			PIXEL_VALUE saved_bg;
			if (w->textColor) {
				/* use text color to draw the rectangle */
				saved_fg = AXGetForegroundPixel(Dpy,ForeGC);
				XSetForeground(Dpy,ForeGC,w->textColor->any.pixel);
			}

			XFillRectangle(Dpy, w->window, ForeGC, xoffset /*0*/, y,
						   win_width, line_height);

			if (w->textColor) 
				XSetForeground(Dpy, ForeGC, saved_fg);

            /* draw string */
			DrawIconedString(w, backgc, xdisp, y, p, backgc, TRUE, 0, 0);
        } else {
            /* clear line */
            xmColorFillRectangle(w, w->window, BackGC, 0, y,
                                 win_width, line_height);
            /* draw string */
            DrawIconedString(w, gc, xdisp, y, p, backgc, 0, 0, 0);
        }
        if (ix == mark_idx)
            return; /* done */
bottom:
        y += line_height;
        if (y >= win_height)
            break;
    }
    return;
}

/***********************************************************************
function: ListDrawCursor - Put a box cursor around current mark.  If
there is no mark, mark the last selected item and put box cursor
around it.
If PUT_CURSOR is TRUE, put cursor.
If PUT_CURSOR is FALSE, lift cusror.
*/
void
ListDrawCursor(w, put_cursor)
AXWidget_list w;
register int put_cursor;
{
    if (!w)
        return;
    if (w->type != W_LIST)
        return;

    ClearAllSelections(w);
    AddSelection(w, w->last_item_selected - 1); /* FIXME, check range */
    if (put_cursor)
        ListDrawMark(w, w->last_item_selected - 1, TRUE);
    PaintList(w, NULL, FALSE, FALSE);
    return;
}

/***********************************************************************
function: YPosOfRow - Return the y position of row index IDX on
success, 0 on failure (min y pos of any row is 1!!)
*/
static int
YPosOfRow(w, idx)
AXWidget_list w;
register int idx;
{
    register int y = 1;
    register int ix;
    register int line_height;
    register int win_height;

    line_height = xmListBoxLineHeight(w);
    win_height  = w->height - 6;
    for (ix = w->scroll_pos; ix < w->num_strs; ix++) {
        if (ix == idx)
            return(y);
        y+= line_height;
        if (y >= win_height)
            break;
    }
    return(0); /* bad */
}

/***********************************************************************
function: ListAutoScroll - Auto scroll the list box, and do marking.
*/
void
ListAutoScroll(w)
AXWidget_list w;
{
    int new_top_row;

    if (!w)
        return;
    if (w->type != W_LIST)
        return;
    if (!w->multi_pick)
        return;
    if (!xmlistStr.left_button_down)
        return;
    if ((w->armed != XmCR_INCREMENT) && (w->armed != XmCR_DECREMENT))
        return;

    if (w->armed == XmCR_INCREMENT) {
        new_top_row = w->scroll_pos + 1;
        ListScrollNewTopRow(w, new_top_row);
        if (new_top_row != w->scroll_pos)
            return;

        /* scroll succeeded */
        AddSelectionRange(w, xmlistStr.button_press_item - 1,
                          w->scroll_pos + w->scroll_max - 1);
        w->last_item_selected = w->scroll_pos + w->scroll_max /*+ 1 */;
    } else { /* XmCR_DECREMENT */
        new_top_row = w->scroll_pos - 1;
        ListScrollNewTopRow(w, new_top_row);
        if (new_top_row != w->scroll_pos)
            return;

        /* scroll succeeded */
        AddSelectionRange(w, xmlistStr.button_press_item - 1, w->scroll_pos);
        w->last_item_selected = w->scroll_pos + 1;
    }
    PaintList(w, NULL, FALSE, FALSE); /* true, true */
    return;
}

/***********************************************************************
function: ListScrollNewTopRow - Scroll to a new `scroll_pos' value.
*/
static void
ListScrollNewTopRow(w, new_scroll_pos)
AXWidget_list w;
int new_scroll_pos;
{
    int lines;
    int old_scroll_pos;
    int win_height;
    int line_height;
    int src_x, src_y, dst_x, dst_y;
    unsigned int width, height;
    int clip_x_origin, clip_y_origin;
    XRectangle crect[1];

    if (!w)
        return;
    
    if (w->type != W_LIST)
        return;
    
    if (w->scroll_pos == new_scroll_pos)
        return;

    old_scroll_pos = w->scroll_pos;
    lines = w->scroll_max;
    win_height = w->height - 6;
    line_height = xmListBoxLineHeight(w);
    if ((lines >= w->num_strs) && w->vScrollBar)
        new_scroll_pos = 0;
    else if ((new_scroll_pos + lines) > w->num_strs)
        new_scroll_pos = w->num_strs - lines;
    else if (new_scroll_pos < 0)
        new_scroll_pos = 0;

    if (ABS(new_scroll_pos - old_scroll_pos) >= lines) {
        /* results in a page scroll */
        w->scroll_pos = new_scroll_pos;
        goto full_repaint;
    } else {
        if (new_scroll_pos > old_scroll_pos) { /* shift up */
            src_y = YPosOfRow(w, new_scroll_pos);
            src_x = 0;
            dst_x = src_x;
            dst_y = 1;
            width  = w->width;
            height = win_height - src_y;
            ListSetWorkColors(w);
            XCopyArea(Dpy, w->window, w->window, BackGC, src_x, src_y,
                      width, height, dst_x, dst_y);
            clip_x_origin = src_x;
            clip_y_origin = dst_y + height;
            crect[0].x = 0;
            crect[0].y = 0;
            crect[0].width  = width;
            crect[0].height = win_height - dst_y;
            ListUnsetWorkColors(w);
#if 0 /* debugging */
            XDrawRectangle(Dpy, w->window, ForeGC, clip_x_origin,
                           clip_y_origin, crect[0].width,
                           crect[0].height);
#endif
        } else { /* shift down */
            src_x = 0;
            dst_x = src_x;
            src_y = 1;
            dst_y = src_y + ((old_scroll_pos - new_scroll_pos) * line_height);
            width = w->width;
            height = win_height - dst_y;
            ListSetWorkColors(w);
            XCopyArea(Dpy, w->window, w->window, BackGC, src_x, src_y,
                      width, height, dst_x, dst_y);
            clip_x_origin = src_x;
            clip_y_origin = src_y;
            crect[0].x = 0;
            crect[0].y = 0;
            crect[0].width  = width;
            crect[0].height = dst_y - 1;
            ListUnsetWorkColors(w);
#if 0 /* debugging */
            XDrawRectangle(Dpy, w->window, ForeGC, clip_x_origin,
                           clip_y_origin, crect[0].width,
                           crect[0].height);
#endif
        }
    }

    w->scroll_pos = new_scroll_pos;
    ListUpdateScrollbars(w);
    ListSetClipAllGCs(w, clip_x_origin, clip_y_origin, crect, 1, YXBanded);
    PaintList(w, NULL, TRUE, TRUE); /* lazy paint */
    ListUnsetClipAllGCs(w);
    return;

full_repaint:
    w->regen_widget = TRUE;
    PaintList(w, NULL, FALSE, FALSE);
    return;
}

/***********************************************************************
function: ListScrollNewHScrollPos - Scroll to a new `hscroll_pos' value.
*/
static void
ListScrollNewHScrollPos(w, new_hscroll_pos)
AXWidget_list w;
register int new_hscroll_pos;
{
    int old_hscroll_pos;
    int max_width;
    int win_height;
    int line_height;
    int src_x, src_y, dst_x, dst_y;
    unsigned int width, height;
    int clip_x_origin, clip_y_origin;
    int win_width;
    XRectangle crect[1];
    int shift_amt;

    if (!w)
        return;
    if (w->type != W_LIST)
        return;
    max_width = (int) w->maxLen;
    old_hscroll_pos = w->hscroll_pos;
    win_width = w->width - 6;
    if (max_width > (win_width - 15))
        max_width += 25; /* display extra white space at right */
    /* adjust new scroll hscroll pos */
    if ((win_width >= max_width) && w->hScrollBar)
        new_hscroll_pos = 0;
    if ((new_hscroll_pos + win_width) > max_width)
        new_hscroll_pos = max_width - win_width;
    if (new_hscroll_pos < 0)
        new_hscroll_pos = 0;

    if (ABS(new_hscroll_pos - old_hscroll_pos) >= w->width) {
        /* lateral page scroll */
        w->hscroll_pos = new_hscroll_pos;
        goto full_repaint;
    } else {
        if (new_hscroll_pos > old_hscroll_pos) { /* shift left */
            shift_amt = new_hscroll_pos - old_hscroll_pos;
            src_y = 1;
            src_x = shift_amt;
            dst_x = 0;
            dst_y = 1;
            width  = win_width - shift_amt;
            height = w->height;
            ListSetWorkColors(w);
            XCopyArea(Dpy, w->window, w->window, BackGC, src_x, src_y,
                      width, height, dst_x, dst_y);
            clip_x_origin = win_width - shift_amt;
            clip_y_origin = 1;
            crect[0].x = 0;
            crect[0].y = 0;
            crect[0].width  = new_hscroll_pos;
            crect[0].height = height;
            ListUnsetWorkColors(w);
#if 0 /* debugging */
            XDrawRectangle(Dpy, w->window, ForeGC, clip_x_origin,
                           clip_y_origin, crect[0].width,
                           crect[0].height);
#endif
        } else { /* shift right */
            shift_amt = old_hscroll_pos - new_hscroll_pos;
            src_y = 1;
            src_x = 0;
            dst_x = shift_amt;
            dst_y = 1;
            width  = win_width - shift_amt;
            height = w->height;
            ListSetWorkColors(w);
            XCopyArea(Dpy, w->window, w->window, BackGC, src_x, src_y,
                      width, height, dst_x, dst_y);
            clip_x_origin = 0;
            clip_y_origin = 1;
            crect[0].x = 0;
            crect[0].y = 0;
            crect[0].width  = shift_amt;
            crect[0].height = height;
            ListUnsetWorkColors(w);
#if 0 /* debugging */
            XDrawRectangle(Dpy, w->window, ForeGC, clip_x_origin,
                           clip_y_origin, crect[0].width,
                           crect[0].height);
#endif
        }
    }
    w->hscroll_pos = new_hscroll_pos;
#if 0 /* scrollbar-opt */
    ListUpdateScrollbars(w); /* paint-list does it */
#endif
    ListSetClipAllGCs(w, clip_x_origin, clip_y_origin, crect, 1, YXBanded);
    PaintList(w, NULL, TRUE, TRUE); /* lazy paint */
    ListUnsetClipAllGCs(w);
    return;

full_repaint:
    w->regen_widget = TRUE;
    PaintList(w, NULL, FALSE, FALSE);
    return;
}

/***********************************************************************
function: ListUpdateScrollbars - Update list box scroll bars.
*/
static void
ListUpdateScrollbars(w)
AXWidget_list w;
{
    int win_width;
    int lines;

    if (!w)
        return;
    if (w->type != W_LIST)
        return;

    win_width = w->width - 6;
    lines = w->scroll_max;

    /* NOTE: scrollbar parent MUST be dialog to ensure proper
       behaviour when task of listbox is pended */
    if ( !w->hide_vscroll) {
        if ( !w->vScrollBar ) {
            Arg args[10];
            int n = 0;
            static XtCallbackRec callback_list[2];
            CALLBACKER(callback_list,ListBarChanged,w);
            XtSetArg(args[n],XmNx,w->xpos+w->width+2); n++;
            XtSetArg(args[n],XmNy,w->ypos); n++;
            XtSetArg(args[n],XmNheight,w->height); n++;
            XtSetArg(args[n],XmNorientation,AXmVERTICAL); n++;
            XtSetArg(args[n],XmNvalueChangedCallback,callback_list); n++;
            if ( w->vScrollBar )
                AxXtSetValues(w->vScrollBar, args, n);
            else
                w->vScrollBar = (AXWidget_scroll) AXmCreateScrollBar(w->parent,
                                    "x",args,n);

            if (w->event_table) {
                    /* give the newly created scrollbar an event table
                     * which matches that of the list widget */
                copyEventHandlerList(w->event_table,
                            &w->vScrollBar->event_table);
            }
                /* dlg editor support */
            XtSetArg(args[0], ZXmNcompositeLinkUp, w);
            XtSetArg(args[1], ZXmNinEdit, w->flags & WFLG_IN_EDIT);
            AxXtSetValues(w->vScrollBar, args, 2);
            XtSetArg(args[0], ZXmNcompositeLinkDown, w->vScrollBar);
            AxXtSetValues(w, args, 1);
        }
        w->vScrollBar->display = TRUE;
        if ( lines >= w->num_strs ) {
            w->vScrollBar->scroll_per = 100;
            w->vScrollBar->scroll_max = 100;
            w->vScrollBar->scroll_pos = 0;
        }
        else {
            w->vScrollBar->scroll_per = lines * 10;
            w->vScrollBar->scroll_max = w->num_strs * 10;
            w->vScrollBar->scroll_pos = w->scroll_pos*10;
        }

        /* Propogate `buttonUpScroll' value here */
        w->vScrollBar->buttonUpScroll = w->buttonUpScroll;

        PaintScrollBar(w->vScrollBar, NULL, FALSE, FALSE);
    }
    else if ( w->vScrollBar ) {
        AxXtDestroyWidget(w->vScrollBar);
        w->vScrollBar = (AXWidget_scroll) NULL;
    }

    if ( w->list_hscroll ) {
        int max_width;
        max_width = (int) w->maxLen;
        if (max_width > (win_width - 15))
            max_width += 25; /* display extra white space at right */
        if ( !w->hScrollBar ) {
            Arg args[10];
            int n = 0;
            static XtCallbackRec hcallback_list[2];
            CALLBACKER(hcallback_list,ListBarChanged,w);
            XtSetArg(args[n],XmNx,w->xpos); n++;
            XtSetArg(args[n],XmNy,w->ypos+w->height+2); n++;
            XtSetArg(args[n],XmNwidth,w->width); n++;
            XtSetArg(args[n],XmNorientation,AXmHORIZONTAL); n++;
            XtSetArg(args[n],XmNvalueChangedCallback,hcallback_list); n++;
            if ( w->hScrollBar )
                AxXtSetValues(w->hScrollBar, args, n);
            else
                w->hScrollBar = (AXWidget_scroll)AXmCreateScrollBar(w->parent,
                                    "y",args,n);

            if (w->event_table) {
                    /* give the newly created scrollbar an event table
                     * which matches that of the list widget */
                copyEventHandlerList(w->event_table,
                            &w->hScrollBar->event_table);
            }
                /* dlg editor support */
            XtSetArg(args[0], ZXmNcompositeLinkUp, w);
            XtSetArg(args[1], ZXmNinEdit, w->flags & WFLG_IN_EDIT);
            AxXtSetValues(w->hScrollBar, args, 2);
            XtSetArg(args[0], ZXmNcompositeLinkDown, w->hScrollBar);
            AxXtSetValues(w, args, 1);
        }
        w->hScrollBar->display = TRUE;
        if ( w->width >= max_width ) {
            w->hScrollBar->scroll_per = 100;
            w->hScrollBar->scroll_max = 100;
            w->hScrollBar->scroll_pos = 0;
        }
        else {
            w->hScrollBar->scroll_per = win_width * 10;
            w->hScrollBar->scroll_max = max_width * 10;
            w->hScrollBar->scroll_pos = w->hscroll_pos * 10;
        }
        /* Propogate `buttonUpScroll' value here. */
        w->hScrollBar->buttonUpScroll = w->buttonUpScroll;

        PaintScrollBar(w->hScrollBar, NULL, FALSE, FALSE);
    }
    else if ( w->hScrollBar ) {
        AxXtDestroyWidget(w->hScrollBar);
        w->hScrollBar = (AXWidget_scroll) NULL;
    }
    return;
}   

/***********************************************************************
function: ListSetClipAllGCs - Set clip rectangle on all list box GCs.
*/
static void
ListSetClipAllGCs(w, clip_x_origin, clip_y_origin, rectangles, n,
                  ordering)
register AXWidget_list w;
register int clip_x_origin;
register int clip_y_origin;
register XRectangle *rectangles;
register int n;
register int ordering;
{
    if (!w)
        return;
    if (w->type != W_LIST)
        return;
    xmlistStr.clips_on = 1;
    xmlistStr.save_clip_x_origin = clip_x_origin;
    xmlistStr.save_clip_y_origin = clip_y_origin;
    xmlistStr.save_ordering = ordering;
    memcpy((char *) &xmlistStr.save_crect, (char *) rectangles, sizeof(XRectangle));

    XSetClipRectangles(Dpy, BackGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceBackGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceItalBoldBackGC, clip_x_origin,
                       clip_y_origin, rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceBoldBackGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceItalBackGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, ForeGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, DisabledGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceItalGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceBoldGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, MonospaceItalBoldGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, SunGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    XSetClipRectangles(Dpy, ShadowGC, clip_x_origin, clip_y_origin,
                       rectangles, n, ordering);
    return;
}

/***********************************************************************
function: ListRestoreSavedClips - Restores previously set clips.
*/
static void
ListRestoreSavedClips(w)
register AXWidget_list w;
{
    if (!w)
        return;
    ListSetClipAllGCs(w, xmlistStr.save_clip_x_origin, xmlistStr.save_clip_y_origin,
                      &xmlistStr.save_crect, 1, xmlistStr.save_ordering);
}
    
/***********************************************************************
function: ListUnsetClipAllGCs - Remove clip rectangles from all list
box GCs.
*/
static void
ListUnsetClipAllGCs(w)
register AXWidget_list w;
{
    if (!w)
        return;
    if (w->type != W_LIST)
        return;

    xmlistStr.clips_on = 0;
    XSetClipMask(Dpy, BackGC, None);
    XSetClipMask(Dpy, MonospaceBackGC, None);
    XSetClipMask(Dpy, MonospaceItalBoldBackGC, None);
    XSetClipMask(Dpy, MonospaceBoldBackGC, None);
    XSetClipMask(Dpy, MonospaceItalBackGC, None);
    XSetClipMask(Dpy, ForeGC, None);
    XSetClipMask(Dpy, DisabledGC, None);
    XSetClipMask(Dpy, MonospaceGC, None);
    XSetClipMask(Dpy, MonospaceItalGC, None);
    XSetClipMask(Dpy, MonospaceBoldGC, None);
    XSetClipMask(Dpy, MonospaceItalBoldGC, None);
    XSetClipMask(Dpy, SunGC, None);
    XSetClipMask(Dpy, ShadowGC, None);
    return;
}

static unsigned long
ColrFromName(name)
register char *name;
{
    register char *p;
    register char *end_p;
    register char *end_name;
    int r, g, b, color_ix;
    unsigned long color;

    /* find the closing paren */
    p = name;
    end_name = strchr(p, ')');
    if ( !end_name )
        return ( MAXLONGINT );

    /* get the red */
    end_p = strchr(p, ',');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        r = atoi(p);
    }

    /* get the green */
    p = end_p+1;
    end_p = strchr(p, ',');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        g = atoi(p);
    }

    /* get the blue */
    p = end_p+1;
    end_p = strchr(p, ')');
    if ( !end_p || end_p > end_name )
        return ( MAXLONGINT );
    else
    {
        *end_p = (char)0;
        b = atoi(p);
    }

    AxGetRealPixel(0, r, g, b, 0, 255, &color);
    return(color);
}

/*************************************************************************
function: DrawIconedString - Draw string, optionally paint images
*/
static void
DrawIconedString (w,gc,x,y,p,backgc,hilitbar,barWidth,barHt)
AXWidget_list w;
GC gc;
int x,y;    /* top-left-corner of text */
register char *p;   /* the string */
GC backgc;
int hilitbar; /* bool: true->text selected->use widget color to draw text */
int barWidth, barHt;
{
    register int sub_len;
    register int i;
    register int j;
    char buf[1000], sub_buf[1000], *sub_p, *end_p, *strchr();
    int fontHeight, fontAscent, lineHeight;
    GC topGC, bottomGC;
    Drawable drw;
    int txt_attr;
    unsigned long col_attr, map_fg;
    pixcache_t *pixc;
    Pixmap pix;
    int pix_wid, txt_wid, pix_height;
    unsigned long valuemask;
    XGCValues values;
    XImage *ximg;
    wcolor_t *stringColor;
    XFontStruct *savedFont;
    static GC iconGC = (GC) NULL;

    /* init local buffers */
    memset(buf, 0, sizeof(buf));
    memset(sub_buf, 0, sizeof(sub_buf));
    strncpy(buf,p,999);
    buf[999] = 0;
    p = buf;
    sub_p = sub_buf;
    sub_len = 0;
    txt_attr = 0;
    col_attr = MAXLONGINT;
    valuemask = GCForeground | GCBackground;

    drw = w->window;

    /* set the line height and widget font ascent */
    if (w->font)
    {
        fontHeight = w->font->ascent + w->font->descent;
        fontAscent = w->font->ascent;
    }
    else
    {
        fontHeight = AxCharHeight;
        fontAscent = AxCharAbove;
    }
    
    if (w->monospace_font)
    {
        /* this declaration overrides widget font */
        savedFont = w->font;
        w->font = (XFontStruct *) NULL;
    }

    /* read thru the string, handling each sub-element */
    while ( *p )
    {
        /* convert tabs to spaces */
        if ( *p == '\t' )
            *p = ' ';

        /* attribute info? */
        if ( *p == '\\'  && *(p+2) == '(' && (end_p = strchr(p+4,')')) )
        {
            /* if there is an outstanding string, draw it now */
            if ( sub_len )
            {
                XFontStruct *lsavedFont;
                lsavedFont = w->font;     /* in-line font attr may override */
                
                /* get the correct GC */
                if ( txt_attr )
                {
                    if ( gc == backgc )
                        gc = BackGCFromAttr(w, txt_attr);
                    else
                        gc = GCFromAttr(w, txt_attr);
                    txt_attr = 0;

                    /* in-line font attribute overrides widget font */
                    w->font = (XFontStruct *) NULL;
                }

                /* set the GC's color */
                if ( col_attr != MAXLONGINT )
                {
                    XGetGCValues(Dpy, gc, valuemask, &values);
                    XSetForeground(Dpy, gc, col_attr);

                    /* allow in-line attr to override widget text color */
                    stringColor = (wcolor_t *) NULL;
                }
                else
                {
					if (hilitbar)
						/* Highlighted text should use background color */
						stringColor = w->widgetColor;
					else
						/* Unhighlighted text should use the text color */
                    	stringColor = w->textColor;
                }

                /* draw the string */
                sub_buf[sub_len] = (char)0;
                txt_wid = BasicStrlen(sub_buf);
                xmDrawString(w, drw, gc, x, y+fontAscent,
                             sub_buf, sub_len, w->textShadow,
                             stringColor, w->widgetColor);
                sub_len = 0;

                /* restore widget's font attr */
                w->font = lsavedFont;

                /* restore the GC to it's default state */
                if ( col_attr != MAXLONGINT )
                {
                    XSetForeground(Dpy, gc, values.foreground);
                    col_attr = MAXLONGINT;
                }

                /* update the current draw position */
                x += txt_wid+2;
            }

            if ( *(p+1) == 'i' ) /* it's an icon */
            {
                if (!iconGC)
                {
                    /* use this gc for masked imaging of icon */
                    iconGC = axGetGC(GXcopy, ForePixel, BackPixel, AllPlanes);
                }
                
                /* get the correct GC */
                if ( txt_attr )
                {
                    if ( gc == backgc )
                        gc = BackGCFromAttr(w, txt_attr);
                    else
                        gc = GCFromAttr(w, txt_attr);
                    txt_attr = 0;
                }

                /* draw the (variable width,height) icon.  height is clipped
                 */
                lineHeight = xmListBoxLineHeight(w);
                *end_p = (char)0;
                pixc = Pixmapper(p + 3);
                if ( pixc ) /* draw using width=pixmap width, height=16 */
                {
                    pix = pixc->pix;
                    pix_wid = pixc->width;
                    pix_height = MIN(lineHeight, (int) pixc->height);
                }
                else /* unknown pixmap: draw 16x16 of default (50% gray) */
                {
                    pix = UnknownPixmap;
                    pix_wid = 16;
                    pix_height = MIN(lineHeight, 16);
                }

                /* clear the area behind the icon
                 */
                xmColorFillRectangle(w, drw, backgc,
                                     x, y, pix_wid+3, lineHeight);
                
                /* color stuff uses images, not pixmaps */
                if ( col_attr != MAXLONGINT )
                {
                    /* apply the color attr to the "foreground pixels"
                     * in the image.  Since pixcache_t makes no claim
                     * as to foreground pix value, we need to guess.
                     * This guess will be reasonable only for one-plane
                     * .im files.  These are imaged onto the pixmap using
                     * PixmapperForeGC, so use its fg pix as the guess val.
                     */
                    XGetGCValues(Dpy, PixmapperForeGC, valuemask, &values);
                    map_fg = values.foreground;
                    
                    /* get an image from the pixmap */
                    ximg = XGetImage(Dpy, pix,
                                     0,0, pix_wid,pix_height,
                                     AllPlanes, ZPixmap);

                    /* convert the fg pixels to the requested pixels */
                    for ( i=0; i<ximg->height; i++ )
                    {
                        for ( j=0; j<ximg->width; j++ )
                        {
                            if ( XGetPixel(ximg, j, i) == map_fg )
                                XPutPixel(ximg, j, i, col_attr);
                        }
                    }

                    /* put the image onto the display */
                    if (pixc && pixc->clip_mask)
                    {
                        XSetClipMask(Dpy, iconGC, pixc->clip_mask);
                        XSetClipOrigin(Dpy, iconGC, x,
                                       y + (fontHeight -
                                            LISTBOX_ICON_HT)/2);
                    }
                    else
                    {
                        XSetClipMask(Dpy, iconGC, None);
                        XSetClipOrigin(Dpy, iconGC, 0, 0);
                    }
                    XPutImage(Dpy, drw, iconGC, ximg,
                              0, 0,
                              x, y+(fontHeight-LISTBOX_ICON_HT)/2,
                              ximg->width, ximg->height);
                    
                    /* free the image memeory */
                    XDestroyImage(ximg);

                    col_attr = MAXLONGINT;
                }
                else /* copy from the icon pixmap to the listbox drawable */
                {
                    if (pixc && pixc->clip_mask)
                    {
                        XSetClipMask(Dpy, iconGC, pixc->clip_mask);
                        XSetClipOrigin(Dpy, iconGC, x,
                                       y + (fontHeight -
                                            LISTBOX_ICON_HT)/2);
                    }
                    else
                    {
                        XSetClipMask(Dpy, iconGC, None);
                        XSetClipOrigin(Dpy, iconGC, 0, 0);
                    }
                    XCopyArea(Dpy, pix, drw, iconGC,
                              0, 0, pix_wid, pix_height,
                              x, y+(fontHeight-LISTBOX_ICON_HT)/2);
                }

                /* update the current draw position */
                x += pix_wid+3;
            }

            else if ( *(p+1) == 'a' ) /* it's a text attr */
            {
                
                *end_p = (char)0;
                txt_attr |= AttrFromName((p + 3));
            }

            else if ( *(p+1) == 'c' ) /* it's an rgb attr */
                col_attr = ColrFromName((p+3));

            /* update the source string pointer */
            p = end_p+1;
        }

        /* just a character */
        else
        {
            /* add the character to the string list */
            sub_buf[sub_len] = *p;
            sub_len++;

            /* update the source string pointer */
            p++;
        }
    }

    /* if there is a string remaining, draw it now */
    if ( sub_len )
    {
        XFontStruct *lsavedFont;
        lsavedFont = w->font;        /* in-line attr may override */
        
        /* get the correct GC */
        if ( txt_attr )
        {
            if ( gc == backgc )
                gc = BackGCFromAttr(w, txt_attr);
            else
                gc = GCFromAttr(w, txt_attr);

            /* allow in-line font attr to override widget font */
            w->font = (XFontStruct *) NULL;
        }

        /* set the GC's color */
        if ( col_attr != MAXLONGINT )
        {
            XGetGCValues(Dpy, gc, valuemask, &values);
            XSetForeground(Dpy, gc, col_attr);

            /* allow in-line attr to override widget text color */
            stringColor = (wcolor_t *) NULL;
        }
        else
        {
			if (hilitbar)
				/* Highlighted text should use background color */
				stringColor = w->widgetColor;
			else
				/* Unhighlighted text should use the text color */
				stringColor = w->textColor;
        }

        /* draw the string */
        xmDrawString(w, drw, gc, x, y+fontAscent, sub_buf, sub_len,
                     w->textShadow, stringColor, w->widgetColor);

        /* restore widget's font attr */
        w->font = lsavedFont;

        /* restore the GC to it's default state */
        if ( col_attr != MAXLONGINT )
        {
            XSetForeground(Dpy, gc, values.foreground);
            col_attr = MAXLONGINT;
        }
    }
    
    if (w->monospace_font)
    {
        /* restore widget font */
        w->font = savedFont;
    }

}

int
IconedStringWidth(w, p)
AXWidget_list w;
register char *p;
{
    register char *slashP;
    register char *endP;
    int len;
    char buf[1000];
    int width = 0;
    int attr = 0;
    extern char *strchr();

    if (!p)
        return(0);
    strncpy(buf,p,999);
    buf[999] = 0;
    while ( p = strchr(buf,'\t') )  /* convert tabs to spaces (dumbly) */
        *p = ' ';
    p = buf;
    while ( (slashP = strchr(p,'\\')) &&    /* got \ */
            (*(slashP+2) == '(') &&         /* got \i( */
            (endP = strchr(slashP+4,')')) &&    /* got \i(xxx) */
            (endP-slashP < 30) ) {              /* and xxx is not too big */
        if (*(slashP+1) == 'i') {  /* icon */
            if ( slashP != p ) {        /* put portion before image */
                *slashP = 0;
                width += IconedStringWidth(w, p);
            }
            width += LISTBOX_ICON_HT;
        }
        else if (*(slashP+1) == 'a') {  /* attribute */
            
            p = slashP+3;   /* first char of number */
            *endP = 0;
            
            attr |= AttrFromName(p);
        }
        p = endP + 1;
    }
    if ( len = strlen(p) ) {
        XFontStruct *fs = FontFromAttr(w, attr);
        if (!fs) {
            if (w->font) {
                fs = w->font;
            }
            else {
                fs = AxDlgMainFont;
            }
        }
        width = width + AXTextWidth( fs, p, len );
    }
    return(width);
}


static int
AttrFromName(name)
register char *name;
{
    register char *p;

    p = name;
    while (*p) { 
        if ( isupper(*p) )  /* test for isupper needed on some machines */
            *p = (char) tolower(*p);
        p++;
    }
    if ( streq(name, NXLT("bold")) )
        return(ATTR_BOLD);
    else if ( streq(name, NXLT("ital")) || streq(name, NXLT("italic")) )
        return(ATTR_ITAL);
    else if ( streq(name, NXLT("mono")) || streq(name, NXLT("monospace")) )
        return(ATTR_MONO);
    else
        return(0);
}

static XFontStruct*
FontFromAttr(w, attr)
AXWidget_list w;
int attr;
{
    if ((attr & ATTR_MONO) || w->monospace_font) {
        if ((attr & ATTR_BOLD) && (attr & ATTR_ITAL))
            return(MonospaceItalBoldFont);
        else if (attr & ATTR_BOLD)
            return(MonospaceBoldFont);
        else if (attr & ATTR_ITAL)
            return(MonospaceItalFont);
        else if (!w->font)
            return(MonospaceFont);  /* default for monospace */
    }
    /* attr is 0, not recognized, or local font attr is present */
    return((XFontStruct *) NULL);
}

static GC
GCFromAttr(w, attr)
AXWidget_list w;
int attr;
{
    if ((attr & ATTR_MONO) || w->monospace_font) {
        if ((attr & ATTR_BOLD) && (attr & ATTR_ITAL))
            return(MonospaceItalBoldGC);
        else if (attr & ATTR_BOLD)
            return(MonospaceBoldGC);
        else if (attr & ATTR_ITAL)
            return(MonospaceItalGC);
        else
            return(MonospaceGC);   /* default for monospace */
    }
    /* attr not recognized - return gc for system default font */
    return(w->disabled ? DisabledGC : ForeGC);
}

static GC
BackGCFromAttr(w, attr)
AXWidget_list w;
int attr;
{
    if ((attr & ATTR_MONO) || w->monospace_font) {
        if ((attr & ATTR_BOLD) && (attr & ATTR_ITAL))
            return(MonospaceItalBoldBackGC);
        else if (attr & ATTR_BOLD)
            return(MonospaceBoldBackGC);
        else if (attr & ATTR_ITAL)
            return(MonospaceItalBackGC);
        else
            return(MonospaceBackGC);   /* default for monospace */
    }
    /* attr not recognized - return gc for system default font */
    return(BackGC);
}


/*************************************************************************
function: xmDestroyListPixmap - Free pixmap for list.
*/
void
xmDestroyListPixmap(w)
AXWidget_list w;
{
    if (!w->wapixmap) {
        return;
    }
#if !USE_SYS_MAP
    XFreePixmap(Dpy, w->wapixmap);
#endif
    w->wapixmap = (Pixmap) NULL;
    return;
}

/***********************************************************************
function: ListKeyPressCB - Process a key press inside the list
widget.
Note: Handles *only* XK_Up, XK_Down and not XK_Tab.
Return: 1 if event was consumed, 0 otherwise;
*/
static int
ListKeyPressCB(w, eventP)
register AXWidget_list w;
register XEvent *eventP;
{
    register int num_selections;
    register int tempint;
    int num_chars;
    wchar *buf;
    KeySym  ksym;
    int event_consumed = 0;
    XmListCallbackStruct data;

    if (!w || !eventP)
        return(event_consumed);
    if (w->type != W_LIST)
        return(event_consumed);
    if (eventP->xany.type != KeyPress)
        return(event_consumed);
    if (!w->selections)
        return(event_consumed);

    if (w->num_strs <= 0)
        return(event_consumed);

    num_selections = IntsArraySize(w->selections);
    num_chars = AXLookupString16(eventP, &buf, &ksym);
    if ((num_chars == 0) && ((ksym == 0) || AxKeysymIsModifier(ksym)))
        return(event_consumed); /* ignore shift/control */

    if ((ksym == XK_Up) || (ksym == XK_Down))
        event_consumed = 1;
    else
        return(event_consumed); /* deaf to all other keys. */
    
    if (((ksym == XK_Up) || (ksym == XK_Down)) && !num_selections) {
        /* If there are no selections, put selection on first item. */
        if (w->num_strs > 0) {
            if (w->curPos != -1) {
                tempint = w->curPos - 1;
                if (ksym == XK_Down) {
                    if ((tempint + 1) >= w->num_strs)
                        return(event_consumed);
                    tempint += 1;
                    AddSelection(w, tempint);
                    w->last_item_selected = tempint + 1;
                } else {
                    if (tempint < 1)
                        return(event_consumed); /* cant go up */
                    tempint -= 1;
                    AddSelection(w, tempint);
                    w->last_item_selected = tempint + 1;
                }
            } else {
                AddSelection(w, 0);
                w->last_item_selected = 1;
            }
        } else {
            return(event_consumed);
        }
    } else if (ksym == XK_Up) {
        event_consumed = 1;
        if (num_selections == 1) {
            tempint = ReadIntsArray(w->selections, 0);
            if (tempint < 1)
                return(event_consumed); /* cant go up */
            ListDrawMark(w, tempint, FALSE);
            tempint -= 1;
            ClearAndInsertSelection(w, tempint);
            w->last_item_selected = tempint + 1;
        } else {
            tempint = w->last_item_selected - 1;
            if (tempint < 1)
                return(event_consumed); /* can't go up */
            tempint -= 1;
            ClearAndInsertSelection(w, tempint);
            w->last_item_selected = tempint + 1;
        }
    } else if (ksym == XK_Down) {
        event_consumed = 1;
        if (num_selections == 1) {
            tempint = ReadIntsArray(w->selections, 0);
            if ((tempint + 1) >= w->num_strs)
                return(event_consumed);
            ListDrawMark(w, tempint, FALSE);
            tempint += 1;
            ClearAndInsertSelection(w, tempint);
            w->last_item_selected = tempint + 1;
        } else {
            tempint = w->last_item_selected - 1;
            if ((tempint + 1) >= w->num_strs)
                return(event_consumed);
            tempint += 1;
            ClearAndInsertSelection(w, tempint);
            w->last_item_selected = tempint + 1;
        }
    } else {
        event_consumed = 0;
        return(event_consumed);
    }

    if (((w->last_item_selected - 1) <= w->scroll_pos) ||
        (w->last_item_selected - 1) >= (w->scroll_pos + w->scroll_max) ||
        num_selections != 1) {
        PaintList(w, NULL, FALSE, FALSE);
    } else {
        ListDrawMark(w, w->last_item_selected - 1, TRUE);
        if (w->old_selections)
            free(w->old_selections);
        w->old_selections = CopyIntsArray(w->selections);
    }

    memset((char *) &data, '\0', sizeof(XmListCallbackStruct));
    data.reason = XmCR_SINGLE_SELECT;
    data.item_position = w->last_item_selected;
    if (w->multi_pick) {
        /* HACK, need an array for multi-pick list boxes. */
        data.selected_items = (XmString *) malloc(sizeof(XmString));
        data.selected_items[0] = (XmString) w->selections;
        data.selected_item_count = 1;
    }
    if (w->callback)
        AxCallback(w->callback, w, w->callbacktag, &data);
    if (data.selected_items)
        free(data.selected_items);
    return(event_consumed);
}

/***********************************************************************
function: ListButtonMotionCB - Process button-1-down-motion inside the
list box.
Note: Assumes caller has made sure button-1 is down.
*/
static void
ListButtonMotionCB(w, eventP)
register AXWidget_list w;
register XEvent *eventP;
{
    int ix, sx, ex;
    int item_position;
    long *new_selections;
    int num_new_selections;
    int num_selections;
    int tempint;
    int ypos;
    int line_height;
    int selno;

    if (!w || !eventP)
        return;
    if (w->type != W_LIST)
        return;
    if (eventP->xany.type != MotionNotify)
        return;
    if (w->num_strs <= 0)
        return;

    ypos = eventP->xmotion.y;
    line_height = xmListBoxLineHeight(w);
    if (eventP->xmotion.y > (w->height - 8))
        ypos = w->height - 8;

    ix = (ypos - 3) / line_height;
    if (ix < 0)
        ix = 0;

    /* Note: `item_position' is 1 based, however indices stored in
     * `w->selections' are 0 based.
	 */
    if (ix <= (w->num_strs - 1 - w->scroll_pos)) {
        ix += w->scroll_pos;
        item_position = ix + 1;
    } else
        return;

    if (item_position == w->last_item_selected)
        return; /* motion still in same item */

    if (!w->selections)
        w->selections = CreateIntsArray(0); /* sanity */

    /* Remove selection over range: button_press_item - last_item_selected;
	 * then add selectin over range: button_press_item - item_position
	 */
	if (xmlistStr.button_press_item < w->last_item_selected) {
		sx = xmlistStr.button_press_item - 1;
		ex = w->last_item_selected - 1;
	}
	else {
		sx = w->last_item_selected - 1;
		ex = xmlistStr.button_press_item - 1;
	}
	for (ix = sx; ix <= ex; ix++) {
		ClearSelection(w, ix);
	}
    AddSelectionRange(w, xmlistStr.button_press_item - 1, item_position - 1);
    w->last_item_selected = item_position;
    PaintList(w, NULL, FALSE, FALSE); /* true, true */
    return;
}

/***********************************************************************
function: ListButtonReleaseCB - Handle a button release in the list
box window.
*/
static void
ListButtonReleaseCB(w, eventP)
AXWidget_list w;
XEvent *eventP;
{
    XmListCallbackStruct data;
    int num_selections;

    memset((char *) &data, '\0', sizeof(XmListCallbackStruct));
    if (xmlistStr.left_btn_dbl_clicked) {
        data.reason = XmCR_DEFAULT_ACTION;
        data.item_position = xmlistStr.button_press_item;
        if (w->multi_pick) {
            /* HACK, need to pass an array for multi-pick list boxes. */
            num_selections = IntsArraySize(w->selections);
            if (num_selections != 1)
                return;
            data.selected_items = (XmString *) malloc(sizeof(XmString));
            data.selected_items[0] = (XmString) w->selections;
            data.selected_item_count = num_selections;
        }
    } else if (w->multi_pick) {
        if (ThimIsControled())
            data.reason = XmCR_MULTIPLE_SELECT;
        else if (ThimIsShifted())
            data.reason = XmCR_EXTENDED_SELECT;
        else
            data.reason = AXmCR_STROKE_SELECT;
        num_selections = IntsArraySize(w->selections);
        if (num_selections == 1)
            data.reason = XmCR_SINGLE_SELECT; /* HACK!! */
        data.item_position = xmlistStr.button_press_item;
        data.selected_items = (XmString *) malloc(sizeof(XmString));
        data.selected_items[0] = (XmString) w->selections;
        data.selected_item_count = num_selections;
    } else {
        data.reason = XmCR_SINGLE_SELECT;
        data.item_position = xmlistStr.button_press_item;
    }

    if (w->callback)
        AxCallback(w->callback, w, w->callbacktag, &data);

    if (data.selected_items)
        free(data.selected_items);

    /* No change in visual state at this point.  Don't paint. */
#if 0
    PaintList(w, NULL, TRUE, TRUE);
#endif
    return;
}

/***********************************************************************
function: SendListDropMessage - Form a drop message, and pass it to
the list box.
*/
SendListDropMessage(w, fname)
AXWidget_list w;
char *fname;
{
    XmListCallbackStruct data;

    if (!w || !fname)
        return(-1);
    data.reason = AXmCR_LIST_DROP;
    data.selected_items = (XmString *) malloc(sizeof(XmString));
    data.selected_items[0] = (XmString) fname;
    if (w->callback) {
        w->update_widget = WidgetNeedsUpdated = TRUE;
        AxCallback(w->callback, w, w->callbacktag, &data);
    }
    if (data.selected_items)
        free(data.selected_items);
    return(0);
}

/***********************************************************************
function: ListButtonPressCB - Handle a button press event in the list
box window.
*/
static void
ListButtonPressCB(w, eventP)
AXWidget_list w;
XEvent *eventP;
{
    int ix, line_height;
    unsigned long time;

#if LINUX
	int button_pressed = (int)eventP->xbutton.button;
	if (button_pressed == Button4 || button_pressed == Button5) {
		char *str = (char *)UPbyName(NXLT("axMouseWheelScroll"));
		int new_scroll_pos;
		if (str && (atoi(str) != 0)) {
			if (button_pressed == Button4) { /* mouse scroll up */
				if (ThimIsShifted())
					new_scroll_pos = w->scroll_pos - w->scroll_max;
				else
					new_scroll_pos = w->scroll_pos - 3;
			} else if (button_pressed == Button5) { /* mouse scroll down */
				if (ThimIsShifted())
					new_scroll_pos = w->scroll_pos + w->scroll_max;
				else
					new_scroll_pos = w->scroll_pos + 3;
			}
		}
		xmlistStr.AllowListToHaveHiddenSelection = TRUE;
		ListScrollNewTopRow(w, new_scroll_pos);
		xmlistStr.AllowListToHaveHiddenSelection = FALSE;
		return;
	}
#endif

    line_height = xmListBoxLineHeight(w);
    ix = (eventP->xbutton.y-3) / line_height;
    if (ix < 0)
        ix = 0;

    if (ix <= w->num_strs - 1 - w->scroll_pos) {
        time = eventP->xbutton.time;
        ix += w->scroll_pos;
        xmlistStr.button_press_item = ix + 1;

        if (w->double_click && xmlistStr.left_button_down &&
                    (xmlistStr.button_press_item == w->last_item_selected) &&
                    (time - w->last_click_time <= DoubleMillisec) &&
                    (w == (AXWidget_list)ClickWidget) ) {
            ClearAndInsertSelection(w, ix);
            time -= DoubleMillisec;/*so triple click won't be 1,2,2 is 1,2,1 */
            xmlistStr.left_btn_dbl_clicked = 1;
        } else if (w->multi_pick) {
            if (ThimIsControled())
                ToggleSelection(w, ix);
            else if (ThimIsShifted())
                ExtendAddSelection(w, ix);
            else {
                int cnt;
                int num_selections;
                int tempint;
                num_selections = IntsArraySize(w->selections);
                for (cnt = 0; cnt < num_selections; cnt++) {
                    tempint = ReadIntsArray(w->selections, cnt);
                    ListSetWorkColors(w);
                    ListDrawMark(w, tempint, FALSE);
                    ListUnsetWorkColors(w);
                }
                ClearAndInsertSelection(w, ix);
            }
        } else {  /* NOTE: only locally handlable case */
            /* non-multi-select: allow *only* one selection. */
            if (xmlistStr.left_button_down)
                ClearAndInsertSelection(w, ix);
        }
        w->last_click_time = time;
        w->last_item_selected = xmlistStr.button_press_item;
    }

#if ALPHA
    PaintList(w, NULL, TRUE, FALSE); /* true, true */
#else
    PaintList(w, NULL, FALSE, FALSE); /* true, true */
#endif
    return;
}

/***********************************************************************
function: AddSelection - Add SELNO to the selections list if not
already there.  Return new number of selections in the selections array.
*/
static int
AddSelection(w, selno)
AXWidget_list w;
register int selno; /* 0 based */
{
    register long *new_selections = (long *) NULL;
    register int num_selections;
    register int ix;
    register int tempint;

    num_selections = IntsArraySize(w->selections);
    new_selections = CreateIntsArray(num_selections + 1);
    for (ix = 0; ix < num_selections; ix++) {
        tempint = ReadIntsArray(w->selections, ix);
        if (tempint == selno) /* both are 0 based */
            goto bailout; /* already there no need to add */
        WriteIntsArray(new_selections, ix, tempint);
    }
    WriteIntsArray(new_selections, num_selections, selno);
    if (w->selections)
        free(w->selections);
    w->selections = new_selections;
    return(num_selections + 1);
bailout:
    if (new_selections)
        free(new_selections);
    return(num_selections);
}

/***********************************************************************
function: ClearSelection - Clear SELNO from the selections list if
already there.  Return new number of selections in the selections array.
*/
static int
ClearSelection(w, selno)
register AXWidget_list w;
register int selno;
{
    register long *new_selections = (long *) NULL;
    register int num_selections;
    register int ix;
    register int nx;
    register int tempint;

    num_selections = IntsArraySize(w->selections);
    if (num_selections <= 0)
        return(0);
    if (num_selections == 1) {
        tempint = ReadIntsArray(w->selections, 0);
        if (tempint != selno) 
            return(1);
        if (w->selections)
            free(w->selections);
        w->selections = CreateIntsArray(0);
        return(0);
    }

    new_selections = CreateIntsArray(num_selections - 1);
    for (ix = 0, nx = 0; ix < num_selections; ix++) {
        tempint = ReadIntsArray(w->selections, ix);
        if (tempint == selno)
            continue;
        WriteIntsArray(new_selections, nx, tempint); nx++;
    }
    if (w->selections)
        free(w->selections);
    w->selections = new_selections;
    return(num_selections - 1);
}

/***********************************************************************
function: ToggleSelection - Add SELNO if not already there; remove
SELNO if already there.  Return the number of selections in the
selections array.
*/
static int
ToggleSelection(w, selno)
register AXWidget_list w;
register int selno; /* 0 based */
{
    register int tempint;
    register int ix;
    register int num_selections;
    int found = 0;
    int new_numselections;

    num_selections = IntsArraySize(w->selections);
    for (ix = 0; ix < num_selections; ix++) {
        tempint = ReadIntsArray(w->selections, ix);
        if (tempint == selno) {
            found = 1;
            break;
        }
    }
    if (found)
        new_numselections = ClearSelection(w, selno);
    else
        new_numselections = AddSelection(w, selno);
    return(new_numselections);
}

/***********************************************************************
function: ExtendAddSelection - Add selections from`w->last_item_selected - 1'
to SELNO.  Return SELNO.
*/
static int
ExtendAddSelection(w, selno)
AXWidget_list w;
int selno;
{
    register int ix;
    register int upper_bound;
    register int lower_bound;
    register int last_idx;

    last_idx = w->last_item_selected - 1;

    if (last_idx == selno) {
        return(selno);
    } else if (last_idx < selno) {
        upper_bound = selno;
        lower_bound = last_idx + 1;
    } else if (last_idx > selno) {
        upper_bound = last_idx - 1;
        lower_bound = selno;
    }

    for (ix = lower_bound; ix <= upper_bound; ix++)
        AddSelection(w, ix);
    return(selno);
}

/***********************************************************************
function: AddSelectionRange - Add selections from FROM_SELNO to
TO_SELNO.
Return: 0
*/
static int
AddSelectionRange(w, from_selno, to_selno)
AXWidget_list w;
int from_selno; /* 0 based */
int  to_selno; /* 0 based */
{
    register int ix;
    register int upper_bound;
    register int lower_bound;

    if (from_selno == to_selno) {
        AddSelection(w, to_selno);
        return(0);
    } else if (from_selno > to_selno) {
        upper_bound = from_selno;
        lower_bound = to_selno;
    } else {
        upper_bound = to_selno;
        lower_bound = from_selno;
    }
    for (ix = lower_bound; ix <= upper_bound; ix++)
        AddSelection(w, ix);
    return(0);
}

/***********************************************************************
function: ExtendClearSelection - Clear selections from
`w->last_item_selected - 1' to SELNO.  Return SELNO.
*/
static int
ExtendClearSelection(w, selno)
register AXWidget_list w;
int selno;
{
    register int ix;
    register int upper_bound;
    register int lower_bound;
    register int last_idx;

    last_idx = w->last_item_selected - 1;
    if (last_idx == selno) {
        ClearSelection(w, selno);
        return(selno);
    }
    if (last_idx < selno) {
        upper_bound = selno;
        lower_bound = last_idx + 1;
    } else if (last_idx > selno) {
        upper_bound = last_idx - 1;
        lower_bound = selno;
    }
    for (ix = lower_bound; ix <= upper_bound; ix++) {
        ClearSelection(w, ix);
	}
    return(selno);
}

/***********************************************************************
function: ExtendToggleSelection - Toggle selections from
`w->last_item_selected - 1' to SELNO.  Return SELNO.
*/
static int
ExtendToggleSelection(w, selno)
AXWidget_list w;
int selno;
{
    register int ix;
    register int upper_bound;
    register int lower_bound;
    register int last_idx;

    last_idx = w->last_item_selected - 1;
    if (last_idx == selno) {
        return(selno);
    }
    if (last_idx < selno) {
        upper_bound = selno;
        lower_bound = last_idx + 1;
    } else if (last_idx > selno) {
        upper_bound = last_idx - 1;
        lower_bound = selno;
    }
    for (ix = lower_bound; ix <= upper_bound; ix++)
        ToggleSelection(w, ix);
    return(selno);
}

/***********************************************************************
function: ClearAndInsertSelection - Clear existing selections, then
insert new selection SELNO.
*/
static void
ClearAndInsertSelection(w, selno)
register AXWidget_list w;
register int selno; /* 0 based */
{
    if (w->selections)
        free(w->selections);
    w->selections = CreateIntsArray(1);
    WriteIntsArray(w->selections, 0, selno);
    return;
}

/***********************************************************************
function: ClearAllSelections - Clear all selections from the
selections array.
*/
static void
ClearAllSelections(w)
register AXWidget_list w;
{
    if (w->selections)
        free(w->selections);
    w->selections = CreateIntsArray(0);
    return;
}

/***********************************************************************
function: ListSetWorkColors - Set work colors on all GCs if necessary.
*/
static void
ListSetWorkColors(w)
register AXWidget_list w;
{
    if (!w)
        return;
    if ( w->useWorkColors ) {
        SetWorkColors(BackGC, 0);
        SetWorkColors(MonospaceBackGC, 0);
        SetWorkColors(MonospaceItalBoldBackGC, 0);
        SetWorkColors(MonospaceBoldBackGC, 0);
        SetWorkColors(MonospaceItalBackGC, 0);
        SetWorkColors(ForeGC, 1);
        SetWorkColors(DisabledGC, 1);
        SetWorkColors(MonospaceGC, 1);
        SetWorkColors(MonospaceItalGC, 1);
        SetWorkColors(MonospaceBoldGC, 1);
        SetWorkColors(MonospaceItalBoldGC, 1);
    }
    return;
}

/***********************************************************************
function: ListUnsetWorkColors - Unset work colors on all GCs if necessary.
*/
static void
ListUnsetWorkColors(w)
register AXWidget_list w;
{
    if (!w)
        return;
    if ( w->useWorkColors ) {
        UnSetWorkColors(BackGC, 0);
        UnSetWorkColors(MonospaceBackGC, 0);
        UnSetWorkColors(MonospaceItalBoldBackGC, 0);
        UnSetWorkColors(MonospaceBoldBackGC, 0);
        UnSetWorkColors(MonospaceItalBackGC, 0);
        UnSetWorkColors(ForeGC, 1);
        UnSetWorkColors(DisabledGC, 1);
        UnSetWorkColors(MonospaceGC, 1);
        UnSetWorkColors(MonospaceItalGC, 1);
        UnSetWorkColors(MonospaceBoldGC, 1);
        UnSetWorkColors(MonospaceItalBoldGC, 1);
    }
    return;
}

static int
xmListBoxLineHeight(w)
AXWidget_list w;
{
    int xoff, yoff, lineHeight;
    
    if (w->font) {
        lineHeight = w->font->ascent + w->font->descent;
    }
    else {
        lineHeight = AxCharHeight;
    }
    if (wShadowIsOn(w->textShadow)) {
        xmTextShadowOffsets(w->font, &xoff, &yoff);
        lineHeight += yoff + 1;
    }
    return (lineHeight);
}



/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
