/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmutils.c
   Applix ASC version: 143
   Date: Fri May 14 21:13:37 1999
*/
#include <stdio.h>
#include <stdlib.h>

#include <dwt2xm.h>
#include <basicwin.h>
#include <ax_xm.h>

#include <aos.h>
#include <xim.h>
#include <thimble.h>
#include <xmlib.h>
#include <getstr5.h>
#include <axdnd.h>
#include <atm.h>
#include <axbitmap.h>
#include <java_syms.h>
#include <infobox.h>

#define TIMEOUT_FOREVER -1  /* from axmain.c */

#if AX_X11
#include <X11/Xproto.h>
#else
#define X_CreatePixmap 53    /* define this for NT */
#endif


int AxPostMemoryWarning;    /* tells schedular to post memory warning box */
extern int AxMemoryWarning ; /* in bytes before warning box */
extern int AxMemoryLimit ;  /* in bytes before tearing task down */

extern char *DirSlash;
extern Window AxTopWinNeverMapped;  /* created by AxGetDpyAndGCs */
extern int AxNumberOfTopLevelTasks; /* # of tasks whose taskMaster is 0 */
extern Display *Dpy;    /* Resolution of DisplayWidget */
extern short DpyWid;    /* physical screen size */
extern short DpyHt; /* physical screen size */
extern short DpyDepth;  /* physical screen size */
extern short THIMpid;   /* pid of task */
extern GC Gc1;          /* grahics context shared by all windows */
extern int PrintXWarnings; /* set in xmlibcom.c */
XFontStruct *Curpixfontp;
Pixmap ScratchMap; /* screen size pixmap available as application resource */
extern Window RootWin;


int JavaMode = FALSE;   /* TRUE for Java slaved axmain */
int EnterpriseMode = FALSE; /* TRUE if running enterprise product */
unsigned long TimeOfButtonPress;    /* event time of button down */
unsigned long TimeOfKeyPress; /* event time of key press */
unsigned long TimeOfButtonRelease;  /* event time of button up */
int AxHighRes;  /* If 1, use 100 dpi.  If 2, use 125 dpi */
int AxFontShift;    /* Hack to force all fonts selects up in size */
int ThimNoWindowsLeft;  /* goes TRUE after terming last window */
info_box_t *AxInfoMessages;	/* list of info/error boxes */
int QuietRunning;   /* used to suppress display of dialogs */
int QuietErrsRunning;   /* used to suppress display of error msgs */

int ThimXErrorCondition = FALSE;
int ThimXErrorRequest = 0;
int ThimXErrorCode = Success;
int ThimLogEvents = FALSE;
short SpWid = -1;   /* gross hack "current" space character width. OBS? */

int ThimExposuresMayBeComing;   /* Hint for command startup delaying */

extern int ThimBellVolume;
extern int AxAllowXSync;

extern Pixmap AxCreateQueryPixmap();
extern XImage *AxGetSubImage();
extern Window ZXtDispatchEvent();
extern int UPnumVal();
extern GC axCreateGC();
typeErr getStr();
extern context_block *ActiveTasks[MAX_PIDS+1]; /* array of tasks .in_use */

extern int AxKeepRunning;   /* if TRUE, keey axmain up after last window hoes away */
extern int NumDlgNonTransients; /* Number of major dialogs */ /* JJM */

extern short ColorDisplay;  /* color available and being used */
extern int UseGloballyActiveFocus;
short NoColor = 0;  /* THIMBLE is X11 base let's try color */ 
extern short ToggleFG;  /* white background, black foreground */
#if !AXMS && !LINUX
extern char *sys_errlist[];
#endif

extern Atom AxPROTOCOL_ATOM;
extern Atom AxDELETE_WIN_ATOM;
extern Atom AxWIN_TAKE_FOCUS;
extern Atom AxXA_SAVE_YOURSELF;

int AxOpenLook;     /* TRUE if using OpenLook */

AXWidget AXmCreateErrorDialog();
AXWidget AXmCreateInformationDialog();
AXWidget WidgetOfCurrentAtmWindow();
AXWidget WidgetOfFocusWindow();
AXWidget WidgetOfWindow(), AXmMainWidgetOfTask();

#define isStatusStr(p) (p && (p[0] == '?') && strchr(NXLT("tsw"),p[1]))

static char *AxGetRequestName AXP_((int req));
static AxDoMessagePoster(/* int wid;char *p;int code;char *prepend;int error_mode; int perm_stat; int pend; */);

CreateScratchPixmap (display, drawable, width, height, depth)
Display *display;
Drawable drawable;
unsigned int width, height, depth;
{
    if (UPnumVal(PROF_AX_NO_SCRATCHMAP)) {
        ScratchMap = (Pixmap) NULL;
        return;
    }
    ScratchMap = AxCreateQueryPixmap(display, drawable, width, height, depth);
}

/*************************************************************************
 * : AxCreateQueryPixmap - create a pixmap, checking whether the
 * error handler executed
 */
Pixmap
AxCreateQueryPixmap(dpy, draw, width, height, depth)
Display *dpy;
Drawable draw;
unsigned int width, height, depth;
{
    Pixmap pix;

        /* make sure that if an error condition is detected
         * just after creating the pixmap, that it is because
         * of the creation of this pixmap and not some other.
         * Could this deprive someone else of needed error
         * info ?? yes, but they should specifically check
         * for it at request time -- a serial# method would
         * save this extra sync */
    XSync(dpy, False);
    ThimXErrorCondition = FALSE;

    pix = XCreatePixmap(dpy, draw, width, height, depth);
    XSync(dpy, False);
        /* any problems creating this particular pixmap should've
         * shown up by now */
    if (ThimXErrorCondition && ThimXErrorRequest == X_CreatePixmap) {
        ThimXErrorCondition = FALSE; /* always reset */
        return ((Pixmap) NULL);
    }
    return (pix);
}


Zmsgup()    /* just for help in debug */
{
}

/*************************************************************************
function: RingTheBell - Beep
*/
void RingTheBell ()
{
	if (TaskIsJavaBased(ThimPidFromUID(TaskInfo[AxInTask].uid))) {
		RingJavaBell();
		return;
	}
#if AX_X11
    XBell(Dpy,ThimBellVolume);
#else
    /* Win32 API call that uses the default sound specified in
     * Control Panel->Sounds.
     */
    MessageBeep(MB_OK);
#endif

    return;
}

/***********************************************************************
function: AxGetRequestName - Return the name of the X-Request in
string form, where REQ is the request code.
*/
static char *
AxGetRequestName(req)
int req;
{
    static char *cmd;

    switch (req) {
    case 1 :    cmd = NXLT("CreateWindow"); break;
    case 2 :    cmd = NXLT("ChangeWindowAttributes");   break;
    case 3 :    cmd = NXLT("GetWindowAttributes");  break;
    case 4: cmd = NXLT("DestroyWindow");    break;
    case 5 :    cmd = NXLT("DestroySubwindows");    break;
    case 6: cmd = NXLT("ChangeSaveSet");    break;
    case 7: cmd = NXLT("ReparentWindow");   break;
    case 8: cmd = NXLT("MapWindow");    break;
    case 9: cmd = NXLT("MapSubwindows");    break;
    case 10:    cmd = NXLT("UnmapWindow");  break;
    case 11 :   cmd = NXLT("UnmapSubwindows");  break;
    case 12 :   cmd = NXLT("ConfigureWindow");  break;
    case 13 :   cmd = NXLT("CirculateWindow");  break;
    case 14:    cmd = NXLT("GetGeometry");  break;
    case 15:    cmd = NXLT("QueryTree");    break;
    case 16:    cmd = NXLT("InternAtom");   break;
    case 17:    cmd = NXLT("GetAtomName");  break;
    case 18 :   cmd = NXLT("ChangeProperty");   break;
    case 19 :   cmd = NXLT("DeleteProperty");   break;
    case 20:    cmd = NXLT("GetProperty");  break;
    case 21 :   cmd = NXLT("ListProperties");   break;
    case 22 :   cmd = NXLT("SetSelectionOwner");    break;
    case 23 :   cmd = NXLT("GetSelectionOwner");    break;
    case 24 :   cmd = NXLT("ConvertSelection"); break;
    case 25:    cmd = NXLT("SendEvent");    break;
    case 26:    cmd = NXLT("GrabPointer");  break;
    case 27:    cmd = NXLT("UngrabPointer");    break;
    case 28:    cmd = NXLT("GrabButton");   break;
    case 29:    cmd = NXLT("UngrabButton"); break;
    case 30 :   cmd = NXLT("ChangeActivePointerGrab");  break;
    case 31:    cmd = NXLT("GrabKeyboard"); break;
    case 32 :   cmd = NXLT("UngrabKeyboard");   break;
    case 33:    cmd = NXLT("GrabKey");  break;
    case 34:    cmd = NXLT("UngrabKey");    break;
    case 35 :   cmd = NXLT("AllowEvents");  break;
    case 36 :   cmd = NXLT("GrabServer");   break;
    case 37 :   cmd = NXLT("UngrabServer"); break;
    case 38 :   cmd = NXLT("QueryPointer"); break;
    case 39 :   cmd = NXLT("GetMotionEvents");  break;
    case 40 :   cmd = NXLT("TranslateCoords");  break;
    case 41 :   cmd = NXLT("WarpPointer");  break;
    case 42 :   cmd = NXLT("SetInputFocus");    break;
    case 43 :   cmd = NXLT("GetInputFocus");    break;
    case 44 :   cmd = NXLT("QueryKeymap");  break;
    case 45 :   cmd = NXLT("OpenFont"); break;
    case 46 :   cmd = NXLT("CloseFont");    break;
    case 47:    cmd = NXLT("QueryFont");    break;
    case 48 :   cmd = NXLT("QueryTextExtents"); break;
    case 49 :   cmd = NXLT("ListFonts");    break;
    case 50 :   cmd = NXLT("ListFontsWithInfo");    break;
    case 51 :   cmd = NXLT("SetFontPath");  break;
    case 52 :   cmd = NXLT("GetFontPath");  break;
    case 53 :   cmd = NXLT("CreatePixmap"); break;
    case 54 :   cmd = NXLT("FreePixmap");   break;
    case 55 :   cmd = NXLT("CreateGC"); break;
    case 56 :   cmd = NXLT("ChangeGC"); break;
    case 57 :   cmd = NXLT("CopyGC");   break;
    case 58 :   cmd = NXLT("SetDashes");    break;
    case 59 :   cmd = NXLT("SetClipRectangles");    break;
    case 60 :   cmd = NXLT("FreeGC");   break;
    case 61 :   cmd = NXLT("ClearArea");    break;
    case 62 :   cmd = NXLT("CopyArea"); break;
    case 63 :   cmd = NXLT("CopyPlane");    break;
    case 64 :   cmd = NXLT("PolyPoint");    break;
    case 65 :   cmd = NXLT("PolyLine"); break;
    case 66 :   cmd = NXLT("PolySegment");  break;
    case 67 :   cmd = NXLT("PolyRectangle");    break;
    case 68 :   cmd = NXLT("PolyArc");  break;
    case 69 :   cmd = NXLT("FillPoly"); break;
    case 70 :   cmd = NXLT("PolyFillRectangle");    break;
    case 71 :   cmd = NXLT("PolyFillArc");  break;
    case 72 :   cmd = NXLT("PutImage"); break;
    case 73 :   cmd = NXLT("GetImage"); break;
    case 74 :   cmd = NXLT("PolyText8");    break;
    case 75 :   cmd = NXLT("PolyText16");   break;
    case 76 :   cmd = NXLT("ImageText8");   break;
    case 77 :   cmd = NXLT("ImageText16");  break;
    case 78 :   cmd = NXLT("CreateColormap");   break;
    case 79 :   cmd = NXLT("FreeColormap"); break;
    case 80 :   cmd = NXLT("CopyColormapAndFree");  break;
    case 81 :   cmd = NXLT("InstallColormap");  break;
    case 82 :   cmd = NXLT("UninstallColormap");    break;
    case 83 :   cmd = NXLT("ListInstalledColormaps");   break;
    case 84 :   cmd = NXLT("AllocColor");   break;
    case 85 :   cmd = NXLT("AllocNamedColor");  break;
    case 86 :   cmd = NXLT("AllocColorCells");  break;
    case 87 :   cmd = NXLT("AllocColorPlanes"); break;
    case 88 :   cmd = NXLT("FreeColors");   break;
    case 89 :   cmd = NXLT("StoreColors");  break;
    case 90 :   cmd = NXLT("StoreNamedColor");  break;
    case 91 :   cmd = NXLT("QueryColors");  break;
    case 92 :   cmd = NXLT("LookupColor");  break;
    case 93 :   cmd = NXLT("CreateCursor"); break;
    case 94 :   cmd = NXLT("CreateGlyphCursor");    break;
    case 95 :   cmd = NXLT("FreeCursor");   break;
    case 96 :   cmd = NXLT("RecolorCursor");    break;
    case 97 :   cmd = NXLT("QueryBestSize");    break;
    case 98 :   cmd = NXLT("QueryExtension");   break;
    case 99 :   cmd = NXLT("ListExtensions");   break;
    case 100:   cmd = NXLT("ChangeKeyboardMapping");    break;
    case 101:   cmd = NXLT("GetKeyboardMapping");   break;
    case 102 :  cmd = NXLT("ChangeKeyboardControl");    break;
    case 103 :  cmd = NXLT("GetKeyboardControl");   break;
    case 104:   cmd = NXLT("Bell"); break;
    case 105:   cmd = NXLT("ChangePointerControl"); break;
    case 106:   cmd = NXLT("GetPointerControl");    break;
    case 107 :  cmd = NXLT("SetScreenSaver");   break;
    case 108 :  cmd = NXLT("GetScreenSaver");   break;
    case 109 :  cmd = NXLT("ChangeHosts");  break;
    case 110 :  cmd = NXLT("ListHosts");    break;
    case 111 :  cmd = NXLT("SetAccessControl"); break;
    case 112:   cmd = NXLT("SetCloseDownMode"); break;
    case 113 :  cmd = NXLT("KillClient");   break;
    case 114:   cmd = NXLT("RotateProperties"); break;
    case 115:   cmd = NXLT("ForceScreenSaver"); break;
    case 116:   cmd = NXLT("SetPointerMapping");    break;
    case 117:   cmd = NXLT("GetPointerMapping");    break;
    case 118:   cmd = NXLT("SetModifierMapping");   break;
    case 119:   cmd = NXLT("GetModifierMapping");   break;
    case 127:   cmd = NXLT("NoOperation");  break;
    default:    cmd = NXLT("NoCommand");
    }
    return(cmd);
}


#if AX_X11    /* { */
/*************************************************************************
function: ThimXErrorHandler - Catch X window error messages
*/
ThimXErrorHandler (Dpy,eventP)
Display *Dpy;
XErrorEvent *eventP;
{
#if 1
    char *msg;
    char *cmd;
    char x_error_msg[300 + 1];

    ThimXErrorCode = eventP->error_code;
    switch ( eventP->error_code ) {
    case Success:   msg = NXLT("everything's okay");    break;
    case BadRequest:    msg = NXLT("bad request code"); break;
    case BadValue:  msg = NXLT("int parameter out of range");   break;
    case BadWindow: msg = NXLT("parameter not a Window");   break;
    case BadPixmap: msg = NXLT("parameter not a Pixmap");   break;
    case BadAtom:   msg = NXLT("parameter not an Atom");    break;
    case BadCursor: msg = NXLT("parameter not a Cursor");   break;
    case BadFont:   msg = NXLT("parameter not a Font"); break;
    case BadMatch:  msg = NXLT("parameter mismatch");   break;
    case BadDrawable:   msg = NXLT("parameter not a Pixmap or Window"); break;
    case BadAccess: msg = NXLT("depending on conte");   break;
    case BadAlloc:  msg = NXLT("insufficient resources");   break;
    case BadColor:  msg = NXLT("no such colormap"); break;
    case BadGC: msg = NXLT("parameter not a GC");   break;
    case BadIDChoice:   msg = NXLT("choice not in range or already used");  break;
    case BadName:   msg = NXLT("font or color name doesn't exist"); break;
    case BadLength: msg = NXLT("Request length incorrect"); break;
    case BadImplementation: msg = NXLT("server is defective");  break;
    default:    msg = NXLT("Unknown");
    }
#if 1
    cmd = AxGetRequestName(eventP->request_code);
#else
    switch ( eventP->request_code ) {
    case 1 :    cmd = NXLT("CreateWindow"); break;
    case 2 :    cmd = NXLT("ChangeWindowAttributes");   break;
    case 3 :    cmd = NXLT("GetWindowAttributes");  break;
    case 4: cmd = NXLT("DestroyWindow");    break;
    case 5 :    cmd = NXLT("DestroySubwindows");    break;
    case 6: cmd = NXLT("ChangeSaveSet");    break;
    case 7: cmd = NXLT("ReparentWindow");   break;
    case 8: cmd = NXLT("MapWindow");    break;
    case 9: cmd = NXLT("MapSubwindows");    break;
    case 10:    cmd = NXLT("UnmapWindow");  break;
    case 11 :   cmd = NXLT("UnmapSubwindows");  break;
    case 12 :   cmd = NXLT("ConfigureWindow");  break;
    case 13 :   cmd = NXLT("CirculateWindow");  break;
    case 14:    cmd = NXLT("GetGeometry");  break;
    case 15:    cmd = NXLT("QueryTree");    break;
    case 16:    cmd = NXLT("InternAtom");   break;
    case 17:    cmd = NXLT("GetAtomName");  break;
    case 18 :   cmd = NXLT("ChangeProperty");   break;
    case 19 :   cmd = NXLT("DeleteProperty");   break;
    case 20:    cmd = NXLT("GetProperty");  break;
    case 21 :   cmd = NXLT("ListProperties");   break;
    case 22 :   cmd = NXLT("SetSelectionOwner");    break;
    case 23 :   cmd = NXLT("GetSelectionOwner");    break;
    case 24 :   cmd = NXLT("ConvertSelection"); break;
    case 25:    cmd = NXLT("SendEvent");    break;
    case 26:    cmd = NXLT("GrabPointer");  break;
    case 27:    cmd = NXLT("UngrabPointer");    break;
    case 28:    cmd = NXLT("GrabButton");   break;
    case 29:    cmd = NXLT("UngrabButton"); break;
    case 30 :   cmd = NXLT("ChangeActivePointerGrab");  break;
    case 31:    cmd = NXLT("GrabKeyboard"); break;
    case 32 :   cmd = NXLT("UngrabKeyboard");   break;
    case 33:    cmd = NXLT("GrabKey");  break;
    case 34:    cmd = NXLT("UngrabKey");    break;
    case 35 :   cmd = NXLT("AllowEvents");  break;
    case 36 :   cmd = NXLT("GrabServer");   break;
    case 37 :   cmd = NXLT("UngrabServer"); break;
    case 38 :   cmd = NXLT("QueryPointer"); break;
    case 39 :   cmd = NXLT("GetMotionEvents");  break;
    case 40 :   cmd = NXLT("TranslateCoords");  break;
    case 41 :   cmd = NXLT("WarpPointer");  break;
    case 42 :   cmd = NXLT("SetInputFocus");    break;
    case 43 :   cmd = NXLT("GetInputFocus");    break;
    case 44 :   cmd = NXLT("QueryKeymap");  break;
    case 45 :   cmd = NXLT("OpenFont"); break;
    case 46 :   cmd = NXLT("CloseFont");    break;
    case 47:    cmd = NXLT("QueryFont");    break;
    case 48 :   cmd = NXLT("QueryTextExtents"); break;
    case 49 :   cmd = NXLT("ListFonts");    break;
    case 50 :   cmd = NXLT("ListFontsWithInfo");    break;
    case 51 :   cmd = NXLT("SetFontPath");  break;
    case 52 :   cmd = NXLT("GetFontPath");  break;
    case 53 :   cmd = NXLT("CreatePixmap"); break;
    case 54 :   cmd = NXLT("FreePixmap");   break;
    case 55 :   cmd = NXLT("CreateGC"); break;
    case 56 :   cmd = NXLT("ChangeGC"); break;
    case 57 :   cmd = NXLT("CopyGC");   break;
    case 58 :   cmd = NXLT("SetDashes");    break;
    case 59 :   cmd = NXLT("SetClipRectangles");    break;
    case 60 :   cmd = NXLT("FreeGC");   break;
    case 61 :   cmd = NXLT("ClearArea");    break;
    case 62 :   cmd = NXLT("CopyArea"); break;
    case 63 :   cmd = NXLT("CopyPlane");    break;
    case 64 :   cmd = NXLT("PolyPoint");    break;
    case 65 :   cmd = NXLT("PolyLine"); break;
    case 66 :   cmd = NXLT("PolySegment");  break;
    case 67 :   cmd = NXLT("PolyRectangle");    break;
    case 68 :   cmd = NXLT("PolyArc");  break;
    case 69 :   cmd = NXLT("FillPoly"); break;
    case 70 :   cmd = NXLT("PolyFillRectangle");    break;
    case 71 :   cmd = NXLT("PolyFillArc");  break;
    case 72 :   cmd = NXLT("PutImage"); break;
    case 73 :   cmd = NXLT("GetImage"); break;
    case 74 :   cmd = NXLT("PolyText8");    break;
    case 75 :   cmd = NXLT("PolyText16");   break;
    case 76 :   cmd = NXLT("ImageText8");   break;
    case 77 :   cmd = NXLT("ImageText16");  break;
    case 78 :   cmd = NXLT("CreateColormap");   break;
    case 79 :   cmd = NXLT("FreeColormap"); break;
    case 80 :   cmd = NXLT("CopyColormapAndFree");  break;
    case 81 :   cmd = NXLT("InstallColormap");  break;
    case 82 :   cmd = NXLT("UninstallColormap");    break;
    case 83 :   cmd = NXLT("ListInstalledColormaps");   break;
    case 84 :   cmd = NXLT("AllocColor");   break;
    case 85 :   cmd = NXLT("AllocNamedColor");  break;
    case 86 :   cmd = NXLT("AllocColorCells");  break;
    case 87 :   cmd = NXLT("AllocColorPlanes"); break;
    case 88 :   cmd = NXLT("FreeColors");   break;
    case 89 :   cmd = NXLT("StoreColors");  break;
    case 90 :   cmd = NXLT("StoreNamedColor");  break;
    case 91 :   cmd = NXLT("QueryColors");  break;
    case 92 :   cmd = NXLT("LookupColor");  break;
    case 93 :   cmd = NXLT("CreateCursor"); break;
    case 94 :   cmd = NXLT("CreateGlyphCursor");    break;
    case 95 :   cmd = NXLT("FreeCursor");   break;
    case 96 :   cmd = NXLT("RecolorCursor");    break;
    case 97 :   cmd = NXLT("QueryBestSize");    break;
    case 98 :   cmd = NXLT("QueryExtension");   break;
    case 99 :   cmd = NXLT("ListExtensions");   break;
    case 100:   cmd = NXLT("ChangeKeyboardMapping");    break;
    case 101:   cmd = NXLT("GetKeyboardMapping");   break;
    case 102 :  cmd = NXLT("ChangeKeyboardControl");    break;
    case 103 :  cmd = NXLT("GetKeyboardControl");   break;
    case 104:   cmd = NXLT("Bell"); break;
    case 105:   cmd = NXLT("ChangePointerControl"); break;
    case 106:   cmd = NXLT("GetPointerControl");    break;
    case 107 :  cmd = NXLT("SetScreenSaver");   break;
    case 108 :  cmd = NXLT("GetScreenSaver");   break;
    case 109 :  cmd = NXLT("ChangeHosts");  break;
    case 110 :  cmd = NXLT("ListHosts");    break;
    case 111 :  cmd = NXLT("SetAccessControl"); break;
    case 112:   cmd = NXLT("SetCloseDownMode"); break;
    case 113 :  cmd = NXLT("KillClient");   break;
    case 114:   cmd = NXLT("RotateProperties"); break;
    case 115:   cmd = NXLT("ForceScreenSaver"); break;
    case 116:   cmd = NXLT("SetPointerMapping");    break;
    case 117:   cmd = NXLT("GetPointerMapping");    break;
    case 118:   cmd = NXLT("SetModifierMapping");   break;
    case 119:   cmd = NXLT("GetModifierMapping");   break;
    case 127:   cmd = NXLT("NoOperation");  break;
    default:    cmd = NXLT("NoCommand");
    }
#endif

#ifndef AXLOG
#define AXLOG(body) AxLogger body
#endif
    AXLOG(("%s: %s\n",cmd,msg));
#endif

/* Print warning message. */
    if (PrintXWarnings) {
        if (eventP) {
            XGetErrorText(Dpy, eventP->error_code, (char *)x_error_msg, 300);
            /* Say "AXWarning" so that we know applix is printing the
               message. */
            printf("AXWarning: %s: %s\n", cmd, x_error_msg);
        } else
            printf("AXWarning: %s: no error structure\n", cmd);
    }

/* below is handling that was already there */
    if (eventP->error_code != Success) {
        ThimXErrorCondition = TRUE;
        ThimXErrorRequest = eventP->request_code;
    }
}


/*************************************************************************
function: RaiseMessageBoxToTop - Make sure user can see message box
This raises all message boxesto the top.  It can be well argued that
we should only raise the one related to the window we are trying to work
in, but the realtion may be a subtle 'uncle' relationship...
Note that task-0 may have a box...
*/
RaiseMessageBoxToTop ()
{
    XWMHints xwmh;
	int pid;
	info_box_t *ip;

	for ( ip = AxInfoMessages; ip; ip = ip->next ) {
	    xwmh.flags = StateHint;
	    xwmh.initial_state = NormalState;
	    XSetWMHints(Dpy, ip->window, &xwmh);
	    XMapWindow(Dpy,ip->window);
	    XRaiseWindow(Dpy,ip->window);
	    AXSetInputFocus(ip->window, FALSE, CurrentTime);
	}
}


/*************************************************************************
function: GetSysEvent - get the next event from the queue for processing
*/
GetSysEvent(timeout, event)
int timeout;    /* -1 or in milliseconds */
XEvent *event;
{
    extern int ThimbleSaysToReturnNow; /* HACK for escaping XtAppNextEvent */
    static int ExitTask = 0;    /* Task uid fired of for exiting */

    /* all negative timeouts become forever */
    if ( timeout < 0 )
        timeout = TIMEOUT_FOREVER;

    /* remove the hourglass cursor unless this is a quick poll */
    if ( timeout != 0 )
        XmClrHourglass();

    if ( !AxKeepRunning     /* The -stay is dominant */
        && (timeout == TIMEOUT_FOREVER || timeout > 1)  /* let delay@(0)  be ok,allow 1 millisec! */
        && !AxHaveAnyWindows()  /* Any windows at all keep us up (even unmapped) */
        && !AxHaveAnyTopTasks() ) {
        VfyContext(0);  /* required for kernel startups of tasks */
        if ( !ExitTask || !ThimPidFromUID(ExitTask) ) {
            ExitTask = ElfbNewTask("EXIT_ALL@",""); /* may or may not logout */
            return(FALSE);
        }
    }
    if ( AxPostMemoryWarning ) {
        VfyContext(0);  /* required for kernel startups of tasks */
        AxPostMemoryWarning = FALSE;
		if (AxMemoryLimit <= (AxMemoryWarning + AxMemoryWarning/8)) { 
			/* tells the memory_warning$ macro to post a final warning
			message. Same kind of check is done in tmzmallo.c */
			ElfbNewTask("MEMORY_WARNING$","TRUE");  /* may or may not logout */
		} else {
			ElfbNewTask("MEMORY_WARNING$","");
		}
    }

    /* ipc queued application work activity */
    if ( ThimbleSaysToReturnNow )
    {
        ThimbleSaysToReturnNow = FALSE;
        return ( FALSE );
    }

    if ( timeout == 0 && AXtAppNextEvent(NULL,0) == FALSE )
        return ( FALSE );

    /* Wait for next event */
    if ( AXtAppNextEvent(event, timeout) == FALSE )
        return ( FALSE );

    /* special case because this event not reported to any window */
    if ( event->type == MappingNotify )
    {
        if ( event->xmapping.request == MappingKeyboard )
            XRefreshKeyboardMapping(&event->xmapping);
        AxModifierMapping();
        return ( FALSE );
    }

#if BUILD_ORIENT
    if ( AXFilterEvent( event ) )
       {
       /* event was handled by the input mechanism */
       return( FALSE );
       }
#endif


    return ( TRUE );
}

/*************************************************************************
function: GetAndDoEvent - Fetch and Process incoming event or time out
*/
GetAndDoEvent(timeout)
int timeout;    /* in milliseconds, -1 = INFINITY */
{
    static unsigned long NLMtimeCheck;
    XEvent event;

    if ( GetSysEvent(timeout, &event) )
        DoSysEvent(&event);
}
#endif    /* } AX_X11 */



static AxMessagePoster(wid,code,prepend,p,error_mode, perm_stat)
int wid;    /* ATM window id or -1 (not used) */
char *p;
int code;   /* from applixstrfl */
char *prepend;  /* object of message */
int error_mode;
int perm_stat; /* load permstatus field */
{
    AxDoMessagePoster(wid,code,prepend,p,error_mode, perm_stat, TRUE);
}

static AxDoMessagePoster(wid,code,prepend,p,error_mode, perm_stat , pend)
int wid;    /* ATM window id or -1 (not used) */
char *p;
int code;   /* from applixstrfl */
char *prepend;  /* object of message */
int error_mode;
int perm_stat; /* load permstatus field */
int pend;
{
    register int ix;
    char buf[3000];     /* plenty long */
    AXWidget parent;
    Arg args[20];
    int an = 0;
    static XtCallbackRec Callback[2];   /* standard template */
    int is_status = FALSE, is_hourglass = FALSE;
    void ZXmTakeMsgAway();
    char getstrbuf[500];
    AXWidget atmWindowWidget;
	AXWidget infoBoxWidget;
	info_box_t *ip;

/* fetch from Appplixstrfl if need to */

    if ( ((p == NULL) || (*p == 0)) && (code != 0) ) {
        if ( AOK == getStr(code,getstrbuf) )
            p = getstrbuf;
        else {
            error_mode = TRUE;
            p = "";
        }
    }

/* detect leading ! for compatability */

    if ( p && (*p == '!') ) {
        while ( *p == '!' ) p++;
        error_mode = TRUE;
    }

/* Note whether message is status area rather than popup msg */

    if ( isStatusStr(p) ) {
        is_status = TRUE;
        if ( p[1] == 'w' )
            is_hourglass = TRUE;
        p += 2;
    }

/* note old message for later comparasons */

    atmWindowWidget = parent = WidgetOfWindow(wid);
    if ( !atmWindowWidget ) {
        wid = WindowIdFromPid(ThimPidFromUID(TaskInfo[THIMpid].taskMaster));
        if ( wid == -1 )
            parent = AXmMainWidgetOfTask(TaskInfo[THIMpid].taskMaster);
        else
            parent = WidgetOfWindow(wid);
#if AX_X11
        if ( !parent ) {
            parent = WidgetOfFocusWindow();
            atmWindowWidget = WidgetOfCurrentAtmWindow();
        }
#endif
    }

/* Apply object of message */

    if ( prepend && *prepend )
        sprintf(buf,"%s: ",prepend);
    else
        buf[0] = 0;

/* Add text */

    if ( p != NULL ) {
        while ( *p == ' ' ) p++;
        strcat(buf,p);
    }

    if ( JavaMode ) {
        AxJavaPostMessage(javaChanFromPid(THIMpid),NULL,buf,is_status,
						  error_mode);
		/* InfoMessage in Dlg.jv does not post a box for zero len messages.
		   Also, status messages do not result in an info box being posted */
		if ((buf && (strlen(buf) > 0)) && !is_status) {
			ip = (info_box_t*)TaskAlloc(0,sizeof(info_box_t));
			ip->widget = NULL;
			ip->window = 0;
			ip->dlgWindow = 0;
			ip->task = TaskInfo[AxInTask].taskMaster;
			ip->pended = pend && (AxInTask != 0);
			ip->next = AxInfoMessages;
			if ( ip->pended )
				TaskInfo[AxInTask].infoBox = ip;
			AxInfoMessages = ip;
		}
        return;
    }
    if ( is_status ) {
        if ( !QuietRunning ) {
            if ( atmWindowWidget ) {
                if ( perm_stat )
                    XmUpdatePermStatusMessage(atmWindowWidget,buf,code);
                else
                    XmUpdateStatusMessage(atmWindowWidget,buf,code);
                if ( error_mode )
                    XBell(Dpy,ThimBellVolume);
            }
        }
        if ( is_hourglass )
            XmPutHourglass();
        return;
    }

#if AX_X11    /* { */

/* Toss old messages */

	if ( atmWindowWidget ){
		if ( perm_stat )
			XmUpdatePermStatusMessage(atmWindowWidget,"",0);
		else
			XmUpdateStatusMessage(atmWindowWidget,"",0);
	}
	AxDestroyInfoBox(AxInTask);

#if BUILD_KANJI
    /* Ashisuto modified to fit the specification of the possible mode:
     * suppress the error message, but express the normal message.
     * 1996.11.14
     */
    if ( (QuietRunning && !error_mode) || (QuietErrsRunning && error_mode) )
        return;
#else
	if ( (QuietRunning && !error_mode) || QuietErrsRunning )
		return;
#endif

	if ( error_mode )
		XBell(Dpy,ThimBellVolume);

	if ( !buf[0] )
		return;

	CALLBACKER(Callback,ZXmTakeMsgAway,0);
	XtSetArg(args[an],XmNokCallback,Callback); an++;
	XtSetArg(args[an],XmNcancelCallback,Callback); an++;
	XtSetArg(args[an],XmNmessageString,buf); an++;
	XtSetArg(args[an],XmNmenuHelpWidget,code); an++;
	if ( error_mode )
		infoBoxWidget = AXmCreateErrorDialog(parent,XLT2("Generic title for error dialog box", "error"),args,an);
	else
		infoBoxWidget = AXmCreateInformationDialog(parent,XLT2("Generic title for message dialog box","msg"),args,an);
	AXtRealizeWidget(infoBoxWidget);
	ip = (info_box_t*)TaskAlloc(0,sizeof(info_box_t));
	ip->widget = infoBoxWidget;
	ip->window = AxXtWindow(ip->widget);
	ip->dlgWindow = AxXtWindow(XmDlgInWidget(ip->widget));
	ip->task = AxInTask;
	ip->pended = pend && (AxInTask != 0);
	ip->next = AxInfoMessages;
	if ( ip->pended )
		TaskInfo[AxInTask].infoBox = ip;
	AxInfoMessages = ip;
	Zmsgup();   /* just for help in debug */
#else	/* } { */
	/* AXMS */
	if ( !buf[0] )
		return;

	Zmsgup();	/* the debug hook */

	if ( error_mode )
		WXErrorMessage(buf);
	else
		WXInfoMessage(buf);

#if 0
    do not know what this is for, and it is undefined, si it is gone - jon
	ThimInfoBoxWindow = (Window)11111;	/* fake DC, for now */
#endif
#endif	/* } */
}

/*************************************************************************
function: AxErrorMessage - Post an error message window
*/
AxErrorMessage (wid,code,prepend,str)
int wid;	/* ATM window id or -1 (not used) */
int code;   /* from applixstrfl */
char *prepend;  /* object of message */
char *str;  /* override code produced string */
{
	extern int AxInTask;	/* true while not in kernel code */

	AxMessagePoster(wid,code,prepend,str,TRUE,FALSE);
    if ( AxInTask && !isStatusStr(str) )
		TaskRecycle();
}




pxtst()
{
	Pixmapper(NXLT("el_save"));
	return(0);
}

/*************************************************************************
function: ThimXIOErrorHandler - Catch fatal X window error messages
*/
ThimXIOErrorHandler ()
{
	/* IO error is caused due to system call failure -- print errno
	   error message. */
	printf("AXIOError: sys error msg: %s\n", sys_errlist[errno]);

	/* exit thru AxExit so that /tmp/.axscNN file gets cleared out.
	   This handler gets called when an Xlib read/write fails.  When
	   user does a Window Manager exit for instance... */
	AxExit(0);
}

/*************************************************************************
function: LogX11Event - Log event data if logging enabled
*/
void LogX11Event (event)
XEvent *event;
{
    char *p;

    if ( !ThimLogEvents ) return;

    switch ( event->type ) {
    case KeyPress:      p = NXLT("KeyPress");       break;
    case KeyRelease:        p = NXLT("KeyRelease");     break;
    case ButtonPress:       p = NXLT("ButtonPress");        break;
    case ButtonRelease:     p = NXLT("ButtonRelease");      break;
    case MotionNotify:      p = NXLT("MotionNotify");       break;
    case EnterNotify:       p = NXLT("EnterNotify");        break;
    case LeaveNotify:       p = NXLT("LeaveNotify");        break;
    case FocusIn:       p = NXLT("FocusIn");        break;
    case FocusOut:      p = NXLT("FocusOut");       break;
    case KeymapNotify:      p = NXLT("KeymapNotify");       break;
    case Expose:        p = NXLT("Expose");     break;
    case GraphicsExpose:        p = NXLT("GraphicsExpose");     break;
    case NoExpose:      p = NXLT("NoExpose");       break;
    case VisibilityNotify:      p = NXLT("VisibilityNotify");       break;
    case CreateNotify:      p = NXLT("CreateNotify");       break;
    case DestroyNotify:     p = NXLT("DestroyNotify");      break;
    case UnmapNotify:       p = NXLT("UnmapNotify");        break;
    case MapNotify:     p = NXLT("MapNotify");      break;
    case MapRequest:        p = NXLT("MapRequest");     break;
    case ReparentNotify:        p = NXLT("ReparentNotify");     break;
    case ConfigureNotify:       p = NXLT("ConfigureNotify");        break;
    case ConfigureRequest:      p = NXLT("ConfigureRequest");       break;
    case GravityNotify:     p = NXLT("GravityNotify");      break;
    case ResizeRequest:     p = NXLT("ResizeRequest");      break;
    case CirculateNotify:       p = NXLT("CirculateNotify");        break;
    case CirculateRequest:      p = NXLT("CirculateRequest");       break;
    case PropertyNotify:        p = NXLT("PropertyNotify");     break;
    case SelectionClear:        p = NXLT("SelectionClear");     break;
    case SelectionRequest:      p = NXLT("SelectionRequest");       break;
    case SelectionNotify:       p = NXLT("SelectionNotify");        break;
    case ColormapNotify:        p = NXLT("ColormapNotify");     break;
    case ClientMessage:     p = NXLT("ClientMessage");      break;
    case MappingNotify:     p = NXLT("MappingNotify");      break;
    default:                p = NXLT("?????");
    }
    XWINSlog("%s w=%x",p,event->xany.window);
}

XWINSlog(str,a,b,c,d,e,f,g,h,i,j,k,l,m)
char *str;
int a,b,c,d,e,f,g,h,i,j,k,l,m;
{
    static FILE *fp = NULL;
    static int counter;

    if ( !ThimLogEvents ) return;
    if ( !fp )
        fp = fopen("zzevents","w");
    fprintf(fp,"%d) ",counter++);
    fprintf(fp,str,a,b,c,d,e,f,g,h,i,j,k,l,m);
    fprintf(fp,"\n");
    fflush(fp);
}

#define MAX_N_PATS  33
/* pixmaps for pattern stipples */
typedef struct {
    Pixmap map, imap;
    int hyt, wid;
} StippleMap;

static StippleMap PatPM[MAX_N_PATS];

char *display_fills[] = {
    NXLT("gpfild00.im"),  NXLT("gpfild01.im"),
    NXLT("gpfild02.im"),  NXLT("gpfild03.im"),
    NXLT("gpfild04.im"),  NXLT("gpfild05.im"),
    NXLT("gpfild06.im"),  NXLT("gpfild07.im"),
    NXLT("gpfild08.im"),  NXLT("gpfild09.im"),
    NXLT("gpfild10.im"),  NXLT("gpfild11.im"),
    NXLT("gpfild12.im"),  NXLT("gpfild13.im"),
    NXLT("gpfild14.im"),  NXLT("gpfild15.im"),
    NXLT("gpfild16.im"),  NXLT("gpfild17.im"),
    NXLT("gpfild18.im"),  NXLT("gpfild19.im"),
    NXLT("gpfild20.im"),  NXLT("gpfild21.im"),
    NXLT("gpfild22.im"),  NXLT("gpfild23.im"),
    NXLT("gpfild24.im"),  NXLT("gpfild25.im"),
    NXLT("gp_fill.im"),   NXLT("gp_lfill.im"),
    NXLT("gpdisp.im"),
    NXLT("gp_dot1.im"), /* 4 handles in ge - 7x7 */
    NXLT("gp_dot2.im"),
    NXLT("gp_dot3.im"),
    NXLT("gp_dot4.im"),
};

char *printer_fills[] = {
    NXLT("gpfilp00.im"),  NXLT("gpfilp01.im"),
    NXLT("gpfilp02.im"),  NXLT("gpfilp03.im"),
    NXLT("gpfilp04.im"),  NXLT("gpfilp05.im"),
    NXLT("gpfilp06.im"),  NXLT("gpfilp07.im"),
    NXLT("gpfilp08.im"),  NXLT("gpfilp09.im"),
    NXLT("gpfilp10.im"),  NXLT("gpfilp11.im"),
    NXLT("gpfilp12.im"),  NXLT("gpfilp13.im"),
    NXLT("gpfilp14.im"),  NXLT("gpfilp15.im"),
    NXLT("gpfilp16.im"),  NXLT("gpfilp17.im"),
    NXLT("gpfilp18.im"),  NXLT("gpfilp19.im"),
    NXLT("gpfilp20.im"),  NXLT("gpfilp21.im"),
    NXLT("gpfilp22.im"),  NXLT("gpfilp23.im"),
    NXLT("gpfilp24.im"),  NXLT("gpfilp25.im"),
    NXLT("gp_fill.im"),   NXLT("gp_lfill.im"),
    NXLT("gpdisp.im"),
    NXLT("gp_dot1.im"), /* 4 handles in ge - 7x7 */
    NXLT("gp_dot2.im"),
    NXLT("gp_dot3.im"),
    NXLT("gp_dot4.im"),
};




/*************************************************************************
function: AxInitPatternPixmap - Load pixmap for standard fill patterns
*/
void AxInitPatternPixmap ( map_num )
int map_num;
{
    int i, size, wid, hyt;
    unsigned long vmask;
    bitmap_struct bmap;
    XGCValues vals;
    GC gc;

    if ( map_num >= MAX_N_PATS )
    {
       map_num = 0;
    }

    if ( PatPM[map_num].map != (Pixmap)NULL )
    {
       /* already created */
       return;
    }

    /* init the bitmap data */
    memset((char *)&bmap, 0, sizeof(bitmap_struct));
    bmap.pid = THIMpid;

    /* read the file, then copy the data onto pixmaps */
    if ( AxIMtoXImage((char *)0, display_fills[map_num], &bmap) != AOK )
    {
        /* could not create for some reason */
        PatPM[map_num].map = PatPM[map_num].imap = (Pixmap)NULL;
        PatPM[map_num].wid = PatPM[map_num].hyt = 0;
        return;
    }

    /* create a pixmap */
    wid = PatPM[map_num].wid = bmap.image.width;
    hyt = PatPM[map_num].hyt = bmap.image.height;
    size = bmap.image.bytes_per_line * hyt;
#if AXMS
    /* On Windows, we already have the Pixmap handle in the
     * XImage, so just use that.        -donato
     */
    PatPM[map_num].map = bmap.image.bitmap_handle;
 
    /* invert the bits in the image */
    for ( i=0; i<size; i++ )
        bmap.image.data[i] = ~bmap.image.data[i];
    /* create a pixmap for the inverted image */
    PatPM[map_num].imap = MS_CreateBitmap(wid, hyt, 1, 1, bmap.image.data);

    if ( bmap.image.bitmap_info != (BITMAPINFO *)NULL )
        free(bmap.image.bitmap_info);
    if ( bmap.image.palette_handle )
        MS_DeleteObject(bmap.image.palette_handle);
#else
    PatPM[map_num].map = XCreatePixmap(Dpy,AxTopWinNeverMapped,wid, hyt, 1);

    /* create a GC to draw onto the pixmap with */
    vmask = GCForeground | GCBackground;
    vals.foreground = 1;
    vals.background = 0;
    gc = axCreateGC(Dpy, PatPM[map_num].map, DefaultScreen(Dpy), 1,
                            (XFontStruct *) 0, vmask, &vals);

    /* draw the image onto the pixmap */
    XPutImage(Dpy, PatPM[map_num].map, gc, &bmap.image, 0,0, 0,0, wid,hyt);

    /* invert the bits in the image */
    for ( i=0; i<size; i++ )
        bmap.image.data[i] = ~bmap.image.data[i];

    /* create a pixmap for the inverted image */
    PatPM[map_num].imap = XCreatePixmap(Dpy,AxTopWinNeverMapped,wid,hyt, 1);

    /* draw the inverted image onto the pixmap */
    XPutImage(Dpy, PatPM[map_num].imap, gc, &bmap.image, 0,0, 0,0, wid,hyt);

    /* done - free resources */
    XFreeGC(Dpy, gc);
#endif

    if ( bmap.image.data )
        TaskFree(bmap.pid,bmap.image.data);
    if ( bmap.mask.data )
        TaskFree(bmap.pid,bmap.mask.data);

    return;
}

Pixmap GetStippleMap( map_num )
int map_num;
{
    if ( map_num >= MAX_N_PATS )
    {
       map_num = 0;
    }

    if ( PatPM[map_num].map == (Pixmap)NULL )
    {
       /* not yet created */
       AxInitPatternPixmap( map_num );
    }

    return( PatPM[map_num].map );
}


/* get the inverted stipple pixmap */
Pixmap GetStippleImap( map_num )
int map_num;
{
    if ( map_num >= MAX_N_PATS )
    {
       map_num = 0;
    }

    if ( PatPM[map_num].imap == (Pixmap)NULL )
    {
       /* not yet created */
       AxInitPatternPixmap( map_num );
    }
    return( PatPM[map_num].imap );
}





/************************************************************************/
Pixmap getBadImagePixmap()
{
    return( GetStippleMap(28) );
}
/*************************************************************************
function: AxSetWMProtocols - request window-manager protocols that we need.
the WM_DELETE_WINDOW is always needed, to prevent window-manager kill from
snapping our server connection without warning.
*/
AxSetWMProtocols (win, request_save)
Window win;          /* in */
int request_save;    /* in; bool: if true, may include WM_SAVE_YOURSELF */
{
    Atom props[3];
    int px = 0;
    static int save_yourself = FALSE;

    if ( !AxPROTOCOL_ATOM ) {
        /* create atoms for use during session
         */
        if (XInternAtom(Dpy, "_VUE_WORKSPACE_PRESENCE", True) != None) {
            save_yourself = TRUE;
        }
		save_yourself = TRUE;
        AxPROTOCOL_ATOM    = XInternAtom(Dpy,"WM_PROTOCOLS",False);
        AxDELETE_WIN_ATOM  = XInternAtom(Dpy,"WM_DELETE_WINDOW",False);
        AxWIN_TAKE_FOCUS   = XInternAtom(Dpy,"WM_TAKE_FOCUS",False);
        if (save_yourself) {
            AxXA_SAVE_YOURSELF = XInternAtom(Dpy,"WM_SAVE_YOURSELF",False);
        }
    }

    props[px] = AxDELETE_WIN_ATOM; px++;   /* we always need this protocol */

#if 0     /* shut off because of interference with DELETE_WIN */
    if (save_yourself && request_save) {
        props[px] = AxXA_SAVE_YOURSELF; px++;
    }
#endif  
    
    if (UseGloballyActiveFocus) {
        /* use the globally active input focus model
         */
        props[px] = AxWIN_TAKE_FOCUS; px++;
    }

    XSetWMProtocols(Dpy, win, &props[0], px);
}

ThimIOSync()
{
    XSync(Dpy,FALSE);
}

/*************************************************************************
function: GetMousePosOnDesktop - Return where pointer is on screen
*/
GetMousePosOnDesktop (xP,yP)
short *xP, *yP;
{
    int x,y,winx,winy;
    unsigned int buttons;
    Window root,child;

    XQueryPointer(Dpy,DefaultRootWindow(Dpy),&root,&child,&x,&y,&winx,&winy,
                            &buttons);
    *xP = x;
    *yP = y;
}

/*************************************************************************
function: IsWinInfoBox - Return TRUE if passed window is info_message
*/
int IsWinInfoBox (Window win)
{
	info_box_t *ip;

	for ( ip = AxInfoMessages; ip; ip = ip->next ) {
		if ( ip->window == win || ip->dlgWindow == win )
			return(TRUE);
	}
	return(FALSE);
}

/*************************************************************************
function: ZXmTakeMsgAway - Callback on InfoMsg OK button
*/
void ZXmTakeMsgAway(widget, tag, unused_data)
     AXWidget widget;
     caddr_t tag;
     mbchar *unused_data;
{
	info_box_t *ip;
	info_box_t *next;

	for ( ip = AxInfoMessages; ip; ip = next ) {
		next = ip->next;
		if ( ip->widget == (AXWidget)(widget->parent->parent) )
			AxDestroyInfoBox(0,ip);
	}
}

/*************************************************************************
function: AxDestroyInfoBox - Destroy info boxes by task or info_box_t*
*/
AxDestroyInfoBox (int pid, info_box_t *removeMe)
{
	AXWidget w;
	info_box_t *ip, *prev = NULL;
	int ix;

	if ( !removeMe ) {
		for ( ip = AxInfoMessages; ip; ip = ip->next ) {
			if ( ip->task == pid )
				break;
		}
		removeMe = ip;
	}
	if ( !removeMe )
		return;

	for ( ip = AxInfoMessages; ip; prev = ip, ip = ip->next ) {
		if ( ip == removeMe ) {
			if ( !prev )
				AxInfoMessages = ip->next;
			else
				prev->next = ip->next;
		    w = ip->widget;
			TaskFree(0,ip);
		    AxXtDestroyWidget(w);
		    for ( ix = 0; ActiveTasks[ix]; ix++ )
		        if ( ActiveTasks[ix]->infoBox == ip )
					ActiveTasks[ix]->infoBox = NULL;
			return;
		}
	}
}

/***********************************************************************
function: AxfJvCloseInfoMsg --
*/
void
AxfJvCloseInfoMsg(task)
int task;
{
	info_box_t *ip, *prev = NULL;
	info_box_t *removeMe = NULL;
	int ix;

	for (ip = AxInfoMessages; ip; ip = ip->next) {
		if (ip->task == task)
			break;
	}
	removeMe = ip;

	if (!removeMe) {
		return;
	}
	for (ip = AxInfoMessages; ip; prev = ip, ip = ip->next) {
		if (ip == removeMe) {
			if (!prev)
				AxInfoMessages = ip->next;
			else
				prev->next = ip->next;
			TaskFree(0, ip);
			for (ix = 0; ActiveTasks[ix]; ix++) {
				if (ActiveTasks[ix]->infoBox == removeMe) {
					ActiveTasks[ix]->infoBox = NULL;
				}
			}
			return;
		}
	}
	return;
}

/************************************************************************/
Pixmap AxCreatePMFromBM(dat, wid, hyt,dep, invert)
char *dat;
int wid, hyt;
int dep,invert;
{
    XImage ximage;
    GC gc;
    XGCValues gcv;
    Pixmap pix;
    int fg,bg;
#if AXMS
    HDC hdc;
    
    hdc = MS_GetDC(NULL);
    AxTopWinNeverMapped = hdc;
#endif    
    
    if ( invert )
    {
        fg = 0;
        bg = 1;
    }
    else
    {
        fg = 1;
        bg = 0;
    }

    pix = XCreatePixmap(Dpy, AxTopWinNeverMapped, wid, hyt, dep);
    gcv.foreground = fg;
    gcv.background = bg;
    if (! (gc = axCreateGC(Dpy, pix, DefaultScreen(Dpy), dep,
                           (XFontStruct *) 0,
                           GCForeground|GCBackground, &gcv))) {
        
        return (Pixmap) NULL;
    }
    memset(&ximage, 0, sizeof(ximage));
    ximage.height = hyt;
    ximage.width = wid;
    ximage.depth = dep;
    ximage.xoffset = 0;
    ximage.format = ZPixmap;
    ximage.data = dat;
    ximage.byte_order = MSBFirst;
    ximage.bitmap_bit_order = MSBFirst;
    ximage.bits_per_pixel = dep;
    ximage.obdata = NULL;
    ximage.bitmap_unit = 16;
    ximage.bitmap_pad = 16; 

    if ( dep == 8 )
        ximage.bytes_per_line = wid+wid%2;
    else
        ximage.bytes_per_line = (wid+7)/8 + ((wid+7)/8)%2;
    XPutImage(Dpy, pix, gc, &ximage, 0, 0, 0, 0, wid, hyt);
    XFreeGC(Dpy, gc);

#if AXMS
    AxTopWinNeverMapped = NULL;
    MS_ReleaseDC(NULL, hdc);
    /* The following may have been allocated in XPutImage */
    if ( ximage.bitmap_info )
        free(ximage.bitmap_info);
    if ( ximage.bitmap_handle )
        MS_DeleteObject(ximage.bitmap_handle);
    if ( ximage.palette_handle )
        MS_DeleteObject(ximage.palette_handle);
#endif
    return(pix);
}

/************************************************************************/
AxFreePixmap(map) 
Pixmap map; 
{
    XFreePixmap(Dpy, map); 
}

/*************************************************************************
function: HandleExposures - Respond to incoming exposure events only
*/
HandleExposures ()
{
    XEvent event;
    int n;
    int got_expose = FALSE;

#if AX_X11    /* { */
    /* HandleExposures () is called many times (typically >20) when a
       dialog box is destroyed, thus causing a lot of syncs.
       -- Results in a large time delay when running Aster*x over a
       phone line.  Product feels sluggish.
       I have tested the product with and without `axSuppressBackingStore'.
       Tried to fill *large* ranges in the spread sheet...  Since the
       spreadsheet and all other Aster*x apps are capable of redrawing
       `regions', the product is well behaved.
       For fallback, profile variable `axAllowXSync' controls whether
       or not sync will happen */
    if (AxAllowXSync)
        XSync(Dpy,FALSE);

    event.xany.type = 0;
#if SUPPORT_HP_VUE
    while (AxRealXtPending())
#else
    while ( XPending(Dpy) )
#endif
    {
#if SUPPORT_HP_VUE
        XtPeekEvent(&event);
#else
        XPeekEvent(Dpy,&event);     /* check for expose event */
#endif
        if (( event.type != Expose ) && (event.type != GraphicsExpose)) /* no, quit */
            return(got_expose);
        got_expose = TRUE;
        n = AXtAppNextEvent(&event,-1); /* fetch it normally */
        if ( !n )   /* ignore incoming signal */
            continue;
        if ( SetWpFromX11Window(event.xany.window) )    /* for whom? */
            HandleExposureEvent(&event);        /* expose window */
        ZXtDispatchEvent(&event);       /* hand to widget kit */
    }
    ThimExposuresMayBeComing = FALSE;
    return(got_expose);
#else    /* } AX_X11 { */

    /* NT case */
    ThimExposuresMayBeComing = FALSE;
    return( FALSE );
#endif    /* } AX_X11 */    
}

SystemMessage(p)    /* ??x Obsolete this guy! */
char *p;
{
    AxMessagePoster(-1,0,NULL,p,FALSE,FALSE);
}

extern int AxInTask;    /* true while not in kernel code */

ElfbStatusMessage (p)   /* ??x Obsolete this guy! */
char *p;
{
    SystemMessage(p);
    if ( AxInTask && !isStatusStr(p) )
        TaskRecycle();
}

/*************************************************************************
function: AxInfoMessageNonPend - Post an info message box
*/
AxInfoMessageNonPend (wid,code,object,str)
int wid;        /* ATM window id or -1 (not used) */
typeErr code;   /* Applixstrfl number */
char *object;   /* NULL or object of message */
char *str;      /* NULL or string to override Applixstrfl fetch */
{
    extern int AxInTask;    /* true while not in kernel code */

    AxDoMessagePoster(wid,code,object,str,FALSE,FALSE,FALSE);
    if ( AxInTask && !isStatusStr(str) )
        TaskRecycle();
}
/*************************************************************************
function: AxInfoMessage - Post an info message box
*/
AxInfoMessage (wid,code,object,str)
int wid;        /* ATM window id or -1 (not used) */
typeErr code;   /* Applixstrfl number */
char *object;   /* NULL or object of message */
char *str;      /* NULL or string to override Applixstrfl fetch */
{
    extern int AxInTask;    /* true while not in kernel code */

    AxMessagePoster(wid,code,object,str,FALSE,FALSE);
    if ( AxInTask && !isStatusStr(str) )
        TaskRecycle();
}
AxDirectInfoMessage(wid, str)
int wid;        /* ATM window id or -1 (not used) */
char *str;      /* string */
{
    AxMessagePoster(wid, 0, (char *)0, str, FALSE, TRUE);
}
AxDirectInfoCode(wid, code)
int wid;        /* ATM window id or -1 (not used) */
typeErr code;   /* Applixstrfl number */
{
    AxMessagePoster(wid, code, (char *)0, (char *)0, FALSE, TRUE);
}

/*************************************************************************
function: AxgetColorpalFromWidget - returns colorpal of widget
*/
AXWidget
AxgetColorpalFromWidget(wd)
AXWidget_main wd;
{
    if (wd && wd->type == W_MAIN)
        return((AXWidget)wd->colorpal);
}

/*************************************************************************
function: getWindowFromWidget - returns window from widget
*/
Window
getWindowFromWidget(wd)
AXWidget_main wd;
{
    Window xwin;

    xwin = 0;
    if (wd)
    {
        if (wd->type == W_MAIN)
            xwin = wd->workWindow->window;
        else if (wd->type == W_GE_XRULER ||
                 wd->type == W_GE_YRULER )
            xwin = wd->window;
        else
            fprintf(stdout,"not supported for this widget =%d\n",wd->type);
    }
    return(xwin);
}

/*************************************************************************
function: set_drawable - changes drawable of widget
*/
Drawable
set_drawable(wd, drw)
AXWidget_main wd;
Drawable drw;
{
    Drawable xwin;

    xwin = 0;
    if (wd)
    {
        if (wd->type == W_MAIN)
        {
            xwin = wd->workWindow->window;
            wd->workWindow->window = drw;
        }
        else
            fprintf(stdout,"not supported for this widget =%d\n",wd->type);
    }
    return(xwin);
}

/*************************************************************************
function: AxSetFontPath - Set or change Applix font font entry
*/
void AxSetFontPath(oldname,newname)
char *oldname, *newname;    /* must be same for initial call */
{
#if AXMS    /*  {  */
    tempAbort("AxSetFontPath called");
#else       /* }  {  */
    char fplist[50][256];
    char *real_fplist[50];      /* hope this is enough */
    int npaths, i;
    char *p;
    char **SvFontPath;      /* for later restoration */
    extern Display *Dpy;    /* Resolution of DisplayWidget */

/* skim current list, getting rid of trailing "/" and look for already there */

    SvFontPath = XGetFontPath(Dpy, &npaths);
    for (i = 0; i < npaths; i++) {
        strcpy(fplist[i], SvFontPath[i]);
        p = fplist[i];
        if ( p[strlen(p)-1] == '/' )
            p[strlen(p)-1] = 0;
        real_fplist[i] = fplist[i];
        if ( streq(fplist[i], oldname) ) {  /* found it! */
            if ( !streq(oldname,newname) ) {    /* replace it! */
                real_fplist[i] = newname;
                XSetFontPath(Dpy, real_fplist, npaths);
            }
            if (SvFontPath) XFreeFontPath (SvFontPath);
            return;
        }
    }

/* If got here, old name was not in list */

    real_fplist[npaths] = newname;
    XSetFontPath(Dpy, real_fplist, npaths+1);
    if (SvFontPath) XFreeFontPath (SvFontPath);
#endif    /*  }  */
}




/* The following function can be called to warn the user that he is opening */
/* a 2.1 revision document, and that writing the file back out will overwrite */
/* the original.  The message text comes from the file ".../axdata/warn_2.1" */
/* If this file is not present, this function does nothing                   */
Post2_1OpenMessage()
{
    char msg[3001];
    FILE *fp;
    char path[STRPATH+1];
    int num_bytes;

    strcpy( path, ThimApplixDir );
    strcat( path, DirSlash );
    strcat( path, NXLT("warn_2.1") );

    fp = fopen( path, READ_STR );
    if ( fp == (FILE *)NULL )
       /* no file */
       return;

    /* get a bunch to get the whole file */
    num_bytes = fread( msg, 1, 3000, fp );
    msg[num_bytes] = 0;              /* fail safe end */

    fclose( fp );

    ElfbStatusMessage( msg );

    return;
}

/****************************************************************************/
Pixmap
GetPixmapFromAttrs(attr, free_map)
attr_type *attr;   /* for drawing lines  */
int *free_map;
{
    Pixmap fill_map;
    int inv;

    *free_map = FALSE;
    if ( attr->f_type == 5 )
    {
        attr->f_type = 0;
        attr->f_pat = get_percent_ix(attr->f_pat);
    }
    inv = attr->ffg.see_thru ? TRUE : FALSE;
    if ( attr->f_type != 1 ) { /* assume built in fill, get map by index */
        fill_map = inv ? GetStippleImap(attr->f_pat) : 
                              GetStippleMap(attr->f_pat);
    }else {
        /* we will be allocating a pixmap, caller must free */
        *free_map = TRUE;
        if ( attr->f_ddep == 8 )
            fill_map = get_color_pixmap(attr->f_dwid, attr->f_dhyt,
                                        attr->f_data, attr->f_cmap,inv);
        else
            fill_map = AxCreatePMFromBM(attr->f_data, attr->f_dwid,
                                        attr->f_dhyt, attr->f_ddep, inv);
    }
    return(fill_map);
}

/**************************************************************************** 
macro: ElfbColorState - Return the virtual depth of the display
*/
ElfbColorState()
{
#if !FOR_TESTER
    extern short DpyDepth;
    extern short NoColor;

    if (NoColor || DpyDepth == 1)
        return (1);
    else
        return ((int) DpyDepth);
#endif
}



 
/*******************************************************************/
AxGetPatDimensions(type, pat, width, height)
int type,   /* fill type */
pat;    /* fill pattern */
int *width, *height;
{
    /* convert percent fill to pattern fill */
    if ( type == 5 )
        pat = get_percent_ix(pat);
    if ( PatPM[pat].map == (Pixmap)NULL )
        AxInitPatternPixmap( pat );
    *width = PatPM[pat].wid;
    *height = PatPM[pat].hyt;
}
 


/*************************************************************************/
