/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: adld.h
   Applix ASC version: 5
   Date: Tue Jun 15 21:12:33 1999
*/
#ifndef _adld_h_
#define _adld_h_

/* shared library bind bit flags */
#define ADL_BIND_IMMEDIATE 1
#define ADL_BIND_DEFERRED  2
#define ADL_BIND_FIRST     4 /* required for internal shared libraries
								on HP800, to place the library at the head
								of the symbol search order.
								This should not be used for user shared
								libraries, as they will be able
								to override applixware internal functions */
#define ADL_BIND_GLOBAL     8  /* for platforms that support RTLD_GLOBAL */

#define ADL_TYPE_UNDEFINED 0
#define ADL_TYPE_DATA      1
#define ADL_TYPE_PROCEDURE 2

#if defined(__cplusplus)
extern "C" {
void *Adlopen (char *path, int mode);
void *Adlsym (void *handle, char *symbol, int type);
char *Adlerror (void);
int  Adlclose (void *handle);
}

#else

#ifndef AXP_
#define AXP_(body) ()
#endif

void *Adlopen AXP_((char *path, int mode));
void *Adlsym AXP_((void *handle, char *symbol, int type));
char *Adlerror AXP_((void));
int  Adlclose AXP_((void *handle));
#endif	/* !cplusplus */

#endif /* !_adld_h_ */


/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
