/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: aos.h
   Applix ASC version: 85.7
   Date: Thu Apr  8 21:11:13 1999
*/
#ifndef aosHinclude
#define aosHinclude 1

#if NT_MIPS
/* this is defined by the compiler but used by us as the flag for the */
/* Mips Magnum machine whose porting changes we do not want. - jimr */
#undef MIPS
#endif

#define V7      1   /* Version 7 */
#define SYS3        2   /* System III */
#define SYS5        4   /* System V */
#define B4_2        8   /* Berkely 4.2BSD */

#ifndef AX_NT
#define AX_X11 1
#define AX_NT 0
#define AX_UNIX 1
#endif

/* Control of function prototyping */

#if AX_USE_PROTOS
#define AXP_(body) body
#else
#define AXP_(body) ()
#endif

#if 0
this is taken out since the PMAX does not support full prototyes yet
#if PMAX
#undef AXP_
#define AXP_(body) body
#endif  /* PMAX */
#endif

#if AX_NT
#include <io.h>
#include <direct.h>
#include <string.h>
#else
#if SYSV4 || CLIX || M_88K
#include <string.h>
#else
#include <strings.h>
#endif
#endif
#include <atypes.h>
#include <sys/stat.h>
#include <stdio.h>
#include <malloc.h>
#include <errno.h>
#include <math.h>

#include <exits.h>

#if !NOLIB_THIMBLE
#include <stdlib.h>     /* this must be included before things like "malloc" */
                        /* get redefined so we don't hit stdlib later        */
#include <thim_gen.h>       /* OBSOLETE THIS SUCKER! */
#if UDFM_THIMBLE
#include <ax_udfm.h>
#endif
#if PF_THIMBLE
#include <thim_pf.h>
#endif
#if GE_THIMBLE
#include <thim_ge.h>
#endif
#if GC_THIMBLE      /* gecvt */
#include <ax_gecvt.h>
#endif
#if PX_THIMBLE
#include <thim_px.h>
#endif
#if CL_THIMBLE
#include <thim_cl.h>
#endif
#if SS_THIMBLE
#include <thim_ss.h>
#endif
#if ED_THIMBLE
#include <thim_ed.h>
#endif
#endif

/*-------------------------- Useful and obvious stuff -----------------------*/

#define IN
#define OUT
#define INOUT

#ifndef TRUE
#define TRUE        1
#define FALSE       0
#endif

#ifndef M_PI
   /* this does not seem to be defined on Windows-NT */
#define  M_PI    3.14159265358979323846
#endif

#if M_88K
#define hypot Axhypot
double hypot(); 
#endif

#ifdef ABS /* defined in timers.h */
#undef ABS
#endif
#define ABS(x) (((x) > 0) ? (x) : -(x))


#define typeErr short   /* Values must be represented in 16 bits!! */
#define AOK     0       /* the best error code of all !! */
#define AOKTYPELESS 0       /* for Document Composer. */


#ifndef DLL_EXPORT
#if AXMS
#define DLL_EXPORT __declspec( dllexport )
#else
#define DLL_EXPORT
#endif
#endif

/* DLL_IMPORT is needed only when building DLLs (shared libs) on NT.
 * The application DLLs need to import data from the main executable.
 * We do this by 1) marking the appropriate variables as exported data
 * in axmain.def, and 2) declaring those variables using declspec(dllimport)
 * in the DLL code.  From the MS knowledge base: "In the case of data, using
 * declspec(dllimport) is a convenience item that removes a layer of
 * indirection. When you import data from a DLL [or executable in our case],
 * you still have to go through the import address table."(Article ID: Q132044)
 */
#ifndef DLL_IMPORT
#if AX_DLL
#define DLL_IMPORT __declspec( dllimport )
#else
#define DLL_IMPORT
#endif
#endif


/***********************************************************************/
/* Define the basic data types used in the Aster*x product             */
/***********************************************************************/
#define int8   char
#define uint8  unsigned char
#define int16  short
#define uint16 unsigned short
#define int32  int
#define uint32 unsigned int

#if BUILD_WIDE  /* { */
/* build the product using wide characters */
#define wchar unsigned short
#define mbchar char
#else   
#define wchar unsigned char
#define mbchar char
#endif  /* } BUILD_WIDE */

#define generic_ptr unsigned char *


/***********************************************************************/
/* SYS_INFO stuff, used to be in axio.c                                */
/***********************************************************************/
#if PMAX
#define SYS_INFO    "1001"
#endif
#if SUN4
#define SYS_INFO    "1002"
#endif
#if HP300
#define SYS_INFO        "1003"
#endif
#if SUN3
#define SYS_INFO    "1004"
#endif
#if MIPS
#define SYS_INFO    "1005"
#endif
#if X386_NEW
#define SYS_INFO    "1006"
#endif
#if SGI || NEC_EWS
#define SYS_INFO    "1007"
#endif
#if HP800
#define SYS_INFO    "1008"
#endif
#if RIOS
#define SYS_INFO    "1009"
#endif
#if AUX
#define SYS_INFO    "1010"
#endif
#if VAX
#define SYS_INFO    "1011"
#endif
#if M_88K
#define SYS_INFO    "1012"
#endif
#if CLIX
#define SYS_INFO    "1013"
#endif
#if AXMS
#define SYS_INFO        "1014"
#endif
#if ALPHA
#define SYS_INFO        "1015"
#endif
#if USL54
#define SYS_INFO        "1016"
#endif
#if SUNIS
#define SYS_INFO        "1017"
#endif
#if LINUX
#define SYS_INFO        "1018"
#endif
#ifndef SYS_INFO
/* This will print an obvious message at compile time */
"aos.h: Need a revstamp for this machine";
#endif


#define NXLT(str) str

#if !BUILDING_AOSXLATE /* { */

#ifdef __cplusplus
extern "C" {
#endif

char *XLT(char *);
char *XLT2(char *, char *);
char *XLT_SEQ(char *);
char *XLT_SEQ2(char *, char *);

#ifdef __cplusplus 
};
#endif  

#endif	/*  } !BUILDING_AOSXLATE */


/* default font faces, defined in fontname.c */
extern DLL_IMPORT char *axDefaultSerifFont;
extern DLL_IMPORT char *axDefaultSansSerifFont;
extern DLL_IMPORT char *axDefaultMonospaceFont;



/********************************************************************/
/** herin follows a define for bcopy such that the result function **/
/** is defined to correctly handle overlaping regions              **/
/********************************************************************/
#if SYSV4 || PMAX || HP800 || RIOS || ALPHA || AXMS || M_88K || CLIX || SCOUNIX || SGI || LINUX || NEC_EWS
#define bcopy(a,b,c) memmove(b,a,c)
#define BCOPY_OK 1
#endif

#if SUN4 && (SYS&B4_2)
  /* bcopy is OK */
#define BCOPY_OK 1
#endif

#if !BCOPY_OK
You must set up a define for 'bcopy'
#endif
/********************************************************************/


/***********************************************************************/
/* for porting reasons, (re)define some common utilities.   These      */
/* use to be in "utils.h" but that did not get included everywhere it  */
/* needed to be                                                        */
/* Note: for those functions where the arguments are the same they are */
/*       not specified so that old code which does things like:        */
/*       " char *strchr() "    will still compile without a complaint  */
/*       that the strchr macro has no arguments                        */
/***********************************************************************/
#if SYS&SYS5 || SYS&VMSSYS || SYSV4 || PMAX || AXMS || M_88K   /*  {  */
#define bcmp memcmp
#define bzero(a,b) memset(a,0,b)
#define memclr(a,b) memset(a,0,b)

#ifdef index 
#undef index
#endif

#ifdef rindex
#undef rindex
#endif

/** in the "wide" environment the following should be used:
**   index -->  Windex
**   rindex -->  Wrindex
**   strchr -->  Windex
**   strrchr -->  Wrindex **/

#define index strchr
#define rindex strrchr

#if X386_NEW || HP800 || CLIX || HP300
extern char *strchr(),*strrchr(); 
#else
#if !SYSV4 && !PMAX && !AXMS && !SGI && !AVIION && !RIOS && !NEC_EWS
extern char *memcpy(),*memset(),*strchr(),*strrchr();
#endif
#endif

#else                                   /*  }  {   */
#define memcpy(a,b,c) bcopy(b,a,c)
#define memcmp bcmp
#define memclr bzero
 
#ifdef strchr
#undef strchr
#endif

#ifdef strrchr
#undef strrchr
#endif

/** in the "wide" environment the following should be used:
**   index -->  Windex
**   rindex -->  Wrindex
**   strchr -->  Windex
**   strrchr -->  Wrindex **/

#if !HYUNDAI
#define strchr index
#define strrchr rindex
#endif

extern char *index();
extern char *rindex();
#endif                                 /*  }  */


/***********************************************************************/
/* Define the character manipulation functions                         */
/***********************************************************************/

/* the following "MB" defines are done so that we can tell, in the */
/*   source code, that the developer looked at this and decided that */
/*   the things being manipulated were indeed byte based strings, and not */
/*   wide strings                                                    */
#define MBstrcat(a,b) (mbchar *)strcat((char *)a,(char *)b)
#define MBstrncat(a,b,n) (mbchar *)strncat((char *)a,(char *)b, n)
#define MBstrdup (mbchar *)strdup
#define MBstrcmp(a,b) strcmp((char *)a,(char *)b)
#define MBstrncmp(a,b,n) strncmp((char *)a,(char *)b, n)
#define MBstrcpy(a,b) (mbchar *)strcpy((char *)a,(char *)b)
#define MBstrncpy(a,b,n) (mbchar *)strncpy((char *)a,(char *)b, n)
#define MBstrlen(a) strlen((char *)a)
#define MBstreq(a,b) streq((char *)a,(char *)b)
#define MBstrchr (mbchar *)strchr
#define MBstrrchr (mbchar *)strrchr
#define MBstrpbrk (mbchar *)strpbrk
#define MBstrspn strspn
#define MBstrcspn strcspn
#define MBstrstr (mbchar *)strstr
#define MBstrtok (mbchar *)strtok
#define MBindex (mbchar *)index
#define MBrindex (mbchar *)rindex

int WToMbStr AXP_(( IN wchar *, OUT mbchar * ));
int WnToMbStr AXP_(( IN wchar *, OUT mbchar *, IN int ));
int MbToWStr AXP_(( IN mbchar *, OUT wchar * ));
int MbnToWStr AXP_(( IN mbchar *, OUT wchar *, IN int ));
int Wnum_wide_chars_n AXP_(( IN wchar *, IN int ));
int MBnum_wide_chars_n AXP_(( IN mbchar *, IN int ));
mbchar *WToMbOneStr AXP_(( IN wchar * ));

#if BUILD_ORIENT
   /* use of these routines has some performance hit, so only use them */
   /* if we actually intend to process kanji characters, otherwise, do */
   /* the simple byte based character things to get the result         */
#define MB_CHAR_POS MbCharPos 
#define MB_CHAR_LEN MbCharLen
int32 MbCharLen AXP_(( IN mbchar * ));
mbchar *MbCharPos AXP_(( IN mbchar *, IN int ));
#else
#define MB_CHAR_LEN strlen
#define MB_CHAR_POS( a, b ) (a+b)
#endif


#if BUILD_WIDE      /*   {   */
/** build the product with wide chracter strings */

wchar *WMbstrcpy AXP_(( OUT wchar *, IN mbchar * ));
wchar *Wstrcat AXP_(( INOUT wchar *, IN wchar * ));
wchar *Wstrncat AXP_(( INOUT wchar *, IN wchar *, IN int ));
int32  Wstrcmp AXP_(( IN wchar *, IN wchar * ));
int32  Wstrncmp AXP_(( IN wchar *, IN wchar *, IN int ));
wchar *Wstrcpy AXP_(( INOUT wchar *, IN wchar * ));
wchar *Wstrncpy AXP_(( INOUT wchar *, IN wchar *, IN int ));
int32  Wstrlen AXP_(( IN wchar * ));
wchar *Windex AXP_(( IN wchar *, IN int ));
wchar *Wrindex AXP_(( IN wchar *, IN int ));
wchar *Wstrspn AXP_((IN wchar *s1, IN wchar *s2));
wchar *Wstrstr AXP_((IN wchar *s1, IN wchar *s2));
wchar *Wstrtok AXP_((INOUT wchar *s1, IN wchar *s2));
wchar *Wstrpbrk AXP_((IN wchar *s1, IN wchar *s2));
int32 WMbstreq  AXP_((IN wchar *s1, IN mbchar * ));
int32 WMbstrcaseeq  AXP_((IN wchar *s1, IN mbchar * ));
int32 Wstreq  AXP_((IN wchar *s1, IN wchar *s2));
wchar *Wstrtok();


#else            /*  } BUILD_WIDE  {  */
/* not building with wide characters, so do the usual stuff */

#define WMbstreq(x,y)   streq((char *)(x), (char *)(y))
#define WMbstrcaseeq(wstr, mbstr) (!strcasecmp((char*)(wstr), (char*)(mbstr)))
#define Wstreq(x,y) streq((char *)(x), (char *)(y))
#define Wstrncmp(x,y,n) strncmp((char *)(x), (char *)(y), (n))
#define WMbstrcpy(x,y) (wchar *)strcpy((char *)(x), (char *)(y))
#define Wstrcat(x,y) (wchar *)strcat((char *)(x), (char *)(y))
#define Wstrncat(x,y,n) (wchar *)strncat((char*)(x), (char *)(y), (n))
#define Wstrcmp(x,y) strcmp((char *)(x), (char *)(y))
#define Wstrcpy(x,y) (wchar *)strcpy((char *)(x), (char *)(y))
#define Wstrncpy(x,y,n) (wchar *)strncpy((char *)(x), (char *)(y), (n))
#define Wstrlen(x) strlen((char *)(x))
#define Wstrpbrk(x,y) (wchar *)strpbrk((char *)(x), (char *)(y))
#define Wstrtok(x,y) (wchar *)strtok((char *)(x), (char *)(y))

#if SYS&SYS5 || SYSV4
#define Windex(x,y)  (wchar *)strchr((char *)x, (int)y) 
#define Wrindex(x,y) (wchar *)strrchr((char *)x, (int)y)
#else
#define Windex(x,y)  (wchar *)index((char *)x, (int)y)
#define Wrindex(x,y) (wchar *)rindex((char *)x, (int)y)
#endif

#endif            /*  }  BUILD_WIDE */


/* These get defined in sys/param.h on some machines */
#ifndef MIN
#define MIN(a,b)    (((a)<(b))?(a):(b))
#endif
#ifndef MAX
#define MAX(a,b)    (((a)>(b))?(a):(b))
#endif

#include <limits.h>    /* make sure we use the correct values */
#ifndef MAXINT
#define MAXINT      INT_MAX
#endif
#define MAXLONGINT  LONG_MAX
#define MINLONGINT  LONG_MIN
#ifndef MININT
#define MININT      INT_MIN
#endif
#define MAXSHORTINT SHRT_MAX
#define MINSHORTINT SHRT_MIN

#if HP800 || M_88K || CLIX || ALPHA || NT_MIPS || (LINUX && __alpha__)
# define FLOAT_ALIGNED_8BYTE 1
#else
#   if PMAX || SUN4 || HP300 || SUN3 || MIPS || X386_NEW || SGI || \
       HP800 || RIOS || AUX || VAX || AXMS || USL54 || SUNIS || \
       (LINUX && (__i386__ || __powerpc__ || __sparc__)) || NEC_EWS
#       define FLOAT_ALIGNED_4BYTE 1
#   else
        aos.h - need an alignment type for this machine.
#   endif
#endif

#if HP800V3	/* HP compiler has trouble with const keyword! */
#define ACONST
#else
#define ACONST const
#endif

#if M_88K || SCOUNIX
#define MAXHOSTNAMELEN  64
#define MAXPATHLEN      1024
#endif

#define AX_BOOLEAN int


#define ERRMXINGROUP    256 /* Max. number of error codes in a group. */
                /* (This can be used to see if an error code
                    is in one of the groups below.) */
#define ERRMBZ      4   /* 2**(number of reserved bits, currently 2)*/
                /* This symbol to be used only to define the
                   following constant: */
#define ERRCOFFSET  (ERRMXINGROUP*ERRMBZ) /*  2**(number of bits to shift
                the category number left to locate it properly
                in an error code value).  This constant only
                to be used in defining the table below. */

/* - - - - - - - - - Error Code Category Definitions - - - - - - - - - - - - */
/* Historical stuff: CLEAN UP!!!*/
#define CP_MAX_LINE_LEN 255      /* Maximum line length for converter program output*/
#define ERRSC    (1*ERRCOFFSET)  /* System controller errors*/
#define ERRUCMD  (4*ERRCOFFSET)  /* User Command MBAP errors */
#define ERRIMP   (5*ERRCOFFSET)  /* IMP errors*/
#define ERRHELP  (6*ERRCOFFSET)  /* Help MBAP errors*/
#define ERRIPC   (7*ERRCOFFSET)  /* IPC message service errors */
#define ERRREG   (8*ERRCOFFSET)  /* Registration service errors*/
#define ERRMISC  (9*ERRCOFFSET)  /* Miscellaneous / MPAP errors*/
#define ERRFILE  (10*ERRCOFFSET) /* Personal/Group/Limitd Filing errs*/
#define ERRAB    (12*ERRCOFFSET) /* Archive/Backup errors*/
#define ERRATM   (13*ERRCOFFSET) /* ATM errors*/
#define ERRTRIG  (14*ERRCOFFSET) /* Trigger MBAP errors*/
#define ERRAC    (15*ERRCOFFSET) /* Activity Controller/Transfer errs*/
#define ERRADM   (16*ERRCOFFSET) /* Systm Administrator MBAP errors*/
#define ERRPROF  (17*ERRCOFFSET) /* Profile errors*/
#define ERRPRINT (18*ERRCOFFSET) /* Printing errors*/
#define ERRDC    (19*ERRCOFFSET) /* Document composer errors*/
#define ERRSS    (20*ERRCOFFSET) /* SpreadSheet errors*/
#define ERRDB    (21*ERRCOFFSET) /* Personal/Office DBMS errors*/
#define ERRGE    (23*ERRCOFFSET) /* Graphics Editor/Bus. Graph errors*/
#define ERRMAIL  (24*ERRCOFFSET) /* Mail MBAP & server errors*/
#define ERRCAL   (25*ERRCOFFSET) /* Calendar MBAP & server errors*/
#define ERRCALC  (26*ERRCOFFSET) /* Calculator errors*/
#define ERRTINT (0*ERRCOFFSET) /* Temp interrupt handlr errs*/
 
/*-------------------------- String Maximum Sizes --------------------------- */

#define STRNORMAL   (unsigned)30    /* max size of normal strings: AP(normal) */
#define STRSHORT    (unsigned)15    /* max size of short strings:  AP(short)  */
#define STRLONG     (unsigned)100   /* max size of long strings:   AP(long)   */
#define STRPATH     (unsigned)1025  /* max size of operating system pathnames */
#define AX_MAX_FILENAME (unsigned)256  /* max size of filename */


#if AXMS
#define strcasecmp(s1,s2)    stricmp(s1,s2)
#define strncasecmp(s1,s2,n) strnicmp(s1,s2,n)
#else
   /* Windows-NT needs the real Arename() a Astat()  */
#define Arename rename
#define Astat stat
#endif

#if USL54 || SGI
    /* USL54 needs strcasecmp defined  */
#define strcasecmp(s1,s2) Astrcmp(s1,s2)
#define strncasecmp(s1,s2,n) Astrncmp(s1,s2,n)
#endif
#define Agetcwd getcwd
#define Aaccess access
#define Achdir chdir
#define Asprintf sprintf
#define Adelete unlink

#define axstatic static /* safe, multi-task static */
#define axglobal        /* just a tag for a safe, multi-task global */

#define LINTCOMMENT(body)

#if 1
#define AXLOG(body) AxLogger body
#else
#define AXLOG(body)
#endif

#define AxAssert(x) if (!(x)) tempAbort("assert line %d in %s",__LINE__,__FILE__)

#define AXMSBUG 0   /* Code waiting for bug fix from Microsoft */

#if !THIMalloc
char *THIMalloc();
#endif
#if !THIMrealloc
char *THIMrealloc();
#endif
#if !THIMcalloc
char *THIMcalloc();
#endif

#include <ax.h>     /* to get function prototypes, global vars */

#if HP800
#include <axt.h> /* UGLY HACK in order to link with libXt.a */
#endif


/*******************************************************************/
/* On WIndows/NT when lines are written to an fopen'd file, a NL is */
/* replaced with a CR/NL pair.  This can screw all sorts of things up when */
/* the file is read in.  To avoid this problem the file must be opened for */
/* write with a "b" flag, ie "wb" instead of "w".  When the file is read,
/* if one is rreading a file generated outside of Applixware, one wants to */
/* specify only "r" so that the CR/NL pairs which may end each line        */
/* (depending on how the file was orifginally written) get converted back  */
/* into a simple NL.  If however the file is binary (like an image file), it */
/* must NOT be opened in normal mode, otherwise, if the bits in the image    */
/* happen to look line CR/NL, a byte will get stripped.                     */
/* To avoid a lot of #if'ing in the code, we define the flag strings here.  */
/*******************************************************************/
#if AX_X11                       /*  {  */
#define WRITE_STR NXLT( "w" )
#define WRITE_TRUNC_STR NXLT( "w+" )
#define READ_STR NXLT( "r" )
#define READ_TRUNC_STR NXLT( "r+" )
#define READ_BINARY_STR NXLT( "r" )
#define APPEND_STR NXLT( "a" )
#define APPEND_TRUNC_STR NXLT( "a+" )
#else                            /*  }  {  */
#define WRITE_STR NXLT( "wb" )
#define WRITE_TRUNC_STR NXLT( "wb+" )
#define READ_TRUNC_STR NXLT( "rb+" )
#define READ_STR NXLT( "r" )
#define READ_BINARY_STR NXLT( "rb" )
#define APPEND_STR NXLT( "ab" )
#define APPEND_TRUNC_STR NXLT( "ab+" )
#endif                           /*   }     */

#define WP_GLOBAL_CODE          13579           /* 'Random', recognizable tag */
#define SS_GLOBAL_CODE          12345           /* 'Random', recognizable tag */
#define GE_GLOBAL_CODE          97531           /* 'Random', recognizable tag */

/****************** TYPEDEFS *************************************/

/* The genericAppStruct defines the first few elements of all of the
    different applications' main structs - ssP/ge/wpP */

typedef struct {
    int GlobalCode; /* Should match application code- if not, coding error */
    int javaClientId;   /* If non-zero, a handle to a Java AxViewer */
    int uid;            /* Unique id to find in list of gfxs/wpps/ssxs */
} genericAppStruct;

#endif
