/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: aos_xfer.h
   Applix ASC version: 20
   Date: Mon Nov 16 13:52:52 1998
*/
#ifndef AOS_XFER_H_LOADED
#define AOS_XFER_H_LOADED

/* Atoms for xfer support */
extern DLL_IMPORT Atom AxXA_WP_FILE;
extern DLL_IMPORT Atom AxXA_GE_FILE;
extern DLL_IMPORT Atom AxXA_GEGE_FILE;
extern DLL_IMPORT Atom AxXA_SS_FILE;
extern DLL_IMPORT Atom AxXA_SS_INSET_FILE;
extern DLL_IMPORT Atom AxXA_EQN_FILE;
extern DLL_IMPORT Atom AxXA_ELF_DATA;
extern DLL_IMPORT Atom AxXA_QUERY_DATA;
extern DLL_IMPORT Atom AxXA_ELF_TABLE;
extern DLL_IMPORT Atom AxXA_GE_PAGE_FILE;
extern DLL_IMPORT Atom AxXA_INSET;
extern DLL_IMPORT Atom AxXA_GE_OLIN_FILE;
extern DLL_IMPORT Atom AxXA_CLIPBOARD;
extern DLL_IMPORT Atom AxXA_PRIMARY;
extern DLL_IMPORT Atom AxXA_LENGTH;
#if AXMS
/* Atom for registering "Rich Text Format" data. */
extern DLL_IMPORT Atom AxXA_RTF_DATA;
#endif

extern DLL_IMPORT int AxSelectionLength;

/* Command Codes */

#define XFER_CODE_COPY 0    /* produce data */
#define XFER_CODE_PASTE 1   /* paste data supplied */
#define XFER_CODE_SELECTION_PASTE 2 /* paste data supplied */
#define XFER_CODE_CLEAR_SELECTION 3 /* clear selection,
                                        (binType == XFER_BIN_SELECTION)
                                    or clipboard,
                                        (binType == XFER_BIN_CLIPBOARD) */
#define XFER_BIN_SELECTION 0 /* this means XA_PRIMARY */
#define XFER_BIN_CLIPBOARD 1 /* this means XA_CLIPBOARD */

/* Clipboard codes */

typedef struct {
    int code;       /* message code */
    int type;       /* of data in xfer (Atom) */
    char *binDoc;   /* DocPtr to doc containing the data */
    char pathname[STRPATH+1];   /* file object within binDoc */
    int binType;    /* XFER_BIN_SELECTION or XFER_BIN_CLIPBOARD */
    int docType;    /* asterx object type code (see doctypes.h) */
} xfer_data_convert_msg_t;

#ifndef XA_CLIPBOARD    /* just till all versions have this */
#define XA_CLIPBOARD AxXA_CLIPBOARD
#endif
#ifdef XA_PRIMARY
#undef XA_PRIMARY
#endif
#define XA_PRIMARY AxXA_PRIMARY


#endif  /* AOS_XFER_H_LOADED */
