/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: atmgraph.h
   Applix ASC version: 2
   Date: Mon Nov 16 13:52:51 1998
*/
#define TM_POINT_MAX	512

struct TmGraphFlags {
	unsigned absrel		: 1;
	unsigned close_flag	: 1;
	unsigned fill_flag	: 1;
	unsigned curve_flag	: 1;
	};

struct TmBbltStruct {
	short window_id;
	short rule;
	short x_destination;
	short y_destination;
	short x_dest_len;
	short y_dest_len;
	short x_clip;
	short y_clip;
	short x_clip_len;
	short y_clip_len;
	short x_source;
	short y_source;
	short halftone;
	};

/* calls */

#if 1
typeErr TmScroll();
typeErr TmPolymarker();
typeErr TmPolyline();
typeErr TmArc();
typeErr TmBblt();
#endif

/* SYNOPSIS */

#if 0					/* documentation only */
*************************************************

typeErr TmScroll(window_id, x_sc_origin, y_sc_origin, x_sc_len,
			y_sc_len, dx, dy, movebars)
short window_id;
short x_sc_origin;
short y_sc_origin;
short x_sc_len;
short y_sc_len;
short dx;
short dy;
short movebars;		/* TRUE = move thumbing bars */

 return status

 TMR_OK
 TMR_POSE

*************************************************

typeErr TmPolymarker(window_id,point_count,points,absrel);
short window_id;
short point_count;
short absrel;
TmPoint *points;

 return status

 TMR_OK
 TMR_PARM

*************************************************

typeErr TmPolyline(window_id,flags,point_count,points,fill_pat);
short window_id;
struct TmGraphFlags *flags;
short point_count;
TmPoint *points;
short fill_pat;

 return status

 TMR_OK
 TMR_PARM

*************************************************

typeErr TmArc(window_id,flags,bound_box,start_angle,arc_angle,fill_pat);
short window_id;
struct TmGraphFlags *flags;
TmRect *bound_box;
short start_angle;
short arc_angle;
short fill_pat;

 return status

 TMR_OK
 TMR_PARM

*************************************************

typeErr TmBblt(bblt_pack)
struct TmBbltStruct *bblt_pack;

 return status

 TMR_OK
 TMR_OWN
 TMR_RE
 TMR_POSE

************************************************
#endif

