/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: atmimage.h
   Applix ASC version: 2
   Date: Sat Jan 23 21:14:17 1999
*/

/* atm call interface parameters for image and color support */

struct TmEPSPacket
{
	int height;
	int width;
	TmPoint32 outline_pts[4];
	char *filename;
	char *sharedfile;
};

struct TmImagePacket
{
	unsigned pixel_flag : 1;	/* win_rect is in pixel coordinates */
	unsigned file_flag : 1;		/* pathname supplied in union below */
	short mode;		/* transfer mode (rasterop operation) */
	TmRect win_rect;	/* rectangle in window to transfer */
	short mem_depth;	/* pixel size of memory bitmap */
	union
	{
		short *mem_image;	/* address of pixel image in memory */
		char *pathname;		/* pathname of pixel image file */
	} u;
};

typeErr TmInclude();
typeErr TmPutImage();
typeErr TmGetImage();
