/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: dia.h
   Applix ASC version: 5
   Date: Sat Jan 23 21:14:17 1999
*/

/* The vast majority of this file is completely obsolete and needs
   to be cleared out! */

/* Define a storage specifier for Dt values: */
typedef unsigned short  typeDt;

/* Message Data Descriptor */

typedef struct {
	typeDt 		AItype;	/* One of the Dt values defined below. */
	unsigned short  AIdlen;	/* Datum length in bytes */
	char 		*AIptr;	/* and its location */
} AI_desc;




/*********************** Applix Data Type Codes (DT's) ***********************
 *
 *  These codes are used in the 'type' field of DIA message values.
 *
 *  Each code is an unsigned short with the following format:
 *
 *	The 3 most significant bits are the fundamental data type.
 *	The 1 next most significant bit is reserved and always zero.
 *      The 6 next most significant bits are the generic data type or zero.
 *      The 6 next most significant bits are the instantation data type of 0.
 *  
 *  Two functions have been provided to help isolate portions of a Dt:
 *   typeDt DtGeneric( Dt_value ) - returns the Dt with the instantation
 *				    subfield cleared, i.e. the Fundamental plus 
 *				    Generic equivalent.
 *    typeDt DtFundamental( Dt_value ) - returns a Dt with the instantation 
 *				    and generic fields cleared, i.e. one of the
 *				    fundamental Dt values in the list below.
 * NOTE! If people need private Dt values, feel free to add  generic 
 *	types as needed.  For example, see DtIMP_LONGPRIV below.
 */
#define  DtFUNDAMENTAL (typeDt)8192 /*Not to be referenced except */
#define  DtGENERIC     (typeDt)64  /* to define the list membrs below.*/

/*- - - - - - - DT's specified to the fundatmental level.- - - - - - - - - - */
#define DtNODATA 	(typeDt) 0
#define	DtCHAR	 	(typeDt)(DtFUNDAMENTAL*1)
#define	DtSHORT  	(typeDt)(DtFUNDAMENTAL*2) 
#define	DtLONG	 	(typeDt)(DtFUNDAMENTAL*3)
#define	DtDOUBLE 	(typeDt)(DtFUNDAMENTAL*4) 
#define DtCONSTRUCTOR 	(typeDt)(DtFUNDAMENTAL*5) /*Identifies the 
				beginning of a sub message in DIA format. */
#define DtBIT		(typeDt)(DtFUNDAMENTAL*6)

/*- - - - - - - - -  DT's specified to the generic level.- - - - - - - - - - */
#define DtEOM		(typeDt)DtNODATA   /* end of message or submessage */
#define DtRESERVED  	(typeDt)(DtNODATA+(DtGENERIC*1))
#define DtIMP_NDPRIVATE	(typeDt)(DtNODATA+(DtGENERIC*6)) /*IMP priv (no data)*/
#define DtMS_NDPRIVATE  (typeDt)(DtNODATA+(DtGENERIC*7)) /*MAIL priv (no data)*/
#define DtRS_NDPRIVATE  (typeDt)(DtNODATA+(DtGENERIC*12)) /*RS priv (no data)*/
#define DtAC_NDPRIVATE  (typeDt)(DtNODATA+(DtGENERIC*13)) /*AC priv (no data)*/


#define	DtDOCNAME 	(typeDt)(DtCHAR+(DtGENERIC*1)) /* document name */
#define DtUSERNAME	(typeDt)(DtCHAR+(DtGENERIC*2)) /* Applix user name */
#define DtCMDLINE	(typeDt)(DtCHAR+(DtGENERIC*4)) /* proc command line */
#define DtUFILE		(typeDt)(DtCHAR+(DtGENERIC*5)) /* Unix file name */
#define DtIMP_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*6))  /* IMP's priv strings */
#define DtMS_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*7))  /* MAIL priv strings*/
#define DtCA_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*8))  /* CALENDAR  strings*/
#define DtFS_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*9))  /* FS priv strings*/
#define DtDB_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*10)) /* DBM  priv strings*/
#define DtTM_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*11)) /* ATM  priv strings*/
#define DtRS_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*12)) /* RS  priv strings*/
#define DtAC_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*13)) /* AC  priv strings*/
#define DtUP_CHARPRIV	(typeDt)(DtCHAR+(DtGENERIC*14)) /* UP  priv strings*/


#define DtDATE		(typeDt)(DtLONG+(DtGENERIC*1))  /* an applix date. */
#define DtTIME		(typeDt)(DtLONG+(DtGENERIC*2))  /* an applix time. */
#define DtDATE_TIME	(typeDt)(DtLONG+(DtGENERIC*3))  /* a date& time.*/
#define DtBOOLLONG	(typeDt)(DtLONG+(DtGENERIC*4))  /* a long boolean valu*/
#define DtERRCODE	(typeDt)(DtLONG+(DtGENERIC*5))  /* an Applix err code*/
#define DtIMP_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*6))  /* IMP's priv longs */
#define DtMS_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*7))  /* MAIL private (long)*/
#define DtCA_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*8))  /* CALENDAR priv longs*/
#define DtFS_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*9))  /* FS priv longs*/
#define DtDB_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*10)) /* DBM  priv longs*/
#define DtTM_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*11)) /* ATM  priv longs*/
#define DtRS_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*12)) /* RS  priv longs*/
#define DtAC_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*13)) /* AC  priv longs*/
#define DtUP_LONGPRIV	(typeDt)(DtLONG+(DtGENERIC*14)) /* UP  priv longs*/


#define DtWINDOWID	(typeDt)(DtSHORT+(DtGENERIC*1))	 /* An ATM Window id*/
#define DtIMP_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*6))  /* IMP's priv shorts */
#define DtMS_SHORTPRIV  (typeDt)(DtSHORT+(DtGENERIC*7))  /* MAIL priv shorts*/
#define DtCA_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*8))  /* CALENDAR  shorts*/
#define DtFS_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*9))  /* FS priv shorts*/
#define DtDB_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*10)) /* DBM  priv shorts*/
#define DtTM_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*11)) /* ATM  priv shorts*/
#define DtRS_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*12)) /* RS  priv shorts*/
#define DtAC_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*13)) /* AC  priv shorts*/
#define DtUP_SHORTPRIV	(typeDt)(DtSHORT+(DtGENERIC*14)) /* UP  priv shorts*/


#define DtIMP_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*6))  /* IMP's priv*/
#define DtMS_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*7)) /* MAIL priv*/ 
#define DtCA_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*8))  /* CAL  priv*/
#define DtFS_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*9))  /* FS priv*/
#define DtDB_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*10)) /* DBM  priv*/
#define DtTM_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*11)) /* ATM  priv*/
#define DtRS_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*12)) /* RS  priv*/
#define DtAC_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*13)) /* AC  priv*/
#define DtUP_CONSPRIV	(typeDt)(DtCONSTRUCTOR+(DtGENERIC*14)) /* UP  priv*/


#define DtIMP_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*6))  /* IMP's priv*/
#define DtMS_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*7)) /* MAIL priv*/ 
#define DtCA_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*8))  /* CAL  priv*/
#define DtFS_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*9))  /* FS priv*/
#define DtDB_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*10)) /* DBM  priv*/
#define DtTM_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*11)) /* ATM  priv*/
#define DtRS_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*12)) /* RS  priv*/
#define DtAC_BITPRIV	(typeDt)(DtBIT+(DtGENERIC*13)) /* AC  priv*/







/*- - - - - - - - -  DT's specified to the "instantation" level.- - - - - -  */
#define DtCREATEDATE	(typeDt)(DtDATE_TIME+1)  /* create date of a doc or file*/
#define DtMODIFYDATE	(typeDt)(DtDATE_TIME+2)  /* doc or file last modify date*/
#define DtBWORKHRS	(typeDt)(DtTIME+1)	 /* begin normal work hours (calendar profile ) */
#define DtEWORKHRS	(typeDt)(DtTIME+2)	 /* end normal work hours (calendar profile ) */
#define DtBLUNCH	(typeDt)(DtTIME+3)	 /* begin lunch time (calendar profile ) */
#define DtELUNCH	(typeDt)(DtTIME+4)	 /* end lunch time (calendar profile ) */

/* Some DIA size definitions for those who need to know:
*/
#define DIA_HEAD_LN 4	/* DIA header size (in bytes)	*/
#define DIA_EOM_LN  4	/* length of DIA 'End-Of-Message' data type */

/*
 	FUNCTION DEFINITIONS:
 */
#define DtGeneric( Dtval )     ( ((Dtval) & 0167700) )
					 /*always clear the reserved bit. */
#define DtFundamental( Dtval ) ( ((Dtval) & 0160000) )

/*   	Compute the length of a DIA msg given ptrs to its beginning and end*/
#define Msglen( msgP, msgendP )  ( ((msgendP) - (msgP)) )

#ifdef FUNCPROTO
char *DIAgettype (REGISTER char *, REGISTER AI_desc *);
char *DIAsearch (REGISTER char *, REGISTER typeDt, REGISTER AI_desc *);
char *DIAgetval (REGISTER AI_desc *, REGISTER char *);
char *DIAgetlong (REGISTER AI_desc *, REGISTER unsigned long *);
char *DIAgetshort (REGISTER AI_desc *, REGISTER unsigned short *);
char *DIAgetdouble (REGISTER AI_desc *, REGISTER double *);
char *DIAputval (REGISTER char *, REGISTER AI_desc *, REGISTER char *);
char *DIAbegcon (REGISTER char *, REGISTER AI_desc *, REGISTER char *);
char *DIAendcon (REGISTER char *, REGISTER char *);
#else
extern	char	*DIAgettype(),
		*DIAsearch(),
		*DIAgetval(), 
		*DIAgetdouble(), 
		*DIAgetlong(), 
		*DIAgetshort(), 
		*DIAputval(), 
		*DIAbegcon(), 
		*DIAendcon();
#endif

/* taken from mailDIA.h in alis includes */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*
 * Definition of data types used in IPCs between UA-MTA,  MTA-MTA
*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* A word about messaging between mail processes.
 * The messages which flow between UA/MTA and MTA/MTA can contain up to three
 * components: a request header (RH), a message header (MH), and a message 
 * body (MB). 
 * The RH is always present, the presence of the other two is
 * dependent on the content of the RH.  The RH contains low level information
 * concerning the type of request being made beteen processes: a request code
 * at a minimum, and various other fields like message ID, host ID of 
 * originator of the request, deferred delivery flag, more data indicator 
 * (which indicates a segmented message), and an error code.
 * The MH contains all the attributes associated with a mail request (sender,
 * subject, etc.). The MH would not be present on a 'delete item from inbox'
 * request. The MB contains information about the object being mailed.
 * In the case of an Applix document object, the MB contains the Unix files
 * that make up the document as well as additional information which is
 * used by the file server to recreate the document at the receiving end.
*/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		CONSTRUCTOR TYPES:					*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

/* MTA message component types:
*/
#define MLRQH  ((typeDt)DtMS_CONSPRIV+1)	/* (a1c1) Request header (RH)	*/
#define MLMSH (MLRQH+1)		/* (a1c2) Message header (MH) 	*/
#define MLMBODY	(MLMSH+1)	/* (a1c3) Message body (MB)		*/

/* Other constructor types:
*/
#define MLTOLIST (MLMBODY+1)	/* (a1c4) 'TO' recipient list (deliver to)	*/
#define MLCCLIST (MLTOLIST+1)	/* (a1c5) 'CC' recipient list	(deliver to) */
#define MLBCLIST (MLCCLIST+1)	/* (a1c6) 'BC' recipient list (deliver to) */
#define MLUFLIST (MLBCLIST+1)	/** (a1c7)  Unix file list - this constructor 
                               * may be found in 2 places: within the MLDOCINFO
                               * constructor, or as a simple constructor list
                               * within the MLBODY component */
#define MLSDOCCAB (MLUFLIST+1)	/* (a1c8) (Filing system cabinet descriptor for
				 * source of document	*/
#define MLDDOCCAB (MLSDOCCAB+1)	/* (a1c9) Filing system cabinet descriptor for
				 * destination of document	*/
#define MLDENVCAB (MLDDOCCAB+1)	/* (a1ca) Filing system cabinet descriptor for
				 * destination of 'envelope'	*/
#define MLDOCINFO (MLDENVCAB+1)	/* (a1cb) Document information (doc. hdrs, filenames)*/
#define MLMIDS (MLDOCINFO+1)	/* (a1cc) List of message ids. (used for inbox jobs) */
#define MLSORTINFO (MLMIDS+1)	/* (a1cd) Inbox sorting info, used in mbap sort request*/
#define MLVIEWINFO (MLSORTINFO+1) /* (a1ce) Inbox view info, used in 'list view'.
 * This constructor contains elements: MLVCOLNAME, MLVCOLPOS, MLVDSPSIZE,
 * MLVSORT, MLVHDCOLS.
*/
#define MLHIDLIST (MLVIEWINFO+1) /* (a1cf) Host Id list */
#define MLIADDRLIST (MLHIDLIST+1)	/* (a1d0) Internet address list */
#define MLXTOLIST (MLIADDRLIST+1)	/* (a1d1) 'To' recip. list (for displaying) */
#define MLXCCLIST (MLXTOLIST+1)	/* (a1d2) 'Cc' recip. list (for displaying) */
#define MLXBCLIST (MLXCCLIST+1)	/* (a1d3) 'Bc' recip. list (for displaying) */
#define MLUFTLIST (MLXBCLIST+1)	/* (a1d4) Unix file type list */
#define MLMISCINFO (MLUFTLIST+1)	/* (a1d5) miscellaneous info */
#define MLDOCIDLIST (MLMISCINFO+1)	/* (a1d6) document id list */
#define MLFORWLIST (MLDOCIDLIST+1)	/* (a1d7) Forwarding name list */
#define MLDELLIST (MLFORWLIST+1)	/* (a1d8) Delete list (i.e. file(s) to be 
 * deleted during cleanup) */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		NO DATA TYPES:						*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

#define MLRHMDI ((typeDt)DtMS_NDPRIVATE+1) /* (1c1) more data indicator (in RH)*/
#define MLRHEXP (MLRHMDI + 1) /* (1c2) Expedited request indicator (in RH)	*/
#define MLPOKEFLAG (MLRHEXP + 1) /* (1c3) Poke application when mail delivered */
#define MLDOCDELETEFLAG (MLPOKEFLAG+1)  /* (1c4) Delete source doc. after mailing	*/
#define MLUFDELETEFLAG (MLDOCDELETEFLAG+1) /* (1c5) Delete source unix files after
					 * mailing	*/
#define MLVSORT (MLUFDELETEFLAG+1)	/* (1c6) 'Sort field' flag, used in 
		 * MLVIEWINFO constructor */
#define MLLOCALINSETSFLAG (MLVSORT+1)	/* (1c7) mail local insets only */
#define MLCONVERTED (MLLOCALINSETSFLAG+1) /* (1c8) indicates that the associated
 * entity has been converted to canonical (ASCII) format.
*/
#define MLDEFLECTED (MLCONVERTED+1) /* (1c9) indicates that the original mail
 * request was deflected from another MTA because it referenced a document 
 * in a remote (shared) cabinet.
*/
#define MLSROUTED (MLDEFLECTED+1) /* (1ca) indicates that the original mail
 * request plus referenced document was forwarded from another MTA because 
 * recipient's name references resoures on another host (e.g source node
 * routing for unix gateway or interdomain Alis mail)
*/
#define MLMAILSIGNATURES (MLSROUTED+1) /* (1cb) indicates that the signature(s), if
 * any, should be mailed with the document */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		SHORT DATA TYPES:					*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

#define MLRHCODE ((typeDt)DtMS_SHORTPRIV+1) /* (41c1) Request code (in RH)	*/
#define MLRHQCODE (MLRHCODE+1)	/* (41c2) request code qualifier (in RH)	*/
#define MLRHERR	(MLRHQCODE+1)		  /* (41c3) error code (in RH)		*/
#define MLRQSTATE (MLRHERR+1)	/* (41c4) state of a mail deliver request - 
				 * used in grunt termination message	*/
#define MLRECSIZE (MLRQSTATE+1) /* (41c5) Size of records in the fixed-length
				 * Ascii data file used for tabular display*/
#define MLVERB (MLRECSIZE+1)	/* (41c6) Inbox verb (used in UA -> MTA trigger
				 * for certification response)		*/
#define MLCABTYPE (MLVERB+1)	/* (41c7) Type of filing cabinet (used in
				 * cabinet descriptor structure)	*/
#define MLCABSVRID (MLCABTYPE+1)/* (41c8) Server ID of server's filing cabinet
				 * (used in cabinet descriptor structure)*/
#define MLRTLOG (MLCABSVRID+1)	/* (41c9) Runtime logging switch	*/
#define MLFIELDID (MLRTLOG+1) /* (41ca) Inbox field Id, used in sort requests from mbap*/
/**** DELETE 'MLVCOLID' WHEN CONVENIENT ***/

#define MLVCOLID (MLFIELDID+1) /* (41cb) Inbox 'list view' column Id.	*/
#define MLVDSPSIZE (MLVCOLID+1) /* (41cc) Inbox 'list view' column display size */
#define MLVCOLPOS (MLVDSPSIZE+1) /* (41cd) Inbox 'list view' column position */
#define MLUFTYPE (MLVCOLPOS+1)	/* (41ce) Unix file type (see mail.h) */
#define MLHOPCOUNT (MLUFTYPE+1) /* (41cf) 'Hop count', no. times mail has been 
 * forwarded between hosts. */
#define MLDOCCOUNT (MLHOPCOUNT+1) /* (41d0) The number of documents contained in
 * this mail.
*/
#define MLAFCOUNT (MLDOCCOUNT+1) /* (41d1) The number of times a message has
									been automatically forwarded */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		CHARACTER DATA TYPES:					*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

#define MLDOCNM (DtDOCNAME)	/* (2040) Mail document name	*/
#define MLSENDER ((typeDt)DtMS_CHARPRIV+1) /* (21c1) Mail Sender 		*/
#define MLRQSENDER (MLSENDER+1)	/* (21c2) Registry-qualified sender name */
#define MLRECIPIENT (MLRQSENDER+1)	/* (21c3) Mail recipient	*/
#define MLRQRECIPIENT (MLRECIPIENT)	/* (21c3) Registry-qualified recipient name */
#define MLSUBJECT (MLRQRECIPIENT+1)	/* (21c4) Subject		*/
#define MLBEHALF (MLSUBJECT+1)	/* (21c5) Authorization (on behalf of)	*/
#define MLREPLYTXT (MLBEHALF+1)	/* (21c6) Reply by text	*/
#define MLSPECTAG (MLREPLYTXT+1)/* (21c7) Specific tag		*/
#define MLFORWARD (MLSPECTAG+1) /* (21c8) Forwarded by ...		*/
#define MLORIG	(MLFORWARD+1)	/* (21c9) Original info type	*/
#define MLDIRNAME (MLORIG+1)	/* (21ca) the Unix directory name in a DELIVER_RESPONSE
				* (in RH). This field found only in MTA-MTA
				* deliver, not UA-MTA submit.		*/
#define MLDATAFILE (MLDIRNAME+1) /* (21cb) Unix Ascii data file name (cache file)
					  * (for tab. display)  */
#define MLMETAFILE (MLDATAFILE+1) /* (21cc) Unix meta data file name 
					  * (for tab. display)  */
#define MLREJNAME (MLMETAFILE+1) /* (21cd) Name of intended recipient of a
				 * rejected message			*/
#define MLMHFILE (MLREJNAME+1)	/* (21ce) Name of unix file containing original
				* message header of a rejected message */

/* the following types are used in the message body to contain information
 * about a document.
*/
#define MLUFILEDIR (MLMHFILE+1)	/* (21cf) The directory within which the Unix files
				* to be transferred reside		*/
#define MLDOCHDRFILE (MLUFILEDIR+1) /* (21d0) The Unix file containing doc hdr info */
#define MLCMPTBLFILE (MLDOCHDRFILE+1) /* (21d1) The Unix file containing composition
					* table info			*/
#define MLCABUSRNAME (MLCMPTBLFILE+1) /* (21d2) The user for which a cabinet is being
					* described (used in cab desc. constr.)
					*/
#define MLCABNAME (MLCABUSRNAME+1) /* (21d3) The name of the cabinet (used in cabinet
					* descriptor constructor	*/
#define MLSORTORDER (MLCABNAME+1)  /* (21d4) Inbox sort order ('a' or 'd')	*/
#define MLVIEWFILE (MLSORTORDER+1)	/* (21d5) Inbox 'view definition' file */
#define MLVCOLNAME (MLVIEWFILE+1)  /* (21d6) List view column (field) name (see
 * 'MLVIEWINFO')  */
#define MLCOMMENT (MLVCOLNAME+1) /* (21d7) (Forwarding) Comment */
#define MLCOMPANY (MLCOMMENT+1)	 /* (21d8) Company name (for phone messages) */
#define MLWHOCALLED (MLCOMPANY+1) /* (21d9) Who called (for phone messages) */
#define MLPHONENUM (MLWHOCALLED+1) /* (21da) Phone no. (for phone messages) */
#define MLIADDR (MLPHONENUM+1)		/* (21db) Host internet address */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		LONG DATA TYPES:					*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

#define MLEXPDATE ((typeDt)DtMS_LONGPRIV+1)	/* (61c1) Expiration date	*/
#define MLDEFDATE (MLEXPDATE+1)	 	/* (61c2) Deferred Delivery date	*/
#define MLPOSTMARK (MLDEFDATE+1)	 /* (61c3) Postmark	*/
#define MLFLAGS	(MLPOSTMARK+1)		/* (61c4) Internal flags and message tags*/
#define MLVERBS	(MLFLAGS+1)		/* (61c5) Legal verbs		*/
#define MLMID (MLVERBS+1)		/* (61c6) Unique Message ID (in RH)	*/
#define MLHOSTID (MLMID+1)		/* (61c7) HOST ID */
#define MLSAPPID (MLHOSTID+1)		/* (61c8) Application ID of sender	*/
#define MLDAPPID (MLSAPPID+1)		/* (61c9) Application ID of recipient	*/
#define MLREJCODE (MLDAPPID+1)	/* (61ca) Mail Reject code (used in mail rejects)*/
#define MLODOCID (MLREJCODE+1)	/* (61cb) Document ID of source document	*/
#define MLNDOCID (MLODOCID+1)	/* (61cc) Document ID of delivered document	*/
#define MLI1 (MLNDOCID+1)	/* (61cd) Application-specific integer		*/
#define MLI2 (MLI1+1)	/* (61ce) Application-specific integer		*/
#define MLI3 (MLI2+1)	/* (61cf) Application-specific integer		*/
#define MLMATERIALTYPE (MLI3+1) /* (61d0) Document material type	*/
#define MLMSGTYPE (MLMATERIALTYPE+1) /* (61d1) Message type	*/
#define MLTIMER (MLMSGTYPE+1) /* (61d2) Job timer	*/
#define MLSUBMITDATE (MLTIMER+1) /* (61d3) Mail submission date/time */
#define MLERRCODE (MLSUBMITDATE+1)	/* (61d4) Context-specific error code 
 * (currently used only by file server to inspect 'receive doc' error code).
*/
#define MLREQHID (MLERRCODE+1)	/* (61d5) Host id of process issuing a mail request */


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*		BIT-STRING DATA TYPES:					*/
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */

#define MLVHDCOLS ((typeDt)DtMS_BITPRIV+1) /* (c1c1) Hidden columns bit-string; 
 * part of 'list view' definition (see 'MLVIEWINFO')
*/

