/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: doclinks.h
   Applix ASC version: 4
   Date: Mon Nov 16 13:52:54 1998
*/
#ifndef _DOC_LINKS_H_
#define _DOC_LINKS_H_

#define AXELFDEX_LINK_name 0
#define AXELFDEX_LINK_docType 1
#define AXELFDEX_LINK_appType 2
#define AXELFDEX_LINK_filterMacro 3
#define AXELFDEX_LINK_launchMacro 4
#define AXELFDEX_LINK_externalRef 5
#define AXELFDEX_LINK_internalRef 6
#define AXELFDEX_LINK_info 7
#define AXELFDEX_LINK_override 8
#define AXELFSIZE_LINK 9

#define AXELFDEX_OBJECT_name 0
#define AXELFDEX_OBJECT_docType 1
#define AXELFDEX_OBJECT_appType 2
#define AXELFDEX_OBJECT_filterMacro 3
#define AXELFDEX_OBJECT_launchMacro 4
#define AXELFDEX_OBJECT_internalRef 5
#define AXELFDEX_OBJECT_allowUnreferenced 6
#define AXELFDEX_OBJECT_info 7
#define AXELFSIZE_OBJECT 8

/* document link and object info */
typedef struct {
	int numLinks;
	int numObjects;
	struct link_info_t_ *links;
	struct object_info_t_ *objects;
} doc_links_info_t;

/* link info */
typedef struct link_info_t_ {
	mbchar name[STRPATH+1];
	mbchar tempfile[STRPATH+1];
	int docType;						/* file format type as in doctypes.h */
	int appType;						/* application type as in app_type.h */
	mbchar filterMacro[STRLONG+1];
	mbchar launchMacro[STRLONG+1];
	mbchar externalRefName[STRPATH+1];
	mbchar internalRefName[STRPATH+1];
	doc_links_info_t *info;
	mbchar override[STRPATH+1];
} link_info_t;

/* embedded object info */
typedef struct object_info_t_ {
	mbchar name[STRPATH+1];
	mbchar tempfile[STRPATH+1];
	int docType;						/* file format type as in doctypes.h */
	int appType;						/* application type as in app_type.h */
	mbchar filterMacro[STRLONG+1];
	mbchar launchMacro[STRLONG+1];
	mbchar internalRefName[STRLONG+1];
	int allowUnreferenced;
	doc_links_info_t *info;
} object_info_t;

#endif	/* _DOC_LINKS_H_ */
