/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: eldata.h
   Applix ASC version: 35
   Date: Mon Nov 16 13:52:52 1998
*/
#if !eldataHinclude
#define eldataHinclude 1

#if AXMS
/* undefine the varargs macros which may have been pulled in, from the */
/*   ansi style varargs, instead of the older berkley style, by the windows */
/*   inlude files                        */
#ifdef va_start
#undef va_start
#endif
#ifdef va_end
#undef va_end
#endif
#endif

#ifdef __cplusplus
#if RIOS
#include <stdio.h>
#include <va_list.h>
#else
#include <varargs.h>
#endif
#else
#include <varargs.h>
#endif

#include <elf.h>


#if !ELF_DATA_DONE
typedef struct data_any *elfData;
#define ELF_DATA_DONE 1
#endif

int AxIsNumber AXP_((data_ptr arg));
int AxIsString AXP_((data_ptr arg));
int AxIsBinary AXP_((data_ptr arg));
int AxIsObject AXP_((data_ptr arg));
int AxBinarySize AXP_((data_ptr arg));
int AxBinaryFromDataPtr AXP_((elfData data, char **binP));
char *AxBinaryBytesPtr AXP_((data_ptr data));


char *AxMalloc AXP_((int size));
void AxFree AXP_(( char *p ));
char *AxRealloc AXP_((char *oldP, int new_size));
void  AxMallocAborter AXP_((jmp_buf abortBuf));
void  AxError AXP_((int code, char *str, char *obj));
data_ptr AxCopyData AXP_((elfData data));
data_ptr AxTaskCopyData AXP_((int pid, elfData data));
mbchar  *AxStrFromDataPtr AXP_((elfData ap));


int AxMemWrite AXP_((data_ptr data,int makeRoom,char **buf));
data_ptr AxMemRead AXP_((char *bufP));
data_ptr AxMakeArray AXP_((int elements));
data_ptr AxTaskMakeArray AXP_((int pid, int elements));
data_ptr AxBuildArray();
int AxListWalkerInit AXP_((data_ptr aP));
data_ptr AxListWalkerNext AXP_(( void ));


data_ptr AxAppendArray AXP_((data_ptr ap1, data_ptr ap2 ));
data_ptr AxTaskAppendArray AXP_((int pid, data_ptr ap1, data_ptr ap2 ));
data_ptr AxWriteArray AXP_((data_ptr ap,int dex,data_ptr new_val));
data_ptr AxTaskWriteArray AXP_((int pid, data_ptr ap,int dex,data_ptr new_val));
data_ptr AxTruncArray AXP_((data_ptr ap,int newsize));
data_ptr AxTaskTruncArray AXP_((int pid, data_ptr ap,int newsize));
data_ptr AxAddStrToArray AXP_((data_ptr ap,int dex,char *str));
data_ptr AxTaskAddStrToArray AXP_((int pid, data_ptr ap,int dex,char *str));
data_ptr AxAddWideStrToArray AXP_((data_ptr ap, int dex, wchar *str));
data_ptr AxTaskAddWideStrToArray AXP_((int pid, data_ptr ap, int dex, wchar *str));
data_ptr AxAddIntToArray AXP_((data_ptr ap,int dex,int n));
data_ptr AxTaskAddIntToArray AXP_((int pid, data_ptr ap,int dex,int n));
data_ptr AxAddFloatToArray AXP_((data_ptr ap,int dex, double dbl));
data_ptr AxTaskAddFloatToArray AXP_((int pid, data_ptr ap,int dex, double dbl));
data_ptr AxAddBoolToArray AXP_((data_ptr ap,int dex,int n));
data_ptr AxTaskAddBoolToArray AXP_((int pid, data_ptr ap,int dex,int n));
data_ptr AxAddBinaryToArray AXP_((data_ptr ap,int dex,int dataSize, char *bin));
data_ptr AxTaskAddBinaryToArray AXP_((int pid, data_ptr ap,int dex,int dataSize, char *bin));
data_ptr AxAddDlbToArray AXP_((data_ptr ap,int dex,double n));
data_ptr AxAddArrayToArray AXP_((data_ptr ap,int dex,data_ptr p));
data_ptr AxTaskAddArrayToArray AXP_((int pid, data_ptr ap,int dex,data_ptr p));
data_ptr AxAddDataToArray AXP_((data_ptr ap,int dex,data_ptr p));
data_ptr AxTaskAddDataToArray AXP_((int pid, data_ptr ap,int dex,data_ptr p));
int AxArraySize AXP_ ((data_ptr arg));
data_ptr AxArrayElement AXP_((data_ptr ap,int dex));
int AxIsArray AXP_((data_ptr p));
data_ptr AxArrayFromArray AXP_((data_ptr ap,int dex));
double AxDblFromArray AXP_((data_ptr ap,int dex));
mbchar *AxStrPtrFromArray AXP_((data_ptr ap,int dex));
mbchar *AxStrFromArray AXP_((data_ptr ap,int dex));
wchar *AxWideStrPtrFromArray AXP_((data_ptr ap, int dex));
double AxFloatFromArray AXP_((data_ptr aP,int dex));
int AxBinaryFromArray AXP_((data_ptr data, int dex, char **binP));
int AxBoolFromArray AXP_((data_ptr data, int index));
int AxIntFromArray AXP_((data_ptr aP,int dex));
data_ptr ElfGetMsgData AXP_((void));
data_ptr AxMakeStrData AXP_((int len, char *str));
data_ptr AxTaskMakeStrData AXP_((int pid, int len, char *str));
data_ptr AxMakeWideStrData AXP_((int len, wchar *str));
data_ptr AxTaskMakeWideStrData AXP_((int pid, int len, wchar *str));
data_ptr AxMakeIntData AXP_((int num));
data_ptr AxTaskMakeIntData AXP_((int pid, int num));
data_ptr AxMakeNumData AXP_((int num));
data_ptr AxMakeDblData AXP_((double num));
void AxFreeData AXP_((data_ptr p));
void AxTaskFreeData AXP_((int pid, data_ptr p));
int ElfCallByName();
data_ptr AxTaskCopyElfData AXP_((int task, data_ptr aP));
void AxTaskFreeElfData AXP_((int task, data_ptr aP));
int AxIntFromDataPtr AXP_((data_ptr aP));
int AxBoolFromDataPtr AXP_((data_ptr aP));
mbchar *AxStrPtrFromDataPtr AXP_((data_ptr aP));
wchar *AxWideStrPtrFromDataPtr AXP_(( data_ptr ap));
data_ptr AxMakeFloatData AXP_((double val));
data_ptr AxTaskMakeFloatData AXP_((int pid, double val));
data_ptr AxMakeBinaryData AXP_((int elements, mbchar *data_bytes));
data_ptr AxMakeObjectData AXP_((int objdex,int objuid));
data_ptr AxTaskMakeObjectData AXP_((int pid, int objdex,int objuid));
double AxFloatFromDataPtr AXP_((data_ptr ap));
void   *AxInitCube AXP_(( data_ptr , int *, int *, int *));
void    AxFreeCube AXP_(( void *));
data_ptr 	AxCubeElement AXP_((void *, int, int, int));
data_ptr 	AxSSMakeNaData AXP_((void));
data_ptr 	AxSSMakeErrorData AXP_((void));
int 		AxSSIsNa AXP_((data_ptr));
int 		AxSSIsError AXP_((data_ptr));
#endif /* eldataHinclude */
