/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: trcdefs.h
   Applix ASC version: 1
   Date: Mon Nov 16 13:52:53 1998
*/
#ifndef TRLEV_1

#ifndef FILE
#include <stdio.h>
#endif

#define TRLEV_1 1
#define TRLEV_2 2
#define TRLEV_3 4
#define TRLEV_4 8
#define TRLEV_P 16
#define TREXCL 32
#define TRINCL 64
#define DB 1
#ifndef DBABST
#define DBABST 1
#endif
#define A_ 2
#define D_ 4
#define RX 8
#define R_ 16
#define UT 32
#define PD 64

/*-------------------*/
/* error definitions */
/*-------------------*/
#define ED_NORMAL 0		/* Normal completion */
#define ED_BADARG -1	/* Invalid argument specified */
#define ED_NOREC -2		/* A record has not been read */
#define ED_BADCMP -3	/* Illegal field-date comparison */
#define ED_NOPRED -4	/* No predicate list */
#define ED_BADPRED -5	/* ALL is not allowed */
#define ED_BADFLD -6	/* Invalid field identifier */
#define ED_BADOPER -7	/* Illegal comparison operator */
#define ED_BADUID -8	/* No current record uid */
#define ED_MAXOPN -9	/* Maximum tables open */
#define ED_RDMODE -10	/* Writes not allowed in read mode */
#define ED_NOTUNIQ -11	/* Not unique key */
#define ED_DELREC -12	/* Record deleted or already used */
#define ED_BADMODE -13	/* Bad open mode */

#define	ED_BADATTR -1000	/* Invalid field attribute */
#define ED_NOWHAT -1001	/* Whatpred is null */
#define ED_BADSRCH -1002	/* Algorithmic search error */
#define ED_TBLOPN -1003	/* Table already open */
#define ED_TOOBIG -1004 /* Record too large */
#define ED_BADOFF -1005 /* Bad file offset */
#define ED_BADBTPG -1006	/* Bad Btree page */
#define ED_INTERNAL -1007	/* Internal failure */
#define ED_BADREC -1008		/* Read bad datafile record */
#define ED_ACOPY -1009	/* Acopy failed */

#define ED_MALLOC 1		/* malloc failed */
#define ED_OPEN 2		/* open failed */
#define ED_READ 3		/* read failed */
#define ED_UNLINK 4		/* unlink failed */
#define ED_LSEEK 5		/* lseek failed */
#define ED_WRITE 6		/* write failed */
#define ED_REALLOC 7	/* realloc failed */
#define ED_FSTAT 8		/* fstat failed */
#define ED_STAT 9		/* stat failed */
#define ED_LOCK 10		/* flock, lockf, or locking failed */
#define ED_RE_COMP 11	/* re_comp failed */
#define ED_RE_EXEC 12	/* re_exec failed */
#define ED_CLOSE 13		/* close failed */
#define ED_RENAME 14	/* rename failed */

extern FILE *D_trcfp;
extern int D_trlevel;
extern int D_trtime;
extern int D_trperf;
extern int D_traceon;
extern int D_trsubsys;
extern char *D_rname;

extern void rx_trace();
extern void rx_error();
#endif
