/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: x2winkey.h
   Applix ASC version: 4
   Date: Mon Dec 21 21:11:25 1998
*/
#if !X_TO_WIN_KEYS

#define X_TO_WIN_KEYS 1

#include <winuser.h>

#define KEY_TYPE_MASK 0xFF00	/* other values may be required for kanji, ... */

#define XK_BackSpace	(KEY_TYPE_MASK | VK_BACK)	/* back space, back char */
#define XK_Tab			(KEY_TYPE_MASK | VK_TAB)
#define XK_Clear		(KEY_TYPE_MASK | VK_CLEAR)
#define XK_Return		(KEY_TYPE_MASK | VK_RETURN)	/* Return, enter */
#define XK_Pause		(KEY_TYPE_MASK | VK_PAUSE)	/* Pause, hold */
#define XK_Escape		(KEY_TYPE_MASK | VK_ESCAPE)
#define XK_Delete		(KEY_TYPE_MASK | VK_DELETE)	/* Delete, rubout */


/* Cursor control & motion */

#define XK_Home			(KEY_TYPE_MASK | VK_HOME)
#define XK_Left			(KEY_TYPE_MASK | VK_LEFT)	/* Move left, left arrow */
#define XK_Up			(KEY_TYPE_MASK | VK_UP)	/* Move up, up arrow */
#define XK_Right		(KEY_TYPE_MASK | VK_RIGHT)	/* Move right, right arrow */
#define XK_Down			(KEY_TYPE_MASK | VK_DOWN)	/* Move down, down arrow */
#define XK_Prior		(KEY_TYPE_MASK | VK_PRIOR)	/* Prior, previous */
#define XK_Next			(KEY_TYPE_MASK | VK_NEXT)	/* Next */
#define XK_End			(KEY_TYPE_MASK | VK_END)	/* EOL */


/* Misc Functions */

#define XK_Print		(KEY_TYPE_MASK | VK_PRINT)
#define XK_Execute		(KEY_TYPE_MASK | VK_EXECUTE)	/* Execute, run, do */
#define XK_Insert		(KEY_TYPE_MASK | VK_INSERT)	/* Insert, insert here */
#define XK_Cancel		(KEY_TYPE_MASK | VK_CANCEL)	/* Cancel, stop, abort, exit */
#define XK_Help			(KEY_TYPE_MASK | VK_HELP)	/* Help, ? */
#define XK_Num_Lock		(KEY_TYPE_MASK | VK_NUMLOCK)

/* Keypad Functions, keypad numbers cleverly chosen to map to ascii */

#define XK_KP_Multiply		(KEY_TYPE_MASK | VK_MULTIPLY)
#define XK_KP_Add			(KEY_TYPE_MASK | VK_ADD)
#define XK_KP_Separator		(KEY_TYPE_MASK | VK_SEPARATOR)	/* separator, often comma */
#define XK_KP_Subtract		(KEY_TYPE_MASK | VK_SUBTRACT)
#define XK_KP_Decimal		(KEY_TYPE_MASK | VK_DECIMAL)
#define XK_KP_Divide		(KEY_TYPE_MASK | VK_DIVIDE)

#define XK_KP_0			(KEY_TYPE_MASK | VK_NUMPAD0)
#define XK_KP_1			(KEY_TYPE_MASK | VK_NUMPAD1)
#define XK_KP_2			(KEY_TYPE_MASK | VK_NUMPAD2)
#define XK_KP_3			(KEY_TYPE_MASK | VK_NUMPAD3)
#define XK_KP_4			(KEY_TYPE_MASK | VK_NUMPAD4)
#define XK_KP_5			(KEY_TYPE_MASK | VK_NUMPAD5)
#define XK_KP_6			(KEY_TYPE_MASK | VK_NUMPAD6)
#define XK_KP_7			(KEY_TYPE_MASK | VK_NUMPAD7)
#define XK_KP_8			(KEY_TYPE_MASK | VK_NUMPAD8)
#define XK_KP_9			(KEY_TYPE_MASK | VK_NUMPAD9)



#define XK_F1			(KEY_TYPE_MASK | VK_F1)
#define XK_F2			(KEY_TYPE_MASK | VK_F2)
#define XK_F3			(KEY_TYPE_MASK | VK_F3)
#define XK_F4			(KEY_TYPE_MASK | VK_F4)
#define XK_F5			(KEY_TYPE_MASK | VK_F5)
#define XK_F6			(KEY_TYPE_MASK | VK_F6)
#define XK_F7			(KEY_TYPE_MASK | VK_F7)
#define XK_F8			(KEY_TYPE_MASK | VK_F8)
#define XK_F9			(KEY_TYPE_MASK | VK_F9)
#define XK_F10			(KEY_TYPE_MASK | VK_F10)
#define XK_F11			(KEY_TYPE_MASK | VK_F11)
#define XK_F12			(KEY_TYPE_MASK | VK_F12)
#define XK_F13			(KEY_TYPE_MASK | VK_F13)
#define XK_F14			(KEY_TYPE_MASK | VK_F14)
#define XK_F15			(KEY_TYPE_MASK | VK_F15)
#define XK_F16          (KEY_TYPE_MASK | VK_F16)
#define XK_F17          (KEY_TYPE_MASK | VK_F17)
#define XK_F18          (KEY_TYPE_MASK | VK_F18)
#define XK_F19          (KEY_TYPE_MASK | VK_F19)
#define XK_F20          (KEY_TYPE_MASK | VK_F20)
#define XK_F21          (KEY_TYPE_MASK | VK_F21)
#define XK_F22          (KEY_TYPE_MASK | VK_F22)
#define XK_F23          (KEY_TYPE_MASK | VK_F23)
#define XK_F24          (KEY_TYPE_MASK | VK_F24)

/* Modifiers */
#define VK_PAD    5    /* since XK_Shift_L and XK_Shift_R (for example) *
                        * may be used in the same switch statement,     *
                        * they cannot be defined as the same for NT.    *
                        * adding this "pad" (5) does not step on any    *
                        * other VK defines, and makes each unique.      *
                        * -donato    */
#define XK_Shift_L		(KEY_TYPE_MASK | VK_SHIFT)            /* Left shift */
#define XK_Shift_R		(KEY_TYPE_MASK | VK_RSHIFT)           /* Right shift */
#define XK_Control_L	(KEY_TYPE_MASK | VK_CONTROL)          /* Left control */
#define XK_Control_R	(KEY_TYPE_MASK | VK_RCONTROL)         /* Right control */
#define XK_Caps_Lock	(KEY_TYPE_MASK | VK_CAPITAL)	    /* Caps lock */
#define XK_Shift_Lock	(KEY_TYPE_MASK | (VK_CAPITAL + VK_PAD)) /* Shift lock */
#define XK_Alt_L		(KEY_TYPE_MASK | VK_MENU)	            /* Left alt */
#define XK_Alt_R		(KEY_TYPE_MASK | VK_RMENU)            /* Right alt */

/* the following are never true on windows */
/* these need to be unique values (in the case that they *
 * are used in the same switch statement). These numbers *
 * will not step on any other VK defines. - donato       */
#define XK_Meta_L         166
#define XK_Meta_R         167
#define XK_Super_L        168
#define XK_Super_R        169
#define XK_Hyper_L        170
#define XK_Hyper_R        171

/*
 *  Latin 1
 *  Byte 3 = 0
 */
#define XK_space               0x020
#define XK_exclam              0x021
#define XK_quotedbl            0x022
#define XK_numbersign          0x023
#define XK_dollar              0x024
#define XK_percent             0x025
#define XK_ampersand           0x026
#define XK_apostrophe          0x027
#define XK_quoteright          0x027	/* deprecated */
#define XK_parenleft           0x028
#define XK_parenright          0x029
#define XK_asterisk            0x02a
#define XK_plus                0x02b
#define XK_comma               0x02c
#define XK_minus               0x02d
#define XK_period              0x02e
#define XK_slash               0x02f
#define XK_0                   0x030
#define XK_1                   0x031
#define XK_2                   0x032
#define XK_3                   0x033
#define XK_4                   0x034
#define XK_5                   0x035
#define XK_6                   0x036
#define XK_7                   0x037
#define XK_8                   0x038
#define XK_9                   0x039
#define XK_colon               0x03a
#define XK_semicolon           0x03b
#define XK_less                0x03c
#define XK_equal               0x03d
#define XK_greater             0x03e
#define XK_question            0x03f
#define XK_at                  0x040
#define XK_A                   0x041
#define XK_B                   0x042
#define XK_C                   0x043
#define XK_D                   0x044
#define XK_E                   0x045
#define XK_F                   0x046
#define XK_G                   0x047
#define XK_H                   0x048
#define XK_I                   0x049
#define XK_J                   0x04a
#define XK_K                   0x04b
#define XK_L                   0x04c
#define XK_M                   0x04d
#define XK_N                   0x04e
#define XK_O                   0x04f
#define XK_P                   0x050
#define XK_Q                   0x051
#define XK_R                   0x052
#define XK_S                   0x053
#define XK_T                   0x054
#define XK_U                   0x055
#define XK_V                   0x056
#define XK_W                   0x057
#define XK_X                   0x058
#define XK_Y                   0x059
#define XK_Z                   0x05a
#define XK_bracketleft         0x05b
#define XK_backslash           0x05c
#define XK_bracketright        0x05d
#define XK_asciicircum         0x05e
#define XK_underscore          0x05f
#define XK_grave               0x060
#define XK_quoteleft           0x060	/* deprecated */
#define XK_a                   0x061
#define XK_b                   0x062
#define XK_c                   0x063
#define XK_d                   0x064
#define XK_e                   0x065
#define XK_f                   0x066
#define XK_g                   0x067
#define XK_h                   0x068
#define XK_i                   0x069
#define XK_j                   0x06a
#define XK_k                   0x06b
#define XK_l                   0x06c
#define XK_m                   0x06d
#define XK_n                   0x06e
#define XK_o                   0x06f
#define XK_p                   0x070
#define XK_q                   0x071
#define XK_r                   0x072
#define XK_s                   0x073
#define XK_t                   0x074
#define XK_u                   0x075
#define XK_v                   0x076
#define XK_w                   0x077
#define XK_x                   0x078
#define XK_y                   0x079
#define XK_z                   0x07a
#define XK_braceleft           0x07b
#define XK_bar                 0x07c
#define XK_braceright          0x07d
#define XK_asciitilde          0x07e

#define XK_nobreakspace        0x0a0
#define XK_exclamdown          0x0a1
#define XK_cent        	       0x0a2
#define XK_sterling            0x0a3
#define XK_currency            0x0a4
#define XK_yen                 0x0a5
#define XK_brokenbar           0x0a6
#define XK_section             0x0a7
#define XK_diaeresis           0x0a8
#define XK_copyright           0x0a9
#define XK_ordfeminine         0x0aa
#define XK_guillemotleft       0x0ab	/* left angle quotation mark */
#define XK_notsign             0x0ac
#define XK_hyphen              0x0ad
#define XK_registered          0x0ae
#define XK_macron              0x0af
#define XK_degree              0x0b0
#define XK_plusminus           0x0b1
#define XK_twosuperior         0x0b2
#define XK_threesuperior       0x0b3
#define XK_acute               0x0b4
#define XK_mu                  0x0b5
#define XK_paragraph           0x0b6
#define XK_periodcentered      0x0b7
#define XK_cedilla             0x0b8
#define XK_onesuperior         0x0b9
#define XK_masculine           0x0ba
#define XK_guillemotright      0x0bb	/* right angle quotation mark */
#define XK_onequarter          0x0bc
#define XK_onehalf             0x0bd
#define XK_threequarters       0x0be
#define XK_questiondown        0x0bf
#define XK_Agrave              0x0c0
#define XK_Aacute              0x0c1
#define XK_Acircumflex         0x0c2
#define XK_Atilde              0x0c3
#define XK_Adiaeresis          0x0c4
#define XK_Aring               0x0c5
#define XK_AE                  0x0c6
#define XK_Ccedilla            0x0c7
#define XK_Egrave              0x0c8
#define XK_Eacute              0x0c9
#define XK_Ecircumflex         0x0ca
#define XK_Ediaeresis          0x0cb
#define XK_Igrave              0x0cc
#define XK_Iacute              0x0cd
#define XK_Icircumflex         0x0ce
#define XK_Idiaeresis          0x0cf
#define XK_ETH                 0x0d0
#define XK_Eth                 0x0d0	/* deprecated */
#define XK_Ntilde              0x0d1
#define XK_Ograve              0x0d2
#define XK_Oacute              0x0d3
#define XK_Ocircumflex         0x0d4
#define XK_Otilde              0x0d5
#define XK_Odiaeresis          0x0d6
#define XK_multiply            0x0d7
#define XK_Ooblique            0x0d8
#define XK_Ugrave              0x0d9
#define XK_Uacute              0x0da
#define XK_Ucircumflex         0x0db
#define XK_Udiaeresis          0x0dc
#define XK_Yacute              0x0dd
#define XK_THORN               0x0de
#define XK_Thorn               0x0de	/* deprecated */
#define XK_ssharp              0x0df
#define XK_agrave              0x0e0
#define XK_aacute              0x0e1
#define XK_acircumflex         0x0e2
#define XK_atilde              0x0e3
#define XK_adiaeresis          0x0e4
#define XK_aring               0x0e5
#define XK_ae                  0x0e6
#define XK_ccedilla            0x0e7
#define XK_egrave              0x0e8
#define XK_eacute              0x0e9
#define XK_ecircumflex         0x0ea
#define XK_ediaeresis          0x0eb
#define XK_igrave              0x0ec
#define XK_iacute              0x0ed
#define XK_icircumflex         0x0ee
#define XK_idiaeresis          0x0ef
#define XK_eth                 0x0f0
#define XK_ntilde              0x0f1
#define XK_ograve              0x0f2
#define XK_oacute              0x0f3
#define XK_ocircumflex         0x0f4
#define XK_otilde              0x0f5
#define XK_odiaeresis          0x0f6
#define XK_division            0x0f7
#define XK_oslash              0x0f8
#define XK_ugrave              0x0f9
#define XK_uacute              0x0fa
#define XK_ucircumflex         0x0fb
#define XK_udiaeresis          0x0fc
#define XK_yacute              0x0fd
#define XK_thorn               0x0fe
#define XK_ydiaeresis          0x0ff


/* not used on NT, but need unique values that do not step on *
 * other VK defines  - donato                                 */
#define XK_Linefeed 181
#define XK_F25      182
#define XK_F26      183
#define XK_F27      184
#define XK_F28      185
#define XK_F29      186
#define XK_F30      187
#define XK_F31      188
#define XK_F32      189
#define XK_F33      190
#define XK_F34      191
#define XK_F35      192
#define XK_Begin    193
#define XK_Select   194
#define XK_Undo     195
#define XK_Redo     196
#define XK_Menu     197
#define XK_Find     198
#define XK_Break    199
#define XK_KP_Space 200
#define XK_KP_Tab   201
#define XK_KP_Enter 202
#define XK_KP_F1    203
#define XK_KP_F2    204
#define XK_KP_F3    205
#define XK_KP_F4    206
#define XK_KP_Equal 207
#define XK_L1       208 
#define XK_L2       209
#define XK_L3       210
#define XK_L4       211
#define XK_L5       212
#define XK_L6       213
#define XK_L7       214
#define XK_L8       215
#define XK_L9       216 
#define XK_L10      217
#define XK_R1       218
#define XK_R2       219
#define XK_R3       220
#define XK_R4       221
#define XK_R5       222
#define XK_R6       223
#define XK_R7       224
#define XK_R8       225
#define XK_R9       226
#define XK_R10      227
#define XK_R11      228
#define XK_R12      229
#define XK_R13      230
#define XK_R14      231
#define XK_R15      232
#define XK_KP_Home  233
#define XK_KP_End   234

#endif    /*  X_TO_WIN_KEYS  */
