/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: of.h
   Applix ASC version: 15
   Date: Wed Apr 14 21:15:55 1999
*/
#ifndef _OF_H_
#define _OF_H_

typedef int (*AXFLT_FUNC)(unsigned short*, unsigned short*, void*);

#define MSW_CLSID	    "00020900-0000-0000-c000-000000000046"
#define MSW6P_CLSID	    "00020901-0000-0000-c000-000000000046" /* Word 6 Pic */
#define MSW8_CLSID	    "00020906-0000-0000-c000-000000000046"
#define MSPPT_CLSID	    "ea7bae70-fb3b-11cd-a903-00aa00510ea3"
#define MSPPT97_CLSID	"64818d10-4f9b-11cf-86ea-00aa00b929e8"
#define MSPPT97A_CLSID	"64818d11-4f9b-11cf-86ea-00aa00b929e8"
#define MSXLS_CLSID	    "00020810-0000-0000-c000-000000000046"
#define MSXLS97_CLSID	"00020820-0000-0000-c000-000000000046"
#define MSXLS97A_CLSID	"00020821-0000-0000-c000-000000000046"
#define MSXLS97B_CLSID	"00020811-0000-0000-c000-000000000046"
#define MSXLS97C_CLSID	"00020803-0000-0000-c000-000000000046"
#define MSXLS97D_CLSID	"00020801-0000-0000-c000-000000000046"
#define WP7_CLSID       "aae68660-c718-11ce-8d9b-444553540000"
#define WP8_CLSID	    "519873ff-2dad-0220-1937-0000929679cd"

#if AXMS
#define AXMSW_FLT_LIB	"libaxmsw.dll"
#define AXPPT_FLT_LIB	"libaxppt.dll"
#define AXXLS_FLT_LIB	"libaxxls.dll"
#elif HP800V3
#define AXMSW_FLT_LIB   "libaxmsw.sl"
#define AXPPT_FLT_LIB   "libaxppt.sl"
#define AXXLS_FLT_LIB   "libaxxls.sl"
#else
#define AXMSW_FLT_LIB	"libaxmsw.so"
#define AXPPT_FLT_LIB	"libaxppt.so"
#define AXXLS_FLT_LIB	"libaxxls.so"
#endif

#define AXMSW_FUNC_NAME	"axmsw_main"
#define AXPPT_FUNC_NAME	"axppt_main"
#define AXXLS_FUNC_NAME	"axxls_main"

#ifndef READ_BINARY_STR
#if AXMS
#define READ_BINARY_STR "rb"
#else
#define READ_BINARY_STR "r"
#endif
#endif

#ifndef WRITE_BINARY_STR
#if AXMS
#define WRITE_BINARY_STR "wb"
#else
#define WRITE_BINARY_STR "w"
#endif
#endif

#ifndef DLL_EXPORT
#if AXMS
#define DLL_EXPORT __declspec( dllexport )
#else
#define DLL_EXPORT
#endif
#endif

#if !AXMS
#define mbstowcs				sbstowcs
#define wcstombs				wcstosbs
#endif	/* !AXMS */

/* code pages (from Win32 API GetACP) */
#define OF_CP_JAPAN		932
#define OF_CP_UNICODE   1200
#define OF_CP_LATIN1    1252

#define OF_SHIFTJIS_CHARSET		128


#endif	/* _OF_H_ */
