/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pfattr.c
   Applix ASC version: 12
   Date: Mon Nov 16 13:56:49 1998
*/
#include <stdio.h>
#include <pf.h>
#include <aos.h>
#include <paratm.h>
#include <devsetup.h>
#include <pfint.h>

#include <pfattr.p>


		/* TmSetWinAttr function */

short PfOutline[8];

pf_set_win()
{
	int x, y, last_x, last_y;
	int left, top, right, bottom;

	Debugs("pf_set_win()\n");
	PF.PfPage.lin_des.line_style = InWord ();
	PF.PfPage.lin_des.line_thickness = InWord ();
	PF.PfPage.write_tx_des = InLong ();
	Debugf("text des: 0x%lx\n", (long) PF.PfPage.write_tx_des);
	PF.PfPage.trans_mode = InWord ();
	PF.PfPage.txAlign = InWord ();
	if (PF.PfSe_version >= 4)
	{
		/*
		 * These window-level color attrs are the only means of expressing
		 * the color of graphic objects.  For text, they will take effect only
		 * if not explicitly overriden by the text descriptors at fontSelect.
		 * Note that background color can typically be set only once per page.
		 */
		PF.PfWin_fg_color = InWord();
		PF.PfWin_bg_color = InWord();
		Debug2f("PF.PfWin_fg_color %d, PF.PfWin_bg_color %d\n", PF.PfWin_fg_color, PF.PfWin_bg_color);
	}
#ifdef DEBUGCOMP
	Debugs("clip rect set to:\n");
	x = InWord ();
	y = InWord ();
	last_x = InWord ();
	last_y = InWord ();
	Debug4f(NXLT("mil x1:   %d   mil y1:   %d   mil x2:   %d   mil y2:   %d\n"),
			x, y, last_x, last_y);
	x = xmiltopix (x);
	y = ymiltopix (y);
	last_x = xmiltopix (last_x);
	last_y = ymiltopix (last_y);
	Debug4f(NXLT("pixel x1: %d   pixel y1: %d   pixel x2: %d   pixel y2: %d\n"),
			x, y, last_x, last_y);
#else
	x = xmiltopix (InWord ());
	y = ymiltopix (InWord ());
	last_x = xmiltopix (InWord ());
	last_y = ymiltopix (InWord ());
#endif
	left = PF.PfPage.inner.origin.x;
	top = PF.PfPage.inner.origin.y;
	right = PF.PfPage.inner.corner.x;
	bottom = PF.PfPage.inner.corner.y;
	if (x < left)
		x = left;
	if (x > right)
		x = right;
	if (y < top)
		y = top;
	if (y > bottom)
		y = bottom;
	if (last_x < left)
		last_x = left;
	if (last_x > right)
		last_x = right;
	if (last_y < top)
		last_y = top;
	if (last_y > bottom)
		last_y = bottom;
	if (last_x < x)
		last_x = x;
	if (last_y < y)
		last_y = y;

	/* set the clipping in the print graphics context */
	SetSEClip(&PF.PfPage.appClip, x , y, last_x, last_y);

}

pf_imgtxt()
{
	short tmp;

	PF.PfPage.scaledText = InWord();
	tmp = InWord();
	PfOutline[0] = tmp;
	PF.PfPage.imageBox[0].x = xmiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[1] = tmp;
	PF.PfPage.imageBox[0].y = ymiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[2] = tmp;
	PF.PfPage.imageBox[1].x = xmiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[3] = tmp;
	PF.PfPage.imageBox[1].y = ymiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[4] = tmp;
	PF.PfPage.imageBox[2].x = xmiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[5] = tmp;
	PF.PfPage.imageBox[2].y = ymiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[6] = tmp;
	PF.PfPage.imageBox[3].x = xmiltopix ((int)tmp);
	tmp = InWord();
	PfOutline[7] = tmp;
	PF.PfPage.imageBox[3].y = ymiltopix ((int)tmp);
}

void PFSetColordev(color)
int color;
{
	PF.PfColordev = color;
}

