/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pffw.c
   Applix ASC version: 42
   Date: Mon Nov 16 13:56:50 1998
*/
#include <stdio.h>
#include <math.h>
#include <pf.h>
#include <aos.h>
#include <paratm.h>
#include <devsetup.h>
#include <pfint.h>
#include <sff.h>
#include <axtext.h>

#include <pffw.p>


extern int TargetRes;

#if AXMS
#define hypot _hypot
#endif

/*-----------------------------------------------------------------------------
	axtGetShadowPrintInfo

-----------------------------------------------------------------------------*/
int axtGetShadowPrintInfo(txProps, draw_shadow, draw_emboss, shadow)
	textAttrs *txProps;
	int draw_shadow;
	int draw_emboss;
	int shadow;
{
	int no_prnt, s_type;

	if ( !txProps->fillpattern )
		no_prnt = TRUE;
	else
	{
		s_type = txProps->fillpattern->s_type;
		if ( s_type == 0 )
			no_prnt = TRUE;
		else switch ( shadow )
		{
			default:
			case 0:
				no_prnt = TRUE;
			break;
			case 1:
				if ( draw_emboss == FALSE )
					no_prnt = TRUE;
				else if ( s_type != 3 && s_type != 4 )
					no_prnt = TRUE;
				else 
					no_prnt = FALSE;
			break;
			case 2:
				if ( draw_shadow == TRUE )
					no_prnt = FALSE;
				else
					no_prnt = TRUE;
			break;
		}
	}
	return(no_prnt);
}


/*-----------------------------------------------------------------------------
	pfText
	
	print an axtext instance
-----------------------------------------------------------------------------*/
int pfText()
{
	int segCount, piececount, width, txlen;
	int underPos, underThick, strikePos;
	int xZoom, yZoom, draw_shadow, shadow_only, draw_emboss, s_type;
	int sdx, sdy, sfg, no_prnt;
	p32 pos;
	tx_char *textstr;
	textAttrs *txProps, fieldProps;
	char *fontName;
	void pfFreeTextAttrs();
	TmRect32 clip ;
	color_type new_color;

	s_type = InInt(); 
	InTxFieldProps(&fieldProps, &xZoom, &yZoom,
					&draw_shadow, &shadow_only, &draw_emboss);

	/* clipping rectangle */
	InBlock((char *)&clip, sizeof(clip)) ;

	segCount = InInt(); /* # mono-attr segments in this text */
	while (segCount--) {
		piececount = InInt(); /* # 'default-positioned' pieces in seg */
			/* get attr info for this seg */
		InTextAttrs(&txProps, &fontName, &underPos, &underThick, &strikePos);

		if ( s_type == 2 ) /* dark shadow */
		{
			no_prnt = axtGetShadowPrintInfo(txProps, draw_shadow, draw_emboss, s_type);
			if ( no_prnt )
			{
				sdx = 0;
				sdy = 0;
			}
			else
			{
				sdx = txProps->fillpattern->s_xoff;
				sdy = txProps->fillpattern->s_yoff;
				txProps->fillpattern->ffg = txProps->fillpattern->sfg;
				txProps->fillpattern->fbg = txProps->fillpattern->sfg;
				txProps->fillpattern->lfg = txProps->fillpattern->sfg;
				txProps->fillpattern->lbg = txProps->fillpattern->sfg;
				sfg = 0;
				sfg |= txProps->fillpattern->ffg.c << 24;
				sfg |= txProps->fillpattern->ffg.m << 16;
				sfg |= txProps->fillpattern->ffg.y << 8;
				sfg |= txProps->fillpattern->ffg.k;
				txProps->fillcolor = sfg;
			}
		}
		else if ( s_type == 1 ) /* emboss shadow */
		{
			no_prnt = axtGetShadowPrintInfo(txProps, draw_shadow, draw_emboss, s_type);
			if ( no_prnt )
			{
				sdx = 0;
				sdy = 0;
			}
			else if ( txProps->fillpattern->s_type < 3 )
			{
				sdx = 0;
				sdy = 0;
				no_prnt = TRUE;
			}
			else
			{
				sdx = (-1)*txProps->fillpattern->s_xoff;
				sdy = (-1)*txProps->fillpattern->s_yoff;

				GetWashoutColor(&txProps->fillpattern->sfg, &new_color);
				txProps->fillpattern->sfg.c = new_color.c;
				txProps->fillpattern->sfg.m = new_color.m;
				txProps->fillpattern->sfg.y = new_color.y;
				txProps->fillpattern->sfg.k = new_color.k;

				txProps->fillpattern->ffg = txProps->fillpattern->sfg;
				txProps->fillpattern->fbg = txProps->fillpattern->sfg;
				txProps->fillpattern->lfg = txProps->fillpattern->sfg;
				txProps->fillpattern->lbg = txProps->fillpattern->sfg;
				sfg = 0;
				sfg |= txProps->fillpattern->ffg.c << 24;
				sfg |= txProps->fillpattern->ffg.m << 16;
				sfg |= txProps->fillpattern->ffg.y << 8;
				sfg |= txProps->fillpattern->ffg.k;
				txProps->fillcolor = sfg;
			}
		}
		else if ( shadow_only == FALSE ) /* normal text */
		{
			sdx = 0;
			sdy = 0;
			no_prnt = FALSE;
		}

		while (piececount--) {
			pos.x = InInt();
			pos.y = InInt();
			width = InInt();
			pos.x += sdx;
			pos.y += sdy;
			txlen = InTxCharString(&textstr);
			if (txProps->ruling || txProps->strike_thru) {
				p32 ruleFrom, ruleTo;
				axformTerms field, local;
				axform xform;
				
				field.angle = fieldProps.angle;
				field.xscale = fieldProps.xscale;
				field.yscale = fieldProps.yscale;
				field.xshear = fieldProps.xshear;
				if (field.angle ||
					(field.xscale != 10000) || (field.yscale != 10000) ||
					field.xshear) {
					
					field.unity = FALSE;
				}
				else {
					field.unity = TRUE;
				}

				local.angle = txProps->angle;
				local.xscale = txProps->xscale;
				local.yscale = txProps->yscale;
				local.xshear = txProps->xshear;
				if (local.angle ||
					(local.xscale != 10000) || (local.yscale != 10000) ||
					local.xshear) {
					
					local.unity = FALSE;
				}
				else {
					local.unity = TRUE;
				}
				axtWriteTargetCtm(xZoom, yZoom, &local, &field, &xform);
				
				ruleFrom.x = InInt();
				ruleFrom.y = InInt();
				ruleTo.x = InInt();
				ruleTo.y = InInt();
				pfDrawRuling(&ruleFrom, &ruleTo, txProps, &xform,
							 underPos, underThick, strikePos, &clip);
			}
			if (txlen && no_prnt == FALSE ) {
				DrawAxText(textstr, txlen, &pos, width, fontName,
						   underPos, underThick, strikePos,
						   txProps, &fieldProps, xZoom, yZoom, &clip);
				free(textstr);
			}
		}
		free(fontName);
		fontName = NULL;
		pfFreeTextAttrs(txProps, 1);
	}

}


    /* this macro assumes the character encoding has these
	   characters as actual whitespace..  Shouldn't make
	   assumptions like this; oh well.   The nonbreak space is
	   omitted to decrease the chances that this macro will
	   treat black as white */
#define PFWHITE(ch) ((int)ch == ' ' || (int)ch == '\t')
#define PFBLACK(ch) (!(PFWHITE(ch)))

/*-----------------------------------------------------------------------------
	pfGetTextLayoutDeltas
	
	this is a 'print bashing' function
	intended for adjusting the layout of a segment of text when
	it is necessary to use a substitute font at print time; the
	layout is adjusted to get it to extend about where it would if
	the actual font could be used;  This function returns a txlen-sized
	array of position adjustments, which the caller must free

	caller must free nonnull return
-----------------------------------------------------------------------------*/
int *pfGetTextLayoutDeltas(ftab, textstr, txlen, width, txProps, altRec, alt)
	fontTabEnt *ftab;     /* in: record describing actual font */
	register tx_char *textstr;     /* in: text string */
	register int txlen;            /* in: string len */
	int width;            /* in: text string width in mils */
	textAttrs *txProps;   /* in: attributes of text */
	fontTabEnt *altRec;   /* in: alternate font's record */
	register axtext *alt;          /* in/out: text 'wearing' alternate font */
{
	int altwidth, werror;
	int spCount, totSpWid, spwid;
    register int ix;
	int firstIx, lastIx;
	unsigned int tflags;
	textAttrs altAtts;
	XFontStruct *altFs;
	int *deltas = (int *) NULL;

	    /* create a text instance using the passed attributes,
		   but with the substitue font used instead */
	        /* start with the font-attr portion of the passed atts */
	tflags = TXfontFamily | TXweight | TXslant | TXpointsize;
	setDefaultTextAttrs(alt, txProps, tflags);
	insChars(alt, textstr, 0, txlen);  /* add text */
	altAtts.fontFamily = altRec->familyName;  /* override font name */
	altAtts.weight = altRec->weight;
	altAtts.slant = altRec->slant;
	tflags = TXfontFamily | TXweight | TXslant;
	setTextAttrs(alt, &altAtts, tflags, 0, txlen);  /* override */
	constructForPrint(alt);  /* get target metrics info onto text */
	    /* take the alternate text's width, which in this
		   context can be done by just summing advances */
	for (ix = 0, altwidth = 0; ix < txlen; ix++) {
		altwidth += alt->items[ix].padvance;
	}
	    /* get the setwidth error */
	werror = width - altwidth;
	    /* get the width of a spacechar in the alt font;
		   assume ' ' is a spacechar.... */
	altFs = alt->atts[0].fconx.target->xfont;
	spwid = mToMils(WCharWid((tx_char) ' ', altFs, (r32 *) NULL),
					alt->atts[0].fontAttr.ptsize);
	    /* get the space count and total width of whitespace
		   across the text;  the PFWHITE macro used here makes
		   encoding assumptions, oh well.. */
	for (ix = 0, totSpWid = 0, spCount = 0; ix < txlen; ix++) {
		if (PFWHITE(alt->items[ix].charcode)) {
			totSpWid += spwid;
			spCount++;
		}
	}

	    /* the delta on character position ix is applied after
		   character ix is set; this means that a delta on the
		   last character position has no effect; exclude this
		   position from the range passed to DistributeOverWhite
		   (distribOverInterBlack omits last char already) */
	firstIx = 0;
	lastIx = txlen - 2;
	if (PFWHITE(textstr[txlen - 1])) {
		if (werror > 0 && spCount == 1) {
			    /* this is an exception; when expanding, allow
				   error to be 'absorbed' on a lone, trailing space;
				   this causes the gob to be expanded not quite
				   enough, which is at least stable */
			lastIx = txlen - 1;
		}
		else {
			spCount--;
			totSpWid -= spwid;
		}
	}

	    /* alloc array for storing position adjustments */
	deltas = (int *) malloc(txlen * sizeof(int));
	memset((char *) deltas, 0, txlen * sizeof(int));
	if (werror == 0) {
		    /* no adjustments to make */
		return (deltas);
	}

	if (spCount == 0) {
		pfDistributeOverInterblack (deltas, werror,
									textstr, txlen);
	}
	else {
		int threshold;
		if (werror < 0) {
			    /* allow spaces to compress to 2/3 */
#if 0
			threshold = (int)((double)totSpWid / 3.0);
#else
			threshold = totSpWid ;
			threshold = (int)((double)totSpWid / 1.5);
#endif
		}
		else {
			threshold = totSpWid * 2;      /* let spaces expand x3 */
		}
		if ( abs(werror) <= threshold) {
			    /* absorb error using whitespace characters */
			pfDistributeOverWhite (&deltas[firstIx], werror,
								   &textstr[firstIx],
								   lastIx - firstIx + 1, spCount);
		}
		else {
			int whiteError, blackError;
			    /* absorb as much as possible in whitespace, then
				   spread the remainder between nonwhite chars */
			whiteError = threshold;
			blackError = abs(werror) - threshold;
			if (werror < 0) {
				whiteError = -whiteError;
				blackError = -blackError;
			}
			pfDistributeOverWhite (&deltas[firstIx], whiteError,
								   &textstr[firstIx],
								   lastIx - firstIx + 1, spCount);
			pfDistributeOverInterblack (deltas, blackError,
										textstr, txlen);
		}
	}
#if 0  /* test code */
	{
		int totalerr;
		for (ix = 0, totalerr = 0; ix < txlen; ix++) {
			totalerr += deltas[ix];
		}
		if ((totalerr != werror) || deltas[txlen - 1]) {
			ix = 0;  /* if here, something's wrong */
		}
	}
#endif
	return (deltas);    /* caller must free */
}

/*-----------------------------------------------------------------------------

	write the deltas array to represent adjustment of
	   error over whitespace characters
-----------------------------------------------------------------------------*/
static void pfDistributeOverWhite (deltas, werror, textstr, txlen, spcount)
	int *deltas;      /* out: array of position adjustments */
	int werror;       /* in:  amount of error to absorb */
	tx_char *textstr; /* in:  text string */
	int txlen;
	int spcount;      /* in:  #whitespace chars in text */
{
	int adjust, ix, inSmall;
	int bigAdjustCount;
	int smallAdjustCount;

	if (spcount <= 0)
		return;

	    /* (smallCount * adjust) + (bigCount * (adjust + 1)
		   will account for the error */

	adjust = werror / spcount;
	bigAdjustCount = abs(werror) % spcount;
	smallAdjustCount = spcount - bigAdjustCount;
	inSmall = TRUE;

	for (ix = 0; ix < txlen; ix++, spcount-- ) {
		if (spcount && PFWHITE(textstr[ix])) {
			if (inSmall) {
				if (smallAdjustCount == 0) {
					inSmall = FALSE;
					    /* increase abs(adjust) by 1 */
					if (werror < 0)
						adjust--;
					else
						adjust++;
				}
				else {
					smallAdjustCount--;
				}
			}
			deltas[ix] = adjust;
		}
	}
}

/*-----------------------------------------------------------------------------

    write the deltas array to represent adjustment of
	   error between blackspace characters
-----------------------------------------------------------------------------*/
static void pfDistributeOverInterblack (deltas, werror, textstr, txlen)
	int *deltas;      /* out: array of position adjustments */
	int werror;       /* in:  amount of error to absorb */
	tx_char *textstr; /* in:  text string */
	int txlen;
{
	int adjust, ix, nInter, inSmall;
	int bigAdjustCount;
	int smallAdjustCount;
	tx_char nextchar;

	    /* count the # inter-black-character sites that
		   are in the passed text */
	if (txlen > 1) {
		nextchar = textstr[1];
	}
	else {
		nextchar = (tx_char) ' ';  /* a whitespace character.. */
	}
	for (ix = 0, nInter = 0; ix < txlen; ix++) {
		if (ix < txlen - 1) {
			nextchar = textstr[ix + 1];
		}
		else {
			nextchar = (tx_char) ' ';
		}
#if 0
		if (PFBLACK(textstr[ix]) && PFBLACK(nextchar)) {
#else
		if (PFBLACK(textstr[ix])) {
#endif
			nInter++;
		}
	}
	if (nInter == 0)
		return;

	    /* (smallCount * adjust) + (bigCount * (adjust + 1)
		   will account for the error */
	adjust = werror / nInter;
	bigAdjustCount = abs(werror) % nInter;
	smallAdjustCount = nInter - bigAdjustCount;
	inSmall = TRUE;

	if (txlen > 1) {
		nextchar = textstr[1];
	}
	else {
		nextchar = (tx_char) ' ';  /* a whitespace character.. */
	}
	for (ix = 0; ix < txlen; ix++ ) {
		if (ix < txlen - 1) {
			nextchar = textstr[ix + 1];
		}
		else {
			nextchar = (tx_char) ' ';
		}
#if 0
		if (PFBLACK(textstr[ix]) && PFBLACK(nextchar)) {
#else
		if (PFBLACK(textstr[ix])) {
#endif
			if (inSmall) {
				if (smallAdjustCount == 0) {
					inSmall = FALSE;
				        /* increase abs(adjust) by 1 */
					if (werror < 0)
						adjust--;
					else
						adjust++;
				}
				else {
					smallAdjustCount--;
				}
			}
			deltas[ix] = adjust;
		}
	}
}

/*-----------------------------------------------------------------------------
	pfGetTransformTerms - extract xform terms:
   angle, xscale, yscale, xshear given a ctm description
-----------------------------------------------------------------------------*/
void pfGetTransformTerms(ctm, terms)
	axform *ctm;         /* in: matrix info */
	axformTerms *terms;  /* out: write corresponding terms */
{
	r32 source;
	b32 dest;

	    /* write source as a reference rectangle */
	source.origin.x = 0;
	source.origin.y = -10000;
	source.width = source.height = 10000;

	    /* transform onto dest */
	forwardSXRT(source.origin.x, source.origin.y,
				&dest.p0.x, &dest.p0.y, ctm);
	forwardSXRT(source.origin.x + source.width - 1,
				source.origin.y,
				&dest.p1.x, &dest.p1.y, ctm);
	forwardSXRT(source.origin.x + source.width - 1,
				source.origin.y + source.height - 1,
				&dest.p2.x, &dest.p2.y, ctm);
	forwardSXRT(source.origin.x,
				source.origin.y + source.height - 1,
				&dest.p3.x, &dest.p3.y, ctm);

	pfGetTransformTermsFromBox(&source, &dest, terms);
}

/*-----------------------------------------------------------------------------
	pfGetTransformTermsFromBox - given source and destination
   pointsets (source is some reference rectangle, destination
   its transformed correspondent), write the transform terms
   xscale, yscale, angle, xshear.
-----------------------------------------------------------------------------*/
void pfGetTransformTermsFromBox(sbox, xbox, terms)
	r32 *sbox;           /* in:  source rect */
	b32 *xbox;           /* in:  transformed sourerect */
	axformTerms *terms;  /* out: fill this in */
{
	float xwid, sinAng, cosAng, hx, sx, sy;
	p32 tp0, tp3;
	int nrwid, nrht; /* bounding wid, ht of transformed pts */
	int tmp;

	if (nonrotated(xbox)) {
		sinAng = 0.0;
		cosAng = 1.0;
		hx = 0.0;
		nrwid = xbox->p1.x - xbox->p0.x + 1;
		nrht = xbox->p3.y - xbox->p0.y + 1;
		if (sbox->width > 0) {
			sx = (float) nrwid /
					(float) sbox->width;
		}
		else {
			sx = 1.0;
		}
		if (sbox->height > 0) {
			sy = (float) nrht / (float) sbox->height;
		}
		else {
			sy = 1.0;
		}
		terms->angle = axtGetAngle(sinAng, cosAng);
		terms->xscale = qRound(sx * 10000.0);
		terms->yscale = qRound(sy * 10000.0);
		terms->xshear = qRound(hx * 10000.0);

		if (!terms->angle && !terms->xshear &&
			terms->xscale == 10000 && terms->yscale == 10000)
		{
			terms->unity = TRUE;
		}
		else
		{
			terms->unity = FALSE;
		}
	}
	else {
		xwid = (float) hypot((double)(xbox->p1.x - xbox->p0.x),
							 (double)(xbox->p1.y - xbox->p0.y));
		if (sbox->width == 0) {
			sx = 1.0;
		}
		else {
			sx = (float)(xwid) / (float)(sbox->width);
		}
			/* translate xbox so that p0 is on the origin */
		xbox->p1.x -= xbox->p0.x;
		xbox->p1.y -= xbox->p0.y;
		xbox->p2.x -= xbox->p0.x;
		xbox->p2.y -= xbox->p0.y;
		xbox->p3.x -= xbox->p0.x;
		xbox->p3.y -= xbox->p0.y;
		xbox->p0.x = xbox->p0.y = 0;
			/* extract angle */
		if (xwid != 0.0) {
			sinAng = (float)(xbox->p1.y - xbox->p0.y) / xwid;
			cosAng = (float)(xbox->p1.x - xbox->p0.x) / xwid;
		}
		else {
			sinAng = 0.0;
			cosAng = 1.0;
		}
			/* derotate pts 0,3 and compare to get xshear and yscale */
		tp0.x = tp0.y = 0; /* derotate of 0,0 is 0,0 */
		axtScaleInvR(xbox->p3.x, xbox->p3.y, &tp3.x, &tp3.y, sinAng, cosAng);
		if ((tp3.y - tp0.y) == 0) {
			hx = 0.0;
		}
		else if ((tmp = tp3.x - tp0.x) != 0) {
			hx = (float)tmp / (float)(tp3.y - tp0.y);
		}
		else {
			hx = 0.0;
		}
		if (sbox->height == 0) {
			sy = 1.0;
		}
		else {
			sy = (float)(tp3.y - tp0.y) / (float) sbox->height;
		}

		terms->angle = axtGetAngle(sinAng, cosAng);
		terms->xscale = qRound(sx * 10000.0);
		terms->yscale = qRound(sy * 10000.0);
		terms->xshear = qRound(hx * 10000.0);
		terms->unity = FALSE;
	}
}

/*-----------------------------------------------------------------------------
	nonrotated
-----------------------------------------------------------------------------*/
static int nonrotated(b)
	b32 *b;
{
	if (b->p0.y==b->p1.y && b->p0.y < b->p3.y &&
		b->p0.x==b->p3.x) {
		return TRUE;
	}
	else {
		return FALSE;
	}
}


