/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: pfpat.h
   Applix ASC version: 8
   Date: Mon Nov 16 13:56:50 1998
*/
#define MAX_PATS    26      /* this # of built-in pattern fills */

typedef struct {
    int         mode;
    int         type;
    int         pat;
    int         ang;
    char        *name;
    char		*data;
    int         dhyt, dwid, ddep;
    int         xoff, yoff, fill_abs;
    color_type  fg ;            /* foreground color */
    color_type  bg ;            /* background color */
    int         use_f_black;
    int         use_b_white;
#if 0
    int     fc, fm, fy, fb, use_f_black;
    int     bc, bm, by, bb, use_b_white;
#endif
} sub_attr_type;


typedef struct {
    int         needed ;
    int         pat ;
    int         hyt, wid, dep;  /* dimensions of the pattern data */
    char        *data;          /* the pattern data itself (what bit/byte order?) */
    cmap_type   cmap ;          /* color map */
    int         byte_wid;
    int         ref_index;      /* the number by which to refer to this pattern  */
    color_type  fg ;            /* foreground color */
    color_type  bg ;            /* background color */
#if AXMS
    HBITMAP      pixmap, imap;   /* bitmap handles for Windows. */
#endif
} pattern_type ;

extern pattern_type pattern[] ;


