/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: finance.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:56:38 1998
*/
#include <math.h>
#include <sysdep.h>

/* typedefs ---------------------------------------------------------------*/
typedef int boolean ;

typedef struct {
	int		year ;
	int		month ;
	int		day ;
	boolean		leap ;
	int		last_day ;
	} DATE_TRIP ;

/* defines ---------------------------------------------------------------*/
#define TRUE			1
#define FALSE			0

#ifndef NULL
#define NULL			0
#endif

#define	NUM_ERROR		SPL_ERROR
#define	NA_ERROR		SPL_NA
#define	STAND_ALONE		TRUE	/* for test in stand-alone system --------*/

#if AXMS
#define strcasecmp(s1,s2)    stricmp(s1,s2)
#define strncasecmp(s1,s2,n) strnicmp(s1,s2,n)


/** the following prototypes are included here, since they will not be built */
/* into the ".p" files on NT, since that produces DLL type definition        */
/* colllisions based on things which are imported, or exported               */
#ifndef DLL_EXPORT
#define DLL_EXPORT __declspec( dllexport )
#endif

#ifndef AX_DLL
DLL_EXPORT double ssDATEVALUE( char *s );
DLL_EXPORT double ssDAYS360( double sdate, double edate, double method );
DLL_EXPORT double ssEDATE(double d, double months);
DLL_EXPORT double ssEOMONTH(double d, double months);
DLL_EXPORT double ssNETWORKDAYS(double start, double end, double holiday);
DLL_EXPORT double ssTIMEVALUE( char *s );
DLL_EXPORT double ssWEEKDAY(double d, double type);
DLL_EXPORT double ssWORKDAY(double start, double days, double holiday);
DLL_EXPORT double ssYEARFRAC(double start, double end, double basis);
DLL_EXPORT double idate(int year, int month, int day, int last);
DLL_EXPORT double days_between(double start, double end, int basis);
DLL_EXPORT double DAY(double datenum);
DLL_EXPORT double MONTH(double datenum);
DLL_EXPORT double YEAR(double datenum);
DLL_EXPORT void undate(double datenum, DATE_TRIP *s);
DLL_EXPORT int x_basis(double basis);
DLL_EXPORT int x_pint(double d);
#endif
#endif

