/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: getargs.h
   Applix ASC version: 4
   Date: Mon Nov 16 13:57:07 1998
*/
#ifndef __GETARGS_H	/* { */
#define __GETARGS_H
#define ARG_EOF 		0		/* end of arguments */
#define ARG_BOUNDS 		1		/* arg value check by function failed */
#define ARG_PEND 		2
#define ARG_NA 			3
#define ARG_ERROR 		4
#define ARG_FERROR 		5
#define ARG_CIRC 		6
#define ARG_EMPTY 		7
#define ARG_BAD			8
#define ARG_NUMERR 		9
#define	ARG_TYPERR		10
#define ARG_DIVZERO		11
#define ARG_REFERR		12
#define ARG_UDEFNAME	13
#define ARG_TEXT 		14
#define ARG_ADDR 		15
#define ARG_INVALID 	16
#define ARG_TOOMANY 	17
#define ARG_FAIL		18

#define ARG_DBERRDBHT	19	/* height of db is less than minimum */
#define ARG_DBERRCRHT	20	/* height of cr is less than minimum */
#define ARG_DBERRDBMAX	21	/* max number of db rows exceeded */
#define ARG_DBERRCRMAX	22	/* max number of criterion cols exceeded */
#define ARG_DBERRDBEMPTY	23	/* db name contains empty cells */
#define ARG_DBERRCREMPTY	24	/* crit name contains empty cells */
#define ARG_DBERRDBINV		25	/* db names don't contain labels */
#define ARG_DBERRCRINV		26	/* crit names don't contain labels */
#define ARG_DBERRCRNOMATCH	27	/* crit name doesn't match db names */
#define ARG_DBERRBLANK		28	/* comp criteria error for matching blank */
#define ARG_DBERRQUOTES		29	/* no matching quotes for string in criterio*/
#define ARG_DBINVSTR		30  /* invalid value for criterion */
#define ARG_DBINVSTROPER	31	/* invalid operator for string comparision */
#define ARG_DBNOTABS		32	/* cell not absolute in computed criteria */
#define ARG_DBNOFIELD		33	/* no db columns referenced in computed crit */
#define ARG_DBCOMPERR		34	/* computed criterior formula error */
#define ARG_DBNO3D			35	/* 3d args not allowed */


#define ARG_OK 			36
#define ARG_SRNG 		37 
#define ARG_ERNG 		38
#define ARG_DONE 		39  /* functions return this if they are successfull */
#define ARG_FLOAT_ERR 	40 
#define ARG_CSCODE 		41
#define ARG_ELF_DATA	42	/* elf datum */
#define ARG_ELF_ERR		43	/* elf datum */
#define ARG_NULL   		44

/*  the following define values for the "skip_empty" flag in the
 *   structure used to get arguments off the function stack.
 *   They are used to define the action taken when an empty cell, or a
 *   cell containg text is encountered while processing a numberic
 *   function.  These values are set by the function before getting
 *   the desired argument value off the stack.
 *
 *   SKIP_ALL ==> skip this cell and go on to the next as if it were not
 *                    in the argument list at all.
 *   RETURN_EMPTY ==> return error = ARG_EMPTY indicating that an
 *                    empty cell was encountered.
 *   SKIP_NONE ==> don't skip, return a zero value for empty or text cells.
 *	 SKIP_EMPTY ==> skip ONLY empty or blank cells, but not text cells.
 */
 
#define SKIP_NONE 0
#define SKIP_ALL 1
#define RETURN_EMPTY 2
#define SKIP_EMPTY 3

#endif		/* } */
