/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: global.h
   Applix ASC version: 17
   Date: Tue Mar 16 21:10:43 1999
*/
#ifndef __GLOBAL_H
#define __GLOBAL_H



#define REV_3_0 3.0
#define REV_3_1 3.1
#define REV_3_11 3.11
#define REV_3_2 3.2

#define REVISION REV_3_11

#define BCOPY(a,b,c)  bcopy(((char *)(a)),((char *)(b)),c)
#define MEMCPY(a,b,c) memcpy(((char *)(a)),((char *)(b)),c)
#define MEMSET(a,b,c) memset(((char *)(a)),b,c)
#define ANYCPY(a,b,c) anycpy(((char *)(a)),((char *)(b)),c)
#define ANYCMP(a,b,c) anycmp(((char *)(a)),((char *)(b)),c)

#define CH0 '\0'
#define ZeroChar '0'
#define NineChar '9'
#define SpaceChar ' '
#define NlChar '\n'
#define NullStr ""

#ifdef LINTING		/* registers confuse lint */
#define register
#endif

#define noMRG_HACK

#if DEBUG
#define LOGGING
#define CMDLOG
#endif

#ifdef CMDLOG
#define CMD(body) if (ZcmdLog) {CmdLog body;} else;
#else
#define CMD(body)
#endif

#define nMY_GRAPH
#define BOOM
#define TESTABLE 0


#ifdef LOGGING
#define LOGGER(body) if (Zlogging) {LogSend body;} else;
#define CHK LOGGER(("checkpoint %s line %d",__FILE__,__LINE__));
#if 0
#define LGASSERT(x) if ( !(x) ) SSFault(ThisSources, __LINE__);
#else
#define LGASSERT(x) if ( !(x) ) SSFault(__FILE__, __LINE__);
#endif
#else
#define LOGGER(body)
#define LGASSERT(x)
#define CHK
#endif

#ifdef NO_AOS
#else
#include <aos.h>
#endif

#include <obj.h>

#ifndef MIN_SYMS
#ifdef NO_AOS
#else
#include <paratm.h>
#endif

#include <sysdep.h>
#include <mark.h>
#else
#include <atmwin.h>
#endif


#include <getstr20.h>
#include <getstr27.h>

#define assert(x) if ( !(x) ) SSFault(ssP, __FILE__, __LINE__);
#if DEBUG
#if 0
#define ABORT SSFault(ssP, ThisSources, __LINE__)
#else
#define ABORT SSFault(ssP, __FILE__, __LINE__)
#endif
#define DFLTABORT default: ABORT
#else
#define ABORT
#define DFLTABORT
#endif

#define NULL_OBJ 0
#define MAX_SHORT 32767

/* the following is used to size the arrays and processed the bits    */
/*   used by the "Touched" functions used during the move/copy and    */
/*   insert/delete code.  This value represents how big the bit pattern */
/*   is.  It must be a power of 2.  A larger number means more efficient */
/*   processing since there will be less overlap of columns/rows which   */
/*   have been affected.  A larger number however consumes more space for */
/*   the bit strings.                                                     */
#define TOUCHED_MODULO 128

#define MAX_RANGE_OP 5000    /* maximum size of a range for certain operations*/
#define MAX_SCREEN_ROWS 200  /* maximum number of rows on the display screen */

#define FPEXPFLTERR  0
#define FPEXPPRS_ENV 1
#define FPEXPPOW_ENV 2
#define  GRIDSOFF 0
#define  GRIDSDASHED 1
#define  GRIDSSOLID  2


#include <ss.h>
#include <ss_attrs.h>

#ifndef MIN_SYMS
#include <goto.h>
#endif

#include <fcalls.h>

#ifndef SS_FILTER
#ifdef SS
#undef SS
#endif
#endif




#ifdef MY_ATM
extern int WndCount;
#endif

#define MakeArray(group_size,num_groups,max_l1,max_l2,null_special) \
   xMakeArray(ssP, group_size,num_groups,max_l1,max_l2,null_special, FALSE)

#define MakeSortedArray(group_size,num_groups,max_l1,max_l2,null_special) \
   xMakeArray(ssP, group_size,num_groups,max_l1,max_l2,null_special, TRUE)

#define ReadID(a,b) zReadArray(ssP ,a, (array_value*)NULL, b, (char *)NULL)
#define SpclReadID(a,b,c) zReadArray(ssP,  a, b, c, (char*)NULL)
#define SSReadArray(a,b,c) zReadArray(ssP, a,(array_value*)NULL,b,((char *)(c)))

#define SSWriteArray(a,b,c) zWriteArray(ssP, ((ID)(a)),b,((char *)(c)))
#define SizeArray(x) zSizeArray(ssP, ((ID)(x)))
#define SrchArray(x,s) zSrchArray(ssP, ((ID)(x)),((char*)(s)))

#define SPACE_FILL 0
#define ZERO_FILL 1
#define NULL_FILL 2

#if DEBUG
#define TMTerm(a,b) { assert(AOK==TmTerm(a,b)); }
#define TMDreg(a,b,c) {assert(a==Zwnd.ATM_id); assert(AOK==TmDreg(a,b,c)); }
#define TMCreate(a,b) {assert(*a==Zwnd.ATM_id); assert(AOK==TmCreate(a,b)); }
#define TMDchar(a,b,c,d,e,f) { assert(AOK==TmDchar(a,b,c,d,e,f)); }
#define TMMreg(a,b,c) {assert(a==Zwnd.ATM_id); assert(AOK==TmMreg(a,b,c)); }
#define TMARclose(a) {assert(a==Zwnd.ATM_id); assert(AOK==TmARclose(a)); }
#define TMXclose(a,b,c) TmXclose(a,b,c)
#else
#define TMTerm(a,b) TmTerm(a,b);
#define TMDreg(a,b,c) TmDreg(a,b,c);
#define TMCreate(a,b) TmCreate(a,b);
#define TMDchar(a,b,c,d,e,f) TmDchar(a,b,c,d,e,f);
#define TMMreg(a,b,c) TmMreg(a,b,c);
#define TMARclose(a) TmARclose(a);
#define TMXclose(a,b,c) TmXclose(a,b,c)
#endif
#define ReadID(a,b) zReadArray(ssP ,a, (array_value*)NULL, b, (char *)NULL)
#define SpclReadID(a,b,c) zReadArray(ssP,  a, b, c, (char*)NULL)
#define SSReadArray(a,b,c) zReadArray(ssP, a,(array_value*)NULL,b,((char *)(c)))

#define SSWriteArray(a,b,c) zWriteArray(ssP, ((ID)(a)),b,((char *)(c)))
#define SizeArray(x) zSizeArray(ssP, ((ID)(x)))
#define SrchArray(x,s) zSrchArray(ssP, ((ID)(x)),((char*)(s)))

#define SPACE_FILL 0
#define ZERO_FILL 1
#define NULL_FILL 2

#if DEBUG
#define TMTerm(a,b) { assert(AOK==TmTerm(a,b)); }
#define TMDreg(a,b,c) {assert(a==Zwnd.ATM_id); assert(AOK==TmDreg(a,b,c)); }
#define TMCreate(a,b) {assert(*a==Zwnd.ATM_id); assert(AOK==TmCreate(a,b)); }
#define TMDchar(a,b,c,d,e,f) { assert(AOK==TmDchar(a,b,c,d,e,f)); }
#define TMMreg(a,b,c) {assert(a==Zwnd.ATM_id); assert(AOK==TmMreg(a,b,c)); }
#define TMARclose(a) {assert(a==Zwnd.ATM_id); assert(AOK==TmARclose(a)); }
#define TMXclose(a,b,c) TmXclose(a,b,c)
#else
#define TMTerm(a,b) TmTerm(a,b);
#define TMDreg(a,b,c) TmDreg(a,b,c);
#define TMCreate(a,b) TmCreate(a,b);
#define TMDchar(a,b,c,d,e,f) TmDchar(a,b,c,d,e,f);
#define TMMreg(a,b,c) TmMreg(a,b,c);
#define TMARclose(a) TmARclose(a);
#define TMXclose(a,b,c) TmXclose(a,b,c)
#endif

#ifndef MIN_SYMS
  /* the following are used as input to the "assert" macro, and cause */
  /*   the file number and line number to be printed out by the "SSFault" */
  /*   routine                                                         */
#define arrayFILE 1
#define atmFILE 2
#define barsFILE 3
#define bltinsFILE 4
#define builddtFILE 5
#define cacheFILE 6
#define calcFILE 7
#define callimpFILE 8
#define copyFILE 9
#define displayFILE 10
#define explodedtFILE 11
#define faultFILE 12
#define filerFILE 13
#define getdspstrFILE 14
#define goalFILE 15
#define graphFILE 16
#define indexFILE 17
#define initFILE 18
#define ins_udfFILE 19
#define insetFILE 20
#define mXclerkFILE 21
#define mXcopyFILE 22
#define mXdefaultsFILE 23
#define mXdeleteFILE 24
#define mXgdFILE 25
#define mXgotoFILE 26
#define mXgraphFILE 27
#define mXhdrvlFILE 28
#define mXmarkFILE 29
#define mXmoveFILE 30
#define mXnamesFILE 31
#define mXpasteFILE 32
#define mXstyleFILE 33
#define mXwindowFILE 34
#define mXxferFILE 35
#define makersFILE 36
#define markFILE 37
#define moveFILE 38
#define movecFILE 39
#define namesFILE 40
#define parseFILE 41
#define postfrdFILE 42
#define prsFILE 43
#define putcellFILE 44
#define qmakeFILE 45
#define regionsFILE 46
#define ss_to_udfFILE 47
#define ssmainFILE 48
#define styleFILE 49
#define tableFILE 50
#define testFILE 51
#define uimainFILE 52
#define viewFILE 53
#define vobjFILE 54
#define xferFILE 55
#define readvcFILE 56
#define imprespFILE 57
#define getstrFILE 58
#define menuFILE 59
#define prtrangeFILE 60
#define shareFILE 61
#define undoFILE 62
#define vfyFILE 63
#define emptyFILE 64 
#define docmdFILE 65
#define sortFILE 66
#endif

#define CASE break; case

#ifndef MIN_SYMS
#include <statics.h>
#endif

long RngSize();
ID zReadArray();

#define MAXREENTRY 10 /* The maximum number of times the Whatif, bltPredict or bltGoal*/
		      /* can be reentered */

/* Define constants which can come back form a call to "get_range_overlap()"  */
#define NO_CORNERS_IN    0
#define ONE_CORNER_IN    1
#define BOTH_CORNERS_IN  2



#endif /* end of __GLOBAL_H*/

