/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: mark.h
   Applix ASC version: 5
   Date: Mon Nov 16 13:57:02 1998
*/
#define MK_ANY		0
#define MK_RANGE	1
#define MK_COL		2
#define MK_ROW		3
#define MK_DESC		4
#define MK_CELL		5
#define MK_1DESC	6

#define MK_NOGOOD	(AOK+1)

/*
*	New marking scheme. Each cell highlighted is highlighted inside
*	the cell only. Based on its adjacents cells' state the mark for this
*	cell is extended on the top and/or left.
*	The area inside the cell is noted using the bit mask IS_MARKED.
*	the top extension is noted using MARK_TEXT
*	the left extension is noted using MARK_LEXT
*
*	During the marking process, some of the unused bits in the members
*	of SS.w->marked array are used temporarily. 
*
*
*  Note: the distinction between a extension and short extension is this.
*	if a cell has only one of its extensions, then it is a short extension.
*	if the cell has both extensions, one of the extension is longer than
*	other so that the horz/vertical extensions join corectly.
*/

/* Note: the drawing states are preceded by a D and are ephemeral only */

/* the following two are noted in the lower nibble of spl_flags local array */
#define DMARK_LEXT		0x0C	/* draw/erase left extension */
#define	DMARK_TEXT		0x03	/* draw/erase bot extension */
/* the upper nibble of spl_flags is used for noting the new marking state */
/* for this region */

#define DMARK_LSHEXT	0x04	/* draw short left extension */
#define DMARK_LSPLEXT	0x08	/* draw only special extension */
#define DMARK_TSHEXT	0x01	/* draw short top extension */

/* MARK_IT_NOW and MARK_PROCESSED are also ephemeral and are noted in the */
/* SS.w->marked */

/* MARK_IT_NOW tells that the area inside the cell should be highlighted */
/* in this display loop */
#define MARK_IT_NOW		0x02	/* this cell has to be marked now (base) */

/* MARK_PROCESSED tells that this region has been preprocessed by */
/* check_highlight */
#define MARK_PROCESSED	0x04	/* this mark has been processed */

#define MARK_LSHTEXT	0xB0	/* used for cleaing the top ext and */
								/* making the left extension short */




/* this is saved along with the mark */
#define	MARK_LEXT		0xC0	/* this mark contains left extension */
#define MARK_TEXT		0x30	/* this mark contains a top extension */
#define IS_MARKED		0x01	/* this region is marked */
#define MARK_LSHEXT		0x40	/* left extension is short */
#define MARK_TSHEXT		0x10	/* top extension is short */








/* theses are only masks to read stuff */

/* MARK_CHANGED tells if this regions extensions need to be drawn or erased */
/* during this display loop */
#define MARK_CHANGED	0x0F	/* (DMARK_REXT | DMARK_BEXT) */

/* this is the mask to read the new state for this region from the spl_flags */
/* array and put it to the SS.w->marked array */
#define MARK_LTEXT		0xF0	/* (MARK_LEXT | MARK_TEXT) */

#define NO_MARKS_VALUE	-999
