/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ss_style.h
   Applix ASC version: 23
   Date: Wed Nov 18 16:29:07 1998
*/
#define PNmREGULAR 0
#define PNmINTEGER 1

/* maximum exponent allowed by ParseNum */
#if PCS
#define MAX_EXPONENT 19.0
#else
#if VAX
#define MAX_EXPONENT 20.0
#else
#if THIMBLE
#define MAX_EXPONENT 306
#else
#define MAX_EXPONENT 25.0
#endif
#endif
#endif

#define SS_MAX_PREC	15
#define SS_MAX_DATE_PREC	20
/* horizontal alignment */
#define HALIGN_DEFAULT	0	/* default, left for text, right for numbers */
#define HALIGN_LEFT		1	/* left justfied */
#define HALIGN_RIGHT	2	/* right justified */
#define HALIGN_CENTER	3	/* center justified */	
#define HALIGN_REPEAT	4	/* repeat justified */	

/* vertical alignment */
#define VALIGN_DEFAULT	0	/* default */
#define VALIGN_TOP		1	/* top justfied */
#define VALIGN_CENTER	2	/* center justified */
#define VALIGN_BOT		3	/* bottom justified */	

#define TOTAL_BUILTIN_STYLES 17
/* number style */
#define SS_STL_BOOL			1	/* boolean */
#define SS_STL_GENERAL		2	/* general */
#define SS_STL_FIXED		3	/* fixed */
#define SS_STL_SCIENCE		4	/* scientific */
#define SS_STL_CURRENCY		5	/* currency */
#define SS_STL_COMMA		6	/* comma */
#define SS_STL_PERCENT		7	/* percent */
#define SS_STL_DATE			8	/* date */
#define SS_STL_GRAPH		9	/* graph */
#define SS_STL_TIME			10	/* time */
#define SS_STL_DEFAULT		11	/* default */
#define SS_STL_X			12	/* user defined format 1 */
#define SS_STL_Y			13	/* user defined format 2 */
#define SS_STL_CUSTOM 		14	/* custom style */
#define SS_STL_TEXT			15	/* text style */
#define SS_STL_GENERAL_NP 	16	/* general with max precision */

/* there are indices into the ZUSAstlStrings */
#define SS_LJUST_CHAR_IDX	SS_STL_TEXT
#define SS_RJUST_CHAR_IDX	(SS_STL_TEXT+1)	
#define SS_CJUST_CHAR_IDX	(SS_STL_TEXT+2)
#define SS_RPJUST_CHAR_IDX	(SS_STL_TEXT+3)
#define SS_PROT_CHAR_IDX	(SS_STL_TEXT+4)

#define	ULINE_OFF	0
#define ULINE_SINGLE 1
#define ULINE_DOUBLE 2
#define ULINE_WSINGLE 3
#define ULINE_WDOUBLE 4






/* first the "border" bits  */
#define TOP_BORDER     0x000000FF
#define BOT_BORDER     0x0000FF00
#define LEFT_BORDER    0x00FF0000
#define RIGHT_BORDER   0xFF000000

#define TB_SHIFT	0
#define	BB_SHIFT	8
#define LB_SHIFT	16
#define RB_SHIFT	24

#define	BORDER_STYLE		0xFF
#define BCOLOR	0xFF00
#define BCOLOR_SHIFT	0x8	/* shift to get the color for borders */

#define	BTHIN	1
#define BMEDIUM	2
#define BTHICK	3
#define BDASHED 4
#define BDBL_LINE 5

#define LTHIN	1
#define LMEDIUM	2
#define LTHICK	3

#define DEFAULT_FG_COLOR	0xFD
#define DEFAULT_BG_COLOR	0xFE

#define SHADE_COLOR_MASK	0xff00
#define SHADE_COLOR_SHIFT	8		
#define SHADE_FG_MASK		0xf0	/* after shift color */
#define SHADE_BG_MASK		0x0f	/* after shift color */
#define SHADE_FG_SHIFT		4		
#define SHADE_BG_SHIFT		0

#define SHADE_STYLE_MASK	0x00ff	

/* this is the 20th shading button in the borders dialog box */
#define SS_ELF_SHADING_NONE		19

/* these the are the shading styles used by the spreadsheet */
#define SS_SHADING_NONE			0
#define SS_SHADING_FILL_A		1	
#define SS_SHADING_FILL			2	
#define SS_SHADING_FILL_M		3	
#define SS_SHADING_FILL_B		4	
#define SS_SHADING_FILL_C		5	
#define SS_SHADING_FILL_D		6	
#define SS_SHADING_FILL_N		7	
#define SS_SHADING_FILL_E		8	
#define SS_SHADING_FILL_F		9	
#define SS_SHADING_FILL_G		10	
#define SS_SHADING_FILL_H		11
#define SS_SHADING_FILL_I		12
#define SS_SHADING_FILL_J		13
#define SS_SHADING_FILL_K		14
#define SS_SHADING_FILL_L		15
#define SS_SHADING_FILL_O		16
#define SS_SHADING_FILL_P		17
#define SS_SHADING_FILL_Q		18
#define SS_SHADING_FILL_R		19
#define SS_SHADING_LINEAR_GRADIENT		20
#define SS_SHADING_RADIAL_GRADIENT		21
#define SS_SHADING_RECT_GRADIENT		22
#define SS_SHADING_USER_DEFINED			23

#define HORZ_BORDER		0x0000FFFF /* TOP_BORDER | BOT_BORDER */
#define VERT_BORDER		0xFFFF0000 /* LEFT_BORDER | RIGHT_BORDER */



#define BORDER_MASK 0x1000

/* Next the String Function Identifier */
#define STR_FUNC 0x0100

/* Tag a cell that its back pointers were removed, because an ERR token */
/* put into the cell as a result of cell going off the grid or being */
/* deleted during a delete row/col or insert row/col operation */
#define BKPTRS_REMOVED  0x0020



#include <gstyle.h>
