/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ssfunc.h
   Applix ASC version: 9
   Date: Mon Nov 16 13:57:08 1998
*/
#ifndef SSFUNC_INCL	/* { */
#define SSFUNC_INCL

#ifdef AX_USE_PROTOS
#define AXP_(body) body
#else
#define AXP_(body) ()
#endif

/*===========================================================================*/
/*		SS Time definition												     */
/* 1/(num seconds in 24 hours * 1000)  */
#define	SS_TIME_GRANULE	(double)(1.0/(24*60*60 * 1000)) 
struct ss_time_struct {
short hour; /* hour 0-23 */
short min;  /* min  0-59 */
short sec;  /* second 0-59 */
short tsec; /* thousands of a second 0-999*/
};

typedef struct ss_time_struct   SS_TIME_STRUCT;

#define HOURFACTOR	(3600*1000)
#define MINFACTOR	(60*1000)
#define	SECFACTOR	(1000)

#define   MAX_DATE 109939	/* Dec 31, 2200 */
#define   MIN_DATE 1        /* Jan 1, 1900 */
#define   SS_IS_VALID_DATE(x)	((x >= MIN_DATE) && (x <= MAX_DATE))
/*===========================================================================*/

double ssToday AXP_((int *));
double TimeBuild AXP_(());
double ssNow AXP_((int *));
double ssYear AXP_((double, int *));
double ssMonth AXP_((double, int *));
double ssTime AXP_((double, double, double, int *));
double ssHour AXP_((double, int *));
double ssMinute AXP_((double, int *));
double ssSecond AXP_((double, int *));
double ssDay AXP_((double, int *));
double ssDate AXP_((double, double, double, int *));
double ssAddDays AXP_((double, double, int *));
double ssAddMonths AXP_((double, double, int *));
double ssAddYears AXP_((double, double, int *));
double ssAddHours AXP_((double, double, int *));
double ssAddMinutes AXP_((double, double, int *));
double ssAddSeconds AXP_((double, double, int *));
DLL_EXPORT double ssExp AXP_((double));
double ssPower AXP_(( double, double, int *));
double ssRound AXP_(( double, double, int *));
double ssPi AXP_(( void));


double int_part AXP_((double));
double TimeBuild AXP_((SS_TIME_STRUCT *ts));
#endif	/* } SSEDIT_INCL */
