/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: sysdep.h
   Applix ASC version: 9
   Date: Mon Nov 16 13:57:03 1998
*/
#define SPL_SAFE -1.000000001E+306 /* a bit of fail safe */
#define SPL_MINSAFE	1.0E-306

/*** all the SPL_* are explicitly type casted as double due to porting 
problems faced on UNIVEL platforms -vikas 02/28/94
****/
#if 0 /**** { ***/


#define SPL_FLAG	((double)((2)*(SPL_SAFE)))/*function begins flag*/
#define SPL_STYLE	((double)((3)*(SPL_SAFE)))/* style info held in elf 
							array */
#define SPL_ELF		((double)((4)*(SPL_SAFE)))/* data held in elf array */
#define SPL_TEXT	((double)((5)*(SPL_SAFE)))/* text */
#define SPL_RANGE	((double)((6)*(SPL_SAFE)))/* range */
#define SPL_ADDR	((double)((7)*(SPL_SAFE)))/* quoted cell addr */
#define SPL_ERROR	((double)((8)*(SPL_SAFE)))/* error cell value */
#define SPL_NA		((double)((9)*(SPL_SAFE)))/* NA cell value */
#define SPL_CIRCULAR	((double)((10)*(SPL_SAFE)))/* CIRC cell value */
#define SPL_PENDING	((double)((11)*(SPL_SAFE)))/* PENDING cell value */
#define SPL_EMPTY	((double)((12)*(SPL_SAFE)))/* EMPTY cell value */
#define SPL_INVALID	((double)((13)*(SPL_SAFE)))/* INVALID cell value */
#define SPL_FLOAT	((double)((14)*(SPL_SAFE)))/*floating point exception*/
#define SPL_FEWARGS	((double)((15)*(SPL_SAFE)))/*too few args for function*/
#define SPL_FBOUNDS	((double)((16)*(SPL_SAFE)))/* function's args not good 
							values */
#define SPL_FUNCODD	((double)((17)*(SPL_SAFE)))/* function correctly ret'd 							error */
#define SPL_NUMERR	((double)((18)*(SPL_SAFE)))/*force an error thru */
#define SPL_FCIRCULAR	((double)((19)*(SPL_SAFE)))/*force a circularity thru */
#define SPL_NOTHING    	((double)((20)*(SPL_SAFE)))/* don't display any result*/
#define SPL_DIVZERO	((double)((21)*(SPL_SAFE)))/* div by zero error */
#define	SPL_TYPERR	((double)((22)*(SPL_SAFE)))/* numeric arg 
							for a string func */
#define SPL_REFERR	((double)((23)*(SPL_SAFE)))/* reference to
							 deleted cells etc */
#define SPL_UDEFNAME	((double)((24)*(SPL_SAFE)))/* invalid named range */
#define SPL_ARGCOUNT	((double)((25)*(SPL_SAFE)))/*invalid # of arguments */
#define SPL_FAILERR	((double)((26)*(SPL_SAFE)))/* function failed */
#define SPL_DBERR1	((double)((27)*(SPL_SAFE)))/* invalid db */
#define SPL_DBERR2	((double)((28)*(SPL_SAFE)))/* invalid criteria */
#define SPL_DBERR3	((double)((29)*(SPL_SAFE)))/*invalid data in a column*/
#define SPL_LAST	((double)((29)*(SPL_SAFE)))



#else  /*** } { ***/

#define SPL_FLAG		(-2.000000001E+306) 	/*function begins flag*/
#define SPL_STYLE		(-3.000000001E+306)		/*style info held in elf array */
#define SPL_ELF			(-4.000000001E+306)		/*data held in elf array */
#define SPL_TEXT		(-5.000000001E+306)		/*text */
#define SPL_RANGE		(-6.000000001E+306) 	/*range */
#define SPL_ADDR		(-7.000000001E+306)		/*quoted cell addr */
#define SPL_ERROR		(-8.000000001E+306)		/*error cell value */
#define SPL_NA			(-9.000000001E+306)		/*NA cell value */
#define SPL_CIRCULAR 	(-10.000000001E+306)	/*CIRC cell value */
#define SPL_PENDING		(-11.000000001E+306)	/*PENDING cell value */
#define SPL_EMPTY		(-12.000000001E+306)	/*EMPTY cell value */
#define SPL_INVALID		(-13.000000001E+306)	/*INVALID cell value */
#define SPL_FLOAT		(-14.000000001E+306)	/*floating point exception*/
#define SPL_FEWARGS		(-15.000000001E+306)	/*too few args for function*/
#define SPL_FBOUNDS		(-16.000000001E+306)	/*function's args not good values*/
#define SPL_FUNCODD		(-17.000000001E+306)	/*function correctly ret'd	error*/
#define SPL_NUMERR		(-18.000000001E+306)	/*force an error thru */
#define SPL_FCIRCULAR	(-19.000000001E+306)	/*force a circularity thru */
#define SPL_NOTHING    	(-20.000000001E+306)	/*don't display any result*/
#define SPL_DIVZERO		(-21.000000001E+306)	/*div by zero error */
#define	SPL_TYPERR		(-22.000000001E+306)	/*numeric arg for a string func */
#define SPL_REFERR		(-23.000000001E+306)	/*reference to deleted cells etc */
#define SPL_UDEFNAME	(-24.000000001E+306)	/*invalid named range */
#define SPL_ARGCOUNT	(-25.000000001E+306)	/*invalid # of arguments */
#define SPL_FAILERR		(-26.000000001E+306)	/*function failed */
#define SPL_DBERR1		(-27.000000001E+306)	/*invalid db */
#define SPL_DBERR2		(-28.000000001E+306)	/*invalid criteria */
#define SPL_DBERR3		(-29.000000001E+306)	/*invalid data in a column*/
#define SPL_LAST		(-29.000000001E+306)	/*LAST ONE */

#endif /**** } ***/

#define MAX_SHORT 32767

#if ALPHA
#define INT_SHIFT 3
#else
#define INT_SHIFT 2
#endif

#define INTCPY(a,b,c) anycpy(a,b,(c)<<INT_SHIFT)

/* Number of decimal digits of precision */

#define PREC_SYSDEP 15

