/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: ax_des.h
   Applix ASC version: 3
   Date: Thu Mar  4 21:15:44 1999
*/
#ifndef AX_DES_H

#define AX_DES_H 1

#define KEY_LEN 64

typedef struct key_tables {
	unsigned int current_saltbits;
	char salt[3];

	unsigned int pc1_table[8][2][128];
	unsigned int pc2_table[8][128];
	unsigned int eperm32tab[4][256][2];
	unsigned int efp[16][64][2];
	int e_inverse[64];

	unsigned int sb0[8192];
	unsigned int sb1[8192];
	unsigned int sb2[8192];
	unsigned int sb3[8192];
} key_tables;

typedef struct key_ring {
	unsigned int encrypt_key[16][2];
	unsigned int decrypt_key[16][2];
	char key_str[KEY_LEN];
} key_ring;
#endif
