/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axfs.c
   Applix ASC version: 106
   Date: Fri May 14 21:13:34 1999
*/
#define NO_APX_INTERNATIONAL 1


#include <stdio.h>
#if X386_NEW
#include <stdlib.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <aos.h>
#include <fsrts.h>
#include <afsjnk.h>
#include <afile.h>
#include <ctype.h>
#include <getstr10.h>
#include <getstr4.h>
#include <getstr5.h>
#include <getstr7.h>
#include <errno.h>
#include <setjmp.h>
#include <paripc.h>
#include <scac.h>
#include <thimble.h>
#include <adocio.h>
#include <adlgpoke.h>
#include <fs_save.h>
#include <afileimg.h>
#include <signal.h>

#if SYSV4 || LINUX
#include <unistd.h>
#endif

#include <tmi.h>
#include <paratm.h>
#include <parint.h>
#include <aiconids.h>
#include <doctypes.h>

extern elfData AxElfCallProgram();
extern elfData AxCallAxMain();
extern double UPdblVal();

#define Astreq(a,b) (Astrcmp(a,b) == 0)

extern char *DirSlash;
extern char ThimTempDir[STRPATH+1];
extern char *AxSocketName;

extern char *Amktemp();

extern char *ThimTextSfx;
extern char *ThimSprdSfx;

/* Newly in winxfer.c */
extern doc_info *FindDocStruct();
extern void DfltSetupsToDoc(/*DocInfoType *infoP;*/);

#if !FOR_VERSION_FILTERS    /* Filters only need last few fcns - DHM 9/94 { */

#if 0
#define LOGGER(body) if (1) THIMlog body
#else
#define LOGGER(body)
#endif


#define SYS5_STRDOCNAME 14

extern int AxShortNames;    /* Use SYS5_STRDOCNAME; see axatmrt/tmdispat.c */
extern int AxShellWaiting;
extern int AxHaveShellServer;   /* true if can pipe to out command server */

extern short THIMpid;

extern long FSrfDocCounter;
extern DocInfoType FSrfDoc;
extern ks_entry *FSrfDocKS;


static char KsRefDocStr[] = NXLT("Doc Reference");
static char KsLinkDataStr[] = NXLT("Doc Link Data");


typedef struct ks_file {
    struct ks_file *next;   /* next in thread */
    ks_entry *entries;  /* head of ks entry pairs */
    int changed;        /* TRUE if stuff added/removed */
    char name[STRPATH+1];   /* filename of the KS file */
} ks_file;

static ks_file CurrKS;          /* Current FS kitchen sink file */
static ks_file *KSfiles;        /* List of all KS files */

char *MatNames[] = {
    NXLT("None"),
    NXLT("Database"),
    NXLT("Spreadsheet"),
    NXLT("Calculator"),
    NXLT("Graph"),
    NXLT("Picture"),
    NXLT("Text"),
    NXLT("External"),
    NXLT("Command"),
    NXLT("Calendar"),
    NXLT("Query"),
    NXLT("UDF"),
    NXLT("FSTable"),
    "",
    "",
    "",
    "",
    NXLT("Equation"),
    NXLT("ApplixBuilder"),
    NULL
};

extern doc_info *DocList;       /* Head of documents list */
static char SetupsFile[] = NXLT("Setups");
static long SetupsDtmod;    /* when file was last written */
static char PrntFile[] = NXLT("Printers");
ks_entry *PrntInfoP;    /* head of KS for printing info */

FSLocType FSNullLoc = {
    "", FSNULL, FSNULL, FSNULL, FSNULL};

DocInfoType FSNullDoc;

char *FSNameLastCreated[STRPATH+1]; /* Hack for local insets - see dc/CMenu.c */

short FSCabIsShared;    /* always false */
short FSIsLocal = TRUE;

doc_info *DocPtr();
extern char *GetFromKS(), *NeedFromKS(), *FSKSLookup(), *ThimSfxFromType(), *DocPath();
extern char *xGetFromKS();
extern typeErr IsValidPathFilename(), KSAdd(), ErrnoErr();
extern typeErr ThimDcInfoFromPath() , FSThimGtDcInfo(), FSRegisterDoc(), getStr();
extern doc_info *DocPtrFromPathname();

char *AxCreateTempfile AXP_((char *proto_name));
mbchar *UPbyName ();
void ClipDocSuffix();

extern short *clip1fromShorts();

static typeErr FSDoOpenDocument (/*char *name;int mode;DocInfoType *infoP;int forceFlag; type*/);



/*************************************************************************
function: FSGetInternalRefname - Return the refname exactly as in KS data
*/
char *FSGetInternalRefname (DocInfoP,VirtualId)
DocInfoType *DocInfoP;  /* referencer */
long VirtualId;
{
    register char *pathname;
    char refname[STRPATH+1];

    sprintf(refname,"%s %d",KsRefDocStr,VirtualId);
    return(FSKSLookup(DocInfoP,refname));
}

/*************************************************************************
function: FSGetRefLinkData - get link data associated with this doc reference
*/
char *QQFSGetRefLinkData (DocInfoP,VirtualId)
DocInfoType *DocInfoP;  /* referencer */
long VirtualId;
{
    register char *pathname;
    char refname[STRPATH+1];

    sprintf(refname,"%s %d",KsLinkDataStr,VirtualId);
    return(FSKSLookup(DocInfoP,refname));
}

/*************************************************************************
function: FSGenName - Create a name for a doc to be created "nameless"
*/
char *FSGenName (starter)
char *starter;      /* Sheet.as .. Grafix.ag... */
{
    static char pathname[STRPATH+1];
    char entryname[STRPATH+1];
    char dir[STRPATH+1];
    char doc_suffix[50];
    doc_info *p;
    DocInfoType doc;
    int cnt = 0;
    char *cp;

    cp = strrchr(starter,'.');
    if ( !cp )
        return("");
    strcpy(doc_suffix,cp);
    strcpy( pathname, starter );
    ParsePath(pathname,dir,entryname);
    for ( cnt = 0; TRUE; cnt++ ) {
        if ( cnt != 0 ) {
            ClipDocSuffix(entryname);
            if ( streq(dir,DirSlash) )  /* avoid "//foo.ag" */
                sprintf(pathname,"%s%s%d%s",DirSlash,entryname,cnt,doc_suffix);
            else
                sprintf(pathname,"%s%s%s%d%s",dir,DirSlash,entryname,cnt,doc_suffix);
        }
        LoadRef(pathname,&doc);
        p = doc.sysFileId;
        if ( !p->owner && (-1 == Aaccess(pathname,0)) )
            break;
    }
    return(pathname);
}

/*************************************************************************
function: FSFindDoc - Find doc by name, set info struct
Return AOK if doc exists and is accessable, else error status.
*/
typeErr
FSFindDoc (name,infoP,mode)
char *name;
DocInfoType *infoP;
int mode;       /* file access mode */
{
    char pathname[STRPATH+1];
    strcpy(pathname, name); /* was AbsolutifyPathname(pathname,name,TRUE); */
    LoadRef(pathname,infoP);
    if ( Aaccess(pathname,mode) == -1 )
        return(ErrnoErr());
    return(AOK);
}

/*************************************************************************
function: FSGtDcInfo - Get info from a name
REAL SIMILAR TO FSFINDDOC!
*/
typeErr FSGtDcInfo (passed_name,doindex,wid,docP,locP)
int doindex,wid;/*ignored */
char *passed_name;      /* may be a path */
DocInfoType *docP;
FSLocType *locP;
{
    typeErr err;

    if ( AOK != (err = FSFindDoc(passed_name,docP,0)) )
        return(err);
    strcpy(locP->CabName,docP->pathname);
    locP->DrawerId=locP->FolderId=locP->SectionId=locP->SubsectionId=FSNULL;
    return(AOK);
}

/*************************************************************************
function: LoadRef - Set referred flag and load info struct
*/
LoadRef (pathname,infoP)
char *pathname;
DocInfoType *infoP;
{
    char junk[STRPATH+1];
    char docname[STRPATH+1];
    register doc_info *p;

    p = FindDocStruct(pathname);

    memset(infoP,0,sizeof(*infoP));
    strcpy(infoP->pathname,pathname);
    infoP->DocId = p->id;
    infoP->sysFileId = p;
    infoP->DocMatType = p->type = DocTypeFromName(pathname);
    ParsePath(pathname,junk,docname);
    ClipDocSuffix(docname);
    strcpy(infoP->DocName,docname);
}

/*************************************************************************
function: FSGetVirtIdForSS - Get virtual doc id from referenced doc infoP
*/
typeErr FSGetVirtIdForSS (DocInfoP,LockFlag,RDocInfoP,VirtualId)
IN DocInfoType *DocInfoP;  /* referencer */
short LockFlag; /* ignore */
IN DocInfoType *RDocInfoP; /* referenced */
OUT long *VirtualId;        /* result virtual id */
{
    char *p;
    char name[STRPATH+1];

    sprintf(name,"%s.%s",RDocInfoP->DocName,
                        ThimSfxFromType(RDocInfoP->DocMatType));
    *VirtualId = FSKSLookupDocByName(DocInfoP,name);
    if ( *VirtualId == -1 )
        return(FEENOENT);
    return(AOK);
}
/*************************************************************************
function: FSKSValueLookup - Lookup a value in this doc's KS file
Return KS field NAME. Returns NULL if entry not found.
*/
int FSKSLookupDocByName (infoP,value)
DocInfoType *infoP;
char *value;        /* value of field */
{
    register ks_entry *ks = infoP->ksData;
    int len = strlen(KsRefDocStr);

    while ( ks ) {
        if ( (0 == strncmp(KsRefDocStr,ks->name,len)) && 
            streq(value,ks->value) ) {
            return(atoi(ks->name+len+1));
        }
        ks = ks->next;
    }
    return(-1);
}



/*************************************************************************
function: FSStRfFlg - No op (may one day be used by DC)
*/
typeErr FSStRfFlg (){return(AOK);}
/*************************************************************************
function: FSGtRfFlg - No op (may one day be used by DC)
*/
typeErr FSGtRfFlg (){return(AOK);}

/*************************************************************************
function: FSGetDir - Fidn where a doc exists
*/
typeErr FSGetDir (docP,rootname)
DocInfoType *docP;
char *rootname;
{
    sprintf(rootname,"%s%s1",docP->pathname,DirSlash);
    return(AOK);
}

/*************************************************************************
function: FSGetDirs - Find where a doc exists
*/
typeErr FSGetDirs(docP,rootname,hackstr,hacklongP)
DocInfoType *docP;
char *rootname;
char *hackstr;
long *hacklongP;
{
    *hackstr = 0;
    *hacklongP = FSNULL;
    sprintf(rootname,"%s%s1",docP->pathname,DirSlash);
    return(AOK);
}
/*************************************************************************
function: FSAbleToOpen - Return whether a doc is locked
Needed only for opening local insets.
*/
typeErr FSAbleToOpen (DocInfoP)
DocInfoType *DocInfoP;
{
    doc_info *p;

    p = DocInfoP->sysFileId;
    if ( p->owner )
        return(FEalreadyOpen);
    return(AOK);
}

/*************************************************************************
function: FSDelDoc - Delete a document
*/
typeErr FSDelDoc (DocInfoP)
register DocInfoType *DocInfoP;
{
    doc_info *p = DocInfoP->sysFileId;
    
    if ( 0 == unlink(p->pathname) )
        TmPokeDialogs(0, POKE_DELETE_FILE,p->pathname);
    return(AOK);
}

/*************************************************************************
function: FSSetInternalRefname - Change the reference name
*/
typeErr FSSetInternalRefname (DocInfoP,VirtualId,newname)
DocInfoType *DocInfoP;  /* referencer */
long VirtualId;
char *newname;
{
    char refname[STRPATH+1];
    char refstr[STRNORMAL];

    sprintf(refname,"%s %d",KsRefDocStr,VirtualId);
    FSKSAdd(DocInfoP,refname,newname);
    return(AOK);
}

/*************************************************************************
function: FSSetRefLinkData - store link data for referenced docuement
*/
typeErr FSSetRefLinkData (DocInfoP,VirtualId,linkData)
DocInfoType *DocInfoP;  /* referencer */
long VirtualId;         /* reference id */
char *linkData;         /* new data */
{
    char refstr[STRPATH+1];

    sprintf(refstr,"%s %d",KsLinkDataStr,VirtualId);
    FSKSAdd(DocInfoP,refstr,linkData);
    return(AOK);
}




/*************************************************************************
function: FSOKToDelete - Returns whether doc can be deleted by this pid
*/
typeErr FSOKToDelete (DocInfoP)
DocInfoType *DocInfoP;
{
    int hostPid;
    int hostAppid;

    /* all non parasites can be deleted */
    hostPid = ThimGetHostTask(THIMpid);
    if ( hostPid <= 0 )
        return ( AOK );
    
    hostAppid = AxAppidFromPid(hostPid);

    /* bg's can also be deleted (parent is SS/112 ) */
    if ( hostAppid == APSS )
        return ( AOK );

    /* Allow deletion of WP's child docs.  Embedded objects in
     * the WP cannot be deleted, but that is checked in each app. */
    else if ( hostAppid == APDC )
        return ( AOK );

    /* no other parasites can be deleted (what's left?) */
    else
        return(FENoDelLocal);
}

#ifndef AX_MAX_FILENAME1
#define AX_MAX_FILENAME1 255
#endif
#ifndef FEINVALCHARS
#define FEINVALCHARS FEBadName
#endif

/*************************************************************************
function: IsValidPathFilename - validata a full path to a document
          returns:  AOK or string file error code
**********************************************************************/
typeErr IsValidPathFilename(file_path)
register char *file_path;
{
    register int ch;
    register int len = 0;
    char *temp_path, *p;
    char path[STRPATH+1], file_entry[AX_MAX_FILENAME1+1];
    int max_len, file_len;
    static mbchar *invalid_chars = (mbchar *)NULL;
    int count;

    len = strlen(file_path);
    if ( len > STRPATH )
        return(FEtooLong);
    if ( invalid_chars == (mbchar *)NULL )
        {
        /* first time initialize invalid charas.  This is either a user */
        /* specified profile value, or is a hard coded string */
        invalid_chars = UPbyName( NXLT("axInvalidFileChars") );
        if ( invalid_chars == (mbchar *)NULL )
            /* no profile entry, use the hard coded defaults */
#if AXMS
            invalid_chars = (mbchar *)NXLT("<>*?\t\"[]^~&!$|");
#else
            invalid_chars = (mbchar *)NXLT("<>*?\t\"[]^~&!$|");
#endif
        }

    temp_path = file_path;
    /* check for invalid characters */
    while ( ch = *temp_path++ ) 
        {
    if ( MBstrchr( invalid_chars, ch) != (mbchar *)NULL )
            return( FEINVALCHARS );
        }

    /* Check against number of chars allowed by OS */
    /* Most OS's allow long filenames but we also have to check  */
    /* a profile variable to see if we need to restrict the length of  */
    /*  the filenames to SYS5 limits (14); e.g. if the user is mounting  */
    /*  a SYS5 file system on a 'long' filename system                 */
    ParsePath(file_path,path,file_entry);
    max_len = ElfbGetMaxFileLength( path );
    file_len = strlen(file_entry);
    if ((AxShortNames && (file_len > SYS5_STRDOCNAME)) || (file_len > max_len))
        return(FEtooLong);

    return(AOK);
}

/*************************************************************************
function: FSPreOpen - No op
*/
typeErr FSPreOpen (p)
DocInfoType *p;
{
    return(AOK);
}

/*************************************************************************
function: FSITouch - Touch the KS file to update datestamp
What is this supposed to do?
*/
FSITouch ()
{
    return(AOK);
}


/*************************************************************************
function: FSGtDcName - Get doc name from doc struct
*/
typeErr FSGtDcName(docP,str)
DocInfoType *docP;
char *str;
{
    strcpy(str,docP->DocName);
    return(AOK);
}

/*************************************************************************
function: FSCCtAndCpyDoc - Copy doc from app
*/
typeErr FSCCtAndCpyDoc ()
{
    return(FEnoCopyimplemented);
}

/*************************************************************************
function: FSStartRefDocScan - begin incrementing thru referenced documents
This assumes that OpenDocumentFile has been called for the reference.
This should probably be in fs_private! ??x
*/
FSStartRefDocScan (infoP)
DocInfoType *infoP;
{
    register typeErr code;

    FSrfDocCounter = -1;
    FSrfDoc = *infoP;
    FSrfDocKS = infoP->ksData;
    return(AOK);
}

/*************************************************************************
function: FSDtLastMod - Return last mod time of a doc
This does not cache the dtmod because we would like to be able to handle
the case where User-2 changes an ISR/Inset referenced by User-1's document.
*/
typeErr FSDtLastMod (fsp,dtmodP)
DocInfoType *fsp;
long *dtmodP;
{
    struct stat status;
    doc_info *p;

    p = fsp->sysFileId;
    if ( 0 == stat(p->pathname,&status) )
        p->dtmod = status.st_mtime;
    else
        p->dtmod = 100;     /* a long time ago! */
    *dtmodP = p->dtmod;
}




#if 0
typeErr FSGetMetaDoc (DocInfoP,MDocKind,MDocInfoP)
DocInfoType * DocInfoP, * MDocInfoP;
int MDocKind;
{

    *MDocInfoP = FSNullDoc;
    return(AOK);
}


UnixTimeToAlisTime(x) 
int x;
{
return(x);      /* ??x perofrm work here! */
}
#endif






THIMlog(a,b,c,d,e,f,g,h,i,k)
char *a;
int b,c,d,e,f,g,h,i,k;
{
    static FILE *fp;

    if ( !fp )
        fp = fopen(NXLT("zz.log"),"w");
    fprintf(fp,a,b,c,d,e,f,g,h,i,k);
    fprintf(fp,"\n");
    fflush(fp);
}

/*************************************************************************
function: FreeKSlist - Free memory assocated with a KS style file
*/
FreeKSlist (p)
register ks_entry *p;
{
    register ks_entry *next;

    while ( p ) {
        next = p->next;
        free(p->name);
        free(p->value);
        free(p);
        p = next;
    }
}

/*************************************************************************
function: docSetupInfo - Return info about a line in the setups file
*/
typeErr docSetupInfo (infoP,name,class,number,height,width,left_ofs,top_ofs,
                    p1_org,even_org,odd_org,orient,date)
IN DocInfoType *infoP;
IN char *name;  /* name of setup to look up */
OUT char *class;    /* printer class, assumed to be STRNORMAL+1 buf */
OUT short *number;  /* setup number */
OUT short *height, *width;  /* paper dimensions */
OUT short *left_ofs, *top_ofs;/* margin offsets */
OUT short *p1_org, *even_org, *odd_org; /* paper access 0-4 */
OUT short *orient;  /* 0-portrait, 1-landscape */
OUT long *date; /* date KS last modded */
{
    extern DocInfoType FSOverrideSetupDoc;

    if ( FSOverrideSetupDoc.DocId )
        infoP = &FSOverrideSetupDoc;
    if ( !FSKSLookup(infoP,SETUP_CLASS_STR) )
        DfltSetupsToDoc(infoP);
    strcpy(class,FSKSLookup(infoP,SETUP_CLASS_STR));
    *number = atoi(FSKSLookup(infoP,SETUP_NUMBER_STR));
    *height = atoi(FSKSLookup(infoP,SETUP_HEIGHT_STR));
    *width = atoi(FSKSLookup(infoP,SETUP_WIDTH_STR));
    *left_ofs = atoi(FSKSLookup(infoP,SETUP_LEFT_OFS_STR));
    *top_ofs = atoi(FSKSLookup(infoP,SETUP_TOP_OFS_STR));
    *p1_org = atoi(FSKSLookup(infoP,SETUP_P1_ORG_STR));
    *even_org = atoi(FSKSLookup(infoP,SETUP_EVEN_ORG_STR));
    *odd_org = atoi(FSKSLookup(infoP,SETUP_ODD_STR));
    *orient = atoi(FSKSLookup(infoP,SETUP_LANDSCAPE_STR));
    *date = atoi(FSKSLookup(infoP,SETUP_TIME_STR));
    return(AOK);
}

FSIArchivedDoc()
{
    return(FALSE);
}
typedef struct {
    char name[10];
    char **strs;
} index_data_block;


typeErr FSHasSigs (DocInfoP,DoClosure,HasSigsP)
DocInfoType *DocInfoP;
short DoClosure;
short * HasSigsP;
{
    *HasSigsP = FALSE;
    return(AOK);
}

typeErr FSSign (
    IN DocId,                   /* The ID of the document to be signed
                                   (Must reside in the current cabinet)
                                 */
    IN Signer,                  /* The registry-qualified name of the
                                   signer */
    IN SigId,                   /* A unique number which identifies
                                   the signature, or FSNULL if this
                                   is a material type which can
                                   only be signed once */
    IN Title,                   /* The title the user wishes to sign with */
    OUT SigFlagChangedP)    /* Did the doc hdr's signature flag change? */

long DocId;
char * Signer;
long SigId;
char * Title;
short * SigFlagChangedP;
{
    SigFlagChangedP = FALSE;
    return(AOK);
}

typeErr FSNdsLcl (  
    IN DocId,       /* The ID of the doc which
               may need a localization.
                   Must reside in current cabinet */
    OUT NeedsLocalizeP) /* Indication of whether the doc
               needs to be localized.
               (TRUE means it does)
             */

long DocId;
short * NeedsLocalizeP;
{
    *NeedsLocalizeP = FALSE;
    return(AOK);
}

/*************************************************************************
function: FSChangeSetup - Chnage doc's setup
*/
typeErr FSChangeSetup (infoP,height,width,landscape,p1,even,odd)
DocInfoType *infoP;
int height,width;
int landscape,p1,even,odd;
{
    char temp[100];

    if((height <= 0) || (height > 32000))
        return(ERR_BADHEIGHT);  /* must be between 0 and 32 inches */
    if((width <= 0) || (width > 32000))
        return(ERR_BADWIDTH);   /* must be between 0 and 32 inches */

    sprintf(temp,"%d",height);
    FSKSAdd(infoP,SETUP_HEIGHT_STR,temp);
    sprintf(temp,"%d",width);
    FSKSAdd(infoP,SETUP_WIDTH_STR,temp);
    sprintf(temp,"%d",p1);
    FSKSAdd(infoP,SETUP_P1_ORG_STR,temp);
    sprintf(temp,"%d",even);
    FSKSAdd(infoP,SETUP_EVEN_ORG_STR,temp);
    sprintf(temp,"%d",odd);
    FSKSAdd(infoP,SETUP_ODD_STR,temp);
    sprintf(temp,"%d",landscape);
    FSKSAdd(infoP,SETUP_LANDSCAPE_STR,temp);
    sprintf(temp,"%d",time(0L));
    FSKSAdd(infoP,SETUP_TIME_STR,temp);
    return(AOK);
}



/*************************************************************************
function: FSSaveFileToDisk - Write the document
*/
typeErr FSSaveFileToDisk (infoP)
DocInfoType *infoP;
{
    typeErr FSSaveRevFileToDisk();

    return ( FSSaveRevFileToDisk (infoP, 2) );
}

/*************************************************************************
function: FSSaveRevFileToDisk - Write the document with revstamp control
*/
typeErr FSSaveRevFileToDisk (infoP, revID)
DocInfoType *infoP;
int revID;
{
register doc_info *p;
register typeErr err;
int ix;
struct stat status;
int DemoMode=FALSE;

    p = infoP->sysFileId;

    if ( AOK != (err = SaveDocumentFile(infoP, revID)) )
        return(err);

    infoP->onDisk = TRUE;
    stat(infoP->pathname,&status);
#if 0
    p->dtmod = UnixTimeToAlisTime(status.st_mtime);
#else 
    p->dtmod = status.st_mtime;
#endif

/* sent docmod notifies */

notify_users:
    FSPokeDocInterested(infoP);
    return(AOK);
}


/*************************************************************************
function: ElfbDemoMode - Return whether sofware in demo mode
*/
ElfbDemoMode ()
{
/* function no longer used */
}


/*************************************************************************
function: FSFrcSaveFileToDisk - Write the document
*/
typeErr FSFrcSaveFileToDisk (infoP)
DocInfoType *infoP;
{
    register doc_info *p;
    register typeErr err;
    int ix;
    struct stat status;


    p = infoP->sysFileId;

    if ( AOK != (err = SaveDocumentFile(infoP,2)) )
        return(err);

    infoP->onDisk = TRUE;
    stat(infoP->pathname,&status);
#if 0
    p->dtmod = UnixTimeToAlisTime(status.st_mtime);
#else
    p->dtmod = status.st_mtime;
#endif

/* sent docmod notifies */

notify_users:
    FSPokeDocInterested(infoP);
    return(AOK);
}

/*************************************************************************
function: FSPokeDocInterested - Send message to tasks decalring interest in doc
*/
FSPokeDocInterested (infoP)
DocInfoType *infoP;
{
    register doc_info *p;
    scac_message_info msg;
    int have_sent_msg[MAX_PIDS];    /* pids that have been notified */
    int pid;
    int ix;
    data_ptr filename;

{       /* !0 for now, send a message to all WP's */
    for ( ix = 0; ix < MAX_PIDS; ix++ ) {
        if ( TaskInfo[ix].in_use && 
            (TaskInfo[ix].appid == APDC ||
             TaskInfo[ix].appid == APGE ||
             TaskInfo[ix].appid == APSS) ) {

            msg.type = AC_DOCMOD;
            memcpy(msg.buf,infoP,sizeof(*infoP));
            IPCXsendMes(IPC_SRT,ix,&msg,sizeof(msg),APAC,0);
        }
    }
}
    p = infoP->sysFileId;
    memset(have_sent_msg,0,sizeof(have_sent_msg));
    for ( ix = 0; ix < p->num_lookers; ix++ ) {
        pid = p->lookers[ix];
        if ( have_sent_msg[pid] )
            continue;       /* don't double msg */
        msg.type = AC_DOCMOD;
        memcpy(msg.buf,infoP,sizeof(*infoP));
        IPCXsendMes(IPC_SRT,pid,&msg,sizeof(msg),APAC,0);
        have_sent_msg[pid] = TRUE;
    }

    /* poke interested dialogs */
    filename = AxMakeStrData(-1,infoP->pathname);
    XmPoker(POKE_DOC_MODIFIED,filename,NULL,TRUE,TRUE);
    AxFreeData(filename);
}

/*************************************************************************
function: FSPokeDocInterested - Send message to tasks decalring interest in doc
*/
FSPokeAll(pathname, msgtype)
char *pathname; /* name of document thats being saved */
int msgtype;
{
    int ix;
    scac_message_info msg;
    data_ptr filename;
    int *taskList;
    data_ptr uidP;

    msg.type = msgtype;
    memcpy(msg.buf, pathname, strlen(pathname)+1);

    for ( ix = 0; ix < MAX_PIDS; ix++ ) 
        {
        if ( TaskInfo[ix].in_use && 
            (TaskInfo[ix].appid == APDC ||
             TaskInfo[ix].appid == APHTML ||
             TaskInfo[ix].appid == APUCM ||
             TaskInfo[ix].appid == APGE ||
             TaskInfo[ix].appid == APSS) ) {
            IPCXsendMes(IPC_SRT, ix, &msg, sizeof(msg), APAC, 0);
            }
        }

    /* If there are any elf tasks that are interested in this task 
       then send them a message too.
    */
    ix = ThimTopPidFromPid(THIMpid);
    taskList = TaskInfo[ix].tasks_interested;
    if (taskList) {
        int rcvr_task;
        uidP = AxMakeArray(3);
        uidP = AxWriteArray(uidP,0,AxMakeIntData(TaskInfo[ix].uid));
        uidP = AxWriteArray(uidP,1,AxMakeStrData(-1,pathname));
        uidP = AxWriteArray(uidP,2,AxMakeIntData(msgtype));
        for(ix=0;taskList[ix] != 0;ix++) {
            rcvr_task = ThimPidFromUID(taskList[ix]);
            if (rcvr_task != 0)
                SendElfData(rcvr_task, POKE_DOC_MODIFIED, uidP);
        }
        AxFreeData(uidP);
    }

    /* poke interested dialogs */
    if (msgtype == AC_DOCMOD) {
        filename = AxMakeStrData(-1,pathname);
        XmPoker(POKE_DOC_MODIFIED,filename,NULL,TRUE,TRUE);
        AxFreeData(filename);
    }
}

/*************************************************************************
function: CloseDocInfoStruct - Clear out doc_info stuff
*/
static CloseDocInfoStruct (p,pid,local_insets_too)
register doc_info *p;
int pid;        /* task id */
int local_insets_too;   /* whether to kill off references to self */
{
    register int ix;
    register int did_work = FALSE;

    if ( p->owner == pid ) {
        p->owner = 0;       /* orphan it */
        did_work = TRUE;
    }
    for ( ix = 0; ix < p->num_openers; ix++ ) {
        if ( p->openers[ix] == pid ) {
            p->openers = clip1fromShorts(p->openers,ix,p->num_openers);
            p->num_openers--;
            did_work = TRUE;
        }
    }
/* This local insets test was added 7/24/90. It prevents this bug:
        1. Create DC
        2. Create local GE inset
        3. Edit & Exit (with save) inset
        4. Save As... DC doc
        5. Reopen inset
        6. Save inset... nothing happens in DC
*/
    if ( local_insets_too ) {
        for ( ix = 0; ix < p->num_lookers; ix++ ) {
            if ( p->lookers[ix] == pid ) {
                p->lookers = clip1fromShorts(p->lookers,ix,p->num_lookers);
                p->num_lookers--;
                did_work = TRUE;
            }
        }
    }
    for ( ix = 0; ix < p->num_refers; ix++ ) {
        if ( p->refers[ix] == pid ) {
            p->refers = clip1fromShorts(p->refers,ix,p->num_refers);
            p->num_refers--;
            did_work = TRUE;
        }
    }
    return(did_work);
}

/*************************************************************************
function: ACdocInt - Declares interest in a document
*/
ACdocInt (infoP)
DocInfoType *infoP;
{
    register doc_info *p;

    p = FindDocStruct(infoP->pathname);
    p->num_lookers++;
    p->lookers = (short*)
            TaskRealloc(0,p->lookers,p->num_lookers * sizeof(short));
    p->lookers[p->num_lookers-1] = THIMpid;
    return(AOK);
}

/*****************************************************************************
function: ACnotInt - Undeclare interest in a document
*/
ACnotInt(infoP)
DocInfoType *infoP;
{
    register doc_info *p;
    int ix;

    p = p = FindDocStruct(infoP->pathname);
    for ( ix = 0; ix < p->num_lookers; ix++ ) {
        if ( p->lookers[ix] == THIMpid ) {
            p->lookers = clip1fromShorts(p->lookers,ix,p->num_lookers);
            p->num_lookers--;
            return(AOK);
        }
    }
}


/*************************************************************************
function: FSclipOrphans - Toss out unused doc_info structures
*/
static FSclipOrphans ()
{
    doc_info *p, *next, **parent;

    parent = &DocList;
    for ( p = DocList; p; p = next ) {
        next = p->next;
        if ( !p->owner && !p->num_openers && !p->num_lookers && !p->num_refers ) {
            *parent = p->next;  /* unthread */
            TaskFree(0,p->lookers);
            TaskFree(0,p->refers);
            TaskFree(0,p->openers);
            TaskFree(0,p);
        }
        else
            parent = &p->next;
    }
}

/*************************************************************************
function: FSClearTask - Release all of a task's resources
Gets rid of open doc info & resets all doc refs.
*/
FSClearTask (pid)
register int pid;
{
    register doc_info *p;
    register int did_work = FALSE;

    for ( p = DocList; p; p = p->next )
        did_work = CloseDocInfoStruct(p,pid,TRUE);
    if ( did_work )
        FSclipOrphans();
}



/*************************************************************************
function: FSSetSaveMode - Set the binary/ascii./compressed file saving mode
*/
FSSetSaveMode (infoP,mode,grpAccess,allAccess)
DocInfoType *infoP;
int mode;
int grpAccess, allAccess;
{
    if ( allAccess > grpAccess )    /* sanity */
        grpAccess = allAccess;
    infoP->saveMode = mode;
    infoP->grpAccess = grpAccess;
    infoP->allAccess = allAccess;
}


/* #endif */

/*************************************************************************
function: AxSendDocInfoToElf - Return major elements of FSCurrDoc
Update & return major elements of FSCurrDoc
*/
typeErr AxSendDocInfoToElf (infoP)
DocInfoType *infoP;
{
    int docid, mode, grpAccess, allAccess, writeable, onDisk;
    char *name;
    typeErr err;

    if ( AOK != (err = ElfGetMsg("")) )
        return(ElfRetErr(err));
    FSSetAndFetchPerms(infoP);
    name = infoP->pathname;
    mode = infoP->saveMode;
    docid = infoP->DocId;
    writeable = infoP->canIwrite;
    grpAccess = infoP->grpAccess;
    allAccess = infoP->allAccess;
    onDisk = infoP->onDisk;
    ElfRespond(NXLT("SIIIIII"),&name,&docid,&onDisk,&mode, &grpAccess,&allAccess,&writeable);
    return(AOK);
}

/*************************************************************************
function: FSSetAndFetchPerms - For new docs, sets for old, simply returns
*/
FSSetAndFetchPerms (infoP)
DocInfoType *infoP;
{
    char *name;
    typeErr err;
    char dir[STRPATH+1], entryname[STRPATH+1];
    struct stat status;
    int docid, mode, grpAccess, allAccess, writeable, onDisk;

    static int filemask;

    if ( filemask == 0 ) {
        filemask = umask(0);    /* fetch old */
        umask(filemask);        /* restore it */
        filemask = ~filemask;       /* use it in a positve rather than negative manner */
    }

    ParsePath(infoP->pathname,dir,entryname);
    onDisk = infoP->onDisk;

    if (infoP->DocMatType != MSpreadsheet)
        infoP->saveMode = FS_SAVE_PORTABLE;

    if ( !onDisk ) {
        if ( 0 == Aaccess(dir,W_OK) )
            writeable = TRUE;
        else
            writeable = FALSE;
        if ( filemask & 0020 )
            grpAccess = 2;
        else if ( filemask & 0040 )
            grpAccess = 1;
        else
            grpAccess = 0;
        if ( filemask & 0002 )
            allAccess = 2;
        else if ( filemask & 0004 )
            allAccess = 1;
        else
            allAccess = 0;
    }
    else {
        if ( Aaccess(dir,W_OK) || Aaccess(infoP->pathname,W_OK) ) {
            writeable = FALSE;
            grpAccess = 1;
            allAccess = 1;
        }
        else {
            writeable = TRUE;
            stat(infoP->pathname,&status);
            if ( status.st_mode & 002 )
                allAccess = 2;
            else if ( status.st_mode & 004 )
                allAccess = 1;
            else
                allAccess = 0;
            if ( status.st_mode & 0020 )
                grpAccess = 2;
            else if ( status.st_mode & 0040 )
                grpAccess = 1;
            else
                grpAccess = 0;
        }
    }
    infoP->canIwrite = writeable;
    infoP->grpAccess = grpAccess;
    infoP->allAccess = allAccess;
}

typeErr UPgetinfo(){return(1);}


int FSnoSSDirs; /* ??x do something about this !!!!! */


char *ScanForNthFileObject();

void FSCreateUserPixmap(map_name, owner_name, data, wid, hyt)
char *map_name, *owner_name;
unsigned char *data;
int wid, hyt;
{
    doc_info *p;
    int i, j, array_size, byte_size;

    p = FindDocStruct ( owner_name );

    /* look for the map - if found, don't do anything */
    for ( i=0; i<p->nPixmaps; i++ )
        if ( strcmp(p->pm[i].name, map_name) == 0 )
            return;

    /* couldn't find the entry - create a new fill pixmap */
    i = p->nPixmaps++;
    array_size = p->nPixmaps * sizeof(user_pixmap);
    p->pm = (user_pixmap *)TaskRealloc(0,p->pm, array_size);
    p->pm[i].name = (char *)TaskAlloc(0, strlen(map_name)+1 );
    strcpy(p->pm[i].name, map_name);
    p->pm[i].map  = AxCreatePMFromBM(data, wid, hyt, FALSE);
    byte_size = ((wid+7)/8)*hyt;
    for(j=0; j<byte_size; j++)
        data[j] = ~data[j];
    p->pm[i].imap = AxCreatePMFromBM(data, wid, hyt, FALSE);
    p->pm[i].wid = wid;
    p->pm[i].hyt = hyt;
}

/*
*   function FSGetDocRev()
*           gives the revision of the document.
*   returns AOK if able to find the rev number else returns -1
*   
*/

typeErr FSGetDocRev(pathname, rev)
char *pathname; /* IN pathname of the document */
int *rev; /* OUT revision of this document */
{
char first_line[101];
char tmpstr[80], revstr[80];
FILE *fp;
    fp = fopen(pathname,"r");
    if(fp == NULL)
        return(-1);
        
    /* read the first line from the file */
    fgets(first_line, 100, fp);
    if( 0 != fclose(fp))
        return(-1);
    /* the first line of the header contains magic number ,rev number etc. */
    /*  the second field contains the rev number */
    /* the revision string is as follows */
    /* 000 for rev 1.0 */
    /* 1000 for rev 2.0 */
    /* etc .. */
    sscanf(first_line,"%s %s",tmpstr,revstr);
    *rev = atoi(revstr);
    switch(*rev)
        {
        case 0: 
            *rev = 1;
            break;
        case 1000:  
            *rev = 2;
            break;
        default:
            *rev = 0;
            break;
        }
    return(AOK);
}

/*************************************************************************
function: ACxferDoc - Return ptr to XferDoc
*/
DocInfoType *ACxferDoc ()
{
    return(&XferDoc);
}





ACxferGotStuff(){return(AOK);}

ACxfer (mode,infoP) /* ??x get rid of this! */
register int mode;
register XferDesc *infoP;
{
    static XferDesc XferState;
    XferState.status = AC_XNOT_EMPTY + AC_XSCOPIED;
    if ( mode == AC_COPYTO ) {
        XferState.disc = infoP->disc;
    }
    else if ( mode == AC_XCOPYTO ) {
        XferState.disc = infoP->disc;
    }
    *infoP = XferState;
    return(AOK);
}

DocInfoType DCEmptyDoc; /* HACK For DC's new function */

/*************************************************************************
function: ACGetStyleFilename - 
*/
char *ACGetStyleFilename ()
{
    char *style;
    static char name[STRPATH+1];
    char *UPbyCode();
    extern char *ThimTextSfx;

    style = UPbyCode(PROF_WP_NEW_TEMPLATE);
    if ( !style || (*style == 0) )
        sprintf(name,"%s%s%s.%s",AxLangDir,DirSlash,
                    XLT2("style guide name", "empty"), ThimTextSfx);
    else
        strcpy(name, style); /* was AbsolutifyPathname(name,style,TRUE); */
    return(name);
}

#endif          /* } if !FOR_VERSION_FILTERS */


/*************************************************************************
function: ElfbXferSafe - Return TRUE if xfer bin empty or already copied from
OBSOLETE
*/
ElfbXferSafe ()
{
    return(-1);     /* ??c BTRUE */
}


