/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: axmain.c
   Applix ASC version: 121.14
   Date: Mon Jun 28 21:13:45 1999
*/
#include <stdio.h>
#include <stdlib.h>
#if AXMS
#include <basicwin.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <axsocket.h>
#include <setjmp.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <math.h>
#include <paripc.h>
#include <tmi.h>
#include <thimble.h>
#include <getstr5.h>
#include <eldata.h>
#include <el_syms.h>
#include <axnet.h>
#include <eldata.h>
#include <revstamp.h>
#if AX_X11
#include <X11/Xlib.h>
#endif
#include <axmain.p>

static char *ASC_id = ASC_WHAT_STR;

int AxUseEncryption;/* TRUE if profile imposes file encryption */
int AxDocFromPriorRev;  /* Set for rev1 docs on file opens */
int AxDocInBinaryForm;  /* Set if machineType not 1000 or 0000 */
int AxViewOnly; /* TRUE only if axViewOnly set in profile... */
int AxViewRest; /* Set/Clear able by ELF macro */
long AxActiveTask;  /* Task to get called macros attached to */
int AxLockingTask;  /* Task that called AxTaskLock() */
int AxSockFd;   /* primary services request channel */
char *AxSocketName; /* name of primary service channel */
int AxHaveShellServer;  /* true if can pipe to out command server */
char *StackBase;        /* Stack base of Schedular's main loop */
int AxAllowCore = FALSE;
char *AxComlFontPath;   /* NULL or command line fontpath specification */
int AxKeepRunning=FALSE;  /* if TRUE, keey axmain up after last window goes away */
int AxStartedForPrinting;   /* if TRUE, axmain started just for a print job */
int AxNoSymbolicFileLinks;  /* for HP-CDROM */
char *ThimCmdArgsFile;  /* name of file containing command line args */
char *ThimSignalFile;   /* startup[ connector file with my pid in it */
int AxNoMapWindows;     /* -quiet mode */
int ThimHelperPid;      /* process id of helper */
extern int AxElfrtMode;     /* TRUE if running as elfrt rather than axmain */
char *AxServiceName;    /* axnet service name passed from starter program */
int AxDontSaveProfiles = FALSE; /* At exit time do not save profiles */
int AXRPCdebug=0;
int RegisteredRemoteFunctions = FALSE;      /* SS related */
char *AxDisplayName;
#if AXMS
char AxDisplayNameBuff[35];
char AxHostName[30];
extern HWND WXDummyWnd;
#endif
extern char *ThimSessionElfDir;
extern int  AxDndNoMessaging; /* See axdnd.c */
char *AxInitMacroName;  /* for axnet startup, the initial macro to run */
char *AxInitMacroArgStr;    /* for AxInitMacro */
int AxCommandLineSpecified = FALSE;   /* on NT, are there command line args? */

/* Number of days left in Applixware demo. Zero implies not a demo! */
int AxDemoDays=0;


#if AXMS
char *DirSlash = "\\";
#else
char *DirSlash = "/";
#endif

extern context_block *ActiveTasks[MAX_PIDS+1]; /* array of tasks .in_use */
extern int ThimExposuresMayBeComing;    /* Hint for command startup delaying */
extern int AxInTask;    /* 0 or task that owns the current stack */
extern char *UPbyName AXP_((char *name));
extern char *ThimApplixDir;        /* Where the THIMBLE executable lies */
extern int AxRPCNonBlockingIO;  /* If TRUE, use AxTimedReadBytes() in elfapi.a */
extern int JavaMode;    /* TRUE for Java slaved axmain */
extern int EnterpriseMode; /* TRUE when running enterprise product */
data_ptr AxTaskCreateElfString();

static int TaskTimeoutVal = -1;  /* ipc timout adjust for tasks */
static int StartedAxmain = FALSE;

/* static char FirstArgInfo[8]; */ /* unused... */

ax_jmp_buf KernelJump; /* jump to ATM's main loop */

int AxTestMode;     /* set to TRUE if axmain started with -test switch */
int AxTestVerbose;	/* set TRUE is -amake_verbose on command line */
char *AxTestOptions;    /* command line options after the -test switch */
int ElfSysMode;     /* TRUE if ELF compiled in system mode */

extern int PrintMemoryStatsFlag;
extern int AxLanguage;

int  AXNLMdebug  = FALSE;


/*************************************************************************
function: axmain - Top of the world!
*/
axmain(main_argc,main_argv)  /* THIMBLE schedular */
int main_argc;
char **main_argv;
{
    int ix;
    register context_block *p;
    register msg_info *mesP;
    struct timeval current_time;
    struct timezone cur_timezone;
    int ranLogin = FALSE;
    int got_expose = FALSE;
    typeErr err;
#if 0
extern int _Xdebug;
_Xdebug = TRUE;
#endif

    StackBase = (char *)&main_argc;


#if 0
    /* used to do this IBM */
    AxLoadMallocShlibForIBM(main_argv[0]);
#endif

#if AXMS
	if (streq("elfmain.exe",main_argv[0]+strlen(main_argv[0])-11))
#else
	if (streq("elfmain",main_argv[0]+strlen(main_argv[0])-7))
#endif
		AxElfrtMode = TRUE;
	else
		AxElfrtMode = FALSE;
    InitShlibImportFuncPtrs();
    InitializeMemoryStructure();

#if PROFILE_BUILD
    toggle_profiling( FALSE);   /* turn off profiling, turns on with F12 in  */
                                /* ProcessKeyEvent()                      */
#endif

#if AXMS
    {
    /* initialize connection to socket libraries */
    WSADATA wsadata;
    WSAStartup(0x0101, &wsadata);
    }
#endif

    AxCommandLineOptions(main_argc,main_argv);
#if AX_X11
/* NT sets elf command line in AxCommandLineOptions */
	if (AxElfrtMode)
		 ElfrtCommandLineOpts(main_argc,main_argv);
	
    if (AxStartedForPrinting)
        nice(10);  /* big bg process and we\'re not waiting on it... */
#endif

    AxRPCNonBlockingIO = FALSE; /* syncronized server startup */
    AxSockFd = AxServerStartup(AxServiceName);  /* create socket & fork */
    AxRPCNonBlockingIO = TRUE;  /* tells elfapi.a to use scheduled IO */
    massive_init(main_argc,main_argv);
	SetTaskTimerLogger();
    ElfInitLibs();

    while ( axsetjmp(KernelJump) ); /* kernel access point during login */
 
               /* This simply sets a system variable so I can know
                  which domains to add when help comes up -- barryk */
    err = ElfCallByName("HELP_INIT_APPLIXWARE$", (data_ptr *)NULL, 0);

    if ( !ranLogin ) {
        ranLogin = TRUE;
        if ( AxTestMode ) {
            VfyContext(0);
            ElfbNewTask("TEST_RUN@",AxTestOptions);
        }
        else if ( AxInitMacroName ) {
            VfyContext(0);
            ElfbNewTask(AxInitMacroName,AxInitMacroArgStr);
        }
        else
            ElfStartNewTask(ELElfMacroId(ELFM_INITIAL_ICONS_));
    }

kernel_loop:

    while ( axsetjmp(KernelJump) ); /* where all task suspends come back to */

mainloop:

    AxInTask = 0;
	ReportTaskTiming();

    if ( AxLockingTask && !ThimPidFromUID(AxLockingTask) )
        AxLockingTask = 0;  /* paranoid... reset if locking task crashed */

    if ( ThimExposuresMayBeComing ) {
        if( HandleExposures() )
            goto mainloop;
    }

/* See if any tasks are waiting to start or be shot down */

    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        if ( AxLockingTask && (p->uid != AxLockingTask) )
            continue;
        if ( p->start_me ) {
            ix = p - TaskInfo;
            p->ipc_timed_wait = FALSE;
            VfyContext(ix);
            if ( p->usesElfArgs )
                StartTask(ix,p->func,p->argc,p->argv,TRUE,p->elfArgv);
            else
                StartTask(ix,p->func,p->argc,p->argv,FALSE,NULL);
            goto kernel_loop;   /* only gets here if task terminates */
        }
        if ( p->kill_me ) {
            p->kill_me = FALSE;
            p->ipc_timed_wait = FALSE;
            ix = p - TaskInfo;
            VfyContext(ix);
            AxInTask = ix;
            AxExitWithData(0,NULL);
            goto kernel_loop;   /* only gets here if task terminates */
        }
    }

/* See if any tasks have an incoming response pending.
    Likewise, wake up any task that waited on a proc */

    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        if ( AxLockingTask && (p->uid != AxLockingTask) )
            continue;
        if ( ((p->ipc_response_waiting && p->rsp) || (p->unpend_me)) &&
                !p->pended && !p->elfCallBlocked && !p->recycle_only &&
				!p->infoBox) {
            p->unpend_me = FALSE;
            ix = p - TaskInfo;
            LowerTaskPriority(p);
            ActivateTask(ix);
            goto kernel_loop;   /* only gets here if task terminates */
        }
    }

/* See if any tasks have an incoming event pending */

    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        if ( AxLockingTask && (p->uid != AxLockingTask) )
            continue;
retry:  if ( p->msgs && !p->pended && !p->elfCallBlocked && !p->infoBox
                && !p->ipc_response_waiting && !p->recycle_only ) {
            mesP = p->msgs;
            if ( mesP->discard_me ) {   /* already read */
                p->msgs = mesP->next;
                free(mesP);
                goto retry;
            }
            p->ipc_timed_wait = FALSE;
            LowerTaskPriority(p);
            ix = p - TaskInfo;
            ActivateTask(ix);
            goto kernel_loop;   /* only gets here if task terminates */
        }
    }

/* Respond to events before activating any timed tasks.  This helps
    solve the "wait till steady state" needed for exposures when
    dialogs and menus go away.
*/

/* See if any tasks have timed out on their IPCawait, adjust ATM's timeout.
    A task getting input on a socket has the same preference.
    Note that if task locking is active, the socket task has to suspend itself after getting the
    input.
*/
    TaskTimeoutVal = -1;
    gettimeofday (&current_time, &cur_timezone);
    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        int my_time;
        if ( p->haveSocketInput ) {
            if ( AXtAppNextEvent(0,0) ) {   /* quick poll */
                GetAndDoEvent(1);   /* process the event (1sec timer for sanity */
                goto mainloop;
            }
            LowerTaskPriority(p);
            ix = p - TaskInfo;
            ActivateTask(ix);
            goto kernel_loop;   /* only gets here if task terminates */
        }
        if ( AxLockingTask && (p->uid != AxLockingTask) )
            continue;
        if ( p->pended || p->elfCallBlocked || p->recycle_only ||
             !p->ipc_timed_wait || p->infoBox ||
             p->ipc_response_waiting )
            continue;
        if ( AxSubtractTime(&current_time,&p->ipc_run_time) >= 0 ) {
            if ( AXtAppNextEvent(0,0) ) {   /* quick poll */
                GetAndDoEvent(1);   /* process the event (1sec timer for sanity */
                goto mainloop;
            }
            p->ipc_timed_wait = FALSE;
            p->timed_out = TRUE;
            LowerTaskPriority(p);
            ix = p - TaskInfo;
            ActivateTask(ix);
            goto kernel_loop;   /* only if task terminates */
        }
        my_time = AxSubtractTime(&p->ipc_run_time,&current_time);
        if ( TaskTimeoutVal == -1 )
            TaskTimeoutVal = my_time;
        else
            TaskTimeoutVal = MIN(TaskTimeoutVal,my_time);
        TaskTimeoutVal = MAX(0,TaskTimeoutVal);
    }

/* See if any tasks had given up timeslice out of niceness to other tasks. */

    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        if ( AxLockingTask && (p->uid != AxLockingTask) )
            continue;
        if ( p->pended || p->elfCallBlocked || p->infoBox ) continue;
        if ( p->recycle_only ) {
            p->recycle_only = FALSE;
            ix = p - TaskInfo;
            p->timed_out = TRUE;
            LowerTaskPriority(p);
            ActivateTask(ix);
            goto kernel_loop;   /* only if task terminates */
        }
    }

    /* Free object applications memory, marked for kill */
    FreeupExitedObjApps();

    if ( PrintMemoryStatsFlag )
        {
        PrintMemoryStatsFlag = FALSE;
        Print_Memory_Stats();
        }


    GetAndDoEvent(TaskTimeoutVal);
    goto mainloop;
}

#if RIOS
/*************************************************************************
function: AxLoadMallocShlibForIBM - load rs_ax.o lib for malloc fix. will
exit if fails
*/
AxLoadMallocShlibForIBM(in_path)
char *in_path;  /* path to axmain, don't change it, just use it */
{
    void *handle;
    char libpath[STRPATH+1], *cp;

    strcpy(libpath, in_path);
    cp = strrchr(libpath, '/');
    if(NULL == cp)  {
        fprintf(stderr, "%s\n",
                         XLT("Start product with full path to ``axmain''."));
        exit(1);                                                              
    }
    cp++;
    *cp = '\0'; /* truncate after last slash in the string */
    strcat(libpath, NXLT("rs_ax.o"));
    /* load the library */
    handle = load(libpath, 0, NULL);
    if(NULL == handle)  {
        fprintf(stderr,"%s\n",XLT("Could not load rs_ax.o"));
        exit(1);
    }
}
#endif

/*************************************************************************
function: AxSubtractTime - Subtract second time arg from first
Returns difference in milliseconds
*/
AxSubtractTime (t1P, t2P)
struct timeval *t1P, *t2P;
{
    return((t1P->tv_sec - t2P->tv_sec) * 1000 + 
           (t1P->tv_usec - t2P->tv_usec) / 1000);
}

/*************************************************************************
function: AxSubtractUSecTime - Subtract second time arg from first
Returns difference in microseconds
*/
double AxSubtractUSecTime (t1P, t2P)
struct timeval *t1P, *t2P;
{
    return(((double)(t1P->tv_sec - t2P->tv_sec)) * 1000000 + 
           (t1P->tv_usec - t2P->tv_usec));
}

static void axSetAlarmForMinimumTask();
void AxSetAlarmAbsolute();
void AxSetAlarm();
void AxSetTaskAlarm();
void AxSetTaskAlarmAbsolute();

/*************************************************************************
function: axAlarmFunc - Called when axmain's alarm triggers
*/
static void axAlarmFunc (int unused)    /* arg just for prototype warning */
{
    register context_block *p;
    register int ix;
    struct timeval now;
    int task;

    gettimeofday(&now, NULL);

    /* see which tasks are to be woken up */
    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        switch ( p->alarm_mode ) {
        case ALARM_MODE_NOP:
            break;
        case ALARM_MODE_FLAG:
        case ALARM_MODE_RECYCLE:
            if ( !p->alarm_has_fired ) {
                if ( AxSubtractUSecTime(&now,&p->alarm_wakeup_time) >= 0 )
                    p->alarm_has_fired = TRUE;
            }
            break;
        default:
            tempAbort("Unsupported alarm mode");
        }
    }
    axSetAlarmForMinimumTask(&now);
}


/*************************************************************************
function: axSetAlarmForMinimumTask - Enable alarm code for "soonest" task
*/
static void axSetAlarmForMinimumTask (nowP)
struct timeval *nowP;
{
#if AX_X11    /* { */
    register context_block *p;
    register int ix;
    register int min_secs = MAXINT, min_usecs = MAXINT, millisec;
    struct timeval min;
    double usecs;
    struct itimerval value;

    signal(SIGALRM, axAlarmFunc);
    for ( ix = 0, p = ActiveTasks[ix]; p; p = ActiveTasks[++ix] ) {
        if ( (p->alarm_mode != ALARM_MODE_NOP) && !p->alarm_has_fired ) {
            if ( p->alarm_wakeup_time.tv_sec <= min_secs ) {
                min_secs = p->alarm_wakeup_time.tv_sec;
                min_usecs = MIN(p->alarm_wakeup_time.tv_usec,min_usecs);
            }
        }
    }
    if ( min_secs == MAXINT )
        return;

    min.tv_sec = min_secs;
    min.tv_usec = min_usecs;
    usecs = AxSubtractUSecTime(&min,nowP);
    if ( usecs < 0 ) {
        axAlarmFunc(0);
        return;
    }
    value.it_value.tv_sec = usecs / 1000000;
    value.it_value.tv_usec = fmod(usecs,1000000.0);
    timerclear(&value.it_interval);
    setitimer(ITIMER_REAL, &value, NULL);
#endif    /* } AX_X11 */
}

/*************************************************************************
function: AxSetAlarm - Set Alarm for this task
*/
void AxSetAlarm (mode,millisec)
int mode;       /* ALARM_MODE_XXX -> MSG/FLAG/NOP */
int millisec;   /* milliseconds from right now */
{
    AxSetTaskAlarm(AxInTask,mode,millisec);
}

void AxSetTaskAlarm (task,mode,millisec)
int task;       /* TaskInfo index (not uid) */
int mode;       /* ALARM_MODE_XXX -> MSG/FLAG/NOP */
int millisec;   /* milliseconds from right now */
{
    struct timeval alarm;

    if ( mode == ALARM_MODE_NOP ) {
        TaskInfo[task].alarm_mode = mode;
        TaskInfo[task].alarm_has_fired = FALSE;
        return;
    }
    TaskInfo[task].alarm_millisec = millisec;
    gettimeofday(&alarm, NULL);
    alarm.tv_sec += millisec / 1000;
    alarm.tv_usec += (millisec %1000) * 1000;
    AxSetTaskAlarmAbsolute(task,mode,&alarm);
}

/*************************************************************************
function: AxSetAlarmAbsolute - Set Alarm for this task
*/
void AxSetAlarmAbsolute (mode,time)
int mode;       /* ALARM_MODE_XXX -> MSG/FLAG/NOP */
struct timeval *time;    /* time when this task gets notified */
{
    AxSetTaskAlarmAbsolute(AxInTask,mode,time);
}

void AxSetTaskAlarmAbsolute (task,mode,time)
int task;       /* TaskInfo index (not uid) */
int mode;       /* ALARM_MODE_XXX -> MSG/FLAG/NOP */
struct timeval *time;    /* time when this task gets notified */
{
#if AX_X11
    struct timeval now;

    signal(SIGALRM, axAlarmFunc);

    if ( mode == ALARM_MODE_NOP ) {
        TaskInfo[task].alarm_mode = mode;
        TaskInfo[task].alarm_has_fired = FALSE;
        return;
    }
    TaskInfo[task].alarm_wakeup_time = *time;
    TaskInfo[task].alarm_has_fired = FALSE;
    TaskInfo[task].alarm_mode = mode;
    gettimeofday(&now, NULL);
    axSetAlarmForMinimumTask(&now);
#endif
}

/*************************************************************************
function: AxAlarmHasFired - Return whether last alarm hit. CHEAP CALL!
*/
int AxAlarmHasFired ()
{
    return(TaskInfo[AxInTask].alarm_has_fired);
}

/*************************************************************************
function: AxAlarmCurrentMode - Return alarm_mode
*/
int AxAlarmCurrentMode ()
{
    return(TaskInfo[AxInTask].alarm_mode);
}


FILE *AxLogFp;
void AxLogger(s,a,b,c,d,e,f,g,h,i,j,k)
char *s;
int a,b,c,d,e,f,g,h,i,j,k;
{
#if !TURBO
    static int called = FALSE;
    char *prof;

    if ( ThimApplixDir == (char *)NULL )
       {
       /* environemnt not yet set up, skip it */
       return;
       }

    if ( !called ) {
        called = TRUE;
        prof = UPbyName(NXLT("AxLog"));
        if (!prof || !atoi(prof)) return;
#if AX_NT
        if ( !AxLogFp )
            AxLogFp = fopen("\\tmp\\log","w");
#else
        if ( !AxLogFp )
            AxLogFp = fopen("/tmp/zzlog","w");
#endif
    }
    if ( AxLogFp ) {
        fprintf(AxLogFp,s,a,b,c,d,e,f,g,h,i,j,k);
        fflush(AxLogFp);
    }
#endif
}

/*************************************************************************
function: AxTaskLock - Lock current thread to be the only thread
*/
void AxTaskLock ()
{
    AxLockingTask = TaskInfo[AxInTask].uid;
}

/*************************************************************************
function: AxTaskUnlock - Unlock current locking thread
*/
void AxTaskUnlock ()
{
    AxLockingTask = 0;
}

/*************************************************************************
function: AxServerStartup - Bind to socket & fork
*/
int AxServerStartup (serviceName)
char *serviceName;
{
    int channel, sockfd;
    int code;
    char *str, *obj;
    char *p;
    elfData response;

    if ( !serviceName ) {
#if !AXMS
        AxAllowCore = TRUE; /* only axmain mode startup cores */
#endif
        return(0);
    }

    channel = AxNetConnect(NULL,&code,&str,&obj);
    if ( code != 0 ) {
        char buf[300];
err:    sprintf(buf,"axmain: %s: %s\n",obj,str);
        tempAbort(buf);
    }
    AxSendMessageToServer(channel,AXNET_GET_SOCKET,NULL,&code,&str,&obj);
    if ( code != 0 )
        goto err;

    response = AxGetResponseFromServer(channel,&code,&str,&obj);
    p = (char *)AxStrPtrFromDataPtr((data_ptr)response);
    p = strcpy(malloc(strlen(p)+1),p);
    AxSocketName = p;
    AxClientDisConnect(channel);

    AxNetRegisterService(AxSocketName,serviceName,TRUE,"",&code, &str, &obj);
    if ( code != 0 )
        goto err;

    sockfd = AxOpenServerAndSignalParent(p);
#if AXMS && !ELF_COMM_STAND_ALONE
    code = WSAAsyncSelect(sockfd, WXDummyWnd, SOCKET_PSEUDO_EVENT,
                    FD_READ | FD_WRITE | FD_ACCEPT | FD_CONNECT);
    if ( code != 0 )
        return 0;
#endif
    return sockfd;
}

/*************************************************************************
function: AxCommandLineOptions - Read the options file for C-code info
*/
static void
AxCommandLineOptions (argc,argv)
int argc;
char **argv;
{
    char *buf;
    char *p;
    int ix;
    extern int THIMwtHelper, THIMrdHelper;  /* pipe fds to thimble helper */
    int num_args;
    elfData AxCommandLineData;
if (getenv("CATCH_AXMAIN")) {
	static int spin = 1;
	while (spin);
}

    for ( ix = 1; ix < argc; ix++ ) {
        buf = argv[ix];
        if ( streq("-display",buf) )
            AxDisplayName = argv[++ix];
		else if ( streq("-elfrt", buf) )
			AxElfrtMode = TRUE;
        else if ( streq("-elfdir", buf) ) {
            ThimSessionElfDir = (char *) malloc(strlen(argv[ix + 1]) + 1);
            strcpy(ThimSessionElfDir, argv[++ix]);
        }
        else if ( streq("-fp",buf) )
            AxComlFontPath = argv[++ix];
        else if (streq("-noMessaging", buf))
            AxDndNoMessaging = TRUE; /* Don't allow HP drag-n-drop by
                                        not initializing with the BMS. */
        else if (streq("-core",buf) )
            AxAllowCore = TRUE;
        else if (streq("-stay",buf) )
            AxKeepRunning = TRUE;
        else if ( strncmp( "-language:", buf, 10 ) == 0 )
            AxLanguage = atoi( &buf[10] );
        else if (streq("-no_exp_link",buf) )
            AxNoSymbolicFileLinks = TRUE;
        else if (streq("-nlm",buf) )
			 AXNLMdebug = TRUE;
        else if (streq("-enterprise",buf) )
            EnterpriseMode = TRUE;
        else if (streq("-rpc",buf) )
            AXRPCdebug = TRUE;
        else if (streq("-quiet",buf) )
            AxNoMapWindows = TRUE;
        else if ( streq("-print",buf) ) {
            AxStartedForPrinting = TRUE;
        }
        else if ( streq("-homedir",buf) ) {
            char *homepath;

            homepath = (char *) AxMalloc(sizeof(char)*
                (strlen("HOME=")+strlen(argv[++ix])+1));
            sprintf(homepath,NXLT("HOME=%s"),argv[ix]);
            putenv(homepath);
            JavaMode = TRUE;    /* need a -java flag! */
        }
        else if ( streq("-sysvar",buf) ) {
            char *name,*value;
            if ( ix >= argc - 2 )
                break;
            name = argv[++ix];
            value = argv[++ix];
            ElfbSetSysVar(name,AxTaskCreateElfString(0,value));
        }
        else if ( streq("-helper",buf) ) {
            ThimHelperPid = atoi(argv[++ix]);
            THIMrdHelper = atoi(argv[++ix]);
            THIMwtHelper = atoi(argv[++ix]);
            AxHaveShellServer = TRUE;
        }
        else if ( streq("-noprofiles",buf) ) {
            AxDontSaveProfiles = TRUE;
#if AXMS
            putenv(NXLT("HOME=\\tmp"));
            putenv(NXLT("AXHOME=\\tmp"));
#else
            putenv(NXLT("HOME=/tmp"));
            putenv(NXLT("AXHOME=/tmp"));
#endif
        }
        else if ( streq("-servicename",buf) )
            AxServiceName = argv[++ix];
        else if ( streq("-init_macro",buf) ) {
            AxInitMacroName = argv[++ix];
            ix++;
            if ( ix < argc )
               /* we have an argument */
               AxInitMacroArgStr = argv[ix];
            else
               /* no argument */
               AxInitMacroArgStr = "";
        }
        else if ( streq("-channel",buf) ) {
            data_ptr rP;
            int size, cnt;
            char *outBuf;
            int pipeFd;

            pipeFd = atoi(argv[++ix]);
            rP = AxMakeArray(2);
            AxAddIntToArray(rP,0,0);
            AxAddArrayToArray(rP,1,NULL);
            size = AxMemWrite(rP,0,&outBuf);
            cnt = write(pipeFd,outBuf,size);    /* Unblock client */
        }
		else if ( streq("-amake_verbose",buf) ) {
			AxTestVerbose = TRUE;
            ElfbSetSysVar("AMAKE_VERBOSE$",AxMakeIntData(BTRUE));
            ElfbSetSysVar("amake_verbose$",AxMakeIntData(BTRUE));
		}
        else if ( streq("-test",buf) ) {
            int jx;
			ElfSysMode = TRUE;	/* allow $ and @ functions */
            AxTestMode = TRUE;
            AxTestOptions = (char*)malloc(64000);
            AxTestOptions[0] = 0;
            for ( jx = ix+1; jx < argc; jx++ ) {
                strcat(AxTestOptions,argv[jx]);
                if ( jx != argc-1 )
                    strcat(AxTestOptions," ");
            }
        }
    }

#if AX_X11    /*  {  */
    if ( !AxDisplayName )
        AxDisplayName = getenv(NXLT("DISPLAY"));
    if ( (!AxDisplayName || !AxDisplayName[0]) && JavaMode ) {
        char hostname[100];
        if ( gethostname(hostname,99) != -1 ) {
            AxDisplayName = (char *) malloc(strlen(hostname)+3);
            sprintf(AxDisplayName,"%s:0",hostname);
        }
    }
    if ( !AxDisplayName || !AxDisplayName[0] ) {
        /*  Can't translate on-the-fly; XLTInit() is called after this point */
        printf(NXLT("Before running this product, you must set\n"));
        printf(NXLT("your environment DISPLAY variable.\n"));
        AxExit(0);
    }
#else        /*  }  {  */

    /* on NT we collect any real command line arguments, and create an */
    /* ELF array of these, so that we can run the startup code in      */
    /* "process_options$" just as if the data had come from the starter */
    /* program on UNIX.                                                 */
    AxCommandLineSpecified = FALSE;
    num_args = GetRealCommandLineOptions( argc, argv, 0, TRUE,
                                               &AxCommandLineData );
    if ( num_args > 2 || (AxElfrtMode && num_args != -1) )
       {
       /* more than just the default "-pwd" */
       AxCommandLineSpecified = TRUE;
       ElfbSetSysVar( "command_line_options$", AxCommandLineData );
       }

    /* On NT we "manufacture" a display name, used as a registration hook */
    /* for various real-time services.                                    */
    AxDisplayName = (char *)0;
    if ( 0 == NoteWinIPCUse() )
        {
        /* Socket stuff initialized correctly */
        if ( 0 == gethostname(AxHostName, (sizeof(AxHostName)-1)) );
            {
            /* all is well */
            sprintf( AxDisplayNameBuff, "%s:0", AxHostName );
            AxDisplayName = AxDisplayNameBuff;
            }
        NoteWinIPCDone();
        }
     
     
    if ( AxDisplayName == (char *)NULL )
        {
        printf(XLT("Warning: networking not initialized, error code=%d\n"),
                                     WSAGetLastError() );
        
        }
#endif        /*  }  */
}

/*************************************************************************
function: ElfrtCommandLineOpts - Load command_line_options$ sysvar
*/
void ElfrtCommandLineOpts (argc,argv)
int argc;
char **argv;
{
	data_ptr aP;
	int ix;

	AxKeepRunning = FALSE;
	
	aP = AxMakeArray(argc-1);
	for ( ix = 1; ix < argc; ix++ )
		AxAddStrToArray(aP,ix-1,argv[ix]);
	ElfbSetSysVar("command_line_options$",aP);
	AxFreeData(aP);
}

#if PROFILE_BUILD

toggle_profiling( ring )
  int ring;
{

    static int  mmmm = 0;    /* profiling is on by default;
                                want to turn it OFF with first call */

    moncontrol(mmmm);                                          
                                                              
    if (ring) {                                              
        RingTheBell();          /* 1 beep if turn profiling off */
        if(mmmm) {                                 
            RingTheBell();      /* 2 more beeps if profiling on */
            RingTheBell();                           
        }
    }           
 
    mmmm = !mmmm;

}
#endif

typedef struct {
	int enabled;	/* TRUE if timing tasks */
	int threshold;	/* In millisec, relates to profile axTaskTimerThreshold */
	FILE *fp;		/* logfile (or stdout) if AxTaskTimer!=0 */
	int taskUid;	/* 0 or task being timed */
    struct timeval started;	/* when pid began running */	
} taskTimer_t;
taskTimer_t AxTaskTimer;

/*************************************************************************
function: ReportTaskTiming - If time crosses threshold, log info
*/
void ReportTaskTiming ()
{
    struct timeval current;
    struct timezone cur_timezone;
	int diff, pid;
	char *taskName;

	if ( !AxTaskTimer.enabled || !AxTaskTimer.taskUid )
		return;
	gettimeofday(&current, &cur_timezone);
	diff = AxSubtractTime(&current,&AxTaskTimer.started);
	if ( diff >= AxTaskTimer.threshold ) {
		pid = ThimPidFromUID(AxTaskTimer.taskUid);
		taskName = (pid ? TaskInfo[pid].argv[0] : "***task-completed***");
		fprintf(AxTaskTimer.fp,"%5d %s\n",diff,taskName);
		fflush(AxTaskTimer.fp);
	}
	AxTaskTimer.taskUid = 0;
}

/*************************************************************************
function: NoteTaskStartup - Set the taskUid and start timer
*/
void NoteTaskStartup ()
{
    struct timezone cur_timezone;

	if ( !AxTaskTimer.enabled )
		return;
	AxTaskTimer.taskUid = TaskInfo[AxInTask].uid;
	gettimeofday(&AxTaskTimer.started, &cur_timezone);
}

/*************************************************************************
function: SetTaskTimerLogger - Read profile, set TaskTimerLoggerFp as needed
*/
void SetTaskTimerLogger ()
{
	char *timeStr = GetProfileByStr("axTaskTimerThreshold");	/* in secs */
	char *timeFile = GetProfileByStr("axTaskTimerLogFile");	/* empty for stdout */

	AxTaskTimer.threshold = atoi(timeStr);
	if ( *timeStr ) {
		AxTaskTimer.enabled = TRUE;
		if ( timeFile[0] )
			AxTaskTimer.fp = fopen(timeFile,"w");
		else
			AxTaskTimer.fp = stdout;
		if ( !AxTaskTimer.fp )
			tempAbort("Could not open task timer file");
	}
}

/*************************************************************************
function: AxRunTask - Called whenever a task is scheduled
This just exists for breakpointing and to see/track task behaviour
*/
void AxRunTask ()
{
	if ( AxTaskTimer.enabled )
		NoteTaskStartup();
/*	printf("Running %s task %d",TaskInfo[AxInTask].argv[0],AxInTask); */
}

/*************************************************************************
function: SetAXNLMdebug
*/
void SetAXNLMdebug (int value)
{
   AXNLMdebug = value;
}

/*************************************************************************
function: GetAXNLMdebug
*/

int GetAXNLMdebug ()
{
   return (AXNLMdebug);
}
