/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: cmdline.c
   Applix ASC version: 5
   Date: Mon Nov 16 13:53:26 1998
*/
#include <aos.h>
#include <eldata.h>

#if AXMS
#include <direct.h>

extern int AxElfrtMode;    /* TRUE if running as elfrt rather than axmain */
#endif


#ifndef THIM_NAME
#define THIM_NAME "ApplixWare"
#endif

#define streq(a,b) (0 == strcmp(a,b))

int GetRealCommandLineOptions(argc, argv, filteredArgs, add_cwd, result_request  )
int argc;
char *argv[];
int add_cwd;          /* should we add the current directory as an arg? */
int filteredArgs;
elfData *result_request;
{
	char working_dir[STRPATH+1];
    int ix, cnt, request_size;
    elfData request; 
   
	/* Form the `request' that will be x-mitted to axmain:  Skip over all *\
	 * filtered args (args that were used up with FindAxMain()).          *
	 * Stuff in invoker's present working directory -- mainlib.els will   *
	\* use it when opening documents specified on the command line.       */
	request_size = argc - 1 - filteredArgs;
#if AXMS
	if ( AxElfrtMode || add_cwd == FALSE || !getcwd(working_dir, STRPATH+1) ) {
#else
	if ( add_cwd == FALSE || !getcwd(working_dir, STRPATH+1) ) {
#endif
		cnt = 0;
		request = (elfData)AxMakeArray(request_size);
	}
	else {
		working_dir[STRPATH] = '\0';
		cnt = 2;
		request_size += 2;
		request = (elfData)AxMakeArray(request_size);
		request = (elfData)AxAddStrToArray(request, 0, NXLT("-pwd"));
		request = (elfData)AxAddStrToArray(request, 1, working_dir);
	}

	for ( ix = 1; ix < argc; ix++ ) {
		if ( streq(argv[ix],NXLT("-host")) && (argc > ix) )
			ix++;
		else if ( streq(argv[ix],NXLT("-uid")) && (argc > ix) )
			ix++;
		else if ( streq(argv[ix],NXLT("-fp")) && (argc > ix) )
			ix++;
		else if ( streq(argv[ix],NXLT("-display")) && (argc > ix) )
			ix++;
		else if (streq(argv[ix],NXLT("-elfdir")) && (argc > ix))
			ix++;
		else if (streq(argv[ix], NXLT("-call")) && (argc > ix)) {
			/* zap all remaining tokens on command line. */
			ix = argc;
		} else if (streq(argv[ix], NXLT("-core")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-stay")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-nlm")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-enterprise")) && (argc > ix))
		    ;
		else if (streq(argv[ix], NXLT("-no_exp_link")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-rpc")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-quiet")) && (argc > ix))
			;
		else if (streq(argv[ix], NXLT("-noMessaging")) && (argc > ix))
			;
#if AXMS
		else if ( streq(argv[ix],NXLT("-elfrt")) )
			;
#endif
		else if ( streq(argv[ix],NXLT("-test")) && (argc > ix) )
			return( -1 );
		else {
            /* not a switch, probably a document name */
			if (cnt >= request_size) {
			   /* Botched command line. */
				printf(NXLT("%s: Warning: Badly formed command line.\n"),
							THIM_NAME);
				continue;
			}
			AxAddStrToArray(request,cnt++,argv[ix]);
		}
	}
    *result_request = request;
    return( cnt );
}

