/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: int_enc.c
   Applix ASC version: 10
   Date: Mon Nov 16 13:53:27 1998
*/
#if defined(__STDC__) || defined(__cplusplus)
#include <stdlib.h>
#endif

#include <aos.h>
#include <axtime.h>
#include <int_enc.p>



#define ENCRYPT_LEN 200  /* if this is changed, change in elb.c too */
#define MAX_PASSWD_SIZE 25
 
 
/* the following are the positions in the encrypted string at which we keep */
/* the password characters.  Each of these positions must be unique,      */
/* must be greater than 27, (since we put the length some place in the     */
/* first 27 characters) and less than ENCRYPT_LEN                          */
static short enc_pos[MAX_PASSWD_SIZE] = { 191, 45, 67, 110, 189, 
                                          172, 62, 90, 131, 162,
                                          111, 57, 74, 181, 139,
                                          129, 31, 77, 166, 143,
                                          124, 58, 99, 147, 125 };



#if 0  /* { */
   /** This is a stnadalone test stub */
   /****** broken - AddEncryptedPasswordToTable() now in elb.c ********/
#define NULL 0
char *AxMalloc( size )
int size;
{
    return( (char *)malloc(size) );
}

char *AxRealloc( ptr, size )
char *ptr;
int size;
{
    return( (char *)realloc( ptr, size ) );
}

void AddEncryptedPasswordToTable();
char *GetEncryptedPassword();
void GetClearPassword();
 
main()
{
    char *buff;
    char password[25];

    AddEncryptedPasswordToTable( "host", "passwd" ); /* broken - now in elb.c */

    buff = GetEncryptedPassword( "host", buff );
 
    GetClearPassword( buff, password );

}
#endif  /* } */






#if defined(__STDC__) || defined(__cplusplus)
static void GenerateRandomBuffer (
char *buff
)
#else
static void GenerateRandomBuffer( buff )
char *buff;
#endif
{
    char *buffP;
    char c;
 
    srand(time(0L));     /* see the random number generateor */
 
    buffP = buff;
    while ( buffP < (buff+ENCRYPT_LEN) )
       {
       c = rand() % 0x7F;
       if ( buffP == buff )
          {
          /* first char must be lower-case alphabetic since we use it as */
          /* an index to the length char during encryption               */
          if ((c >= 'a') && (c <= 'z'))
             {
             *buffP = c;
             buffP++;
             }
          }
       else if ( (c >= '0') && (c <= 'z') )
          {
          /* a valid character */
          *buffP = c;
          buffP++;
          }
       }
    return;
}


#if defined(__STDC__) || defined(__cplusplus)
void EncryptPassword (
char *in_password,
char *encrypt_pwd  /* RETURN - must be at least ENCRYPT_LEN+1 */
)
#else
void EncryptPassword (in_password, encrypt_pwd)
char *in_password;
char *encrypt_pwd;  /* RETURN - must be at least ENCRYPT_LEN+1 */
#endif
{
	int i;
	int len;
    char c;
    char password[MAX_PASSWD_SIZE+1];

    strncpy( password, in_password, MAX_PASSWD_SIZE );
    password[MAX_PASSWD_SIZE] = '\0';    /* being safe */

    /* start by filling the buffer with random characters */
    GenerateRandomBuffer( encrypt_pwd );
    encrypt_pwd[ENCRYPT_LEN] = '\0';

    /* the first character is used to determine which of the next */
    /* 26 characters contains the length, modulo 'a'              */
    len = strlen(password);
    i = encrypt_pwd[0] - 'a' + 1;
    encrypt_pwd[i] = 'a' + len;

    /* now put the characters into the buffer at known locations */
    /* we store the upper 4 bits in the upper 4 bits of one byte, and */
    /* the lower four bits in the four bits of the next byte          */
    for ( i=0; i<len; i++ )
        {
        c = password[i];
        encrypt_pwd[ enc_pos[i] ] = (c & 0xF0) | 
                                (encrypt_pwd[ enc_pos[i] ] & 0x0F);
        encrypt_pwd[ enc_pos[i]+1 ] = (c & 0x0F) | 
                                (encrypt_pwd[ enc_pos[i]+1 ] & 0xF0);
        }
}


#if defined(__STDC__) || defined(__cplusplus)
void GetClearPassword (
char *encrypt_pwd,
char *password
)
#else
void GetClearPassword ( encrypt_pwd, password )
char *encrypt_pwd;
char *password;
#endif
{
    int i;
    int len;
    unsigned char c1, c2;

    if ( !encrypt_pwd || (*encrypt_pwd  == '\0') )
        {
        /* null encryption means null result */
        *password = '\0';
        return;
        }

    /* the first character is used to determine which of the next */
    /* 26 characters contains the length, modulo 'a'              */
    i = encrypt_pwd[0] - 'a' + 1;
    len = encrypt_pwd[i] - 'a';
    if ( len > MAX_PASSWD_SIZE )
        len = MAX_PASSWD_SIZE;

    /* now get the characters from the buffer at known locations */
    /* we get the upper 4 bits from 1 byte, and the lower four from the */
    /* next byte.                                                       */
    for ( i=0; i<len; i++ )
        {
        c1 = encrypt_pwd[ enc_pos[i] ];
        c2 = encrypt_pwd[ enc_pos[i]+1 ];
        *(password+i) = (c1 & 0xF0) + (c2 & 0x0F);
        }

    *(password+len) = '\0';
    return;
}
 


