/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: msstub.c
   Applix ASC version: 97
   Date: Fri May 28 21:11:46 1999
*/
#include <stdlib.h>
#include <basicwin.h>

extern void DebugMessage(char*);

/* default conversion factor 75dpi */
short UWidMils = 40;
short UHtMils = 40;
short UWidPels = 3;
short UHtPels = 3;

Drawable HostWin;

/* declared in axdnd.c, which NT doesn't build, and never will. */
int AxDndNoMessaging = FALSE;

void AxLogger();
void WXInfoMessage();

char *sys_siglist[20];
int AxMemoryWindow;
int MapMode;


void LoadDialogKeyBindings()
   { return; }
void axolInit()
   { return; }
int TestForSunX()
   { return( 0 ); }
int axolVerbButtonSize()
   { return( 50 ); }


void AXmUpdateDialogSize()    /* will we ever need this? */
{  return;  /*DebugMessage("AXmUpdateDialogSize called");*/ }


DlgLiftCursor(){}
ElfbTest(){}  
ElfbFetchAndRun(){}


int getuid()
{
    char *p;
    int uid;

    uid = -1;
    p = getenv( "UNIX_UID" );
    if ( p != (char *)NULL )
       {
       uid = atoi( p );
       if ( uid == 0 )
          uid = -1;
       }
    return( uid );
}



void nice() {}
#if 0
void getpagesize(){DebugMessage("getpagesize called");}
void scanr(){DebugMessage("scanr called");}
void kill(){DebugMessage("kill called");}
void fcntl(){DebugMessage("fcntl called");}
void fork(){DebugMessage("fork called");}
void readlink(){DebugMessage("readlink called");}
#endif

void sleep(int duration) { MS_Sleep(duration*1000); }

void fsync(){return;}    /* there seems to be no equivalent on NT.
                          * can we safely assume no-op?   -donato
                          */

#if 0
void Acopy(){DebugMessage("Acopy called");}
void Amkdir(){DebugMessage("Amkdir called");}
void Amove(){DebugMessage("Amove called");}
void Armdir(){DebugMessage("Armdir called");}

void openImage(){DebugMessage("openImage called");}
void closei(){DebugMessage("closei called");}
#endif


/***************************/
/** move to xmlibcom.c ? */
void AxShowMemoryWindow(){DebugMessage("AxShowMemoryWindow called");}
/***************************/


void ElfbDBList(){DebugMessage("ElfbDBList called");}

/* (xmlib.c) */
void ElfbFixupQuirks(){DebugMessage("ElfbFixupQuirks called");}
void ZXtDispatchEvent(){DebugMessage("ZXtDispatchEvent called");}
/***************************/





void ATMexit()
{
    exit(0);
}



void AxRegisterStandardColormap() {DebugMessage("AxRegisterStandardColormap called");}
void AxDestroyStandardColormap() { return; }

#if 0
void beep()
{
    MS_Beep(1000, 100);
}
#endif



/* from tmx.c */
void WMinit() { ; }    /* NT init'd elsewhere, so do nothing */ 
void SetWidgetVal() {DebugMessage("SetWidgetVal called");}

/** obsolete */
void AXmNoMapThisWindow() {DebugMessage("AXmNoMapThisWindow called");}


/* from xmoption.c */
void AXmCreateOptionMenu() { DebugMessage("AXmCreateOptionMenu called"); }



/* for now. eventually need to remove from here and tmxcom.c */
int atm_modify() { return 0; }


/* this will get called by widget's painter, but Windows *
 * will already have drawn it, so do nothing.            */
void PaintStatus() { return; }

void EditBoxDrawCursor() { return; }


/* OpenLook only stuff */
GC olButtonGC;
void olClrRecessButtonGC() { return; }
void olClrShadowButtonGC() { return; }
void olClrSunButtonGC() { return; }


void editboxClearSelection() {return;}


/** from xinifont.c.  do we need to port or common-ify these? **/
char *AxProfileValue(){ return((char*)NULL); }



/*********************************
 * editbox widget functions that *
 * are no-ops for NT.   for now? *
 *********************************/
void drawCursor(){};
void rewindCursor(){};
void dispCursorAtCenter(){}; 
void formatObjs(){};
void paintText(){};


/* FOR NOW ?! */
void SetWindowHints(){return;}    /* no-op on NT */
void ZXmHammerStandardProperties(){return;}    /* no-op on NT */


/* this may be called from ArmRibbon, but has no meaning on NT *
 * so just return */
void PaintOptionPulldown() {return;}


/* we use Windows listboxes and scrollbars, so these are no-ops */
void xmDestroyListPixmap() {return;}
void xmDestroyScrollPixmap() {return;}

/***************************************************************************/
/* the "new" W_COMBO widget is actually the same as the original
 * W_OPTION on Windows, so we never need to create Applixware combo-boxes
 * on Windows. These stubs are here to keep code generic.
 */
void *ComboBoxInEditWindow = NULL;
void *AXmCreateComboBox(){return NULL;}
int CbComputeComboHeight(XFontStruct *fs) { return 0; }
void CbEditDrawCursor(void *w, int mode) {return;}
/***************************************************************************/

#if 0
/*** TEMP, do NOT check in to source control!! ***/
void ElfXCeboxFocusChanged(){return;}
void ElfXCfieldChanged(){return;}
void ElfXentryButtonPress(){return;}
/*************************************************/
#endif
