/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: otparams.h
   Applix ASC version: 3
   Date: Mon Nov 16 13:53:26 1998
*/
#ifndef	__OTPARAMS_H	/* { */
#define	__OTPARAMS_H

#ifndef MAX_BLOCKS
#define MAX_BLOCKS 128  /* for file buffering 128 * 32K -> 4 Meg */
#endif

typedef struct {
	int fd;			/* virtual file desc */
    caddr_t *ptrs; /* pointer to array of object ptrs */
    unsigned short *flags;   /* pointer to array of object flags */
	int *sizes;			/* sizes as know to SS */
    long *fileAddrs;    /* offsets in the file read */
    long numObjects;        /* total number of objects currently allocated */
    unsigned long topObj;       /* current object number */
    unsigned long freeObj;  /* free object linked list*/
    unsigned long maxObjs;      /* limit of object table */
} otParams;

/* the globals in zoom.c were converted into this structure */
typedef struct {
	int smallFrame;	/* used by GE & calc - small mode boom */
	int abortOnError;         /* TRUE if should abort on all errors */
} otParams2 ;

#endif	/* } */
