/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: rpc_err.c
   Applix ASC version: 10
   Date: Mon Nov 16 13:53:26 1998
*/
#if AXMS
#include <stdlib.h>    /* for sys_errlist */
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <axsocket.h>
#include <errno.h>
#include <signal.h>

#define THIM_STATIC 1    /** do not redefine such things as "exit()"  */
#include <aos.h>
#include <elfapi.h>

#if !AXMS && !LINUX
/* NT declares this is stdlib.h */
extern char *sys_errlist[]; /* Unix errro strings */
extern int sys_nerr;
#endif

extern void AxErrnoError();

void AxErrnoError(msg)
char *msg;
{
    static char buf[100];
    char *p;
    extern int errno;

    if ( errno < sys_nerr )
        printf("%s: %s\n",msg,sys_errlist[errno]);
    else
        printf("%s: Error number %d\n",msg,errno); 
    BadExit( errno );
}

void AxIntErrAbort(msg)
char *msg;
{
    printf("%s\n",msg);

#if AXMS
    /* make sure that we clean up any socket stuff */
    WSACleanup();
#endif

    abort();
}

