/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tm1sbdef.h
   Applix ASC version: 1
   Date: Mon Nov 16 14:27:46 1998
*/
#define SQUARE_IS_OFFSET_FROM_TEXT_HEIGHT        2

/* This offset indicates how far from the left side of the canvas the
   leftmost element (e.g. - the element with the highest level) will
   be displayed. */
#define INIT_X_OFFSET                            4

/* This offset indicates the space between the portion drawn hierarchy 
   for an element (either a line for a base element, or a box for a
   consolidation element) and the text of that element name. */
#define SPACE_BETWEEN_TEXT_AND_BOX_OR_LINE       2

/* canvas size measurements */
#define CANVAS_MAX_HEIGHT_WITH_HSCROLL         400
#define CANVAS_MAX_HEIGHT_WITHOUT_HSCROLL      420
#define CANVAS_MAX_WIDTH_WITHOUT_VSCROLL       330
#define CANVAS_MAX_WIDTH_WITH_VSCROLL          310

/* Since the canvas is a height is a multiple of the text height, the 
   text of the last element displayed rests directly on top of the end
   of the canvas (and looks weird).  Adding a fudge factor allows for
   some whitespace below the text, and looks better. */
#define CANVAS_VERTICAL_FUDGE_FACTOR     1

/* constants for defining whether an entry has a line in a particular
   "line column" array */
#define VERT_LINE_FULL 2
#define VERT_LINE_HALF 1
#define VERT_LINE_NONE 0

/* flags for indicating canvas points that correspond to no element entry */
#define CANVAS_POINT_BEFORE_FIRST_LIST_ELEMENT  -1
#define CANVAS_POINT_AFTER_LAST_LIST_ELEMENT    -2

/* flags for indicating the state of the tabbed panel */
#define TM1_SUBSET_PANEL_IN_ADVANCED_MODE        1
#define TM1_SUBSET_PANEL_IN_SIMPLE_MODE          2
