/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tm1ui.c
   Applix ASC version: 9
   Date: Mon Nov 16 14:27:35 1998
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#define AX_USE_PROTOS 1
#include <aos.h>
#include <elfapi.h>
#include <tm1ui.h>
#include <tm1brdef.h>
#include <tm1sbdef.h>
#include <tm1sbst.h>

/***************/
/* Definitions */
/***************/

#define FALSE    0
#ifdef TRUE
#undef TRUE
#endif
#define TRUE    -1

/**********************************/
/* Prototypes of Local Procedures */
/**********************************/

data_ptr tm1ui_calc_browse_canvas_layout_aux(data_ptr binfo,
					    data_ptr bheight,
					    data_ptr bwidth,
					    data_ptr ewidth,
					    data_ptr cwidth);
int tmui_calc_max_text_widths(data_ptr diminfo_array,
			      int dsize,
			      data_ptr cnvsData,
			      data_ptr penData,
			      int *out_elemwidth,
			      int *out_boxwidth);
data_ptr tm1ui_calc_box_structure(int newpoint_x,
				 int newpoint_y,
				 data_ptr diminfo,
				 int areawidth,
				 int areaheight,
				 int *rval);

data_ptr tm1ui_get_view_info(data_ptr binfo, int *rval);
data_ptr tm1ui_get_layout_info(data_ptr vinfo, int *rval);
data_ptr tm1ui_get_row_array(data_ptr lData, int *rval);
data_ptr tm1ui_get_col_array(data_ptr lData, int *rval);
data_ptr tm1ui_get_unalloc_array(data_ptr lData, int *rval);
data_ptr tm1ui_get_layout_array(data_ptr lData, int idx, int *rval);
data_ptr tm1ui_get_dim_info(data_ptr dData_ary, int idx, int *rval);
data_ptr tm1ui_get_dimname(data_ptr diminfo, int *rval);
data_ptr tm1ui_get_subset_info(data_ptr diminfo, int *rval);
data_ptr tm1ui_get_subset_name(data_ptr subsetinfo, int *rval);
data_ptr tm1ui_get_subset_elements(data_ptr subsetinfo, int *rval);
data_ptr tm1ui_get_subset_single_element(data_ptr subsetinfo, int *rval);

data_ptr tm1ui_cbox_add_upperleft_x(data_ptr cbox, int x, int *rval);
data_ptr tm1ui_cbox_add_upperleft_y(data_ptr cbox, int y, int *rval);
data_ptr tm1ui_cbox_add_boxstring(data_ptr cbox, data_ptr rdstr, int *rval);
data_ptr tm1ui_cbox_add_elemstring(data_ptr cbox, data_ptr rdstr, int *rval);
data_ptr tm1ui_cbox_add_subsetstring(data_ptr cbox, data_ptr rdstr, int *rval);
data_ptr tm1ui_cbox_add_real_dimname(data_ptr cbox, data_ptr rdstr, int *rval);
data_ptr tm1ui_cbox_add_string_by_index(data_ptr cbox, data_ptr rdstr, int idx, int *rval);
data_ptr tm1ui_cbox_add_total_area(data_ptr cbox, int x, int y, int width, int height);

data_ptr tm1ui_make_area_def(int x, int y, int width, int height);
int tm1ui_get_array_size(data_ptr ary);

data_ptr tm1ui_subset_calc_box(int unadjx,
			      int unadjy, 
			      int square_size);
data_ptr tm1ui_subset_create_entry(char *elemname, 
				  int levnum,
				  int level_max,
				  int curr_x, 
				  int curr_y, 
				  int square_size,
				  int textw,
				  int box_x,
				  int *max_total_width);
int
tm1ui_subset_find_parent_index(char **element_parents,
			       int num_parents,
			       char **potential_parents,
			       int level_max);
data_ptr
tm1ui_subset_calc_layout(int num_elems,
			 data_ptr elemlist, 
			 data_ptr parentlist,
			 data_ptr levlist, 
			 data_ptr text_x_pos_list,
			 int level_max,
			 int text_height,
			 int square_size,
			 data_ptr text_widths,
			 data_ptr box_x_pos_by_level,
			 data_ptr canonical_element_list);
void
tm1ui_subset_calc_hierarchy_lines(data_ptr current_entry,
				  int entry_idx,
				  char *elemname,
				  int levnum,
				  char ***in_potential_parents,
				  char **element_parents,
				  int num_parents,
				  int **in_higher_up_idxs,
				  int level_max,
				  data_ptr entry_list,
				  data_ptr levlist,
				  int canonical_index);
void
tm1ui_subset_free_potential_parents(char **potential_parents,
				    int level_max);
void
tm1ui_subset_handle_first_last_idxs(data_ptr entry,
				    int kid_idx);
void
tm1ui_subset_set_had_kids_displayed(data_ptr entry,
				    int has_kids_displayed);
void
tm1ui_subset_add_line_at_level(data_ptr entry, 
			       int levnum,
			       int line_type);
int
tm1ui_subset_get_first_idx(data_ptr member_entry);
void
tm1ui_subset_set_lev_of_hline(data_ptr entry,
			      int lev_of_hline);
void
tm1ui_subset_replace_parent_at_index(char **potential_parents,
				     int idx,
				     char *new_parent);
int
tm1ui_subset_find_canonical_index(char *elemname, 
				  data_ptr canonical_element_list);
void
tm1ui_subset_free_actual_parents(char ***actual_parents,
				 int canonical_num_elems,
				 int *num_parents_array);
int tm1ui_subset_get_level(data_ptr entry);

/****************************************************/
/* Procedures For Helping Calculate Browser Layouts */
/****************************************************/

/**************************************************************************
 * tm1ui_calc_browse_init_canvas_layout
 */
data_ptr
tm1ui_calc_browse_init_canvas_layout(data_ptr funcData)
{
  data_ptr cnvsData, penData, binfo, rData;
  data_ptr twData, txtData, vinfo, linfo, diminfo, dimname;
  data_ptr rowarray, colarray, unallocarray;
  int elemwidth, boxwidth, myboxwidth, textwidth;
  int rval, ix, rasize, casize, uasize;

  /* verify basic input correctness, and parse out arguments */
  if (! AxIsArray(funcData)) {
    return(NULL);
  }
  if (AxArraySize(funcData) < 3) {
    return(NULL);
  }
  binfo = AxArrayElement(funcData, 0);
  cnvsData = AxArrayElement(funcData, 1);
  penData = AxArrayElement(funcData, 2);

  /* parse out the tm1_Browz_info$ structure */
  rval = tm1ui_parse_binfo(binfo, &vinfo, &linfo, &rowarray,
	   &colarray, &unallocarray, &rasize, &casize, &uasize);
  if (FALSE == rval) {
    goto do_error_return;
  }

  /* calculate the box & element/subset widths to find the
     maximum values */
  elemwidth = 0;
  boxwidth = 0;
  rval = tmui_calc_max_text_widths(rowarray, rasize, cnvsData,
		   penData, &elemwidth, &boxwidth);
  if (FALSE == rval) {
    goto do_error_return;
  }
  rval = tmui_calc_max_text_widths(colarray, casize, cnvsData,
		   penData, &elemwidth, &boxwidth);
  if (FALSE == rval) {
    goto do_error_return;
  }
  rval = tmui_calc_max_text_widths(unallocarray, uasize, cnvsData,
		   penData, &elemwidth, &boxwidth);
  if (FALSE == rval) {
    goto do_error_return;
  }

  /* return the layout values */
  rData = AxMakeArray(2);
  rData = AxAddIntToArray(rData, 0, boxwidth);
  rData = AxAddIntToArray(rData, 1, elemwidth);
  return(rData);

 do_error_return:
  return(NULL);
} /* tm1ui_calc_browse_init_canvas_layout */

/**************************************************************************
 *
 */
int
tmui_calc_max_text_widths(data_ptr diminfo_array,  /* IN */
			  int dsize,              /* IN */
			  data_ptr cnvsData,       /* IN */
			  data_ptr penData,        /* IN */
			  int *out_elemwidth,     /* IN/OUT */
			  int *out_boxwidth)      /* IN/OUT */
{
  int ix, rval, textwidth, myboxwidth;
  data_ptr diminfo, dimname, dname_ary, txtData, twData;
  int elemwidth = *out_elemwidth;
  int boxwidth = *out_boxwidth;

  for (ix=0; (ix < dsize); ix++) {
    /* get the dimension info */
    diminfo = tm1ui_get_dim_info(diminfo_array, ix, &rval);
    if (FALSE == rval) {
      return(FALSE);
    }

    /* calculate the name to go in the box */
    dimname = tm1ui_get_dimname(diminfo, &rval);
    if (FALSE == rval) {
      return(FALSE);
    }
    dname_ary = AxMakeArray(0);
    dname_ary = AxAddDataToArray(dname_ary, 0, dimname);
    rval = ElfCallByName("tm1_remove_server_name", &txtData, 1,
			 dimname);
    if (0 != rval) {
      if ((AxIsArray(twData)) &&
	  (AxIsString(AxArrayElement(twData,0)))) {
	char *str = AxStrPtrFromArray(twData,0);
      }
      return(FALSE);
    }

    /* calculate the size of the box */
    rval = ElfCallByName("tm1ui_calc_textwidth$", &twData, 3, cnvsData,
			 penData, txtData);
    if (0 != rval) {
      if ((AxIsArray(twData)) &&
	  (AxIsString(AxArrayElement(twData,0)))) {
	char *str = AxStrPtrFromArray(twData,0);
      }
      return(FALSE);
    }
    if (! AxIsInt(twData)) {
      return(FALSE);
    }
    textwidth = AxIntFromDataPtr(twData);
    myboxwidth = textwidth + TEXT_BOX_LEFT_SPACE + TEXT_BOX_RIGHT_SPACE;

    /* calculate the maximum box width seen so far */
    if (myboxwidth > boxwidth) {
      boxwidth = myboxwidth;
    }

    /* calculate the width of the element string */
    rval = ElfCallByName("tm1ui_get_element_string$", &txtData, 1, diminfo);
    if (0 != rval) {
      if ((AxIsArray(txtData)) &&
	  (AxIsString(AxArrayElement(txtData,0)))) {
	char *str = AxStrPtrFromArray(txtData,0);
      }
      return(FALSE);
    }
    if (! AxIsString(txtData)) {
      return(FALSE);
    }
    rval = ElfCallByName("tm1ui_calc_textwidth$", &twData, 3, cnvsData,
			 penData, txtData);
    if (0 != rval) {
      if ((AxIsArray(twData)) &&
	  (AxIsString(AxArrayElement(twData,0)))) {
	char *str = AxStrPtrFromArray(twData,0);
      }
      return(FALSE);
    }
    if (! AxIsInt(twData)) {
      return(FALSE);
    }
    textwidth = AxIntFromDataPtr(twData);
    if (textwidth > elemwidth) {
      elemwidth = textwidth;
    }

    /* calculate the width of the subset string */
    rval = ElfCallByName("tm1ui_get_subset_string$", &txtData, 1, diminfo);
    if (0 != rval) {
      if ((AxIsArray(txtData)) &&
	  (AxIsString(AxArrayElement(txtData,0)))) {
	char *str = AxStrPtrFromArray(txtData,0);
      }
      return(FALSE);
    }
    if (! AxIsString(txtData)) {
      return(FALSE);
    }
    rval = ElfCallByName("tm1ui_calc_textwidth$", &twData, 3, cnvsData,
			 penData, txtData);
    if (0 != rval) {
      if ((AxIsArray(twData)) &&
	  (AxIsString(AxArrayElement(twData,0)))) {
	char *str = AxStrPtrFromArray(twData,0);
      }
      return(FALSE);
    }
    if (! AxIsInt(twData)) {
      return(FALSE);
    }
    textwidth = AxIntFromDataPtr(twData);
    if (textwidth > elemwidth) {
      elemwidth = textwidth;
    }
  }

  *out_elemwidth = elemwidth;
  *out_boxwidth = boxwidth;
  return(TRUE);
} /* tmui_calc_max_text_widths */

/**************************************************************************
 * tm1ui_calc_browse_canvas_layout - calculates the layout of the
 *     browser canvas
 */
data_ptr
tm1ui_calc_browse_canvas_layout(data_ptr funcData)
{
  data_ptr binfo, bheight, bwidth, ewidth, cwidth, rData;

  if (! AxIsArray(funcData)) {
    return(NULL);
  }
  if (AxArraySize(funcData) < 5) {
    return(NULL);
  }
  binfo = AxArrayElement(funcData, 0);
  bheight = AxArrayElement(funcData, 1);
  bwidth = AxArrayElement(funcData, 2);
  ewidth = AxArrayElement(funcData, 3);
  cwidth = AxArrayElement(funcData, 4);

  rData = tm1ui_calc_browse_canvas_layout_aux(binfo, bheight, bwidth,
					      ewidth, cwidth);
  return(rData);
}  /* tm1ui_calc_browse_canvas_layout */

/**************************************************************************
 * tm1ui_calc_browse_canvas_layout_aux
 */
data_ptr
tm1ui_calc_browse_canvas_layout_aux(data_ptr binfo,   /* IN */
				    data_ptr bheight, /* IN */
				    data_ptr bwidth,  /* IN */
				    data_ptr ewidth,  /* IN */
				    data_ptr cwidth)  /* IN */
{
  int rasize, casize, uasize, ix, rval;
  int newpoint_x, newpoint_y, boxheight, boxwidth, elemwidth;
  int saved_max_point, saved_y_point, saved_x_point;
  int elem_col_xcoord_unalloc, elem_col_xcoord_rowcol;
  int cnvs_height, cnvs_width;
  int uawidth, uaheight, tmp, rax, raheight, rawidth;
  data_ptr vinfo, linfo, diminfo;
  data_ptr rowarray, colarray, unallocarray;
  data_ptr returnData;
  data_ptr unalloc_area, row_area, col_area, elem_area;
  data_ptr currbox;
  data_ptr rboxary = NULL;
  data_ptr cboxary = NULL;
  data_ptr uboxary = NULL;
  data_ptr row_label_pos = NULL;
  data_ptr column_label_pos = NULL;

  if (! AxIsInt(bheight)) {
    goto do_error_return;
  }
  boxheight = AxIntFromDataPtr(bheight);

  if (! AxIsInt(bwidth)) {
    goto do_error_return;
  }
  boxwidth = AxIntFromDataPtr(bwidth);

  if (! AxIsInt(ewidth)) {
    goto do_error_return;
  }
  elemwidth = AxIntFromDataPtr(ewidth);

  if (! AxIsInt(cwidth)) {
    goto do_error_return;
  }
  cnvs_width = AxIntFromDataPtr(cwidth);

  rval = tm1ui_parse_binfo(binfo, &vinfo, &linfo, &rowarray,
	   &colarray, &unallocarray, &rasize, &casize, &uasize);
  if (FALSE == rval) {
    goto do_error_return;
  }

  /* get the initial upperleft point for the unalloc'ed stack */
  newpoint_x = LAYOUT_UPPER_LEFT_X;
  newpoint_y = LAYOUT_UPPER_LEFT_Y;

  for (ix=0; (ix < uasize); ix++) {
    /* get the dimension info */
    diminfo = tm1ui_get_dim_info(unallocarray, ix, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* use the info to fill in the current box structure */
    currbox = tm1ui_calc_box_structure(newpoint_x, newpoint_y, diminfo,
       (boxwidth + BETWEEN_BOX_N_ELEM_MIN_SPACE + elemwidth),
       boxheight, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* assign the box info the the unalloc'ed list */
    if (NULL == uboxary) {
      uboxary = AxMakeArray(uasize);
    }
    uboxary = AxAddArrayToArray(uboxary, ix, currbox);

    /* adjust the y coordinate for the next iteration */
    newpoint_y += boxheight + BOX_VERT_SPACE;
  }

  saved_x_point = LAYOUT_UPPER_LEFT_X + boxwidth + BOX_HORIZ_SPACE;
  elem_col_xcoord_unalloc = LAYOUT_UPPER_LEFT_X + boxwidth +
    BETWEEN_BOX_N_ELEM_MIN_SPACE;

  /* record the area of the unalloced dimensions */
  uawidth = saved_x_point;
  uaheight = newpoint_y;
  unalloc_area = tm1ui_make_area_def(0, 0, uawidth, uaheight);

  /* adjust the upperleft point to the start point for the row stack */
  saved_y_point = newpoint_y;
  newpoint_x = saved_x_point;
  newpoint_y = saved_y_point + (casize * (boxheight + BOX_VERT_SPACE));

  /* handle the row & column labels */
  if (rasize > 0) {
    row_label_pos = AxMakeArray(2);
    row_label_pos = AxAddIntToArray(row_label_pos, 0,
				    LAYOUT_UPPER_LEFT_X);
    row_label_pos = AxAddIntToArray(row_label_pos, 1, newpoint_y);
  }
  if (casize > 0) {
    column_label_pos = AxMakeArray(2);
    column_label_pos = AxAddIntToArray(column_label_pos, 0,
				       LAYOUT_UPPER_LEFT_X);
    column_label_pos = AxAddIntToArray(column_label_pos, 1,
				       saved_y_point);
  }

  /* handle the row dimensions second */
  for (ix=0; (ix < rasize); ix++) {
    /* get the dimension info */
    diminfo = tm1ui_get_dim_info(rowarray, ix, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* use the info to fill in the current box structure */
    currbox = tm1ui_calc_box_structure(newpoint_x, newpoint_y,
	       diminfo, (cnvs_width - newpoint_x), boxheight, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* assign the box info the the row list */
    if (NULL == rboxary) {
      rboxary = AxMakeArray(rasize);
    }
    rboxary = AxAddArrayToArray(rboxary, ix, currbox);

    /* adjust the y coordinate for the next iteration */
    newpoint_y += boxheight + BOX_VERT_SPACE;
  }
  saved_max_point = newpoint_y;

  /* record the area of the row dimensions */
  tmp = uaheight + (casize * (boxheight + BOX_VERT_SPACE));
  rax = uawidth;
  rawidth = boxwidth + BOX_HORIZ_SPACE;
  raheight = saved_max_point - tmp;
  row_area = tm1ui_make_area_def(rax, tmp, rawidth, raheight); 

  /* adjust the upperleft point to the start point for the column stack */
  newpoint_x = saved_x_point + boxwidth + BOX_HORIZ_SPACE;
  newpoint_y = saved_y_point;

  /* handle the column dimensions third */
  for (ix=0; (ix < casize); ix++) {
    /* get the dimension info */
    diminfo = tm1ui_get_dim_info(colarray, ix, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* use the info to fill in the current box structure */
    currbox = tm1ui_calc_box_structure(newpoint_x, newpoint_y, diminfo,
       (boxwidth + BETWEEN_BOX_N_ELEM_MIN_SPACE + elemwidth),
       boxheight, &rval);
    if (FALSE == rval) {
      goto do_error_return;
    }

    /* assign the box info the the column list */
    if (NULL == cboxary) {
      cboxary = AxMakeArray(casize);
    }
    cboxary = AxAddArrayToArray(cboxary, ix, currbox);

    /* adjust the y coordinate for the next iteration */
    newpoint_y += boxheight + BOX_VERT_SPACE;
  }

  /* calculate the x coordinate of the column of element/subset names */
  elem_col_xcoord_rowcol = newpoint_x + boxwidth + BETWEEN_BOX_N_ELEM_MIN_SPACE;

  /* record the area of the column dimensions */
  col_area = tm1ui_make_area_def((rax + rawidth), saved_y_point,
	 (boxwidth + BETWEEN_BOX_N_ELEM_MIN_SPACE),
	 (casize * (boxheight + BOX_VERT_SPACE)));

  /* calculate the width & height of the layout canvas */
  cnvs_width = elem_col_xcoord_rowcol + elemwidth + ADD_TABLE_LOWER_RIGHT_X;
  cnvs_height = saved_max_point + ADD_TABLE_LOWER_RIGHT_Y;

  /* record the area for the element/subset names */
  elem_area = tm1ui_make_area_def(elem_col_xcoord_rowcol,
	 saved_y_point, (ADD_TABLE_LOWER_RIGHT_X + elemwidth),
	 (cnvs_height - saved_y_point));

  /* bundle up the all the calculated data and return it */
  returnData = AxMakeArray(13);
  returnData = AxAddArrayToArray(returnData, 0, uboxary);
  returnData = AxAddArrayToArray(returnData, 1, rboxary);
  returnData = AxAddArrayToArray(returnData, 2, cboxary);
  returnData = AxAddArrayToArray(returnData, 3, unalloc_area);
  returnData = AxAddArrayToArray(returnData, 4, row_area);
  returnData = AxAddArrayToArray(returnData, 5, col_area);
  returnData = AxAddArrayToArray(returnData, 6, elem_area);
  returnData = AxAddArrayToArray(returnData, 7, row_label_pos);
  returnData = AxAddArrayToArray(returnData, 8, column_label_pos);
  returnData = AxAddIntToArray(returnData, 9, cnvs_width);
  returnData = AxAddIntToArray(returnData, 10, cnvs_height);
  returnData = AxAddIntToArray(returnData, 11, elem_col_xcoord_rowcol);
  returnData = AxAddIntToArray(returnData, 12, elem_col_xcoord_unalloc);
  return(returnData);

 do_error_return:
  return(NULL);
} /* tm1ui_calc_browse_canvas_layout_aux */


/**************************************************************************
 * tm1ui_parse_binfo
 */
int
tm1ui_parse_binfo(data_ptr binfo,          /* IN */
		  data_ptr *vinfo,         /* OUT */
		  data_ptr *linfo,         /* OUT */
		  data_ptr *rowarray,      /* OUT */
		  data_ptr *colarray,      /* OUT */
		  data_ptr *unallocarray,  /* OUT */
		  int *rasize,            /* OUT */
		  int *casize,            /* OUT */
		  int *uasize)            /* OUT */
{
  int rval;

  *vinfo = tm1ui_get_view_info(binfo, &rval);
  if (FALSE == rval) {
    return(FALSE);
  }
  *linfo = tm1ui_get_layout_info(*vinfo, &rval);
  if (FALSE == rval) {
    return(FALSE);
  }
  *rowarray = tm1ui_get_row_array(*linfo, &rval);
  if (FALSE == rval) {
    return(FALSE);
  }
  *colarray = tm1ui_get_col_array(*linfo, &rval);
  if (FALSE == rval) {
    return(FALSE);
  }
  *unallocarray = tm1ui_get_unalloc_array(*linfo, &rval);
  if (FALSE == rval) {
    return(FALSE);
  }
  *rasize = tm1ui_get_array_size(*rowarray);
  if (-1 == *rasize) {
    return(FALSE);
  }
  *casize = tm1ui_get_array_size(*colarray);
  if (-1 == *casize) {
    return(FALSE);
  }
  *uasize = tm1ui_get_array_size(*unallocarray);
  if (-1 == *uasize) {
    return(FALSE);
  }
  return(TRUE);
} /* tm1ui_parse_binfo */

/**************************************************************************
 * tm1ui_calc_box_structure
 */
data_ptr
tm1ui_calc_box_structure(int newpoint_x,  /* IN */
			 int newpoint_y,  /* IN */
			 data_ptr diminfo, /* IN */
			 int areawidth,    /* IN */
			 int areaheight,   /* IN */
			 int *rval)       /* OUT */
{
  data_ptr currbox = NULL;
  data_ptr strData, strData2, dname_ary, dimname, sing_elem;
  data_ptr subsetinfo, elem_array, newsinfo;
  int no_subset_elements, no_subset_name, must_free_strData;

  /* get the upperleft point */
  currbox = tm1ui_cbox_add_upperleft_x(currbox, newpoint_x, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
  currbox = tm1ui_cbox_add_upperleft_y(currbox, newpoint_y, rval);
  if (FALSE == *rval) {
    return(NULL);
  }

  /* get the real dimension name stored away */
  dimname = tm1ui_get_dimname(diminfo, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
  currbox = tm1ui_cbox_add_real_dimname(currbox, dimname, rval);
  if (FALSE == *rval) {
    return(NULL);
  }

  /* get the dimension name that goes *in* the box */
  dname_ary = AxMakeArray(0);
  dname_ary = AxAddDataToArray(dname_ary, 0, dimname);
  *rval = ElfCallByName("tm1_remove_server_name", &strData2, 1, dimname);
  if (0 != *rval) {
    if ((AxIsArray(strData2)) &&
	(AxIsString(AxArrayElement(strData2,0)))) {
      char *str = AxStrPtrFromArray(strData2,0);
    }
    return(NULL);
  }

  if (NULL == strData2) {
    return(NULL);
  }
  currbox = tm1ui_cbox_add_boxstring(currbox, strData2, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
   
  /* get the subset information for the names that go *next to* the box */
  subsetinfo = tm1ui_get_subset_info(diminfo, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
  strData2 = tm1ui_get_subset_name(subsetinfo, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
  if ((NULL == strData2) || (! AxIsString(strData2))) {
    no_subset_name = TRUE;
  } else {
    no_subset_name = FALSE;
  }
  elem_array = tm1ui_get_subset_elements(subsetinfo, rval);
  if (FALSE == *rval) {
    return(NULL);
  }
  if ((NULL == elem_array) || (! AxIsArray(elem_array)) ||
      (AxArraySize(elem_array) < 1)) {
    no_subset_elements = TRUE;
  } else {
    no_subset_elements = FALSE;
  }

  /* calculate the name of the *subset* (if this is a row/column
     dimension in the layout) that goes *next to* the box */
  if (no_subset_name) {
    if (no_subset_elements) {
      strData2 = AxMakeStrData(-1, XLT("ALL"));
    } else {
      strData2 = AxMakeStrData(-1, XLT("(Unnamed)"));
    }
    must_free_strData = TRUE;
  } else {
    must_free_strData = FALSE;
  }
  currbox = tm1ui_cbox_add_subsetstring(currbox, strData2, rval);
  if (must_free_strData) {
    AxFreeData(strData2);
  }

  /* calculate the name of the *element* (if this is an unalloc'd
     dimension in the layout) that goes *next to* the box */
  sing_elem = tm1ui_get_subset_single_element(subsetinfo, rval);
  if (NULL != sing_elem) {
    strData = sing_elem;
  } else {
    if (no_subset_elements) {
      if (no_subset_name) {
	char *str;
	*rval = ElfCallByName(NXLT("TM_DFRST"), &strData, 1, dimname);
	str = AxStrPtrFromDataPtr(strData);
	if (0 != *rval) {
	  return(NULL);
	}
      } else {
	*rval = ElfCallByName(NXLT("tm1_get_subset_name_and_elems$"),
			      &newsinfo, 2, dimname, subsetinfo);
	if (0 != *rval) {
	  return(NULL);
	}
	elem_array = tm1ui_get_subset_elements(newsinfo, rval);
	if (FALSE == *rval) {
	  return(NULL);
	}
	strData = AxArrayElement(elem_array,0);
      }
    } else {
      strData = AxArrayElement(elem_array,0);
    }
  }
  currbox = tm1ui_cbox_add_elemstring(currbox, strData, rval);

  /* calculate the total area */
  currbox = tm1ui_cbox_add_total_area(currbox, newpoint_x, newpoint_y,
				      areawidth, areaheight);

  /* return the box value */
  return(currbox);
} /* tm1ui_calc_box_structure */

/**********************************************************/
/* Procedures for Unpacking the tm1_Browz_info$ Structure */
/**********************************************************/

/**************************************************************************
 * tm1ui_get_view_info - given a TM1_Browz_info$ structure, returns
 *      the "view" field's tm1_view_info$ structure; rval returns TRUE
 *      if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_view_info(data_ptr binfo, int *rval)
{
  data_ptr tData;

  if (! AxIsArray(binfo)) {
    goto do_error_return;
  }
  if (AxArraySize(binfo) < 2) {
    goto do_error_return;
  }
  tData = AxArrayElement(binfo, 1); 
  *rval = TRUE;
  return(tData);

 do_error_return:  
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_view_info */

/*********************************************************/
/* Procedures for Unpacking the tm1_view_info$ Structure */
/*********************************************************/

/**************************************************************************
 * tm1ui_get_layout_info - given a tm1_view_info$ structure, returns
 *      the "layout" field's tm1_layout_info$ structure; rval returns
 *      TRUE if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_layout_info(data_ptr vinfo, int *rval)
{
  data_ptr tData;

  if (! AxIsArray(vinfo)) {
    goto do_error_return;
  }
  if (AxArraySize(vinfo) < 2) {
    goto do_error_return;
  }
  tData = AxArrayElement(vinfo, 1); 
  *rval = TRUE;
  return(tData);

 do_error_return:  
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_layout_info */

/***********************************************************/
/* Procedures for Unpacking the tm1_layout_info$ Structure */
/***********************************************************/

#define LAYOUT_INDEX_FOR_ROW_ARRAY        0
#define LAYOUT_INDEX_FOR_COL_ARRAY        1
#define LAYOUT_INDEX_FOR_UNALLOC_ARRAY    2

/**************************************************************************
 * tm1ui_get_row_array - given a tm1_layout_info$ structure, returns
 *     the "rows" array of tm1_dim_info$ structures; rval returns TRUE
 *     if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_row_array(data_ptr lData, int *rval)
{
  data_ptr rData;
  rData = tm1ui_get_layout_array(lData, LAYOUT_INDEX_FOR_ROW_ARRAY,
				 rval);
  return(rData);
} /* tm1ui_get_row_array */

/**************************************************************************
 * tm1ui_get_col_array - given a tm1_layout_info$ structure, returns
 *     the "columns" array of tm1_dim_info$ structures; rval returns
 *     TRUE if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_col_array(data_ptr lData, int *rval)
{
  data_ptr rData;
  rData = tm1ui_get_layout_array(lData, LAYOUT_INDEX_FOR_COL_ARRAY,
				 rval);
  return(rData);
} /* tm1ui_get_col_array */

/**************************************************************************
 * tm1ui_get_unalloc_array - given a tm1_layout_info$ structure, returns
 *     the "unallocd" array of tm1_dim_info$ structures; rval returns
 *     TRUE if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_unalloc_array(data_ptr lData, int *rval)
{
  data_ptr rData;
  rData = tm1ui_get_layout_array(lData, LAYOUT_INDEX_FOR_UNALLOC_ARRAY,
				 rval);
  return(rData);
} /* tm1ui_get_unalloc_array */

/**************************************************************************
 * tm1ui_get_layout_array - auxillary procedure; handles the actual
 *     implementation of three preceding procedures
 */
data_ptr
tm1ui_get_layout_array(data_ptr lData, int idx, int *rval)
{
  data_ptr tData;

  if (AxArraySize(lData) < (idx+1)) {
    *rval = TRUE;
    return(NULL);
  }
  /* get the arrayof tm1_dim_info$ */
  tData = AxArrayElement(lData, idx);
  *rval = TRUE;
  return(tData);
} /* tm1ui_get_layout_array */

/********************************************************/
/* Procedures for Unpacking the tm1_dim_info$ Structure */
/********************************************************/

/**************************************************************************
 * tm1ui_get_dim_info - given an array of tm1_dim_info$ structures,
 *    this procedure returns the tm1_dim_info$ data_ptr structure that
 *    corresponds to the one at that index of the array in the input
 *    value; rval returns TRUE if the parse was successful,a nd FALSE
 *    otherwise
 */
data_ptr
tm1ui_get_dim_info(data_ptr dData_ary, int idx, int *rval)
{
  data_ptr dData;

  if (! AxIsArray(dData_ary)) {
    goto do_error_return;
  }
  if (AxArraySize(dData_ary) < (idx+1)) {
    goto do_error_return;
  }
  dData = AxArrayElement(dData_ary, idx);
  *rval = TRUE;
  return(dData);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_dim_info */

/**************************************************************************
 * tm1ui_get_dimname - given a tm1_dim_info$ structure, returns the
 *     data_ptr containing the dimension name string; rval returns TRUE
 *     if the parse was successful, and FALSE otherwise
 */
data_ptr
tm1ui_get_dimname(data_ptr diminfo, int *rval)
{
  data_ptr strData;

  if (! AxIsArray(diminfo)) {
    goto do_error_return;
  }
  if (AxArraySize(diminfo) < 1) {
    goto do_error_return;
  }
  strData = AxArrayElement(diminfo, 0);
  *rval = TRUE;
  return(strData);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_dimname */

/**************************************************************************
 * tm1ui_get_subset_info
 */
data_ptr
tm1ui_get_subset_info(data_ptr diminfo, int *rval)
{
  data_ptr sinfo;

  if (! AxIsArray(diminfo)) {
    goto do_error_return;
  }
  *rval = TRUE;
  if (AxArraySize(diminfo) < 3) {
    return(NULL);
  }
  sinfo = AxArrayElement(diminfo, 2);
  return(sinfo);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_subset_info */

/***********************************************************/
/* Procedures for Unpacking the tm1_subset_info$ Structure */
/***********************************************************/

/**************************************************************************
 * tm1ui_get_subset_name
 */
data_ptr
tm1ui_get_subset_name(data_ptr subsetinfo, int *rval)
{
  data_ptr sname;

  if (NULL == subsetinfo) {
    *rval = TRUE;
    return(NULL);
  }

  if (! AxIsArray(subsetinfo)) {
    goto do_error_return;
  }
  *rval = TRUE;
  if (AxArraySize(subsetinfo) < 1) {
    return(NULL);
  }
  sname = AxArrayElement(subsetinfo, 0);
  return(sname);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_subset_name */

/**************************************************************************
 * tm1ui_get_subset_elements
 */
data_ptr
tm1ui_get_subset_elements(data_ptr subsetinfo, int *rval)
{
  data_ptr elem_array;

  if (NULL == subsetinfo) { /* default is "ALL" */
    return(NULL);
  }

  if (! AxIsArray(subsetinfo)) {
    goto do_error_return;
  }
  *rval = TRUE;
  if (AxArraySize(subsetinfo) < 2) {
    return(NULL);
  }
  elem_array = AxArrayElement(subsetinfo, 1);
  return(elem_array);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_subset_elements */

/**************************************************************************
 * tm1ui_get_subset_single_element
 */
data_ptr
tm1ui_get_subset_single_element(data_ptr subsetinfo, int *rval)
{
  data_ptr sing_elem;

  if (NULL == subsetinfo) {
    return(NULL);
  }

  if (! AxIsArray(subsetinfo)) {
    goto do_error_return;
  }
  *rval = TRUE;
  if (AxArraySize(subsetinfo) < 3) {
    return(NULL);
  }
  sing_elem = AxArrayElement(subsetinfo, 2);
  if (! AxIsString(sing_elem)) {
    return(NULL);
  }
  return(sing_elem);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_get_subset_single_element */

/**************************************************************/
/* Procedures for Handling TM1Browse.ab's "canvas_box" format */
/**************************************************************/

/**************************************************************************
 * tm1ui_cbox_add_upperleft_x
 */
data_ptr
tm1ui_cbox_add_upperleft_x(data_ptr cbox, int x, int *rval)
{
  data_ptr ulpoint;

  if (NULL == cbox) {
    cbox = AxMakeArray(0);
  add_point:
    ulpoint = AxMakeArray(0);
    ulpoint = AxAddIntToArray(ulpoint, 0, x);
    cbox = AxAddArrayToArray(cbox, 0, ulpoint);
    *rval = TRUE;
    return(cbox);
  }
  if (! AxIsArray(cbox)) {
    goto do_error_return;
  }
  if (AxArraySize(cbox) < 1) {
    goto add_point;
  }

  ulpoint = AxArrayElement(cbox, 0);
  if (! AxIsArray(ulpoint)) {
    goto do_error_return;
  }

  ulpoint = AxAddIntToArray(ulpoint, 0, x);
  AxOverwriteArray(cbox, 0, ulpoint);
  *rval = TRUE;
  return(cbox);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_cbox_add_upperleft_x */

/**************************************************************************
 * tm1ui_cbox_add_upperleft_y
 */
data_ptr
tm1ui_cbox_add_upperleft_y(data_ptr cbox, int y, int *rval)
{
  data_ptr ulpoint;

  if (NULL == cbox) {
    cbox = AxMakeArray(0);
  add_point:
    ulpoint = AxMakeArray(0);
    ulpoint = AxAddIntToArray(ulpoint, 1, y);
    cbox = AxAddArrayToArray(cbox, 0, ulpoint);
    *rval = TRUE;
    return(cbox);
  }
  if (! AxIsArray(cbox)) {
    goto do_error_return;
  }
  if (AxArraySize(cbox) < 1) {
    goto add_point;
  }

  ulpoint = AxArrayElement(cbox, 0);
  if (! AxIsArray(ulpoint)) {
    goto do_error_return;
  }

  ulpoint = AxAddIntToArray(ulpoint, 1, y);
  AxOverwriteArray(cbox, 0, ulpoint);
  *rval = TRUE;
  return(cbox);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_cbox_add_upperleft_y */

/**************************************************************************
 * tm1ui_cbox_add_boxstring - 
 */
data_ptr
tm1ui_cbox_add_boxstring(data_ptr cbox, data_ptr rdstr, int *rval)
{
  cbox = tm1ui_cbox_add_string_by_index(cbox, rdstr, 1, rval);
  return(cbox);
} /* tm1ui_cbox_add_boxstring */

/**************************************************************************
 * tm1ui_cbox_add_elemstring - 
 */
data_ptr
tm1ui_cbox_add_elemstring(data_ptr cbox, data_ptr rdstr, int *rval)
{
  cbox = tm1ui_cbox_add_string_by_index(cbox, rdstr, 2, rval);
  return(cbox);
} /* tm1ui_cbox_add_elemstring */

/**************************************************************************
 * tm1ui_cbox_add_subsetstring - 
 */
data_ptr
tm1ui_cbox_add_subsetstring(data_ptr cbox, data_ptr rdstr, int *rval)
{
  cbox = tm1ui_cbox_add_string_by_index(cbox, rdstr, 3, rval);
  return(cbox);
} /* tm1ui_cbox_add_subsetstring */

/**************************************************************************
 * tm1ui_cbox_add_real_dimname - 
 */
data_ptr
tm1ui_cbox_add_real_dimname(data_ptr cbox, data_ptr rdstr, int *rval)
{
  cbox = tm1ui_cbox_add_string_by_index(cbox, rdstr, 4, rval);
  return(cbox);
} /* tm1ui_cbox_add_real_dimname */

/**************************************************************************
 * tm1ui_cbox_add_string_by_index - 
 */
data_ptr
tm1ui_cbox_add_string_by_index(data_ptr cbox,  /* IN/OUT */
			       data_ptr rdstr, /* IN */
			       int idx,       /* IN */
			       int *rval)     /* OUT */
{
  char *str;

  if (NULL == cbox) {
    cbox = AxMakeArray(0);
  } else if (! AxIsArray(cbox)) {
    goto do_error_return;
  }

  if (! AxIsString(rdstr)) {
    goto do_error_return;
  }
  str = AxStrFromDataPtr(rdstr);
  cbox = AxAddStrToArray(cbox, idx, str);
  *rval = TRUE;
  return(cbox);

 do_error_return:
  *rval = FALSE;
  return(NULL);
} /* tm1ui_cbox_add_string_by_index */

/**************************************************************************
 * tm1ui_cbox_add_total_area
 */
data_ptr
tm1ui_cbox_add_total_area(data_ptr cbox, /* IN */
			  int x,        /* IN */
			  int y,        /* IN */
			  int width,    /* IN */
			  int height)   /* IN */
{
  data_ptr tData;

  tData = AxMakeArray(4);
  tData = AxAddIntToArray(tData, 0, x);
  tData = AxAddIntToArray(tData, 1, y);
  tData = AxAddIntToArray(tData, 2, width);
  tData = AxAddIntToArray(tData, 3, height);
  cbox = AxAddArrayToArray(cbox, 5, tData);
  return(cbox);
} /* tm1ui_cbox_add_total_area */

/***********************************************/
/* Procedures for Handling gr_area@ Structures */
/***********************************************/

/**************************************************************************
 * tm1ui_make_area_def
 */
data_ptr
tm1ui_make_area_def(int x, int y, int width, int height)
{
  data_ptr grData;

  grData = AxMakeArray(4);
  grData = AxAddIntToArray(grData, 0, x);
  grData = AxAddIntToArray(grData, 1, y);
  grData = AxAddIntToArray(grData, 2, width);
  grData = AxAddIntToArray(grData, 3, height);
  return(grData);
} /* tm1ui_make_area_def */

/*******************************/
/* Generally Useful Procedures */
/*******************************/

/**************************************************************************
 * tm1ui_get_array_size - returns 0 if the input value is NULL;
 *     returns -1 if the input value is not an data_ptr array;
 *     otherwise, returns the size of the data_ptr array
 */
int
tm1ui_get_array_size(data_ptr ary)
{
  int asize;

  if (NULL == ary) {
    return(0);
  }
  if (! AxIsArray(ary)) {
    return(-1);
  }
  asize = AxArraySize(ary);
  return(asize);
} /* tm1ui_get_array_size */

/***************************************************/
/***************************************************/
/** Procedures for Working With the Subset Dialog **/
/***************************************************/
/***************************************************/

/*******************************************************/
/* Procedures for Calculating the Subset Canvas Layout */
/*******************************************************/

/**************************************************************************
 * tm1ui_subset_calc_layout_init - breaks up the input array of
 *     arguments into individual values and passes them on to the main
 *     layout procedure
 */
data_ptr
tm1ui_subset_calc_layout_init(data_ptr funcData)
{
  data_ptr rData;
  char dimname[150];
  char *cptr;
  int num_elems, level_max, text_height, square_size;
  data_ptr elemlist, parentlist, levlist, text_x_pos_list;
  data_ptr text_widths, box_x_pos_by_level, canonical_element_list;

  if (! AxIsArray(funcData)) {
    return(NULL);
  }
  if (AxArraySize(funcData) < 9) {
    return(NULL);
  }

  /* "num_elems" */
  if (! AxIsInt(AxArrayElement(funcData, 0))) {
    return(NULL);
  }
  num_elems = AxIntFromArray(funcData, 0);

  /* "dimname_with_server" */
  if (! AxIsString(AxArrayElement(funcData, 1))) {
    return(NULL);
  }
  cptr = AxStrPtrFromArray(funcData, 1);
  strcpy(dimname, cptr);

  /* retrieve the element, parent and levels lists */
  canonical_element_list = 
    tm1subset_get_pointer_to_subset_elements(dimname, TM1_SUBSET_ALL_NAME);
  parentlist = tm1subset_get_pointer_to_parent_list(dimname);
  levlist = tm1subset_get_pointer_to_level_list(dimname);

  /* "subset_elements" */
  elemlist = AxArrayElement(funcData, 2);

  /* "text_x_pos_list" */
  text_x_pos_list = AxArrayElement(funcData, 3);
  if (! AxIsArray(text_x_pos_list)) {
    return(NULL);
  }

  /* "level_max" */
  if (! AxIsInt(AxArrayElement(funcData, 4))) {
    return(NULL);
  }
  level_max = AxIntFromArray(funcData, 4);

  /* "text_height" */
  if (! AxIsInt(AxArrayElement(funcData, 5))) {
    return(NULL);
  }
  text_height = AxIntFromArray(funcData, 5);

  /* "square_size" */
  if (! AxIsInt(AxArrayElement(funcData, 6))) {
    return(NULL);
  }
  square_size = AxIntFromArray(funcData, 6);

  /* text_widths */
  text_widths = AxArrayElement(funcData, 7);
  if (! AxIsArray(text_widths)) {
    return(NULL);
  }

  /* "box_x_pos_by_level" */
  box_x_pos_by_level = AxArrayElement(funcData, 8);
  if (! AxIsArray(box_x_pos_by_level)) {
    return(NULL);
  }

  rData = tm1ui_subset_calc_layout(num_elems, elemlist, parentlist,
	   levlist, text_x_pos_list, level_max, text_height,
	   square_size, text_widths, box_x_pos_by_level,
	   canonical_element_list); 
  return(rData);
} /* tm1ui_subset_calc_layout_init */

/**************************************************************************
 * tm1ui_subset_calc_layout - calculates the entry_list layout of
 *     canvas_entry data structures for the TM1 Subset Dialog;
 *  "num_elems" is the number of elements in the listbox;
 *  "elemlist" is an array of strings that is the list of those
 *     element names;
 *  "parentlist" is an array paralleling the canonical list of element
 *     names, each element of which is an array of strings,
 *     constituting the parents of the corresponding element;
 *  "levlist" is an array paralleling the list of canonical element
 *     names, each element of which is the integer level number of the
 *     corresponding element;
 *  "text_x_pos_list" is an array of integers, giving the starting
 *     x-coordinate position for an element of a given level (the size
 *     of this array is,  hence, equal to level_max+1 (since levels
 *     start at zero)); 
 *  "level_max" is the maximum level for the current dimension;
 *  "text_height" is the height of the font for displaying in the
 *     Subset Dialog listbox;
 *  "square_size" is the length of the side of the expand/collapse
 *     squares residing next to consolidation elements in the drawing
 *     of the dimension hierarchy; 
 *  "text_widths" is an array paralleling the canonical list of
 *     element names, each element of which is an integer representing
 *     the width of the string in the display font; 
 *  "box_x_pos_by_level" is an array of integers, giving the starting
 *     x-coordinate position for the box of a consolidation element of
 *     a given level (the sizeo of this array is, hence, equal to
 *     level_max+1);
 *  "canonical_element_list" is the array of element names for the
 *     entire dimension 
 */
data_ptr
tm1ui_subset_calc_layout(int num_elems,
			 data_ptr elemlist, 
			 data_ptr parentlist,
			 data_ptr levlist, 
			 data_ptr text_x_pos_list,
			 int level_max,
			 int text_height,
			 int square_size,
			 data_ptr text_widths,
			 data_ptr box_x_pos_by_level,
			 data_ptr canonical_element_list)
{
  int ix, jx, kx, kx2, asize, strsize, canonical_num_elems;
  int levnum, curr_y, curr_x, textw, box_x, canonical_index;
  int max_total_width = 0;
  char *sptr;
  char *elemname;
  char **potential_parents = NULL;
  char ***actual_parents = NULL;
  int *num_parents_array = NULL;
  int *higher_up_idxs = NULL;
  data_ptr entry_list, current_entry;
  data_ptr current_parent, current_parent_list;
  data_ptr rData;

  /* allocate memory for the return value */
  entry_list = AxMakeArray(num_elems);
  if (NULL == entry_list) {
    goto do_error_return;
  }

  /* allocate memory for the array of indices that parallels the
     "potential_parents" array, and initialize all entries to -1,
      indicating "no corresponding index for this level" */
  higher_up_idxs = (int *)malloc((level_max+1) * sizeof(int));
  if (NULL == higher_up_idxs) {
    goto do_error_return;
  }
  for (ix=0; (ix <= level_max); ix++) {
    higher_up_idxs[ix] = -1;
  }

  /* allocate memory for the "potential parents" list; this array need 
     only contain space sufficient for the depth of the dimension
     hierarchy; note that the calloc initializes the returned memory
     with NULLs */
  potential_parents = (char **)calloc((level_max+1), sizeof(char *));
  if (NULL == potential_parents) {
    goto do_error_return;
  }

  /* allocate memory for the "parents array" -- each entry in this 
     array is itself an array of strings, constituting the list of
     parents for the corresponding element; fill in the data structure
     with the supplied information; note that the calloc initializes
     the returned memory with NULLs */
  canonical_num_elems = AxArraySize(canonical_element_list);
  num_parents_array = (int *)calloc(canonical_num_elems, sizeof(int));
  if (NULL == num_parents_array) {
    goto do_error_return;
  }
  actual_parents = (char ***)calloc(canonical_num_elems, sizeof(char **));
  if (NULL == actual_parents) {
    goto do_error_return;
  }
  for (ix=0; (ix < canonical_num_elems); ix++) {
    current_parent_list = AxArrayElement(parentlist, ix);
    if (NULL == current_parent_list) {
      continue;
    }
    if (! AxIsArray(current_parent_list)) {
      continue;
    }
    num_parents_array[ix] = asize = AxArraySize(current_parent_list);
    actual_parents[ix] = (char **)calloc(asize, sizeof(char *));
    if (NULL == actual_parents[ix]) {
      goto do_error_return;
    }
    for (jx=0; (jx < asize); jx++) {
      current_parent = AxArrayElement(current_parent_list, jx);
      if (NULL == current_parent) {
	continue;
      }
      if (! AxIsString(current_parent)) {
	continue;
      }
      sptr = AxStrFromDataPtr(current_parent);
      strsize = (strlen(sptr) + 1) * sizeof(char);
      actual_parents[ix][jx] = (char *)malloc(strsize);
      if (NULL == actual_parents[ix][jx]) {
	goto do_error_return;
      }
      strcpy(actual_parents[ix][jx], sptr);
    }
  }

  /* setup the initial Y coordinate */
  curr_y = 0;

  /* iterate over the elements, constructing a listbox entry value for 
     each */ 
  for (ix=0; (ix < num_elems); ix++) {
    elemname = AxStrFromArray(elemlist, ix);
    canonical_index = 
      tm1ui_subset_find_canonical_index(elemname, canonical_element_list);
    levnum = AxIntFromArray(levlist, canonical_index);
    curr_x = AxIntFromArray(text_x_pos_list, levnum);
    box_x = AxIntFromArray(box_x_pos_by_level, levnum);
    textw = AxIntFromArray(text_widths, canonical_index);
    current_entry = tm1ui_subset_create_entry(elemname, levnum,
	      level_max, curr_x, curr_y, square_size, textw, box_x,
	      &max_total_width); 
    tm1ui_subset_calc_hierarchy_lines(current_entry, ix, elemname,
	      levnum, &potential_parents, actual_parents[canonical_index],
	      num_parents_array[canonical_index], &higher_up_idxs, level_max,
	      entry_list, levlist, canonical_index); 
    entry_list = AxAddArrayToArray(entry_list, ix, current_entry);
    curr_y += text_height;
  }

  /* free up the memory allocated for holding computation values */
  tm1ui_subset_free_actual_parents(actual_parents,
	   canonical_num_elems, num_parents_array);
  free(num_parents_array);
  tm1ui_subset_free_potential_parents(potential_parents, level_max);
  free(higher_up_idxs);

  /* return the calculated layout */
  rData = AxMakeArray(3);
  AxAddIntToArray(rData, 0, max_total_width);
  AxAddIntToArray(rData, 1, curr_y);
  AxAddArrayToArray(rData, 2, entry_list);
  return(rData);

  /* handle error condition clean-up and return */
 do_error_return:
  AxFreeData(entry_list);
  if (higher_up_idxs) {
    free(higher_up_idxs);
  }
  if (potential_parents) {
    for (ix=0; (ix <= level_max); ix++) {
      if (potential_parents[ix]) {
	free(potential_parents[ix]);
      }
    }
    free(potential_parents);
  }
  tm1ui_subset_free_actual_parents(actual_parents,
	   canonical_num_elems, num_parents_array);
  if (num_parents_array) {
    free(num_parents_array);
  }
  return(NULL);
} /* tm1ui_subset_calc_layout */

/**************************************************************************
 * tm1ui_subset_find_canonical_index
 */
int
tm1ui_subset_find_canonical_index(char *elemname, 
				  data_ptr canonical_element_list)
{
  int ix;
  char *sptr;

  for (ix=0; (ix < AxArraySize(canonical_element_list)); ix++) {
    sptr = AxStrPtrFromArray(canonical_element_list, ix);
    if (0 == strcasecmp(sptr, elemname)) {
      return(ix);
    }
  }
  return(-1);
} /* tm1ui_subset_find_canonical_index */

/**************************************************************************
 * tm1ui_subset_calc_hierarchy_lines
 */
void
tm1ui_subset_calc_hierarchy_lines(data_ptr current_entry,
				  int entry_idx,
				  char *elemname,
				  int levnum,
				  char ***in_potential_parents,
				  char **element_parents,
				  int num_parents,
				  int **in_higher_up_idxs,
				  int level_max,
				  data_ptr entry_list,
				  data_ptr levlist,
				  int canonical_index)
{
  int parent_idx, member_idx, ix, first_idx, last_idx, parent_lev;
  char **potential_parents = *in_potential_parents;
  int *higher_up_idxs = *in_higher_up_idxs;
  data_ptr parent_entry, member_entry;

  /* see if the parent of the current element is currently in the list 
     box */
  parent_idx = tm1ui_subset_find_parent_index(element_parents,
		      num_parents, potential_parents, level_max);

  /* if the current element's parent is not in the list box, then the 
     hierarchy lines are broken by the current entry; this means that
     any lines that were being drawn terminate that the current entry;
     a new set of hierarchy information must be started */
  if (-1 == parent_idx) {
    /* zero out the potential parents array, and then put in the
       current element; note that calloc initialized the returned
       memory to NULLs */
    for (ix=0; (ix <= level_max); ix++) {
      if (potential_parents[ix]) {
	free(potential_parents[ix]);
	potential_parents[ix] = NULL;
      }
    }
    tm1ui_subset_replace_parent_at_index(potential_parents, levnum,
					 elemname);
    /* minus-one out the parent index array, and then put in the
       current index */
    for (ix=0; (ix < (level_max+1)); ix++) {
      higher_up_idxs[ix] = -1;
    }
    higher_up_idxs[levnum] = entry_idx;
    return;
  }

  /* otherwise, the current entry does have a parent displayed in the
     listbox; so hierarchy lines must be drawn; note that "parent_idx"
     is in the range of (0 <= parent_idx <= level_max), being an index
     into the potential_parents array, while member_idx is in the
     range of (0 <= member_idx < num_elems), being an index into the
     list of listbox entries */ 
  member_idx = higher_up_idxs[parent_idx];
  if (-1 == member_idx) {
    goto do_update_member_lists;
  }
  /* here, "member_entry" is the entry of the current element's parent */
  member_entry = AxArrayElement(entry_list, member_idx);
  /* indicate that the parent entry has children displayed */
  tm1ui_subset_set_had_kids_displayed(member_entry, TRUE);
  /* record the first/last index for the children displayed */
  tm1ui_subset_handle_first_last_idxs(member_entry, entry_idx);
  /* for all entries between the parent and the current entry, mark
     their hierarchy line arrays as having a vertical line for the
     level of the parent entry */
  parent_lev = tm1ui_subset_get_level(member_entry);
  first_idx = tm1ui_subset_get_first_idx(member_entry);
  last_idx = entry_idx - 1;
  for (ix=first_idx; (ix <= last_idx); ix++) {
    member_entry = AxArrayElement(entry_list, ix);
    tm1ui_subset_add_line_at_level(member_entry, parent_lev, VERT_LINE_FULL);
  }
  /* mark the current entry has having only a half-line for the
     parent's level, and then indicate that the horizontal line for
     this entry also is drawn to the parent's level; this will create
     the elbow between the vertical and horizontal lines in the
     hierarchy display */
  tm1ui_subset_add_line_at_level(current_entry, parent_lev, VERT_LINE_HALF);
  tm1ui_subset_set_lev_of_hline(current_entry, parent_lev);

  /* update the "members higher up" lists to reflect the addition of
     the current entry; note that if we're adding an entry for an
     element at level N, then the data for all previous entries for
     elements of levels < N is invalid, and must be removed */
 do_update_member_lists:
  for (ix=0; (ix < levnum); ix++) {
    if (potential_parents[ix]) {
      free(potential_parents[ix]);
      potential_parents[ix] = NULL;
    }
    higher_up_idxs[ix] = -1;
  }
  tm1ui_subset_replace_parent_at_index(potential_parents, levnum, elemname);
  higher_up_idxs[levnum] = entry_idx;
} /* tm1ui_subset_calc_hierarchy_lines */

/********************************************************/
/* Procedures for Handling the "canvas_entry" Data Type */
/********************************************************/

/**************************************************************************
 * tm1ui_subset_create_entry
 */
data_ptr
tm1ui_subset_create_entry(char *elemname, 
			  int levnum,
			  int level_max,
			  int curr_x, 
			  int curr_y, 
			  int square_size,
			  int textw,
			  int box_x,
			  int *max_total_width)
{
  data_ptr entry, boxarea, line_array;
  int ix, mtw;

  entry = AxMakeArray(12);

  /* member name */
  AxAddStrToArray(entry, 0, elemname);
  /* level_number */
  AxAddIntToArray(entry, 1, levnum);
  /* start_point_y */
  AxAddIntToArray(entry, 2, curr_y);
  /* is_selected */
  AxAddIntToArray(entry, 3, FALSE);
  /* was_selected */
  AxAddIntToArray(entry, 4, FALSE);
  /* has_kids_displayed */
  AxAddIntToArray(entry, 5, FALSE);
  /* first_kid_idx */
  AxAddIntToArray(entry, 6, -1);
  /* last_kid_idx */
  AxAddIntToArray(entry, 7, -1);
  /* boxarea */
  if (levnum > 0) {
    boxarea = tm1ui_subset_calc_box(box_x, curr_y, square_size);
    AxAddArrayToArray(entry, 8, boxarea);
  }
  /* total width */
  mtw = curr_x + textw;
  AxAddIntToArray(entry, 9, mtw);
  if (mtw > *max_total_width) {
    *max_total_width = mtw;
  }
  /* line_array -- setup defaults */
  line_array = AxMakeArray(level_max+1);
  for (ix=0; (ix <= level_max); ix++) {
    AxAddIntToArray(line_array, ix, VERT_LINE_NONE);
  }
  AxAddArrayToArray(entry, 10, line_array);
  /* level_of_hline */
  AxAddIntToArray(entry, 11, -1);

  return(entry);
} /* tm1ui_subset_create_entry */

/**************************************************************************
 * tm1ui_subset_get_level
 */
int
tm1ui_subset_get_level(data_ptr entry)
{
  return(AxIntFromArray(entry, 1));
} /* tm1ui_subset_get_level */

/**************************************************************************
 * tm1ui_subset_set_lev_of_hline
 */
void
tm1ui_subset_set_lev_of_hline(data_ptr entry,
			      int lev_of_hline)
{
  AxAddIntToArray(entry, 11, lev_of_hline);
} /* tm1ui_subset_set_lev_of_hline */

/**************************************************************************
 * tm1ui_subset_get_first_idx
 */
int
tm1ui_subset_get_first_idx(data_ptr member_entry)
{
  return(AxIntFromArray(member_entry, 6));
} /* tm1ui_subset_get_first_idx */

/**************************************************************************
 * tm1ui_subset_add_line_at_level
 */
void
tm1ui_subset_add_line_at_level(data_ptr entry, 
			       int levnum,
			       int line_type)
{
  data_ptr line_array;
  line_array = AxArrayFromArray(entry, 10);
  AxAddIntToArray(line_array, levnum, line_type);
} /* tm1ui_subset_add_line_at_level */

/**************************************************************************
 * tm1ui_subset_set_had_kids_displayed
 */
void
tm1ui_subset_set_had_kids_displayed(data_ptr entry,
				    int has_kids_displayed)
{
  AxAddIntToArray(entry, 5, has_kids_displayed);
} /* tm1ui_subset_set_had_kids_displayed */

/**************************************************************************
 * tm1ui_subset_handle_first_last_idxs
 */
void
tm1ui_subset_handle_first_last_idxs(data_ptr entry,
				    int kid_idx)
{
  int first_idx;
  first_idx = AxIntFromArray(entry, 6);
  if (-1 == first_idx) {
    AxAddIntToArray(entry, 6, kid_idx);
  }
  AxAddIntToArray(entry, 7, kid_idx);
} /* tm1ui_subset_handle_first_last_idxs */

/**************************************************************************
 * tm1ui_subset_calc_box
 */
data_ptr
tm1ui_subset_calc_box(int unadjx, 
		      int unadjy, 
		      int square_size)
{
  int uly;
  data_ptr boxarea;

  uly = unadjy + SQUARE_IS_OFFSET_FROM_TEXT_HEIGHT;
  boxarea = AxMakeArray(4);

  /* boxarea x */
  boxarea = AxAddIntToArray(boxarea, 0, unadjx);
  /* boxarea y */
  boxarea = AxAddIntToArray(boxarea, 1, uly);
  /* boxarea width */
  boxarea = AxAddIntToArray(boxarea, 2, square_size);
  /* boxarea height */
  boxarea = AxAddIntToArray(boxarea, 3, square_size);

  return(boxarea);
} /* tm1ui_subset_calc_box */

/***************************************************************/
/* Utility Functions for Element Parents/Children Calculations */
/***************************************************************/

/**************************************************************************
 * tm1ui_subset_find_parent_index -- returns an array index in
 *     "potential_parents" at which a parent in the "element_parents"
 *      may be found; returns -1 if there are no possible matches
 *      between the contents of the "potential_parents" and
 *      "element_parents" arrays
 */
int
tm1ui_subset_find_parent_index(char **element_parents,
			       int num_parents,
			       char **potential_parents,
			       int level_max)
{
  int ix, jx;
  char *current_parent;
  char *potential_match;

  /* handle cases where either "parents" array doesn't exist */
  if (NULL == potential_parents) {
    return(-1);
  }
  if (NULL == element_parents) {
    return(-1);
  }
  for (ix=0; (ix < num_parents); ix++) {
    current_parent = element_parents[ix];
    if (NULL == current_parent) {
      continue;
    }
    for (jx=0; (jx <= level_max); jx++) {
      potential_match = potential_parents[jx];
      if (NULL == potential_match) {
	continue;
      }
      if (0 == strcasecmp(potential_match, current_parent)) {
	return(jx);
      }
    }
  }
  return(-1);
} /* tm1ui_subset_find_parent_index */

/**************************************************************************
 * tm1ui_subset_free_potential_parents
 */
void
tm1ui_subset_free_potential_parents(char **potential_parents,
				    int level_max)
{
  int ix;

  if (NULL == potential_parents) {
    return;
  }
  for (ix=0; (ix <= level_max); ix++) {
    if (NULL != potential_parents[ix]) {
      free(potential_parents[ix]);
    }
  }
  free(potential_parents);
} /* tm1ui_subset_free_potential_parents */

/**************************************************************************
 * tm1ui_subset_replace_parent_at_index
 */
void
tm1ui_subset_replace_parent_at_index(char **potential_parents,
				     int idx,
				     char *new_parent)
{
  if (NULL != potential_parents[idx]) {
    free(potential_parents[idx]);
  }
  potential_parents[idx] = (char *)malloc(
		  (strlen(new_parent)+1) * sizeof(char));
  strcpy(potential_parents[idx], new_parent);
} /* tm1ui_subset_replace_parent_at_index */

/**************************************************************************
 * tm1ui_subset_free_actual_parents
 */
void
tm1ui_subset_free_actual_parents(char ***actual_parents,
				 int canonical_num_elems,
				 int *num_parents_array)
{
  int ix, jx;

  for (ix=0; (ix < canonical_num_elems); ix++) {
    if (actual_parents[ix]) {
      for (jx=0; (jx < num_parents_array[ix]); jx++) {
	if (actual_parents[ix][jx]) {
	  free(actual_parents[ix][jx]);
	}
      }
      free(actual_parents[ix]);
    }
  }
  free(actual_parents);
} /* tm1ui_subset_free_actual_parents */
