/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: bin2hex.c
   Applix ASC version: 6
   Date: Tue Nov 17 11:22:59 1998
*/
#include <stdio.h>

#ifdef AXMS 
#define  ENV_USER       "USERNAME"
#else
#define  ENV_USER       "USER"
#endif

main(argc,argv)
int argc;
char *argv[];
{
	FILE *rfp, *wfp;
	char *infile, *outfile;
	char buf[1];
	unsigned short checksum = 0;
	int bytecounter = 0;
	char *bytestr();

	infile = argv[2];
	outfile = argv[1];

/* Open input file */

#if AXMS
	rfp = fopen(infile,"rb");
#else
	rfp = fopen(infile,"r");
#endif
	if ( !rfp ) {
		fprintf(stderr,"Could not open input file %s\n",infile);
		exit(1);
	}

/* Open output file */

#if AXMS
	wfp = fopen(outfile,"wb");
#else
	wfp = fopen(outfile,"w");
#endif
	if ( !wfp ) {
		fprintf(stderr,"Could not open output file %s\n",outfile);
		exit(1);
	}

/* Apply header */

	fprintf(wfp,"! @(#)  %s\n",getenv(ENV_USER));
	fprintf(wfp,"%s\n","!");
	fprintf(wfp,"%s\n","!            COPYRIGHT NOTICE ON THE REV3 SOFTWARE");
	fprintf(wfp,"%s\n","!            ------------------------------------------");
	fprintf(wfp,"%s\n","!");
	fprintf(wfp,"%s\n","!                  Trade secret of Applix, Inc.");
	fprintf(wfp,"%s\n","!          Copyright 1992 Applix, Inc.  All rights reserved");
	fprintf(wfp,"%s\n","!");
	fprintf(wfp,"%s\n","! This notice is intended as a precaution against inadvertent publication");
	fprintf(wfp,"%s\n","! and does not imply publication or any waiver of confidentiality.  The");
	fprintf(wfp,"%s\n","! year included in the foregoing notice is the year of creation of the ");
	fprintf(wfp,"%s\n","! work.");
	fprintf(wfp,"%s\n","!");
	fprintf(wfp,"%s\n","! No part of this material may be reproduced or transmitted in any form");
	fprintf(wfp,"%s\n","! or by any means, electronic, mechanical or otherwise, without written");
	fprintf(wfp,"%s\n","! permission from Applix, Inc.");
	fprintf(wfp,"%s\n","");
	fprintf(wfp,"%s\n","");
	fprintf(wfp,"%s\n","");
	fprintf(wfp,"%s\n","");

/* Scan input to compute checksum, write checksum to output file */

	while ( fread(buf,1,1,rfp) )
		checksum += buf[0] & 255;
	buf[0] = (checksum >> 8) & 255;
	if ( 1 != fwrite(bytestr(buf[0]),2,1,wfp) ) goto errout;
	buf[0] = checksum & 255;
	if ( 1 != fwrite(bytestr(buf[0]),2,1,wfp) ) goto errout;
	if ( 1 != fwrite("\n",1,1,wfp) ) goto errout;

/* Reopen input file - silly, but I's rather do this than trust fseek() */

	fclose(rfp);
#if AXMS
	rfp = fopen(infile,"rb");
#else
	rfp = fopen(infile,"r");
#endif
	if ( !rfp ) {
		fprintf(stderr,"Could not open input file %s\n",infile);
		exit(1);
	}

	while ( fread(buf,1,1,rfp) ) {
		if ( 1 != fwrite(bytestr(buf[0]),2,1,wfp) ) goto errout;
		bytecounter++;
		if ( 0 == (bytecounter % 35) )
			fwrite("\n",1,1,wfp);
	}
	fwrite("\n",1,1,wfp);
	fclose(rfp);
	fclose(wfp);
	exit(0);

errout:
	fprintf(stderr,"Write failed on %s\n",outfile);
	exit(1);
}

char *bytestr(n)
char n;
{
	static char *chars = "0123456789ABCDEF";
	static char result[3];

	result[0] = chars[(n >> 4) & 15];
	result[1] = chars[n & 15];
	result[2] = 0;
	return(result);
}
