/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: noheader.c
   Applix ASC version: 8
   Date: Sat Jan 23 21:14:33 1999
*/
/* STRIP LINES THROUGH HERE */
/*

Strip off lines from top of file to the text "STRIP LINES THROUGH HERE"
or the first 18 lines if the "STRIP LINES THROUGH HERE" marker is not present

Calling sequence:
   noheader out_file in_file [-mod <val>]

*/

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>

#if !LINUX
extern char *sys_errlist[];
#endif

#define TRUE 1
#define FALSE 0

char *strstr();

main(argc,argv)
int argc;
char *argv[];
{
	FILE *in_fp, *out_fp;
    char *in_file, *out_file;
	char buf[3000];
    char *p;
    char *ret;
    int line_num;
    int strip_to_line=0;
	int mode;
    char format_str[5];

	if( argc > 3 ){
		mode = atoi(argv[1]);
		out_file = argv[2]; 
		in_file = argv[3];
	}
	else { 
		mode = -1;
		out_file = argv[1]; 
		in_file = argv[2];
	}

    /* open input file */
	in_fp = fopen(in_file,"r");
	if ( !in_fp ) {
		fprintf(stderr,"Could not open input file %s, errno=%d\n",
                                                 in_file,errno);
		exit(1);
	}

    /* open output file */
    strcpy( format_str, "wb" );
#if AXMS
    if ( mode > 0 )
       /* make a widows text file, ie. not in "binary" mode */
       strcpy( format_str, "w" );
#endif
    out_fp = fopen( out_file, format_str );
    if ( !out_fp ) {
        fprintf(stderr,"Could not open output  file %s, errno = %d\n",
                                    out_file, errno );
        exit(1);
    }

    line_num = 0;
    while ( 1 )
       {
       ret = fgets( buf, 3000, in_fp );
       if ( ret == (char *)NULL )
           break;

       line_num++;
       p = strstr( buf, "STRIP LINES THROUGH HERE");
       if ( p != (char *)NULL )
          {
          /* found the marker line */
          strip_to_line = line_num;
          break;
          }
       }

	fclose(in_fp);

    if ( strip_to_line == 0 )
       strip_to_line = 17;

    /* re-open input file */
    in_fp = fopen(in_file,"r");

    line_num = 0;
    while ( 1 )
       {
       ret = fgets( buf, 3000, in_fp );
       if ( ret == (char *)NULL )
           break;
       
       line_num++;
       if ( line_num <= strip_to_line )
          continue;
       fprintf( out_fp, "%s", buf );
       }

    fclose(in_fp);
    fclose(out_fp);

#if !AXMS
	if( mode != -1 ){
		char bigStr[1000];

		sprintf(bigStr,"chmod %d %s\n",mode,out_file);
		if( system( bigStr ) != 0 ){
        	fprintf(stderr,"Could not chmod %d output  file %s\n",mode,out_file);
			exit(1);
		}
	}
#endif

    exit(0);
}

