/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: agethos.c
   Applix ASC version: 8
   Date: Mon Nov 16 13:57:58 1998
*/
#if AXMS
#include <winsock.h>
#endif

#include <utloc.h>
#if USL54
#include <limits.h>
#endif
#if SYSV4
#include <sys/systeminfo.h>                 /* for SI_HOSTNAME */
#endif


/*
NAME Agethostname - Obtain the name of current host.
DESCRIPTION
	Agethostname() provides a generic interface for obtaining the host
	name of the processor.  The host name may be up to 31 characters long.
ARGUMENTS hostname The address of a buffer which will receive the host name.
           hostlen The size of the buffer specified by hostname.
RETURN VALUE
    When succesful, Agethostname() returns 0.  On error, -1 is returned.
*/

Agethostname (hostname, hostlen)
char *hostname;
int hostlen;
{
	static char temp_host[STRLONG];
	char *hostP;

#if SYSV4
		sysinfo(SI_HOSTNAME, temp_host, sizeof(temp_host) - 1);
		temp_host[sizeof(temp_host) - 1] = 0;
		strcpy(hostname, temp_host);
#else
		if(gethostname(hostname,--hostlen) < 0)
			return(-1);
		hostname[hostlen] = '\0';
#endif

	return(0);
}
