/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: agetnfn.c
   Applix ASC version: 8
   Date: Fri Jan  8 21:11:43 1999
*/
#include <stdio.h>  	/* For pre-System 5.3 systems */
#include <utloc.h>

#if AXMS    /* Windows/NT */
#include <string.h>
#include <windows.h>

char *TaskAlloc(int,unsigned int);
char *TaskCalloc(int,unsigned int,unsigned int);
char *TaskRealloc(int, void*, unsigned int);
void TaskFree(int, void*);
#define malloc(s) TaskAlloc(0,s)
#define calloc(n,s) TaskCalloc(0, n, s)
#define realloc(p,s) TaskRealloc(0, p, s)
#define free(p) TaskFree(0, p)

#define ALCSTR(p) strcpy(malloc(strlen(p)+1),p)
char *AddNameToPath(char *, LPWIN32_FIND_DATA);
int AgetNfilename();
void AMakePath();
BOOL IsDir(LPWIN32_FIND_DATA);
#endif

#define MAXLEVEL 20		/* Max directory levels */


	/****************************************************************/
	/*		AEGIS and VMS includes, defines, and declarations		*/
    /*      have been removed. See Rev 6.5 or earlier of this file  */
    /*      if you need this code.                                  */
	/****************************************************************/


    /********************************************************/
    /*      UNIXy includes, defines, and declarations       */
	/*			beware all who enter this code...			*/
    /********************************************************/

#include <sys/types.h>

#if UNISYS
#include <dirent.h>
#else
#if PCS
#include <dirent.h>
struct direct {
	long d_ino;
	char d_name[MAXNAMLEN];
};
#else
#if HP300 || HP800
#include <ndir.h>
#else
#if X386_NEW || M_88K || AXMS
#define MAXNAMLEN   512     /* maximum filename length */
struct dirent               /* data from readdir() */
    {
    long        d_ino;      /* inode number of entry */
    off_t       d_off;      /* offset of disk direntory entry */
    unsigned short  d_reclen;   /* length of this record */
    char        d_name[255];    /* JJM was 1 - name of file */
    };
#define DIRBUF      1048        /* buffer size for fs-indep. dirs */
 
typedef struct
    {
    int dd_fd;          /* file descriptor */
    int dd_loc;         /* offset in block */
    int dd_size;        /* amount of valid data */
    char    *dd_buf;        /* directory block */
    }   DIR;            /* stream data from opendir() */
 
extern DIR      *opendir();
extern struct dirent    *readdir();
extern long     telldir();
extern void     seekdir();
extern int      closedir();
#define direct dirent       /* JJM */
 
#else
#if RIOS || CLIX || ALPHA
#include <dirent.h>
#define direct dirent
#else
#if SYSV4
 
#define direct dirent
#include <sys/types.h>  /* for ino_t and off_t */
#include <sys/param.h>  /* for MAXNAMELEN */

/*
 * NOTE:
 * We need our own "struct dirent" because we do a structure assignment in
 * scandir().  On SYSV ports, the d_name[] element of "struct dirent" is a
 * char array of size 2, so a structure assignment copies only the first two
 * chars of the filename.
 */
/* from <dirent.h> */
typedef struct {
    int  dd_fd; /* file descriptor */
    int  dd_loc;    /* offset in block */
    int  dd_size;   /* amount of valid data */
    char *dd_buf;   /* directory block */
} DIR;  /* stream data from opendir() */
 
/* from <sys/dirent.h> */
struct dirent {
    ino_t d_ino;    /* "inode number of entry */
    off_t d_off;    /* offset of disk directory entry */
    unsigned short d_reclen;    /* length of this record */
    char  d_name[MAXNAMELEN + 1];/* <--- name of file -- for struct assign.*/
};
 
extern struct dirent *readdir(/* DIR * */);
extern int closedir(/* DIR * */);
extern DIR *opendir(/* const char * */);
/* end of SYSV4 */
 
#else

/* DEFAULT */
#if !AXMS
#include <sys/dir.h>

#endif  /* if !AXMS, DAMNT */
#endif  /* if SYSV4 */
#endif  /* if RIOS */
#endif  /* if X386_NEW */
#endif  /* if HP300 */
#endif	/* if PCS */
#endif	/* if UNISYS */


static int checkSkip(name)
struct direct *name;
{
	/*
	 *	if(!strcmp((*name).d_name,".") ||
	 *		!strcmp((*name).d_name,"..")) return (0);
	 */
	if(name->d_name[0] == '.' && 
	   ((name->d_name[1] == '.' && name->d_name[2] == '\0') ||
		name->d_name[1] == '\0'))
		return(0);
	return(1);
}

struct getinfo {
	int current;
	int count;
	struct direct **dirlist;
	struct direct  *p;
	struct direct **startlist;
	struct direct **dirstack[MAXLEVEL];
	struct direct **startstack[MAXLEVEL];
	int level;
	int countstack[MAXLEVEL];
	int currstack[MAXLEVEL];
};







/* BEGIN SYNOPSIS */
AgetNfilename(init, dirpath, buffer, stack)
int init;
char *dirpath;
char *buffer;
char **stack;
/* END SYNOPSIS */
{
	/*****************************************************************/
	/*		VMS and AEGIS code sections have                         */
    /*      been removed. See rev 6.5 or earlier of this file        */
    /*      if you need to see that code.                            */
	/*****************************************************************/


#if !AXMS    /*  { =============== not Windows/NT ================= */
	/********************************************************/
	/*		UNIXy code section								*/
	/********************************************************/
	struct getinfo **place = (struct getinfo **)stack;

	if (*place == NULL) {
		*place = (struct getinfo *)malloc(sizeof(struct getinfo));
		(*place)->level = 0;
	}
	
	if (init) {
		/* Sanity check. */
		if ((*place)->level >= MAXLEVEL)
			return(FALSE);
		if ((*place)->level > 0) {
			(*place)->dirstack[(*place)->level] = (*place)->dirlist;
			(*place)->startstack[(*place)->level] = (*place)->startlist;
			(*place)->countstack[(*place)->level] = (*place)->count;
			(*place)->currstack[(*place)->level] = (*place)->current;
		}
		(*place)->level++;
		(*place)->startlist = NULL;
		(*place)->count = scandir(dirpath,&(*place)->startlist,checkSkip,(int)NULL);
		(*place)->dirlist = (*place)->startlist;
		(*place)->current = 0;
	}
	if ((*place)->current++ >= (*place)->count) {
		if((*place)->startlist != NULL)
			free ((*place)->startlist);
		if(--((*place)->level) > 0) {
			(*place)->dirlist = (*place)->dirstack[(*place)->level];
			(*place)->startlist = (*place)->startstack[(*place)->level];
			(*place)->current = (*place)->currstack[(*place)->level];
			(*place)->count = (*place)->countstack[(*place)->level];
		}
		else {
			free(*place);
			*place = NULL;
		}
		return (FALSE);
	}
	(*place)->p = *(*place)->dirlist++;


#if CLIX
/* Stick a NULL on the end of buffer on machines on which strcpy
   doesn't do it for you. */
    strncpy(buffer,(*(*place)->p).d_name,14);
    buffer[14] = '\0';
#else
	strcpy(buffer,(*(*place)->p).d_name);
#endif

	free((char *)(*place)->p);
	return(TRUE);

#else     /* ===============================  }  { ================= */

/****************/
/** Windows/NT  */
/****************/

static	char            **retP;
static  int             cnt=0, index=0;
	WIN32_FIND_DATA data;
	HANDLE          h;
	char            *path,
                        name[STRPATH+1],
                        currentDir[STRPATH+1];
        int             i=1, cmp1, cmp2;

        if (cnt == 0) { 
	    retP    = (char**)calloc(1,sizeof(char*));
            path    = (char*)malloc(STRPATH*sizeof(char));
	}
        
        while (init)
        {
            strcpy(currentDir, dirpath);
	    sprintf(name,"%s\\*.*",dirpath);
                
            h = FindFirstFile(name,&data);
	    if (h == INVALID_HANDLE_VALUE)
            {
	        printf("\nNo files in %s. Check directory name.\n", name);
	        return FALSE;
	    }

	    retP = (char**)realloc(retP,(cnt+2)*sizeof(char*));

            cmp1 = strcmp(data.cFileName, ".");
            cmp2 = strcmp(data.cFileName, "..");    	    
	    if ((cmp1 !=0) && (cmp2 != 0))
	        retP[cnt++] = ALCSTR(data.cFileName);

 	    while (FindNextFile(h,&data))
            {
                if (IsDir(&data))
                {
                    path = AddNameToPath(currentDir, &data);
                    AgetNfilename(TRUE, path, buffer, NULL);
                }
                else {            
                    retP = (char**)realloc(retP,(cnt+2)*sizeof(char*));
                    cmp1 = strcmp(data.cFileName, ".");
                    cmp2 = strcmp(data.cFileName, "..");    	    
	            if ((cmp1 !=0) && (cmp2 != 0))
                        retP[cnt++] = ALCSTR(data.cFileName);
                }
	    }
	    FindClose(h);
	    retP[cnt] = 0;
	    init = FALSE;
        }

        if (retP[index] == 0) 
            return FALSE;
            
        strcpy(buffer, retP[index++]); 
	return TRUE;
#endif    /*  }   end of Window/NT code */

}






#if SYS&SYS5 || SYSV4
/*
 *	Name: scandir() - scan a directory.
 *
 *	Description: Scandir reads the directory dirname and builds an array of
 *		pointers to directory entries using malloc(3).  The second parameter is
 *		a pointer to an array of structure pointers. The third parameter is a
 *		pointer to a routine which is called with a pointer to a directory
 *		entry and should return a none zero value if the directory should be
 *		included in the array.  If this pointer is null, than all the directory
 *		entries will be included.  The last argument is a pointer to a routine
 *		which is passed to qsort(3) to sort the completed array.  If this
 *		pointer is null, the array is not sorted. 
 *
 *		Scandir returns the number of entries in the array and a pointer to the
 *		array through the parameter namelist.
 */

scandir(dirname,namelist,select,compar)
char *dirname;
struct direct ***namelist;
int (*select)();
int (*compar)();
{
#if (SYSV3 | HP300 | X386_NEW | HP800 | SGI | AUX | RIOS | M_88K | CLIX | SYSV4) && (!UNISYS)
	DIR *fp;
#else
	FILE *fp;
	struct direct ldir;
#endif
#if PCS
	struct dirent *mips_dir;
	struct direct ldir;
#endif
	struct direct *dir,*dirptr,**nameptr;
	int array_cnt = 0;
	int dir_cnt = 0;

#if (SYSV3 | HP300 | X386_NEW | HP800 | SGI | AUX | RIOS | M_88K | CLIX | SYSV4) && (!UNISYS)
	if(!(fp = opendir(dirname)))
#else
	dir = &ldir;
	if(!(fp = fopen(dirname,"r")))
#endif
		return(-1);

#if PCS
	dir = &ldir;
	while(mips_dir = readdir(fp)) {
		dir->d_ino = mips_dir->d_ino;
		strcpy(dir->d_name,mips_dir->d_name);
#else
#if (SYSV3 | HP300 | X386_NEW | HP800 | SGI | AUX | RIOS | M_88K | CLIX | SYSV4) && (!UNISYS) && (!PCS)
	while(dir = readdir(fp)) {
#else
	while(fread(dir,sizeof(struct direct),1,fp)) {
#endif
#endif
		if(!dir->d_ino || (select && !(*select)(dir)))
			continue;
		if(dir_cnt == array_cnt) {
			if(array_cnt) {
				array_cnt *= 2;
				if(!(nameptr = (struct direct **)
					malloc((unsigned int)
						(sizeof(struct direct *) * array_cnt))))
					goto free_mem;
				bcopy((char *)*namelist,(char *)nameptr,(int)
					(sizeof(struct direct *) * dir_cnt));
				free((char *)*namelist);
				*namelist = nameptr;
			}
			else {
				array_cnt = 64;
				if(!(*namelist = nameptr = (struct direct **)
					malloc((unsigned int)(sizeof(struct direct *) * array_cnt))))
					return(-1);
			}
		}
		if(!(dirptr = (struct direct *)
			malloc((unsigned int)sizeof(struct direct))))
			goto free_mem;
		*dirptr = *dir;
		nameptr[dir_cnt++] = dirptr;
	}
#if (SYSV3 | HP300 | X386_NEW | HP800 | SGI | AUX | RIOS | M_88K | CLIX | SYSV4) && (!UNISYS)
	closedir(fp);
#else 
	fclose(fp); 
#endif

	if(compar && dir_cnt > 1)
		qsort(nameptr,dir_cnt,(int)sizeof(struct direct *),*compar);

	return(dir_cnt);

free_mem:
#if (SYSV3 | HP300 | X386_NEW | HP800 | SGI | AUX | RIOS | M_88K | CLIX | SYSV4) && (!UNISYS)
	closedir(fp);
#else
	fclose(fp);
#endif
	nameptr = *namelist;
	while(dir_cnt--)
		free((char *)nameptr[dir_cnt]);
	free((char *)nameptr);
	return(-1);
}
#endif	/* SYS&SYS5 */





#if AXMS   /*  {   Windows/NT */

/*****************************************************
function: AddNameToPath - adds filename and DIRSLASH
                            to current directory path.
*/
char *AddNameToPath(char *currentDir, LPWIN32_FIND_DATA lpData)
{
    char *newpath;
    newpath = (char*)malloc(STRPATH*sizeof(char));
    
    strcpy(newpath, currentDir);
    strcat(newpath, "\\");
    strcat(newpath, lpData->cFileName);

    return(newpath);
} 

/********************************************************
function: IsDir - returns true if filename is a directory
*/
BOOL IsDir(LPWIN32_FIND_DATA lpData)
{
    int     cmp1, cmp2;
    DWORD   dir;
    
    cmp1 = strcmp(lpData->cFileName, ".");
    cmp2 = strcmp(lpData->cFileName, "..");    
    dir  = FILE_ATTRIBUTE_ARCHIVE | FILE_ATTRIBUTE_DIRECTORY; 
    
    if ((lpData->dwFileAttributes == dir) &&
                        (cmp1 != 0) && (cmp2 != 0))
        return TRUE;
    	    	   
    return FALSE;
}                
#endif   /*   }   Windows/NT */
