/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: agetusr.c
   Applix ASC version: 13
   Date: Tue Jan 12 21:12:34 1999
*/
#include <utloc.h>
#include <stdlib.h>

#if AXMS
#   include <basicwin.h>
#   define MAX_USERNAME_LENGTH 20 /* according to system manual */
#else
#   include <apwd.h>
#endif


/**************************************************************************
    Agetuser - Obtain the current user name.

    Agetuser() provides a generic interface for obtaining the current
    user name. See also getpwuid(3) getuid(3)

    On successful completion, Agetuser() returns a pointer to a static
    buffer that holds the current user name.  On error, 0 is returned.
*/

char *Agetuser()
{
    char *envP;

#if AXMS
    static char user_name[MAX_USERNAME_LENGTH+1];
    DWORD buffLength = MAX_USERNAME_LENGTH;

    if ((MS32_GetUserName(user_name, &buffLength)) != FALSE)
        return (user_name);
#else        

    struct passwd *pwd;
# if CLIX
    extern struct passwd *getpwuid(const int);
# else
    extern struct passwd *getpwuid();
# endif

    if(pwd = getpwuid(getuid()))
        return(pwd->pw_name);


#endif

    if ((envP = getenv(NXLT("USER"))) == 0)
    {
        if ((envP = getenv(NXLT("USERNAME"))) == 0)
            return(NULL);
    }

    return(envP);
}

