/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: astrcmp.c
   Applix ASC version: 7
   Date: Mon Nov 16 13:57:59 1998
*/
#include <aos.h>
#include <ctype.h>
#include <wchars.h>

/*************************************************************************
function: Astrcmp - Case insensitive string compare
Formerly used Imap... no longer does
*/
int Astrcmp(str1, str2)
register mbchar *str1;
register mbchar *str2;
{
	register unsigned int char1,char2;
	
	if (str1 == str2)
		return(0);

	while ( ((char1 = *str1++ & 0xff) != 0) & ((char2 = *str2++ & 0xff) != 0)) {
		char1 = Atoupper(char1);
		char2 = Atoupper(char2);
		if (char1 != char2)
			break;
	}
	return(char1 - char2);
}



/** The following function is used to do a case-insensitive compare         */
/** of strings as part of doing a "qsort", where the inputs are (char **)   */
int AStrcmpP(s1, s2)
mbchar          **s1, **s2;
{
    return (Astrcmp(*s1, *s2));
}
 

/** The following function is used to do a case-sensitive compare         */
/** of strings as part of doing a "qsort", where the inputs are (char **)   */
int StrcmpP(s1, s2)
mbchar          **s1, **s2;
{
    return (strcmp(*s1, *s2));
}
 



#if BUILD_WIDE    /*  {  */


/*** do a case insensitive (for western characters) wide string comparison */
int AWstrcmp(str1, str2)
register wchar *str1;
register wchar *str2;
{
    register unsigned int char1,char2;
 
    if (str1 == str2)
        return(0);
 
    while ( ((char1 = *str1++) != 0) & ((char2 = *str2++) != 0)) 
        {
        char1 = Atoupper(char1);
        char2 = Atoupper(char2);
        if (char1 != char2)
            break;
        }
    return(char1 - char2);
}
 


/*************************************************************************
function: WMbstrcaseeq - Compare (case insensitive) a wide string, and a
multi-byte string, return TRUE if equal */
 
WMbstrcaseeq (s1,s2)
register wchar *s1;
register mbchar *s2;
{
    for ( ; Atoupper(*s1) == Atoupper(*s2); s1++,s2++ )
        {
        if ( *s1 == (wchar)0 )
            return(TRUE);
        }
    return(FALSE);
}
 


#endif    /*  } BUILD_WIDE */


