/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: tolower.c
   Applix ASC version: 5
   Date: Mon Nov 16 13:58:00 1998
*/
#include <stdio.h>
#include <aos.h>
#include <wchars.h>

int Atolower (c)
register unsigned int c;
{
    if ( IS_ORIENT_CHAR( c ) )
        return( c );

	if (Aisupper (c))
        {
        /* the following works for standard alphabetic chars, and   */
        /*   for ISO-8859 accented characters                       */
        c = c + 0x20;
        }
	return (c);
		
}



Aisupper( c )
register unsigned int c;
{
    if ( ((c >= 'A') && (c <='Z')) ||
         ((c >= 0xC0) && (c <= 0xDE)) &&
         (c != 0xD7) )
       return( TRUE );
    else
       return( FALSE );
}



Aisalpha( c )
register unsigned int c;
{
    /** the two section below dupliucate Aisupper and Aislower.  These */
    /**   functions are not called for performance reasons             */

    /* check for upper case */
    if ( ((c >= 'A') && (c <='Z')) ||
         ((c >= 0xC0) && (c <= 0xDE)) &&
         (c != 0xD7) )
       return( TRUE );

    /* check for lower case */
    if ( ((c >= 'a') && (c <='z')) ||
         ((c >= 0xE0) && (c <= 0xFE)) &&
         (c != 0xF7) )
       return( TRUE );

    return ( FALSE );
}

Aisalnum( c )
register unsigned int c;
{
    /** the two section below dupliucate Aisupper and Aislower.  These */
    /**   functions are not called for performance reasons             */

    /* check for upper case */
    if ( ((c >= 'A') && (c <='Z')) ||
         ((c >= 0xC0) && (c <= 0xDE)) &&
         (c != 0xD7) )
       return( TRUE );

    /* check for lower case */
    if ( ((c >= 'a') && (c <='z')) ||
         ((c >= 0xE0) && (c <= 0xFE)) &&
         (c != 0xF7) )
       return( TRUE );

	/* check for number */
	 if ((c >= '0') && (c <='9'))
		return( TRUE );

    return ( FALSE );
}
