/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: utgtopt.c
   Applix ASC version: 7
   Date: Mon Nov 16 13:58:00 1998
*/
#if LINUX
#define _BSD_SOURCE 1
#define _POSIX_C_SOURCE 1
#endif

#include <stdio.h>
#include <utloc.h>

#if THIMBLE
#define place ut_getopt_place
char *place = "";
#endif
int		opterr = 1,			/* useless, never set or used */
		optind = 1,			/* index into parent argv vector */
		optopt=0;				/* character checked for validity */
char   	*optarg=NULL;			/* argument associated with option */

#define BADCH	(int)'?'
#define EMSG	""
#ifdef VERBOSE
#define tell(s)	fputs(*nargv,stderr);fputs(s,stderr); \
		fputc(optopt,stderr);fputc('\n',stderr);return(BADCH);
#else
#define tell(s) return(BADCH);
#endif

int
getopt(nargc, nargv, ostr)
int		nargc;
char * const nargv[];
const char  *ostr;
{
#if !THIMBLE
	static char	*place = EMSG;	/* option letter processing */
#endif
	register char	*oli;		/* option letter list index */

	if(!*place) {
		/* update scanning pointer */
		if(   optind >= nargc
		   || *(place = nargv[optind]) != '-'
		   || !*++place)
		{
			return(EOF);
		}
		if (*place == '-') {
			/* found "--" */
			++optind;
			return(EOF);
		}
	}
	/* option letter okay? */
	if (   (optopt = (int)*place++) == (int)':'
		|| !(oli = strchr(ostr, optopt)))
	{
		if(!*place) ++optind;
		tell(": illegal option -- ");
	}
	if (*++oli != ':') {
		/* don't need argument */
		optarg = NULL;
		if (!*place) ++optind;
	}
	else {
		/* need an argument */
		if (*place) {
			/* no white space */
			optarg = place;
		}
		else if (nargc <= ++optind) {
			/* no arg */
			place = EMSG;
			tell(": option requires an argument -- ");
		}
	 	else {
			/* white space */
			optarg = nargv[optind];
		}
		place = EMSG;
		++optind;
	}
	return(optopt);						/* dump back option letter */
}


/* GNU Emacs settings - This (including the "\n^L") MUST be the last thing
 *                      in this file!
 * Local variables:
 * mode: c
 * tab-width: 4
 * end:
 */
