/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: wpdefs.h
   Applix ASC version: 139.9
   Date: Wed Jun  2 21:11:35 1999
*/
/* STRIP LINES THROUGH HERE */


/* Generic defines for ELF */

#ifndef ELFDEFS
#define AX_FORBIDDEN_SYMBOL NXLT("$")
#define AX_RESERVED_SYMBOL NXLT("@")
#else
define AX#FORBIDDEN#SYMBOL NXLT("$")
define AX#RESERVED#SYMBOL NXLT("@")
#endif


/* Common characters */

#ifndef ELFDEFS
#else
define BLANK$ NXLT(" ")
define SQUOTE$ NXLT("'")
define SBACKQUOTE$ NXLT("`")
define DQUOTE$ NXLT("\"")
define BANG$ NXLT("!")
define COMMA$ NXLT(",")
#endif


/*** Document variable names ***/

#ifndef ELFDEFS

#define WP_EDIT_HISTORY_VAR		NXLT("EditHistory$") /* User-created edit hist */
#define WP_LANGUAGE_VAR			NXLT("Language@")
#define WP_USER_NAME_VAR		NXLT("UserName$")
#define WP_FILE_CREATOR_VAR		NXLT("Creator$") /* Where did doc come from? */
#define WP_FILE_CREATED_VAR		NXLT("Created$") /* version/rev when created */
#define WP_CREATION_DATE_VAR	NXLT("CreationDate$")
#define WP_CREATION_USER_VAR	NXLT("CreationUser$")
#define WP_FILE_UPDATED_VAR		NXLT("Updated$") /* version/rev of last save */
#define WP_UPDATE_DATE_VAR		NXLT("UpdateDate$")
#define WP_UPDATE_USER_VAR		NXLT("UpdateUser$")
#define WP_READ_ONLY_VAR		NXLT("ReadOnly@")	/* Read-only mode */
#define WP_TERSE_FILE_VAR		NXLT("TerseFile@")	/* Write 'terse' doc file */
#define WP_BUILD_STAMP_VAR		NXLT("BuildStamp$")	/* Datestamp for exe */
#define WP_DOC_NAME_VAR			NXLT("DocName$")	/* (Short) document name */
#define WP_PATH_NAME_VAR		NXLT("PathName$")	/* Full path name */
#define WP_PATH_NAME_REAL_VAR	NXLT("PathNameReal$")	/* ...when printing */
#define WP_PATH_NAME_IMPORT_VAR	NXLT("PathNameImport$")	/* ...of orig import */
#define WP_BACKGROUND_SAVE_VAR	NXLT("BackgroundSave$")	/* re creation vars */
#define ME_SAVE_COMPILED_VAR	NXLT("SaveCompiled@")	/* Save compiled obj? */
#define WP_LEVEL_INDENT_VAR		NXLT("LevelIndent@")	/* Indent per level */
#define WP_WIDOW_ORPHAN_VAR		NXLT("AllowWidowOrphan@")
#define WP_FACING_PAGES_VAR		NXLT("FacingPages@")	/* 2-sided doc? */
#define WP_HEADER_MARGIN_VAR	NXLT("HeaderMargin@")	/* amt of hdr margin */
#define WP_FOOTER_MARGIN_VAR	NXLT("FooterMargin@")	/* amt of ftr margin */
#define WP_IGNORE_LAST_PARA_VAR	NXLT("IgnoreLastPara@")	/* ...in searches */
#define WP_IGNORE_LAST_SECT_VAR	NXLT("IgnoreLastSect@")	/* ...in searches */
#define WP_CHANGE_BAR_POS_VAR	NXLT("ChangeBarPos@")	/* Left, Right, outer */
#define WP_HOOK_MACRO_NAME_VAR	NXLT("HookMacroName@")	/* WP_SET_HOOK@ (old) */
#define WP_HOOKS_VAR			NXLT("HookArray$")		/* WP_SET_HOOK@ (new)*/
#define WP_DOC_WIN_ATTR_TYPE_VAR	NXLT("DocWindowAttrType@")	/* dflt,last,fxd */
#define WP_DOC_WIN_SIZE_VAR		NXLT("DocWindowSize$")	/* width, height */
#define WP_DOC_IS_FORM_VAR		NXLT("DocIsForm@")	/* Open doc in form mode */
#define WP_MACRO_SRC_PREFIX_VAR	NXLT("ElfSrc$")		/* For elf source in WP */
#define WP_MACRO_OBJ_PREFIX_VAR	NXLT("ElfObj$")		/* For elf object in WP */
#define WP_EMULATE_21_VAR		NXLT("Emulate21@")	/* emulate 2.1 tabs, etc. */
#define WP_DOC_ZOOM_VAR			NXLT("DocZoom@")	/* zoom percentage */
#define WP_HTML_BASE_URL_VAR	NXLT("HtmlBaseURL@")	/* as in <BASE> */
#define WP_HTML_URL_VAR			NXLT("HtmlURL@")		/* Web access URL */
#define WP_ENTRY_SHADE_VAR		NXLT("EntryShade@")		/* Shading code for entry fld/cell */
#define WP_ENTRY_COLOR_VAR		NXLT("EntryColor@")		/* Color name for entry fld/cell */
#define WP_EDIT_FORM_PARAS_VAR	NXLT("AllowEditFormParas@")	/* Not strict locking */

#else

define WP#EDIT#HISTORY#VAR		NXLT("EditHistory$") 
define WP#LANGUAGE#VAR			NXLT("Language@")
define WP#USER#NAME#VAR			NXLT("UserName$")
define WP#FILE#CREATOR#VAR		NXLT("Creator$")
define WP#FILE#CREATED#VAR		NXLT("Created$")
define WP#CREATION#DATE#VAR		NXLT("CreationDate$")
define WP#CREATION#USER#VAR		NXLT("CreationUser$")
define WP#FILE#UPDATED#VAR		NXLT("Updated$")
define WP#UPDATE#DATE#VAR		NXLT("UpdateDate$")
define WP#UPDATE#USER#VAR		NXLT("UpdateUser$")
define WP#READ#ONLY#VAR			NXLT("ReadOnly@")
define WP#TERSE#FILE#VAR		NXLT("TerseFile@")
define WP#BUILD#STAMP#VAR		NXLT("BuildStamp$")
define WP#DOC#NAME#VAR			NXLT("DocName$")
define WP#PATH#NAME#VAR			NXLT("PathName$")
define WP#PATH#NAME#REAL#VAR	NXLT("PathNameReal$")
define WP#PATH#NAME#IMPORT#VAR	NXLT("PathNameImport$")
define WP#BACKGROUND#SAVE#VAR	NXLT("BackgroundSave$")
define ME#SAVE#COMPILED#VAR		NXLT("SaveCompiled@")
define WP#LEVEL#INDENT#VAR		NXLT("LevelIndent@")
define WP#WIDOW#ORPHAN#VAR		NXLT("AllowWidowOrphan@")
define WP#FACING#PAGES#VAR		NXLT("FacingPages@")
define WP#HEADER#MARGIN#VAR		NXLT("HeaderMargin@")
define WP#FOOTER#MARGIN#VAR		NXLT("FooterMargin@")
define WP#IGNORE#LAST#PARA#VAR	NXLT("IgnoreLastPara@")
define WP#IGNORE#LAST#SECT#VAR	NXLT("IgnoreLastSect@")
define WP#CHANGE#BAR#POS#VAR	NXLT("ChangeBarPos@")
define WP#HOOK#MACRO#NAME#VAR	NXLT("HookMacroName@")
define WP#HOOKS#VAR				NXLT("HookArray$")
define WP#DOC#WIN#ATTR#TYPE#VAR	NXLT("DocWindowAttrType@")
define WP#DOC#WIN#SIZE#VAR		NXLT("DocWindowSize$")
define WP#DOC#IS#FORM#VAR		NXLT("DocIsForm@")
define WP#MACRO#SRC#PREFIX#VAR	NXLT("ElfSrc$")
define WP#MACRO#OBJ#PREFIX#VAR	NXLT("ElfObj$")
define WP#EMULATE#21#VAR		NXLT("Emulate21@")
define WP#DOC#ZOOM#VAR			NXLT("DocZoom@")
define WP#HTML#BASE#URL#VAR		NXLT("HtmlBaseURL@")
define WP#HTML#URL#VAR			NXLT("HtmlURL@")
define WP#ENTRY#SHADE#VAR		NXLT("EntryShade@")
define WP#ENTRY#COLOR#VAR		NXLT("EntryColor@")
define WP#EDIT#FORM#PARAS#VAR	NXLT("AllowEditFormParas@")

#endif


/*** Session variable names ***/

#ifndef ELFDEFS
#define WP_USER_DICT_VAR		NXLT("DefaultDict@")	/* Old "user dict" */
#define WP_DICTS_VAR			NXLT("CustomDicts@")
#define WP_SKIP_DICT_VAR		NXLT("SkipDict@")
#define WP_DOC_DICT_VAR			NXLT("DocDict@")		/* !!1 future enh */
#define WP_NEW_DICTS_VAR		NXLT("NewDicts@")
#define WP_PAGE_COUNT_VAR		NXLT("PageCount$")
#define WP_VIEW_ONLY_VAR		NXLT("ViewOnly$")	/* Cannot edit at all! */
#define ME_CURRENT_COMPILE_VAR	NXLT("CurrentCompile$")  /* compile is ok */
#define ME_COMPILED_OBJECT_VAR	NXLT("CompiledObject$") /* ...from ME compile */
#define ME_SAVE_ASCII_VAR		NXLT("SaveASCII@") 	/* save ASCII file */
#define WP_IS_REV2_DOC_VAR		NXLT("IsRev2Doc@")		/* TRUE if 2.1 doc */
#define WP_PREFETCHED_URL		NXLT("PrefetchedURL$") /* tmp file for URL */
#define HTML_INSET_TRUENAME_VAR	NXLT("htmlInsetTrueName$") /* editing inset */
#define WP_TRUENAME_VAR			NXLT("TrueName$") 		/* original fname */
#define WP_INSET_PARENTS_VAR	NXLT("InsetParents$") 	/* Parents list */
#define WP_FORCE_SAVE_AS_VAR	NXLT("ForceSaveAs@") /* Save -> Save As dbox */
#define WP_LINK_HISTORY_VAR		NXLT("LinkHistory$") /* Stack of docs */
#else
define WP#USER#DICT#VAR			NXLT("DefaultDict@")
define WP#DICTS#VAR				NXLT("CustomDicts@")
define WP#SKIP#DICT#VAR			NXLT("SkipDict@")
define WP#DOC#DICT#VAR			NXLT("DocDict@")
define WP#NEW#DICTS#VAR			NXLT("NewDicts@")
define WP#PAGE#COUNT#VAR		NXLT("PageCount$")
define WP#VIEW#ONLY#VAR			NXLT("ViewOnly$")
define ME#CURRENT#COMPILE#VAR	NXLT("CurrentCompile$")
define ME#COMPILED#OBJECT#VAR	NXLT("CompiledObject$")
define ME#SAVE#ASCII#VAR		NXLT("SaveASCII@")
define WP#IS#REV2#DOC#VAR		NXLT("IsRev2Doc@")
define WP#PREFETCHED#URL		NXLT("PrefetchedURL$")
define HTML#INSET#TRUENAME#VAR	NXLT("htmlInsetTrueName$")
define WP#TRUENAME#VAR			NXLT("TrueName$")
define WP#INSET#PARENTS#VAR		NXLT("InsetParents$")
define WP#FORCE#SAVE#AS#VAR		NXLT("ForceSaveAs@") /* Save -> Save As dbox */
define WP#LINK#HISTORY#VAR		NXLT("LinkHistory$") /* Stack of docs */
#endif


/*** Document-specific Window Creation Options ***/

#ifndef ELFDEFS
#define WP_DOC_WIN_ATTR_DEFAULT		0	/* no doc-specified win attrs */
#define WP_DOC_WIN_ATTR_LAST		1	/* use attrs during last save */
#define WP_DOC_WIN_ATTR_FIXED		2	/* use specified attrs (don't update) */
#else
define WP#DOC#WIN#ATTR#DEFAULT		0
define WP#DOC#WIN#ATTR#LAST			1
define WP#DOC#WIN#ATTR#FIXED		2
#endif


/*** Style names ***/

/*
  Note there are a pair of defines for each style:
	- The default name of the style (e.g. 'Cell')
	- The name of an associated document variable (e.g. 'CellStyle@')
  When the code needs to find a default style, it looks up the name in
  the appropriate document var. These will be preloaded with the default
  names.
*/

#ifndef ELFDEFS
#define WP_CELL_STYLE				XLT2("Style name","Cell")
#define WP_CELL_STYLE_VAR			NXLT("CellStyle@")
#define WP_HDR_FTR_STYLE			XLT2("Style name","HdrFtr")
#define WP_HDR_FTR_STYLE_VAR		NXLT("HdrFtrStyle@")
#define WP_FOOTNOTE_STYLE			XLT2("Style name","Footnote")
#define WP_FOOTNOTE_STYLE_VAR		NXLT("FootnoteStyle@")
#define WP_FIELD_ERROR_STYLE		XLT2("Style name","FieldError")
#define WP_FIELD_ERROR_STYLE_VAR	NXLT("FieldErrorStyle@")
#define WP_FRAME_STYLE				XLT2("Style name","Frame")
#define WP_FRAME_STYLE_VAR			NXLT("FrameStyle@")
#define WP_TOC_STYLE				XLT2("Style name","TOC")
#define WP_TOC_STYLE_VAR			NXLT("TOCStyle@")
#define WP_TOC_STYLE_PREFIX			XLT2("Style name prefix","TOC-")
#else
define WP#CELL#STYLE				XLT2("Style name","Cell")
define WP#CELL#STYLE#VAR			NXLT("CellStyle@")
define WP#HDR#FTR#STYLE				XLT2("Style name","HdrFtr")
define WP#HDR#FTR#STYLE#VAR			NXLT("HdrFtrStyle@")
define WP#FOOTNOTE#STYLE			XLT2("Style name","Footnote")
define WP#FOOTNOTE#STYLE#VAR		NXLT("FootnoteStyle@")
define WP#FIELD#ERROR#STYLE			XLT2("Style name","FieldError")
define WP#FIELD#ERROR#STYLE#VAR		NXLT("FieldErrorStyle@")
define WP#FRAME#STYLE				XLT2("Style name","Frame")
define WP#FRAME#STYLE_VAR			NXLT("FrameStyle@")
define WP#TOC#STYLE					XLT2("Style name","TOC")
define WP#TOC#STYLE#VAR				NXLT("TOCStyle@")
define WP#TOC#STYLE#PREFIX			XLT2("Style name prefix","TOC-")
#endif


/*** Tags ***/

#ifndef ELFDEFS
#define WP_CELL_MACRO_TAG			NXLT("$$PrevSelectedCell$$") /* Form mode */
#define WP_MAIN_FLOW_CURSOR_TAG		NXLT("$$MainFlowCursor$$") /* most recent */
#else
define WP#CELL#MACRO#TAG			NXLT("$$PrevSelectedCell$$")
define WP#MAIN#FLOW#CURSOR#TAG		NXLT("$$MainFlowCursor$$")
#endif


/*** Glossaries ***/

#ifndef ELFDEFS
#define WP_MERGE_GLOSSARY				NXLT("Merge$")	/* contains merge data */
#define WP_CELL_RADIO_ON_GLOSSARY		NXLT("CellRadioOn@")	/* [X] */
#define WP_CELL_RADIO_OFF_GLOSSARY		NXLT("CellRadioOff@")	/* [ ] */
#define WP_CELL_TOGGLE_ON_GLOSSARY		NXLT("CellToggleOn@")	/* [X] */
#define WP_CELL_TOGGLE_OFF_GLOSSARY		NXLT("CellToggleOff@")	/* [ ] */
#define WP_FOOTNOTE_BAR_GLOSSARY		NXLT("FootnoteBar@")
#define WP_FOOTNOTE_CONT_BAR_GLOSSARY	NXLT("FootnoteContBar@")
#define WP_ENDNOTE_BAR_GLOSSARY			NXLT("EndnoteBar@")
#define WP_OLD_FOOTNOTE_BAR_GLOSSARY		NXLT("footnoteBar")	/* C only */
#define WP_OLD_FOOTNOTE_CONT_BAR_GLOSSARY	NXLT("footnoteContBar") /* C only */
#define WP_OLD_ENDNOTE_BAR_GLOSSARY			NXLT("footnoteBarEndDoc") /* C only */
#define WP_TABLE_CONT_GLOSSARY			NXLT("TableContinuation@")
#else
define WP#MERGE#GLOSSARY				NXLT("Merge$")
define WP#CELL#RADIO#ON#GLOSSARY		NXLT("CellRadioOn@")
define WP#CELL#RADIO#OFF#GLOSSARY		NXLT("CellRadioOff@")
define WP#CELL#TOGGLE#ON#GLOSSARY		NXLT("CellToggleOn@")
define WP#CELL#TOGGLE#OFF#GLOSSARY		NXLT("CellToggleOff@")
define WP#FOOTNOTE#BAR#GLOSSARY			NXLT("FootnoteBar@")
define WP#FOOTNOTE#CONT#BAR#GLOSSARY	NXLT("FootnoteContBar@")
define WP#ENDNOTE#BAR#GLOSSARY			NXLT("EndnoteBar@")
define WP#TABLE#CONT#GLOSSARY			NXLT("TableContinuation@")
#endif


/*** Constants ***/

#ifndef ELFDEFS
#define FORCE_ON					1	/* Nominal bool value forced TRUE */
#define OPTIONAL_ON					2	/* Nominal bool value optionally TRUE */
#define WP_TEMPLATE_FILE			XLT("empty.aw")		/* Dflt WP style */
#define WP_ASCII_TEMPLATE_FILE		XLT("ascii.aw")		/* Dflt WP ASCII style*/
#define ME_TEMPLATE_FILE			XLT("empty.am")		/* Dflt ME style */
#define ME_ASCII_TEMPLATE_FILE		XLT("ascii.am")		/* Dflt ME ASCII style*/
#define HTML_TEMPLATE_FILE			XLT("html.aw")		/* Dflt HTML style */
#define WP_MARKER_PADDED_CELL		NXLT("PaddedCell")	/* Extra Copy cell */
#define WP_MARKER_ENTRY_START		NXLT("$$EntryStart$$")	/* Before E fld */
#define WP_MARKER_ENTRY_END			NXLT("$$EntryEnd$$")	/* After E fld */
#else
define FORCE#ON						1
define OPTIONAL#ON					2
define WP#TEMPLATE#FILE				XLT("empty.aw")		/* Dflt WP style */
define WP#ASCII#TEMPLATE#FILE		XLT("ascii.aw")		/* Dflt WP ASCII style*/
define ME#TEMPLATE#FILE				XLT("empty.am")		/* Dflt ME style */
define ME#ASCII#TEMPLATE#FILE		XLT("ascii.am")		/* Dflt ME ASCII style*/
define HTML#TEMPLATE#FILE			XLT("html.aw")		/* Dflt HTML style */
define WP#MARKER#PADDED#CELL		NXLT("PaddedCell")	/* Extra Copy cell */
define WP#MARKER#ENTRY#START		NXLT("$$EntryStart$$")	/* Before E fld */
define WP#MARKER#ENTRY#END			NXLT("$$EntryEnd$$")	/* After E fld */
#endif



/*** WP attributes ***/

/* 'Generic' attribute flags */

#ifndef ELFDEFS
#define WP_ATTRS_NONE 			-2			/* No tabs, no frame... */
#define WP_ATTRS_LOCALS 		-1			/* Some or all locals */
#define WP_ATTRS_INHERIT 		0			/* All inherits (the default) */
#define WP_ATTRS_UNKNOWN 		-999		/* Need to resolve state */
#else
define WP#ATTRS#NONE 			-2
define WP#ATTRS#LOCALS 			-1
define WP#ATTRS#INHERIT 		0
define WP#ATTRS#UNKNOWN 		-999
#endif

/* General values */

#ifndef ELFDEFS
#else
define WP#NONE#STRING XLT("None")
define WP#OFF#STRING XLT("Off")
define WP#ON#STRING XLT("On")
define WP#LOCAL#STRING XLT("Local")
define WP#NO#STRING XLT("No")
define WP#YES#STRING XLT("Yes")
#endif


/*** Character attributes ***/

/* Font names */

#ifndef ELFDEFS
#define WP_FONT_TIMES NXLT("Times")
#define WP_FONT_BOOKMAN NXLT("Bookman")
#define WP_FONT_SCHOOL NXLT("New Century Schoolbook")
#define WP_FONT_CHANCERY NXLT("Zapf Chancery")
#define WP_FONT_PALATINO NXLT("Palatino")
#define WP_FONT_COURIER NXLT("Courier")
#define WP_FONT_HELVETICA NXLT("Helvetica")
#define WP_FONT_HELVNARROW NXLT("Helvetica Narrow")
#define WP_FONT_AVANT NXLT("Avant Garde")
#define WP_FONT_SYMBOL NXLT("Symbol")
#define WP_FONT_DINGBATS NXLT("Zapf Dingbats")
#if BUILD_KANJI
#define WP_FONT_MINCHOU NXLT("Minchou")
#define WP_FONT_GOTHIC NXLT("Gothic")
#endif

#else

define WP#FONT#TIMES_ NXLT("Times")
define WP#FONT#TIMES#STRING NXLT("Times Roman")
define WP#FONT#BOOKMAN_ NXLT("Bookman")
define WP#FONT#BOOKMAN#STRING NXLT("ITC Bookman")
define WP#FONT#SCHOOL_ NXLT("New Century Schoolbook")
define WP#FONT#SCHOOL#STRING NXLT("New Century Schoolbook")
define WP#FONT#CHANCERY_ NXLT("Zapf Chancery")
define WP#FONT#CHANCERY#STRING NXLT("ITC Zapf Chancery")
define WP#FONT#PALATINO_ NXLT("Palatino")
define WP#FONT#PALATINO#STRING NXLT("Palatino")
define WP#FONT#COURIER_ NXLT("Courier")
define WP#FONT#COURIER#STRING NXLT("Courier")
define WP#FONT#HELVETICA_ NXLT("Helvetica")
define WP#FONT#HELVETICA#STRING NXLT("Helvetica")
define WP#FONT#HELVNARROW_ NXLT("Helvetica Narrow")
define WP#FONT#HELVNARROW#STRING NXLT("Helvetica Narrow")
define WP#FONT#AVANT_ NXLT("Avant Garde")
define WP#FONT#AVANT#STRING NXLT("ITC Avant Garde Gothic")
define WP#FONT#SYMBOL_ NXLT("Symbol")
define WP#FONT#SYMBOL#STRING NXLT("Symbol")
define WP#FONT#DINGBATS_ NXLT("Zapf Dingbats")
define WP#FONT#DINGBATS#STRING NXLT("Zapf Dingbats")
define WP#FONT#MINCHOU_ NXLT("Minchou")
define WP#FONT#MINCHOU#STRING NXLT("Minchou")
define WP#FONT#GOTHIC NXLT("Gothic")
define WP#FONT#GOTHIC#STRING NXLT("Gothic")
#endif

/* "Raw text face array" contents:
 * Note we don't use zero, as it is convenient in the C source to treat
 * this array as a string */

#ifndef ELFDEFS
#define WP_FONT_TYPE_LATIN			1		/* Times, Bookman, Courier... */
#define WP_FONT_TYPE_SYMBOL			2		/* Symbol only */
#define WP_FONT_TYPE_DINGBATS		3		/* Dingbats only */
#else
define WP#FONT#TYPE#LATIN			1
define WP#FONT#TYPE#SYMBOL			2
define WP#FONT#TYPE#DINGBATS		3
#endif

/* Pointsize */

#ifndef ELFDEFS
#else
define WP#SIZE#6#STRING XLT("6 point")
define WP#SIZE#8#STRING XLT("8 point")
define WP#SIZE#10#STRING XLT("10 point")
define WP#SIZE#12#STRING XLT("12 point")
define WP#SIZE#14#STRING XLT("14 point")
define WP#SIZE#18#STRING XLT("18 point")
define WP#SIZE#24#STRING XLT("24 point")
define WP#SIZE#36#STRING XLT("36 point")
define WP#SIZE#OTHER#STRING XLT("Other")
#endif

/* Position */

#ifndef ELFDEFS
#else
define WP#POS#NORMAL#POINTS_ 0
define WP#POS#SUB#POINTS_ -3
define WP#POS#SUPER#POINTS_ 3
define WP#POS#NORMAL#STRING XLT("Normal")
define WP#POS#SUB#STRING XLT("Subscript")
define WP#POS#SUPER#STRING XLT("Superscript")
#endif

/* Underline */

#ifndef ELFDEFS
#define WP_ATTRS_UNDER_NONE		0		/* No underlining */
#define WP_ATTRS_UNDER_SINGLE	1		/* Single underlining */
#define WP_ATTRS_UNDER_DOUBLE	2		/* Double underlining */
#define WP_ATTRS_UNDER_WORDS	3		/* Underline by words */
#define WP_ATTRS_UNDER_DOUBLE_WORDS 4 	/* Double word underlining */
#define WP_ATTRS_UNDER_NOTABS	5		/* Underline everything but tabs */
#define WP_ATTRS_UNDER_DOUBLE_NOTABS 6 /* Double Underline everything but tabs */
#else
define WP#UNDER#NONE_ 0
define WP#UNDER#SINGLE_ 1
define WP#UNDER#SINGLE#STRING XLT("Single")
define WP#UNDER#DOUBLE_ 2		/* Double underlining */
define WP#UNDER#DOUBLE#STRING XLT("Double")
define WP#UNDER#WORDS_ 3		/* By words */
define WP#UNDER#WORDS#STRING XLT("Single Words")
define WP#UNDER#DOUBLE#WORDS_ 4	
define WP#UNDER#DOUBLE#WORDS#STRING XLT("Double Words")
define WP#UNDER#NOTABS 5
define WP#UNDER#NOTABS#STRING XLT("Single Not Tabs")
define WP#UNDER#DOUBLE#NOTABS 6
define WP#UNDER#DOUBLE#NOTABS#STRING XLT("Double Not Tabs")
#endif

/* Caps */

#ifndef ELFDEFS
#define WP_ATTRS_CAPS_NONE		0		/* Leave lowercase letters alone */
#define WP_ATTRS_CAPS_ALL		1		/* Display lowercase as uppercase */
#define WP_ATTRS_CAPS_SMALL		2		/* Lowercase -> smaller size upper */
#else
define WP#CAPS#NORMAL_ 0
define WP#CAPS#UPPER_ 1
define WP#CAPS#LOWER_ 2
#endif

/* Hyphenation Methods */

/* The following are obsolete as of 4.0 */
#ifdef ELFDEFS
define WP#HYPHENATE#ALGORITHM 0
define WP#HYPHENATE#DICTIONARY 1	/* Really means Dict w/Rule-based backup */
define WP#HYPHENATE#NONE_ 2
#endif

/* Document hyphenation options for 4.0 */
/* Note we preserve the order of the previous defines (see above)
	so that old scripts will still run properly */
#ifndef ELFDEFS
#define WP_HYPH_CALC_ONLY		0		/* Rule-based only */
#define WP_HYPH_DICT_CALC		1		/* Dictionary with rule-based backup */
#define WP_HYPH_NONE			2		/* Don't hyphenate */
#define WP_HYPH_DICT_ONLY		3		/* Dictionary only */
#define WP_HYPH_PROFILE			4		/* Use profile setting */
#else
define WP#HYPH#CALC#ONLY		0		/* Rule-based only */
define WP#HYPH#DICT#CALC		1		/* Dictionary with rule-based backup */
define WP#HYPH#NONE				2		/* Don't hyphenate */
define WP#HYPH#DICT#ONLY		3		/* Dictionary only */
define WP#HYPH#PROFILE			4		/* Use profile setting */
#endif

/* Proximity hyphenation defines - as copied from aspeller.h for use in 
	direct calls to generic (non-WP) hyphenation functions (e.g. in the 
	TEXT_HYPHENATE@ macro) */
#ifdef ELFDEFS
define HYPH_NONE				0		/* Don't hyphenate */
define HYPH_DICT				1		/* Dictionary only */
define HYPH_CALC				2		/* Rule-based only */
define HYPH_DICT_CALC			3		/* Dictionary with rule-based backup */
#endif


/*** Paragraph attributes ***/

/* Justification */

#ifndef ELFDEFS
#define WP_JUSTIFY_LEFT		0		/* Left aligned */
#define WP_JUSTIFY_RIGHT	1		/* Right aligned */
#define WP_JUSTIFY_CENTER	2		/* Center aligned */
#define WP_JUSTIFY_FULL		3		/* Pad out to full width */
#else
define WP#JUSTIFY#LEFT_ 0		/* Left aligned */
define WP#JUSTIFY#LEFT#STRING XLT("Left")
define WP#JUSTIFY#RIGHT_ 1		/* Right aligned */
define WP#JUSTIFY#RIGHT#STRING XLT("Right")
define WP#JUSTIFY#CENTER_ 2		/* Center aligned */
define WP#JUSTIFY#CENTER#STRING XLT("Center")
define WP#JUSTIFY#FULL_ 3		/* Padded to both sides */
define WP#JUSTIFY#FULL#STRING XLT("Justified")
#endif

/* Line-height computation modes and names (linespacing)*/

#ifndef ELFDEFS
					/*26 May 1999 rjd History: 441 used (0,1,2) for Mode;	  */
					/* 442 started using (3,2,1), which is incompatible with  */
					/* 441.  We now write two linespacing Mode values:		  */
					/* lineSpacingMode = 441 values; lineSpacingMode2 = 442.  */
					/* This writes files 441 can read, and files 442 can read,*/
					/* but not files the older 442 (before today) can read.   */

					/*26 May 1999 rjd Values used in 441 (lineSpacingMode)	  */
#define WP_LINESPACING_MODE_441_AUTO 0			/* Line height				  */
#define WP_LINESPACING_MODE_441_EXACT	1		/* Fixed by user or filter 	  */
#define WP_LINESPACING_MODE_441_ATLEAST	2		/*Minimum value in para attrs.*/

					/*26 May 1999 rjd Accomodate 442 values from before today */
#define WP_LINESPACING_MODE_OLD442_ATLEAST 1
#define WP_LINESPACING_MODE_OLD442_EXACT 2
#define WP_LINESPACING_MODE_OLD442_MULTILINE 3

					/*26 May 1999 rjd 442 values in lineSpacingMode2		  */
#define WP_LINESPACING_MODE_ATLEAST 4
#define WP_LINESPACING_MODE_EXACT 5
#define WP_LINESPACING_MODE_MULTILINE 6

#define WP_LINESPACING_MODE_FORCESINGLE 7	/* Deal with erroneous .aw files  */

#define WP_LINESPACING_SCALE 1000			/* Precision and N*(# lines)	  */

#if 0 /*26 May 1999 Don't use names. Numerals are historical, and take less space.*/
											/* These are new names in AW files*/
#define WP_LINESPACING_MODE_ATLEAST_NAME "ATLST"
#define WP_LINESPACING_MODE_EXACT_NAME	"EXACT"
#define WP_LINESPACING_MODE_MULTILINE_NAME "MULTI"
#endif

#else
					/*26 May 1999 rjd Elf won't see the old 441, 442 values,  */
					/* so define only new ones here.						  */
define WP#LINESPACING#MODE#ATLEAST	4		/* Minimum value in para attrs.	  */
define WP#LINESPACING#MODE#EXACT	5		/* Fixed by user or filter 		  */
define WP#LINESPACING#MODE#MULTILINE 6		/* Space = x*current line height  */

											/*Following are for the dialog box*/
											/* See wpattrs.els.				  */
define WP#LINESPACING#SINGLE	0			/* Subscript in combo box		  */
define WP#LINESPACING#3HALVES 	1
define WP#LINESPACING#DOUBLE	2  
define WP#LINESPACING#ATLEAST	3
define WP#LINESPACING#EXACT		4
define WP#LINESPACING#MULTIPLE	5
define WP_LINESPACING_SCALE 1000

define WP#LINESPACING#SINGLE#STRING XLT("Single")
define WP#LINESPACING#3HALVES#STRING XLT("1.5 Lines")
define WP#LINESPACING#DOUBLE#STRING XLT("Double")
define WP#LINESPACING#ATLEAST#STRING XLT("At least")
define WP#LINESPACING#EXACT#STRING XLT("Exact")
define WP#LINESPACING#MULTIPLE#STRING XLT("Multiple")
define WP#LINESPACING#Label_lines XLT("lines")

#endif

/* Cursor to start/end line */

#ifndef ELFDEFS
#define WP_CURSOR_NOT_TO_ENDLINE 0				/* Desired position			  */
#define WP_CURSOR_TO_END_LINE 1
#define WP_CURSOR_TO_START_LINE 2
#define WP_CURSOR_TO_END_LINE_STICK 3
#define WP_CURSOR_TO_START_LINE_STICK 4
#else
define WP_CURSOR_NOT_TO_ENDLINE 0
define WP_CURSOR_TO_END_LINE 1
define WP_CURSOR_TO_START_LINE 2
define WP_CURSOR_TO_END_LINE_STICK 3
define WP_CURSOR_TO_START_LINE_STICK 4
#endif

/* Cursor coordinates. WP_GET_CURSOR_XY@ */

#ifndef ELFDEFS
#define WP_GET_CURSOR_WINDOW 0
#define WP_GET_CURSOR_PAGE 1
#define WP_GET_CURSOR_DOC 2
#else
define WP#GET#CURSOR#WINDOW 0
define WP#GET#CURSOR#PAGE 1
define WP#GET#CURSOR#DOC 2
#endif

/* Tab types */

#ifndef ELFDEFS
#define WP_MAX_TABS		50	/* max # of tabs per para/style */
#define WP_TAB_LEFT		0
#define WP_TAB_RIGHT	1
#define WP_TAB_CENTER	2
#define WP_TAB_DECIMAL	3
#define WP_TAB_INDENT	4	/* (psuedo) tabs in to left para indent */
#else
define WP#MAX#TABS		50	
define WP#TAB#LEFT_ 0
define WP#TAB#RIGHT_ 1
define WP#TAB#CENTER_ 2
define WP#TAB#DECIMAL_ 3
define WP#TAB#INDENT_ 4
#endif

/* Pagebreak */

#ifndef ELFDEFS
#else
define WP#PBREAK#BEFORE#STRING XLT("Before")
#endif

/* Keep with next */

#ifndef ELFDEFS
#else
define WP#KEEPWITH#NEXT#STRING XLT("Next")
#endif

/* Indent to level */

#ifndef ELFDEFS
#else
define WP#INDENTTOLEV#NO#STRING XLT("No affect")
define WP#INDENTTOLEV#YES#STRING XLT("Has affect")
#endif


/*** Frames ***/

/* Frame identity */

#ifndef ELFDEFS
#define WP_FRAME_DEF_INHERIT	0  /* normal case (inherit parent frame def) */
#define WP_FRAME_DEF_NONE		1  /* no frame (override parent frame def) */
#define WP_FRAME_DEF_LOCAL		2  /* use local frame def (override parent) */
#else
define WP#FRAME#DEF#INHERIT			0
define WP#FRAME#DEF#NONE			1
define WP#FRAME#DEF#LOCAL			2
#endif

/* Frame types */

#ifndef ELFDEFS
#define WP_FRAME_FLOW_AROUND	0
#define WP_FRAME_JUMP_OVER		1
#define WP_FRAME_BACKGROUND		2
#else
define WP#FRAME#FLOW#AROUND			0
define WP#FRAME#JUMP#OVER			1
define WP#FRAME#BACKGROUND			2
#endif

/* Frame horizontal position */

#ifndef ELFDEFS
#define WP_FRAME_XREL_PAGE		0
#define WP_FRAME_XREL_MARGIN	1
#define WP_FRAME_XREL_COLUMN	2
#else
define WP#FRAME#XREL#PAGE			0
define WP#FRAME#XREL#MARGIN			1
define WP#FRAME#XREL#COLUMN			2
#endif

#ifndef ELFDEFS
#define WP_FRAME_XPOS_LEFT		0
#define WP_FRAME_XPOS_CENTER	1
#define WP_FRAME_XPOS_RIGHT		2
#define WP_FRAME_XPOS_OUTSIDE	3
#define WP_FRAME_XPOS_INSIDE	4
#else
define WP#FRAME#XPOS#LEFT			0
define WP#FRAME#XPOS#CENTER			1
define WP#FRAME#XPOS#RIGHT			2
define WP#FRAME#XPOS#OUTSIDE		3
define WP#FRAME#XPOS#INSIDE			4
#endif

/* Frame vertical position */

#ifndef ELFDEFS
#define WP_FRAME_YREL_PAGE		0
#define WP_FRAME_YREL_MARGIN	1
#define WP_FRAME_YREL_PARA		2
#else
define WP#FRAME#YREL#PAGE			0
define WP#FRAME#YREL#MARGIN			1
define WP#FRAME#YREL#PARA			2
#endif

#ifndef ELFDEFS
#define WP_FRAME_YPOS_TOP		0
#define WP_FRAME_YPOS_CENTER	1
#define WP_FRAME_YPOS_BOTTOM	2
#else
define WP#FRAME#YPOS#TOP			0
define WP#FRAME#YPOS#CENTER			1
define WP#FRAME#YPOS#BOTTOM			2
#endif

/* Frame width */

#ifndef ELFDEFS
#define WP_FRAME_WIDTH_AUTO		0
#define WP_FRAME_WIDTH_EXACT	1
#else
define WP#FRAME#WIDTH#AUTO			0
define WP#FRAME#WIDTH#EXACT			1
#endif

/* Frame height */

#ifndef ELFDEFS
#define WP_FRAME_HEIGHT_AUTO	0
#define WP_FRAME_HEIGHT_EXACT	1
#define WP_FRAME_HEIGHT_MIN		2
#define WP_FRAME_HEIGHT_MAX		3
#else
define WP#FRAME#HEIGHT#AUTO			0
define WP#FRAME#HEIGHT#EXACT		1
define WP#FRAME#HEIGHT#MIN			2
define WP#FRAME#HEIGHT#MAX			3
#endif


/*** Section ***/

/* Section types */

#ifndef ELFDEFS
#define WP_SECTION_CONTINUOUS	0
#define WP_SECTION_NEXT_COLUMN	1
#define WP_SECTION_NEXT_PAGE	2
#define WP_SECTION_ODD_PAGE		3
#define WP_SECTION_EVEN_PAGE	4
#else
define WP#SECTION#CONTINUOUS		0
define WP#SECTION#NEXT#COLUMN		1
define WP#SECTION#NEXT#PAGE			2
define WP#SECTION#ODD#PAGE			3
define WP#SECTION#EVEN#PAGE			4
#endif

/* Header/Footer types */

#ifndef ELFDEFS
#define WP_ODD_HDRFTR_INHERIT			0  /* use same hdr/ftr as prev section*/
#define WP_ODD_HDRFTR_NORMAL			1  /* use local definition */
#define WP_ODD_HDRFTR_NONE				2  /* no hdr/ftr for this section */
#define WP_ODD_HDRFTR_USE_GLOSSARY		3  /* use named glossary as hdr/ftr */
#else
define WP#ODD#HDRFTR#INHERIT		0
define WP#ODD#HDRFTR#NORMAL			1
define WP#ODD#HDRFTR#NONE			2
define WP#ODD#HDRFTR#USE#GLOSSARY	3
#endif

#ifndef ELFDEFS
#define WP_EVEN_HDRFTR_USE_ODD			0  /* use odd hdr/ftr (for even,first)*/
#define WP_EVEN_HDRFTR_INHERIT			1  /* use same hdr/ftr as prev section*/
#define WP_EVEN_HDRFTR_NORMAL			2  /* use local definition */
#define WP_EVEN_HDRFTR_NONE				3  /* no hdr/ftr for this section */
#define WP_EVEN_HDRFTR_USE_GLOSSARY		4  /* use named glossary as hdr/ftr */
#else
define WP#EVEN#HDRFTR#USE#ODD		0
define WP#EVEN#HDRFTR#INHERIT		1
define WP#EVEN#HDRFTR#NORMAL		2
define WP#EVEN#HDRFTR#NONE			3
define WP#EVEN#HDRFTR#USE#GLOSSARY	4
#endif

#ifndef ELFDEFS
#define WP_FIRST_HDRFTR_NOT_SPECIAL		0  /* use approprite odd/even hdr/ftr */
#define WP_FIRST_HDRFTR_INHERIT			1  /* use same hdr/ftr as prev section*/
#define WP_FIRST_HDRFTR_NORMAL			2  /* use local definition */
#define WP_FIRST_HDRFTR_NONE			3  /* no hdr/ftr for this section */
#define WP_FIRST_HDRFTR_USE_GLOSSARY	4  /* use named glossary as hdr/ftr */
#else
define WP#FIRST#HDRFTR#NOT#SPECIAL	0
define WP#FIRST#HDRFTR#INHERIT		1
define WP#FIRST#HDRFTR#NORMAL		2
define WP#FIRST#HDRFTR#NONE			3
define WP#FIRST#HDRFTR#USE#GLOSSARY	4
#endif

#ifndef ELFDEFS
#define WP_LAST_HDRFTR_NOT_SPECIAL		0  /* use approprite odd/even hdr/ftr */
#define WP_LAST_HDRFTR_INHERIT			1  /* use same hdr/ftr as prev section*/
#define WP_LAST_HDRFTR_NORMAL			2  /* use local definition */
#define WP_LAST_HDRFTR_NONE				3  /* no hdr/ftr for this section */
#define WP_LAST_HDRFTR_USE_GLOSSARY		4  /* use named glossary as hdr/ftr */
#else
define WP#LAST#HDRFTR#NOT#SPECIAL	0
define WP#LAST#HDRFTR#INHERIT		1
define WP#LAST#HDRFTR#NORMAL		2
define WP#LAST#HDRFTR#NONE			3
define WP#LAST#HDRFTR#USE#GLOSSARY	4
#endif

/* Page orientations */

#ifndef ELFDEFS
#define WP_PAGE_PORTRAIT		0
#define WP_PAGE_LANDSCAPE		1
#else
define WP#PAGE#PORTRAIT_			0
define WP#PAGE#LANDSCAPE_			1
#endif

/* Printing options */

#ifndef ELFDEFS
#define WP_PRINT_SIMPLEX			0
#define WP_PRINT_DUPLEX_LONG		1
#define WP_PRINT_DUPLEX_SHORT		2
#else
define WP#PRINT#SIMPLEX				0
define WP#PRINT#DUPLEX#LONG			1
define WP#PRINT#DUPLEX#SHORT		2
#endif

/*** Borders & Shading ***/

/* Shading */

#ifndef ELFDEFS
#define WP_SHADING_FILL_A				0
#define WP_SHADING_FILL_M				1
#define WP_SHADING_FILL_B				2
#define WP_SHADING_FILL_C				3
#define WP_SHADING_FILL_D				4
#define WP_SHADING_FILL_N				5
#define WP_SHADING_FILL_E				6
#define WP_SHADING_FILL_F				7
#define WP_SHADING_FILL_G				8
#define WP_SHADING_FILL_H				9
#define WP_SHADING_FILL_I				10
#define WP_SHADING_FILL_J				11
#define WP_SHADING_FILL_K				12
#define WP_SHADING_FILL_L				13
#define WP_SHADING_FILL_O				14
#define WP_SHADING_FILL_P				15
#define WP_SHADING_FILL_Q				16
#define WP_SHADING_FILL_R				17
#define WP_SHADING_NONE					18
#define WP_SHADING_LINEAR_GRADIENT		19
#define WP_SHADING_RADIAL_GRADIENT		20
#define WP_SHADING_RECT_GRADIENT		21
#define WP_SHADING_USER_DEFINED			22
#else
define WP#SHADING#FILL#A				0
define WP#SHADING#FILL#M				1
define WP#SHADING#FILL#B				2
define WP#SHADING#FILL#C				3
define WP#SHADING#FILL#D				4
define WP#SHADING#FILL#N				5
define WP#SHADING#FILL#E				6
define WP#SHADING#FILL#F				7
define WP#SHADING#FILL#G				8
define WP#SHADING#FILL#H				9
define WP#SHADING#FILL#I				10
define WP#SHADING#FILL#J				11
define WP#SHADING#FILL#K				12
define WP#SHADING#FILL#L				13
define WP#SHADING#FILL#O				14
define WP#SHADING#FILL#P				15
define WP#SHADING#FILL#Q				16
define WP#SHADING#FILL#R				17
define WP#SHADING#NONE					18
define WP#SHADING#LINEAR#GRADIENT		19
define WP#SHADING#RADIAL#GRADIENT		20
define WP#SHADING#RECT#GRADIENT			21
define WP#SHADING#USER#DEFINED			22
#endif

/* Shadow */

#ifndef ELFDEFS
#define WP_SHADOW_NONE			0
#define WP_SHADOW_BOTTOM_RIGHT	1
#define WP_SHADOW_TOP_LEFT		2  /* not yet implemented */
#define WP_SHADOW_BOTTOM_LEFT	3  /* not yet implemented */
#define WP_SHADOW_TOP_RIGHT		4  /* not yet implemented */
#else
define WP#SHADOW#NONE			0
define WP#SHADOW#BOTTOM#RIGHT	1
define WP#SHADOW#TOP#LEFT		2
define WP#SHADOW#BOTTOM#LEFT	3
define WP#SHADOW#TOP#RIGHT		4
#endif

/* Border type based on cursor/selection */

#ifndef ELFDEFS
#define WP_BORDER_PARAGRAPH					0
#define WP_BORDER_SINGLE_ROW_SINGLE_COL		1
#define WP_BORDER_SINGLE_ROW_MULTI_COL		2
#define WP_BORDER_MULTI_ROW_SINGLE_COL		3
#define WP_BORDER_MULTI_ROW_MULTI_COL		4
#else
define WP#BORDER#PARAGRAPH					0
define WP#BORDER#SINGLE#ROW#SINGLE#COL		1
define WP#BORDER#SINGLE#ROW#MULTI#COL		2
define WP#BORDER#MULTI#ROW#SINGLE#COL		3
define WP#BORDER#MULTI#ROW#MULTI#COL		4
#endif

/* Range types based on section */

#ifndef ELFDEFS
#else
define WP#RANGE#CURSOR				0
define WP#RANGE#SINGLE#SECTION		1
define WP#RANGE#MULTI#SECTION		2
#endif


/*** Numbering ***/

/* Generic numbering styles  - for series, page and section numbering */

#ifndef ELFDEFS
#define WP_NUMBERING_NONE			-1
#define WP_NUMBERING_ARABIC			0			/* 1, 2, 3... */
#define WP_NUMBERING_LETTER_UPPER	1			/* A, B, C... */
#define WP_NUMBERING_LETTER_LOWER	2			/* a, b, c... */
#define WP_NUMBERING_ROMAN_UPPER	3			/* I, II, III... */
#define WP_NUMBERING_ROMAN_LOWER	4			/* i, ii, iii... */
#else
define WP#NUMBERING#NONE			-1
define WP#NUMBERING#ARABIC			0			/* 1, 2, 3... */
define WP#NUMBERING#LETTER#UPPER	1			/* A, B, C... */
define WP#NUMBERING#LETTER#LOWER	2			/* a, b, c... */
define WP#NUMBERING#ROMAN#UPPER		3			/* I, II, III... */
define WP#NUMBERING#ROMAN#LOWER		4			/* i, ii, iii... */
#endif

/* Page numbering styles */
/* !!0 To be phased out in favor of the above */

#ifndef ELFDEFS
#define WP_PAGENUM_ARABIC			0
#define WP_PAGENUM_LETTER_UPPER		1
#define WP_PAGENUM_LETTER_LOWER		2
#define WP_PAGENUM_ROMAN_UPPER		3
#define WP_PAGENUM_ROMAN_LOWER		4
#else
define WP#PAGE#NUM#ARABIC			0
define WP#PAGE#NUM#ALPHABETIC#UPPER	1
define WP#PAGE#NUM#ALPHABETIC#LOWER	2
define WP#PAGE#NUM#ROMAN#UPPER		3
define WP#PAGE#NUM#ROMAN#LOWER		4
#endif

/* Section numbering controls */

#ifndef ELFDEFS
#define WP_SECT_NUM_SAME			0		/* Same # as previous section */
#define WP_SECT_NUM_INCREM			1		/* Increment previous section # */
#define WP_SECT_NUM_RESTART			2		/* Set to exact value */
#else
define WP#SECT#NUM#SAME				0
define WP#SECT#NUM#INCREM			1
define WP#SECT#NUM#RESTART			2
#endif

/* Special for standard and user-defined numbered series formats */

#ifndef ELFDEFS
#define WP_NUM_SERIES_1			0					/* 1, 2, 3... */
#define WP_NUM_SERIES_CAP_A		1					/* A, B, C... */
#define WP_NUM_SERIES_SMALL_A	2					/* a, b, c... */
#define WP_NUM_SERIES_CAP_I		3					/* i, ii, iii... */
#define WP_NUM_SERIES_SMALL_I	4					/* I, II, III... */
#define WP_NUM_SERIES_PREFIX	NXLT("UserSeries")	/* UserSeries1, 2, 3... */
#define WP_NUM_SERIES_BASE		1000				/* Add to trailing # */
#else
define WP#NUM#SERIES#1			0
define WP#NUM#SERIES#CAP#A		1
define WP#NUM#SERIES#SMALL#A	2
define WP#NUM#SERIES#CAP#I		3
define WP#NUM#SERIES#SMALL#I	4
define WP#NUM#SERIES#PREFIX		NXLT("UserSeries")
define WP#NUM#SERIES#BASE		1000
#endif


/*** Change bars ***/

#ifndef ELFDEFS
#define WP_CB_NOCHANGE 0
#define WP_CB_ADDED 1
#define WP_CB_DELETED 2
#define WP_CB_CHANGED 3
#else
define WP#CB#NOCHANGE 		0
define WP#CB#ADDED 			1
define WP#CB#DELETED 		2
define WP#CB#CHANGED 		3
#endif

#ifndef ELFDEFS
#define WP_CB_POS_LEFT		0	/* Change bars on left side of page */
#define WP_CB_POS_RIGHT		1	/* Change bars on right side of page */
#define WP_CB_POS_OUTER		2	/* Change bars in outer margin of 2-sided page*/
#else
define WP#CB#POS#LEFT		0
define WP#CB#POS#RIGHT		1
define WP#CB#POS#OUTER		2
#endif

#ifndef ELFDEFS
#define WP_CB_NONE			0	/* Not a Change Bars write (wpfileio.c flag) */
#define WP_CB_STANDARD		1	/* Consider attrs */
#define WP_CB_NO_ATTRS		2	/* Ignore text & para attrs */
#else
define WP#CB#NONE			0
define WP#CB#STANDARD		1
define WP#CB#NO#ATTRS		2
#endif


/*** Fields ***/

/* Field defines */

#ifndef ELFDEFS
#define WP_DATE_FIELD 1
#define WP_DATE_FIELD_STRING NXLT("date")
#define WP_TIME_FIELD 2
#define WP_TIME_FIELD_STRING NXLT("time")
#define WP_NUMBER_FIELD 3
#define WP_NUMBER_FIELD_STRING NXLT("series")
#define WP_FOOTNOTE_REF_FIELD 4
#define WP_FOOTNOTE_FIELD_STRING NXLT("footnote")
#define WP_FOOTNOTE_BODY_FIELD 5
#define WP_FOOTNOTE_BODY_FIELD_STRING NXLT("footnote_body")
#define WP_LINK_FILE_FIELD 6		/* linked inset */
#define WP_LINK_FIELD_STRING NXLT("link")
#define WP_LOCAL_INSET_FIELD 7		/* local inset */
#define WP_LOCAL_INSET_FIELD_STRING NXLT("local_inset")
#define WP_INCLUDE_FILE_FIELD 8			/* !!0 Still needed? */
#define WP_INCLUDE_FIELD_STRING NXLT("include")
#define WP_GLOSSARY_FIELD 9
#define WP_GLOSSARY_FIELD_STRING NXLT("glossary")
#define WP_XREF_FIELD 10
#define WP_XREF_FIELD_STRING NXLT("xref")
#define WP_XREF_SOURCE_FIELD 11
#define WP_XREF_SOURCE_FIELD_STRING NXLT("xref_source")
#define WP_INDEX_FIELD 12
#define WP_INDEX_FIELD_STRING NXLT("index")
#define WP_MAKE_INDEX_FIELD 13
#define WP_MAKE_INDEX_FIELD_STRING NXLT("make_index")
#define WP_MAKE_TOC_FIELD 14
#define WP_MAKE_TOC_FIELD_STRING NXLT("make_TOC")
#define WP_MERGE_FIELD 15
#define WP_MERGE_FIELD_STRING NXLT("merge")
#define WP_MACRO_FIELD 16
#define WP_MACRO_FIELD_STRING NXLT("macro")
#define WP_HYPER_TARGET_FIELD 17
#define WP_HYPER_TARGET_FIELD_STRING NXLT("hyper_target")
#define WP_SOFT_HYPHEN_FIELD 18
#define WP_SOFT_HYPHEN_FIELD_STRING NXLT("-")
#define WP_PAGE_NUMBER_FIELD 19
#define WP_PAGE_NUMBER_FIELD_STRING NXLT("page_number")
#define WP_PAGE_COUNT_FIELD 20
#define WP_PAGE_COUNT_FIELD_STRING NXLT("page_count")
#define WP_IF_VAR_FIELD 21
#define WP_IF_VAR_FIELD_STRING NXLT("if_var")
#define WP_IF_MACRO_FIELD 22
#define WP_IF_MACRO_FIELD_STRING NXLT("if_macro")
#define WP_ELF_STR_FIELD 23
#define WP_ELF_STR_FIELD_STRING NXLT("macro_string")
#define WP_ELF_BEAD_FIELD 24
#define WP_ELF_BEAD_FIELD_STRING NXLT("macro_beads")
#define WP_VAR_STR_FIELD 25
#define WP_VAR_STR_FIELD_STRING NXLT("var_string")
#define WP_ENTRY_FIELD 26
#define WP_ENTRY_FIELD_STRING NXLT("entry")
#define WP_HTML_TAG_FIELD 27
#define WP_HTML_TAG_FIELD_STRING NXLT("html_tag")
#define WP_PRINTER_CODE_FIELD 28
#define WP_PRINTER_CODE_FIELD_STRING NXLT("printer_code")
#define WP_PLAIN_FIELD 29
#define WP_PLAIN_FIELD_STRING NXLT("plain")
#else
define WP#DATE#FIELD 1
define WP#DATE#FIELD#STRING NXLT("date")
define WP#DATE#FIELD#NAME XLT("Date")
define WP#TIME#FIELD 2
define WP#TIME#FIELD#STRING NXLT("time")
define WP#TIME#FIELD#NAME XLT("Time")
define WP#NUMBER#FIELD 3
define WP#NUMBER#FIELD#STRING NXLT("series")
define WP#NUMBER#FIELD#NAME XLT("Numbered Series")
define WP#FOOTNOTE#REF#FIELD 4
define WP#FOOTNOTE#FIELD#STRING NXLT("footnote")
define WP#FOOTNOTE#FIELD#NAME XLT("Footnote")
define WP#FOOTNOTE#BODY#FIELD 5
define WP#FOOTNOTE#BODY#FIELD#STRING NXLT("footnote_body")
define WP#FOOTNOTE#BODY#FIELD#NAME XLT("Footnote Body")
define WP#LINK#FILE#FIELD 6
define WP#LINK#FIELD#STRING NXLT("link")
define WP#LINK#FIELD#NAME XLT("Link")
define WP#LOCAL#INSET#FIELD 7
define WP#LOCAL#INSET#FIELD#STRING NXLT("local_inset")
define WP#LOCAL#INSET#FIELD#NAME XLT("Local Inset")
define WP#INCLUDE#FILE#FIELD 8
define WP#INCLUDE#FIELD#STRING NXLT("include")
define WP#INCLUDE#FIELD#NAME XLT("Include")
define WP#GLOSSARY#FIELD 9
define WP#GLOSSARY#FIELD#STRING NXLT("glossary")
define WP#GLOSSARY#FIELD#NAME XLT("Glossary")
define WP#XREF#FIELD 10
define WP#XREF#FIELD#STRING NXLT("xref")
define WP#XREF#FIELD#NAME XLT("Cross-Reference")
define WP#XREF#SOURCE#FIELD 11
define WP#XREF#SOURCE#FIELD#STRING NXLT("xref_source")
define WP#XREF#SOURCE#FIELD#NAME XLT("Cross-Reference Source")
define WP#INDEX#FIELD 12
define WP#INDEX#FIELD#STRING NXLT("index")
define WP#INDEX#FIELD#NAME XLT("Index Entry")
define WP#MAKE#INDEX#FIELD 13
define WP#MAKE#INDEX#FIELD#STRING NXLT("make_index")
define WP#MAKE#INDEX#FIELD#NAME XLT("Index")
define WP#MAKE#TOC#FIELD 14
define WP#MAKE#TOC#FIELD#STRING NXLT("make_TOC")
define WP#MAKE#TOC#FIELD#NAME XLT("Table of Contents")
define WP#MERGE#FIELD 15
define WP#MERGE#FIELD#STRING NXLT("merge")
define WP#MERGE#FIELD#NAME XLT("Merge")
define WP#MACRO#FIELD 16
define WP#MACRO#FIELD#STRING NXLT("macro")
define WP#MACRO#FIELD#NAME XLT("Macro")
define WP#HYPER#TARGET#FIELD 17
define WP#HYPER#TARGET#FIELD#STRING NXLT("hyper_target")
define WP#HYPER#TARGET#FIELD#NAME XLT("Hypertarget")
define WP#SOFT#HYPHEN#FIELD 18
define WP#SOFT#HYPHEN#FIELD#STRING NXLT("-")
define WP#SOFT#HYPHEN#FIELD#NAME XLT("Soft Hyphen")
define WP#PAGE#NUMBER#FIELD 19
define WP#PAGE#NUMBER#FIELD#STRING NXLT("page_number")
define WP#PAGE#NUMBER#FIELD#NAME XLT("Page Number")
define WP#PAGE#COUNT#FIELD 20
define WP#PAGE#COUNT#FIELD#STRING NXLT("page_count")
define WP#PAGE#COUNT#FIELD#NAME XLT("Page Count")
define WP#IF#VAR#FIELD 21
define WP#IF#VAR#FIELD#STRING NXLT("if_var")
define WP#IF#VAR#FIELD#NAME XLT("Conditional Variable")
define WP#IF#MACRO#FIELD 22
define WP#IF#MACRO#FIELD#STRING NXLT("if_macro")
define WP#IF#MACRO#FIELD#NAME XLT("Conditional Macro")
define WP#ELF#STR#FIELD 23
define WP#ELF#STR#FIELD#STRING NXLT("macro_string")
define WP#ELF#STR#FIELD#NAME XLT("ELF Macro String")
define WP#ELF#BEAD#FIELD 24
define WP#ELF#BEAD#FIELD#STRING NXLT("macro_beads")
define WP#ELF#BEAD#FIELD#NAME XLT("ELF Macro Beads")
define WP#VAR#STR#FIELD 25
define WP#VAR#STR#FIELD#STRING NXLT("var_string")
define WP#VAR#STR#FIELD#NAME XLT("Document Variable String")
define WP#ENTRY#FIELD 26
define WP#ENTRY#FIELD#STRING NXLT("entry")
define WP#ENTRY#FIELD#NAME XLT("Entry")
define WP#HTML#TAG#FIELD 27
define WP#HTML#TAG#FIELD#STRING NXLT("html_tag")
define WP#HTML#TAG#FIELD#NAME NXLT("HTML Tag")
define WP#PRINTER#CODE#FIELD 28
define WP#PRINTER#CODE#FIELD#STRING NXLT("printer_code")
define WP#PRINTER#CODE#FIELD#NAME NXLT("Printer Code")
define WP#PLAIN#FIELD 29
define WP#PLAIN#FIELD#STRING NXLT("plain")
define WP#PLAIN#FIELD#NAME NXLT("Plain")
#endif

/* Field parameters */
/* Note:
	General pattern is WP_FIELD_PARM_<fieldtype>_<identifier>

	However, if a parameter is shared between multiple field types,
	use the pattern: WP_FIELD_PARM_<identifier>
*/
/* !!0 To do:
	- Make Index and TOC share _TITLE parm
*/

#ifndef ELFDEFS
#define WP_FIELD_PARM_TEXT 				NXLT("-text")		/* Latin text */
#define WP_FIELD_PARM_DTEXT 			NXLT("-dtext")		/* Dingbat text */
#define WP_FIELD_PARM_STEXT 			NXLT("-stext")		/* Symbol text */
#define WP_FIELD_PARM_TEXT_STYLE 		NXLT("-textStyle")	/* Style for text */
#define WP_FIELD_PARM_OUT_OF_DATE 		NXLT("-saveOutOfDate")/* obs, use... */
#define WP_FIELD_PARM_READ_EVAL 		NXLT("-readEval") /* Eval when read */
#define WP_FIELD_PARM_PRINT_EVAL 		NXLT("-printEval")/* Eval when printed*/
#define WP_FIELD_PARM_SAVE_EVAL 		NXLT("-saveEval") /* Eval when saved */
#define WP_FIELD_PARM_NO_EVAL 			NXLT("-noEval")  /* Never eval! */
#define WP_FIELD_PARM_EMPTY_VALUE 		NXLT("-emptyValue")  /* Force no FV */
#define WP_FIELD_PARM_GLOSSARY_VALUE 	NXLT("-glossary")	/* Gloss in FV */
#define WP_FIELD_PARM_PESERVE_VALUE 	NXLT("-preserveVal")/* Refmt val only */
#define WP_FIELD_PARM_2CLICK 			NXLT("-doubleClick")	/*calls macro */
#define WP_FIELD_PARM_2CLICK_MACRO 		NXLT("-dblClickMacro")	/*calls macro */
#define WP_FIELD_PARM_ENTER_MACRO 		NXLT("-enterMacro")		/*calls macro */
#define WP_FIELD_PARM_EXIT_MACRO 		NXLT("-exitMacro")		/*calls macro */
#define WP_FIELD_PARM_TYPING_MACRO 		NXLT("-typingMacro")	/*calls macro */
#define WP_FIELD_PARM_MACRO_TEXTBUTTON 	NXLT("-textButton")	/* text in button */
#define WP_FIELD_PARM_MACRO_TB_WIDTH 	NXLT("-buttonWidth")/* button width */
#define WP_FIELD_PARM_MACRO_ICONBUTTON 	NXLT("-iconButton")	/* icon in button */
#define WP_FIELD_PARM_MACRO_CMD			NXLT("-pass")	/* cmds for macro */

#define WP_FIELD_PARM_INSET_DOC_TYPE	NXLT("-docType")	/* inset doc type */
#define WP_FIELD_PARM_INSET_APP_TYPE 	NXLT("-appType")	/* inset app name */
#define WP_FIELD_PARM_INSET_APP_CODE 	NXLT("-appTypeCode")/* inset app type */
#define WP_FIELD_PARM_INSET_TYPE 		NXLT("-type")	/* OLD inset app type */
#define WP_FIELD_PARM_INSET_CVT 		NXLT("-cvt")		/* inset converter*/
#define WP_FIELD_PARM_INSET_CVTCMD		NXLT("-cvtcmd")	/* converter command */
#define WP_FIELD_PARM_INSET_APP			NXLT("-app")		/* foreign appl */
#define WP_FIELD_PARM_INSET_VIEW		NXLT("-view")	/* SS view/range/obj */
#define WP_FIELD_PARM_INSET_SS_OBJECT	NXLT("-ssObject")	/* SS object	  */
#define WP_FIELD_PARM_INSET_SS_RANGE	NXLT("-ssRange")	/* SS named range */
#define WP_FIELD_PARM_INSET_SS_VIEW		NXLT("-ssView")		/* SS view */
#define WP_FIELD_PARM_INSET_CLIPMODE	NXLT("-clipMode")	/* for graphics */
#define WP_FIELD_PARM_INSET_PICTURE		NXLT("-picture")  /* GFX, WPX, SSX.. */
#define WP_FIELD_PARM_INSET_XSCALE		NXLT("-xscale")	/* for graphics */
#define WP_FIELD_PARM_INSET_YSCALE		NXLT("-yscale")	/* for graphics */
#define WP_FIELD_PARM_INSET_XOFFSET		NXLT("-xoffset")	/* for graphics */
#define WP_FIELD_PARM_INSET_YOFFSET		NXLT("-yoffset")	/* for graphics */
#define WP_FIELD_PARM_INSET_SRCWIDTH	NXLT("-srcWidth")	/* for graphics */
#define WP_FIELD_PARM_INSET_SRCHEIGHT	NXLT("-srcHeight")	/* for graphics */
#define WP_FIELD_PARM_INSET_PROPORTIONAL	NXLT("-proportional")  /* " */
#define WP_FIELD_PARM_INSET_LASTSECT	NXLT("-lastSection")  /* use last section bead of WP*/
#define WP_FIELD_PARM_INSET_SHRINK_TBL	NXLT("-shrinkToFit")  /*make table fit*/
#define WP_FIELD_PARM_INSET_NOMERGECELLS NXLT("-noMergeCells") /*no merge from SS link*/
#define WP_FIELD_PARM_INDEX_SPAN		NXLT("-span")	/* spanning page #'s */
#define WP_FIELD_PARM_INDEX_SEEALSO		NXLT("-see")		/* See Also entry */
#define WP_FIELD_PARM_INDEX_LETTERHEAD	NXLT("-letterHeader")	/* "A" */
#define WP_FIELD_PARM_INDEX_BLANKHEAD	NXLT("-blankHeader")	/* Blank line */
#define WP_FIELD_PARM_INDEX_NOHEAD	 	NXLT("-noHeader")	/* No header */
#define WP_FIELD_PARM_INDEX_TITLE		NXLT("-title")	/* "Index" title */
#define WP_FIELD_PARM_NEWSTYLES			NXLT("-newStyles")/* Style override */
#define WP_FIELD_PARM_TOC_STYLES		NXLT("-styles")	/* Styles in TOC */
#define WP_FIELD_PARM_TOC_TITLE			NXLT("-contents")/* "Contents" title */
#define WP_FIELD_PARM_TOC_MAXLEVEL		NXLT("-maxLevel")/* ...for paras */
#define WP_FIELD_PARM_TOC_NOTAB			NXLT("-noTab")	/* ...before page # */
#define WP_FIELD_PARM_TOC_PLAINTAB		NXLT("-plainTab")/* ...before page # */
#define WP_FIELD_PARM_TOC_DOTTAB		NXLT("-dotTab")	/* ...before page # */
#define WP_FIELD_PARM_TOC_NONUMS		NXLT("-noPageNums")	/* ...for these */
#define WP_FIELD_PARM_TOC_STRIP_TABS	NXLT("-stripTabs")	/* from styles */
#define WP_FIELD_PARM_SERIES_NOINCREM	NXLT("-noIncrement")/* don't incr # */
#define WP_FIELD_PARM_SERIES_NODISPLAY	NXLT("-noDisplay")	/* don't disp # */
#define WP_FIELD_PARM_SERIES_SET		NXLT("-set")		/* set value of # */
#define WP_FIELD_PARM_SERIES_LEVEL		NXLT("-level")	/* override para level*/
#define WP_FIELD_PARM_FOOTNOTE_SERIES	NXLT("-series")	/* footnote series */
#define WP_FIELD_PARM_FOOTNOTE_ENDDOC	NXLT("-endDoc")	/* End-of-doc fnote */
#define WP_FIELD_PARM_XREFSRC_LIVE		NXLT("-live")	/* Xref's auto-change */
#define WP_FIELD_PARM_XREF_NEXT			NXLT("-next")	/* Find next xref src */
#define WP_FIELD_PARM_XREF_PREV			NXLT("-prev")	/* Find prev xref src */
#define WP_FIELD_PARM_XREF_MAINFLOW		NXLT("-mainFlow")/* Look in main flow */
#define WP_FIELD_PARM_XREF_PAGE_TOP		NXLT("-pageTop")	/* page top based */
#define WP_FIELD_PARM_XREF_PAGE_BOTTOM	NXLT("-pageBottom")/*page bottom based*/
#define WP_FIELD_PARM_MERGE_OFFSET		NXLT("-rowOffset")	/* which row? */
#define WP_FIELD_PARM_MERGE_ADVANCE		NXLT("-rowAdvance")	/* which row next?*/
#define WP_FIELD_PARM_MERGE_LAST_PARA	NXLT("-usePara")/* use last cell para */
#define WP_FIELD_PARM_NO_ICON			NXLT("-noIcon")/* no icon */
#define WP_FIELD_PARM_ICON				NXLT("-icon")	/* icon */
#define WP_FIELD_PARM_FORMAT			NXLT("-format")	/* (date/time) format */
#define WP_FIELD_PARM_COMMENT			NXLT("-comment")	/* comment */
#define WP_FIELD_PARM_HTML				NXLT("-html")	/* generic html field */
#define WP_FIELD_PARM_HTML_TAG			NXLT("-htmlTag")/* entire unknown tag */
#define WP_FIELD_PARM_HTML_PARM			NXLT("-htmlParm")	/* unknown parm */
#define WP_FIELD_PARM_HTML_ANCHOR		NXLT("-htmlAnchor")	/* this is a link */
#define WP_FIELD_PARM_HTML_IMG			NXLT("-htmlImg")	/* an image */
#define WP_FIELD_PARM_HTML_ALIGN		NXLT("-htmlAlign")	/* Img vert align */
#define WP_FIELD_PARM_HTML_ALT			NXLT("-htmlAlt")	/* no-grafix text */
#define WP_FIELD_PARM_HTML_ISMAP		NXLT("-htmlIsmap")	/*interactive bmap*/
#define WP_FIELD_PARM_ENTRY_CHARS		NXLT("-maxChars")	/* in field */
#define WP_FIELD_PARM_ENTRY_START_VAL	NXLT("-startValue")	/* e.g. [ */
#define WP_FIELD_PARM_ENTRY_END_VAL		NXLT("-endValue")	/* e.g. ] */
#define WP_FIELD_PARM_ENTRY_NEXT_ID		NXLT("-nextId")	/* next fld to goto */
#define WP_FIELD_PARM_ENTRY_LOCKED		NXLT("-locked")	/* ...in Form mode */
#define WP_FIELD_PARM_ENTRY_NEXT_FULL	NXLT("-nextIfFull")	/* re overflow */
#define WP_FIELD_PARM_ENTRY_CASE		NXLT("-case")	/* for text */
#define WP_FIELD_PARM_ENTRY_UNDERLINE	NXLT("-underline")	/* for text */
#define WP_FIELD_PARM_ENTRY_PROMPT		NXLT("-promptText")	/* status line msg*/
#define WP_FIELD_PARM_ENTRY_WIDTH		NXLT("-minWidth")	/* min fld width */
#define WP_FIELD_PARM_DOMAIN            NXLT("-domain") /* special for help; don't doc */
#define WP_FIELD_PARM_PRINT_ASCII		NXLT("-ascii") 	/* ascii code of escape/special char */
#define WP_FIELD_PARM_PRINT_PCL			NXLT("-pcl") 		/* Print code for PCL printer only */
#define WP_FIELD_PARM_PRINT_PS			NXLT("-postscript") /* Print code for PS printer only */
#define WP_FIELD_PARM_PRINT_GDI			NXLT("-gdi") 		/* Print code for GDI printer only */
#else
define WP#FIELD#PARM#TEXT 				NXLT("-text")
define WP#FIELD#PARM#DTEXT 				NXLT("-dtext")
define WP#FIELD#PARM#STEXT 				NXLT("-stext")
define WP#FIELD#PARM#TEXT#STYLE 		NXLT("-textStyle")
define WP#FIELD#PARM#OUT#OF#DATE 		NXLT("-saveOutOfDate")
define WP#FIELD#PARM#READ#EVAL 			NXLT("-readEval")
define WP#FIELD#PARM#PRINT#EVAL 		NXLT("-printEval")
define WP#FIELD#PARM#SAVE#EVAL 			NXLT("-saveEval")
define WP#FIELD#PARM#NO#EVAL 			NXLT("-noEval")
define WP#FIELD#PARM#EMPTY#VALUE 		NXLT("-emptyValue")
define WP#FIELD#PARM#GLOSSARY#VALUE 	NXLT("-glossary")
define WP#FIELD#PARM#PESERVE#VALUE 		NXLT("-preserveVal")
define WP#FIELD#PARM#2CLICK 			NXLT("-doubleClick")
define WP#FIELD#PARM#2CLICK#MACRO 		NXLT("-dblClickMacro")
define WP#FIELD#PARM#ENTER#MACRO 		NXLT("-enterMacro")
define WP#FIELD#PARM#EXIT#MACRO 		NXLT("-exitMacro")
define WP#FIELD#PARM#TYPING#MACRO 		NXLT("-typingMacro")
define WP#FIELD#PARM#MACRO#TEXTBUTTON 	NXLT("-textButton")
define WP#FIELD#PARM#MACRO#TB#WIDTH 	NXLT("-buttonWidth")
define WP#FIELD#PARM#MACRO#ICONBUTTON 	NXLT("-iconButton")
define WP#FIELD#PARM#MACRO#CMD			NXLT("-pass")

define WP#FIELD#PARM#INSET#DOC#TYPE 	NXLT("-docType")
define WP#FIELD#PARM#INSET#APP#TYPE 	NXLT("-appType")
define WP#FIELD#PARM#INSET#APP#CODE 	NXLT("-appTypeCode")
define WP#FIELD#PARM#INSET#TYPE 		NXLT("-type")	/* OLD (use -appType) */
define WP#FIELD#PARM#INSET#CVT 			NXLT("-cvt")
define WP#FIELD#PARM#INSET#CVTCMD		NXLT("-cvtcmd")
define WP#FIELD#PARM#INSET#APP			NXLT("-app")
define WP#FIELD#PARM#INSET#VIEW			NXLT("-view")
define WP#FIELD#PARM#INSET#SS#OBJECT	NXLT("-ssObject")
define WP#FIELD#PARM#INSET#SS#RANGE		NXLT("-ssRange")
define WP#FIELD#PARM#INSET#SS#VIEW		NXLT("-ssView")

define WP#FIELD#PARM#INSET#CLIPMODE		NXLT("-clipMode")
define WP#FIELD#PARM#INSET#PICTURE		NXLT("-picture")
define WP#FIELD#PARM#INSET#XSCALE		NXLT("-xscale")
define WP#FIELD#PARM#INSET#YSCALE		NXLT("-yscale")
define WP#FIELD#PARM#INSET#XOFFSET		NXLT("-xoffset")
define WP#FIELD#PARM#INSET#YOFFSET		NXLT("-yoffset")
define WP#FIELD#PARM#INSET#SRCWIDTH		NXLT("-srcWidth")
define WP#FIELD#PARM#INSET#SRCHEIGHT	NXLT("-srcHeight")
define WP#FIELD#PARM#INSET#PROPORTION	NXLT("-proportional")
define WP#FIELD#PARM#INSET#LASTSECT		NXLT("-lastSection")
define WP#FIELD#PARM#INSET#SHRINK#TBL	NXLT("-shrinkToFit")
define WP#FIELD#PARM#INSET#NOMERGECELLS NXLT("-noMergeCells") /*no merge from SS link*/

define WP#FIELD#PARM#INDEX#SPAN			NXLT("-span")
define WP#FIELD#PARM#INDEX#SEEALSO		NXLT("-see")
define WP#FIELD#PARM#INDEX#LETTERHEAD	NXLT("-letterHeader")
define WP#FIELD#PARM#INDEX#BLANKHEAD 	NXLT("-blankHeader")
define WP#FIELD#PARM#INDEX#NOHEAD	 	NXLT("-noHeader")
define WP#FIELD#PARM#INDEX#TITLE		NXLT("-title")
define WP#FIELD#PARM#NEWSTYLES			NXLT("-newStyles")
define WP#FIELD#PARM#TOC#STYLES			NXLT("-styles")
define WP#FIELD#PARM#TOC#TITLE			NXLT("-contents")
define WP#FIELD#PARM#TOC#MAXLEVEL		NXLT("-maxLevel")
define WP#FIELD#PARM#TOC#NOTAB			NXLT("-noTab")
define WP#FIELD#PARM#TOC#PLAINTAB		NXLT("-plainTab")
define WP#FIELD#PARM#TOC#DOTTAB			NXLT("-dotTab")
define WP#FIELD#PARM#TOC#NONUMS			NXLT("-noPageNums")
define WP#FIELD#PARM#TOC#STRIP#TABS		NXLT("-stripTabs")
define WP#FIELD#PARM#SERIES#NOINCREM	NXLT("-noIncrement")
define WP#FIELD#PARM#SERIES#NODISPLAY	NXLT("-noDisplay")
define WP#FIELD#PARM#SERIES#SET			NXLT("-set")
define WP#FIELD#PARM#SERIES#LEVEL		NXLT("-level")
define WP#FIELD#PARM#FOOTNOTE#SERIES	NXLT("-series")
define WP#FIELD#PARM#FOOTNOTE#ENDDOC	NXLT("-endDoc")
define WP#FIELD#PARM#XREFSRC#LIVE		NXLT("-live")
define WP#FIELD#PARM#XREF#NEXT			NXLT("-next")
define WP#FIELD#PARM#XREF#PREV			NXLT("-prev")
define WP#FIELD#PARM#XREF#MAINFLOW		NXLT("-mainFlow")
define WP#FIELD#PARM#XREF#PAGE#TOP		NXLT("-pageTop")
define WP#FIELD#PARM#XREF#PAGE#BOTTOM	NXLT("-pageBottom")
define WP#FIELD#PARM#MERGE#OFFSET		NXLT("-rowOffset")
define WP#FIELD#PARM#MERGE#ADVANCE		NXLT("-rowAdvance")
define WP#FIELD#PARM#MERGE#LAST#PARA	NXLT("-usePara")
define WP#FIELD#PARM#NO#ICON			NXLT("-noIcon")
define WP#FIELD#PARM#ICON				NXLT("-icon")
define WP#FIELD#PARM#FORMAT				NXLT("-format")	
define WP#FIELD#PARM#COMMENT			NXLT("-comment")
define WP#FIELD#PARM#HTML				NXLT("-html")
define WP#FIELD#PARM#HTML#TAG			NXLT("-htmlTag")
define WP#FIELD#PARM#HTML#PARM			NXLT("-htmlParm")
define WP#FIELD#PARM#HTML#ANCHOR		NXLT("-htmlAnchor")
define WP#FIELD#PARM#HTML#IMG			NXLT("-htmlImg")
define WP#FIELD#PARM#HTML#ALIGN			NXLT("-htmlAlign")
define WP#FIELD#PARM#HTML#ALT			NXLT("-htmlAlt")
define WP#FIELD#PARM#HTML#ISMAP			NXLT("-htmlIsmap")
define WP#FIELD#PARM#ENTRY#CHARS		NXLT("-maxChars")
define WP#FIELD#PARM#ENTRY#START#VAL	NXLT("-startValue")
define WP#FIELD#PARM#ENTRY#END#VAL		NXLT("-endValue")
define WP#FIELD#PARM#ENTRY#NEXT#ID		NXLT("-nextId")
define WP#FIELD#PARM#ENTRY#LOCKED		NXLT("-locked")
define WP#FIELD#PARM#ENTRY#NEXT#FULL	NXLT("-nextIfFull")
define WP#FIELD#PARM#ENTRY#CASE			NXLT("-case")
define WP#FIELD#PARM#ENTRY#UNDERLINE	NXLT("-underline")
define WP#FIELD#PARM#ENTRY#PROMPT		NXLT("-promptText")
define WP#FIELD#PARM#ENTRY#WIDTH		NXLT("-minWidth")
define WP#FIELD#PARM#DOMAIN             NXLT("-domain") 
define WP#FIELD#PARM#PRINT#ASCII		NXLT("-ascii")
define WP#FIELD#PARM#PRINT#PCL			NXLT("-pcl")
define WP#FIELD#PARM#PRINT#PS			NXLT("-postscript")
define WP#FIELD#PARM#PRINT#GDI			NXLT("-gdi")
#endif

/*** Command-line options (See WpConvertSSToBeads.) ***/

#define WP_FIELD_INSET_CMD_NOMC		NXLT("-nomc")	 /*no-merge tag for SS*/

/*** Objects ***/

/* App types */

#ifndef ELFDEFS
#define WP_APP_TYPE_NONE			0	/* MNone */
#define WP_APP_TYPE_WORDS			1	/* MText */
#define WP_APP_TYPE_GRAPHICS		2	/* MDrawing */
#define WP_APP_TYPE_SPREADSHEET		3	/* MSpreadsheet */
#define WP_APP_TYPE_MACRO			4	/* MUserCommand */
#define WP_APP_TYPE_AUDIO			5	/* MAudio */
#define WP_APP_TYPE_EQUATION		6	/* Equation */
#define WP_APP_TYPE_QUERY			7	/* Data */
#define WP_APP_TYPE_BITMAP			8	/* !! only used to get sfx */
#else
define WP#APP#TYPE#NONE				0
define WP#APP#TYPE#WORDS			1
define WP#APP#TYPE#GRAPHICS			2
define WP#APP#TYPE#SPREADSHEET		3
define WP#APP#TYPE#MACRO			4
define WP#APP#TYPE#AUDIO			5
define WP#APP#TYPE#EQUATION			6
define WP#APP#TYPE#QUERY			7
#endif

/* Graphics clip modes */

#ifndef ELFDEFS
#define WP_PICT_SCALE_TO_FIT_MODE			0
#define WP_PICT_CLIP_TO_FIT_MODE			1
#define WP_PICT_SCALE_IF_WOULD_CLIP_MODE	2
#else
define WP#PICT#SCALE#TO#FIT					0
define WP#PICT#CLIP#TO#FIT					1
define WP#PICT#SCALE#IF#WOULD#CLIP			2
#endif


/*** Color ***/

#ifndef ELFDEFS
#define WP_MAX_COLOR_VAL 255  /* max val for color values */
#else
define WP#MAX#COLOR#VALUE 255
#endif


/*** Tables ***/

/* Row alignment */

#ifndef ELFDEFS
#define WP_ROW_JUST_LEFT		0
#define WP_ROW_JUST_CENTER		1
#define WP_ROW_JUST_RIGHT		2
#else
define WP#ROW#ALIGN#LEFT		0
define WP#ROW#ALIGN#CENTER		1
define WP#ROW#ALIGN#RIGHT		2
#endif

/* Row height */

#ifndef ELFDEFS
#define WP_ROW_HEIGHT_AUTO		0
#define WP_ROW_HEIGHT_EXACT		1
#define WP_ROW_HEIGHT_MIN		2
#define WP_ROW_HEIGHT_MAX		3
#else
define WP#ROW#HEIGHT#AUTO		0
define WP#ROW#HEIGHT#EXACT		1
define WP#ROW#HEIGHT#MIN		2
define WP#ROW#HEIGHT#MAX		3
#endif

/* Vertical alignment within cell */

#ifndef ELFDEFS
#define WP_VERT_ALIGN_TOP		0
#define WP_VERT_ALIGN_CENTER	1
#define WP_VERT_ALIGN_BOTTOM	2
#define WP_VERT_ALIGN_JUSTIFIED	3
#else
define WP#VERT#ALIGN#TOP		0
define WP#VERT#ALIGN#CENTER		1
define WP#VERT#ALIGN#BOTTOM		2
define WP#VERT#ALIGN#JUSTIFIED	3
#endif


/*** Footnotes ***/

/* Special series for footnotes */

#ifndef ELFDEFS
#define WP_FOOTNOTE_SERIES			NXLT("Footnote$")	/* for bottom of page */
#define WP_OLD_ENDNOTE_SERIES		NXLT("FootnoteEndDoc$")	/* OBSOLETE */
#define WP_ENDNOTE_SERIES			NXLT("Endnote$")	/* for end of doc */
#else
define WP#FOOTNOTE#SERIES#PAGE		NXLT("Footnote$")	/* old define */
define WP#FOOTNOTE#SERIES#DOC		NXLT("Endnote$")	/* old define */
define WP#FOOTNOTE#SERIES			NXLT("Footnote$")
define WP#ENDNOTE#SERIES			NXLT("Endnote$")
#endif

/* Footnote types */

#ifndef ELFDEFS
#define WP_FOOTNOTE_BOTTOM_PAGE	0
#define WP_FOOTNOTE_END_DOC		1
#else
define WP#FOOTNOTE#BOTTOM#PAGE	0
define WP#FOOTNOTE#END#DOC		1
#endif


/*** Hypertext ***/

/* Special for Help Hypertext */

#ifndef ELFDEFS
#else
define WP#HELP#PREFIX#VAR 		NXLT("HelpPrefix@")
define WP#HELP#GLOSSARY#VAR 	NXLT("HelpGlossary@")
define WP#HELP#SECTION#VAR 		NXLT("HelpSection@")
define WP#HELP#STYLE#VAR 		NXLT("HelpStyle@")
#endif

/* Search directions */

#ifndef ELFDEFS
#define WP_SEARCH_FORWARDS		0
#define WP_SEARCH_BACKWARDS		1
#define WP_SEARCH_BOTH			2		/* i.e. both directions, or wrap */
#else
define WP#SEARCH#FORWARDS		0
define WP#SEARCH#BACKWARDS		1
define WP#SEARCH#BOTH			2
#endif


/*** Spelling ***/

/* Useful constants */

#ifndef ELFDEFS
#else
define WP#MAX#NUM#DICTS			8
#endif

/* Maximum-sized word Proximity (speller, thesaurus) wants to deal with: */

#ifndef ELFDEFS
#else
define MAXWORD 32
#endif


/*** HTML stuff ***/
#ifndef ELFDEFS
#define HTML_MODE_NONE			0			/* I.e. plain WP */
#define HTML_MODE_EDIT			1			/* Edit a doc destined for HTML export */
#define HTML_MODE_VIEW			2			/* Mini-browser */
#else
define HTML#MODE#NONE			0
define HTML#MODE#EDIT			1
define HTML#MODE#VIEW			2
#endif

/*** WP Instance stuff ***/

#ifndef ELFDEFS

#define BAD_INSET_UID			0			/* == BAD#INSET#UID in insets_.h */

#define WPX_WHOLE_DOC			0			/* Render whole doc */ 
#define WPX_FIRST_PAGE			1			/* Start at first page */
#define WPX_LAST_PAGE			2			/* End at last page */
#define WPX_PAGE				3 			/* Begin or end w/certain page... */
#define WPX_SECTION				4 			/* ...or a section... */
#define WPX_PARAGRAPH			5			/* ...or a paragraph... */ 
#define WPX_TABLE				6			/* ...or a table... */ 
#define WPX_ROW					7			/* ...or a row */

#define WPX_NUMBER				0 			/* Use object number 'value' */
#define WPX_STRING				1			/* 'value' holds desired string */ 
#define WPX_MARKER				2 			/* 'value' holds marker name */

#else

define WPX#WHOLE#DOC			0			/*  Render whole doc  */
define WPX#FIRST#PAGE			1			/* Start at first page */
define WPX#LAST#PAGE			2			/* End at last page */
define WPX#PAGE					3 			/* Begin or end with a page... */
define WPX#SECTION				4 			/* ...or a section... */
define WPX#PARAGRAPH			5			/* ...or a paragraph...  */
define WPX#TABLE				6			/* ...or a table...  */
define WPX#ROW					7			/* ...or a row */

define WPX#NUMBER				0 			/* Use object number 'value' */
define WPX#STRING				1			/* 'value' holds desired string  */
define WPX#MARKER				2 			/* 'value' holds marker name */

format wp_inset_source@
	format ax_area@ area,		/* Ignored during measurement call. During */
								/* rendering call, if not NULL, overrides */
								/* the remaining flags. */
	format ax_units@ units,		/* Units 'area' is expressed in. */
	start_type,					/* WPX#WHOLE#DOC, WPX#PAGE, WPX#TABLE, etc. */
	start_contents_type,		/* WPX#NUMBER, WPX#STRING, WPX#MARKER */
	start_value,				/* Value for 'start_contents_type' */
	end_type,					/* WPX#PAGE, WPX#TABLE, etc. */
	end_contents_type,			/* WPX#NUMBER, WPX#STRING, WPX#MARKER */
	end_value,					/* Value for 'end_contents_type' */
	preserve_whitespace			/* FALSE to clip margins, measure real material */
#endif

#ifndef ELFDEFS
#define WP_SSX_OBJECT			0
#define WP_SSX_RANGE			1
#define WP_SSX_VIEW				2
#else
define WP#SSX#OBJECT			0
define WP#SSX#RANGE				1
define WP#SSX#VIEW				2
#endif


/*** Data structures passed to XX_APPLICATION_DLG@ macros ***/

#ifdef ELFDEFS
format wp_data@
	read_only					/* TRUE: doc to be opened as Read Only */
								/* FALSE: use normal algorithm (Read Only if */
								/*	indicated by file permissions, doc var...) */
format me_data@
	read_only					/* As above */

format html_data@
	read_only					/* As above */
#endif


/*** Linked/opened file history structures ***/

#ifdef ELFDEFS
format wp_link_history_entry@
	filename,					/* Full pathname or URL of document */
	target,						/* Target within document */
	doc_type,					/* AX_DOC_TYPE_ if known */
	read_only					/* TRUE if doc to be opened as read-only */

format wp_link_history@
	index,						/* Current position within 'entries' */
	format arrayof wp_link_history_entry@ entries	/* zero based; docs are */
													/* added to the end (higher  */
													/* #'s) of the array */
#endif


/*** Debugging tools ***/

/* Flags determining what tests are carried out (on a continual basis).
	In C, bit flags. In ELF, array indices. */

#ifndef ELFDEFS
#define WP_DEBUG_CHECK_MEMORY		0x01	/* ThimMemCheck(): corruption? */
#define WP_DEBUG_DOC_VALID			0x02	/* WpCheckDocumentLegality() */
#else
define WP#DEBUG#CHECK#MEMORY		0
define WP#DEBUG#DOC#VALID			1
#endif

/*** WP bead classes ***/

/*
	Document bead types.
	Note that all paired types must have the end after the start and
	have a value >= ED_FIRST_PAIRED.
*/

#ifndef ELFDEFS
#define ED_NO_CLASS				0	/* Illegal */
#define ED_TEXT					1	/* Attributes and text block */
#define ED_PARAGRAPH			2	/* Paragraph marker (terminates para) */
#define ED_STYLE				3	/* A paragraph style template */
#define ED_BITMAP				4	/* picture bead (bitmap) */
#define ED_OBJECT				5	/* Generic inset (could be foreign) */
#define ED_COLUMN_BREAK			6	/* Columnbreak marker (terminates column) */
#define ED_PAGE_BREAK			7	/* Pagebreak marker */
#define ED_MARKER				8	/* Tag bead for Elf users */
#define ED_ERROR				9	/* Error text for macro compilations */
#define ED_CELL_END				10	/* Cell in a row (in a table) */
#define ED_ROW_START			11	/* Row in a table */
#define ED_SECTION				12	/* Section (has column, hdrs/ftrs, etc) */
#define ED_SERIES				13	/* autonumber definition bead */
#define ED_FIELD_SPLIT			14	/* Value part of a field */
#define ED_EQUATION				15	/* Equation */
#define ED_DOCVAR				16  /* document variable, ELF array value */
#define ED_COLOR				17	/* color definition */
#define ED_GRAPHICS				18	/* Native graphics inset */
#define ED_TAG					19	/* named character style bead */
#define ED_PAIRED_STARTS		20
#define ED_FIELD_START			20	/* Field (e.g. autonumber, glossary */
#define ED_FIELD_END			21	/* Field (e.g. autonumber, glossary) */
#define ED_STYLE_START			22	/* Style definition */
#define ED_STYLE_END			23	/* Style definition */
#define ED_GROUP_START			24	/* Planned for equations */
#define ED_GROUP_END			25	/* Planned for equations */
#define ED_FOOTNOTE_START		26	/* Footnote start */
#define ED_FOOTNOTE_END			27	/* Footnote end */
#define ED_HDRFTR_START			28	/* Header/footer definition */
#define ED_HDRFTR_END			29	/* Header/footer definition */
#define ED_GLOSSARY_START		30	/* Glossary definition */
#define ED_GLOSSARY_END			31	/* Glossary definition */
#define ED_FLOW_START			32	/* Document material area */
#define ED_FLOW_END				33	/* Future hook for multiple main flows */
#define ED_DOCVARS_START		34	/* The start of the ED_DOCVAR beads */
#define ED_DOCVARS_END			35	/* The end of the ED_DOCVAR beads */
#define ED_DOCUMENT_START		36	/* The start of the entire document */
#define ED_DOCUMENT_END			37	/* The end of the entire document */
#define ED_MAX_CLASS		ED_DOCUMENT_END	/* Largest legal class value */
#else
define WP_NO_CLASS 						0
define WP_TEXT_CLASS 					1
define WP_PARAGRAPH_CLASS 				2
define WP_STYLE_CLASS 					3
define WP_BITMAP_CLASS 					4
define WP_OBJECT_CLASS 					5
define WP_COLUMN_BREAK_CLASS 			6
define WP_PAGE_BREAK_CLASS 				7
define WP_MARKER_CLASS 					8
define WP_ERROR_CLASS 					9
define WP_CELL_END_CLASS 				10
define WP_ROW_START_CLASS 				11
define WP_SECTION_CLASS 				12
define WP_SERIES_CLASS	 				13
define WP_FIELD_SPLIT_CLASS 			14
define WP_EQUATION_CLASS 				15
define WP_VARIABLE_CLASS				16
define WP_COLOR_CLASS					17
define WP_GRAPHICS_CLASS				18
define WP_TAG_CLASS						19

define WP_FIELD_START_CLASS 			20
define WP_FIELD_END_CLASS 				21
define WP_STYLE_START_CLASS 			22
define WP_STYLE_END_CLASS 				23
define WP_GROUP_START_CLASS 			24
define WP_GROUP_END_CLASS 				25
define WP_FOOTNOTE_START_CLASS 			26
define WP_FOOTNOTE_END_CLASS 			27
define WP_HDRFTR_START_CLASS 			28
define WP_HDRFTR_END_CLASS 				29
define WP_GLOSSARY_START_CLASS 			30
define WP_GLOSSARY_END_CLASS 			31
define WP_FLOW_START_CLASS 				32
define WP_FLOW_END_CLASS 				33
define WP_VARIABLES_START_CLASS			34
define WP_VARIABLES_END_CLASS			35
define WP_DOCUMENT_START_CLASS 			36
define WP_DOCUMENT_END_CLASS 			37
define WP_MAX_CLASS_NUMBER				WP_DOCUMENT_END_CLASS
#endif


/*** Equation Editor ***/

/* Equation editor template classes */

#ifndef ELFDEFS
#else
define	WP#EQN_EMPTY		0	/* empty template  */
define		WP#EQN_EMPTY_DELETABLE		0	/* deletable slot */
define		WP#EQN_EMPTY_NONDELETABLE	1	/* non deletable slot */

define	WP#EQN_SYMBOL		1				/* symbol template */
define		WP#EQN_SYMBOL_CHAR			0	/* simple character from variable font */
define		WP#EQN_SYMBOL_EQUAL			1	/* equals character, = */
define		WP#EQN_SYMBOL_RELATIONAL	2	/* relational operators, >=, <=, ...  */
define		WP#EQN_SYMBOL_EMBELLISH		3	/* embellishments like ',",`, ... */
define		WP#EQN_SYMBOL_SPACE			4	/* space adjustments btw templates */
define		WP#EQN_SYMBOL_OPERATOR		5	/* operators like +,-,*,x,... */
define		WP#EQN_SYMBOL_DIGIT			6	/* char is digit */
define		WP#EQN_SYMBOL_ARROW			7	/* different types of arrows */
define		WP#EQN_SYMBOL_LOGICAL		8	/* logical symbols */
define		WP#EQN_SYMBOL_SET			9	/* set theory symbols */
define		WP#EQN_SYMBOL_LOGREEK		10	/* lower case chars from greek charset */
define		WP#EQN_SYMBOL_UPGREEK		11	/* upper case chars from greek charset */
define		WP#EQN_SYMBOL_MISC			12	/* misc symbols */
define		WP#EQN_SYMBOL_FUNCTION		13	/* function names */
define		WP#EQN_SYMBOL_MAXSUBS		14	/* max sub types for symbol template */
define	WP#EQN_FENCE		2	/* fence template */
define		WP#EQN_FENCE_PAREN			0		/* ( .. ) */
define		WP#EQN_FENCE_PAREN_LEFT		1		/* ( ..  */
define		WP#EQN_FENCE_PAREN_RIGHT	2		/* .. ) */
define		WP#EQN_FENCE_BRACE			3		/* { .. } */
define		WP#EQN_FENCE_BRACE_LEFT		4		/* { ..  */
define		WP#EQN_FENCE_BRACE_RIGHT	5		/*  .. } */
define		WP#EQN_FENCE_BRACKET		6		/* [ .. ] */
define		WP#EQN_FENCE_BRACKET_LEFT	7		/* [ ..  */
define		WP#EQN_FENCE_BRACKET_RIGHT	8		/*  .. ] */
define		WP#EQN_FENCE_VERT			9		/* | .. | */
define		WP#EQN_FENCE_VERT_LEFT		10		/* | ..  */
define		WP#EQN_FENCE_VERT_RIGHT		11		/*  .. | */
define		WP#EQN_FENCE_DVERT			12		/* || .. ||*/ 
define		WP#EQN_FENCE_DVERT_LEFT		13		/* || ..  */
define		WP#EQN_FENCE_DVERT_RIGHT	14		/*  .. || */
define		WP#EQN_FENCE_OVERBAR		15		/* single overbar */
define		WP#EQN_FENCE_DBLOVERBAR		16		/* double overbar */
define		WP#EQN_FENCE_UNDERBAR		17		/* single underline */
define		WP#EQN_FENCE_DBLUNDERBAR	18		/* double underline */
define		WP#EQN_FENCE_FLOOR			19		/* |_ ... _| */
define		WP#EQN_FENCE_FLOOR_LEFT		20		/* |_ ...  */
define		WP#EQN_FENCE_FLOOR_RIGHT	21		/*  ... _| */
define		WP#EQN_FENCE_CEIL			22		/* |~ ... ~| */
define		WP#EQN_FENCE_CEIL_LEFT		23		/* |~ ...  */
define		WP#EQN_FENCE_CEIL_RIGHT		24		/*  ... ~| */
define		WP#EQN_FENCE_BRACKET_2LEFT	25		/*  [...[ */
define		WP#EQN_FENCE_BRACKET_2RIGHT	26		/*  ]...] */
define		WP#EQN_FENCE_BRACKET_OPP	27		/*  ]...[ */
define		WP#EQN_FENCE_PAREN_BRACKET	28		/*  (...] */
define		WP#EQN_FENCE_BRACKET_PAREN	29		/*  [...) */

define	WP#EQN_FRACTION		4	/* fractions or radicals */
define		WP#EQN_FRACTION_OVER		0		/* up OVER down */
define		WP#EQN_FRACTION_DIVIDE		1		/* sub up OVER sub down */
define		WP#EQN_FRACTION_SLASH		2		/* up SLASH down */
define		WP#EQN_FRACTION_BY			3		/* sub up SLASH sub down */
define		WP#EQN_FRACTION_VERTSLASH	4		/* 80 degrees bar up 80SLASH down */

define	WP#EQN_SQRT			5
define		WP#EQN_SQRT_SQRT			0	/* square root of */
define		WP#EQN_SQRT_NROOT			1	/* nth root of */
define		WP#EQN_SQRT_CURVYSQRT		2	/* curvy square root symbol */
define		WP#EQN_SQRT_CURVYNROOT		3	/* curvy nth root */
define		WP#EQN_SQRT_SQRTOVER		4	/* body over sqrt */
define		WP#EQN_SQRT_MAXSUBS			5	/* max sub types for radicals */

define	WP#EQN_SUBSUP		6	/* subscript and superscript template */
define		WP#EQN_SUBSUP_SUB			0	/* subscript only */
define		WP#EQN_SUBSUP_SUP			1	/* superscript only */
define		WP#EQN_SUBSUP_SUBSUP		2	/* superscript ans subscript */
define		WP#EQN_SUBSUP_SUP_LEFT		3	/* superscript on left side */
define		WP#EQN_SUBSUP_SUB_LEFT		4	/* subscript on left side */
define		WP#EQN_SUBSUP_SUBSUP_LEFT	5	/* sub and superscripts on left side */
define		WP#EQN_SUBSUP_SUP_OVER		6	/* superscript on top */
define		WP#EQN_SUBSUP_SUB_OVER		7	/* superscript on top */
define		WP#EQN_SUBSUP_SUBSUP_OVER	8	/* superscript on top */
define		WP#EQN_SUBSUP_MAXSUBS		5	/* max sub types for subsup */

define	WP#EQN_SUM			7	/* summation template */
define		WP#EQN_SUM_NONE				0	/* summation with no limits */
define		WP#EQN_SUM_UP				1	/* up limit */
define		WP#EQN_SUM_DOWN				2	/* down limit */
define		WP#EQN_SUM_UPDOWN			3	/* up and down limits */
define		WP#EQN_SUM_SUP				4	/* down limit as sub */
define		WP#EQN_SUM_SUB				5	/* up limit as sup */
define		WP#EQN_SUM_SUBSUP			6	/* up and down limits as sup and sub */
define		WP#EQN_INTEGRAL_NONE		7	/* no limits */
define		WP#EQN_INTEGRAL_UP			8	/* up limit */
define		WP#EQN_INTEGRAL_DOWN		9	/* down limit */
define		WP#EQN_INTEGRAL_UPDOWN		10	/* up and down limits */
define		WP#EQN_INTEGRAL_SUP			11	/* up limit as sup*/
define		WP#EQN_INTEGRAL_SUB			12	/* down limit as sub*/ 
define		WP#EQN_INTEGRAL_SUBSUP		13	/* up and down limits as sup and sub */
define		WP#EQN_2INTEGRAL_NONE		14	/* no limits */
define		WP#EQN_2INTEGRAL_UP			15	/* up limit */
define		WP#EQN_2INTEGRAL_DOWN		16	/* down limit */
define		WP#EQN_2INTEGRAL_UPDOWN		17	/* up and down limits */
define		WP#EQN_2INTEGRAL_SUP		18	/* up limit as sup*/
define		WP#EQN_2INTEGRAL_SUB		19	/* down limit as sub */
define		WP#EQN_2INTEGRAL_SUBSUP		20	/* up and down limits as sup and sub */
define		WP#EQN_3INTEGRAL_NONE		21	/* no limits */
define		WP#EQN_3INTEGRAL_UP			22	/* up limit */
define		WP#EQN_3INTEGRAL_DOWN		23	/* down limit */
define		WP#EQN_3INTEGRAL_UPDOWN		24	/* up and down limits */
define		WP#EQN_3INTEGRAL_SUP		25	/* up limit as sup*/
define		WP#EQN_3INTEGRAL_SUB		26	/* down limit as sub*/ 
define		WP#EQN_3INTEGRAL_SUBSUP		27	/* up and down limits as sup and sub */
define		WP#EQN_OINTEGRAL_NONE		28	/* no limits */
define		WP#EQN_OINTEGRAL_UP			29	/* up limit */
define		WP#EQN_OINTEGRAL_DOWN		30	/* down limit */
define		WP#EQN_OINTEGRAL_UPDOWN		31	/* up and down limits */
define		WP#EQN_OINTEGRAL_SUP		32	/* up limit as sup */
define		WP#EQN_OINTEGRAL_SUB		33	/* down limit as sub  */
define		WP#EQN_OINTEGRAL_SUBSUP		34	/* up and down limits as sup and sub  */
define		WP#EQN_PRODUCT_NONE			35	/* no limits  */
define		WP#EQN_PRODUCT_UP			36	/* up limit  */
define		WP#EQN_PRODUCT_DOWN			37	/* down limit  */
define		WP#EQN_PRODUCT_UPDOWN		38	/* up and down limits  */
define		WP#EQN_PRODUCT_SUP			39	/* up limit as sup  */
define		WP#EQN_PRODUCT_SUB			40	/* down limit as sub  */
define		WP#EQN_PRODUCT_SUBSUP		41	/* up and down limits as sup and sub  */
define		WP#EQN_UNION_NONE			42	/* union no limits  */
define		WP#EQN_UNION_UP				43	/* up limit  */
define		WP#EQN_UNION_DOWN			44	/* down limit  */
define		WP#EQN_UNION_UPDOWN			45	/* up and down limits  */
define		WP#EQN_UNION_SUP			46	/* up limit as sup */
define		WP#EQN_UNION_SUB			47	/* down limit as sub */
define		WP#EQN_UNION_SUBSUP			48	/* up and down limits as sup and sub */
define		WP#EQN_INTERS_NONE			49	/* intersection with no limits */
define		WP#EQN_INTERS_UP			50	/* up limit */
define		WP#EQN_INTERS_DOWN			51	/* down limit */
define		WP#EQN_INTERS_UPDOWN		52	/* up and down limits */
define		WP#EQN_INTERS_SUP			53	/* up limit as sup */
define		WP#EQN_INTERS_SUB			54	/* down limit as sub */
define		WP#EQN_INTERS_SUBSUP		55	/* down limit as sub */

define		WP#EQN_SCRIPT_NONE			56	/* General function with no limits*/
define		WP#EQN_SCRIPT_UP			57	/* up limit*/
define		WP#EQN_SCRIPT_DOWN			58	/* down limit*/
define		WP#EQN_SCRIPT_UPDOWN		59	/* up and down limits*/
define		WP#EQN_SCRIPT_SUP			60	/* up limit as sup*/
define		WP#EQN_SCRIPT_SUB			61	/* down limit as sub*/
define		WP#EQN_SCRIPT_SUBSUP		62	/* down limit as sub*/

define	WP#EQN_ARROW		8	/* labeled arrow template 
define		WP#EQN_ARROW_LEFT_NONE		0	/* left arrow with no limits */
define		WP#EQN_ARROW_LEFT_UP		1	/* left arrow with up limit */
define		WP#EQN_ARROW_LEFT_DOWN		2	/* left arrow with down limit */
define		WP#EQN_ARROW_RIGHT_NONE		3	/* right arrow with no limits */
define		WP#EQN_ARROW_RIGHT_UP		4	/* right arrow with up limit */
define		WP#EQN_ARROW_RIGHT_DOWN		5	/* right arrow with down limit */
define		WP#EQN_ARROW_LTRT_NONE		6	/* left right arrow with no limits*/
define		WP#EQN_ARROW_LTRT_UP		7	/* left right arrow with up limit */
define		WP#EQN_ARROW_LTRT_DOWN		8	/* left right arrow with down limit */

define	WP#EQN_MATRIX		9				/* matrix template */
define		WP#EQN_MATRIX_1ROW_2COL		0	/* matrix of size 1 row 2 cols */
define		WP#EQN_MATRIX_2ROW_1COL		1	/* matrix of size 2 rows 1 col */
define		WP#EQN_MATRIX_2ROW_2COL		2	/* matrix of size 2 rows 2 cols */
define		WP#EQN_MATRIX_1ROW_3COL		3	/* matrix of size 1 row 3 cols */
define		WP#EQN_MATRIX_3ROW_1COL		4	/* matrix of size 3 rows 1 col */
define		WP#EQN_MATRIX_3ROW_3COL		5	/* matrix of size 3 rows 3 cols */
define		WP#EQN_MATRIX_1ROW_NCOL		6	/* matrix of size 1 row n cols */
define		WP#EQN_MATRIX_MROW_1COL		7	/* matrix of size m rows 1 col */
define		WP#EQN_MATRIX_MROW_NCOL		8	/* matrix of size m rows n cols */

define	WP#EQN_ATTR		10	/* template attribute */
define		WP#EQN_ATTR_XNUDGE			0
define		WP#EQN_ATTR_YNUDGE			1

define	WP#EQN_NEXT		11	/* next equation in pile*/ 
#endif

