/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: atext.c
   Applix ASC version: 51
   Date: Thu Feb 11 21:11:27 1999
*/
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <aos.h>
#include <getstr5.h>
#include <atm.h>
#include <atmwin.h>
#include <aspeller.h>
#include <axtext.h>
#include <axhtab.h>
#include <axgfs.h>
#include <wchars.h>
#include <xim.h>
#include <axtxint.h>
#include <atxint.h>
#include <ge.h>

#if !SCOUNIX
/* workaround for sco prototyper problem with stat, lstat, statlstat */
/* this needs to be fixed for real.   markl 3/19/97                  */
#include <atext.p>
#endif

#if AXMS
#ifndef M_PI
#define  M_PI            3.14159265358979323846
#endif
#define hypot _hypot
extern Window RootWin;    /* for DefaultVisual macro on NT */
#endif

#define BYTE_WIDTH(w)       ((((w) + 15) >> 3) & ~1)

#define WHITE 0
#define BLACK 1

/* from atmattr.h */
#define TMS       3
#define TMS_O_D   7
#define TMIS_O_D 13

#define SPACECHAR (' ') /* %%%%%%% should really use txAttrI->spaceChar */
#define WHITESPACE(x) (x == SPACECHAR)
#define HYPHEN ('-')
#define TABCHAR ('\t')
#define NEWLINE ('\n')
#define CR (0x000D)
#define NEWCHAR(c) ((c) == NEWLINE || (c) == CR)
#define WHITECHAR(c) ((c) == SPACECHAR || \
                      (c) == TABCHAR   || \
                      (c) == NEWLINE   || \
                      (c) == CR)
#define BLACKCHAR(c) (!(WHITECHAR(c)))
#define NONBREAKSPACE   (SPACECHAR + 0x80)  /* font convention */   
#define WORDBREAK(c) ((c < 0x30 && c != 0x2d ) || \
                      (c > 0x7b && c < 0x80)   || \
                      (c > 0x39 && c < 0x41)   || \
                      (c > 0x5a && c < 0x61 && c != 0x5f))

#define CHAR_IS_TABCHAR(cc) ( cc == TABCHAR )
#define CHAR_IS_NEWLINE(cc) ( cc == NEWLINE )
#define CHAR_IS_CR(cc) ( cc == CR )

#define NEWPARA(pc, ix) ((ix == 0) || CHAR_IS_NEWLINE((int) pc[ix]->charcode))

#define CHAR_IS_DIMENSIONLESS(cc) (CHAR_IS_NEWLINE(cc) || \
                                   CHAR_IS_TABCHAR(cc) || \
                                   CHAR_IS_CR(cc))

/* BIG_MILS specifies a number considered too big for some formatting calcs.
 * any real text objects exceeding this size will probably cause trouble.
 */
#define BIG_MILS 1020000     /* 85 feet, in mils */

#define CHARS_PER_LINE_GUESS    20  /* reFitI uses this to alloc line table */
#define LINE_TABLE_INC          20  /* reFitI uses this to extend line tab */


#define IS_SOLID_FILL(gcontext, fill) ( !fill || easy_text_fill(gcontext, (attr_type *)fill) )

#define TXtransformAtts (TXxscale | TXyscale |\
                         TXxshear | TXangle)

extern Display *Dpy;
extern unsigned long AlisPixels[];
extern int ScreenRes;

GC axTextGC, axTextStencilGC, axLiftGC;
GC PixClearGC, PixGC, axTextCursorGC, axInactiveTextCursorGC;

extern int qRound(), mToPix();
extern int milsToPix(), axtPixToMils();
extern int axCyanComponent(), axMagentaComponent();
extern int axYellowComponent(), axBlackComponent();
extern int affectsLetterforms();
extern int differingStrings(), differingBullets(), differingIndents();
extern int affectsFontName();
extern int useForegroundColorForBlack();
extern void freeErrString();
extern void unionRectangle();
extern void convPixToMils();
extern void axtFormScalableName();
extern void axtFreeFillPattern();
extern void getTriPoints(), getDiamondPoints();
extern void axtSetClip(), axUnSetClip();
extern void axtCopyFillPattern();
extern void axtDrawText();
extern void axtFreeIndent(), axtCopyIndent();
extern void axtFreeBullet(), axtCopyBullet();
extern void axtFreeDropShadow(), axtCopyDropShadow();
extern char *getErrString();
extern char *axGetFontRecord(), *axGetFontFamily();
extern char *axGetFontRecordForScreen();
extern char *axGetScreenMetrics();
extern char *axGetTargetMetrics();
extern char *axGetFontRecordName();
extern char *axMakeCompoundWinName();
extern char *XLT();
#if AX_X11
extern char *axtGetClosestRasterName();
#endif
extern axtIndent *axtNewDefaultIndent();
extern axtBullet *axtNewDefaultBullet();
extern attr_type *axtNewFillPattern();


#if BUILD_ORIENT
mbchar *sansserif_orient_face();
mbchar *serif_orient_face();
mbchar *serif_narrow_kana_face();
mbchar *sansserif_narrow_kana_face();
#endif

void daxtextI();
void liftCursorI();
void axtSetAlignmentI();
void axtHiliteTextI();
void axtLiftTextCursorI();
void axtSetZoomI();
void axtDefaultTextI();
void axtAdjustRulingEndpointsI();
void axtSetFieldWidthI();
void axtBulletRectI();
void axtToggleForegroundColorI();

int setDefaultTextAttrsI();
int insCharsI(), axtGetAlignmentI();
int axtHasBulletI(), axtHasOffsetI();

char *getOverallBounderI();
char *constructForPrintI();

atext *axtCopyI();

#if BUILD_ORIENT && !FOR_FILTER
extern mbchar *OrientFace[];
XFontStruct *VerifyFont();
#endif

static void foldDefaultsI();
static void txAttDefaultsI();
static void updateTargetCharI(), fieldDefaultsI();
static void updateScreenCharsI();
static void justifyLineI(), doAlignmentI();
static void liftOldI();
static void axtGetPosOffsetI();
static void copyAxtextI();
static void copyInTextAttrI(), copyOutTextAttrI();
static void copyTxAttrI();
static void liftTextI(), setLiftColorI();
static void axtSetFgBgI();
static void resetPerCharsI();
static void getBarPointsI();
static void liftBulletI();
static void axtSnapshotTextI(), extendFieldBounderI();
static void axtSnapshotFieldBounderI();
static void axtGetIndentLineValsI();
static void axtTrimTextI();
static void axtSetFixedPosI();
static void tossTxAttrI();

static int axtEditPosI();
static int getCursorPointsI();
static int qDrawTextI();
static int getOldIndexI();
static int attrChangeI(), needSplitI(), checkJoinI();
static int doSplitI();
static int axtLineFormatterI();
static int needLiftI();
static int axtDefaultPointsizeI();
static int segCountI();

static int firstLeftOffsetI();
static int axtNRindexAtPointI();
static int axtLineIndexFromCharIndexI();
static int axtGetMaxWidthI(), axtLinelenI();

static txAttrI *attrSegAtPosI(), *inheritedAttrI();
static txAttrI *insCharsIntI(), *delCharsIntI();

static char *reFitI();
static char *axtSubDispTxI();
#if AX_X11
static char *getClosestRasterNameI();
#endif
static char *axtMeasuredTextI();
static char *axtDisplayableTextI();
extern Drawable AxGetDrawableFromWidget();
extern char *txloc();
extern char *retxloc();

/*
 * Contsruction / destruction routines
 */

/* : axtDefaultTextI - write hardcoded default attributes onto *tx
 */
static void
axtDefaultTextI(tx)
atext *tx; /* out: fill this in upto 'axtDefaultText' level */
{
	int ix, charcount;
	txAttrI *tDefault, tmpAttr;
	unsigned int jnk;

	if (!tx)
		return;

	txAttDefaultsI(&tmpAttr, &jnk, tx->pid); /* hardcoded defaults */
	if (tx->userDefaults) {
		tDefault = tx->userDefaults; /* use existing user default */
	}
	else {
		tDefault = &tmpAttr;	/* use hardcoded */
	}
	if (tx->atts) {
		charcount = tx->whole.nChars;
		ix = 0;
		while (charcount) {
			charcount -= tx->atts[ix]->nChars;
			tossTxAttrI(tx->atts[ix]);
			txfree(tx->atts[ix]);
			ix++;
		}
		txfree(tx->atts);
	}

	tx->atts = (txAttrI **) txloc(tx->pid, sizeof(txAttrI *));
	tx->atts[0] = (txAttrI *) txloc(tx->pid, sizeof(txAttrI));
	memset((void *)tx->atts[0], 0, sizeof(txAttrI));
	copyTxAttrI(tx->atts[0], tDefault, tx->pid);/* initial matches default */

	tx->atts[0]->nChars = 0;
	fieldDefaultsI(tx);
	tossTxAttrI((char *) &tmpAttr);
	tx->whole.nChars = 0;
	tx->constructed = TRUE;
}

/* deallocate that constructed during axtDefaultText
 */
static void
dtext1I(tx)
atext *tx;
{
	int charcount;
	txAttrI *txAp;
    
	if(tx) {
		if (tx->atts) {
			charcount = tx->whole.nChars;
			if (charcount) {
				int segix = 0;
				while(charcount > 0) {
					charcount -= tx->atts[segix]->nChars;
					tossTxAttrI(tx->atts[segix]);
					txfree(tx->atts[segix]);
					segix++;
				}
			}
			else {
				tossTxAttrI(tx->atts[0]);
				txfree(tx->atts[0]);
			}
			txfree(tx->atts);
		}
		if (tx->userDefaults) {
			tossTxAttrI(tx->userDefaults);
			txfree(tx->userDefaults);
		}
		if (tx->whole.linetab) {
			txfree(tx->whole.linetab);
		}
		memset((void *)tx, 0, sizeof(atext));
	}
}

/* : axtMeasuredTextI - put target measurements onto *tx
 */
static char *         /* NULL if ok */
axtMeasuredTextI(tx)
atext *tx;            /* out: fill this in upto 'tx->measured' level */
{
	int charcount, ix;
	int segix, charix, lastix, lpos, charsInSeg;
	txAttrI *txAp;
	perCharI *pc;
	char *errString;
	int lastfit;

	if (!tx->constructed) {
		axtDefaultTextI(tx);
	}

	if (!tx->items && tx->whole.nChars > 0) {
		/* get mem for per-char data 
		 */
		tx->items = (perCharI **)
			txloc(tx->pid, tx->whole.nChars * sizeof(perCharI *));
		for (ix = 0; ix < tx->whole.nChars; ix++) {
			tx->items[ix] = (perCharI *) txloc(tx->pid, sizeof(perCharI));
			memset((void *) tx->items[ix], 0, sizeof(perCharI));
		}
	}

	/* now go thru the attr seg structs 
	 */
	charcount = tx->whole.nChars - tx->editState.editPos;

#if BUILD_ORIENT && !FOR_FILTER
	CheckCharsAgainstAttrsI( tx );
#endif

	txAp = attrSegAtPosI(tx, tx->editState.editPos, &lpos, &segix);
	charix = tx->editState.editPos;
    
	while(charcount > 0) {
        
		txAp = tx->atts[segix++];
		charsInSeg = txAp->nChars - lpos;
		lpos = 0;
        
		if (!txAp->fontAttr.fontName) {
			if (errString = axGetFontRecordName(txAp->fontAttr.familyName,
												txAp->fontAttr.weight,
												txAp->fontAttr.slant,
												&txAp->fontAttr.fontName)) {
				return(errString);
			}
		}

		/* Ensure  uptodate refs to font table entry, target metrics
		 */
		if (errString = axGetFontRecord(txAp->fontAttr.fontName,
										&txAp->fconx.font)) {
			return errString;
		}
		if (errString =
			axGetTargetMetrics(txAp->fconx.font->targetMetricsNames[0],
							   txAp->fconx.font,
							   &txAp->fconx.target)) {
			return errString;
		}

		txAp->fontAttr.underlinePosition =
			-txAp->fconx.target->underlinePosition;
		txAp->fontAttr.underlineThickness =
			txAp->fconx.target->underlineThickness;
		
		/* jot targ metrics for the particular chars in this seg
		 */
		for(lastix = charsInSeg + charix ; charix < lastix; charix++) {
			pc = tx->items[charix];
			if(!pc->targetMetrics) {
				updateTargetCharI(tx, txAp, pc); /* get the target metrics */
				pc->targetMetrics = TRUE;
			}
		}
		charcount -= charsInSeg;
	}
	tx->measured = TRUE;
	return( reFitI(tx) );
}

/* deallocate that constructed during axtMeasuredTextI
 */
static void
dtext2I(tx)
atext *tx;
{
	int ix;
	
	if (!tx)
		return;
	
	if(tx->items) {
		for (ix = 0; ix < tx->whole.nChars; ix++) {
			txfree(tx->items[ix]);
		}
		txfree(tx->items);
		tx->items = (perCharI **) NULL;
	}
	tx->measured = FALSE;
}

static void
axtMoveItemsI(tx)
atext *tx;
{
	int ix;
	
	if (tx->editState.disp && tx->items) {
		ix = tx->whole.nChars - 1;
		while(ix >= 0) {
			tx->items[ix]->moved = TRUE;
			ix--;
		}
	}
}

/* : axtDisplayableTextI - axtMeasuredTextI plus screenfont info
 */
static char *  /* NULL means ok */
axtDisplayableTextI(tx)
atext *tx;      /* out: fill this in upto displayable state */
{
	int charcount, segix, charix, itemsize, charsInSeg, lpos;
	int rasterError=0;
	char *errString;
	txAttrI *txAp;
	fontTabEnt *ftab;

	if (!tx->measured) {
		if (errString = axtMeasuredTextI(tx)) {
			return errString;
		}
	}
    
	charcount = tx->whole.nChars - tx->editState.editPos;
	txAp = attrSegAtPosI(tx, tx->editState.editPos, &lpos, &segix);
	charix = tx->editState.editPos;
    
	while(charcount > 0) {

		txAp = tx->atts[segix++];
		charsInSeg = txAp->nChars - lpos;
		lpos = 0;
        
		if (errString = axGetFontRecord(txAp->fontAttr.fontName,
										&txAp->fconx.font)) {
			return errString;
		}
		ftab = txAp->fconx.font;
		/* ensure uptodate fconx.target reference
		 */
		if (errString =
			axGetTargetMetrics(txAp->fconx.font->targetMetricsNames[0],
							   txAp->fconx.font,
							   &txAp->fconx.target)) {
			return errString;
		}
		if (!txAp->screenFontName) {
			char *txName;
			char *lsName = (char *) NULL;
			fontTabEnt *screenRecord, *notUsed;

			if (ftab->XAlternate || ftab->largeXAlternate ||
				ftab->WindowsAlternate) {
                
				/* use the alternate record's screenfont info
				 */
				if (errString =
					axGetFontRecordForScreen(ftab->familyName,
											 ftab->weight,
											 ftab->slant,
											 (int) txAp->fontAttr.ptsize,
											 &notUsed,
											 &screenRecord)) {
					return errString;
				}
			}
			else {
				screenRecord = ftab;
			}
            
#if AX_X11						/*  {  */
            
			/* on X, find or form the name of the best xlfd to use
			 */
			if (screenRecord->scalable) {
                
				lsName = (char *) txloc(tx->pid, MAXLFD);
				axtFormScalableName(screenRecord->scalableName,
									(int) txAp->fontAttr.ptsize,
									ScreenRes, (axctm *) 0,
									lsName);
				txName = lsName;
			}
			else {
				txName = getClosestRasterNameI(screenRecord, txAp,
											   &rasterError);
			}
            
#else

			/* on Win32, form "xlfd" as <ptsize>,<wt>,<slant>,<family>
			 */
			lsName = axMakeCompoundWinName(screenRecord->familyName, 
										   (int) txAp->fontAttr.ptsize,
										   txAp->fontAttr.weight,
										   txAp->fontAttr.slant);
			txName = lsName;
            
#endif /*  }  AX_X11 */
			
			itemsize = strlen(txName) + 1;
			txAp->screenFontName = (char *)txloc(tx->pid, itemsize);
			strcpy(txAp->screenFontName, txName);
			if (lsName) {
				txfree(lsName);
			}
		}
		
		/* load the metrics for the screenfont
		 */
		if (errString = axGetScreenMetrics(txAp->screenFontName,
										   txAp->fconx.font,
										   &txAp->fconx.screen)) {
			return errString;
		}
		
		/* write per-char screen metrics
		 */
		updateScreenCharsI(txAp, tx->items, charix, charix + charsInSeg - 1);

		charcount -= charsInSeg;
		charix += charsInSeg;
	}
	tx->displayable = TRUE;
	return ((char *)NULL);
}

/* deallocate that constructed during axtDisplayableTextI
 */
static void
dtext3I(tx)
atext *tx;
{
	int charcount;
	txAttrI *txAp;
	perCharI *pc;

	if (!tx)
		return;

	if (tx->atts) {
		charcount = tx->whole.nChars;
		if (charcount) {
			int segix = 0;
			while(charcount > 0) {
				txAp = tx->atts[segix++];
				if (txAp->screenFontName) {
					txfree((char *)txAp->screenFontName);
					txAp->screenFontName = (char *)NULL;
				}
				charcount -= txAp->nChars;
			}
		}
		else {
			txAp = tx->atts[0];
			if (txAp->screenFontName) {
				txfree((char *)txAp->screenFontName);
				txAp->screenFontName = (char *)NULL;
			}
		}
	}
	if (tx->old) {
		daxtextI(tx->old);
		txfree((char *) tx->old);
		tx->old = (atext *)NULL;
	}
	tx->displayable = FALSE;

}

/* : constructForPrintI - wrapper for axtMeasuredTextI
 *   portion of construction
 */
char *  /* if null, OK; if not, caller must free error string */
constructForPrintI(txt)
atext *txt;
{
	if (txt->measured)
		return ((char *) NULL);
	else
		return (axtMeasuredTextI(txt));
}

/* : daxtextI - deconstruct an axtext instance
 */
void
daxtextI(tx)
atext *tx;
{
	if (tx) {
		dtext3I(tx);
		dtext2I(tx);
		dtext1I(tx);
	}
}

static void
axtSetFixedPosI(txt)
atext *txt;
{
	/* set fixedPos based on formattedWidth, current pos, field alignment
	 */
	txt->whole.fixedPos = txt->whole.pos;
	switch (txt->whole.alignment) {
		
	case RIGHT_ALIGN:
		txt->whole.fixedPos.x += txt->whole.formattedWidth;
		break;
		
	case CENTER_ALIGN:
		txt->whole.fixedPos.x += (txt->whole.formattedWidth / 2);
		break;
	}
	return;
}

/* : setPos - set the window-relative position of *txt
 */
void
setPosI(txt, pos)
atext *txt;
p32 *pos;          /* in: drawable-relative mil coords */
{
	if (txt->editState.disp) {
		if(!txt->old) {
			/* first edit since last display -- save state.
			 * setPos is effectively an edit at pos 0
			 */
			axtSnapshotTextI(txt, 0);
		}
		axtMoveItemsI(txt);		/* mark all chars as moved */
		txt->editState.fieldBounder.width = 0; /* turn off clear rect */
	}
	
	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
			return;
		}
	}
	
	txt->whole.pos = *pos;
	
	axtSetFixedPosI(txt);
		
	txt->measured = txt->displayable = FALSE;
}

/* : axtGetPosI - return the window-relative position of *txt
 */
void
axtGetPosI(txt, pos)
atext *txt;
p32 *pos;            /* out: drawable-relative mil coords */
{
	*pos = txt->whole.pos;
}

static void
intersectRects(r1, r2, out)
r32 *r1, *r2;
r32 *out;      /* out: init this */
{
    int tmp1, tmp2;
    int maxOx, minCx; /* limits in x direction; max origin, min corner */
    int maxOy, minCy; /* limits in y direction */

    if (r1->origin.x > r2->origin.x) {
        maxOx = r1->origin.x;
    }
    else {
        maxOx = r2->origin.x;
    }
    if ((tmp1 = r1->origin.x + r1->width - 1) <
        (tmp2 = r2->origin.x + r2->width - 1)) {
        minCx = tmp1;
    }
    else {
        minCx = tmp2;
    }
    if (r1->origin.y > r2->origin.y) {
        maxOy = r1->origin.y;
    }
    else {
        maxOy = r2->origin.y;
    }
    if ((tmp1 = r1->origin.y + r1->height - 1) <
        (tmp2 = r2->origin.y + r2->height - 1)) {
        minCy = tmp1;
    }
    else {
        minCy = tmp2;
    }
    if (maxOx < minCx && maxOy < minCy) {
        out->origin.x = maxOx;
        out->origin.y = maxOy;
        out->width = minCx - maxOx + 1;
        out->height = minCy - maxOy + 1;
    }
    else {
        out->origin.x = out->origin.y = 0;
        out->width = out->height = 0;
    }
}

void
axtSetClip(gc, clip, clip2)
GC gc;
r32 *clip;
r32 *clip2;  /* intersect this if present */
{
    XRectangle clipRect;
    r32 lclip;
    int tx, ty;

    if (!clip && !clip2)
        return;

    if (clip && clip2) {
        intersectRects(clip, clip2, &lclip);
    }
    else if (clip) {
        lclip = *clip;
    }
    else {
        lclip = *clip2;
    }

    convMilsToPix(lclip.origin.x, lclip.origin.y, &tx, &ty);
    clipRect.x = (short) tx - 1;  /* blatant fudge */
    clipRect.y = (short) ty - 1;
    convMilsToPix(lclip.width, lclip.height, &tx, &ty);
    clipRect.width = (short) tx + 2;    /* blatant fudge */
    clipRect.height = (short) ty + 2;
 
    XSetClipRectangles(Dpy, gc, 0, 0, &clipRect, 1, Unsorted);
}

void
axtSetAlignmentI(tx, align)
atext *tx;
int align;  /* left, center, right.. */
{

	if (!tx)
		return;
	
	if (align != tx->whole.alignment) {
		if (tx->editState.disp) { 
			if (!tx->old) {
				/* first edit since last display -- save state.
				 * setAlignment is effectively an edit at pos 0.
				 */
				axtSnapshotTextI(tx, 0);
			}
			axtMoveItemsI(tx);	/* alignment change affects all chars */
		}
		
		if (!tx->measured) {
			char *err;
			if (err = axtMeasuredTextI(tx)) {
				freeErrString(err);
				return;
			}
		}
		tx->whole.alignment = align;
		axtSetFixedPosI(tx);
		tx->measured = tx->displayable = FALSE;
	}
	return;
}

int   /* return alignment value */
axtGetAlignmentI(tx)
atext *tx;
{
	if (tx) {
		return(tx->whole.alignment);
	}
	else {
		return(LEFT_ALIGN);
	}
}

void
axtDrawTextCursorI(w, txt, clip, pos, type, active)
long w;
atext *txt;
r32 *clip;
int pos; /* pos 0 puts cursor just before 1st char */
int type; /* i-bar or ol triangle */
int active;
{
	int i, lpos, pointcount, segix;
	int x_off, y_off, free_bounder;
	char *errString;
	r32 cursorClip;
	r32 bounderRect;
	p32 base_pt;
	txAttrI *txAp;
	GC gc;
	XPoint pts[4];
	Drawable drw;

	if (!txt)
		return;
	
	if (pos < 0 || pos > txt->whole.nChars)
		return;
	
	if (!txt->displayable) {
		if(errString = axtDisplayableTextI(txt)) {
			freeErrString(errString);
			txt->editState.cursorPos = pos;
			return;
		}
	}
    
	base_pt = txt->whole.pos;
	if (!txt->whole.nChars) {
		base_pt = txt->whole.fixedPos;
	}

	if (txt->editState.cursorOn) {
		axtLiftTextCursorI(w, txt);
	}
	
	/* don't draw if adjacent to hidden char
	 */
	if (txt->items &&
		((pos < txt->whole.nChars && txt->items[pos]->hidden) ||
		 (pos > 0 && txt->items[pos - 1]->hidden))) {
		
		/* don't draw if adjacent to hidden char
		 */
		txt->editState.cursorOn = FALSE;
	}
	else {
		/* get cursor size based on text size
		 */
		if (pos > 0) {
			txAp = attrSegAtPosI(txt, pos - 1, &lpos, &segix);
		}
		else {
			txAp = txt->atts[0];
		}
		pointcount = txt->editState.lastCursorPointcount =
			getCursorPointsI(txt, type, active, txAp, pts, &cursorClip);

		/* add in whole-pos-relative offset
		 */
		if (txt->items) {
			if (pos > 0) {
				p32 relpt;
				axtGetPosOffsetI(txt, pos - 1, &relpt);
				relpt.x += txt->items[pos - 1]->tadvance;
				base_pt.x += relpt.x;
				base_pt.y += relpt.y;
			}
			else {
				base_pt.x += txt->items[0]->offset.x;
				base_pt.y += txt->items[0]->offset.y;
			}
		}
		else if (txt->whole.nChars == 0 && txAp->indent) {
			/* indented, but with no text; offset the cursor position
			 * by the indent distance
			 */
			int itmp;
			itmp = firstLeftOffsetI(txt, txAp);
			base_pt.x += itmp;
		}
		for (i=0; i<4; i++) {
			pts[i].x += (short)(milsToPix(base_pt.x, ScreenRes));
			pts[i].y += (short)(milsToPix(base_pt.y, ScreenRes));
			txt->editState.lastCursorPoints[i].x = pts[i].x;
			txt->editState.lastCursorPoints[i].y = pts[i].y;
		}
		
		/* draw the new cursor
		 */
		if (active)
			gc = axTextCursorGC;
		else
			gc = axInactiveTextCursorGC;

		if (cursorClip.height) {
			/* if there's a real clip provided by getCursorPts,
			 * then add in whole-pos-relative offset
			 */
			cursorClip.origin.x += txt->whole.pos.x;
			cursorClip.origin.y += txt->whole.pos.y;
			axtSetClip(gc, clip, &cursorClip);
		}
		else {
			axtSetClip(gc, clip, (r32 *) NULL);
		}

		/* get the drawable
		 */
		drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

		if ( drw ) {
			if (pointcount == 2) {
				XDrawLine(Dpy, drw, gc,
						  pts[0].x, pts[0].y, pts[1].x, pts[1].y);
			}
			else {
				XFillPolygon(Dpy, drw, gc, pts, pointcount,
							 Convex, CoordModeOrigin);
			}
		}
		axUnSetClip(gc, clip);
		txt->editState.cursorPos = pos;
		txt->editState.cursorType = type;
		txt->editState.cursorActive = 
			txt->editState.lastCursorActive = active;
		txt->editState.cursorOn = TRUE;
		
		/* remember the protection clip
		 */
		txt->editState.lastCursorClip = cursorClip;
	}
}

void
liftCursorI(w, txt, clip)
long w;
atext *txt;
r32 *clip;
{
	XPoint *tpts;
	Drawable drw;
	GC gc;
	int x_off, y_off;

	if (!txt)
		return;
	
	drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

	if (txt->editState.cursorOn) {
		/* assume xor-transfers, lift by drawing
		 */
		tpts = txt->editState.lastCursorPoints;

		if (txt->editState.lastCursorActive)
			gc = axTextCursorGC;
		else
			gc = axInactiveTextCursorGC;

		if (txt->editState.lastCursorClip.height) {
			axtSetClip(gc, clip,
					   &txt->editState.lastCursorClip);
		}
		else {
			axtSetClip(gc, clip, (r32 *) NULL);
		}

		if (txt->editState.lastCursorPointcount == 2) {
			XDrawLine(Dpy, drw, gc, tpts[0].x, tpts[0].y,
					  tpts[1].x, tpts[1].y);
		}
		else {
			XFillPolygon(Dpy, drw, gc, tpts,
						 txt->editState.lastCursorPointcount,
						 Convex, CoordModeOrigin);
		}
		axUnSetClip(gc, clip);
	}
	txt->editState.cursorOn = FALSE;
}

void
deactivateCursorI(txt) /* typically because we lost kb focus */
atext *txt;
{
	if (!txt)
		return;
	txt->editState.cursorActive = FALSE;
}

void
activateCursorI(txt) /* typically because we got kb focus */
atext *txt;
{
	if (!txt)
		return;
	txt->editState.cursorActive = TRUE;
}

/* : pointAtIndexI - given textchar index, return window-
 * relative location of the 'set position' of that character.
 */
void
pointAtIndexI(txt, index, pos)
atext *txt;
int index;
p32 *pos; /* return this; position of index, window-relative */
{
	char *err;

	if (!txt || !pos)
		return;

	if ( !txt->measured ) {
		if( err = axtMeasuredTextI(txt)) {
			freeErrString(err);
			txt->measured = txt->displayable = FALSE;
			pos->x = pos->y = 0;
			return;
		}
	}
	if (txt->whole.nChars) {
		axtGetPosOffsetI(txt, index, pos);
		pos->x += txt->whole.pos.x;
		pos->y += txt->whole.pos.y;
	}
	else {
		axtGetPosI(txt, pos);
	}
}

/* : indexAtPointI - returns index of 1st textchar found whose
 * bounder contains pos
 */
int
indexAtPointI(txt, pos)
atext *txt;
p32 *pos;
{
	int i;
	p32 currentpoint, cen, tmp, leastVec;
	int leastDistance, tdistance, leastIx;
	perCharI *pc = NULL;
	char *err;

	if ( !txt )
		return 0;

	if ( !txt->measured ) {
		if( err = axtMeasuredTextI(txt)) {
			freeErrString(err);
			txt->measured = txt->displayable = FALSE;
			return 0;
		}
	}
	return (axtNRindexAtPointI(txt, pos));
}

/* : axtNRindexAtPointI - variant of indexAtPoint for the simpler
 * case in which no rotation or xshear occurs anywhere in the text.
 */
static int
axtNRindexAtPointI(txt, pos)
atext *txt;
p32 *pos;
{
	int stripbot;	  /* at line end, lowest character ink ycoord seen */
	int leftix;		  /* at line end, greatest char index left of pos */
	int basey;					/* baseline ypos this line */
	int setx;					/* setpoint xpos */
	int lsetx;					/* setx of char at leftx */
	int ledgex;					/* setx of leftmost char on line */
	int ledge_ix;				/* index of leftmost char on line */
	int ix, cenx, charix, tmp;
    
	/* sanity */
	if ( txt->whole.nChars <= 0 )
		return(0);
    
	/* set the parameters of this line of the text field */
	stripbot = basey = txt->whole.pos.y;
	setx = ledgex = txt->whole.pos.x;
	ledge_ix = 0;

	/* set the info on the first character */
	lsetx = txt->whole.pos.x + txt->items[0]->offset.x + txt->items[0]->kern;
	leftix = 0;

	/* rip thru the text, finding the character to the left of the position */
	for ( ix=0; ix<txt->whole.nChars; ix++ )
	{
		/* account for offsets (indents, line wraps, kerns, ...) */
		setx += txt->items[ix]->offset.x + txt->items[ix]->kern;
		if ( txt->items[ix]->offset.y )
		{
			if ( pos->y < stripbot ) /* must be on previous line */
			{
				/* bail out of loop */
				ix = txt->whole.nChars;
				continue;
			}
			else /* not on the previous line */
			{
				/* set the parameters of this line of the text field */
				basey += txt->items[ix]->offset.y;
				stripbot = basey;
				ledgex = setx;
				ledge_ix = ix;
			}
		}

		/* if descender of character exceeds current bottom, expand bottom */
		tmp = basey +
		      txt->items[ix]->tbox.origin.y +
		      txt->items[ix]->tbox.height;
		if ( tmp > stripbot )
			stripbot = tmp;

		/* left edge is left of point, note it's index and pos */
		if ( setx + txt->items[ix]->tbox.origin.x < pos->x )
		{
			leftix = ix;
			lsetx = setx;
		}

		/* advance the current position by the width of the character */
		if ( ix < txt->whole.nChars - 1 )
			setx += txt->items[ix]->tadvance;
	}

	/* determine the index from the index in the last line examined */
	if ( pos->x < ledgex ) /* to the left of the first char on the last line */
		charix = ledge_ix ? ledge_ix+1 : ledge_ix;
	else {
		/* get the center point of the leftmost char */
		cenx = ((txt->items[leftix]->tbox.origin.x +
		         txt->items[leftix]->tbox.width) / 2) + lsetx;
		charix = (pos->x < cenx) ? leftix : leftix+1;
	}
	return(charix);
}

int
axtGetShadowDisplayInfoI(txt, txAp, shadow)
atext *txt;
txAttrI *txAp;
int shadow;
{
	int no_display, s_type;

	if ( !txAp->fillpattern )
		no_display = TRUE;
	else
		{
			s_type = txAp->fillpattern->s_type;
			if ( s_type == 0 )
				no_display = TRUE;
			else switch ( shadow )
				{
				default:
				case 0:			/* text */
					no_display = TRUE;
					break;

				case 1:			/* embossed shadow */
					if ( txt->draw_emboss == FALSE )
						no_display = TRUE;
					else if ( s_type != 3 && s_type != 4 )
						no_display = TRUE;
					else
						no_display = FALSE;
					break;

				case 2:			/* drop shadow */
					if ( txt->draw_shadow == TRUE )
						no_display = FALSE;
					else
						no_display = TRUE;
					break;
				}
		}
	return(no_display);
}

static char *
axtSubDispTxI(w, txt, len, clip, accum, shadow)
long w;
atext *txt;
int len;
r32 *clip;
p32 accum;
int shadow;
{
	int charcount, segix, ix, charix, tcharix, atStart, lpos, charsInSeg;
	int lx, llen, xdelta, ydelta;
	int inText, display, needs_redraw, full_display, no_display;
	int sdx, sdy, fillcolor, sfg, textless;
	int (*drawBull)();
	p32 prevSup, piecePos, rulept, tpt, rpt, bpt;
	txAttrI *txAp;
	attr_type txt_attr;
	color_type new_color;
	perCharI *pc;
	char *err;
	r32 bRect;

	/* init */
	charcount = len ? len : txt->whole.nChars - txt->editState.editPos;
	txAp = attrSegAtPosI(txt, txt->editState.editPos, &lpos, &segix);
	ix = charix = tcharix = txt->editState.editPos;
	prevSup.x = prevSup.y = 0;
	atStart = TRUE;
	inText = TRUE;
    
	if ( txt->whole.nChars == 0 )
		textless = TRUE;		/* we're here only to draw a possible bullet */
	else
		textless = FALSE;
    
	/* draw characters */
	while ( charcount > 0 || textless ) {
		txAp = txt->atts[segix++];
		charsInSeg = txAp->nChars - lpos;
		lpos = 0;
        
		/* get up-to-date screenfont reference */
		if ( !textless ) {
			/* read screen metrics */
			err = axGetScreenMetrics(txAp->screenFontName,
									 txAp->fconx.font,
									 &txAp->fconx.screen);
			if ( err )
				return(err);
		}

		/* set segment starting position */
		lx = charix + charsInSeg;
		llen = ydelta = xdelta = 0;
		if ( atStart == TRUE ) {
			atStart = FALSE;
		}
		else if ( txt->items ) {
			accum.x += txt->items[charix]->kern;
			accum.x += txt->items[charix]->offset.x;
			accum.y += txt->items[charix]->offset.y;
		}
		piecePos = rulept = accum;
		ix = charix;
		if ( txt->items ) {
			piecePos.y += txt->items[ix]->sup;
			rulept.y += txt->items[ix]->sup;
		}

		/* determine shadow offsets */
		memset(&txt_attr, 0, sizeof(attr_type));
		if ( txAp->fillpattern ) {
			txt_attr.ffg = txAp->fillpattern->ffg;
			txt_attr.fbg = txAp->fillpattern->fbg;
			txt_attr.lfg = txAp->fillpattern->lfg;
			txt_attr.lbg = txAp->fillpattern->lbg;
			fillcolor = txAp->fillcolor;
		}
		switch(shadow) {
			
		case 2:					/* dark shadow */
			no_display = axtGetShadowDisplayInfoI(txt, txAp, shadow);
			if ( no_display ) {
				sdx = 0;
				sdy = 0;
			}
			else {
				sdx = txAp->fillpattern->s_xoff * txt->whole.zoom / 1000.0;
				sdy = txAp->fillpattern->s_yoff * txt->whole.zoom / 1000.0;
				txAp->fillpattern->ffg = txAp->fillpattern->sfg;
				txAp->fillpattern->fbg = txAp->fillpattern->sfg;
				txAp->fillpattern->lfg = txAp->fillpattern->sfg;
				txAp->fillpattern->lbg = txAp->fillpattern->sfg;
				sfg = 0;
				sfg |= txAp->fillpattern->ffg.c << 24;
				sfg |= txAp->fillpattern->ffg.m << 16;
				sfg |= txAp->fillpattern->ffg.y << 8;
				sfg |= txAp->fillpattern->ffg.k;
				txAp->fillcolor = sfg;
			}
			break;
			
		case 1:					/* embossed/sun shadow */
			no_display = axtGetShadowDisplayInfoI(txt, txAp, shadow);
			if (txt->draw_emboss == FALSE ) {
				no_display = TRUE;
			}
			if ( no_display ) {
				sdx = 0;
				sdy = 0;
			}
			else if ( txAp->fillpattern->s_type < 3 ) {	/* < 3 ?? */
				no_display = TRUE;
				sdx = 0;
				sdy = 0;
			}
			else {
				no_display = FALSE;
				
				sdx = txAp->fillpattern->s_xoff * txt->whole.zoom / 1000.0;
				sdy = txAp->fillpattern->s_yoff * txt->whole.zoom / 1000.0;
				sdx *= (-1);
				sdy *= (-1);
				GetWashoutColor(&txAp->fillpattern->sfg, &new_color);
				txAp->fillpattern->ffg.c = new_color.c;
				txAp->fillpattern->ffg.m = new_color.m;
				txAp->fillpattern->ffg.y = new_color.y;
				txAp->fillpattern->ffg.k = new_color.k;
				
				txAp->fillpattern->fbg = txAp->fillpattern->ffg;
				txAp->fillpattern->lfg = txAp->fillpattern->ffg;
				txAp->fillpattern->lbg = txAp->fillpattern->ffg;
				
				sfg = 0;
				sfg |= txAp->fillpattern->ffg.c << 24;
				sfg |= txAp->fillpattern->ffg.m << 16;
				sfg |= txAp->fillpattern->ffg.y << 8;
				sfg |= txAp->fillpattern->ffg.k;
				txAp->fillcolor = sfg;
			}
			break;
			
		default:				/* no shadow */
			no_display = FALSE;
			sdx = 0;
			sdy = 0;
			break;
			
		}
        
		if ( textless ) {
			if (txAp->indent && txAp->indent->bullet &&
				txAp->indent->bullet->type) {
				
				if ( !no_display && (!txt->old ||
									 txAp->indent->bullet->changed) ) {

					/* no text -- only thing to display is the bullet
					 */
					axtBulletRectI(txt, txAp, &accum, &bRect);
					drawBull = txAp->indent->bullet->bulletDraw;
					bRect.origin.x = bRect.origin.x + sdx;
					bRect.origin.y = bRect.origin.y + sdy;
                    drawBull(txAp->indent, txAp->fontAttr.ptsizeInt,
                             txAp->fillpattern, &bRect, shadow,
                             txAp->useFgPixel);
					txAp->indent->bullet->changed = FALSE;
					txt->editState.disp = TRUE;

					/* load the clip into the relevant GC's */
					axtSetClip(axTextGC, clip, (r32 *) NULL);
					axtSetClip(axTextCursorGC, clip, (r32 *) NULL);
					axtSetClip(axTextStencilGC, clip, (r32 *) NULL);
				}
			}
			return ((char *) NULL);
		}

		/* draw the text associated with this attribute */
		for ( tcharix=charix; tcharix<lx; tcharix++ ) {
			pc = txt->items[tcharix];
			if ( tcharix > charix ) {
				/* include kern and offset in accum
				 */
				accum.x += txt->items[tcharix]->kern;
				accum.x += txt->items[tcharix]->offset.x;
				accum.y += txt->items[tcharix]->offset.y;
			}

			if ( pc->moved || pc->changed || pc->inserted || pc->damaged )
				needs_redraw = TRUE;
			else
				needs_redraw = FALSE;
			
			if ( !txt->old )
				full_display = TRUE;
			else
				full_display = FALSE;

			/* draw the bullet */
			if ( txAp->indent && axtHasBulletI(txt, txAp, pc, tcharix) ) {
				if ( pc->hidden || no_display )
					display = FALSE;
				else if ( txAp->indent->bullet->changed )
					display = TRUE;
				else if ( full_display )
					display = TRUE;
				else
					display = needs_redraw;
				if ( display ) {
					axtBulletRectI(txt, txAp, &accum, &bRect);
					drawBull = txAp->indent->bullet->bulletDraw;

					bRect.origin.x = bRect.origin.x + sdx;
					bRect.origin.y = bRect.origin.y + sdy;
                    drawBull(txAp->indent, txAp->fontAttr.ptsizeInt,
                             txAp->fillpattern, &bRect, shadow,
                             txAp->useFgPixel);
					txAp->indent->bullet->changed = FALSE;

					/* load the clip into the relevant GC's */
					axtSetClip(axTextGC, clip, (r32 *) NULL);
					axtSetClip(axTextCursorGC, clip, (r32 *) NULL);
					axtSetClip(axTextStencilGC, clip, (r32 *) NULL);
				}
			}

			/* draw the text */
			if ( pc->hidden || no_display )
				display = FALSE;
			else if ( full_display )
				display = TRUE;
			else
				display = needs_redraw;
			if ( inText ) {
				/* end of the last contiguous group */
				if ( !display || (axtHasOffsetI(pc, &prevSup.x) && llen) ) {
					/* draw text */
					tpt.x = piecePos.x + sdx;
					tpt.y = piecePos.y + sdy;
					rpt.x = rulept.x + sdx;
					rpt.y = rulept.y + sdy;
					qDrawTextI(Dpy, w, axTextGC, txt, txAp, ix, llen, &tpt);
					if ( txAp->ruling || txAp->strike_thru )
						drawRulingI(txt, w, txAp, ix, llen, &tpt, &rpt, FALSE);

					/* create new text segment */
					if ( display == FALSE )
						inText = FALSE; /* end of contiguous group */
					else
						{
							llen = 1;
							ix = tcharix;
							piecePos.x = accum.x + txt->items[ix]->sup;
							piecePos.y = accum.y;
							rulept = piecePos;
						}
				}
				else
					llen++;
			}
			else if ( display ) {
				inText = TRUE;	/* start of contiguous group */
				llen = 1;
				ix = tcharix;
				piecePos.x = accum.x + txt->items[ix]->sup;
				piecePos.y = accum.y;
				rulept = piecePos;
			}

			/* advance the text position */
			prevSup.x = 0;
			prevSup.y = pc->sup;
			accum.x += pc->tadvance;
			rulept.x = accum.x + pc->sup;
			rulept.y = accum.y;
		}

		/* any text left undrawn? - draw it now! */
		if ( inText && llen > 0 ) {
			tpt.x = piecePos.x + sdx;
			tpt.y = piecePos.y + sdy;
			rpt.x = rulept.x + sdx;
			rpt.y = rulept.y + sdy;
			qDrawTextI(Dpy, w, axTextGC, txt, txAp, ix, llen, &tpt);
			if ( txAp->ruling || txAp->strike_thru ) {
				drawRulingI(txt, w, txAp, ix, llen, &tpt, &rpt, FALSE);
			}
		}
		charcount -= charsInSeg;
		charix += charsInSeg;
		if ( txAp->fillpattern ) {
			txAp->fillpattern->ffg = txt_attr.ffg;
			txAp->fillpattern->fbg = txt_attr.fbg;
			txAp->fillpattern->lfg = txt_attr.lfg;
			txAp->fillpattern->lbg = txt_attr.lbg;
			txAp->fillcolor = fillcolor;
		}
	}
	txt->editState.disp = TRUE;	/* something is on-screen now */
	return((char *)0);
}

/* : dispTxI - display an axtext instance
 */
char * /* NULL means ok */
dispTxI(w, txt, clip)
long w;
atext *txt;
r32 *clip;
{
	r32 *old_clip, newField;
	p32 accum;
	char *err;
    
#if BUILD_ORIENT && !FOR_FILTER
	CheckCharsAgainstAttrsI(txt);
#endif

	/* if the text is unmeasured, format it for the display now */
	if ( txt->displayable == FALSE ) {
		err = axtDisplayableTextI(txt);
		if ( err )
			return(err);
	}
  
	/* load the clip into the relevant GC's */
	axtSetClip(axTextGC, clip, (r32 *) NULL);
	axtSetClip(axTextCursorGC, clip, (r32 *) NULL);
	axtSetClip(axTextStencilGC, clip, (r32 *) NULL);

	/* lift the cursor */
	if ( txt->editState.inEdit )
		liftCursorI(w, txt, (r32 *)0);

	if ( !txt->old ) {
		/* init display start-point 'accum' */
		if ( !txt->items ) {
			accum = txt->whole.pos;
		}
		else {
			accum.x = txt->whole.pos.x + txt->items[0]->offset.x +
				txt->items[0]->kern;
			accum.y = txt->whole.pos.y + txt->items[0]->offset.y;
		}
	}
	else {
		/* lift old text */
		/* init display start-point 'accum' */
		if ( txt->editState.editPos <= 0 ) {
			if ( !txt->items ) {
				accum = txt->whole.pos;
			}
			else {
				accum.x = txt->whole.pos.x + txt->items[0]->offset.x +
					txt->items[0]->kern;
				accum.y = txt->whole.pos.y + txt->items[0]->offset.y;
			}
		}
		else {		/* use old's pos and 0th offset to do the init */
			if ( !txt->old->items ) {
				accum = txt->old->whole.pos;
			}
			else {
				accum.x = txt->old->whole.pos.x +
					txt->old->items[0]->offset.x +
						txt->old->items[0]->kern;
				accum.y = txt->old->whole.pos.y +
					txt->old->items[0]->offset.y;
			}
		}
        
		/* compare current and last-displayed, lift non-current */
		if ( (txt->old->clipRect.width > 0) &&
			(txt->old->clipRect.height > 0) ) {
			
			old_clip = &txt->old->clipRect;
		}
		else {
			old_clip = (r32 *)0;
		}
		axtSetClip(axTextCursorGC, old_clip, (r32 *) NULL);
		axtSetClip(axLiftGC, old_clip, (r32 *) NULL);
		liftOldI(w, txt);
		axUnSetClip(axLiftGC, old_clip);
		axtSetClip(axTextCursorGC, clip, (r32 *) NULL);
	}

	/* draw text */
	/* clear any portion of the bounder that expanded since last display */
	if ( txt->editState.inEdit ) {
		axtSetClip(axLiftGC, clip, (r32 *) NULL);
		axtSnapshotFieldBounderI(txt, &newField);
		if ( txt->editState.forceBGDraw )
			extendFieldBounderI(txt, w, (r32 *)0);
		else
			extendFieldBounderI(txt, w, &newField);
		txt->editState.fieldBounder = newField;
		axUnSetClip(axLiftGC, clip);
	}
  
	/* draw shadows */
	if ( txt->draw_shadow )		/* draw dark shadow */
		err = axtSubDispTxI(w, txt, txt->editState.displayLen, clip, accum, 2);
    
	if ( txt->draw_emboss )		/* draw sun shadow */
		err = axtSubDispTxI(w, txt, txt->editState.displayLen, clip, accum, 1);

	/* draw text */
	if ( txt->shadow_only == FALSE ) {
		err = axtSubDispTxI(w, txt, txt->editState.displayLen, clip, accum, 0);
		if ( !err ) {
			/* reset the per-character info that pertains to edits */
			resetPerCharsI(txt);
      
			/* toss the old copy of the text */
			if ( txt->old ) {
				daxtextI(txt->old); /* toss the copy */
				txfree((char *) txt->old);
				txt->old = (atext *)NULL;
				txt->editState.editPos = 0;
				txt->editState.displayLen = 0;
			}
      
			/* draw cursor */
			if ( txt->editState.inEdit ) {
				axtDrawTextCursorI(w, txt, (r32 *)0,
								   txt->editState.cursorPos,
								   txt->editState.cursorType,
								   txt->editState.cursorActive);
			}
      
			/* save it for possible future lift */
			if ( clip ) {
				txt->clipRect.origin = clip->origin;
				txt->clipRect.width  = clip->width;
				txt->clipRect.height = clip->height;
			}
		}
	}
  
	/* done */
	axUnSetClip(axTextStencilGC, clip);
	axUnSetClip(axTextCursorGC, clip);
	axUnSetClip(axTextGC, clip);
	return(err);
}

/* : getOverallBounderI - return the 'ink bounder' for the given
 * range of text characters on *tx.   El cheapo version
 */
char * /* NULL means ok */
getOverallBounderI(txt, sindex, len, bbox)
atext *txt;
int sindex;
int len;
r32 *bbox; /* fill this in */
{
	int slinex, elinex, ix;
	
	bbox->origin.x = bbox->origin.y = 0;
	bbox->width = bbox->height = 0;

	if (!txt->whole.nChars) {
		return ((char *)NULL);
	}

	if (!txt->measured) {
		char *err;
		if(err = axtMeasuredTextI(txt)) {
			return err;
		}
	}
	if (len == -1) {
		len = txt->whole.nChars - sindex;
	}
    
	slinex = axtLineIndexFromCharIndexI(txt, sindex);
	elinex = axtLineIndexFromCharIndexI(txt, sindex + len - 1);

	bbox->width = txt->whole.width;
	bbox->height = 0;
	bbox->origin.x = 0;
	bbox->origin.y = -txt->whole.linetab[0].line_height;
	for (ix = 0; ix < slinex; ix++) {
		bbox->origin.y += txt->whole.linetab[ix].line_height;
	}
	for ( ; ix <= elinex; ix++) {
		bbox->height += txt->whole.linetab[ix].line_height;
	}
	bbox->origin.x -= txt->whole.bounderMargin;
	bbox->origin.y -= txt->whole.bounderMargin;
	bbox->height += txt->whole.bounderMargin + txt->whole.bounderMargin;
	return ((char *) NULL);
}

/* : axtGetPosOffsetI - return total positional offset between
 * the start of the text and the character at the passed index.
 */
static void
axtGetPosOffsetI(tx, charix, off)
atext *tx;
int charix;
p32 *off; /* return position of char relative to tx origin in mils */
{
	int ix, linex;
	p32 toff;
	
	if (!tx->whole.nChars) {
		off->x = off->y = 0;
		return;
	}

	if (!tx->measured) {
		char *err;
		if (err = axtMeasuredTextI(tx)) {
			freeErrString(err);
		}
	}

	/* find offset from whole.pos to charix
	 */
	toff.x = toff.y = 0;
	if (charix == 0) {
		toff.x += tx->whole.linetab[0].x_indent;
		linex = 0;
	}
	else {
		toff.y = -tx->whole.linetab[0].line_height;
		linex = axtLineIndexFromCharIndexI(tx, charix);
		for (ix = 0; ix <= linex; ix++) {
			toff.y += tx->whole.linetab[ix].line_height;
		}
		toff.x += tx->whole.linetab[linex].x_indent;
	}
	for (ix = tx->whole.linetab[linex].leftix; ix < tx->whole.nChars; ix++) {
		if (ix >= charix) {
			break;     /* add escapements upto but not including charix */
		}
		
		toff.x += tx->items[ix]->tadvance + tx->items[ix]->kern;
		
		if (ix > tx->whole.linetab[linex].leftix &&
			tx->items[ix]->linebreak) {
			
			break;    /* hit next line */
		}
	}
	
	if (charix < tx->whole.nChars) {
		/* any sup/kern on the character will affect its position
		 */
		toff.x += tx->items[charix]->kern;
		toff.y += tx->items[charix]->sup;
	}
	*off = toff;
	return;
}

axtGetSizeI(txt, wid, hyt)
atext *txt;
int *wid;
int *hyt;
{
	int i, n, ypos, maxy, xpos, maxx;
	int minx;

	n = txt->whole.nChars;
	for ( ypos = minx = maxy = xpos = maxx = i = 0; i < n; i++ ) {
		/* setpoint */
		if (i == 0) {  /* account alignment for position of first char */
			switch (txt->whole.alignment) {
			case CENTER_ALIGN:
				xpos -= (txt->items[0]->tadvance / 2);
				break;
			case RIGHT_ALIGN:
				xpos -= txt->items[0]->tadvance;
				break;
			default:
				xpos = 0;
				break;
			}
		} else {
			xpos += (txt->items[i]->offset.x + txt->items[i]->kern);
		}
		if ( xpos > maxx )
			maxx = xpos;
		if ( (i != 0) && (xpos < minx) )
			minx = xpos;

		ypos += txt->items[i]->offset.y + txt->items[i]->kern;
		if ( ypos > maxy )
			maxy = ypos;

		/* end of character */
		xpos += txt->items[i]->tadvance;
		if ( xpos > maxx )
			maxx = xpos;
		if ( (i != 0) && (xpos < minx) )
			minx = xpos;

		ypos += txt->items[i]->tadvance;
		if ( ypos > maxy )
			maxy = ypos;
	}
	*wid = maxx - minx;
	*hyt = maxy;
}

int
axtGetSimpleOffsetI(txt, ix1, ix2, old_offset)
atext *txt;
int ix1, ix2, old_offset;
{
	int i, new_offset;

	new_offset = old_offset;
	for ( i = ix1; i < ix2; i++ )
		new_offset += txt->items[i]->offset.y;
	return(new_offset);
}

int
axtGetOffsetI(txt, cindex)
atext *txt;
int cindex;
{
	int ix, slinex, new_offset;

	if ( cindex < 0 )
		slinex = 0;
	else
		slinex = axtLineIndexFromCharIndexI(txt, cindex);
	new_offset = txt->whole.pos.y - txt->whole.linetab[0].line_height;
	for (ix = 0; ix <= slinex; ix++)
		new_offset += txt->whole.linetab[ix].line_height;
#if 0
	if ( slinex == 0 )
		new_offset -= txt->whole.linetab[0].line_height/2;
	else
		new_offset -= txt->whole.linetab[ix-1].line_height/2;
#endif
	return(new_offset);

}

/* : insCharsI - inserts len# characters into *txt at index pos
 */
int
insCharsI(txt, str, pos, len)
atext *txt;
tx_char *str;
int pos;
int len;
{
	int lineix, alineix, alinelen;
	int singleChar, leftix, linelen, copylen;
	txAttrI *txAp;
	
	if (!txt)
		return FALSE;
	
	if (len == 0 || pos < 0 || pos > txt->whole.nChars) {
		return FALSE;
	}
	else if (pos < txt->editState.editPos) {
		/* optimization restriction -- see axtxint.h: editPos */
		return FALSE;
	}
	
	if (!txt->constructed) {
		axtDefaultTextI(txt);
	}
	
	singleChar = FALSE;
	lineix = alineix = alinelen = 0;
	leftix = linelen = copylen = 0;
	
	if (txt->editState.disp) {
		if (!txt->old) {
			/* first edit since last display -- save state.
			 */
			int epos, ipos;
			if (str && (1 == len) && (TABCHAR != str[0]) &&
				!NEWCHAR(str[0]) && (LEFT_ALIGN == txt->whole.alignment) &&
				(pos > 0) && txt->items && !txt->items[pos - 1]->linebreak) {
				
				/* insertion of a single regular text character,
				 * and not at the leftmost position on the line.
				 * 
				 * get line start indicies, current line lengths for
				 * line at pos, and line just above.  Copy just this
				 * much of the text in the hopes that the formatting
				 * needn't go further than that.
				 */
				singleChar = TRUE;
				ipos = pos ? pos - 1 : pos;/* char not actually inserted yet */
				lineix = axtLineIndexFromCharIndexI(txt, ipos);
				leftix = txt->whole.linetab[lineix].leftix;
				linelen = axtLinelenI(txt, lineix, leftix);
				epos = txt->editState.editPos = axtEditPosI(txt, pos);
				alineix = axtLineIndexFromCharIndexI(txt, epos);
				alinelen = axtLinelenI(txt, alineix,
									   txt->whole.linetab[alineix].leftix);
				if (alineix != lineix) {
					copylen = linelen + alinelen;
				}
				else {
					copylen = linelen;
				}
				copyAxtextI(&txt->old, txt, copylen);
			}
			else {
				epos = pos;
				if (str && len == 1 && str[0] == TABCHAR) {
					/* a very cheap n quick test for tab insertion;
					 * axtEditPosI should obviate this,
					 * but a safe hack anyway..
					 */
					epos = 0;
				}
				axtSnapshotTextI(txt, epos);
			}
		}
	}
	
	txAp = insCharsIntI(txt, str, pos, len);
	
	if (singleChar && txAp) {
		/* update target and screen info for the newly inserted char
		 */
		int tSpace, rightOffset, leftOffset, fitwidth;
		int numFit, linewid, vlap, ix, itmp;
		
		if ( txAp->fconx.target )
			updateTargetCharI(txt, txAp, txt->items[pos]);
		if ( txAp->fconx.screen )
			updateScreenCharsI(txAp, txt->items, pos, pos);
		
		/* 'pre-format' the affected line
		 */
		for (ix = lineix + 1; ix < txt->whole.numlines; ix++) {
			txt->whole.linetab[ix].leftix++;
		}
		axtGetIndentLineValsI(txt, txAp, leftix, &tSpace,
							  &rightOffset, &leftOffset);
		fitwidth = txt->whole.width ? txt->whole.width : BIG_MILS;
		fitwidth -= leftOffset + rightOffset;
		vlap = - txt->whole.linetab[lineix].line_height;
		if (lineix > 0) {
			vlap += txt->whole.linetab[lineix - 1].inkbottom;
		}
		axtLineFormatterI(txt, leftix, fitwidth,
						  &numFit, &linewid, &vlap, FALSE);
		
		if (numFit == linelen + 1) {
			/* good.  assume formatting effects are restricted to this line.
			 * claim that the measured/displayable state is upto date, after
			 * folding in the effects of this newly reformatted line.
			 */
			itmp = leftOffset + rightOffset + linewid;
			if ((txt->whole.numlines == 1) ||
				(itmp > txt->whole.formattedWidth)) {
				
				txt->whole.formattedWidth = itmp;
			}
			txt->whole.linetab[lineix].inkbottom = vlap;
			if (lineix < (txt->whole.numlines - 1)) {
				/* adjust next line's 1stchar offset to account for
				 * lengthening of this line
				 */
				itmp = txt->whole.linetab[lineix + 1].leftix;
				txt->items[itmp]->offset.x -=
					(txt->items[pos]->tadvance + txt->items[pos]->kern);
			}
			if (txt->whole.numlines > 1) {
				/* restrict redisplay to the affected line (and line above)
				 */
				txt->editState.displayLen = copylen + 1;
			}
			txt->measured = txt->displayable = TRUE;
		}
		else {
			/* not so good. formatting will affect more than one line.
			 * because we already took a short text copy, we need to
			 * delete the character, toss the copy, and reinsert.
			 */
 			delCharsIntI(txt, pos, 1);                   /* delete char */
			daxtextI(txt->old);                          /* toss old copy */
			txt->old = (atext *) NULL;
			axtSnapshotTextI(txt, pos);                  /* take new copy */
			insCharsIntI(txt, str, pos, len);            /* reinsert */
			txt->measured = txt->displayable = FALSE;
		}
	}
	else {
		txt->measured = txt->displayable = FALSE;
	}
    
	return TRUE;
}

/* : delCharsI - deletes len# text characters from *txt at index pos
 */
int
delCharsI(txt, pos, len)
atext *txt;
int pos;
int len;
{
	int ix, itmp, oldix, segix;
	txAttrI *txAp;

	if (!txt)
		return FALSE;
	
	if (len == 0 || pos < 0 || (pos+len) > txt->whole.nChars) {
		return FALSE;
	}
	else if (pos < txt->editState.editPos) {
		/* optimization restriction -- see axtxint.h: editPos */
		return FALSE;
	}
	if (!txt->items) {
		return FALSE;
	}
	if (!txt->constructed) {
		axtDefaultTextI(txt);
	}
	if (txt->editState.disp) { 
		if (!txt->old) {
			int tpos, tlimit;
			/* first edit since last display -- save state
			 */
			axtSnapshotTextI(txt, pos);
            
			/* indicate deletion on old copy
			 */
			tpos = pos - txt->editState.editPos;
			tlimit = pos + len - txt->editState.editPos;
			for (ix = tpos; ix < tlimit; ix++) {
				txt->old->items[ix]->deleted = TRUE;
			}
		}
		else {
			int fx = -1, lx = -2;
			/* indicate the deletion on the old copy - hard way
			 * (since the deleted bit itself figures in finding
			 * the old correspondent, collect sites first then
			 * mark as deleted "atomically")
			 */
			itmp = pos + len;
			for(ix = pos; ix < itmp; ix++) {
				oldix = getOldIndexI(txt, txt->old, ix);
				if (ix == pos) {
					fx = oldix;	/* 1st affected in range */
				}
				if (ix == itmp - 1) {
					lx = oldix;	/* last affected in range */
				}
				if (oldix >= 0 && oldix < txt->old->whole.nChars) {
					/* mark 'temp' member to collect deleted chars
					 */
					txt->old->items[oldix]->temp = TRUE;
				}
			}
			if ( fx >= 0 && fx < txt->old->whole.nChars ) {
				for (ix = fx; ix <= lx; ix++) {
					/* turn temp's into deleted's
					 */
					if (txt->old->items[ix]->temp) {
						txt->old->items[ix]->temp = 0; /* leave clean */
						txt->old->items[ix]->deleted = TRUE;
					}
				}
			}
		}
	}
	
	delCharsIntI(txt, pos, len);
    
	/* the delete may have brought two identical attr segs together
	 */
	checkJoinI(txt, pos-1, 2);

	txt->measured = txt->displayable = FALSE;
	return TRUE;
}

/* : setTextAttrs - applies one or more attrs to the *txt text character
 * range specified by index pos and length len
 */
int
setTextAttrsI(txt, attr, flags, pos, len)
atext *txt;                              /* all params in */
textAttrs *attr;
unsigned int flags; /* for example, TXpointsize | TXfontFamily | ... */
int pos, len;
{
	int fpos, lpos, tmp, oldix;
	int fsegix, lsegix, ix;
	int ok = TRUE;
	int firstSplit = FALSE;
	int lastSplit = FALSE;
	int firstChanged = FALSE;
	int lastChanged = FALSE;
	unsigned int tflags;
	txAttrI *first, *last;		/* of those affected */
	txAttrI txDefault, *defp;
	txAttrI tnew, newAttr, *tp;

	if (!txt || !attr)
		return FALSE;
	
	if (len == -1) {
		len = txt->whole.nChars - pos;
	}
	if (pos < 0 || pos + len > txt->whole.nChars) {
		return FALSE;
	}
	else if (pos < txt->editState.editPos) {
		/* optimization restriction -- see axtxint.h: editPos */
		return FALSE;
	}
	if (txt->editState.disp) { 
		if (!txt->old) {
			/* first edit since last display -- save state.
			 */
			axtSnapshotTextI(txt, pos);
		}
		if (txt->items) {
			/* indicate on the current chars that their
			 * appearance has changed from their on-screen image
			 */
			for(tmp = pos; tmp < pos + len; tmp++) {
				txt->items[tmp]->changed = TRUE;
			}
		}
	}
	
	txAttDefaultsI(&txDefault, &tflags, txt->pid); /* get hard defaults */
	if (txt->userDefaults) {
		defp = txt->userDefaults;
	}
	else {
		defp = &txDefault;
	}
	/* copy public to private (onto txAttrI)
	 */
	memset((void *)&tnew, 0, sizeof(txAttrI));
	memset((void *)&newAttr, 0, sizeof(txAttrI));
	copyInTextAttrI(txt, attr, &tnew, defp, flags, txt->pid);
	
	/* complete newAttr by folding in txDefault info */
	foldDefaultsI(flags, &tnew, defp, &newAttr, txt->pid);
	
	/* put newAttr onto *txt
	 */
	if (!txt->constructed) {
		axtDefaultTextI(txt);
	}
	
	/* first and last contain the endpoints of the range
	 */
	first = attrSegAtPosI(txt, pos, &fpos, &fsegix);
	last = attrSegAtPosI(txt, pos+len-1, &lpos, &lsegix);
	
	/* before possibly splitting the first & last affected,
	 * apply whatever changes to the attr segs in between.
	 */
	for (ix = fsegix; ix <= lsegix; ix++) {
		tp = txt->atts[ix];
		if (tp != first && tp != last) {
			attrChangeI(tp, &newAttr, flags, TRUE, txt->pid); /* change if needed */
		}
	}
	
	/* now look at the endpoints
	 */
	if (attrChangeI(last, &newAttr, flags, FALSE, txt->pid)) {
		if (needSplitI(txt, pos+len-1, RIGHT_EDGE)) {
			/* split right-edge attr
			 */
			if(!doSplitI(txt, pos+len)) {
				ok = FALSE;
				goto allDone;
			}
			lastSplit = TRUE;
		}
		lastChanged = TRUE;
	}
	if (lastSplit) {
		/* reset first since above split may have readdressed things
		 */
		first = attrSegAtPosI(txt, pos, &fpos, &fsegix);
	}
	if (attrChangeI(first, &newAttr, flags, FALSE, txt->pid)) {
		if (needSplitI(txt, pos, LEFT_EDGE)) {
			if(!doSplitI(txt, pos)) {
				ok =  FALSE;
				goto allDone;
			}
			firstSplit = TRUE;
		}
		firstChanged = TRUE;
	}
	if (firstChanged || lastChanged) {
		/* apply the new attr info to the endpoint attrs
		 */
		first = attrSegAtPosI(txt, pos, &fpos, &fsegix);
		last = attrSegAtPosI(txt, pos+len-1, &lpos, &lsegix);
		attrChangeI(first, &newAttr, flags, TRUE, txt->pid);
		if (last != first)
			attrChangeI(last, &newAttr, flags, TRUE, txt->pid);
	}
	
	/* scan the affected range for joins
	 */
	if(!checkJoinI(txt, pos, len)) {
		ok = FALSE;
		goto allDone;
	}
	
 allDone:
	if (affectsLetterforms(flags)) {
		if (txt->items) {
			for(lpos = pos; lpos < pos + len; lpos++) {
				/* mark perCharI's in affected range
				 */
				txt->items[lpos]->targetMetrics = FALSE;
				txt->items[lpos]->screenMetrics = FALSE;
			}
		}
		txt->measured = FALSE;
	}
	if (flags & TXindent) {
		txt->measured = FALSE;	/* this may move things */
	}
	txt->displayable = FALSE;
	tossTxAttrI((char *) &newAttr);
	tossTxAttrI((char *) &tnew);
	tossTxAttrI((char *) &txDefault);
    
	return ok;
}

/* : setDefaultTextAttrsI - establish a thorough txt->userDefaults
 * text attribute description on a new *txt instance
 */
int
setDefaultTextAttrsI(txt, attr, flags)
atext *txt; /* all params in */
textAttrs *attr;
unsigned int flags;
{
	txAttrI tnew, newAttr, txDefault;
	int ix;
	unsigned int tflags;
    
	if (!txt || !attr)
		return FALSE;
    
	/* get hard defaults */
	txAttDefaultsI(&txDefault, &tflags, txt->pid);

	/* get private copy of public attr struct
	 */
	memset((void *)&tnew, 0, sizeof(txAttrI));
	memset((void *)&newAttr, 0, sizeof(txAttrI));
	copyInTextAttrI(txt, attr, &tnew, &txDefault, flags, txt->pid);
    
    
	/* mix with user-supplied onto newAttr
	 */
	foldDefaultsI(flags, &tnew, &txDefault, &newAttr, txt->pid);
    
	/* attach to *txt
	 */
	if (txt->userDefaults) {
		tossTxAttrI((char *) txt->userDefaults);
		txfree(txt->userDefaults);
	}
	txt->userDefaults = (txAttrI *) txloc(txt->pid, sizeof(txAttrI));
	memset((void *)txt->userDefaults, 0, sizeof(txAttrI));
	copyTxAttrI(txt->userDefaults, &newAttr, txt->pid);
	txt->userDefaultFlags = flags;
	if (txt->items) {			/* probably not */
		for (ix = 0; ix < txt->whole.nChars; ix++) {
			txt->items[ix]->targetMetrics = FALSE;
		}
	}
	txt->displayable = txt->measured = txt->constructed = FALSE;
	tossTxAttrI((char *) &tnew);
	tossTxAttrI((char *) &newAttr);
	tossTxAttrI((char *) &txDefault);
	return TRUE;
}

/* : getDefaultTextAttr
 * report complete defaults onto *attr.  Note that
 * *attr should be in good shape -- either clear, or
 * with real data on it.  As this function copies onto
 * it, it will try to free any string pointers it finds. */
int
getDefaultTextAttrI(txt, attr)
atext *txt; /* in */
textAttrs *attr; /* out */
{
	unsigned int flags = (unsigned int) TXAllAtts;
	if (!txt || !attr)
		return FALSE;
	copyOutTextAttrI(attr, txt->userDefaults, flags, txt->pid);
	return TRUE;
}
int
axtGetDefTextAttrI(txt, attr)
atext *txt;
textAttrs **attr; /* out */
{
	*attr = (textAttrs *)txloc(txt->pid, sizeof(textAttrs));
	memset((void *)*attr, 0, sizeof(textAttrs));
	if ( getDefaultTextAttrI(txt, *attr) == FALSE ) {
		txfree((char *)*attr);
		*attr = (textAttrs *)NULL;
		return FALSE;
	}
	return TRUE;
}

/* : getTextAttrsI
 * get textAttr array fully describing attr info for
 * selected range of *txt;  Note that caller must free
 * the resultant array, and the textAttrs have strings
 * attached.. */
int
getTextAttrsI(txt, pos, len, attrs, attrLen)
atext *txt;
int pos, len;
textAttrs **attrs; /* out */
int *attrLen;     /* out */
{
	unsigned int flags = (unsigned int) TXAllAtts;
	int lpos, segcount, firstix, lastix, ix, jx;
	txAttrI *first, *last, txDefault, txFullDefault;

	if (!txt || !attrs || !attrLen) {
		*attrs = (textAttrs *)NULL;
		*attrLen = 0;
		return FALSE;
	}

	if (len==-1) {
		len=txt->whole.nChars - pos;
	}
	else if (len == 0) {
		len = 1;
	}

	if (txt->atts) {
		first = attrSegAtPosI(txt, pos, &lpos, &firstix);
		last = attrSegAtPosI(txt, pos+len-1, &lpos, &lastix);
		segcount = (lastix - firstix) + 1;
		*attrs = (textAttrs *)txloc(txt->pid, segcount * sizeof(textAttrs));
		memset((void *)*attrs, 0, segcount * sizeof(textAttrs));
		for(ix = firstix, jx = 0; ix <= lastix; ix++, jx++) {
			copyOutTextAttrI(*attrs + jx, txt->atts[ix], flags, txt->pid);
			(*attrs)[jx].numChars = txt->atts[ix]->nChars;
		}
		*attrLen = segcount;
	}
	else {
		/* no explicit attrs; report defaults */
		memset((void *)&txDefault, 0, sizeof(txAttrI));
		/* get hard defaults */
		txAttDefaultsI(&txDefault, &flags, txt->pid);
		if (txt->userDefaults) {
			/* fold in user defaults */
			memset((void *)&txFullDefault, 0, sizeof(txAttrI));
			foldDefaultsI(txt->userDefaultFlags, txt->userDefaults,
						  &txDefault, &txFullDefault, txt->pid);
			*attrs = (textAttrs *)txloc(txt->pid, sizeof(textAttrs));
			memset((void *)*attrs, 0, sizeof(textAttrs));
			copyOutTextAttrI(*attrs, &txFullDefault, flags, txt->pid);
			tossTxAttrI((char *) &txFullDefault);
		}
		tossTxAttrI((char *) &txDefault);
		*attrLen = 1;
	}
	return TRUE;
}

/* : getHardcodedDefaults - return internal hardcoded defaults
 * onto passed textAttrs instance.  the passed instance should
 * be clean or otherwise properly initialized -- copyOut will
 * free nonzero heap addrs that it finds there
 */
int
getHardcodedDefaultsI(attrs, pid)
textAttrs *attrs; /* out: internal defaults in textAttr form */
int pid;
{
	txAttrI txDefault;
	unsigned int flags = (unsigned int) TXAllAtts;
	memset((void *)&txDefault, 0, sizeof(txAttrI));
	txAttDefaultsI(&txDefault, &flags, pid);
	copyOutTextAttrI(attrs, &txDefault, flags, pid);
	tossTxAttrI((char *) &txDefault);
	return TRUE;
}

/* : getTextI
 * Return the complete textstr of *txt
 */
int
getTextI(txt, charcodes, len)
atext *txt;
tx_char **charcodes; /* out -- caller must free */
int *len;           /* out -- number of tx_chars returned */
{
	int ix, tlen;

	if (!txt || !charcodes || !len)
		return FALSE;

	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}

	tlen = txt->whole.nChars;

	if (tlen > 0) {
		*charcodes = (tx_char *)txloc(txt->pid, tlen * sizeof(tx_char));
		for (ix = 0; ix < tlen; ix++) {
			(*charcodes)[ix] = txt->items[ix]->charcode;
		}
	}
	else {
		*charcodes = (tx_char *) NULL;
	}
	*len = tlen;
	return TRUE;
}

/* : getTextFromIndexI
 * Return the partial textstr of *txt from index and len
 */
int
getTextFromIndexI(txt, charcodes, index, len)
atext *txt;
tx_char **charcodes; /* out -- caller must free */
int index;
int len;
{
	int ix, jx;

	*charcodes = (tx_char *) NULL;
	if (!txt || !charcodes || !len)
		return FALSE;
	if ( index < 0 || index > txt->whole.nChars ) 
		index = 0;
	if ( len <= 0 )
		len = txt->whole.nChars;

	*charcodes = (tx_char *)txloc(txt->pid, len * sizeof(tx_char));
	for (jx=0, ix = index; jx < len; ix++, jx++)
		(*charcodes)[jx] = txt->items[ix]->charcode;

	return TRUE;
}

/* : axtTextEditClearedI - used when text-under-edit
 * has been lifted from screen by something other
 * than the axtext code.  This func lets the axtext
 * instance know that it's no longer on-screen
 */
void
axtTextEditClearedI(txt)
atext *txt;
{
	if (!txt || !txt->editState.inEdit)
		return;
	
	if (txt->old) {
		daxtextI(txt->old); /* toss old state */
		txfree((char *) txt->old);
		txt->old = (atext *) NULL;
	}
    txt->editState.cursorOn = FALSE;
    txt->editState.disp = FALSE;
    txt->editState.fieldBounder.width = 0;
	txt->editState.editPos = 0;
	txt->editState.displayLen = 0;
}

void
axtClearOldTextI(txt)
atext *txt;
{
	if (!txt )
		return;
	
	if (txt->old) {
		daxtextI(txt->old); /* toss old state */
		txfree((char *) txt->old);
		txt->old = (atext *) NULL;
	}
    txt->editState.cursorOn = FALSE;
    txt->editState.disp = FALSE;
	txt->editState.editPos = 0;
}

/* : axtStartEdit - enable text cursor display, etablish optional
 * background pixmap for text lifting.
 */  
void
axtStartEditI(txt, background, backRect, color)
atext *txt;       /* in */
Pixmap background; /* in: lift text by copying from this */
r32 *backRect;     /* in: expresses offset within passed pixmap */
color_type *color; /* in: use this for plain clears if no pixmap */
{
	unsigned long pel;
	if ( txt && txt->editState.inEdit == FALSE )
	{
		txt->editState.cursorType = CURSOR_TRIANGLE;
		txt->editState.cursorActive = ACTIVE;
		txt->editState.background = background;
		if ( backRect )
			txt->editState.backRect = *backRect; /* in screen pix */
		if ( color && color->see_thru == FALSE )
		{
			AxGetRealPixel(2, color->c,color->m,color->y,color->k, 255, &pel);
			txt->editState.backgroundPixel = pel;
			txt->editState.javaPixel = 0xff000000 +
			 (((255 - (color->c + color->k))<<16)&0x00ff0000) +
			 (((255 - (color->m + color->k))<<8)&0x0000ff00) +
			  ((255 - (color->y + color->k))&0x000000ff);
		}
		else
		{
			txt->editState.backgroundPixel = AlisPixels[WHITE];
			txt->editState.javaPixel = 0xffffffff;
		}
		txt->editState.inEdit = TRUE;
	}
}

/* : axtSetLineHeight
 */
void
axtSetLineHeightI(tx, lineHeight)
     atext *tx;
     int lineHeight;
{
  if (!tx)
    return;

  if (tx->whole.lineHeight != lineHeight) {
    if (tx->editState.disp) {
      if (!tx->old) {
		  /* first edit since last display -- save state.
		   * setLineHeight is effectively an edit at pos 0.
		   */
		  axtSnapshotTextI(tx, 0);
      }
      axtMoveItemsI(tx); /* lineheight change affects all chars */
    }
    tx->whole.lineHeight = lineHeight;
    tx->measured = tx->displayable = FALSE;
  }
}

void
axtSetZoomI(tx, zoom, notUsed)
atext *tx;
int zoom;   /* where 100% zoom (unzoomed) is 1000 */
{
	int segcount, ix;
	txAttrI *txAp;
	
	if (zoom != tx->whole.zoom) {
		tx->whole.zoom = zoom;
		if (zoom == 1000) {
			tx->whole.zoomOn = FALSE;
		}
		else {
			tx->whole.zoomOn = TRUE;
		}
		if (!tx->measured) {
			char *err;
			if (err = axtMeasuredTextI(tx)) {
				freeErrString(err);
			}
		}
		/* recompute the effective pointsize numbers
		 */
		segcount = segCountI(tx, -1, &txAp);
		for (ix = 0; ix < segcount; ix++) {
			txAp = tx->atts[ix];
			txAp->fontAttr.ptsizeInt =
				(int)(txAp->fontAttr.unzoomed_ptsize *
					  ((float) tx->whole.zoom / 1000.0));
			txAp->fontAttr.ptsize =
				(float) txAp->fontAttr.ptsizeInt / 10000.0;
			if (txAp->screenFontName) {
				txfree((char *)txAp->screenFontName);
				txAp->screenFontName = (char *) NULL;
			}
		}
		for (ix = 0; ix < tx->whole.nChars; ix++) {
			tx->items[ix]->screenMetrics = FALSE;
			tx->items[ix]->targetMetrics = FALSE;
		}
		tx->measured = tx->displayable = FALSE;
	}
}

void
axtGetZoomI(tx, xZoom, yZoom)
     atext *tx;
     int *xZoom, *yZoom;  /* out: (100% zoom (unzoomed) returned as 1000) */
{
  if (!tx || !xZoom || !yZoom)
    return;

  *xZoom = tx->whole.zoom;
  *yZoom = tx->whole.zoom;
}

void
axtZoomBounderI(tx, bbox)
     atext *tx;
     r32 *bbox;
{
  double zoom;
  int val;

  if (tx->whole.zoomOn) {
    zoom = 1000.0 / tx->whole.zoom;
    val = (bbox->origin.x + (int) bbox->width - 1) * zoom;
    bbox->origin.x = bbox->origin.x * zoom;
    bbox->width = val - bbox->origin.x + 1;

    zoom = 1000.0 / tx->whole.zoom;
    val = (bbox->origin.y + (int) bbox->height - 1) * zoom;
    bbox->origin.y = bbox->origin.y * zoom;
    bbox->height = val - bbox->origin.y + 1;
  }
}

/* : axtSetFieldWidthI - specify that the passed axtext instance's
 * text should be formatted to fit within the passed width. If the
 * passed width is 0, the bounding is unconstrained.
 */
void
axtSetFieldWidthI(tx, width)
atext *tx;
int width;           /* formatting width, mustn't contain zoom */
{
	if (!tx)
		return;

    if (tx->whole.width != width) {
		tx->whole.width = width;
		tx->measured = tx->displayable = FALSE;
	}
}

/* : axtGetFieldWidth
 */
void
axtGetFieldWidthI(tx, width)
atext *tx;
int *width;
{
	*width = tx->whole.width;
}

int /* FALSE if no cursor */
getCursorIndexAndPosI(tx, indx, pos)
atext *tx;
int *indx; /* out: cursor index */
p32 *pos; /* out: window-relative position of cursor in mils */
{
    
	if (!indx || !pos)
		return FALSE;
    
	if (tx->editState.inEdit) {
		if (tx->whole.nChars) {
			axtGetPosOffsetI(tx, tx->editState.cursorPos, pos);
			pos->x += tx->whole.pos.x;
			pos->y += tx->whole.pos.y;
			*indx = tx->editState.cursorPos;
		}
		else {
			axtGetPosI(tx, pos);
			*indx = 0;
		}
		return TRUE;
	}
	else
		return FALSE;
}

/* return the indices of the word, and line which enclose
 * refIndex
 */
int
getWordIndicesI(txt, refIndex, wLeft, wRight, lLeft, lRight)
atext *txt;
int refIndex; /* in: reference index */
int *wLeft, *wRight; /* out: indices of ends of enclosing word */
int *lLeft, *lRight; /* out: indices of ends of enclosing line */
{
	int ix, break_char;
	tx_char code;
	perCharI *pc;

	/* sanity check */
	if ( !txt || !txt->items || !txt->whole.nChars) {
		*wLeft = *wRight = *lLeft = *lRight = 0;
		return FALSE;
	}

	/* init */
	if ( refIndex >= txt->whole.nChars )
		refIndex = txt->whole.nChars - 1;
	if ( refIndex < 0 )
		refIndex = 0;
	code = txt->items[refIndex]->charcode;
	break_char = WORDBREAK(code);

	/* look leftward for enclosing word index */
	*wLeft = 0;
	for ( ix = refIndex; ix >= 0; ix-- ) {
		pc = txt->items[ix];
		if ( break_char != WORDBREAK(pc->charcode) ) {
			*wLeft = ix + 1;
			break;
		}
	}

	/* look leftward for enclosing line index */
	*lLeft = 0;
	for ( ix = refIndex - 1; ix > 0; ix-- ) {
		pc = txt->items[ix];
		if ( pc->offset.y ) {
			*lLeft = ix;
			break;
		}
	}

	/* look rightward for enclosing word index */
	*wRight = txt->whole.nChars - 1;
	for( ix = refIndex; ix < txt->whole.nChars; ix++ ) {
		pc = txt->items[ix];
		if ( break_char != WORDBREAK(pc->charcode) ) {
			*wRight = ix - 1;
			break;
		}
	}

	/* look rightward for enclosing line index */
	*lRight = txt->whole.nChars - 1;
	for ( ix = refIndex; ix < txt->whole.nChars; ix++ ) {
		pc = txt->items[ix];
		if ( pc->offset.y ) {
			if ( ix == *lLeft ) {
				*lRight = ix;
			} else {
				*lRight = ix - 1;
			}
			break;
		}
	}

	return TRUE;
}

/* : return a copy of the passed instance.  Though copy is not
 * thorough, it will be measurable if passed a measurable instance.
 * caller must free non-null returned copy using daxtextI().
 * Note that no copy is returned in the 0-chars case.
 */
atext *
axtCopyI(tx)
atext *tx;
{
	atext *tcopy = (atext *) NULL;

	if (tx->whole.nChars) {
		copyAxtextI(&tcopy, tx, tx->whole.nChars - tx->editState.editPos);
	}
	return (tcopy);
}

/*
 * Support routines
 */

int
axtHasOffsetI(pc, prevSup)
perCharI *pc;           /* in */
int *prevSup;           /* in: previous char's sub/sup offset */
{
    if (CHAR_IS_DIMENSIONLESS(pc->charcode)) {
        return TRUE;
    }
        
    if (pc->offset.x || pc->offset.y || pc->kern) {
        return TRUE;			/* any nonzero value denotes offset */
    }
    else if (pc->sup != *prevSup) {
        return TRUE;			/* offset only when different from prev char */
    }
    else
        return FALSE;			/* good */
}

static void
fieldDefaultsI(tx)
atext *tx;
{
	tx->whole.zoom = 1000;
	tx->whole.zoomOn = FALSE;
}

/* reset perCharI info that pertains to edits
 */
static void
resetPerCharsI(txt)
atext *txt;
{
	int lx;
	if (!txt || !txt->items)
		return;
	for (lx = txt->editState.editPos; lx < txt->whole.nChars; lx++) {
		txt->items[lx]->changed =
			txt->items[lx]->deleted = 
				txt->items[lx]->damaged =
					txt->items[lx]->moved = 
						txt->items[lx]->inserted = FALSE;
	}
}

void
axtLiftTextCursorI(w, txt)
long w;
atext *txt;
{
	XPoint *tpts;
	Drawable drw;
	GC gc;
	int x_off, y_off;
    
	if (!txt->editState.cursorOn)
		return;

	/* get the drawable */
	drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

	/* lift old cursor; assume xor-transfers, lift by drawing */
	tpts = txt->editState.lastCursorPoints;
	if (txt->editState.lastCursorActive)
		gc = axTextCursorGC;
	else
		gc = axInactiveTextCursorGC;

	if (txt->editState.lastCursorClip.height) {
		axtSetClip(gc, (r32 *) NULL,
					&txt->editState.lastCursorClip);
	}
	else {
		axtSetClip(gc, (r32 *) NULL, (r32 *) NULL);
	}
    
	if (txt->editState.lastCursorPointcount == 2) {
		XDrawLine(Dpy, drw, gc, tpts[0].x, tpts[0].y, tpts[1].x, tpts[1].y);
	}
	else {
		XFillPolygon(Dpy,drw,gc,tpts,txt->editState.lastCursorPointcount,
					 Convex,CoordModeOrigin);
	}
	txt->editState.cursorOn = FALSE;
}

static void
axtDrawTextI(txt, drw, x, y, hyt, wid, mask, fillpattern, useFgPixel)
atext *txt;
Drawable drw;
int x, y, hyt, wid;
Drawable mask;
attr_type *fillpattern;
int useFgPixel;
{
	attr_type attr;

	memcpy(&attr, fillpattern, sizeof(attr_type));
	if (useFgPixel)
	{
		attr.ffg.c = 0;
		attr.ffg.m = 0;
		attr.ffg.y = 0;
		attr.ffg.k = 255;

		attr.fbg.c = 0;
		attr.fbg.m = 0;
		attr.fbg.y = 0;
		attr.fbg.k = 255;
		attr.fill_flag = TRUE;
	}
	axtDrawText((axtext *)txt, drw, x, y, hyt, wid, mask, &attr);
}

static int
drawRulingI(tx, w, txAp, startix, len, ufrom, uto, lifting)
atext *tx;
long w;
txAttrI *txAp;       /* in: attr seg being underlined */
int startix, len;   /* in: start index, length in chars of the seg */
p32 *ufrom, *uto;   /* in: corresponding endpoints, on baseline */
int lifting;        /* in; bool: TRUE if lifting the ruling */
{
	p32 tfrom, tto, from, to, mapOrig;
	p32 lfrom, lto;
	p32 thickness, offset, strikeoffset;
	r32 mapRect;
	unsigned long fgCol, bgCol, planeMask;
	int strokewidth, patterned;
	Pixmap map;
	Drawable drw, screenDrw;
	GC tgc;
	int x_off, y_off;

	if (len == 0 )
		return FALSE;
    if (txAp->ruling == FALSE && txAp->strike_thru == FALSE )
        return FALSE;

	/* set drawable, get draw colors
	 */
	screenDrw = drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
	if (lifting) {
		/* %%%%%%% note no treatment of background pixmap.... */
		setLiftColorI(tx, axLiftGC);
	}
	else {
		axtSetFgBgI(Dpy, txAp, &fgCol, &bgCol, &planeMask);
	}

	/* take copies of passed endpoints, adjust if needed
	 */
	axtAdjustRulingEndpointsI(tx, startix, len, ufrom, uto, &lfrom, &lto);
    
	/* get the metric info on underline
	 */
	thickness.y = txAp->fontAttr.underlineThickness;
	offset.y = txAp->fontAttr.underlinePosition;
	if (thickness.y == 0)
		thickness.y = 50;		/* most common in our core fontset */
	if (offset.y == 0)
		offset.y = 150;
	strokewidth = thickness.y;
	if (txAp->strike_thru ) {
		strikeoffset.y = strikeThruOffsetI(txAp);
	}
	else {
		strikeoffset.y = 0;
	}
	thickness.x = offset.x = strikeoffset.x = 0;
	/* convert these numbers to screenpix
	 */
	offset.x = mToPix(offset.x, txAp->fontAttr.ptsize, ScreenRes);
	offset.y = mToPix(offset.y, txAp->fontAttr.ptsize, ScreenRes);
	strikeoffset.x = milsToPix(strikeoffset.x, ScreenRes);
	strikeoffset.y = milsToPix(strikeoffset.y, ScreenRes);
	thickness.x = mToPix(thickness.x, txAp->fontAttr.ptsize, ScreenRes);
	thickness.y = mToPix(thickness.y, txAp->fontAttr.ptsize, ScreenRes);
	strokewidth = mToPix(strokewidth, txAp->fontAttr.ptsize, ScreenRes);
	if (strokewidth <= 0)
		strokewidth = 1;

	/* done with most geometry; do drawing now */

	if ( lifting ) {
		patterned = FALSE;
	}
	else if ( IS_SOLID_FILL(tx->gContext, txAp->fillpattern) == FALSE ) {
		patterned = TRUE;
	}
	else {
		patterned = FALSE;
	}
    
	if (patterned) {
		/* draw the ruling onto a pixmap whose size
		 * contains the text being underlined
		 */
		char *errString;
		int pixwid, pixht, tstart, tlen;
		p32 startpos;

		/* include an extra character in each direction if
		 * possible.  ok for the pixmap to be 2 chars larger..
		 */
		tstart = startix;
		tlen = len;
		if (startix) {
			tstart = startix - 1;
			tlen++;
		}
		if ((startix + len) < (tx->whole.nChars - 1)) {
			tlen++;
		}
        
		if (errString = getOverallBounderI(tx, tstart, tlen, &mapRect)) {
			freeErrString(errString);
			return FALSE;
		}
        
		pixwid = milsToPix(mapRect.width, ScreenRes);
		pixht = milsToPix(mapRect.height, ScreenRes);

		map = XCreatePixmap(Dpy, drw, pixwid, pixht, 1);
		XFillRectangle(Dpy, map, PixClearGC, 0, 0, pixwid, pixht);
        
		/* write screen pos at which to display the pixmap onto mapOrig
		 */
		axtGetPosOffsetI(tx, tstart, &startpos);

		/* need to subtract any kern & offset on tstart'th char;
		 * these vectors are already present in the mapRect's origin
		 */
		startpos.x -= tx->items[tstart]->kern;
		startpos.x -= tx->items[tstart]->offset.x;
		startpos.y -= tx->items[tstart]->offset.y;
		mapOrig.x = startpos.x + mapRect.origin.x + tx->whole.pos.x;
		mapOrig.y = startpos.y + mapRect.origin.y + tx->whole.pos.y;
        
		/* init the pixmap-relative baseline endpoints (from, to)
		 * from which the ruling endpoints will be derived; best
		 * to think of this as the subtraction of the pixmap's origin
		 * from the adjusted underline endpoints lfrom, lto
		 */
		from.x = lfrom.x - mapOrig.x;
		from.y = lfrom.y - mapOrig.y;
		to.x = lto.x - mapOrig.x;
		to.y = lto.y - mapOrig.y;
        
		mapRect.width = pixwid;
		mapRect.height = pixht;
		mapOrig.x = milsToPix(mapOrig.x, ScreenRes);
		mapOrig.y = milsToPix(mapOrig.y, ScreenRes);
        
		drw = map;
		tgc = PixGC;
	}
	else {
		map = (Pixmap) 0;
		tgc = lifting ? axLiftGC : axTextGC;
		from = lfrom;
		to = lto;
	}
    
	XSetLineAttributes(Dpy, tgc, strokewidth, LineSolid,
					   CapButt, JoinRound);

	if (!(patterned || lifting)) { /* patterned case uses (ready) PixGC */
		XSetState(Dpy, tgc, fgCol, ~AllPlanes, GXcopy, AllPlanes);
	}

	if (txAp->strike_thru ) {
		tfrom.x = milsToPix(from.x, ScreenRes) + strikeoffset.x;
		tfrom.y = milsToPix(from.y, ScreenRes) + strikeoffset.y;
		tto.x = milsToPix(to.x, ScreenRes) + strikeoffset.x;
		tto.y = milsToPix(to.y, ScreenRes) + strikeoffset.y;
		XDrawLine(Dpy, drw, tgc, tfrom.x, tfrom.y, tto.x, tto.y);
	}
	if (txAp->ruling & AXRULING_SINGLE || txAp->ruling & AXRULING_DOUBLE) {
		tfrom.x = milsToPix(from.x, ScreenRes) + offset.x;
		tfrom.y = milsToPix(from.y, ScreenRes) + offset.y;
		tto.x = milsToPix(to.x, ScreenRes) + offset.x;
		tto.y = milsToPix(to.y, ScreenRes) + offset.y;
		XDrawLine(Dpy, drw, tgc, tfrom.x, tfrom.y, tto.x, tto.y);
	}
	if (txAp->ruling & AXRULING_DOUBLE) {
		tfrom.x = tfrom.x + (3 * thickness.x);
		tfrom.y = tfrom.y + (3 * thickness.y);
		tto.x = tto.x + (3 * thickness.x);
		tto.y = tto.y + (3 * thickness.y);
		XDrawLine(Dpy, drw, tgc, tfrom.x, tfrom.y, tto.x, tto.y);
	}
	if (patterned) {
		/* draw results to screen using map and pattern info
		 */
		axtDrawTextI(tx, screenDrw, mapOrig.x, mapOrig.y, mapRect.height,
					mapRect.width, map,
					txAp->fillpattern, txAp->useFgPixel);
		XFreePixmap(Dpy, map);
	}
	return(TRUE);
}

int
strikeThruOffsetI(txAp)
txAttrI *txAp;
{
	int tmp = -qRound(0.5 * (float) 
                      emToMils(txAp->fconx.target->xHeight,
							   txAp->fontAttr.ptsizeInt));
  
	if (tmp == 0)
		tmp = -1;
	return (tmp);				/* in mils */
}

/* : reFitI - reformats the text to keep it inside a galley width
 */
static char * /* NULL means ok */
reFitI(tx)
atext *tx;
{
	int leftIndex, ix, itmp;
	int numFit, tSpace, segix, line_index;
	int bounder_margin;
	int linewid, left_adj, lpos;
	int lineHeight, tLineHeight, lineSpacing; /* contains zoom */
	int prev_right_x, left_x, vlap;	          /* contains zoom */
	int fitwidth, fieldwidth;	              /* mustn't contain zoom */
	int leftOffset, rightOffset;              /* mustn't contain zoom */
	int vertAdvance = TRUE;
	txAttrI *txAp;
	char *errString;
	
	if (!tx->whole.nChars) {
		return ((char *) NULL);
	}

	/* init starting index, linespacing, indenting info
	 */
	if (!tx->whole.lineHeight) {
		lineHeight = getDefaultLineHeightI(tx);
	}
	else {
		lineHeight = tx->whole.lineHeight;
	}
	if (tx->whole.zoomOn) {
		tLineHeight = (int)(lineHeight * ((float) tx->whole.zoom / 1000.0));
	}
	else {
		tLineHeight = lineHeight;
	}
	leftIndex = tx->editState.editPos;
	txAp = attrSegAtPosI(tx, leftIndex, &lpos, &segix);
	rightOffset = leftOffset = 0;
	if (txAp->indent) {
		axtGetIndentLineValsI(tx, txAp, leftIndex, &tSpace,
							  &rightOffset, &leftOffset);
		if (tSpace) {
			if (tx->whole.zoomOn) {
				tLineHeight =
					(int)(tSpace * ((float) tx->whole.zoom / 1000.0));
			}
			else {
				tLineHeight = tSpace;
			}
		}
	}
	/* estimate max ink extent beyond formatting bounder using ~1/3 em.
	 */
	itmp = emToMils(300, txAp->fontAttr.ptsizeInt);
	if (itmp > tx->whole.bounderMargin) {
		tx->whole.bounderMargin = itmp;
	}

	/* init left_x, prev_right_x, used for offset assignment
	 */
	if (tx->whole.zoomOn) {
		left_x = (int)(leftOffset * ((float) tx->whole.zoom / 1000.0));
	}
	else {
		left_x = leftOffset;
	}
	left_adj = 0;
	prev_right_x = 0;

	/* init overall fieldwidth, and per-line fitwidth
	 */
	if (tx->whole.width) {
		fieldwidth = tx->whole.width;
	}
	else if ((RIGHT_ALIGN == tx->whole.alignment) ||
			 (CENTER_ALIGN == tx->whole.alignment)) {
		fieldwidth = axtGetMaxWidthI(tx, &tx->whole.formattedWidth);
	}
	else {
		fieldwidth = BIG_MILS;	/* supposedely unlimited */
	}
	fitwidth = fieldwidth - rightOffset - leftOffset;
	
	if (leftIndex) {
		line_index = axtLineIndexFromCharIndexI(tx, leftIndex);
	}
	else {
		line_index = 0;
	}
	
	vlap = -(INT_MAX >> 2);		/* this is for vertical overlap detection */

	while(TRUE) {
		
		/* fit the current line.  leftIndex is that of the 1st char at
		 * which to start reformatting.
		 */
		vlap -= tLineHeight;	/* update to inkbottom of prev line */
		
		axtLineFormatterI(tx, leftIndex, fitwidth,
						  &numFit, &linewid, &vlap, TRUE);

		/* do line alignment, which may adjust offsets
		 */
		doAlignmentI(tx, linewid, fitwidth,
					 leftIndex, numFit, &left_adj);
		
		if ((linewid + leftOffset + rightOffset) > tx->whole.formattedWidth) {
			tx->whole.formattedWidth = linewid + leftOffset + rightOffset;
		}
		
		/* update linetable
		 */
		if ((line_index + 2) > tx->whole.linetab_memsize) {
			itmp = line_index + LINE_TABLE_INC + 2;
			tx->whole.linetab = (linetab_ent *) retxloc(tx->pid,
				tx->whole.linetab, itmp * sizeof(linetab_ent));
			tx->whole.linetab_memsize = itmp;
		}
		tx->whole.linetab[line_index].line_height = tLineHeight;
		tx->whole.linetab[line_index].x_indent = left_x + left_adj;
		tx->whole.linetab[line_index].inkbottom = vlap;
		tx->whole.linetab[line_index].leftix = leftIndex;
		line_index++;
		tx->whole.numlines = line_index;

		leftIndex += numFit;
		
		/* (should try to detect convergence....)
		 */
		if (leftIndex >= tx->whole.nChars) {
			break;				/* ran out of characters. */
		}
		
		/* remember this line's right edge pos
		 */
		prev_right_x = left_x + left_adj + linewid;
		
		/* update indent, lineheight vals for upcoming line
		 */
		txAp = attrSegAtPosI(tx, leftIndex, &lpos, &segix);
		if (txAp->indent) {
			axtGetIndentLineValsI(tx, txAp,
								  leftIndex, &tLineHeight,
								  &rightOffset, &leftOffset);
			if (!tLineHeight) {
				tLineHeight = lineHeight;
			}
		}
		else {
			tLineHeight = lineHeight; /* use whole-field numbers */
			leftOffset = rightOffset = 0;
		}
		/* estimate max ink extent beyond formatting bounder using ~1/3 em.
		 */
		itmp = emToMils(300, txAp->fontAttr.ptsizeInt);
		if (itmp > tx->whole.bounderMargin) {
			tx->whole.bounderMargin = itmp;
		}

		if (tx->whole.zoomOn) {
			tLineHeight =
				(int)(tLineHeight * ((float) tx->whole.zoom / 1000.0));
		}
		if (tx->whole.zoomOn) {
			left_x = (int)(leftOffset * ((float) tx->whole.zoom / 1000.0));
		}
		else {
			left_x = leftOffset;
		}
		fitwidth = fieldwidth - rightOffset - leftOffset;
		
		/* assign offset value for next line's left-edge character
		 */
		tx->items[leftIndex]->offset.x = left_x - prev_right_x;
		tx->items[leftIndex]->offset.y = tLineHeight;
	}

	/* reset tx->whole.pos if text is center- or right-aligned
	 */
	if (CENTER_ALIGN == tx->whole.alignment) { 
		tx->whole.pos.x = tx->whole.fixedPos.x -
			(tx->whole.formattedWidth / 2);
		tx->items[0]->offset.x = tx->whole.linetab[0].x_indent;
	}
	else if (RIGHT_ALIGN == tx->whole.alignment) { 
		tx->whole.pos.x = tx->whole.fixedPos.x -
			tx->whole.formattedWidth;
		tx->items[0]->offset.x = tx->whole.linetab[0].x_indent;
	}
	return ((char *)NULL);
}

/* Lay out a line of text 
 * simple left justification, no tab ruler, no hyphenation,
 * hardcoded notion of whitespace characters..
 */
static int   /* return whether to advance to next intercept pair */
axtLineFormatterI(tx, leftIndex, fitwidth, numFit, linewid, vlap, writeformat)
atext *tx;
int leftIndex;
int fitwidth; /* max formatted width allowed */
int *numFit;  /* return #chars which could fit on this line */
int *linewid; /* return formatted width of this line */
int *vlap;    /* in/out; in: bottom of ink of last line;
				 out: bottom of ink of this line; used for
				 vertical-overlap detection */
int writeformat;  /* bool: whether to write *tx with format info */
{
	perCharI *pc;
	int ix, currx, z_currx;
	int inkbottom, tbot;
	int doAdvance = FALSE;
	int tnumfit = 0;

	if (!tx || !tx->items) {
		return FALSE;
	}
    
	if (leftIndex > (tx->whole.nChars - 1))
		return FALSE;
    
	pc = tx->items[leftIndex];
	if (writeformat) {
		pc->linebreak = leftIndex > 0;	/* 1st char this line */
		pc->hanging = FALSE;		    /* alignment could change this */
	}
    
	inkbottom = *vlap;
	currx = z_currx = 0;
    
	/* advance toward the right intercept
	 */
	for (ix = leftIndex; ix < tx->whole.nChars; ix++) {
		pc = tx->items[ix];
		if ( NEWCHAR((int) pc->charcode) ) {
			if (ix != leftIndex) {
				/* if the newline isn't the 1st char on
				   the line, then it doesn't fit */
				doAdvance = TRUE;
				break;
			}
		}
        
		if (!tx->editState.fullDisp) {
			/* check whether the current character's top
			 * juts above the last line's bottom ink
			 */
			if (writeformat && (pc->tbox.origin.y < *vlap)) {
				tx->editState.fullDisp |= FORMAT_OVERLAP; /* vert. overlap */
			}
		}
		tbot = pc->tbox.origin.y + pc->tbox.height - 1;
		if (tbot > inkbottom) {
			inkbottom = tbot;
		}
        
		/* check whether current character fits
		 */
		if ((currx + pc->fadvance + pc->fkern) > fitwidth) {
			doAdvance = TRUE;
			break;
		}
		tnumfit++;
		currx += pc->fadvance + pc->fkern;
		z_currx += pc->tadvance + pc->kern;
		if (writeformat && (ix > leftIndex)) {
			pc->offset.x = pc->offset.y = 0;
			pc->hanging = FALSE;
			pc->linebreak = FALSE;
		}
	}

	if (tnumfit && doAdvance) {
		tnumfit = axtWordBreakI(tx, leftIndex, tnumfit, TRUE, &z_currx);
	}
	
	if (!tnumfit) {
		tnumfit = 1;
	}

	*linewid = z_currx;
	*numFit = tnumfit;
	*vlap = inkbottom;
	return doAdvance;
}

/* : axtWordBreak - given a 'raw' formatted line,
 * adjust based on wordbreak */
static int /* return the adjusted numfit */
axtWordBreakI(tx, leftix, numfit, hyph, fmt_width)
atext *tx;
int leftix;  /* index of leftmost char on line */
int numfit;  /* raw format fit this many on the line */
int hyph;  /* bool: whether to do hyphenation or just whole word break */
int *fmt_width; /* in/out; in: formatted width, zoomed. out: adjusted */
{
	perCharI *pc;
	int twidth;
	int ix, tix;
	int numback = 0;
	
	ix = leftix + numfit - 1;	/* index of last char that fit */

	if ((ix >= tx->whole.nChars - 1) ||
		(BLACKCHAR(tx->items[ix]->charcode) &&
		 WHITECHAR(tx->items[ix + 1]->charcode))) {
		/* the last char that fit is also the end of a word */
		return numfit;
	}
    
	for (twidth = *fmt_width, tix = ix; tix > leftix; tix--, numback++) {
		pc = tx->items[tix];
		if (pc->charcode == SPACECHAR) {
			*fmt_width = twidth;
			numfit -= numback;
			break;
		}
		twidth -= (pc->tadvance + pc->kern);
	}
	return numfit;
}

/* : axtGetMaxWidthI - reFitI util which returns the maximum
 * formatting linewidth in an axtext instance.
 */
static int
axtGetMaxWidthI(tx, zmaxwidp)
atext *tx;                 /* in */
int *zmaxwidp;             /* out: return zoomed version, too */
{
	int lx, maxwid, twid, itmp, segix;
	int rightOffset, leftOffset, leftix;
	int zmaxwid;
	p32 tpt;
	perCharI *pc;
	txAttrI *txAp;
	
	if (!tx->whole.nChars) {
		return 0;
	}

	leftOffset = rightOffset = 0;
	if (tx->atts[0]->indent) {
		axtGetIndentLineValsI(tx, tx->atts[0],
							  0, &itmp, &rightOffset, &leftOffset);
	}
    
	/* get widest line width
	 */
	maxwid = leftOffset + rightOffset;
	for (lx = 0, twid = 0, leftix = 0; lx < tx->whole.nChars; lx++) {
		pc = tx->items[lx];
		if (NEWCHAR((int)pc->charcode)) {
			txAp = attrSegAtPosI(tx, lx, &itmp, &segix);
			if (txAp->indent) {
				axtGetIndentLineValsI(tx, txAp, lx, &itmp,
									  &rightOffset, &leftOffset);
			}
			twid += rightOffset + leftOffset;
			if (twid > maxwid) {
				maxwid = twid;
			}
			twid = 0;
			leftix = lx;
		}
		twid += pc->fadvance + pc->fkern;
	}
	twid += rightOffset + leftOffset;
	if (twid > maxwid) {
		maxwid = twid;
	}
	if (tx->whole.zoomOn) {
		zmaxwid = (int)(maxwid * ((float) tx->whole.zoom / 1000.0));
		*zmaxwidp = zmaxwid;
	}
	else {
		*zmaxwidp = maxwid;
	}
	return (maxwid);
}

/* : doAlignmentI - do text alignment on the tentatively
 * formatted line.
 */
static void
doAlignmentI(tx, linewid, fitwidth, leftIndex, numFit, left_adj)
atext *tx;
int linewid;       /* line's ink is this wide */
int fitwidth;      /* line has been formatted to fit in this width */
int leftIndex;     /* index of 1st char on line */
int numFit;        /* #chars that fit on the line */
int *left_adj;     /* out: return left-side adjustment */
{
	int lastix, talign, ix, hang;
	int width, adj;
    
	if (tx->whole.width) {
		hang = TRUE;
	}
	else {
		hang = FALSE;	/* don't hang whitespace for unconstrained case */
	}

	lastix = leftIndex + numFit - 1; /* index of last char that fit */

	if (tx->whole.alignment == JUSTIFIED_ALIGN) {
		if (lastix >= tx->whole.nChars - 1) {
			talign = LEFT_ALIGN; /* don't justify last line */
		}
		else if ((lastix < tx->whole.nChars - 2) &&
				 NEWCHAR((int)tx->items[lastix + 1]->charcode) &&
				 NEWCHAR((int)tx->items[lastix + 2]->charcode) ) {
			/* don't justify if the line precedes two consecutive
			 * newlines -- a 'paragraph break' of sorts.. cheezy
			 */
			talign = LEFT_ALIGN;
		}
		else {
			talign = tx->whole.alignment;
		}
	}
	else {
		talign = tx->whole.alignment;
	}

	width = linewid;

	switch(talign) {
        
	case LEFT_ALIGN:
		adj = 0;
		if (hang) {
			/* hang leading whitespace if not on the first line
			 */
			if (leftIndex != 0) {
				/* the line is other than the first */
				for (ix = leftIndex; ix <= lastix; ix++) {
					if (WHITESPACE(tx->items[ix]->charcode)) {
						tx->items[leftIndex]->offset.x -=
							tx->items[ix]->tadvance;
						adj -= tx->items[ix]->tadvance;
						tx->items[ix]->hanging = TRUE;
					}
					else
						break;
				}
			}
			/* mark trailing spaces as "hanging", just to suppress uline
			 */
			for (ix = lastix; ix >= leftIndex; ix--) {
				if (WHITESPACE(tx->items[ix]->charcode)) {
					tx->items[ix]->hanging = TRUE;
				}
			}
		}
		break;
        
	case CENTER_ALIGN:
		if (hang) {
			/* exclude both leading and trailing whitespace */
			/* leading */
			for (ix = leftIndex; ix <= lastix; ix++) {
				if (WHITESPACE(tx->items[ix]->charcode)) {
					tx->items[leftIndex]->offset.x -=
						tx->items[ix]->tadvance;
					tx->items[ix]->hanging = TRUE;
				}
				else
					break;
			}
			/* trailing */
			for (ix = lastix; ix >= leftIndex; ix--) {
				if (WHITESPACE(tx->items[ix]->charcode)) {
					width -= tx->items[ix]->tadvance;
					tx->items[ix]->hanging = TRUE;
				}
				else
					break;
			}
		}
		adj = (fitwidth - width) / 2;
		tx->items[leftIndex]->offset.x += adj;
		break;
        
	case RIGHT_ALIGN:
		if (hang) {
			/* hang trailing whitespace
			 */
			for (ix = lastix; ix >= leftIndex; ix--) {
				if (WHITESPACE(tx->items[ix]->charcode)) {
					width -= tx->items[ix]->tadvance;
					tx->items[ix]->hanging = TRUE;
				}
				else
					break;
			}
			/* mark leading spaces as "hanging", just to suppress uline
			 */
			for (ix = leftIndex; ix <= lastix; ix++) {
				if (WHITESPACE(tx->items[ix]->charcode)) {
					tx->items[ix]->hanging = TRUE;
				}
			}
		}
		adj = fitwidth - width;
		tx->items[leftIndex]->offset.x += adj;
		break;
        
	case JUSTIFIED_ALIGN:
		adj = 0;
		justifyLineI(tx, leftIndex, numFit, fitwidth);
		break;
	}

	*left_adj = adj;
}

static void
justifyLineI(txt, leftIndex, numFit, availWidth)
atext *txt;
int leftIndex, numFit;
int availWidth;
{
	int ix, lastix, spCount, spx, hang;
	int lscanx, rscanx, foundBlack;
	int adjust, bigAdjustCount, smallAdjustCount;
	int totSpWid, inSmall, totAdj;

	if (!txt || !numFit)
		return;
    
	if (txt->whole.width) {
		hang = TRUE;
	}
	else {
		hang = FALSE;			/* don't hang whitespace in unconstrained case */
	}
	
	/* (smallCount * adjust) + (bigCount * (adjust + 1)
	 * will account for the error
	 */
	
	/* first determine spacecount, total space width;
	 * exclude leading whitespace while doing so
	 */
	lastix = leftIndex + numFit - 1;
	totSpWid = spCount = 0;
	foundBlack = FALSE;
	for (ix = lscanx = leftIndex; ix <= lastix; ix++) {
		if (WHITESPACE(txt->items[ix]->charcode)) {
			if (foundBlack) {
				spCount++;
				totSpWid += txt->items[ix]->tadvance;
			}
			else {
				if (hang) {
					/* adjust offset to 'hang' the space
					 */
					txt->items[leftIndex]->offset.x -=
						txt->items[ix]->tadvance;
					if ((leftIndex + numFit) < txt->whole.nChars) {
						txt->items[leftIndex + numFit]->offset.x +=
							txt->items[ix]->tadvance;
					}
					txt->items[ix]->hanging = TRUE;
				}

				availWidth += txt->items[ix]->tadvance;
			}
		}
		else if (!foundBlack) {
			foundBlack = TRUE;
			lscanx = ix;		/* skip leading white */
		}
	}
    
	if (hang) {
		/* exclude trailing white, too
		 */
		for (ix = rscanx = lastix; ix > lscanx; ix--) {
			if (WHITESPACE(txt->items[ix]->charcode)) {
				spCount--;
				totSpWid -= txt->items[ix]->tadvance;
				availWidth += txt->items[ix]->tadvance;
				txt->items[ix]->hanging = TRUE;
			}
			else {
				rscanx = ix;
				break;
			}
		}
	}
	else {
		rscanx = lastix;
	}
	
	if (spCount) {
		/* set up adjustment size and counts */
		adjust = availWidth / spCount;
		totAdj = 0;
		bigAdjustCount = availWidth % spCount;
		smallAdjustCount = spCount - bigAdjustCount;
		inSmall = TRUE;
		spx = spCount;

		/* apply the adjustments */
		for (ix = lscanx; ix <= rscanx; ix++, spx-- ) {
			if (WHITESPACE(txt->items[ix]->charcode)) {

				if (inSmall) {
					if (smallAdjustCount == 0) {
						inSmall = FALSE;
						adjust++;
					}
					else {
						smallAdjustCount--;
					}
				}
				if (ix < rscanx) {
					/* make this char wider by increasing
					 * nextchar's xoffset
					 */
					txt->items[ix + 1]->offset.x += adjust;
					totAdj += adjust;
				}
			}
		}
		if ((leftIndex + numFit) < txt->whole.nChars) {
			txt->items[leftIndex + numFit]->offset.x -= totAdj;
		}
	}
}

static int
axtLineIndexFromCharIndexI(tx, char_index)
atext *tx;
int char_index;
{
	int ix, line_index;

	for (line_index = 0, ix = 0; ix < tx->whole.numlines; ix++) {
		if (char_index >= tx->whole.linetab[ix].leftix) {
			line_index++;
		}
		else {
			break;
		}
	}
	return (line_index ? line_index - 1 : line_index);
}

/* : axtEditPosI -- set index marking upstream-most effect of
 * an edit.  pos is passed as the position of an edit to *tx
 */
static int
axtEditPosI(tx, pos)
atext *tx;
int pos;
{
	int above = 0;
	int enough;
	perCharI *pc;
    
	if (!tx || !tx->items || !tx->whole.nChars)
		return 0;
    
	if (pos < 0)
		return 0;
    
	if (pos >= tx->whole.nChars)
		pos = tx->whole.nChars - 1;
    
	/* set pos backward, ideally to the upstream-most
	 * character on the line just above that containing 
	 * the passed pos; the desired pos is the nearest
	 * linestart which is upstream of any edit effects.
	 * for nonleft alignment, we need to go an extra line
	 * back.
	 */
	if (tx->whole.alignment == LEFT_ALIGN) {
		enough = 1;
		pc = tx->items[pos];
		while(pos > 0) {
			if (pc->offset.y) {
				if (above == enough)
					return pos;
				else
					above++;
			}
			pos--;
			pc = tx->items[pos];
		}
	}
	else {
		pos = 0;			/* edits on nonleft align affect all chars */
	}

	if (tx->old) {
		/* an edit has already been done since last display;
		 * use the currently passed pos only if upstream
		 */
		if (pos > tx->editState.editPos)
			pos = tx->editState.editPos;
	}
	return pos;
}

/* : getOldIndexI - given index on current copy,
 * return corresponding index on the old copy
 */
static int /* either the corr. index or -1 (i.e., 'no correspondent') */
getOldIndexI(currtxt, oldtxt, currix)
atext *currtxt;
atext *oldtxt;
int currix;
{
	/* find the 'corresponding index' (corrx) on currtxt, then return
	 * the real index of old's member which has the same corrx..
	 */
	int ix, corrx, ocorrx;
	if (!oldtxt || currtxt->items[currix]->inserted ||
		currix < currtxt->editState.editPos) {
		return -1;
	}
	for (ix = currtxt->editState.editPos, corrx = -1; ix <= currix; ix++) {
		if (!currtxt->items[ix]->inserted) {
			corrx++;
		}
	}
	/* now find the index on oldtxt with the same corresponding index
	 */
	for (ix = 0, ocorrx = -1; ix < oldtxt->whole.nChars; ix++) {
		if (!oldtxt->items[ix]->deleted) {
			ocorrx++;
			if (ocorrx >= corrx) {
				return ix;
			}
		}
	}
	return oldtxt->whole.nChars - 1;
}

static int /* either the corr. index or -1 (i.e., 'no correspondent') */
getNewIndexI(currtxt, oldtxt, oldix)
atext *currtxt;
atext *oldtxt;
int oldix;
{
	/* find the 'corresponding index' (ocorrx) on oldtxt, then return
	 * the real index of new's member which has the same ocorrx..
	 */
	int ix, corrx, ocorrx;
	if (!oldtxt || !currtxt || oldtxt->items[oldix]->deleted) {
		return -1;
	}
	for (ix = 0, ocorrx = -1; ix <= oldix; ix++) {
		if (!oldtxt->items[ix]->deleted) {
			ocorrx++;
		}
	}
	/* now find the index on currtxt with the same corresponding index */
	for (ix = currtxt->editState.editPos, corrx = -1;
		 ix < currtxt->whole.nChars; ix++) {
		if (!currtxt->items[ix]->inserted) {
			corrx++;
			if (corrx >= ocorrx) {
				return ix;
			}
		}
	}
	return currtxt->whole.nChars - 1;
}


/* : liftOldI - compare current and last-displayed states of the
 * passed text instance, and lift anything non-current.  This is
 * done in preparation for display, called from dispTx
 */
static void
liftOldI(w, txt)
long w;                /* in */
atext *txt;            /* in */
{
    
	int pieceIx, inLiftage, liftlen, lift, liftPrev;
	int oldix, currix, currscan, corrx, ocorrx, lastcurrix;
	int charcount, charix, lx, hasCorrespondent, prevSup;
	int segix, itmp;
	char *errString;
	p32 oldpoint, currentpoint, piecePos, rulept;
	perCharI *oldpc;
	txAttrI *txAp, *pieceAp;
    
	/* we scan the old copy marking and lifing those characters that
	 * need it.  oldix and oldpoint refer to the current char on the
	 * old copy during scan.
	 */

	if (!txt || !txt->old )
		return;

	if (!txt->old->whole.nChars) {
		/* test whether to lift the 0th bullet if present
		 */
		if (txt->old->atts && txt->old->atts[0]->indent &&
			txt->old->atts[0]->indent->bullet && 
			txt->old->atts[0]->indent->bullet->type) {
			
			p32 oldpt, newpt;
			int liftb = FALSE;
			
			if (!txt->atts[0]->indent->bullet ||
				!txt->atts[0]->indent->bullet->type) {
				
				liftb = TRUE;	/* bullet gone on current */
			}
			else if (txt->atts[0]->indent->bullet->changed) {
				liftb = TRUE;	/* modified on current */
			}
			else {
				/* compare old & new positions determining bullet pos.
				 * 0th bullet pos derives from whole.pos.x, 0th charpos.y
				 */
				oldpt = txt->old->whole.pos;
				newpt = txt->whole.pos;
				if (txt->items) {
					newpt.y += txt->items[0]->offset.y;
				}
				if ((newpt.x != oldpt.x) || (newpt.y != oldpt.y)) {
					liftb = TRUE;
				}
			}
			if (liftb) {
				liftBulletI(txt->old, w, txt->old->atts[0], axLiftGC,
							&txt->old->whole.pos);
			}
		}
		return;
	}

	if (!txt->old->displayable && txt->old->whole.nChars) {
		/* possibly need screenfont dimensions to do lifting
		 */
		if(errString = axtDisplayableTextI(txt->old)) {
			freeErrString(errString);
			return;
		}
	}
	setLiftColorI(txt, axLiftGC);
	
	/* init oldpoint, currentpoint.  These scan the
	 * old-copy and new-copy set positions, respectively
	 */
	oldpoint = txt->old->whole.pos;
	if (txt->editState.editPos) {
		currentpoint = oldpoint;
		if (txt->items) {
			currentpoint.x += txt->old->items[0]->offset.x +
				txt->old->items[0]->kern;
			currentpoint.y += txt->old->items[0]->offset.y;
		}
	}
	else {
		currentpoint = txt->whole.pos;
		if (txt->items) {
			currentpoint.x += txt->items[0]->offset.x + txt->items[0]->kern;
			currentpoint.y += txt->items[0]->offset.y;
		}
	}

	if (!txt->old->items) {
		return;
	}
	
	/* init vars describing the start of the current to-be-lifted
	 * run of chars.  If "on", then the previous char (at least) is
	 * to-be-lifted.  Init value is "off" (pieceIx == -1)
	 */
	piecePos.x = piecePos.y = 0;
	rulept.x = rulept.y = 0;
	pieceIx = -1;
	inLiftage = FALSE;
	liftlen = 0;
    
	lift = FALSE;	  /* bool "lift" says whether this char is to be lifted */
	liftPrev = FALSE; /* whether previous char was lifted */
	prevSup = 0;	  /* prev char's sub/sup offset */

	/* currix, currscan, corrx, ocorrix, along with currentpoint, support
	 * peeking at the current text instance to test whether this char
	 * should be lifted.
	 */
	currix = currscan = txt->editState.editPos;
	corrx = ocorrx = -1;
    
	lastcurrix = txt->editState.editPos - 1; /* used for damage-repair */
    
	/* scan
	 */

	txAp = pieceAp = txt->old->atts[0];
	charcount = txt->old->whole.nChars;
	charix = segix = 0;
    
	while (charcount > 0) {
        
		/* per-attr-seg inits
		 */
		lx = charix + txAp->nChars;

		/* need screen metrics to get lift dimensions
		 */
		if (!txAp->screenFontName) {
			return;
		}
		if (errString = axGetScreenMetrics(txAp->screenFontName,
										   txAp->fconx.font,
										   &txAp->fconx.screen)) {
			freeErrString(errString);
			return;
		}
        
		for (oldix = charix; oldix < lx; oldix++) {
            
			oldpc = txt->old->items[oldix];

			oldpoint.x += txt->old->items[oldix]->kern;
			oldpoint.x += txt->old->items[oldix]->offset.x;
			oldpoint.y += txt->old->items[oldix]->offset.y;
            
			/* determine whether current char is to be lifted.
			 */
			if (!oldpc->deleted) {
				ocorrx++;
				hasCorrespondent = TRUE;
			}
			else
				hasCorrespondent = FALSE;

			if (hasCorrespondent) {
				perCharI *pc, *tpc;
                
				/* get currix and currentpoint in sync for comparison
				 */
				for ( ; currscan < txt->whole.nChars - 1; currscan++) {
					if (!txt->items[currscan]->inserted)
						corrx++;
					if (corrx >= ocorrx) {
						break;
					}
				}
				for ( ; currix < currscan; currix++) {
					pc = txt->items[currix];
					currentpoint.x += pc->tadvance;
					if (currix < txt->whole.nChars - 1) {
						tpc = txt->items[currix+1];
						currentpoint.x += tpc->offset.x + tpc->kern;
						currentpoint.y += tpc->offset.y;
					}
				}
    
				if (txt->items[currix]->moved) {
					lift = TRUE;
				}
				else {
					int hasMoved;
					p32 tpt, otpt;
                        
					tpt.x = currentpoint.x;
					tpt.y = currentpoint.y + txt->items[currix]->sup;
					otpt.x = oldpoint.x;
					otpt.y = oldpoint.y + oldpc->sup;
					lift = needLiftI(oldpc, txt->items[currix],
									 &otpt, &tpt, &hasMoved);
					if (hasMoved) {
						/* this character on the old copy has a
						 * correspondent on the current copy that has moved
						 */
						if (currix >= 0 && currix < txt->whole.nChars) {
							txt->items[currix]->moved = TRUE;
						}
					}
				}
			}
			else {
				/* no current correspondent; lift unless hidden
				 */
				lift = !oldpc->hidden;
			}
            
			if (txt->items) {
				if (oldix && lift && !liftPrev) {
					/* the previous character on the old copy has
					 * a correspondent on the current copy which
					 * may get lift-damaged; mark it
					 */
					if (lastcurrix >= 0 && lastcurrix < txt->whole.nChars)
						txt->items[lastcurrix]->damaged = TRUE;
				}
				if (oldix && !lift && liftPrev) {
					/* like above only left-edge damage to the current
					 * rather than right-edge damage to the prev
					 */
					if (currix >= 0 && currix < txt->whole.nChars) {
						txt->items[currix]->damaged = TRUE;
					}
				}
			}
			lastcurrix = currix;
			if (hasCorrespondent)
				currscan++;
            
			if (txAp->indent &&
				axtHasBulletI(txt->old, txAp, oldpc,
							  txt->editState.editPos + oldix)) {
                
				/* determine whether at this text position
				 * there's a bullet which needs to be lifted
				 */
				int liftb = FALSE;
				int lpos;
                
				if (!hasCorrespondent) {
					/* lift the bullet if the current-txt char
					 * associated with it is gone; but not for
					 * deletion of last (non-tab) character.
					 */
					if (txt->whole.nChars > 0) {
						liftb = TRUE;
					}
					else if (txt->old->items[0]->charcode == TABCHAR) {
						/* last char was deleted, but was a tab; this
						 * probably affected the position of any bullet
						 */
						liftb = TRUE;
					}
				}
				else if (txt->items[currix]->moved) {
					liftb = TRUE; /* correspondent has moved */
				}
				else {
					txAttrI *newTxAp;
					newTxAp = attrSegAtPosI(txt, currix, &lpos, &itmp);
					if (!axtHasBulletI(txt, newTxAp,
									   txt->items[currix], currix)) {
                        
						/* correspondent's att-seg no longer has bullet
						 */
						liftb = TRUE;
					}
					else if (newTxAp->indent && 
							 newTxAp->indent->bullet &&
							 newTxAp->indent->bullet->changed) {
                        
						liftb = TRUE; /* has bullet, but changed */
					}
				}
				if (liftb) {
					liftBulletI(txt->old, w, txAp, axLiftGC, &oldpoint);
				}
			}

			/* call lifter as needed, based on these types of transitions:
			 * 1) whether current character is 1st in its attribute-segment,
			 * 2) whether current character has an position offset requiring a
			 * separate lift call, and 3) whether current char is the 1st of a
			 * to-be-lifted or not-to-be-lifted run of characters.
			 */
			if ((oldix == charix) || axtHasOffsetI(oldpc, &prevSup)) {
				if (inLiftage && liftlen && (pieceIx >= 0)) {
					liftTextI(txt->old, w, axLiftGC, pieceAp, pieceIx,
							  liftlen, piecePos.x, piecePos.y);
					if ( pieceAp->ruling || pieceAp->strike_thru ) {
						drawRulingI(txt->old, w, pieceAp, pieceIx, liftlen,
									&piecePos, &rulept, TRUE);
					}
				}
				inLiftage = FALSE;
				liftlen = 0;
                
				/* piecePos, rulept, pieceIx should be off
				 */
				piecePos.x = piecePos.y = 0;
				rulept.x = rulept.y = 0;
				pieceIx = -1;
			}
			prevSup = oldpc->sup;
			if (lift) {
				if (inLiftage) {
					liftlen++;
				}
				else {
					/* init piecePos, pieceIx, rulepoint, describing this char
					 * as the start of a new to-be-lifted run
					 */
					liftlen = 1;
					pieceIx = oldix;
					piecePos.x = oldpoint.x;
					piecePos.y = oldpoint.y + oldpc->sup;
					pieceAp = txAp;
					rulept = piecePos;
					inLiftage = TRUE;
				}
			}
			else {
				if (inLiftage) {
					inLiftage = FALSE;
					if (liftlen && (pieceIx >= 0)) {
						liftTextI(txt->old, w, axLiftGC, pieceAp, pieceIx,
								  liftlen, piecePos.x, piecePos.y);
						if ( pieceAp->ruling || pieceAp->strike_thru ) {
							drawRulingI(txt->old, w, pieceAp, pieceIx, liftlen,
										&piecePos, &rulept, TRUE);
						}
					}
					/* turn off piecePos, rulept, pieceIx
					 */
					piecePos.x = piecePos.y = 0;
					rulept.x = rulept.y = 0;
					pieceIx = -1;
				}
			}
            
			oldpoint.x += oldpc->tadvance;
		}
        
		charcount -= txAp->nChars;
		charix += txAp->nChars;
		if (charcount > 0) {
			segix++;
			txAp = txt->old->atts[segix];
		}
	}

	if (inLiftage) {
		if (liftlen && (pieceIx >= 0)) {
			liftTextI(txt->old, w, axLiftGC, pieceAp, pieceIx, liftlen,
					  piecePos.x, piecePos.y);
			if ( pieceAp->ruling || pieceAp->strike_thru ) {
				drawRulingI(txt->old, w, pieceAp, pieceIx, liftlen,
							&piecePos, &rulept, TRUE);
			}
		}
	}
}       

static void
liftBulletI(tx, widget_handle, txAp, gc, pos)
atext *tx;              /* in */
long widget_handle;     /* in: get drawable from this */
txAttrI *txAp;          /* in: att-seg this bullet falls under */
GC gc;
p32 *pos;               /* in: setpos of char associated with bullet */
{
	r32 brect;
	int x_off, y_off;
	Drawable drw;

	drw = AxGetDrawableFromWidget((AXWidget)widget_handle, &x_off, &y_off);
	axtBulletRectI(tx, txAp, pos, &brect);
	if (brect.width && brect.height) {
		XFillRectangle(Dpy, drw, gc, milsToPix(brect.origin.x, ScreenRes),
					   milsToPix(brect.origin.y, ScreenRes),
					   milsToPix(brect.width, ScreenRes),
					   milsToPix(brect.height, ScreenRes));
	}
}

static int
needLiftI(oldpc, newpc, oldpos, newpos, hasMoved)
perCharI *oldpc, *newpc;
p32 *oldpos, *newpos;
int *hasMoved; /* return; true == still there, but has moved */
{
	*hasMoved = FALSE;
    
	if (!oldpc->deleted) {
		*hasMoved = (oldpos->x != newpos->x) || (oldpos->y != newpos->y);
	}
	if (CHAR_IS_DIMENSIONLESS(oldpc->charcode)) {
		return FALSE;			/* don't lift what was never drawn */
	}
	if (oldpc->hidden) {
		return FALSE;			/* don't lift if it was invisible */
	}
	else if (oldpc->deleted) {
		return TRUE;			/* gone now */
	}
	else if (newpc->changed) {
		return TRUE;			/* looks different. */
	}
	else if (!(*hasMoved)) {
		return FALSE;			/* still there, looks the same, and hasn't moved */
	}
	*hasMoved = TRUE;
	return TRUE;				/* do the lift */
}

static void
liftTextI(txt, w, gc, txAp, startix, in_len, x, y)
atext *txt;
long w;
GC gc;
txAttrI *txAp;
int startix;
int in_len;
int x, y; /* mils */
{
	int ix, tx, ty, pcix, len;
	int minx, miny, maxx, maxy;
	unsigned int wid, ht;
	p32 currentpoint;
	perCharI *pc;
	Drawable drw;
    
	len = in_len;
	pcix = startix;
	axtTrimTextI(txt, &pcix, &len);

	if (!len)
		return;
    
	pc = txt->items[pcix];

	/* get the drawable */
	drw = AxGetDrawableFromWidget((AXWidget)w, &minx, &miny);
    
	for (ix = 0, currentpoint.x = x, currentpoint.y = y; ix < len; ix++) {
        
		/* use screenfont dimensions as much as possible
		 */
		tx = milsToPix(currentpoint.x, ScreenRes);
		ty = milsToPix(currentpoint.y, ScreenRes);
		tx += pc->sbox.origin.x;
		ty += pc->sbox.origin.y;
		wid = pc->sbox.width;
		ht = pc->sbox.height;
		/* this extra xpos adjustment parallels adjustment in qDrawTextI.
		 */
		tx -= pc->sbox.origin.x - milsToPix(pc->tbox.origin.x, ScreenRes);

		if ( txAp->ruling || txAp->strike_thru ) {
			int ttx, tty, twid, tht;
            
			ttx = axtPixToMils(tx, ScreenRes);
			tty = axtPixToMils(ty, ScreenRes);
			twid = axtPixToMils(wid, ScreenRes);
			tht = axtPixToMils(ht, ScreenRes);
			adjustRectForRulingI(txAp, pc, &ttx, &tty, &twid, &tht);
			tx = milsToPix(ttx, ScreenRes);
			ty = milsToPix(tty, ScreenRes);
			wid = milsToPix(twid, ScreenRes);
			ht = milsToPix(tht, ScreenRes);
		}

		if (!ix) {
			minx = tx;
			miny = ty;
			maxx = tx + wid;
			maxy = ty + ht;
		}
		else {
			if (tx < minx)
				minx = tx;
			if (ty < miny)
				miny = ty;
			if (tx + (int) wid > maxx)
				maxx = tx + wid;
			if (ty + (int) ht > maxy)
				maxy = ty + ht;
		}

		currentpoint.x += pc->tadvance;

		pcix++;
		
		if (pcix < txt->whole.nChars) {
			pc = txt->items[pcix];
			currentpoint.x += pc->offset.x + pc->kern;
		}
	}
    
	/* fudge the edges outward a bit;  this is because
	 * the qDrawTextI function per-char positions text chars
	 * to the screen, and since the lift pattern doesn't match
	 * the set pattern in general, we can't exactly predict the
	 * placement of the right/left edges of the lift range..
	 */
	maxx++;
	minx--;
	maxy++;
	miny--;

	if (txt->editState.background) {
		/* use the background pixmap to lift
		 */
		XCopyArea(Dpy, txt->editState.background, drw, gc,
				  minx - txt->editState.backRect.origin.x,
				  miny - txt->editState.backRect.origin.y,
				  maxx - minx, maxy - miny, minx, miny);
	}
	else {
		/* lift by filling with background color
		 */
		XFillRectangle(Dpy, drw, axLiftGC, minx, miny,
					   maxx - minx, maxy - miny);
	}
}

static void
setLiftColorI(txt, gc)
atext *txt;
GC gc;
{
	if (txt->editState.backgroundPixel) {
		XSetForeground(Dpy, gc, txt->editState.backgroundPixel);
	}
	else {
		/* the work area background color */
		XSetForeground(Dpy, gc, AlisPixels[WHITE]);
	}
}

static int
adjustRectForRulingI(txAp, pc, tx, ty, wid, ht)
txAttrI *txAp;  /* attr seg current char is in */
perCharI *pc;   /* perChar struct for current char */
int *tx, *ty, *wid, *ht; /* out: mils; may be adjusted */
{
	int strikey, undery, tmp, lwid, lht;
	int xadvance;
	r32 lrect, refrect;
	b32 lbox, tbb;
	p32 tp;

    if (txAp->ruling == FALSE && txAp->strike_thru == FALSE )
        return FALSE;

	/* init undery, position of bottom edge of underline,
	 * with 1/2 strokewidth extra. in milliems
	 */
	undery = txAp->fontAttr.underlinePosition +
		txAp->fontAttr.underlineThickness;
	if (txAp->ruling & AXRULING_DOUBLE)
		undery += 3 * txAp->fontAttr.underlineThickness;

	/* init strikey, position of top edge of strikethru,
	 * with 1/2 strokewidth extra, in mills
	 */
	tmp = emToMils(txAp->fontAttr.underlineThickness,
				   txAp->fontAttr.ptsizeInt);
	strikey = strikeThruOffsetI(txAp) - tmp;

	/* get a copy of the unadjusted bounder to use as
	 * a reference; this copy is pc->bbox's bounder plus
	 * whatever sub/sup offset may be present
	 */
	refrect.origin.x = pc->tbox.origin.x;
	refrect.origin.y = pc->tbox.origin.y + pc->sup;
	refrect.width = pc->tbox.width;
	refrect.height = pc->tbox.height;
	lrect = refrect;
	xadvance = pc->tadvance;

	/* do the adjustments to lrect
	 */
	if (txAp->strike_thru ) {
		if ((tmp = lrect.origin.y - strikey) > 0) {
			/* bounder top is below strikey; pull up */
			lrect.origin.y -= tmp + 1;
			lrect.height += tmp + 1;
		}
	}
	if (txAp->ruling & AXRULING_SINGLE ||
		txAp->ruling & AXRULING_DOUBLE) {
		undery = emToMils(undery, txAp->fontAttr.ptsizeInt);
		if ((tmp = undery - (lrect.origin.y + lrect.height)) > 0) {
			/* bounder bot is below strikey; pull down */
			lrect.height += tmp + 1;
		}
	}
	if ((tmp = xadvance - (lrect.origin.x + lrect.width)) > 0) {
		/* make sure right edge of rect contains the advance */
		lrect.width += tmp;
	}
	if (lrect.origin.x > 0) {
		/* make sure left edge of rect contains set position */
		tmp = lrect.origin.x;
		lrect.origin.x = 0;
		lrect.width += tmp;
	}

	/* return lrect as the adjusted bounder
	 */
	*tx += lrect.origin.x - refrect.origin.x;
	*ty += lrect.origin.y - refrect.origin.y;
	*wid += lrect.width - refrect.width;
	*ht += lrect.height - refrect.height;

	return TRUE;
}

void
axtHiliteTextI(w, tx, startix, len)
long w;
atext *tx;
int startix, len;
{
	int ix, pcix, x_off, y_off;
	int ox, oy, cx, cy, itmp;
	int slinex, elinex;
	Drawable drw;
	p32 linepos;

	drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);

	if (!tx->measured) {
		char *err;
		if (err = axtMeasuredTextI(tx)) {
			freeErrString(err);
		}
	}
	slinex = axtLineIndexFromCharIndexI(tx, startix);
	elinex = axtLineIndexFromCharIndexI(tx, startix + len - 1);

	linepos = tx->whole.pos;
	linepos.y -= tx->whole.linetab[0].line_height;
	for (ix = 0; ix < slinex; ix++) {
		linepos.y += tx->whole.linetab[ix].line_height;
	}

	for (ix = slinex; ix <= elinex; ix++) {
		/* get hilite dimensions for this line
		 */
		linepos.y += tx->whole.linetab[ix].line_height;
		ox = linepos.x + tx->whole.linetab[ix].x_indent;     /* origin x */
		oy = linepos.y - tx->whole.linetab[ix].line_height;  /* origin y */
		cx = ox;                                             /* corner x */
		cy = oy + tx->whole.linetab[ix].line_height +        /* corner y */
			tx->whole.linetab[ix].inkbottom;
		if (ix > 0) {
			oy += tx->whole.linetab[ix - 1].inkbottom;
		}
		for (pcix = tx->whole.linetab[ix].leftix;
			 (pcix < tx->whole.nChars); pcix++) {

			itmp = tx->items[pcix]->tadvance + tx->items[pcix]->kern;
			if ((pcix >= startix) && (pcix < startix + len)) {
				cx += itmp;
			}
			else if (pcix < startix) {
				ox += itmp;
				cx += itmp;
			}
			else
				break;
			
			if ((pcix > tx->whole.linetab[ix].leftix) &&
				tx->items[pcix]->linebreak) {
				
				break;
			}
		}

		if ((cx > ox) && (cy > oy)) {
			/* hilite this line
			 */
			XFillRectangle(Dpy, drw, axTextCursorGC,
						   milsToPix(ox, ScreenRes),
						   milsToPix(oy, ScreenRes),
						   milsToPix(cx, ScreenRes) -
						   milsToPix(ox, ScreenRes),
						   milsToPix(cy, ScreenRes) -
						   milsToPix(oy, ScreenRes));
		}
	}
}

/* per-char-position: set screenfont glyphs on screen
 * using target widths to determine screen placement.
 * The positions of each screen char should match
 * the spot that the target char would hit if it were
 * scaled onto the screen device.
 * Note that in order to work correctly, this call must
 * be given a text range which has a common, horizontal
 * baseline.  (y-component of character advance is ignored).
 */
static int
qDrawTextI(dpy, w, gc, txt, txAp, start_index, numChars, pt)
Display *dpy;
long w;
GC gc;
atext *txt;
txAttrI *txAp;
int start_index;
int numChars;  /* # perCharI structs */
p32 *pt;
{
	int tx, ty, charix;
	int ix, delta, startix, nChars, x_off, y_off;
	p32 currentpoint, screenpoint;
	unsigned long fgCol, bgCol, planeMask;
	Drawable drw;
#if BUILD_WIDE
	wchar *txstr;
#else
	mbchar *txstr;
#endif
	perCharI *pc;
    
	tx = pt->x;
	ty = pt->y;
	nChars = numChars;
	startix = start_index;
	axtTrimTextI(txt, &startix, &nChars);
    
	if (nChars == 0)
		return;

	/* take a string copy to get from tx_char to mb/wchar types
	 */
#if BUILD_WIDE
	txstr = (wchar *) txloc(txt->pid, nChars * sizeof(wchar));
	for (ix = 0; ix < nChars; ix++) {
		txstr[ix] = (wchar) txt->items[ix + startix]->charcode;
	}
#else
	txstr = (mbchar *) txloc(txt->pid, nChars * sizeof(mbchar));
	for (ix = 0; ix < nChars; ix++) {
		txstr[ix] = (mbchar) txt->items[ix + startix]->charcode;
	}
#endif
    
	/* get the drawable, set font and pixel values
	 */
	drw = AxGetDrawableFromWidget((AXWidget)w, &x_off, &y_off);
	axSetFont(Dpy, gc, txAp->fconx.screen->xfont);
	axtSetFgBgI(dpy, txAp, &fgCol, &bgCol, &planeMask);
    
	currentpoint.x = tx;
	currentpoint.y = ty;

	screenpoint.x = milsToPix(tx, ScreenRes);
	screenpoint.y = milsToPix(ty, ScreenRes);
    
	if ( IS_SOLID_FILL(txt->gContext, txAp->fillpattern) == FALSE ) {
		/* draw patterned style, one character at a time
		 */
		int wid, hyt, xoff, yoff;
		Pixmap map;

		for (ix = 0, charix = startix; ix < nChars; ix++, charix++) {
			pc = txt->items[charix];
			/* create a pixmap
			 */
			wid = pc->sbox.width;
			hyt = pc->sbox.height;
			map = XCreatePixmap(dpy, drw, wid, hyt, 1);
			XFillRectangle(dpy, map, PixClearGC, 0, 0, wid, hyt);
            
			/* draw the character onto the pixmap
			 */
			xoff = -pc->sbox.origin.x;
			yoff = -pc->sbox.origin.y;
			XSetForeground(dpy, PixGC, 1);
			axSetFont(dpy, PixGC, txAp->fconx.screen->xfont);
#if BUILD_WIDE
			axWDrawString(dpy, map, PixGC, txAp->fconx.screen->xfont,
						  xoff, yoff, &txstr[ix], 1);
#else
			axDrawString(dpy, map, PixGC, txAp->fconx.screen->xfont,
						 xoff, yoff, &txstr[ix], 1);
#endif
			/* Do the masked draw.  Note the additional xpos adjust for
			 * the difference between screen and target left sidebearings.
			 */
			xoff += pc->sbox.origin.x -
				milsToPix(pc->tbox.origin.x, ScreenRes);
			axtDrawTextI(txt, drw,
						milsToPix(currentpoint.x, ScreenRes) -
						xoff,
						milsToPix(currentpoint.y + pc->sup, ScreenRes) -
						yoff,
						hyt, wid, map, txAp->fillpattern, txAp->useFgPixel);
			XFreePixmap(Dpy, map);
			currentpoint.x += pc->tadvance;
		}
	}
	else {
		/* draw directly, in segments as large as possible. A new segment
		 * starts each time a delta is needed to match target & screen pos.
		 */
		int lastscreenx, seglen, lastix, ttx;
        
		XSetState(dpy, gc, fgCol, bgCol, GXcopy, AllPlanes);
		lastscreenx = screenpoint.x;
		lastix = 0;
		for (ix = 0, seglen = 0, charix = startix; ix < nChars;
			 ix++, seglen++, charix++) {
			
			pc = txt->items[charix];
            
			/* Test for screen-target delta. Note the additional xpos adjust
			 * for the difference between screen and target left sidebearings.
			 */
			ttx = milsToPix(currentpoint.x + pc->tbox.origin.x, ScreenRes);
			delta = ttx - (screenpoint.x + pc->sbox.origin.x);
			if (delta) {
				if (seglen) {
#if BUILD_WIDE
					axWDrawString(dpy, drw, gc, txAp->fconx.screen->xfont,
								  lastscreenx, screenpoint.y,
								  &txstr[lastix], seglen);
#else
					axDrawString(dpy, drw, gc, txAp->fconx.screen->xfont,
								 lastscreenx, screenpoint.y,
								 &txstr[lastix], seglen);
#endif
				}
				seglen = 0;
				lastix = ix;
				lastscreenx = screenpoint.x + delta;
			}
			currentpoint.x += pc->tadvance;
			screenpoint.x += pc->sadvance + delta;
		}
		if (seglen) {
#if BUILD_WIDE
			axWDrawString(dpy, drw, gc, txAp->fconx.screen->xfont,
						  lastscreenx, screenpoint.y,
						  &txstr[lastix], seglen);
#else
			axDrawString(dpy, drw, gc, txAp->fconx.screen->xfont,
						 lastscreenx, screenpoint.y,
						 &txstr[lastix], seglen);
#endif
		}
	}
	txfree(txstr);
}

static void
axtSetFgBgI(dpy, txAp, fgCol, bgCol, planeMask)
Display *dpy;
txAttrI *txAp;
unsigned long *fgCol, *bgCol, *planeMask;          /* out */
{

	/* lookup pixels; type 2 is CMYK, max value
	 * assumed on txAp is 255
	 */
	if (txAp->useFgPixel) {
		/* foreground pixel value stored directly on *txAp
		 */
		*fgCol = txAp->fgPixel;
	}
	else if (isBlackCMYK(txAp->fillcolor) &&
			 useForegroundColorForBlack(txAp->fillpattern)) {
        
		/* display black as the work area foreground color
		 */
		*fgCol = (unsigned long) AlisPixels[BLACK];
	}
	else {
		AxGetRealPixel(2, axCyanComponent(txAp->fillcolor),
					   axMagentaComponent(txAp->fillcolor),
					   axYellowComponent(txAp->fillcolor),
					   axBlackComponent(txAp->fillcolor),
					   255, fgCol);
	}
    
	AxGetRealPixel(2, axCyanComponent(txAp->fillbcolor),
				   axMagentaComponent(txAp->fillbcolor),
				   axYellowComponent(txAp->fillbcolor),
				   axBlackComponent(txAp->fillbcolor),
				   255, bgCol);
	*planeMask = AllPlanes;
}

#if AX_X11   /*  {  */

/* : getClosestRasterNameI - when stuck doing raster-scaling,
 * determine which size is best to work with.
 * Beware unprotected access of cache objects fconx.target,
 * fconx.screen, fconx.font -- but, called only from
 * axtDisplayableTextI where those objects are looked up first.
 */
static char *    /* do not free returned xlfd fontname */
getClosestRasterNameI(ftab, txAp, minError)
fontTabEnt *ftab;
txAttrI *txAp;
int *minError;         /* return this */
{
	return( axtGetClosestRasterName(ftab, txAp->fontAttr.ptsize,
									(float) 1.0, minError) );
}

#endif   /*  }  AX_X11 */

static void
updateScreenCharsI(txAp, items, firstix, lastix)
txAttrI *txAp;
perCharI **items;
int firstix, lastix; /* both inside txAp's character range */
{
	perCharI *pc;
	int tcharix;
    
	/* collect screen metrics for each char of this attr seg
	 */
	for(tcharix=firstix ;tcharix <= lastix; tcharix++) {
		pc = items[tcharix];
		if (!pc->screenMetrics) {
			if (!(CHAR_IS_DIMENSIONLESS((int) pc->charcode))) {
				pc->sadvance = WCharWid(pc->charcode,
										txAp->fconx.screen->xfont,
										&pc->sbox);
			}
			pc->screenMetrics = TRUE;
		}
	}
}

/* get the target metrics for a character, along with
 * transformed metrics derived from the target numbers */
static void
updateTargetCharI(tx, txAp, pc)
atext *tx;
txAttrI *txAp;
perCharI *pc;
{
	if (CHAR_IS_DIMENSIONLESS((int) pc->charcode)) {
		memset((void *) &pc->tbox, 0, sizeof(r32));
		pc->tadvance = 0;
		pc->tbox.width = pc->tbox.height =
			pc->tbox.origin.x = pc->tbox.origin.y = 0;
		return;
	}
	else {
		pc->tadvance = WCharWid(pc->charcode, txAp->fconx.target->xfont,
								&pc->tbox);
	}
	pc->fadvance = pc->tadvance;
	
	/* go from milliems to mills
	 */
	pc->tbox.origin.x = emToMils(pc->tbox.origin.x, txAp->fontAttr.ptsizeInt);
	pc->tbox.origin.y = emToMils(pc->tbox.origin.y, txAp->fontAttr.ptsizeInt);
	pc->tbox.width = emToMils(pc->tbox.width, txAp->fontAttr.ptsizeInt);
	pc->tbox.height = emToMils(pc->tbox.height, txAp->fontAttr.ptsizeInt);
	pc->tadvance = emToMils(pc->tadvance, txAp->fontAttr.ptsizeInt);
	pc->fadvance = emToMils(pc->fadvance, txAp->fontAttr.unzoomed_ptsize);

	/* apply any kern and sup
	 */
	pc->sup = txAp->supy;
	pc->kern = txAp->kern;
	pc->fkern = pc->kern;
	if (tx->whole.zoomOn) {
		if (pc->kern)
			pc->kern = (int)(pc->kern * ((float) tx->whole.zoom / 1000.0));
		if (pc->sup)
			pc->sup = (int)(pc->sup * ((float) tx->whole.zoom / 1000.0));
	}
}

/* : attrSegAtPosI - returns a pointer to the txAttr instance
 * that applies to the textchar at position pos */
static txAttrI *
attrSegAtPosI(txt, pos, lpos, osegix)
atext *txt;
int pos;
int *lpos;       /* out: return index of pos within attr */
int *osegix;     /* out: return corresponding index in tx->atts array */
{
    int charcount, segix, charix, lastix, tpos;
    txAttrI *txAp;
    txAttrI *segp;
    int found = FALSE;
	
    if (!txt) {
		*osegix = 0;
        return ((txAttrI *)NULL);
	}
	
    charcount = txt->whole.nChars;
    charix = tpos = 0;
    segix = 0;
    txAp = txt->atts[0];
    while(charcount > 0) {
		txAp = txt->atts[segix];
        lastix = charix + txAp->nChars;
        for(tpos = charix ; charix < lastix; charix++) {
            if (charix == pos) {
                segp = txAp;
                *lpos = charix - tpos;
                found = TRUE;
                break;
            }
        }
        if (found)
            break;
        charcount -= txAp->nChars;
		if (charcount > 0) {
			segix++;
		}
    }
	*osegix = segix;
    if (!found) {
        segp = txAp;
        *lpos = --charix - tpos;
    }
    return segp;
}

/* : inheritedAttrI - return a pointer to the txAttr struct
 * expressing the attribute that a new character should inherit.
 */
static txAttrI *
inheritedAttrI(txt, pos)
atext *txt;
int pos;
{
    int tmp, ipos, segix;

    if (!txt)
        return ((txAttrI *) NULL);

    if (pos > 0) {
        return (attrSegAtPosI(txt, pos - 1, &tmp, &segix));
    }
    else {
        return (attrSegAtPosI(txt, pos, &tmp, &segix));
    }
}

/* tossTxAttrI: free all dynamic memory from the
 * passed txAttrI instance;  note that the txAttr
 * instance itself is not freed, only its appendages
 */
static void
tossTxAttrI(tx)
void *tx;         /* in: treat as (txAttrI *)  */
{
    txAttrI *ttx = (txAttrI *) tx;
    
    if (!ttx)
        return;
    
    if (ttx->strokepattern) {
        axtFreeFillPattern(ttx->strokepattern);
        ttx->strokepattern = (attr_type *)NULL;
    }
    if (ttx->fillpattern) {
        axtFreeFillPattern(ttx->fillpattern);
        ttx->fillpattern = (attr_type *)NULL;
    }
    if (ttx->screenFontName) {
        txfree((char *)ttx->screenFontName);
        ttx->screenFontName = (char *)NULL;
    }
    if (ttx->fontAttr.familyName) {
        txfree((char *)ttx->fontAttr.familyName);
        ttx->fontAttr.familyName = (char *)NULL;
    }
    if (ttx->fontAttr.fontName) {
        txfree((char *)ttx->fontAttr.fontName);
        ttx->fontAttr.fontName = (char *)NULL;
    }
    if (ttx->indent) {
        axtFreeIndent(ttx->indent);
        ttx->indent = (axtIndent *) NULL;
    }
}

/* : foldDefaultsI - support for sparse attribute description.
 * combine the explicitly-specified (sparse) attr description
 * with underlying (thorough) default attr info to produce
 * a thorough description that expresses the overriding
 * explicit info
 */
static void
foldDefaultsI(mask, exp, dp, outp, pid)
unsigned int mask; /* which exp attrs to look at */
txAttrI *exp; /* in: explicitly specified attrs */
txAttrI *dp; /* in: defaults */
txAttrI *outp; /* out: if explicit use exp, else use dp */
int pid;
{
    int tlen = 0;
    axtIndent *indp = (axtIndent *) NULL;
    axtBullet *bulp = (axtBullet *) NULL;
    axtDropShadow *drop = (axtDropShadow *) NULL;
    char *cp=(char *)NULL;
    attr_type *tp = NULL;

    /* get the string propvals out of the way first */
    if (mask & TXfontFamily) {
        cp = exp->fontAttr.familyName;
    }
    else {
        cp = dp->fontAttr.familyName;
    }
    if (cp) {
        tlen = strlen(cp);
        if (outp->fontAttr.familyName) {
            txfree(outp->fontAttr.familyName);
        }
        outp->fontAttr.familyName = (char *)txloc(pid, tlen + 1);
        strcpy(outp->fontAttr.familyName, cp);
    }
    else
        outp->fontAttr.familyName = (char *)NULL;

    if (mask & TXstrokepattern) {
        tp = exp->strokepattern;
    }
    else {
        tp = dp->strokepattern;
    }
    if (tp) {
        if (outp->strokepattern) {
            axtFreeFillPattern(outp->strokepattern);
        }
        outp->strokepattern = axtNewFillPattern(pid);
        axtCopyFillPattern(tp, &outp->strokepattern, pid);
    }
    else
        outp->strokepattern = (attr_type *)NULL;

    if (mask & TXfillpattern) {
        tp = exp->fillpattern;
    }
    else {
        tp = dp->fillpattern;
    }
    if (tp) {
        if (outp->fillpattern) {
            axtFreeFillPattern(outp->fillpattern);
        }
        outp->fillpattern = axtNewFillPattern(pid);
        axtCopyFillPattern(tp, &outp->fillpattern, pid);
    }
    else
        outp->fillpattern = (attr_type *)NULL;

    /* do the rest of the txAttrI struct */
    outp->fontAttr.weight = (mask & TXweight) ? 
		exp->fontAttr.weight : dp->fontAttr.weight;
    outp->fontAttr.slant = (mask & TXslant) ? 
		exp->fontAttr.slant : dp->fontAttr.slant;
    outp->fontAttr.ptsize = (mask & TXpointsize) ? 
		exp->fontAttr.ptsize : dp->fontAttr.ptsize;
    outp->fontAttr.ptsizeInt = (mask & TXpointsize) ? 
		exp->fontAttr.ptsizeInt : dp->fontAttr.ptsizeInt;
    outp->fontAttr.unzoomed_ptsize =
		(mask & TXpointsize) ? exp->fontAttr.unzoomed_ptsize :
			dp->fontAttr.unzoomed_ptsize;
    outp->ruling = (mask & TXruling) ? exp->ruling : dp->ruling;
    outp->strike_thru = (mask & TXstrike) ? exp->strike_thru : dp->strike_thru;
    outp->strokecolor = (mask & TXstrokecolor) ? exp->strokecolor :
	dp->strokecolor;
    outp->strokebcolor = (mask & TXstrokebcolor) ? exp->strokebcolor :
	dp->strokebcolor;
    outp->fillcolor = (mask & TXfillcolor) ? exp->fillcolor :
	dp->fillcolor;
    outp->fillbcolor = (mask & TXfillbcolor) ? exp->fillbcolor :
	dp->fillbcolor;
    if (mask & TXfgPixel) {
        outp->fgPixel = exp->fgPixel;
        outp->useFgPixel = TRUE;
    }
    else {
        outp->fgPixel = (unsigned long) 0;
        outp->useFgPixel = FALSE;
    }

    outp->supy = (mask & TXsupy) ? exp->supy : dp->supy;
    outp->kern = (mask & TXkernx) ? exp->kern : dp->kern;
    
    if (mask & TXindent) {
        indp = exp->indent;
    }
    else {
        indp = dp->indent;
    }
    if (indp) {
        if (outp->indent) {
            axtFreeIndent(outp->indent);
        }
        outp->indent = axtNewDefaultIndent(pid);
        axtCopyIndent(indp, outp->indent, pid);
    }
    else {
        outp->indent = (axtIndent *) NULL;
    }

    if (mask & TXbullet) {
        bulp = exp->indent ? exp->indent->bullet : (axtBullet *) NULL;
    }
    else {
        bulp = dp->indent ? dp->indent->bullet : (axtBullet *) NULL;
    }
    if (bulp) {
        if (outp->indent && outp->indent->bullet) {
            axtFreeBullet(outp->indent->bullet);
        }
        if (!outp->indent) {
            outp->indent = axtNewDefaultIndent(pid);
        }
        outp->indent->bullet = axtNewDefaultBullet(pid);
        axtCopyBullet(bulp, outp->indent->bullet, pid);
    }
    else if (outp->indent) {
        outp->indent->bullet = (axtBullet *)NULL;
    }

    if (mask & TXdropShadow) {
        drop = exp->dropShadow;
    }
    else {
        drop = dp->dropShadow;
    }
    if (drop) {
        if (outp->dropShadow) {
            axtFreeDropShadow(outp->dropShadow);
        }
        outp->dropShadow = (axtDropShadow *) txloc(pid, sizeof(axtDropShadow));
        axtCopyDropShadow(drop, outp->dropShadow, pid);
    }
    else
        outp->dropShadow = (axtDropShadow *) NULL;

}

/*
 * these are the hardcoded text attr defaults!
 */
static void
txAttDefaultsI(ap, flags, pid)
txAttrI *ap;
unsigned int *flags; /* report which are actually set in here */
int pid;
{
    int len;
    if (!ap)
        return;

	/* Ashisuto add for wp2rtf not crash.  1995.09.14 */
#if FOR_FILTER
    if (!axDefaultSerifFont)
#if AXMS
        axDefaultSerifFont = NXLT("Times New Roman");
#else
	axDefaultSerifFont = NXLT("Times");
#endif
#endif

    memset((void *)ap, 0, sizeof(txAttrI));
    *flags = 0;
    len = strlen(NXLT(axDefaultSerifFont)) + 1;
    ap->fontAttr.familyName = (char *)txloc(pid, len);
    *flags |= TXfontFamily;
    strcpy(ap->fontAttr.familyName, NXLT(axDefaultSerifFont));
    ap->fontAttr.ptsize = (float) axtDefaultPointsizeI();
    ap->fontAttr.ptsizeInt = axtDefaultPointsizeI() * 10000;
    ap->fontAttr.unzoomed_ptsize = ap->fontAttr.ptsizeInt;
    *flags |= TXpointsize;
    ap->strokecolor = 255;
    *flags |= TXstrokecolor;
    ap->strokebcolor = 0;
    *flags |= TXstrokebcolor;
    ap->fillcolor = 255;
    *flags |= TXfillcolor;
    ap->fillbcolor = 0;
    *flags |= TXfillbcolor;
}

static int
axtDefaultPointsizeI()
{
    return 12;					/* our hardcoded default! */
}

static int
getDefaultLineHeightI(tx)
atext *tx;
{
    int pointsize;
    if (tx->userDefaults && (tx->userDefaultFlags && TXpointsize)) {
        pointsize = tx->userDefaults->fontAttr.unzoomed_ptsize;
    }
    else {
        pointsize = 10000 * axtDefaultPointsizeI();
    }
    return (emToMils(1200, pointsize));
}

static void
copyTxAttrI(to, from, pid)
txAttrI *to, *from;
int pid;
{
    int len;
    
	/* (noncached) free-store appendages are:
	 * fontAttr.familyName, fontAttr.fontName,
	 * strokepattern, fillpattern, screenFontName.
	 */
    if (to->fontAttr.familyName) {
        txfree((char *)to->fontAttr.familyName);
        to->fontAttr.familyName = (char *)NULL;
    }
    if (to->fontAttr.fontName) {
        txfree((char *)to->fontAttr.fontName);
        to->fontAttr.fontName = (char *)NULL;
    }
    if (to->strokepattern) {
        axtFreeFillPattern(to->strokepattern);
        to->strokepattern = (attr_type *)NULL;
    }
    if (to->fillpattern) {
        axtFreeFillPattern(to->fillpattern);
        to->fillpattern = (attr_type *)NULL;
    }
    if (to->screenFontName) {
        txfree((char *)to->screenFontName);
        to->screenFontName = (char *)NULL;
    }
    if (to->indent) {
        axtFreeIndent(to->indent);
        to->indent = (axtIndent *) NULL;
    }
    if (to->dropShadow) {
        axtFreeDropShadow(to->dropShadow);
        to->dropShadow = (axtDropShadow *) NULL;
    }

    *to = *from;

    if (from->fontAttr.familyName) {
        len = strlen(from->fontAttr.familyName) + 1;
        to->fontAttr.familyName = (char *)txloc(pid, len);
        strcpy((char *)to->fontAttr.familyName,
			   (char *)from->fontAttr.familyName);
    }
    if (from->fontAttr.fontName) {
        len = strlen(from->fontAttr.fontName) + 1;
        to->fontAttr.fontName = (char *)txloc(pid, len);
        strcpy((char *)to->fontAttr.fontName,
			   (char *)from->fontAttr.fontName);
    }
    if (from->strokepattern) {
        to->strokepattern = axtNewFillPattern(pid);
        axtCopyFillPattern(from->strokepattern, &to->strokepattern, pid);
    }
    if (from->fillpattern) {
        to->fillpattern = axtNewFillPattern(pid);
        axtCopyFillPattern(from->fillpattern, &to->fillpattern, pid);
    }
    if (from->screenFontName) {
        len = strlen(from->screenFontName) + 1;
        to->screenFontName = (char *)txloc(pid, len);
        strcpy((char *)to->screenFontName,
			   (char *)from->screenFontName);
    }
    if (from->indent) {
        to->indent = axtNewDefaultIndent(pid);
        axtCopyIndent(from->indent, to->indent, pid);
    }
    if (from->dropShadow) {
        to->dropShadow = (axtDropShadow *) txloc(pid, sizeof(axtDropShadow));
        memset((void *) to->dropShadow, 0, sizeof (axtDropShadow));
        axtCopyDropShadow(from->dropShadow, to->dropShadow, pid);
    }
}

/* This routine is used to support interactive
 * display during edit.  Its job is to assign
 * tx->old, a copy of on-screen state over the
 * range expected to change.
 *
 * It doesn't do a complete copy, only enough
 * for the lift/display code.
 */
static void
copyAxtextI(to, from, len)
atext **to;    /* out: copy onto this; caller must free */
atext *from;   /* in */
int len;       /* #textchars to copy */
{
	int ix, jx, charcount, segcount, fpos, lpos, fsegix, lsegix;
	txAttrI *firstSeg, *lastSeg;
	atext *last;
	p32 oldOff;
	
	/* toss anything still on *to
	 */
	last = *to;
	if (last) {
		daxtextI(last);
	}
	else {
		last = (atext *) txloc(from->pid, sizeof(atext));
		memset((void *)last, 0, sizeof(atext));
	}
	
	last->pid = from->pid;
	last->whole = from->whole;
	charcount = len ? len : from->whole.nChars - from->editState.editPos;
	last->whole.nChars = charcount;
    
	/* copy txAttrI array
	 */
	if (charcount) {
		firstSeg = attrSegAtPosI(from, from->editState.editPos,
								 &fpos, &fsegix);
		lastSeg = attrSegAtPosI(from, from->editState.editPos + charcount - 1,
								&lpos, &lsegix);
		segcount = lsegix - fsegix + 1;
		ix = segcount * sizeof(txAttrI *);
		last->atts = (txAttrI **) txloc(last->pid, ix);
		memset((void *)last->atts, 0, ix);
		for (ix = fsegix, jx = 0; jx < segcount; ix++, jx++) {
			last->atts[jx] = (txAttrI *) txloc(last->pid, sizeof(txAttrI));
			memset((void *) last->atts[jx], 0, sizeof(txAttrI));
			copyTxAttrI(last->atts[jx], from->atts[ix], last->pid);
		}
		/* adjust txAttrI->nChars vals for the starting and
		 * ending segs of the copy.
		 */
		if (fsegix == lsegix) {
			last->atts[0]->nChars = charcount;
		}
		else {
			last->atts[0]->nChars = from->atts[fsegix]->nChars - fpos;
			last->atts[segcount - 1]->nChars = lpos + 1;
		}
	}
	else if (from->atts) {
		last->atts = (txAttrI **) txloc(last->pid, sizeof(txAttrI*));
		last->atts[0] = (txAttrI *) txloc(last->pid, sizeof(txAttrI));
		memset((void *) last->atts[0], 0, sizeof(txAttrI));
		copyTxAttrI(last->atts[0], from->atts[0], last->pid);
		last->atts[0]->nChars = 0;
	}
	
	if (charcount) {
		/* copy perCharI array
		 */
		ix = charcount * sizeof(perCharI *);
		if (ix) {
			last->items = (perCharI **) txloc(last->pid, ix);
			memset((void *) last->items, 0, ix);
			for (ix = from->editState.editPos, jx = 0;
				 jx < charcount; ix++, jx++) {

				last->items[jx] = (perCharI *) txloc(last->pid, sizeof(perCharI));
				memset((void *) last->items[jx], 0, sizeof(perCharI));
				*(last->items[jx]) = *(from->items[ix]);
				last->items[jx]->changed = last->items[jx]->deleted = 
					last->items[jx]->damaged = last->items[jx]->moved = 
						last->items[jx]->inserted = FALSE;
			}
		}
	}
	
	/* set last's position and 0th offset.  Position is taken
	 * as equal to from's, with the offset to editPos stored as
	 * last's 0th offset
	 */
	last->whole.pos = from->whole.pos;
	if (from->whole.nChars) {
		axtGetPosOffsetI(from, from->editState.editPos, &oldOff);
		if (from->items) {
			oldOff.y -= from->items[from->editState.editPos]->sup;
		}
		if (last->items) {
			last->items[0]->offset = oldOff;
		}
	}
	
	/* shut off the linetable for the old copy
	 */
	last->whole.linetab = (linetab_ent *) NULL;
	last->whole.linetab_memsize = 0;
	last->whole.numlines = 0;
	
	/* for editState, copy only the background color/pix stuff,
	 * and the fieldBounder.
	 */
	memset((void *)&last->editState, 0, sizeof(eStateI));
	last->editState.background = from->editState.background;
	last->editState.backgroundPixel = from->editState.backgroundPixel;
	last->editState.backRect = from->editState.backRect;
	last->editState.fieldBounder = from->editState.fieldBounder;
	
	/* but copy the 'construction' state flags
	 */
	last->constructed = from->constructed;
	last->measured = from->measured;
	last->displayable = from->displayable;
	
	*to = last;
}

/* test whether the txAttrI will need to be split
 */
static int /* TRUE means split */
needSplitI(txt, pos, whichEdge)
atext *txt;
int pos; /* of edge of range affected by attr change */
int whichEdge; /* of range */
{
    int lpos, segix;
    txAttrI *thisAp;
	
    thisAp = attrSegAtPosI(txt, pos, &lpos, &segix);
	if (lpos < 0) {
		return (FALSE);
	}
    if (whichEdge == LEFT_EDGE) {
        return (lpos != 0);
    }
    else {						/* right edge */
        return (lpos != (thisAp->nChars - 1));
    }
}

/* split one attr seg into two copies of itself,
 * changing only the nChars members; 'pos' will
 * the leftmost position in the rightmost of the
 * resultant two segs
 */
static int
doSplitI(txt, pos)
atext *txt;
int pos;
{
    txAttrI *new, *txAp, *tmpAp;
    int lpos, nsegs, segix, itmp;
    
	/* make a copy of the attr seg at pos, adjust charcounts
	 */
	new = (txAttrI *) txloc(txt->pid, sizeof(txAttrI));
    memset((void *) new, 0, sizeof(txAttrI));
    txAp = attrSegAtPosI(txt, pos, &lpos, &segix);
    copyTxAttrI(new, txAp, txt->pid);
	
	/* widen exisiting array, attach new copy
	 */
    nsegs = segCountI(txt, -1, &tmpAp);
	itmp = (nsegs + 1) * sizeof(txAttrI *);
	txt->atts = (txAttrI **) retxloc(txt->pid, txt->atts, itmp);
	if (segix < nsegs) {
		/* slide existing tail down to new position
		 */
		itmp = (nsegs - segix) * sizeof(txAttrI *);
		memmove((void *) &txt->atts[segix + 1], 
				(void *) &txt->atts[segix], itmp);
	}
    new->nChars = lpos;
    txAp->nChars -= lpos;
	txt->atts[segix] = new;
    return TRUE;
}

/* compare txAttrI range containing pos,len.  Join whenever
 * txAttrI's are found that are adjacent & identical, or if
 * a txAttrI is found whose character count has hit zero.
 */
static int
checkJoinI(txt, pos, len)
atext *txt;
int pos, len; /* check across attr range containing this char range */
{
    txAttrI *first, *last, *thisAp, *nextAp, *txAp, *tmpAp;
    int fpos, lpos, attrIx, nsegs, empty, fsegix, lsegix, itmp;
    first = attrSegAtPosI(txt, pos, &fpos, &fsegix);
    last = attrSegAtPosI(txt, pos+len, &lpos, &lsegix);
	
    attrIx = fsegix;
    txAp = first;
    while (attrIx < lsegix) {
        thisAp = txAp;
        nextAp = txt->atts[attrIx + 1];
        if (!attrChangeI(thisAp, nextAp, (unsigned int)TXAllAtts, FALSE, txt->pid) ||
            thisAp->nChars <= 0) {
			
			/* identical to its neighbor, or empty; delete
			 */
            empty = thisAp->nChars <= 0;
            nsegs = segCountI(txt, -1, &tmpAp);
            nextAp->nChars += thisAp->nChars;
			
			/* cut out the deleted txAttrI, collapse atts array
			 */
			tossTxAttrI(txt->atts[attrIx]);
			txfree(txt->atts[attrIx]);
			if ((attrIx + 1) < nsegs) {
				/* slide undeleted tail in
				 */
				itmp = (nsegs - attrIx - 1) * sizeof(txAttrI *);
				memmove((void *) &txt->atts[attrIx],
						(void *) &txt->atts[attrIx + 1], itmp);
			}
			txt->atts = (txAttrI **) retxloc(txt->pid, 
				txt->atts, (nsegs - 1) * sizeof(txAttrI *));
	
			/* delete can readdress the attr array, so..
			 */
            last = attrSegAtPosI(txt, pos+len, &lpos, &lsegix); /* loop var */
			
			/* stay at same position in array until neighbor
			 * is different; ie, keep txAp at attrIx-th seg
			 */
            segCountI(txt, attrIx, &txAp); /* (loop variable..) */
            if (empty && attrIx) {
				/* back up in case the seg just before the empty
				 * seg just deleted is identical to the next
				 */
                attrIx--;
                txAp = txt->atts[attrIx];
            }
        }
        else {
            attrIx++;
			txAp = txt->atts[attrIx];
        }
    }
    return TRUE;
}

static int
segCountI(txt, ix, txAp)
atext *txt;
int ix;        /* if >= 0, count only to ix */
txAttrI **txAp; /* out: return & of ixth attr if ix >= 0 */
{
    txAttrI *tmpAp;
    int charcount = txt->whole.nChars;
    int segix = 0;
    *txAp = (txAttrI *) NULL;
    while(charcount > 0) {
        tmpAp = txt->atts[segix];
        if (segix == ix) {
            *txAp = txt->atts[segix];
			return (segix);
        }
        charcount -= tmpAp->nChars;
		segix++;
    }
    return (segix);
}

/* public to private copy
 */
static void
copyInTextAttrI(tx, pub, newAttr, defP, flags, pid)
atext *tx;
textAttrs *pub;
txAttrI *newAttr;
txAttrI *defP;
unsigned int flags;
int pid;
{

    if ((flags & TXfontFamily) && pub->fontFamily) {
        if (newAttr->fontAttr.familyName)
            txfree((char *)newAttr->fontAttr.familyName);
        newAttr->fontAttr.familyName = (char *)txloc(tx->pid, 
            strlen(pub->fontFamily) + 1);
        strcpy((char *)newAttr->fontAttr.familyName,
            (char *)pub->fontFamily);
    }
    if ((flags & TXfillpattern) && pub->fillpattern) {
        if (newAttr->fillpattern)
            axtFreeFillPattern(newAttr->fillpattern);
        newAttr->fillpattern = axtNewFillPattern(pid);
        axtCopyFillPattern(pub->fillpattern, &newAttr->fillpattern, pid);
    }
    if ((flags & TXstrokepattern) && pub->strokepattern) {
        if (newAttr->strokepattern)
            axtFreeFillPattern(newAttr->strokepattern);
        newAttr->strokepattern = axtNewFillPattern(pid);
        axtCopyFillPattern(pub->strokepattern, &newAttr->strokepattern, pid);
    }
    if (flags & TXweight)
        newAttr->fontAttr.weight = pub->weight;
    if (flags & TXslant)
        newAttr->fontAttr.slant = pub->slant;
    if (flags & TXpointsize) {
        newAttr->fontAttr.ptsizeInt = pub->pointsize;
        newAttr->fontAttr.ptsize = (float) pub->pointsize / 10000.0;
        newAttr->fontAttr.unzoomed_ptsize = newAttr->fontAttr.ptsizeInt;
		if (tx->whole.zoomOn) {
			newAttr->fontAttr.ptsizeInt =
				(int)(newAttr->fontAttr.ptsizeInt *
					  ((float) tx->whole.zoom / 1000.0));
			newAttr->fontAttr.ptsize =
				(float)(newAttr->fontAttr.ptsize * (tx->whole.zoom / 1000.0));
		}
    }
    if (flags & TXruling)
        newAttr->ruling = pub->ruling;
    if (flags & TXstrike)
        newAttr->strike_thru = pub->strike_thru;
    if (flags & TXsupy)
        newAttr->supy = pub->supy;
    if (flags & TXkernx)
        newAttr->kern = pub->kernx;
    if (flags & TXfillcolor)
        newAttr->fillcolor = pub->fillcolor;
    if (flags & TXfillbcolor)
        newAttr->fillbcolor = pub->fillbcolor;
    if (flags & TXfgPixel) {
        newAttr->fgPixel = pub->fgPixel;
        newAttr->useFgPixel = TRUE;
    }
    if (flags & TXstrokecolor)
        newAttr->strokecolor = pub->strokecolor;
    if (flags & TXstrokebcolor)
        newAttr->strokebcolor = pub->strokebcolor;
    
    if (flags & TXindent) {
        if (newAttr->indent) {
            axtFreeIndent(newAttr->indent);
            newAttr->indent = (axtIndent *) NULL;
        }
        if (pub->indent) {
            newAttr->indent = axtNewDefaultIndent(pid);
            axtCopyIndent(pub->indent, newAttr->indent, pid);
        }
    }
    if (flags & TXbullet) {
        if (newAttr->indent && newAttr->indent->bullet) {
            axtFreeBullet(newAttr->indent->bullet);
            newAttr->indent->bullet = (axtBullet *) NULL;
        }
        if (pub->bullet || (pub->indent && pub->indent->bullet)) {
            if (!newAttr->indent) {
                newAttr->indent = axtNewDefaultIndent(pid);
            }
            newAttr->indent->bullet = axtNewDefaultBullet(pid);
            if (pub->bullet) {
                axtCopyBullet(pub->bullet, newAttr->indent->bullet, pid);
            }
            else if (pub->indent && pub->indent->bullet) {
                axtCopyBullet(pub->indent->bullet, newAttr->indent->bullet, pid);
            }
        }
        if (newAttr->indent->bullet && newAttr->indent->bullet->bulletSize) {
            /* snapshot the bullet's size
             */
            int fsize;
            axtBullet *bb = newAttr->indent->bullet;
			if (flags & TXpointsize)
				fsize = newAttr->fontAttr.ptsizeInt;
			else
				fsize = defP->fontAttr.ptsizeInt;
            bb->bulletSize(newAttr->indent, fsize, 
                           &bb->bounder.origin.x, &bb->bounder.origin.y,
                           &bb->bounder.width, &bb->bounder.height);
        }
    }
    if (flags & TXdropShadow) {
        if (newAttr->dropShadow) {
            axtFreeDropShadow(newAttr->dropShadow);
            newAttr->dropShadow = (axtDropShadow *) NULL;
        }
        if (pub->shadow) {
            newAttr->dropShadow =
                (axtDropShadow *) txloc(tx->pid, sizeof(axtDropShadow));
            memset((void *) newAttr->dropShadow, 0, sizeof(axtDropShadow));
            axtCopyDropShadow(pub->shadow, newAttr->dropShadow, pid);
        }
    }
}

/* private to public copy */
static void
copyOutTextAttrI(pubAttr, attr, flags, pid)
textAttrs *pubAttr;
txAttrI *attr;
unsigned int flags;
int pid;
{
    if ((flags & TXfontFamily) && attr->fontAttr.familyName) {
        if (pubAttr->fontFamily)
            txfree((char *)pubAttr->fontFamily);
        pubAttr->fontFamily =
			(char *)txloc(pid,strlen(attr->fontAttr.familyName) + 1);
        strcpy(pubAttr->fontFamily, attr->fontAttr.familyName);
    }
    if ((flags & TXfillpattern) && attr->fillpattern) {
        if (pubAttr->fillpattern)
            axtFreeFillPattern(pubAttr->fillpattern);
        pubAttr->fillpattern = axtNewFillPattern(pid);
        axtCopyFillPattern(attr->fillpattern, &pubAttr->fillpattern, pid);
    }
    if ((flags & TXstrokepattern) && attr->strokepattern) {
        if (pubAttr->strokepattern)
            axtFreeFillPattern(pubAttr->strokepattern);
        pubAttr->strokepattern = axtNewFillPattern(pid);
        axtCopyFillPattern(attr->strokepattern, &pubAttr->strokepattern, pid);
    }
    if (flags & TXweight) {
        pubAttr->weight = attr->fontAttr.weight;
    }
    if (flags & TXslant) {
        pubAttr->slant = attr->fontAttr.slant;
    }
    if (flags & TXpointsize) {
        pubAttr->pointsize = attr->fontAttr.unzoomed_ptsize;
    }
    if (flags & TXruling) {
        pubAttr->ruling = attr->ruling;
    }
    if (flags & TXstrike) {
        pubAttr->strike_thru = attr->strike_thru;
    }
    if (flags & TXfillcolor) {
        pubAttr->fillcolor = attr->fillcolor;
    }
    if (flags & TXfillbcolor) {
        pubAttr->fillbcolor = attr->fillbcolor;
    }
    if (flags & TXfgPixel) {
        pubAttr->fgPixel = attr->fgPixel;
        pubAttr->useFgPixel = TRUE;
    }
    if (flags & TXstrokecolor) {
        pubAttr->strokecolor = attr->strokecolor;
    }
    if (flags & TXstrokebcolor) {
        pubAttr->strokebcolor = attr->strokebcolor;
    }
    if (flags & TXsupx) {
        pubAttr->supx = 0;
    }
    if (flags & TXsupy) {
        pubAttr->supy = attr->supy;
    }
    if (flags & TXkernx) {
        pubAttr->kernx = attr->kern;
    }
    if (flags & TXkerny) {
        pubAttr->kerny = 0;
    }
    if ((flags & TXindent) && attr->indent) {
        if (pubAttr->indent) {
            axtFreeIndent(pubAttr->indent);
        }
        pubAttr->indent = axtNewDefaultIndent(pid);
        axtCopyIndent(attr->indent, pubAttr->indent, pid);
    }
    if ((flags & TXbullet) && attr->indent && attr->indent->bullet) {
        if (pubAttr->bullet) {
            axtFreeBullet(pubAttr->bullet);
        }
        pubAttr->bullet = axtNewDefaultBullet(pid);
        axtCopyBullet(attr->indent->bullet, pubAttr->bullet, pid);
    }
    if ((flags & TXdropShadow) && attr->dropShadow) {
        if (pubAttr->shadow) {
            axtFreeDropShadow(pubAttr->shadow);
        }
        pubAttr->shadow =
			(axtDropShadow *) txloc(pid, sizeof(axtDropShadow));
        memset((void *) pubAttr->shadow, 0, sizeof(axtDropShadow));
        axtCopyDropShadow(attr->dropShadow, pubAttr->shadow, pid);
    }
}

/* compare two txAttrI structs; possibly apply attr info
 */
static int /* true if different */
attrChangeI(txAp, newAp, flags, apply, pid)
txAttrI *txAp;
txAttrI *newAp;
unsigned int flags;
int apply; /* if true, apply changes from *newAp to *txAp */
int pid;
{
	int different = FALSE;

	if (flags & TXfontFamily) {
		if (differingStrings(newAp->fontAttr.familyName,
							 txAp->fontAttr.familyName)) {
			different = TRUE;
			if (apply) {
				if (txAp->fontAttr.familyName) {
					txfree((char *)txAp->fontAttr.familyName);
					txAp->fontAttr.familyName = (char *)NULL;
				}
				if (newAp->fontAttr.familyName) {
					txAp->fontAttr.familyName =
						(char *)txloc(pid, strlen(newAp->fontAttr.familyName)+1);
					strcpy((char *)txAp->fontAttr.familyName,
						   (char *)newAp->fontAttr.familyName);
				}
			}
			else
				return TRUE;
		}
	}
	if (flags & TXstrokepattern) {
		/* %%%%%%% need to compare fillpat data to prevent unneeded fragment'n */
		different = TRUE;		/* %%%%%% whether or not actually different */
		if (apply) {
			if (txAp->strokepattern)
				axtFreeFillPattern(txAp->strokepattern);
			if (newAp->strokepattern) {
				txAp->strokepattern = axtNewFillPattern(pid);
				axtCopyFillPattern(newAp->strokepattern,
								   &txAp->strokepattern, pid);
			}
			else
				txAp->strokepattern = (attr_type *) NULL;
		}
		else
			return TRUE;
	}
	if (flags & TXfillpattern) {
/* %%%%%%% need to compare fillpat data to prevent unneeded fragment'n */
		different = TRUE;		/* %%%%%% whether or not actually different */
		if (apply) {
			if (txAp->fillpattern)
				axtFreeFillPattern(txAp->fillpattern);
			if (newAp->fillpattern) {
				txAp->fillpattern = axtNewFillPattern(pid);
				axtCopyFillPattern(newAp->fillpattern,
								   &txAp->fillpattern, pid);
			}
			else
				txAp->fillpattern = (attr_type *) NULL;
		}
		else
			return TRUE;
	}
	if (flags & TXweight) {
		if (newAp->fontAttr.weight != txAp->fontAttr.weight) {
			different = TRUE;
			if (apply) {
				txAp->fontAttr.weight = newAp->fontAttr.weight;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXslant) {
		if (newAp->fontAttr.slant != txAp->fontAttr.slant) {
			different = TRUE;
			if (apply) {
				txAp->fontAttr.slant = newAp->fontAttr.slant;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXpointsize) {
		if (newAp->fontAttr.ptsize != txAp->fontAttr.ptsize) {
			different = TRUE;
			if (apply) {
				txAp->fontAttr.ptsize = newAp->fontAttr.ptsize;
				txAp->fontAttr.ptsizeInt = newAp->fontAttr.ptsizeInt;
				txAp->fontAttr.unzoomed_ptsize =
					newAp->fontAttr.unzoomed_ptsize;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXruling) {
		if (newAp->ruling != txAp->ruling) {
			different = TRUE;
			if (apply) {
				txAp->ruling = newAp->ruling;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXstrike) {
		if (newAp->strike_thru != txAp->strike_thru) {
			different = TRUE;
			if (apply) {
				txAp->strike_thru = newAp->strike_thru;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXsupy) {
		if (newAp->supy != txAp->supy) {
			different = TRUE;
			if (apply) {
				txAp->supy = newAp->supy;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXkernx) {
		if (newAp->kern != txAp->kern) {
			different = TRUE;
			if (apply) {
				txAp->kern = newAp->kern;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXfillcolor) {
		if (newAp->fillcolor != txAp->fillcolor) {
			different = TRUE;
			if (apply) {
				txAp->fillcolor = newAp->fillcolor;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXfillbcolor) {
		if (newAp->fillbcolor != txAp->fillbcolor) {
			different = TRUE;
			if (apply) {
				txAp->fillbcolor = newAp->fillbcolor;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXfgPixel) {
		if ((newAp->useFgPixel != txAp->useFgPixel) ||
			(newAp->useFgPixel && (newAp->fgPixel != txAp->fgPixel))) {
			/* usage bits are different, or pixvals are different
			 */
			different = TRUE;
			if (apply) {
				txAp->fgPixel = newAp->fgPixel;
				txAp->useFgPixel = newAp->useFgPixel;
				if (!txAp->useFgPixel) {
					txAp->fgPixel = (unsigned long) 0;
				}
			}
			else
				return TRUE;
		}
	}
	if (flags & TXstrokecolor) {
		if (newAp->strokecolor != txAp->strokecolor) {
			different = TRUE;
			if (apply) {
				txAp->strokecolor = newAp->strokecolor;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXstrokebcolor) {
		if (newAp->strokebcolor != txAp->strokebcolor) {
			different = TRUE;
			if (apply) {
				txAp->strokebcolor = newAp->strokebcolor;
			}
			else
				return TRUE;
		}
	}
	if (flags & TXindent) {
		if (differingIndents(newAp->indent, txAp->indent)) {
			different = TRUE;
			if (apply) {
				if (newAp->indent) {
					if (!txAp->indent) {
						txAp->indent = axtNewDefaultIndent(pid);
					}
					axtCopyIndent(newAp->indent, txAp->indent, pid);
				}
				else if (txAp->indent) {
					axtFreeIndent(txAp->indent);
					txAp->indent = (axtIndent *) NULL;
				}
			}
			else
				return TRUE;
		}
	}
	if (flags & TXbullet) {
		axtBullet *bcur, *bnew;
        
		bnew = newAp->indent ? newAp->indent->bullet : (axtBullet *) NULL;
		bcur = txAp->indent ? txAp->indent->bullet : (axtBullet *) NULL;
        
		if (differingBullets(bnew, bcur)) {
			different = TRUE;
			if (apply) {
				if (newAp->indent && newAp->indent->bullet) {
					if (!txAp->indent) {
						txAp->indent = axtNewDefaultIndent(pid);
					}
					if (!txAp->indent->bullet) {
						txAp->indent->bullet = axtNewDefaultBullet(pid);
					}
					axtCopyBullet(newAp->indent->bullet, txAp->indent->bullet, pid);
					txAp->indent->bullet->changed = TRUE;
				}
				else if (txAp->indent && txAp->indent->bullet) {
					axtFreeBullet(txAp->indent->bullet);
					txAp->indent->bullet = (axtBullet *) NULL;
				}
			}
			else
				return TRUE;
		}
	}
	if (flags & TXdropShadow) {
/* %%%%%%% need to compare attr_type data to prevent unneeded fragment'n */
		different = TRUE;
		if (apply) {
			if (newAp->dropShadow) {
				if (!txAp->dropShadow) {
					txAp->dropShadow =
						(axtDropShadow *) txloc(pid, sizeof(axtDropShadow));
					memset((void *) txAp->dropShadow, 0,
						   sizeof(axtDropShadow));
				}
				axtCopyDropShadow(newAp->dropShadow, txAp->dropShadow, pid);
			}
			else if (txAp->dropShadow) {
				axtFreeDropShadow(txAp->dropShadow);
				txAp->dropShadow = (axtDropShadow *) NULL;
			}
		}
		else
			return TRUE;
	}
    
	if (apply && affectsLetterforms(flags)) {
		if(txAp->screenFontName) {
			txfree((char *)txAp->screenFontName);
			txAp->screenFontName = (char *)NULL;
		}
	}
	if (apply && affectsFontName(flags)) {
		if(txAp->fontAttr.fontName) {
			txfree((char *)txAp->fontAttr.fontName);
			txAp->fontAttr.fontName = (char *)NULL;
		}
	}
	return different;
}

static int
getCursorPointsI(txt, type, active, txAp, pts, clipRect)
atext *txt;
int type, active;
txAttrI *txAp;
XPoint *pts;          /* out: of which there are four */
r32 *clipRect;        /* out: clip to possibly use with display */
{
	int pointcount, i, dstx, dsty, tpointsize;
	float xscale, yscale;
	XPoint cpoints[4];

	tpointsize = (int) txAp->fontAttr.ptsize;

	if (type == CURSOR_TRIANGLE) {
		if (active) {
			pointcount = 3;
			getTriPoints(cpoints, tpointsize);
		}
		else {
			pointcount = 4;
			getDiamondPoints(cpoints, tpointsize);
		}
	}
	else {
		pointcount = 2;
		getBarPointsI(txt, txAp, cpoints, clipRect);
	}
	/* suppress text-size clip */
	clipRect->origin.x = clipRect->origin.y =
		clipRect->height = clipRect->width = 0;

	for (i=0; i<pointcount; i++) {
		pts[i].x = cpoints[i].x;
		pts[i].y = cpoints[i].y;
	}
	return pointcount;
}

static void
getBarPointsI(txt, txAp, pts, clipRect)
atext *txt;
txAttrI *txAp;         /* in: containing text attr info */
XPoint *pts;           /* out */
r32 *clipRect;         /* out: clip rectangle to possibly use */
{
	int height, ascent;
	char *errString;
	r32 bbox;
   
	/* start with height derived from pointsize; guess
	 * an ascent of 80% height
	 */
	height = mToPix(1000, txAp->fontAttr.ptsize, ScreenRes);
	ascent = (int)((height * 8.0) / 10.0);

	if (txt->whole.nChars != 0) {
		/* get the overall
		 * bounder for clipping purposes
		 */
		if (errString = getOverallBounderI(txt, 0, -1, &bbox)) {
			freeErrString(errString);
			clipRect->height = clipRect->width = 0;
			clipRect->origin.x = clipRect->origin.y = 0;
		}
		else {
			*clipRect = bbox;
		}

		/* in this hack, relax the horizontal dimension of
		 * the clip; this is to ensure that cursors won't
		 * clip out in the most common case..
		 */
		clipRect->origin.x -= 1000;
		clipRect->width += 2000;
	}
	else {
		clipRect->origin.x = clipRect->origin.y =
			clipRect->width = clipRect->height = 0;
	}
	pts[0].x = pts[1].x = 0;
	pts[0].y = -ascent;
	pts[1].y = height - ascent;
}

void
axtToggleForegroundColorI(txt, fgpixel)
atext *txt;          /* in */
int fgpixel;          /* in */
{
	int n_atts, i;
	txAttrI *txAp;
        
	n_atts = segCountI(txt, -1, &txAp);
	for ( i = 0; i<n_atts; i++ ) {
		txt->atts[i]->useFgPixel  = !txt->atts[i]->useFgPixel;
		txt->atts[i]->fgPixel     = fgpixel;
	}
}

/* : axtAdjustRulingEndpointsI - Adjust the endpoints of the
 * passed ruling endpoints corresponding to text {startix,len}
 * Adjustments are made to account for kerning, hanging spaces, etc..
 */
void
axtAdjustRulingEndpointsI(tx, startix, len, ifrom, ito, ofrom, oto)
atext *tx;     /* in */
int startix;    /* in: starting index of range to underline */
int len;        /* in: #chars to underline */
p32 *ifrom;     /* in: tentative upstream endpoint */
p32 *ito;       /* in: tentative downstream endpoint */
p32 *ofrom;     /* out: adjusted upstream endpoint */
p32 *oto;       /* out: adjusted downstream endpoint */
{
	int ix;
	p32 lpos;
	perCharI *pc;
    
	if (!len) {
		*ofrom = *ifrom;
		*oto = *ito;
		return;
	}

	/* look at left endpoint first
	 */
	lpos = *ifrom;
	pc = tx->items[startix];
    
	if (pc->linebreak) {
		/* pc is 1st char on a line;  adjust forward
		 * if needed to reject any left-side hanging chars
		 */
		for (ix = startix; ix < startix + len; ix++) {
			pc = tx->items[ix];
			if (!pc->hanging) {
				break;
			}
			lpos.x += (pc->kern + pc->tadvance);
		}
	}
	else if (pc->offset.x || pc->offset.y) {
		/* pc has non-linebreak offset; adjust backward
		 * by that amount
		 */
		lpos.x -= pc->offset.x;
		lpos.y -= pc->offset.y;
	}
	else if (startix) {
		/* for a mid-line character, remove any kerning
		 * on that char (*ifrom arrives containing that kern)
		 */
		lpos.x -= pc->kern;
	}
	*ofrom = lpos;
    
	/* now look at the right endpoint; sweep it backwards
	 * for as far has right-side hanging chars are found
	 */
	lpos = *ito;
	for (ix = startix + len - 1; ix >= startix; ix--) {
		pc = tx->items[ix];
		if (!pc->hanging) {
			break;
		}
		lpos.x -= (pc->kern + pc->tadvance);
	}
	*oto = lpos;
}

/* : axtHasBulletI - return whether the character within the
 * passed attribute segment is associated with a bullet
 */
int
axtHasBulletI(txt, txAp, pc, pcIndex)
atext *txt;                 /* in */
txAttrI *txAp;                /* in: att seg containing pc */
perCharI *pc;                 /* in: character within att seg */
int pcIndex;                 /* in: char's index within text */
{
	if (txAp->indent && txAp->indent->bullet && txAp->indent->bullet->type) {
		if (!txt->whole.nChars) {
			return (TRUE);
		}
		if (!pcIndex || (pc && CHAR_IS_NEWLINE((int) pc->charcode))) {
            
			/* bullet points are defined for the 0th character (if
			 * it falls under a TXindent attr) and for any newlines
			 * under a TXindent attr.  Note that a bullet is hidden
			 * if the associated character is hidden.
			 */
			return (pc ? !pc->hidden : TRUE);
		}
	}
	return (FALSE);
}

/* : axtBulletRectI - return window-relative footprint of bullet in mils
 */
void
axtBulletRectI(tx, txAp, charpos, bRect)
atext *tx;       /* in */
txAttrI *txAp;   /* in: att-seg this bullet falls under */
p32 *charpos;    /* in: position of character assoc. with bullet */
r32 *bRect;      /* out: return window-relative footprint */
{
	int bx, by, bwidth, bheight;
	p32 bpoint, orig_bpoint;
	axtBullet *bb;
    
	if (!txAp->indent || !txAp->indent->bullet) {
		bRect->origin.x = bRect->origin.y =
			bRect->width = bRect->height = 0;
		return;
	}

	/* get bullet bounding rectangle
	 */
	bb = txAp->indent->bullet;
	bx = bb->bounder.origin.x;
	by = bb->bounder.origin.y;
	bwidth = bb->bounder.width;
	bheight = bb->bounder.height;
    
	if (!bwidth || !bheight) {
		bRect->origin.x = bRect->origin.y =
			bRect->width = bRect->height = 0;
		return;
	}
    
	/* init bpoint as the origin for the bullet rect.  this point
	 * is taken from the passed position, plus indent and other offsets.
	 */
	orig_bpoint = bpoint = *charpos;
	if (tx->whole.zoomOn) {
		/* character position contains zoom, while the indent offsets don't.
		 * remove zoom while accumulating offsets.
		 */
		bpoint.x = 
			(int)((float) charpos->x * 1000.0 / (float) tx->whole.zoom);
		bpoint.y = 
			(int)((float) charpos->y * 1000.0 / (float) tx->whole.zoom);
		orig_bpoint = bpoint;
	}
	
	if (tx->whole.nChars) {
		/* the first offset is the indent distance.  move leftward by
		 * the difference between firstLeft and left indents.
		 */
		bpoint.x -= firstLeftOffsetI(tx, txAp) - txAp->indent->firstLeft;
	}
	
	/* offset upwards in unzoomed space, to vertically center
	 * the bullet on a "small" estimate of the current font's
	 * xheight above baseline. our cheap n' nasty xheight estimate
	 * is 1/3 pointsize....
	 */
	bpoint.y -= emToMils(330, txAp->fontAttr.unzoomed_ptsize) +
		(bheight / 2);
    
	/* finally, there's a bullet offset defined on axtBullet
	 */
	bpoint.x += bb->bulletOffset.x;
	bpoint.y += bb->bulletOffset.y;
	
	if (tx->whole.zoomOn) {
		/* restore zoom
		 */
		bpoint.x = (int) (((float) bpoint.x * tx->whole.zoom) / 1000.0);
		bpoint.y = (int) (((float) bpoint.y * tx->whole.zoom) / 1000.0);
		bwidth = (int) (((float) bwidth * tx->whole.zoom) / 1000.0);
		bheight = (int) (((float) bheight * tx->whole.zoom) / 1000.0);
	}
    
	bRect->origin.x = bpoint.x;
	bRect->origin.y = bpoint.y;
	bRect->width = bwidth;
	bRect->height = bheight;
    
	/* fudge outward
	 */
	bRect->origin.x -= 7;
	bRect->origin.y -= 7;
	bRect->height += 14;
	bRect->width += 14;
}

#if !FOR_FILTER   /*  {  */

#if BUILD_ORIENT   /* {  */
CheckCharsAgainstAttrsI(txt)
atext *txt;
{
	txAttrI  *txAp;
	int     charCount = 0;
	int     local_pos;
	int seg_len, segix;
	textAttrs new_attrs;
	register int ix;
	int is_wide_font, is_wide_char;
	int RefFontIsWide;			/* FALSE if English, TRUE if Wide font */
	int RefFontIsSans;			/* FALSE if serif, TRUE if sans-serif */
	char RefFontFamily[100];

#if 0
    /* This will causes infinite recursive calling! - Ashisuto,1997.01.13 */
	if (!tx->measured) {
		char *err;
		if (err = axtMeasuredTextI(tx)) {
			freeErrString(err);
		}
	}
#endif

	memset((void *)&new_attrs, 0, sizeof(textAttrs));
	while (charCount < txt->whole.nChars) {
		txAp = attrSegAtPosI(txt, charCount, &local_pos, &segix);
/**==================================================================*/
/* remember the attributes that start the string, and use this face */
/* to create "intelligent" defaults, and use this  when the string */
/* returns to the character type of the first attribute segment  */
/**==================================================================*/
		strcpy(RefFontFamily, txAp->fontAttr.familyName );
		RefFontIsWide = IsWideFontFace(RefFontFamily);
		RefFontIsSans = IsSansFontFace(RefFontFamily);
		is_wide_font = RefFontIsWide;
		seg_len = txAp->nChars;
#if BUILD_KANJI
/* Is NarrowKana font appears here, we thought it has been checked before.
* Because the NarrowKana font never appearing until do printing, or do
* text width calculation. Do not check this segment twice. */
		if (!IsNarrowKanaFontFace(RefFontFamily))
#endif
			for (ix = 0; ix < seg_len; ix++) {
				is_wide_char =
					IS_ORIENT_CHAR(txt->items[charCount+ix]->charcode);
/**--------------------------------------------------------------**/
/* now, if the attribute are wrong, make them right.  We set the */
/* "new" attributes onto the remainder of the string, since chars */
/* tend to come in bunches.                                      */
/**--------------------------------------------------------------**/
				if (is_wide_char != is_wide_font) {
					if (is_wide_char == RefFontIsWide)
						new_attrs.fontFamily = RefFontFamily;
					else {
						if (is_wide_char)
							if (RefFontIsSans)
								new_attrs.fontFamily = sansserif_orient_face();
							else
								new_attrs.fontFamily = serif_orient_face();
						else
							if (RefFontIsSans)
								new_attrs.fontFamily =
									NXLT(axDefaultSansSerifFont);
							else
								new_attrs.fontFamily =
									NXLT(axDefaultSerifFont);
					}
					setTextAttrsI(txt, &new_attrs, TXfontFamily,
								  charCount + ix, seg_len - ix);
					is_wide_font = is_wide_char;
				}
			}

		charCount += seg_len;
	}
}




/* Ashisuto added for the new specification of Japanese font.
 * (KANJI and KATAKANA) We pretent until last to keep the Narrow Kana font as
 * a wide font, even in the function CheckCharsAgainstAttrs(). So that the
 * Narrow Kana be completely hidden from user, and also we got the simplicity
 * of our processing. But right before output texts, we had to modify the
 * font face at the end point. This is a special issue for Japanese.
 * 95.11.06
 */
#if BUILD_KANJI    /*  {  */
CheckNarrowKanaAgainstAttrsI(txt)
atext *txt;
{
	txAttrI  *txAp;
	int     charCount = 0;
	int     local_pos;
	int seg_len, segix;
	textAttrs new_attrs;
	register int ix;
	int is_narrow_kana_font, is_narrow_kana_char;
	int RefFontIsNarrowKana;    /* FALSE if English, TRUE if Wide font */
	char WideFontFamily[100];
	char NarrowKanaFontFamily[100];

	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}

	memset((void *)&new_attrs, 0, sizeof(textAttrs));
	while (charCount < txt->whole.nChars) {
		txAp = attrSegAtPosI(txt, charCount, &local_pos, &segix);
		seg_len = txAp->nChars;
		if (IsWideFontFace(txAp->fontAttr.familyName)) {
			strcpy(WideFontFamily, txAp->fontAttr.familyName);
			strcpy(NarrowKanaFontFamily, NXLT("Narrow"));
			strcat(NarrowKanaFontFamily, WideFontFamily);
			is_narrow_kana_font = FALSE;
			for (ix = 0; ix < seg_len; ix++) {
				is_narrow_kana_char =
					IS_NARROW_KANA(txt->items[charCount+ix]->charcode);
				if (is_narrow_kana_char != is_narrow_kana_font) {
					if (is_narrow_kana_char)
						new_attrs.fontFamily = NarrowKanaFontFamily;
					else
						new_attrs.fontFamily = WideFontFamily;
					setTextAttrsI(txt, &new_attrs, TXfontFamily,
								  charCount + ix, seg_len - ix);
					is_narrow_kana_font = is_narrow_kana_char;
				}
			}
		}
		charCount += seg_len;
	}
}
#endif    /* }  BUILD_KANJI  */

#endif   /*  }  BUILD_ORIENT  */

#endif   /*  }  !FOR_FILTER  */


axtAttAtPosI(txt, att, pos)
atext *txt;
textAttrs *att;
int pos;
{
	unsigned int flags = (unsigned int)TXAllAtts;
	txAttrI *txAp;
	int tmp, segix;

	txAp = attrSegAtPosI(txt, pos, &tmp, &segix);
	copyOutTextAttrI(att, txAp, flags, txt->pid);
}

txAttrI *
axtAttrAtPosI(txt, pos)
atext *txt;
int pos;
{
	int tmp, segix;
	return( attrSegAtPosI(txt, pos, &tmp, &segix));
}

/* : axtSnapshotTextI - take a copy of the current, in-edit text
 * instance in preparation for an edit of some sort
 */
static void
axtSnapshotTextI(current, editPos)
atext *current;                  /* in */
int editPos;                      /* in: snap from here downstream */
{
	/* state that old and current will be the same from editPos upstream
	 */
	current->editState.editPos = axtEditPosI(current, editPos);
    
	/* copy the downstream portion of current onto txt->old
	 */
	copyAxtextI(&current->old, current,
				current->whole.nChars - current->editState.editPos);
}

static void
axtSnapshotFieldBounderI(current, newBounder)
atext *current;
r32 *newBounder;           /* out, in screenpix */
{   
	char *err;
	r32 trect;

	/* current has changed from editPos on down somehow; get the
	 * bounder of this new material
	 */
	if (err = getOverallBounderI(current, current->editState.editPos,
								 -1, &trect)) {
		freeErrString(err);
	}
	
	/* add the text position to the bounder
	 */
	trect.origin.x += current->whole.pos.x;
	trect.origin.y += current->whole.pos.y;
	
	/* store fieldBounder in screenpix;
	 */
	trect.origin.x = milsToPix(trect.origin.x, ScreenRes);
	trect.origin.y = milsToPix(trect.origin.y, ScreenRes);
	trect.width = milsToPix(trect.width, ScreenRes);
	trect.height = milsToPix(trect.height, ScreenRes);
	if (trect.width) {
		trect.origin.x--;		/* fudge outward */
		trect.origin.y--;
		trect.width += 2;
		trect.height += 2;
	}
	
	/* add it into current's field bounder
	 */
	if (current->editState.fieldBounder.width) {
		unionRectangle(&current->editState.fieldBounder, &trect, newBounder);
	}
	else {
		*newBounder = trect;
	}
	return;
}

/* : extendFieldBounderI - enlarge the field
 * bounder of text under edit, since the text in its
 * current state may have a larger footprint than last state.
 * The axtext member ->old is expected to be valid.
 */
static void
extendFieldBounderI(txt, w, newField)
atext *txt;       /* in: text under edit, w/ old fieldBounder val */
long w;           /* in: widget handle from which to get drawable */
r32 *newField;    /* in: this is txt's new fieldBounder to extend to */
{
	int last_protruded, top_protruded, fx, fy, twid, thyt;
	r32 newf, *oldf;
	Drawable drw;
	char *err;
	
	if (!txt->whole.nChars)
		return;

	/* get drawing resources */
	drw = AxGetDrawableFromWidget((AXWidget)w, &fx, &fy);
	setLiftColorI(txt, axLiftGC);

	/* fill the background */
	if ( txt->editState.fieldBounder.width ) {
		/* get the old */
		oldf = &txt->editState.fieldBounder;
		
		if ( newField == (r32 *)0 ) {
			/* no new field - fill the old one
			 */
			XFillRectangle(Dpy, drw, axLiftGC,
						   oldf->origin.x,
						   oldf->origin.y,
						   oldf->width,
						   oldf->height);
		}
		else  {
			/* compare with the new bounder
			 */
			/* draw top part */
			unionRectangle(&txt->editState.fieldBounder, newField, &newf);
			if ( newf.origin.y >= oldf->origin.y ) {
				last_protruded = top_protruded = FALSE;
			}
			else {
				last_protruded = top_protruded = TRUE;
				if ( newf.width ) {
					XFillRectangle(Dpy, drw, axLiftGC,
								   newf.origin.x,
								   newf.origin.y,
								   newf.width,
								   oldf->origin.y - newf.origin.y);
				}
			}

			/* draw right part */
			twid = newf.origin.x + newf.width - oldf->origin.x - oldf->width;
			if ( twid <= 0 ) {
				last_protruded = FALSE;
			}
			else {
				fx = oldf->origin.x + oldf->width;
				fy = last_protruded ? oldf->origin.y : newf.origin.y;
				thyt = newf.origin.y + newf.height - fy;
				if ( thyt > 0 )
					XFillRectangle(Dpy, drw, axLiftGC, fx,fy, twid,thyt);
				last_protruded = TRUE;
			}
			
			/* draw bottom part */
			thyt = newf.origin.y + newf.height - oldf->origin.y - oldf->height;
			if ( thyt <= 0 ) {
				last_protruded = FALSE;
			}
			else {
				fy = oldf->origin.y + oldf->height;
				fx = newf.origin.x;
				if ( last_protruded )
					twid = oldf->origin.x + oldf->width - newf.origin.x;
				else
					twid = newf.origin.x + newf.width - newf.origin.x;
				if ( twid > 0 )
					XFillRectangle(Dpy, drw, axLiftGC, fx,fy, twid,thyt);
				last_protruded = TRUE;
			}
			
			/* draw the left part */
			if ( newf.origin.x < oldf->origin.x ) {
				fx = newf.origin.x;
				twid = oldf->origin.x - newf.origin.x;
				if ( top_protruded )
					fy = oldf->origin.y;
				else
					fy = newf.origin.y;
				if ( last_protruded )
					thyt = oldf->origin.y + oldf->height - fy;
				else
					thyt = newf.origin.y + newf.height - fy;
				if ( twid > 0 && thyt > 0 )
					XFillRectangle(Dpy, drw, axLiftGC, fx,fy, twid,thyt);
			}
		}
	}
	else {
		/* nothing to extend from; just fill new field
		 */
		err = getOverallBounderI(txt, 0, -1, &newf);
		if ( err ) {
			freeErrString(err);
		}
		else {
			newf.origin.x += txt->whole.pos.x;
			newf.origin.y += txt->whole.pos.y;
			newf.origin.x = milsToPix(newf.origin.x, ScreenRes);
			newf.origin.y = milsToPix(newf.origin.y, ScreenRes);
			newf.width = milsToPix(newf.width, ScreenRes);
			newf.height = milsToPix(newf.height, ScreenRes);
			if ( newf.width ) {
				newf.origin.x--; /* fudge outward */
				newf.origin.y--;
				newf.width += 2;
				newf.height += 2;
#if ALLOW_JAVA_GE && !FOR_FILTER
                {
					TmRect32 r;
					int fg;

					r.x_position = newf.origin.x;
					r.y_position = newf.origin.y;
					r.x_size = newf.width;
					r.y_size = newf.height;
					fg = txt->editState.javaPixel;
					tx_java_fillrect(txt->gContext, &r, 5, fg, fg, 0, 0, &r);
				}
#endif
				XFillRectangle(Dpy, drw, axLiftGC, newf.origin.x,
							   newf.origin.y,
							   newf.width,
							   newf.height);
			}
		}
	}
}

void
axtGetFieldBounderI(txt, bbox)
atext *txt;     /* in */
r32 *bbox;      /* out, in mils */
{
	int ixtmp, iytmp;
    
	if (txt->editState.fieldBounder.width) {
		convPixToMils(txt->editState.fieldBounder.origin.x,
					  txt->editState.fieldBounder.origin.y,
					  &bbox->origin.x, &bbox->origin.y);
		convPixToMils(txt->editState.fieldBounder.width,
					  txt->editState.fieldBounder.height,
					  &ixtmp, &iytmp);
		bbox->width = ixtmp;
		bbox->height = iytmp;
	}
	else {
		bbox->origin.x = bbox->origin.y = bbox->width = bbox->height = 0;
	}
}

/* : firstLeftOffsetI - return the offset value for use
 * on the 1st line of text falling under a particular TXindent attr
 */
static int                     /* return offset */
firstLeftOffsetI(tx, txAp)
atext *tx;                /* in */
txAttrI *txAp;            /* in: att-seg this indent falls under */
{
	int leftOffset, bRight, itmp;

	if (!txAp->indent->bullet ||
		(!txAp->indent->bullet->bounder.width ||
		 !txAp->indent->bullet->bounder.height)) {
            
		/* no bullet; use firstLeft directly
		 */
		leftOffset = txAp->indent->firstLeft;
	}
	else {
		/* there's a bullet; start text at left rather
		 * than firstLeft
		 */
		leftOffset = txAp->indent->left;
        
		/* find right edge of bullet (which starts at firstLeft)
		 */
		bRight = txAp->indent->firstLeft + txAp->indent->bullet->bounder.width;
		if ((itmp = bRight - txAp->indent->left) > 0) {
			leftOffset += itmp;	/* increase leftOffset to avoid bullet */
		}
	}
	return (leftOffset);
}

/* : axtGetIndentLineValsI - report the linespacing and offset values for
 * the attr segment occurring at ix.
 */
static void
axtGetIndentLineValsI(tx, curr_para_attr, ix, space, right_off, left_off)
atext *tx;                /* in */
txAttrI *curr_para_attr;  /* in */
int ix;                   /* in */
int *space;               /* out */
int *right_off;           /* out */
int *left_off;            /* out */
{
	txAttrI *prev_para_attr;
	int i, jnk, segix;
  
	/* normal text (ie. not at the beginning of a paragraph) */
	if ( NEWPARA(tx->items, ix) == FALSE ) {
		/* get the left indent */
		*left_off = curr_para_attr->indent->left;
    
		/* get the baseline offset */
		*space = curr_para_attr->indent->midLineHeight;
	}
	else {
		/* special treatment for beginning of a paragraph */
		/* get the left indent */
		*left_off = firstLeftOffsetI(tx, curr_para_attr);
    
		/* get the baseline offset */
		if ( ix == 0 )			/* no previous paragraph */
			*space = curr_para_attr->indent->topLineHeight;
		else {
			/* find the previous paragraph attr */
			prev_para_attr = (txAttrI *) 0;
			for ( i=ix-1; i>=0; i-- ) {
				if ( NEWPARA(tx->items, i) ) {
					prev_para_attr = attrSegAtPosI(tx, i, &jnk, &segix);
					break;
				}
			}
			if ( !prev_para_attr )
				prev_para_attr = attrSegAtPosI(tx, 0, &jnk, &segix);
      
			/* line height plus previous para bottom offset */
			*space = curr_para_attr->indent->topLineHeight +
				prev_para_attr->indent->bottomLineOffset;
		}
	}
  
	/* get the right indent */
	*right_off = curr_para_attr->indent->right;
}

/* : axtTrimTextI - sub called by qDrawTextI.
 * reduce passed starting index and run length to trim out
 * non-graphic (CHAR_IS_DIMENSIONLESS) characters.  Work on
 * the ends of the range only; don't worry about the middle.
 */
static void
axtTrimTextI(tx, startix, len)
atext *tx;                          /* in */
int *startix;                       /* in/out */
int *len;                           /* in/out */
{
	int ix, tix;
	int endix;

	tix = *startix;
	endix = *startix + *len - 1;
    
	/* trim upstream side
	 */
	for (ix = tix; ix <= endix; ix++) {
		if (CHAR_IS_DIMENSIONLESS(tx->items[ix]->charcode)) {
			(*startix)++;
			(*len)--;
		}
		else {
			break;
		}
	}
    
	if (*startix > endix) {
		*startix = endix;
		if (*len < 0)
			*len = 0;
		return;
	}
    
	/* trim downstream side
	 */
	tix = *startix;
	for (ix = endix; ix >= tix; ix--) {
		if (CHAR_IS_DIMENSIONLESS(tx->items[ix]->charcode)) {
			(*len)--;
		}
		else {
			break;
		}
	}
    
	if (*len < 0)
		*len = 0;
}

static int
axtLinelenI(tx, lineix, leftix)
atext *tx;
int lineix;
int leftix;
{
	if (lineix < tx->whole.numlines - 1) {
		return (tx->whole.linetab[lineix + 1].leftix - leftix);
	}
	else {
		int ix, ll;

		for (ll = 0, ix = leftix; ix < tx->whole.nChars; ix++, ll++) {
			if ((ix > leftix) && tx->items[ix]->linebreak) {
				break;
			}
		}
		return (ll);
	}
}

/* : insCharsIntI - sub called by insCharsI
 */
static txAttrI *
insCharsIntI(txt, str, pos, len)
atext *txt;
tx_char *str;
int pos;
int len;
{
	int ix, itmp;
	txAttrI *txAp;
	
	/* insert empty perCharIs in position, assign charcode vals
	 */
	itmp = (txt->whole.nChars + len) * sizeof(perCharI *);
	txt->items = (perCharI **) retxloc(txt->pid, txt->items, itmp);
	if (pos < txt->whole.nChars) {
		/* slide existing tail down to new position
		 */
		itmp = (txt->whole.nChars - pos) * sizeof(perCharI *);
		memmove((void *) &txt->items[pos + len], 
				(void *) &txt->items[pos], itmp);
	}
	for (ix = 0; ix < len; ix++) {
		txt->items[pos + ix] = (perCharI *)txloc(txt->pid, sizeof(perCharI));
		memset((void *) txt->items[pos + ix], 0, sizeof(perCharI));
		txt->items[pos + ix]->charcode = str[ix];
		if (txt->editState.disp) {
			txt->items[pos + ix]->inserted = TRUE; /* clue for liftOldI */
		}
	}

	/* assign proper attr seg charcount
	 */
	txAp = inheritedAttrI(txt, pos);
	if (txAp) {
		txAp->nChars += len;
	}
	txt->whole.nChars += len;

	txt->editState.cursorPos += len;
	if (txt->editState.cursorPos >= txt->whole.nChars)
		txt->editState.cursorPos = txt->whole.nChars;

    return (txAp);
}

static txAttrI *
delCharsIntI(txt, pos, len)
atext *txt;
int pos;
int len;
{
	int ix, segix, itmp;
	txAttrI *txAp;
	
	/* pitch the deleted perCharI elements
	 */
	for (ix = 0; ix < len; ix++) {
		txfree(txt->items[pos + ix]);
	}
	
	if ((pos + len) < txt->whole.nChars) {
		/* slide undeleted tail in
		 */
		itmp = (txt->whole.nChars - pos - len) * sizeof(perCharI *);
		memmove((void *) &txt->items[pos],
				(void *) &txt->items[pos + len], itmp);
	}
	txt->items = (perCharI **) retxloc(txt->pid, 
		txt->items, (txt->whole.nChars - len) * sizeof(perCharI *));
	
	txAp = attrSegAtPosI(txt, pos, &itmp, &segix);
	if (txAp) {
		/* assign new attr seg charcounts
		 */
		int numLeft;
		numLeft = len;
		while (numLeft) {
			if ((txAp->nChars - itmp) < numLeft) {
				numLeft -= (txAp->nChars - itmp);
				txAp->nChars = itmp;
				segix++;
				txAp = txt->atts[segix];
			}
			else {
				txAp->nChars -= numLeft;
				break;
			}
			itmp = 0;	/* only 1st segment is affected by this offset */
		}
	}
	txt->whole.nChars -= len;
	txt->editState.cursorPos -= len;
	if ( txt->editState.cursorPos < 0 )
		txt->editState.cursorPos = 0;

	/* no more chars */
	if ( txt->whole.nChars <= 0 ) {
		txt->whole.nChars = 0;
		txt->items = (perCharI **)0;
	}

	return (txAp);
}

resetParaGraphAttsI(txt, startix, len)
atext *txt;
int startix, len;
{
	int i, slinex, elinex, char_six, char_eix, char_len, n_atts;
    unsigned long flags;
    textAttrs *atts;
    axtIndent *in;

	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}
	/* get the line index */
	slinex = axtLineIndexFromCharIndexI(txt, startix);
	elinex = axtLineIndexFromCharIndexI(txt, startix + len - 1);

	char_six = txt->whole.linetab[slinex].leftix;
	char_eix = txt->whole.linetab[elinex].leftix;
	char_len = char_eix - char_six;
    getTextAttrsI(txt, char_six, len, &atts, &n_atts);

	/* reset para attrs */
	flags = TXbullet | TXindent;
	for ( i=0; i< n_atts; i++ ) {
		in = atts[i].indent;
		if ( in )
			in->bottomLineOffset = 0;
	}
	i = txt->editState.editPos;
	txt->editState.editPos = char_six;
	setTextAttrsI(txt, atts, flags, char_six, len);
	txt->editState.editPos = i;
}

axtGetDownCharIndexI(txt, startix, offset)
atext *txt;
int startix;
int offset;
{
	int slinex, elinex, char_ix;

	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}

	/* get the line index */
	slinex = axtLineIndexFromCharIndexI(txt, startix);
	if ( slinex < txt->whole.numlines - 1 )
	{
		elinex = slinex + 1;
		char_ix = txt->whole.linetab[elinex].leftix;
		if ( offset == 0 )
			offset = 1;
		if ( (char_ix+offset) < txt->whole.nChars )
		{
			if ( elinex < txt->whole.numlines - 1 )
			{
				if (( char_ix+offset ) < txt->whole.linetab[elinex+1].leftix )
					char_ix = char_ix + offset;
				else
					char_ix = txt->whole.linetab[elinex+1].leftix;
			}
			else
				char_ix = char_ix + 1;
		}
		else
			char_ix = txt->whole.nChars;
	}
	else
		char_ix = startix;
	return(char_ix);
		
}

axtGetUpCharIndexI(txt, startix, offset)
atext *txt;
int startix;
int offset;
{
	int slinex, elinex, char_ix;

	if (!txt->measured) {
		char *err;
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}

	/* get the line index */
	slinex = axtLineIndexFromCharIndexI(txt, startix);
	if ( slinex > 0)
	{
		elinex = slinex - 1;
		char_ix = txt->whole.linetab[elinex].leftix;
		if ( (char_ix+offset) < txt->whole.nChars )
		{
			if ( slinex > 0 )
			{
				if (( char_ix+offset ) < txt->whole.linetab[slinex].leftix )
					char_ix = char_ix + offset;
				else
					char_ix = txt->whole.linetab[slinex].leftix;
			}
			else
				char_ix = char_ix + 1;
		}
		else
			char_ix = char_ix + 1;
	}
	else
		char_ix = startix;
	return(char_ix);
		
}

getLineIndicesI(txt, ref_ix, l_ix, r_ix)
atext *txt;
int ref_ix;
int *l_ix;
int *r_ix;
{
	char *err;
	int slinex, c_ix;

	if (!txt->measured) {
		if (err = axtMeasuredTextI(txt)) {
			freeErrString(err);
		}
	}

	/* init */
	if ( txt->items[ref_ix]->charcode == (tx_char)'\n')
		ref_ix--;
	if ( ref_ix >= txt->whole.nChars )
		ref_ix = txt->whole.nChars - 1;
	if ( ref_ix < 0 )
		ref_ix = 0;
	
	/* get the line index */
	slinex = axtLineIndexFromCharIndexI(txt, ref_ix);

	if ( slinex < txt->whole.numlines - 1 )
	{
		c_ix = txt->whole.linetab[slinex].leftix;
		*r_ix = txt->whole.linetab[slinex+1].leftix;
	}
	else
	{
		c_ix = txt->whole.linetab[slinex].leftix;
		*r_ix = txt->whole.linetab[slinex].leftix;
	}

	/* check for boundary conditions */
	if ( txt->items[c_ix]->charcode == (tx_char)'\n')
		c_ix++;

	if ( c_ix > txt->whole.nChars )
		c_ix = txt->whole.nChars - 1;
	*l_ix = c_ix;
}

int
axtTrimWordIndicesI(txt, ix1, ix2)
atext *txt;
int *ix1;
int *ix2;
{
	int ix, wix1, wix2, modified;

	/* sanity check */
    if ( !txt || !txt->items || !txt->whole.nChars )
		return(FALSE);
	wix1 = *ix1;
	wix2 = *ix2;
	if ( wix1 == wix2 )
		return(FALSE);

	/* scan the end, from right to left */
	modified = FALSE;
	for ( ix=wix2; ix>wix1; ix-- )
	{
		if ( WHITECHAR(txt->items[ix-1]->charcode) == FALSE )
			break;

		*ix2 = ix-1;
		if ( modified == FALSE )
			modified = TRUE;
	}

	/* scan the beginning, from left to right */
	wix2 = *ix2;
	if ( wix1 != wix2 )
	{
		for ( ix=wix1; ix<wix2; ix++ )
		{
			if ( WHITECHAR(txt->items[ix]->charcode) == FALSE )
				break;

			*ix1 = ix+1;
			if ( modified == FALSE )
				modified = TRUE;
		}
	}
	return(modified);
}
