/* Copyright (C) 1983-1999 Applix, Inc.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307, USA.
   
   Applix Inc. is the original author of this material.  Please send
   generally useful enhancements to Applix in the form of all modified 
   source files including an explanation of the changes.  For more
   information see our website at www.applixware.org.
   
   Do not remove or modify the license information above or the following
   Applix source control information from this file.
   
   Applix filename: xmlibcom.c
   Applix ASC version: 406
   Date: Fri May 14 21:13:37 1999
*/
#define NEED_X_INFO 1

#include <stdio.h>
#include <math.h>
#include <basicwin.h>
#include <aos.h>
#include <ax_xm.h>
#if AX_X11
#include <X11/Xatom.h>
#include <X11/keysym.h>
#endif
#include <xmlib.h>
#include <elxwins.h>
#include <atm.h>
#include <atmwin.h>
#include <atmattr.h>
#include <parint.h>
#include <xmdlged.h>
#include <xmpixel.h>
#include <axtext.h>
#include <adlgpoke.h>
#include <getstr2.h>
#include <getstr5.h>
#include <wchars.h>
#include <thimble.h>
#include <el_syms.h>
#include <bitmaps.h>     /* standard patterns */
#include <java_syms.h>
#include <elfjsyms.h>

#if BUILD_ORIENT
#include <xmtable.h>
#endif
#if 0
#include <xmlibcom.p>
#endif


/* Define `ZEROED_MEM' to 1 in order to memset() contents of a widget to
   0 just before free()ing it.  The side effect is that it also pulls
   in some tracing printf()s.  Use *only* for debugging purposes.
   See xmlib.c for some more `ZEROED_MEM'. */
#define ZEROED_MEM 0

#ifndef COLOR_WHITE
#define COLOR_WHITE (WhitePixel(Dpy, DefaultScreen(Dpy)))
#define COLOR_BLACK (BlackPixel(Dpy, DefaultScreen(Dpy)))
#endif

#ifndef PALETTE_USED
#define PALETTE_USED 360
#endif

#if AXMS
#define AllPlanes (~0)
#endif

#define TM_MAXWIN 21            /* copied atmwin.h!! */

#define GE_YRULER_WIDTH 32


#if AXMS
extern int Scrollbar_Thickness;
extern int Entry_Height;
extern int CheckBoxSize;
#define SCROLLBAR_THICK Scrollbar_Thickness   /* variable on Windows */
#define LABEL_HEIGHT_PAD 0
#define STD_ENTRY_YSHIFT 3
#define CHECK_BOX_SPACING (CheckBoxSize+6)
#else
#define SCROLLBAR_THICK 16
#define LABEL_HEIGHT_PAD 4
#define STD_ENTRY_YSHIFT 0
#define CHECK_BOX_SPACING 19
#endif


struct WINDNOMAP 
    {       
    char title[1024];
    struct WINDNOMAP *next;
    };
struct WINDNOMAP *WindNotMapped;  /* List of Windows NOT to be Displayed */


struct XMlibStr {
    PIXEL_VALUE FGpixel;    /* foreground color for app work areas */
    PIXEL_VALUE BGpixel;    /* backround color for app work areas */
    int FullRegenForUpdate;  /* Set by UnMapWidget,
                                            hint for WidgetNeedsUpdated */
};
extern struct XMlibStr xmlibStr;

/* bitmaps - same format as Xm/bitmaps.h */
static unsigned char ax_bitmaps[1][32] =
{
    {   0x88, 0x88, 0x00, 0x00, 0x22, 0x22, 0x00, 0x00, /* 12.5 percent fg */
        0x88, 0x88, 0x00, 0x00, 0x22, 0x22, 0x00, 0x00,
        0x88, 0x88, 0x00, 0x00, 0x22, 0x22, 0x00, 0x00,
        0x88, 0x88, 0x00, 0x00, 0x22, 0x22, 0x00, 0x00  },
};
static char * ax_bitmap_name_set[] =
{
    NXLT("12_foreground"),
};

static int WeThinkItsAIX = FALSE;  /* hack var, true for IBMAIX Xserver */
int WeThinkItsSunX = FALSE;        /* obsolete hack var */
int UseGloballyActiveFocus = TRUE; /* i.e., use WM_TAKE_FOCUS wm protocol */

/****************************************************************/
/* Data elements used by both X-Windows ans MS-Windows            */
/****************************************************************/
AXWidget WindowList = NULL;
AXWidget RowColumnArmed = NULL;    /* currently armed row-column */
AXWidget PopupArmed = NULL;    /* current displayed popup menu */
AXWidget RightButtonArmed = NULL;    /* current displayed popup menu */
AXWidget ButtonArmed = NULL;       /* currently armed button */
AXWidget ScaleArmed = NULL;    /* currently armed scale */
AXWidget SplitterArmed = NULL;     /* currently armed splitter */
AXWidget ComboBoxArmed = NULL; /* currently armed combo box */
AXWidget_canvas CanvasArmed = NULL;
AXWidget_combo_box ComboListArmed = NULL;
#if AX_X11
extern AXWidget EditWinArmed;
#endif

AXWidget TotalWidgetsList;  /* for resource tracking */
win_list_t *TotalWindowsList;   /* for resource tracking */
int NumWidgets;
int NumWindows;

int InSysHourglassMode;    /* TRUE while all windows glassed */
int WidgetNeedsUpdated;    /* Set when a widget needs repainted */
int NumDlgNonTransients;   /* Number of major dialogs */
int AxNewMailMenuIcon;  /* If TRUE, display "new-mail" rather than asterix */
int AxNColorLevels, AxNColors;
int AxSlowDither;
unsigned long BackPixel;        /* backround for control panels */
unsigned long ForePixel;        /* foreground for control panels */
unsigned long SunPixel, ShadowPixel;    /* highlight and shadow for dialogs */
unsigned long RecessPixel;
unsigned long ForeWorkPixel, BackWorkPixel; /* for alt widget colors */
unsigned long SunWorkPixel, ShadowWorkPixel, RecessWorkPixel;
extern short ColorDisplay;
extern short NoColor;
int AxButtonDown=0;  /* which mouse button is down, 0 if none (for widgets) */
Display *Dpy;                   /* the basic display handle */
unsigned long FGpixel;          /* shared foreground color */
unsigned long BGpixel;          /* shared backround color */
GC Gc1, Gc2;                    /* graphics context shared by all windows */
short DpyWid;                   /* physical screen size */
short DpyHt;                    /* physical screen size */
short DpyDepth;             /* physical screen size */
Window AxTopWinNeverMapped; /* created by AxGetDpyAndGCs */
Window AxDummyWin;              /* un-mapped root window */
short ToggleFG = 0;         /* white background, black foreground */
int AxPlaneMask = -1;
GC AxColorGC;                   /* For colormap64 based references */
int ToolbarButtonSep;           /* nominally 2 */
int ToolbarExtraSep;            /* nominally 25 */
Pixmap CascadePixmap, MenuCheckPixmap;
int Thim2dMode = FALSE;
int UseChecksForToggles = TRUE; /* use checkmarks rather than toggle boxes */
int ThimBellVolume;
int NoTransient;                /* if FALSE, use window mgr's Transient for dialogs */
int ShowAccelerators = TRUE;

int NWidth, N2Width, N3Width;   /* width of "n", "nn", "nnn" */
int AxProgramSpecifiedWindowPos = FALSE;        /* affects WMHints */

XFontStruct *AxDlgMainFont;
XFontStruct *AxDlgMiniFont, *MonospaceFont, *MonospaceBoldFont;
XFontStruct *MonospaceItalFont, *MonospaceItalBoldFont;
XFontStruct *Grafont;
extern XFontStruct *AxStatusLineFont;
extern int GotWorkAuxColorCells;
extern int AxNoWidgetColor;
extern int rectInsideRect();
extern int AxGadgetExposed();
extern int AXequalData();
extern int wColorsEqual();
extern int widgetIntersectsUpdateRect();
extern int CbComputeComboHeight();
extern int deGhostMode();

#if QATOOL
/* lance */
extern void QaRegisterWindow(); 
#endif

extern XFontStruct *lookupNamedFont();
extern XCharStruct *getCharStruct();

int *CreateIntsArray(), wShadowIsOn();
int wOptionFieldHeight(), wOptionFieldBaseline();
int AXmNewFootprint();
void xmDrawString(), xmDrawStringAndAccelerator();
static int AXmChildWindowExposed();
static int xmUseEtchedDisabled();
static void xmSetRecessedGCToAntiShadow();
static void xmDrawOneRectTab(), xmDrawRectTabs();
static void PaintLabel(), PaintSplitter(), PaintRect();
static void PaintRadio();
static void xmIntDrawString();
static void AXmInitExposure();
static void xmSwitchDefault();
static void xmMarkDamaged();
static void xmFormatRectTabs();
static void xmTabctlPaintTabs();
static void xmLosingKeyFocus();

AXWidget xmRadioActiveToggle();

extern void PaintOption();
extern void PaintEnter();
void xmFocusSelectorRect();
void xmPaintFocusSelector(), xmLiftFocusSelector();
void xmtcSwitchLayer();
void PaintOrientalStatus(), PaintStatus();
void PaintPageBar();
void PaintGEButton();
void PaintRibbon(), PaintToggle(), PaintScale(), PaintList(), PaintScrollBar();
void wVerbButtonSize(), wFontButtonSize();
void wPixButtonSize(), wColorButtonDefaultSize();
void wRadioButtonSize(), wToggleButtonSize();
void wLabelSize();
void xmTextShadowOffsets();
void xmColorFillRectangle(), xmLiftRectShadow();
void xmDrawRectShadow(), xmDrawRectAntiShadow();
void xmPaintPanelFace();
void xmRectHideOrRevealLayer();
void xmAddWidgetLink(), xmDeleteWidgetLink();
int  xmRectInsidePanel();
int  RectEvent();
int xmTabctlTopInset();
static void wVerbButtonLabelSize();
void wWidgetShadowOffsets();
void paintCompositeWidget();
AXWidget WidgetOfWindow();
AXWidget xmKeyFocusWidget();
/*void xmIntDrawStringW(); */
static void AXmExposeWindowedWidget();
wAux *newAuxData();

Atom AxXA_VISIX_ACCEPT_DROP;
Atom AxPROTOCOL_ATOM;
Atom AxDELETE_WIN_ATOM;
Atom AxWIN_TAKE_FOCUS;
Atom AxXA_EDITBOX_PROP;
Atom AxXA_ENTER_PROP;
Atom AxXA_COMBOBOX_PROP;
Atom AxXA_SAVE_YOURSELF;

GC BackGC;      /* "white" */
GC ForeGC;      /* label text (nominally black) */
GC GXForeGC;    /* same as ForeGC, but with graphics_exposures=TRUE */
GC DisabledGC;  /* "grayed" text (e.g. menu bar inactive) */
GC RecessGC;
GC ElfGC;       /* label text (nominally black) */

/* The pixmapper will use it's own GC to shoot images onto pixmaps.
   See "xmpixel.c::BitmapToPixmap()" for comment on why it needs it's
   own GC. */
GC PixmapperForeGC; /* Foreground GC used by the Pixmapper() */
GC PixmapperBackGC; /* Background GC used by the Pixmapper() */
GC PixmapperRecessGC;   /* Recess GC used by the Pixmapper() */

GC MonospaceBoldGC;
GC MonospaceGC;     /* monspace system font, forground mode */
GC MonospaceBackGC; /* monspace system font, background mode */
GC MonospaceBoldBackGC;
GC MonospaceItalGC;
GC MonospaceItalBackGC;
GC MonospaceItalBoldGC;
GC MonospaceItalBoldBackGC;
GC SmallFontGC;     /* smaller sans-serif system font, forground mode */
GC SmallFontBackGC; /* inverse small font */
GC SunGC;               /* sunlit side */
GC ShadowGC;            /* shaded side */
GC TextCursorGC;
GC InactiveTextCursorGC;
GC ColorSunGC;          /* used only on color devices */
GC StippleGC;
Window RootWin;

extern int ThimExposuresMayBeComing;  /* Hint for command startup delaying */
extern data_ptr ElfRetData;
extern int AxNoMapWindows;
extern int WidgetNeedsUpdated;  /* Set when a widget needs repainted */
extern XFontStruct *Txfont;
extern unsigned long RecessPixel;       /* for OpenLook */
extern Pixmap UnknownPixmap;    /* 16x16 pixmap of unknown image */
extern AXWidget WindowList;
extern int CharWids[];
extern int SmallCharWids[]; /* of reduced dialog font */
extern AXWidget TotalWidgetsList;       /* for resource tracking */
extern win_list_t *TotalWindowsList;    /* for resource tracking */
extern int NumWindows;
extern long WinMask;
extern int THIMhelpMode;
extern context_block *ActiveTasks[MAX_PIDS+1];

#if AX_X11
extern AXWidget_combo_box ComboBoxInEditWindow;
extern void EditWinDrawCursor();
AXWidget AxPulldownActive;
extern AXWidget ListBoxArmed;
extern AXWidget MenuArmed;
extern AXWidget ScrollBarArmed;
extern AXWidget StrokingBar;
extern AXWidget ToolArmedForUpdate;
extern AXWidget TrayArmed;
extern AXWidget_editbox EditBoxArmed;
#else
extern AXWidget ToolBarButtonWidget;
#endif
AXWidget CurrentPopupButton;
extern AXWidget RibbonArmed;
extern AXWidget TableArmed;

int MenuUID;         /* counter of menu starts */
int DoubleMillisec = 500;
int DoublePixSpan = 4;
int AlwaysWide = TRUE;
int AxMarkMenuMnemonics = TRUE; /* if TRUE: underline menu key mnemonics */
int AxHideDisabledTools = FALSE;/* TRUE==> undisplay disabled toolbar buttons*/
int AxNoFocusManage = FALSE;    /* if TRUE, don't set focus unless asked to */
int AxForceFocusManage = FALSE; /* if TRUE, always tru to manage focus */
char *IconSizeStr = NXLT("50x50");
int AXTextCursorTriangle = 0;   /* app. text cursor appearance */
int AxUseGrayScale = FALSE; /* to display color images as grayscale */
int AxSuppressBackingStore = FALSE;
int AxAllowXSync = FALSE;       /* allow xsync in HandleExposures () */
extern Window AxMemoryWindow;   /* out of memory window */
extern int UseWidgetColors;    /* color available for widget kit to use */
int AxCharAbove, AxCharBelow, AxCharHeight;
extern int AxAlternateDialogFont;
int SmallCharAbove, SmallCharBelow, SmallCharHeight;
int PrintXWarnings = FALSE;
XSetWindowAttributes WinAtt;
long WinMask = CWBackPixel | CWWinGravity | CWBitGravity;
extern PIXEL_VALUE AlisPixels[];


#if BUILD_WIDE
/** wide characters use our current pseudo-font-set stuff */
XFontStruct *FontSetFontStruct();
#endif

Cursor ThimTextCursor;
int UPnumVal();
pixcache_t *Pixmapper();
Pixmap GetPixmapByName();
long ReadIntsArray();
long IntsArraySize();
unsigned long AXGetForegroundPixel();
unsigned long AXGetBackgroundPixel();
static Pixmap get50PercentStipple();

unsigned long PlaneMask = AllPlanes;    /* depth of display */

extern int AxFilterGCs;

#if AX_X11
Visual *AxVisual;
extern char *AxDisplayName;    /* Name of display from cmdline or getenv */
extern XFontStruct *Txfont, *olCursorfont, *BoldTxfont;
extern GC olClrSunButtonGC, olClrShadowButtonGC;
extern GC olClrForeButtonGC, olClrBackButtonGC, olClrRecessButtonGC;
extern GC olClrRecessPixGC, olClrInvertedRecessPixGC, olInvertedPixGC;
extern GC olButtonGC, olDisabledButtonGC;
extern AXWidget AxPulldownActive;    /* non-zero while a menubar pulldown is active */
extern int AxMenuItem;      /* current item in menuBar */
extern KeySym AxControlKeyDown; /* which control key is down, 0 if none */
extern int AxPulldownItem;  /* current item in pulldown */
extern int AxCascadeItem;   /* current item in cascade */
extern int AxPulldownStayup;    /* if TRUE: menu pulldown is in stayup mode*/
extern int PointerHasMoved; /* TRUE if pointer has moved since last set to FALSE */
/* ResetActive() exits from menu pulldown stayup mode unless asked not to */
extern int AxExitPulldownStayupMode;
/* active box in menu bar */
extern int BarBoxX,BarBoxY,BarBoxWidth,BarBoxHeight;
extern int BarBoxMenuBarIndex;
extern int _Xdebug;
int ThimXErrorHandler(), ThimXIOErrorHandler();
#endif

int WidthOfDialogZero;    /* width of "0" in standard dialog font */

int diamondSize();
int isOpaqueWidget();
static void DrawDiamond();
static void AddButtonToOptions();

void MoveSplitter();
void PaintIcon();
void PaintCorner();
void PaintMEDebugger();
void PaintGEPalette();
void PaintGExruler();
void PaintGEyruler();
void PaintColorpal();
void UpdateStatusMessage();
void paintTextDropShadow();
AXWidget backgroundWidget();

Pixmap AXCreatePixmapFromBitmapData();
extern void PaintButton();
extern void AxDrawBevel();
extern void widgetFootprint();
extern void unionRectangle();
extern void TblLiftSelectionCursor();
extern void wfDeleteGadgetSet();
extern void axtInitGCs();
extern void xmSetWidgetDisplay();
#if AX_X11
extern void CbDestroyPulldown();
#endif
extern AXWidget topWidget();
extern GC axCreateGC();
GC axGetGC();
extern void *AxRenderInsetGraphic();
extern Pixmap AXCreatePixmapFromBitmapData();

static void xmIntDrawStringW(/* AXWidget w, Drawable win, GC gc, int xpos, ypos, wchar *str, int len, data_ptr shadow, wcolor_t *color, wcolor_t *backColor */);

#if AXMS
extern HANDLE hInst;
#endif

AxSetGC2()
{
    PIXEL_VALUE fg, bg;
    XFontStruct *fp;
    char pattern[2];
    int scalable;
 
    pattern[0] = 1;
    pattern[1] = 1;
    XSetDashes(Dpy, Gc2, 0, pattern, 2);
    XSetLineAttributes(Dpy, Gc2, 0, LineDoubleDash, CapRound, JoinMiter);
    fg = AlisPixels[TMA_WHITE] ^ AlisPixels[TMA_BLACK];
    bg = AlisPixels[TMA_WHITE] ^ white_pixel_from_table();
    XSetState(Dpy, Gc2, fg, bg, GXxor, AllPlanes);
    if ( getXFontStruct(NXLT("Helvetica"), 12, 0, 0, &scalable, &fp) )
        axSetFont(Dpy, Gc2, fp);
    else
        axSetFont(Dpy, Gc2, AxDlgMiniFont);
}

/*************************************************************************
function: BasicInitialize - Startup
*/
int BasicInitialize()
{
    char *UPbyCode();
    int dex;
    XGCValues gcv;
    int i;
    int status;
    XGCValues values;
    int valueMask;
    char *p;
    int x;
    register int ix, j;
    int have_tried_secondary = FALSE;
    long mask;

/* Initialize the font information.  This sets the globals:
   "AxDlgMainFont", "AxDlgMiniFont", "MonospaceFont",
   "MonospaceBoldFont", "MonospaceItalFont", "MonospaceItalBoldFont". */

    InitFontInfo();

#if 0
/* Used to be AXMS. I've changed large fonts on NT3.51 so that they
 * are non-bold, which makes them less wide and which makes this
 * hack obsolete.    -donato
 */     
    /* the zero character on the "large" widdows dialog font is particularly */
    /* wide, which results to listboxes, and some entry areas, spilling */
    /* over to the right on top of other things.  So... lets take an average */
    /* character width instead as a way of adjusting to "small" and "large" */+     /* font mode without messing up a lot of dialog boxes                */
    WidthOfDialogZero = BasicStrlen("ABCDEFGHIJabcdefghij");
    WidthOfDialogZero = WidthOfDialogZero / 20;
#else
    WidthOfDialogZero = BasicStrlen("0");
#endif

    /* Set default GC's for a B&W device */
    valueMask = GCForeground | GCBackground | GCFont | GCGraphicsExposures;
    values.foreground = BackPixel;
    values.background = ForePixel;
    values.font = AxDlgMainFont->fid;
    values.graphics_exposures = FALSE;
    BackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                        DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                        AxDlgMainFont, valueMask, &values);
    PixmapperBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                  DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                  AxDlgMainFont, valueMask, &values);
    values.font = AxDlgMiniFont->fid;
    SmallFontBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                 DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                 AxDlgMiniFont, valueMask, &values);
    values.font = MonospaceFont->fid;
    MonospaceBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                 DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                 MonospaceFont, valueMask, &values);
    values.font = MonospaceBoldFont->fid;
    MonospaceBoldBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                     DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                     MonospaceBoldFont, valueMask, &values);
    values.font = MonospaceItalFont->fid;
    MonospaceItalBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                     DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                     MonospaceItalFont, valueMask, &values);
    values.font = MonospaceItalBoldFont->fid;
    MonospaceItalBoldBackGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                         DisplayPlanes(Dpy,DefaultScreen(Dpy)),
                                         MonospaceItalBoldFont,
                                         valueMask, &values);
    values.font = AxDlgMainFont->fid;
    values.foreground = ForePixel;
    values.background = BackPixel;
    values.graphics_exposures = TRUE;
    GXForeGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                          DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                          AxDlgMainFont, valueMask, &values);
    values.graphics_exposures = FALSE;
    ForeGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                        DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                        AxDlgMainFont, valueMask, &values);
    PixmapperForeGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                 DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                 AxDlgMainFont, valueMask, &values);
    ElfGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                       DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                       AxDlgMainFont, valueMask, &values);
    values.foreground = RecessPixel;
    RecessGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                          DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                          AxDlgMainFont, valueMask, &values);
    PixmapperRecessGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                   DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                   AxDlgMainFont, valueMask, &values);
    values.foreground = ForePixel;
    ColorSunGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                            DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                            AxDlgMainFont, valueMask, &values);
    ShadowGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                          DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                          AxDlgMainFont, valueMask, &values);
    values.font = MonospaceFont->fid;
    MonospaceGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                             DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                             MonospaceFont, valueMask, &values);
    values.font = MonospaceBoldFont->fid;
    MonospaceBoldGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                 DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                 MonospaceBoldFont, valueMask, &values);
    values.font = MonospaceItalFont->fid;
    MonospaceItalGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                 DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                 MonospaceItalFont, valueMask, &values);
    values.font = MonospaceItalBoldFont->fid;
    MonospaceItalBoldGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                     DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                     MonospaceItalBoldGC, valueMask, &values);
    values.font = AxDlgMiniFont->fid;
    SmallFontGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                             DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                             AxDlgMiniFont, valueMask, &values);
    values.font = AxDlgMainFont->fid;
    DisabledGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                            DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                            AxDlgMainFont, valueMask, &values);
    StippleGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                           DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                           AxDlgMainFont, valueMask, &values);
    if (Thim2dMode)
        SunGC = ForeGC;     /* assuming B & W */
    else
        SunGC = DisabledGC; /* assuming B & W */
    valueMask |= GCFunction | GCPlaneMask;
#if INVERTABLE
    values.fill_style = FillSolid;
    values.function = GXinvert;
    values.plane_mask = 1;
    InvertGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                          DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                          AxDlgMainFont, valueMask, &values);
#endif

/* If on a color device, change all GC's for their colors now */
    WidgetColorsFromProfile();
    AxSetGC2();

    valueMask = GCFillStyle | GCTile | GCFunction;
    values.fill_style = FillTiled;
    values.tile = UnknownPixmap = GetPixmapByName(NXLT("50_foreground"));
    values.function = GXcopy;
    axChangeGC(Dpy, DisabledGC, (XFontStruct *) 0, valueMask, &values);
    
    valueMask = GCFillStyle | GCStipple | GCFunction;
    values.fill_style = FillStippled;
    values.stipple = get50PercentStipple();
    values.function = GXcopy;
    axChangeGC(Dpy, StippleGC, (XFontStruct *) 0, valueMask, &values);

    UseGloballyActiveFocus = TestForGlobalFocusModel();

/* Create a GXinvert GC for drawing application (not widget) cursors */
    valueMask = GCForeground | GCBackground | GCFunction | GCFont |
        GCPlaneMask | GCLineStyle | GCLineWidth;
    if (ColorDisplay) {
        values.foreground = 1;
        values.plane_mask = 1;
        values.function = GXinvert;
    } else {
        values.foreground = (COLOR_WHITE) ^ (COLOR_BLACK);
        values.plane_mask = AllPlanes;
        values.function = GXxor;
    }
    values.background = 0;
    values.font = AxDlgMiniFont->fid;
    values.line_style = LineSolid;
    values.line_width = 1;
    TextCursorGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                              DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                              AxDlgMiniFont, valueMask, &values);

    valueMask |= (GCFillStyle | GCTile);
    values.fill_style = FillTiled;
    values.tile = GetPixmapByName(NXLT("50_foreground"));
    InactiveTextCursorGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                                      DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                                      AxDlgMiniFont, valueMask, &values);
    valueMask &= ~(GCFillStyle | GCTile);
    values.fill_style = FillSolid;

#if AX_X11
    WinAtt.background_pixel = BackPixel;
    WinAtt.win_gravity = NorthWestGravity;
    WinAtt.bit_gravity = ForgetGravity;
#endif

    CascadePixmap = GetPixmapByName(NXLT("menu_cascade"));
    MenuCheckPixmap = GetPixmapByName(NXLT("menu_checkmark"));
    NWidth = BasicStrlen("n");
    N2Width = NWidth * 2;
    N3Width = NWidth * 3;

    /* get basic profile info */
    p = UPbyCode(PROF_BELL_VOLUME_);    /* 0-100 bell volume */
    if (p) {
        x = atoi(p);
        ThimBellVolume = 2 * (MAX(0, MIN(100, x))) - 100;
    }
    p = UPbyCode(PROF_CLICK_SPEED_);/* double click span */
    if (p)
        DoubleMillisec = atoi(p);
    p = UPbyCode(PROF_MENU_TOGGLE_);/* checks or toggles in pulldown menus */
    if (p)
        UseChecksForToggles = (*p == '0');
    p = UPbyCode(PROF_MENU_WIDTH_); /*whether to always make room for toggles */
    if (p)
        AlwaysWide = (*p == '0');
    p = UPbyCode(PROF_MARK_MNEMONIC_);/*underline mnemonic keys (Motif menus) */
    if (p)
        AxMarkMenuMnemonics = (*p != '0');
    p = UPbyCode(PROF_SHOW_ACCELS_);/* distance at which dbl-click is too far */
    if (p)
        ShowAccelerators = (*p != '0');
    p = UPbyCode(PROF_2D_STYLE_);       /* 2d rather than 3d style */
    if (p)
        Thim2dMode = (*p != '0');
    p = UPbyCode(PROF_EL_HIDE_DISABLED_);   /* hide disabled toolbar buttons */
    if (p)
        AxHideDisabledTools = (*p != '0');
    p = UPbyCode(PROF_DLG_DECORATE_);   /* Transient mode flag for dialogs */
    if (p)
        NoTransient = (*p != '0');
    else
        NoTransient = TRUE; /* use decos */
    if (!p) {
        if (NoTransient)
            AddProfileByCode(PROF_DLG_DECORATE_, "-1");
        else
            AddProfileByCode(PROF_DLG_DECORATE_, "0");
    }
    /* should focus management be disabled? (for twm) */
    AxNoFocusManage = (UPnumVal(PROF_NO_FOCUS_MANAGE_) == -1);
    AxForceFocusManage = (UPnumVal(PROF_FORCE_FOCUS_MANAGE_) == -1);

    p = UPbyCode(PROF_ICON_SIZE_);      /* 50x50 */
    if (p && *p)
        IconSizeStr = p;

    AXTextCursorTriangle = UPnumVal(PROF_TCURSOR_TRIANGLE_);

    AxUseGrayScale = UPnumVal(PROF_GREYSCALE_);

    p = (char *) GetProfileByCode(PROF_PROG_SPEC_WIN_POS);
    if (p && atoi(p)) {
        AxProgramSpecifiedWindowPos = TRUE;
    }
    p = (char *) GetProfileByCode(PROF_SUPPRESS_BK_STORE);
    if (p && atoi(p)) {
        AxSuppressBackingStore = TRUE;
    }
    /* Allow XSync to happen in HandleExposures ().  Normally, doesn't */
    p = (char *) GetProfileByCode(PROF_ALLOW_XSYNC);
    if (p && atoi(p))
        AxAllowXSync = TRUE;

    /* prepare transfer bin */
    AxInitXferAtoms();

/* Setup cursors: This will set the globals:
   ThimTextCursor, ThimHelpCursor, ThimPointerCursor, ThimBusyCursor,
   ThimRecordCursor, ThimNoRecordCursor, ThimWPDefaultCursor,
   ThimMEDefaultCursor, ThimFleurCursor, ThimDownCursor,
   ThimLeftRightCursor, ThimTopRightCursor ThimBottomLeftCursor
   ThimBottomRightCursor, ThimRotateCursor ThimCrosshairCursor

   It also maps a default cursor to each of the application window types. */
    InitCursors();


    /* Create an unmapped "out-of-memory" window */
#if AX_X11
    {
        XSetWindowAttributes atts;
        mask = CWOverrideRedirect | CWSaveUnder | CWBackPixel;
        atts.override_redirect = TRUE;
        atts.save_under = FALSE;/* minimum resource */
        atts.background_pixel = BackPixel;

        AxMemoryWindow = AxCrtWindow(Dpy, RootWin,
                      (DpyWid - MEMWIN_WID) / 2, (DpyHt - MEMWIN_HT) / 2,
                   MEMWIN_WID, MEMWIN_HT, 0, CopyFromParent, InputOutput,
                                     CopyFromParent, mask, &atts);

        LoadDialogKeyBindings();
    }

    if (UseWidgetColors) {
        /* right now arrow stpples used only when kit is in color */
        axmCreateArrowStipples();       /* for motif scrollbars, etc. */
    }
#endif

    return (0);
}

wAux *newAuxData()
{
    wAux *aux = (wAux *) malloc(sizeof(wAux));
    memset((char *) aux, 0, sizeof(wAux));
    return aux;
}


/***************************************************************************
function: TmPokeDialogsWithData - Pass Elf data to dialogs listening for
poke code.  This does not update the toolbar.
Used mainly for performance reasons.
*/
void TmPokeDialogsWithData(w, code, aP)
AXWidget w;
int code;   /* from aos_dlgpoke.h */
data_ptr aP;/* poke data */
{

    if ( ((long)w) > 0) 
        XmPoker(code, aP, w, FALSE, TRUE);
}

/***************************************************************************
function: TmHavePokeListeners - Return whether anyone is listening to passed
poke code.
*/
int TmHavePokeListeners(wId, code)
int wId;    /* ATM window ID */
int code;   /* from aos_dlgpoke.h */
{
    AXWidget w;

    if ((wId > 0) && (wId < TM_MAXWIN)) {
        w = WidgetOfWindow(wId);
        return (XmPoker(code, w, NULL, TRUE, FALSE));
    }
    return (FALSE);
}

/***************************************************************************
function: XmPoker - Do poke or just retrun whether would have poked
*/
XmPoker(code, aP, mw, no_wait, do_the_poke)
register int code;      /* from aos_dlgpoke.h */
register data_ptr aP;   /* additional info */
register AXWidget_main mw;
register int do_the_poke;/* If FALSE, just return whether would have poked */
{
    register AXWidget_main tw;
    register AXWidget_dialog w;
    register int poked = FALSE;
    register int asize, ix, pid;
    data_ptr arrP, subP;
    context_block *cP;

    for (tw = (AXWidget_main)WindowList; tw; tw = (AXWidget_main)tw->nextWin) {
        if ((tw->type == W_MAIN) && tw->dialog) {
            if (!mw || (tw == mw) || (tw->parent == mw)) {
                /* poke codes stored in dialog portion */
                w = (AXWidget_dialog)tw->dialog;
                if (code == POKE_MENU_BAR)
                    goto doit;
                if (code == POKE_DIALOG_RESIZED) {
                    if (mw == tw)       /* accept only if addressed directly */
                        goto doit;
                }
                if (do_the_poke && (code == POKE_DESTROY_ALL)) {
                    KillTask(w->taskOwner);
                    continue;
                }
                asize = IntsArraySize(w->pokeCodes);
                for (ix = 0; ix < asize; ix++) {    /* see if code in pokes */
                    if (code == ReadIntsArray(w->pokeCodes, ix))
                        break;
                }
                if (ix == asize)/* code not found */
                    continue;
doit:
                if (!do_the_poke)
                    return (TRUE);
                if (w->callbacktag) {
                    if (w->elfObject) {
                        /* pack this as a object event of type "poke_" */
                        subP = AxMakeArray(0);
                        subP = AxAddIntToArray(subP, 0, code);  /* poke code */
                        subP = AxWriteArray(subP, 1, ElfDataCopy(aP));  /* poke data */

                        arrP = AxMakeArray(0);
                        arrP = AxWriteArray(arrP, 0, ElfDataCopy(w->elfObject));
                        arrP = AxAddStrToArray(arrP, 1, NXLT("poke_"));
                        arrP = AxWriteArray(arrP, 2, subP);
                        SendElfData(w->callbacktag, POKE_OBJECT_THROW, arrP);
                        AxFreeData(arrP);
                    }
                    else {
#if 0
                        arrP = AxMakeArray(2);
                        AxAddIntToArray(arrP, 0, (int) w->parent);
                        AxAddArrayToArray(arrP, 1, ElfDataCopy(aP));
						/*is this a typo?? */
                        SendElfData(w->callbacktag, code, arrP);
                        AxFreeData(arrP);
#else
                        SendElfData(w->callbacktag, code, aP);
#endif
                    }
                }
                poked = TRUE;
            }
        }
    }

    for (pid = 0; pid < MAX_PIDS; ++pid) {
        cP = &TaskInfo[pid];

        if (!cP->in_use)
            continue;

#if 0
        if (code == POKE_MENU_BAR || code == POKE_DIALOG_RESIZED)
            goto tdoit;
#endif

        if (do_the_poke && (code == POKE_DESTROY_ALL)) {
            KillTask(pid);
            continue;
        }

        asize = AxArraySize(cP->pokeCodes);
        for (ix = 0; ix < asize; ix++) {    /* see if code in pokes */
            if (code == AxIntFromArray(cP->pokeCodes, ix))
                break;
        }
        if (ix == asize)/* code not found */
            continue;

    tdoit:
        if (!do_the_poke)
            return (TRUE);

        SendElfData(pid, code, aP);

        poked = TRUE;
    }

    if (poked && no_wait == FALSE && do_the_poke)
        XmPutHourglass();

    return (poked);
}


/***************************************************************************
function: TmPokeParasiteDialogs - Poke all dialogs whose parent pid is 'parent'
*/
void TmPokeParasiteDialogs (parent, code, str)
int parent;
int code;
char *str;
{
    data_ptr aP = AxMakeStrData(-1,str);
    int pid;
    for (pid = 0; pid < MAX_PIDS; ++pid) {
        context_block *cP = &TaskInfo[pid];
        int ix;
        if (!cP->in_use || (cP->parasite_of != parent) 
            || cP->javaChannel != TaskInfo[parent].javaChannel)
            continue;
        for (ix = AxArraySize(cP->pokeCodes)-1; ix >= 0; --ix) {
            if (code == AxIntFromArray(cP->pokeCodes, ix)) { /* code in pokes */
                SendElfData(pid, code, aP);
                break;
            }
        }
    }
    AxFreeData(aP);
}


/*************************************************************************
function: AxMtOlVal - Extract Motif/OpenLook x/y value
*/
AxMtOlVal(arr)
data_ptr arr;
{
    if (!arr)
        return (0);
    if (ElfbIsArray(arr)) {
        return (IntFromArray(arr, 0));
    } else
        return (IntFromDataPtr(arr));
}

#if 0           /* { future extension, do not delete - Babu */
#if AX_X11      /* {  */
/***************************************************************************
function: AxGetVisualAndDepth - sets AxVisual and DpyDepth, based on profile
switches. If there is no matching visual found for given profile info
        default visual and default depth are used.
*/
void AxGetVisualAndDepth(display)
Display *display;
{
    char *profile, *GetProfileByCode();
    int class;
    int depth;
    XVisualInfo *v, *visualList;
    unsigned long vTemplateMask;
    XVisualInfo vTemplate;
    int nVisuals;

    /* assume no profiles */
    class = (-1);
    depth = (-1);

    /* set to defaults */
    AxVisual = DefaultVisual(display, DefaultScreen(display));
    DpyDepth = DisplayPlanes(display, DefaultScreen(display));

    /* get profile for visual class */
    profile = GetProfileByCode(PROF_VISUAL_CLASS_);
    if (profile && *profile) {
        if (!strncasecmp(profile, NXLT("DirectColor"), strlen(NXLT("DirectColor"))))
            class = DirectColor;
        else if (!strncasecmp(profile, NXLT("TrueColor"), strlen(NXLT("TrueColor"))))
            class = TrueColor;
        else if (!strncasecmp(profile, NXLT("PseudoColor"), strlen(NXLT("PseudoColor"))))
            class = PseudoColor;
        else if (!strncasecmp(profile, NXLT("StaticColor"), strlen(NXLT("StaticColor"))))
            class = StaticColor;
        else if (!strncasecmp(profile, NXLT("GrayScale"), strlen(NXLT("GrayScale"))))
            class = GrayScale;
        else if (!strncasecmp(profile, NXLT("StaticGray"), strlen(NXLT("StaticGray"))))
            class = StaticGray;
    }
    /* get profile for visual depth */
    profile = GetProfileByCode(PROF_VISUAL_DEPTH_);
    if (profile && *profile)
        depth = atoi(profile);

    if (class == (-1) && depth == (-1)) /* no profiles, use defaults */
        return;

    /* get all the visuals of given depth defined on the default screen by X */
    vTemplateMask = 0;
    vTemplate.screen = DefaultScreen(display);
    vTemplateMask |= VisualScreenMask;
    if (class >= 0) {
        vTemplate.class = class;
        vTemplateMask |= VisualClassMask;
    }
    if (depth > 0) {
        vTemplate.depth = depth;
        vTemplateMask |= VisualDepthMask;
    }
    visualList = XGetVisualInfo(display, vTemplateMask, &vTemplate, &nVisuals);

    /* if no matching visuals found, use defaults */
    if (!nVisuals || !visualList)
        return;

    AxVisual = visualList[0].visual;
    DpyDepth = visualList[0].depth;

    /* free X memory */
    XFree((char *) visualList);

    return;
}

#endif          /* } */
#endif          /* } future extension, do not delete - Babu */

/*
function: AxGetDpyAndGCs - Display Display info and create FGpixel & BGpixel
          There are sections for X-Windows and MS-Windows.  Both sections
          should set the same global variables to something "reasonable"
*/
void AxGetDpyAndGCs()
{
    XGCValues gcv;
    XClassHint classhint;
#if AXMS
    HDC hdcInfo;
#else
    XSizeHints xsh;
    wchar start_win_name[20];
#endif


    if (Dpy != NULL) {
        return;
    }

#if AXMS            /*  {  */

    hdcInfo = MS_CreateDC(NXLT("DISPLAY"), NULL, NULL, NULL);
    DpyDepth = MS_GetDeviceCaps(hdcInfo, PLANES) *
                    MS_GetDeviceCaps(hdcInfo, BITSPIXEL);
    if ( DpyDepth < 8 )
        {
        MS_MessageBox( (HWND)NULL, 
                 XLT("Applixware requires a minimum of 256 colors"),
                 NXLT("Applixware"), MB_OK);
        exit(1);
        }

    DpyWid = MS_GetDeviceCaps(hdcInfo, HORZRES);
    DpyHt = MS_GetDeviceCaps(hdcInfo, VERTRES);
    CreateScratchPixmap(Dpy, hdcInfo, DpyWid, DpyHt, DpyDepth);
    MS_DeleteDC(hdcInfo);

    Dpy = (Display *) 1;        /* a non-valid, but non-null value */

/*  gcv.foreground = COLOR_BLACK; */
/*  gcv.background = COLOR_WHITE; */

    /* initialize the colormap, if required */
    InitColormap(0);

    BackPixel = COLOR_WHITE;
    ForePixel = COLOR_BLACK;

#endif          /*  }  AXMS */


#if AX_X11      /*  {  */
    
    if (Dpy != NULL) {
        return;
    }
    /* register standard colormap */
    AxRegisterStandardColormap();

    if (getenv("AXDEBUG"))
        _Xdebug = True;

#if SUPPORT_HP_VUE
    /* init real toolkit (which opens display) */
    AxRealXtToolkitInitialize();
#else
    /* open the server's default display */
    Dpy = XOpenDisplay(AxDisplayName);
#endif
    if (!Dpy) {
        printf(XLT2("xmlibcom-[1]","Could not open X display!\n"));
        printf(XLT2("xmlibcom-[2]","Your display is set to %s\n"), AxDisplayName);
        printf(XLT2("xmlibcom-[3]","The X server does not seem to recognize this.\n"));
        AxExit(0);
    }

    if (ServerVendor(Dpy)) {
        /* init hackvar WeThinkItsAIX, to avoid a focus-cycling problem
         * found there.  (starts with a WM_TAKE_FOCUS msg containing a
         * 0-timestamp)
         */
        WeThinkItsAIX =
            NULL != strstr(ServerVendor(Dpy),
                           NXLT("International Business Machines"));
    }
    
    if (getenv("AXWARNINGS"))
        PrintXWarnings = TRUE;
    else
        PrintXWarnings = FALSE;

    /* set up error handling */
    XSetErrorHandler(ThimXErrorHandler);
    XSetIOErrorHandler(ThimXIOErrorHandler);

    /* extract display dimensions */
    DpyWid = DisplayWidth(Dpy, DefaultScreen(Dpy));
    DpyHt = DisplayHeight(Dpy, DefaultScreen(Dpy));
    DpyDepth = DisplayPlanes(Dpy, DefaultScreen(Dpy));
    AxVisual = DefaultVisual(Dpy, DefaultScreen(Dpy));
    RootWin = DefaultRootWindow(Dpy);

    /*  initialize the colormap,
                sets cmap to default/private/standard colormap
        */
    InitColormap(DefaultRootWindow(Dpy));       /* sets cmap */

#if 0           /* { future extension, do not delete - Babu */
    {
        unsigned long valueMask;
        XSetWindowAttributes atts;

        AxGetVisualAndDepth(Dpy);

        /* InitColormap(DefaultRootWindow(Dpy)); */

        valueMask = CWColormap;
        atts.colormap = cmap;

        RootWin = AxCrtWindow(Dpy, DefaultRootWindow(Dpy), 0, 0, DpyWid, DpyHt,
                   0, DpyDepth, InputOutput, AxVisual, valueMask, &atts);
        XSetWindowColormap(Dpy, RootWin, cmap);

    }
#endif          /* } future extension, do not delete - Babu */

    /* Create an unmapped initial window */
    xsh.flags = PSize;
    if (AxProgramSpecifiedWindowPos) {
        xsh.flags |= PPosition;
    } else {
        xsh.flags |= USPosition;
    }
    xsh.width = 100;
    xsh.height = 100;
    xsh.x = 0;
    xsh.y = 0;
    CreateScratchPixmap(Dpy, RootWin, DpyWid, DpyHt, DpyDepth);
    AxDummyWin = AxCrtSimpleWindow(Dpy, RootWin,
                                   xsh.x, xsh.y, xsh.width, xsh.height,
                                   2, FGpixel, BGpixel);
    MbToWStr(NXLT("Applix"), start_win_name);
    AxSetWindowProperties(Dpy, AxDummyWin, (AXWidget) NULL,
                          NXLT("Applix"), start_win_name, None, &xsh);

    /* create graphics context */
    FGpixel = BlackPixel(Dpy, DefaultScreen(Dpy));
    BGpixel = WhitePixel(Dpy, DefaultScreen(Dpy));
    ForePixel = FGpixel;
    BackPixel = BGpixel;
    gcv.foreground = FGpixel;
    gcv.background = BGpixel;
    gcv.plane_mask = AxPlaneMask;
    AxColorGC = axCreateGC(Dpy, AxDummyWin, DefaultScreen(Dpy),
                           DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                           (XFontStruct *) 0,
                           (GCForeground | GCBackground | GCPlaneMask), &gcv);

    xsh.flags = (PPosition | PSize);
    xsh.width = 900;
    xsh.height = 800;
    xsh.x = 50;
    xsh.y = 50;

    /* create a phantom (never mapped) window */
    AxTopWinNeverMapped = XCreateSimpleWindow(Dpy, DefaultRootWindow(Dpy),
                                              xsh.x, xsh.y, xsh.width,
                                              xsh.height, 2, FGpixel, BGpixel);
#if QATOOL
    /* lance */
    QaRegisterWindow(Dpy, AxTopWinNeverMapped);
#endif
    XSetStandardProperties(Dpy, AxTopWinNeverMapped, NXLT("Applix"), NXLT("Applix"), None,
                           NULL, 0, &xsh);

#endif          /*  }  AX_X11 */

    /* create graphics context */
    BGpixel = COLOR_WHITE;
    FGpixel = COLOR_BLACK;
    if (ColorDisplay)
        ToggleFG = 0;
    else if (ToggleFG) {
        /* The ToggleFG switch is a command to flip pixel vals */
        FGpixel = COLOR_WHITE;
        BGpixel = COLOR_BLACK;
    }
    gcv.foreground = FGpixel;
    gcv.background = BGpixel;
    gcv.plane_mask = PlaneMask;
    Gc1 = axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                     DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                     (XFontStruct *) 0,
                     GCForeground | GCBackground | GCPlaneMask, &gcv);
    Gc2 = axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                     DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                     (XFontStruct *) 0,
                     GCForeground | GCBackground | GCPlaneMask, &gcv);

    
    /* Get express line stuff */
    ToolbarButtonSep = UPnumVal(PROF_ELINE_GAP);
    if (ToolbarButtonSep <= 0)
        ToolbarButtonSep = 2;
    ToolbarExtraSep = UPnumVal(PROF_ELINE_SEP);
    if (ToolbarExtraSep <= 0)
        ToolbarExtraSep = 25;
    
    allocatePixels();
    InitApplicationColors();
    initAlisPixels();
    
    axtInitGCs(AxTopWinNeverMapped);

    /* finally, initialize a bunch of font stuff etc. */
    BasicInitialize();
}

/* 'aux' data is an optional appendage of AXWidget instances
 */
void removeAuxData(w)
AXWidget w;
{
    wComposite *cp, *tcp;
    void deleteCompositeLink();
    int me = THIMpid;

    if (!w || !w->auxData) {
        return;
    }
    for (cp = w->auxData->compositeList; cp; cp = tcp) {
        tcp = cp->next;
        deleteCompositeLink(w, cp);
    }
    if (w->auxData->wEdit.old) {
        destroyCloneWidget(w->auxData->wEdit.old);
    }
    if (w->auxData->gadget) {
        VfyContext(w->parent->taskOwner);   /* needless paranoia, perhaps */
        AxFreeData(w->auxData->gadget);
        VfyContext(me);
    }
    free((char *) w->auxData);
    w->auxData = (wAux *) NULL;
}

int addCompositeLink(w, type, toWidget)
AXWidget w;
int type;
AXWidget toWidget;
{
    wComposite *cp, *lcp = (wComposite *) NULL;
    wAux *newAuxList();
    wComposite *newCompositeLink();
    if (!w->auxData) {
        w->auxData = newAuxData();
    }
    /* first see whether an identical link is already recorded */
    for (cp = w->auxData->compositeList; cp; cp = cp->next) {
        if (cp->w == toWidget && cp->type == type)
            return TRUE;
        lcp = cp;
    }
    if (lcp) {
        lcp->next = newCompositeLink(toWidget, type);
    } else {
        w->auxData->compositeList = newCompositeLink(toWidget, type);
    }
    return TRUE;
}

wComposite *
newCompositeLink(w, type)
AXWidget w;
int type;
{
    wComposite *nc = (wComposite *) malloc(sizeof(wComposite));
    nc->w = w;
    nc->type = type;
    nc->next = (wComposite *) NULL;
    return nc;
}

void 
deleteCompositeLink(w, cdel)
AXWidget w;
wComposite *cdel;               /* link that's being deleted */
{
    wComposite *cp; /* this element */
    wComposite *lcp;    /* last element */
    wComposite *tcp;
    if (!cdel)
        return;
    if (cdel->w && cdel->w->auxData && !cdel->w->destroyed) {
        /* (note destroyed bit test unreliable, but..) */
        cp = lcp = tcp = cdel->w->auxData->compositeList;
        for (; cp; cp = tcp) {
            tcp = cp->next;
            if (cp->w == w) {
                /* remove reference to w from the other guy's list */
                if (cp != cdel->w->auxData->compositeList) {
                    lcp->next = cp->next;
                } else {
                    cdel->w->auxData->compositeList = cp->next;
                }
                free((char *) cp);
            }
            else {
                lcp = cp;
            }
        }
    }
    free((char *) cdel);
}

void removeCompositeList(w)
AXWidget w;
{
    wComposite *cp, *tcp;
    if (w->auxData) {
        for (cp = w->auxData->compositeList; cp; cp = tcp) {
            tcp = cp->next;
            free((char *) cp);
        }
        w->auxData->compositeList = (wComposite *) NULL;
    }
}

BasicStrlen(p)
register char *p;
{
    register int len = 0;

#if BUILD_WIDE
	len = AXTextWidth(AxDlgMainFont, p, strlen(p));
#else
    while (*p)
        len += CharWids[*p++ & 0xFF];
#endif
    return (len);
}


SmallBasicStrlen(p)
register char *p;
{
    register int len = 0;
#if BUILD_WIDE
	len = AXTextWidth(AxDlgMiniFont, p, strlen(p));
#else
    while (*p)
        len += SmallCharWids[*p++ & 0xFF];
#endif
    return (len);
}

/***********************************************************************
function: GetAnyCharWidth - Get the width of a character in the dialogs.
Assumes the font used in the dialogs.
Note: since this function gets passed a value as an integer it is not
sensitive to the size of a character
*/
int GetAnyCharWidth(font, char_val)
XFontStruct *font;
int char_val;
{
    register int result;
    wchar str[2];
    char nstr[2];
    XFontStruct *fs;
    
    if (!font) {
        fs = AxDlgMainFont;
    }
    else {
        fs = font;
    }

#if !BUILD_WIDE
    nstr[0] = (char) char_val;
    nstr[1] = (char) 0;
    result = AXTextWidth(fs, nstr, 1);
#else
    str[0] = char_val;
    str[1] = 0;

    result = AXWTextWidth(fs, str, 1);
#endif
    return (result);
}

void AddToWindowList(w)
register AXWidget w;
{
    register AXWidget bp;

    for (bp = WindowList; bp; bp = bp->nextWin) {
        if (bp == w)
            return;
    }

    w->nextWin = WindowList;
    WindowList = w;
}

void ClipFromWindowList(w)
register AXWidget w;
{
    register AXWidget bp;
    int found = 0;              /* leak-fix */

    if (WindowList == w) {
        WindowList = w->nextWin;
        found = 1;              /* leak-fix */
    } else {
        for (bp = WindowList; bp; bp = bp->nextWin) {
            if (bp->nextWin == w) {
                bp->nextWin = w->nextWin;
                found = 1;      /* leak-fix */
                break;
            }
        }
    }

#if ZEROED_MEM
    if (!found)             /* leak-fix */
        printf(NXLT("ClipFromWindowList: widget @ 0x%lx NOT FOUND!!\n"), w);
#endif
}



/*************************************************************************
function: ThimDestroyChildDialogs - Kill off orphaned dialogs boxes and tasks
*/
void ThimDestroyChildDialogs(parent)
AXWidget_main parent;
{
    AXWidget_main mw;
    WIDGET_PARANOID( parent, W_MAIN );

    for (mw = (AXWidget_main)WindowList; mw; mw = (AXWidget_main) mw->nextWin) {
        if ((mw->type == W_MAIN) && mw->dialog)
            if ((mw->parent == parent) && (mw != parent))
                KillTask(mw->taskOwner);    /* side effect: destroys box */
    }
}



/************************************************************
function: XmMenuStatus - Set status flags for a menu option
*/
void XmMenuStatus(w, val, str)
AXWidget_main w;    /* of dialog box */
int val;            /* from aos_menudef.h */
char *str;          /* function to apply status to */
{
    menu_opt_status *mop;
    menu_item_def *mP;
    AXWidget childP;
    int display_it, ix;

    if (!w || (w->type != W_MAIN))      /* sanity check */
        return;

    for (mop = w->menu_status; mop; mop = mop->next) {
        if (streq(mop->name, str)) {
            mop->status = val;
            goto do_tool;
        }
    }
    mop = (menu_opt_status *) malloc(sizeof(menu_opt_status));
    mop->next = w->menu_status;
    w->menu_status = mop;
    mop->status = val;
    mop->name = strcpy(malloc(strlen(str) + 1), str);
    mop->item_name = NULL;

/* update the state of the toolbar button */

do_tool:
    w = (AXWidget_main) w->toolBar;
    if (!w)
        return;

    for (ix = 0; ix < MAX_TOOLBAR_ITEMS; ix++) {
        mP = ((AXWidget_tool) w)->toolBarInfo->menuP[ix];
        if (!mP)                /* end of list, done */
            break;
        if (mP->type == ITEM_LINE)
            continue;           /* separator */
        if (!streq(mP->word2, str))
            continue;
        childP = ((AXWidget_tool) w)->toolBarInfo->widgets[ix];
        if (!childP)
            continue;           /* sanity */
        if (val == MENUSTAT_NO_SHOW) {
            if (childP->display) {
                childP->display = FALSE;
                childP->update_widget = TRUE;
                WidgetNeedsUpdated = TRUE;
            }
            break;
        } else {
            display_it = (val == MENUSTAT_INACTIVE ? FALSE : TRUE);
        }
        if (AxHideDisabledTools) {
            if (childP->display != (unsigned int) display_it) {
                if (childP->display == FALSE) {
                    /* don't change status if button not in visible row */
                    if ((childP->ypos + childP->height) > w->height)
                        return;
                }
                childP->display = display_it;
                childP->update_widget = TRUE;
                WidgetNeedsUpdated = TRUE;
            }
        } else {
            if (!childP->display) {
                /* may have been undisplayed earlier */
                childP->display = TRUE;
                childP->update_widget = TRUE;
                WidgetNeedsUpdated = TRUE;
            }
            if (childP->disabled == (unsigned int) display_it) {
                childP->disabled = !display_it;
                childP->update_widget = TRUE;
                WidgetNeedsUpdated = TRUE;
            }
        }
        if (childP->display && !childP->disabled) {
            if ((val == MENUSTAT_TOGGLE_ON) || (val == MENUSTAT_RADIO_ON))
                val = TRUE;
            else
                val = FALSE;
            if (((AXWidget_radio) childP)->value != val) {
                ((AXWidget_radio) childP)->value = val;
                childP->update_widget = TRUE;
                WidgetNeedsUpdated = TRUE;
            }
        }
        break;
    }
}


/***************************************************************************
function: XmMenuItemName - Set name of the menu item.
*/
void XmMenuItemName (w, func, item_name)
AXWidget_main w;    /* of dialog box */
char *func;         /* function to apply item name */
char *item_name;    /* new menu item name */
{
    menu_opt_status *mop;

    if (!w || (w->type != W_MAIN))      /* sanity check */
        return;

    for (mop = w->menu_status; mop; mop = mop->next) {
        if (streq(mop->name, func)) {
            if (mop->item_name)
                free(mop->item_name);
            mop->item_name = strcpy(malloc(strlen(item_name)+1),item_name);
            return;
        }
    }
    mop = (menu_opt_status *) malloc(sizeof(menu_opt_status));
    mop->next = w->menu_status;
    w->menu_status = mop;
    mop->name = strcpy(malloc(strlen(func)+1), func);
    mop->status = 0;    /* Normal */
    mop->item_name = strcpy(malloc(strlen(item_name)+1),item_name);
}


/*************************************************************************
function: AxCreatePushButtonGadget - Create a verb button
Note -- same as AXmCreatePushButtonGadget except for new passed arg
values. in the process of changing over...  need to include color, font,
width, height, ..  what's wrong with the XtArg list of old?
*/
AXWidget_pushbutton
AxCreatePushButtonGadget(parentWidget, name, old_widget, flags,
                         callback_func, pid, button, pixmapLabel,
                         alternatePixmap, xpos, ypos, value, arm_callback)
register AXWidget parentWidget;
register char *name;
AXWidget old_widget; /* used to be int!! -- sanjay*/
int flags;
void (*callback_func) ();
caddr_t pid;
int button;
int pixmapLabel;
char *alternatePixmap;
int xpos, ypos, value, arm_callback;
{
    register AXWidget_pushbutton w;
    
    if (old_widget) {
        w = (AXWidget_pushbutton) old_widget;
        if (flags & WFLG_NODISPLAY)
            UnMapWidget(w);
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else {
        w = (AXWidget_pushbutton)CrtWidget(W_BUTTON, parentWidget, name);
    }
    
    w->painter = PaintButton;

    SetWidgetFlags(w, flags);
    w->callback = callback_func;
    w->pixmapLabel = pixmapLabel;
    w->whichButton = button;
    w->callbacktag = pid;
    free(w->alternatePixmap);
    if (alternatePixmap)
        w->alternatePixmap = strcpy(malloc(strlen(alternatePixmap) + 1),
                                    alternatePixmap);
    else
        w->alternatePixmap = (char *) NULL;
    w->xpos = xpos;
    w->ypos = ypos;

    if (value >= 0) {
        w->update_widget = WidgetNeedsUpdated = value;
        w->value = value;
    }

#if !AXMS
    if (arm_callback)
        w->arm_callback = TRUE;
#endif

    wVerbButtonSize(w->name, w->pixmapLabel, w->font,
                    w->thickness, w->shadow, w->textShadow,
                    &w->width, &w->height);

    return ((AXWidget_pushbutton) w);
}

/*************************************************************************
function: ZXmCreateDebug - Create a debug panel for macro editor
*/
AXWidget ZXmCreateDebug(parentWidget)
register AXWidget_main parentWidget;
{
    register AXWidget_debug w;

    WIDGET_PARANOID( parentWidget, W_MAIN );
    w = (AXWidget_debug)CrtWidget(W_DEBUG, parentWidget, "");
    parentWidget->debug = w;
    w->painter = PaintMEDebugger;
    AddToWindowList(w);
    return ((AXWidget) w);
}

/*************************************************************************
function: AddButtonToOptions - Add a new pushbutton
*/
static void
AddButtonToOptions(w, bP)
register AXWidget_option w;
register AXWidget_togglebutton bP;
{
    WIDGET_PARANOID( w, W_OPTION );
    w->num_buttons++;
    w->buttons = (AXWidget_togglebutton *) realloc(w->buttons,
                         w->num_buttons * sizeof(AXWidget_togglebutton));
    w->buttons[w->num_buttons - 1] = bP;
    bP->in_option = w;
}

/************************************************************************
function:  AxDialogsList - Return list of currently running dialogs
             List format: <<dlg1title>,<dlg1uid>>,<<dlg2title>,<dlg2uid>>,..
*/
data_ptr
AxDialogsList()
{
    register AXWidget_main tw;
    register AXWidget_dialog dlg;
    register data_ptr element;
    data_ptr dlist;
    int numDlgs;
    data_ptr eb1ElfWinInfo();

    dlist = AxMakeArray(0);
    numDlgs = 0;

    if (TaskIsJavaBased(THIMpid)) {
        JVDialogsList(&dlist, &numDlgs);
    }
    
    for (tw = (AXWidget_main)WindowList;tw;tw = (AXWidget_main)tw->nextWin) {
        if (tw->type == W_MAIN && tw->dialog) {
            dlg = (AXWidget_dialog)tw->dialog;
            if (TaskInfo[dlg->taskOwner].in_use)
            {
                element = MkArray(4);
                AxAddIntToArray(element, 0, dlg->window_uid); /* widget uid */
                AxAddStrToArray(element, 1, dlg->parent->name); /* title */
                AxAddIntToArray(element, 2, dlg->style);  /* read "icon id" */
                AxAddIntToArray(element, 3, ThimUIDPid(dlg->taskOwner));/*uid*/
                dlist = AxAddArrayToArray(dlist, numDlgs, element);
                numDlgs++;
            }
        }
    }
    return (dlist);
}

void AXmFreeString(p)
String p;
{
    free(p);
}

AXWidget AXtParent(w)
AXWidget w;
{
    return ((AXWidget) (w->parent));
}

void AxXmEditBoxResetEdited(w_dataP)
data_ptr w_dataP;
{
    AXWidget_editbox w;

    w = (AXWidget_editbox)WidgetPointerFromHandleData(w_dataP);
    w->changed = FALSE;
}


/*************************************************************************/
void UpdateStatusMessage(w)
AXWidget_status w;
{
    XRectangle rect[1];
    int yoffset;

    WIDGET_PARANOID( w, W_STATUS );
    
    if (UseWidgetColors) {
        XFillRectangle(Dpy, w->window, RecessGC, 2, 2,
                       w->width - 4, w->height - 4);
    }
    else {
        XFillRectangle(Dpy, w->window, BackGC, 2, 2,
                       w->width - 4, w->height - 4);
    }
    rect[0].x = 3;
    rect[0].y = 3;
    rect[0].width = w->width - 6;
    rect[0].height = w->height - 6;
    XSetClipRectangles(Dpy, SmallFontGC, 0, 0, rect, 1, Unsorted);
    if ((MBstrlen(w->name) == 0) && w->permStatus) {
        SetWidgetName(w, w->permStatus);
    }

#if AXMS
    if ( AxStatusLineFont )
        {
        MS_SendMessage(w->winid, WM_SETFONT, (WPARAM)AxStatusLineFont->fid, 
                                                        (LPARAM)FALSE);
        }
    MS_SetWindowText(w->winid, w->name);
#else
    yoffset = AxStatusLineFont->max_bounds.ascent + 2;
    axSetFont(Dpy, SmallFontGC, AxStatusLineFont);
    axDrawString(Dpy, w->window, SmallFontGC, (XFontStruct *) 0,
                 w->xpos + 10, w->ypos + yoffset,
                 w->name, MBstrlen(w->name));
    axSetFont(Dpy, SmallFontGC, AxDlgMiniFont);   /* restore */
#endif
    XSync(Dpy, FALSE);
    XSetClipMask(Dpy, SmallFontGC, None);
}

/*************************************************************************
function: XmUpdateStatusMessage - Update the status line assciated with a window
*/
XmUpdateStatusMessage (w,text,code)
AXWidget_main w;        /* main widget */
char *text;
int code;
{
    static XtCallbackRec Callback[2];   /* standard template */
    Arg arg[20];

    WIDGET_PARANOID( w, W_MAIN );
    if ( w->statusArea )
    {
        AXWidget_status w_status;
        w_status = (AXWidget_status)w->statusArea;
        if ( streq(w_status->name,text) )
            return;
        SetNWidgetName(w_status, text, MAX_NAME);
#if 0
        w_status->helpid = code;
        CALLBACKER(Callback,StatusHelpPushed,code);
        XtSetArg(arg[0],XmNactivateCallback,Callback);
        AxXtSetValues(w_status,arg,1);
#endif
        UpdateStatusMessage(w_status);
    }
}

/*************************************************************************
function: XmUpdatePermStatusMessage - Update the status line assciated with a
window
*/
void XmUpdatePermStatusMessage(w, text, code)
AXWidget_main w;                /* main widget */
char *text;
int code;
{
    char str[MAX_NAME + 1];
    AXWidget_status w_status;

    if (!w || (w->type != W_MAIN))
        return;
    if (w->statusArea)
        w_status = w->statusArea;
    else
        return;

    strncpy(str, text, MAX_NAME);
    str[MAX_NAME] = 0;
    if (streq(str, w_status->name))
        return;
    free(w_status->permStatus);
    w_status->permStatus = strcpy(malloc(strlen(str) + 1), str);

    SetWidgetName(w_status, str);
    UpdateStatusMessage(w_status);
}


/*************************************************************************
function: AxXtManageChild - Map a widget
*/
void AxXtManageChild(p)
register AXWidget p;
{
    p->managed = TRUE;
}

/*************************************************************************
function: AxXtManageChildren - Map array of widgets
*/
void AxXtManageChildren()
{
}

/*************************************************************************
function: KillTasksDialogs - Kill off all dialogs created by this task
*/
void KillTasksDialogs (pid)
int pid;
{
    AXWidget w, next;

    for (w = WindowList; w; w = next) {
        next = w->nextWin;
        if ( (w->type == W_MAIN) && ((AXWidget_main) w)->dialog &&
             (w->taskOwner == pid) && !IsWinInfoBox(w->window) )
                AxDestroyWidget(w);
    }
    AxDestroyInfoBox(pid, NULL);    /* now toss task's info message(s) */
}



Window AxXtWindow(w)
AXWidget w;
{
    return (w->window);
}

/*************************************************************************
function: IsCommandAvailable - Return whether command is grayed out (ATM)
*/
IsCommandAvailable(atm_win, name)
int atm_win;
char *name;
{
    AXWidget w;

    w = WidgetOfWindow(atm_win);
    return (AxIsCommandAvailable(w, name));
}

/*************************************************************************
function: AxIsCommandAvailable - Return whether command is grayed out
*/
AxIsCommandAvailable(w, name)
AXWidget w;
char *name;
{
    static menu_item_def tmp;
    int code;

    if (!w || !name)
        return (FALSE);

    tmp.word2 = name;
    code = FlagsFromApp(w, &tmp, FALSE);
    if ((code == MENUSTAT_INACTIVE) || (code == MENUSTAT_NO_SHOW))
        return (FALSE);
    else
        return (TRUE);
}

/*************************************************************************
function: XmRestructureWindow - Assemble window from current widgets
*/
void XmRestructureWindow(w)
AXWidget_main w;
{
    WIDGET_PARANOID( w, W_MAIN );
#if AXMS
    RebuildGDIWindow(w, NULL);
#else
    RebuildMainWindow(w, NULL);
#endif
}


/*************************************************************************
function: XmPokeDialogs - Send a poke message (as AxPokeDialogs)
*/
void XmPokeDialogs(code, str, mw, use_hourglass)
register int code;              /* from aos_dlgpoke.h */
register char *str;         /* additional info */
register AXWidget mw;
register int use_hourglass;
{
    data_ptr aP;

    if (!str)
        str = "";
    if ((code == POKE_MENU_BAR) && streq(str, "0")) {
        /* update dialog key bindings */
        LoadDialogKeyBindings();
        return;
    }
    aP = AxMakeStrData(-1, str);
    XmPoker(code, aP, mw, use_hourglass, TRUE);
    AxFreeData(aP);
}


/***********************************************************************
function: WrappedPokeDialogs - Send a poke message to dependent dialogs.
Also query app to update toolbar display (don't update toolbar display
for broadcast pokes - app may have exited).
*/
void WrappedPokeDialogs(w, code, str, use_hourglass)
AXWidget w;
int code;                       /* from aos_dlgpoke.h */
char *str;                      /* additional info */
{

    if ( ((long)w) > 0) {
        XmPokeDialogs(code, str, w, use_hourglass);
        if (code != POKE_DESTROY_ALL)
            UpdateToolBarDisplay(w);
    } else {
        XmPokeDialogs(code, str, (AXWidget)NULL, use_hourglass);
    }
}

TmQuietPokeDialogs (w,code,str)
AXWidget w;
int code;       /* from aos_dlgpoke.h */
char *str;      /* additional info */
{
    WrappedPokeDialogs (w, code,str,TRUE);
}


/***********************************************************************
*/
void TmPokeDialogs(w, code, str)
AXWidget w;
int code;       /* from aos_dlgpoke.h */
char *str;      /* additional info */
{
    WrappedPokeDialogs(w, code, str, FALSE);
}

void AxXmGetDisplayState(w, display)
AXWidget w;
int *display;
{
    *display = w && w->display;
}



/*******************************************************
function: XmCreateIconImage - Zane's iocn image widget
*/
AXWidget ZXmCreateIconImage (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_icon w;
    register int width = 0;

    if ( args[0].value ) {
        w = (AXWidget_icon)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
        }
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else
        w = (AXWidget_icon)CrtWidget(W_ICON,parentWidget,name);

    w->painter = PaintIcon;
    AxXtSetValues(w,args,cnt);
    return((AXWidget)w);
}


/*************************************************************************
function: FlagsFromApp - Call current window to get Gray/toggle... flag
Note that MenuUID is passed to the App.  This may be used by the app to
cache related info.  It is guaranteed the app's internal state
doesn't change across a single MenuUID value.
*/
int FlagsFromApp(w, mP, toggle_state_too)
register AXWidget_main w;       /* parent window or menubar widget */
register menu_item_def *mP; /* the elf menu bar data */
int toggle_state_too;           /* compute current state?, not just visibilty */
{
    int retval = 0;
    char *name;
    int cmd_code;
    char *ElfSymbolNameFromId();
    menu_opt_status *mop;

#if AXMS
    /* widget paranoid */
    if ( w->type != W_MAIN && w->type != W_MENUBAR && w->type != W_TOOLBAR )
        tempAbort("Widget type mismatch");
#endif

    name = mP->word2;

    if ((w->type == W_MENUBAR && mP->noshow) ||
        (w->type == W_TOOLBAR && !mP->toolshow))
        return (MENUSTAT_KEYONLY);

    if ((w->type == W_MENUBAR) || (w->type == W_TOOLBAR)) {
        if (w->elfObject) {       /* Object model apps control state HERE! */
            retval = ElfGetMenuStatus(w, name);
            goto retter;
        }
        w = w->parent;
    }
    cmd_code = ElfCaselessLookupSymbol(name, ElfLanguage);

    if (IsElfInLearnMode()){
        switch (cmd_code) {
        case DD_RECORD_MACRO_:
        case GR_RECORD_MACRO_:
        case IBX_RECORD_MACRO_:
        case MAIL_RECORD_MACRO_:
        case ME_RECORD_MACRO_:
        case MM_RECORD_MACRO_:
        case SQ_RECORD_MACRO_:
        case PX_RECORD_MACRO_:
        case SS_RECORD_MACRO_:
        case WP_RECORD_MACRO_:
            retval = MENUSTAT_TOGGLE_ON;
            goto retter;
            break;
        }
    }
    if (w->type == W_MAIN) {
        if (w->menuCallback)
            retval = ElfGetMenuStatus(w, name);

        else if (w->menu_status) {
            for (mop = w->menu_status; mop; mop = mop->next) {
                if (streq(mop->name, name)) {
                    retval = mop->status;
                    break;
                }
            }
        } else
            retval = CmdStatusFromAtmApp(w, name, MenuUID,
                                         toggle_state_too, cmd_code);
    }
retter:
    if (THIMhelpMode) {
        if (retval != MENUSTAT_NO_SHOW) {
#if 1   /* reject at higher layer in rev3 */
            retval = 0;
#else
            if (HelpScreenPos(name) || AxIsUserHelp(name))
                retval = 0;
            else
                retval = MENUSTAT_INACTIVE;
#endif
        }
    }
    return (retval);
}



/***********************************************************************
function: AXGetForegroundPixel - Return foreground pixel associated
with `gc'
*/
PIXEL_VALUE
AXGetForegroundPixel(dpy, gc)
register Display *dpy;
register GC gc;
{
    XGCValues values;
    unsigned long value_mask = GCForeground;

    XGetGCValues(dpy, gc, value_mask, &values);
    return(values.foreground);
}

/***********************************************************************
function: AXGetBackgroundPixel - Return background pixel associated
with `gc'
*/
PIXEL_VALUE
AXGetBackgroundPixel(dpy, gc)
register Display *dpy;
register GC gc;
{
    XGCValues values;
    unsigned long value_mask = GCBackground;

    XGetGCValues(dpy, gc, value_mask, &values);
    return(values.background);
}



/**********************************************
 * function : AxDrawBevel - draw a rectangular bevel, 
 * typically using sun/shadow colors.
 */
void
AxDrawBevel(widg, drw, x, y, width, height, thickness, style)
AXWidget widg;
Drawable drw;
int x, y, width, height;
int thickness;
int style;
{
    GC topGC, bottomGC;
    GC innerTopGC, innerBottomGC;  /* used by etch/ridge */
    PIXEL_VALUE savedSun, savedShadow;
    PIXEL_VALUE sun_pixel, shadow_pixel;
    PIXEL_VALUE saved_top, saved_bottom;
    int coloredBevel = FALSE;
    int restore_topGC = FALSE;
    int restore_bottomGC = FALSE;
    int msStyle = style;

        /* init sun/shadow pixel values to defaults */
    sun_pixel = SunPixel;
    shadow_pixel = ShadowPixel;
    
    if (widg && widg->widgetColor) {
            /* try for sun/shadow colors based on widget color
             */
        coloredBevel = AxGetSunShadowPixels(widg->widgetColor, &sun_pixel,
                                            &shadow_pixel);
    }

#if AX_X11  
    if (coloredBevel) {
            /* recolor SunGC and ShadowGC
             */
        savedSun = AXGetForegroundPixel(Dpy, SunGC);
        savedShadow = AXGetForegroundPixel(Dpy, ShadowGC);
        XSetForeground(Dpy, SunGC, sun_pixel);
        XSetForeground(Dpy, ShadowGC, shadow_pixel);
    }
#endif  
    
#if AX_X11  
    switch(style) {
        
    case BEVEL_OUT:
        topGC = SunGC;
        bottomGC = ShadowGC;
        break;
        
    case BEVEL_IN:
        topGC = ShadowGC;
        bottomGC = SunGC;
        break;
        
    case BEVEL_NONE:
        topGC = bottomGC = BackGC;
#if AX_X11      
        if (widg && widg->widgetColor) {
            restore_topGC = restore_bottomGC = TRUE;
            saved_top = AXGetForegroundPixel(Dpy, topGC);
            saved_bottom = AXGetForegroundPixel(Dpy, bottomGC);
            XSetForeground(Dpy, topGC, widg->widgetColor->any.pixel);
            XSetForeground(Dpy, bottomGC, widg->widgetColor->any.pixel);
        }
#endif      
        break;
        
    case BEVEL_ETCH:
        topGC = innerBottomGC = ShadowGC;
        bottomGC = innerTopGC = SunGC;
        break;
        
    case BEVEL_RIDGE:
        topGC = innerBottomGC = SunGC;
        bottomGC = innerTopGC = ShadowGC;
        break;
        
    case BEVEL_SIMPLE:
        topGC = bottomGC = ForeGC;
        break;
        
    }
    
    mtDrawBevel(drw, topGC, bottomGC, x, y, width, height, thickness);
#else
    
    if (style == BEVEL_ETCH) {
        msStyle = BEVEL_IN;
    }
    else if (style == BEVEL_RIDGE) {
        msStyle = BEVEL_OUT;
    }
    msDrawBevel(drw, sun_pixel, shadow_pixel, x, y, width, height,
                thickness, msStyle);
#endif
    if (style == BEVEL_ETCH || style == BEVEL_RIDGE) {
            /* these styles are implemented as two bevels, one
             * inside the other; draw the inner one now
             */
#if AX_X11      
        mtDrawBevel(drw, innerTopGC, innerBottomGC, x + thickness,
                    y + thickness, width - (2 * thickness),
                    height - (2 * thickness), thickness);
#else
        if (style == BEVEL_ETCH) {
            msStyle = BEVEL_OUT;
        }
        else {
            msStyle = BEVEL_IN;
        }
        msDrawBevel(drw, sun_pixel, shadow_pixel, x + thickness,
                    y + thickness, width - (2 * thickness),
                    height - (2 * thickness), thickness, msStyle);
#endif      
    }

#if AX_X11  
    if (coloredBevel) {
            /* restore SunGC, ShadowGC */
        XSetForeground(Dpy, SunGC, savedSun);
        XSetForeground(Dpy, ShadowGC, savedShadow);
    }
    if (restore_topGC) {
        XSetForeground(Dpy, topGC, saved_top);
    }
    if (restore_bottomGC) {
        XSetForeground(Dpy, bottomGC, saved_bottom);
    }
#endif  
}

/* : AxGetSunShadowPixels - compute sun and shadow colors based
 * on passed widgetColor
 */
int     /* return bool: true if success */
AxGetSunShadowPixels(widgetColor, sun_pixel, shadow_pixel)
wcolor_t *widgetColor;        /* in: base color from which to compute */
PIXEL_VALUE *sun_pixel;       /* out: caller should use only if TRUE return */
PIXEL_VALUE *shadow_pixel;    /* out: caller should use only if TRUE return */
{
    float base_h, base_s, base_b;
    float sun_h, sun_s, sun_b;
    float shadow_h, shadow_s, shadow_b;
    PIXEL_VALUE base_pixel, black_pixel;
    int red, green, blue;
    
    if (!widgetColor || !UseWidgetColors) {
        return (FALSE);
    }

        /* get base color's pixel
         */
    AxGetHSBFromWColor(widgetColor, &base_h, &base_s, &base_b);
    HSBToRGB(&red, &green, &blue, base_h, base_s, base_b);
    AxGetRealPixel(0, red, green, blue, 0, 255, &base_pixel);
    
        /* get sun pixel
         */
    AxComputeSun(&sun_h, &sun_s, &sun_b, base_h, base_s, base_b);
    HSBToRGB(&red, &green, &blue, sun_h, sun_s, sun_b);
    AxGetRealPixel(0, red, green, blue, 0, 255, sun_pixel);
    if (*sun_pixel == base_pixel) {
            /* try one more step in sun direction
             */
        AxComputeSun(&sun_h, &sun_s, &sun_b, sun_h, sun_s, sun_b);
        HSBToRGB(&red, &green, &blue, sun_h, sun_s, sun_b);
        AxGetRealPixel(0, red, green, blue, 0, 255, sun_pixel);
        if (*sun_pixel == base_pixel) {
            return (FALSE);             /* can't find distinct sun color */
        }
    }
    
        /* get shadow pixel
         */
    AxComputeShade(&shadow_h, &shadow_s, &shadow_b, base_h,
                   base_s, base_b);
    HSBToRGB(&red, &green, &blue, shadow_h, shadow_s, shadow_b);
    AxGetRealPixel(0, red, green, blue, 0, 255, shadow_pixel);
    if (*shadow_pixel == base_pixel) {
            /* try one more step in shadow direction
             */
        AxComputeShade(&shadow_h, &shadow_s, &shadow_b, shadow_h,
                       shadow_s, shadow_b);
        HSBToRGB(&red, &green, &blue, shadow_h, shadow_s, shadow_b);
        AxGetRealPixel(0, red, green, blue, 0, 255, shadow_pixel);
        if (*shadow_pixel == base_pixel) {
                /* use black (unless base color is black)
                 */
            AxGetRealPixel(0, 0, 0, 0, 0, 255, &black_pixel);
            if (base_pixel == black_pixel) {
                return (FALSE);
            }
            *shadow_pixel = black_pixel;
        }
    }
    
    if (*sun_pixel == *shadow_pixel) {
        return (FALSE);
    }
    else {
        return (TRUE);
    }
}

int
AxComputeSun(hh, ss, bb, h, s, b)
float *hh, *ss, *bb;
float h, s, b;
{
    float new_s;
    float new_b;
    
    new_s = s / 2.0;
    if (new_s < 0.0)
        new_s = 0.0;
    if (new_s > 100.0)
        new_s = 100.0;

    new_b = b * 1.5;
    if (new_b < 40.0)
        new_b = 40.0;
    if (new_b > 100.0)
        new_b = 100.0;

    *hh = h;
    *ss = new_s;
    *bb = new_b;
    return(0);
}

int
AxComputeWeakShade(hh, ss, bb, h, s, b)
float *hh, *ss, *bb;
float h, s, b;
{
    float new_b;
    
    new_b = b / 1.25;
    if (new_b < 40.0)
        new_b = 40.0;
    if (new_b > 100.0)
        new_b = 100.0;
    *hh = h;
    *ss = s;
    *bb = new_b;
    return(0);
}

int
AxComputeShade(hh, ss, bb, h, s, b)
float *hh, *ss, *bb;
float h, s, b;
{
    float new_b;
    
    new_b = b / 1.5;
    if (new_b < 40.0)
        new_b = 40.0;
    if (new_b > 100.0)
        new_b = 100.0;
    *hh = h;
    *ss = s;
    *bb = new_b;
    return(0);
}

/* : AxComputeContrasting - check whether
 * the passed hsb is "too close to black";
 * if too close, return brightened color,
 * otherwise, leave alone
 */
int        /* return whether input color judged "too black" */
AxComputeContrasting(hh, ss, bb, h, s, b)
float *hh, *ss, *bb;    /* out */
float h, s, b;          /* in */
{
    int brightened;
    float new_b;

    brightened = FALSE;
    if (b < 50.0) {
        *bb = 100.0;
        brightened = TRUE;
    }
    *hh = h;
    *ss = s;
    return(brightened);
}

/************************************************************
function: AxDrawShadow - wrapper for DrawShadow
*/
AxDrawShadow(d, top_GC, bottom_GC, size, x, y, width, height,olshadow) 
Drawable d;
GC top_GC;
GC bottom_GC;
register int size;
register int x;
register int y;
register int width;
register int height;
int olshadow;
{
#if AXMS
    if ( top_GC == ShadowGC )
        /* paint in "down" position */
        DrawShadow( d, size, x, y, width, height, DRAW_DOWN_SHADOW );
    else if ( top_GC == BackGC && bottom_GC == BackGC )
        /* erase shadow */
        DrawShadow( d, size, x, y, width, height, DRAW_NO_SHADOW );
    else
        DrawShadow( d, size, x, y, width, height, DRAW_UP_SHADOW );
#else
    DrawShadow( d, top_GC, bottom_GC, size, x, y, width, height, olshadow );
#endif
}


/*************************************************************************
function: PaintMEDebugger - Regen debugger widget
*/
void PaintMEDebugger(w, exP, regen, layered)
register AXWidget w;
XExposeEvent *exP;
int regen;
int layered;
{
    register void (*func) ();
    register AXWidget childP;

    if ((w->flags & WFLG_IN_EDIT) && layered) {
        if (dePaintWidget(w))
            return;
    }
    if (!w->window) {
#if AX_X11
        w->window = AxCrtWindow(Dpy, WIN_OF(w),
                                w->xpos, w->ypos,
                                w->width, w->height,
                                0, CopyFromParent, InputOutput,
                                CopyFromParent, WinMask, &WinAtt);
        XSelectInput(Dpy, w->window, TM_ALL_INPUTS_MASK);
        AxMapWindow(w, Dpy, w->window, w->name);
#endif
        w->mapped = TRUE;
    }
/* blank and draw rect */

    AxDrawBevel(w, w->window, 0, 0, w->width, w->height, 2, BEVEL_IN);

/* draw the gadgets */

    for (childP = w->widgets; childP; childP = childP->nextChild) {
        if (!WidgetExposed(childP, exP))
            continue;
        func = childP->painter;
        if (func && childP->display)
            (*func) (childP, exP, TRUE, TRUE);
    }
}

/*************************************************************************
function: ZXmCreateGExruler - Special for GE
*/
AXWidget_ge_ruler ZXmCreateGExruler (parentWidget,name)
register AXWidget_main parentWidget;
char *name;
{
    register AXWidget_ge_ruler w;

    WIDGET_PARANOID( parentWidget, W_MAIN );
    w = (AXWidget_ge_ruler)CrtWidget(W_GE_XRULER,parentWidget,"");
    parentWidget->ge_xruler = w;
    w->painter = PaintGExruler;
    w->value = 0;
    AddToWindowList(w);
    return(w);
}

/*************************************************************************
function: ZXmCreateGEyruler - Special for GE
*/
AXWidget_ge_ruler ZXmCreateGEyruler (parentWidget,name)
register AXWidget_main parentWidget;
char *name;
{
    register AXWidget_ge_ruler w;

    WIDGET_PARANOID( parentWidget, W_MAIN );
    w = (AXWidget_ge_ruler)CrtWidget(W_GE_YRULER,parentWidget,"");
    parentWidget->ge_yruler = w;
    w->painter = PaintGEyruler;
    w->value = 0;
    AddToWindowList(w);
    return(w);
}

/*************************************************************************
function: ZXmCreatePalette - Special for GE
*/
AXWidget_palette ZXmCreatePalette (parentWidget,name)
register AXWidget_main parentWidget;
char *name;
{
    register AXWidget_palette w;

    WIDGET_PARANOID( parentWidget, W_MAIN );
    w = (AXWidget_palette)CrtWidget(W_PALETTE,parentWidget,"");
    parentWidget->palette = w;
    w->painter = PaintGEPalette;
    AddToWindowList(w);
    return(w);
}

/*************************************************************************
function: ZXmCreateColorpal - Special for GE
*/
AXWidget_colorpal ZXmCreateColorpal (parentWidget,name)
register AXWidget_main parentWidget;
char *name;
{
    register AXWidget_colorpal w;

    WIDGET_PARANOID( parentWidget, W_MAIN );
    w = (AXWidget_colorpal)CrtWidget(W_COLORPAL,parentWidget,"");
    parentWidget->colorpal = w;
    w->painter = PaintColorpal;
    AddToWindowList(w);
    return(w);
}

/*************************************************************************
function: PaintColorpal - Regen widget
*/
void
PaintColorpal (w, exP, regen, layered)
register AXWidget_colorpal w;
XExposeEvent *exP;
int regen;
int layered;
{
    if ( !w || !w->display )
        return;

    if ((w->flags & WFLG_IN_EDIT) && layered) {
        if (dePaintWidget(w))
            return;
    }

    if ( !w->window )
    {
#if AX_X11
        w->window = AxCrtWindow(Dpy,WIN_OF(w),
                                w->xpos, w->ypos,
                                w->width, w->height,
                                0,CopyFromParent,InputOutput,
                                CopyFromParent,WinMask,&WinAtt);
        XSelectInput(Dpy, w->window, TM_ALL_INPUTS_MASK);
        AxMapWindow(w, Dpy, w->window, w->name);
#else
        if ( !w->winid )
            RealizePaletteWidget(w);
#endif
        w->mapped = TRUE;
    }
}


/************************************************************
function: AXmCreatePopupMenu - Create widget and display menu
*/
AXWidget_popup AXmCreatePopupMenu (parentWidget,name,args,cnt)
register AXWidget_palette parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_popup w;
    register int width = 0;

    WIDGET_PARANOID( parentWidget, W_PALETTE );

    w = (AXWidget_popup)CrtWidget(W_POPUP,parentWidget,name);
    AddToWindowList(w);
    AxXtSetValues(w,args,cnt);
    PaintPopupPulldown(w,OPTION_NEW,NULL);
    return( (AXWidget_popup)w );
}


/*************************************************************************
function: PaintGEPalette - Regen widget
*/
void
PaintGEPalette (w, exP, regen, layered)
register AXWidget_palette w;
XExposeEvent *exP;
int regen;
int layered;
{
    register void (*func)();
    register AXWidget childP;
    AXWidget_list listWidget = NULL;
    int avail, linecount, linesize, offset, val;

    if ( !w || !w->display )
        return;

    WIDGET_PARANOID( w, W_PALETTE );

    if ((w->flags & WFLG_IN_EDIT) && layered && dePaintWidget(w) )
        return;

    if ( !w->window )
    {
#if AX_X11
        w->window = AxCrtWindow(Dpy,WIN_OF(w),
                                w->xpos, w->ypos,
                                w->width, w->height,
                                0,CopyFromParent,InputOutput,
                                CopyFromParent,WinMask,&WinAtt);
        XSelectInput(Dpy, w->window, TM_ALL_INPUTS_MASK);
        AxMapWindow(w, Dpy, w->window, w->name);
#else
        if ( !w->winid )
            RealizePaletteWidget(w);
#endif
        w->mapped = TRUE;
    }

    if (!exP && !regen)
        return;

    /* draw shadow/outline */
    AxDrawBevel(w, w->window, 0, 0, w->width, w->height, 2, BEVEL_OUT);

    /* draw all the gadgets owned by the palette except the list box */
    for ( childP = w->widgets; childP; childP = childP->nextChild )
    {
        /* note the list box widget when found */
        if ( childP->type == W_LIST )
            listWidget = (AXWidget_list)childP;
#if 0
        /* make sure the widgets are correctly positioned before clip */
        val = ((AXWidget_pushbutton) childP)->gePaletteButtonType;
        if ( val > 9 && val < 14 )
            childP->ypos = w->height - 20;
#endif
        /* only draw the widgets in the damaged area on a regen */
        if ( regen && !WidgetExposed(childP,exP) )
            continue;

        /* draw the widget */
        func = childP->painter;
        if ( func && childP->display && childP->type != W_LIST )
            (*func)(childP, exP, TRUE, layered);
    }

    /* Draw parts list if not already displayed/managed. Once displayed, *\
     * it becomes sensitive to the WidgetExposed test. WARNING - this    *
    \* widget is larger than it's declared size! (See RepaintDialog).    */
    if ( listWidget )
    {
        /* get the height of a line in the listbox */
        linesize = MAX(AxCharHeight, LISTBOX_ICON_HT);
 
        /* get the max height for the box (2 lines plus scrollbar minimum) */
        avail = MAX(2*linesize + SCROLLBAR_THICK + 12, w->height - PALETTE_USED - 12);
 
        /* set the number of lines to display (don't count the scrollbar) */
        linecount = (avail-SCROLLBAR_THICK-12) / linesize;
 
        /* set the position */
        offset = PALETTE_USED + avail - linecount*linesize - SCROLLBAR_THICK - 3;
 
        /* redraw if list box content or size of palette changes */
        if ( listWidget->scroll_max != linecount || listWidget->ypos != offset )
        {
#if AXMS
            if ( listWidget->winid )
#else
            if ( listWidget->window )
#endif
                AxDestroyWindow(Dpy,listWidget,listWidget->window);
            listWidget->window = 0;
               
#if AX_X11    /* Windows list boxes have automatic scrollbars */
            /* scrollbars sized on creation, so destroy them */
            if ( listWidget->vScrollBar )
            {
                AxDestroyWidget(listWidget->vScrollBar);
                listWidget->vScrollBar = 0;
            }
            if ( listWidget->hScrollBar )
            {
                AxDestroyWidget(listWidget->hScrollBar);
                listWidget->hScrollBar = 0;
            }
#endif
               
            /* update the widget data */
            listWidget->ypos = offset;
            listWidget->scroll_max = linecount;
 
            /* note that the widget has been managed */
            AxXtManageChild(listWidget);

            /* draw it */
            PaintList(listWidget, NULL, TRUE, layered);
            listWidget->mapped = TRUE;  /* may not be needed */
        }

        /* no changes - don't draw it if it's already drawn */
        else if ( !listWidget->managed || regen == FALSE )
        {
            /* note that the widget has been managed */
            AxXtManageChild(listWidget);

            /* draw it */
            PaintList(listWidget,NULL,TRUE,layered);
            listWidget->mapped = TRUE;  /* may not be needed */
        }
    }
}

/*************************************************************************
function: PaintGEListBox - Paint the list box in the GE palette
*/
PaintGEListBox (w)
AXWidget w;
{
    register AXWidget childP;
    AXWidget_list listWidget = NULL;
    int avail, linecount, linesize, offset;

    if ( !w )
        return;

    /* find the current listbox widget structure */
    for ( childP = w->widgets; childP; childP = childP->nextChild )
    {
        if ( childP->type == W_LIST )
        {
            listWidget = (AXWidget_list)childP;
            break;
        }
    }

    if ( listWidget )
    {
        /* get the height of a line in the listbox */
        linesize = MAX(AxCharHeight, LISTBOX_ICON_HT);

        /* get the max height for the box (2 lines plus scrollbar minimum) */
        avail = MAX(2*linesize + SCROLLBAR_THICK + 12, w->height - PALETTE_USED - 12);

        /* set the number of lines to display (don't count the scrollbar) */
        linecount = (avail-SCROLLBAR_THICK-12) / linesize;

        /* set the position */
        offset = PALETTE_USED + avail - linecount*linesize - SCROLLBAR_THICK - 3;

        /* handle changes to the listbox's content */
        if ( listWidget->scroll_max != linecount || listWidget->ypos != offset )
        {
#if AX_X11    /* Windows version of PaintList will handle most of these. */
            if ( listWidget->window )
                AxDestroyWindow(Dpy,listWidget,listWidget->window);
            listWidget->window = 0;

            /* scrollbars sized on creation, so destroy them */
            if ( listWidget->vScrollBar )
            {
                AxDestroyWidget(listWidget->vScrollBar);
                listWidget->vScrollBar = 0;
            }
            if ( listWidget->hScrollBar )
            {
                AxDestroyWidget(listWidget->hScrollBar);
                listWidget->hScrollBar = 0;
            }
#endif

            /* update the widget data */
            listWidget->ypos = offset;        
            listWidget->scroll_max = linecount;
        }

        /* note that the widget has been managed */
        AxXtManageChild(listWidget);

        /* draw it */
        PaintList(listWidget,NULL,TRUE,FALSE);
        listWidget->mapped = TRUE;  /* may not be needed */
    }
}
/*************************************************************************
function: AxGetFullScreenWidget -
          Finds the first full screen slide show widget.
          Returns NULL if not found
*/
AXWidget
AxGetFullScreenWidget()
{
    AXWidget_main w;

    for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin )
    {
        if ( (w->type == W_MAIN) && w->dialog && w->dialog->topmostwindow )
            return( (AXWidget)w );
    }
    return(NULL);
}

/*************************************************************************
function: AXmMainWidgetOfTask - Find task's W_MAIN
Assumes task only owns one W_MAIN.  Finds the first one.
Returns NULL if task has no W_MAIN.
*/
AXWidget AXmMainWidgetOfTask (uid)
int uid;        /* UID of task (not task index) */
{
    int pid = ThimPidFromUID(uid);
    AXWidget_main w;

    for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin )
        {
        if ( (w->type == W_MAIN) && w->dialog && (w->taskOwner == pid) )
            return( (AXWidget)w );
        }
    return(NULL);
}

/************************************************************************
function: XmGetShellPos - Find where window is
*/
XmGetShellPos (wid,x,y)
int wid;                /* ATM id */
int *x, *y;
{
    AXWidget w;
    Window child;

    w = WidgetOfWindow(wid);
    XTranslateCoordinates(Dpy, w->window, RootWin, 0,0, x, y, &child);
}

/************************************************************************
function: xmChangeRulers
*/
xmChangeRulers(w)
AXWidget_main w;
{
    if ( !w->ge_xruler->display && w->ge_xruler->window )
    {
        AxDestroyWindow(Dpy, w->ge_xruler, w->ge_xruler->window);
        w->ge_xruler->window = 0;
    }
    if ( !w->ge_yruler->display && w->ge_yruler->window )
    {
        AxDestroyWindow(Dpy, w->ge_yruler, w->ge_yruler->window);
        w->ge_yruler->window = 0;
    }
}

/************************************************************************
function: AxDestroyRulers
*/
AxDestroyRulers(w)
AXWidget_main w;
{
    if ( w && w->type == W_MAIN )
    {
        if ( w->ge_xruler )
        {
            if ( w->ge_xruler->window )
                AxDestroyWindow(Dpy, w->ge_xruler, w->ge_xruler->window);
            AxXtDestroyWidget(w->ge_xruler);
            w->ge_xruler = NULL;
        }
        if ( w->ge_yruler )
        {
            if ( w->ge_yruler->window )
                AxDestroyWindow(Dpy, w->ge_yruler, w->ge_yruler->window);
            AxXtDestroyWidget(w->ge_yruler);
            w->ge_yruler = NULL;
        }
    }
}

/************************************************************************
function: AxXmTogglePalette
*/
void AxXmTogglePalette(w)
AXWidget_main w;
{
    if ( w && w->type == W_MAIN && w->palette )
    {
        /* toggle and reformat the contents of the window */
        w->palette->display = !w->palette->display;
        XmRestructureWindow(w);
        if ( w->palette->display )
        {
            PaintGEPalette (w->palette,(XExposeEvent *)NULL,FALSE,TRUE);
            ReinitPalette(w);
        }
    }
}

/************************************************************************
function: AxToggleGErulers
*/
AxToggleGErulers(w)
AXWidget_main w;
{
    Arg args[2];
    int an, reconfig;

    if ( w && w->type == W_MAIN )
    {
        /* toggle the y ruler */
        an = 0;
        reconfig = FALSE;
        if ( w->ge_yruler )
        {
            w->ge_yruler->display = !w->ge_yruler->display;
            if ( w->ge_yruler->display )
            {
                if ( w->ge_yruler->xpos == -1 )
                    reconfig = TRUE;
                else
                    PaintGEyruler (w->ge_yruler, (XExposeEvent *) NULL,
                                   TRUE, TRUE);
            }
        }
        else /* ruler doesn't exist - add creation data */
        {
            ZXmCreateGEyruler(w, NXLT("ge_yruler"));
            XtSetArg(args[an],AXmNGEyruler,w->ge_yruler); an++;
        }

        /* toggle the x ruler */
        if ( w->ge_xruler )
        {
            w->ge_xruler->display = !w->ge_xruler->display;
            if ( w->ge_xruler->display )
            {
                if ( w->ge_xruler->xpos == -1 )
                    reconfig = TRUE;
                else
                    PaintGExruler (w->ge_xruler, (XExposeEvent *) NULL,
                                   TRUE, TRUE);
            }
        }
        else /* ruler doesn't exist - add creation data */
        {
            ZXmCreateGExruler(w, NXLT("ge_xruler"));
            XtSetArg(args[an],AXmNGEyruler,w->ge_xruler); an++;
        }

        /* create the widget(s) */
        if ( an == 0 )
        {
            xmChangeRulers(w);
            if ( reconfig )
                XmRestructureWindow(w);
        }
        else
        {
            AxXtSetValues((AXWidget)w, args, an);
            XmRestructureWindow(w);
        }
    }
}

/************************************************************************
function: XmUpdateGErulerMouseTracker
*/
XmUpdateGErulerMouseTracker(w, x, y)
AXWidget_main w;   /* W_MAIN containing rulers */
int  x, y;
{
    int valueMask, min, max, x1, y1, x2, y2;
    XGCValues values;
    char dashes[4];

    if ( w && w->type == W_MAIN )
    {
        /* get ready to xor the line */
        valueMask = GCForeground | GCFunction;
        values.foreground = ForePixel ^ BackPixel;
        values.function = GXxor;
        axChangeGC(Dpy, ForeGC, (XFontStruct *) 0, valueMask, &values);

        /* update tracker line on y ruler */
        if ( w->ge_yruler && w->ge_yruler->display )
        {
            min = 2;
            max = w->ge_yruler->height-2;

            /* erase the old line */
            if ( w->ge_yruler->value > 0 &&
                 w->ge_yruler->value > min && w->ge_yruler->value < max )
            {
                x1 = 5;
                y1 = w->ge_yruler->value;
                x2 = w->ge_yruler->width-4;
                y2 = w->ge_yruler->value;
                XDrawLine(Dpy, w->ge_yruler->window, ForeGC, x1,y1-1, x2,y2-1);
                XDrawLine(Dpy, w->ge_yruler->window, ForeGC, x1,y1+1, x2,y2+1);
            }

            /* draw the new and update the ruler */
            w->ge_yruler->value = y;
            if ( w->ge_yruler->value > min && w->ge_yruler->value < max )
            {
                x1 = 5;
                y1 = w->ge_yruler->value;
                x2 = w->ge_yruler->width-4;
                y2 = w->ge_yruler->value;
                XDrawLine(Dpy, w->ge_yruler->window, ForeGC, x1,y1-1, x2,y2-1);
                XDrawLine(Dpy, w->ge_yruler->window, ForeGC, x1,y1+1, x2,y2+1);
            }
        }

        /* update tracker line on x ruler */
        if ( w->ge_xruler && w->ge_xruler->display )
        {
            min = 2;
            max = w->ge_xruler->width-GE_YRULER_WIDTH-2;

            /* erase the old line */
            if ( w->ge_xruler->value > 0 &&
                 w->ge_xruler->value > min && w->ge_xruler->value < max )
            {
                x1 = w->ge_xruler->value;
                y1 = 5;
                x2 = w->ge_xruler->value;
                y2 = w->ge_xruler->height-4;
                XDrawLine(Dpy, w->ge_xruler->window, ForeGC, x1-1,y1, x2-1,y2);
                XDrawLine(Dpy, w->ge_xruler->window, ForeGC, x1+1,y1, x2+1,y2);
            }

            /* draw the new and update the ruler */
            w->ge_xruler->value = x;
            if ( w->ge_xruler->value > min && w->ge_xruler->value < max )
            {
                x1 = w->ge_xruler->value;
                y1 = 5;
                x2 = w->ge_xruler->value;
                y2 = w->ge_xruler->height-4;
                XDrawLine(Dpy, w->ge_xruler->window, ForeGC, x1-1,y1, x2-1,y2);
                XDrawLine(Dpy, w->ge_xruler->window, ForeGC, x1+1,y1, x2+1,y2);
            }
        }

        /* restore the GC */
        values.foreground = ForePixel;
        values.function = GXcopy;
        axChangeGC(Dpy, ForeGC, (XFontStruct *) 0, valueMask, &values);
    }
}


/************************************************************************
function:AxXmRepaintGErulers
*/
void AxXmRepaintGErulers(w)
AXWidget_main w;   /* W_MAIN containing rulers */
{
    if ( w && w->type == W_MAIN )
    {
        if ( w->ge_yruler && w->ge_yruler->display )
        {
            w->ge_yruler->value = 0;
            PaintGEyruler (w->ge_yruler,(XExposeEvent *)NULL,TRUE,TRUE);
        }
        if ( w->ge_xruler && w->ge_xruler->display )
        {
            w->ge_xruler->value = 0;
            PaintGExruler (w->ge_xruler,(XExposeEvent *)NULL,TRUE,TRUE);
        }
    }
}


DrawRect(d,gc,size,x,y,width,height)
Drawable d;
GC gc;
register int size;
register int x;
register int y;
register int width;
register int height;
{
    AxDrawShadow(d,gc,gc,size,x,y,width,height,OLSHADOW_DRAW);
}



/*************************************************************************
function: AxXtSetSensitive - Allow/disallow events
*/
void AxXtSetSensitive (w,x)
AXWidget w;
int x;
{
    w->disabled = !x;
}



/*************************************************************************
function: SubMenuHidden - Return TRUE if all menu opts have noshow set
*/
SubMenuHidden (w,mP,test_for_dynamic_noshow)
register AXWidget w;
register menu_item_def *mP;
int test_for_dynamic_noshow;
{
    if ( test_for_dynamic_noshow && (MENUSTAT_NO_SHOW == FlagsOfSubMenu(w,mP)) )
        return(TRUE);
    for ( mP = ((menu_item_def*)(mP->word2))+1; TRUE; mP++ ) {
        if ( mP->type == ITEM_FUNC ) {
            if ( !mP->noshow )
                return(FALSE);
        }
        else if ( mP->type == ITEM_MARK )
            break;
        else if ( mP->type == ITEM_MENU ) {
            if ( !SubMenuHidden(w,mP,test_for_dynamic_noshow) )
                return(FALSE);
        }
    }
    return(TRUE);
}

/*************************************************************************
function: FlagsOfSubMenu - If submenu has uniform inactive/no_show, return so
Returns "show" if any children are "show"
Returns "no-show" if ALL children are "no-show"
Returns "inactive" if ALL children are "inactive" or "no-show"
*/
FlagsOfSubMenu (w,mP)
register AXWidget w;
register menu_item_def *mP;
{
    int retval = 0;
    int flag;

    for ( mP = ((menu_item_def*)(mP->word2))+1; TRUE; mP++ ) {
        if ( mP->type == ITEM_FUNC ) {
            flag = FlagsFromApp((AXWidget_main)w,mP,FALSE);
            if ( (flag == 0) ||
                (flag == MENUSTAT_TOGGLE_ON) ||
                (flag == MENUSTAT_RADIO_ON) ||
                (flag == MENUSTAT_TOGGLE_OFF) ||
                (flag == MENUSTAT_RADIO_OFF) )
                return(0);
            else if ( (flag == MENUSTAT_NO_SHOW) && (retval == 0) )
                retval = MENUSTAT_NO_SHOW;
            else if ( (flag == MENUSTAT_KEYONLY) && (retval == 0) )
                retval = MENUSTAT_NO_SHOW;
            else if ( flag == MENUSTAT_INACTIVE )
                retval = MENUSTAT_INACTIVE;
        }
        else if ( mP->type == ITEM_MARK )
            break;
    }
    return(retval);
}




/*************************************************************************
function: AxCallback - Perform callback, unFocus entry boxes
All dialog/widget callbacks pass thru here... Its a great breakpoint place
This should be in xmlib.c, but file was checked out at the time.
*/
void AxCallback (callback,w,callbacktag,moreStuff)
void (*callback)();
AXWidget w;
caddr_t callbacktag;
caddr_t moreStuff;
{
    AxUnFocusCurrent(w);
    (*callback)(w,callbacktag,moreStuff);
}





/*************************************************************************
function: AxUnFocusCurrent - Remove focus from current entryfield/editbox
This is passed the widget that is to get logical focus.  If its
the same as the widget that current has focus, there is no focus change.
*/
AxUnFocusCurrent(w)
AXWidget w;    /* the widget the triggered the unfocus */
{
    AXWidget_dialog dlgP = NULL;
    AXWidget_table entryP;

    if (w->parent && (w->parent->type == W_DIALOG))
        dlgP = (AXWidget_dialog)w->parent;
    else if (w->type == W_DIALOG)
        dlgP = (AXWidget_dialog)w;
    else if (w->type == W_MAIN)
        dlgP = ((AXWidget_main) w)->dialog;
    else if (w->type == W_MENUBAR) {
        AXWidget_main mw;
        if (w->parent && w->parent->type == W_MAIN) {
            mw = (AXWidget_main) w->parent;
            dlgP = mw->dialog;
        }
    }
    if (!dlgP)
        return;
    entryP = (AXWidget_table)ElfbGetActiveWidget(dlgP);
    if (!entryP)
        return;
    if ((entryP != (AXWidget_table)w) && (entryP->flags & WFLG_UNFOCUS_RETURN))
        CallWidget(entryP->callbacktag, entryP, EV_FOCUS_OUT_, NULL);
}






/***********************************************************************
function: AXTextWidth - return setwidth of passed string in pixels.
*/
int
AXTextWidth(font, mbstr, num)
register XFontStruct *font; /* font to be used for finding the text extent */
register mbchar *mbstr;       /* string whose extent has to be measured */
register int num;           /* number of bytes */
{
    int ix, len;
    wchar *wstr;
    XCharStruct *xc;
 
#if BUILD_WIDE
    if (num <= 0 || !mbstr || !*mbstr)
        return(0);
  
    wstr = (wchar *)malloc((num+1) * sizeof(wchar));
    num = MbnToWStr(mbstr, wstr, num);
    len = AXWTextWidth(font, wstr, num);
    free(wstr);
#else
    if ((num <= 0) || !font || !mbstr)
        return(0);

    for (ix = 0, len = 0; ix < num; ix++) {
        xc = getCharStruct((int)((unsigned char) mbstr[ix]), font);
        len += xc->width;
    }
#endif
    return (len);
}

/***********************************************************************
function: AXWTextWidth - return setwidth of passed string in pixels.
*/
int
AXWTextWidth(font, wstr, num)
register XFontStruct *font; /* font to be used for finding the text extent */
register wchar *wstr;       /* string whose extent has to be measured */
register int num;           /* number of chars */
{
    int ascent, descent, ix, len;
    XCharStruct *xc;
 
#if BUILD_ORIENT
    if ((num <= 0) || !wstr)
        return(0);
    if ( font == NULL || font->fid == NULL )
        font = AxDlgMainFont;
    len = AXTextExtents16(font->fid, wstr, num, NULL, &ascent, &descent);
#else
    if ((num <= 0) || !font || !wstr)
        return(0);

    for (ix = 0, len = 0; ix < num; ix++) {
        xc = getCharStruct((int) wstr[ix], font);
        len += xc->width;
    }
#endif
    return (len);
}



/***********************************************************************
function: AXWTextWidthWestern - return setwidth of passed string in pixels.
            To be called ONLY with a single-byte font
*/
int
AXWTextWidthWestern(font, wstr, num)
register XFontStruct *font; /* font to be used for finding the text extent */
register wchar *wstr;       /* string whose extent has to be measured */
register int num;           /* number of chars */
{
    int ix, len;
    XCharStruct *xc;
 
    if ((num <= 0) || !font || !wstr)
        return(0);
 
    for (ix = 0, len = 0; ix < num; ix++) {
        xc = getCharStruct((int) wstr[ix], font);
        len += xc->width;
    }
    return (len);
}




/*************************************************************************
function: SetWorkColors - Change widget gc to use work area colors
Returns 0 on success; -1 otherwise.
No one checks return value.  Mainly to keep gcc happy.
*/
SetWorkColors(gc, type)
GC gc;
int type;   /* 0: foreground is BackPixel, 1: foreground is ForePixel */
            /* 2: sun, 3: shadow, 4: recess */
{
    XGCValues values;
    int valueMask;
 
    /* return if could not allocate color cells for aux work colors */
    if ( (type > 1) && !GotWorkAuxColorCells )
        return(-1);
 
    switch (type) {
        case 0:
            valueMask = GCForeground | GCBackground;
            values.foreground = BackWorkPixel;
            values.background = ForeWorkPixel;
            break;
        case 1:
            valueMask = GCForeground | GCBackground;
            values.foreground = ForeWorkPixel;
            values.background = BackWorkPixel;
            break;
        case 2:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = SunWorkPixel;
            break;
        case 3:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = ShadowWorkPixel;
            break;
        case 4:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = RecessWorkPixel;
        default:
            return(-1);
    }

    axChangeGC(Dpy, gc, (XFontStruct *) 0, valueMask, &values);
    return(0);
}



/*************************************************************************
function: SetWorkColors - Reset widget gc colors
Return 0 on success; -1 otherwise.
No one checks return value.  Mainly to keep gcc happy.
*/
UnSetWorkColors(gc, type)
GC gc;
int type;  /* 0: back, 1: fore, 2: sun, 3: shadow, 4: recess */
{
    XGCValues values;
    int valueMask;
 
    /* return if could not allocate color cells for aux work colors */
    if ( (type > 1) && !GotWorkAuxColorCells )
        return(-1);
 
    switch (type) {
        case 0:
            valueMask = GCForeground | GCBackground;
            values.foreground = BackPixel;
            values.background = ForePixel;
            break;
        case 1:
            valueMask = GCForeground | GCBackground;
            values.foreground = ForePixel;
            values.background = BackPixel;
            break;
        case 2:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = SunPixel;
            break;
        case 3:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = ShadowPixel;
            break;
        case 4:
            /* only for OpenLook color */
            valueMask = GCForeground;
            values.foreground = RecessPixel;
        default:
            return(-1);
    }
    axChangeGC(Dpy, gc, (XFontStruct *) 0, valueMask, &values);
    return(0);
}



/*************************************************************************
function: ResetActive - Reset spring loaded menus, buttons
*/
void ResetActive ()
{
    register AXWidget w;
    axolButton button;
    char asterixSymbol[2];
    int button_xpos;  /* xpos of OpenLook abbr button */
    int pix = FALSE;

#if AX_X11    /* { menus handled automatically by Windows */
    if ( w = ButtonArmed )
        ArmButton(NULL,FALSE,0);    /* dis-arm button */
    if ( w = MenuArmed ) {
        AxDestroyWindow(Dpy, w, w->window);
        w->window = 0;
        MenuArmed = NULL;
    }
#endif    /* } */

    if (w = RowColumnArmed) {
        AxDestroyWindow(Dpy, w, w->window);
        w->window = 0;
        RowColumnArmed = NULL;
        if ( !((AXWidget_pushbutton) w)->gePaletteButtonType )
            PaintRowColumn(w, (XEvent *) NULL, 0, 0);
    }
    if ( w = PopupArmed ) {
        AxDestroyWindow(Dpy, w, w->window);
        w->window = 0;
        PopupArmed = NULL;
    }

#if AX_X11    /* {  */
    if (w = (AXWidget)ComboBoxArmed)
    {
        CbDestroyPulldown(ComboBoxArmed);
        PaintComboBox((AXWidget_combo_box) w, (XEvent *) NULL, 0, 0);
    }
    if ( w = (AXWidget)AxPulldownActive )
    {
        AXWidget_menu w_menu;

        w_menu = (AXWidget_menu)w;
        XFillRectangle(Dpy,w_menu->pulldown,BackGC,0,0,
                w_menu->pulldown_width,w_menu->pulldown_height);
        AxDestroyWindow(Dpy, w_menu, w_menu->pulldown);
        w_menu->pulldown = 0;
        if ( Thim2dMode ) {
            AxDrawBevel(w_menu, w_menu->window, BarBoxX, BarBoxY,
                        BarBoxWidth-1, BarBoxHeight, 1, BEVEL_NONE);
        }
        else {
            AxDrawBevel(w_menu, w_menu->window, BarBoxX, BarBoxY,
                        BarBoxWidth, BarBoxHeight, 2, BEVEL_NONE);
        }
        AxPulldownActive = NULL;
        if (w_menu->cascade) {
            AxDestroyWindow(Dpy, w_menu, w_menu->cascade);
            w_menu->cascade = 0;
        }
    }
    if (AxPulldownStayup && AxExitPulldownStayupMode) {
        AxPulldownStayup = FALSE;
        PointerHasMoved = TRUE;                
        XUngrabPointer(Dpy, CurrentTime);
        XUngrabKeyboard(Dpy, CurrentTime);
        AxMenuItem = -1;
        AxPulldownItem = -1;
        AxCascadeItem = -1;
    }
    AxExitPulldownStayupMode = TRUE;
    AxControlKeyDown = 0;
    if ( w = StrokingBar ) {
        w->update_widget = TRUE;
        StrokingBar = NULL;
    }
#endif    /* } AX_X11 */
}


/*
*   AxFlush - flush the requests to the server.
*       should be moved into tmx.c
*/
AxFlush()
{
    XFlush(Dpy);
}


/*************************************************************************
function: ResetActiveTextsExceptFor - Get rid of cursors
*/
ResetActiveTextsExceptFor (w)
register AXWidget w;
{
    register AXWidget p;
    register AXWidget_entry w_enter;
    register AXWidget_editbox w_editbox;
    register AXWidget_combo_box w_combo_box;
    register int did_work = FALSE;


    if (!w->parent->window)
        return 0; /* W_ENTER and W_EDITBOX require a valid container. */

    for ( p = w->parent->widgets; p ; p = p->nextChild ) {
        if ( p == w ) {
            continue;
        }
        if ( p->type == W_ENTER ) {
            w_enter = (AXWidget_entry)p;
            if ( w_enter->hasFocus ) {
                w_enter->curPos = -1;
                w_enter->pending_delete = FALSE;
                if ( !w_enter->disabled && w_enter->display ) {
                    p->hasFocus = FALSE;
                    PaintEnter(w_enter,NULL, TRUE, TRUE);
                }
                did_work = TRUE;
            }
        }
        else if ( p->type == W_EDITBOX ) {
            w_editbox = (AXWidget_editbox)p;
            if ( w_editbox->hasFocus ) {
                EditBoxDrawCursor(w_editbox, FALSE);
                w_editbox->hasFocus = FALSE;
                did_work = TRUE;
            }
        }
#if AX_X11
    else if ( (AXWidget_combo_box)p == ComboBoxInEditWindow ) {
        w_combo_box = (AXWidget_combo_box)p;
        if ( w_combo_box->hasFocus && ComboBoxInEditWindow ) {
        ComboBoxInEditWindow = NULL;
        EditWinDrawCursor(w_combo_box, &(w_combo_box->edit_win),
                  TC_ERASE);
        w_combo_box->hasFocus = FALSE;
        did_work = TRUE;
        }
    }
#endif
#if BUILD_ORIENT
        else if ( p->type == W_TABLE ) {
            /* turn off flag used to mark table as active Asian entry area */
            if ( p->hasFocus ) {
                table_info *tp;
                TblLiftSelectionCursor( p );   /* erase the cursor */
                tp = (table_info *)((AXWidget_table)p)->info.table;
                if ( tp != (table_info *)NULL )
                    tp->cursor.col = -1;
            }
        }
#endif
        p->hasFocus = FALSE;
    }
    return(did_work);
}



/*
 * function AxGetPixmap - reads the image file and returns information about
 *                      the pixmap
 */
 
AxGetPixmap(filename, pix, width, height)
char *filename; /* image file */
Pixmap *pix;    /* ret'd    pixmap id */
int *width, *height; /* ret'd  width and height of the pixmap */    
{
pixcache_t *p;
    p = Pixmapper(filename);
    if(p == NULL) /* unable to find/create a pixmap */
        return(FALSE);
    /* return the pix map information */
    *pix = p->pix;
    *width = p->width;
    *height = p->height;
    return(TRUE);
}



/*************************************************************************
function: GetPixmapByName - Given a name, return pixmap
          Modified to handle Xm/bitmaps.h as well as axol.h bitmaps
*/
Pixmap GetPixmapByName (name)
char   *name;
{
    register int i;
    static int initialized = FALSE;
    static char **maps_in_memory;
    static Pixmap *map_ptrs;
    int num_bltins_xm, num_bltins;

    if ( !initialized ) {
        num_bltins_xm = sizeof(bitmap_name_set) / sizeof(char*);
        num_bltins = num_bltins_xm+sizeof(ax_bitmap_name_set) /
                  sizeof(char*);
        maps_in_memory = (char**)malloc((num_bltins+1)*sizeof(char*));
        map_ptrs = (Pixmap*)malloc(num_bltins*sizeof(Pixmap));
        for ( i = 0; i < num_bltins_xm; i++ ) {
            map_ptrs[i] = XCreatePixmapFromBitmapData(
                          Dpy, RootWin, bitmaps[i], 
                          16, 16, ForePixel, BackPixel, DpyDepth);
            maps_in_memory[i] = 
                          strcpy(malloc( strlen(bitmap_name_set[i])+1),
                            bitmap_name_set[i]);
        }
        for ( i; i < num_bltins; i++) {
            map_ptrs[i] = XCreatePixmapFromBitmapData(
                          Dpy, RootWin, ax_bitmaps[i-num_bltins_xm],
                          16, 16, ForePixel, BackPixel, DpyDepth);
            maps_in_memory[i] = strcpy(
                          malloc(strlen(ax_bitmap_name_set[i-num_bltins_xm])+1),
                          ax_bitmap_name_set[i-num_bltins_xm]);
        }
        initialized = TRUE;
    }

   /*  Check for a matching pixmap  */

    for ( i = 0; maps_in_memory[i]; i++ )
        if ( streq(maps_in_memory[i],name) )
            return(map_ptrs[i]);

   /*  If no image was found, set up and go try to get an image from a file  */
    /* See ImageCache.c */

   abort();
}


/****************************************************************
function: AXmUpdateSetasideIcon
*/
AXmUpdateSetasideIcon(w, iconName)
AXWidget_main w;
char *iconName; /* a number string to which IconSizeStr is appended */
{
    int iconNum;
    if (!iconName || !(*iconName) || !w || (w->type != W_MAIN))
        return;
    iconNum = atoi(iconName);
    if (iconNum != w->style) {
        /* the icon has changed */
        if (w->iconPixmap) {
            XFreePixmap(Dpy, w->iconPixmap);
            w->iconPixmap = (Pixmap) NULL;
        }
        w->style = iconNum;
#if AX_X11
        AxSetWindowProperties(Dpy, w->window, w, w->name, w->wstr,
                              w->style, (XSizeHints *)NULL);
#endif
        XFlush(Dpy);
    }
}








/*************************************************************************
function: AXmCreateToggleButtonGadget - Create a toggle button
*/
AXWidget AXmCreateToggleButtonGadget(parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_option in_option;
    register  AXWidget_radio in_radio;
    register AXWidget_togglebutton w;
    void xmToggleButtonSize();

    in_option = (AXWidget_option) NULL;
    in_radio = (AXWidget_radio) NULL;
#if AX_X11
    if ( parentWidget->type == W_OPTION ) {
        in_option = (AXWidget_option) parentWidget;
        parentWidget = (AXWidget) parentWidget->parent;
        if ( args[0].value ) {
            w = in_option->buttons[args[0].value-1];
            w->update_widget = TRUE;
            WidgetNeedsUpdated = TRUE;
        }
        else {
            w = (AXWidget_togglebutton) CrtWidget(W_TOGGLE,parentWidget,name);
        }
        /* option buttons always destroyed and then re-created
         */
        AddButtonToOptions(in_option, w);
    }
#endif
    if ( parentWidget->type == W_RADIO ) {
        in_radio = (AXWidget_radio)parentWidget;
        parentWidget = (AXWidget)parentWidget->parent;
        if ( args[0].value && (in_radio->num_buttons >= args[0].value) ) {
            /* toggle already exists in radio */
            w = (AXWidget_togglebutton)in_radio->buttons[args[0].value-1];
            if (w->name) {
                xmToggleButtonSize(w, w->font, w->name);
            }
            if (AXmNewFootprint(w, name, args, cnt)) {
                UnMapWidget(w);
            }
            w->update_widget = TRUE;
            WidgetNeedsUpdated = TRUE;
            SetWidgetName(w, name);
            
            in_radio->update_widget = TRUE;
            in_radio->regen_widget = TRUE;
            if ( args[1].value & WFLG_NODISPLAY )
                xmSetWidgetDisplay(in_radio, FALSE);
        }
        else {
            w = (AXWidget_togglebutton)CrtWidget(W_TOGGLE,parentWidget,name);
        }
        w->in_radio = in_radio;
    }
    if (!(in_option || in_radio)) {
        /* a single toggle button, not part of option or radio
         */
        if ( args[0].value ) {
            /* toggle already exists
             */
            w = (AXWidget_togglebutton)args[0].value;
            if (AXmNewFootprint(w, name, args, cnt)) {
                UnMapWidget(w);
            }
            w->update_widget = TRUE;
            WidgetNeedsUpdated = TRUE;
            SetWidgetName(w, name);
        }
        else {
            w = (AXWidget_togglebutton)CrtWidget(W_TOGGLE,parentWidget,name);
        }
    }
    
    if ( args[1].value & WFLG_DIAMOND )
        w->like_radio = TRUE;
    else
        w->like_radio = FALSE;
    
    w->painter = PaintToggle;
    AxXtSetValues(w,args,cnt);
    
    if ( args[0].value ) {
        if ( w->in_radio ) {
            if ( w->in_radio->num_buttons < args[0].value ) {
                /* new toggle (did not exist in old radio) */
                AddToggleToRadio(w->in_radio, w);
            }
            else {
                /* toggle already exists in radio */
                UpdateRadioSize(w->in_radio, w);
            }
            w->update_widget = TRUE;
            WidgetNeedsUpdated = TRUE;
        }
    }
    else {
        if ( w->in_radio ) {
            AddToggleToRadio(w->in_radio, w);
        }
    }
    xmToggleButtonSize(w, w->font, name);
    return((AXWidget)w);
}

void
xmToggleButtonSize(w, fs, name)
AXWidget_togglebutton w;
XFontStruct *fs;
mbchar *name;
{
    if ( w->in_radio || w->like_radio )
        wRadioButtonSize(name, fs, &w->width, &w->height);
    else
        wToggleButtonSize(name, fs, &w->width, &w->height);
}

/* this refers to a toggle button that's part of a radio group */
void
wRadioButtonSize(name, fs, width, height)
mbchar *name;         /* in */
XFontStruct *fs;      /* in */
int *width, *height;  /* out */
{
    XFontStruct *lfs;
    int fontHeight;
    
    if (fs) {
        lfs = fs;
        fontHeight = fs->ascent + fs->descent;
    }
    else {
        lfs = AxDlgMainFont;
        fontHeight = AxCharHeight;
    }
    *width = 21; /* 21 pix extra for diamond plus sep */
    if (name) {
        *width += AXTextWidth(lfs, (char *) name, MBstrlen(name));
    }
    *height = fontHeight + 4;
}

void
wToggleButtonSize(name, fs, width, height)
mbchar *name;         /* in */
XFontStruct *fs;      /* in */
int *width, *height;  /* out */
{
    XFontStruct *lfs;
    int fontHeight;
    
    if (fs) {
        lfs = fs;
        fontHeight = fs->ascent + fs->descent;
    }
    else {
        lfs = AxDlgMainFont;
        fontHeight = AxCharHeight;
    }
    
/* !!? need to use ToggleTextOffsets to get any extra labelXoffset */
    *width = CHECK_BOX_SPACING; /* square plus seperator spacing */
    if (name) {
        *width += AXTextWidth(lfs, (char *) name, MBstrlen(name));
    }
    *height = fontHeight + 4;
}

/* : wToggleTextVOffset - return offsets for use in painting
 * toggle buttons; the offsets vary with toggle type and font
 */
int
wToggleTextOffsets(font, like_radio, buttonVoffset, labelXoffset)
XFontStruct *font;    /* in */
int like_radio;   /* in: true means diamond shape rather than square */
int *buttonVoffset;   /* out */
int *labelXoffset;    /* out */
{
    int textVoffset, ascent, buttonHeight;

    *labelXoffset = *buttonVoffset = 0;
    if (like_radio) {
        buttonHeight = 15;
    }
    else {
        buttonHeight = 13;
    }
    if (font || AxAlternateDialogFont) {
        if (font) {
            ascent =  font->ascent;
        }
        else if (AxAlternateDialogFont) {
            ascent = AxDlgMainFont->ascent;
        }
        if (ascent > buttonHeight) {
            textVoffset = ascent;
            *buttonVoffset = ascent - buttonHeight;
        }
        else {
            textVoffset = ((buttonHeight - ascent) / 2) + ascent;
        }
    }
    else {
        if (like_radio) {
            textVoffset = 13;
        }
        else {
            textVoffset = 12;    /* based on axsab-16 */
        }
    }
    return (textVoffset);
}

/*************************************************************************
function: PaintToggle - Paint a squared toggle button
*/
void PaintToggle (w, exP, regen, layered)
register AXWidget_togglebutton w;
XEvent *exP;
int regen;
int layered;
{
    void mtPaintToggle();

#if AXMS
    msPaintToggle(w, layered);
#else
    if (w->in_option)
        return;     /* allow option menu itself to manage its buttons */
    
    mtPaintToggle(w, layered);
#endif

}

/*************************************************************************
function: AddToggleToRadio - Add a new toggle button
*/
AddToggleToRadio (w, tP)
register AXWidget_radio w;
register AXWidget_togglebutton tP;
{
    register int ix, sz;

    w->num_buttons++;

    sz = w->num_buttons * sizeof(AXWidget_togglebutton);
    w->buttons = (AXWidget_togglebutton *) realloc(w->buttons,sz);
    w->buttons[w->num_buttons-1] = (AXWidget_togglebutton)tP;
    tP->xpos = w->xpos;
    tP->ypos = w->ypos + w->height;
    UpdateRadioSize(w, tP);
}

/*
 * UpdateRadioSize - Update size of radio box.
 */
UpdateRadioSize(w, tP)
register AXWidget_radio w;
register AXWidget_togglebutton tP;
{
    int ix, ypos;

    w->width = MAX(w->width, tP->width);
    w->height += tP->height;
        /* the buttons are left-aligned, so their x positions
           remain equal to the radio box's xpos; the y positions
           must be updated in case the font has changed */
    for (ix = 0, ypos = w->ypos; ix < w->num_buttons; ix++) {
        w->buttons[ix]->ypos = ypos;
        w->buttons[ix]->xpos = w->xpos;
        ypos += w->buttons[ix]->height;
    }
}


/*****************************************************************
function: AXmCreatePushButtonGadget - Create a verb button
*/
AXWidget_pushbutton
AXmCreatePushButtonGadget (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_pushbutton w;
    int ascent, descent, thick;

    if ( args[0].value ) {
        w = (AXWidget_pushbutton)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
        }
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else {
        w = (AXWidget_pushbutton)CrtWidget(W_BUTTON,parentWidget,name);
    }
    
    w->painter = PaintButton;

    AxXtSetValues(w,args,cnt);

    wVerbButtonSize(w->name, w->pixmapLabel, w->font,
                    w->thickness, w->shadow, w->textShadow,
                    &w->width, &w->height);
    
#if AXMS
    /* if the button exists, and the font is not the default dialog font, */
    /* tell Windows to change the font                                    */
    if ( w->winid  && w->font && (w->font != AxDlgMainFont) )
        MS_SendMessage( w->winid, WM_SETFONT, w->font->fid, TRUE );

    /* temporary(?) HACK: if we are creating an Apply button make its
     * parent (the dialog box) be a child of the app that called it.
     * this keeps the dialog box on top while allowing focus in the app.
     */
    if ( streq(w->name, "Apply") && parentWidget->parent )
        {
        /* parentWidget = dialog (W_DIALOG).
         * parentWidget->parent = W_MAIN widget of dialog.
         * parentWidget->parent->parent = parent of dialog (application).
         */
        if ( parentWidget->parent->parent )
            parentWidget->parent->parent_hwnd =
                    parentWidget->parent->parent->winid;
        }
#endif
    return((AXWidget_pushbutton)w);
}


/*************************************************************************
function: AXmCreateScrolledList - Create a list box
*/
AXWidget AXmCreateScrolledList (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_list w;

    if ( args[0].value ) {
        w = (AXWidget_list)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);   /* lift widget, destroy window */
#if AX_X11
            if ( w->vScrollBar ) {
                AxXtDestroyWidget(w->vScrollBar);
                w->vScrollBar = (AXWidget_scroll) NULL;
            }
            if ( w->hScrollBar ) {
                AxXtDestroyWidget(w->hScrollBar);
                w->hScrollBar = (AXWidget_scroll ) NULL;
            }
#endif
        }
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else
        w = (AXWidget_list)CrtWidget(W_LIST,parentWidget,name);

    w->painter = PaintList;
    if ( w->selections )
        free(w->selections);
    w->selections = (long *)CreateIntsArray(0);
    AxXtSetValues(w,args,cnt);

    return( (AXWidget)w );
}



/*************************************************************************
*   function :AxGetSubImage -copy a rectangle in drawable to a location
*             within the existing image
*/
XImage *AxGetSubImage( dpy, draw, x,y,width,height,plane_mask,format,
                       dest_image,dest_x, dest_y )
register Display *dpy;
Drawable draw;
int x,y;
unsigned int width, height;
unsigned long plane_mask;
int format; /* either XYFormat or ZFormat */
XImage *dest_image;
int dest_x, dest_y;
{
    XImage *temp_image;
    register unsigned long pixel;
    register int row, col;
    int wid, hyt, startrow, startcol;

    temp_image = XGetImage( dpy, draw,x,y,width,height,plane_mask,format );
    if ( !temp_image )
        return ((XImage *)NULL);

    if ( x < 0 )
    {
        startcol = -x;
        x = 0;
    }
    else
        startcol = 0;
    if ( y < 0 )
    {
        startrow = -y;
        y = 0;
    }
    else
        startrow = 0;
    wid = dest_image->width -x;
    if ( temp_image->width < wid )
        wid = temp_image->width;
    hyt = dest_image->height -x;
    if ( temp_image->height < hyt )
        hyt = temp_image->height;
    for ( row = startrow; row < hyt; row++ )
    {
        for ( col = startcol; col < wid; col++ )
        {
            pixel = XGetPixel(temp_image, col, row);
            XPutPixel(dest_image, x + col, y + row, pixel);
        }
    }
#if AXMS
    /* the Windows XImage structure may contain a bitmap handle that we *
     * don't want to destroy. Set it to null so it won't get deleted.   */
    if ( temp_image->bitmap_handle == draw )
        temp_image->bitmap_handle = NULL;
#endif            
    XDestroyImage(temp_image);
    return ( dest_image );
}


/*************************************************************************
function: ElfbPokeDialogs - Send a poke to all dialogs
*/
ElfbPokeDialogs (codeP,aP,kids_only)
data_ptr codeP;
data_ptr aP;
data_ptr kids_only;
{
    AXWidget widgie;
    int code;

    code = IntFromDataPtr(codeP);
    if ( kids_only ) {
        /* if there is no main widget, don't poke anybody. */
        widgie = AXmMainWidgetOfTask(ThimUIDPid(AxInTask));
        if (widgie) 
            XmPoker(code,aP,widgie,FALSE,TRUE);
    }
    else
        XmPoker(code,aP,(AXWidget)NULL,FALSE,TRUE);
}


/*************************************************************************
function: AxRePaintAll - Send exposure events to all windows
*/
AxRePaintAll (wid)
int wid;    /* ATM window id */
{
    AXWidget_main w, mw;
    int ix;
    int width, height, x;
    Window rw;

    if ( (wid > 0) && (wid < TM_MAXWIN) ) {
        mw = (AXWidget_main)WidgetOfWindow(wid);
        for ( w = (AXWidget_main)WindowList; w; w=(AXWidget_main)w->nextWin ) {
            if ( (w->type == W_WORK) && (w->parent == mw) ) {
                XGetGeometry(Dpy,w->window,&rw,&x,&x,&width,&height,&x,&x);
                XClearArea (Dpy, w->window, 0, 0, width, height, TRUE);
            }
        }
    }
    else {
        for ( w = (AXWidget_main)WindowList; w; w=(AXWidget_main)w->nextWin ) {
            XGetGeometry(Dpy,w->window,&rw,&x,&x,&width,&height,&x,&x);
            XClearArea (Dpy, w->window, 0, 0, width, height, TRUE);
        }
    }
}


/*************************************************************************
function: AxReportWidgets - Return total number of widgets
*/
AxReportWidgets ()
{
    register int cnt = 0;
    register AXWidget w;

    for ( w = TotalWidgetsList; w; w = w->next )
        cnt++;
/* printf("widgets %d vs %d\n",cnt,NumWidgets); */
    return(cnt);
}

/*************************************************************************
function: AxReportWindows - Return total number of windows
*/
AxReportWindows ()
{
    register int cnt = 0;
    register win_list_t *w;

    for ( w = TotalWindowsList; w; w = w->next )
        cnt++;
/* printf("windows %d vs %d\n",cnt,NumWindows); */
    return(cnt);
}


/*************************************************************************
function: AxClearAllWindows - Used when posting "out-of-memory" window
*/
AxClearAllWindows ()
{
    AXWidget w, mw;
    int ix;
    int width, height, x;
    Window rw;

    for ( w = WindowList; w; w = w->nextWin ) {
        XGetGeometry(Dpy,w->window,&rw,&x,&x,&width,&height,&x,&x);
        XFillRectangle (Dpy, w->window, BackGC, 0, 0, width, height);
    }
}



AxXmInsEditBoxData(w, str)
AXWidget w;
char *str;
{
    insertEditBoxData(w, str);
    PaintEditBox(w, NULL, TRUE, TRUE);
}



/*************************************************************************
function: InitXferAtoms - Create xfer atoms
*/
AxInitXferAtoms ()
{
#if AXMS
    WinInitPredefinedAtoms();
#endif
    AxXA_EDITBOX_PROP = XInternAtom(Dpy, "_AX_EDITBOX_PROP", False);
    AxXA_ENTER_PROP = XInternAtom(Dpy, "_AX_ENTER_PROP", False);
    AxXA_COMBOBOX_PROP = XInternAtom(Dpy, "_AX_COMBOBOX_PROP", False);
    AxXA_VISIX_ACCEPT_DROP = XInternAtom(Dpy,"_VISIX_IAS_DROP_AWARE",False);
    AxClipboardInitialize();
}


/***********************************************************************
function: wTablePixHeight - Calculate the window height of the table given
the number of lines to display (excluding heading). Uses standard dialog font.
*/
int
wTablePixHeight(numLines, thickness)
int numLines;
int thickness;
{
    int widgetHeight;
    int headingHeight;
    int rowHeight;

    if (numLines < 2)
        numLines = 2;
    if (thickness < 0)
        thickness = -thickness;

    headingHeight = AxCharHeight + 4 + 2;
    rowHeight = AxCharHeight + 4 + 2;
    widgetHeight = headingHeight + (numLines * rowHeight);
    widgetHeight = widgetHeight + (2 * thickness);
    return(widgetHeight - 2);
}

void
wVerbButtonSize(name, pixType, font, thickness,
                shadow, textShadow, width, height)
mbchar *name;              /* in */
int pixType;               /* in: bool */
XFontStruct *font;         /* in */
int thickness;             /* in: border thickness in screenpix */
data_ptr shadow;           /* in */
data_ptr textShadow;       /* in */
int *width, *height;       /* in/out */
{
    int tthick, minHeight, minWid, len;
    r32 trect;
    XFontStruct *fs;
    int twidth = 0;
    int theight = 0;
    
    if (pixType) {
        wPixButtonSize(name, thickness, width, height);
        return;
    }
    if (!thickness)
        tthick = 2;
    else
        tthick = thickness;
    
    len = MBstrlen(name);
    
    if (font) {
        fs = font;
    }
    else {
        fs = AxDlgMainFont;
    }

    if (len && (font || AxAlternateDialogFont)) {
        wVerbButtonLabelSize(fs, name, len, textShadow, &twidth, &theight);
        twidth += (2 * tthick) + 6;
#if 0
/* Used to be AXMS. I've changed large fonts on NT3.51 so that they
 * are non-bold, which makes them less wide and which makes this
 * hack obsolete.    -donato
 */     
        /* the "1.77" is an emprical number which, based on observation, */
        /* created the correct button height, dependent on whether the user */
        /* is running "small" or "large" fonts. - jon                       */
        /* only use "1.77" if we have the dialog font.  -donato */
        if ( fs->fid == AxDlgMainFont->fid )
            {
            tthick = tthick - 2;    /* any "unusual" thickness */
            theight = 1.77 * (float)theight + (2*tthick);
            }
        else
            theight += (2 * tthick) + 2;
#else
        theight += (2 * tthick) + 2;
#endif
        if (*width < twidth) {
            *width = twidth;
        }
        if (*height < theight) {
            *height = theight;
        }
    }
    else {
            /* font is axsab-16, or no text; use ancient incantation
               for button height */
        minWid = BasicStrlen((char *) name) + (2 * tthick) + 6;
        minHeight = AxCharHeight +
            2 * MIN(AxCharAbove / 5, 1) + (2 * tthick);
        if (*height < minHeight) {
            *height = minHeight;
        }
        if (*width < minWid) {
            *width = minWid;
        }
    }
}

static void
wVerbButtonLabelSize(fs, name, len, textShadow, width, height)
XFontStruct *fs;        /* in: button label font */
mbchar *name;           /* in: button label text */
int len;
data_ptr textShadow;
int *width, *height;    /* out */
{
    int tmp, minHeight, xoff, yoff;
    XCharStruct *xc;
    
        /* include sidebearings in width, use font height
           for height; if shadow present, include that, too */
    
    *width = AXTextWidth(fs, (char *) name, len);
    xc = getCharStruct((int)((unsigned char) name[0]), fs);
    if ((int) xc->lbearing < 0) {
        *width -= (int) xc->lbearing;
    }
    xc = getCharStruct((int)((unsigned char) name[len - 1]), fs);
    if ((tmp = ((int) xc->rbearing - (int) xc->width)) > 0) {
        *width += tmp;
    }

    *height = fs->ascent + fs->descent;
    
    if (wShadowIsOn(textShadow)) {
            /* the shadow is painted to the lower right of the text;
               it might be diffused a bit, so add some space */
        xmTextShadowOffsets(fs, &xoff, &yoff);
        *width += xoff + 2;
        *height += yoff + 3;
    }
}

void
wPixButtonSize(name, thickness, width, height)
mbchar *name;         /* in */
int thickness;        /* in: border thickness in screenpix */
int *width, *height;  /* out */
{
    int tthick;
    pixcache_t *pix;
    
    if (!thickness)
        tthick = 2;
    else
        tthick = thickness;
    
    pix = Pixmapper((char *) name);
    if (pix) {
        *width = pix->width + 2 * tthick;
        *height = pix->height + 2 * tthick;
        *width += 2;  /* include room for border */
        *height += 2;
#if AXMS
        /*  add in extra room for the black border */
        /*  around the button */
        *width++;
        *height++;
#endif
    }
}

void
wColorButtonDefaultSize(width, height)
int *width, *height;  /* out */
{
    *width = *height = 20;  /* 'sane' default? */
}

void
wWidgetShadowOffsets(type, shadow, xoff, yoff)
int type;            /* widget type, c-style, e.g., W_BUTTON */
data_ptr shadow;     /* in */
int *xoff, *yoff;    /* out */
{
    *xoff = *yoff = 0;
    if (wShadowIsOn(shadow)) {
        switch(type) {
        case W_TOGGLE:
            *xoff = *yoff = 2;
            break;
        default:
            *xoff = *yoff = 2;
            break;
        }
    }
}

void
wOptionWidth(name, labelFont, widestStrWidth, pulldownWidth,
             barwid, barspace, totalWidth)
mbchar *name;            /* in */
XFontStruct *labelFont;  /* in */
int widestStrWidth;      /* in:  pixwid of widest value string */
int *pulldownWidth;      /* out: pixwid of potential pulldown (motif) */
int *barwid;             /* out: pixwid of graphic bar (motif) */
int *barspace;           /* out: between graphic bar and end (motif) */
int *totalWidth;         /* out: pixwid of entire static option widget */
{
    XFontStruct *ofont;
    int spacewid;
    
    if (labelFont) {
        ofont = labelFont;
    }
    else {
        ofont = AxDlgMainFont;
    }
    spacewid = AXTextWidth(ofont, " ", 1);

    *pulldownWidth = widestStrWidth + (2 * spacewid) + 14;
    *barwid = 2 + 8 + 2;
    *barspace = spacewid + 5;
    *totalWidth = AXTextWidth(ofont, name, strlen(name)) + spacewid +
        *pulldownWidth + *barwid + *barspace;
}

int
wOptionHeight(labelFs, choicesFs, labelShadow, choicesShadow,
              labelYoffset, fieldYoffset)
XFontStruct *labelFs;     /* in */
XFontStruct *choicesFs;   /* in */
data_ptr labelShadow;     /* in */
data_ptr choicesShadow;   /* in */
int *labelYoffset;        /* out: from widget yorigin to label yorigin */
int *fieldYoffset;        /* out: from widget yorigin to field yorigin */
{
    int labelHeight, labelAscent;
    int choicesHeight, choicesAscent;
    int fieldHeight, labelBaseline, fieldBaseline;
    int labelDescent, lowestDescent;
    XFontStruct *label_font, *choices_font;
    
    if (labelFs) {
        labelHeight = labelFs->ascent + labelFs->descent;
        labelAscent = labelFs->ascent;
        label_font = labelFs;
    }
    else {
        labelHeight = AxCharHeight;
        labelAscent = AxCharAbove;
        label_font = AxDlgMainFont;
    }
    labelDescent = labelHeight - labelAscent;
    if (wShadowIsOn(labelShadow)) {
        int xoff, yoff;
        xmTextShadowOffsets(labelFs, &xoff, &yoff);
        labelDescent += yoff + 1;
    }
    if (choicesFs) {
        choicesHeight = choicesFs->ascent + choicesFs->descent;
        choicesAscent = choicesFs->ascent;
        choices_font = choicesFs;
    }
    else {
        choicesHeight = AxCharHeight;
        choicesAscent = AxCharAbove;
        choices_font = AxDlgMainFont;
    }
    
#if AXMS
    *fieldYoffset = *labelYoffset = 0;
    return (choicesHeight);
#else

    fieldHeight = wOptionFieldHeight(choices_font, choicesShadow);
    labelBaseline = wOptionFieldBaseline(label_font);
    fieldBaseline = wOptionFieldBaseline(choices_font);
    
    if ((label_font->ascent + label_font->descent) > fieldHeight) {
            /* center-align the field with the label.
             * the alignment point for the label is
             * at half the xheight above its baseline; 
             * since XFontStruct doesn't have an explicit
             * xheight (maybe in the properties, tho), use
             * half the total height as the xheight guess..
             */
        int labelCenter, fieldCenter, halfXheight;
        fieldCenter = fieldHeight / 2;
        halfXheight = (label_font->ascent + label_font->descent) / 4;
        labelCenter = labelBaseline - halfXheight;
        *fieldYoffset = labelCenter - fieldCenter;
    }
    else {
            /* align label and field text baselines
             */
        *fieldYoffset = labelBaseline - fieldBaseline;
    }
    
    *labelYoffset = 0;
    if (*fieldYoffset < 0) {
            /* bring back to 0 by shifting both
             * label and field downward in parallel;
             * this is to keep the widget inside w->ypos, w->height
             */
        *labelYoffset = -(*fieldYoffset);
        *fieldYoffset = 0;
    }
    fieldBaseline += *fieldYoffset;
    labelBaseline += *labelYoffset;

    if ((labelBaseline + labelDescent) >
        (fieldHeight + *fieldYoffset)) {
        lowestDescent = (labelBaseline + labelDescent);
    }
    else {
        lowestDescent = (fieldHeight + *fieldYoffset);
    }
    return (lowestDescent);
#endif
}

/* : wOptionFieldHeight - return the height of the
 * (static, or closed) choices-box portion of a W_OPTION
 */
int
wOptionFieldHeight(choicesFont, choicesShadow)
XFontStruct *choicesFont;
data_ptr choicesShadow;
{
    int fieldHeight, xoff, yoff;
    
#if AXMS
    fieldHeight = choicesFont->ascent + choicesFont->descent;
#else   
    fieldHeight = choicesFont->ascent + choicesFont->descent +
        2 * MIN(choicesFont->ascent/5,1) + 4;
#endif  
    if(wShadowIsOn(choicesShadow)) {
        xmTextShadowOffsets(choicesFont, &xoff, &yoff);
        fieldHeight += yoff + 1;
    }
    return (fieldHeight);
}

/* : wOptionFieldBaseline - return the distance from the
 * top of the (static, or closed) choices-box portion of
 * a W_OPTION widget to the baseline of the text in that
 * that portion
 */
int
wOptionFieldBaseline(choicesFont)
XFontStruct *choicesFont;
{
#if AXMS
    return (choicesFont->ascent);
#else
    return (choicesFont->ascent +
           2 + MIN(1, choicesFont->ascent/5));
#endif  
}

void
xmLabelSize(w, name, font, shadow)
AXWidget w;
mbchar *name;
XFontStruct *font;
data_ptr shadow;
{
    wLabelSize(name, font, shadow, &w->width, &w->height);
}

void
wLabelSize(name, font, shadow, width, height)
mbchar *name;         /* in */
XFontStruct *font;    /* in */
data_ptr shadow;
int *width, *height;  /* out */
{
    XFontStruct *fs;
    XCharStruct *xc;
    int fontHeight, itmp, len;

    if (!name) {
        *width = *height = 0;
        return;
    }
    
    len = strlen(name);
    
    if (!len) {
        *width = *height = 0;
        return;
    }
    
    if (font) {
        fontHeight = font->ascent + font->descent;
        fs = font;
    }
    else {
        fontHeight = AxCharHeight;
        fs = AxDlgMainFont;
    }

    *width = AXTextWidth(fs, (char *) name, len);
    *height = fontHeight;
    
    xc = getCharStruct((int)((unsigned char) name[len - 1]), fs);
    if ((itmp = ((int) xc->rbearing - (int) xc->width)) > 0) {
            /* include extra right sidebearing in width
             */
        *width += itmp;
    }
    
    if (wShadowIsOn(shadow)) {
            /* include drop shadow in size
             */
        int xoff, yoff;
        xmTextShadowOffsets(font, &xoff, &yoff);
        *width += xoff + 1;
        *height += yoff + 1;
    }
    
    *width += 1;        /* possible etched-disabled style, adds 1pix */
    *height += 1;
}

/* for W_ENTER, convert width from #columns to pixels */
int wEnterPixWidth(nColumns, font, textShadow)
int nColumns;
XFontStruct *font;
data_ptr textShadow;
{
    register int pixwid, cellwidth, xtra;
    
    if (font) {
        cellwidth = AXTextWidth(font, "0", 1);
    }
    else {
        cellwidth = WidthOfDialogZero;
    }
    if (wShadowIsOn(textShadow)) {
        int xoff, yoff;
        xmTextShadowOffsets(font, &xoff, &yoff);
        xtra = xoff + 1;
    }
    else {
        xtra = 0;
    }
    pixwid = (cellwidth * nColumns) + xtra + 10; /* 10 = 2+1+4+2+1 */
    return( pixwid );
}

int
wEnterColWidth(nPix, font, textShadow)
int nPix;
XFontStruct *font;
data_ptr textShadow;
{
    register int colwid, cellwidth, xtra;
    
    if (font) {
        cellwidth = AXTextWidth(font, "0", 1);
    }
    else {
        cellwidth = WidthOfDialogZero;
    }
    if (wShadowIsOn(textShadow)) {
        int xoff, yoff;
        xmTextShadowOffsets(font, &xoff, &yoff);
        xtra = xoff + 1;
    }
    else {
        xtra = 0;
    }
    colwid = (nPix - 10 - xtra) / cellwidth;
    if (colwid <= 0)
        colwid = 0;
    return( colwid );
}

void
wEnterPixHeight(font, textShadow, winHeight, totalHeight)
XFontStruct *font;
data_ptr textShadow;
int *winHeight, *totalHeight;    /* out */
{
    register int cellHeight, xtra;
    if (font) {
        cellHeight = font->ascent + font->descent;
    }
    else {
        cellHeight = AxCharHeight;
    }
    if (wShadowIsOn(textShadow)) {
        int xoff, yoff;
        xmTextShadowOffsets(font, &xoff, &yoff);
        xtra = xoff + 1;
    }
    else {
        xtra = 0;
    }
    *winHeight = cellHeight + xtra + 4;

#if AXMS
    if ( cellHeight == AxCharHeight )
       {
       /* this is a default font sized entry box, use the window's size */
       *totalHeight = Entry_Height;
       }
    else
#endif

    *totalHeight  = *winHeight + 6;
}

/* : wEnterFieldOffset - return a vector extending from
 * the W_ENTER widget's overall origin to the origin of
 * its enterable field window
 */
void
wEnterFieldOffset(labelStyle, labelText, labelFont,
                  fieldFont, fieldNcolumns, fieldTextShadow,
                  xoffset, yoffset)
int labelStyle;            /* in: LABEL_NONE, LABEL_LEFT, LABEL_TOP */
mbchar *labelText;         /* in */
XFontStruct *labelFont;    /* in */
XFontStruct *fieldFont;    /* in */
int fieldNcolumns;         /* in: DBDEXwidth as used by W_ENTER */
data_ptr fieldTextShadow;  /* in */
int *xoffset;              /* out: return x component of vector */
int *yoffset;              /* out: y component */
{
    int labelHt, labelWid, fieldHt, itmp;
    int labelBaseline, fieldBottom;
    XFontStruct *label_font, *field_font;
    
    if (LABEL_NONE == labelStyle) {
        *xoffset = *yoffset = 0;
        return;
    }

        /* resolve label/field fonts */
    if (labelFont) {
        label_font = labelFont;
    }
    else {
        label_font = AxDlgMainFont;
    }
    if (fieldFont) {
        field_font = fieldFont;
    }
    else {
        field_font = AxDlgMainFont;
    }

    labelHt = label_font->ascent + label_font->descent;
    labelWid = AXTextWidth(label_font, labelText, MBstrlen(labelText));
    wEnterPixHeight(field_font, fieldTextShadow, &itmp, &fieldHt);
    
    if (LABEL_TOP == labelStyle) {
        *xoffset = 0;
        *yoffset = labelHt + LABEL_HEIGHT_PAD;
        return;
    }
    
    /* the label style is LABEL_LEFT. the xoffset is set to
     * the label width, plus a 3 pixels.  the yoffset is
     * STD_ENTRY_YSHIFT, but lower if needed to prevent the
     * label's baseline from dipping below the field's bottom
     * edge (use 2pix above that edge, actually)
     */
    labelBaseline = label_font->ascent;
    fieldBottom = fieldHt - STD_ENTRY_YSHIFT - 2;
#if AX_X11
    fieldBottom -= 4;      /* the painter offsets the field frame -4.. */
#endif  
    if ((itmp = labelBaseline - fieldBottom) > 0) {
        *yoffset = itmp;
    }
    else {
        *yoffset = -(STD_ENTRY_YSHIFT);
    }
    *xoffset = labelWid + 3;
}

/* for W_LIST, convert visible item count into pixel height */
int
wListPixHeight(visibleItemCount, font, textShadow, horizScroll)
int visibleItemCount;
XFontStruct *font;
data_ptr textShadow;
int horizScroll;
{
    int fontHeight, listHeight, x_height, win_rows;
    int xoff = 0;
    int yoff = 0;

    if (wShadowIsOn(textShadow)) {
        xmTextShadowOffsets(font, &xoff, &yoff);
        yoff++;     /* add a pix in case shadow is diffuse */
    }
    if (font) {
        fontHeight = font->ascent + font->descent + yoff;
    }
    else {
        fontHeight = AxCharHeight + yoff;
    }
    
#if AXMS
    /* to make the dialogs lay out as close to the X side as possible, */
    /* if the listbox uses the default dialog font and not a custom font */
    /* we compute the height of the box on X, given that the default font */
    /* on X is 16 pixels high.  Using this pixel height, we then see how */
    /* many rows we can fit into that space using the current dialog font */
    /* on windows.                                                        */
    if ( font  == (XFontStruct *)NULL )
        {
        /* using the default font */
        x_height = 16 * visibleItemCount + 5;    /* 5 == 7 - 2 */
        if ( horizScroll )
            {
            /* under X the scrollbar is added below the window, while here */
            /* it is inside the window.  So add in "16", the height if the */
            /* X scrollbar to get the total height on the X dialog         */
            win_rows = (x_height+16-SCROLLBAR_THICK) / AxCharHeight;
        	listHeight = (win_rows * fontHeight) + SCROLLBAR_THICK;
            /* make sure the height is a multiple of the line height, */
            /* Windows seems to clip it off at the line height! - jon */
            win_rows = (listHeight+fontHeight-1) / fontHeight;
            }
        else
            /* no horizontal scroll bar */
            win_rows = x_height / AxCharHeight;

       	listHeight = (win_rows * fontHeight) + 2;
	    }
    else
	    {
	    /* not the default font, we can not adjust with any accuracy  */
	    listHeight = visibleItemCount * fontHeight + 2;
	    }
#else
    listHeight = (visibleItemCount * fontHeight) + 7;
#endif
    
    return (listHeight);
}

int wListVisibleItemCount(pixheight, font, textShadow, horizScroll)
int pixheight;
XFontStruct *font;
data_ptr textShadow;
int horizScroll;
{
    int itemCount;
    int fontHeight;
    int xoff = 0;
    int yoff = 0;
    
    if (wShadowIsOn(textShadow)) {
        xmTextShadowOffsets(font, &xoff, &yoff);
        yoff++;     /* add a pix in case shadow is diffuse */
    }
    if (font) {
        fontHeight = font->ascent + font->descent + yoff;
    }
    else {
#if AXMS
        /* 16 = X default font height. see above in wListPixHeight. */
        fontHeight = 16 + yoff;
#else
        fontHeight = AxCharHeight + yoff;
#endif
    }
    
#if AXMS
    /* in wListPixHeight, we only adjusted for the horizontal scroll
     * if we were using the default font.
     */
    if ( horizScroll && !font ) {
        pixheight -= SCROLLBAR_THICK;
    }
    pixheight += 3;     /* 3 = -2 + 5 */
#else
    pixheight -= 7;
#endif
    
    itemCount = pixheight / fontHeight;
    if (itemCount <= 0)
        itemCount = 0;
    return itemCount;
}

    /* for W_LIST, convert width in columns to width in pixels */
int
wListPixWidth(nCols, rev, referenceFont)
int nCols;                   /* in: width in character cells */
int rev;                     /* in: dbox revision */
XFontStruct *referenceFont;  /* in: dbox reference font */
{
    int width, win_cols;

    if ( rev == 0 ) {
        /* for rev 0 list boxes, the width is n*8+40. For newer
         * boxes, the width is computed from the actual char size */
        width = nCols * 8 + 40;
        width = axDlgScaleX(width, referenceFont);  
    }
    else {
#if AX_X11   /*  {  */
          width = (nCols * WidthOfDialogZero) + 6; /* +6 border */

#else   /*  }  AX_X11/AXMS  { */

    /* to make the dialogs lay out as close to the X side as possible, */
    /* if the listbox uses the default dialog font and not a custom font */
    /* we compute the width of the box on X, given that on X the default */
    /* dthOfDialogZero" == 7.  Using this width, we then see how many cols*/
    /* can fit into that space using the current dialog font on windows. */
    if ( (rev > 0) && 
         ((referenceFont == (XFontStruct *)NULL) ||
          (referenceFont->ascent + referenceFont->descent == AxCharHeight)) )
        {
        /* no special font, or the font is the same "size" as the default */
        /* dialog font.  Comput the X size and then the windows size      */
        width = (nCols * 7);
        win_cols = width / WidthOfDialogZero;
        width = (win_cols * WidthOfDialogZero) + 6;
        }
     else
        {
        /* some special font, just do the basics since we can not extimate */
        /* the size on X                                                   */
        width = (nCols * WidthOfDialogZero) + 6; 
        }
#endif    /*  }  AXMS  */

    }
    return width;
}

    /* inverse of wListPixWid - convert pixels to columns */
int
wListColWidth(pixwid, rev, referenceFont)
int pixwid;             /* in: listbox width in pix */
int rev;                    /* in: parent dbox revision */
XFontStruct *referenceFont; /* in: parent dbox's reference font */
{
    int colwid;

    if ( rev == 0 ) {
        colwid = (axDlgUnscaleX(pixwid, referenceFont) - 40) / 8;
    }
    else {
        colwid = (pixwid - 6) / WidthOfDialogZero;
    }
    return colwid;
}

void
wIconSize(name, maxWidth, maxHeight, width, height)
mbchar *name;             /* in */
int maxWidth, maxHeight;  /* in */
int *width, *height;      /* out */
{
    pixcache_t *pix;
    
    pix = Pixmapper((char *) name);
    if (!pix) {
        *width = 0;
        *height = 0;
    }
    else if (maxWidth > 0 && maxHeight > 0) {
        *width = MIN((unsigned int) pix->width, (unsigned int) maxWidth);
        *height = MIN((unsigned int) pix->height, (unsigned int) maxHeight);
    }
    else {
        *width = pix->width;
        *height = pix->height;
    }
}

int
wComboHeight(fp)
XFontStruct *fp;
{
    return (CbComputeComboHeight(fp));
}

/* : xmAcceleratorIsVisible - return the 1st index of the
 * passed accelerator char within the passed text range.
 * Return -1 if none found.  str and len are assumed to be safe.
 */
int
xmAcceleratorIsVisible(accelerator_key, str, len)
int accelerator_key;
mbchar *str;
int len;
{
	int ix, acc_ix = -1;
	
	if (accelerator_key) {
		for (ix = 0; ix < len; ix++) {
			if (Atoupper((unsigned int) str[ix]) == accelerator_key) {
				return ix;
			}
		}
	}
	return acc_ix;
}

/* : xmDrawStringAndAccelerator - draw a label string, and possibly
 * also an Alt-<char> accelerator-indicator (an underscore beneath <char>)
 */
void
xmDrawStringAndAccelerator(w, win, gc, xpos, ypos, str, len,
						   shadow, color, backColor, accelerator_key)
AXWidget w;
Drawable win;
GC gc;
int xpos, ypos;
mbchar *str;
int len;
data_ptr shadow;
wcolor_t *color;
wcolor_t *backColor;
int accelerator_key;
{
	int accel_ix = -1;
	xmDrawString(w, win, gc, xpos, ypos, str, len, shadow, color, backColor);
	if (str && len > 0) {
		accel_ix = xmAcceleratorIsVisible(accelerator_key, str, len);
	}
	if (accel_ix >= 0) {
		if (accel_ix > 0) {
			xpos += AXTextWidth(w->font ? w->font : AxDlgMainFont,
								str, accel_ix);
		}
		/* may also need to increase ypos a pix or so, which would
		 * need to be included in label measurements.. for now use passed ypos
		 */
		xmDrawString(w, win, gc, xpos, ypos, "_", 1, shadow, color, backColor);
	}
}

void
xmDrawString(w, win, gc, xpos, ypos, str, len, shadow, color, backColor)
AXWidget w;
Drawable win;
GC gc;
int xpos, ypos;
mbchar *str;
int len;
data_ptr shadow;
wcolor_t *color;
wcolor_t *backColor;
{
#if BUILD_WIDE
    wchar *wstrP;
  
    wstrP = (wchar *)MbToWOneStr( str );
    len = Wstrlen( wstrP );
    xmIntDrawStringW(w, win, gc, xpos, ypos,
                      wstrP, len, shadow, color, backColor);
#else
    xmIntDrawStringW(w, win, gc, xpos, ypos,
                    (wchar *)str, len, shadow, color, backColor);
#endif
}

void
xmDrawString16(w, win, gc, xpos, ypos, str, len, shadow, color, backColor)
AXWidget w;
Drawable win;
GC gc;
int xpos, ypos;
wchar *str;
int len;
data_ptr shadow;
wcolor_t *color;
wcolor_t *backColor;
{
    xmIntDrawStringW(w, win, gc, xpos, ypos,
                    (void *) str, len, shadow, color, backColor);
}

static void
xmIntDrawStringW(w, win, gc, xpos, ypos, str, len, shadow, color, backColor)
AXWidget w;
Drawable win;
GC gc;
int xpos, ypos;
wchar *str;
int len;
data_ptr shadow;
wcolor_t *color;
wcolor_t *backColor;
{
    int wide;               /* bool; whether string is wchar or mbchar */
    int use_color = TRUE;
    static GC fontGC = (GC) NULL;
    static GC shadowGC = (GC) NULL;
    static unsigned long valuemask = 0;
    GC tgc, sun_gc, shadow_gc;
    PIXEL_VALUE saved_fg, sun_pix, shadow_pix;
    int hasShadow, restore;
    XFontStruct *tfont;

    /** We interpret the input buffer of type "wchar" base on the build  */
#if BUILD_WIDE
    wide = TRUE;
#else
    wide = FALSE;
#endif

/* create static gcs  */
    if (!fontGC) {
        fontGC = axGetGC(GXcopy, AllPlanes, ~AllPlanes, AllPlanes);
    }
    if (!shadowGC) {
        shadowGC = axGetGC(GXcopy, AllPlanes, ~AllPlanes, AllPlanes);
    }
    if (!valuemask) {
        valuemask = GCFunction | GCPlaneMask | GCFont |
            GCForeground | GCBackground | GCFillStyle | GCFillRule |
                GCTile | GCStipple | GCTileStipXOrigin | GCTileStipYOrigin |
                    GCClipMask | GCClipXOrigin | GCClipYOrigin;
    }

/* select appropriate gc */
    if (w->font) {
        XCopyGC(Dpy, gc, valuemask, fontGC);
        tgc = fontGC;
        tfont = w->font;
    }
    else {
        tgc = gc;
        tfont = AxDlgMainFont;
    }
    
    if (w->disabled || NoColor || AxNoWidgetColor) {
        use_color = FALSE;
    }

    if (use_color && wShadowIsOn(shadow) && !w->disabled) {
        hasShadow = TRUE;
        XCopyGC(Dpy, gc, valuemask, shadowGC);
    }
    else {
        hasShadow = FALSE;
    }

    if (w->font) {
        axSetFont(Dpy, fontGC, w->font);
    }

    if (hasShadow && w->font) {
        axSetFont(Dpy, shadowGC, w->font);
    }

    if (hasShadow) {
        paintTextDropShadow(w, win, shadowGC, xpos, ypos, str, len, wide);
    }
    if (color && use_color) {
        saved_fg = AXGetForegroundPixel(Dpy, tgc);
        XSetForeground(Dpy, tgc, color->any.pixel);
    }
    if (w->disabled && xmUseEtchedDisabled(w, backColor, &sun_gc, &shadow_gc,
                                           &sun_pix, &shadow_pix, &restore)) {
        
        axSetFont(Dpy, sun_gc, tfont);
        axSetFont(Dpy, shadow_gc, tfont);
        if (wide) {
            axDrawString16(Dpy, win, sun_gc, tfont,
                           xpos + 1, ypos + 1, (wchar *) str, len);
            axDrawString16(Dpy, win, shadow_gc, tfont,
                           xpos, ypos, (wchar *) str, len);
        }
        else {
            axDrawString(Dpy, win, sun_gc, tfont, xpos + 1, ypos + 1,
                         (mbchar *) str, len);
            axDrawString(Dpy, win, shadow_gc, tfont,
                         xpos, ypos, (mbchar *) str, len);
        }
        if (restore) {
            XSetForeground(Dpy, sun_gc, sun_pix);
            XSetForeground(Dpy, shadow_gc, shadow_pix);
        }
    }
    else {
        if (wide) {
            axDrawString16(Dpy, win, tgc, tfont,
                           xpos, ypos, (wchar *) str, len);
        }
        else {
            axDrawString(Dpy, win, tgc, tfont,
                         xpos, ypos, (mbchar *) str, len);
        }
    }
    if (color && use_color) {
        XSetForeground(Dpy, tgc, saved_fg);
    }
}

void
xmTextShadowOffsets(font, xoff, yoff)
XFontStruct *font;
int *xoff, *yoff;
{
    XFontStruct *fs;
    int height, tmp, shift, offset;
    
    if (font) {
        fs = font;
    }
    else {
        fs = AxDlgMainFont;
    }
    
        /* take the lesser of min_bounds.width
         * and a height-relative figure
         */
    offset = fs->min_bounds.width;
    if (!offset)
        offset = 1;
    
    height = fs->ascent + fs->descent;
    tmp = height >> 4;
    if (!tmp)
        tmp = 1;
    
    if (tmp < offset) {
        *xoff = tmp;
        *yoff = tmp;
    }
    else {
        *xoff = offset;
        *yoff = offset;
    }
}

int
wShadowIsOn(shadow)
data_ptr shadow;
{
    if (!UseWidgetColors) {
        return FALSE;
    }
    if (Thim2dMode) {
        return FALSE;
    }
    if (!shadow) {
        return FALSE;
    }
    if (!AxIsArray(shadow)) {
        return FALSE;
    }
        /* expected to be an array, with 0th element an on/off bool */
    if (!AxIntFromArray(shadow, 0)) {
        return FALSE;
    }
    return TRUE;
}

/* : axGetGC - convenience wrapper for axCreateGC
 */
GC
axGetGC(function, foreground, background, planemask)
int function;
unsigned long foreground, background, planemask;
{
    XGCValues gcv;
    unsigned long mask;

    memset((char *)&gcv, 0, sizeof(XGCValues));
    mask = GCForeground | GCBackground | GCFunction | GCPlaneMask;
    gcv.function = function;
    gcv.foreground = foreground;
    gcv.background = background;
    gcv.plane_mask = planemask;
    return (axCreateGC(Dpy, AxTopWinNeverMapped, DefaultScreen(Dpy),
                       DisplayPlanes(Dpy, DefaultScreen(Dpy)),
                       (XFontStruct *) 0, mask, &gcv));
}

/*************************************************************************
function: PaintLabel - Paint text string
*/
static void PaintLabel (w, exP, regen, layered)
register AXWidget_label w;
XEvent *exP;
int regen;
int layered;
{
    register GC gc;
    int ascent;
    wcolor_t *backColor;
    AXWidget bw;
    char str[1001];

    WIDGET_PARANOID( w, W_LABEL );
    if ( !w->display || w->style == LABEL_NONE)
        return;

    if ( w->parent && (w->parent->type == W_DIALOG) &&
        !((AXWidget_dialog) w->parent)->exposed )
        return;
    
    if (layered) {
        if (w->flags & WFLG_IN_EDIT) {
            if (dePaintWidget(w)) {
                return;
            }
        }
        else {
            if (topWidget(w) == (AXWidget)w) {
                paintCompositeWidget(w, exP, regen);
                return;
            }
        }
    }
    
    w->mapped = TRUE;
#if AXMS
	/* on Windows, we need to draw a "static control", unless we are in
	 * the dialog editor, in which case we use the old draw string code.
	 */
    if ( !(w->flags & WFLG_IN_EDIT) )
		{
		axmsPaintLabel(w);
		return;
		}
#endif
	gc = w->disabled ? DisabledGC : ForeGC;
	if (w->font) {
		ascent = w->font->ascent;
	}
	else {
		ascent = w->small_font ? SmallCharAbove : AxCharAbove;
	}
    MBstrcpy(str,w->name);
    XmClipText(str,w->width,w->font,w->small_font);
    
    backColor = (wcolor_t *) NULL;
    if (w->disabled && (bw = backgroundWidget(w))) {
        backColor = bw->widgetColor;
    }
    if (LABEL_BACKGROUND_CLEARED == w->style) {
        int l_height, l_width;
        wLabelSize(w->name, w->font, w->textShadow, &l_width, &l_height);
        if (w->widgetColor) {
            bw = (AXWidget) w;   /* use label's own widget color as bg */
        }
        else {
            bw = backgroundWidget(w);
        }
        xmColorFillRectangle(bw, WIN_OF(w), BackGC, w->xpos, w->ypos,
                             l_width, l_height);
    }
    
    xmDrawStringAndAccelerator(w, WIN_OF(w), gc, w->xpos, w->ypos + ascent,
							   str, strlen(str), w->textShadow, w->textColor,
							   backColor, w->accelerator_key);
}


/*************************************************************************
function: AXmCreateLabelGadget - Produce a fixed str
*/
AXWidget AXmCreateLabelGadget (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_label w;
    register int oldFlags;
    register wcolor_t *oldColor;
    wcolor_t tcolor;
    register int test_identical_appearance = FALSE;

    if ( args[0].value ) {
        w = (AXWidget_label)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
            w->update_widget = TRUE;
            WidgetNeedsUpdated = TRUE;
        }
        else {
            test_identical_appearance = TRUE;
            oldFlags = w->flags;
            if (w->textColor) {
                tcolor = *(w->textColor);
                oldColor = &tcolor;
            }
            else {
                oldColor = (wcolor_t *) NULL;
            }
        }
        SetWidgetName(w, name);
    }
    else {
        w = (AXWidget_label)CrtWidget(W_LABEL,parentWidget,name);
    }
    w->painter = PaintLabel;
    AxXtSetValues(w,args,cnt);
    xmLabelSize(w, name, w->font, w->textShadow);
    
    if (test_identical_appearance) {
            /* the footprint test above has ruled out most
             * of what could cause a visual difference; request
             * repaint here only if color or grayedness has changed,
             * or if displayedness is has just been toggled on
             */
        if (((w->flags & WFLG_INACTIVE) != (oldFlags & WFLG_INACTIVE)) ||
            ((!(w->flags & WFLG_NODISPLAY) && (oldFlags & WFLG_NODISPLAY))) ||
            !wColorsEqual(oldColor, w->textColor)) {
            
            w->update_widget = TRUE;    /* color,display,gray changed */
            WidgetNeedsUpdated = TRUE;
        }
    }
    
    return((AXWidget)w);
}                                                
            
/* : AXmNewFootprint - return bool indicating whether
 * the passed widget's size/position will change after
 * accepting the Arg list.
 */
int     /* return whether footprint will change */
AXmNewFootprint(w, name, args, cnt)
register AXWidget w;        /* in */
register char *name;        /* in */
register Arg args[];        /* in */
register int cnt;           /* in */
{
    register int ix;
    register int newFlags;
    int width, height, new_width;
    AXWidget_pushbutton bw;
    
        /* we're looking for changes in any of:
         *   xpos, ypos, width, height, font,
         *   grayed-ness, displayed-ness, title,
         *   shadow, text shadow, style
         */
    if (!args) {
        return(FALSE);
    }
    
    if (name && strcmp(name, w->name)) {
            /* a change in title; whether footprint
             * is affected is type-dependent:
             */
        switch(w->type) {
            
        case W_RADIO:
        case W_TOGGLE:
        case W_OPTION:
        case W_LABEL:
            return (TRUE);
            
        case W_ENTER:
            if (w->style != LABEL_NONE) {
                return (TRUE);
            }
            break;
            
        case W_BUTTON:
            bw = (AXWidget_pushbutton) w;
            width = new_width = bw->width;
            height = bw->height;
            wVerbButtonSize(bw->name, bw->pixmapLabel, bw->font,
                            bw->thickness, bw->shadow, bw->textShadow,
                            &width, &height);
            wVerbButtonSize(name, bw->pixmapLabel, bw->font,
                            bw->thickness, bw->shadow, bw->textShadow,
                            &new_width, &height);
            if (width != new_width) {
                return (TRUE);
            }
            break;
            
        case W_RECT:
            if (RECT_LABELED == w->style) {
                return (TRUE);
            }
            break;
            
        case W_ICON:
            return (TRUE);
            
        }
    }
    
    for (ix = 0; ix < cnt; ix++) {
        switch (args[ix].name) {
            
        case XXmNx:
            if ((int) args[ix].value != w->xpos) {
                return (TRUE);
            }
            break;
            
        case XXmNy:
            if ((int) args[ix].value != w->ypos) {
                return (TRUE);
            }
            break;
            
        case XXmNwidth:
            if ((int) args[ix].value != w->width) {
                return (TRUE);
            }
            break;
            
        case XXmNcolumns:
            if (w->type == W_ENTER) {
                if ((int) args[ix].value !=
                    wEnterColWidth(w->width, w->font, w->textShadow)) {
                    
                    return (TRUE);
                }
            }
            break;
            
        case XXmNheight:
            if ((int) args[ix].value != w->height) {
                return (TRUE);
            }
            break;
            
        case XXmNaxFont:
            if (args[ix].value) {
                if (w->font != lookupNamedFont((data_ptr) args[ix].value)) {
                    if ((w->type != W_TABLE) && (w->type != W_EDITBOX)) {
                        /* for most types, font change changes widget size
                         */
                        return (TRUE);
                    }
                }
            }
            break;
            
        case XXmNflags:
            newFlags = (int) args[ix].value;
            if ((newFlags & WFLG_INACTIVE) != (w->flags & WFLG_INACTIVE)) {
                
                /* change in grayedness; affects footprint only for some types
                 */
                if ((w->type == W_LABEL || w->type == W_TOGGLE ||
                    w->type == W_OPTION)) {
                    
                    int etch = !AxNoWidgetColor;
                    
                    if (newFlags & WFLG_INACTIVE) {
                        /* changing from ungrayed to grayed; new footprint
                         * if shadowed, or if non-etch style gray
                         */
                        if (!etch || (wShadowIsOn(w->textShadow))) {
                            return (TRUE);
                        }
                    }
                    else {
                        /* changing from grayed to ungrayed; new footprint
                         * only for etch-style case
                         */
                        if (etch) {
                            return (TRUE);
                        }
                    }
                }
            }
            if (!(w->flags & WFLG_NODISPLAY) && (newFlags & WFLG_NODISPLAY)) {
                return (TRUE);    /* changing from displayed to undisplayed */
            }
            break;
            
        case XXmNshadow:
            if (args[ix].value) {
                if (!AXequalData((data_ptr) args[ix].value, w->shadow)) {
                    return (TRUE);
                }
            }
            break;
            
        case XXmNtextShadow:
            if (args[ix].value) {
                if (!AXequalData((data_ptr) args[ix].value, w->textShadow)) {
                    return (TRUE);
                }
            }
            break;
            
        case XXmNstyle:
            if (w->style != (int) args[ix].value) {
                return (TRUE);
            }
            break;
            
        case XXmNwidgetColor:
            if (W_RECT == w->type) {
                wcolor_t *coltmp;
                coltmp = AxCreateWColor(w, (data_ptr) args[ix].value);
                if (!w->widgetColor || memcmp((void *) w->widgetColor,
                                              (void *) coltmp,
                                              sizeof(wcolor_t))) {
                    AxFreeWColor(coltmp);
                    return (TRUE);
                }
                AxFreeWColor(coltmp);
            }
            break;
        
        case XXmNthickness:
            if (w->thickness != (int) args[ix].value) {
                return (TRUE);
            }
            break;
            
        case XXmNvisibleItemCount:
            if (W_LIST == w->type) {
                AXWidget_list wl = (AXWidget_list) w;
                if (wl->scroll_max != (int) args[ix].value) {
                    return (TRUE);
                }
            }
            break;
            
        }
    }
    return (FALSE);
}

/*
*   ssFindPlatesGadget - special code to handle ss folder tabs gadgets on
*           plates widget
*   note: Some magic numbers used have meaning as follows
*
*       7 - width of each folder pixmap
*       22 - height of folder pixmap
*       24 - where the folder panel ends
*/
ssFindPlatesGadget(wp, x, y)
AXWidget_pushbutton wp;
int x,y;
{
double m;
int newx, newy;


    WIDGET_PARANOID(wp, W_BUTTON);
    /* regular buttons */
    if ( (x >= wp->xpos) && (x < wp->xpos+wp->width) &&
            (y >= wp->ypos) && (y < 24) )
         return(TRUE);

    if(wp->pixmapLabel) 
        return(FALSE);
    
    /* folder tab buttons */
    if ( (x < wp->xpos-7) || (x >= (wp->xpos+wp->width+7)) ||
         (y < wp->ypos) || (y >= 24) ) 
             return(FALSE); /* complete outside the folder tab */
    
    m = 22.0/7.0;       /* height/width of folder tab pixmaps */
    if(x >= wp->xpos + wp->width)
        newx = 7 - (x - (wp->xpos + wp->width));
    else
        newx = x - (wp->xpos - 7);
    
    newy = ( m * newx);
    y = wp->ypos + 22 - y;
    if(y > newy)
        return(FALSE);
    return(TRUE);
}


/*************************************************************************
function: XmNewStarMenu - Change the display state of the leftmost menu
Lsb of passed value for "new mail".  Other bits for future use.
*/
void XmNewStarMenu(newval)
int newval;
{
    register AXWidget w;

    if ( ((newval & 1) && AxNewMailMenuIcon) ||
         (!(newval & 1) && !AxNewMailMenuIcon) )
        return;

    AxNewMailMenuIcon = (newval & 1);

	if (TaskIsJavaBased(ThimPidFromUID(TaskInfo[AxInTask].uid))) {
		JvNewStarMenu(AxNewMailMenuIcon);
		return;
	}

#if AX_X11
    AxRePaintAllMenuBars();
#else
    axmsToggleStarMenus();
#endif
}



/*************************************************************************
function: XmCreateSplitter
*/
AXWidget_splitter XmCreateSplitter(parentWidget, name, args, cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    AXWidget_splitter w;

    if ( args[0].value ) {
        w = (AXWidget_splitter)args[0].value;
        UnMapWidget(w);  /* will cause flicker, OK for now */
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else
        w = (AXWidget_splitter)CrtWidget(W_SPLITTER, parentWidget, name);
    w->painter = PaintSplitter;
    w->width = 16;  /* default */
    AxXtSetValues(w, args, cnt);
    if ( w->width < 4 )
        w->width = 4;
    w->height = w->width;
    return((AXWidget_splitter)w);
}


static void DrawDiamond (w, x, y, size, topGC, bottomGC, centerGC)
Window w;
int x, y, size;
GC topGC, bottomGC, centerGC;
{
   XSegment seg[8];
   XPoint   pt[5];
   int midX, midY;
   
   if (!diamondSize(x, y, &size, &midX, &midY, seg)) {
       return;      /* size too small to work with */
   }
   if (Thim2dMode) {
       XDrawSegments (Dpy, w, topGC, &seg[1], 1);
       XDrawSegments (Dpy, w, bottomGC, &seg[2], 2);
       XDrawSegments (Dpy, w, topGC, &seg[0], 1);
   }
   else {
       XDrawSegments (Dpy, w, topGC, &seg[2], 2);
       XDrawSegments (Dpy, w, bottomGC, &seg[4], 4);
       XDrawSegments (Dpy, w, topGC, &seg[0], 2);
   }

   pt[0].x = x + 3;
   pt[0].y = midY - 1;
   pt[1].x = midX - 1;
   pt[1].y = y + 2;
   pt[2].x = x + size - 3;
   pt[2].y = midY - 1;
   pt[3].x = midX - 1;
   pt[3].y = y + size - 3;
   if (pt[0].x > pt[1].x) return;  /* button too small */
   if (pt[0].y < pt[1].y) return;  /* button too small */
   XFillPolygon (Dpy, w, centerGC, pt, 4, Convex, CoordModeOrigin);
}

/* : diamondSize - fill in XSegment data for use in drawing
 * the diamond-shaped button on a radio-flavored toggle button
 */
int
diamondSize(x, y, size, midX, midY, seg)
int x;           /* in */
int y;           /* in */
int *size;       /* in/out */
int *midX;       /* out */
int *midY;       /* out */
XSegment *seg;   /* out: fill in this array (we expect 8 elements) */
{
    if ( *size < 4 ) {     /* ignore request, too small */
        return FALSE;
    }
    if (*size % 2 == 0)
        (*size)--;

    *midX = x + (*size + 1) / 2;
    *midY = y + (*size + 1) / 2;

    if ( Thim2dMode ) {
        /*  The top shadow segments  */
        seg[0].x1 = x;          /*  1  */
        seg[0].y1 = *midY - 1;
        seg[0].x2 = *midX - 1;       /*  2  */
        seg[0].y2 = y;
        seg[1].x1 = *midX - 1;       /*  5  */
        seg[1].y1 = y;
        seg[1].x2 = x + *size - 1;   /*  6  */
        seg[1].y2 = *midY - 1;
           /*  The bottom shadow segments  */
        seg[2].x1 = x;          /*  9  */
        seg[2].y1 = *midY - 1;
        seg[2].x2 = *midX - 1;       /*  10  */
        seg[2].y2 = y + *size - 1;
        seg[3].x1 = *midX - 1;       /*  13  */
        seg[3].y1 = y + *size - 1;
        seg[3].x2 = x + *size - 1;   /*  14  */
        seg[3].y2 = *midY - 1;
    
    }
    else {
        /*  The top shadow segments  */
        seg[0].x1 = x;          /*  1  */
        seg[0].y1 = *midY - 1;
        seg[0].x2 = *midX - 1;       /*  2  */
        seg[0].y2 = y;
        seg[1].x1 = x + 1;      /*  3  */
        seg[1].y1 = *midY - 1;
        seg[1].x2 = *midX - 1;       /*  4  */
        seg[1].y2 = y + 1;
        seg[2].x1 = *midX - 1;       /*  5  */
        seg[2].y1 = y;
        seg[2].x2 = x + *size - 1;   /*  6  */
        seg[2].y2 = *midY - 1;
        seg[3].x1 = *midX - 1;       /*  7  */
        seg[3].y1 = y + 1;
        seg[3].x2 = x + *size - 2;   /*  8  */
        seg[3].y2 = *midY - 1;
           /*  The bottom shadow segments  */
        seg[4].x1 = x;          /*  9  */
        seg[4].y1 = *midY - 1;
        seg[4].x2 = *midX - 1;       /*  10  */
        seg[4].y2 = y + *size - 1;
        seg[5].x1 = x + 1;      /*  11  */
        seg[5].y1 = *midY - 1;
        seg[5].x2 = *midX - 1;       /*  12  */
        seg[5].y2 = y + *size - 2;
        seg[6].x1 = *midX - 1;       /*  13  */
        seg[6].y1 = y + *size - 1;
        seg[6].x2 = x + *size - 1;   /*  14  */
        seg[6].y2 = *midY - 1;
        seg[7].x1 = *midX - 1;       /*  15  */
        seg[7].y1 = y + *size - 2;
        seg[7].x2 = x + *size - 2;   /*  16  */
        seg[7].y2 = *midY - 1;
    }
    return TRUE;
}


void AxDrawDiamond (w, x, y, size, topGC, bottomGC, centerGC)
Window w;
int x, y, size;
GC topGC, bottomGC, centerGC;
{
    DrawDiamond (w, x, y, size, topGC, bottomGC, centerGC);
}

/*************************************************************************
function: PaintSplitter
*/
static void
PaintSplitter(w, exP, regen, layered)
AXWidget_splitter w;
XEvent *exP;
int regen;
int layered;
{
    int x, y, width, height;
    GC gc;

    if ( !w || (w->type != W_SPLITTER) )
        return;

    if ( !w->display )
        return;

    if ((w->flags & WFLG_IN_EDIT) && layered) {
        if (dePaintWidget(w))
            return;
    }

    w->mapped = TRUE;

    x = w->xpos;
    y = w->ypos + w->value - w->height/2;
    width = w->width;
    height = w->height;

    XFillRectangle(Dpy, WIN_OF(w), BackGC, x, y, width, height);

    gc = w->disabled ? DisabledGC : ForeGC;
    if ( w->disabled || Thim2dMode )
        DrawDiamond(WIN_OF(w), x, y, width, gc, gc, gc);
    else
        DrawDiamond(WIN_OF(w), x, y, width, SunGC, ShadowGC, gc);
}


/*************************************************************************
function: ArmSplitter
*/
void ArmSplitter(w, eventP)
AXWidget_splitter w;
XEvent *eventP;
{
    int ypos, val;
    XmScaleCallbackStruct data;


    WIDGET_PARANOID(w, W_SPLITTER);
    if ( eventP->type == ButtonPress ) {
        if ( SplitterArmed )
            return;
        SplitterArmed = (AXWidget)w;
        if ( w->flags & WFLG_ACTIVE_RETURN ) {
            data.reason = 0;
            data.value = w->value;
            if ( w->callback )
                AxCallback(w->callback,w, w->callbacktag, &data);
        }
    }
    else if ( eventP->type == MotionNotify ) {
        ypos = MAX(w->ypos, eventP->xmotion.y);
        ypos = MIN(w->ypos+w->maxHeight, ypos);
        val = ypos - w->ypos;
        if ( w->value != val ) {
            MoveSplitter(w, val);
            if ( w->flags & WFLG_MOD_RETURN ) {
                data.reason = 1;
                data.value = w->value;
                if ( w->callback )
                    AxCallback(w->callback,w, w->callbacktag, &data);
            }
        }
    }
    else if ( eventP->type == ButtonRelease) {
        SplitterArmed = NULL;
        ypos = MAX(w->ypos, eventP->xbutton.y);
        ypos = MIN(w->ypos+w->maxHeight, ypos);
        val = ypos - w->ypos;
        if ( w->value != val ) {
            MoveSplitter(w, val);
        }
        data.reason = 2;
        data.value = w->value;
        if ( w->callback )
            AxCallback(w->callback,w, w->callbacktag, &data);
    }
}

/*************************************************************************
function: MoveSplitter
*/
void MoveSplitter(w, new_value)
AXWidget_splitter w;
int new_value;
{
    int y, ht;

    WIDGET_PARANOID(w, W_SPLITTER);
    XCopyArea(Dpy, WIN_OF(w), WIN_OF(w), GXForeGC, w->xpos,
                   w->ypos+w->value-w->height/2, w->width, w->height,
                   w->xpos, w->ypos+new_value-w->height/2);
    if ( abs(w->value-new_value) > w->height ) {
        y = w->ypos + w->value - w->height/2;
        ht = w->height;
    }
    else if ( w->value > new_value ) {
        y = w->ypos + new_value + w->height/2;
        ht = w->ypos + w->value + w->height/2 - y;
    }
    else {
        y = w->ypos + w->value - w->height/2;
        ht = w->ypos + new_value - w->height/2 - y;
    }
    XFillRectangle(Dpy, WIN_OF(w), BackGC, w->xpos, y, w->width, ht);
    w->value = new_value;
}


/*************************************************************************
function: AXmCreateScrollBar - Create a scroll bar
*/
AXWidget AXmCreateScrollBar (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget w;
    register int width = 0;

    w = (AXWidget)CrtWidget(W_SCROLL,parentWidget,name);
    w->painter = PaintScrollBar;
    w->width   = SCROLLBAR_THICK;
    w->height  = SCROLLBAR_THICK;
    AddToWindowList(w);
    AxXtSetValues(w,args,cnt);
    return((AXWidget)w);
}

/*************************************************************************
function: XmCreateRect - Produce a surface or etching
*/
AXWidget_rect XmCreateRect (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_rect w;

    if ( args[0].value ) {
        w = (AXWidget_rect)args[0].value;
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
        if (AXmNewFootprint((AXWidget)w, name, args, cnt)) {
            UnMapWidget(w);
        }
        SetWidgetName(w, name);
    }
    else
        w = (AXWidget_rect)CrtWidget(W_RECT,parentWidget,name);
    w->painter = PaintRect;
    AxXtSetValues(w,args,cnt);
    w->height = MAX(2,w->height);
    w->width = MAX(2,w->width);
    return((AXWidget_rect)w);
}


#define RECTAB_HORIZ_PAD 8   /* from left edge tab text to left edge tab */
#define RECTAB_VERT_PAD 5

/* tabrow_h type describes starting indices of
 * the 1 or more rows of tabs on a tabctl
 */
typedef struct tabrow_h_t {
    int num_rows;
    int *row_start_ix;
} tabrow_h;

/* tabpos type describes an individual tab on a tabcontrol */
typedef struct tabpos_t {
    int xpos;                   /* relative to axw_rect left edge */
    int ypos;                   /* relative to axw_rect top edge */
    int width;                  /* width of this tab */
    int height;
} tabpos;

static int
xmTabctlActiveRow(tc, tabrows)  /* sub of xmFormatRectTabs, xmDrawRectTabs */
tabctl_info *tc;     /* in */
tabrow_h *tabrows;   /* in */
{
    int active_row, ix;

    /* get index of row which contains current active tablayer
     */
    for (active_row = 0, ix = 0; ix < tabrows->num_rows; ix++) {
        if (tc->active_layer >= tabrows->row_start_ix[ix]) {
            active_row = ix;
        }
    }
    return (active_row);
}

/* : xmTabctlWidthPad - compute an additional width term
 * to apply to all the tabcontrol tabs, as part of formatting.
 */
static int
xmTabctlWidthPad(tc, tabctl_width, tabfont, bigcount)
tabctl_info *tc;             /* in */
int tabctl_width;
XFontStruct *tabfont;        /* in */
int *bigcount;         /* out: #times pad should be added in as (pad + 1) */
{
    int ix, itmp, widest, twid, thistab_wid, pad, tcount;
    int num_rows, check_nrows, check_padding;
    int multi_row = FALSE;

    /* get width of widest row of tabs
     */
    widest = twid = 0;
    num_rows = 1;
    for (ix = 0; ix < tc->num_layers; ix++) {
        thistab_wid = (2 * RECTAB_HORIZ_PAD) +
            AXTextWidth(tabfont, tc->layerlist[ix].layerName,
                        MBstrlen(tc->layerlist[ix].layerName));
        itmp = twid + thistab_wid;
        if (itmp > (tabctl_width - RECTAB_HORIZ_PAD)) {
            multi_row = TRUE;
            num_rows++;
            if (twid > widest) {
                widest = twid;
            }
            twid = thistab_wid;
        }
        else {
            twid = itmp;
        }
    }
    
    if (!multi_row) {
        *bigcount = 0;
        return (0);             /* just one row of tabs, good.  no padding */
    }
    else {
        if (twid > widest) {
            widest = twid;
        }
    }

    /* repeat, to sum up total padding needed across all rows
     */
    for (pad = twid = 0, ix = 0; ix < tc->num_layers; ix++) {
        thistab_wid = (2 * RECTAB_HORIZ_PAD) +
            AXTextWidth(tabfont, tc->layerlist[ix].layerName,
                        MBstrlen(tc->layerlist[ix].layerName));
        itmp = twid + thistab_wid;
        if (itmp > (tabctl_width - RECTAB_HORIZ_PAD)) {
            if (twid < widest) {
                pad += widest - twid;
            }
            twid = thistab_wid;
        }
        else {
            twid = itmp;
        }
    }
    if (twid < widest) {
        pad += widest - twid;
    }
    
    tcount = pad % tc->num_layers;
    pad = pad / tc->num_layers;
        
    /* use these tentative padding vals, and recompute #rows; reduce
     * padding as needed to keep #rows same as 1st computation above.
     */
    check_padding = TRUE;
    while (pad && check_padding) {
        check_nrows = 1;
        for (twid = 0, ix = 0; ix < tc->num_layers; ix++) {
            
            thistab_wid = (2 * RECTAB_HORIZ_PAD) +
                AXTextWidth(tabfont, tc->layerlist[ix].layerName,
                            MBstrlen(tc->layerlist[ix].layerName)) +
                                ((tcount > 0) ? pad + 1 : pad);
            tcount--;
            
            itmp = twid + thistab_wid;
            if (itmp > (tabctl_width - RECTAB_HORIZ_PAD)) {
                check_nrows++;
                twid = thistab_wid;
            }
            else {
                twid = itmp;
            }
        }
        if (check_nrows > num_rows) {
            pad = pad * tc->num_layers;
            pad = (int) ((float) pad * 0.7);
            tcount = pad % tc->num_layers;
            pad = pad / tc->num_layers;
        }
        else {
            check_padding = FALSE;
        }
    }
    *bigcount = tcount;
    return (pad);
}

/* : xmFormatRectTabs - lay out a tabcontrol's tabs
 * for drawing, and for event dispatching.
 */
static void
xmFormatRectTabs(tc, tabctl_width, tabfont, tablist, rows)
tabctl_info *tc;             /* in */
int tabctl_width;
XFontStruct *tabfont;        /* in */
tabpos **tablist;            /* out: caller must free returned list */
tabrow_h **rows;             /* out: caller must free */
{
    int itmp, ix, rx, xoff, yoff, leftix;
    int tabheight, active_row, nrows, lx;
    int widest_rowix, max_rowwid;
    int pad, bigcount;
    tabpos *tp;
    
    /* this code can do top-edge tabs only.... */

    pad = xmTabctlWidthPad(tc, tabctl_width, tabfont, &bigcount);

    tabheight = tabfont->ascent + (2 * RECTAB_VERT_PAD);
    tc->top_inset = tabheight;
    
    itmp = tc->num_layers * sizeof(tabpos);
    *tablist = (tabpos *) malloc (itmp);
    memset((void *) *tablist, 0, itmp);
    tp = *tablist;

    *rows = (tabrow_h *) malloc(sizeof(tabrow_h));
    memset((void *) *rows, 0, sizeof(tabrow_h));
    (*rows)->row_start_ix = (int *) malloc(sizeof(int));
    (*rows)->row_start_ix[0] = 0;
    (*rows)->num_rows = 1;
    widest_rowix = max_rowwid = 0;
    rx = 0;

    for (xoff = leftix = yoff = 0, ix = 0; ix < tc->num_layers; ix++) {
        tp[ix].xpos = xoff;
        tp[ix].ypos = yoff;
        tp[ix].width = (2 * RECTAB_HORIZ_PAD) +
            AXTextWidth(tabfont, tc->layerlist[ix].layerName,
                        MBstrlen(tc->layerlist[ix].layerName)) +
                            ((bigcount > 0) ? (pad + 1) : pad);
        bigcount--;
        
        tp[ix].height = tabheight;
        
        if ((itmp = tp[ix].xpos + tp[ix].width) >
            (tabctl_width - RECTAB_HORIZ_PAD)) {
            
            /* tab doesn't fit on this row; move down
             */
            if (ix > 0) {
                tp[ix].xpos = 0;
                tp[ix].ypos = tp[leftix].ypos + tabheight;
            }
            yoff += tabheight;
            tc->top_inset += tabheight;

            if (xoff > max_rowwid) {
                max_rowwid = xoff;
                widest_rowix = rx;
            }

            /* record start index, ypos of new row
             */
            rx++;
            (*rows)->row_start_ix = (int *)
                realloc((*rows)->row_start_ix, (rx + 1) * sizeof(int));
            (*rows)->row_start_ix[rx] = ix;
            (*rows)->num_rows++;
            
            leftix = ix;
        }
        
        if ((ix == (*rows)->row_start_ix[rx]) &&
            (ix != tc->active_layer)) {
            
            tp[ix].xpos++;
            tp[ix].width--;
        }
        
        xoff = tp[ix].xpos + tp[ix].width;
    }
    if (xoff > max_rowwid) {
        max_rowwid = xoff;
        widest_rowix = rx;
    }

    nrows = (*rows)->num_rows;
    active_row = xmTabctlActiveRow(tc, *rows);

    if (active_row < (nrows - 1)) {
        /* shift y positions of the rows, so that
         * active row appears as bottommost
         */
        int shift = nrows - active_row - 1;
        int shifted_ix, row_ypos;

        for (rx = 0; rx < nrows; rx++) {
            if (rx < (nrows - 1)) {
                lx = (*rows)->row_start_ix[rx + 1] - 1;
                if (lx < 0) {
                    lx = 0;
                }
            }
            else {
                lx = tc->num_layers - 1;
            }
            shifted_ix = (rx + shift) % nrows;
            row_ypos = shifted_ix * tabheight;
            for (ix = (*rows)->row_start_ix[rx]; ix <= lx; ix++) {
                tp[ix].ypos = row_ypos;
            }
        }
    }

    if (nrows > 1) {
        /* reset widths of tabs to get all rows wide as widest
         */
        int before_width, ntabs, bigcount, werr;
        for (rx = 0; rx < nrows; rx++) {
            if (rx != widest_rowix) {
                if (rx < (nrows - 1)) {
                    lx = (*rows)->row_start_ix[rx + 1] - 1;
                    if (lx < 0) {
                        lx = 0;
                    }
                }
                else {
                    lx = tc->num_layers - 1;
                }
                /* get width before justification
                 */
                for (before_width = 0, ntabs = 0,
                     ix = (*rows)->row_start_ix[rx];
                     ix <= lx; ix++) {

                    before_width += tp[ix].width;
                    ntabs++;
                }
                /* justify the row of tabs against widest row width
                 */
                itmp = (max_rowwid - before_width);
                werr = itmp / ntabs;
                bigcount = itmp % ntabs;
                ix = (*rows)->row_start_ix[rx];
                xoff = tp[ix].xpos;
                for (  ; ix <= lx; ix++) {
                    itmp = ((bigcount > 0) ? werr + 1 : werr);
                    bigcount--;
                    tp[ix].xpos = xoff;
                    tp[ix].width += itmp;
                    xoff = tp[ix].xpos + tp[ix].width;
                }
            }
        }
    }
}

int
xmTabctlTopInset(tc, tabctl_width, tabfont)
tabctl_info *tc;                            /* in/out */
int tabctl_width;
XFontStruct *tabfont;                       /* in */
{
    tabpos *tablist;
    tabrow_h *rows;

    xmFormatRectTabs(tc, tabctl_width, tabfont, &tablist, &rows);
    
    free(tablist);
    if (rows->row_start_ix) {
        free(rows->row_start_ix);
    }
    free(rows);
    
    return (tc->top_inset);
}

static void
xmDrawRectTabs(w, tabfont, poslist, rowlist)
AXWidget_rect w;
XFontStruct *tabfont;
tabpos *poslist;
tabrow_h *rowlist;
{
    int ix, lx, rx, active_row, preclear_width;
    int itmp, row_y, top_row;

    /* this code can do top-edge tabs only.... */
    
    if (!(w && w->tabctl.num_layers)) {
        return;
    }

    /* preclear left edge of tabs
     */
    xmColorFillRectangle(backgroundWidget(w), WIN_OF(w), BackGC,
                         w->xpos, w->ypos - 1, 3,
                         w->tabctl.top_inset + 1);

    /* now paint tabs themselves
     */
    if (rowlist->num_rows > 1) {
        /* index thru the rows to paint top-to-bottom
         */
        int jx;
        active_row = xmTabctlActiveRow(&w->tabctl, rowlist);
        for (row_y = INT_MAX, top_row = 0, rx = 0;
             rx < rowlist->num_rows; rx++) {

            itmp = rowlist->row_start_ix[rx];
            if (poslist[itmp].ypos < row_y) {
                row_y = poslist[itmp].ypos;
                top_row = rx;
            }
        }
        for (rx = top_row, jx = 0; jx < rowlist->num_rows; jx++, rx++) {
            if (rx >= rowlist->num_rows) {
                rx = 0;
            }
            if (rx < (rowlist->num_rows - 1)) {
                lx = rowlist->row_start_ix[rx + 1] - 1;
                if (lx < 0) {
                    lx = 0;
                }
            }
            else {
                lx = w->tabctl.num_layers - 1;
            }
            if (preclear_width = poslist[lx].xpos + poslist[lx].width) {
                /* preclear top edge of tabs for this row
                 */
                if (rx == top_row) {
                    xmColorFillRectangle(backgroundWidget(w), WIN_OF(w),
                                         BackGC, w->xpos + 3,
                                         w->ypos + poslist[lx].ypos - 1,
                                         preclear_width - 1, 5);
                }
                else {
                    xmColorFillRectangle(w, WIN_OF(w), BackGC, w->xpos + 3,
                                         w->ypos + poslist[lx].ypos,
                                         preclear_width - 1, 4);
                }
            }
            /* draw tabs for this row
             */
            for (ix = rowlist->row_start_ix[rx]; ix <= lx; ix++) {
                xmDrawOneRectTab(w, ix, &poslist[ix],
                                 rx == top_row,
                                 rx == active_row,
                                 ix == rowlist->row_start_ix[rx],
                                 ix == lx);
                if (w->hasFocus && (rx == active_row)) {
                    xmPaintFocusSelector(w);
                }
            }
        }
    }
    else {
        if (w->tabctl.num_layers > 0) {
            ix = w->tabctl.num_layers - 1;
            xmColorFillRectangle(backgroundWidget(w), WIN_OF(w),
                                 BackGC, w->xpos + 3,
                                 w->ypos + poslist[ix].ypos - 1,
                                 poslist[ix].xpos + poslist[ix].width - 1, 5);
        }
        for (ix = 0; ix < w->tabctl.num_layers; ix++) {
            xmDrawOneRectTab(w, ix, &poslist[ix], TRUE, TRUE, (ix==0),
                             (ix == w->tabctl.num_layers - 1));
            if (w->hasFocus) {
                xmPaintFocusSelector(w);
            }
        }
    }
}

static void
xmDrawOneRectTab(w, tab_ix, tpos, top_row, bottom_row, left_tab, right_tab)
AXWidget_rect w;      /* in */
int tab_ix;
tabpos *tpos;         /* in */
int top_row;          /* in: bool */
int bottom_row;       /* in: bool */
int left_tab;         /* in: bool; this is leftmost tab in row */
int right_tab;        /* in: bool; this is rightmost tab in row */
{
    /* this code can do top-edge tabs only.... */
    int xpos, ypos, width, height, left_xtra_height;
    int clipped, txlen, text_width, xtra_height, ytmp, xtmp;
    PIXEL_VALUE savedSun, savedShadow;
    PIXEL_VALUE sun_pixel, shadow_pixel;
    PIXEL_VALUE saved_recessed;
    XFontStruct *tabfont;
    int restore_recessed;
    int coloredBevel = FALSE;
    int active = FALSE;
	int bevel = w->thickness > 1 ? 2 : 1;

    /* init sun/shadow pixel values to defaults
     */
    sun_pixel = SunPixel;
    shadow_pixel = ShadowPixel;
    
    if (w && w->widgetColor) {
        /* try for sun/shadow colors based on widget color
         */
        coloredBevel = AxGetSunShadowPixels(w->widgetColor, &sun_pixel,
                                            &shadow_pixel);
    }

    if (coloredBevel) {
        /* recolor SunGC and ShadowGC
         */
        savedSun = AXGetForegroundPixel(Dpy, SunGC);
        savedShadow = AXGetForegroundPixel(Dpy, ShadowGC);
        XSetForeground(Dpy, SunGC, sun_pixel);
        XSetForeground(Dpy, ShadowGC, shadow_pixel);
    }

    xpos = tpos->xpos + w->xpos;
    ypos = tpos->ypos + w->ypos + 1;
    width = tpos->width + 1;
    if (width > w->width) {
        width = w->width;
        clipped = TRUE;
    }
    else {
        clipped = FALSE;
    }
    height = tpos->height - 1;
    if (tab_ix == w->tabctl.active_layer) {
        active = TRUE;
        ypos -= 2;
        height += 4;
        if (left_tab) {
            width += 1;
        } else {
            xpos -= 2;
            width += 3;
        }
    }
    
    /* preclear tab background
     */
	ytmp = active ? ypos : ypos - 1;
	xtmp = xpos;
	if (bevel > 1) {
		xtmp = active ? xpos : xpos - 1;
	}
	xmColorFillRectangle(w, WIN_OF(w), BackGC, xtmp + bevel, ytmp + bevel,
						 width - 2 * bevel, height + 1 - bevel);

    if (bottom_row && !active) {
        /* bit of rail at bottom of tab
         */
        int ix, thick, ty;
        thick = abs(w->thickness);
        for (ix = 0, ty = ypos + height; ix < thick; ix++) {
            XDrawLine(Dpy, WIN_OF(w), SunGC, xpos, ty, xpos + width + 1, ty);
            ty++;
        }
    }

    xtra_height = left_xtra_height = 0;
    if (!bottom_row) {
        if (right_tab) {
            xtra_height = w->tabctl.top_inset - tpos->ypos - tpos->height;
        }
        if (left_tab) {
            left_xtra_height = 5;
        }
    }

    /* left tab edge
     */
    ytmp = active ? ypos + height - 3 : ypos + height - 1;
    ytmp += left_xtra_height;
    if (left_tab || (tab_ix - 1 != w->tabctl.active_layer)) {
        XDrawLine(Dpy, WIN_OF(w), SunGC, xpos, ypos + 2, xpos, ytmp);
        if (w->thickness > 1) {
            XDrawLine(Dpy, WIN_OF(w), SunGC, xpos + 1, ypos + 2, xpos + 1,
                      ytmp);
        }
    }
    
    /* top tab edge
     */
    XDrawLine(Dpy, WIN_OF(w), SunGC, xpos + 2, ypos, xpos + width - 4, ypos);
    if (w->thickness > 1) {
        XDrawLine(Dpy, WIN_OF(w), SunGC, xpos + 1, ypos + 1,
                  xpos + width - 3, ypos + 1);
    } else {
        XDrawPoint(Dpy, WIN_OF(w), SunGC, xpos + 1, ypos + 1);
    }
        
    /* right tab edge
     */

    /* pre-clear possibly different previous edge */
    if (right_tab && bottom_row) {
        xmColorFillRectangle(backgroundWidget(w), WIN_OF(w), BackGC,
							 xpos+width-1, ypos-1, 2,
							 height + (active ? -1 : 1));
    }

    ytmp = active ? ypos + height - 3 : ypos + height - 1;
    ytmp += xtra_height;
    XDrawLine(Dpy, WIN_OF(w), ShadowGC, xpos + width - 2, ypos + 2,
              xpos + width - 2, ytmp);


    /* weaker hilite (used to be anti-shadow */
    xmSetRecessedGCToAntiShadow(w, &restore_recessed, &saved_recessed);
    if (w->thickness > 1) {
        ytmp = active ? ypos + height - 3 : ypos + height - 1;
        ytmp += xtra_height;
        XDrawLine(Dpy, WIN_OF(w), RecessGC, xpos + width - 3, ypos + 1,
                  xpos + width - 3, ytmp);
    } else {
        XDrawPoint(Dpy, WIN_OF(w), RecessGC, xpos + width - 3, ypos + 1);
    }
    if (restore_recessed) {
        XSetForeground(Dpy, RecessGC, saved_recessed);
    }
    
    if (coloredBevel) {
        /* restore SunGC, ShadowGC
         */
        XSetForeground(Dpy, SunGC, savedSun);
        XSetForeground(Dpy, ShadowGC, savedShadow);
    }
    
    /* draw tab text
     */
    tabfont = w->font ? w->font : AxDlgMainFont;
    xpos += RECTAB_HORIZ_PAD;
    if (active && !left_tab) {
        xpos++;
    }
    txlen = MBstrlen(w->tabctl.layerlist[tab_ix].layerName);
    if (clipped) {
        /* shorten txlen as needed to "clip" text to within reduced tab wid */
        int ix, twid, ch;
        XCharStruct *xc;
        for (twid = RECTAB_HORIZ_PAD, ix = 0; ix < txlen; ix++) {
            ch = (int) (w->tabctl.layerlist[tab_ix].layerName[ix]);
            xc = getCharStruct(ch, tabfont);
            if (!xc) {
                break;
            }
            if (twid + xc->width > width) {
                txlen = ix;
                break;
            }
            twid += xc->width;
        }
        text_width = AXTextWidth(tabfont,w->tabctl.layerlist[tab_ix].layerName,
                                 txlen);
    }
    else {
        text_width =
            AXTextWidth(tabfont, w->tabctl.layerlist[tab_ix].layerName,
                        MBstrlen(w->tabctl.layerlist[tab_ix].layerName));
        /* adjust xpos to center-align the text
         */
        xpos += (tpos->width - (text_width + (2 * RECTAB_HORIZ_PAD))) / 2;
    }
  
    xmDrawStringAndAccelerator(w, WIN_OF(w), ForeGC, xpos,
							   ypos + RECTAB_VERT_PAD + tabfont->ascent - 1,
							   w->tabctl.layerlist[tab_ix].layerName, txlen,
							   w->textShadow, w->textColor, w->widgetColor,
							   w->tabctl.layerlist[tab_ix].accelerator_key);
    
    return;
}

/* : xmWidgetIsHidden - return whether passed widget is contained
 * in a tab-control style W_RECT, in a tablayer that is currently hidden.
 */
int
xmWidgetIsHidden(w)
AXWidget w;
{
    int ix;
    hitem *list;
    widglink *wl;
    
    if (!(w && w->tabctl_linktab))
        return (FALSE);
    
    for (ix = 0; ix < w->tabctl_linktab->width; ix++) {
        list = w->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (wl && !wl->direction && (WIDGLINK_TABLAYER == wl->link_type)) {
                /* an uplink to a tabcontrol-style rect
                 */
                int jx;
                long my_layer = (long) wl->link_data;
                AXWidget_rect rw = (AXWidget_rect) wl->to;

                if (xmWidgetIsHidden(rw)) {
                    return (TRUE);  /* all layers of hidden rect are hidden */
                }
                else {
                    if (rw->tabctl.active_layer == my_layer) {
                        return (FALSE);
                    }
                    else {
                        return (TRUE);
                    }
                }
            }
            list = list->next;
        }
    }
    return (FALSE);
}

/* : xmRectHideOrRevealLayer - hide or reveal all the widgets
 * of the indicated layer of a tab-control style W_RECT.
 */
void
xmRectHideOrRevealLayer(rw, layer_ix, hide)
AXWidget_rect rw; /* in */
int layer_ix;     /* in: index of tabcontrol layer to hide or reveal */
int hide;         /* in; bool */
{
    int ix, jx;
    hitem *list;
    AXWidget tw;
    AXWidget_rect rr;
    widglink *wl;
    wComposite *cp;

    if (!(rw && rw->tabctl_linktab))
        return;
    
    if (hide && (layer_ix != rw->tabctl.active_layer)) {
        return;    /* hide layer only if currently active */
    }
    
    for (ix = 0; ix < rw->tabctl_linktab->width; ix++) {
        list = rw->tabctl_linktab->table[ix];
        while (list) {
            wl = (widglink *) list->value;
            if (wl && wl->direction && ((long) wl->link_data == layer_ix)) {
                tw = wl->to;
                tw->update_widget = WidgetNeedsUpdated = TRUE;
                if (hide) {
                    tw->saved_display = tw->display;
                    tw->display = FALSE;
                }
                else {
                    tw->display = tw->saved_display;
                }
                xmlibStr.FullRegenForUpdate = TRUE;
                if (tw->auxData) {
                    for (cp = tw->auxData->compositeList; cp; cp = cp->next) {
                        if (cp->type == WLINKDOWN) {
                            if (hide) {
                                cp->w->saved_display = cp->w->display;
                                cp->w->display = FALSE;
                            }
                            else {
                                cp->w->display = cp->w->saved_display;
                            }
                            cp->w->update_widget = TRUE;
                        }
                    }
                }
                if ((W_RECT == tw->type) &&
                    (RECT_LAYERED == tw->style)) {

                    rr = (AXWidget_rect) tw;
                    if (hide) {
                        /* hide all layers of this tabctl rect
                         */
                        for (jx = 0;
                             jx < rr->tabctl.num_layers; jx++) {
                            
                            xmRectHideOrRevealLayer(rr, jx, hide);
                        }
                    }
                    else {
                        xmRectHideOrRevealLayer
                            (rr, rr->tabctl.active_layer, 0);
                    }
                }
            }
            list = list->next;
        }
    }
}

int
RectEvent(rw, evp)
register AXWidget_rect rw;
register XEvent *evp;
{
    tabpos *tablist;
    tabrow_h *tabrows;
    XFontStruct *tabfont;
    int lx, ly, ix;
    int event_consumed = FALSE;

    if (!rw || !evp)
        return (FALSE);
    
    if (rw->type != W_RECT)
        return (FALSE);
    
    if (rw->style != RECT_LAYERED)
        return (FALSE);
    
    if (!rw->tabctl.num_layers)
        return (FALSE);

    switch (evp->xany.type) {
    case ButtonPress:
        tabfont = rw->font ? rw->font : AxDlgMainFont;
        tablist = (tabpos *) NULL;
        tabrows = (tabrow_h *) NULL;
        xmFormatRectTabs(&rw->tabctl, rw->width, tabfont, &tablist, &tabrows);
        lx = evp->xbutton.x - rw->xpos;
        ly = evp->xbutton.y - rw->ypos;
        for (ix = 0; ix < rw->tabctl.num_layers; ix++) {
            if ((lx >= tablist[ix].xpos) &&
                (lx < tablist[ix].xpos + tablist[ix].width) &&
                (ly >= tablist[ix].ypos) &&
                (ly < tablist[ix].ypos + tablist[ix].height)) {
                
                /* button press inside tab
                 */
                event_consumed = TRUE;
                xmtcSwitchLayer(rw, ix);
            }
        }
        if (tablist) {
            free(tablist);
        }
        if (tabrows) {
            if (tabrows->row_start_ix) {
                free(tabrows->row_start_ix);
            }
            free(tabrows);
        }
        break;
    }
    return (event_consumed);
}

int
TabctlKeyPressHandler(rw, eventP, ksym, kbuf, num_chars)
     AXWidget_rect rw;         /* in: widget getting the keypress */
     XEvent *eventP;           /* in: keypress event */
     KeySym ksym;
     wchar *kbuf;       /* in: key string associated with ksym, from LookupString */
     int num_chars;            /* num_chars in kbuf */
{
  /* left, right arrows switch active layer.
   */
  if (XK_Left == ksym) {
    if (rw->tabctl.active_layer > 0) {
      xmtcSwitchLayer(rw, rw->tabctl.active_layer - 1);
    }
    else {
      xmtcSwitchLayer(rw, rw->tabctl.num_layers - 1);
    }
	return (TRUE);
  }
  else if (XK_Right == ksym) {
    if (rw->tabctl.active_layer < rw->tabctl.num_layers - 1) {
      xmtcSwitchLayer(rw, rw->tabctl.active_layer + 1);
    }
    else {
      xmtcSwitchLayer(rw, 0);
    }
	return (TRUE);
  }
  return (FALSE);
}

/* : sub called from RectEvent, TabctlKeyPressHandler.
 */
void
xmtcSwitchLayer(rw, new_ix)
AXWidget_rect rw;          /* in; assumed to be RECT_LAYRED-style */
int new_ix;                /* assumed to be within range */
{
    if (new_ix != rw->tabctl.active_layer) {
        /* we're changing to a new layer
         */
        XmRowColumnCallbackStruct data;
        int itmp;
        
        xmRectHideOrRevealLayer(rw, rw->tabctl.active_layer, TRUE);
        rw->tabctl.active_layer = new_ix;
        xmRectHideOrRevealLayer(rw, new_ix, FALSE);
        if (rw->flags & WFLG_IN_EDIT) {
            rw->update_widget = WidgetNeedsUpdated = TRUE;
        }
        else {
            xmTabctlPaintTabs(rw);  /* just paint directly, avoid full paint */
        }
            
        itmp = rw->tabctl.active_layer;
        data.data = rw->tabctl.layerlist[itmp].layerName;
        if (rw->callback) {
            AxCallback(rw->callback, rw, rw->callbacktag, &data);
        }
    }
}

/*************************************************************************
function: PaintRect - Paint an etched line or surface
*/
static void PaintRect (w, exP, regen, layered)
register AXWidget_rect w;
XEvent *exP;
int regen;
int layered;
{
    void DrawHorizGroove(), DrawVertGroove();
    int width, height, thickness, x, y;
    int top_inset;
    Window d;
    XFontStruct *tabfont;
    tabpos *tablist;
    tabrow_h *tabrows;

    if ( w->parent && (w->parent->type == W_DIALOG) && 
                !((AXWidget_dialog) w->parent)->exposed )
        return;

    if (layered) {
        if (w->flags & WFLG_IN_EDIT) {
            if (dePaintWidget(w)) {
                return;
            }
        }
        else {
            if (topWidget(w) == (AXWidget)w) {
                paintCompositeWidget(w, exP, regen);
                return;
            }
        }
    }
    
    tabfont = w->font ? w->font : AxDlgMainFont;
    top_inset = 0;
    tablist = (tabpos *) NULL;
    tabrows = (tabrow_h *) NULL;

    if (RECT_LAYERED == w->style) {
        xmFormatRectTabs(&w->tabctl, w->width, tabfont, &tablist, &tabrows);
        top_inset = w->tabctl.top_inset;
    }
        
    w->mapped = TRUE;
    x = w->xpos;
    y = w->ypos + top_inset;
    width = w->width;
    height = w->height - top_inset;
    thickness = abs(w->thickness);
    thickness = MIN(10,thickness);   /* sanity */
    d = WIN_OF(w);

    if ( w->thickness == 0 || (RECT_LABELED == w->style)) { /* etched style */
        if ( height < 4 ) { /* horiz line */
            XDrawLine(Dpy,d,ShadowGC,x,y,x+width,y);
            XDrawLine(Dpy,d,SunGC,x,y+1,x+width,y+1);
            w->height = 2;      /* sanity */
        }
        else if ( width < 4 ) { /* vert line */
            XDrawLine(Dpy,d,ShadowGC,x,y,x,y+height);
            XDrawLine(Dpy,d,SunGC,x+1,y,x+1,y+height);
            w->width = 2;       /* sanity */
        }
        else {
            AxDrawBevel(w, d, x, y, width, height, 1, BEVEL_ETCH);
        }
    }
    else if ( w->thickness < 0 ) {
        AxDrawBevel(w, WIN_OF(w), x, y, width, height,
                    thickness, BEVEL_IN);
    }
    else {
        AxDrawBevel(w, WIN_OF(w), x, y, width, height,
                    thickness, BEVEL_OUT);
        if (wShadowIsOn(w->shadow)) {
                /* draw a drop shadow */
            xmDrawRectShadow(w, x, y, width, height);
            xmDrawRectAntiShadow(w, x, y, width, height);
        }
    }

    if ((width >= 4) && (height >= 4)) {
            /* Fill the rectangle if it has a tile, fillcolor, or graphic.
             * Tile and fillcolor are exclusive of each other.  Any graphic
             * will be painted on top of those.
             */
        if (w->background_image) {
        }
        else if (w->widgetColor) {
            xmColorFillRectangle(w, WIN_OF(w), BackGC, x + thickness,
                                 y + thickness, width - (2 * thickness),
                                 height - (2 * thickness));
        }
        if (w->graphic) {
            AxRenderInsetGraphic(w, w->graphic);
        }
    }

    if (RECT_LAYERED == w->style && tablist) {
        xmDrawRectTabs(w, tabfont, tablist, tabrows);
        free(tablist);
        if (tabrows) {
            if (tabrows->row_start_ix) {
                free(tabrows->row_start_ix);
            }
            free(tabrows);
        }
    }
    
    if (RECT_LABELED == w->style) {
        /* draw the panel label after pre-clearing the etch beneath
         */
        XFontStruct *labelfont;
        AXWidget backWidget;
        int labelwidth, labelypos;
        
        labelfont = w->font ? w->font : AxDlgMainFont;
        labelwidth = AXTextWidth(labelfont, w->name, MBstrlen(w->name));
        backWidget = backgroundWidget(w);
        xmColorFillRectangle(backWidget, WIN_OF(w), BackGC, x + 5, y,
                             labelwidth + 10, 2);
        labelypos = y + labelfont->ascent / 2;
        xmDrawString(w, WIN_OF(w), ForeGC, x + 10,
					 labelypos, w->name, MBstrlen(w->name),
					 w->textShadow, w->textColor,
					 backWidget->widgetColor);
        
        /* borrow w->tabctl to store the bottom extent of the label
         */
        w->tabctl.top_inset = labelypos + labelfont->descent + 2;
    }
        
    w->mapped = TRUE;
}

static void
xmTabctlPaintTabs(rw)
AXWidget_rect rw;
{
    XFontStruct *tabfont;
    tabpos *tablist;
    tabrow_h *tabrows;
    
    if (rw) {
        tabfont = rw->font ? rw->font : AxDlgMainFont;
        tabrows = (tabrow_h *) NULL;
        xmFormatRectTabs(&rw->tabctl, rw->width, tabfont, &tablist, &tabrows);
        xmDrawRectTabs(rw, tabfont, tablist, tabrows);
        free(tablist);
        if (tabrows->row_start_ix) {
            free(tabrows->row_start_ix);
        }
        free(tabrows);
    }
}

/* : xmPaintPanelFace - paint only a subrect of the passed W_RECT's
 * face.  This assumes that the passed dimensions are fully inside
 * the widget's bevel.
 */
void
xmPaintPanelFace(w, x, y, width, height)
AXWidget_rect w;
int x, y, width, height;
{
    if (w->background_image) {
    }
    else if (w->widgetColor && (width > 0)  && (height > 0)) {
        xmColorFillRectangle(w, WIN_OF(w), BackGC, x, y, width, height);
    }
    
    if (w->update_widget && (RECT_LAYERED == w->style)) {
        /* repaint the tabs portion
         */
        xmTabctlPaintTabs(w);
    }
}

/* : xmPaintFocusSelector - paint a rectangle around the widget
 * to denote that this widget has the keyboard focus within its dialog.
 */
void
xmPaintFocusSelector(ww)
AXWidget ww;
{
    r32 rr;

    if (!(ww && ww->parent->hasFocus)) 
        return;
    
    if (ww->disabled || !ww->display)
        return;
    
    if (xmWidgetIsHidden(ww))  /* i.e., in hidden tabctl layer */
        return;
    
    xmFocusSelectorRect(ww, &rr);
#if AXMS
	/* on Windows, we'll be drawing a GDI rect, unless we are in the
	 * dialog editor, in which case we use the straight draw code.
	 */
    if ( !(ww->flags & WFLG_IN_EDIT) )
		{
		RECT rect;
		rect.top = rr.origin.y;
		rect.left = rr.origin.x;
		rect.right = rr.origin.x + rr.width;
		rect.bottom = rr.origin.y + rr.height;
		if ( !IsRectEmpty(&rect) )	/* GDI call */
			{
			InflateRect(&rect, 1, 1);
			axmsDrawWidgetFocusRect(WIN_OF(ww), &rect, TRUE);
			}
		return;
		}
#endif
    XDrawRectangle(Dpy, WIN_OF(ww), ForeGC,
                   rr.origin.x, rr.origin.y,
                   rr.width, rr.height);
    if (W_BUTTON == ww->type) {
        /* buttons are painted so differently based on focus that..
         */
        ww->update_widget = WidgetNeedsUpdated = TRUE;
    }
}

void
xmLiftFocusSelector(ww)
AXWidget ww;
{
    r32 rr;
    PIXEL_VALUE saved_fg;
    AXWidget bw;

    if (!ww)
        return;
    
    xmFocusSelectorRect(ww, &rr);

#if AXMS
	/* on Windows, we'll be drawing a GDI rect, unless we are in the
	 * dialog editor, in which case we use the straight draw code.
	 */
    if ( !(ww->flags & WFLG_IN_EDIT) )
		{
		RECT rect;
		rect.top = rr.origin.y;
		rect.left = rr.origin.x;
		rect.right = rr.origin.x + rr.width;
		rect.bottom = rr.origin.y + rr.height;
		if ( !IsRectEmpty(&rect) )	/* GDI call */
			{
			InflateRect(&rect, 1, 1);
			axmsDrawWidgetFocusRect(WIN_OF(ww), &rect, FALSE);
			}
		return;
		}
#endif

    if (W_RECT == ww->type) {
        bw = ww;                    /* selector painted on ww's surface */
    }
    else {
        bw = backgroundWidget(ww);  /* selector painted around widget */
    }
    if (bw && bw->widgetColor && !(NoColor || AxNoWidgetColor)) {
        saved_fg = AXGetForegroundPixel(Dpy, BackGC);
        XSetForeground(Dpy, BackGC, bw->widgetColor->any.pixel);
    }
    
    XDrawRectangle(Dpy, WIN_OF(ww), BackGC,
                   rr.origin.x, rr.origin.y,
                   rr.width, rr.height);
    
    if (bw && bw->widgetColor && !(NoColor || AxNoWidgetColor)) {
        XSetForeground(Dpy, BackGC, saved_fg);  /* restore */
    }

    if (W_DIALOG == ww->parent->type) {
        if ((W_TOGGLE == ww->type) || (ww->flags & WFLG_IN_EDIT)) {
            /* mark lift-damage for toggles.  For all other types,
             * neglect the lift damage that may occur (0 or 1pix
             * around the rectangular part of the widget). (Note we
             * mark damage all the time in dialog editor.)
             */
            xmMarkDamaged(ww->parent, &rr);
        }
    }
    
    if (W_BUTTON == ww->type) {
        /* buttons are painted so differently based on focus that..
         */
        ww->update_widget = WidgetNeedsUpdated = TRUE;
    }
}

void
xmFocusSelectorRect(ww, rr)
AXWidget ww;
r32 *rr;      /* out */
{
    int itmp;
    
    rr->origin.x = rr->origin.y = rr->width = rr->height = 0;

/* On Windows, we only paint a selector rect around our home-grown
 * widgets (e.g. W_RECT). For the Windows widgets we return an empty
 * rect which tells the caller not to draw the rect.
 */
    
    switch (ww->type) {
        
    case W_ENTER:
#if AX_X11
        rr->origin.x = ww->xpos + 1;
        rr->origin.y = ww->ypos - 5;
        rr->width = ww->width + 2;
        rr->height = ww->height + 2;
#endif
        break;
        
    case W_TOGGLE:
#if AX_X11
        if (!(ww->width && ww->height)) {   /* why tho?? a bug elsewhere */
            xmToggleButtonSize(ww, ww->font, ww->name);
        }
        rr->origin.x = ww->xpos - 1;
        rr->origin.y = ww->ypos - 2;
        rr->width = ww->width + 2;
        rr->height = ww->height - 2;
        if ((int) rr->height < 0)
            rr->height = 0;
#endif
        break;
        
    case W_RADIO:
#if AX_X11
        /* convert reference to that of the "on" toggle.
         */
        if (ww->auxData) {
            wComposite *cp;
            for (cp = ww->auxData->compositeList; cp; cp = cp->next) {
                if (cp->type == WLINKDOWN) {
                    if (cp->w && cp->w->value) {
                        xmFocusSelectorRect(cp->w, rr);
                        return;
                    }
                }
            }
        }
#endif
        break;

    case W_BUTTON:
#if AX_X11
        rr->origin.x = ww->xpos;
        rr->origin.y = ww->ypos;
        rr->width = ww->width - 1;
        if ((int) rr->width < 0)
            rr->width = 0;
        rr->height = ww->height - 1;
        if ((int) rr->height < 0)
            rr->height = 0;
#endif
        break;
        
    case W_OPTION:
#if AX_X11
        if (ww->name) {
            XFontStruct *fs;
            fs = ww->font ? ww->font : AxDlgMainFont;
            itmp = AXTextWidth(fs, ww->name, MBstrlen(ww->name));
            itmp += AXTextWidth(fs, NXLT(" "), 1);
        }
        else {
            itmp = 0;
        }
        rr->origin.x = ww->xpos - 1 + itmp;
        rr->origin.y = ww->ypos - 1;
        rr->width = ww->width + 1 - itmp;
        if ((int) rr->width < 0)
            rr->width = 0;
        rr->height = ww->height + 1;
#endif
        break;
        
    case W_RECT:
        if (RECT_LAYERED == ww->style) {
            /* selector goes around label of active tablayer.
             */
            XFontStruct *tabfont;
            AXWidget_rect rw;
            tabpos *tablist;
            tabrow_h *tabrows;

            rw = (AXWidget_rect) ww;
            tabfont = rw->font ? rw->font : AxDlgMainFont;
            tablist = (tabpos *) NULL;
            tabrows = (tabrow_h *) NULL;
            rr->origin.x = rr->origin.y = rr->width = rr->height = 0;
            xmFormatRectTabs(&rw->tabctl, rw->width, tabfont,
                             &tablist, &tabrows);
            if (tablist) {
                itmp = rw->tabctl.active_layer;
                rr->origin.x = tablist[itmp].xpos + RECTAB_HORIZ_PAD - 3;
                rr->origin.y = tablist[itmp].ypos + RECTAB_VERT_PAD - 2;
                rr->width = AXTextWidth
                    (tabfont, rw->tabctl.layerlist[itmp].layerName,
                     MBstrlen(rw->tabctl.layerlist[itmp].layerName));
                rr->origin.x += (tablist[itmp].width - 
                    (rr->width + ( 2 * RECTAB_HORIZ_PAD))) / 2;
                rr->width += 3;
                rr->height = tabfont->ascent + tabfont->descent;
                rr->origin.x += ww->xpos;
                rr->origin.y += ww->ypos;
                free(tablist);
            }
            if (tabrows) {
                if (tabrows->row_start_ix) {
                    free(tabrows->row_start_ix);
                }
                free(tabrows);
            }
        }
        break;
        
        
    case W_ROWCOL:      
        rr->origin.x = ww->xpos - 1;
        rr->origin.y = ww->ypos - 1;
        rr->width = ww->width + 1;
        rr->height = ww->height + 1;
        break;

    case W_CHOOSE:
        rr->origin.x = ww->xpos + 1;
        rr->origin.y = ww->ypos;
        rr->width = ww->width - 4;
        if ((int) rr->width < 0)
            rr->width = 0;
        rr->height = ww->height - 5;
        if ((int) rr->height < 0)
            rr->height = 0;
        break;
        
	case W_LIST:
#if AXMS
	/* just so we don't try to draw a selector rect around listboxes. */
		break;
#endif
    default:
        rr->origin.x = ww->xpos - 1;
        rr->origin.y = ww->ypos - 1;
        rr->width = ww->width + 1;
        rr->height = ww->height + 1;
        break;
        
    }
}

/* : xmRectInsidePanel - return bool indicating whether
 * passed rectangle fits fully inside the bevel of W_RECT w.
 */
int
xmRectInsidePanel(rect, w)
r32 *rect;
AXWidget_rect w;
{
    int thick;
    r32 inner;

    thick = abs(w->thickness);
    thick = MIN(10, thick);
    inner.origin.x = w->xpos + thick;
    inner.origin.y = w->ypos + thick;
    inner.width = w->width - (2 * thick) - 1;
    inner.height = w->height - (2 * thick) - 1;
    
    return (rectInsideRect(rect, &inner));
}

/*************************************************************************
function: PaintRadio
*/
static void PaintRadio (w, exP, regen, layered)
register AXWidget_radio w;
XEvent *exP;
int regen;
int layered;
{
    
    if ( w->parent && (w->parent->type == W_DIALOG) &&
                !((AXWidget_dialog) w->parent)->exposed )
        return;
    
    if (layered) {
        if (w->flags & WFLG_IN_EDIT) {
            if (dePaintWidget(w)) {
                return;
            }
        }
        else {
            if (topWidget(w) == (AXWidget)w) {
                paintCompositeWidget(w, exP, regen);
                return;
            }
        }
    }
    
    /* the radio is a composite widget, made of a label and
       some toggle buttons.  this empty painter is supplied
       to produce a call pattern like the other composites */
}

/*************************************************************************
function: AXmCreateRadioBox - Create a radio box
*/
AXWidget_radio AXmCreateRadioBox(parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_radio w;

    if ( args[0].value ) {
        w = (AXWidget_radio)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
        }
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
    }
    else
        w = (AXWidget_radio)CrtWidget(W_RADIO,parentWidget,name);
    w->value = -1;
    AxXtSetValues(w,args,cnt);
    w->painter = PaintRadio;

    /* provide a little more space between title and buttongroup */
    w->ypos += 2;
    return((AXWidget_radio)w);
}


pixcache_t *
xmIconPixmapAndSize(w)
AXWidget_icon w;
{
    pixcache_t *p;
    int width, height;
    
    p = Pixmapper(w->name);
    wIconSize(w->name, w->maxWidth, w->maxHeight, &width, &height);
    w->width = width;
    w->height = height;
    
    return(p);
}


/*************************************************************************
function: PaintIcon - Paint bitmap
*/
void PaintIcon (w, exP, regen, layered)
register AXWidget_icon w;
XEvent *exP;
int regen;
int layered;
{
    unsigned long fgMapColor, bgMapColor, bgPixInImage;
    unsigned long fgPixel, bgPixel;
    int x, y, use_fg, use_bg;
    XGCValues gc_value;
    pixcache_t *p;
    XImage *ximg;

    if ( !w )
        return;

    if ( w->parent && (w->parent->type == W_DIALOG) &&
                !((AXWidget_dialog) w->parent)->exposed )
        return;

    if (layered)
    {
        if (w->flags & WFLG_IN_EDIT)
        {
            if (dePaintWidget(w))
            {
                return;
            }
        }
        else
        {
            if (topWidget(w) == (AXWidget)w)
            {
                paintCompositeWidget(w, exP, regen);
                return;
            }
        }
    }

    if ( w->maxWidth > 0 && w->maxHeight > 0 )
    {
        XFillRectangle(Dpy, WIN_OF(w), BackGC,
                       w->xpos, w->ypos,
                       w->maxWidth, w->maxHeight);
    }
    p = xmIconPixmapAndSize(w);
    if (!p)
        return;
    w->mapped = TRUE;

    /* set the clip if there is one */
    if ( p->clip_mask )
    {
        XSetClipOrigin(Dpy, ForeGC, w->xpos, w->ypos);
        XSetClipMask(Dpy, ForeGC, p->clip_mask);
    }

    use_fg = getWidgetRealPixel(w->color,   &fgPixel);
    use_bg = getWidgetRealPixel(w->bg_color,&bgPixel);
    if ( use_fg && use_bg && fgPixel == bgPixel )
    {
        XGetGCValues(Dpy, ForeGC, GCForeground, &gc_value);
        XSetForeground(Dpy, ForeGC, fgPixel);
        XSetFillStyle(Dpy, ForeGC, FillSolid);
        XFillRectangle(Dpy, WIN_OF(w), ForeGC,
                       w->xpos, w->ypos,
                       w->width, w->height);
        XSetForeground(Dpy, ForeGC, gc_value.foreground);
    }
    else if ( use_bg || use_fg )
    {
        /* set the background and foreground colors of the dest image */
        fgMapColor = fgPixel;
        bgMapColor = bgPixel;

        /* get an image out of the source pixmap */
        ximg = XGetImage(Dpy, p->pix,
                         0, 0, w->width, w->height,
                         AllPlanes, ZPixmap);

        /* HACK! first pixel in image is treated as the background color */
        bgPixInImage = XGetPixel(ximg, 0, 0);

        /* transform all pixels with the same val as the first pixel to  *\
        \* background color, and all others to the foreground color  */
        if ( use_fg && use_bg ) for ( y=0; y<w->height; y++ )
        {
            for ( x=0; x<w->width; x++ )
            {
                if ( bgPixInImage == XGetPixel(ximg, x, y) )
                    XPutPixel(ximg, x, y, bgMapColor);
                else
                    XPutPixel(ximg, x, y, fgMapColor);
            }
        }
        else if ( use_fg ) for ( y=0; y<w->height; y++ )
        {
            for ( x=0; x<w->width; x++ )
            {
                if ( bgPixInImage != XGetPixel(ximg, x, y) )
                    XPutPixel(ximg, x, y, fgMapColor);
            }
        }
        else /* if ( use_bg ) */ for ( y=0; y<w->height; y++ )
        {
            for ( x=0; x<w->width; x++ )
            {
                if ( bgPixInImage == XGetPixel(ximg, x, y) )
                    XPutPixel(ximg, x, y, bgMapColor);
            }
        }

        /* display the image, then destroy the allocated space */
        if ( w->width > 0 && w->height > 0 )
        {
            XPutImage(Dpy, WIN_OF(w), ForeGC, ximg,
                      0, 0, w->xpos, w->ypos,
                      w->width, w->height);
        }
        XDestroyImage(ximg);
    }

    else if ( w->width > 0 && w->height > 0 )
    {
        /* set the clip */
        if ( p->clip_mask )
        {
            XSetClipOrigin(Dpy, ForeGC, w->xpos, w->ypos);
            XSetClipMask(Dpy, ForeGC, p->clip_mask);
        }

        /* paint thru the clip */
        XCopyArea(Dpy, p->pix, WIN_OF(w), ForeGC,
                  0, 0, w->width, w->height,
                  w->xpos, w->ypos);
    }

    /* remove any clip */
    if ( p->clip_mask )
        XSetClipMask(Dpy, ForeGC, None);
}


/*************************************************************************
function: AXmCreateText - Create a W_ENTER widget in a window
*/
AXWidget_entry AXmCreateText (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_entry w; 

    if ( args[0].value ) {
        w = (AXWidget_entry)args[0].value;
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
        }
        SetWidgetName(w, name);
    }
    else {
        w = (AXWidget_entry)CrtWidget(W_ENTER,parentWidget,name);
        w->curPos = -1;
    }
    
    w->painter = PaintEnter;
    if (  w->wstr != (wchar *)NULL )
        free(w->wstr);
    w->wstr = (wchar *)malloc( sizeof(wchar) );
    w->wstr[0] = 0;
    
    AxXtSetValues(w,args,cnt);

    if ((w->curPos != -1) &&
        ((int)w->curPos > Wstrlen(w->wstr)) ) {
        
        w->curPos = Wstrlen(w->wstr); /* in case text got smaller */
    }
    return((AXWidget_entry)w);
}

/*************************************************************************
function: AXmExposeChildren - Pass exposure to children, redraw children
*/
AXmExposeChildren (w, exP, regen, layered)
register AXWidget w;
register XExposeEvent *exP;
int regen;
int layered;
{
    register AXWidget childP;
    r32 updateRect, thisRect;

    if (w->widgets) {
        w->update_widget = FALSE;
    }
    
    AXmInitExposure(w, exP, &updateRect);

    if (w->layerList) {
        wLayer *ly;
            /* expose in back-to-front order
             */
        for ( ly = w->layerList; ly; ly = ly->next) {
            childP = ly->w;
            
            if (!childP)
                continue;
            
            if (childP->display && AxGadgetExposed(childP, &updateRect)) {
                    /* this widget is on display and overlaps updateRect
                     */
                if (exP && childP->window) {
                    AXmExposeWindowedWidget(childP, &updateRect, TRUE);
                }
                else if (childP->painter) {
                    childP->painter(childP, exP, TRUE, TRUE);
                }
                    /* make sure updateRect contains any damage
                     * caused by reshooting this widget
                     */
                widgetFootprint(childP, &thisRect);
                unionRectangle(&thisRect, &updateRect, &updateRect);
            }
        }
    }
    else {
            /* expose in widgets-chain order
             */
        for ( childP = w->widgets; childP; childP = childP->nextChild ) {
            if (childP->display && WidgetExposed(childP, exP)) {
                if (exP && childP->window) {
                    AXmExposeWindowedWidget(childP, &updateRect, FALSE);
                    continue;
                }
            }
            if (childP->painter) {
                childP->painter(childP, exP, TRUE, FALSE);
            }
        }
    }
}

/* : AXmExposeWindowedWidget - call the passed widget' painter
 * "minimally", based on the assumption that some part of the
 * widget has been damaged, but that since this is called in a
 * true expose event context, the portion falling inside its window
 * will get its own expose if it needs it. (ideally all of a widget
 * would always be inside its window, however this isn't true for
 * several types)
 */
static void
AXmExposeWindowedWidget(cw, rect, layered)
AXWidget cw;                     /* in */
r32 *rect;                       /* in: area to redisplay */
int layered;                     /* in: pass thru to painter */
{
    XExposeEvent xev;

    if (!cw || !cw->painter || !rect)
        return;
    
#if AXMS
    if ((cw->type == W_LIST) || (cw->type == W_EDITBOX) ||
        (cw->type == W_ENTER)) {
        
        return; /* GDI manages exposure paints for these types */
    }
#endif
    
    if (cw->type == W_CANVAS) {
            /* the canvas' features are all inside its own window,
             * so it can be minimally painted by doing nothing
             */
        return;
    }
    
    switch (cw->type) {
        
    case W_LIST:
#if AX_X11      
        PaintListBorder(cw);
#endif      
        break;
        
    case W_TABLE:
        PaintTableBorder(cw);
        break;
        
    case W_TRAY:
        DrawTrayBorder(cw);
        break;
        
    default:
        /* _any_ windowed widget type hitting this case is
         * vulnerable to double paints -- one now, and possibly
         * again, if an expose is delivered
         *
         * the full-painters need an expose event.
         * synthesize one here, and supply as much info as practical.
         * the x,y,width,height are essential.
         */
        memset((char *) &xev, 0, sizeof(XExposeEvent));
        xev.type = Expose;
        xev.display = Dpy;
        xev.window = cw->window;
        xev.x = rect->origin.x;
        xev.y = rect->origin.y;
        xev.width = rect->width;
        xev.height = rect->height;
    
        cw->painter(cw, &xev, TRUE, layered);
        break;
        
    }
}

/* : AXmInitExposure - copy dimensions of
 * XExposeEvent onto r32 instance
 */
static void
AXmInitExposure(parent, exP, rect)
AXWidget parent;                  /* in: typically a dbox */
XExposeEvent *exP;                 /* in */
r32 *rect;                         /* out */
{   
    if (exP && exP->type == Expose) {
        rect->origin.x = exP->x;
        rect->origin.y = exP->y;
        rect->width = exP->width;
        rect->height = exP->height;
    }
    else {
            /* treat null exP as expose-all-children
             */
        rect->origin.x = parent->xpos;
        rect->origin.y = parent->ypos;
        rect->width = parent->width;
        rect->width = parent->height;
    }
}   

/* : paintCompositeWidget - call widget's painter,
 * possibly also the painters of "composite kids",
 * for instance, the scrollbars of a list box
 */
void
paintCompositeWidget(w, exp, full_regen)
AXWidget w;                  /* in */
XExposeEvent *exp;           /* in */
int full_regen;              /* in */
{
    if (w->painter) {
        w->painter(w, exp, full_regen, FALSE);
    }
    if (w->auxData) {
        wComposite *cp;
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if (cp->type == WLINKDOWN && cp->w->painter) {
                /* 
                 * paint composite 'child', e.g., the
                 * label of an entry field
                 */
                cp->w->painter(cp->w, exp, full_regen, FALSE);
                cp->w->update_widget = FALSE;
                if (cp->w->parent && (W_DIALOG == cp->w->parent->type)
                    && cp->w->hasFocus) {
                    
                    xmPaintFocusSelector(cp->w);
                }
            }
        }
    }
    if (w->parent && (W_DIALOG == w->parent->type) && w->hasFocus) {
        xmPaintFocusSelector(w);
    }
}

/***********************************************************************
function: VerifyFontSpec - Verify a font spec.
Return 0 if font spec is OK; -1 otherwise
*/
/*ARGSUSED*/
int
VerifyFontSpec(family, size, weight, slant)
char *family;
int size;
int weight;
int slant;
{
    int number = 0;
    char **font_strs;
    int found, ix;

    if (!family)
        return(-1);
    
    font_strs = (char **)axListFontFamilies((char **) NULL, 0, &number);
    if (!font_strs || !number)
        return(-1);
    
       /* Scan returned string to
          see if it has `family'. */

    for (ix = 0, found = FALSE; ix < number; ix++) {
        if (streq(family, font_strs[ix])) {
            found = TRUE;
        }
    }
       
    for (ix = 0; ix < number; ix++) {
        THIMfree((char *) font_strs[ix]);
    }
    THIMfree(font_strs);
    
    if (found) {
        return (0);
    }
    else {
        return (-1);
    }
}



/*************************************************************************
function: AXmCreatePulldownMenu - Create the menu part of an option menu
*/
AXWidget_option AXmCreatePulldownMenu (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_option w;
    register int width = 0;
    register int ix;
    int alreadyExists = FALSE;
    XFontStruct *ofont, *choicesFont;
    int fontAscent, fontHeight;
    int labelOffset, boxOffset;
    data_ptr choicesShadow, labelShadow;

    if ( args[0].value ) {
        w = (AXWidget_option)args[0].value;
        if (AXmNewFootprint(w, name, args, cnt)) {
            UnMapWidget(w);
        }
        SetWidgetName(w, name);
        w->update_widget = TRUE;
        WidgetNeedsUpdated = TRUE;
        alreadyExists = TRUE;
    }
    else {
        w = (AXWidget_option)CrtWidget(W_OPTION,parentWidget,name);
    }
    w->painter = PaintOption;
    
#if AX_X11
    if (alreadyExists) {
            /* buttons are re-created each time thru, by caller
             */
        for ( ix = 0; ix < w->num_buttons; ix++ ) {
            AxDestroyWidget(w->buttons[ix]);
        }
        free(w->buttons);
    }
    w->buttons = NULL;
#else
    if ( w->strs ) {
        for ( ix=0; ix < w->num_strs; ix++ ) {
            if ( w->strs[ix] )
               free(w->strs[ix]);
        }
        free(w->strs);
	}
#endif
    w->num_buttons = 0; /* for re-create case */
    AxXtSetValues(w,args,cnt);
    
    if (w->font) {
        fontAscent = w->font->max_bounds.ascent;
        fontHeight = fontAscent + w->font->max_bounds.descent;
        ofont = w->font;
        labelShadow = w->textShadow;
    }
    else {
        fontAscent = AxCharAbove;
        fontHeight = AxCharHeight;
        ofont = AxDlgMainFont;
        labelShadow = (data_ptr) NULL;
    }
#if AX_X11
    if (w->num_buttons && (w->buttons[0])->font) {
        choicesFont = (w->buttons[0])->font;
        choicesShadow = (w->buttons[0])->textShadow;
    }
    else {
        choicesFont = AxDlgMainFont;
        choicesShadow = (data_ptr) NULL;
    }
#else
    if ( parentWidget->type == W_RULER )
        choicesFont = AxStatusLineFont;
    else if ( parentWidget->type == W_RIBBON )
        choicesFont = AxDlgMiniFont;
    else
        choicesFont = AxDlgMainFont;
    
    choicesShadow = (data_ptr) NULL;
#endif

#if AX_X11
        /* hack alert.. member "scrolltext" stores pixwidth of
         * widest text among pulldown choices, AX_X11 only. Init
         * to -1 to cause computation in painter
         */
    w->scrolltext = -1;
#endif

    w->height = wOptionHeight(ofont, choicesFont, labelShadow, choicesShadow,
                              &labelOffset, &boxOffset);
    w->value = -1;
    
    return((AXWidget_option)w);
}

/* : widestOptionChoice - return pixwid of the widest
 * choice string among an W_OPTION's pulldown choices
 */
int
widestOptionChoice(w)
AXWidget_option w;           /* in */
{
    int ix, thiswid, widest;
    XFontStruct *choiceFont;
    
    for ( ix = 0, widest = 0; ix < w->num_buttons; ix++ ) {
        if ((w->buttons[ix])->font) {
            choiceFont = (w->buttons[ix])->font;
        }
        else {
            choiceFont = AxDlgMainFont;
        }
        thiswid = AXTextWidth(choiceFont, (w->buttons[ix])->name,
                              MBstrlen((w->buttons[ix])->name));
        if ( thiswid > widest ) {
            widest = thiswid;
        }
    }
    return (widest);
}

/*************************************************************************
function: XmCreateDlgShell - Create W_MAIN for a dialog
*/
AXWidget XmCreateDlgShell (parent,title,iconstr)
AXWidget parent;
char *title;
char *iconstr;
{
    register AXWidget_main w;
    char *p;
    int sz;

    w = (AXWidget_main)CrtWidget(W_MAIN,NULL,title);
    w->parent = (AXWidget_main)parent;
    AddToWindowList(w);
    if ( !iconstr || !iconstr[0] )
        iconstr = "????";

    sz = strlen(iconstr)+1;
    w->wstr = (wchar *) malloc(sz * sizeof(wchar));
    MbToWStr( (mbchar *)iconstr, w->wstr );
    return((AXWidget)w);
}

/*************************************************************************
function: AXmCreateBulletinBoardDialog - Create dialog box
*/
AXWidget AXmCreateBulletinBoardDialog (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_dialog w;

    w = (AXWidget_dialog)CrtWidget(W_DIALOG,parentWidget,name);
    w->parent->dialog = w;
    AddToWindowList(w);
    SetWidgetName(w, name);
    AxXtSetValues(w,args,cnt);
    w->parent->style = w->style;   /* set icon-id on parent W_MAIN */
    w->parent->topmostwindow = w->topmostwindow;
    w->parent->notTransient = w->notTransient;
    if (w->flags & WFLG_IN_EDIT) {
            /* in_edit set by the dialog editor */
        deInitDlgEdit(w);
    }
    return((AXWidget)w);
}

/*************************************************************************
function: XmCanBeParent - Return TRUE if widget is DIALOG
This is used only for setting parentage for non-transient dialogs.
*/
XmCanBeParent (tst)
register AXWidget tst;
{
    register AXWidget w;

    for ( w = WindowList; w; w = w->nextWin ) {
        if ( (w == tst) && (w->type == W_MAIN) && ((AXWidget_main)w)->dialog )
            return(TRUE);
    }
    return(FALSE);
}


/*************************************************************************
function: AXtAppCreateShell - Create basic container widget
*/
AXWidget AXtAppCreateShell (title,iconstr)
char *title;
char *iconstr;
{
    register AXWidget_main w;
    char *p;
    int sz;

    w = (AXWidget_main)CrtWidget(W_MAIN,NULL,title);
    AddToWindowList(w);
    if ( !iconstr || !iconstr[0] )
        iconstr = "????";

    sz = strlen(iconstr)+1;
    w->wstr = (wchar *) malloc(sz * sizeof(wchar));
    MbToWStr( (mbchar *)iconstr, w->wstr );

    return((AXWidget)w);
}


/*************************************************************************
function: AXmCreateBulletinBoard - Create work area in a major app.
*/
AXWidget AXmCreateBulletinBoard (parentWidget,name,args,cnt)
register AXWidget parentWidget;
register char *name;
register Arg args[];
register int cnt;
{
    register AXWidget w;
    register int ix;
    int is_work_area = FALSE;

    w = (AXWidget)CrtWidget(W_WORK,parentWidget,name);
    AddToWindowList(w);
    SetWidgetName(w, name);
    AxXtSetValues(w,args,cnt);
    return((AXWidget)w);
}


/*************************************************************************
function: XmCreateCorner - Create a main window bottom right corner
*/
AXWidget XmCreateCorner (parentWidget)
register AXWidget_main parentWidget;
{
    register AXWidget w;

    w = (AXWidget)CrtWidget(W_CORNER,parentWidget,NXLT("corner"));
    parentWidget->corner = w;
    w->painter = PaintCorner;
    w->width = SCROLLBAR_THICK;
    w->height = SCROLLBAR_THICK;
    AddToWindowList(w);
    return((AXWidget)w);
}


/*************************************************************************
function: XmPromoteDialog - Promote a dialog to top of display
*/
XmPromoteDialog (w)
AXWidget_main w;
{
#if AX_X11
    SetWindowHints(w, 0);
    w->exposed = FALSE;  /* to raise & set input focus at expose */
    AxMapWindow(w, Dpy,w->window,w->name);
    XRaiseWindow(Dpy,w->window);
    AXSetInputFocus(w->window, FALSE, CurrentTime);
#else
    MS_SetForegroundWindow( w->winid );
    /* if the dialog has been set-aside let's restore it. */
    if ( MS_IsIconic(w->winid) )
        MS_ShowWindow(w->winid, SW_RESTORE);
#endif
}

/*************************************************************************
function: AxmSelectWinByWinUid - Slave this task to another viw window handle
*/
int AxmSelectWinByWinUid (uid,grab)
int uid;
int grab;
{
    AXWidget_main w;

    for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin ) {
        if ( (w->type == W_MAIN) && w->dialog &&(w->dialog->window_uid == uid) )
            break;
    }
    if ( !w ) {
        if ( TaskIsJavaBased(THIMpid) ) {
            return(JVSelectWinByWinUid(uid, grab));
        } else {
            return(FALSE);
        }
    }
    if ( grab )
        XmPromoteDialog(w);
    AxSetTaskMaster(THIMpid,TaskInfo[w->taskOwner].uid);
    return(TRUE);
}

/*
 * A x M a p W i n N a m e ()
 *
 * Return if the WinName should be displayed
 */
AxMapWinName(WinName)   /* OBSOLETE!!!!0 */
char *WinName;
{
struct WINDNOMAP *ptr;

    if ( WinName == NULL || WinName[0] == '\0' )
        {
        /* No Window Title */
        return(TRUE);
        }
    ptr = WindNotMapped;
    while(ptr != (struct WINDNOMAP *)NULL)
        {
#if DEBUG_NOMAP
        printf("Searching for %s in %s\n",WinName, ptr->title);
#endif
        if(!strcmp(WinName, ptr->title))
            {
#if DEBUG_NOMAP
            printf("Found NoMapWindow %s\n",WinName);
#endif
            return(FALSE);
            }
        ptr = ptr->next;
        }
    return(TRUE);
}


/*************************************************************************
function: AxMapWindow - Map window unless running quite mode
Return TRUE if window gets mapped;  FALSE otherwise.
*/
AxMapWindow (w,d,win,WinName)
AXWidget w;
Display *d;
Window win;
char *WinName;
{
    if ( w->display && !AxNoMapWindows && AxMapWinName(WinName) ) {
        XMapWindow(d,win);
        return(TRUE);
    }
    return(FALSE);
}


/*************************************************************************
function: AxIconifyWindow - called to [un]set-aside a window
*/
int
AxIconifyWindow(w,set_aside)
AXWidget w;
int set_aside;
{
    AXWidget_main w_m;

    if (!w)
        return(FALSE);

    if (w->type == W_DIALOG)
    {
        if (!w->parent)
            return(FALSE);

        w_m = w->parent;
    }
    else
        w_m = (AXWidget_main)w;

    if (set_aside)
    {
        /* window --> icon */

#if AX_X11
        if  ( w_m->currently_mapped )
#else
        if ( !MS_IsIconic(w_m->winid) )
#endif
        {
            if (XIconifyWindow(Dpy,w_m->window,DefaultScreen(Dpy)) != 0)
                return(TRUE);
            else
                return(FALSE);
        }
        else
            return(TRUE);
    }
    else
    {
        /* icon --> window */

#if AX_X11
        if ( !w_m->currently_mapped )
#else
        if ( MS_IsIconic(w_m->winid) )
#endif
            XmPromoteDialog(w_m);

        return(TRUE);
    }
}


/*************************************************************************
function: ElfbPromotedDlgID - Raise a task's dialog to top; return handle
*/
int
ElfbPromotedDlgID (name,parent,no_promote)
char *name; /* name of dialog box */
int parent; /* ATM window num of parent window */
int no_promote;
{
    AXWidget_main w;
    AXWidget_handle wh;

    ElfRetData = NULL;
    for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin ) {
        if ( (w->type == W_MAIN) && w->dialog && streq(w->name,name) ) {
            if ( !parent || (WidgetOfWindow(parent) == (AXWidget)w->parent) &&
                 (w->parent != w) /* impossible case */ ) {
                if ( !no_promote )
                    XmPromoteDialog(w);
                wh = HANDLE_FROM_WIDGET(w);
                ElfRetData = AxMakeBinaryData( sizeof(wh), &wh);
                return 0;
            }
        }
    }
    return 0;
}

/*************************************************************************
function: ElfbPromoteDlg - Raise a task's dialog to top; return bool
*/
int
ElfbPromoteDlg (name,parentTask,no_promote)
char *name; /* name of dialog box */
int parentTask; /* UID of task this is slaved to */
int no_promote;
{
    int pid = 0;
    AXWidget_main w;
    int clientId = AxJavaClientId(AxInTask);

    if ( parentTask ) {
        pid = ThimPidFromUID(parentTask);
        if ( !pid )
            return(BFALSE);
    }
    ElfRetData = NULL;
    if (TaskIsJavaBased(THIMpid))
        return(JVPromoteDlg(clientId, name, parentTask, no_promote));
    else {
        for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin ) {
            if ( (w->type == W_MAIN) && w->dialog && streq(w->name,name) ) {
                if ( !pid || (w->parent && (w->parent->taskOwner == pid)) ) {
                    if ( !no_promote )
                        XmPromoteDialog(w);
                    return BTRUE;      /* found 'promote-able' dialog */
                }
            }
        }
    }
    return BFALSE;
}

/*************************************************************************
function: ElfPromoteAppWindow - Raise an application window to top; return bool
*/
int
ElfPromoteAppWindow (name,parentTask,no_promote)
char *name;             /* name of dialog box */
int parentTask;         /* UID of task this is slaved to */
int no_promote;
{
    int pid = 0;
    AXWidget w;
    AXWidget WidgetOfWindow();

    if ( parentTask ) {
        pid = ThimPidFromUID(parentTask);
        if ( !pid )
            return(BFALSE);
    }
    for ( w = WindowList; w; w = w->nextWin ) {
        if ( (w->type == W_MAIN) && ((AXWidget_main)w)->workWindow &&
                                            streq(w->name,name) ) {
            if ( !pid || (w->parent && (w->parent->taskOwner == pid)) ) {
                if ( !no_promote )
                    XmPromoteDialog(w);
                return(BTRUE);      /* found 'promote-able' dialog */
            }
        }
    }
    return(BFALSE);
}
 

/*************************************************************************
function: ZXmCreateStatusArea - Create status widget next to Hscroll bar
*/
AXWidget ZXmCreateStatusArea (parentWidget,name,args,cnt,type)
register AXWidget_main parentWidget;
char *name;
register Arg args[];
register int cnt;
int type;
{
    register AXWidget w;
    Arg arg[20];
    int an;
    static XtCallbackRec Callback[2];   /* standard template */

    w = (AXWidget)CrtWidget(type,parentWidget,"");
    if ( type == W_KANJI_STATUS )
    {
#if AX_X11
       parentWidget->kanji_status = (AXWidget_kanji)w;
       w->painter = PaintOrientalStatus;
#endif
    }
    else
    {
       parentWidget->statusArea = (AXWidget_status)w;
       w->painter = PaintStatus;
    }
    AddToWindowList(w);
    AxXtSetValues(w,args,cnt);

#if 0
/* Create the Help button */

    an = 0;
    CALLBACKER(Callback,StatusHelpPushed,0);
    XtSetArg(arg[an],XmNoldWidget,0); an++;
    XtSetArg(arg[an],XmNflags,0); an++;
    XtSetArg(arg[an],XmNactivateCallback,Callback); an++;
    XtSetArg(arg[an],XmNx,MSG_WIDTH-20); an++;
    XtSetArg(arg[an],XmNy,3); an++;
    XtSetArg(arg[an],XmNlabelPixmap,TRUE); an++;
    XtSetArg(arg[an],XmNwhichButton,Button1); an++;
    AXmCreatePushButtonGadget(w,NXLT("msghelp"),arg,an);
#endif

    return((AXWidget)w);
}

/*************************************************************************
function: ZXmCreatePageBar - Create page widget next to status area
*/
AXWidget ZXmCreatePageBar (parentWidget,name,args,cnt)
register AXWidget_main parentWidget;
char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_page w;
    Arg arg[20];
    int an;
    static XtCallbackRec Callback[2];   /* standard template */
    
    w = (AXWidget_page)CrtWidget(W_PAGEBAR, parentWidget, "" );
    parentWidget->pageBar = w;
    w->painter = PaintPageBar;
    AddToWindowList( w );
    AxXtSetValues( w, args, cnt );
    return((AXWidget) w );
}

/*************************************************************************
function: ZXmCreateButtonBar - Create buttonbar widget above vertical scrolbar
*/
AXWidget ZXmCreateButtonBar(parentWidget,name,args,cnt)
register AXWidget_main parentWidget;
char *name;
register Arg args[];
register int cnt;
{
    register AXWidget_buttonbar w;
    Arg arg[20];
    int an;
    static XtCallbackRec Callback[2];   /* standard template */
    
    w = (AXWidget_buttonbar)CrtWidget(W_BUTBAR, parentWidget, "" );
    parentWidget->butonBar = w;
    w->painter = PaintGEButton;
    AddToWindowList( w );
    AxXtSetValues( w, args, cnt );
    return((AXWidget) w );
}

/*************************************************************************
function: UnMapWidget - Unpaint existing widget image, typically because
                        its footprint changed, or elf code has lifted it
*/
UnMapWidget (w)
register AXWidget w;
{
    register XFontStruct *textFont, *labelFont;
    register int xpos, ypos, width, height;
    int xoff, yoff;
    wComposite *cp;

#if AXMS
    if ( !w )
        return(FALSE);

    if ( (w->type == W_DIALOG || !w->mapped) &&
         ((w->type != W_ROWCOL) && (w->type != W_POPUP)) )
        return FALSE;

    if ( (w->type == W_ROWCOL || w->type == W_POPUP) && !w->mapped )
#else
    if ( !w || (w->type == W_DIALOG) || !w->mapped )
#endif
        return(FALSE);


    w->mapped = FALSE;
    
    if (w->hasFocus && w->parent->hasFocus) {
        xmLiftFocusSelector(w);
    }

    if (w->flags & WFLG_IN_EDIT) {
        if ( w->window ) {
            ClipFromWindowList(w);
            XFreePixmap(Dpy, w->window);
            w->window = 0;
        }
        if (!deGhostMode()) {
            return(FALSE); /* lift work done already */
        }
    }
    
    if (w->shadow && wShadowIsOn(w->shadow)) {
            /* include size of drop shadow, add 2pix for possible diffusion
             */
        wWidgetShadowOffsets(w->type, w->shadow, &xoff, &yoff);
        xoff += 2;
        yoff += 2;
    }
    else {
        xoff = yoff = 0;
    }
    
    switch (w->type) {
        
        /* note that the widget's image is often larger than
         * w->xpos,ypos,width,height -- the paint code works
         * its way outward, rather than inward..
         */
    case W_BUTTON:
        if (w->parent->type == W_PLATES) {
            xpos = w->xpos - 7;
            ypos = w->ypos;
            width = w->width + 14;
            height = w->height;
        }
        else {
            xpos = w->xpos;
            ypos = w->ypos;
            height = w->height;
            width = w->width;
        }
        width += xoff;     /* W_BUTTON might have a drop shadow */
        height += yoff;
        break;
        
    case W_ENTER:
        xpos = w->xpos;
        ypos = w->ypos - 4;
        width = w->width + 2;
        height = w->height + 4;
        break;
        
    case W_EDITBOX:
        /* clear box around window too */
        xpos = w->xpos - 4;
        ypos = w->ypos - 4;
        width = w->width + 8;
        height = w->height + 8;
        break;
        
    case W_SPLITTER:
        xpos = w->xpos;
        ypos = w->ypos + w->value - (w->height / 2);
        width = w->width;
        height = w->height;
        break;

    case W_OPTION:
        xpos = w->xpos;
        ypos = w->ypos;
        width = w->width + xoff + 1;    /* possible drop shadow */
        height = w->height + yoff + 1;
        break;
        
    case W_RECT:
        xpos = w->xpos;
        ypos = w->ypos;
        width = w->width + xoff + 1;    /* possible drop shadow */
        height = w->height + yoff + 1;
        if (RECT_LAYERED == w->style) {
            ypos--;                     /* active layer juts above a bit */
            height++;
        }
        else if (RECT_LABELED == w->style) {
            labelFont = w->font ? w->font : AxDlgMainFont;
            ypos -= labelFont->ascent / 2;  /* label juts northward some */
            height += labelFont->ascent / 2;
        }
        break;
        
    case W_RADIO:
        if (w->auxData) {
            w->width = w->height = 0;
            for (cp = w->auxData->compositeList; cp; cp = cp->next) {
                if (cp->w && (WLINKDOWN == cp->type)) {
                    UpdateRadioSize(w, cp->w);
                }
            }
        }
        xpos = w->xpos;
        ypos = w->ypos;
        width = w->width + 1;
        height = w->height + 1;
        break;

    default:
        xpos = w->xpos;
        ypos = w->ypos;
        width = w->width + 1;
        height = w->height + 1;
        break;
    }
    
    xmColorFillRectangle(backgroundWidget(w), WIN_OF(w), BackGC,
                         xpos, ypos, width, height);
    
    if ((w->flags & WFLG_IN_EDIT) && (W_COMBO_BOX == w->type)) {
        AXWidget_combo_box cb = (AXWidget_combo_box) w;
        if (cb->edit_win.win) {
            /* must free "child" of w->window explicitly when it's a pixmap.
             */
            XFreePixmap(Dpy, cb->edit_win.win);
        }
    }

#if AXMS
    if ( w->winid ) {
#else    
    if ( w->window ) {
#endif
        ClipFromWindowList(w);
        AxDestroyWindow(Dpy, w, w->window);
        w->window = 0;
    }

#if AXMS
    /* need to make sure we destroy the option menu label on Windows,
     * because it is an actual "static" window.    -donato
     */
    if ( w->type == W_OPTION && ((AXWidget_option)w)->labelid )
       MS_DestroyWindow(((AXWidget_option)w)->labelid);
#endif

    /* Check all other widgets in this window looking for mapped
     * widgets below.  Widgets get regened at next AXtAppNextEvent.
     */
    if ( w->parent && (w->parent->type == W_DIALOG) ) {
        r32 bbox;                   /* unmapped widget's footprint */
        register AXWidget childP;
            
        bbox.origin.x = xpos;
        bbox.origin.y = ypos;
        bbox.width = width;
        bbox.height = height;
        
        if (w->parent->layerList) {
            /* just record the extent of the lift damage on the dialog
             */
            AXWidget_dialog dlg = (AXWidget_dialog)w->parent;
            
            widgetFootprint(topWidget(w), &bbox);  /* need composite size */
            xmMarkDamaged(dlg, &bbox);
        }
        else {
            for ( childP = w->parent->widgets; childP;
                 childP = childP->nextChild ) {
                
                if ( childP->mapped && childP->display ) {
                    if ( widgetIntersectsUpdateRect(childP, &bbox) ) {
                        /* this widget was damaged by the lift
                         */
                        childP->update_widget = TRUE;
                        WidgetNeedsUpdated = TRUE;
                        xmlibStr.FullRegenForUpdate = TRUE;
                    }
                }
            }
        }
    }
    return(TRUE);
}


/**************************************************
 * : backgroundWidget - return the handle of the nearest W_RECT/ICON
 * widget which is behind the passed widget; return the dialog
 * widget if none found.  a widget is considered 'behind w' if
 * it is headward in the (back-to-front) dlg->layerList and it
 * encloses w.  Note that this function looks for opaque panels
 * and icons only.
 */
AXWidget
backgroundWidget(w)
AXWidget w;
{
    wLayer *ly, *myLayer;
    r32 myRect, trect;
    
    if (!w || !w->parent || (w->type == W_DIALOG) ||
        !w->parent->layerList) {
        return ((AXWidget) NULL);
    }

    w = topWidget(w);
    if (!w) {
        return ((AXWidget) NULL);
    }

        /* first find myself on the layerlist */
    myLayer = (wLayer *) NULL;
    for (ly = w->parent->layerList; ly; ly = ly->next) {
        if (ly->w == w) {
            myLayer = ly;
            break;
        }
    }
    if (!myLayer) {
        return ((AXWidget) NULL);
    }
    
        /* now search backward for the nearest enclosing panel */
    myRect.origin.x = myLayer->w->xpos;
    myRect.origin.y = myLayer->w->ypos;
    myRect.width = myLayer->w->width;
    myRect.height = myLayer->w->height;
    for (ly = myLayer; ly; ly = ly->prev) {
        if ((ly != myLayer) &&
            (ly->w->type == W_RECT || ly->w->type == W_ICON) &&
            isOpaqueWidget(ly->w)) {

            if ((xmWidgetIsHidden(ly->w)) || !(ly->w->mapped)) {
                continue;
            }
            trect.origin.x = ly->w->xpos;
            trect.origin.y = ly->w->ypos;
            trect.width = ly->w->width;
            trect.height = ly->w->height;
            if (rectInsideRect(&myRect, &trect)) {
                return(ly->w);
            }
        }
    }
    return((AXWidget)w->parent);
}

void
paintTextDropShadow(w, win, gc, xpos, ypos, str, len, wide)
AXWidget w;
Drawable win;
GC gc;
int xpos;
int ypos;
void *str;
int len;
int wide;
{
    int xoffset, yoffset;
    PIXEL_VALUE recessPix, shadowPix, sunPix;
    XFontStruct *tfont;
    AXWidget backWidget = (AXWidget) NULL;
    
    /* get the appropriate widget representing the background
     */
    switch(w->type) {
        
    case W_ENTER:
    case W_EDITBOX:
    case W_LIST:
    case W_TABLE:
    case W_RECT:
        /* the widget's own text area is the background */
        backWidget = w;
        break;
        
    case W_BUTTON:
        if ((topWidget(w))->type == W_OPTION) {
            backWidget = topWidget(w);
        }
        else {
            backWidget = w;
        }
        break;
        
    default:
        /* typically the next-behind enclosing panel, or dlg
         */
        backWidget = backgroundWidget(topWidget(w));
        break;
    }

    if (backWidget) {
        if (isOpaqueWidget(backWidget)) {
            recessPix = (unsigned long) 0; /* don't bother with diffusion */
            
                /* try for a shadow color relative to backwidget color
                 */
            if(!AxGetSunShadowPixels(backWidget->widgetColor,
                                    &sunPix, &shadowPix)) {
                
                    /* couldn't get shadow color; default to black
                     */
                AxGetRealPixel(2, 0, 0, 0, 255, 255,
                               &shadowPix); /* black cmyk */
            }
        }
        else {
                /* the backWidget is transparent */
            recessPix = RecessPixel;
            shadowPix = ShadowPixel;
        }
    }
    else {
        recessPix = RecessPixel;
        shadowPix = ShadowPixel;
    }

    xmTextShadowOffsets(w->font, &xoffset, &yoffset);
    
    if (w->font) {
        tfont = w->font;
    }
    else {
        tfont = AxDlgMainFont;
    }
    
    if (wide) {
        if (recessPix) {
                /* diffuse the shadow a bit */
            XSetForeground(Dpy, gc, recessPix);
            axDrawString16(Dpy, win, gc, tfont, xpos + xoffset - 1,
                           ypos + yoffset - 1, (wchar *) str, len);
            axDrawString16(Dpy, win, gc, tfont, xpos + xoffset + 1,
                           ypos + yoffset + 1, (wchar *) str, len);
        }
        XSetForeground(Dpy, gc, shadowPix);
        axDrawString16(Dpy, win, gc, tfont, xpos + xoffset,
                       ypos + yoffset, (wchar *) str, len);
    }
    else {
        if (recessPix) {
                /* diffuse the shadow a bit */
            XSetForeground(Dpy, gc, recessPix);
            axDrawString(Dpy, win, gc, tfont, xpos + xoffset - 1,
                         ypos + yoffset - 1, (mbchar *) str, len);
            axDrawString(Dpy, win, gc, tfont, xpos + xoffset + 1,
                         ypos + yoffset + 1, (mbchar *) str, len);
        }
        XSetForeground(Dpy, gc, shadowPix);
        axDrawString(Dpy, win, gc, tfont, xpos + xoffset,
                     ypos + yoffset, (mbchar *) str, len);
    }
}

int
isOpaqueWidget(w)
AXWidget w;
{
    int opaque = FALSE;
    
    if (!w)
        return (FALSE);

    switch(w->type) {

    case W_DIALOG:
    case W_RECT:
    case W_BUTTON:
    case W_OPTION:
    case W_LIST:
    case W_ENTER:
    case W_EDITBOX:
    case W_TABLE:
        if (w->graphic || w->widgetColor || w->background_image) {
            opaque = TRUE;
        }
        break;
        
    case W_ICON:
        opaque = TRUE;
        break;
        
    }
    
    return (opaque);
}

/*
 * : xmDrawRectShadow - draw rectangular widget drop shadow
 */
void
xmDrawRectShadow(w, x, y, width, height)
AXWidget w;
int x, y, width, height;
{
    int xoff, yoff;
    GC recess_gc, shadow_gc;
    AXWidget backWidget;
    
    wWidgetShadowOffsets(w->type, w->shadow, &xoff, &yoff);
    backWidget = backgroundWidget(w);
    if (isOpaqueWidget(backWidget)) {
        recess_gc = (GC) NULL;
        shadow_gc = StippleGC;
    }
    else {
        recess_gc = RecessGC;
        shadow_gc = ShadowGC;
    }
    
        /* draw backwards-L-shape representing drop shadow;
           draw base of L, then draw 'ascender' */
    if (recess_gc) {
            /* draw two light L's offset 0/+2, for diffusion */
        XFillRectangle(Dpy, WIN_OF(w), recess_gc,
                       x + xoff, y + height, width - xoff, yoff);
        XFillRectangle(Dpy, WIN_OF(w), recess_gc,
                       x + xoff + 2, y + height, width - xoff - 2,
                       yoff + 2);
        XFillRectangle(Dpy, WIN_OF(w), recess_gc,
                       x + width, y + yoff, xoff, height);
        XFillRectangle(Dpy, WIN_OF(w), recess_gc,
                       x + width, y + yoff + 2, xoff + 2, height);
    }
    XFillRectangle(Dpy, WIN_OF(w), shadow_gc,
                   x + xoff + 1, y + height, width - xoff - 1,
                   xoff + 1);
    XFillRectangle(Dpy, WIN_OF(w), shadow_gc,
                   x + width, y + yoff + 1, xoff + 1, height);
}

void
xmLiftRectShadow(w, backGC, x, y, width, height)
AXWidget w;
GC backGC;
int x, y, width, height;
{
    int xoff, yoff;
    AXWidget bgw = backgroundWidget(w);

    if (!w || !bgw) {
        return;
    }
    
    wWidgetShadowOffsets(w->type, w->shadow, &xoff, &yoff);
    xmColorFillRectangle(bgw, WIN_OF(w), backGC, x + xoff, y + yoff,
                         width + 2, height + 2);
}

void
xmColorFillRectangle(w, drw, gc, x, y, width, height)
AXWidget w;
Drawable drw;
GC gc;
int x, y, width, height;
{
    PIXEL_VALUE saved_fg;
    
    if (w && w->widgetColor && !(NoColor || AxNoWidgetColor)) {
        saved_fg = AXGetForegroundPixel(Dpy, gc);
        XSetForeground(Dpy, gc, w->widgetColor->any.pixel);
    }
    XFillRectangle(Dpy, drw, gc, x, y, width, height);
    if (w && w->widgetColor && !(NoColor || AxNoWidgetColor)) {
        XSetForeground(Dpy, gc, saved_fg);  /* restore */
    }
}

static void
xmSetRecessedGCToAntiShadow(w, restore, saved_fg)
AXWidget w;              /* in */
int *restore;            /* out; bool: whether to restore Recessed GC */
PIXEL_VALUE *saved_fg;   /* out: initialized iff restore == TRUE */
{
    PIXEL_VALUE hilite_pixel, shadow_pixel, sun_pixel;
        
    *restore = FALSE;
    
    if (!UseWidgetColors) {
        return;
    }
    
    if (w->widgetColor &&
        AxGetSunShadowPixels(w->widgetColor, &sun_pixel, &shadow_pixel)) {
        
        float base_h, base_s, base_b;
        float hilite_h, hilite_s, hilite_b;
        int red, green, blue;
        
            /* we were able to get sun and shadow colors derived
             * from the base color.  try for a 'antishadow', or
             * weak-hilite shade which is between the base and
             * shadow colors.
             */
        AxGetHSBFromWColor(w->widgetColor, &base_h, &base_s, &base_b);
        AxComputeWeakShade(&hilite_h, &hilite_s, &hilite_b, base_h,
                           base_s, base_b);
        HSBToRGB(&red, &green, &blue, hilite_h, hilite_s, hilite_b);
        AxGetRealPixel(0, red, green, blue, 0, 255, &hilite_pixel);
        
        if (hilite_pixel == shadow_pixel) {
                /* the 'antishadow' is painted on top of the shadow,
                 * so since the two are the same, we're done.
                 */
            return;
        }
        
        if (hilite_pixel != AXGetForegroundPixel(Dpy, SunGC)) {
                /* widget-kit sun color is the only color
                 * we reject for use as a weak hilite..
                 */
            *restore = TRUE;
            *saved_fg = AXGetForegroundPixel(Dpy, RecessGC);
            XSetForeground(Dpy, RecessGC, hilite_pixel);
        }
    }
    return;
}

/*
 * : xmDrawRectAntiShadow - draw rectangular 'diffused hilite'
 * which is present when a rectangular drop shadow is on.
 */
void
xmDrawRectAntiShadow(w, x, y, width, height)
AXWidget w;
int x, y, width, height;
{
    int xoff, yoff, restore;
    PIXEL_VALUE saved_fg, hilite_pixel, shadow_pixel, sun_pixel;
    
    if (!UseWidgetColors)
        return;
    
    xmSetRecessedGCToAntiShadow(w, &restore, &saved_fg);
        
    /* use the recessed color to represent diffused
     * light on the edges adjacent to the drop shadow
     */
    wWidgetShadowOffsets(w->type, w->shadow, &xoff, &yoff);
    XDrawLine(Dpy, WIN_OF(w), RecessGC, x + width - 1,
              y + yoff + 1, x + width - 1, y + height - 1);
    XDrawLine(Dpy, WIN_OF(w), RecessGC, x + xoff + 1,
              y + height - 1, x + width - 1, y + height - 1);
    
    if (restore) {
        XSetForeground(Dpy, RecessGC, saved_fg);
    }
}

static Pixmap
get50PercentStipple()
{
    unsigned char bits[8];
    int ix, tog;
    
    for (ix = 0, tog = 0; ix < 8; ix++) {
        if (tog) {
            bits[ix] = (unsigned char) 0x55;
            tog = 0;
        }
        else {
            bits[ix] = (unsigned char) 0xaa;
            tog = 1;
        }
    }
    return (AXCreatePixmapFromBitmapData(Dpy, AxTopWinNeverMapped,
                                         bits, 8, 8, AllPlanes,
                                         ~AllPlanes, 1));
}

AxMakeParentActive(myparentWidget, mypid)
AXWidget myparentWidget;
int mypid;
{
    AXWidget parentWidget;
    int parentpid;
    int atmWid;
	int force_it;


	/* Make parent active (if allow-wm-to-set-focus pref FALSE --
	 * the FALSE param to AXSetInputFocus defers to this pref)
	 */
	parentWidget = NULL;
	force_it = AxForceFocusManage;
	parentpid = ThimPidFromUID(TaskInfo[mypid].parentTask);
	if ( parentpid && (TaskInfo[parentpid].pended == mypid) )
	   parentWidget = AXmMainWidgetOfTask(TaskInfo[parentpid].uid);
	if ( parentWidget && parentWidget->window )
	   AXSetInputFocus(parentWidget->window, force_it, CurrentTime);
	else {
		atmWid = WindowIdFromPid(ThimPidFromUID(TaskInfo[mypid].taskMaster));
		if ( atmWid != -1 ) {
		   if ( myparentWidget )  /* sanity check for parent (W_MAIN) */        
			   SetCurWinFromShellId(myparentWidget->parent,TRUE);
	   }
	   else {
		   parentWidget = AXmMainWidgetOfTask(TaskInfo[mypid].taskMaster);
		   if ( parentWidget && parentWidget->window )
			   AXSetInputFocus(parentWidget->window, force_it, CurrentTime);
	   }
   }
}


/*************************************************************************
function: DestroyDialog - Kill window
*/
void DestroyDialog (w,wasObject)
register AXWidget_dialog w;
int wasObject;      /* if TRUE, dialog was created by the object model */
{
    register AXWidget childP, next;
    register AXWidget bp;
    menu_opt_status *mop, *next_mop;
    int atmWid;
    AXWidget parentWidget;
    int mypid, parentpid;

    if ( w->notTransient ) {
        NumDlgNonTransients--;
        TestForNoWindowsLeft();
    }
start_again:
    for ( childP = w->widgets; childP; childP = next ) {
        next = childP->nextChild;
        /* Note: Scroll-bars are destroyed by their creators
           (list-box, edit-box...).
           ie. AxXtDestroyWidget() on a widget of type W_LIST will
           destroy it's scroll-bars.  Don't do it here. */
        if (childP->type != W_SCROLL) {
            AxDestroyWidget(childP);
            goto start_again;
        }
    }
    for ( mop = w->parent->menu_status; mop; mop = next_mop ) {
        free(mop->name);
        next_mop = mop->next;
        free(mop);
    }
    if ( w->pokeCodes )
        free(w->pokeCodes);
    if ( w->flags & WFLG_IN_EDIT)
        deCloseDlgEdit(w);
    
    wfDeleteGadgetSet(w->db_uid); /* toss align-links info for this dbox */
    
    if (w->uidWidgets) {
        /* remove table associating dbox-containee-uid's with widget ptrs.
         */
        axhDeleteTable(w->uidWidgets, (void *) NULL);
        free(w->uidWidgets);
        w->uidWidgets = (axhtab *) NULL;
    }

    ClipFromWindowList(w);

    /* check for any full screen slide show`s */
    parentWidget = AxGetFullScreenWidget();
    if ( parentWidget &&  parentWidget->window )
        AXSetInputFocus(parentWidget->window, TRUE, CurrentTime);
    else
    {
		AxMakeParentActive(w->parent, w->taskOwner);
    }

/*
    Now we tear down all the tasks that are presenting dialogs that behave
    as children to this dialog.  We do NOT do this in the object model
    because all dialogs tend to be part of the same task.
*/  
    if ( !wasObject )
        ThimDestroyChildDialogs(w->parent); /* child dlgs have shell as parent */

    free(w);
    ThimExposuresMayBeComing = TRUE;
#if 1   /* the ThimExposuresMayBeComing causes schedular to do a sync */
    XFlush(Dpy);    /* but get the destroy wins out now */
#else
    XSync(Dpy,FALSE);
#endif

}


/*************************************************************************
function: XmClipText - Reduce text str to fit a max width
Applies elipsis chars
*/
XmClipText (str,width,font,small_font)
char *str;
int width;  /* max width in pix */
XFontStruct *font;
int small_font;
{
    int wid;
    int dotwid;
    char *p;
    XFontStruct *fs;
    int len;            /* strlen of passed string */
    wchar *wstr, *wP;

    len = strlen( str);
    
    if (font) {
        fs = font;
    }
    else if (small_font) {
        fs = AxDlgMiniFont;
    }
    else {
        fs = AxDlgMainFont;
    }

    /* see if already fits */
    wid = AXTextWidth(fs, str, len);
    if ( wid <= width )
        return;
    
    dotwid = AXTextWidth(fs, NXLT("..."), 3);
    if ( dotwid > width ) {
        str[1] = 0; /* punt, just put out first char of str */
        return;
    }
#if BUILD_ORIENT
    wstr = (wchar *)malloc( (len+1)*sizeof(wchar) );
    MbToWStr( str, wstr );
    wP = wstr;
    for ( wid = dotwid; wid <= width; wP++ ) {
       /* Ashisuto added for not overwriting beyond end of passed string.
        *  95.09.14 */
       if (MBstrlen(WToMbOneStr(wP)) < 3)     /* 3 == strlen("...") */
           break;
       wid += AXWTextWidth(fs, wP, 1);
    }
    *wP = 0;    /*  clip string to what fits */
    p = str + MBstrlen( WToMbOneStr(wstr) ); /* num bytes which fit */
    free(wstr);
#else
    for ( wid = dotwid, p = str; wid <= width; p++ ) {
        wid += AXTextWidth(fs, p, 1);
    }
    p--;    /* remove overrun char */
#endif

    /* Cannot overwrite beyond end of passed string */
    if (p > &(str[len-3])) {
        p = &(str[len-3]);
    }
    *p++ = '.';
    *p++ = '.';
    *p++ = '.';
    *p = 0;
}


/*************************************************************************
function: AXSetInputFocus - Set input focus if focus management not disabled
                            or if 'force_it' bool is true
*/
AXSetInputFocus(xwin, force_it, timestamp)
Window xwin;
int force_it;
Time timestamp;
{
    if ( force_it || !AxNoFocusManage ) {
        XSetInputFocus(Dpy, xwin, RevertToParent, timestamp);
#if USE_XIM
        SetXIMFocus( (AXWidget )NULL, xwin );
#endif
    }
}


/** Update the current setting of an option menu, and get it re-painted */
/*  without having to re-create the entire widget                      */
/* It returns TRUE if all is well, FALSE if for some reson the update */
/*  could not be done                                                 */

UpdateOptionChoice( w, new_value )
AXWidget_option w;
int new_value;
{
    if ( (w == (AXWidget_option)NULL) || (new_value < 0) ||
         (w->value < 0 ) )
       /* if the value iin the widget currently is less than zero, it is a */
       /* flag meaning that the widget needs to be re-created              */
       return( FALSE );
 
    WIDGET_PARANOID( w, W_OPTION );
 
    
#if AXMS
    if ( !w->winid )
       return( FALSE );

    /* we have the widget, just change the current value */
    w->value = new_value;
    MS_SendMessage(w->winid, CB_SETCURSEL, w->value, 0L);
    return( TRUE );
#else
    if ( new_value >= w->num_buttons )
       /** off the end */
       return( FALSE );

    w->value = new_value;
    w->optionValue = (AXWidget)w->buttons[new_value];

    PaintOption( w );
    return( TRUE );
#endif
}

/*************************************************************************
function: TaskOfWidgetPended - Return whether task that owns this widget
is pended.  Also, if it is, promote the dialog of the task this is pended on.
*/
int TaskOfWidgetPended (w)
AXWidget_main w;
{
    int pid;

    if ( w->type == W_DIALOG )
        w = w->parent;
    else {
        while ( w && (w->type != W_MAIN) )
            w = w->parent;
    }
    if ( !w || !w->dialog )
        return(FALSE);
    pid = w->taskOwner;
    if ( !AxTaskPended(pid) )
        return(FALSE);
    pid = AxPendedForWhom(pid);
    if ( pid ) {    /* promote the other task */
        for ( w = (AXWidget_main)WindowList; w; w = (AXWidget_main)w->nextWin){
            if ( (w->type == W_MAIN) && w->dialog && (w->taskOwner == pid) )
                XmPromoteDialog(w);
        }
    }
    return(TRUE);
}

AXWidget
WidgetOfXWindow(win)
register Window win;
{
    register AXWidget w;
 
    for (w = WindowList; w; w = w->nextWin)
        if (w->window == win)
            return((AXWidget ) w);
 
    return((AXWidget ) NULL);
}
 
/***********************************************************************
function: AxSetWidgetWorkColors - If using work colors for this instance,
set work colors.
*/
void
AxSetWidgetWorkColors(w)
register AXWidget w;
{
    if (!w)
        return;
    if (w->useWorkColors) {
        SetWorkColors(BackGC, 0);
        SetWorkColors(ForeGC, 1);
        SetWorkColors(DisabledGC, 1);
    }
    return;
}

/***********************************************************************
function: AxUnsetWidgetWorkColors - If using work colors for this instance,
unset work colors.
*/
void
AxUnsetWidgetWorkColors(w)
register AXWidget w;
{
    if (!w)
        return;
    if (w->useWorkColors) {
        UnSetWorkColors(BackGC, 0);
        UnSetWorkColors(ForeGC, 1);
        UnSetWorkColors(DisabledGC, 1);
    }
    return;
}

/*****************************************************************
function: AXmClearGlobalWidgetHandle - null any of the too-many
global widget handle variables that match the passed handle.
This is done when the passed handle's widget is to be destroyed.

Not all globals of type AXWidget (aka (widget_t *)) are tested here.
Among the omitted categories are lists of handles, and any handles
on the app-specific "globals" structs (e.g., WP, GE, SS, DE)

Besides that problem, there's:  a) perhaps some of these globals
are obsolete.., and b) this'd execute faster if it used else if,
but no proof that these globals are really used exclusively.
*/
void
AXmClearGlobalWidgetHandle(w)
AXWidget w;
{
#if AXMS
    if (w == ToolBarButtonWidget) {
        ToolBarButtonWidget = (AXWidget) NULL;
    }
#else
    if (w == AxPulldownActive) {
        AxPulldownActive = (AXWidget) NULL;
    }
    if (w == ListBoxArmed) {
        ListBoxArmed = (AXWidget) NULL;
    }
    if (w == MenuArmed) {
        MenuArmed = (AXWidget) NULL;
    }
    if (w == ScrollBarArmed) {
        ScrollBarArmed = (AXWidget) NULL;
    }
    if (w == StrokingBar) {
        StrokingBar = (AXWidget) NULL;
    }
    if (w == ToolArmedForUpdate) {
        ToolArmedForUpdate = (AXWidget) NULL;
    }
    if (w == TrayArmed) {
        TrayArmed = (AXWidget) NULL;
    }
    if (w == (AXWidget) EditBoxArmed) {
        EditBoxArmed = (AXWidget_editbox) NULL;
    }
#endif
    if (w == ButtonArmed) {
        ButtonArmed = (AXWidget) NULL;
    }
    if (w == CurrentPopupButton) {
        CurrentPopupButton = (AXWidget) NULL;
    }
    if (w == PopupArmed) {
        PopupArmed = (AXWidget) NULL;
    }
    if (w == RibbonArmed) {
        RibbonArmed = (AXWidget) NULL;
    }
    if (w == RightButtonArmed) {
        RightButtonArmed = (AXWidget) NULL;
    }
    if (w == RowColumnArmed) {
        RowColumnArmed = (AXWidget) NULL;
    }
    if (w == ScaleArmed) {
        ScaleArmed = (AXWidget) NULL;
    }
    if (w == SplitterArmed) {
        SplitterArmed = (AXWidget) NULL;
    }
    if (w == TableArmed) {
        TableArmed = (AXWidget) NULL;
    }
    if (w == ComboBoxArmed) {
        ComboBoxArmed = (AXWidget) NULL;
    }
    if (w == (AXWidget) ComboListArmed) {
        ComboListArmed = (AXWidget_combo_box) NULL;
    }
    if (w == (AXWidget) CanvasArmed) {
        CanvasArmed = (AXWidget_canvas) NULL;
    }
#if AX_X11
    if (w == (AXWidget) ComboBoxInEditWindow) {
        ComboBoxInEditWindow = (AXWidget_combo_box) NULL;
    }
    if (w == EditWinArmed) {
        EditWinArmed = (AXWidget) NULL;
    }
#endif
}

/* : xmUseEtchedDisabled - test whether to use an etched
 * style for disabled text.  If so, return TRUE and init
 * return params.  If not, return FALSE.
 */
static int
xmUseEtchedDisabled(w, backColor,
                    sun_gc, shadow_gc, sun_pix, shadow_pix, restore)
AXWidget w;                    /* in */
wcolor_t *backColor;           /* in: color of draw surface */
GC *sun_gc;                    /* out: init only if true return */
GC *shadow_gc;                 /* out: init only if true return */
PIXEL_VALUE *sun_pix;          /* out: init only if true & restore */
PIXEL_VALUE *shadow_pix;       /* out: init only if true & restore */
int *restore;                  /* out: bool; whether to restore sun/shad pix */
{
    PIXEL_VALUE etch_sun, etch_shadow;
    
#if AXMS
    return (FALSE); /* ironic, since etched style ripped off from win95! */
#endif

    *restore = FALSE;
    
    if (!w->disabled || AxNoWidgetColor) {
        return FALSE;
    }
    
    *sun_gc = SunGC;
    *shadow_gc = ShadowGC;
    
    if (backColor) {
        if (AxGetSunShadowPixels(backColor, &etch_sun, &etch_shadow)) {
            *sun_pix = AXGetForegroundPixel(Dpy, *sun_gc);
            *shadow_pix = AXGetForegroundPixel(Dpy, *shadow_gc);
            XSetForeground(Dpy, *sun_gc, etch_sun);
            XSetForeground(Dpy, *shadow_gc, etch_shadow);
            *restore = TRUE;
        }
    }
    return TRUE;
}


void
initCharWids(fs, smallDefaultWidth, bigDefaultWidth,
             charWids, aboveP, belowP, heightP)
XFontStruct *fs;          /* in */
int smallDefaultWidth;    /* in */
int bigDefaultWidth;      /* in */
int *charWids;            /* out */
int *aboveP;              /* out */
int *belowP;              /* out */
int *heightP;             /* out */
{
    int ix;
    XCharStruct *xc;
    
    memset(charWids, 0, sizeof(charWids));
    if (fs->min_char_or_byte2 > 32) {
        for (ix = 32; ix < fs->min_char_or_byte2; ix++)
            charWids[ix] = smallDefaultWidth;   /* sane default */
    }
    if (fs->max_char_or_byte2 < 255) {
        for (ix = MAX(32, (fs->max_char_or_byte2 + 1)); ix < 256; ix++)
            charWids[ix] = smallDefaultWidth;   /* sane default */
    }
    for (ix = fs->min_char_or_byte2; ix <= fs->max_char_or_byte2; ix++) {
        xc = getCharStruct(ix, fs);
        charWids[ix] = MIN(bigDefaultWidth, xc->width);  /* sanity MIN */
    }

    *aboveP = fs->ascent;
    *belowP = fs->descent;
    *heightP = *aboveP + *belowP;
}

/* : axNewUidWidget - supply a value for a new item in
 * axw_dialog->uidWidgets table.
 */
static char *
axNewUidWidget(notUsed, notUsed2, wp)
void *notUsed;
int notUsed2;
char *wp;
{
    return (wp);  /* this is an AXWidget */
}

/* : axInitUidWidget - for the passed dialog, create a
 * wd->uidWidgets table associating DBDEX#uid vals with widget pointers.
 * The DBDEX#uid numbers are unique within the dialog box, so the
 * table is stored on the dialog widget.
 */
void
axInitUidWidgets(wd)
AXWidget_dialog wd;
{
    if (wd) {
        wd->uidWidgets = (axhtab *) malloc (sizeof(axhtab));
        memset((void *) wd->uidWidgets, 0, sizeof(axhtab));
        axhInitTable(wd->uidWidgets, 31, axNewUidWidget, NULL);
    }
}

axhtab **
xmLinkTablePtr(w, link_type)
AXWidget w;
int link_type;
{
    axhtab **tp;
    
    switch (link_type) {
    case WIDGLINK_TABLAYER:
        tp = &w->tabctl_linktab;
        break;
    }
    return (tp);
}

/* : axNewWidgetLink - supply a value for a new item in
 * one of the axw_any->linktabs
 */
static char *
axNewWidgetLink(notUsed, notUsed2, link_datap)
void *notUsed;
int notUsed2;
char *link_datap;
{
    widglink *ldata, *new_wl;
    
    ldata = (widglink *) link_datap;
    if (!ldata) {
        return ((char *) NULL);
    }
    new_wl = (widglink *) malloc(sizeof(widglink));
    *new_wl = *ldata;
    
    return ((char *) new_wl);
}

/* : axDeleteWidgetLink - delete a link from one of the axw_any->linktabs
 */
static void
axDeleteWidgetLink(linkp, doBack)
char *linkp;
void *doBack;
{
    widglink *lw = (widglink *) linkp;

    if (doBack) {
        axhtab **linktab;
        /* delete backlink if not already gone.
         */
        linktab = xmLinkTablePtr(lw->to, lw->link_type);
        if (*linktab) {
            axhTossItemI(&lw->from, sizeof(AXWidget),
                         *linktab, (char *) NULL);
        }
    }
    /* what if the lw->link_data is dyn allocated (right now it isn't);
     * this would be the time to free that somehow.
     */
    return;
}

void
xmAddWidgetLink(link_type, from_w, to_w, linkdata)
int link_type;
AXWidget from_w;
AXWidget to_w;
void *linkdata;
{
    char *ctmp;
    axhtab **linktab;
    widglink newdata;
    
    if (!(from_w && to_w)) {
        return;
    }
    
    /* first make link from from_w to to_w
     */
    newdata.direction = 1;
    newdata.to = to_w;
    newdata.from = from_w;
    newdata.link_type = link_type;
    newdata.link_data = linkdata;
    linktab = xmLinkTablePtr(from_w, link_type);
    if (!(*linktab)) {
        *linktab = (axhtab *) malloc(sizeof(axhtab));
        memset((void *) *linktab, 0, sizeof(axhtab));
        axhInitTable(*linktab, 7, axNewWidgetLink, axDeleteWidgetLink);
        from_w->tabctl_linktab = *linktab;
    }
    axhGetItemI(&to_w, sizeof(AXWidget), *linktab, (char *) &newdata, &ctmp);
    
    /* then add backlink from to_w to from_w
     */
    newdata.to = from_w;
    newdata.from = to_w;
    newdata.direction = 0;
    linktab = xmLinkTablePtr(to_w, link_type);
    if (!(*linktab)) {
        *linktab = (axhtab *) malloc(sizeof(axhtab));
        memset((void *) *linktab, 0, sizeof(axhtab));
        axhInitTable(*linktab, 7, axNewWidgetLink, axDeleteWidgetLink);
        to_w->tabctl_linktab = *linktab;
    }
    axhGetItemI(&from_w, sizeof(AXWidget), *linktab, (char *) &newdata, &ctmp);
    
    return;
}

void
xmDeleteWidgetLink(link_type, from_w, to_w)
int link_type;
AXWidget from_w;
AXWidget to_w;
{
    axhtab **linktab;
    
    linktab = xmLinkTablePtr(from_w, link_type);
    if (from_w && to_w && *linktab) {
        axhTossItemI(&to_w, sizeof(AXWidget), *linktab, (char *) TRUE);
    }
    return;
}

void
SetTabLayers(rw, tablayer_info, full_update)
AXWidget_rect rw;
data_ptr tablayer_info;
int full_update;   /* bool: whether to reset and reapply containee links */
{
    AXWidget_dialog dw;
    
    if (!(rw && (RECT_LAYERED == rw->style))) {
        return;
    }
    if (!tablayer_info) {
        return;
    }
    if (!(rw->parent && (W_DIALOG == rw->parent->type))) {
        return;
    }
    dw = (AXWidget_dialog) rw->parent;
    if (!dw) {
        return;
    }
    xmtcSetTabctlInfo(rw, &rw->tabctl, tablayer_info, full_update);
}

static int
xmCanTakeAlgoKeyFocus(d_w, ww)
AXWidget_dialog d_w;
AXWidget ww;
{
#if 0   /* for possible hybrid w/ cancel,defaultbuttons, enter, ebox */
    AXWidget cancel_w, default_w;
    
    cancel_w = (AXWidget) d_w->cancelButton;
    default_w = (AXWidget) d_w->currentDefaultButton;
#endif
    
#if 1   /* wide open */
	return (TRUE);
#else   /* "classic" */
    if ((W_EDITBOX == ww->type) ||
        (W_ENTER == ww->type) ||
    (W_COMBO_BOX == ww->type)) {
        
        return (TRUE);
    }
    
#if BUILD_ORIENT
    if (W_TABLE == ww->type) {
        return (TRUE);
    }
#endif
    return (FALSE);
#endif
}

/* : xmCanTakeKeyFocus - return whether passed widget
 * can accept keyboard focus, e.g., an icon widget can't.
 * This function doesn't test every defined widget type;
 * it's concerned mainly with dialog-box widgets.
 */
int
xmCanTakeKeyFocus(d_w, ww, clicked)
AXWidget_dialog d_w;
AXWidget ww;
int clicked;
{
    AXWidget top_w;
    
    /* test for basic conditions that disallow key focus
     */
    if (ww->disabled || !ww->display) {
        return (FALSE);
    }
    if ((W_RECT == ww->type) && (RECT_LAYERED != ww->style)) {
        return (FALSE);
    }
    if ((W_ICON == ww->type) || (W_LABEL == ww->type)) {
        return (FALSE);
    }
#if AXMS
	if ( ww->type == W_BUTTON && ww->parent->type == W_TOOLBAR )
		return FALSE;
#endif
    top_w = topWidget(ww);
    if (ww != top_w) {
        /* typical example of not-top-widget would be W_SCROLL, or
         * W_TOGGLE kids of an option menu.  Radio toggles are exempted.
         */
        if (W_TOGGLE == ww->type && ((AXWidget_togglebutton) ww)->in_radio) {
            /* ww is a toggle of a radio widget
             */
            if (xmWidgetIsHidden(top_w)) {
                return (FALSE);
            }
            if (!ww->value && !clicked) {
                /* for radios, only "on" toggle can take focus, unless clicked.
                 */
                return (FALSE);
            }
        }
        else {
            return (FALSE);
        }
    }
    
    { 
        return (xmCanTakeAlgoKeyFocus(d_w, ww));   /* algorithmic */
    }
}

/* : xmTakeKeyFocus - set the hasFocus state on the passed widget.
 */
void
xmTakeKeyFocus(ww, bev, pending_delete)
AXWidget ww;
XButtonEvent *bev;   /* in: passed when in button-press context */
int pending_delete;  /* in: bool; for W_ENTER, go to pending-delete state */
{
    AXWidget oldw;
    
    if (!(ww && (W_DIALOG == ww->parent->type))) {
        return;
    }
    if (W_RADIO == ww->type) {
        ww = xmRadioActiveToggle(ww); /* convert to "on" toggle */
    }
    if (!ww->hasFocus) {
        oldw = xmKeyFocusWidget(ww->parent);
        if (oldw) {
            xmLiftFocusSelector(oldw);
            xmLosingKeyFocus(oldw);
        }
        if ((oldw && (W_BUTTON == oldw->type)) || (W_BUTTON == ww->type)) {
            xmSwitchDefault(ww->parent, ww);
        }
        AxUnFocusCurrent(ww);
#if AX_X11
        ResetActiveTextsExceptFor(ww);
#endif
		if ( oldw )
			oldw->hasFocus = FALSE;
        SetActiveWidget(ww, pending_delete);
        ww->hasFocus = TRUE;
        xmPaintFocusSelector(ww);
#if AXMS
		axmsSetDialogWidgetFocus(ww);
#else
        
        if (W_ENTER == ww->type) {
            ElfXCfieldChanged(ww, ww->taskOwner); /* callback */
            if (bev && (AxButtonDown == Button1) &&
                (bev->time - ww->last_click_time > DoubleMillisec)) {
        
                ElfXentryButtonPress(ww, ww->taskOwner); /* callback */
            }
        }
        else if (W_EDITBOX == ww->type) {
            drawCursor(ww, TC_DRAW);
            ElfXCeboxFocusChanged(ww, ww->taskOwner); /* callback */
        }
#endif
    }

#if AX_X11
    if (xmCanTakeKeyFocus(ww->parent, ww, NULL != bev)) {
        ((AXWidget_dialog) ww->parent)->lastWidgetFocus = ww;
    }
#endif
}

/* : xmLosingKeyFocus - allow widget to know that it's about to
 * lose keyboard focus.  This occurs before AxUnFocusCurrent.
 * Note that AxUnFocusCurrent will send EV_FOCUS_OUT_ messages
 * for certain types.  Take care not to send redundant focus out events.
 */
static void
xmLosingKeyFocus(ww)
AXWidget ww;           /* this widget is about to lose key focus */
{
    switch (ww->type) {
#if AX_X11
    case W_COMBO_BOX:
        CbLosingKeyFocus(ww);
        break;
#endif
    }
}

/* : xmKeyFocusWidget - return the handle of the dialog box
 * widget that currently holds keyboard focus
 */
AXWidget
xmKeyFocusWidget(dw)
AXWidget_dialog dw;      /* in: the dialog box */
{
    AXWidget tw;

    if (W_MAIN == dw->type) {
        dw = ((AXWidget_main) dw)->dialog;
    }
    if (!(dw && (W_DIALOG == dw->type))) {
        return ((AXWidget) NULL);
    }
    for (tw = dw->widgets; tw; tw = tw->nextChild) {
        if (tw->hasFocus) {
            return (tw);
        }
    }
    return ((AXWidget) NULL);
}

/* : xmSwitchDefault - sub called by xmTakeKeyFocus when one or
 * both of the old/new focus widgets are W_BUTTON type. Purpose
 * is to manage the default indicator.
 */
static void
xmSwitchDefault(d_w, to_w)
AXWidget_dialog d_w;
AXWidget to_w;
{
    AXWidget_pushbutton old_default;
    
    if (!d_w->defaultButton) {
        return;
    }
    
    old_default = d_w->currentDefaultButton;

    if (old_default && ((to_w && (W_BUTTON == to_w->type)) ||
                        old_default != d_w->defaultButton)) {

        /* Mark old default button for redraw, in order to lift its indicator..
         * 2nd term of above test:
         *   (lift if going to another button) || (lift if going to
         *    non-button, and "real" default indicator needs to be restored)
         */
        WidgetNeedsUpdated = TRUE;
        old_default->update_widget = TRUE;
    }
    
    if (to_w && (W_BUTTON == to_w->type)) {
        /* this button is to receive the default indicator
         */
        d_w->currentDefaultButton = (AXWidget_pushbutton) to_w;
        WidgetNeedsUpdated = TRUE;
        to_w->update_widget = TRUE;
    }
    else if (d_w->defaultButton) {
        /* focus is going to non-W_BUTTON. Put indicator back on
         * the "real", or program-specified, button.
         */
        d_w->currentDefaultButton = d_w->defaultButton;
        WidgetNeedsUpdated = TRUE;
        d_w->defaultButton->update_widget = TRUE;
    }
}

static void
xmMarkDamaged(d_w, rr)
AXWidget_dialog d_w;
r32 *rr;
{
    AXWidget tw;

    if (d_w && rr) {
        if (!d_w->auxData) {
            d_w->auxData = newAuxData();
        }
        if (!d_w->auxData->damageRect.width) {
            d_w->auxData->damageRect = *rr;
        }
        else {
            unionRectangle(rr, &d_w->auxData->damageRect,
                           &d_w->auxData->damageRect);
        }
        WidgetNeedsUpdated = TRUE;  /* trigger a call to doWidgetUpdates */
    }
}

/* : xmRadioActiveToggle - convert the passed W_RADIO handle
 * to that of the "on" togglebutton among its toggles
 */
AXWidget
xmRadioActiveToggle(w)
AXWidget w;
{
    if (w->auxData) {
        wComposite *cp;
        for (cp = w->auxData->compositeList; cp; cp = cp->next) {
            if ((cp->type == WLINKDOWN) && cp->w &&
                (W_TOGGLE == cp->w->type) && cp->w->value) {
                
                return (cp->w);
            }
        }
    }
    return (w);   /* just return passed on failure */
}

/*************************************************************************
  function: AxPostHelp - Put help text & clear modes
*/
AxPostHelp (w)
AXWidget w;
{
    char buf[20];
    int n;

    if ( !w )
        RingTheBell();
    else if ( w->helpid ) {
        sprintf(buf,"%d",w->helpid);
        ElfPostHelp(buf);
    }
    else if ( w->helpstr && w->helpstr[0] )
        ElfPostHelp(w->helpstr);
    else
        RingTheBell();
    ElfbSetHelpMode(FALSE);
    ResetActive();  
}

int
TestForGlobalFocusModel()
{
    /* On AIX we use locally active input focus model.
     * Everywhere else, use globally active input focus model.
     */
    return (!WeThinkItsAIX);
}


int
RadioKeyPressEvent(wp, eventP, ksym, kbuf, num_chars)
     AXWidget_togglebutton wp; /* in: widget getting the keypress */
     XEvent *eventP;           /* in: keypress event */
     KeySym ksym;
     wchar *kbuf;  /* in: key string associated with ksym, from LookupString */
     int num_chars;            /* num_chars in kbuf */
{
  int do_callback = FALSE;
  int new_togix = -1;
  AXWidget_togglebutton *togs = NULL;
  wComposite *cp;
    
  /* up, down arrows circulate selection, unlesss they're
   * laid out horizontally, in which case use left, right arrows.
   */
  if (wp && wp->auxData) {
    /* need to position-sort the radio toggles.  start by counting.
     */
    int ix, num_togs, sorted;
    int same_ypos, itmp;
    AXWidget_togglebutton wtmp;
        
    for (num_togs = 0, cp = wp->auxData->compositeList; cp;
     cp = cp->next) {
            
      if ((cp->type == WLINKDOWN) && cp->w &&
      (W_TOGGLE == cp->w->type)) {
                
    num_togs++;
      }
    }
        
    /* alloc array of toggle refs, do sort
     */
    togs = (AXWidget_togglebutton *)
      malloc(num_togs * sizeof(AXWidget_togglebutton));
    same_ypos = TRUE;
    for (ix = 0, cp = wp->auxData->compositeList; cp; cp = cp->next) {
      if ((cp->type == WLINKDOWN) && cp->w &&
      (W_TOGGLE == cp->w->type)) {

    togs[ix] = (AXWidget_togglebutton) cp->w;
    if (ix == 0) {
      itmp = cp->w->ypos;
    }
    else if (cp->w->ypos != itmp) {
      same_ypos = FALSE;
    }
    ix++;
      }
    }
    if (same_ypos) {
      /* sort by xpos
       */
      sorted = FALSE;
      while (!sorted) {
    sorted = TRUE;
    for (ix = 0; ix < num_togs; ix++) {
      if (ix < num_togs - 1) {
        if (togs[ix]->xpos > togs[ix + 1]->xpos) {
          wtmp = togs[ix + 1];
          togs[ix + 1] = togs[ix];
          togs[ix] = wtmp;
          sorted = FALSE;
        }
      }
    }
      }
    }
    else {
      /* sort by ypos
       */
      sorted = FALSE;
      while (!sorted) {
    sorted = TRUE;
    for (ix = 0; ix < num_togs; ix++) {
      if (ix < num_togs - 1) {
        if (togs[ix]->ypos > togs[ix + 1]->ypos) {
          wtmp = togs[ix + 1];
          togs[ix + 1] = togs[ix];
          togs[ix] = wtmp;
          sorted = FALSE;
        }
      }
    }
      }
    }
    for (ix = 0; ix < num_togs; ix++) {
      if (togs[ix]->value) {
    break;          /* ix now indexes to current "on" toggle */
      }
    }
    if (same_ypos) {
      if (XK_Left == ksym) {
    if (ix > 0) {
      new_togix = ix - 1;
    }
    else {
      new_togix = num_togs - 1;
    }
    do_callback = TRUE;
      }
      else if (XK_Right == ksym) {
    if (ix < num_togs - 1) {
      new_togix = ix + 1;
    }
    else {
      new_togix = 0;
    }
    do_callback = TRUE;
      }
    }
    else {
      if (XK_Up == ksym) {
    if (ix > 0) {
      new_togix = ix - 1;
    }
    else {
      new_togix = num_togs - 1;
    }
    do_callback = TRUE;
      }
      else if (XK_Down == ksym) {
    if (ix < num_togs - 1) {
      new_togix = ix + 1;
    }
    else {
      new_togix = 0;
    }
    do_callback = TRUE;
      }
    }
  }
  if (do_callback) {
    XmRowColumnCallbackStruct rad_data;
        
    if (new_togix >= 0) {
      SetRadioValue(togs[new_togix], FALSE);
      xmTakeKeyFocus(togs[new_togix], (XButtonEvent *) NULL, FALSE);
      rad_data.data = (char*) wp->value;
      rad_data.widget = (Widget) wp;
      if ( wp->callback ) {
    AxCallback(wp->callback, wp, wp->callbacktag, &rad_data);
      }
      togs[new_togix]->update_widget = TRUE;
      WidgetNeedsUpdated = TRUE;
#if AXMS
		wp->update_widget = TRUE;
#endif
    }
  }
  if (togs) {
    free(togs);
  }
  return (do_callback);
}

void
xmDialogFocus(fw, taking_focus)
AXWidget_main fw;
int taking_focus; /* bool: whether dialog is keeping or losing focus */
{
    AXWidget ww;
	AXWidget_dialog d_w;
	
	if ((W_MAIN == fw->type) && fw->dialog) {
		d_w = (AXWidget_dialog) fw->dialog;
	}
	else if (W_DIALOG == fw->type) {
		d_w = (AXWidget_dialog) fw;
	}
	else {
		return;
	}
	
	ww = xmKeyFocusWidget(d_w);

	if (ww) {
	    if (taking_focus) {
			d_w->hasFocus = TRUE;
			xmPaintFocusSelector(ww);
#if AXMS
			if ( (int)ww->winid > 1 )
				MS_SetFocus(ww->winid);
			axmsSendActivateMessageToWidget(ww);
#endif
#if AX_X11
			if ((W_COMBO_BOX == ww->type) && (ww->flags & WFLG_EDITABLE)
		    	&& (((AXWidget_combo_box)ww)->edit_win.cursor_on)) {
		    		ComboBoxInEditWindow = (AXWidget_combo_box)ww;
			}
#endif
	    } else {
			d_w->hasFocus = FALSE;
			xmLiftFocusSelector(ww);
#if AX_X11
			if (W_COMBO_BOX == ww->type)
		    	ComboBoxInEditWindow = NULL;
#endif
	    }
#if AX_X11
		if (W_BUTTON == ww->type) {
			/* sign up for repaint, since buttons are painted
			 * differently, inside their footprint, based on focus
			 */
			ww->update_widget = WidgetNeedsUpdated = TRUE;
		}
#endif
	}
}

int JavaWinIdFromWidget(w)
AXWidget_main w;
{
	int jwId = TaskInfo[w->taskOwner].uid;
	if (AxIsSSTask(w->taskOwner)) {
		int wid = WindowIdFromWidget(w);
		jwId |= (wid << 16);
	}
	return (jwId);
}
